require 'quickfix'
module Quickfix50Sp2
class Message < Quickfix::Message
	def initialize
		super
		getHeader().setField( Quickfix::BeginString.new("FIXT.1.1") )
		getHeader().setField( Quickfix::ApplVerID.new("9") )
	end
end

class IOI < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("6") )
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoInstrAttrib < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 871
			order[1] = 872
			order[2] = 0
			super(870, 871, order)
		end
	end

	class NoIndexRollMonths < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2733
			order[1] = 0
			super(2734, 2733, order)
		end
	end

	class NoReferenceDataDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2747
			order[1] = 2748
			order[2] = 0
			super(2746, 2747, order)
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoRelatedInstruments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 1648
			order[1] = 1649
			order[2] = 1650
			order[3] = 1651
			order[4] = 1652
			order[5] = 1653
			order[6] = 2413
			order[7] = 2414
			order[8] = 2415
			order[9] = 2417
			order[10] = 0
			super(1647, 1648, order)
		end
	end

	class NoStipulations < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 233
			order[1] = 234
			order[2] = 0
			super(232, 233, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(155)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 682
			order[153] = 683
			order[154] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegStipulations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 688
				order[1] = 689
				order[2] = 0
				super(683, 688, order)
			end
		end
	end

	class NoPriceQualifiers < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2710
			order[1] = 0
			super(2709, 2710, order)
		end
	end

	class NoIOIQualifiers < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 104
			order[1] = 0
			super(199, 104, order)
		end
	end

	class NoRoutingIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 216
			order[1] = 217
			order[2] = 0
			super(215, 216, order)
		end
	end

	class NoRelativeValues < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2530
			order[1] = 2531
			order[2] = 2532
			order[3] = 0
			super(2529, 2530, order)
		end
	end
end

class Advertisement < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("7") )
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoInstrAttrib < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 871
			order[1] = 872
			order[2] = 0
			super(870, 871, order)
		end
	end

	class NoIndexRollMonths < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2733
			order[1] = 0
			super(2734, 2733, order)
		end
	end

	class NoReferenceDataDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2747
			order[1] = 2748
			order[2] = 0
			super(2746, 2747, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoRelatedInstruments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 1648
			order[1] = 1649
			order[2] = 1650
			order[3] = 1651
			order[4] = 1652
			order[5] = 1653
			order[6] = 2413
			order[7] = 2414
			order[8] = 2415
			order[9] = 2417
			order[10] = 0
			super(1647, 1648, order)
		end
	end

	class NoRoutingIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 216
			order[1] = 217
			order[2] = 0
			super(215, 216, order)
		end
	end
end

class ExecutionReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("8") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoTargetPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1462
			order[1] = 1463
			order[2] = 1464
			order[3] = 1818
			order[4] = 2433
			order[5] = 0
			super(1461, 1462, order)
		end

		class NoTargetPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2434
				order[1] = 2435
				order[2] = 0
				super(2433, 2434, order)
			end
		end
	end

	class NoContraBrokers < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 375
			order[1] = 337
			order[2] = 437
			order[3] = 438
			order[4] = 655
			order[5] = 0
			super(382, 375, order)
		end
	end

	class NoRegulatoryTradeIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 1903
			order[1] = 1905
			order[2] = 1904
			order[3] = 1906
			order[4] = 2411
			order[5] = 2397
			order[6] = 0
			super(1907, 1903, order)
		end
	end

	class NoAllocs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(14)
			order[0] = 79
			order[1] = 661
			order[2] = 736
			order[3] = 2927
			order[4] = 467
			order[5] = 2727
			order[6] = 539
			order[7] = 209
			order[8] = 80
			order[9] = 1752
			order[10] = 1753
			order[11] = 1754
			order[12] = 1755
			order[13] = 0
			super(78, 79, order)
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoPayments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(41)
			order[0] = 40213
			order[1] = 40993
			order[2] = 40214
			order[3] = 40215
			order[4] = 43087
			order[5] = 40216
			order[6] = 40217
			order[7] = 42598
			order[8] = 42599
			order[9] = 43097
			order[10] = 43098
			order[11] = 43100
			order[12] = 43099
			order[13] = 43101
			order[14] = 43105
			order[15] = 43104
			order[16] = 43103
			order[17] = 43102
			order[18] = 40218
			order[19] = 40919
			order[20] = 41155
			order[21] = 40219
			order[22] = 40220
			order[23] = 40944
			order[24] = 41156
			order[25] = 41157
			order[26] = 41158
			order[27] = 41159
			order[28] = 40222
			order[29] = 41160
			order[30] = 40224
			order[31] = 40225
			order[32] = 40226
			order[33] = 40227
			order[34] = 492
			order[35] = 40230
			order[36] = 41304
			order[37] = 40229
			order[38] = 40984
			order[39] = 40985
			order[40] = 0
			super(40212, 40213, order)
		end

		class NoPaymentBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40221
				order[1] = 0
				super(40944, 40221, order)
			end
		end

		class NoPaymentSettls < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40231
				order[1] = 40232
				order[2] = 40233
				order[3] = 0
				super(40230, 40231, order)
			end

			class NoPaymentSettlPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40234
					order[1] = 40235
					order[2] = 40236
					order[3] = 40237
					order[4] = 40238
					order[5] = 0
					super(40233, 40234, order)
				end

				class NoPaymentSettlPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40239
						order[1] = 40240
						order[2] = 0
						super(40238, 40239, order)
					end
				end
			end
		end
	end

	class NoStipulations < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 233
			order[1] = 234
			order[2] = 0
			super(232, 233, order)
		end
	end

	class NoPriceQualifiers < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2710
			order[1] = 0
			super(2709, 2710, order)
		end
	end

	class NoStrategyParameters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 958
			order[1] = 959
			order[2] = 960
			order[3] = 0
			super(957, 958, order)
		end
	end

	class NoOrderAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2594
			order[1] = 2595
			order[2] = 0
			super(2593, 2594, order)
		end
	end

	class NoLimitAmts < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(9)
			order[0] = 1631
			order[1] = 1632
			order[2] = 1633
			order[3] = 2394
			order[4] = 2395
			order[5] = 1634
			order[6] = 2935
			order[7] = 2396
			order[8] = 0
			super(1630, 1631, order)
		end
	end

	class NoFills < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 1363
			order[1] = 1364
			order[2] = 1365
			order[3] = 2673
			order[4] = 2674
			order[5] = 1443
			order[6] = 1622
			order[7] = 1623
			order[8] = 1414
			order[9] = 0
			super(1362, 1363, order)
		end

		class NoNested4PartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1415
				order[1] = 1416
				order[2] = 1417
				order[3] = 2383
				order[4] = 1413
				order[5] = 0
				super(1414, 1415, order)
			end

			class NoNested4PartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1412
					order[1] = 1411
					order[2] = 0
					super(1413, 1412, order)
				end
			end
		end
	end

	class NoOrderEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(8)
			order[0] = 1796
			order[1] = 1797
			order[2] = 1798
			order[3] = 1799
			order[4] = 1800
			order[5] = 1801
			order[6] = 1802
			order[7] = 0
			super(1795, 1796, order)
		end
	end

	class NoCommissions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(17)
			order[0] = 2640
			order[1] = 2641
			order[2] = 2725
			order[3] = 2642
			order[4] = 2643
			order[5] = 2923
			order[6] = 2644
			order[7] = 2645
			order[8] = 2924
			order[9] = 2646
			order[10] = 2647
			order[11] = 2648
			order[12] = 2649
			order[13] = 2650
			order[14] = 2651
			order[15] = 2652
			order[16] = 0
			super(2639, 2640, order)
		end
	end

	class NoRelativeValues < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2530
			order[1] = 2531
			order[2] = 2532
			order[3] = 0
			super(2529, 2530, order)
		end
	end

	class NoRateSources < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1446
			order[1] = 1447
			order[2] = 1448
			order[3] = 2412
			order[4] = 2796
			order[5] = 0
			super(1445, 1446, order)
		end
	end

	class NoValueChecks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1869
			order[1] = 1870
			order[2] = 0
			super(1868, 1869, order)
		end
	end

	class NoMatchInst < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1625
			order[1] = 1673
			order[2] = 1626
			order[3] = 1627
			order[4] = 0
			super(1624, 1625, order)
		end
	end

	class NoDisclosureInstructions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1813
			order[1] = 1814
			order[2] = 0
			super(1812, 1813, order)
		end
	end

	class NoContAmts < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 519
			order[1] = 520
			order[2] = 521
			order[3] = 0
			super(518, 519, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(181)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 685
			order[153] = 687
			order[154] = 2346
			order[155] = 690
			order[156] = 683
			order[157] = 1366
			order[158] = 670
			order[159] = 2680
			order[160] = 1817
			order[161] = 564
			order[162] = 565
			order[163] = 948
			order[164] = 654
			order[165] = 587
			order[166] = 588
			order[167] = 637
			order[168] = 675
			order[169] = 2900
			order[170] = 1073
			order[171] = 1074
			order[172] = 1075
			order[173] = 1689
			order[174] = 1379
			order[175] = 1381
			order[176] = 1383
			order[177] = 1384
			order[178] = 1418
			order[179] = 2421
			order[180] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegStipulations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 688
				order[1] = 689
				order[2] = 0
				super(683, 688, order)
			end
		end

		class NoLegAllocs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 671
				order[1] = 672
				order[2] = 756
				order[3] = 673
				order[4] = 674
				order[5] = 1367
				order[6] = 2928
				order[7] = 1756
				order[8] = 1757
				order[9] = 1758
				order[10] = 1759
				order[11] = 0
				super(670, 671, order)
			end

			class NoNested2PartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 757
					order[1] = 758
					order[2] = 759
					order[3] = 2381
					order[4] = 806
					order[5] = 0
					super(756, 757, order)
				end

				class NoNested2PartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 760
						order[1] = 807
						order[2] = 0
						super(806, 760, order)
					end
				end
			end
		end

		class NoNested3PartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 949
				order[1] = 950
				order[2] = 951
				order[3] = 2382
				order[4] = 952
				order[5] = 0
				super(948, 949, order)
			end

			class NoNested3PartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 953
					order[1] = 954
					order[2] = 0
					super(952, 953, order)
				end
			end
		end
	end

	class NoMiscFees < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 137
			order[1] = 138
			order[2] = 139
			order[3] = 2712
			order[4] = 2633
			order[5] = 891
			order[6] = 2216
			order[7] = 2217
			order[8] = 2713
			order[9] = 0
			super(136, 137, order)
		end

		class NoMiscFeeSubTypes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2634
				order[1] = 2635
				order[2] = 2636
				order[3] = 2637
				order[4] = 2638
				order[5] = 0
				super(2633, 2634, order)
			end
		end
	end

	class NoTrdRegTimestamps < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 769
			order[1] = 770
			order[2] = 771
			order[3] = 2839
			order[4] = 1033
			order[5] = 1034
			order[6] = 1035
			order[7] = 1727
			order[8] = 2831
			order[9] = 2832
			order[10] = 2833
			order[11] = 2834
			order[12] = 0
			super(768, 769, order)
		end
	end

	class NoTrdRegPublications < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2669
			order[1] = 2670
			order[2] = 0
			super(2668, 2669, order)
		end
	end

	class NoTradePriceConditions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 1839
			order[1] = 0
			super(1838, 1839, order)
		end
	end

	class NoOrders < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 2887
			order[1] = 2888
			order[2] = 2836
			order[3] = 2889
			order[4] = 2890
			order[5] = 2835
			order[6] = 0
			super(73, 2887, order)
		end
	end
end

class OrderCancelReject < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("9") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end
end

class News < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("B") )
	end

	class NoNewsRefIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1476
			order[1] = 1477
			order[2] = 0
			super(1475, 1476, order)
		end
	end

	class NoRoutingIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 216
			order[1] = 217
			order[2] = 0
			super(215, 216, order)
		end
	end

	class NoRelatedSym < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(183)
			order[0] = 55
			order[1] = 65
			order[2] = 48
			order[3] = 22
			order[4] = 460
			order[5] = 1227
			order[6] = 1151
			order[7] = 461
			order[8] = 2891
			order[9] = 167
			order[10] = 762
			order[11] = 200
			order[12] = 541
			order[13] = 1079
			order[14] = 966
			order[15] = 1049
			order[16] = 965
			order[17] = 224
			order[18] = 1449
			order[19] = 1450
			order[20] = 1451
			order[21] = 1452
			order[22] = 1457
			order[23] = 1458
			order[24] = 1739
			order[25] = 2210
			order[26] = 1938
			order[27] = 1939
			order[28] = 1940
			order[29] = 2735
			order[30] = 1941
			order[31] = 1575
			order[32] = 1942
			order[33] = 1943
			order[34] = 1944
			order[35] = 1945
			order[36] = 1946
			order[37] = 1947
			order[38] = 1948
			order[39] = 1949
			order[40] = 1950
			order[41] = 2879
			order[42] = 1951
			order[43] = 1952
			order[44] = 1953
			order[45] = 1954
			order[46] = 1955
			order[47] = 1956
			order[48] = 1957
			order[49] = 1958
			order[50] = 1959
			order[51] = 1960
			order[52] = 1577
			order[53] = 1580
			order[54] = 1581
			order[55] = 1678
			order[56] = 1697
			order[57] = 225
			order[58] = 239
			order[59] = 226
			order[60] = 227
			order[61] = 228
			order[62] = 255
			order[63] = 543
			order[64] = 470
			order[65] = 471
			order[66] = 472
			order[67] = 240
			order[68] = 202
			order[69] = 2578
			order[70] = 2577
			order[71] = 947
			order[72] = 2904
			order[73] = 967
			order[74] = 968
			order[75] = 1698
			order[76] = 1866
			order[77] = 2600
			order[78] = 2001
			order[79] = 2601
			order[80] = 1478
			order[81] = 1479
			order[82] = 1480
			order[83] = 1481
			order[84] = 206
			order[85] = 231
			order[86] = 1435
			order[87] = 2353
			order[88] = 1439
			order[89] = 969
			order[90] = 1146
			order[91] = 996
			order[92] = 1147
			order[93] = 1716
			order[94] = 2905
			order[95] = 1191
			order[96] = 1192
			order[97] = 1717
			order[98] = 2906
			order[99] = 1193
			order[100] = 2579
			order[101] = 1194
			order[102] = 1482
			order[103] = 1195
			order[104] = 2753
			order[105] = 1196
			order[106] = 1197
			order[107] = 2002
			order[108] = 2140
			order[109] = 1524
			order[110] = 2907
			order[111] = 1198
			order[112] = 1199
			order[113] = 1200
			order[114] = 201
			order[115] = 2681
			order[116] = 2685
			order[117] = 1244
			order[118] = 1242
			order[119] = 2575
			order[120] = 2574
			order[121] = 997
			order[122] = 223
			order[123] = 207
			order[124] = 970
			order[125] = 971
			order[126] = 106
			order[127] = 348
			order[128] = 349
			order[129] = 2737
			order[130] = 2714
			order[131] = 2715
			order[132] = 2716
			order[133] = 107
			order[134] = 350
			order[135] = 351
			order[136] = 691
			order[137] = 667
			order[138] = 875
			order[139] = 876
			order[140] = 873
			order[141] = 874
			order[142] = 1687
			order[143] = 1787
			order[144] = 2141
			order[145] = 2142
			order[146] = 2143
			order[147] = 2752
			order[148] = 2144
			order[149] = 2145
			order[150] = 2576
			order[151] = 2962
			order[152] = 2602
			order[153] = 2603
			order[154] = 668
			order[155] = 869
			order[156] = 2736
			order[157] = 2738
			order[158] = 913
			order[159] = 914
			order[160] = 1961
			order[161] = 915
			order[162] = 918
			order[163] = 2952
			order[164] = 1962
			order[165] = 1963
			order[166] = 1964
			order[167] = 1965
			order[168] = 1966
			order[169] = 1967
			order[170] = 1968
			order[171] = 1969
			order[172] = 1970
			order[173] = 1513
			order[174] = 1525
			order[175] = 1527
			order[176] = 788
			order[177] = 916
			order[178] = 917
			order[179] = 919
			order[180] = 898
			order[181] = 1647
			order[182] = 0
			super(146, 55, order)
		end

		class NoSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 455
				order[1] = 456
				order[2] = 2957
				order[3] = 0
				super(454, 455, order)
			end
		end

		class NoSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1977
				order[1] = 1978
				order[2] = 1979
				order[3] = 2741
				order[4] = 0
				super(1976, 1977, order)
			end
		end

		class NoAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2305
				order[1] = 2306
				order[2] = 2307
				order[3] = 0
				super(2304, 2305, order)
			end
		end

		class NoEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 865
				order[1] = 866
				order[2] = 1145
				order[3] = 1827
				order[4] = 1826
				order[5] = 2340
				order[6] = 867
				order[7] = 868
				order[8] = 1578
				order[9] = 1579
				order[10] = 0
				super(864, 865, order)
			end
		end

		class NoInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1019
				order[1] = 1050
				order[2] = 1051
				order[3] = 2378
				order[4] = 1052
				order[5] = 0
				super(1018, 1019, order)
			end

			class NoInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1053
					order[1] = 1054
					order[2] = 0
					super(1052, 1053, order)
				end
			end
		end

		class NoComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 1484
				order[1] = 2117
				order[2] = 2118
				order[3] = 2119
				order[4] = 1485
				order[5] = 2120
				order[6] = 2121
				order[7] = 2122
				order[8] = 2941
				order[9] = 1486
				order[10] = 2123
				order[11] = 1487
				order[12] = 1488
				order[13] = 1489
				order[14] = 1490
				order[15] = 1491
				order[16] = 2124
				order[17] = 2942
				order[18] = 2125
				order[19] = 2943
				order[20] = 2126
				order[21] = 2127
				order[22] = 2407
				order[23] = 2408
				order[24] = 2128
				order[25] = 2129
				order[26] = 2130
				order[27] = 2131
				order[28] = 2132
				order[29] = 41013
				order[30] = 41020
				order[31] = 41021
				order[32] = 41022
				order[33] = 41023
				order[34] = 41024
				order[35] = 41025
				order[36] = 41026
				order[37] = 41027
				order[38] = 41028
				order[39] = 41010
				order[40] = 2133
				order[41] = 2134
				order[42] = 2135
				order[43] = 2136
				order[44] = 2137
				order[45] = 41029
				order[46] = 40997
				order[47] = 2597
				order[48] = 2598
				order[49] = 2599
				order[50] = 2138
				order[51] = 2139
				order[52] = 0
				super(1483, 1484, order)
			end

			class NoComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1492
					order[1] = 1493
					order[2] = 1494
					order[3] = 0
					super(1491, 1492, order)
				end

				class NoComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1495
						order[1] = 1496
						order[2] = 0
						super(1494, 1495, order)
					end
				end
			end

			class NoComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41014
					order[1] = 41015
					order[2] = 41016
					order[3] = 41017
					order[4] = 0
					super(41013, 41014, order)
				end
			end

			class NoComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41019
					order[1] = 0
					super(41018, 41019, order)
				end
			end

			class NoComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41011
					order[1] = 41012
					order[2] = 41031
					order[3] = 41007
					order[4] = 40994
					order[5] = 0
					super(41010, 41011, order)
				end

				class NoComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41032
						order[1] = 41033
						order[2] = 41034
						order[3] = 41035
						order[4] = 41036
						order[5] = 0
						super(41031, 41032, order)
					end
				end

				class NoComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41008
						order[1] = 41009
						order[2] = 0
						super(41007, 41008, order)
					end
				end

				class NoComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40995
						order[1] = 40996
						order[2] = 0
						super(40994, 40995, order)
					end
				end
			end

			class NoComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41030
					order[1] = 0
					super(41029, 41030, order)
				end
			end

			class NoComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40998
					order[1] = 40999
					order[2] = 41000
					order[3] = 41001
					order[4] = 41002
					order[5] = 41003
					order[6] = 41004
					order[7] = 41005
					order[8] = 0
					super(40997, 40998, order)
				end

				class NoComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41006
						order[1] = 0
						super(41005, 41006, order)
					end
				end
			end
		end

		class NoBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40471
				order[1] = 0
				super(40278, 40471, order)
			end
		end

		class NoPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41231
				order[1] = 0
				super(41230, 41231, order)
			end
		end

		class NoMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41093
				order[1] = 40991
				order[2] = 0
				super(41092, 41093, order)
			end
		end

		class NoMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41095
				order[1] = 40992
				order[2] = 0
				super(41094, 41095, order)
			end
		end

		class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41097
				order[1] = 41098
				order[2] = 41099
				order[3] = 41100
				order[4] = 41101
				order[5] = 41102
				order[6] = 41103
				order[7] = 41104
				order[8] = 41105
				order[9] = 0
				super(41096, 41097, order)
			end
		end

		class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42776
				order[1] = 0
				super(42775, 42776, order)
			end
		end

		class NoOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41117
				order[1] = 0
				super(41116, 41117, order)
			end
		end

		class NoOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41138
				order[1] = 41139
				order[2] = 0
				super(41137, 41138, order)
			end
		end

		class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41141
				order[1] = 0
				super(41140, 41141, order)
			end
		end

		class NoOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41153
				order[1] = 41154
				order[2] = 0
				super(41152, 41153, order)
			end
		end

		class NoStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40050
				order[1] = 41303
				order[2] = 40051
				order[3] = 42784
				order[4] = 42785
				order[5] = 40052
				order[6] = 40053
				order[7] = 41305
				order[8] = 40054
				order[9] = 40055
				order[10] = 42786
				order[11] = 42787
				order[12] = 41306
				order[13] = 41307
				order[14] = 41308
				order[15] = 41309
				order[16] = 41310
				order[17] = 41311
				order[18] = 41251
				order[19] = 41252
				order[20] = 41253
				order[21] = 41254
				order[22] = 41255
				order[23] = 41256
				order[24] = 41257
				order[25] = 42587
				order[26] = 41258
				order[27] = 41259
				order[28] = 41260
				order[29] = 41261
				order[30] = 41262
				order[31] = 41263
				order[32] = 41264
				order[33] = 41265
				order[34] = 41266
				order[35] = 41267
				order[36] = 41268
				order[37] = 41269
				order[38] = 41270
				order[39] = 41271
				order[40] = 41272
				order[41] = 41273
				order[42] = 41274
				order[43] = 41275
				order[44] = 41276
				order[45] = 40907
				order[46] = 40908
				order[47] = 40910
				order[48] = 40911
				order[49] = 40912
				order[50] = 40913
				order[51] = 40914
				order[52] = 40065
				order[53] = 40066
				order[54] = 40068
				order[55] = 40069
				order[56] = 40070
				order[57] = 40071
				order[58] = 40072
				order[59] = 41244
				order[60] = 41245
				order[61] = 40073
				order[62] = 40075
				order[63] = 40076
				order[64] = 40078
				order[65] = 40079
				order[66] = 40080
				order[67] = 40081
				order[68] = 40082
				order[69] = 40083
				order[70] = 40084
				order[71] = 41246
				order[72] = 41247
				order[73] = 41248
				order[74] = 40738
				order[75] = 40739
				order[76] = 40740
				order[77] = 42600
				order[78] = 40741
				order[79] = 40742
				order[80] = 43106
				order[81] = 40743
				order[82] = 40744
				order[83] = 40745
				order[84] = 40746
				order[85] = 40747
				order[86] = 42601
				order[87] = 42602
				order[88] = 42603
				order[89] = 42604
				order[90] = 40748
				order[91] = 40749
				order[92] = 40750
				order[93] = 41180
				order[94] = 41181
				order[95] = 41182
				order[96] = 41183
				order[97] = 41184
				order[98] = 41185
				order[99] = 41186
				order[100] = 42605
				order[101] = 40828
				order[102] = 40872
				order[103] = 41058
				order[104] = 41059
				order[105] = 41060
				order[106] = 41061
				order[107] = 41062
				order[108] = 42192
				order[109] = 42193
				order[110] = 41063
				order[111] = 41064
				order[112] = 41065
				order[113] = 41066
				order[114] = 41067
				order[115] = 41218
				order[116] = 41068
				order[117] = 41069
				order[118] = 41070
				order[119] = 41071
				order[120] = 41072
				order[121] = 41073
				order[122] = 41074
				order[123] = 41075
				order[124] = 41076
				order[125] = 41077
				order[126] = 41078
				order[127] = 41079
				order[128] = 41080
				order[129] = 43094
				order[130] = 41037
				order[131] = 40056
				order[132] = 40982
				order[133] = 40983
				order[134] = 0
				super(40049, 40050, order)
			end

			class NoStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41278
					order[1] = 41279
					order[2] = 0
					super(41277, 41278, order)
				end
			end

			class NoStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41238
					order[1] = 41239
					order[2] = 41240
					order[3] = 0
					super(41237, 41238, order)
				end
			end

			class NoStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41281
					order[1] = 41282
					order[2] = 0
					super(41280, 41281, order)
				end
			end

			class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41250
					order[1] = 0
					super(41249, 41250, order)
				end
			end

			class NoStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41290
					order[1] = 41291
					order[2] = 41292
					order[3] = 41293
					order[4] = 41294
					order[5] = 41295
					order[6] = 41296
					order[7] = 41297
					order[8] = 41298
					order[9] = 41299
					order[10] = 41300
					order[11] = 41283
					order[12] = 41301
					order[13] = 41302
					order[14] = 0
					super(41289, 41290, order)
				end

				class NoStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41284
						order[1] = 41285
						order[2] = 41286
						order[3] = 0
						super(41283, 41284, order)
					end

					class NoStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41287
							order[1] = 41288
							order[2] = 41588
							order[3] = 0
							super(41286, 41287, order)
						end
					end
				end
			end

			class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40909
					order[1] = 0
					super(40960, 40909, order)
				end
			end

			class NoStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40067
					order[1] = 0
					super(40961, 40067, order)
				end
			end

			class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40074
					order[1] = 0
					super(40958, 40074, order)
				end
			end

			class NoStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41242
					order[1] = 41243
					order[2] = 0
					super(41241, 41242, order)
				end
			end

			class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40077
					order[1] = 0
					super(40959, 40077, order)
				end
			end

			class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40752
					order[1] = 0
					super(40947, 40752, order)
				end
			end

			class NoPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41221
					order[1] = 41222
					order[2] = 0
					super(41220, 41221, order)
				end
			end

			class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40763
					order[1] = 0
					super(40948, 40763, order)
				end
			end

			class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40769
					order[1] = 0
					super(40949, 40769, order)
				end
			end

			class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40776
					order[1] = 0
					super(40950, 40776, order)
				end
			end

			class NoPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42661
					order[1] = 42662
					order[2] = 0
					super(42660, 42661, order)
				end
			end

			class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41193
					order[1] = 0
					super(41192, 41193, order)
				end
			end

			class NoPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41228
					order[1] = 41229
					order[2] = 0
					super(41227, 41228, order)
				end
			end

			class NoPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41225
					order[1] = 41226
					order[2] = 0
					super(41224, 41225, order)
				end
			end

			class NoPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43109
					order[1] = 42684
					order[2] = 42685
					order[3] = 0
					super(42683, 43109, order)
				end
			end

			class NoDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42275
					order[1] = 42276
					order[2] = 42277
					order[3] = 42278
					order[4] = 42279
					order[5] = 42280
					order[6] = 42294
					order[7] = 42281
					order[8] = 42282
					order[9] = 42283
					order[10] = 42284
					order[11] = 42285
					order[12] = 42286
					order[13] = 42287
					order[14] = 42288
					order[15] = 42289
					order[16] = 42290
					order[17] = 42291
					order[18] = 42292
					order[19] = 42293
					order[20] = 0
					super(42274, 42275, order)
				end

				class NoDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42295
						order[1] = 0
						super(42294, 42295, order)
					end
				end
			end

			class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42273
					order[1] = 0
					super(42272, 42273, order)
				end
			end

			class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42237
					order[1] = 0
					super(42236, 42237, order)
				end
			end

			class NoReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42736
					order[1] = 42737
					order[2] = 42738
					order[3] = 42739
					order[4] = 42740
					order[5] = 42741
					order[6] = 42765
					order[7] = 42731
					order[8] = 42742
					order[9] = 42743
					order[10] = 42744
					order[11] = 42745
					order[12] = 42746
					order[13] = 42747
					order[14] = 42748
					order[15] = 42749
					order[16] = 42750
					order[17] = 42751
					order[18] = 42752
					order[19] = 42753
					order[20] = 42761
					order[21] = 42754
					order[22] = 42755
					order[23] = 42709
					order[24] = 42756
					order[25] = 42757
					order[26] = 42758
					order[27] = 42759
					order[28] = 42760
					order[29] = 0
					super(42735, 42736, order)
				end

				class NoReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42766
						order[1] = 42767
						order[2] = 42768
						order[3] = 42769
						order[4] = 0
						super(42765, 42766, order)
					end
				end

				class NoReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42732
						order[1] = 42733
						order[2] = 42734
						order[3] = 0
						super(42731, 42732, order)
					end
				end

				class NoReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42762
						order[1] = 42763
						order[2] = 42764
						order[3] = 0
						super(42761, 42762, order)
					end
				end

				class NoReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42710
						order[1] = 42772
						order[2] = 42711
						order[3] = 42712
						order[4] = 42713
						order[5] = 42714
						order[6] = 42715
						order[7] = 42716
						order[8] = 42717
						order[9] = 42718
						order[10] = 42719
						order[11] = 42720
						order[12] = 42721
						order[13] = 42722
						order[14] = 42723
						order[15] = 42724
						order[16] = 42725
						order[17] = 42726
						order[18] = 42727
						order[19] = 42728
						order[20] = 42729
						order[21] = 42730
						order[22] = 42770
						order[23] = 0
						super(42709, 42710, order)
					end

					class NoReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42773
							order[1] = 42774
							order[2] = 0
							super(42772, 42773, order)
						end
					end

					class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42771
							order[1] = 0
							super(42770, 42771, order)
						end
					end
				end
			end

			class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42621
					order[1] = 0
					super(42620, 42621, order)
				end
			end

			class NoPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42607
					order[1] = 42608
					order[2] = 0
					super(42606, 42607, order)
				end
			end

			class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40819
					order[1] = 0
					super(40946, 40819, order)
				end
			end

			class NoNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40826
					order[1] = 40827
					order[2] = 0
					super(40825, 40826, order)
				end
			end

			class NoSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40086
					order[1] = 40373
					order[2] = 40655
					order[3] = 40088
					order[4] = 40089
					order[5] = 0
					super(40085, 40086, order)
				end
			end

			class NoPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40829
					order[1] = 41164
					order[2] = 41165
					order[3] = 40830
					order[4] = 40831
					order[5] = 40832
					order[6] = 40833
					order[7] = 40834
					order[8] = 40835
					order[9] = 40836
					order[10] = 40837
					order[11] = 40838
					order[12] = 40839
					order[13] = 41166
					order[14] = 41167
					order[15] = 41168
					order[16] = 41169
					order[17] = 40840
					order[18] = 40841
					order[19] = 40842
					order[20] = 40843
					order[21] = 41170
					order[22] = 41171
					order[23] = 41172
					order[24] = 41173
					order[25] = 40844
					order[26] = 40845
					order[27] = 40846
					order[28] = 40847
					order[29] = 40848
					order[30] = 40849
					order[31] = 40868
					order[32] = 40850
					order[33] = 40851
					order[34] = 40852
					order[35] = 40853
					order[36] = 40977
					order[37] = 40855
					order[38] = 40856
					order[39] = 40857
					order[40] = 41174
					order[41] = 41175
					order[42] = 40858
					order[43] = 41161
					order[44] = 41176
					order[45] = 41177
					order[46] = 41178
					order[47] = 41179
					order[48] = 40859
					order[49] = 40860
					order[50] = 40861
					order[51] = 40862
					order[52] = 40945
					order[53] = 40864
					order[54] = 40865
					order[55] = 40866
					order[56] = 40867
					order[57] = 0
					super(40828, 40829, order)
				end

				class NoPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40869
						order[1] = 40870
						order[2] = 40871
						order[3] = 0
						super(40868, 40869, order)
					end
				end

				class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40854
						order[1] = 0
						super(40977, 40854, order)
					end
				end

				class NoPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41162
						order[1] = 41163
						order[2] = 0
						super(41161, 41162, order)
					end
				end

				class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40863
						order[1] = 0
						super(40945, 40863, order)
					end
				end
			end

			class NoPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40873
					order[1] = 40874
					order[2] = 42698
					order[3] = 42699
					order[4] = 42700
					order[5] = 42701
					order[6] = 42702
					order[7] = 42703
					order[8] = 42704
					order[9] = 42689
					order[10] = 42690
					order[11] = 42691
					order[12] = 42692
					order[13] = 42693
					order[14] = 42694
					order[15] = 42695
					order[16] = 40875
					order[17] = 40876
					order[18] = 40877
					order[19] = 40878
					order[20] = 40879
					order[21] = 40880
					order[22] = 40881
					order[23] = 40882
					order[24] = 40883
					order[25] = 40884
					order[26] = 40885
					order[27] = 40886
					order[28] = 40887
					order[29] = 40888
					order[30] = 40889
					order[31] = 40890
					order[32] = 40891
					order[33] = 40892
					order[34] = 40893
					order[35] = 40894
					order[36] = 40895
					order[37] = 40896
					order[38] = 40897
					order[39] = 40898
					order[40] = 40899
					order[41] = 40900
					order[42] = 40901
					order[43] = 0
					super(40872, 40873, order)
				end

				class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42706
						order[1] = 0
						super(42705, 42706, order)
					end
				end

				class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42697
						order[1] = 0
						super(42696, 42697, order)
					end
				end
			end

			class NoDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41086
					order[1] = 0
					super(41085, 41086, order)
				end
			end

			class NoDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41082
					order[1] = 41083
					order[2] = 41084
					order[3] = 0
					super(41081, 41082, order)
				end
			end

			class NoDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41038
					order[1] = 41039
					order[2] = 41040
					order[3] = 41041
					order[4] = 41042
					order[5] = 41043
					order[6] = 41044
					order[7] = 41045
					order[8] = 41046
					order[9] = 41047
					order[10] = 41048
					order[11] = 41049
					order[12] = 41050
					order[13] = 41051
					order[14] = 0
					super(41037, 41038, order)
				end

				class NoDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41052
						order[1] = 41053
						order[2] = 41054
						order[3] = 0
						super(41051, 41052, order)
					end

					class NoDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41055
							order[1] = 41056
							order[2] = 41057
							order[3] = 0
							super(41054, 41055, order)
						end
					end
				end
			end
		end

		class NoProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40091
				order[1] = 40092
				order[2] = 40093
				order[3] = 40957
				order[4] = 40095
				order[5] = 40096
				order[6] = 40097
				order[7] = 42707
				order[8] = 42708
				order[9] = 40098
				order[10] = 40099
				order[11] = 40100
				order[12] = 40114
				order[13] = 40115
				order[14] = 40116
				order[15] = 40118
				order[16] = 40119
				order[17] = 40120
				order[18] = 40121
				order[19] = 40122
				order[20] = 40123
				order[21] = 40125
				order[22] = 40126
				order[23] = 40127
				order[24] = 40128
				order[25] = 40129
				order[26] = 40130
				order[27] = 40131
				order[28] = 40132
				order[29] = 40133
				order[30] = 40134
				order[31] = 40135
				order[32] = 40136
				order[33] = 40137
				order[34] = 40138
				order[35] = 40139
				order[36] = 40140
				order[37] = 40141
				order[38] = 40145
				order[39] = 40146
				order[40] = 40148
				order[41] = 40149
				order[42] = 40150
				order[43] = 40151
				order[44] = 40152
				order[45] = 40153
				order[46] = 40154
				order[47] = 40155
				order[48] = 40156
				order[49] = 40158
				order[50] = 40159
				order[51] = 40160
				order[52] = 40161
				order[53] = 40162
				order[54] = 40101
				order[55] = 40102
				order[56] = 40103
				order[57] = 40104
				order[58] = 40105
				order[59] = 40106
				order[60] = 40107
				order[61] = 40163
				order[62] = 40165
				order[63] = 40166
				order[64] = 40167
				order[65] = 40168
				order[66] = 40169
				order[67] = 40170
				order[68] = 40108
				order[69] = 40109
				order[70] = 40110
				order[71] = 40111
				order[72] = 40112
				order[73] = 41406
				order[74] = 40113
				order[75] = 40986
				order[76] = 40987
				order[77] = 40174
				order[78] = 0
				super(40090, 40091, order)
			end

			class NoProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40094
					order[1] = 0
					super(40957, 40094, order)
				end
			end

			class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40117
					order[1] = 0
					super(40953, 40117, order)
				end
			end

			class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40124
					order[1] = 0
					super(40954, 40124, order)
				end
			end

			class NoProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40143
					order[1] = 40144
					order[2] = 0
					super(40142, 40143, order)
				end
			end

			class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40147
					order[1] = 0
					super(40955, 40147, order)
				end
			end

			class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40157
					order[1] = 0
					super(40956, 40157, order)
				end
			end

			class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40164
					order[1] = 0
					super(40952, 40164, order)
				end
			end

			class NoProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40172
					order[1] = 40173
					order[2] = 0
					super(40171, 40172, order)
				end
			end

			class NoProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40175
					order[1] = 40176
					order[2] = 40177
					order[3] = 2385
					order[4] = 40178
					order[5] = 0
					super(40174, 40175, order)
				end

				class NoProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40179
						order[1] = 40180
						order[2] = 0
						super(40178, 40179, order)
					end
				end
			end
		end

		class NoAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40020
				order[1] = 40021
				order[2] = 40000
				order[3] = 0
				super(40019, 40020, order)
			end

			class NoAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 40001
					order[1] = 40002
					order[2] = 40003
					order[3] = 40004
					order[4] = 40005
					order[5] = 40006
					order[6] = 40007
					order[7] = 40008
					order[8] = 40009
					order[9] = 40010
					order[10] = 40011
					order[11] = 40012
					order[12] = 40013
					order[13] = 40014
					order[14] = 40015
					order[15] = 40016
					order[16] = 40017
					order[17] = 40018
					order[18] = 0
					super(40000, 40001, order)
				end
			end
		end

		class NoProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 40182
				order[1] = 40183
				order[2] = 40184
				order[3] = 40185
				order[4] = 40186
				order[5] = 40187
				order[6] = 40188
				order[7] = 40951
				order[8] = 40191
				order[9] = 40201
				order[10] = 40190
				order[11] = 0
				super(40181, 40182, order)
			end

			class NoProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40189
					order[1] = 0
					super(40951, 40189, order)
				end
			end

			class NoProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40192
					order[1] = 40193
					order[2] = 40194
					order[3] = 40195
					order[4] = 40196
					order[5] = 40197
					order[6] = 40198
					order[7] = 40199
					order[8] = 0
					super(40191, 40192, order)
				end

				class NoProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40200
						order[1] = 0
						super(40199, 40200, order)
					end
				end
			end

			class NoProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40202
					order[1] = 40203
					order[2] = 0
					super(40201, 40202, order)
				end
			end
		end

		class NoCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 40023
				order[1] = 40024
				order[2] = 40916
				order[3] = 40917
				order[4] = 40025
				order[5] = 40026
				order[6] = 40027
				order[7] = 40028
				order[8] = 40029
				order[9] = 40030
				order[10] = 40031
				order[11] = 40277
				order[12] = 42216
				order[13] = 42217
				order[14] = 40033
				order[15] = 40034
				order[16] = 42207
				order[17] = 42208
				order[18] = 42209
				order[19] = 42210
				order[20] = 42211
				order[21] = 42212
				order[22] = 42213
				order[23] = 40035
				order[24] = 40036
				order[25] = 40037
				order[26] = 40038
				order[27] = 40039
				order[28] = 0
				super(40022, 40023, order)
			end

			class NoCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40032
					order[1] = 0
					super(40277, 40032, order)
				end
			end

			class NoCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42215
					order[1] = 0
					super(42214, 42215, order)
				end
			end
		end

		class NoPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40209
				order[1] = 40205
				order[2] = 40206
				order[3] = 40207
				order[4] = 40208
				order[5] = 0
				super(40204, 40209, order)
			end

			class NoPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40210
					order[1] = 40211
					order[2] = 0
					super(40209, 40210, order)
				end
			end
		end

		class NoExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42297
				order[1] = 42298
				order[2] = 0
				super(42296, 42297, order)
			end
		end

		class NoInstrAttrib < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 871
				order[1] = 872
				order[2] = 0
				super(870, 871, order)
			end
		end

		class NoIndexRollMonths < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 2733
				order[1] = 0
				super(2734, 2733, order)
			end
		end

		class NoReferenceDataDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2747
				order[1] = 2748
				order[2] = 0
				super(2746, 2747, order)
			end
		end

		class NoContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40041
				order[1] = 0
				super(40040, 40041, order)
			end
		end

		class NoFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40047
				order[1] = 40048
				order[2] = 0
				super(40046, 40047, order)
			end
		end

		class NoContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40043
				order[1] = 40044
				order[2] = 40045
				order[3] = 0
				super(40042, 40043, order)
			end
		end

		class NoRelatedInstruments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1648
				order[1] = 1649
				order[2] = 1650
				order[3] = 1651
				order[4] = 1652
				order[5] = 1653
				order[6] = 2413
				order[7] = 2414
				order[8] = 2415
				order[9] = 2417
				order[10] = 0
				super(1647, 1648, order)
			end
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoLinesOfText < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 58
			order[1] = 354
			order[2] = 355
			order[3] = 0
			super(33, 58, order)
		end
	end
end

class Email < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("C") )
	end

	class NoRoutingIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 216
			order[1] = 217
			order[2] = 0
			super(215, 216, order)
		end
	end

	class NoRelatedSym < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(183)
			order[0] = 55
			order[1] = 65
			order[2] = 48
			order[3] = 22
			order[4] = 460
			order[5] = 1227
			order[6] = 1151
			order[7] = 461
			order[8] = 2891
			order[9] = 167
			order[10] = 762
			order[11] = 200
			order[12] = 541
			order[13] = 1079
			order[14] = 966
			order[15] = 1049
			order[16] = 965
			order[17] = 224
			order[18] = 1449
			order[19] = 1450
			order[20] = 1451
			order[21] = 1452
			order[22] = 1457
			order[23] = 1458
			order[24] = 1739
			order[25] = 2210
			order[26] = 1938
			order[27] = 1939
			order[28] = 1940
			order[29] = 2735
			order[30] = 1941
			order[31] = 1575
			order[32] = 1942
			order[33] = 1943
			order[34] = 1944
			order[35] = 1945
			order[36] = 1946
			order[37] = 1947
			order[38] = 1948
			order[39] = 1949
			order[40] = 1950
			order[41] = 2879
			order[42] = 1951
			order[43] = 1952
			order[44] = 1953
			order[45] = 1954
			order[46] = 1955
			order[47] = 1956
			order[48] = 1957
			order[49] = 1958
			order[50] = 1959
			order[51] = 1960
			order[52] = 1577
			order[53] = 1580
			order[54] = 1581
			order[55] = 1678
			order[56] = 1697
			order[57] = 225
			order[58] = 239
			order[59] = 226
			order[60] = 227
			order[61] = 228
			order[62] = 255
			order[63] = 543
			order[64] = 470
			order[65] = 471
			order[66] = 472
			order[67] = 240
			order[68] = 202
			order[69] = 2578
			order[70] = 2577
			order[71] = 947
			order[72] = 2904
			order[73] = 967
			order[74] = 968
			order[75] = 1698
			order[76] = 1866
			order[77] = 2600
			order[78] = 2001
			order[79] = 2601
			order[80] = 1478
			order[81] = 1479
			order[82] = 1480
			order[83] = 1481
			order[84] = 206
			order[85] = 231
			order[86] = 1435
			order[87] = 2353
			order[88] = 1439
			order[89] = 969
			order[90] = 1146
			order[91] = 996
			order[92] = 1147
			order[93] = 1716
			order[94] = 2905
			order[95] = 1191
			order[96] = 1192
			order[97] = 1717
			order[98] = 2906
			order[99] = 1193
			order[100] = 2579
			order[101] = 1194
			order[102] = 1482
			order[103] = 1195
			order[104] = 2753
			order[105] = 1196
			order[106] = 1197
			order[107] = 2002
			order[108] = 2140
			order[109] = 1524
			order[110] = 2907
			order[111] = 1198
			order[112] = 1199
			order[113] = 1200
			order[114] = 201
			order[115] = 2681
			order[116] = 2685
			order[117] = 1244
			order[118] = 1242
			order[119] = 2575
			order[120] = 2574
			order[121] = 997
			order[122] = 223
			order[123] = 207
			order[124] = 970
			order[125] = 971
			order[126] = 106
			order[127] = 348
			order[128] = 349
			order[129] = 2737
			order[130] = 2714
			order[131] = 2715
			order[132] = 2716
			order[133] = 107
			order[134] = 350
			order[135] = 351
			order[136] = 691
			order[137] = 667
			order[138] = 875
			order[139] = 876
			order[140] = 873
			order[141] = 874
			order[142] = 1687
			order[143] = 1787
			order[144] = 2141
			order[145] = 2142
			order[146] = 2143
			order[147] = 2752
			order[148] = 2144
			order[149] = 2145
			order[150] = 2576
			order[151] = 2962
			order[152] = 2602
			order[153] = 2603
			order[154] = 668
			order[155] = 869
			order[156] = 2736
			order[157] = 2738
			order[158] = 913
			order[159] = 914
			order[160] = 1961
			order[161] = 915
			order[162] = 918
			order[163] = 2952
			order[164] = 1962
			order[165] = 1963
			order[166] = 1964
			order[167] = 1965
			order[168] = 1966
			order[169] = 1967
			order[170] = 1968
			order[171] = 1969
			order[172] = 1970
			order[173] = 1513
			order[174] = 1525
			order[175] = 1527
			order[176] = 788
			order[177] = 916
			order[178] = 917
			order[179] = 919
			order[180] = 898
			order[181] = 1647
			order[182] = 0
			super(146, 55, order)
		end

		class NoSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 455
				order[1] = 456
				order[2] = 2957
				order[3] = 0
				super(454, 455, order)
			end
		end

		class NoSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1977
				order[1] = 1978
				order[2] = 1979
				order[3] = 2741
				order[4] = 0
				super(1976, 1977, order)
			end
		end

		class NoAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2305
				order[1] = 2306
				order[2] = 2307
				order[3] = 0
				super(2304, 2305, order)
			end
		end

		class NoEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 865
				order[1] = 866
				order[2] = 1145
				order[3] = 1827
				order[4] = 1826
				order[5] = 2340
				order[6] = 867
				order[7] = 868
				order[8] = 1578
				order[9] = 1579
				order[10] = 0
				super(864, 865, order)
			end
		end

		class NoInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1019
				order[1] = 1050
				order[2] = 1051
				order[3] = 2378
				order[4] = 1052
				order[5] = 0
				super(1018, 1019, order)
			end

			class NoInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1053
					order[1] = 1054
					order[2] = 0
					super(1052, 1053, order)
				end
			end
		end

		class NoComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 1484
				order[1] = 2117
				order[2] = 2118
				order[3] = 2119
				order[4] = 1485
				order[5] = 2120
				order[6] = 2121
				order[7] = 2122
				order[8] = 2941
				order[9] = 1486
				order[10] = 2123
				order[11] = 1487
				order[12] = 1488
				order[13] = 1489
				order[14] = 1490
				order[15] = 1491
				order[16] = 2124
				order[17] = 2942
				order[18] = 2125
				order[19] = 2943
				order[20] = 2126
				order[21] = 2127
				order[22] = 2407
				order[23] = 2408
				order[24] = 2128
				order[25] = 2129
				order[26] = 2130
				order[27] = 2131
				order[28] = 2132
				order[29] = 41013
				order[30] = 41020
				order[31] = 41021
				order[32] = 41022
				order[33] = 41023
				order[34] = 41024
				order[35] = 41025
				order[36] = 41026
				order[37] = 41027
				order[38] = 41028
				order[39] = 41010
				order[40] = 2133
				order[41] = 2134
				order[42] = 2135
				order[43] = 2136
				order[44] = 2137
				order[45] = 41029
				order[46] = 40997
				order[47] = 2597
				order[48] = 2598
				order[49] = 2599
				order[50] = 2138
				order[51] = 2139
				order[52] = 0
				super(1483, 1484, order)
			end

			class NoComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1492
					order[1] = 1493
					order[2] = 1494
					order[3] = 0
					super(1491, 1492, order)
				end

				class NoComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1495
						order[1] = 1496
						order[2] = 0
						super(1494, 1495, order)
					end
				end
			end

			class NoComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41014
					order[1] = 41015
					order[2] = 41016
					order[3] = 41017
					order[4] = 0
					super(41013, 41014, order)
				end
			end

			class NoComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41019
					order[1] = 0
					super(41018, 41019, order)
				end
			end

			class NoComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41011
					order[1] = 41012
					order[2] = 41031
					order[3] = 41007
					order[4] = 40994
					order[5] = 0
					super(41010, 41011, order)
				end

				class NoComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41032
						order[1] = 41033
						order[2] = 41034
						order[3] = 41035
						order[4] = 41036
						order[5] = 0
						super(41031, 41032, order)
					end
				end

				class NoComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41008
						order[1] = 41009
						order[2] = 0
						super(41007, 41008, order)
					end
				end

				class NoComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40995
						order[1] = 40996
						order[2] = 0
						super(40994, 40995, order)
					end
				end
			end

			class NoComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41030
					order[1] = 0
					super(41029, 41030, order)
				end
			end

			class NoComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40998
					order[1] = 40999
					order[2] = 41000
					order[3] = 41001
					order[4] = 41002
					order[5] = 41003
					order[6] = 41004
					order[7] = 41005
					order[8] = 0
					super(40997, 40998, order)
				end

				class NoComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41006
						order[1] = 0
						super(41005, 41006, order)
					end
				end
			end
		end

		class NoBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40471
				order[1] = 0
				super(40278, 40471, order)
			end
		end

		class NoPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41231
				order[1] = 0
				super(41230, 41231, order)
			end
		end

		class NoMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41093
				order[1] = 40991
				order[2] = 0
				super(41092, 41093, order)
			end
		end

		class NoMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41095
				order[1] = 40992
				order[2] = 0
				super(41094, 41095, order)
			end
		end

		class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41097
				order[1] = 41098
				order[2] = 41099
				order[3] = 41100
				order[4] = 41101
				order[5] = 41102
				order[6] = 41103
				order[7] = 41104
				order[8] = 41105
				order[9] = 0
				super(41096, 41097, order)
			end
		end

		class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42776
				order[1] = 0
				super(42775, 42776, order)
			end
		end

		class NoOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41117
				order[1] = 0
				super(41116, 41117, order)
			end
		end

		class NoOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41138
				order[1] = 41139
				order[2] = 0
				super(41137, 41138, order)
			end
		end

		class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41141
				order[1] = 0
				super(41140, 41141, order)
			end
		end

		class NoOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41153
				order[1] = 41154
				order[2] = 0
				super(41152, 41153, order)
			end
		end

		class NoStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40050
				order[1] = 41303
				order[2] = 40051
				order[3] = 42784
				order[4] = 42785
				order[5] = 40052
				order[6] = 40053
				order[7] = 41305
				order[8] = 40054
				order[9] = 40055
				order[10] = 42786
				order[11] = 42787
				order[12] = 41306
				order[13] = 41307
				order[14] = 41308
				order[15] = 41309
				order[16] = 41310
				order[17] = 41311
				order[18] = 41251
				order[19] = 41252
				order[20] = 41253
				order[21] = 41254
				order[22] = 41255
				order[23] = 41256
				order[24] = 41257
				order[25] = 42587
				order[26] = 41258
				order[27] = 41259
				order[28] = 41260
				order[29] = 41261
				order[30] = 41262
				order[31] = 41263
				order[32] = 41264
				order[33] = 41265
				order[34] = 41266
				order[35] = 41267
				order[36] = 41268
				order[37] = 41269
				order[38] = 41270
				order[39] = 41271
				order[40] = 41272
				order[41] = 41273
				order[42] = 41274
				order[43] = 41275
				order[44] = 41276
				order[45] = 40907
				order[46] = 40908
				order[47] = 40910
				order[48] = 40911
				order[49] = 40912
				order[50] = 40913
				order[51] = 40914
				order[52] = 40065
				order[53] = 40066
				order[54] = 40068
				order[55] = 40069
				order[56] = 40070
				order[57] = 40071
				order[58] = 40072
				order[59] = 41244
				order[60] = 41245
				order[61] = 40073
				order[62] = 40075
				order[63] = 40076
				order[64] = 40078
				order[65] = 40079
				order[66] = 40080
				order[67] = 40081
				order[68] = 40082
				order[69] = 40083
				order[70] = 40084
				order[71] = 41246
				order[72] = 41247
				order[73] = 41248
				order[74] = 40738
				order[75] = 40739
				order[76] = 40740
				order[77] = 42600
				order[78] = 40741
				order[79] = 40742
				order[80] = 43106
				order[81] = 40743
				order[82] = 40744
				order[83] = 40745
				order[84] = 40746
				order[85] = 40747
				order[86] = 42601
				order[87] = 42602
				order[88] = 42603
				order[89] = 42604
				order[90] = 40748
				order[91] = 40749
				order[92] = 40750
				order[93] = 41180
				order[94] = 41181
				order[95] = 41182
				order[96] = 41183
				order[97] = 41184
				order[98] = 41185
				order[99] = 41186
				order[100] = 42605
				order[101] = 40828
				order[102] = 40872
				order[103] = 41058
				order[104] = 41059
				order[105] = 41060
				order[106] = 41061
				order[107] = 41062
				order[108] = 42192
				order[109] = 42193
				order[110] = 41063
				order[111] = 41064
				order[112] = 41065
				order[113] = 41066
				order[114] = 41067
				order[115] = 41218
				order[116] = 41068
				order[117] = 41069
				order[118] = 41070
				order[119] = 41071
				order[120] = 41072
				order[121] = 41073
				order[122] = 41074
				order[123] = 41075
				order[124] = 41076
				order[125] = 41077
				order[126] = 41078
				order[127] = 41079
				order[128] = 41080
				order[129] = 43094
				order[130] = 41037
				order[131] = 40056
				order[132] = 40982
				order[133] = 40983
				order[134] = 0
				super(40049, 40050, order)
			end

			class NoStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41278
					order[1] = 41279
					order[2] = 0
					super(41277, 41278, order)
				end
			end

			class NoStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41238
					order[1] = 41239
					order[2] = 41240
					order[3] = 0
					super(41237, 41238, order)
				end
			end

			class NoStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41281
					order[1] = 41282
					order[2] = 0
					super(41280, 41281, order)
				end
			end

			class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41250
					order[1] = 0
					super(41249, 41250, order)
				end
			end

			class NoStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41290
					order[1] = 41291
					order[2] = 41292
					order[3] = 41293
					order[4] = 41294
					order[5] = 41295
					order[6] = 41296
					order[7] = 41297
					order[8] = 41298
					order[9] = 41299
					order[10] = 41300
					order[11] = 41283
					order[12] = 41301
					order[13] = 41302
					order[14] = 0
					super(41289, 41290, order)
				end

				class NoStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41284
						order[1] = 41285
						order[2] = 41286
						order[3] = 0
						super(41283, 41284, order)
					end

					class NoStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41287
							order[1] = 41288
							order[2] = 41588
							order[3] = 0
							super(41286, 41287, order)
						end
					end
				end
			end

			class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40909
					order[1] = 0
					super(40960, 40909, order)
				end
			end

			class NoStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40067
					order[1] = 0
					super(40961, 40067, order)
				end
			end

			class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40074
					order[1] = 0
					super(40958, 40074, order)
				end
			end

			class NoStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41242
					order[1] = 41243
					order[2] = 0
					super(41241, 41242, order)
				end
			end

			class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40077
					order[1] = 0
					super(40959, 40077, order)
				end
			end

			class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40752
					order[1] = 0
					super(40947, 40752, order)
				end
			end

			class NoPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41221
					order[1] = 41222
					order[2] = 0
					super(41220, 41221, order)
				end
			end

			class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40763
					order[1] = 0
					super(40948, 40763, order)
				end
			end

			class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40769
					order[1] = 0
					super(40949, 40769, order)
				end
			end

			class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40776
					order[1] = 0
					super(40950, 40776, order)
				end
			end

			class NoPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42661
					order[1] = 42662
					order[2] = 0
					super(42660, 42661, order)
				end
			end

			class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41193
					order[1] = 0
					super(41192, 41193, order)
				end
			end

			class NoPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41228
					order[1] = 41229
					order[2] = 0
					super(41227, 41228, order)
				end
			end

			class NoPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41225
					order[1] = 41226
					order[2] = 0
					super(41224, 41225, order)
				end
			end

			class NoPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43109
					order[1] = 42684
					order[2] = 42685
					order[3] = 0
					super(42683, 43109, order)
				end
			end

			class NoDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42275
					order[1] = 42276
					order[2] = 42277
					order[3] = 42278
					order[4] = 42279
					order[5] = 42280
					order[6] = 42294
					order[7] = 42281
					order[8] = 42282
					order[9] = 42283
					order[10] = 42284
					order[11] = 42285
					order[12] = 42286
					order[13] = 42287
					order[14] = 42288
					order[15] = 42289
					order[16] = 42290
					order[17] = 42291
					order[18] = 42292
					order[19] = 42293
					order[20] = 0
					super(42274, 42275, order)
				end

				class NoDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42295
						order[1] = 0
						super(42294, 42295, order)
					end
				end
			end

			class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42273
					order[1] = 0
					super(42272, 42273, order)
				end
			end

			class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42237
					order[1] = 0
					super(42236, 42237, order)
				end
			end

			class NoReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42736
					order[1] = 42737
					order[2] = 42738
					order[3] = 42739
					order[4] = 42740
					order[5] = 42741
					order[6] = 42765
					order[7] = 42731
					order[8] = 42742
					order[9] = 42743
					order[10] = 42744
					order[11] = 42745
					order[12] = 42746
					order[13] = 42747
					order[14] = 42748
					order[15] = 42749
					order[16] = 42750
					order[17] = 42751
					order[18] = 42752
					order[19] = 42753
					order[20] = 42761
					order[21] = 42754
					order[22] = 42755
					order[23] = 42709
					order[24] = 42756
					order[25] = 42757
					order[26] = 42758
					order[27] = 42759
					order[28] = 42760
					order[29] = 0
					super(42735, 42736, order)
				end

				class NoReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42766
						order[1] = 42767
						order[2] = 42768
						order[3] = 42769
						order[4] = 0
						super(42765, 42766, order)
					end
				end

				class NoReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42732
						order[1] = 42733
						order[2] = 42734
						order[3] = 0
						super(42731, 42732, order)
					end
				end

				class NoReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42762
						order[1] = 42763
						order[2] = 42764
						order[3] = 0
						super(42761, 42762, order)
					end
				end

				class NoReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42710
						order[1] = 42772
						order[2] = 42711
						order[3] = 42712
						order[4] = 42713
						order[5] = 42714
						order[6] = 42715
						order[7] = 42716
						order[8] = 42717
						order[9] = 42718
						order[10] = 42719
						order[11] = 42720
						order[12] = 42721
						order[13] = 42722
						order[14] = 42723
						order[15] = 42724
						order[16] = 42725
						order[17] = 42726
						order[18] = 42727
						order[19] = 42728
						order[20] = 42729
						order[21] = 42730
						order[22] = 42770
						order[23] = 0
						super(42709, 42710, order)
					end

					class NoReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42773
							order[1] = 42774
							order[2] = 0
							super(42772, 42773, order)
						end
					end

					class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42771
							order[1] = 0
							super(42770, 42771, order)
						end
					end
				end
			end

			class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42621
					order[1] = 0
					super(42620, 42621, order)
				end
			end

			class NoPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42607
					order[1] = 42608
					order[2] = 0
					super(42606, 42607, order)
				end
			end

			class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40819
					order[1] = 0
					super(40946, 40819, order)
				end
			end

			class NoNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40826
					order[1] = 40827
					order[2] = 0
					super(40825, 40826, order)
				end
			end

			class NoSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40086
					order[1] = 40373
					order[2] = 40655
					order[3] = 40088
					order[4] = 40089
					order[5] = 0
					super(40085, 40086, order)
				end
			end

			class NoPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40829
					order[1] = 41164
					order[2] = 41165
					order[3] = 40830
					order[4] = 40831
					order[5] = 40832
					order[6] = 40833
					order[7] = 40834
					order[8] = 40835
					order[9] = 40836
					order[10] = 40837
					order[11] = 40838
					order[12] = 40839
					order[13] = 41166
					order[14] = 41167
					order[15] = 41168
					order[16] = 41169
					order[17] = 40840
					order[18] = 40841
					order[19] = 40842
					order[20] = 40843
					order[21] = 41170
					order[22] = 41171
					order[23] = 41172
					order[24] = 41173
					order[25] = 40844
					order[26] = 40845
					order[27] = 40846
					order[28] = 40847
					order[29] = 40848
					order[30] = 40849
					order[31] = 40868
					order[32] = 40850
					order[33] = 40851
					order[34] = 40852
					order[35] = 40853
					order[36] = 40977
					order[37] = 40855
					order[38] = 40856
					order[39] = 40857
					order[40] = 41174
					order[41] = 41175
					order[42] = 40858
					order[43] = 41161
					order[44] = 41176
					order[45] = 41177
					order[46] = 41178
					order[47] = 41179
					order[48] = 40859
					order[49] = 40860
					order[50] = 40861
					order[51] = 40862
					order[52] = 40945
					order[53] = 40864
					order[54] = 40865
					order[55] = 40866
					order[56] = 40867
					order[57] = 0
					super(40828, 40829, order)
				end

				class NoPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40869
						order[1] = 40870
						order[2] = 40871
						order[3] = 0
						super(40868, 40869, order)
					end
				end

				class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40854
						order[1] = 0
						super(40977, 40854, order)
					end
				end

				class NoPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41162
						order[1] = 41163
						order[2] = 0
						super(41161, 41162, order)
					end
				end

				class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40863
						order[1] = 0
						super(40945, 40863, order)
					end
				end
			end

			class NoPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40873
					order[1] = 40874
					order[2] = 42698
					order[3] = 42699
					order[4] = 42700
					order[5] = 42701
					order[6] = 42702
					order[7] = 42703
					order[8] = 42704
					order[9] = 42689
					order[10] = 42690
					order[11] = 42691
					order[12] = 42692
					order[13] = 42693
					order[14] = 42694
					order[15] = 42695
					order[16] = 40875
					order[17] = 40876
					order[18] = 40877
					order[19] = 40878
					order[20] = 40879
					order[21] = 40880
					order[22] = 40881
					order[23] = 40882
					order[24] = 40883
					order[25] = 40884
					order[26] = 40885
					order[27] = 40886
					order[28] = 40887
					order[29] = 40888
					order[30] = 40889
					order[31] = 40890
					order[32] = 40891
					order[33] = 40892
					order[34] = 40893
					order[35] = 40894
					order[36] = 40895
					order[37] = 40896
					order[38] = 40897
					order[39] = 40898
					order[40] = 40899
					order[41] = 40900
					order[42] = 40901
					order[43] = 0
					super(40872, 40873, order)
				end

				class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42706
						order[1] = 0
						super(42705, 42706, order)
					end
				end

				class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42697
						order[1] = 0
						super(42696, 42697, order)
					end
				end
			end

			class NoDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41086
					order[1] = 0
					super(41085, 41086, order)
				end
			end

			class NoDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41082
					order[1] = 41083
					order[2] = 41084
					order[3] = 0
					super(41081, 41082, order)
				end
			end

			class NoDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41038
					order[1] = 41039
					order[2] = 41040
					order[3] = 41041
					order[4] = 41042
					order[5] = 41043
					order[6] = 41044
					order[7] = 41045
					order[8] = 41046
					order[9] = 41047
					order[10] = 41048
					order[11] = 41049
					order[12] = 41050
					order[13] = 41051
					order[14] = 0
					super(41037, 41038, order)
				end

				class NoDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41052
						order[1] = 41053
						order[2] = 41054
						order[3] = 0
						super(41051, 41052, order)
					end

					class NoDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41055
							order[1] = 41056
							order[2] = 41057
							order[3] = 0
							super(41054, 41055, order)
						end
					end
				end
			end
		end

		class NoProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40091
				order[1] = 40092
				order[2] = 40093
				order[3] = 40957
				order[4] = 40095
				order[5] = 40096
				order[6] = 40097
				order[7] = 42707
				order[8] = 42708
				order[9] = 40098
				order[10] = 40099
				order[11] = 40100
				order[12] = 40114
				order[13] = 40115
				order[14] = 40116
				order[15] = 40118
				order[16] = 40119
				order[17] = 40120
				order[18] = 40121
				order[19] = 40122
				order[20] = 40123
				order[21] = 40125
				order[22] = 40126
				order[23] = 40127
				order[24] = 40128
				order[25] = 40129
				order[26] = 40130
				order[27] = 40131
				order[28] = 40132
				order[29] = 40133
				order[30] = 40134
				order[31] = 40135
				order[32] = 40136
				order[33] = 40137
				order[34] = 40138
				order[35] = 40139
				order[36] = 40140
				order[37] = 40141
				order[38] = 40145
				order[39] = 40146
				order[40] = 40148
				order[41] = 40149
				order[42] = 40150
				order[43] = 40151
				order[44] = 40152
				order[45] = 40153
				order[46] = 40154
				order[47] = 40155
				order[48] = 40156
				order[49] = 40158
				order[50] = 40159
				order[51] = 40160
				order[52] = 40161
				order[53] = 40162
				order[54] = 40101
				order[55] = 40102
				order[56] = 40103
				order[57] = 40104
				order[58] = 40105
				order[59] = 40106
				order[60] = 40107
				order[61] = 40163
				order[62] = 40165
				order[63] = 40166
				order[64] = 40167
				order[65] = 40168
				order[66] = 40169
				order[67] = 40170
				order[68] = 40108
				order[69] = 40109
				order[70] = 40110
				order[71] = 40111
				order[72] = 40112
				order[73] = 41406
				order[74] = 40113
				order[75] = 40986
				order[76] = 40987
				order[77] = 40174
				order[78] = 0
				super(40090, 40091, order)
			end

			class NoProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40094
					order[1] = 0
					super(40957, 40094, order)
				end
			end

			class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40117
					order[1] = 0
					super(40953, 40117, order)
				end
			end

			class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40124
					order[1] = 0
					super(40954, 40124, order)
				end
			end

			class NoProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40143
					order[1] = 40144
					order[2] = 0
					super(40142, 40143, order)
				end
			end

			class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40147
					order[1] = 0
					super(40955, 40147, order)
				end
			end

			class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40157
					order[1] = 0
					super(40956, 40157, order)
				end
			end

			class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40164
					order[1] = 0
					super(40952, 40164, order)
				end
			end

			class NoProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40172
					order[1] = 40173
					order[2] = 0
					super(40171, 40172, order)
				end
			end

			class NoProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40175
					order[1] = 40176
					order[2] = 40177
					order[3] = 2385
					order[4] = 40178
					order[5] = 0
					super(40174, 40175, order)
				end

				class NoProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40179
						order[1] = 40180
						order[2] = 0
						super(40178, 40179, order)
					end
				end
			end
		end

		class NoAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40020
				order[1] = 40021
				order[2] = 40000
				order[3] = 0
				super(40019, 40020, order)
			end

			class NoAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 40001
					order[1] = 40002
					order[2] = 40003
					order[3] = 40004
					order[4] = 40005
					order[5] = 40006
					order[6] = 40007
					order[7] = 40008
					order[8] = 40009
					order[9] = 40010
					order[10] = 40011
					order[11] = 40012
					order[12] = 40013
					order[13] = 40014
					order[14] = 40015
					order[15] = 40016
					order[16] = 40017
					order[17] = 40018
					order[18] = 0
					super(40000, 40001, order)
				end
			end
		end

		class NoProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 40182
				order[1] = 40183
				order[2] = 40184
				order[3] = 40185
				order[4] = 40186
				order[5] = 40187
				order[6] = 40188
				order[7] = 40951
				order[8] = 40191
				order[9] = 40201
				order[10] = 40190
				order[11] = 0
				super(40181, 40182, order)
			end

			class NoProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40189
					order[1] = 0
					super(40951, 40189, order)
				end
			end

			class NoProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40192
					order[1] = 40193
					order[2] = 40194
					order[3] = 40195
					order[4] = 40196
					order[5] = 40197
					order[6] = 40198
					order[7] = 40199
					order[8] = 0
					super(40191, 40192, order)
				end

				class NoProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40200
						order[1] = 0
						super(40199, 40200, order)
					end
				end
			end

			class NoProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40202
					order[1] = 40203
					order[2] = 0
					super(40201, 40202, order)
				end
			end
		end

		class NoCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 40023
				order[1] = 40024
				order[2] = 40916
				order[3] = 40917
				order[4] = 40025
				order[5] = 40026
				order[6] = 40027
				order[7] = 40028
				order[8] = 40029
				order[9] = 40030
				order[10] = 40031
				order[11] = 40277
				order[12] = 42216
				order[13] = 42217
				order[14] = 40033
				order[15] = 40034
				order[16] = 42207
				order[17] = 42208
				order[18] = 42209
				order[19] = 42210
				order[20] = 42211
				order[21] = 42212
				order[22] = 42213
				order[23] = 40035
				order[24] = 40036
				order[25] = 40037
				order[26] = 40038
				order[27] = 40039
				order[28] = 0
				super(40022, 40023, order)
			end

			class NoCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40032
					order[1] = 0
					super(40277, 40032, order)
				end
			end

			class NoCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42215
					order[1] = 0
					super(42214, 42215, order)
				end
			end
		end

		class NoPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40209
				order[1] = 40205
				order[2] = 40206
				order[3] = 40207
				order[4] = 40208
				order[5] = 0
				super(40204, 40209, order)
			end

			class NoPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40210
					order[1] = 40211
					order[2] = 0
					super(40209, 40210, order)
				end
			end
		end

		class NoExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42297
				order[1] = 42298
				order[2] = 0
				super(42296, 42297, order)
			end
		end

		class NoInstrAttrib < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 871
				order[1] = 872
				order[2] = 0
				super(870, 871, order)
			end
		end

		class NoIndexRollMonths < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 2733
				order[1] = 0
				super(2734, 2733, order)
			end
		end

		class NoReferenceDataDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2747
				order[1] = 2748
				order[2] = 0
				super(2746, 2747, order)
			end
		end

		class NoContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40041
				order[1] = 0
				super(40040, 40041, order)
			end
		end

		class NoFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40047
				order[1] = 40048
				order[2] = 0
				super(40046, 40047, order)
			end
		end

		class NoContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40043
				order[1] = 40044
				order[2] = 40045
				order[3] = 0
				super(40042, 40043, order)
			end
		end

		class NoRelatedInstruments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1648
				order[1] = 1649
				order[2] = 1650
				order[3] = 1651
				order[4] = 1652
				order[5] = 1653
				order[6] = 2413
				order[7] = 2414
				order[8] = 2415
				order[9] = 2417
				order[10] = 0
				super(1647, 1648, order)
			end
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoLinesOfText < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 58
			order[1] = 354
			order[2] = 355
			order[3] = 0
			super(33, 58, order)
		end
	end

	class NoAttachments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 2105
			order[1] = 2106
			order[2] = 2107
			order[3] = 2108
			order[4] = 2109
			order[5] = 2110
			order[6] = 2111
			order[7] = 2112
			order[8] = 2113
			order[9] = 0
			super(2104, 2105, order)
		end

		class NoAttachmentKeywords < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 2114
				order[1] = 0
				super(2113, 2114, order)
			end
		end
	end
end

class NewOrderSingle < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("D") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoTargetPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1462
			order[1] = 1463
			order[2] = 1464
			order[3] = 1818
			order[4] = 2433
			order[5] = 0
			super(1461, 1462, order)
		end

		class NoTargetPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2434
				order[1] = 2435
				order[2] = 0
				super(2433, 2434, order)
			end
		end
	end

	class NoAllocs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(14)
			order[0] = 79
			order[1] = 661
			order[2] = 736
			order[3] = 2927
			order[4] = 467
			order[5] = 2727
			order[6] = 539
			order[7] = 209
			order[8] = 80
			order[9] = 1752
			order[10] = 1753
			order[11] = 1754
			order[12] = 1755
			order[13] = 0
			super(78, 79, order)
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end

	class NoValueChecks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1869
			order[1] = 1870
			order[2] = 0
			super(1868, 1869, order)
		end
	end

	class NoMatchInst < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1625
			order[1] = 1673
			order[2] = 1626
			order[3] = 1627
			order[4] = 0
			super(1624, 1625, order)
		end
	end

	class NoDisclosureInstructions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1813
			order[1] = 1814
			order[2] = 0
			super(1812, 1813, order)
		end
	end

	class NoTradingSessions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 336
			order[1] = 625
			order[2] = 0
			super(386, 336, order)
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoStipulations < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 233
			order[1] = 234
			order[2] = 0
			super(232, 233, order)
		end
	end

	class NoCommissions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(17)
			order[0] = 2640
			order[1] = 2641
			order[2] = 2725
			order[3] = 2642
			order[4] = 2643
			order[5] = 2923
			order[6] = 2644
			order[7] = 2645
			order[8] = 2924
			order[9] = 2646
			order[10] = 2647
			order[11] = 2648
			order[12] = 2649
			order[13] = 2650
			order[14] = 2651
			order[15] = 2652
			order[16] = 0
			super(2639, 2640, order)
		end
	end

	class NoOrderAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2594
			order[1] = 2595
			order[2] = 0
			super(2593, 2594, order)
		end
	end

	class NoRateSources < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1446
			order[1] = 1447
			order[2] = 1448
			order[3] = 2412
			order[4] = 2796
			order[5] = 0
			super(1445, 1446, order)
		end
	end

	class NoStrategyParameters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 958
			order[1] = 959
			order[2] = 960
			order[3] = 0
			super(957, 958, order)
		end
	end

	class NoTrdRegTimestamps < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 769
			order[1] = 770
			order[2] = 771
			order[3] = 2839
			order[4] = 1033
			order[5] = 1034
			order[6] = 1035
			order[7] = 1727
			order[8] = 2831
			order[9] = 2832
			order[10] = 2833
			order[11] = 2834
			order[12] = 0
			super(768, 769, order)
		end
	end

	class NoTrdRegPublications < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2669
			order[1] = 2670
			order[2] = 0
			super(2668, 2669, order)
		end
	end
end

class NewOrderList < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("E") )
	end

	class NoRootPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1117
			order[1] = 1118
			order[2] = 1119
			order[3] = 2388
			order[4] = 1120
			order[5] = 0
			super(1116, 1117, order)
		end

		class NoRootPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1121
				order[1] = 1122
				order[2] = 0
				super(1120, 1121, order)
			end
		end
	end

	class NoOrders < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(314)
			order[0] = 11
			order[1] = 526
			order[2] = 67
			order[3] = 583
			order[4] = 160
			order[5] = 453
			order[6] = 229
			order[7] = 75
			order[8] = 1
			order[9] = 660
			order[10] = 581
			order[11] = 589
			order[12] = 590
			order[13] = 70
			order[14] = 591
			order[15] = 78
			order[16] = 63
			order[17] = 64
			order[18] = 544
			order[19] = 635
			order[20] = 21
			order[21] = 18
			order[22] = 110
			order[23] = 1089
			order[24] = 1090
			order[25] = 1138
			order[26] = 1082
			order[27] = 1608
			order[28] = 2828
			order[29] = 1083
			order[30] = 1084
			order[31] = 1085
			order[32] = 1086
			order[33] = 1087
			order[34] = 1088
			order[35] = 111
			order[36] = 100
			order[37] = 1133
			order[38] = 386
			order[39] = 81
			order[40] = 55
			order[41] = 65
			order[42] = 48
			order[43] = 22
			order[44] = 460
			order[45] = 1227
			order[46] = 1151
			order[47] = 461
			order[48] = 2891
			order[49] = 167
			order[50] = 762
			order[51] = 200
			order[52] = 541
			order[53] = 1079
			order[54] = 966
			order[55] = 1049
			order[56] = 965
			order[57] = 224
			order[58] = 1449
			order[59] = 1450
			order[60] = 1451
			order[61] = 1452
			order[62] = 1457
			order[63] = 1458
			order[64] = 1739
			order[65] = 2210
			order[66] = 1938
			order[67] = 1939
			order[68] = 1940
			order[69] = 2735
			order[70] = 1941
			order[71] = 1575
			order[72] = 1942
			order[73] = 1943
			order[74] = 1944
			order[75] = 1945
			order[76] = 1946
			order[77] = 1947
			order[78] = 1948
			order[79] = 1949
			order[80] = 1950
			order[81] = 2879
			order[82] = 1951
			order[83] = 1952
			order[84] = 1953
			order[85] = 1954
			order[86] = 1955
			order[87] = 1956
			order[88] = 1957
			order[89] = 1958
			order[90] = 1959
			order[91] = 1960
			order[92] = 1577
			order[93] = 1580
			order[94] = 1581
			order[95] = 1678
			order[96] = 1697
			order[97] = 225
			order[98] = 239
			order[99] = 226
			order[100] = 227
			order[101] = 228
			order[102] = 255
			order[103] = 543
			order[104] = 470
			order[105] = 471
			order[106] = 472
			order[107] = 240
			order[108] = 202
			order[109] = 2578
			order[110] = 2577
			order[111] = 947
			order[112] = 2904
			order[113] = 967
			order[114] = 968
			order[115] = 1698
			order[116] = 1866
			order[117] = 2600
			order[118] = 2001
			order[119] = 2601
			order[120] = 1478
			order[121] = 1479
			order[122] = 1480
			order[123] = 1481
			order[124] = 206
			order[125] = 231
			order[126] = 1435
			order[127] = 2353
			order[128] = 1439
			order[129] = 969
			order[130] = 1146
			order[131] = 996
			order[132] = 1147
			order[133] = 1716
			order[134] = 2905
			order[135] = 1191
			order[136] = 1192
			order[137] = 1717
			order[138] = 2906
			order[139] = 1193
			order[140] = 2579
			order[141] = 1194
			order[142] = 1482
			order[143] = 1195
			order[144] = 2753
			order[145] = 1196
			order[146] = 1197
			order[147] = 2002
			order[148] = 2140
			order[149] = 1524
			order[150] = 2907
			order[151] = 1198
			order[152] = 1199
			order[153] = 1200
			order[154] = 201
			order[155] = 2681
			order[156] = 2685
			order[157] = 1244
			order[158] = 1242
			order[159] = 2575
			order[160] = 2574
			order[161] = 997
			order[162] = 223
			order[163] = 207
			order[164] = 970
			order[165] = 971
			order[166] = 106
			order[167] = 348
			order[168] = 349
			order[169] = 2737
			order[170] = 2714
			order[171] = 2715
			order[172] = 2716
			order[173] = 107
			order[174] = 350
			order[175] = 351
			order[176] = 691
			order[177] = 667
			order[178] = 875
			order[179] = 876
			order[180] = 873
			order[181] = 874
			order[182] = 1687
			order[183] = 1787
			order[184] = 2141
			order[185] = 2142
			order[186] = 2143
			order[187] = 2752
			order[188] = 2144
			order[189] = 2145
			order[190] = 2576
			order[191] = 2962
			order[192] = 2602
			order[193] = 2603
			order[194] = 711
			order[195] = 140
			order[196] = 54
			order[197] = 2102
			order[198] = 1688
			order[199] = 401
			order[200] = 114
			order[201] = 60
			order[202] = 232
			order[203] = 854
			order[204] = 38
			order[205] = 152
			order[206] = 516
			order[207] = 468
			order[208] = 469
			order[209] = 40
			order[210] = 423
			order[211] = 44
			order[212] = 1092
			order[213] = 99
			order[214] = 1100
			order[215] = 1101
			order[216] = 1628
			order[217] = 1102
			order[218] = 1103
			order[219] = 1104
			order[220] = 1105
			order[221] = 1106
			order[222] = 1107
			order[223] = 1108
			order[224] = 1109
			order[225] = 1110
			order[226] = 1111
			order[227] = 1112
			order[228] = 1113
			order[229] = 1114
			order[230] = 218
			order[231] = 220
			order[232] = 2950
			order[233] = 221
			order[234] = 222
			order[235] = 662
			order[236] = 663
			order[237] = 699
			order[238] = 761
			order[239] = 235
			order[240] = 236
			order[241] = 701
			order[242] = 696
			order[243] = 697
			order[244] = 698
			order[245] = 15
			order[246] = 2897
			order[247] = 376
			order[248] = 2404
			order[249] = 2351
			order[250] = 2352
			order[251] = 377
			order[252] = 23
			order[253] = 117
			order[254] = 1080
			order[255] = 1081
			order[256] = 59
			order[257] = 168
			order[258] = 432
			order[259] = 126
			order[260] = 427
			order[261] = 1629
			order[262] = 1916
			order[263] = 12
			order[264] = 13
			order[265] = 479
			order[266] = 2922
			order[267] = 1233
			order[268] = 1238
			order[269] = 497
			order[270] = 2639
			order[271] = 528
			order[272] = 529
			order[273] = 1091
			order[274] = 582
			order[275] = 2593
			order[276] = 121
			order[277] = 120
			order[278] = 2899
			order[279] = 775
			order[280] = 58
			order[281] = 354
			order[282] = 355
			order[283] = 193
			order[284] = 192
			order[285] = 640
			order[286] = 77
			order[287] = 203
			order[288] = 210
			order[289] = 211
			order[290] = 1094
			order[291] = 835
			order[292] = 836
			order[293] = 837
			order[294] = 838
			order[295] = 840
			order[296] = 1096
			order[297] = 1097
			order[298] = 1098
			order[299] = 1099
			order[300] = 388
			order[301] = 389
			order[302] = 841
			order[303] = 842
			order[304] = 843
			order[305] = 844
			order[306] = 846
			order[307] = 847
			order[308] = 957
			order[309] = 848
			order[310] = 849
			order[311] = 494
			order[312] = 1028
			order[313] = 0
			super(73, 11, order)
		end

		class NoPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 448
				order[1] = 447
				order[2] = 452
				order[3] = 2376
				order[4] = 802
				order[5] = 0
				super(453, 448, order)
			end

			class NoPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 523
					order[1] = 803
					order[2] = 0
					super(802, 523, order)
				end
			end
		end

		class NoAllocs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(14)
				order[0] = 79
				order[1] = 661
				order[2] = 736
				order[3] = 2927
				order[4] = 467
				order[5] = 2727
				order[6] = 539
				order[7] = 209
				order[8] = 80
				order[9] = 1752
				order[10] = 1753
				order[11] = 1754
				order[12] = 1755
				order[13] = 0
				super(78, 79, order)
			end

			class NoNestedPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 524
					order[1] = 525
					order[2] = 538
					order[3] = 2384
					order[4] = 804
					order[5] = 0
					super(539, 524, order)
				end

				class NoNestedPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 545
						order[1] = 805
						order[2] = 0
						super(804, 545, order)
					end
				end
			end
		end

		class NoTradingSessions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 336
				order[1] = 625
				order[2] = 0
				super(386, 336, order)
			end
		end

		class NoSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 455
				order[1] = 456
				order[2] = 2957
				order[3] = 0
				super(454, 455, order)
			end
		end

		class NoSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1977
				order[1] = 1978
				order[2] = 1979
				order[3] = 2741
				order[4] = 0
				super(1976, 1977, order)
			end
		end

		class NoAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2305
				order[1] = 2306
				order[2] = 2307
				order[3] = 0
				super(2304, 2305, order)
			end
		end

		class NoEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 865
				order[1] = 866
				order[2] = 1145
				order[3] = 1827
				order[4] = 1826
				order[5] = 2340
				order[6] = 867
				order[7] = 868
				order[8] = 1578
				order[9] = 1579
				order[10] = 0
				super(864, 865, order)
			end
		end

		class NoInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1019
				order[1] = 1050
				order[2] = 1051
				order[3] = 2378
				order[4] = 1052
				order[5] = 0
				super(1018, 1019, order)
			end

			class NoInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1053
					order[1] = 1054
					order[2] = 0
					super(1052, 1053, order)
				end
			end
		end

		class NoComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 1484
				order[1] = 2117
				order[2] = 2118
				order[3] = 2119
				order[4] = 1485
				order[5] = 2120
				order[6] = 2121
				order[7] = 2122
				order[8] = 2941
				order[9] = 1486
				order[10] = 2123
				order[11] = 1487
				order[12] = 1488
				order[13] = 1489
				order[14] = 1490
				order[15] = 1491
				order[16] = 2124
				order[17] = 2942
				order[18] = 2125
				order[19] = 2943
				order[20] = 2126
				order[21] = 2127
				order[22] = 2407
				order[23] = 2408
				order[24] = 2128
				order[25] = 2129
				order[26] = 2130
				order[27] = 2131
				order[28] = 2132
				order[29] = 41013
				order[30] = 41020
				order[31] = 41021
				order[32] = 41022
				order[33] = 41023
				order[34] = 41024
				order[35] = 41025
				order[36] = 41026
				order[37] = 41027
				order[38] = 41028
				order[39] = 41010
				order[40] = 2133
				order[41] = 2134
				order[42] = 2135
				order[43] = 2136
				order[44] = 2137
				order[45] = 41029
				order[46] = 40997
				order[47] = 2597
				order[48] = 2598
				order[49] = 2599
				order[50] = 2138
				order[51] = 2139
				order[52] = 0
				super(1483, 1484, order)
			end

			class NoComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1492
					order[1] = 1493
					order[2] = 1494
					order[3] = 0
					super(1491, 1492, order)
				end

				class NoComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1495
						order[1] = 1496
						order[2] = 0
						super(1494, 1495, order)
					end
				end
			end

			class NoComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41014
					order[1] = 41015
					order[2] = 41016
					order[3] = 41017
					order[4] = 0
					super(41013, 41014, order)
				end
			end

			class NoComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41019
					order[1] = 0
					super(41018, 41019, order)
				end
			end

			class NoComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41011
					order[1] = 41012
					order[2] = 41031
					order[3] = 41007
					order[4] = 40994
					order[5] = 0
					super(41010, 41011, order)
				end

				class NoComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41032
						order[1] = 41033
						order[2] = 41034
						order[3] = 41035
						order[4] = 41036
						order[5] = 0
						super(41031, 41032, order)
					end
				end

				class NoComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41008
						order[1] = 41009
						order[2] = 0
						super(41007, 41008, order)
					end
				end

				class NoComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40995
						order[1] = 40996
						order[2] = 0
						super(40994, 40995, order)
					end
				end
			end

			class NoComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41030
					order[1] = 0
					super(41029, 41030, order)
				end
			end

			class NoComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40998
					order[1] = 40999
					order[2] = 41000
					order[3] = 41001
					order[4] = 41002
					order[5] = 41003
					order[6] = 41004
					order[7] = 41005
					order[8] = 0
					super(40997, 40998, order)
				end

				class NoComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41006
						order[1] = 0
						super(41005, 41006, order)
					end
				end
			end
		end

		class NoBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40471
				order[1] = 0
				super(40278, 40471, order)
			end
		end

		class NoPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41231
				order[1] = 0
				super(41230, 41231, order)
			end
		end

		class NoMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41093
				order[1] = 40991
				order[2] = 0
				super(41092, 41093, order)
			end
		end

		class NoMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41095
				order[1] = 40992
				order[2] = 0
				super(41094, 41095, order)
			end
		end

		class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41097
				order[1] = 41098
				order[2] = 41099
				order[3] = 41100
				order[4] = 41101
				order[5] = 41102
				order[6] = 41103
				order[7] = 41104
				order[8] = 41105
				order[9] = 0
				super(41096, 41097, order)
			end
		end

		class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42776
				order[1] = 0
				super(42775, 42776, order)
			end
		end

		class NoOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41117
				order[1] = 0
				super(41116, 41117, order)
			end
		end

		class NoOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41138
				order[1] = 41139
				order[2] = 0
				super(41137, 41138, order)
			end
		end

		class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41141
				order[1] = 0
				super(41140, 41141, order)
			end
		end

		class NoOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41153
				order[1] = 41154
				order[2] = 0
				super(41152, 41153, order)
			end
		end

		class NoStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40050
				order[1] = 41303
				order[2] = 40051
				order[3] = 42784
				order[4] = 42785
				order[5] = 40052
				order[6] = 40053
				order[7] = 41305
				order[8] = 40054
				order[9] = 40055
				order[10] = 42786
				order[11] = 42787
				order[12] = 41306
				order[13] = 41307
				order[14] = 41308
				order[15] = 41309
				order[16] = 41310
				order[17] = 41311
				order[18] = 41251
				order[19] = 41252
				order[20] = 41253
				order[21] = 41254
				order[22] = 41255
				order[23] = 41256
				order[24] = 41257
				order[25] = 42587
				order[26] = 41258
				order[27] = 41259
				order[28] = 41260
				order[29] = 41261
				order[30] = 41262
				order[31] = 41263
				order[32] = 41264
				order[33] = 41265
				order[34] = 41266
				order[35] = 41267
				order[36] = 41268
				order[37] = 41269
				order[38] = 41270
				order[39] = 41271
				order[40] = 41272
				order[41] = 41273
				order[42] = 41274
				order[43] = 41275
				order[44] = 41276
				order[45] = 40907
				order[46] = 40908
				order[47] = 40910
				order[48] = 40911
				order[49] = 40912
				order[50] = 40913
				order[51] = 40914
				order[52] = 40065
				order[53] = 40066
				order[54] = 40068
				order[55] = 40069
				order[56] = 40070
				order[57] = 40071
				order[58] = 40072
				order[59] = 41244
				order[60] = 41245
				order[61] = 40073
				order[62] = 40075
				order[63] = 40076
				order[64] = 40078
				order[65] = 40079
				order[66] = 40080
				order[67] = 40081
				order[68] = 40082
				order[69] = 40083
				order[70] = 40084
				order[71] = 41246
				order[72] = 41247
				order[73] = 41248
				order[74] = 40738
				order[75] = 40739
				order[76] = 40740
				order[77] = 42600
				order[78] = 40741
				order[79] = 40742
				order[80] = 43106
				order[81] = 40743
				order[82] = 40744
				order[83] = 40745
				order[84] = 40746
				order[85] = 40747
				order[86] = 42601
				order[87] = 42602
				order[88] = 42603
				order[89] = 42604
				order[90] = 40748
				order[91] = 40749
				order[92] = 40750
				order[93] = 41180
				order[94] = 41181
				order[95] = 41182
				order[96] = 41183
				order[97] = 41184
				order[98] = 41185
				order[99] = 41186
				order[100] = 42605
				order[101] = 40828
				order[102] = 40872
				order[103] = 41058
				order[104] = 41059
				order[105] = 41060
				order[106] = 41061
				order[107] = 41062
				order[108] = 42192
				order[109] = 42193
				order[110] = 41063
				order[111] = 41064
				order[112] = 41065
				order[113] = 41066
				order[114] = 41067
				order[115] = 41218
				order[116] = 41068
				order[117] = 41069
				order[118] = 41070
				order[119] = 41071
				order[120] = 41072
				order[121] = 41073
				order[122] = 41074
				order[123] = 41075
				order[124] = 41076
				order[125] = 41077
				order[126] = 41078
				order[127] = 41079
				order[128] = 41080
				order[129] = 43094
				order[130] = 41037
				order[131] = 40056
				order[132] = 40982
				order[133] = 40983
				order[134] = 0
				super(40049, 40050, order)
			end

			class NoStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41278
					order[1] = 41279
					order[2] = 0
					super(41277, 41278, order)
				end
			end

			class NoStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41238
					order[1] = 41239
					order[2] = 41240
					order[3] = 0
					super(41237, 41238, order)
				end
			end

			class NoStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41281
					order[1] = 41282
					order[2] = 0
					super(41280, 41281, order)
				end
			end

			class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41250
					order[1] = 0
					super(41249, 41250, order)
				end
			end

			class NoStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41290
					order[1] = 41291
					order[2] = 41292
					order[3] = 41293
					order[4] = 41294
					order[5] = 41295
					order[6] = 41296
					order[7] = 41297
					order[8] = 41298
					order[9] = 41299
					order[10] = 41300
					order[11] = 41283
					order[12] = 41301
					order[13] = 41302
					order[14] = 0
					super(41289, 41290, order)
				end

				class NoStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41284
						order[1] = 41285
						order[2] = 41286
						order[3] = 0
						super(41283, 41284, order)
					end

					class NoStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41287
							order[1] = 41288
							order[2] = 41588
							order[3] = 0
							super(41286, 41287, order)
						end
					end
				end
			end

			class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40909
					order[1] = 0
					super(40960, 40909, order)
				end
			end

			class NoStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40067
					order[1] = 0
					super(40961, 40067, order)
				end
			end

			class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40074
					order[1] = 0
					super(40958, 40074, order)
				end
			end

			class NoStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41242
					order[1] = 41243
					order[2] = 0
					super(41241, 41242, order)
				end
			end

			class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40077
					order[1] = 0
					super(40959, 40077, order)
				end
			end

			class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40752
					order[1] = 0
					super(40947, 40752, order)
				end
			end

			class NoPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41221
					order[1] = 41222
					order[2] = 0
					super(41220, 41221, order)
				end
			end

			class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40763
					order[1] = 0
					super(40948, 40763, order)
				end
			end

			class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40769
					order[1] = 0
					super(40949, 40769, order)
				end
			end

			class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40776
					order[1] = 0
					super(40950, 40776, order)
				end
			end

			class NoPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42661
					order[1] = 42662
					order[2] = 0
					super(42660, 42661, order)
				end
			end

			class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41193
					order[1] = 0
					super(41192, 41193, order)
				end
			end

			class NoPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41228
					order[1] = 41229
					order[2] = 0
					super(41227, 41228, order)
				end
			end

			class NoPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41225
					order[1] = 41226
					order[2] = 0
					super(41224, 41225, order)
				end
			end

			class NoPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43109
					order[1] = 42684
					order[2] = 42685
					order[3] = 0
					super(42683, 43109, order)
				end
			end

			class NoDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42275
					order[1] = 42276
					order[2] = 42277
					order[3] = 42278
					order[4] = 42279
					order[5] = 42280
					order[6] = 42294
					order[7] = 42281
					order[8] = 42282
					order[9] = 42283
					order[10] = 42284
					order[11] = 42285
					order[12] = 42286
					order[13] = 42287
					order[14] = 42288
					order[15] = 42289
					order[16] = 42290
					order[17] = 42291
					order[18] = 42292
					order[19] = 42293
					order[20] = 0
					super(42274, 42275, order)
				end

				class NoDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42295
						order[1] = 0
						super(42294, 42295, order)
					end
				end
			end

			class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42273
					order[1] = 0
					super(42272, 42273, order)
				end
			end

			class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42237
					order[1] = 0
					super(42236, 42237, order)
				end
			end

			class NoReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42736
					order[1] = 42737
					order[2] = 42738
					order[3] = 42739
					order[4] = 42740
					order[5] = 42741
					order[6] = 42765
					order[7] = 42731
					order[8] = 42742
					order[9] = 42743
					order[10] = 42744
					order[11] = 42745
					order[12] = 42746
					order[13] = 42747
					order[14] = 42748
					order[15] = 42749
					order[16] = 42750
					order[17] = 42751
					order[18] = 42752
					order[19] = 42753
					order[20] = 42761
					order[21] = 42754
					order[22] = 42755
					order[23] = 42709
					order[24] = 42756
					order[25] = 42757
					order[26] = 42758
					order[27] = 42759
					order[28] = 42760
					order[29] = 0
					super(42735, 42736, order)
				end

				class NoReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42766
						order[1] = 42767
						order[2] = 42768
						order[3] = 42769
						order[4] = 0
						super(42765, 42766, order)
					end
				end

				class NoReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42732
						order[1] = 42733
						order[2] = 42734
						order[3] = 0
						super(42731, 42732, order)
					end
				end

				class NoReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42762
						order[1] = 42763
						order[2] = 42764
						order[3] = 0
						super(42761, 42762, order)
					end
				end

				class NoReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42710
						order[1] = 42772
						order[2] = 42711
						order[3] = 42712
						order[4] = 42713
						order[5] = 42714
						order[6] = 42715
						order[7] = 42716
						order[8] = 42717
						order[9] = 42718
						order[10] = 42719
						order[11] = 42720
						order[12] = 42721
						order[13] = 42722
						order[14] = 42723
						order[15] = 42724
						order[16] = 42725
						order[17] = 42726
						order[18] = 42727
						order[19] = 42728
						order[20] = 42729
						order[21] = 42730
						order[22] = 42770
						order[23] = 0
						super(42709, 42710, order)
					end

					class NoReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42773
							order[1] = 42774
							order[2] = 0
							super(42772, 42773, order)
						end
					end

					class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42771
							order[1] = 0
							super(42770, 42771, order)
						end
					end
				end
			end

			class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42621
					order[1] = 0
					super(42620, 42621, order)
				end
			end

			class NoPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42607
					order[1] = 42608
					order[2] = 0
					super(42606, 42607, order)
				end
			end

			class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40819
					order[1] = 0
					super(40946, 40819, order)
				end
			end

			class NoNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40826
					order[1] = 40827
					order[2] = 0
					super(40825, 40826, order)
				end
			end

			class NoSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40086
					order[1] = 40373
					order[2] = 40655
					order[3] = 40088
					order[4] = 40089
					order[5] = 0
					super(40085, 40086, order)
				end
			end

			class NoPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40829
					order[1] = 41164
					order[2] = 41165
					order[3] = 40830
					order[4] = 40831
					order[5] = 40832
					order[6] = 40833
					order[7] = 40834
					order[8] = 40835
					order[9] = 40836
					order[10] = 40837
					order[11] = 40838
					order[12] = 40839
					order[13] = 41166
					order[14] = 41167
					order[15] = 41168
					order[16] = 41169
					order[17] = 40840
					order[18] = 40841
					order[19] = 40842
					order[20] = 40843
					order[21] = 41170
					order[22] = 41171
					order[23] = 41172
					order[24] = 41173
					order[25] = 40844
					order[26] = 40845
					order[27] = 40846
					order[28] = 40847
					order[29] = 40848
					order[30] = 40849
					order[31] = 40868
					order[32] = 40850
					order[33] = 40851
					order[34] = 40852
					order[35] = 40853
					order[36] = 40977
					order[37] = 40855
					order[38] = 40856
					order[39] = 40857
					order[40] = 41174
					order[41] = 41175
					order[42] = 40858
					order[43] = 41161
					order[44] = 41176
					order[45] = 41177
					order[46] = 41178
					order[47] = 41179
					order[48] = 40859
					order[49] = 40860
					order[50] = 40861
					order[51] = 40862
					order[52] = 40945
					order[53] = 40864
					order[54] = 40865
					order[55] = 40866
					order[56] = 40867
					order[57] = 0
					super(40828, 40829, order)
				end

				class NoPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40869
						order[1] = 40870
						order[2] = 40871
						order[3] = 0
						super(40868, 40869, order)
					end
				end

				class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40854
						order[1] = 0
						super(40977, 40854, order)
					end
				end

				class NoPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41162
						order[1] = 41163
						order[2] = 0
						super(41161, 41162, order)
					end
				end

				class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40863
						order[1] = 0
						super(40945, 40863, order)
					end
				end
			end

			class NoPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40873
					order[1] = 40874
					order[2] = 42698
					order[3] = 42699
					order[4] = 42700
					order[5] = 42701
					order[6] = 42702
					order[7] = 42703
					order[8] = 42704
					order[9] = 42689
					order[10] = 42690
					order[11] = 42691
					order[12] = 42692
					order[13] = 42693
					order[14] = 42694
					order[15] = 42695
					order[16] = 40875
					order[17] = 40876
					order[18] = 40877
					order[19] = 40878
					order[20] = 40879
					order[21] = 40880
					order[22] = 40881
					order[23] = 40882
					order[24] = 40883
					order[25] = 40884
					order[26] = 40885
					order[27] = 40886
					order[28] = 40887
					order[29] = 40888
					order[30] = 40889
					order[31] = 40890
					order[32] = 40891
					order[33] = 40892
					order[34] = 40893
					order[35] = 40894
					order[36] = 40895
					order[37] = 40896
					order[38] = 40897
					order[39] = 40898
					order[40] = 40899
					order[41] = 40900
					order[42] = 40901
					order[43] = 0
					super(40872, 40873, order)
				end

				class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42706
						order[1] = 0
						super(42705, 42706, order)
					end
				end

				class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42697
						order[1] = 0
						super(42696, 42697, order)
					end
				end
			end

			class NoDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41086
					order[1] = 0
					super(41085, 41086, order)
				end
			end

			class NoDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41082
					order[1] = 41083
					order[2] = 41084
					order[3] = 0
					super(41081, 41082, order)
				end
			end

			class NoDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41038
					order[1] = 41039
					order[2] = 41040
					order[3] = 41041
					order[4] = 41042
					order[5] = 41043
					order[6] = 41044
					order[7] = 41045
					order[8] = 41046
					order[9] = 41047
					order[10] = 41048
					order[11] = 41049
					order[12] = 41050
					order[13] = 41051
					order[14] = 0
					super(41037, 41038, order)
				end

				class NoDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41052
						order[1] = 41053
						order[2] = 41054
						order[3] = 0
						super(41051, 41052, order)
					end

					class NoDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41055
							order[1] = 41056
							order[2] = 41057
							order[3] = 0
							super(41054, 41055, order)
						end
					end
				end
			end
		end

		class NoProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40091
				order[1] = 40092
				order[2] = 40093
				order[3] = 40957
				order[4] = 40095
				order[5] = 40096
				order[6] = 40097
				order[7] = 42707
				order[8] = 42708
				order[9] = 40098
				order[10] = 40099
				order[11] = 40100
				order[12] = 40114
				order[13] = 40115
				order[14] = 40116
				order[15] = 40118
				order[16] = 40119
				order[17] = 40120
				order[18] = 40121
				order[19] = 40122
				order[20] = 40123
				order[21] = 40125
				order[22] = 40126
				order[23] = 40127
				order[24] = 40128
				order[25] = 40129
				order[26] = 40130
				order[27] = 40131
				order[28] = 40132
				order[29] = 40133
				order[30] = 40134
				order[31] = 40135
				order[32] = 40136
				order[33] = 40137
				order[34] = 40138
				order[35] = 40139
				order[36] = 40140
				order[37] = 40141
				order[38] = 40145
				order[39] = 40146
				order[40] = 40148
				order[41] = 40149
				order[42] = 40150
				order[43] = 40151
				order[44] = 40152
				order[45] = 40153
				order[46] = 40154
				order[47] = 40155
				order[48] = 40156
				order[49] = 40158
				order[50] = 40159
				order[51] = 40160
				order[52] = 40161
				order[53] = 40162
				order[54] = 40101
				order[55] = 40102
				order[56] = 40103
				order[57] = 40104
				order[58] = 40105
				order[59] = 40106
				order[60] = 40107
				order[61] = 40163
				order[62] = 40165
				order[63] = 40166
				order[64] = 40167
				order[65] = 40168
				order[66] = 40169
				order[67] = 40170
				order[68] = 40108
				order[69] = 40109
				order[70] = 40110
				order[71] = 40111
				order[72] = 40112
				order[73] = 41406
				order[74] = 40113
				order[75] = 40986
				order[76] = 40987
				order[77] = 40174
				order[78] = 0
				super(40090, 40091, order)
			end

			class NoProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40094
					order[1] = 0
					super(40957, 40094, order)
				end
			end

			class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40117
					order[1] = 0
					super(40953, 40117, order)
				end
			end

			class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40124
					order[1] = 0
					super(40954, 40124, order)
				end
			end

			class NoProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40143
					order[1] = 40144
					order[2] = 0
					super(40142, 40143, order)
				end
			end

			class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40147
					order[1] = 0
					super(40955, 40147, order)
				end
			end

			class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40157
					order[1] = 0
					super(40956, 40157, order)
				end
			end

			class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40164
					order[1] = 0
					super(40952, 40164, order)
				end
			end

			class NoProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40172
					order[1] = 40173
					order[2] = 0
					super(40171, 40172, order)
				end
			end

			class NoProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40175
					order[1] = 40176
					order[2] = 40177
					order[3] = 2385
					order[4] = 40178
					order[5] = 0
					super(40174, 40175, order)
				end

				class NoProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40179
						order[1] = 40180
						order[2] = 0
						super(40178, 40179, order)
					end
				end
			end
		end

		class NoAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40020
				order[1] = 40021
				order[2] = 40000
				order[3] = 0
				super(40019, 40020, order)
			end

			class NoAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 40001
					order[1] = 40002
					order[2] = 40003
					order[3] = 40004
					order[4] = 40005
					order[5] = 40006
					order[6] = 40007
					order[7] = 40008
					order[8] = 40009
					order[9] = 40010
					order[10] = 40011
					order[11] = 40012
					order[12] = 40013
					order[13] = 40014
					order[14] = 40015
					order[15] = 40016
					order[16] = 40017
					order[17] = 40018
					order[18] = 0
					super(40000, 40001, order)
				end
			end
		end

		class NoProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 40182
				order[1] = 40183
				order[2] = 40184
				order[3] = 40185
				order[4] = 40186
				order[5] = 40187
				order[6] = 40188
				order[7] = 40951
				order[8] = 40191
				order[9] = 40201
				order[10] = 40190
				order[11] = 0
				super(40181, 40182, order)
			end

			class NoProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40189
					order[1] = 0
					super(40951, 40189, order)
				end
			end

			class NoProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40192
					order[1] = 40193
					order[2] = 40194
					order[3] = 40195
					order[4] = 40196
					order[5] = 40197
					order[6] = 40198
					order[7] = 40199
					order[8] = 0
					super(40191, 40192, order)
				end

				class NoProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40200
						order[1] = 0
						super(40199, 40200, order)
					end
				end
			end

			class NoProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40202
					order[1] = 40203
					order[2] = 0
					super(40201, 40202, order)
				end
			end
		end

		class NoCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 40023
				order[1] = 40024
				order[2] = 40916
				order[3] = 40917
				order[4] = 40025
				order[5] = 40026
				order[6] = 40027
				order[7] = 40028
				order[8] = 40029
				order[9] = 40030
				order[10] = 40031
				order[11] = 40277
				order[12] = 42216
				order[13] = 42217
				order[14] = 40033
				order[15] = 40034
				order[16] = 42207
				order[17] = 42208
				order[18] = 42209
				order[19] = 42210
				order[20] = 42211
				order[21] = 42212
				order[22] = 42213
				order[23] = 40035
				order[24] = 40036
				order[25] = 40037
				order[26] = 40038
				order[27] = 40039
				order[28] = 0
				super(40022, 40023, order)
			end

			class NoCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40032
					order[1] = 0
					super(40277, 40032, order)
				end
			end

			class NoCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42215
					order[1] = 0
					super(42214, 42215, order)
				end
			end
		end

		class NoPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40209
				order[1] = 40205
				order[2] = 40206
				order[3] = 40207
				order[4] = 40208
				order[5] = 0
				super(40204, 40209, order)
			end

			class NoPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40210
					order[1] = 40211
					order[2] = 0
					super(40209, 40210, order)
				end
			end
		end

		class NoExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42297
				order[1] = 42298
				order[2] = 0
				super(42296, 42297, order)
			end
		end

		class NoUnderlyings < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(188)
				order[0] = 311
				order[1] = 312
				order[2] = 309
				order[3] = 305
				order[4] = 2874
				order[5] = 462
				order[6] = 463
				order[7] = 2894
				order[8] = 310
				order[9] = 763
				order[10] = 313
				order[11] = 542
				order[12] = 1213
				order[13] = 1837
				order[14] = 241
				order[15] = 1453
				order[16] = 1454
				order[17] = 2614
				order[18] = 2615
				order[19] = 2921
				order[20] = 2616
				order[21] = 2617
				order[22] = 2619
				order[23] = 1455
				order[24] = 1456
				order[25] = 1459
				order[26] = 1460
				order[27] = 242
				order[28] = 243
				order[29] = 244
				order[30] = 245
				order[31] = 246
				order[32] = 256
				order[33] = 595
				order[34] = 592
				order[35] = 593
				order[36] = 594
				order[37] = 247
				order[38] = 316
				order[39] = 941
				order[40] = 2917
				order[41] = 317
				order[42] = 436
				order[43] = 1437
				order[44] = 2363
				order[45] = 1441
				order[46] = 998
				order[47] = 1423
				order[48] = 1718
				order[49] = 2918
				order[50] = 1424
				order[51] = 1425
				order[52] = 1719
				order[53] = 2919
				order[54] = 1000
				order[55] = 1419
				order[56] = 1526
				order[57] = 2920
				order[58] = 435
				order[59] = 308
				order[60] = 306
				order[61] = 362
				order[62] = 363
				order[63] = 2742
				order[64] = 2720
				order[65] = 2721
				order[66] = 2722
				order[67] = 2723
				order[68] = 2724
				order[69] = 307
				order[70] = 364
				order[71] = 365
				order[72] = 877
				order[73] = 878
				order[74] = 972
				order[75] = 318
				order[76] = 2916
				order[77] = 879
				order[78] = 975
				order[79] = 973
				order[80] = 974
				order[81] = 810
				order[82] = 882
				order[83] = 883
				order[84] = 884
				order[85] = 885
				order[86] = 886
				order[87] = 2885
				order[88] = 2886
				order[89] = 1044
				order[90] = 1045
				order[91] = 1046
				order[92] = 1038
				order[93] = 1039
				order[94] = 315
				order[95] = 2683
				order[96] = 2687
				order[97] = 1988
				order[98] = 1989
				order[99] = 1990
				order[100] = 1991
				order[101] = 1992
				order[102] = 1993
				order[103] = 2881
				order[104] = 1994
				order[105] = 1995
				order[106] = 1996
				order[107] = 1997
				order[108] = 2620
				order[109] = 2621
				order[110] = 1998
				order[111] = 1999
				order[112] = 2000
				order[113] = 2003
				order[114] = 2004
				order[115] = 2005
				order[116] = 2006
				order[117] = 2284
				order[118] = 2285
				order[119] = 2286
				order[120] = 2287
				order[121] = 2288
				order[122] = 2007
				order[123] = 2008
				order[124] = 2009
				order[125] = 2010
				order[126] = 2011
				order[127] = 2012
				order[128] = 2491
				order[129] = 2013
				order[130] = 2014
				order[131] = 2015
				order[132] = 2744
				order[133] = 2016
				order[134] = 2289
				order[135] = 2017
				order[136] = 2018
				order[137] = 2019
				order[138] = 2020
				order[139] = 2021
				order[140] = 2022
				order[141] = 2290
				order[142] = 2622
				order[143] = 2291
				order[144] = 2623
				order[145] = 2292
				order[146] = 2023
				order[147] = 2024
				order[148] = 2025
				order[149] = 2026
				order[150] = 2027
				order[151] = 2028
				order[152] = 2029
				order[153] = 2757
				order[154] = 2030
				order[155] = 2031
				order[156] = 2293
				order[157] = 2294
				order[158] = 2032
				order[159] = 2033
				order[160] = 2034
				order[161] = 2035
				order[162] = 2036
				order[163] = 2037
				order[164] = 2038
				order[165] = 2039
				order[166] = 2040
				order[167] = 2041
				order[168] = 2042
				order[169] = 2043
				order[170] = 2044
				order[171] = 41314
				order[172] = 41315
				order[173] = 2295
				order[174] = 2296
				order[175] = 2297
				order[176] = 2756
				order[177] = 2298
				order[178] = 2299
				order[179] = 2624
				order[180] = 2625
				order[181] = 2626
				order[182] = 2627
				order[183] = 2628
				order[184] = 2629
				order[185] = 2630
				order[186] = 2631
				order[187] = 0
				super(711, 311, order)
			end

			class NoUnderlyingSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 458
					order[1] = 459
					order[2] = 2959
					order[3] = 0
					super(457, 458, order)
				end
			end

			class NoUnderlyingStips < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 888
					order[1] = 889
					order[2] = 0
					super(887, 888, order)
				end
			end

			class NoUndlyInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 1059
					order[1] = 1060
					order[2] = 1061
					order[3] = 2391
					order[4] = 1062
					order[5] = 0
					super(1058, 1059, order)
				end

				class NoUndlyInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1063
						order[1] = 1064
						order[2] = 0
						super(1062, 1063, order)
					end
				end
			end

			class NoUnderlyingEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 1982
					order[1] = 1983
					order[2] = 1984
					order[3] = 1985
					order[4] = 1986
					order[5] = 2342
					order[6] = 1987
					order[7] = 2071
					order[8] = 2072
					order[9] = 2073
					order[10] = 0
					super(1981, 1982, order)
				end
			end

			class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2081
					order[1] = 2082
					order[2] = 2083
					order[3] = 2745
					order[4] = 0
					super(2080, 2081, order)
				end
			end

			class NoUnderlyingAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2313
					order[1] = 2314
					order[2] = 2315
					order[3] = 0
					super(2312, 2313, order)
				end
			end

			class NoUnderlyingComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2046
					order[1] = 2261
					order[2] = 2262
					order[3] = 2263
					order[4] = 2047
					order[5] = 2264
					order[6] = 2265
					order[7] = 2266
					order[8] = 2947
					order[9] = 2048
					order[10] = 2267
					order[11] = 2049
					order[12] = 2050
					order[13] = 2051
					order[14] = 2052
					order[15] = 2053
					order[16] = 2268
					order[17] = 2948
					order[18] = 2269
					order[19] = 2949
					order[20] = 2270
					order[21] = 2271
					order[22] = 2419
					order[23] = 2420
					order[24] = 2272
					order[25] = 2273
					order[26] = 2274
					order[27] = 2275
					order[28] = 2276
					order[29] = 41732
					order[30] = 41739
					order[31] = 41740
					order[32] = 41741
					order[33] = 41742
					order[34] = 41743
					order[35] = 41744
					order[36] = 41745
					order[37] = 41746
					order[38] = 41747
					order[39] = 41729
					order[40] = 2277
					order[41] = 2278
					order[42] = 2279
					order[43] = 2280
					order[44] = 2281
					order[45] = 41748
					order[46] = 41716
					order[47] = 2611
					order[48] = 2612
					order[49] = 2613
					order[50] = 2282
					order[51] = 2283
					order[52] = 0
					super(2045, 2046, order)
				end

				class NoUnderlyingComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2054
						order[1] = 2055
						order[2] = 2056
						order[3] = 0
						super(2053, 2054, order)
					end

					class NoUnderlyingComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2057
							order[1] = 2058
							order[2] = 0
							super(2056, 2057, order)
						end
					end
				end

				class NoUnderlyingComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41733
						order[1] = 41734
						order[2] = 41735
						order[3] = 41736
						order[4] = 0
						super(41732, 41733, order)
					end
				end

				class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41738
						order[1] = 0
						super(41737, 41738, order)
					end
				end

				class NoUnderlyingComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41730
						order[1] = 41731
						order[2] = 41750
						order[3] = 41726
						order[4] = 41713
						order[5] = 0
						super(41729, 41730, order)
					end

					class NoUnderlyingComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41751
							order[1] = 41752
							order[2] = 41753
							order[3] = 41754
							order[4] = 41755
							order[5] = 0
							super(41750, 41751, order)
						end
					end

					class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41727
							order[1] = 41728
							order[2] = 0
							super(41726, 41727, order)
						end
					end

					class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41714
							order[1] = 41715
							order[2] = 0
							super(41713, 41714, order)
						end
					end
				end

				class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41749
						order[1] = 0
						super(41748, 41749, order)
					end
				end

				class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41717
						order[1] = 41718
						order[2] = 41719
						order[3] = 41720
						order[4] = 41721
						order[5] = 41722
						order[6] = 41723
						order[7] = 41724
						order[8] = 0
						super(41716, 41717, order)
					end

					class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41725
							order[1] = 0
							super(41724, 41725, order)
						end
					end
				end
			end

			class NoUnderlyingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40963
					order[1] = 0
					super(40962, 40963, order)
				end
			end

			class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41948
					order[1] = 0
					super(41947, 41948, order)
				end
			end

			class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41865
					order[1] = 41338
					order[2] = 0
					super(41864, 41865, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41867
					order[1] = 41339
					order[2] = 0
					super(41866, 41867, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41869
					order[1] = 41870
					order[2] = 41871
					order[3] = 41872
					order[4] = 41873
					order[5] = 41874
					order[6] = 41875
					order[7] = 41876
					order[8] = 41877
					order[9] = 0
					super(41868, 41869, order)
				end
			end

			class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 43075
					order[1] = 0
					super(43074, 43075, order)
				end
			end

			class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41821
					order[1] = 0
					super(41820, 41821, order)
				end
			end

			class NoUnderlyingOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41842
					order[1] = 41843
					order[2] = 0
					super(41841, 41842, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41845
					order[1] = 0
					super(41844, 41845, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41857
					order[1] = 41858
					order[2] = 0
					super(41856, 41857, order)
				end
			end

			class NoUnderlyingStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40541
					order[1] = 42016
					order[2] = 40542
					order[3] = 43083
					order[4] = 43084
					order[5] = 40543
					order[6] = 40544
					order[7] = 42018
					order[8] = 40545
					order[9] = 40546
					order[10] = 43085
					order[11] = 43086
					order[12] = 42019
					order[13] = 42020
					order[14] = 42021
					order[15] = 42022
					order[16] = 42023
					order[17] = 42024
					order[18] = 41964
					order[19] = 41965
					order[20] = 41966
					order[21] = 41967
					order[22] = 41968
					order[23] = 41969
					order[24] = 41970
					order[25] = 42589
					order[26] = 41971
					order[27] = 41972
					order[28] = 41973
					order[29] = 41974
					order[30] = 41975
					order[31] = 41976
					order[32] = 41977
					order[33] = 41978
					order[34] = 41979
					order[35] = 41980
					order[36] = 41981
					order[37] = 41982
					order[38] = 41983
					order[39] = 41984
					order[40] = 41985
					order[41] = 41986
					order[42] = 41987
					order[43] = 41988
					order[44] = 41989
					order[45] = 40057
					order[46] = 40058
					order[47] = 40060
					order[48] = 40061
					order[49] = 40062
					order[50] = 40063
					order[51] = 40064
					order[52] = 40548
					order[53] = 40549
					order[54] = 40551
					order[55] = 40552
					order[56] = 40553
					order[57] = 40554
					order[58] = 40555
					order[59] = 41957
					order[60] = 41958
					order[61] = 40556
					order[62] = 40558
					order[63] = 40559
					order[64] = 40561
					order[65] = 40562
					order[66] = 40563
					order[67] = 40564
					order[68] = 40565
					order[69] = 40566
					order[70] = 40567
					order[71] = 41959
					order[72] = 41960
					order[73] = 41961
					order[74] = 40568
					order[75] = 40569
					order[76] = 40570
					order[77] = 42895
					order[78] = 40571
					order[79] = 40572
					order[80] = 43107
					order[81] = 40573
					order[82] = 40574
					order[83] = 40575
					order[84] = 40576
					order[85] = 40577
					order[86] = 42896
					order[87] = 42897
					order[88] = 42898
					order[89] = 42899
					order[90] = 40578
					order[91] = 40579
					order[92] = 40580
					order[93] = 41897
					order[94] = 41898
					order[95] = 41899
					order[96] = 41900
					order[97] = 41901
					order[98] = 41902
					order[99] = 41903
					order[100] = 42900
					order[101] = 40664
					order[102] = 40708
					order[103] = 41777
					order[104] = 41778
					order[105] = 41779
					order[106] = 41780
					order[107] = 41781
					order[108] = 42196
					order[109] = 42197
					order[110] = 41782
					order[111] = 41783
					order[112] = 41784
					order[113] = 41785
					order[114] = 41786
					order[115] = 41587
					order[116] = 41787
					order[117] = 41788
					order[118] = 41789
					order[119] = 41790
					order[120] = 41791
					order[121] = 41792
					order[122] = 41793
					order[123] = 41794
					order[124] = 41795
					order[125] = 41796
					order[126] = 41797
					order[127] = 41798
					order[128] = 41799
					order[129] = 43096
					order[130] = 41756
					order[131] = 40547
					order[132] = 40988
					order[133] = 40989
					order[134] = 0
					super(40540, 40541, order)
				end

				class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41991
						order[1] = 41992
						order[2] = 0
						super(41990, 41991, order)
					end
				end

				class NoUnderlyingStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41801
						order[1] = 41802
						order[2] = 41803
						order[3] = 0
						super(41800, 41801, order)
					end
				end

				class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41994
						order[1] = 41995
						order[2] = 0
						super(41993, 41994, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41963
						order[1] = 0
						super(41962, 41963, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 42003
						order[1] = 42004
						order[2] = 42005
						order[3] = 42006
						order[4] = 42007
						order[5] = 42008
						order[6] = 42009
						order[7] = 42010
						order[8] = 42011
						order[9] = 42012
						order[10] = 42013
						order[11] = 41996
						order[12] = 42014
						order[13] = 42015
						order[14] = 0
						super(42002, 42003, order)
					end

					class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41997
							order[1] = 41998
							order[2] = 41999
							order[3] = 0
							super(41996, 41997, order)
						end

						class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 42000
								order[1] = 42001
								order[2] = 41936
								order[3] = 0
								super(41999, 42000, order)
							end
						end
					end
				end

				class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40059
						order[1] = 0
						super(40975, 40059, order)
					end
				end

				class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40550
						order[1] = 0
						super(40976, 40550, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40557
						order[1] = 0
						super(40973, 40557, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41955
						order[1] = 41956
						order[2] = 0
						super(41954, 41955, order)
					end
				end

				class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40560
						order[1] = 0
						super(40974, 40560, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40582
						order[1] = 0
						super(40969, 40582, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41938
						order[1] = 41939
						order[2] = 0
						super(41937, 41938, order)
					end
				end

				class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40594
						order[1] = 0
						super(40970, 40594, order)
					end
				end

				class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40600
						order[1] = 0
						super(40971, 40600, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40607
						order[1] = 0
						super(40972, 40607, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42956
						order[1] = 42957
						order[2] = 0
						super(42955, 42956, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41910
						order[1] = 0
						super(41909, 41910, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41945
						order[1] = 41946
						order[2] = 0
						super(41944, 41945, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41942
						order[1] = 41943
						order[2] = 0
						super(41941, 41942, order)
					end
				end

				class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43111
						order[1] = 42982
						order[2] = 42983
						order[3] = 0
						super(42981, 43111, order)
					end
				end

				class NoUnderlyingDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42863
						order[1] = 42864
						order[2] = 42865
						order[3] = 42866
						order[4] = 42867
						order[5] = 42868
						order[6] = 42882
						order[7] = 42869
						order[8] = 42870
						order[9] = 42871
						order[10] = 42872
						order[11] = 42873
						order[12] = 42874
						order[13] = 42875
						order[14] = 42876
						order[15] = 42877
						order[16] = 42878
						order[17] = 42879
						order[18] = 42880
						order[19] = 42881
						order[20] = 0
						super(42862, 42863, order)
					end

					class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42883
							order[1] = 0
							super(42882, 42883, order)
						end
					end
				end

				class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42854
						order[1] = 0
						super(42853, 42854, order)
					end
				end

				class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42800
						order[1] = 0
						super(42799, 42800, order)
					end
				end

				class NoUnderlyingReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 43035
						order[1] = 43036
						order[2] = 43037
						order[3] = 43038
						order[4] = 43039
						order[5] = 43040
						order[6] = 43064
						order[7] = 43030
						order[8] = 43041
						order[9] = 43042
						order[10] = 43043
						order[11] = 43044
						order[12] = 43045
						order[13] = 43046
						order[14] = 43047
						order[15] = 43048
						order[16] = 43049
						order[17] = 43050
						order[18] = 43051
						order[19] = 43052
						order[20] = 43060
						order[21] = 43053
						order[22] = 43054
						order[23] = 43008
						order[24] = 43055
						order[25] = 43056
						order[26] = 43057
						order[27] = 43058
						order[28] = 43059
						order[29] = 0
						super(43034, 43035, order)
					end

					class NoUnderlyingReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 43065
							order[1] = 43066
							order[2] = 43067
							order[3] = 43068
							order[4] = 0
							super(43064, 43065, order)
						end
					end

					class NoUnderlyingReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43031
							order[1] = 43032
							order[2] = 43033
							order[3] = 0
							super(43030, 43031, order)
						end
					end

					class NoUnderlyingReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43061
							order[1] = 43062
							order[2] = 43063
							order[3] = 0
							super(43060, 43061, order)
						end
					end

					class NoUnderlyingReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 43009
							order[1] = 43071
							order[2] = 43010
							order[3] = 43011
							order[4] = 43012
							order[5] = 43013
							order[6] = 43014
							order[7] = 43015
							order[8] = 43016
							order[9] = 43017
							order[10] = 43018
							order[11] = 43019
							order[12] = 43020
							order[13] = 43021
							order[14] = 43022
							order[15] = 43023
							order[16] = 43024
							order[17] = 43025
							order[18] = 43026
							order[19] = 43027
							order[20] = 43028
							order[21] = 43029
							order[22] = 43069
							order[23] = 0
							super(43008, 43009, order)
						end

						class NoUnderlyingReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 43072
								order[1] = 43073
								order[2] = 0
								super(43071, 43072, order)
							end
						end

						class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 43070
								order[1] = 0
								super(43069, 43070, order)
							end
						end
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42916
						order[1] = 0
						super(42915, 42916, order)
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42902
						order[1] = 42903
						order[2] = 0
						super(42901, 42902, order)
					end
				end

				class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40650
						order[1] = 0
						super(40968, 40650, order)
					end
				end

				class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40657
						order[1] = 40658
						order[2] = 0
						super(40656, 40657, order)
					end
				end

				class NoUnderlyingSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40660
						order[1] = 40904
						order[2] = 40915
						order[3] = 40662
						order[4] = 40663
						order[5] = 0
						super(40659, 40660, order)
					end
				end

				class NoUnderlyingPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40665
						order[1] = 41881
						order[2] = 41882
						order[3] = 40666
						order[4] = 40667
						order[5] = 40668
						order[6] = 40669
						order[7] = 40670
						order[8] = 40671
						order[9] = 40672
						order[10] = 40673
						order[11] = 40674
						order[12] = 40675
						order[13] = 41883
						order[14] = 41884
						order[15] = 41885
						order[16] = 41886
						order[17] = 40676
						order[18] = 40677
						order[19] = 40678
						order[20] = 40679
						order[21] = 41887
						order[22] = 41888
						order[23] = 41889
						order[24] = 41890
						order[25] = 40680
						order[26] = 40681
						order[27] = 40682
						order[28] = 40683
						order[29] = 40684
						order[30] = 40685
						order[31] = 40704
						order[32] = 40686
						order[33] = 40687
						order[34] = 40688
						order[35] = 40689
						order[36] = 40966
						order[37] = 40691
						order[38] = 40692
						order[39] = 40693
						order[40] = 41891
						order[41] = 41892
						order[42] = 40694
						order[43] = 41878
						order[44] = 41893
						order[45] = 41894
						order[46] = 41895
						order[47] = 41896
						order[48] = 40695
						order[49] = 40696
						order[50] = 40697
						order[51] = 40698
						order[52] = 40967
						order[53] = 40700
						order[54] = 40701
						order[55] = 40702
						order[56] = 40703
						order[57] = 0
						super(40664, 40665, order)
					end

					class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40705
							order[1] = 40706
							order[2] = 40707
							order[3] = 0
							super(40704, 40705, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40690
							order[1] = 0
							super(40966, 40690, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41879
							order[1] = 41880
							order[2] = 0
							super(41878, 41879, order)
						end
					end

					class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40699
							order[1] = 0
							super(40967, 40699, order)
						end
					end
				end

				class NoUnderlyingPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40709
						order[1] = 40710
						order[2] = 42993
						order[3] = 42994
						order[4] = 42995
						order[5] = 42996
						order[6] = 42997
						order[7] = 42998
						order[8] = 42999
						order[9] = 42984
						order[10] = 42985
						order[11] = 42986
						order[12] = 42987
						order[13] = 42988
						order[14] = 42989
						order[15] = 42990
						order[16] = 40711
						order[17] = 40712
						order[18] = 40713
						order[19] = 40714
						order[20] = 40715
						order[21] = 40716
						order[22] = 40717
						order[23] = 40718
						order[24] = 40719
						order[25] = 40720
						order[26] = 40721
						order[27] = 40722
						order[28] = 40723
						order[29] = 40724
						order[30] = 40725
						order[31] = 40726
						order[32] = 40727
						order[33] = 40728
						order[34] = 40729
						order[35] = 40730
						order[36] = 40731
						order[37] = 40732
						order[38] = 40733
						order[39] = 40734
						order[40] = 40735
						order[41] = 40736
						order[42] = 40737
						order[43] = 0
						super(40708, 40709, order)
					end

					class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43001
							order[1] = 0
							super(43000, 43001, order)
						end
					end

					class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42992
							order[1] = 0
							super(42991, 42992, order)
						end
					end
				end

				class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41809
						order[1] = 0
						super(41808, 41809, order)
					end
				end

				class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41805
						order[1] = 41806
						order[2] = 41807
						order[3] = 0
						super(41804, 41805, order)
					end
				end

				class NoUnderlyingDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41757
						order[1] = 41758
						order[2] = 41759
						order[3] = 41760
						order[4] = 41761
						order[5] = 41762
						order[6] = 41763
						order[7] = 41764
						order[8] = 41765
						order[9] = 41766
						order[10] = 41767
						order[11] = 41768
						order[12] = 41769
						order[13] = 41770
						order[14] = 0
						super(41756, 41757, order)
					end

					class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41771
							order[1] = 41772
							order[2] = 41773
							order[3] = 0
							super(41770, 41771, order)
						end

						class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41774
								order[1] = 41775
								order[2] = 41776
								order[3] = 0
								super(41773, 41774, order)
							end
						end
					end
				end
			end

			class NoUnderlyingProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 42150
					order[1] = 42151
					order[2] = 42152
					order[3] = 42190
					order[4] = 42153
					order[5] = 42154
					order[6] = 42155
					order[7] = 43002
					order[8] = 43003
					order[9] = 42156
					order[10] = 42157
					order[11] = 42158
					order[12] = 42104
					order[13] = 42105
					order[14] = 42106
					order[15] = 42107
					order[16] = 42108
					order[17] = 42109
					order[18] = 42110
					order[19] = 42111
					order[20] = 42115
					order[21] = 42116
					order[22] = 42117
					order[23] = 42118
					order[24] = 42119
					order[25] = 42120
					order[26] = 42121
					order[27] = 42122
					order[28] = 42123
					order[29] = 42124
					order[30] = 42125
					order[31] = 42126
					order[32] = 42127
					order[33] = 42128
					order[34] = 42129
					order[35] = 42130
					order[36] = 42131
					order[37] = 42132
					order[38] = 42133
					order[39] = 42134
					order[40] = 42135
					order[41] = 42136
					order[42] = 42137
					order[43] = 42138
					order[44] = 42139
					order[45] = 42140
					order[46] = 42141
					order[47] = 42142
					order[48] = 42143
					order[49] = 42144
					order[50] = 42145
					order[51] = 42146
					order[52] = 42147
					order[53] = 42148
					order[54] = 42159
					order[55] = 42160
					order[56] = 42161
					order[57] = 42162
					order[58] = 42163
					order[59] = 42164
					order[60] = 42165
					order[61] = 42092
					order[62] = 42093
					order[63] = 42094
					order[64] = 42095
					order[65] = 42096
					order[66] = 42097
					order[67] = 42098
					order[68] = 42166
					order[69] = 42167
					order[70] = 42168
					order[71] = 42169
					order[72] = 42102
					order[73] = 42103
					order[74] = 42170
					order[75] = 42171
					order[76] = 42172
					order[77] = 42173
					order[78] = 0
					super(42149, 42150, order)
				end

				class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42191
						order[1] = 0
						super(42190, 42191, order)
					end
				end

				class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42183
						order[1] = 0
						super(42182, 42183, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42185
						order[1] = 0
						super(42184, 42185, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42113
						order[1] = 42114
						order[2] = 0
						super(42112, 42113, order)
					end
				end

				class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42187
						order[1] = 0
						super(42186, 42187, order)
					end
				end

				class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42189
						order[1] = 0
						super(42188, 42189, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42181
						order[1] = 0
						super(42180, 42181, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42100
						order[1] = 42101
						order[2] = 0
						super(42099, 42100, order)
					end
				end

				class NoUnderlyingProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 42174
						order[1] = 42175
						order[2] = 42176
						order[3] = 40918
						order[4] = 42177
						order[5] = 0
						super(42173, 42174, order)
					end

					class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42178
							order[1] = 42179
							order[2] = 0
							super(42177, 42178, order)
						end
					end
				end
			end

			class NoUnderlyingAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42037
					order[1] = 42038
					order[2] = 41340
					order[3] = 0
					super(42036, 42037, order)
				end

				class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41341
						order[1] = 41701
						order[2] = 41709
						order[3] = 41710
						order[4] = 41711
						order[5] = 41712
						order[6] = 42017
						order[7] = 42025
						order[8] = 42026
						order[9] = 42027
						order[10] = 42028
						order[11] = 42029
						order[12] = 42030
						order[13] = 42031
						order[14] = 42032
						order[15] = 42033
						order[16] = 42034
						order[17] = 42035
						order[18] = 0
						super(41340, 41341, order)
					end
				end
			end

			class NoUnderlyingProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 42069
					order[1] = 42070
					order[2] = 42071
					order[3] = 42072
					order[4] = 42073
					order[5] = 42074
					order[6] = 42075
					order[7] = 42090
					order[8] = 42077
					order[9] = 42087
					order[10] = 42076
					order[11] = 0
					super(42068, 42069, order)
				end

				class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42091
						order[1] = 0
						super(42090, 42091, order)
					end
				end

				class NoUnderlyingProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 42078
						order[1] = 42079
						order[2] = 42080
						order[3] = 42081
						order[4] = 42082
						order[5] = 42083
						order[6] = 42084
						order[7] = 42085
						order[8] = 0
						super(42077, 42078, order)
					end

					class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42086
							order[1] = 0
							super(42085, 42086, order)
						end
					end
				end

				class NoUnderlyingProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42088
						order[1] = 42089
						order[2] = 0
						super(42087, 42088, order)
					end
				end
			end

			class NoUnderlyingCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 42042
					order[1] = 42043
					order[2] = 42044
					order[3] = 42045
					order[4] = 42046
					order[5] = 42047
					order[6] = 42048
					order[7] = 42049
					order[8] = 42050
					order[9] = 42051
					order[10] = 42052
					order[11] = 42039
					order[12] = 42797
					order[13] = 42798
					order[14] = 42053
					order[15] = 42054
					order[16] = 42790
					order[17] = 42791
					order[18] = 42792
					order[19] = 42793
					order[20] = 42794
					order[21] = 42795
					order[22] = 42796
					order[23] = 42055
					order[24] = 42056
					order[25] = 42057
					order[26] = 42058
					order[27] = 42059
					order[28] = 0
					super(42041, 42042, order)
				end

				class NoUnderlyingCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42040
						order[1] = 0
						super(42039, 42040, order)
					end
				end

				class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42789
						order[1] = 0
						super(42788, 42789, order)
					end
				end
			end

			class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42065
					order[1] = 42061
					order[2] = 42062
					order[3] = 42063
					order[4] = 42064
					order[5] = 0
					super(42060, 42065, order)
				end

				class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42066
						order[1] = 42067
						order[2] = 0
						super(42065, 42066, order)
					end
				end
			end

			class NoUnderlyingRateSpreadSteps < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 43006
					order[1] = 43007
					order[2] = 0
					super(43005, 43006, order)
				end
			end

			class NoUnderlyingDividendPayments < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42856
					order[1] = 42857
					order[2] = 42858
					order[3] = 42859
					order[4] = 0
					super(42855, 42856, order)
				end
			end

			class NoUnderlyingExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42885
					order[1] = 42886
					order[2] = 0
					super(42884, 42885, order)
				end
			end
		end

		class NoStipulations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 233
				order[1] = 234
				order[2] = 0
				super(232, 233, order)
			end
		end

		class NoCommissions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(17)
				order[0] = 2640
				order[1] = 2641
				order[2] = 2725
				order[3] = 2642
				order[4] = 2643
				order[5] = 2923
				order[6] = 2644
				order[7] = 2645
				order[8] = 2924
				order[9] = 2646
				order[10] = 2647
				order[11] = 2648
				order[12] = 2649
				order[13] = 2650
				order[14] = 2651
				order[15] = 2652
				order[16] = 0
				super(2639, 2640, order)
			end
		end

		class NoOrderAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2594
				order[1] = 2595
				order[2] = 0
				super(2593, 2594, order)
			end
		end

		class NoStrategyParameters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 958
				order[1] = 959
				order[2] = 960
				order[3] = 0
				super(957, 958, order)
			end
		end
	end
end

class OrderCancelRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("F") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end
end

class OrderCancelReplaceRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("G") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoTargetPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1462
			order[1] = 1463
			order[2] = 1464
			order[3] = 1818
			order[4] = 2433
			order[5] = 0
			super(1461, 1462, order)
		end

		class NoTargetPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2434
				order[1] = 2435
				order[2] = 0
				super(2433, 2434, order)
			end
		end
	end

	class NoAllocs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(14)
			order[0] = 79
			order[1] = 661
			order[2] = 736
			order[3] = 2927
			order[4] = 467
			order[5] = 2727
			order[6] = 539
			order[7] = 209
			order[8] = 80
			order[9] = 1752
			order[10] = 1753
			order[11] = 1754
			order[12] = 1755
			order[13] = 0
			super(78, 79, order)
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end

	class NoValueChecks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1869
			order[1] = 1870
			order[2] = 0
			super(1868, 1869, order)
		end
	end

	class NoMatchInst < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1625
			order[1] = 1673
			order[2] = 1626
			order[3] = 1627
			order[4] = 0
			super(1624, 1625, order)
		end
	end

	class NoDisclosureInstructions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1813
			order[1] = 1814
			order[2] = 0
			super(1812, 1813, order)
		end
	end

	class NoTradingSessions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 336
			order[1] = 625
			order[2] = 0
			super(386, 336, order)
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoStipulations < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 233
			order[1] = 234
			order[2] = 0
			super(232, 233, order)
		end
	end

	class NoStrategyParameters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 958
			order[1] = 959
			order[2] = 960
			order[3] = 0
			super(957, 958, order)
		end
	end

	class NoCommissions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(17)
			order[0] = 2640
			order[1] = 2641
			order[2] = 2725
			order[3] = 2642
			order[4] = 2643
			order[5] = 2923
			order[6] = 2644
			order[7] = 2645
			order[8] = 2924
			order[9] = 2646
			order[10] = 2647
			order[11] = 2648
			order[12] = 2649
			order[13] = 2650
			order[14] = 2651
			order[15] = 2652
			order[16] = 0
			super(2639, 2640, order)
		end
	end

	class NoOrderAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2594
			order[1] = 2595
			order[2] = 0
			super(2593, 2594, order)
		end
	end

	class NoRateSources < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1446
			order[1] = 1447
			order[2] = 1448
			order[3] = 2412
			order[4] = 2796
			order[5] = 0
			super(1445, 1446, order)
		end
	end

	class NoTrdRegTimestamps < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 769
			order[1] = 770
			order[2] = 771
			order[3] = 2839
			order[4] = 1033
			order[5] = 1034
			order[6] = 1035
			order[7] = 1727
			order[8] = 2831
			order[9] = 2832
			order[10] = 2833
			order[11] = 2834
			order[12] = 0
			super(768, 769, order)
		end
	end
end

class OrderStatusRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("H") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end
end

class AllocationInstruction < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("J") )
	end

	class NoOrders < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 11
			order[1] = 37
			order[2] = 198
			order[3] = 526
			order[4] = 66
			order[5] = 756
			order[6] = 38
			order[7] = 799
			order[8] = 800
			order[9] = 40
			order[10] = 0
			super(73, 11, order)
		end

		class NoNested2PartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 757
				order[1] = 758
				order[2] = 759
				order[3] = 2381
				order[4] = 806
				order[5] = 0
				super(756, 757, order)
			end

			class NoNested2PartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 760
					order[1] = 807
					order[2] = 0
					super(806, 760, order)
				end
			end
		end
	end

	class NoExecs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(14)
			order[0] = 32
			order[1] = 17
			order[2] = 527
			order[3] = 31
			order[4] = 669
			order[5] = 29
			order[6] = 1003
			order[7] = 1041
			order[8] = 880
			order[9] = 2749
			order[10] = 2524
			order[11] = 2668
			order[12] = 1838
			order[13] = 0
			super(124, 32, order)
		end

		class NoTrdRegPublications < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2669
				order[1] = 2670
				order[2] = 0
				super(2668, 2669, order)
			end
		end

		class NoTradePriceConditions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 1839
				order[1] = 0
				super(1838, 1839, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoInstrAttrib < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 871
			order[1] = 872
			order[2] = 0
			super(870, 871, order)
		end
	end

	class NoIndexRollMonths < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2733
			order[1] = 0
			super(2734, 2733, order)
		end
	end

	class NoReferenceDataDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2747
			order[1] = 2748
			order[2] = 0
			super(2746, 2747, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoPriceQualifiers < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2710
			order[1] = 0
			super(2709, 2710, order)
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoStipulations < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 233
			order[1] = 234
			order[2] = 0
			super(232, 233, order)
		end
	end

	class NoRegulatoryTradeIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 1903
			order[1] = 1905
			order[2] = 1904
			order[3] = 1906
			order[4] = 2411
			order[5] = 2397
			order[6] = 0
			super(1907, 1903, order)
		end
	end

	class NoPosAmt < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 707
			order[1] = 708
			order[2] = 2096
			order[3] = 1055
			order[4] = 2937
			order[5] = 2097
			order[6] = 2098
			order[7] = 1585
			order[8] = 2099
			order[9] = 2100
			order[10] = 2876
			order[11] = 2877
			order[12] = 0
			super(753, 707, order)
		end
	end

	class NoAllocs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(67)
			order[0] = 79
			order[1] = 661
			order[2] = 573
			order[3] = 366
			order[4] = 80
			order[5] = 2515
			order[6] = 1752
			order[7] = 1753
			order[8] = 1754
			order[9] = 1755
			order[10] = 467
			order[11] = 1729
			order[12] = 1593
			order[13] = 2727
			order[14] = 1908
			order[15] = 81
			order[16] = 989
			order[17] = 1002
			order[18] = 1735
			order[19] = 993
			order[20] = 1047
			order[21] = 992
			order[22] = 539
			order[23] = 208
			order[24] = 209
			order[25] = 161
			order[26] = 360
			order[27] = 361
			order[28] = 1732
			order[29] = 1733
			order[30] = 1734
			order[31] = 12
			order[32] = 13
			order[33] = 479
			order[34] = 2922
			order[35] = 1233
			order[36] = 1238
			order[37] = 497
			order[38] = 2653
			order[39] = 153
			order[40] = 154
			order[41] = 119
			order[42] = 2300
			order[43] = 737
			order[44] = 120
			order[45] = 736
			order[46] = 2927
			order[47] = 155
			order[48] = 156
			order[49] = 742
			order[50] = 741
			order[51] = 136
			order[52] = 576
			order[53] = 635
			order[54] = 780
			order[55] = 172
			order[56] = 169
			order[57] = 170
			order[58] = 171
			order[59] = 2392
			order[60] = 2393
			order[61] = 2483
			order[62] = 2761
			order[63] = 2770
			order[64] = 2769
			order[65] = 1844
			order[66] = 0
			super(78, 79, order)
		end

		class NoAllocRegulatoryTradeIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 1909
				order[1] = 1910
				order[2] = 1911
				order[3] = 1912
				order[4] = 2406
				order[5] = 2399
				order[6] = 0
				super(1908, 1909, order)
			end
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end

		class NoAllocCommissions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(17)
				order[0] = 2654
				order[1] = 2655
				order[2] = 2726
				order[3] = 2656
				order[4] = 2657
				order[5] = 2925
				order[6] = 2658
				order[7] = 2659
				order[8] = 2926
				order[9] = 2660
				order[10] = 2661
				order[11] = 2662
				order[12] = 2663
				order[13] = 2664
				order[14] = 2665
				order[15] = 2666
				order[16] = 0
				super(2653, 2654, order)
			end
		end

		class NoMiscFees < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 137
				order[1] = 138
				order[2] = 139
				order[3] = 2712
				order[4] = 2633
				order[5] = 891
				order[6] = 2216
				order[7] = 2217
				order[8] = 2713
				order[9] = 0
				super(136, 137, order)
			end

			class NoMiscFeeSubTypes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 2634
					order[1] = 2635
					order[2] = 2636
					order[3] = 2637
					order[4] = 2638
					order[5] = 0
					super(2633, 2634, order)
				end
			end
		end

		class NoClearingInstructions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 577
				order[1] = 0
				super(576, 577, order)
			end
		end

		class NoDlvyInst < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 165
				order[1] = 787
				order[2] = 781
				order[3] = 0
				super(85, 165, order)
			end

			class NoSettlPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 782
					order[1] = 783
					order[2] = 784
					order[3] = 2389
					order[4] = 801
					order[5] = 0
					super(781, 782, order)
				end

				class NoSettlPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 785
						order[1] = 786
						order[2] = 0
						super(801, 785, order)
					end
				end
			end
		end

		class NoTradeAllocAmts < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1845
				order[1] = 1846
				order[2] = 1847
				order[3] = 2933
				order[4] = 1850
				order[5] = 0
				super(1844, 1845, order)
			end
		end
	end

	class NoRateSources < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1446
			order[1] = 1447
			order[2] = 1448
			order[3] = 2412
			order[4] = 2796
			order[5] = 0
			super(1445, 1446, order)
		end
	end
end

class ListCancelRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("K") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end
end

class ListExecute < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("L") )
	end
end

class ListStatusRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("M") )
	end
end

class ListStatus < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("N") )
	end

	class NoOrders < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(14)
			order[0] = 11
			order[1] = 37
			order[2] = 526
			order[3] = 14
			order[4] = 39
			order[5] = 636
			order[6] = 151
			order[7] = 84
			order[8] = 6
			order[9] = 103
			order[10] = 58
			order[11] = 354
			order[12] = 355
			order[13] = 0
			super(73, 11, order)
		end
	end
end

class AllocationInstructionAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("P") )
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoRegulatoryTradeIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 1903
			order[1] = 1905
			order[2] = 1904
			order[3] = 1906
			order[4] = 2411
			order[5] = 2397
			order[6] = 0
			super(1907, 1903, order)
		end
	end

	class NoAllocs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(31)
			order[0] = 79
			order[1] = 661
			order[2] = 366
			order[3] = 1047
			order[4] = 467
			order[5] = 1593
			order[6] = 1729
			order[7] = 1832
			order[8] = 2727
			order[9] = 1908
			order[10] = 776
			order[11] = 539
			order[12] = 209
			order[13] = 161
			order[14] = 360
			order[15] = 361
			order[16] = 1732
			order[17] = 1733
			order[18] = 1734
			order[19] = 989
			order[20] = 993
			order[21] = 992
			order[22] = 80
			order[23] = 2515
			order[24] = 1752
			order[25] = 1753
			order[26] = 1754
			order[27] = 1755
			order[28] = 2770
			order[29] = 2769
			order[30] = 0
			super(78, 79, order)
		end

		class NoAllocRegulatoryTradeIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 1909
				order[1] = 1910
				order[2] = 1911
				order[3] = 1912
				order[4] = 2406
				order[5] = 2399
				order[6] = 0
				super(1908, 1909, order)
			end
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end
end

class DontKnowTrade < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("Q") )
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end
end

class QuoteRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("R") )
	end

	class NoRootPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1117
			order[1] = 1118
			order[2] = 1119
			order[3] = 2388
			order[4] = 1120
			order[5] = 0
			super(1116, 1117, order)
		end

		class NoRootPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1121
				order[1] = 1122
				order[2] = 0
				super(1120, 1121, order)
			end
		end
	end

	class NoRelatedSym < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(250)
			order[0] = 55
			order[1] = 65
			order[2] = 48
			order[3] = 22
			order[4] = 460
			order[5] = 1227
			order[6] = 1151
			order[7] = 461
			order[8] = 2891
			order[9] = 167
			order[10] = 762
			order[11] = 200
			order[12] = 541
			order[13] = 1079
			order[14] = 966
			order[15] = 1049
			order[16] = 965
			order[17] = 224
			order[18] = 1449
			order[19] = 1450
			order[20] = 1451
			order[21] = 1452
			order[22] = 1457
			order[23] = 1458
			order[24] = 1739
			order[25] = 2210
			order[26] = 1938
			order[27] = 1939
			order[28] = 1940
			order[29] = 2735
			order[30] = 1941
			order[31] = 1575
			order[32] = 1942
			order[33] = 1943
			order[34] = 1944
			order[35] = 1945
			order[36] = 1946
			order[37] = 1947
			order[38] = 1948
			order[39] = 1949
			order[40] = 1950
			order[41] = 2879
			order[42] = 1951
			order[43] = 1952
			order[44] = 1953
			order[45] = 1954
			order[46] = 1955
			order[47] = 1956
			order[48] = 1957
			order[49] = 1958
			order[50] = 1959
			order[51] = 1960
			order[52] = 1577
			order[53] = 1580
			order[54] = 1581
			order[55] = 1678
			order[56] = 1697
			order[57] = 225
			order[58] = 239
			order[59] = 226
			order[60] = 227
			order[61] = 228
			order[62] = 255
			order[63] = 543
			order[64] = 470
			order[65] = 471
			order[66] = 472
			order[67] = 240
			order[68] = 202
			order[69] = 2578
			order[70] = 2577
			order[71] = 947
			order[72] = 2904
			order[73] = 967
			order[74] = 968
			order[75] = 1698
			order[76] = 1866
			order[77] = 2600
			order[78] = 2001
			order[79] = 2601
			order[80] = 1478
			order[81] = 1479
			order[82] = 1480
			order[83] = 1481
			order[84] = 206
			order[85] = 231
			order[86] = 1435
			order[87] = 2353
			order[88] = 1439
			order[89] = 969
			order[90] = 1146
			order[91] = 996
			order[92] = 1147
			order[93] = 1716
			order[94] = 2905
			order[95] = 1191
			order[96] = 1192
			order[97] = 1717
			order[98] = 2906
			order[99] = 1193
			order[100] = 2579
			order[101] = 1194
			order[102] = 1482
			order[103] = 1195
			order[104] = 2753
			order[105] = 1196
			order[106] = 1197
			order[107] = 2002
			order[108] = 2140
			order[109] = 1524
			order[110] = 2907
			order[111] = 1198
			order[112] = 1199
			order[113] = 1200
			order[114] = 201
			order[115] = 2681
			order[116] = 2685
			order[117] = 1244
			order[118] = 1242
			order[119] = 2575
			order[120] = 2574
			order[121] = 997
			order[122] = 223
			order[123] = 207
			order[124] = 970
			order[125] = 971
			order[126] = 106
			order[127] = 348
			order[128] = 349
			order[129] = 2737
			order[130] = 2714
			order[131] = 2715
			order[132] = 2716
			order[133] = 107
			order[134] = 350
			order[135] = 351
			order[136] = 691
			order[137] = 667
			order[138] = 875
			order[139] = 876
			order[140] = 873
			order[141] = 874
			order[142] = 1687
			order[143] = 1787
			order[144] = 2141
			order[145] = 2142
			order[146] = 2143
			order[147] = 2752
			order[148] = 2144
			order[149] = 2145
			order[150] = 2576
			order[151] = 2962
			order[152] = 2602
			order[153] = 2603
			order[154] = 913
			order[155] = 914
			order[156] = 1961
			order[157] = 915
			order[158] = 918
			order[159] = 2952
			order[160] = 1962
			order[161] = 1963
			order[162] = 1964
			order[163] = 1965
			order[164] = 1966
			order[165] = 1967
			order[166] = 1968
			order[167] = 1969
			order[168] = 1970
			order[169] = 1513
			order[170] = 1525
			order[171] = 1527
			order[172] = 788
			order[173] = 916
			order[174] = 917
			order[175] = 919
			order[176] = 898
			order[177] = 711
			order[178] = 140
			order[179] = 303
			order[180] = 117
			order[181] = 1751
			order[182] = 537
			order[183] = 336
			order[184] = 625
			order[185] = 229
			order[186] = 1913
			order[187] = 54
			order[188] = 854
			order[189] = 38
			order[190] = 152
			order[191] = 516
			order[192] = 468
			order[193] = 469
			order[194] = 110
			order[195] = 63
			order[196] = 64
			order[197] = 193
			order[198] = 192
			order[199] = 15
			order[200] = 2897
			order[201] = 120
			order[202] = 2899
			order[203] = 1445
			order[204] = 232
			order[205] = 1
			order[206] = 660
			order[207] = 581
			order[208] = 555
			order[209] = 735
			order[210] = 828
			order[211] = 2347
			order[212] = 1907
			order[213] = 2115
			order[214] = 692
			order[215] = 2709
			order[216] = 40
			order[217] = 62
			order[218] = 126
			order[219] = 1914
			order[220] = 1915
			order[221] = 1629
			order[222] = 1916
			order[223] = 60
			order[224] = 218
			order[225] = 220
			order[226] = 2950
			order[227] = 221
			order[228] = 222
			order[229] = 662
			order[230] = 663
			order[231] = 699
			order[232] = 761
			order[233] = 423
			order[234] = 44
			order[235] = 631
			order[236] = 640
			order[237] = 235
			order[238] = 236
			order[239] = 701
			order[240] = 696
			order[241] = 697
			order[242] = 698
			order[243] = 453
			order[244] = 1937
			order[245] = 2374
			order[246] = 2372
			order[247] = 2371
			order[248] = 443
			order[249] = 0
			super(146, 55, order)
		end

		class NoSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 455
				order[1] = 456
				order[2] = 2957
				order[3] = 0
				super(454, 455, order)
			end
		end

		class NoSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1977
				order[1] = 1978
				order[2] = 1979
				order[3] = 2741
				order[4] = 0
				super(1976, 1977, order)
			end
		end

		class NoAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2305
				order[1] = 2306
				order[2] = 2307
				order[3] = 0
				super(2304, 2305, order)
			end
		end

		class NoEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 865
				order[1] = 866
				order[2] = 1145
				order[3] = 1827
				order[4] = 1826
				order[5] = 2340
				order[6] = 867
				order[7] = 868
				order[8] = 1578
				order[9] = 1579
				order[10] = 0
				super(864, 865, order)
			end
		end

		class NoInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1019
				order[1] = 1050
				order[2] = 1051
				order[3] = 2378
				order[4] = 1052
				order[5] = 0
				super(1018, 1019, order)
			end

			class NoInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1053
					order[1] = 1054
					order[2] = 0
					super(1052, 1053, order)
				end
			end
		end

		class NoComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 1484
				order[1] = 2117
				order[2] = 2118
				order[3] = 2119
				order[4] = 1485
				order[5] = 2120
				order[6] = 2121
				order[7] = 2122
				order[8] = 2941
				order[9] = 1486
				order[10] = 2123
				order[11] = 1487
				order[12] = 1488
				order[13] = 1489
				order[14] = 1490
				order[15] = 1491
				order[16] = 2124
				order[17] = 2942
				order[18] = 2125
				order[19] = 2943
				order[20] = 2126
				order[21] = 2127
				order[22] = 2407
				order[23] = 2408
				order[24] = 2128
				order[25] = 2129
				order[26] = 2130
				order[27] = 2131
				order[28] = 2132
				order[29] = 41013
				order[30] = 41020
				order[31] = 41021
				order[32] = 41022
				order[33] = 41023
				order[34] = 41024
				order[35] = 41025
				order[36] = 41026
				order[37] = 41027
				order[38] = 41028
				order[39] = 41010
				order[40] = 2133
				order[41] = 2134
				order[42] = 2135
				order[43] = 2136
				order[44] = 2137
				order[45] = 41029
				order[46] = 40997
				order[47] = 2597
				order[48] = 2598
				order[49] = 2599
				order[50] = 2138
				order[51] = 2139
				order[52] = 0
				super(1483, 1484, order)
			end

			class NoComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1492
					order[1] = 1493
					order[2] = 1494
					order[3] = 0
					super(1491, 1492, order)
				end

				class NoComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1495
						order[1] = 1496
						order[2] = 0
						super(1494, 1495, order)
					end
				end
			end

			class NoComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41014
					order[1] = 41015
					order[2] = 41016
					order[3] = 41017
					order[4] = 0
					super(41013, 41014, order)
				end
			end

			class NoComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41019
					order[1] = 0
					super(41018, 41019, order)
				end
			end

			class NoComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41011
					order[1] = 41012
					order[2] = 41031
					order[3] = 41007
					order[4] = 40994
					order[5] = 0
					super(41010, 41011, order)
				end

				class NoComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41032
						order[1] = 41033
						order[2] = 41034
						order[3] = 41035
						order[4] = 41036
						order[5] = 0
						super(41031, 41032, order)
					end
				end

				class NoComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41008
						order[1] = 41009
						order[2] = 0
						super(41007, 41008, order)
					end
				end

				class NoComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40995
						order[1] = 40996
						order[2] = 0
						super(40994, 40995, order)
					end
				end
			end

			class NoComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41030
					order[1] = 0
					super(41029, 41030, order)
				end
			end

			class NoComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40998
					order[1] = 40999
					order[2] = 41000
					order[3] = 41001
					order[4] = 41002
					order[5] = 41003
					order[6] = 41004
					order[7] = 41005
					order[8] = 0
					super(40997, 40998, order)
				end

				class NoComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41006
						order[1] = 0
						super(41005, 41006, order)
					end
				end
			end
		end

		class NoBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40471
				order[1] = 0
				super(40278, 40471, order)
			end
		end

		class NoPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41231
				order[1] = 0
				super(41230, 41231, order)
			end
		end

		class NoMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41093
				order[1] = 40991
				order[2] = 0
				super(41092, 41093, order)
			end
		end

		class NoMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41095
				order[1] = 40992
				order[2] = 0
				super(41094, 41095, order)
			end
		end

		class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41097
				order[1] = 41098
				order[2] = 41099
				order[3] = 41100
				order[4] = 41101
				order[5] = 41102
				order[6] = 41103
				order[7] = 41104
				order[8] = 41105
				order[9] = 0
				super(41096, 41097, order)
			end
		end

		class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42776
				order[1] = 0
				super(42775, 42776, order)
			end
		end

		class NoOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41117
				order[1] = 0
				super(41116, 41117, order)
			end
		end

		class NoOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41138
				order[1] = 41139
				order[2] = 0
				super(41137, 41138, order)
			end
		end

		class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41141
				order[1] = 0
				super(41140, 41141, order)
			end
		end

		class NoOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41153
				order[1] = 41154
				order[2] = 0
				super(41152, 41153, order)
			end
		end

		class NoStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40050
				order[1] = 41303
				order[2] = 40051
				order[3] = 42784
				order[4] = 42785
				order[5] = 40052
				order[6] = 40053
				order[7] = 41305
				order[8] = 40054
				order[9] = 40055
				order[10] = 42786
				order[11] = 42787
				order[12] = 41306
				order[13] = 41307
				order[14] = 41308
				order[15] = 41309
				order[16] = 41310
				order[17] = 41311
				order[18] = 41251
				order[19] = 41252
				order[20] = 41253
				order[21] = 41254
				order[22] = 41255
				order[23] = 41256
				order[24] = 41257
				order[25] = 42587
				order[26] = 41258
				order[27] = 41259
				order[28] = 41260
				order[29] = 41261
				order[30] = 41262
				order[31] = 41263
				order[32] = 41264
				order[33] = 41265
				order[34] = 41266
				order[35] = 41267
				order[36] = 41268
				order[37] = 41269
				order[38] = 41270
				order[39] = 41271
				order[40] = 41272
				order[41] = 41273
				order[42] = 41274
				order[43] = 41275
				order[44] = 41276
				order[45] = 40907
				order[46] = 40908
				order[47] = 40910
				order[48] = 40911
				order[49] = 40912
				order[50] = 40913
				order[51] = 40914
				order[52] = 40065
				order[53] = 40066
				order[54] = 40068
				order[55] = 40069
				order[56] = 40070
				order[57] = 40071
				order[58] = 40072
				order[59] = 41244
				order[60] = 41245
				order[61] = 40073
				order[62] = 40075
				order[63] = 40076
				order[64] = 40078
				order[65] = 40079
				order[66] = 40080
				order[67] = 40081
				order[68] = 40082
				order[69] = 40083
				order[70] = 40084
				order[71] = 41246
				order[72] = 41247
				order[73] = 41248
				order[74] = 40738
				order[75] = 40739
				order[76] = 40740
				order[77] = 42600
				order[78] = 40741
				order[79] = 40742
				order[80] = 43106
				order[81] = 40743
				order[82] = 40744
				order[83] = 40745
				order[84] = 40746
				order[85] = 40747
				order[86] = 42601
				order[87] = 42602
				order[88] = 42603
				order[89] = 42604
				order[90] = 40748
				order[91] = 40749
				order[92] = 40750
				order[93] = 41180
				order[94] = 41181
				order[95] = 41182
				order[96] = 41183
				order[97] = 41184
				order[98] = 41185
				order[99] = 41186
				order[100] = 42605
				order[101] = 40828
				order[102] = 40872
				order[103] = 41058
				order[104] = 41059
				order[105] = 41060
				order[106] = 41061
				order[107] = 41062
				order[108] = 42192
				order[109] = 42193
				order[110] = 41063
				order[111] = 41064
				order[112] = 41065
				order[113] = 41066
				order[114] = 41067
				order[115] = 41218
				order[116] = 41068
				order[117] = 41069
				order[118] = 41070
				order[119] = 41071
				order[120] = 41072
				order[121] = 41073
				order[122] = 41074
				order[123] = 41075
				order[124] = 41076
				order[125] = 41077
				order[126] = 41078
				order[127] = 41079
				order[128] = 41080
				order[129] = 43094
				order[130] = 41037
				order[131] = 40056
				order[132] = 40982
				order[133] = 40983
				order[134] = 0
				super(40049, 40050, order)
			end

			class NoStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41278
					order[1] = 41279
					order[2] = 0
					super(41277, 41278, order)
				end
			end

			class NoStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41238
					order[1] = 41239
					order[2] = 41240
					order[3] = 0
					super(41237, 41238, order)
				end
			end

			class NoStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41281
					order[1] = 41282
					order[2] = 0
					super(41280, 41281, order)
				end
			end

			class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41250
					order[1] = 0
					super(41249, 41250, order)
				end
			end

			class NoStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41290
					order[1] = 41291
					order[2] = 41292
					order[3] = 41293
					order[4] = 41294
					order[5] = 41295
					order[6] = 41296
					order[7] = 41297
					order[8] = 41298
					order[9] = 41299
					order[10] = 41300
					order[11] = 41283
					order[12] = 41301
					order[13] = 41302
					order[14] = 0
					super(41289, 41290, order)
				end

				class NoStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41284
						order[1] = 41285
						order[2] = 41286
						order[3] = 0
						super(41283, 41284, order)
					end

					class NoStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41287
							order[1] = 41288
							order[2] = 41588
							order[3] = 0
							super(41286, 41287, order)
						end
					end
				end
			end

			class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40909
					order[1] = 0
					super(40960, 40909, order)
				end
			end

			class NoStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40067
					order[1] = 0
					super(40961, 40067, order)
				end
			end

			class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40074
					order[1] = 0
					super(40958, 40074, order)
				end
			end

			class NoStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41242
					order[1] = 41243
					order[2] = 0
					super(41241, 41242, order)
				end
			end

			class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40077
					order[1] = 0
					super(40959, 40077, order)
				end
			end

			class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40752
					order[1] = 0
					super(40947, 40752, order)
				end
			end

			class NoPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41221
					order[1] = 41222
					order[2] = 0
					super(41220, 41221, order)
				end
			end

			class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40763
					order[1] = 0
					super(40948, 40763, order)
				end
			end

			class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40769
					order[1] = 0
					super(40949, 40769, order)
				end
			end

			class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40776
					order[1] = 0
					super(40950, 40776, order)
				end
			end

			class NoPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42661
					order[1] = 42662
					order[2] = 0
					super(42660, 42661, order)
				end
			end

			class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41193
					order[1] = 0
					super(41192, 41193, order)
				end
			end

			class NoPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41228
					order[1] = 41229
					order[2] = 0
					super(41227, 41228, order)
				end
			end

			class NoPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41225
					order[1] = 41226
					order[2] = 0
					super(41224, 41225, order)
				end
			end

			class NoPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43109
					order[1] = 42684
					order[2] = 42685
					order[3] = 0
					super(42683, 43109, order)
				end
			end

			class NoDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42275
					order[1] = 42276
					order[2] = 42277
					order[3] = 42278
					order[4] = 42279
					order[5] = 42280
					order[6] = 42294
					order[7] = 42281
					order[8] = 42282
					order[9] = 42283
					order[10] = 42284
					order[11] = 42285
					order[12] = 42286
					order[13] = 42287
					order[14] = 42288
					order[15] = 42289
					order[16] = 42290
					order[17] = 42291
					order[18] = 42292
					order[19] = 42293
					order[20] = 0
					super(42274, 42275, order)
				end

				class NoDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42295
						order[1] = 0
						super(42294, 42295, order)
					end
				end
			end

			class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42273
					order[1] = 0
					super(42272, 42273, order)
				end
			end

			class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42237
					order[1] = 0
					super(42236, 42237, order)
				end
			end

			class NoReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42736
					order[1] = 42737
					order[2] = 42738
					order[3] = 42739
					order[4] = 42740
					order[5] = 42741
					order[6] = 42765
					order[7] = 42731
					order[8] = 42742
					order[9] = 42743
					order[10] = 42744
					order[11] = 42745
					order[12] = 42746
					order[13] = 42747
					order[14] = 42748
					order[15] = 42749
					order[16] = 42750
					order[17] = 42751
					order[18] = 42752
					order[19] = 42753
					order[20] = 42761
					order[21] = 42754
					order[22] = 42755
					order[23] = 42709
					order[24] = 42756
					order[25] = 42757
					order[26] = 42758
					order[27] = 42759
					order[28] = 42760
					order[29] = 0
					super(42735, 42736, order)
				end

				class NoReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42766
						order[1] = 42767
						order[2] = 42768
						order[3] = 42769
						order[4] = 0
						super(42765, 42766, order)
					end
				end

				class NoReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42732
						order[1] = 42733
						order[2] = 42734
						order[3] = 0
						super(42731, 42732, order)
					end
				end

				class NoReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42762
						order[1] = 42763
						order[2] = 42764
						order[3] = 0
						super(42761, 42762, order)
					end
				end

				class NoReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42710
						order[1] = 42772
						order[2] = 42711
						order[3] = 42712
						order[4] = 42713
						order[5] = 42714
						order[6] = 42715
						order[7] = 42716
						order[8] = 42717
						order[9] = 42718
						order[10] = 42719
						order[11] = 42720
						order[12] = 42721
						order[13] = 42722
						order[14] = 42723
						order[15] = 42724
						order[16] = 42725
						order[17] = 42726
						order[18] = 42727
						order[19] = 42728
						order[20] = 42729
						order[21] = 42730
						order[22] = 42770
						order[23] = 0
						super(42709, 42710, order)
					end

					class NoReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42773
							order[1] = 42774
							order[2] = 0
							super(42772, 42773, order)
						end
					end

					class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42771
							order[1] = 0
							super(42770, 42771, order)
						end
					end
				end
			end

			class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42621
					order[1] = 0
					super(42620, 42621, order)
				end
			end

			class NoPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42607
					order[1] = 42608
					order[2] = 0
					super(42606, 42607, order)
				end
			end

			class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40819
					order[1] = 0
					super(40946, 40819, order)
				end
			end

			class NoNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40826
					order[1] = 40827
					order[2] = 0
					super(40825, 40826, order)
				end
			end

			class NoSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40086
					order[1] = 40373
					order[2] = 40655
					order[3] = 40088
					order[4] = 40089
					order[5] = 0
					super(40085, 40086, order)
				end
			end

			class NoPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40829
					order[1] = 41164
					order[2] = 41165
					order[3] = 40830
					order[4] = 40831
					order[5] = 40832
					order[6] = 40833
					order[7] = 40834
					order[8] = 40835
					order[9] = 40836
					order[10] = 40837
					order[11] = 40838
					order[12] = 40839
					order[13] = 41166
					order[14] = 41167
					order[15] = 41168
					order[16] = 41169
					order[17] = 40840
					order[18] = 40841
					order[19] = 40842
					order[20] = 40843
					order[21] = 41170
					order[22] = 41171
					order[23] = 41172
					order[24] = 41173
					order[25] = 40844
					order[26] = 40845
					order[27] = 40846
					order[28] = 40847
					order[29] = 40848
					order[30] = 40849
					order[31] = 40868
					order[32] = 40850
					order[33] = 40851
					order[34] = 40852
					order[35] = 40853
					order[36] = 40977
					order[37] = 40855
					order[38] = 40856
					order[39] = 40857
					order[40] = 41174
					order[41] = 41175
					order[42] = 40858
					order[43] = 41161
					order[44] = 41176
					order[45] = 41177
					order[46] = 41178
					order[47] = 41179
					order[48] = 40859
					order[49] = 40860
					order[50] = 40861
					order[51] = 40862
					order[52] = 40945
					order[53] = 40864
					order[54] = 40865
					order[55] = 40866
					order[56] = 40867
					order[57] = 0
					super(40828, 40829, order)
				end

				class NoPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40869
						order[1] = 40870
						order[2] = 40871
						order[3] = 0
						super(40868, 40869, order)
					end
				end

				class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40854
						order[1] = 0
						super(40977, 40854, order)
					end
				end

				class NoPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41162
						order[1] = 41163
						order[2] = 0
						super(41161, 41162, order)
					end
				end

				class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40863
						order[1] = 0
						super(40945, 40863, order)
					end
				end
			end

			class NoPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40873
					order[1] = 40874
					order[2] = 42698
					order[3] = 42699
					order[4] = 42700
					order[5] = 42701
					order[6] = 42702
					order[7] = 42703
					order[8] = 42704
					order[9] = 42689
					order[10] = 42690
					order[11] = 42691
					order[12] = 42692
					order[13] = 42693
					order[14] = 42694
					order[15] = 42695
					order[16] = 40875
					order[17] = 40876
					order[18] = 40877
					order[19] = 40878
					order[20] = 40879
					order[21] = 40880
					order[22] = 40881
					order[23] = 40882
					order[24] = 40883
					order[25] = 40884
					order[26] = 40885
					order[27] = 40886
					order[28] = 40887
					order[29] = 40888
					order[30] = 40889
					order[31] = 40890
					order[32] = 40891
					order[33] = 40892
					order[34] = 40893
					order[35] = 40894
					order[36] = 40895
					order[37] = 40896
					order[38] = 40897
					order[39] = 40898
					order[40] = 40899
					order[41] = 40900
					order[42] = 40901
					order[43] = 0
					super(40872, 40873, order)
				end

				class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42706
						order[1] = 0
						super(42705, 42706, order)
					end
				end

				class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42697
						order[1] = 0
						super(42696, 42697, order)
					end
				end
			end

			class NoDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41086
					order[1] = 0
					super(41085, 41086, order)
				end
			end

			class NoDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41082
					order[1] = 41083
					order[2] = 41084
					order[3] = 0
					super(41081, 41082, order)
				end
			end

			class NoDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41038
					order[1] = 41039
					order[2] = 41040
					order[3] = 41041
					order[4] = 41042
					order[5] = 41043
					order[6] = 41044
					order[7] = 41045
					order[8] = 41046
					order[9] = 41047
					order[10] = 41048
					order[11] = 41049
					order[12] = 41050
					order[13] = 41051
					order[14] = 0
					super(41037, 41038, order)
				end

				class NoDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41052
						order[1] = 41053
						order[2] = 41054
						order[3] = 0
						super(41051, 41052, order)
					end

					class NoDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41055
							order[1] = 41056
							order[2] = 41057
							order[3] = 0
							super(41054, 41055, order)
						end
					end
				end
			end
		end

		class NoProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40091
				order[1] = 40092
				order[2] = 40093
				order[3] = 40957
				order[4] = 40095
				order[5] = 40096
				order[6] = 40097
				order[7] = 42707
				order[8] = 42708
				order[9] = 40098
				order[10] = 40099
				order[11] = 40100
				order[12] = 40114
				order[13] = 40115
				order[14] = 40116
				order[15] = 40118
				order[16] = 40119
				order[17] = 40120
				order[18] = 40121
				order[19] = 40122
				order[20] = 40123
				order[21] = 40125
				order[22] = 40126
				order[23] = 40127
				order[24] = 40128
				order[25] = 40129
				order[26] = 40130
				order[27] = 40131
				order[28] = 40132
				order[29] = 40133
				order[30] = 40134
				order[31] = 40135
				order[32] = 40136
				order[33] = 40137
				order[34] = 40138
				order[35] = 40139
				order[36] = 40140
				order[37] = 40141
				order[38] = 40145
				order[39] = 40146
				order[40] = 40148
				order[41] = 40149
				order[42] = 40150
				order[43] = 40151
				order[44] = 40152
				order[45] = 40153
				order[46] = 40154
				order[47] = 40155
				order[48] = 40156
				order[49] = 40158
				order[50] = 40159
				order[51] = 40160
				order[52] = 40161
				order[53] = 40162
				order[54] = 40101
				order[55] = 40102
				order[56] = 40103
				order[57] = 40104
				order[58] = 40105
				order[59] = 40106
				order[60] = 40107
				order[61] = 40163
				order[62] = 40165
				order[63] = 40166
				order[64] = 40167
				order[65] = 40168
				order[66] = 40169
				order[67] = 40170
				order[68] = 40108
				order[69] = 40109
				order[70] = 40110
				order[71] = 40111
				order[72] = 40112
				order[73] = 41406
				order[74] = 40113
				order[75] = 40986
				order[76] = 40987
				order[77] = 40174
				order[78] = 0
				super(40090, 40091, order)
			end

			class NoProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40094
					order[1] = 0
					super(40957, 40094, order)
				end
			end

			class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40117
					order[1] = 0
					super(40953, 40117, order)
				end
			end

			class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40124
					order[1] = 0
					super(40954, 40124, order)
				end
			end

			class NoProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40143
					order[1] = 40144
					order[2] = 0
					super(40142, 40143, order)
				end
			end

			class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40147
					order[1] = 0
					super(40955, 40147, order)
				end
			end

			class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40157
					order[1] = 0
					super(40956, 40157, order)
				end
			end

			class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40164
					order[1] = 0
					super(40952, 40164, order)
				end
			end

			class NoProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40172
					order[1] = 40173
					order[2] = 0
					super(40171, 40172, order)
				end
			end

			class NoProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40175
					order[1] = 40176
					order[2] = 40177
					order[3] = 2385
					order[4] = 40178
					order[5] = 0
					super(40174, 40175, order)
				end

				class NoProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40179
						order[1] = 40180
						order[2] = 0
						super(40178, 40179, order)
					end
				end
			end
		end

		class NoAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40020
				order[1] = 40021
				order[2] = 40000
				order[3] = 0
				super(40019, 40020, order)
			end

			class NoAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 40001
					order[1] = 40002
					order[2] = 40003
					order[3] = 40004
					order[4] = 40005
					order[5] = 40006
					order[6] = 40007
					order[7] = 40008
					order[8] = 40009
					order[9] = 40010
					order[10] = 40011
					order[11] = 40012
					order[12] = 40013
					order[13] = 40014
					order[14] = 40015
					order[15] = 40016
					order[16] = 40017
					order[17] = 40018
					order[18] = 0
					super(40000, 40001, order)
				end
			end
		end

		class NoProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 40182
				order[1] = 40183
				order[2] = 40184
				order[3] = 40185
				order[4] = 40186
				order[5] = 40187
				order[6] = 40188
				order[7] = 40951
				order[8] = 40191
				order[9] = 40201
				order[10] = 40190
				order[11] = 0
				super(40181, 40182, order)
			end

			class NoProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40189
					order[1] = 0
					super(40951, 40189, order)
				end
			end

			class NoProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40192
					order[1] = 40193
					order[2] = 40194
					order[3] = 40195
					order[4] = 40196
					order[5] = 40197
					order[6] = 40198
					order[7] = 40199
					order[8] = 0
					super(40191, 40192, order)
				end

				class NoProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40200
						order[1] = 0
						super(40199, 40200, order)
					end
				end
			end

			class NoProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40202
					order[1] = 40203
					order[2] = 0
					super(40201, 40202, order)
				end
			end
		end

		class NoCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 40023
				order[1] = 40024
				order[2] = 40916
				order[3] = 40917
				order[4] = 40025
				order[5] = 40026
				order[6] = 40027
				order[7] = 40028
				order[8] = 40029
				order[9] = 40030
				order[10] = 40031
				order[11] = 40277
				order[12] = 42216
				order[13] = 42217
				order[14] = 40033
				order[15] = 40034
				order[16] = 42207
				order[17] = 42208
				order[18] = 42209
				order[19] = 42210
				order[20] = 42211
				order[21] = 42212
				order[22] = 42213
				order[23] = 40035
				order[24] = 40036
				order[25] = 40037
				order[26] = 40038
				order[27] = 40039
				order[28] = 0
				super(40022, 40023, order)
			end

			class NoCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40032
					order[1] = 0
					super(40277, 40032, order)
				end
			end

			class NoCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42215
					order[1] = 0
					super(42214, 42215, order)
				end
			end
		end

		class NoPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40209
				order[1] = 40205
				order[2] = 40206
				order[3] = 40207
				order[4] = 40208
				order[5] = 0
				super(40204, 40209, order)
			end

			class NoPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40210
					order[1] = 40211
					order[2] = 0
					super(40209, 40210, order)
				end
			end
		end

		class NoExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42297
				order[1] = 42298
				order[2] = 0
				super(42296, 42297, order)
			end
		end

		class NoContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40041
				order[1] = 0
				super(40040, 40041, order)
			end
		end

		class NoFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40047
				order[1] = 40048
				order[2] = 0
				super(40046, 40047, order)
			end
		end

		class NoContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40043
				order[1] = 40044
				order[2] = 40045
				order[3] = 0
				super(40042, 40043, order)
			end
		end

		class NoUnderlyings < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(188)
				order[0] = 311
				order[1] = 312
				order[2] = 309
				order[3] = 305
				order[4] = 2874
				order[5] = 462
				order[6] = 463
				order[7] = 2894
				order[8] = 310
				order[9] = 763
				order[10] = 313
				order[11] = 542
				order[12] = 1213
				order[13] = 1837
				order[14] = 241
				order[15] = 1453
				order[16] = 1454
				order[17] = 2614
				order[18] = 2615
				order[19] = 2921
				order[20] = 2616
				order[21] = 2617
				order[22] = 2619
				order[23] = 1455
				order[24] = 1456
				order[25] = 1459
				order[26] = 1460
				order[27] = 242
				order[28] = 243
				order[29] = 244
				order[30] = 245
				order[31] = 246
				order[32] = 256
				order[33] = 595
				order[34] = 592
				order[35] = 593
				order[36] = 594
				order[37] = 247
				order[38] = 316
				order[39] = 941
				order[40] = 2917
				order[41] = 317
				order[42] = 436
				order[43] = 1437
				order[44] = 2363
				order[45] = 1441
				order[46] = 998
				order[47] = 1423
				order[48] = 1718
				order[49] = 2918
				order[50] = 1424
				order[51] = 1425
				order[52] = 1719
				order[53] = 2919
				order[54] = 1000
				order[55] = 1419
				order[56] = 1526
				order[57] = 2920
				order[58] = 435
				order[59] = 308
				order[60] = 306
				order[61] = 362
				order[62] = 363
				order[63] = 2742
				order[64] = 2720
				order[65] = 2721
				order[66] = 2722
				order[67] = 2723
				order[68] = 2724
				order[69] = 307
				order[70] = 364
				order[71] = 365
				order[72] = 877
				order[73] = 878
				order[74] = 972
				order[75] = 318
				order[76] = 2916
				order[77] = 879
				order[78] = 975
				order[79] = 973
				order[80] = 974
				order[81] = 810
				order[82] = 882
				order[83] = 883
				order[84] = 884
				order[85] = 885
				order[86] = 886
				order[87] = 2885
				order[88] = 2886
				order[89] = 1044
				order[90] = 1045
				order[91] = 1046
				order[92] = 1038
				order[93] = 1039
				order[94] = 315
				order[95] = 2683
				order[96] = 2687
				order[97] = 1988
				order[98] = 1989
				order[99] = 1990
				order[100] = 1991
				order[101] = 1992
				order[102] = 1993
				order[103] = 2881
				order[104] = 1994
				order[105] = 1995
				order[106] = 1996
				order[107] = 1997
				order[108] = 2620
				order[109] = 2621
				order[110] = 1998
				order[111] = 1999
				order[112] = 2000
				order[113] = 2003
				order[114] = 2004
				order[115] = 2005
				order[116] = 2006
				order[117] = 2284
				order[118] = 2285
				order[119] = 2286
				order[120] = 2287
				order[121] = 2288
				order[122] = 2007
				order[123] = 2008
				order[124] = 2009
				order[125] = 2010
				order[126] = 2011
				order[127] = 2012
				order[128] = 2491
				order[129] = 2013
				order[130] = 2014
				order[131] = 2015
				order[132] = 2744
				order[133] = 2016
				order[134] = 2289
				order[135] = 2017
				order[136] = 2018
				order[137] = 2019
				order[138] = 2020
				order[139] = 2021
				order[140] = 2022
				order[141] = 2290
				order[142] = 2622
				order[143] = 2291
				order[144] = 2623
				order[145] = 2292
				order[146] = 2023
				order[147] = 2024
				order[148] = 2025
				order[149] = 2026
				order[150] = 2027
				order[151] = 2028
				order[152] = 2029
				order[153] = 2757
				order[154] = 2030
				order[155] = 2031
				order[156] = 2293
				order[157] = 2294
				order[158] = 2032
				order[159] = 2033
				order[160] = 2034
				order[161] = 2035
				order[162] = 2036
				order[163] = 2037
				order[164] = 2038
				order[165] = 2039
				order[166] = 2040
				order[167] = 2041
				order[168] = 2042
				order[169] = 2043
				order[170] = 2044
				order[171] = 41314
				order[172] = 41315
				order[173] = 2295
				order[174] = 2296
				order[175] = 2297
				order[176] = 2756
				order[177] = 2298
				order[178] = 2299
				order[179] = 2624
				order[180] = 2625
				order[181] = 2626
				order[182] = 2627
				order[183] = 2628
				order[184] = 2629
				order[185] = 2630
				order[186] = 2631
				order[187] = 0
				super(711, 311, order)
			end

			class NoUnderlyingSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 458
					order[1] = 459
					order[2] = 2959
					order[3] = 0
					super(457, 458, order)
				end
			end

			class NoUnderlyingStips < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 888
					order[1] = 889
					order[2] = 0
					super(887, 888, order)
				end
			end

			class NoUndlyInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 1059
					order[1] = 1060
					order[2] = 1061
					order[3] = 2391
					order[4] = 1062
					order[5] = 0
					super(1058, 1059, order)
				end

				class NoUndlyInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1063
						order[1] = 1064
						order[2] = 0
						super(1062, 1063, order)
					end
				end
			end

			class NoUnderlyingEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 1982
					order[1] = 1983
					order[2] = 1984
					order[3] = 1985
					order[4] = 1986
					order[5] = 2342
					order[6] = 1987
					order[7] = 2071
					order[8] = 2072
					order[9] = 2073
					order[10] = 0
					super(1981, 1982, order)
				end
			end

			class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2081
					order[1] = 2082
					order[2] = 2083
					order[3] = 2745
					order[4] = 0
					super(2080, 2081, order)
				end
			end

			class NoUnderlyingAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2313
					order[1] = 2314
					order[2] = 2315
					order[3] = 0
					super(2312, 2313, order)
				end
			end

			class NoUnderlyingComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2046
					order[1] = 2261
					order[2] = 2262
					order[3] = 2263
					order[4] = 2047
					order[5] = 2264
					order[6] = 2265
					order[7] = 2266
					order[8] = 2947
					order[9] = 2048
					order[10] = 2267
					order[11] = 2049
					order[12] = 2050
					order[13] = 2051
					order[14] = 2052
					order[15] = 2053
					order[16] = 2268
					order[17] = 2948
					order[18] = 2269
					order[19] = 2949
					order[20] = 2270
					order[21] = 2271
					order[22] = 2419
					order[23] = 2420
					order[24] = 2272
					order[25] = 2273
					order[26] = 2274
					order[27] = 2275
					order[28] = 2276
					order[29] = 41732
					order[30] = 41739
					order[31] = 41740
					order[32] = 41741
					order[33] = 41742
					order[34] = 41743
					order[35] = 41744
					order[36] = 41745
					order[37] = 41746
					order[38] = 41747
					order[39] = 41729
					order[40] = 2277
					order[41] = 2278
					order[42] = 2279
					order[43] = 2280
					order[44] = 2281
					order[45] = 41748
					order[46] = 41716
					order[47] = 2611
					order[48] = 2612
					order[49] = 2613
					order[50] = 2282
					order[51] = 2283
					order[52] = 0
					super(2045, 2046, order)
				end

				class NoUnderlyingComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2054
						order[1] = 2055
						order[2] = 2056
						order[3] = 0
						super(2053, 2054, order)
					end

					class NoUnderlyingComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2057
							order[1] = 2058
							order[2] = 0
							super(2056, 2057, order)
						end
					end
				end

				class NoUnderlyingComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41733
						order[1] = 41734
						order[2] = 41735
						order[3] = 41736
						order[4] = 0
						super(41732, 41733, order)
					end
				end

				class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41738
						order[1] = 0
						super(41737, 41738, order)
					end
				end

				class NoUnderlyingComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41730
						order[1] = 41731
						order[2] = 41750
						order[3] = 41726
						order[4] = 41713
						order[5] = 0
						super(41729, 41730, order)
					end

					class NoUnderlyingComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41751
							order[1] = 41752
							order[2] = 41753
							order[3] = 41754
							order[4] = 41755
							order[5] = 0
							super(41750, 41751, order)
						end
					end

					class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41727
							order[1] = 41728
							order[2] = 0
							super(41726, 41727, order)
						end
					end

					class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41714
							order[1] = 41715
							order[2] = 0
							super(41713, 41714, order)
						end
					end
				end

				class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41749
						order[1] = 0
						super(41748, 41749, order)
					end
				end

				class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41717
						order[1] = 41718
						order[2] = 41719
						order[3] = 41720
						order[4] = 41721
						order[5] = 41722
						order[6] = 41723
						order[7] = 41724
						order[8] = 0
						super(41716, 41717, order)
					end

					class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41725
							order[1] = 0
							super(41724, 41725, order)
						end
					end
				end
			end

			class NoUnderlyingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40963
					order[1] = 0
					super(40962, 40963, order)
				end
			end

			class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41948
					order[1] = 0
					super(41947, 41948, order)
				end
			end

			class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41865
					order[1] = 41338
					order[2] = 0
					super(41864, 41865, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41867
					order[1] = 41339
					order[2] = 0
					super(41866, 41867, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41869
					order[1] = 41870
					order[2] = 41871
					order[3] = 41872
					order[4] = 41873
					order[5] = 41874
					order[6] = 41875
					order[7] = 41876
					order[8] = 41877
					order[9] = 0
					super(41868, 41869, order)
				end
			end

			class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 43075
					order[1] = 0
					super(43074, 43075, order)
				end
			end

			class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41821
					order[1] = 0
					super(41820, 41821, order)
				end
			end

			class NoUnderlyingOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41842
					order[1] = 41843
					order[2] = 0
					super(41841, 41842, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41845
					order[1] = 0
					super(41844, 41845, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41857
					order[1] = 41858
					order[2] = 0
					super(41856, 41857, order)
				end
			end

			class NoUnderlyingStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40541
					order[1] = 42016
					order[2] = 40542
					order[3] = 43083
					order[4] = 43084
					order[5] = 40543
					order[6] = 40544
					order[7] = 42018
					order[8] = 40545
					order[9] = 40546
					order[10] = 43085
					order[11] = 43086
					order[12] = 42019
					order[13] = 42020
					order[14] = 42021
					order[15] = 42022
					order[16] = 42023
					order[17] = 42024
					order[18] = 41964
					order[19] = 41965
					order[20] = 41966
					order[21] = 41967
					order[22] = 41968
					order[23] = 41969
					order[24] = 41970
					order[25] = 42589
					order[26] = 41971
					order[27] = 41972
					order[28] = 41973
					order[29] = 41974
					order[30] = 41975
					order[31] = 41976
					order[32] = 41977
					order[33] = 41978
					order[34] = 41979
					order[35] = 41980
					order[36] = 41981
					order[37] = 41982
					order[38] = 41983
					order[39] = 41984
					order[40] = 41985
					order[41] = 41986
					order[42] = 41987
					order[43] = 41988
					order[44] = 41989
					order[45] = 40057
					order[46] = 40058
					order[47] = 40060
					order[48] = 40061
					order[49] = 40062
					order[50] = 40063
					order[51] = 40064
					order[52] = 40548
					order[53] = 40549
					order[54] = 40551
					order[55] = 40552
					order[56] = 40553
					order[57] = 40554
					order[58] = 40555
					order[59] = 41957
					order[60] = 41958
					order[61] = 40556
					order[62] = 40558
					order[63] = 40559
					order[64] = 40561
					order[65] = 40562
					order[66] = 40563
					order[67] = 40564
					order[68] = 40565
					order[69] = 40566
					order[70] = 40567
					order[71] = 41959
					order[72] = 41960
					order[73] = 41961
					order[74] = 40568
					order[75] = 40569
					order[76] = 40570
					order[77] = 42895
					order[78] = 40571
					order[79] = 40572
					order[80] = 43107
					order[81] = 40573
					order[82] = 40574
					order[83] = 40575
					order[84] = 40576
					order[85] = 40577
					order[86] = 42896
					order[87] = 42897
					order[88] = 42898
					order[89] = 42899
					order[90] = 40578
					order[91] = 40579
					order[92] = 40580
					order[93] = 41897
					order[94] = 41898
					order[95] = 41899
					order[96] = 41900
					order[97] = 41901
					order[98] = 41902
					order[99] = 41903
					order[100] = 42900
					order[101] = 40664
					order[102] = 40708
					order[103] = 41777
					order[104] = 41778
					order[105] = 41779
					order[106] = 41780
					order[107] = 41781
					order[108] = 42196
					order[109] = 42197
					order[110] = 41782
					order[111] = 41783
					order[112] = 41784
					order[113] = 41785
					order[114] = 41786
					order[115] = 41587
					order[116] = 41787
					order[117] = 41788
					order[118] = 41789
					order[119] = 41790
					order[120] = 41791
					order[121] = 41792
					order[122] = 41793
					order[123] = 41794
					order[124] = 41795
					order[125] = 41796
					order[126] = 41797
					order[127] = 41798
					order[128] = 41799
					order[129] = 43096
					order[130] = 41756
					order[131] = 40547
					order[132] = 40988
					order[133] = 40989
					order[134] = 0
					super(40540, 40541, order)
				end

				class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41991
						order[1] = 41992
						order[2] = 0
						super(41990, 41991, order)
					end
				end

				class NoUnderlyingStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41801
						order[1] = 41802
						order[2] = 41803
						order[3] = 0
						super(41800, 41801, order)
					end
				end

				class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41994
						order[1] = 41995
						order[2] = 0
						super(41993, 41994, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41963
						order[1] = 0
						super(41962, 41963, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 42003
						order[1] = 42004
						order[2] = 42005
						order[3] = 42006
						order[4] = 42007
						order[5] = 42008
						order[6] = 42009
						order[7] = 42010
						order[8] = 42011
						order[9] = 42012
						order[10] = 42013
						order[11] = 41996
						order[12] = 42014
						order[13] = 42015
						order[14] = 0
						super(42002, 42003, order)
					end

					class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41997
							order[1] = 41998
							order[2] = 41999
							order[3] = 0
							super(41996, 41997, order)
						end

						class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 42000
								order[1] = 42001
								order[2] = 41936
								order[3] = 0
								super(41999, 42000, order)
							end
						end
					end
				end

				class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40059
						order[1] = 0
						super(40975, 40059, order)
					end
				end

				class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40550
						order[1] = 0
						super(40976, 40550, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40557
						order[1] = 0
						super(40973, 40557, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41955
						order[1] = 41956
						order[2] = 0
						super(41954, 41955, order)
					end
				end

				class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40560
						order[1] = 0
						super(40974, 40560, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40582
						order[1] = 0
						super(40969, 40582, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41938
						order[1] = 41939
						order[2] = 0
						super(41937, 41938, order)
					end
				end

				class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40594
						order[1] = 0
						super(40970, 40594, order)
					end
				end

				class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40600
						order[1] = 0
						super(40971, 40600, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40607
						order[1] = 0
						super(40972, 40607, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42956
						order[1] = 42957
						order[2] = 0
						super(42955, 42956, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41910
						order[1] = 0
						super(41909, 41910, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41945
						order[1] = 41946
						order[2] = 0
						super(41944, 41945, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41942
						order[1] = 41943
						order[2] = 0
						super(41941, 41942, order)
					end
				end

				class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43111
						order[1] = 42982
						order[2] = 42983
						order[3] = 0
						super(42981, 43111, order)
					end
				end

				class NoUnderlyingDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42863
						order[1] = 42864
						order[2] = 42865
						order[3] = 42866
						order[4] = 42867
						order[5] = 42868
						order[6] = 42882
						order[7] = 42869
						order[8] = 42870
						order[9] = 42871
						order[10] = 42872
						order[11] = 42873
						order[12] = 42874
						order[13] = 42875
						order[14] = 42876
						order[15] = 42877
						order[16] = 42878
						order[17] = 42879
						order[18] = 42880
						order[19] = 42881
						order[20] = 0
						super(42862, 42863, order)
					end

					class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42883
							order[1] = 0
							super(42882, 42883, order)
						end
					end
				end

				class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42854
						order[1] = 0
						super(42853, 42854, order)
					end
				end

				class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42800
						order[1] = 0
						super(42799, 42800, order)
					end
				end

				class NoUnderlyingReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 43035
						order[1] = 43036
						order[2] = 43037
						order[3] = 43038
						order[4] = 43039
						order[5] = 43040
						order[6] = 43064
						order[7] = 43030
						order[8] = 43041
						order[9] = 43042
						order[10] = 43043
						order[11] = 43044
						order[12] = 43045
						order[13] = 43046
						order[14] = 43047
						order[15] = 43048
						order[16] = 43049
						order[17] = 43050
						order[18] = 43051
						order[19] = 43052
						order[20] = 43060
						order[21] = 43053
						order[22] = 43054
						order[23] = 43008
						order[24] = 43055
						order[25] = 43056
						order[26] = 43057
						order[27] = 43058
						order[28] = 43059
						order[29] = 0
						super(43034, 43035, order)
					end

					class NoUnderlyingReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 43065
							order[1] = 43066
							order[2] = 43067
							order[3] = 43068
							order[4] = 0
							super(43064, 43065, order)
						end
					end

					class NoUnderlyingReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43031
							order[1] = 43032
							order[2] = 43033
							order[3] = 0
							super(43030, 43031, order)
						end
					end

					class NoUnderlyingReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43061
							order[1] = 43062
							order[2] = 43063
							order[3] = 0
							super(43060, 43061, order)
						end
					end

					class NoUnderlyingReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 43009
							order[1] = 43071
							order[2] = 43010
							order[3] = 43011
							order[4] = 43012
							order[5] = 43013
							order[6] = 43014
							order[7] = 43015
							order[8] = 43016
							order[9] = 43017
							order[10] = 43018
							order[11] = 43019
							order[12] = 43020
							order[13] = 43021
							order[14] = 43022
							order[15] = 43023
							order[16] = 43024
							order[17] = 43025
							order[18] = 43026
							order[19] = 43027
							order[20] = 43028
							order[21] = 43029
							order[22] = 43069
							order[23] = 0
							super(43008, 43009, order)
						end

						class NoUnderlyingReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 43072
								order[1] = 43073
								order[2] = 0
								super(43071, 43072, order)
							end
						end

						class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 43070
								order[1] = 0
								super(43069, 43070, order)
							end
						end
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42916
						order[1] = 0
						super(42915, 42916, order)
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42902
						order[1] = 42903
						order[2] = 0
						super(42901, 42902, order)
					end
				end

				class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40650
						order[1] = 0
						super(40968, 40650, order)
					end
				end

				class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40657
						order[1] = 40658
						order[2] = 0
						super(40656, 40657, order)
					end
				end

				class NoUnderlyingSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40660
						order[1] = 40904
						order[2] = 40915
						order[3] = 40662
						order[4] = 40663
						order[5] = 0
						super(40659, 40660, order)
					end
				end

				class NoUnderlyingPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40665
						order[1] = 41881
						order[2] = 41882
						order[3] = 40666
						order[4] = 40667
						order[5] = 40668
						order[6] = 40669
						order[7] = 40670
						order[8] = 40671
						order[9] = 40672
						order[10] = 40673
						order[11] = 40674
						order[12] = 40675
						order[13] = 41883
						order[14] = 41884
						order[15] = 41885
						order[16] = 41886
						order[17] = 40676
						order[18] = 40677
						order[19] = 40678
						order[20] = 40679
						order[21] = 41887
						order[22] = 41888
						order[23] = 41889
						order[24] = 41890
						order[25] = 40680
						order[26] = 40681
						order[27] = 40682
						order[28] = 40683
						order[29] = 40684
						order[30] = 40685
						order[31] = 40704
						order[32] = 40686
						order[33] = 40687
						order[34] = 40688
						order[35] = 40689
						order[36] = 40966
						order[37] = 40691
						order[38] = 40692
						order[39] = 40693
						order[40] = 41891
						order[41] = 41892
						order[42] = 40694
						order[43] = 41878
						order[44] = 41893
						order[45] = 41894
						order[46] = 41895
						order[47] = 41896
						order[48] = 40695
						order[49] = 40696
						order[50] = 40697
						order[51] = 40698
						order[52] = 40967
						order[53] = 40700
						order[54] = 40701
						order[55] = 40702
						order[56] = 40703
						order[57] = 0
						super(40664, 40665, order)
					end

					class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40705
							order[1] = 40706
							order[2] = 40707
							order[3] = 0
							super(40704, 40705, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40690
							order[1] = 0
							super(40966, 40690, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41879
							order[1] = 41880
							order[2] = 0
							super(41878, 41879, order)
						end
					end

					class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40699
							order[1] = 0
							super(40967, 40699, order)
						end
					end
				end

				class NoUnderlyingPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40709
						order[1] = 40710
						order[2] = 42993
						order[3] = 42994
						order[4] = 42995
						order[5] = 42996
						order[6] = 42997
						order[7] = 42998
						order[8] = 42999
						order[9] = 42984
						order[10] = 42985
						order[11] = 42986
						order[12] = 42987
						order[13] = 42988
						order[14] = 42989
						order[15] = 42990
						order[16] = 40711
						order[17] = 40712
						order[18] = 40713
						order[19] = 40714
						order[20] = 40715
						order[21] = 40716
						order[22] = 40717
						order[23] = 40718
						order[24] = 40719
						order[25] = 40720
						order[26] = 40721
						order[27] = 40722
						order[28] = 40723
						order[29] = 40724
						order[30] = 40725
						order[31] = 40726
						order[32] = 40727
						order[33] = 40728
						order[34] = 40729
						order[35] = 40730
						order[36] = 40731
						order[37] = 40732
						order[38] = 40733
						order[39] = 40734
						order[40] = 40735
						order[41] = 40736
						order[42] = 40737
						order[43] = 0
						super(40708, 40709, order)
					end

					class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43001
							order[1] = 0
							super(43000, 43001, order)
						end
					end

					class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42992
							order[1] = 0
							super(42991, 42992, order)
						end
					end
				end

				class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41809
						order[1] = 0
						super(41808, 41809, order)
					end
				end

				class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41805
						order[1] = 41806
						order[2] = 41807
						order[3] = 0
						super(41804, 41805, order)
					end
				end

				class NoUnderlyingDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41757
						order[1] = 41758
						order[2] = 41759
						order[3] = 41760
						order[4] = 41761
						order[5] = 41762
						order[6] = 41763
						order[7] = 41764
						order[8] = 41765
						order[9] = 41766
						order[10] = 41767
						order[11] = 41768
						order[12] = 41769
						order[13] = 41770
						order[14] = 0
						super(41756, 41757, order)
					end

					class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41771
							order[1] = 41772
							order[2] = 41773
							order[3] = 0
							super(41770, 41771, order)
						end

						class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41774
								order[1] = 41775
								order[2] = 41776
								order[3] = 0
								super(41773, 41774, order)
							end
						end
					end
				end
			end

			class NoUnderlyingProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 42150
					order[1] = 42151
					order[2] = 42152
					order[3] = 42190
					order[4] = 42153
					order[5] = 42154
					order[6] = 42155
					order[7] = 43002
					order[8] = 43003
					order[9] = 42156
					order[10] = 42157
					order[11] = 42158
					order[12] = 42104
					order[13] = 42105
					order[14] = 42106
					order[15] = 42107
					order[16] = 42108
					order[17] = 42109
					order[18] = 42110
					order[19] = 42111
					order[20] = 42115
					order[21] = 42116
					order[22] = 42117
					order[23] = 42118
					order[24] = 42119
					order[25] = 42120
					order[26] = 42121
					order[27] = 42122
					order[28] = 42123
					order[29] = 42124
					order[30] = 42125
					order[31] = 42126
					order[32] = 42127
					order[33] = 42128
					order[34] = 42129
					order[35] = 42130
					order[36] = 42131
					order[37] = 42132
					order[38] = 42133
					order[39] = 42134
					order[40] = 42135
					order[41] = 42136
					order[42] = 42137
					order[43] = 42138
					order[44] = 42139
					order[45] = 42140
					order[46] = 42141
					order[47] = 42142
					order[48] = 42143
					order[49] = 42144
					order[50] = 42145
					order[51] = 42146
					order[52] = 42147
					order[53] = 42148
					order[54] = 42159
					order[55] = 42160
					order[56] = 42161
					order[57] = 42162
					order[58] = 42163
					order[59] = 42164
					order[60] = 42165
					order[61] = 42092
					order[62] = 42093
					order[63] = 42094
					order[64] = 42095
					order[65] = 42096
					order[66] = 42097
					order[67] = 42098
					order[68] = 42166
					order[69] = 42167
					order[70] = 42168
					order[71] = 42169
					order[72] = 42102
					order[73] = 42103
					order[74] = 42170
					order[75] = 42171
					order[76] = 42172
					order[77] = 42173
					order[78] = 0
					super(42149, 42150, order)
				end

				class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42191
						order[1] = 0
						super(42190, 42191, order)
					end
				end

				class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42183
						order[1] = 0
						super(42182, 42183, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42185
						order[1] = 0
						super(42184, 42185, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42113
						order[1] = 42114
						order[2] = 0
						super(42112, 42113, order)
					end
				end

				class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42187
						order[1] = 0
						super(42186, 42187, order)
					end
				end

				class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42189
						order[1] = 0
						super(42188, 42189, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42181
						order[1] = 0
						super(42180, 42181, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42100
						order[1] = 42101
						order[2] = 0
						super(42099, 42100, order)
					end
				end

				class NoUnderlyingProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 42174
						order[1] = 42175
						order[2] = 42176
						order[3] = 40918
						order[4] = 42177
						order[5] = 0
						super(42173, 42174, order)
					end

					class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42178
							order[1] = 42179
							order[2] = 0
							super(42177, 42178, order)
						end
					end
				end
			end

			class NoUnderlyingAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42037
					order[1] = 42038
					order[2] = 41340
					order[3] = 0
					super(42036, 42037, order)
				end

				class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41341
						order[1] = 41701
						order[2] = 41709
						order[3] = 41710
						order[4] = 41711
						order[5] = 41712
						order[6] = 42017
						order[7] = 42025
						order[8] = 42026
						order[9] = 42027
						order[10] = 42028
						order[11] = 42029
						order[12] = 42030
						order[13] = 42031
						order[14] = 42032
						order[15] = 42033
						order[16] = 42034
						order[17] = 42035
						order[18] = 0
						super(41340, 41341, order)
					end
				end
			end

			class NoUnderlyingProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 42069
					order[1] = 42070
					order[2] = 42071
					order[3] = 42072
					order[4] = 42073
					order[5] = 42074
					order[6] = 42075
					order[7] = 42090
					order[8] = 42077
					order[9] = 42087
					order[10] = 42076
					order[11] = 0
					super(42068, 42069, order)
				end

				class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42091
						order[1] = 0
						super(42090, 42091, order)
					end
				end

				class NoUnderlyingProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 42078
						order[1] = 42079
						order[2] = 42080
						order[3] = 42081
						order[4] = 42082
						order[5] = 42083
						order[6] = 42084
						order[7] = 42085
						order[8] = 0
						super(42077, 42078, order)
					end

					class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42086
							order[1] = 0
							super(42085, 42086, order)
						end
					end
				end

				class NoUnderlyingProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42088
						order[1] = 42089
						order[2] = 0
						super(42087, 42088, order)
					end
				end
			end

			class NoUnderlyingCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 42042
					order[1] = 42043
					order[2] = 42044
					order[3] = 42045
					order[4] = 42046
					order[5] = 42047
					order[6] = 42048
					order[7] = 42049
					order[8] = 42050
					order[9] = 42051
					order[10] = 42052
					order[11] = 42039
					order[12] = 42797
					order[13] = 42798
					order[14] = 42053
					order[15] = 42054
					order[16] = 42790
					order[17] = 42791
					order[18] = 42792
					order[19] = 42793
					order[20] = 42794
					order[21] = 42795
					order[22] = 42796
					order[23] = 42055
					order[24] = 42056
					order[25] = 42057
					order[26] = 42058
					order[27] = 42059
					order[28] = 0
					super(42041, 42042, order)
				end

				class NoUnderlyingCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42040
						order[1] = 0
						super(42039, 42040, order)
					end
				end

				class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42789
						order[1] = 0
						super(42788, 42789, order)
					end
				end
			end

			class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42065
					order[1] = 42061
					order[2] = 42062
					order[3] = 42063
					order[4] = 42064
					order[5] = 0
					super(42060, 42065, order)
				end

				class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42066
						order[1] = 42067
						order[2] = 0
						super(42065, 42066, order)
					end
				end
			end

			class NoUnderlyingRateSpreadSteps < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 43006
					order[1] = 43007
					order[2] = 0
					super(43005, 43006, order)
				end
			end

			class NoUnderlyingDividendPayments < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42856
					order[1] = 42857
					order[2] = 42858
					order[3] = 42859
					order[4] = 0
					super(42855, 42856, order)
				end
			end

			class NoUnderlyingExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42885
					order[1] = 42886
					order[2] = 0
					super(42884, 42885, order)
				end
			end
		end

		class NoRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1446
				order[1] = 1447
				order[2] = 1448
				order[3] = 2412
				order[4] = 2796
				order[5] = 0
				super(1445, 1446, order)
			end
		end

		class NoStipulations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 233
				order[1] = 234
				order[2] = 0
				super(232, 233, order)
			end
		end

		class NoLegs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(168)
				order[0] = 600
				order[1] = 601
				order[2] = 602
				order[3] = 603
				order[4] = 1788
				order[5] = 607
				order[6] = 1594
				order[7] = 608
				order[8] = 2893
				order[9] = 609
				order[10] = 764
				order[11] = 610
				order[12] = 611
				order[13] = 1212
				order[14] = 2146
				order[15] = 2147
				order[16] = 2148
				order[17] = 248
				order[18] = 2149
				order[19] = 2150
				order[20] = 2151
				order[21] = 2152
				order[22] = 2153
				order[23] = 2154
				order[24] = 2155
				order[25] = 2348
				order[26] = 2067
				order[27] = 2068
				order[28] = 2069
				order[29] = 2739
				order[30] = 2070
				order[31] = 2156
				order[32] = 2157
				order[33] = 2158
				order[34] = 2159
				order[35] = 2160
				order[36] = 2161
				order[37] = 2162
				order[38] = 2163
				order[39] = 2164
				order[40] = 2165
				order[41] = 2880
				order[42] = 2166
				order[43] = 2167
				order[44] = 2168
				order[45] = 2169
				order[46] = 2170
				order[47] = 2171
				order[48] = 2172
				order[49] = 2173
				order[50] = 2174
				order[51] = 2175
				order[52] = 2176
				order[53] = 2177
				order[54] = 2178
				order[55] = 2179
				order[56] = 2180
				order[57] = 249
				order[58] = 250
				order[59] = 251
				order[60] = 252
				order[61] = 253
				order[62] = 257
				order[63] = 599
				order[64] = 596
				order[65] = 597
				order[66] = 598
				order[67] = 254
				order[68] = 612
				order[69] = 942
				order[70] = 2908
				order[71] = 2181
				order[72] = 2182
				order[73] = 2183
				order[74] = 2184
				order[75] = 2604
				order[76] = 2185
				order[77] = 2605
				order[78] = 2186
				order[79] = 2187
				order[80] = 2188
				order[81] = 2189
				order[82] = 613
				order[83] = 614
				order[84] = 1436
				order[85] = 2354
				order[86] = 1440
				order[87] = 2190
				order[88] = 2191
				order[89] = 999
				order[90] = 1224
				order[91] = 1720
				order[92] = 2909
				order[93] = 1421
				order[94] = 1422
				order[95] = 1721
				order[96] = 2910
				order[97] = 2192
				order[98] = 1001
				order[99] = 1420
				order[100] = 2193
				order[101] = 2194
				order[102] = 2755
				order[103] = 2195
				order[104] = 2196
				order[105] = 2197
				order[106] = 2198
				order[107] = 1528
				order[108] = 2911
				order[109] = 2199
				order[110] = 2200
				order[111] = 2201
				order[112] = 2202
				order[113] = 2203
				order[114] = 615
				order[115] = 616
				order[116] = 2205
				order[117] = 2206
				order[118] = 617
				order[119] = 618
				order[120] = 619
				order[121] = 2740
				order[122] = 2717
				order[123] = 2718
				order[124] = 2719
				order[125] = 620
				order[126] = 621
				order[127] = 622
				order[128] = 2207
				order[129] = 2208
				order[130] = 623
				order[131] = 624
				order[132] = 556
				order[133] = 2898
				order[134] = 740
				order[135] = 739
				order[136] = 955
				order[137] = 956
				order[138] = 1358
				order[139] = 2682
				order[140] = 2686
				order[141] = 1017
				order[142] = 566
				order[143] = 2209
				order[144] = 2211
				order[145] = 2212
				order[146] = 2213
				order[147] = 2754
				order[148] = 2214
				order[149] = 2215
				order[150] = 2606
				order[151] = 2607
				order[152] = 685
				order[153] = 687
				order[154] = 2346
				order[155] = 690
				order[156] = 587
				order[157] = 588
				order[158] = 683
				order[159] = 539
				order[160] = 676
				order[161] = 2951
				order[162] = 677
				order[163] = 678
				order[164] = 679
				order[165] = 680
				order[166] = 654
				order[167] = 0
				super(555, 600, order)
			end

			class NoLegSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 605
					order[1] = 606
					order[2] = 2958
					order[3] = 0
					super(604, 605, order)
				end
			end

			class NoLegSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2077
					order[1] = 2078
					order[2] = 2079
					order[3] = 2743
					order[4] = 0
					super(2076, 2077, order)
				end
			end

			class NoLegAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2309
					order[1] = 2310
					order[2] = 2311
					order[3] = 0
					super(2308, 2309, order)
				end
			end

			class NoLegEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 2060
					order[1] = 2061
					order[2] = 2062
					order[3] = 2063
					order[4] = 2064
					order[5] = 2341
					order[6] = 2065
					order[7] = 2066
					order[8] = 2074
					order[9] = 2075
					order[10] = 0
					super(2059, 2060, order)
				end
			end

			class NoLegInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 2255
					order[1] = 2256
					order[2] = 2257
					order[3] = 2379
					order[4] = 2258
					order[5] = 0
					super(2254, 2255, order)
				end

				class NoLegInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2259
						order[1] = 2260
						order[2] = 0
						super(2258, 2259, order)
					end
				end
			end

			class NoLegComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2219
					order[1] = 2220
					order[2] = 2221
					order[3] = 2222
					order[4] = 2223
					order[5] = 2224
					order[6] = 2225
					order[7] = 2226
					order[8] = 2944
					order[9] = 2227
					order[10] = 2228
					order[11] = 2229
					order[12] = 2230
					order[13] = 2231
					order[14] = 2232
					order[15] = 2250
					order[16] = 2233
					order[17] = 2945
					order[18] = 2234
					order[19] = 2946
					order[20] = 2235
					order[21] = 2236
					order[22] = 2409
					order[23] = 2410
					order[24] = 2237
					order[25] = 2238
					order[26] = 2239
					order[27] = 2240
					order[28] = 2241
					order[29] = 41382
					order[30] = 41389
					order[31] = 41390
					order[32] = 41391
					order[33] = 41392
					order[34] = 41393
					order[35] = 41394
					order[36] = 41395
					order[37] = 41396
					order[38] = 41397
					order[39] = 41379
					order[40] = 2242
					order[41] = 2243
					order[42] = 2244
					order[43] = 2245
					order[44] = 2246
					order[45] = 41398
					order[46] = 41366
					order[47] = 2608
					order[48] = 2609
					order[49] = 2610
					order[50] = 2248
					order[51] = 2249
					order[52] = 0
					super(2218, 2219, order)
				end

				class NoLegComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2251
						order[1] = 2252
						order[2] = 2253
						order[3] = 0
						super(2250, 2251, order)
					end

					class NoLegComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2204
							order[1] = 2247
							order[2] = 0
							super(2253, 2204, order)
						end
					end
				end

				class NoLegComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41383
						order[1] = 41384
						order[2] = 41385
						order[3] = 41386
						order[4] = 0
						super(41382, 41383, order)
					end
				end

				class NoLegComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41388
						order[1] = 0
						super(41387, 41388, order)
					end
				end

				class NoLegComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41380
						order[1] = 41381
						order[2] = 41400
						order[3] = 41376
						order[4] = 41363
						order[5] = 0
						super(41379, 41380, order)
					end

					class NoLegComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41401
							order[1] = 41402
							order[2] = 41403
							order[3] = 41404
							order[4] = 41405
							order[5] = 0
							super(41400, 41401, order)
						end
					end

					class NoLegComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41377
							order[1] = 41378
							order[2] = 0
							super(41376, 41377, order)
						end
					end

					class NoLegComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41364
							order[1] = 41365
							order[2] = 0
							super(41363, 41364, order)
						end
					end
				end

				class NoLegComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41399
						order[1] = 0
						super(41398, 41399, order)
					end
				end

				class NoLegComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41367
						order[1] = 41368
						order[2] = 41369
						order[3] = 41370
						order[4] = 41371
						order[5] = 41372
						order[6] = 41373
						order[7] = 41374
						order[8] = 0
						super(41366, 41367, order)
					end

					class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41375
							order[1] = 0
							super(41374, 41375, order)
						end
					end
				end
			end

			class NoLegBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40924
					order[1] = 0
					super(40923, 40924, order)
				end
			end

			class NoLegPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41608
					order[1] = 0
					super(41607, 41608, order)
				end
			end

			class NoLegMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41468
					order[1] = 40223
					order[2] = 0
					super(41467, 41468, order)
				end
			end

			class NoLegMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41470
					order[1] = 40990
					order[2] = 0
					super(41469, 41470, order)
				end
			end

			class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41472
					order[1] = 41473
					order[2] = 41474
					order[3] = 41475
					order[4] = 41476
					order[5] = 41477
					order[6] = 41478
					order[7] = 41479
					order[8] = 41480
					order[9] = 0
					super(41471, 41472, order)
				end
			end

			class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42582
					order[1] = 0
					super(42581, 42582, order)
				end
			end

			class NoLegOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41492
					order[1] = 0
					super(41491, 41492, order)
				end
			end

			class NoLegOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41513
					order[1] = 41514
					order[2] = 0
					super(41512, 41513, order)
				end
			end

			class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41516
					order[1] = 0
					super(41515, 41516, order)
				end
			end

			class NoLegOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41528
					order[1] = 41529
					order[2] = 0
					super(41527, 41528, order)
				end
			end

			class NoLegStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40242
					order[1] = 41700
					order[2] = 40243
					order[3] = 42583
					order[4] = 42584
					order[5] = 40244
					order[6] = 40245
					order[7] = 41702
					order[8] = 40246
					order[9] = 40247
					order[10] = 42585
					order[11] = 42586
					order[12] = 41703
					order[13] = 41704
					order[14] = 41705
					order[15] = 41706
					order[16] = 41707
					order[17] = 41708
					order[18] = 41648
					order[19] = 41649
					order[20] = 41650
					order[21] = 41651
					order[22] = 41652
					order[23] = 41653
					order[24] = 41654
					order[25] = 42588
					order[26] = 41655
					order[27] = 41656
					order[28] = 41657
					order[29] = 41658
					order[30] = 41659
					order[31] = 41660
					order[32] = 41661
					order[33] = 41662
					order[34] = 41663
					order[35] = 41664
					order[36] = 41665
					order[37] = 41666
					order[38] = 41667
					order[39] = 41668
					order[40] = 41669
					order[41] = 41670
					order[42] = 41671
					order[43] = 41672
					order[44] = 41673
					order[45] = 40249
					order[46] = 40250
					order[47] = 40252
					order[48] = 40253
					order[49] = 40254
					order[50] = 40255
					order[51] = 40256
					order[52] = 40257
					order[53] = 40258
					order[54] = 40260
					order[55] = 40261
					order[56] = 40262
					order[57] = 40263
					order[58] = 40264
					order[59] = 41641
					order[60] = 41642
					order[61] = 40265
					order[62] = 40267
					order[63] = 40268
					order[64] = 40270
					order[65] = 40271
					order[66] = 40272
					order[67] = 40273
					order[68] = 40274
					order[69] = 40275
					order[70] = 40276
					order[71] = 41643
					order[72] = 41644
					order[73] = 41645
					order[74] = 40279
					order[75] = 40280
					order[76] = 40281
					order[77] = 42399
					order[78] = 40282
					order[79] = 40283
					order[80] = 43108
					order[81] = 40284
					order[82] = 40285
					order[83] = 40286
					order[84] = 40287
					order[85] = 40288
					order[86] = 42400
					order[87] = 42401
					order[88] = 42402
					order[89] = 42403
					order[90] = 40289
					order[91] = 40290
					order[92] = 40291
					order[93] = 41549
					order[94] = 41550
					order[95] = 41551
					order[96] = 41552
					order[97] = 41553
					order[98] = 41554
					order[99] = 41555
					order[100] = 42404
					order[101] = 40374
					order[102] = 40418
					order[103] = 41429
					order[104] = 41430
					order[105] = 41431
					order[106] = 41432
					order[107] = 41433
					order[108] = 42194
					order[109] = 42195
					order[110] = 41434
					order[111] = 41435
					order[112] = 41436
					order[113] = 41437
					order[114] = 41438
					order[115] = 41219
					order[116] = 41439
					order[117] = 41440
					order[118] = 41441
					order[119] = 41442
					order[120] = 41443
					order[121] = 41444
					order[122] = 41445
					order[123] = 41446
					order[124] = 41447
					order[125] = 41448
					order[126] = 41449
					order[127] = 41450
					order[128] = 41451
					order[129] = 43095
					order[130] = 41408
					order[131] = 40248
					order[132] = 40978
					order[133] = 40979
					order[134] = 0
					super(40241, 40242, order)
				end

				class NoLegStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41675
						order[1] = 41676
						order[2] = 0
						super(41674, 41675, order)
					end
				end

				class NoLegStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41453
						order[1] = 41454
						order[2] = 41455
						order[3] = 0
						super(41452, 41453, order)
					end
				end

				class NoLegStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41678
						order[1] = 41679
						order[2] = 0
						super(41677, 41678, order)
					end
				end

				class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41647
						order[1] = 0
						super(41646, 41647, order)
					end
				end

				class NoLegStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41687
						order[1] = 41688
						order[2] = 41689
						order[3] = 41690
						order[4] = 41691
						order[5] = 41692
						order[6] = 41693
						order[7] = 41694
						order[8] = 41695
						order[9] = 41696
						order[10] = 41697
						order[11] = 41680
						order[12] = 41698
						order[13] = 41699
						order[14] = 0
						super(41686, 41687, order)
					end

					class NoLegStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41681
							order[1] = 41682
							order[2] = 41683
							order[3] = 0
							super(41680, 41681, order)
						end

						class NoLegStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41684
								order[1] = 41685
								order[2] = 41935
								order[3] = 0
								super(41683, 41684, order)
							end
						end
					end
				end

				class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40251
						order[1] = 0
						super(40942, 40251, order)
					end
				end

				class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40259
						order[1] = 0
						super(40943, 40259, order)
					end
				end

				class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40266
						order[1] = 0
						super(40940, 40266, order)
					end
				end

				class NoLegStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41639
						order[1] = 41640
						order[2] = 0
						super(41638, 41639, order)
					end
				end

				class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40269
						order[1] = 0
						super(40941, 40269, order)
					end
				end

				class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40293
						order[1] = 0
						super(40930, 40293, order)
					end
				end

				class NoLegPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41590
						order[1] = 41591
						order[2] = 0
						super(41589, 41590, order)
					end
				end

				class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40305
						order[1] = 0
						super(40931, 40305, order)
					end
				end

				class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40311
						order[1] = 0
						super(40932, 40311, order)
					end
				end

				class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40318
						order[1] = 0
						super(40933, 40318, order)
					end
				end

				class NoLegPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42460
						order[1] = 42461
						order[2] = 0
						super(42459, 42460, order)
					end
				end

				class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41562
						order[1] = 0
						super(41561, 41562, order)
					end
				end

				class NoLegPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41597
						order[1] = 41598
						order[2] = 0
						super(41596, 41597, order)
					end
				end

				class NoLegPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41594
						order[1] = 41595
						order[2] = 0
						super(41593, 41594, order)
					end
				end

				class NoLegPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43110
						order[1] = 42486
						order[2] = 42487
						order[3] = 0
						super(42485, 43110, order)
					end
				end

				class NoLegDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42367
						order[1] = 42368
						order[2] = 42369
						order[3] = 42370
						order[4] = 42371
						order[5] = 42372
						order[6] = 42386
						order[7] = 42373
						order[8] = 42374
						order[9] = 42375
						order[10] = 42376
						order[11] = 42377
						order[12] = 42378
						order[13] = 42379
						order[14] = 42380
						order[15] = 42381
						order[16] = 42382
						order[17] = 42383
						order[18] = 42384
						order[19] = 42385
						order[20] = 0
						super(42366, 42367, order)
					end

					class NoLegDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42387
							order[1] = 0
							super(42386, 42387, order)
						end
					end
				end

				class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42365
						order[1] = 0
						super(42364, 42365, order)
					end
				end

				class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42311
						order[1] = 0
						super(42310, 42311, order)
					end
				end

				class NoLegReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 42535
						order[1] = 42536
						order[2] = 42537
						order[3] = 42538
						order[4] = 42539
						order[5] = 42540
						order[6] = 42564
						order[7] = 42530
						order[8] = 42541
						order[9] = 42542
						order[10] = 42543
						order[11] = 42544
						order[12] = 42545
						order[13] = 42546
						order[14] = 42547
						order[15] = 42548
						order[16] = 42549
						order[17] = 42550
						order[18] = 42551
						order[19] = 42552
						order[20] = 42560
						order[21] = 42553
						order[22] = 42554
						order[23] = 42508
						order[24] = 42555
						order[25] = 42556
						order[26] = 42557
						order[27] = 42558
						order[28] = 42559
						order[29] = 0
						super(42534, 42535, order)
					end

					class NoLegReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 42565
							order[1] = 42566
							order[2] = 42567
							order[3] = 42568
							order[4] = 0
							super(42564, 42565, order)
						end
					end

					class NoLegReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42531
							order[1] = 42532
							order[2] = 42533
							order[3] = 0
							super(42530, 42531, order)
						end
					end

					class NoLegReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42561
							order[1] = 42562
							order[2] = 42563
							order[3] = 0
							super(42560, 42561, order)
						end
					end

					class NoLegReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 42509
							order[1] = 42571
							order[2] = 42510
							order[3] = 42511
							order[4] = 42512
							order[5] = 42513
							order[6] = 42514
							order[7] = 42515
							order[8] = 42516
							order[9] = 42517
							order[10] = 42518
							order[11] = 42519
							order[12] = 42520
							order[13] = 42521
							order[14] = 42522
							order[15] = 42523
							order[16] = 42524
							order[17] = 42525
							order[18] = 42526
							order[19] = 42527
							order[20] = 42528
							order[21] = 42529
							order[22] = 42569
							order[23] = 0
							super(42508, 42509, order)
						end

						class NoLegReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 42572
								order[1] = 42573
								order[2] = 0
								super(42571, 42572, order)
							end
						end

						class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 42570
								order[1] = 0
								super(42569, 42570, order)
							end
						end
					end
				end

				class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42420
						order[1] = 0
						super(42419, 42420, order)
					end
				end

				class NoLegPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42406
						order[1] = 42407
						order[2] = 0
						super(42405, 42406, order)
					end
				end

				class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40361
						order[1] = 0
						super(40929, 40361, order)
					end
				end

				class NoLegNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40368
						order[1] = 40369
						order[2] = 0
						super(40367, 40368, order)
					end
				end

				class NoLegSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40903
						order[1] = 40366
						order[2] = 40370
						order[3] = 40905
						order[4] = 40906
						order[5] = 0
						super(40902, 40903, order)
					end
				end

				class NoLegPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40375
						order[1] = 41533
						order[2] = 41534
						order[3] = 40376
						order[4] = 40377
						order[5] = 40378
						order[6] = 40379
						order[7] = 40380
						order[8] = 40381
						order[9] = 40382
						order[10] = 40383
						order[11] = 40384
						order[12] = 40385
						order[13] = 41535
						order[14] = 41536
						order[15] = 41537
						order[16] = 41538
						order[17] = 40386
						order[18] = 40387
						order[19] = 40388
						order[20] = 40389
						order[21] = 41539
						order[22] = 41540
						order[23] = 41541
						order[24] = 41542
						order[25] = 40390
						order[26] = 40391
						order[27] = 40392
						order[28] = 40393
						order[29] = 40394
						order[30] = 40395
						order[31] = 40414
						order[32] = 40396
						order[33] = 40397
						order[34] = 40398
						order[35] = 40399
						order[36] = 40927
						order[37] = 40401
						order[38] = 40402
						order[39] = 40403
						order[40] = 41543
						order[41] = 41544
						order[42] = 40404
						order[43] = 41530
						order[44] = 41545
						order[45] = 41546
						order[46] = 41547
						order[47] = 41548
						order[48] = 40405
						order[49] = 40406
						order[50] = 40407
						order[51] = 40408
						order[52] = 40928
						order[53] = 40410
						order[54] = 40411
						order[55] = 40412
						order[56] = 40413
						order[57] = 0
						super(40374, 40375, order)
					end

					class NoLegPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40415
							order[1] = 40416
							order[2] = 40417
							order[3] = 0
							super(40414, 40415, order)
						end
					end

					class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40400
							order[1] = 0
							super(40927, 40400, order)
						end
					end

					class NoLegPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41531
							order[1] = 41532
							order[2] = 0
							super(41530, 41531, order)
						end
					end

					class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40409
							order[1] = 0
							super(40928, 40409, order)
						end
					end
				end

				class NoLegPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40419
						order[1] = 40420
						order[2] = 42497
						order[3] = 42498
						order[4] = 42499
						order[5] = 42500
						order[6] = 42501
						order[7] = 42502
						order[8] = 42503
						order[9] = 42488
						order[10] = 42489
						order[11] = 42490
						order[12] = 42491
						order[13] = 42492
						order[14] = 42493
						order[15] = 42494
						order[16] = 40421
						order[17] = 40422
						order[18] = 40423
						order[19] = 40424
						order[20] = 40425
						order[21] = 40426
						order[22] = 40427
						order[23] = 40428
						order[24] = 40429
						order[25] = 40430
						order[26] = 40431
						order[27] = 40432
						order[28] = 40433
						order[29] = 40434
						order[30] = 40435
						order[31] = 40436
						order[32] = 40437
						order[33] = 40438
						order[34] = 40439
						order[35] = 40440
						order[36] = 40441
						order[37] = 40442
						order[38] = 40443
						order[39] = 40444
						order[40] = 40445
						order[41] = 40446
						order[42] = 40447
						order[43] = 0
						super(40418, 40419, order)
					end

					class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42505
							order[1] = 0
							super(42504, 42505, order)
						end
					end

					class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42496
							order[1] = 0
							super(42495, 42496, order)
						end
					end
				end

				class NoLegDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41461
						order[1] = 0
						super(41460, 41461, order)
					end
				end

				class NoLegDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41457
						order[1] = 41458
						order[2] = 41459
						order[3] = 0
						super(41456, 41457, order)
					end
				end

				class NoLegDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41409
						order[1] = 41410
						order[2] = 41411
						order[3] = 41412
						order[4] = 41413
						order[5] = 41414
						order[6] = 41415
						order[7] = 41416
						order[8] = 41417
						order[9] = 41418
						order[10] = 41419
						order[11] = 41420
						order[12] = 41421
						order[13] = 41422
						order[14] = 0
						super(41408, 41409, order)
					end

					class NoLegDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41423
							order[1] = 41424
							order[2] = 41425
							order[3] = 0
							super(41422, 41423, order)
						end

						class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41426
								order[1] = 41427
								order[2] = 41428
								order[3] = 0
								super(41425, 41426, order)
							end
						end
					end
				end
			end

			class NoLegProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 40449
					order[1] = 40450
					order[2] = 40451
					order[3] = 40939
					order[4] = 40453
					order[5] = 40454
					order[6] = 40455
					order[7] = 42506
					order[8] = 42507
					order[9] = 40456
					order[10] = 40457
					order[11] = 40458
					order[12] = 40524
					order[13] = 40525
					order[14] = 40526
					order[15] = 40528
					order[16] = 40529
					order[17] = 40530
					order[18] = 40531
					order[19] = 40532
					order[20] = 40476
					order[21] = 40478
					order[22] = 40479
					order[23] = 40480
					order[24] = 40481
					order[25] = 40482
					order[26] = 40483
					order[27] = 40484
					order[28] = 40485
					order[29] = 40486
					order[30] = 40487
					order[31] = 40488
					order[32] = 40489
					order[33] = 40490
					order[34] = 40491
					order[35] = 40492
					order[36] = 40493
					order[37] = 40494
					order[38] = 40498
					order[39] = 40499
					order[40] = 40501
					order[41] = 40502
					order[42] = 40503
					order[43] = 40504
					order[44] = 40505
					order[45] = 40506
					order[46] = 40507
					order[47] = 40508
					order[48] = 40509
					order[49] = 40511
					order[50] = 40512
					order[51] = 40513
					order[52] = 40514
					order[53] = 40515
					order[54] = 40459
					order[55] = 40460
					order[56] = 40461
					order[57] = 40462
					order[58] = 40463
					order[59] = 40464
					order[60] = 40465
					order[61] = 40516
					order[62] = 40518
					order[63] = 40519
					order[64] = 40520
					order[65] = 40521
					order[66] = 40522
					order[67] = 40523
					order[68] = 40466
					order[69] = 40467
					order[70] = 40468
					order[71] = 40469
					order[72] = 40470
					order[73] = 41407
					order[74] = 40472
					order[75] = 40980
					order[76] = 40981
					order[77] = 40533
					order[78] = 0
					super(40448, 40449, order)
				end

				class NoLegProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40452
						order[1] = 0
						super(40939, 40452, order)
					end
				end

				class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40527
						order[1] = 0
						super(40935, 40527, order)
					end
				end

				class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40477
						order[1] = 0
						super(40936, 40477, order)
					end
				end

				class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40496
						order[1] = 40497
						order[2] = 0
						super(40495, 40496, order)
					end
				end

				class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40500
						order[1] = 0
						super(40937, 40500, order)
					end
				end

				class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40510
						order[1] = 0
						super(40938, 40510, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40517
						order[1] = 0
						super(40934, 40517, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40474
						order[1] = 40475
						order[2] = 0
						super(40473, 40474, order)
					end
				end

				class NoLegProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40534
						order[1] = 40535
						order[2] = 40536
						order[3] = 2380
						order[4] = 40537
						order[5] = 0
						super(40533, 40534, order)
					end

					class NoLegProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40538
							order[1] = 40539
							order[2] = 0
							super(40537, 40538, order)
						end
					end
				end
			end

			class NoLegAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41336
					order[1] = 41337
					order[2] = 41316
					order[3] = 0
					super(41335, 41336, order)
				end

				class NoLegAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41317
						order[1] = 41318
						order[2] = 41319
						order[3] = 41320
						order[4] = 41321
						order[5] = 41322
						order[6] = 41323
						order[7] = 41324
						order[8] = 41325
						order[9] = 41326
						order[10] = 41327
						order[11] = 41328
						order[12] = 41329
						order[13] = 41330
						order[14] = 41331
						order[15] = 41332
						order[16] = 41333
						order[17] = 41334
						order[18] = 0
						super(41316, 41317, order)
					end
				end
			end

			class NoLegProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 41618
					order[1] = 41619
					order[2] = 41620
					order[3] = 41621
					order[4] = 41622
					order[5] = 41623
					order[6] = 41624
					order[7] = 41614
					order[8] = 41625
					order[9] = 41635
					order[10] = 41617
					order[11] = 0
					super(41616, 41618, order)
				end

				class NoLegProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41615
						order[1] = 0
						super(41614, 41615, order)
					end
				end

				class NoLegProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41626
						order[1] = 41627
						order[2] = 41628
						order[3] = 41629
						order[4] = 41630
						order[5] = 41631
						order[6] = 41632
						order[7] = 41633
						order[8] = 0
						super(41625, 41626, order)
					end

					class NoLegProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41634
							order[1] = 0
							super(41633, 41634, order)
						end
					end
				end

				class NoLegProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41636
						order[1] = 41637
						order[2] = 0
						super(41635, 41636, order)
					end
				end
			end

			class NoLegCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 41345
					order[1] = 41346
					order[2] = 41347
					order[3] = 41348
					order[4] = 41349
					order[5] = 41350
					order[6] = 41351
					order[7] = 41352
					order[8] = 41353
					order[9] = 41354
					order[10] = 41355
					order[11] = 41342
					order[12] = 42308
					order[13] = 42309
					order[14] = 41356
					order[15] = 41357
					order[16] = 42299
					order[17] = 42300
					order[18] = 42301
					order[19] = 42302
					order[20] = 42303
					order[21] = 42304
					order[22] = 42305
					order[23] = 41358
					order[24] = 41359
					order[25] = 41360
					order[26] = 41361
					order[27] = 41362
					order[28] = 0
					super(41344, 41345, order)
				end

				class NoLegCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41343
						order[1] = 0
						super(41342, 41343, order)
					end
				end

				class NoLegCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42307
						order[1] = 0
						super(42306, 42307, order)
					end
				end
			end

			class NoLegPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41604
					order[1] = 41601
					order[2] = 41602
					order[3] = 41603
					order[4] = 41600
					order[5] = 0
					super(41599, 41604, order)
				end

				class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41605
						order[1] = 41606
						order[2] = 0
						super(41604, 41605, order)
					end
				end
			end

			class NoLegExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42389
					order[1] = 42390
					order[2] = 0
					super(42388, 42389, order)
				end
			end

			class NoLegStipulations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 688
					order[1] = 689
					order[2] = 0
					super(683, 688, order)
				end
			end

			class NoNestedPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 524
					order[1] = 525
					order[2] = 538
					order[3] = 2384
					order[4] = 804
					order[5] = 0
					super(539, 524, order)
				end

				class NoNestedPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 545
						order[1] = 805
						order[2] = 0
						super(804, 545, order)
					end
				end
			end
		end

		class NoQuoteQualifiers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 695
				order[1] = 0
				super(735, 695, order)
			end
		end

		class NoRegulatoryTradeIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 1903
				order[1] = 1905
				order[2] = 1904
				order[3] = 1906
				order[4] = 2411
				order[5] = 2397
				order[6] = 0
				super(1907, 1903, order)
			end
		end

		class NoPriceQualifiers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 2710
				order[1] = 0
				super(2709, 2710, order)
			end
		end

		class NoPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 448
				order[1] = 447
				order[2] = 452
				order[3] = 2376
				order[4] = 802
				order[5] = 0
				super(453, 448, order)
			end

			class NoPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 523
					order[1] = 803
					order[2] = 0
					super(802, 523, order)
				end
			end
		end
	end
end

class Quote < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("S") )
	end

	class NoQuoteQualifiers < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 695
			order[1] = 0
			super(735, 695, order)
		end
	end

	class NoQuoteAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2707
			order[1] = 2708
			order[2] = 0
			super(2706, 2707, order)
		end
	end

	class NoValueChecks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1869
			order[1] = 1870
			order[2] = 0
			super(1868, 1869, order)
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoRateSources < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1446
			order[1] = 1447
			order[2] = 1448
			order[3] = 2412
			order[4] = 2796
			order[5] = 0
			super(1445, 1446, order)
		end
	end

	class NoStipulations < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 233
			order[1] = 234
			order[2] = 0
			super(232, 233, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(173)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 685
			order[153] = 687
			order[154] = 2346
			order[155] = 690
			order[156] = 587
			order[157] = 588
			order[158] = 683
			order[159] = 539
			order[160] = 686
			order[161] = 681
			order[162] = 684
			order[163] = 676
			order[164] = 2951
			order[165] = 677
			order[166] = 678
			order[167] = 679
			order[168] = 680
			order[169] = 654
			order[170] = 1067
			order[171] = 1068
			order[172] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegStipulations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 688
				order[1] = 689
				order[2] = 0
				super(683, 688, order)
			end
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end

	class NoTrdRegTimestamps < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 769
			order[1] = 770
			order[2] = 771
			order[3] = 2839
			order[4] = 1033
			order[5] = 1034
			order[6] = 1035
			order[7] = 1727
			order[8] = 2831
			order[9] = 2832
			order[10] = 2833
			order[11] = 2834
			order[12] = 0
			super(768, 769, order)
		end
	end

	class NoPriceQualifiers < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2710
			order[1] = 0
			super(2709, 2710, order)
		end
	end

	class NoRelativeValues < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2530
			order[1] = 2531
			order[2] = 2532
			order[3] = 0
			super(2529, 2530, order)
		end
	end

	class NoRoutingIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 216
			order[1] = 217
			order[2] = 0
			super(215, 216, order)
		end
	end
end

class SettlementInstructions < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("T") )
	end

	class NoSettlInst < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(28)
			order[0] = 162
			order[1] = 163
			order[2] = 214
			order[3] = 453
			order[4] = 54
			order[5] = 460
			order[6] = 167
			order[7] = 461
			order[8] = 2891
			order[9] = 120
			order[10] = 2899
			order[11] = 168
			order[12] = 126
			order[13] = 779
			order[14] = 172
			order[15] = 169
			order[16] = 170
			order[17] = 171
			order[18] = 492
			order[19] = 476
			order[20] = 488
			order[21] = 489
			order[22] = 503
			order[23] = 490
			order[24] = 491
			order[25] = 504
			order[26] = 505
			order[27] = 0
			super(778, 162, order)
		end

		class NoPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 448
				order[1] = 447
				order[2] = 452
				order[3] = 2376
				order[4] = 802
				order[5] = 0
				super(453, 448, order)
			end

			class NoPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 523
					order[1] = 803
					order[2] = 0
					super(802, 523, order)
				end
			end
		end

		class NoDlvyInst < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 165
				order[1] = 787
				order[2] = 781
				order[3] = 0
				super(85, 165, order)
			end

			class NoSettlPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 782
					order[1] = 783
					order[2] = 784
					order[3] = 2389
					order[4] = 801
					order[5] = 0
					super(781, 782, order)
				end

				class NoSettlPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 785
						order[1] = 786
						order[2] = 0
						super(801, 785, order)
					end
				end
			end
		end
	end
end

class MarketDataRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("V") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoMDEntryTypes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 269
			order[1] = 0
			super(267, 269, order)
		end
	end

	class NoMarketSegments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1301
			order[1] = 1300
			order[2] = 0
			super(1310, 1301, order)
		end
	end

	class NoRelatedSym < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(201)
			order[0] = 55
			order[1] = 65
			order[2] = 48
			order[3] = 22
			order[4] = 460
			order[5] = 1227
			order[6] = 1151
			order[7] = 461
			order[8] = 2891
			order[9] = 167
			order[10] = 762
			order[11] = 200
			order[12] = 541
			order[13] = 1079
			order[14] = 966
			order[15] = 1049
			order[16] = 965
			order[17] = 224
			order[18] = 1449
			order[19] = 1450
			order[20] = 1451
			order[21] = 1452
			order[22] = 1457
			order[23] = 1458
			order[24] = 1739
			order[25] = 2210
			order[26] = 1938
			order[27] = 1939
			order[28] = 1940
			order[29] = 2735
			order[30] = 1941
			order[31] = 1575
			order[32] = 1942
			order[33] = 1943
			order[34] = 1944
			order[35] = 1945
			order[36] = 1946
			order[37] = 1947
			order[38] = 1948
			order[39] = 1949
			order[40] = 1950
			order[41] = 2879
			order[42] = 1951
			order[43] = 1952
			order[44] = 1953
			order[45] = 1954
			order[46] = 1955
			order[47] = 1956
			order[48] = 1957
			order[49] = 1958
			order[50] = 1959
			order[51] = 1960
			order[52] = 1577
			order[53] = 1580
			order[54] = 1581
			order[55] = 1678
			order[56] = 1697
			order[57] = 225
			order[58] = 239
			order[59] = 226
			order[60] = 227
			order[61] = 228
			order[62] = 255
			order[63] = 543
			order[64] = 470
			order[65] = 471
			order[66] = 472
			order[67] = 240
			order[68] = 202
			order[69] = 2578
			order[70] = 2577
			order[71] = 947
			order[72] = 2904
			order[73] = 967
			order[74] = 968
			order[75] = 1698
			order[76] = 1866
			order[77] = 2600
			order[78] = 2001
			order[79] = 2601
			order[80] = 1478
			order[81] = 1479
			order[82] = 1480
			order[83] = 1481
			order[84] = 206
			order[85] = 231
			order[86] = 1435
			order[87] = 2353
			order[88] = 1439
			order[89] = 969
			order[90] = 1146
			order[91] = 996
			order[92] = 1147
			order[93] = 1716
			order[94] = 2905
			order[95] = 1191
			order[96] = 1192
			order[97] = 1717
			order[98] = 2906
			order[99] = 1193
			order[100] = 2579
			order[101] = 1194
			order[102] = 1482
			order[103] = 1195
			order[104] = 2753
			order[105] = 1196
			order[106] = 1197
			order[107] = 2002
			order[108] = 2140
			order[109] = 1524
			order[110] = 2907
			order[111] = 1198
			order[112] = 1199
			order[113] = 1200
			order[114] = 201
			order[115] = 2681
			order[116] = 2685
			order[117] = 1244
			order[118] = 1242
			order[119] = 2575
			order[120] = 2574
			order[121] = 997
			order[122] = 223
			order[123] = 207
			order[124] = 970
			order[125] = 971
			order[126] = 106
			order[127] = 348
			order[128] = 349
			order[129] = 2737
			order[130] = 2714
			order[131] = 2715
			order[132] = 2716
			order[133] = 107
			order[134] = 350
			order[135] = 351
			order[136] = 691
			order[137] = 667
			order[138] = 875
			order[139] = 876
			order[140] = 873
			order[141] = 874
			order[142] = 1687
			order[143] = 1787
			order[144] = 2141
			order[145] = 2142
			order[146] = 2143
			order[147] = 2752
			order[148] = 2144
			order[149] = 2145
			order[150] = 2576
			order[151] = 2962
			order[152] = 2602
			order[153] = 2603
			order[154] = 668
			order[155] = 869
			order[156] = 2736
			order[157] = 2738
			order[158] = 913
			order[159] = 914
			order[160] = 1961
			order[161] = 915
			order[162] = 918
			order[163] = 2952
			order[164] = 1962
			order[165] = 1963
			order[166] = 1964
			order[167] = 1965
			order[168] = 1966
			order[169] = 1967
			order[170] = 1968
			order[171] = 1969
			order[172] = 1970
			order[173] = 1513
			order[174] = 1525
			order[175] = 1527
			order[176] = 788
			order[177] = 916
			order[178] = 917
			order[179] = 919
			order[180] = 898
			order[181] = 711
			order[182] = 555
			order[183] = 1647
			order[184] = 218
			order[185] = 220
			order[186] = 2950
			order[187] = 221
			order[188] = 222
			order[189] = 662
			order[190] = 663
			order[191] = 699
			order[192] = 761
			order[193] = 15
			order[194] = 2897
			order[195] = 537
			order[196] = 63
			order[197] = 64
			order[198] = 271
			order[199] = 1500
			order[200] = 0
			super(146, 55, order)
		end

		class NoSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 455
				order[1] = 456
				order[2] = 2957
				order[3] = 0
				super(454, 455, order)
			end
		end

		class NoSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1977
				order[1] = 1978
				order[2] = 1979
				order[3] = 2741
				order[4] = 0
				super(1976, 1977, order)
			end
		end

		class NoAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2305
				order[1] = 2306
				order[2] = 2307
				order[3] = 0
				super(2304, 2305, order)
			end
		end

		class NoEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 865
				order[1] = 866
				order[2] = 1145
				order[3] = 1827
				order[4] = 1826
				order[5] = 2340
				order[6] = 867
				order[7] = 868
				order[8] = 1578
				order[9] = 1579
				order[10] = 0
				super(864, 865, order)
			end
		end

		class NoInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1019
				order[1] = 1050
				order[2] = 1051
				order[3] = 2378
				order[4] = 1052
				order[5] = 0
				super(1018, 1019, order)
			end

			class NoInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1053
					order[1] = 1054
					order[2] = 0
					super(1052, 1053, order)
				end
			end
		end

		class NoComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 1484
				order[1] = 2117
				order[2] = 2118
				order[3] = 2119
				order[4] = 1485
				order[5] = 2120
				order[6] = 2121
				order[7] = 2122
				order[8] = 2941
				order[9] = 1486
				order[10] = 2123
				order[11] = 1487
				order[12] = 1488
				order[13] = 1489
				order[14] = 1490
				order[15] = 1491
				order[16] = 2124
				order[17] = 2942
				order[18] = 2125
				order[19] = 2943
				order[20] = 2126
				order[21] = 2127
				order[22] = 2407
				order[23] = 2408
				order[24] = 2128
				order[25] = 2129
				order[26] = 2130
				order[27] = 2131
				order[28] = 2132
				order[29] = 41013
				order[30] = 41020
				order[31] = 41021
				order[32] = 41022
				order[33] = 41023
				order[34] = 41024
				order[35] = 41025
				order[36] = 41026
				order[37] = 41027
				order[38] = 41028
				order[39] = 41010
				order[40] = 2133
				order[41] = 2134
				order[42] = 2135
				order[43] = 2136
				order[44] = 2137
				order[45] = 41029
				order[46] = 40997
				order[47] = 2597
				order[48] = 2598
				order[49] = 2599
				order[50] = 2138
				order[51] = 2139
				order[52] = 0
				super(1483, 1484, order)
			end

			class NoComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1492
					order[1] = 1493
					order[2] = 1494
					order[3] = 0
					super(1491, 1492, order)
				end

				class NoComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1495
						order[1] = 1496
						order[2] = 0
						super(1494, 1495, order)
					end
				end
			end

			class NoComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41014
					order[1] = 41015
					order[2] = 41016
					order[3] = 41017
					order[4] = 0
					super(41013, 41014, order)
				end
			end

			class NoComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41019
					order[1] = 0
					super(41018, 41019, order)
				end
			end

			class NoComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41011
					order[1] = 41012
					order[2] = 41031
					order[3] = 41007
					order[4] = 40994
					order[5] = 0
					super(41010, 41011, order)
				end

				class NoComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41032
						order[1] = 41033
						order[2] = 41034
						order[3] = 41035
						order[4] = 41036
						order[5] = 0
						super(41031, 41032, order)
					end
				end

				class NoComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41008
						order[1] = 41009
						order[2] = 0
						super(41007, 41008, order)
					end
				end

				class NoComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40995
						order[1] = 40996
						order[2] = 0
						super(40994, 40995, order)
					end
				end
			end

			class NoComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41030
					order[1] = 0
					super(41029, 41030, order)
				end
			end

			class NoComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40998
					order[1] = 40999
					order[2] = 41000
					order[3] = 41001
					order[4] = 41002
					order[5] = 41003
					order[6] = 41004
					order[7] = 41005
					order[8] = 0
					super(40997, 40998, order)
				end

				class NoComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41006
						order[1] = 0
						super(41005, 41006, order)
					end
				end
			end
		end

		class NoBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40471
				order[1] = 0
				super(40278, 40471, order)
			end
		end

		class NoPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41231
				order[1] = 0
				super(41230, 41231, order)
			end
		end

		class NoMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41093
				order[1] = 40991
				order[2] = 0
				super(41092, 41093, order)
			end
		end

		class NoMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41095
				order[1] = 40992
				order[2] = 0
				super(41094, 41095, order)
			end
		end

		class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41097
				order[1] = 41098
				order[2] = 41099
				order[3] = 41100
				order[4] = 41101
				order[5] = 41102
				order[6] = 41103
				order[7] = 41104
				order[8] = 41105
				order[9] = 0
				super(41096, 41097, order)
			end
		end

		class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42776
				order[1] = 0
				super(42775, 42776, order)
			end
		end

		class NoOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41117
				order[1] = 0
				super(41116, 41117, order)
			end
		end

		class NoOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41138
				order[1] = 41139
				order[2] = 0
				super(41137, 41138, order)
			end
		end

		class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41141
				order[1] = 0
				super(41140, 41141, order)
			end
		end

		class NoOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41153
				order[1] = 41154
				order[2] = 0
				super(41152, 41153, order)
			end
		end

		class NoStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40050
				order[1] = 41303
				order[2] = 40051
				order[3] = 42784
				order[4] = 42785
				order[5] = 40052
				order[6] = 40053
				order[7] = 41305
				order[8] = 40054
				order[9] = 40055
				order[10] = 42786
				order[11] = 42787
				order[12] = 41306
				order[13] = 41307
				order[14] = 41308
				order[15] = 41309
				order[16] = 41310
				order[17] = 41311
				order[18] = 41251
				order[19] = 41252
				order[20] = 41253
				order[21] = 41254
				order[22] = 41255
				order[23] = 41256
				order[24] = 41257
				order[25] = 42587
				order[26] = 41258
				order[27] = 41259
				order[28] = 41260
				order[29] = 41261
				order[30] = 41262
				order[31] = 41263
				order[32] = 41264
				order[33] = 41265
				order[34] = 41266
				order[35] = 41267
				order[36] = 41268
				order[37] = 41269
				order[38] = 41270
				order[39] = 41271
				order[40] = 41272
				order[41] = 41273
				order[42] = 41274
				order[43] = 41275
				order[44] = 41276
				order[45] = 40907
				order[46] = 40908
				order[47] = 40910
				order[48] = 40911
				order[49] = 40912
				order[50] = 40913
				order[51] = 40914
				order[52] = 40065
				order[53] = 40066
				order[54] = 40068
				order[55] = 40069
				order[56] = 40070
				order[57] = 40071
				order[58] = 40072
				order[59] = 41244
				order[60] = 41245
				order[61] = 40073
				order[62] = 40075
				order[63] = 40076
				order[64] = 40078
				order[65] = 40079
				order[66] = 40080
				order[67] = 40081
				order[68] = 40082
				order[69] = 40083
				order[70] = 40084
				order[71] = 41246
				order[72] = 41247
				order[73] = 41248
				order[74] = 40738
				order[75] = 40739
				order[76] = 40740
				order[77] = 42600
				order[78] = 40741
				order[79] = 40742
				order[80] = 43106
				order[81] = 40743
				order[82] = 40744
				order[83] = 40745
				order[84] = 40746
				order[85] = 40747
				order[86] = 42601
				order[87] = 42602
				order[88] = 42603
				order[89] = 42604
				order[90] = 40748
				order[91] = 40749
				order[92] = 40750
				order[93] = 41180
				order[94] = 41181
				order[95] = 41182
				order[96] = 41183
				order[97] = 41184
				order[98] = 41185
				order[99] = 41186
				order[100] = 42605
				order[101] = 40828
				order[102] = 40872
				order[103] = 41058
				order[104] = 41059
				order[105] = 41060
				order[106] = 41061
				order[107] = 41062
				order[108] = 42192
				order[109] = 42193
				order[110] = 41063
				order[111] = 41064
				order[112] = 41065
				order[113] = 41066
				order[114] = 41067
				order[115] = 41218
				order[116] = 41068
				order[117] = 41069
				order[118] = 41070
				order[119] = 41071
				order[120] = 41072
				order[121] = 41073
				order[122] = 41074
				order[123] = 41075
				order[124] = 41076
				order[125] = 41077
				order[126] = 41078
				order[127] = 41079
				order[128] = 41080
				order[129] = 43094
				order[130] = 41037
				order[131] = 40056
				order[132] = 40982
				order[133] = 40983
				order[134] = 0
				super(40049, 40050, order)
			end

			class NoStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41278
					order[1] = 41279
					order[2] = 0
					super(41277, 41278, order)
				end
			end

			class NoStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41238
					order[1] = 41239
					order[2] = 41240
					order[3] = 0
					super(41237, 41238, order)
				end
			end

			class NoStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41281
					order[1] = 41282
					order[2] = 0
					super(41280, 41281, order)
				end
			end

			class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41250
					order[1] = 0
					super(41249, 41250, order)
				end
			end

			class NoStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41290
					order[1] = 41291
					order[2] = 41292
					order[3] = 41293
					order[4] = 41294
					order[5] = 41295
					order[6] = 41296
					order[7] = 41297
					order[8] = 41298
					order[9] = 41299
					order[10] = 41300
					order[11] = 41283
					order[12] = 41301
					order[13] = 41302
					order[14] = 0
					super(41289, 41290, order)
				end

				class NoStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41284
						order[1] = 41285
						order[2] = 41286
						order[3] = 0
						super(41283, 41284, order)
					end

					class NoStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41287
							order[1] = 41288
							order[2] = 41588
							order[3] = 0
							super(41286, 41287, order)
						end
					end
				end
			end

			class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40909
					order[1] = 0
					super(40960, 40909, order)
				end
			end

			class NoStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40067
					order[1] = 0
					super(40961, 40067, order)
				end
			end

			class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40074
					order[1] = 0
					super(40958, 40074, order)
				end
			end

			class NoStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41242
					order[1] = 41243
					order[2] = 0
					super(41241, 41242, order)
				end
			end

			class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40077
					order[1] = 0
					super(40959, 40077, order)
				end
			end

			class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40752
					order[1] = 0
					super(40947, 40752, order)
				end
			end

			class NoPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41221
					order[1] = 41222
					order[2] = 0
					super(41220, 41221, order)
				end
			end

			class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40763
					order[1] = 0
					super(40948, 40763, order)
				end
			end

			class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40769
					order[1] = 0
					super(40949, 40769, order)
				end
			end

			class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40776
					order[1] = 0
					super(40950, 40776, order)
				end
			end

			class NoPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42661
					order[1] = 42662
					order[2] = 0
					super(42660, 42661, order)
				end
			end

			class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41193
					order[1] = 0
					super(41192, 41193, order)
				end
			end

			class NoPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41228
					order[1] = 41229
					order[2] = 0
					super(41227, 41228, order)
				end
			end

			class NoPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41225
					order[1] = 41226
					order[2] = 0
					super(41224, 41225, order)
				end
			end

			class NoPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43109
					order[1] = 42684
					order[2] = 42685
					order[3] = 0
					super(42683, 43109, order)
				end
			end

			class NoDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42275
					order[1] = 42276
					order[2] = 42277
					order[3] = 42278
					order[4] = 42279
					order[5] = 42280
					order[6] = 42294
					order[7] = 42281
					order[8] = 42282
					order[9] = 42283
					order[10] = 42284
					order[11] = 42285
					order[12] = 42286
					order[13] = 42287
					order[14] = 42288
					order[15] = 42289
					order[16] = 42290
					order[17] = 42291
					order[18] = 42292
					order[19] = 42293
					order[20] = 0
					super(42274, 42275, order)
				end

				class NoDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42295
						order[1] = 0
						super(42294, 42295, order)
					end
				end
			end

			class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42273
					order[1] = 0
					super(42272, 42273, order)
				end
			end

			class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42237
					order[1] = 0
					super(42236, 42237, order)
				end
			end

			class NoReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42736
					order[1] = 42737
					order[2] = 42738
					order[3] = 42739
					order[4] = 42740
					order[5] = 42741
					order[6] = 42765
					order[7] = 42731
					order[8] = 42742
					order[9] = 42743
					order[10] = 42744
					order[11] = 42745
					order[12] = 42746
					order[13] = 42747
					order[14] = 42748
					order[15] = 42749
					order[16] = 42750
					order[17] = 42751
					order[18] = 42752
					order[19] = 42753
					order[20] = 42761
					order[21] = 42754
					order[22] = 42755
					order[23] = 42709
					order[24] = 42756
					order[25] = 42757
					order[26] = 42758
					order[27] = 42759
					order[28] = 42760
					order[29] = 0
					super(42735, 42736, order)
				end

				class NoReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42766
						order[1] = 42767
						order[2] = 42768
						order[3] = 42769
						order[4] = 0
						super(42765, 42766, order)
					end
				end

				class NoReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42732
						order[1] = 42733
						order[2] = 42734
						order[3] = 0
						super(42731, 42732, order)
					end
				end

				class NoReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42762
						order[1] = 42763
						order[2] = 42764
						order[3] = 0
						super(42761, 42762, order)
					end
				end

				class NoReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42710
						order[1] = 42772
						order[2] = 42711
						order[3] = 42712
						order[4] = 42713
						order[5] = 42714
						order[6] = 42715
						order[7] = 42716
						order[8] = 42717
						order[9] = 42718
						order[10] = 42719
						order[11] = 42720
						order[12] = 42721
						order[13] = 42722
						order[14] = 42723
						order[15] = 42724
						order[16] = 42725
						order[17] = 42726
						order[18] = 42727
						order[19] = 42728
						order[20] = 42729
						order[21] = 42730
						order[22] = 42770
						order[23] = 0
						super(42709, 42710, order)
					end

					class NoReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42773
							order[1] = 42774
							order[2] = 0
							super(42772, 42773, order)
						end
					end

					class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42771
							order[1] = 0
							super(42770, 42771, order)
						end
					end
				end
			end

			class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42621
					order[1] = 0
					super(42620, 42621, order)
				end
			end

			class NoPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42607
					order[1] = 42608
					order[2] = 0
					super(42606, 42607, order)
				end
			end

			class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40819
					order[1] = 0
					super(40946, 40819, order)
				end
			end

			class NoNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40826
					order[1] = 40827
					order[2] = 0
					super(40825, 40826, order)
				end
			end

			class NoSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40086
					order[1] = 40373
					order[2] = 40655
					order[3] = 40088
					order[4] = 40089
					order[5] = 0
					super(40085, 40086, order)
				end
			end

			class NoPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40829
					order[1] = 41164
					order[2] = 41165
					order[3] = 40830
					order[4] = 40831
					order[5] = 40832
					order[6] = 40833
					order[7] = 40834
					order[8] = 40835
					order[9] = 40836
					order[10] = 40837
					order[11] = 40838
					order[12] = 40839
					order[13] = 41166
					order[14] = 41167
					order[15] = 41168
					order[16] = 41169
					order[17] = 40840
					order[18] = 40841
					order[19] = 40842
					order[20] = 40843
					order[21] = 41170
					order[22] = 41171
					order[23] = 41172
					order[24] = 41173
					order[25] = 40844
					order[26] = 40845
					order[27] = 40846
					order[28] = 40847
					order[29] = 40848
					order[30] = 40849
					order[31] = 40868
					order[32] = 40850
					order[33] = 40851
					order[34] = 40852
					order[35] = 40853
					order[36] = 40977
					order[37] = 40855
					order[38] = 40856
					order[39] = 40857
					order[40] = 41174
					order[41] = 41175
					order[42] = 40858
					order[43] = 41161
					order[44] = 41176
					order[45] = 41177
					order[46] = 41178
					order[47] = 41179
					order[48] = 40859
					order[49] = 40860
					order[50] = 40861
					order[51] = 40862
					order[52] = 40945
					order[53] = 40864
					order[54] = 40865
					order[55] = 40866
					order[56] = 40867
					order[57] = 0
					super(40828, 40829, order)
				end

				class NoPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40869
						order[1] = 40870
						order[2] = 40871
						order[3] = 0
						super(40868, 40869, order)
					end
				end

				class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40854
						order[1] = 0
						super(40977, 40854, order)
					end
				end

				class NoPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41162
						order[1] = 41163
						order[2] = 0
						super(41161, 41162, order)
					end
				end

				class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40863
						order[1] = 0
						super(40945, 40863, order)
					end
				end
			end

			class NoPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40873
					order[1] = 40874
					order[2] = 42698
					order[3] = 42699
					order[4] = 42700
					order[5] = 42701
					order[6] = 42702
					order[7] = 42703
					order[8] = 42704
					order[9] = 42689
					order[10] = 42690
					order[11] = 42691
					order[12] = 42692
					order[13] = 42693
					order[14] = 42694
					order[15] = 42695
					order[16] = 40875
					order[17] = 40876
					order[18] = 40877
					order[19] = 40878
					order[20] = 40879
					order[21] = 40880
					order[22] = 40881
					order[23] = 40882
					order[24] = 40883
					order[25] = 40884
					order[26] = 40885
					order[27] = 40886
					order[28] = 40887
					order[29] = 40888
					order[30] = 40889
					order[31] = 40890
					order[32] = 40891
					order[33] = 40892
					order[34] = 40893
					order[35] = 40894
					order[36] = 40895
					order[37] = 40896
					order[38] = 40897
					order[39] = 40898
					order[40] = 40899
					order[41] = 40900
					order[42] = 40901
					order[43] = 0
					super(40872, 40873, order)
				end

				class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42706
						order[1] = 0
						super(42705, 42706, order)
					end
				end

				class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42697
						order[1] = 0
						super(42696, 42697, order)
					end
				end
			end

			class NoDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41086
					order[1] = 0
					super(41085, 41086, order)
				end
			end

			class NoDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41082
					order[1] = 41083
					order[2] = 41084
					order[3] = 0
					super(41081, 41082, order)
				end
			end

			class NoDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41038
					order[1] = 41039
					order[2] = 41040
					order[3] = 41041
					order[4] = 41042
					order[5] = 41043
					order[6] = 41044
					order[7] = 41045
					order[8] = 41046
					order[9] = 41047
					order[10] = 41048
					order[11] = 41049
					order[12] = 41050
					order[13] = 41051
					order[14] = 0
					super(41037, 41038, order)
				end

				class NoDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41052
						order[1] = 41053
						order[2] = 41054
						order[3] = 0
						super(41051, 41052, order)
					end

					class NoDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41055
							order[1] = 41056
							order[2] = 41057
							order[3] = 0
							super(41054, 41055, order)
						end
					end
				end
			end
		end

		class NoProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40091
				order[1] = 40092
				order[2] = 40093
				order[3] = 40957
				order[4] = 40095
				order[5] = 40096
				order[6] = 40097
				order[7] = 42707
				order[8] = 42708
				order[9] = 40098
				order[10] = 40099
				order[11] = 40100
				order[12] = 40114
				order[13] = 40115
				order[14] = 40116
				order[15] = 40118
				order[16] = 40119
				order[17] = 40120
				order[18] = 40121
				order[19] = 40122
				order[20] = 40123
				order[21] = 40125
				order[22] = 40126
				order[23] = 40127
				order[24] = 40128
				order[25] = 40129
				order[26] = 40130
				order[27] = 40131
				order[28] = 40132
				order[29] = 40133
				order[30] = 40134
				order[31] = 40135
				order[32] = 40136
				order[33] = 40137
				order[34] = 40138
				order[35] = 40139
				order[36] = 40140
				order[37] = 40141
				order[38] = 40145
				order[39] = 40146
				order[40] = 40148
				order[41] = 40149
				order[42] = 40150
				order[43] = 40151
				order[44] = 40152
				order[45] = 40153
				order[46] = 40154
				order[47] = 40155
				order[48] = 40156
				order[49] = 40158
				order[50] = 40159
				order[51] = 40160
				order[52] = 40161
				order[53] = 40162
				order[54] = 40101
				order[55] = 40102
				order[56] = 40103
				order[57] = 40104
				order[58] = 40105
				order[59] = 40106
				order[60] = 40107
				order[61] = 40163
				order[62] = 40165
				order[63] = 40166
				order[64] = 40167
				order[65] = 40168
				order[66] = 40169
				order[67] = 40170
				order[68] = 40108
				order[69] = 40109
				order[70] = 40110
				order[71] = 40111
				order[72] = 40112
				order[73] = 41406
				order[74] = 40113
				order[75] = 40986
				order[76] = 40987
				order[77] = 40174
				order[78] = 0
				super(40090, 40091, order)
			end

			class NoProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40094
					order[1] = 0
					super(40957, 40094, order)
				end
			end

			class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40117
					order[1] = 0
					super(40953, 40117, order)
				end
			end

			class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40124
					order[1] = 0
					super(40954, 40124, order)
				end
			end

			class NoProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40143
					order[1] = 40144
					order[2] = 0
					super(40142, 40143, order)
				end
			end

			class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40147
					order[1] = 0
					super(40955, 40147, order)
				end
			end

			class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40157
					order[1] = 0
					super(40956, 40157, order)
				end
			end

			class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40164
					order[1] = 0
					super(40952, 40164, order)
				end
			end

			class NoProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40172
					order[1] = 40173
					order[2] = 0
					super(40171, 40172, order)
				end
			end

			class NoProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40175
					order[1] = 40176
					order[2] = 40177
					order[3] = 2385
					order[4] = 40178
					order[5] = 0
					super(40174, 40175, order)
				end

				class NoProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40179
						order[1] = 40180
						order[2] = 0
						super(40178, 40179, order)
					end
				end
			end
		end

		class NoAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40020
				order[1] = 40021
				order[2] = 40000
				order[3] = 0
				super(40019, 40020, order)
			end

			class NoAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 40001
					order[1] = 40002
					order[2] = 40003
					order[3] = 40004
					order[4] = 40005
					order[5] = 40006
					order[6] = 40007
					order[7] = 40008
					order[8] = 40009
					order[9] = 40010
					order[10] = 40011
					order[11] = 40012
					order[12] = 40013
					order[13] = 40014
					order[14] = 40015
					order[15] = 40016
					order[16] = 40017
					order[17] = 40018
					order[18] = 0
					super(40000, 40001, order)
				end
			end
		end

		class NoProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 40182
				order[1] = 40183
				order[2] = 40184
				order[3] = 40185
				order[4] = 40186
				order[5] = 40187
				order[6] = 40188
				order[7] = 40951
				order[8] = 40191
				order[9] = 40201
				order[10] = 40190
				order[11] = 0
				super(40181, 40182, order)
			end

			class NoProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40189
					order[1] = 0
					super(40951, 40189, order)
				end
			end

			class NoProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40192
					order[1] = 40193
					order[2] = 40194
					order[3] = 40195
					order[4] = 40196
					order[5] = 40197
					order[6] = 40198
					order[7] = 40199
					order[8] = 0
					super(40191, 40192, order)
				end

				class NoProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40200
						order[1] = 0
						super(40199, 40200, order)
					end
				end
			end

			class NoProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40202
					order[1] = 40203
					order[2] = 0
					super(40201, 40202, order)
				end
			end
		end

		class NoCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 40023
				order[1] = 40024
				order[2] = 40916
				order[3] = 40917
				order[4] = 40025
				order[5] = 40026
				order[6] = 40027
				order[7] = 40028
				order[8] = 40029
				order[9] = 40030
				order[10] = 40031
				order[11] = 40277
				order[12] = 42216
				order[13] = 42217
				order[14] = 40033
				order[15] = 40034
				order[16] = 42207
				order[17] = 42208
				order[18] = 42209
				order[19] = 42210
				order[20] = 42211
				order[21] = 42212
				order[22] = 42213
				order[23] = 40035
				order[24] = 40036
				order[25] = 40037
				order[26] = 40038
				order[27] = 40039
				order[28] = 0
				super(40022, 40023, order)
			end

			class NoCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40032
					order[1] = 0
					super(40277, 40032, order)
				end
			end

			class NoCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42215
					order[1] = 0
					super(42214, 42215, order)
				end
			end
		end

		class NoPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40209
				order[1] = 40205
				order[2] = 40206
				order[3] = 40207
				order[4] = 40208
				order[5] = 0
				super(40204, 40209, order)
			end

			class NoPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40210
					order[1] = 40211
					order[2] = 0
					super(40209, 40210, order)
				end
			end
		end

		class NoExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42297
				order[1] = 42298
				order[2] = 0
				super(42296, 42297, order)
			end
		end

		class NoInstrAttrib < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 871
				order[1] = 872
				order[2] = 0
				super(870, 871, order)
			end
		end

		class NoIndexRollMonths < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 2733
				order[1] = 0
				super(2734, 2733, order)
			end
		end

		class NoReferenceDataDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2747
				order[1] = 2748
				order[2] = 0
				super(2746, 2747, order)
			end
		end

		class NoContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40041
				order[1] = 0
				super(40040, 40041, order)
			end
		end

		class NoFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40047
				order[1] = 40048
				order[2] = 0
				super(40046, 40047, order)
			end
		end

		class NoContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40043
				order[1] = 40044
				order[2] = 40045
				order[3] = 0
				super(40042, 40043, order)
			end
		end

		class NoUnderlyings < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(188)
				order[0] = 311
				order[1] = 312
				order[2] = 309
				order[3] = 305
				order[4] = 2874
				order[5] = 462
				order[6] = 463
				order[7] = 2894
				order[8] = 310
				order[9] = 763
				order[10] = 313
				order[11] = 542
				order[12] = 1213
				order[13] = 1837
				order[14] = 241
				order[15] = 1453
				order[16] = 1454
				order[17] = 2614
				order[18] = 2615
				order[19] = 2921
				order[20] = 2616
				order[21] = 2617
				order[22] = 2619
				order[23] = 1455
				order[24] = 1456
				order[25] = 1459
				order[26] = 1460
				order[27] = 242
				order[28] = 243
				order[29] = 244
				order[30] = 245
				order[31] = 246
				order[32] = 256
				order[33] = 595
				order[34] = 592
				order[35] = 593
				order[36] = 594
				order[37] = 247
				order[38] = 316
				order[39] = 941
				order[40] = 2917
				order[41] = 317
				order[42] = 436
				order[43] = 1437
				order[44] = 2363
				order[45] = 1441
				order[46] = 998
				order[47] = 1423
				order[48] = 1718
				order[49] = 2918
				order[50] = 1424
				order[51] = 1425
				order[52] = 1719
				order[53] = 2919
				order[54] = 1000
				order[55] = 1419
				order[56] = 1526
				order[57] = 2920
				order[58] = 435
				order[59] = 308
				order[60] = 306
				order[61] = 362
				order[62] = 363
				order[63] = 2742
				order[64] = 2720
				order[65] = 2721
				order[66] = 2722
				order[67] = 2723
				order[68] = 2724
				order[69] = 307
				order[70] = 364
				order[71] = 365
				order[72] = 877
				order[73] = 878
				order[74] = 972
				order[75] = 318
				order[76] = 2916
				order[77] = 879
				order[78] = 975
				order[79] = 973
				order[80] = 974
				order[81] = 810
				order[82] = 882
				order[83] = 883
				order[84] = 884
				order[85] = 885
				order[86] = 886
				order[87] = 2885
				order[88] = 2886
				order[89] = 1044
				order[90] = 1045
				order[91] = 1046
				order[92] = 1038
				order[93] = 1039
				order[94] = 315
				order[95] = 2683
				order[96] = 2687
				order[97] = 1988
				order[98] = 1989
				order[99] = 1990
				order[100] = 1991
				order[101] = 1992
				order[102] = 1993
				order[103] = 2881
				order[104] = 1994
				order[105] = 1995
				order[106] = 1996
				order[107] = 1997
				order[108] = 2620
				order[109] = 2621
				order[110] = 1998
				order[111] = 1999
				order[112] = 2000
				order[113] = 2003
				order[114] = 2004
				order[115] = 2005
				order[116] = 2006
				order[117] = 2284
				order[118] = 2285
				order[119] = 2286
				order[120] = 2287
				order[121] = 2288
				order[122] = 2007
				order[123] = 2008
				order[124] = 2009
				order[125] = 2010
				order[126] = 2011
				order[127] = 2012
				order[128] = 2491
				order[129] = 2013
				order[130] = 2014
				order[131] = 2015
				order[132] = 2744
				order[133] = 2016
				order[134] = 2289
				order[135] = 2017
				order[136] = 2018
				order[137] = 2019
				order[138] = 2020
				order[139] = 2021
				order[140] = 2022
				order[141] = 2290
				order[142] = 2622
				order[143] = 2291
				order[144] = 2623
				order[145] = 2292
				order[146] = 2023
				order[147] = 2024
				order[148] = 2025
				order[149] = 2026
				order[150] = 2027
				order[151] = 2028
				order[152] = 2029
				order[153] = 2757
				order[154] = 2030
				order[155] = 2031
				order[156] = 2293
				order[157] = 2294
				order[158] = 2032
				order[159] = 2033
				order[160] = 2034
				order[161] = 2035
				order[162] = 2036
				order[163] = 2037
				order[164] = 2038
				order[165] = 2039
				order[166] = 2040
				order[167] = 2041
				order[168] = 2042
				order[169] = 2043
				order[170] = 2044
				order[171] = 41314
				order[172] = 41315
				order[173] = 2295
				order[174] = 2296
				order[175] = 2297
				order[176] = 2756
				order[177] = 2298
				order[178] = 2299
				order[179] = 2624
				order[180] = 2625
				order[181] = 2626
				order[182] = 2627
				order[183] = 2628
				order[184] = 2629
				order[185] = 2630
				order[186] = 2631
				order[187] = 0
				super(711, 311, order)
			end

			class NoUnderlyingSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 458
					order[1] = 459
					order[2] = 2959
					order[3] = 0
					super(457, 458, order)
				end
			end

			class NoUnderlyingStips < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 888
					order[1] = 889
					order[2] = 0
					super(887, 888, order)
				end
			end

			class NoUndlyInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 1059
					order[1] = 1060
					order[2] = 1061
					order[3] = 2391
					order[4] = 1062
					order[5] = 0
					super(1058, 1059, order)
				end

				class NoUndlyInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1063
						order[1] = 1064
						order[2] = 0
						super(1062, 1063, order)
					end
				end
			end

			class NoUnderlyingEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 1982
					order[1] = 1983
					order[2] = 1984
					order[3] = 1985
					order[4] = 1986
					order[5] = 2342
					order[6] = 1987
					order[7] = 2071
					order[8] = 2072
					order[9] = 2073
					order[10] = 0
					super(1981, 1982, order)
				end
			end

			class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2081
					order[1] = 2082
					order[2] = 2083
					order[3] = 2745
					order[4] = 0
					super(2080, 2081, order)
				end
			end

			class NoUnderlyingAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2313
					order[1] = 2314
					order[2] = 2315
					order[3] = 0
					super(2312, 2313, order)
				end
			end

			class NoUnderlyingComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2046
					order[1] = 2261
					order[2] = 2262
					order[3] = 2263
					order[4] = 2047
					order[5] = 2264
					order[6] = 2265
					order[7] = 2266
					order[8] = 2947
					order[9] = 2048
					order[10] = 2267
					order[11] = 2049
					order[12] = 2050
					order[13] = 2051
					order[14] = 2052
					order[15] = 2053
					order[16] = 2268
					order[17] = 2948
					order[18] = 2269
					order[19] = 2949
					order[20] = 2270
					order[21] = 2271
					order[22] = 2419
					order[23] = 2420
					order[24] = 2272
					order[25] = 2273
					order[26] = 2274
					order[27] = 2275
					order[28] = 2276
					order[29] = 41732
					order[30] = 41739
					order[31] = 41740
					order[32] = 41741
					order[33] = 41742
					order[34] = 41743
					order[35] = 41744
					order[36] = 41745
					order[37] = 41746
					order[38] = 41747
					order[39] = 41729
					order[40] = 2277
					order[41] = 2278
					order[42] = 2279
					order[43] = 2280
					order[44] = 2281
					order[45] = 41748
					order[46] = 41716
					order[47] = 2611
					order[48] = 2612
					order[49] = 2613
					order[50] = 2282
					order[51] = 2283
					order[52] = 0
					super(2045, 2046, order)
				end

				class NoUnderlyingComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2054
						order[1] = 2055
						order[2] = 2056
						order[3] = 0
						super(2053, 2054, order)
					end

					class NoUnderlyingComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2057
							order[1] = 2058
							order[2] = 0
							super(2056, 2057, order)
						end
					end
				end

				class NoUnderlyingComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41733
						order[1] = 41734
						order[2] = 41735
						order[3] = 41736
						order[4] = 0
						super(41732, 41733, order)
					end
				end

				class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41738
						order[1] = 0
						super(41737, 41738, order)
					end
				end

				class NoUnderlyingComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41730
						order[1] = 41731
						order[2] = 41750
						order[3] = 41726
						order[4] = 41713
						order[5] = 0
						super(41729, 41730, order)
					end

					class NoUnderlyingComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41751
							order[1] = 41752
							order[2] = 41753
							order[3] = 41754
							order[4] = 41755
							order[5] = 0
							super(41750, 41751, order)
						end
					end

					class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41727
							order[1] = 41728
							order[2] = 0
							super(41726, 41727, order)
						end
					end

					class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41714
							order[1] = 41715
							order[2] = 0
							super(41713, 41714, order)
						end
					end
				end

				class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41749
						order[1] = 0
						super(41748, 41749, order)
					end
				end

				class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41717
						order[1] = 41718
						order[2] = 41719
						order[3] = 41720
						order[4] = 41721
						order[5] = 41722
						order[6] = 41723
						order[7] = 41724
						order[8] = 0
						super(41716, 41717, order)
					end

					class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41725
							order[1] = 0
							super(41724, 41725, order)
						end
					end
				end
			end

			class NoUnderlyingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40963
					order[1] = 0
					super(40962, 40963, order)
				end
			end

			class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41948
					order[1] = 0
					super(41947, 41948, order)
				end
			end

			class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41865
					order[1] = 41338
					order[2] = 0
					super(41864, 41865, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41867
					order[1] = 41339
					order[2] = 0
					super(41866, 41867, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41869
					order[1] = 41870
					order[2] = 41871
					order[3] = 41872
					order[4] = 41873
					order[5] = 41874
					order[6] = 41875
					order[7] = 41876
					order[8] = 41877
					order[9] = 0
					super(41868, 41869, order)
				end
			end

			class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 43075
					order[1] = 0
					super(43074, 43075, order)
				end
			end

			class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41821
					order[1] = 0
					super(41820, 41821, order)
				end
			end

			class NoUnderlyingOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41842
					order[1] = 41843
					order[2] = 0
					super(41841, 41842, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41845
					order[1] = 0
					super(41844, 41845, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41857
					order[1] = 41858
					order[2] = 0
					super(41856, 41857, order)
				end
			end

			class NoUnderlyingStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40541
					order[1] = 42016
					order[2] = 40542
					order[3] = 43083
					order[4] = 43084
					order[5] = 40543
					order[6] = 40544
					order[7] = 42018
					order[8] = 40545
					order[9] = 40546
					order[10] = 43085
					order[11] = 43086
					order[12] = 42019
					order[13] = 42020
					order[14] = 42021
					order[15] = 42022
					order[16] = 42023
					order[17] = 42024
					order[18] = 41964
					order[19] = 41965
					order[20] = 41966
					order[21] = 41967
					order[22] = 41968
					order[23] = 41969
					order[24] = 41970
					order[25] = 42589
					order[26] = 41971
					order[27] = 41972
					order[28] = 41973
					order[29] = 41974
					order[30] = 41975
					order[31] = 41976
					order[32] = 41977
					order[33] = 41978
					order[34] = 41979
					order[35] = 41980
					order[36] = 41981
					order[37] = 41982
					order[38] = 41983
					order[39] = 41984
					order[40] = 41985
					order[41] = 41986
					order[42] = 41987
					order[43] = 41988
					order[44] = 41989
					order[45] = 40057
					order[46] = 40058
					order[47] = 40060
					order[48] = 40061
					order[49] = 40062
					order[50] = 40063
					order[51] = 40064
					order[52] = 40548
					order[53] = 40549
					order[54] = 40551
					order[55] = 40552
					order[56] = 40553
					order[57] = 40554
					order[58] = 40555
					order[59] = 41957
					order[60] = 41958
					order[61] = 40556
					order[62] = 40558
					order[63] = 40559
					order[64] = 40561
					order[65] = 40562
					order[66] = 40563
					order[67] = 40564
					order[68] = 40565
					order[69] = 40566
					order[70] = 40567
					order[71] = 41959
					order[72] = 41960
					order[73] = 41961
					order[74] = 40568
					order[75] = 40569
					order[76] = 40570
					order[77] = 42895
					order[78] = 40571
					order[79] = 40572
					order[80] = 43107
					order[81] = 40573
					order[82] = 40574
					order[83] = 40575
					order[84] = 40576
					order[85] = 40577
					order[86] = 42896
					order[87] = 42897
					order[88] = 42898
					order[89] = 42899
					order[90] = 40578
					order[91] = 40579
					order[92] = 40580
					order[93] = 41897
					order[94] = 41898
					order[95] = 41899
					order[96] = 41900
					order[97] = 41901
					order[98] = 41902
					order[99] = 41903
					order[100] = 42900
					order[101] = 40664
					order[102] = 40708
					order[103] = 41777
					order[104] = 41778
					order[105] = 41779
					order[106] = 41780
					order[107] = 41781
					order[108] = 42196
					order[109] = 42197
					order[110] = 41782
					order[111] = 41783
					order[112] = 41784
					order[113] = 41785
					order[114] = 41786
					order[115] = 41587
					order[116] = 41787
					order[117] = 41788
					order[118] = 41789
					order[119] = 41790
					order[120] = 41791
					order[121] = 41792
					order[122] = 41793
					order[123] = 41794
					order[124] = 41795
					order[125] = 41796
					order[126] = 41797
					order[127] = 41798
					order[128] = 41799
					order[129] = 43096
					order[130] = 41756
					order[131] = 40547
					order[132] = 40988
					order[133] = 40989
					order[134] = 0
					super(40540, 40541, order)
				end

				class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41991
						order[1] = 41992
						order[2] = 0
						super(41990, 41991, order)
					end
				end

				class NoUnderlyingStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41801
						order[1] = 41802
						order[2] = 41803
						order[3] = 0
						super(41800, 41801, order)
					end
				end

				class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41994
						order[1] = 41995
						order[2] = 0
						super(41993, 41994, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41963
						order[1] = 0
						super(41962, 41963, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 42003
						order[1] = 42004
						order[2] = 42005
						order[3] = 42006
						order[4] = 42007
						order[5] = 42008
						order[6] = 42009
						order[7] = 42010
						order[8] = 42011
						order[9] = 42012
						order[10] = 42013
						order[11] = 41996
						order[12] = 42014
						order[13] = 42015
						order[14] = 0
						super(42002, 42003, order)
					end

					class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41997
							order[1] = 41998
							order[2] = 41999
							order[3] = 0
							super(41996, 41997, order)
						end

						class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 42000
								order[1] = 42001
								order[2] = 41936
								order[3] = 0
								super(41999, 42000, order)
							end
						end
					end
				end

				class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40059
						order[1] = 0
						super(40975, 40059, order)
					end
				end

				class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40550
						order[1] = 0
						super(40976, 40550, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40557
						order[1] = 0
						super(40973, 40557, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41955
						order[1] = 41956
						order[2] = 0
						super(41954, 41955, order)
					end
				end

				class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40560
						order[1] = 0
						super(40974, 40560, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40582
						order[1] = 0
						super(40969, 40582, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41938
						order[1] = 41939
						order[2] = 0
						super(41937, 41938, order)
					end
				end

				class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40594
						order[1] = 0
						super(40970, 40594, order)
					end
				end

				class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40600
						order[1] = 0
						super(40971, 40600, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40607
						order[1] = 0
						super(40972, 40607, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42956
						order[1] = 42957
						order[2] = 0
						super(42955, 42956, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41910
						order[1] = 0
						super(41909, 41910, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41945
						order[1] = 41946
						order[2] = 0
						super(41944, 41945, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41942
						order[1] = 41943
						order[2] = 0
						super(41941, 41942, order)
					end
				end

				class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43111
						order[1] = 42982
						order[2] = 42983
						order[3] = 0
						super(42981, 43111, order)
					end
				end

				class NoUnderlyingDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42863
						order[1] = 42864
						order[2] = 42865
						order[3] = 42866
						order[4] = 42867
						order[5] = 42868
						order[6] = 42882
						order[7] = 42869
						order[8] = 42870
						order[9] = 42871
						order[10] = 42872
						order[11] = 42873
						order[12] = 42874
						order[13] = 42875
						order[14] = 42876
						order[15] = 42877
						order[16] = 42878
						order[17] = 42879
						order[18] = 42880
						order[19] = 42881
						order[20] = 0
						super(42862, 42863, order)
					end

					class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42883
							order[1] = 0
							super(42882, 42883, order)
						end
					end
				end

				class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42854
						order[1] = 0
						super(42853, 42854, order)
					end
				end

				class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42800
						order[1] = 0
						super(42799, 42800, order)
					end
				end

				class NoUnderlyingReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 43035
						order[1] = 43036
						order[2] = 43037
						order[3] = 43038
						order[4] = 43039
						order[5] = 43040
						order[6] = 43064
						order[7] = 43030
						order[8] = 43041
						order[9] = 43042
						order[10] = 43043
						order[11] = 43044
						order[12] = 43045
						order[13] = 43046
						order[14] = 43047
						order[15] = 43048
						order[16] = 43049
						order[17] = 43050
						order[18] = 43051
						order[19] = 43052
						order[20] = 43060
						order[21] = 43053
						order[22] = 43054
						order[23] = 43008
						order[24] = 43055
						order[25] = 43056
						order[26] = 43057
						order[27] = 43058
						order[28] = 43059
						order[29] = 0
						super(43034, 43035, order)
					end

					class NoUnderlyingReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 43065
							order[1] = 43066
							order[2] = 43067
							order[3] = 43068
							order[4] = 0
							super(43064, 43065, order)
						end
					end

					class NoUnderlyingReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43031
							order[1] = 43032
							order[2] = 43033
							order[3] = 0
							super(43030, 43031, order)
						end
					end

					class NoUnderlyingReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43061
							order[1] = 43062
							order[2] = 43063
							order[3] = 0
							super(43060, 43061, order)
						end
					end

					class NoUnderlyingReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 43009
							order[1] = 43071
							order[2] = 43010
							order[3] = 43011
							order[4] = 43012
							order[5] = 43013
							order[6] = 43014
							order[7] = 43015
							order[8] = 43016
							order[9] = 43017
							order[10] = 43018
							order[11] = 43019
							order[12] = 43020
							order[13] = 43021
							order[14] = 43022
							order[15] = 43023
							order[16] = 43024
							order[17] = 43025
							order[18] = 43026
							order[19] = 43027
							order[20] = 43028
							order[21] = 43029
							order[22] = 43069
							order[23] = 0
							super(43008, 43009, order)
						end

						class NoUnderlyingReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 43072
								order[1] = 43073
								order[2] = 0
								super(43071, 43072, order)
							end
						end

						class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 43070
								order[1] = 0
								super(43069, 43070, order)
							end
						end
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42916
						order[1] = 0
						super(42915, 42916, order)
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42902
						order[1] = 42903
						order[2] = 0
						super(42901, 42902, order)
					end
				end

				class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40650
						order[1] = 0
						super(40968, 40650, order)
					end
				end

				class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40657
						order[1] = 40658
						order[2] = 0
						super(40656, 40657, order)
					end
				end

				class NoUnderlyingSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40660
						order[1] = 40904
						order[2] = 40915
						order[3] = 40662
						order[4] = 40663
						order[5] = 0
						super(40659, 40660, order)
					end
				end

				class NoUnderlyingPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40665
						order[1] = 41881
						order[2] = 41882
						order[3] = 40666
						order[4] = 40667
						order[5] = 40668
						order[6] = 40669
						order[7] = 40670
						order[8] = 40671
						order[9] = 40672
						order[10] = 40673
						order[11] = 40674
						order[12] = 40675
						order[13] = 41883
						order[14] = 41884
						order[15] = 41885
						order[16] = 41886
						order[17] = 40676
						order[18] = 40677
						order[19] = 40678
						order[20] = 40679
						order[21] = 41887
						order[22] = 41888
						order[23] = 41889
						order[24] = 41890
						order[25] = 40680
						order[26] = 40681
						order[27] = 40682
						order[28] = 40683
						order[29] = 40684
						order[30] = 40685
						order[31] = 40704
						order[32] = 40686
						order[33] = 40687
						order[34] = 40688
						order[35] = 40689
						order[36] = 40966
						order[37] = 40691
						order[38] = 40692
						order[39] = 40693
						order[40] = 41891
						order[41] = 41892
						order[42] = 40694
						order[43] = 41878
						order[44] = 41893
						order[45] = 41894
						order[46] = 41895
						order[47] = 41896
						order[48] = 40695
						order[49] = 40696
						order[50] = 40697
						order[51] = 40698
						order[52] = 40967
						order[53] = 40700
						order[54] = 40701
						order[55] = 40702
						order[56] = 40703
						order[57] = 0
						super(40664, 40665, order)
					end

					class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40705
							order[1] = 40706
							order[2] = 40707
							order[3] = 0
							super(40704, 40705, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40690
							order[1] = 0
							super(40966, 40690, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41879
							order[1] = 41880
							order[2] = 0
							super(41878, 41879, order)
						end
					end

					class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40699
							order[1] = 0
							super(40967, 40699, order)
						end
					end
				end

				class NoUnderlyingPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40709
						order[1] = 40710
						order[2] = 42993
						order[3] = 42994
						order[4] = 42995
						order[5] = 42996
						order[6] = 42997
						order[7] = 42998
						order[8] = 42999
						order[9] = 42984
						order[10] = 42985
						order[11] = 42986
						order[12] = 42987
						order[13] = 42988
						order[14] = 42989
						order[15] = 42990
						order[16] = 40711
						order[17] = 40712
						order[18] = 40713
						order[19] = 40714
						order[20] = 40715
						order[21] = 40716
						order[22] = 40717
						order[23] = 40718
						order[24] = 40719
						order[25] = 40720
						order[26] = 40721
						order[27] = 40722
						order[28] = 40723
						order[29] = 40724
						order[30] = 40725
						order[31] = 40726
						order[32] = 40727
						order[33] = 40728
						order[34] = 40729
						order[35] = 40730
						order[36] = 40731
						order[37] = 40732
						order[38] = 40733
						order[39] = 40734
						order[40] = 40735
						order[41] = 40736
						order[42] = 40737
						order[43] = 0
						super(40708, 40709, order)
					end

					class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43001
							order[1] = 0
							super(43000, 43001, order)
						end
					end

					class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42992
							order[1] = 0
							super(42991, 42992, order)
						end
					end
				end

				class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41809
						order[1] = 0
						super(41808, 41809, order)
					end
				end

				class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41805
						order[1] = 41806
						order[2] = 41807
						order[3] = 0
						super(41804, 41805, order)
					end
				end

				class NoUnderlyingDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41757
						order[1] = 41758
						order[2] = 41759
						order[3] = 41760
						order[4] = 41761
						order[5] = 41762
						order[6] = 41763
						order[7] = 41764
						order[8] = 41765
						order[9] = 41766
						order[10] = 41767
						order[11] = 41768
						order[12] = 41769
						order[13] = 41770
						order[14] = 0
						super(41756, 41757, order)
					end

					class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41771
							order[1] = 41772
							order[2] = 41773
							order[3] = 0
							super(41770, 41771, order)
						end

						class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41774
								order[1] = 41775
								order[2] = 41776
								order[3] = 0
								super(41773, 41774, order)
							end
						end
					end
				end
			end

			class NoUnderlyingProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 42150
					order[1] = 42151
					order[2] = 42152
					order[3] = 42190
					order[4] = 42153
					order[5] = 42154
					order[6] = 42155
					order[7] = 43002
					order[8] = 43003
					order[9] = 42156
					order[10] = 42157
					order[11] = 42158
					order[12] = 42104
					order[13] = 42105
					order[14] = 42106
					order[15] = 42107
					order[16] = 42108
					order[17] = 42109
					order[18] = 42110
					order[19] = 42111
					order[20] = 42115
					order[21] = 42116
					order[22] = 42117
					order[23] = 42118
					order[24] = 42119
					order[25] = 42120
					order[26] = 42121
					order[27] = 42122
					order[28] = 42123
					order[29] = 42124
					order[30] = 42125
					order[31] = 42126
					order[32] = 42127
					order[33] = 42128
					order[34] = 42129
					order[35] = 42130
					order[36] = 42131
					order[37] = 42132
					order[38] = 42133
					order[39] = 42134
					order[40] = 42135
					order[41] = 42136
					order[42] = 42137
					order[43] = 42138
					order[44] = 42139
					order[45] = 42140
					order[46] = 42141
					order[47] = 42142
					order[48] = 42143
					order[49] = 42144
					order[50] = 42145
					order[51] = 42146
					order[52] = 42147
					order[53] = 42148
					order[54] = 42159
					order[55] = 42160
					order[56] = 42161
					order[57] = 42162
					order[58] = 42163
					order[59] = 42164
					order[60] = 42165
					order[61] = 42092
					order[62] = 42093
					order[63] = 42094
					order[64] = 42095
					order[65] = 42096
					order[66] = 42097
					order[67] = 42098
					order[68] = 42166
					order[69] = 42167
					order[70] = 42168
					order[71] = 42169
					order[72] = 42102
					order[73] = 42103
					order[74] = 42170
					order[75] = 42171
					order[76] = 42172
					order[77] = 42173
					order[78] = 0
					super(42149, 42150, order)
				end

				class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42191
						order[1] = 0
						super(42190, 42191, order)
					end
				end

				class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42183
						order[1] = 0
						super(42182, 42183, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42185
						order[1] = 0
						super(42184, 42185, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42113
						order[1] = 42114
						order[2] = 0
						super(42112, 42113, order)
					end
				end

				class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42187
						order[1] = 0
						super(42186, 42187, order)
					end
				end

				class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42189
						order[1] = 0
						super(42188, 42189, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42181
						order[1] = 0
						super(42180, 42181, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42100
						order[1] = 42101
						order[2] = 0
						super(42099, 42100, order)
					end
				end

				class NoUnderlyingProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 42174
						order[1] = 42175
						order[2] = 42176
						order[3] = 40918
						order[4] = 42177
						order[5] = 0
						super(42173, 42174, order)
					end

					class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42178
							order[1] = 42179
							order[2] = 0
							super(42177, 42178, order)
						end
					end
				end
			end

			class NoUnderlyingAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42037
					order[1] = 42038
					order[2] = 41340
					order[3] = 0
					super(42036, 42037, order)
				end

				class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41341
						order[1] = 41701
						order[2] = 41709
						order[3] = 41710
						order[4] = 41711
						order[5] = 41712
						order[6] = 42017
						order[7] = 42025
						order[8] = 42026
						order[9] = 42027
						order[10] = 42028
						order[11] = 42029
						order[12] = 42030
						order[13] = 42031
						order[14] = 42032
						order[15] = 42033
						order[16] = 42034
						order[17] = 42035
						order[18] = 0
						super(41340, 41341, order)
					end
				end
			end

			class NoUnderlyingProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 42069
					order[1] = 42070
					order[2] = 42071
					order[3] = 42072
					order[4] = 42073
					order[5] = 42074
					order[6] = 42075
					order[7] = 42090
					order[8] = 42077
					order[9] = 42087
					order[10] = 42076
					order[11] = 0
					super(42068, 42069, order)
				end

				class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42091
						order[1] = 0
						super(42090, 42091, order)
					end
				end

				class NoUnderlyingProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 42078
						order[1] = 42079
						order[2] = 42080
						order[3] = 42081
						order[4] = 42082
						order[5] = 42083
						order[6] = 42084
						order[7] = 42085
						order[8] = 0
						super(42077, 42078, order)
					end

					class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42086
							order[1] = 0
							super(42085, 42086, order)
						end
					end
				end

				class NoUnderlyingProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42088
						order[1] = 42089
						order[2] = 0
						super(42087, 42088, order)
					end
				end
			end

			class NoUnderlyingCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 42042
					order[1] = 42043
					order[2] = 42044
					order[3] = 42045
					order[4] = 42046
					order[5] = 42047
					order[6] = 42048
					order[7] = 42049
					order[8] = 42050
					order[9] = 42051
					order[10] = 42052
					order[11] = 42039
					order[12] = 42797
					order[13] = 42798
					order[14] = 42053
					order[15] = 42054
					order[16] = 42790
					order[17] = 42791
					order[18] = 42792
					order[19] = 42793
					order[20] = 42794
					order[21] = 42795
					order[22] = 42796
					order[23] = 42055
					order[24] = 42056
					order[25] = 42057
					order[26] = 42058
					order[27] = 42059
					order[28] = 0
					super(42041, 42042, order)
				end

				class NoUnderlyingCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42040
						order[1] = 0
						super(42039, 42040, order)
					end
				end

				class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42789
						order[1] = 0
						super(42788, 42789, order)
					end
				end
			end

			class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42065
					order[1] = 42061
					order[2] = 42062
					order[3] = 42063
					order[4] = 42064
					order[5] = 0
					super(42060, 42065, order)
				end

				class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42066
						order[1] = 42067
						order[2] = 0
						super(42065, 42066, order)
					end
				end
			end

			class NoUnderlyingRateSpreadSteps < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 43006
					order[1] = 43007
					order[2] = 0
					super(43005, 43006, order)
				end
			end

			class NoUnderlyingDividendPayments < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42856
					order[1] = 42857
					order[2] = 42858
					order[3] = 42859
					order[4] = 0
					super(42855, 42856, order)
				end
			end

			class NoUnderlyingExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42885
					order[1] = 42886
					order[2] = 0
					super(42884, 42885, order)
				end
			end
		end

		class NoLegs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(176)
				order[0] = 600
				order[1] = 601
				order[2] = 602
				order[3] = 603
				order[4] = 1788
				order[5] = 607
				order[6] = 1594
				order[7] = 608
				order[8] = 2893
				order[9] = 609
				order[10] = 764
				order[11] = 610
				order[12] = 611
				order[13] = 1212
				order[14] = 2146
				order[15] = 2147
				order[16] = 2148
				order[17] = 248
				order[18] = 2149
				order[19] = 2150
				order[20] = 2151
				order[21] = 2152
				order[22] = 2153
				order[23] = 2154
				order[24] = 2155
				order[25] = 2348
				order[26] = 2067
				order[27] = 2068
				order[28] = 2069
				order[29] = 2739
				order[30] = 2070
				order[31] = 2156
				order[32] = 2157
				order[33] = 2158
				order[34] = 2159
				order[35] = 2160
				order[36] = 2161
				order[37] = 2162
				order[38] = 2163
				order[39] = 2164
				order[40] = 2165
				order[41] = 2880
				order[42] = 2166
				order[43] = 2167
				order[44] = 2168
				order[45] = 2169
				order[46] = 2170
				order[47] = 2171
				order[48] = 2172
				order[49] = 2173
				order[50] = 2174
				order[51] = 2175
				order[52] = 2176
				order[53] = 2177
				order[54] = 2178
				order[55] = 2179
				order[56] = 2180
				order[57] = 249
				order[58] = 250
				order[59] = 251
				order[60] = 252
				order[61] = 253
				order[62] = 257
				order[63] = 599
				order[64] = 596
				order[65] = 597
				order[66] = 598
				order[67] = 254
				order[68] = 612
				order[69] = 942
				order[70] = 2908
				order[71] = 2181
				order[72] = 2182
				order[73] = 2183
				order[74] = 2184
				order[75] = 2604
				order[76] = 2185
				order[77] = 2605
				order[78] = 2186
				order[79] = 2187
				order[80] = 2188
				order[81] = 2189
				order[82] = 613
				order[83] = 614
				order[84] = 1436
				order[85] = 2354
				order[86] = 1440
				order[87] = 2190
				order[88] = 2191
				order[89] = 999
				order[90] = 1224
				order[91] = 1720
				order[92] = 2909
				order[93] = 1421
				order[94] = 1422
				order[95] = 1721
				order[96] = 2910
				order[97] = 2192
				order[98] = 1001
				order[99] = 1420
				order[100] = 2193
				order[101] = 2194
				order[102] = 2755
				order[103] = 2195
				order[104] = 2196
				order[105] = 2197
				order[106] = 2198
				order[107] = 1528
				order[108] = 2911
				order[109] = 2199
				order[110] = 2200
				order[111] = 2201
				order[112] = 2202
				order[113] = 2203
				order[114] = 615
				order[115] = 616
				order[116] = 2205
				order[117] = 2206
				order[118] = 617
				order[119] = 618
				order[120] = 619
				order[121] = 2740
				order[122] = 2717
				order[123] = 2718
				order[124] = 2719
				order[125] = 620
				order[126] = 621
				order[127] = 622
				order[128] = 2207
				order[129] = 2208
				order[130] = 623
				order[131] = 624
				order[132] = 556
				order[133] = 2898
				order[134] = 740
				order[135] = 739
				order[136] = 955
				order[137] = 956
				order[138] = 1358
				order[139] = 2682
				order[140] = 2686
				order[141] = 1017
				order[142] = 566
				order[143] = 2209
				order[144] = 2211
				order[145] = 2212
				order[146] = 2213
				order[147] = 2754
				order[148] = 2214
				order[149] = 2215
				order[150] = 2606
				order[151] = 2607
				order[152] = 2497
				order[153] = 2498
				order[154] = 2499
				order[155] = 2496
				order[156] = 2495
				order[157] = 2953
				order[158] = 2511
				order[159] = 2510
				order[160] = 2512
				order[161] = 2509
				order[162] = 2500
				order[163] = 2502
				order[164] = 2501
				order[165] = 2503
				order[166] = 2507
				order[167] = 2505
				order[168] = 2494
				order[169] = 2493
				order[170] = 2514
				order[171] = 2513
				order[172] = 2506
				order[173] = 2504
				order[174] = 2508
				order[175] = 0
				super(555, 600, order)
			end

			class NoLegSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 605
					order[1] = 606
					order[2] = 2958
					order[3] = 0
					super(604, 605, order)
				end
			end

			class NoLegSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2077
					order[1] = 2078
					order[2] = 2079
					order[3] = 2743
					order[4] = 0
					super(2076, 2077, order)
				end
			end

			class NoLegAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2309
					order[1] = 2310
					order[2] = 2311
					order[3] = 0
					super(2308, 2309, order)
				end
			end

			class NoLegEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 2060
					order[1] = 2061
					order[2] = 2062
					order[3] = 2063
					order[4] = 2064
					order[5] = 2341
					order[6] = 2065
					order[7] = 2066
					order[8] = 2074
					order[9] = 2075
					order[10] = 0
					super(2059, 2060, order)
				end
			end

			class NoLegInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 2255
					order[1] = 2256
					order[2] = 2257
					order[3] = 2379
					order[4] = 2258
					order[5] = 0
					super(2254, 2255, order)
				end

				class NoLegInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2259
						order[1] = 2260
						order[2] = 0
						super(2258, 2259, order)
					end
				end
			end

			class NoLegComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2219
					order[1] = 2220
					order[2] = 2221
					order[3] = 2222
					order[4] = 2223
					order[5] = 2224
					order[6] = 2225
					order[7] = 2226
					order[8] = 2944
					order[9] = 2227
					order[10] = 2228
					order[11] = 2229
					order[12] = 2230
					order[13] = 2231
					order[14] = 2232
					order[15] = 2250
					order[16] = 2233
					order[17] = 2945
					order[18] = 2234
					order[19] = 2946
					order[20] = 2235
					order[21] = 2236
					order[22] = 2409
					order[23] = 2410
					order[24] = 2237
					order[25] = 2238
					order[26] = 2239
					order[27] = 2240
					order[28] = 2241
					order[29] = 41382
					order[30] = 41389
					order[31] = 41390
					order[32] = 41391
					order[33] = 41392
					order[34] = 41393
					order[35] = 41394
					order[36] = 41395
					order[37] = 41396
					order[38] = 41397
					order[39] = 41379
					order[40] = 2242
					order[41] = 2243
					order[42] = 2244
					order[43] = 2245
					order[44] = 2246
					order[45] = 41398
					order[46] = 41366
					order[47] = 2608
					order[48] = 2609
					order[49] = 2610
					order[50] = 2248
					order[51] = 2249
					order[52] = 0
					super(2218, 2219, order)
				end

				class NoLegComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2251
						order[1] = 2252
						order[2] = 2253
						order[3] = 0
						super(2250, 2251, order)
					end

					class NoLegComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2204
							order[1] = 2247
							order[2] = 0
							super(2253, 2204, order)
						end
					end
				end

				class NoLegComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41383
						order[1] = 41384
						order[2] = 41385
						order[3] = 41386
						order[4] = 0
						super(41382, 41383, order)
					end
				end

				class NoLegComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41388
						order[1] = 0
						super(41387, 41388, order)
					end
				end

				class NoLegComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41380
						order[1] = 41381
						order[2] = 41400
						order[3] = 41376
						order[4] = 41363
						order[5] = 0
						super(41379, 41380, order)
					end

					class NoLegComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41401
							order[1] = 41402
							order[2] = 41403
							order[3] = 41404
							order[4] = 41405
							order[5] = 0
							super(41400, 41401, order)
						end
					end

					class NoLegComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41377
							order[1] = 41378
							order[2] = 0
							super(41376, 41377, order)
						end
					end

					class NoLegComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41364
							order[1] = 41365
							order[2] = 0
							super(41363, 41364, order)
						end
					end
				end

				class NoLegComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41399
						order[1] = 0
						super(41398, 41399, order)
					end
				end

				class NoLegComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41367
						order[1] = 41368
						order[2] = 41369
						order[3] = 41370
						order[4] = 41371
						order[5] = 41372
						order[6] = 41373
						order[7] = 41374
						order[8] = 0
						super(41366, 41367, order)
					end

					class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41375
							order[1] = 0
							super(41374, 41375, order)
						end
					end
				end
			end

			class NoLegBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40924
					order[1] = 0
					super(40923, 40924, order)
				end
			end

			class NoLegPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41608
					order[1] = 0
					super(41607, 41608, order)
				end
			end

			class NoLegMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41468
					order[1] = 40223
					order[2] = 0
					super(41467, 41468, order)
				end
			end

			class NoLegMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41470
					order[1] = 40990
					order[2] = 0
					super(41469, 41470, order)
				end
			end

			class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41472
					order[1] = 41473
					order[2] = 41474
					order[3] = 41475
					order[4] = 41476
					order[5] = 41477
					order[6] = 41478
					order[7] = 41479
					order[8] = 41480
					order[9] = 0
					super(41471, 41472, order)
				end
			end

			class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42582
					order[1] = 0
					super(42581, 42582, order)
				end
			end

			class NoLegOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41492
					order[1] = 0
					super(41491, 41492, order)
				end
			end

			class NoLegOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41513
					order[1] = 41514
					order[2] = 0
					super(41512, 41513, order)
				end
			end

			class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41516
					order[1] = 0
					super(41515, 41516, order)
				end
			end

			class NoLegOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41528
					order[1] = 41529
					order[2] = 0
					super(41527, 41528, order)
				end
			end

			class NoLegStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40242
					order[1] = 41700
					order[2] = 40243
					order[3] = 42583
					order[4] = 42584
					order[5] = 40244
					order[6] = 40245
					order[7] = 41702
					order[8] = 40246
					order[9] = 40247
					order[10] = 42585
					order[11] = 42586
					order[12] = 41703
					order[13] = 41704
					order[14] = 41705
					order[15] = 41706
					order[16] = 41707
					order[17] = 41708
					order[18] = 41648
					order[19] = 41649
					order[20] = 41650
					order[21] = 41651
					order[22] = 41652
					order[23] = 41653
					order[24] = 41654
					order[25] = 42588
					order[26] = 41655
					order[27] = 41656
					order[28] = 41657
					order[29] = 41658
					order[30] = 41659
					order[31] = 41660
					order[32] = 41661
					order[33] = 41662
					order[34] = 41663
					order[35] = 41664
					order[36] = 41665
					order[37] = 41666
					order[38] = 41667
					order[39] = 41668
					order[40] = 41669
					order[41] = 41670
					order[42] = 41671
					order[43] = 41672
					order[44] = 41673
					order[45] = 40249
					order[46] = 40250
					order[47] = 40252
					order[48] = 40253
					order[49] = 40254
					order[50] = 40255
					order[51] = 40256
					order[52] = 40257
					order[53] = 40258
					order[54] = 40260
					order[55] = 40261
					order[56] = 40262
					order[57] = 40263
					order[58] = 40264
					order[59] = 41641
					order[60] = 41642
					order[61] = 40265
					order[62] = 40267
					order[63] = 40268
					order[64] = 40270
					order[65] = 40271
					order[66] = 40272
					order[67] = 40273
					order[68] = 40274
					order[69] = 40275
					order[70] = 40276
					order[71] = 41643
					order[72] = 41644
					order[73] = 41645
					order[74] = 40279
					order[75] = 40280
					order[76] = 40281
					order[77] = 42399
					order[78] = 40282
					order[79] = 40283
					order[80] = 43108
					order[81] = 40284
					order[82] = 40285
					order[83] = 40286
					order[84] = 40287
					order[85] = 40288
					order[86] = 42400
					order[87] = 42401
					order[88] = 42402
					order[89] = 42403
					order[90] = 40289
					order[91] = 40290
					order[92] = 40291
					order[93] = 41549
					order[94] = 41550
					order[95] = 41551
					order[96] = 41552
					order[97] = 41553
					order[98] = 41554
					order[99] = 41555
					order[100] = 42404
					order[101] = 40374
					order[102] = 40418
					order[103] = 41429
					order[104] = 41430
					order[105] = 41431
					order[106] = 41432
					order[107] = 41433
					order[108] = 42194
					order[109] = 42195
					order[110] = 41434
					order[111] = 41435
					order[112] = 41436
					order[113] = 41437
					order[114] = 41438
					order[115] = 41219
					order[116] = 41439
					order[117] = 41440
					order[118] = 41441
					order[119] = 41442
					order[120] = 41443
					order[121] = 41444
					order[122] = 41445
					order[123] = 41446
					order[124] = 41447
					order[125] = 41448
					order[126] = 41449
					order[127] = 41450
					order[128] = 41451
					order[129] = 43095
					order[130] = 41408
					order[131] = 40248
					order[132] = 40978
					order[133] = 40979
					order[134] = 0
					super(40241, 40242, order)
				end

				class NoLegStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41675
						order[1] = 41676
						order[2] = 0
						super(41674, 41675, order)
					end
				end

				class NoLegStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41453
						order[1] = 41454
						order[2] = 41455
						order[3] = 0
						super(41452, 41453, order)
					end
				end

				class NoLegStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41678
						order[1] = 41679
						order[2] = 0
						super(41677, 41678, order)
					end
				end

				class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41647
						order[1] = 0
						super(41646, 41647, order)
					end
				end

				class NoLegStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41687
						order[1] = 41688
						order[2] = 41689
						order[3] = 41690
						order[4] = 41691
						order[5] = 41692
						order[6] = 41693
						order[7] = 41694
						order[8] = 41695
						order[9] = 41696
						order[10] = 41697
						order[11] = 41680
						order[12] = 41698
						order[13] = 41699
						order[14] = 0
						super(41686, 41687, order)
					end

					class NoLegStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41681
							order[1] = 41682
							order[2] = 41683
							order[3] = 0
							super(41680, 41681, order)
						end

						class NoLegStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41684
								order[1] = 41685
								order[2] = 41935
								order[3] = 0
								super(41683, 41684, order)
							end
						end
					end
				end

				class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40251
						order[1] = 0
						super(40942, 40251, order)
					end
				end

				class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40259
						order[1] = 0
						super(40943, 40259, order)
					end
				end

				class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40266
						order[1] = 0
						super(40940, 40266, order)
					end
				end

				class NoLegStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41639
						order[1] = 41640
						order[2] = 0
						super(41638, 41639, order)
					end
				end

				class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40269
						order[1] = 0
						super(40941, 40269, order)
					end
				end

				class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40293
						order[1] = 0
						super(40930, 40293, order)
					end
				end

				class NoLegPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41590
						order[1] = 41591
						order[2] = 0
						super(41589, 41590, order)
					end
				end

				class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40305
						order[1] = 0
						super(40931, 40305, order)
					end
				end

				class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40311
						order[1] = 0
						super(40932, 40311, order)
					end
				end

				class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40318
						order[1] = 0
						super(40933, 40318, order)
					end
				end

				class NoLegPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42460
						order[1] = 42461
						order[2] = 0
						super(42459, 42460, order)
					end
				end

				class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41562
						order[1] = 0
						super(41561, 41562, order)
					end
				end

				class NoLegPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41597
						order[1] = 41598
						order[2] = 0
						super(41596, 41597, order)
					end
				end

				class NoLegPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41594
						order[1] = 41595
						order[2] = 0
						super(41593, 41594, order)
					end
				end

				class NoLegPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43110
						order[1] = 42486
						order[2] = 42487
						order[3] = 0
						super(42485, 43110, order)
					end
				end

				class NoLegDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42367
						order[1] = 42368
						order[2] = 42369
						order[3] = 42370
						order[4] = 42371
						order[5] = 42372
						order[6] = 42386
						order[7] = 42373
						order[8] = 42374
						order[9] = 42375
						order[10] = 42376
						order[11] = 42377
						order[12] = 42378
						order[13] = 42379
						order[14] = 42380
						order[15] = 42381
						order[16] = 42382
						order[17] = 42383
						order[18] = 42384
						order[19] = 42385
						order[20] = 0
						super(42366, 42367, order)
					end

					class NoLegDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42387
							order[1] = 0
							super(42386, 42387, order)
						end
					end
				end

				class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42365
						order[1] = 0
						super(42364, 42365, order)
					end
				end

				class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42311
						order[1] = 0
						super(42310, 42311, order)
					end
				end

				class NoLegReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 42535
						order[1] = 42536
						order[2] = 42537
						order[3] = 42538
						order[4] = 42539
						order[5] = 42540
						order[6] = 42564
						order[7] = 42530
						order[8] = 42541
						order[9] = 42542
						order[10] = 42543
						order[11] = 42544
						order[12] = 42545
						order[13] = 42546
						order[14] = 42547
						order[15] = 42548
						order[16] = 42549
						order[17] = 42550
						order[18] = 42551
						order[19] = 42552
						order[20] = 42560
						order[21] = 42553
						order[22] = 42554
						order[23] = 42508
						order[24] = 42555
						order[25] = 42556
						order[26] = 42557
						order[27] = 42558
						order[28] = 42559
						order[29] = 0
						super(42534, 42535, order)
					end

					class NoLegReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 42565
							order[1] = 42566
							order[2] = 42567
							order[3] = 42568
							order[4] = 0
							super(42564, 42565, order)
						end
					end

					class NoLegReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42531
							order[1] = 42532
							order[2] = 42533
							order[3] = 0
							super(42530, 42531, order)
						end
					end

					class NoLegReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42561
							order[1] = 42562
							order[2] = 42563
							order[3] = 0
							super(42560, 42561, order)
						end
					end

					class NoLegReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 42509
							order[1] = 42571
							order[2] = 42510
							order[3] = 42511
							order[4] = 42512
							order[5] = 42513
							order[6] = 42514
							order[7] = 42515
							order[8] = 42516
							order[9] = 42517
							order[10] = 42518
							order[11] = 42519
							order[12] = 42520
							order[13] = 42521
							order[14] = 42522
							order[15] = 42523
							order[16] = 42524
							order[17] = 42525
							order[18] = 42526
							order[19] = 42527
							order[20] = 42528
							order[21] = 42529
							order[22] = 42569
							order[23] = 0
							super(42508, 42509, order)
						end

						class NoLegReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 42572
								order[1] = 42573
								order[2] = 0
								super(42571, 42572, order)
							end
						end

						class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 42570
								order[1] = 0
								super(42569, 42570, order)
							end
						end
					end
				end

				class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42420
						order[1] = 0
						super(42419, 42420, order)
					end
				end

				class NoLegPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42406
						order[1] = 42407
						order[2] = 0
						super(42405, 42406, order)
					end
				end

				class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40361
						order[1] = 0
						super(40929, 40361, order)
					end
				end

				class NoLegNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40368
						order[1] = 40369
						order[2] = 0
						super(40367, 40368, order)
					end
				end

				class NoLegSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40903
						order[1] = 40366
						order[2] = 40370
						order[3] = 40905
						order[4] = 40906
						order[5] = 0
						super(40902, 40903, order)
					end
				end

				class NoLegPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40375
						order[1] = 41533
						order[2] = 41534
						order[3] = 40376
						order[4] = 40377
						order[5] = 40378
						order[6] = 40379
						order[7] = 40380
						order[8] = 40381
						order[9] = 40382
						order[10] = 40383
						order[11] = 40384
						order[12] = 40385
						order[13] = 41535
						order[14] = 41536
						order[15] = 41537
						order[16] = 41538
						order[17] = 40386
						order[18] = 40387
						order[19] = 40388
						order[20] = 40389
						order[21] = 41539
						order[22] = 41540
						order[23] = 41541
						order[24] = 41542
						order[25] = 40390
						order[26] = 40391
						order[27] = 40392
						order[28] = 40393
						order[29] = 40394
						order[30] = 40395
						order[31] = 40414
						order[32] = 40396
						order[33] = 40397
						order[34] = 40398
						order[35] = 40399
						order[36] = 40927
						order[37] = 40401
						order[38] = 40402
						order[39] = 40403
						order[40] = 41543
						order[41] = 41544
						order[42] = 40404
						order[43] = 41530
						order[44] = 41545
						order[45] = 41546
						order[46] = 41547
						order[47] = 41548
						order[48] = 40405
						order[49] = 40406
						order[50] = 40407
						order[51] = 40408
						order[52] = 40928
						order[53] = 40410
						order[54] = 40411
						order[55] = 40412
						order[56] = 40413
						order[57] = 0
						super(40374, 40375, order)
					end

					class NoLegPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40415
							order[1] = 40416
							order[2] = 40417
							order[3] = 0
							super(40414, 40415, order)
						end
					end

					class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40400
							order[1] = 0
							super(40927, 40400, order)
						end
					end

					class NoLegPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41531
							order[1] = 41532
							order[2] = 0
							super(41530, 41531, order)
						end
					end

					class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40409
							order[1] = 0
							super(40928, 40409, order)
						end
					end
				end

				class NoLegPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40419
						order[1] = 40420
						order[2] = 42497
						order[3] = 42498
						order[4] = 42499
						order[5] = 42500
						order[6] = 42501
						order[7] = 42502
						order[8] = 42503
						order[9] = 42488
						order[10] = 42489
						order[11] = 42490
						order[12] = 42491
						order[13] = 42492
						order[14] = 42493
						order[15] = 42494
						order[16] = 40421
						order[17] = 40422
						order[18] = 40423
						order[19] = 40424
						order[20] = 40425
						order[21] = 40426
						order[22] = 40427
						order[23] = 40428
						order[24] = 40429
						order[25] = 40430
						order[26] = 40431
						order[27] = 40432
						order[28] = 40433
						order[29] = 40434
						order[30] = 40435
						order[31] = 40436
						order[32] = 40437
						order[33] = 40438
						order[34] = 40439
						order[35] = 40440
						order[36] = 40441
						order[37] = 40442
						order[38] = 40443
						order[39] = 40444
						order[40] = 40445
						order[41] = 40446
						order[42] = 40447
						order[43] = 0
						super(40418, 40419, order)
					end

					class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42505
							order[1] = 0
							super(42504, 42505, order)
						end
					end

					class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42496
							order[1] = 0
							super(42495, 42496, order)
						end
					end
				end

				class NoLegDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41461
						order[1] = 0
						super(41460, 41461, order)
					end
				end

				class NoLegDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41457
						order[1] = 41458
						order[2] = 41459
						order[3] = 0
						super(41456, 41457, order)
					end
				end

				class NoLegDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41409
						order[1] = 41410
						order[2] = 41411
						order[3] = 41412
						order[4] = 41413
						order[5] = 41414
						order[6] = 41415
						order[7] = 41416
						order[8] = 41417
						order[9] = 41418
						order[10] = 41419
						order[11] = 41420
						order[12] = 41421
						order[13] = 41422
						order[14] = 0
						super(41408, 41409, order)
					end

					class NoLegDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41423
							order[1] = 41424
							order[2] = 41425
							order[3] = 0
							super(41422, 41423, order)
						end

						class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41426
								order[1] = 41427
								order[2] = 41428
								order[3] = 0
								super(41425, 41426, order)
							end
						end
					end
				end
			end

			class NoLegProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 40449
					order[1] = 40450
					order[2] = 40451
					order[3] = 40939
					order[4] = 40453
					order[5] = 40454
					order[6] = 40455
					order[7] = 42506
					order[8] = 42507
					order[9] = 40456
					order[10] = 40457
					order[11] = 40458
					order[12] = 40524
					order[13] = 40525
					order[14] = 40526
					order[15] = 40528
					order[16] = 40529
					order[17] = 40530
					order[18] = 40531
					order[19] = 40532
					order[20] = 40476
					order[21] = 40478
					order[22] = 40479
					order[23] = 40480
					order[24] = 40481
					order[25] = 40482
					order[26] = 40483
					order[27] = 40484
					order[28] = 40485
					order[29] = 40486
					order[30] = 40487
					order[31] = 40488
					order[32] = 40489
					order[33] = 40490
					order[34] = 40491
					order[35] = 40492
					order[36] = 40493
					order[37] = 40494
					order[38] = 40498
					order[39] = 40499
					order[40] = 40501
					order[41] = 40502
					order[42] = 40503
					order[43] = 40504
					order[44] = 40505
					order[45] = 40506
					order[46] = 40507
					order[47] = 40508
					order[48] = 40509
					order[49] = 40511
					order[50] = 40512
					order[51] = 40513
					order[52] = 40514
					order[53] = 40515
					order[54] = 40459
					order[55] = 40460
					order[56] = 40461
					order[57] = 40462
					order[58] = 40463
					order[59] = 40464
					order[60] = 40465
					order[61] = 40516
					order[62] = 40518
					order[63] = 40519
					order[64] = 40520
					order[65] = 40521
					order[66] = 40522
					order[67] = 40523
					order[68] = 40466
					order[69] = 40467
					order[70] = 40468
					order[71] = 40469
					order[72] = 40470
					order[73] = 41407
					order[74] = 40472
					order[75] = 40980
					order[76] = 40981
					order[77] = 40533
					order[78] = 0
					super(40448, 40449, order)
				end

				class NoLegProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40452
						order[1] = 0
						super(40939, 40452, order)
					end
				end

				class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40527
						order[1] = 0
						super(40935, 40527, order)
					end
				end

				class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40477
						order[1] = 0
						super(40936, 40477, order)
					end
				end

				class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40496
						order[1] = 40497
						order[2] = 0
						super(40495, 40496, order)
					end
				end

				class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40500
						order[1] = 0
						super(40937, 40500, order)
					end
				end

				class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40510
						order[1] = 0
						super(40938, 40510, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40517
						order[1] = 0
						super(40934, 40517, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40474
						order[1] = 40475
						order[2] = 0
						super(40473, 40474, order)
					end
				end

				class NoLegProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40534
						order[1] = 40535
						order[2] = 40536
						order[3] = 2380
						order[4] = 40537
						order[5] = 0
						super(40533, 40534, order)
					end

					class NoLegProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40538
							order[1] = 40539
							order[2] = 0
							super(40537, 40538, order)
						end
					end
				end
			end

			class NoLegAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41336
					order[1] = 41337
					order[2] = 41316
					order[3] = 0
					super(41335, 41336, order)
				end

				class NoLegAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41317
						order[1] = 41318
						order[2] = 41319
						order[3] = 41320
						order[4] = 41321
						order[5] = 41322
						order[6] = 41323
						order[7] = 41324
						order[8] = 41325
						order[9] = 41326
						order[10] = 41327
						order[11] = 41328
						order[12] = 41329
						order[13] = 41330
						order[14] = 41331
						order[15] = 41332
						order[16] = 41333
						order[17] = 41334
						order[18] = 0
						super(41316, 41317, order)
					end
				end
			end

			class NoLegProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 41618
					order[1] = 41619
					order[2] = 41620
					order[3] = 41621
					order[4] = 41622
					order[5] = 41623
					order[6] = 41624
					order[7] = 41614
					order[8] = 41625
					order[9] = 41635
					order[10] = 41617
					order[11] = 0
					super(41616, 41618, order)
				end

				class NoLegProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41615
						order[1] = 0
						super(41614, 41615, order)
					end
				end

				class NoLegProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41626
						order[1] = 41627
						order[2] = 41628
						order[3] = 41629
						order[4] = 41630
						order[5] = 41631
						order[6] = 41632
						order[7] = 41633
						order[8] = 0
						super(41625, 41626, order)
					end

					class NoLegProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41634
							order[1] = 0
							super(41633, 41634, order)
						end
					end
				end

				class NoLegProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41636
						order[1] = 41637
						order[2] = 0
						super(41635, 41636, order)
					end
				end
			end

			class NoLegCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 41345
					order[1] = 41346
					order[2] = 41347
					order[3] = 41348
					order[4] = 41349
					order[5] = 41350
					order[6] = 41351
					order[7] = 41352
					order[8] = 41353
					order[9] = 41354
					order[10] = 41355
					order[11] = 41342
					order[12] = 42308
					order[13] = 42309
					order[14] = 41356
					order[15] = 41357
					order[16] = 42299
					order[17] = 42300
					order[18] = 42301
					order[19] = 42302
					order[20] = 42303
					order[21] = 42304
					order[22] = 42305
					order[23] = 41358
					order[24] = 41359
					order[25] = 41360
					order[26] = 41361
					order[27] = 41362
					order[28] = 0
					super(41344, 41345, order)
				end

				class NoLegCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41343
						order[1] = 0
						super(41342, 41343, order)
					end
				end

				class NoLegCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42307
						order[1] = 0
						super(42306, 42307, order)
					end
				end
			end

			class NoLegPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41604
					order[1] = 41601
					order[2] = 41602
					order[3] = 41603
					order[4] = 41600
					order[5] = 0
					super(41599, 41604, order)
				end

				class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41605
						order[1] = 41606
						order[2] = 0
						super(41604, 41605, order)
					end
				end
			end

			class NoLegExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42389
					order[1] = 42390
					order[2] = 0
					super(42388, 42389, order)
				end
			end

			class NoLegContractualDefinitions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42199
					order[1] = 0
					super(42198, 42199, order)
				end
			end

			class NoLegFinancingTermSupplements < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42201
					order[1] = 42202
					order[2] = 0
					super(42200, 42201, order)
				end
			end

			class NoLegContractualMatrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42204
					order[1] = 42205
					order[2] = 42206
					order[3] = 0
					super(42203, 42204, order)
				end
			end
		end

		class NoRelatedInstruments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1648
				order[1] = 1649
				order[2] = 1650
				order[3] = 1651
				order[4] = 1652
				order[5] = 1653
				order[6] = 2413
				order[7] = 2414
				order[8] = 2415
				order[9] = 2417
				order[10] = 0
				super(1647, 1648, order)
			end
		end
	end

	class NoTradingSessions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 336
			order[1] = 625
			order[2] = 0
			super(386, 336, order)
		end
	end
end

class MarketDataSnapshotFullRefresh < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("W") )
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoInstrAttrib < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 871
			order[1] = 872
			order[2] = 0
			super(870, 871, order)
		end
	end

	class NoIndexRollMonths < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2733
			order[1] = 0
			super(2734, 2733, order)
		end
	end

	class NoReferenceDataDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2747
			order[1] = 2748
			order[2] = 0
			super(2746, 2747, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoRelatedInstruments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 1648
			order[1] = 1649
			order[2] = 1650
			order[3] = 1651
			order[4] = 1652
			order[5] = 1653
			order[6] = 2413
			order[7] = 2414
			order[8] = 2415
			order[9] = 2417
			order[10] = 0
			super(1647, 1648, order)
		end
	end

	class NoMDEntries < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(115)
			order[0] = 269
			order[1] = 278
			order[2] = 270
			order[3] = 423
			order[4] = 2709
			order[5] = 819
			order[6] = 235
			order[7] = 236
			order[8] = 701
			order[9] = 696
			order[10] = 697
			order[11] = 698
			order[12] = 218
			order[13] = 220
			order[14] = 2950
			order[15] = 221
			order[16] = 222
			order[17] = 662
			order[18] = 663
			order[19] = 699
			order[20] = 761
			order[21] = 40
			order[22] = 15
			order[23] = 2897
			order[24] = 120
			order[25] = 2899
			order[26] = 1445
			order[27] = 271
			order[28] = 1177
			order[29] = 1093
			order[30] = 272
			order[31] = 273
			order[32] = 274
			order[33] = 275
			order[34] = 336
			order[35] = 625
			order[36] = 326
			order[37] = 327
			order[38] = 2447
			order[39] = 2705
			order[40] = 276
			order[41] = 277
			order[42] = 1838
			order[43] = 2961
			order[44] = 2667
			order[45] = 282
			order[46] = 283
			order[47] = 284
			order[48] = 286
			order[49] = 59
			order[50] = 432
			order[51] = 126
			order[52] = 1629
			order[53] = 1916
			order[54] = 110
			order[55] = 18
			order[56] = 287
			order[57] = 37
			order[58] = 198
			order[59] = 299
			order[60] = 1003
			order[61] = 1851
			order[62] = 288
			order[63] = 289
			order[64] = 2449
			order[65] = 2450
			order[66] = 346
			order[67] = 290
			order[68] = 546
			order[69] = 811
			order[70] = 828
			order[71] = 829
			order[72] = 855
			order[73] = 2896
			order[74] = 1934
			order[75] = 2963
			order[76] = 2405
			order[77] = 574
			order[78] = 1115
			order[79] = 1390
			order[80] = 2668
			order[81] = 2373
			order[82] = 570
			order[83] = 1855
			order[84] = 58
			order[85] = 354
			order[86] = 355
			order[87] = 1023
			order[88] = 528
			order[89] = 1024
			order[90] = 332
			order[91] = 333
			order[92] = 1025
			order[93] = 31
			order[94] = 1592
			order[95] = 1020
			order[96] = 1306
			order[97] = 1148
			order[98] = 1149
			order[99] = 1150
			order[100] = 1143
			order[101] = 731
			order[102] = 2451
			order[103] = 63
			order[104] = 64
			order[105] = 1070
			order[106] = 83
			order[107] = 1048
			order[108] = 1026
			order[109] = 1027
			order[110] = 453
			order[111] = 2445
			order[112] = 2446
			order[113] = 654
			order[114] = 0
			super(268, 269, order)
		end

		class NoPriceQualifiers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 2710
				order[1] = 0
				super(2709, 2710, order)
			end
		end

		class NoRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1446
				order[1] = 1447
				order[2] = 1448
				order[3] = 2412
				order[4] = 2796
				order[5] = 0
				super(1445, 1446, order)
			end
		end

		class NoOfSecSizes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1178
				order[1] = 1179
				order[2] = 0
				super(1177, 1178, order)
			end
		end

		class NoTradePriceConditions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 1839
				order[1] = 0
				super(1838, 1839, order)
			end
		end

		class NoTrdRegPublications < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2669
				order[1] = 2670
				order[2] = 0
				super(2668, 2669, order)
			end
		end

		class NoRelatedTrades < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 1856
				order[1] = 1857
				order[2] = 2103
				order[3] = 1858
				order[4] = 1859
				order[5] = 1860
				order[6] = 0
				super(1855, 1856, order)
			end
		end

		class NoPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 448
				order[1] = 447
				order[2] = 452
				order[3] = 2376
				order[4] = 802
				order[5] = 0
				super(453, 448, order)
			end

			class NoPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 523
					order[1] = 803
					order[2] = 0
					super(802, 523, order)
				end
			end
		end
	end

	class NoRoutingIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 216
			order[1] = 217
			order[2] = 0
			super(215, 216, order)
		end
	end
end

class MarketDataIncrementalRefresh < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("X") )
	end

	class NoMDEntries < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(310)
			order[0] = 279
			order[1] = 285
			order[2] = 1173
			order[3] = 264
			order[4] = 269
			order[5] = 278
			order[6] = 280
			order[7] = 1500
			order[8] = 55
			order[9] = 65
			order[10] = 48
			order[11] = 22
			order[12] = 460
			order[13] = 1227
			order[14] = 1151
			order[15] = 461
			order[16] = 2891
			order[17] = 167
			order[18] = 762
			order[19] = 200
			order[20] = 541
			order[21] = 1079
			order[22] = 966
			order[23] = 1049
			order[24] = 965
			order[25] = 224
			order[26] = 1449
			order[27] = 1450
			order[28] = 1451
			order[29] = 1452
			order[30] = 1457
			order[31] = 1458
			order[32] = 1739
			order[33] = 2210
			order[34] = 1938
			order[35] = 1939
			order[36] = 1940
			order[37] = 2735
			order[38] = 1941
			order[39] = 1575
			order[40] = 1942
			order[41] = 1943
			order[42] = 1944
			order[43] = 1945
			order[44] = 1946
			order[45] = 1947
			order[46] = 1948
			order[47] = 1949
			order[48] = 1950
			order[49] = 2879
			order[50] = 1951
			order[51] = 1952
			order[52] = 1953
			order[53] = 1954
			order[54] = 1955
			order[55] = 1956
			order[56] = 1957
			order[57] = 1958
			order[58] = 1959
			order[59] = 1960
			order[60] = 1577
			order[61] = 1580
			order[62] = 1581
			order[63] = 1678
			order[64] = 1697
			order[65] = 225
			order[66] = 239
			order[67] = 226
			order[68] = 227
			order[69] = 228
			order[70] = 255
			order[71] = 543
			order[72] = 470
			order[73] = 471
			order[74] = 472
			order[75] = 240
			order[76] = 202
			order[77] = 2578
			order[78] = 2577
			order[79] = 947
			order[80] = 2904
			order[81] = 967
			order[82] = 968
			order[83] = 1698
			order[84] = 1866
			order[85] = 2600
			order[86] = 2001
			order[87] = 2601
			order[88] = 1478
			order[89] = 1479
			order[90] = 1480
			order[91] = 1481
			order[92] = 206
			order[93] = 231
			order[94] = 1435
			order[95] = 2353
			order[96] = 1439
			order[97] = 969
			order[98] = 1146
			order[99] = 996
			order[100] = 1147
			order[101] = 1716
			order[102] = 2905
			order[103] = 1191
			order[104] = 1192
			order[105] = 1717
			order[106] = 2906
			order[107] = 1193
			order[108] = 2579
			order[109] = 1194
			order[110] = 1482
			order[111] = 1195
			order[112] = 2753
			order[113] = 1196
			order[114] = 1197
			order[115] = 2002
			order[116] = 2140
			order[117] = 1524
			order[118] = 2907
			order[119] = 1198
			order[120] = 1199
			order[121] = 1200
			order[122] = 201
			order[123] = 2681
			order[124] = 2685
			order[125] = 1244
			order[126] = 1242
			order[127] = 2575
			order[128] = 2574
			order[129] = 997
			order[130] = 223
			order[131] = 207
			order[132] = 970
			order[133] = 971
			order[134] = 106
			order[135] = 348
			order[136] = 349
			order[137] = 2737
			order[138] = 2714
			order[139] = 2715
			order[140] = 2716
			order[141] = 107
			order[142] = 350
			order[143] = 351
			order[144] = 691
			order[145] = 667
			order[146] = 875
			order[147] = 876
			order[148] = 873
			order[149] = 874
			order[150] = 1687
			order[151] = 1787
			order[152] = 2141
			order[153] = 2142
			order[154] = 2143
			order[155] = 2752
			order[156] = 2144
			order[157] = 2145
			order[158] = 2576
			order[159] = 2962
			order[160] = 2602
			order[161] = 2603
			order[162] = 668
			order[163] = 869
			order[164] = 2736
			order[165] = 2738
			order[166] = 913
			order[167] = 914
			order[168] = 1961
			order[169] = 915
			order[170] = 918
			order[171] = 2952
			order[172] = 1962
			order[173] = 1963
			order[174] = 1964
			order[175] = 1965
			order[176] = 1966
			order[177] = 1967
			order[178] = 1968
			order[179] = 1969
			order[180] = 1970
			order[181] = 1513
			order[182] = 1525
			order[183] = 1527
			order[184] = 788
			order[185] = 916
			order[186] = 917
			order[187] = 919
			order[188] = 898
			order[189] = 711
			order[190] = 555
			order[191] = 1647
			order[192] = 291
			order[193] = 292
			order[194] = 270
			order[195] = 423
			order[196] = 2709
			order[197] = 819
			order[198] = 235
			order[199] = 236
			order[200] = 701
			order[201] = 696
			order[202] = 697
			order[203] = 698
			order[204] = 218
			order[205] = 220
			order[206] = 2950
			order[207] = 221
			order[208] = 222
			order[209] = 662
			order[210] = 663
			order[211] = 699
			order[212] = 761
			order[213] = 40
			order[214] = 15
			order[215] = 2897
			order[216] = 120
			order[217] = 2899
			order[218] = 1445
			order[219] = 271
			order[220] = 1177
			order[221] = 1093
			order[222] = 272
			order[223] = 273
			order[224] = 274
			order[225] = 275
			order[226] = 336
			order[227] = 625
			order[228] = 326
			order[229] = 327
			order[230] = 2447
			order[231] = 2705
			order[232] = 276
			order[233] = 277
			order[234] = 1838
			order[235] = 2961
			order[236] = 2667
			order[237] = 1934
			order[238] = 2963
			order[239] = 828
			order[240] = 829
			order[241] = 855
			order[242] = 2896
			order[243] = 2405
			order[244] = 574
			order[245] = 1115
			order[246] = 1390
			order[247] = 2668
			order[248] = 2373
			order[249] = 570
			order[250] = 1855
			order[251] = 282
			order[252] = 283
			order[253] = 284
			order[254] = 286
			order[255] = 59
			order[256] = 432
			order[257] = 126
			order[258] = 1629
			order[259] = 1916
			order[260] = 110
			order[261] = 18
			order[262] = 287
			order[263] = 37
			order[264] = 198
			order[265] = 299
			order[266] = 1003
			order[267] = 1851
			order[268] = 288
			order[269] = 289
			order[270] = 2449
			order[271] = 2450
			order[272] = 346
			order[273] = 290
			order[274] = 546
			order[275] = 811
			order[276] = 451
			order[277] = 58
			order[278] = 354
			order[279] = 355
			order[280] = 1023
			order[281] = 528
			order[282] = 1024
			order[283] = 332
			order[284] = 333
			order[285] = 1025
			order[286] = 31
			order[287] = 1592
			order[288] = 1020
			order[289] = 1306
			order[290] = 1148
			order[291] = 1149
			order[292] = 1150
			order[293] = 1143
			order[294] = 731
			order[295] = 2451
			order[296] = 63
			order[297] = 64
			order[298] = 483
			order[299] = 60
			order[300] = 2445
			order[301] = 2446
			order[302] = 1070
			order[303] = 83
			order[304] = 1048
			order[305] = 1026
			order[306] = 1027
			order[307] = 1175
			order[308] = 453
			order[309] = 0
			super(268, 279, order)
		end

		class NoSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 455
				order[1] = 456
				order[2] = 2957
				order[3] = 0
				super(454, 455, order)
			end
		end

		class NoSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1977
				order[1] = 1978
				order[2] = 1979
				order[3] = 2741
				order[4] = 0
				super(1976, 1977, order)
			end
		end

		class NoAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2305
				order[1] = 2306
				order[2] = 2307
				order[3] = 0
				super(2304, 2305, order)
			end
		end

		class NoEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 865
				order[1] = 866
				order[2] = 1145
				order[3] = 1827
				order[4] = 1826
				order[5] = 2340
				order[6] = 867
				order[7] = 868
				order[8] = 1578
				order[9] = 1579
				order[10] = 0
				super(864, 865, order)
			end
		end

		class NoInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1019
				order[1] = 1050
				order[2] = 1051
				order[3] = 2378
				order[4] = 1052
				order[5] = 0
				super(1018, 1019, order)
			end

			class NoInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1053
					order[1] = 1054
					order[2] = 0
					super(1052, 1053, order)
				end
			end
		end

		class NoComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 1484
				order[1] = 2117
				order[2] = 2118
				order[3] = 2119
				order[4] = 1485
				order[5] = 2120
				order[6] = 2121
				order[7] = 2122
				order[8] = 2941
				order[9] = 1486
				order[10] = 2123
				order[11] = 1487
				order[12] = 1488
				order[13] = 1489
				order[14] = 1490
				order[15] = 1491
				order[16] = 2124
				order[17] = 2942
				order[18] = 2125
				order[19] = 2943
				order[20] = 2126
				order[21] = 2127
				order[22] = 2407
				order[23] = 2408
				order[24] = 2128
				order[25] = 2129
				order[26] = 2130
				order[27] = 2131
				order[28] = 2132
				order[29] = 41013
				order[30] = 41020
				order[31] = 41021
				order[32] = 41022
				order[33] = 41023
				order[34] = 41024
				order[35] = 41025
				order[36] = 41026
				order[37] = 41027
				order[38] = 41028
				order[39] = 41010
				order[40] = 2133
				order[41] = 2134
				order[42] = 2135
				order[43] = 2136
				order[44] = 2137
				order[45] = 41029
				order[46] = 40997
				order[47] = 2597
				order[48] = 2598
				order[49] = 2599
				order[50] = 2138
				order[51] = 2139
				order[52] = 0
				super(1483, 1484, order)
			end

			class NoComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1492
					order[1] = 1493
					order[2] = 1494
					order[3] = 0
					super(1491, 1492, order)
				end

				class NoComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1495
						order[1] = 1496
						order[2] = 0
						super(1494, 1495, order)
					end
				end
			end

			class NoComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41014
					order[1] = 41015
					order[2] = 41016
					order[3] = 41017
					order[4] = 0
					super(41013, 41014, order)
				end
			end

			class NoComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41019
					order[1] = 0
					super(41018, 41019, order)
				end
			end

			class NoComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41011
					order[1] = 41012
					order[2] = 41031
					order[3] = 41007
					order[4] = 40994
					order[5] = 0
					super(41010, 41011, order)
				end

				class NoComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41032
						order[1] = 41033
						order[2] = 41034
						order[3] = 41035
						order[4] = 41036
						order[5] = 0
						super(41031, 41032, order)
					end
				end

				class NoComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41008
						order[1] = 41009
						order[2] = 0
						super(41007, 41008, order)
					end
				end

				class NoComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40995
						order[1] = 40996
						order[2] = 0
						super(40994, 40995, order)
					end
				end
			end

			class NoComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41030
					order[1] = 0
					super(41029, 41030, order)
				end
			end

			class NoComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40998
					order[1] = 40999
					order[2] = 41000
					order[3] = 41001
					order[4] = 41002
					order[5] = 41003
					order[6] = 41004
					order[7] = 41005
					order[8] = 0
					super(40997, 40998, order)
				end

				class NoComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41006
						order[1] = 0
						super(41005, 41006, order)
					end
				end
			end
		end

		class NoBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40471
				order[1] = 0
				super(40278, 40471, order)
			end
		end

		class NoPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41231
				order[1] = 0
				super(41230, 41231, order)
			end
		end

		class NoMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41093
				order[1] = 40991
				order[2] = 0
				super(41092, 41093, order)
			end
		end

		class NoMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41095
				order[1] = 40992
				order[2] = 0
				super(41094, 41095, order)
			end
		end

		class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41097
				order[1] = 41098
				order[2] = 41099
				order[3] = 41100
				order[4] = 41101
				order[5] = 41102
				order[6] = 41103
				order[7] = 41104
				order[8] = 41105
				order[9] = 0
				super(41096, 41097, order)
			end
		end

		class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42776
				order[1] = 0
				super(42775, 42776, order)
			end
		end

		class NoOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41117
				order[1] = 0
				super(41116, 41117, order)
			end
		end

		class NoOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41138
				order[1] = 41139
				order[2] = 0
				super(41137, 41138, order)
			end
		end

		class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41141
				order[1] = 0
				super(41140, 41141, order)
			end
		end

		class NoOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41153
				order[1] = 41154
				order[2] = 0
				super(41152, 41153, order)
			end
		end

		class NoStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40050
				order[1] = 41303
				order[2] = 40051
				order[3] = 42784
				order[4] = 42785
				order[5] = 40052
				order[6] = 40053
				order[7] = 41305
				order[8] = 40054
				order[9] = 40055
				order[10] = 42786
				order[11] = 42787
				order[12] = 41306
				order[13] = 41307
				order[14] = 41308
				order[15] = 41309
				order[16] = 41310
				order[17] = 41311
				order[18] = 41251
				order[19] = 41252
				order[20] = 41253
				order[21] = 41254
				order[22] = 41255
				order[23] = 41256
				order[24] = 41257
				order[25] = 42587
				order[26] = 41258
				order[27] = 41259
				order[28] = 41260
				order[29] = 41261
				order[30] = 41262
				order[31] = 41263
				order[32] = 41264
				order[33] = 41265
				order[34] = 41266
				order[35] = 41267
				order[36] = 41268
				order[37] = 41269
				order[38] = 41270
				order[39] = 41271
				order[40] = 41272
				order[41] = 41273
				order[42] = 41274
				order[43] = 41275
				order[44] = 41276
				order[45] = 40907
				order[46] = 40908
				order[47] = 40910
				order[48] = 40911
				order[49] = 40912
				order[50] = 40913
				order[51] = 40914
				order[52] = 40065
				order[53] = 40066
				order[54] = 40068
				order[55] = 40069
				order[56] = 40070
				order[57] = 40071
				order[58] = 40072
				order[59] = 41244
				order[60] = 41245
				order[61] = 40073
				order[62] = 40075
				order[63] = 40076
				order[64] = 40078
				order[65] = 40079
				order[66] = 40080
				order[67] = 40081
				order[68] = 40082
				order[69] = 40083
				order[70] = 40084
				order[71] = 41246
				order[72] = 41247
				order[73] = 41248
				order[74] = 40738
				order[75] = 40739
				order[76] = 40740
				order[77] = 42600
				order[78] = 40741
				order[79] = 40742
				order[80] = 43106
				order[81] = 40743
				order[82] = 40744
				order[83] = 40745
				order[84] = 40746
				order[85] = 40747
				order[86] = 42601
				order[87] = 42602
				order[88] = 42603
				order[89] = 42604
				order[90] = 40748
				order[91] = 40749
				order[92] = 40750
				order[93] = 41180
				order[94] = 41181
				order[95] = 41182
				order[96] = 41183
				order[97] = 41184
				order[98] = 41185
				order[99] = 41186
				order[100] = 42605
				order[101] = 40828
				order[102] = 40872
				order[103] = 41058
				order[104] = 41059
				order[105] = 41060
				order[106] = 41061
				order[107] = 41062
				order[108] = 42192
				order[109] = 42193
				order[110] = 41063
				order[111] = 41064
				order[112] = 41065
				order[113] = 41066
				order[114] = 41067
				order[115] = 41218
				order[116] = 41068
				order[117] = 41069
				order[118] = 41070
				order[119] = 41071
				order[120] = 41072
				order[121] = 41073
				order[122] = 41074
				order[123] = 41075
				order[124] = 41076
				order[125] = 41077
				order[126] = 41078
				order[127] = 41079
				order[128] = 41080
				order[129] = 43094
				order[130] = 41037
				order[131] = 40056
				order[132] = 40982
				order[133] = 40983
				order[134] = 0
				super(40049, 40050, order)
			end

			class NoStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41278
					order[1] = 41279
					order[2] = 0
					super(41277, 41278, order)
				end
			end

			class NoStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41238
					order[1] = 41239
					order[2] = 41240
					order[3] = 0
					super(41237, 41238, order)
				end
			end

			class NoStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41281
					order[1] = 41282
					order[2] = 0
					super(41280, 41281, order)
				end
			end

			class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41250
					order[1] = 0
					super(41249, 41250, order)
				end
			end

			class NoStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41290
					order[1] = 41291
					order[2] = 41292
					order[3] = 41293
					order[4] = 41294
					order[5] = 41295
					order[6] = 41296
					order[7] = 41297
					order[8] = 41298
					order[9] = 41299
					order[10] = 41300
					order[11] = 41283
					order[12] = 41301
					order[13] = 41302
					order[14] = 0
					super(41289, 41290, order)
				end

				class NoStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41284
						order[1] = 41285
						order[2] = 41286
						order[3] = 0
						super(41283, 41284, order)
					end

					class NoStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41287
							order[1] = 41288
							order[2] = 41588
							order[3] = 0
							super(41286, 41287, order)
						end
					end
				end
			end

			class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40909
					order[1] = 0
					super(40960, 40909, order)
				end
			end

			class NoStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40067
					order[1] = 0
					super(40961, 40067, order)
				end
			end

			class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40074
					order[1] = 0
					super(40958, 40074, order)
				end
			end

			class NoStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41242
					order[1] = 41243
					order[2] = 0
					super(41241, 41242, order)
				end
			end

			class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40077
					order[1] = 0
					super(40959, 40077, order)
				end
			end

			class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40752
					order[1] = 0
					super(40947, 40752, order)
				end
			end

			class NoPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41221
					order[1] = 41222
					order[2] = 0
					super(41220, 41221, order)
				end
			end

			class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40763
					order[1] = 0
					super(40948, 40763, order)
				end
			end

			class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40769
					order[1] = 0
					super(40949, 40769, order)
				end
			end

			class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40776
					order[1] = 0
					super(40950, 40776, order)
				end
			end

			class NoPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42661
					order[1] = 42662
					order[2] = 0
					super(42660, 42661, order)
				end
			end

			class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41193
					order[1] = 0
					super(41192, 41193, order)
				end
			end

			class NoPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41228
					order[1] = 41229
					order[2] = 0
					super(41227, 41228, order)
				end
			end

			class NoPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41225
					order[1] = 41226
					order[2] = 0
					super(41224, 41225, order)
				end
			end

			class NoPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43109
					order[1] = 42684
					order[2] = 42685
					order[3] = 0
					super(42683, 43109, order)
				end
			end

			class NoDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42275
					order[1] = 42276
					order[2] = 42277
					order[3] = 42278
					order[4] = 42279
					order[5] = 42280
					order[6] = 42294
					order[7] = 42281
					order[8] = 42282
					order[9] = 42283
					order[10] = 42284
					order[11] = 42285
					order[12] = 42286
					order[13] = 42287
					order[14] = 42288
					order[15] = 42289
					order[16] = 42290
					order[17] = 42291
					order[18] = 42292
					order[19] = 42293
					order[20] = 0
					super(42274, 42275, order)
				end

				class NoDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42295
						order[1] = 0
						super(42294, 42295, order)
					end
				end
			end

			class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42273
					order[1] = 0
					super(42272, 42273, order)
				end
			end

			class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42237
					order[1] = 0
					super(42236, 42237, order)
				end
			end

			class NoReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42736
					order[1] = 42737
					order[2] = 42738
					order[3] = 42739
					order[4] = 42740
					order[5] = 42741
					order[6] = 42765
					order[7] = 42731
					order[8] = 42742
					order[9] = 42743
					order[10] = 42744
					order[11] = 42745
					order[12] = 42746
					order[13] = 42747
					order[14] = 42748
					order[15] = 42749
					order[16] = 42750
					order[17] = 42751
					order[18] = 42752
					order[19] = 42753
					order[20] = 42761
					order[21] = 42754
					order[22] = 42755
					order[23] = 42709
					order[24] = 42756
					order[25] = 42757
					order[26] = 42758
					order[27] = 42759
					order[28] = 42760
					order[29] = 0
					super(42735, 42736, order)
				end

				class NoReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42766
						order[1] = 42767
						order[2] = 42768
						order[3] = 42769
						order[4] = 0
						super(42765, 42766, order)
					end
				end

				class NoReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42732
						order[1] = 42733
						order[2] = 42734
						order[3] = 0
						super(42731, 42732, order)
					end
				end

				class NoReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42762
						order[1] = 42763
						order[2] = 42764
						order[3] = 0
						super(42761, 42762, order)
					end
				end

				class NoReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42710
						order[1] = 42772
						order[2] = 42711
						order[3] = 42712
						order[4] = 42713
						order[5] = 42714
						order[6] = 42715
						order[7] = 42716
						order[8] = 42717
						order[9] = 42718
						order[10] = 42719
						order[11] = 42720
						order[12] = 42721
						order[13] = 42722
						order[14] = 42723
						order[15] = 42724
						order[16] = 42725
						order[17] = 42726
						order[18] = 42727
						order[19] = 42728
						order[20] = 42729
						order[21] = 42730
						order[22] = 42770
						order[23] = 0
						super(42709, 42710, order)
					end

					class NoReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42773
							order[1] = 42774
							order[2] = 0
							super(42772, 42773, order)
						end
					end

					class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42771
							order[1] = 0
							super(42770, 42771, order)
						end
					end
				end
			end

			class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42621
					order[1] = 0
					super(42620, 42621, order)
				end
			end

			class NoPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42607
					order[1] = 42608
					order[2] = 0
					super(42606, 42607, order)
				end
			end

			class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40819
					order[1] = 0
					super(40946, 40819, order)
				end
			end

			class NoNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40826
					order[1] = 40827
					order[2] = 0
					super(40825, 40826, order)
				end
			end

			class NoSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40086
					order[1] = 40373
					order[2] = 40655
					order[3] = 40088
					order[4] = 40089
					order[5] = 0
					super(40085, 40086, order)
				end
			end

			class NoPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40829
					order[1] = 41164
					order[2] = 41165
					order[3] = 40830
					order[4] = 40831
					order[5] = 40832
					order[6] = 40833
					order[7] = 40834
					order[8] = 40835
					order[9] = 40836
					order[10] = 40837
					order[11] = 40838
					order[12] = 40839
					order[13] = 41166
					order[14] = 41167
					order[15] = 41168
					order[16] = 41169
					order[17] = 40840
					order[18] = 40841
					order[19] = 40842
					order[20] = 40843
					order[21] = 41170
					order[22] = 41171
					order[23] = 41172
					order[24] = 41173
					order[25] = 40844
					order[26] = 40845
					order[27] = 40846
					order[28] = 40847
					order[29] = 40848
					order[30] = 40849
					order[31] = 40868
					order[32] = 40850
					order[33] = 40851
					order[34] = 40852
					order[35] = 40853
					order[36] = 40977
					order[37] = 40855
					order[38] = 40856
					order[39] = 40857
					order[40] = 41174
					order[41] = 41175
					order[42] = 40858
					order[43] = 41161
					order[44] = 41176
					order[45] = 41177
					order[46] = 41178
					order[47] = 41179
					order[48] = 40859
					order[49] = 40860
					order[50] = 40861
					order[51] = 40862
					order[52] = 40945
					order[53] = 40864
					order[54] = 40865
					order[55] = 40866
					order[56] = 40867
					order[57] = 0
					super(40828, 40829, order)
				end

				class NoPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40869
						order[1] = 40870
						order[2] = 40871
						order[3] = 0
						super(40868, 40869, order)
					end
				end

				class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40854
						order[1] = 0
						super(40977, 40854, order)
					end
				end

				class NoPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41162
						order[1] = 41163
						order[2] = 0
						super(41161, 41162, order)
					end
				end

				class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40863
						order[1] = 0
						super(40945, 40863, order)
					end
				end
			end

			class NoPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40873
					order[1] = 40874
					order[2] = 42698
					order[3] = 42699
					order[4] = 42700
					order[5] = 42701
					order[6] = 42702
					order[7] = 42703
					order[8] = 42704
					order[9] = 42689
					order[10] = 42690
					order[11] = 42691
					order[12] = 42692
					order[13] = 42693
					order[14] = 42694
					order[15] = 42695
					order[16] = 40875
					order[17] = 40876
					order[18] = 40877
					order[19] = 40878
					order[20] = 40879
					order[21] = 40880
					order[22] = 40881
					order[23] = 40882
					order[24] = 40883
					order[25] = 40884
					order[26] = 40885
					order[27] = 40886
					order[28] = 40887
					order[29] = 40888
					order[30] = 40889
					order[31] = 40890
					order[32] = 40891
					order[33] = 40892
					order[34] = 40893
					order[35] = 40894
					order[36] = 40895
					order[37] = 40896
					order[38] = 40897
					order[39] = 40898
					order[40] = 40899
					order[41] = 40900
					order[42] = 40901
					order[43] = 0
					super(40872, 40873, order)
				end

				class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42706
						order[1] = 0
						super(42705, 42706, order)
					end
				end

				class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42697
						order[1] = 0
						super(42696, 42697, order)
					end
				end
			end

			class NoDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41086
					order[1] = 0
					super(41085, 41086, order)
				end
			end

			class NoDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41082
					order[1] = 41083
					order[2] = 41084
					order[3] = 0
					super(41081, 41082, order)
				end
			end

			class NoDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41038
					order[1] = 41039
					order[2] = 41040
					order[3] = 41041
					order[4] = 41042
					order[5] = 41043
					order[6] = 41044
					order[7] = 41045
					order[8] = 41046
					order[9] = 41047
					order[10] = 41048
					order[11] = 41049
					order[12] = 41050
					order[13] = 41051
					order[14] = 0
					super(41037, 41038, order)
				end

				class NoDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41052
						order[1] = 41053
						order[2] = 41054
						order[3] = 0
						super(41051, 41052, order)
					end

					class NoDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41055
							order[1] = 41056
							order[2] = 41057
							order[3] = 0
							super(41054, 41055, order)
						end
					end
				end
			end
		end

		class NoProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40091
				order[1] = 40092
				order[2] = 40093
				order[3] = 40957
				order[4] = 40095
				order[5] = 40096
				order[6] = 40097
				order[7] = 42707
				order[8] = 42708
				order[9] = 40098
				order[10] = 40099
				order[11] = 40100
				order[12] = 40114
				order[13] = 40115
				order[14] = 40116
				order[15] = 40118
				order[16] = 40119
				order[17] = 40120
				order[18] = 40121
				order[19] = 40122
				order[20] = 40123
				order[21] = 40125
				order[22] = 40126
				order[23] = 40127
				order[24] = 40128
				order[25] = 40129
				order[26] = 40130
				order[27] = 40131
				order[28] = 40132
				order[29] = 40133
				order[30] = 40134
				order[31] = 40135
				order[32] = 40136
				order[33] = 40137
				order[34] = 40138
				order[35] = 40139
				order[36] = 40140
				order[37] = 40141
				order[38] = 40145
				order[39] = 40146
				order[40] = 40148
				order[41] = 40149
				order[42] = 40150
				order[43] = 40151
				order[44] = 40152
				order[45] = 40153
				order[46] = 40154
				order[47] = 40155
				order[48] = 40156
				order[49] = 40158
				order[50] = 40159
				order[51] = 40160
				order[52] = 40161
				order[53] = 40162
				order[54] = 40101
				order[55] = 40102
				order[56] = 40103
				order[57] = 40104
				order[58] = 40105
				order[59] = 40106
				order[60] = 40107
				order[61] = 40163
				order[62] = 40165
				order[63] = 40166
				order[64] = 40167
				order[65] = 40168
				order[66] = 40169
				order[67] = 40170
				order[68] = 40108
				order[69] = 40109
				order[70] = 40110
				order[71] = 40111
				order[72] = 40112
				order[73] = 41406
				order[74] = 40113
				order[75] = 40986
				order[76] = 40987
				order[77] = 40174
				order[78] = 0
				super(40090, 40091, order)
			end

			class NoProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40094
					order[1] = 0
					super(40957, 40094, order)
				end
			end

			class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40117
					order[1] = 0
					super(40953, 40117, order)
				end
			end

			class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40124
					order[1] = 0
					super(40954, 40124, order)
				end
			end

			class NoProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40143
					order[1] = 40144
					order[2] = 0
					super(40142, 40143, order)
				end
			end

			class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40147
					order[1] = 0
					super(40955, 40147, order)
				end
			end

			class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40157
					order[1] = 0
					super(40956, 40157, order)
				end
			end

			class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40164
					order[1] = 0
					super(40952, 40164, order)
				end
			end

			class NoProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40172
					order[1] = 40173
					order[2] = 0
					super(40171, 40172, order)
				end
			end

			class NoProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40175
					order[1] = 40176
					order[2] = 40177
					order[3] = 2385
					order[4] = 40178
					order[5] = 0
					super(40174, 40175, order)
				end

				class NoProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40179
						order[1] = 40180
						order[2] = 0
						super(40178, 40179, order)
					end
				end
			end
		end

		class NoAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40020
				order[1] = 40021
				order[2] = 40000
				order[3] = 0
				super(40019, 40020, order)
			end

			class NoAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 40001
					order[1] = 40002
					order[2] = 40003
					order[3] = 40004
					order[4] = 40005
					order[5] = 40006
					order[6] = 40007
					order[7] = 40008
					order[8] = 40009
					order[9] = 40010
					order[10] = 40011
					order[11] = 40012
					order[12] = 40013
					order[13] = 40014
					order[14] = 40015
					order[15] = 40016
					order[16] = 40017
					order[17] = 40018
					order[18] = 0
					super(40000, 40001, order)
				end
			end
		end

		class NoProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 40182
				order[1] = 40183
				order[2] = 40184
				order[3] = 40185
				order[4] = 40186
				order[5] = 40187
				order[6] = 40188
				order[7] = 40951
				order[8] = 40191
				order[9] = 40201
				order[10] = 40190
				order[11] = 0
				super(40181, 40182, order)
			end

			class NoProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40189
					order[1] = 0
					super(40951, 40189, order)
				end
			end

			class NoProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40192
					order[1] = 40193
					order[2] = 40194
					order[3] = 40195
					order[4] = 40196
					order[5] = 40197
					order[6] = 40198
					order[7] = 40199
					order[8] = 0
					super(40191, 40192, order)
				end

				class NoProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40200
						order[1] = 0
						super(40199, 40200, order)
					end
				end
			end

			class NoProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40202
					order[1] = 40203
					order[2] = 0
					super(40201, 40202, order)
				end
			end
		end

		class NoCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 40023
				order[1] = 40024
				order[2] = 40916
				order[3] = 40917
				order[4] = 40025
				order[5] = 40026
				order[6] = 40027
				order[7] = 40028
				order[8] = 40029
				order[9] = 40030
				order[10] = 40031
				order[11] = 40277
				order[12] = 42216
				order[13] = 42217
				order[14] = 40033
				order[15] = 40034
				order[16] = 42207
				order[17] = 42208
				order[18] = 42209
				order[19] = 42210
				order[20] = 42211
				order[21] = 42212
				order[22] = 42213
				order[23] = 40035
				order[24] = 40036
				order[25] = 40037
				order[26] = 40038
				order[27] = 40039
				order[28] = 0
				super(40022, 40023, order)
			end

			class NoCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40032
					order[1] = 0
					super(40277, 40032, order)
				end
			end

			class NoCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42215
					order[1] = 0
					super(42214, 42215, order)
				end
			end
		end

		class NoPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40209
				order[1] = 40205
				order[2] = 40206
				order[3] = 40207
				order[4] = 40208
				order[5] = 0
				super(40204, 40209, order)
			end

			class NoPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40210
					order[1] = 40211
					order[2] = 0
					super(40209, 40210, order)
				end
			end
		end

		class NoExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42297
				order[1] = 42298
				order[2] = 0
				super(42296, 42297, order)
			end
		end

		class NoInstrAttrib < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 871
				order[1] = 872
				order[2] = 0
				super(870, 871, order)
			end
		end

		class NoIndexRollMonths < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 2733
				order[1] = 0
				super(2734, 2733, order)
			end
		end

		class NoReferenceDataDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2747
				order[1] = 2748
				order[2] = 0
				super(2746, 2747, order)
			end
		end

		class NoContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40041
				order[1] = 0
				super(40040, 40041, order)
			end
		end

		class NoFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40047
				order[1] = 40048
				order[2] = 0
				super(40046, 40047, order)
			end
		end

		class NoContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40043
				order[1] = 40044
				order[2] = 40045
				order[3] = 0
				super(40042, 40043, order)
			end
		end

		class NoUnderlyings < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(188)
				order[0] = 311
				order[1] = 312
				order[2] = 309
				order[3] = 305
				order[4] = 2874
				order[5] = 462
				order[6] = 463
				order[7] = 2894
				order[8] = 310
				order[9] = 763
				order[10] = 313
				order[11] = 542
				order[12] = 1213
				order[13] = 1837
				order[14] = 241
				order[15] = 1453
				order[16] = 1454
				order[17] = 2614
				order[18] = 2615
				order[19] = 2921
				order[20] = 2616
				order[21] = 2617
				order[22] = 2619
				order[23] = 1455
				order[24] = 1456
				order[25] = 1459
				order[26] = 1460
				order[27] = 242
				order[28] = 243
				order[29] = 244
				order[30] = 245
				order[31] = 246
				order[32] = 256
				order[33] = 595
				order[34] = 592
				order[35] = 593
				order[36] = 594
				order[37] = 247
				order[38] = 316
				order[39] = 941
				order[40] = 2917
				order[41] = 317
				order[42] = 436
				order[43] = 1437
				order[44] = 2363
				order[45] = 1441
				order[46] = 998
				order[47] = 1423
				order[48] = 1718
				order[49] = 2918
				order[50] = 1424
				order[51] = 1425
				order[52] = 1719
				order[53] = 2919
				order[54] = 1000
				order[55] = 1419
				order[56] = 1526
				order[57] = 2920
				order[58] = 435
				order[59] = 308
				order[60] = 306
				order[61] = 362
				order[62] = 363
				order[63] = 2742
				order[64] = 2720
				order[65] = 2721
				order[66] = 2722
				order[67] = 2723
				order[68] = 2724
				order[69] = 307
				order[70] = 364
				order[71] = 365
				order[72] = 877
				order[73] = 878
				order[74] = 972
				order[75] = 318
				order[76] = 2916
				order[77] = 879
				order[78] = 975
				order[79] = 973
				order[80] = 974
				order[81] = 810
				order[82] = 882
				order[83] = 883
				order[84] = 884
				order[85] = 885
				order[86] = 886
				order[87] = 2885
				order[88] = 2886
				order[89] = 1044
				order[90] = 1045
				order[91] = 1046
				order[92] = 1038
				order[93] = 1039
				order[94] = 315
				order[95] = 2683
				order[96] = 2687
				order[97] = 1988
				order[98] = 1989
				order[99] = 1990
				order[100] = 1991
				order[101] = 1992
				order[102] = 1993
				order[103] = 2881
				order[104] = 1994
				order[105] = 1995
				order[106] = 1996
				order[107] = 1997
				order[108] = 2620
				order[109] = 2621
				order[110] = 1998
				order[111] = 1999
				order[112] = 2000
				order[113] = 2003
				order[114] = 2004
				order[115] = 2005
				order[116] = 2006
				order[117] = 2284
				order[118] = 2285
				order[119] = 2286
				order[120] = 2287
				order[121] = 2288
				order[122] = 2007
				order[123] = 2008
				order[124] = 2009
				order[125] = 2010
				order[126] = 2011
				order[127] = 2012
				order[128] = 2491
				order[129] = 2013
				order[130] = 2014
				order[131] = 2015
				order[132] = 2744
				order[133] = 2016
				order[134] = 2289
				order[135] = 2017
				order[136] = 2018
				order[137] = 2019
				order[138] = 2020
				order[139] = 2021
				order[140] = 2022
				order[141] = 2290
				order[142] = 2622
				order[143] = 2291
				order[144] = 2623
				order[145] = 2292
				order[146] = 2023
				order[147] = 2024
				order[148] = 2025
				order[149] = 2026
				order[150] = 2027
				order[151] = 2028
				order[152] = 2029
				order[153] = 2757
				order[154] = 2030
				order[155] = 2031
				order[156] = 2293
				order[157] = 2294
				order[158] = 2032
				order[159] = 2033
				order[160] = 2034
				order[161] = 2035
				order[162] = 2036
				order[163] = 2037
				order[164] = 2038
				order[165] = 2039
				order[166] = 2040
				order[167] = 2041
				order[168] = 2042
				order[169] = 2043
				order[170] = 2044
				order[171] = 41314
				order[172] = 41315
				order[173] = 2295
				order[174] = 2296
				order[175] = 2297
				order[176] = 2756
				order[177] = 2298
				order[178] = 2299
				order[179] = 2624
				order[180] = 2625
				order[181] = 2626
				order[182] = 2627
				order[183] = 2628
				order[184] = 2629
				order[185] = 2630
				order[186] = 2631
				order[187] = 0
				super(711, 311, order)
			end

			class NoUnderlyingSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 458
					order[1] = 459
					order[2] = 2959
					order[3] = 0
					super(457, 458, order)
				end
			end

			class NoUnderlyingStips < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 888
					order[1] = 889
					order[2] = 0
					super(887, 888, order)
				end
			end

			class NoUndlyInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 1059
					order[1] = 1060
					order[2] = 1061
					order[3] = 2391
					order[4] = 1062
					order[5] = 0
					super(1058, 1059, order)
				end

				class NoUndlyInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1063
						order[1] = 1064
						order[2] = 0
						super(1062, 1063, order)
					end
				end
			end

			class NoUnderlyingEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 1982
					order[1] = 1983
					order[2] = 1984
					order[3] = 1985
					order[4] = 1986
					order[5] = 2342
					order[6] = 1987
					order[7] = 2071
					order[8] = 2072
					order[9] = 2073
					order[10] = 0
					super(1981, 1982, order)
				end
			end

			class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2081
					order[1] = 2082
					order[2] = 2083
					order[3] = 2745
					order[4] = 0
					super(2080, 2081, order)
				end
			end

			class NoUnderlyingAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2313
					order[1] = 2314
					order[2] = 2315
					order[3] = 0
					super(2312, 2313, order)
				end
			end

			class NoUnderlyingComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2046
					order[1] = 2261
					order[2] = 2262
					order[3] = 2263
					order[4] = 2047
					order[5] = 2264
					order[6] = 2265
					order[7] = 2266
					order[8] = 2947
					order[9] = 2048
					order[10] = 2267
					order[11] = 2049
					order[12] = 2050
					order[13] = 2051
					order[14] = 2052
					order[15] = 2053
					order[16] = 2268
					order[17] = 2948
					order[18] = 2269
					order[19] = 2949
					order[20] = 2270
					order[21] = 2271
					order[22] = 2419
					order[23] = 2420
					order[24] = 2272
					order[25] = 2273
					order[26] = 2274
					order[27] = 2275
					order[28] = 2276
					order[29] = 41732
					order[30] = 41739
					order[31] = 41740
					order[32] = 41741
					order[33] = 41742
					order[34] = 41743
					order[35] = 41744
					order[36] = 41745
					order[37] = 41746
					order[38] = 41747
					order[39] = 41729
					order[40] = 2277
					order[41] = 2278
					order[42] = 2279
					order[43] = 2280
					order[44] = 2281
					order[45] = 41748
					order[46] = 41716
					order[47] = 2611
					order[48] = 2612
					order[49] = 2613
					order[50] = 2282
					order[51] = 2283
					order[52] = 0
					super(2045, 2046, order)
				end

				class NoUnderlyingComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2054
						order[1] = 2055
						order[2] = 2056
						order[3] = 0
						super(2053, 2054, order)
					end

					class NoUnderlyingComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2057
							order[1] = 2058
							order[2] = 0
							super(2056, 2057, order)
						end
					end
				end

				class NoUnderlyingComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41733
						order[1] = 41734
						order[2] = 41735
						order[3] = 41736
						order[4] = 0
						super(41732, 41733, order)
					end
				end

				class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41738
						order[1] = 0
						super(41737, 41738, order)
					end
				end

				class NoUnderlyingComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41730
						order[1] = 41731
						order[2] = 41750
						order[3] = 41726
						order[4] = 41713
						order[5] = 0
						super(41729, 41730, order)
					end

					class NoUnderlyingComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41751
							order[1] = 41752
							order[2] = 41753
							order[3] = 41754
							order[4] = 41755
							order[5] = 0
							super(41750, 41751, order)
						end
					end

					class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41727
							order[1] = 41728
							order[2] = 0
							super(41726, 41727, order)
						end
					end

					class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41714
							order[1] = 41715
							order[2] = 0
							super(41713, 41714, order)
						end
					end
				end

				class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41749
						order[1] = 0
						super(41748, 41749, order)
					end
				end

				class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41717
						order[1] = 41718
						order[2] = 41719
						order[3] = 41720
						order[4] = 41721
						order[5] = 41722
						order[6] = 41723
						order[7] = 41724
						order[8] = 0
						super(41716, 41717, order)
					end

					class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41725
							order[1] = 0
							super(41724, 41725, order)
						end
					end
				end
			end

			class NoUnderlyingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40963
					order[1] = 0
					super(40962, 40963, order)
				end
			end

			class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41948
					order[1] = 0
					super(41947, 41948, order)
				end
			end

			class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41865
					order[1] = 41338
					order[2] = 0
					super(41864, 41865, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41867
					order[1] = 41339
					order[2] = 0
					super(41866, 41867, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41869
					order[1] = 41870
					order[2] = 41871
					order[3] = 41872
					order[4] = 41873
					order[5] = 41874
					order[6] = 41875
					order[7] = 41876
					order[8] = 41877
					order[9] = 0
					super(41868, 41869, order)
				end
			end

			class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 43075
					order[1] = 0
					super(43074, 43075, order)
				end
			end

			class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41821
					order[1] = 0
					super(41820, 41821, order)
				end
			end

			class NoUnderlyingOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41842
					order[1] = 41843
					order[2] = 0
					super(41841, 41842, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41845
					order[1] = 0
					super(41844, 41845, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41857
					order[1] = 41858
					order[2] = 0
					super(41856, 41857, order)
				end
			end

			class NoUnderlyingStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40541
					order[1] = 42016
					order[2] = 40542
					order[3] = 43083
					order[4] = 43084
					order[5] = 40543
					order[6] = 40544
					order[7] = 42018
					order[8] = 40545
					order[9] = 40546
					order[10] = 43085
					order[11] = 43086
					order[12] = 42019
					order[13] = 42020
					order[14] = 42021
					order[15] = 42022
					order[16] = 42023
					order[17] = 42024
					order[18] = 41964
					order[19] = 41965
					order[20] = 41966
					order[21] = 41967
					order[22] = 41968
					order[23] = 41969
					order[24] = 41970
					order[25] = 42589
					order[26] = 41971
					order[27] = 41972
					order[28] = 41973
					order[29] = 41974
					order[30] = 41975
					order[31] = 41976
					order[32] = 41977
					order[33] = 41978
					order[34] = 41979
					order[35] = 41980
					order[36] = 41981
					order[37] = 41982
					order[38] = 41983
					order[39] = 41984
					order[40] = 41985
					order[41] = 41986
					order[42] = 41987
					order[43] = 41988
					order[44] = 41989
					order[45] = 40057
					order[46] = 40058
					order[47] = 40060
					order[48] = 40061
					order[49] = 40062
					order[50] = 40063
					order[51] = 40064
					order[52] = 40548
					order[53] = 40549
					order[54] = 40551
					order[55] = 40552
					order[56] = 40553
					order[57] = 40554
					order[58] = 40555
					order[59] = 41957
					order[60] = 41958
					order[61] = 40556
					order[62] = 40558
					order[63] = 40559
					order[64] = 40561
					order[65] = 40562
					order[66] = 40563
					order[67] = 40564
					order[68] = 40565
					order[69] = 40566
					order[70] = 40567
					order[71] = 41959
					order[72] = 41960
					order[73] = 41961
					order[74] = 40568
					order[75] = 40569
					order[76] = 40570
					order[77] = 42895
					order[78] = 40571
					order[79] = 40572
					order[80] = 43107
					order[81] = 40573
					order[82] = 40574
					order[83] = 40575
					order[84] = 40576
					order[85] = 40577
					order[86] = 42896
					order[87] = 42897
					order[88] = 42898
					order[89] = 42899
					order[90] = 40578
					order[91] = 40579
					order[92] = 40580
					order[93] = 41897
					order[94] = 41898
					order[95] = 41899
					order[96] = 41900
					order[97] = 41901
					order[98] = 41902
					order[99] = 41903
					order[100] = 42900
					order[101] = 40664
					order[102] = 40708
					order[103] = 41777
					order[104] = 41778
					order[105] = 41779
					order[106] = 41780
					order[107] = 41781
					order[108] = 42196
					order[109] = 42197
					order[110] = 41782
					order[111] = 41783
					order[112] = 41784
					order[113] = 41785
					order[114] = 41786
					order[115] = 41587
					order[116] = 41787
					order[117] = 41788
					order[118] = 41789
					order[119] = 41790
					order[120] = 41791
					order[121] = 41792
					order[122] = 41793
					order[123] = 41794
					order[124] = 41795
					order[125] = 41796
					order[126] = 41797
					order[127] = 41798
					order[128] = 41799
					order[129] = 43096
					order[130] = 41756
					order[131] = 40547
					order[132] = 40988
					order[133] = 40989
					order[134] = 0
					super(40540, 40541, order)
				end

				class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41991
						order[1] = 41992
						order[2] = 0
						super(41990, 41991, order)
					end
				end

				class NoUnderlyingStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41801
						order[1] = 41802
						order[2] = 41803
						order[3] = 0
						super(41800, 41801, order)
					end
				end

				class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41994
						order[1] = 41995
						order[2] = 0
						super(41993, 41994, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41963
						order[1] = 0
						super(41962, 41963, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 42003
						order[1] = 42004
						order[2] = 42005
						order[3] = 42006
						order[4] = 42007
						order[5] = 42008
						order[6] = 42009
						order[7] = 42010
						order[8] = 42011
						order[9] = 42012
						order[10] = 42013
						order[11] = 41996
						order[12] = 42014
						order[13] = 42015
						order[14] = 0
						super(42002, 42003, order)
					end

					class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41997
							order[1] = 41998
							order[2] = 41999
							order[3] = 0
							super(41996, 41997, order)
						end

						class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 42000
								order[1] = 42001
								order[2] = 41936
								order[3] = 0
								super(41999, 42000, order)
							end
						end
					end
				end

				class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40059
						order[1] = 0
						super(40975, 40059, order)
					end
				end

				class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40550
						order[1] = 0
						super(40976, 40550, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40557
						order[1] = 0
						super(40973, 40557, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41955
						order[1] = 41956
						order[2] = 0
						super(41954, 41955, order)
					end
				end

				class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40560
						order[1] = 0
						super(40974, 40560, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40582
						order[1] = 0
						super(40969, 40582, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41938
						order[1] = 41939
						order[2] = 0
						super(41937, 41938, order)
					end
				end

				class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40594
						order[1] = 0
						super(40970, 40594, order)
					end
				end

				class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40600
						order[1] = 0
						super(40971, 40600, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40607
						order[1] = 0
						super(40972, 40607, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42956
						order[1] = 42957
						order[2] = 0
						super(42955, 42956, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41910
						order[1] = 0
						super(41909, 41910, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41945
						order[1] = 41946
						order[2] = 0
						super(41944, 41945, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41942
						order[1] = 41943
						order[2] = 0
						super(41941, 41942, order)
					end
				end

				class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43111
						order[1] = 42982
						order[2] = 42983
						order[3] = 0
						super(42981, 43111, order)
					end
				end

				class NoUnderlyingDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42863
						order[1] = 42864
						order[2] = 42865
						order[3] = 42866
						order[4] = 42867
						order[5] = 42868
						order[6] = 42882
						order[7] = 42869
						order[8] = 42870
						order[9] = 42871
						order[10] = 42872
						order[11] = 42873
						order[12] = 42874
						order[13] = 42875
						order[14] = 42876
						order[15] = 42877
						order[16] = 42878
						order[17] = 42879
						order[18] = 42880
						order[19] = 42881
						order[20] = 0
						super(42862, 42863, order)
					end

					class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42883
							order[1] = 0
							super(42882, 42883, order)
						end
					end
				end

				class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42854
						order[1] = 0
						super(42853, 42854, order)
					end
				end

				class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42800
						order[1] = 0
						super(42799, 42800, order)
					end
				end

				class NoUnderlyingReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 43035
						order[1] = 43036
						order[2] = 43037
						order[3] = 43038
						order[4] = 43039
						order[5] = 43040
						order[6] = 43064
						order[7] = 43030
						order[8] = 43041
						order[9] = 43042
						order[10] = 43043
						order[11] = 43044
						order[12] = 43045
						order[13] = 43046
						order[14] = 43047
						order[15] = 43048
						order[16] = 43049
						order[17] = 43050
						order[18] = 43051
						order[19] = 43052
						order[20] = 43060
						order[21] = 43053
						order[22] = 43054
						order[23] = 43008
						order[24] = 43055
						order[25] = 43056
						order[26] = 43057
						order[27] = 43058
						order[28] = 43059
						order[29] = 0
						super(43034, 43035, order)
					end

					class NoUnderlyingReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 43065
							order[1] = 43066
							order[2] = 43067
							order[3] = 43068
							order[4] = 0
							super(43064, 43065, order)
						end
					end

					class NoUnderlyingReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43031
							order[1] = 43032
							order[2] = 43033
							order[3] = 0
							super(43030, 43031, order)
						end
					end

					class NoUnderlyingReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43061
							order[1] = 43062
							order[2] = 43063
							order[3] = 0
							super(43060, 43061, order)
						end
					end

					class NoUnderlyingReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 43009
							order[1] = 43071
							order[2] = 43010
							order[3] = 43011
							order[4] = 43012
							order[5] = 43013
							order[6] = 43014
							order[7] = 43015
							order[8] = 43016
							order[9] = 43017
							order[10] = 43018
							order[11] = 43019
							order[12] = 43020
							order[13] = 43021
							order[14] = 43022
							order[15] = 43023
							order[16] = 43024
							order[17] = 43025
							order[18] = 43026
							order[19] = 43027
							order[20] = 43028
							order[21] = 43029
							order[22] = 43069
							order[23] = 0
							super(43008, 43009, order)
						end

						class NoUnderlyingReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 43072
								order[1] = 43073
								order[2] = 0
								super(43071, 43072, order)
							end
						end

						class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 43070
								order[1] = 0
								super(43069, 43070, order)
							end
						end
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42916
						order[1] = 0
						super(42915, 42916, order)
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42902
						order[1] = 42903
						order[2] = 0
						super(42901, 42902, order)
					end
				end

				class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40650
						order[1] = 0
						super(40968, 40650, order)
					end
				end

				class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40657
						order[1] = 40658
						order[2] = 0
						super(40656, 40657, order)
					end
				end

				class NoUnderlyingSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40660
						order[1] = 40904
						order[2] = 40915
						order[3] = 40662
						order[4] = 40663
						order[5] = 0
						super(40659, 40660, order)
					end
				end

				class NoUnderlyingPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40665
						order[1] = 41881
						order[2] = 41882
						order[3] = 40666
						order[4] = 40667
						order[5] = 40668
						order[6] = 40669
						order[7] = 40670
						order[8] = 40671
						order[9] = 40672
						order[10] = 40673
						order[11] = 40674
						order[12] = 40675
						order[13] = 41883
						order[14] = 41884
						order[15] = 41885
						order[16] = 41886
						order[17] = 40676
						order[18] = 40677
						order[19] = 40678
						order[20] = 40679
						order[21] = 41887
						order[22] = 41888
						order[23] = 41889
						order[24] = 41890
						order[25] = 40680
						order[26] = 40681
						order[27] = 40682
						order[28] = 40683
						order[29] = 40684
						order[30] = 40685
						order[31] = 40704
						order[32] = 40686
						order[33] = 40687
						order[34] = 40688
						order[35] = 40689
						order[36] = 40966
						order[37] = 40691
						order[38] = 40692
						order[39] = 40693
						order[40] = 41891
						order[41] = 41892
						order[42] = 40694
						order[43] = 41878
						order[44] = 41893
						order[45] = 41894
						order[46] = 41895
						order[47] = 41896
						order[48] = 40695
						order[49] = 40696
						order[50] = 40697
						order[51] = 40698
						order[52] = 40967
						order[53] = 40700
						order[54] = 40701
						order[55] = 40702
						order[56] = 40703
						order[57] = 0
						super(40664, 40665, order)
					end

					class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40705
							order[1] = 40706
							order[2] = 40707
							order[3] = 0
							super(40704, 40705, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40690
							order[1] = 0
							super(40966, 40690, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41879
							order[1] = 41880
							order[2] = 0
							super(41878, 41879, order)
						end
					end

					class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40699
							order[1] = 0
							super(40967, 40699, order)
						end
					end
				end

				class NoUnderlyingPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40709
						order[1] = 40710
						order[2] = 42993
						order[3] = 42994
						order[4] = 42995
						order[5] = 42996
						order[6] = 42997
						order[7] = 42998
						order[8] = 42999
						order[9] = 42984
						order[10] = 42985
						order[11] = 42986
						order[12] = 42987
						order[13] = 42988
						order[14] = 42989
						order[15] = 42990
						order[16] = 40711
						order[17] = 40712
						order[18] = 40713
						order[19] = 40714
						order[20] = 40715
						order[21] = 40716
						order[22] = 40717
						order[23] = 40718
						order[24] = 40719
						order[25] = 40720
						order[26] = 40721
						order[27] = 40722
						order[28] = 40723
						order[29] = 40724
						order[30] = 40725
						order[31] = 40726
						order[32] = 40727
						order[33] = 40728
						order[34] = 40729
						order[35] = 40730
						order[36] = 40731
						order[37] = 40732
						order[38] = 40733
						order[39] = 40734
						order[40] = 40735
						order[41] = 40736
						order[42] = 40737
						order[43] = 0
						super(40708, 40709, order)
					end

					class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43001
							order[1] = 0
							super(43000, 43001, order)
						end
					end

					class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42992
							order[1] = 0
							super(42991, 42992, order)
						end
					end
				end

				class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41809
						order[1] = 0
						super(41808, 41809, order)
					end
				end

				class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41805
						order[1] = 41806
						order[2] = 41807
						order[3] = 0
						super(41804, 41805, order)
					end
				end

				class NoUnderlyingDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41757
						order[1] = 41758
						order[2] = 41759
						order[3] = 41760
						order[4] = 41761
						order[5] = 41762
						order[6] = 41763
						order[7] = 41764
						order[8] = 41765
						order[9] = 41766
						order[10] = 41767
						order[11] = 41768
						order[12] = 41769
						order[13] = 41770
						order[14] = 0
						super(41756, 41757, order)
					end

					class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41771
							order[1] = 41772
							order[2] = 41773
							order[3] = 0
							super(41770, 41771, order)
						end

						class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41774
								order[1] = 41775
								order[2] = 41776
								order[3] = 0
								super(41773, 41774, order)
							end
						end
					end
				end
			end

			class NoUnderlyingProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 42150
					order[1] = 42151
					order[2] = 42152
					order[3] = 42190
					order[4] = 42153
					order[5] = 42154
					order[6] = 42155
					order[7] = 43002
					order[8] = 43003
					order[9] = 42156
					order[10] = 42157
					order[11] = 42158
					order[12] = 42104
					order[13] = 42105
					order[14] = 42106
					order[15] = 42107
					order[16] = 42108
					order[17] = 42109
					order[18] = 42110
					order[19] = 42111
					order[20] = 42115
					order[21] = 42116
					order[22] = 42117
					order[23] = 42118
					order[24] = 42119
					order[25] = 42120
					order[26] = 42121
					order[27] = 42122
					order[28] = 42123
					order[29] = 42124
					order[30] = 42125
					order[31] = 42126
					order[32] = 42127
					order[33] = 42128
					order[34] = 42129
					order[35] = 42130
					order[36] = 42131
					order[37] = 42132
					order[38] = 42133
					order[39] = 42134
					order[40] = 42135
					order[41] = 42136
					order[42] = 42137
					order[43] = 42138
					order[44] = 42139
					order[45] = 42140
					order[46] = 42141
					order[47] = 42142
					order[48] = 42143
					order[49] = 42144
					order[50] = 42145
					order[51] = 42146
					order[52] = 42147
					order[53] = 42148
					order[54] = 42159
					order[55] = 42160
					order[56] = 42161
					order[57] = 42162
					order[58] = 42163
					order[59] = 42164
					order[60] = 42165
					order[61] = 42092
					order[62] = 42093
					order[63] = 42094
					order[64] = 42095
					order[65] = 42096
					order[66] = 42097
					order[67] = 42098
					order[68] = 42166
					order[69] = 42167
					order[70] = 42168
					order[71] = 42169
					order[72] = 42102
					order[73] = 42103
					order[74] = 42170
					order[75] = 42171
					order[76] = 42172
					order[77] = 42173
					order[78] = 0
					super(42149, 42150, order)
				end

				class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42191
						order[1] = 0
						super(42190, 42191, order)
					end
				end

				class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42183
						order[1] = 0
						super(42182, 42183, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42185
						order[1] = 0
						super(42184, 42185, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42113
						order[1] = 42114
						order[2] = 0
						super(42112, 42113, order)
					end
				end

				class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42187
						order[1] = 0
						super(42186, 42187, order)
					end
				end

				class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42189
						order[1] = 0
						super(42188, 42189, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42181
						order[1] = 0
						super(42180, 42181, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42100
						order[1] = 42101
						order[2] = 0
						super(42099, 42100, order)
					end
				end

				class NoUnderlyingProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 42174
						order[1] = 42175
						order[2] = 42176
						order[3] = 40918
						order[4] = 42177
						order[5] = 0
						super(42173, 42174, order)
					end

					class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42178
							order[1] = 42179
							order[2] = 0
							super(42177, 42178, order)
						end
					end
				end
			end

			class NoUnderlyingAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42037
					order[1] = 42038
					order[2] = 41340
					order[3] = 0
					super(42036, 42037, order)
				end

				class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41341
						order[1] = 41701
						order[2] = 41709
						order[3] = 41710
						order[4] = 41711
						order[5] = 41712
						order[6] = 42017
						order[7] = 42025
						order[8] = 42026
						order[9] = 42027
						order[10] = 42028
						order[11] = 42029
						order[12] = 42030
						order[13] = 42031
						order[14] = 42032
						order[15] = 42033
						order[16] = 42034
						order[17] = 42035
						order[18] = 0
						super(41340, 41341, order)
					end
				end
			end

			class NoUnderlyingProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 42069
					order[1] = 42070
					order[2] = 42071
					order[3] = 42072
					order[4] = 42073
					order[5] = 42074
					order[6] = 42075
					order[7] = 42090
					order[8] = 42077
					order[9] = 42087
					order[10] = 42076
					order[11] = 0
					super(42068, 42069, order)
				end

				class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42091
						order[1] = 0
						super(42090, 42091, order)
					end
				end

				class NoUnderlyingProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 42078
						order[1] = 42079
						order[2] = 42080
						order[3] = 42081
						order[4] = 42082
						order[5] = 42083
						order[6] = 42084
						order[7] = 42085
						order[8] = 0
						super(42077, 42078, order)
					end

					class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42086
							order[1] = 0
							super(42085, 42086, order)
						end
					end
				end

				class NoUnderlyingProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42088
						order[1] = 42089
						order[2] = 0
						super(42087, 42088, order)
					end
				end
			end

			class NoUnderlyingCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 42042
					order[1] = 42043
					order[2] = 42044
					order[3] = 42045
					order[4] = 42046
					order[5] = 42047
					order[6] = 42048
					order[7] = 42049
					order[8] = 42050
					order[9] = 42051
					order[10] = 42052
					order[11] = 42039
					order[12] = 42797
					order[13] = 42798
					order[14] = 42053
					order[15] = 42054
					order[16] = 42790
					order[17] = 42791
					order[18] = 42792
					order[19] = 42793
					order[20] = 42794
					order[21] = 42795
					order[22] = 42796
					order[23] = 42055
					order[24] = 42056
					order[25] = 42057
					order[26] = 42058
					order[27] = 42059
					order[28] = 0
					super(42041, 42042, order)
				end

				class NoUnderlyingCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42040
						order[1] = 0
						super(42039, 42040, order)
					end
				end

				class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42789
						order[1] = 0
						super(42788, 42789, order)
					end
				end
			end

			class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42065
					order[1] = 42061
					order[2] = 42062
					order[3] = 42063
					order[4] = 42064
					order[5] = 0
					super(42060, 42065, order)
				end

				class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42066
						order[1] = 42067
						order[2] = 0
						super(42065, 42066, order)
					end
				end
			end

			class NoUnderlyingRateSpreadSteps < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 43006
					order[1] = 43007
					order[2] = 0
					super(43005, 43006, order)
				end
			end

			class NoUnderlyingDividendPayments < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42856
					order[1] = 42857
					order[2] = 42858
					order[3] = 42859
					order[4] = 0
					super(42855, 42856, order)
				end
			end

			class NoUnderlyingExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42885
					order[1] = 42886
					order[2] = 0
					super(42884, 42885, order)
				end
			end
		end

		class NoLegs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(176)
				order[0] = 600
				order[1] = 601
				order[2] = 602
				order[3] = 603
				order[4] = 1788
				order[5] = 607
				order[6] = 1594
				order[7] = 608
				order[8] = 2893
				order[9] = 609
				order[10] = 764
				order[11] = 610
				order[12] = 611
				order[13] = 1212
				order[14] = 2146
				order[15] = 2147
				order[16] = 2148
				order[17] = 248
				order[18] = 2149
				order[19] = 2150
				order[20] = 2151
				order[21] = 2152
				order[22] = 2153
				order[23] = 2154
				order[24] = 2155
				order[25] = 2348
				order[26] = 2067
				order[27] = 2068
				order[28] = 2069
				order[29] = 2739
				order[30] = 2070
				order[31] = 2156
				order[32] = 2157
				order[33] = 2158
				order[34] = 2159
				order[35] = 2160
				order[36] = 2161
				order[37] = 2162
				order[38] = 2163
				order[39] = 2164
				order[40] = 2165
				order[41] = 2880
				order[42] = 2166
				order[43] = 2167
				order[44] = 2168
				order[45] = 2169
				order[46] = 2170
				order[47] = 2171
				order[48] = 2172
				order[49] = 2173
				order[50] = 2174
				order[51] = 2175
				order[52] = 2176
				order[53] = 2177
				order[54] = 2178
				order[55] = 2179
				order[56] = 2180
				order[57] = 249
				order[58] = 250
				order[59] = 251
				order[60] = 252
				order[61] = 253
				order[62] = 257
				order[63] = 599
				order[64] = 596
				order[65] = 597
				order[66] = 598
				order[67] = 254
				order[68] = 612
				order[69] = 942
				order[70] = 2908
				order[71] = 2181
				order[72] = 2182
				order[73] = 2183
				order[74] = 2184
				order[75] = 2604
				order[76] = 2185
				order[77] = 2605
				order[78] = 2186
				order[79] = 2187
				order[80] = 2188
				order[81] = 2189
				order[82] = 613
				order[83] = 614
				order[84] = 1436
				order[85] = 2354
				order[86] = 1440
				order[87] = 2190
				order[88] = 2191
				order[89] = 999
				order[90] = 1224
				order[91] = 1720
				order[92] = 2909
				order[93] = 1421
				order[94] = 1422
				order[95] = 1721
				order[96] = 2910
				order[97] = 2192
				order[98] = 1001
				order[99] = 1420
				order[100] = 2193
				order[101] = 2194
				order[102] = 2755
				order[103] = 2195
				order[104] = 2196
				order[105] = 2197
				order[106] = 2198
				order[107] = 1528
				order[108] = 2911
				order[109] = 2199
				order[110] = 2200
				order[111] = 2201
				order[112] = 2202
				order[113] = 2203
				order[114] = 615
				order[115] = 616
				order[116] = 2205
				order[117] = 2206
				order[118] = 617
				order[119] = 618
				order[120] = 619
				order[121] = 2740
				order[122] = 2717
				order[123] = 2718
				order[124] = 2719
				order[125] = 620
				order[126] = 621
				order[127] = 622
				order[128] = 2207
				order[129] = 2208
				order[130] = 623
				order[131] = 624
				order[132] = 556
				order[133] = 2898
				order[134] = 740
				order[135] = 739
				order[136] = 955
				order[137] = 956
				order[138] = 1358
				order[139] = 2682
				order[140] = 2686
				order[141] = 1017
				order[142] = 566
				order[143] = 2209
				order[144] = 2211
				order[145] = 2212
				order[146] = 2213
				order[147] = 2754
				order[148] = 2214
				order[149] = 2215
				order[150] = 2606
				order[151] = 2607
				order[152] = 2497
				order[153] = 2498
				order[154] = 2499
				order[155] = 2496
				order[156] = 2495
				order[157] = 2953
				order[158] = 2511
				order[159] = 2510
				order[160] = 2512
				order[161] = 2509
				order[162] = 2500
				order[163] = 2502
				order[164] = 2501
				order[165] = 2503
				order[166] = 2507
				order[167] = 2505
				order[168] = 2494
				order[169] = 2493
				order[170] = 2514
				order[171] = 2513
				order[172] = 2506
				order[173] = 2504
				order[174] = 2508
				order[175] = 0
				super(555, 600, order)
			end

			class NoLegSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 605
					order[1] = 606
					order[2] = 2958
					order[3] = 0
					super(604, 605, order)
				end
			end

			class NoLegSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2077
					order[1] = 2078
					order[2] = 2079
					order[3] = 2743
					order[4] = 0
					super(2076, 2077, order)
				end
			end

			class NoLegAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2309
					order[1] = 2310
					order[2] = 2311
					order[3] = 0
					super(2308, 2309, order)
				end
			end

			class NoLegEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 2060
					order[1] = 2061
					order[2] = 2062
					order[3] = 2063
					order[4] = 2064
					order[5] = 2341
					order[6] = 2065
					order[7] = 2066
					order[8] = 2074
					order[9] = 2075
					order[10] = 0
					super(2059, 2060, order)
				end
			end

			class NoLegInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 2255
					order[1] = 2256
					order[2] = 2257
					order[3] = 2379
					order[4] = 2258
					order[5] = 0
					super(2254, 2255, order)
				end

				class NoLegInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2259
						order[1] = 2260
						order[2] = 0
						super(2258, 2259, order)
					end
				end
			end

			class NoLegComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2219
					order[1] = 2220
					order[2] = 2221
					order[3] = 2222
					order[4] = 2223
					order[5] = 2224
					order[6] = 2225
					order[7] = 2226
					order[8] = 2944
					order[9] = 2227
					order[10] = 2228
					order[11] = 2229
					order[12] = 2230
					order[13] = 2231
					order[14] = 2232
					order[15] = 2250
					order[16] = 2233
					order[17] = 2945
					order[18] = 2234
					order[19] = 2946
					order[20] = 2235
					order[21] = 2236
					order[22] = 2409
					order[23] = 2410
					order[24] = 2237
					order[25] = 2238
					order[26] = 2239
					order[27] = 2240
					order[28] = 2241
					order[29] = 41382
					order[30] = 41389
					order[31] = 41390
					order[32] = 41391
					order[33] = 41392
					order[34] = 41393
					order[35] = 41394
					order[36] = 41395
					order[37] = 41396
					order[38] = 41397
					order[39] = 41379
					order[40] = 2242
					order[41] = 2243
					order[42] = 2244
					order[43] = 2245
					order[44] = 2246
					order[45] = 41398
					order[46] = 41366
					order[47] = 2608
					order[48] = 2609
					order[49] = 2610
					order[50] = 2248
					order[51] = 2249
					order[52] = 0
					super(2218, 2219, order)
				end

				class NoLegComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2251
						order[1] = 2252
						order[2] = 2253
						order[3] = 0
						super(2250, 2251, order)
					end

					class NoLegComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2204
							order[1] = 2247
							order[2] = 0
							super(2253, 2204, order)
						end
					end
				end

				class NoLegComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41383
						order[1] = 41384
						order[2] = 41385
						order[3] = 41386
						order[4] = 0
						super(41382, 41383, order)
					end
				end

				class NoLegComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41388
						order[1] = 0
						super(41387, 41388, order)
					end
				end

				class NoLegComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41380
						order[1] = 41381
						order[2] = 41400
						order[3] = 41376
						order[4] = 41363
						order[5] = 0
						super(41379, 41380, order)
					end

					class NoLegComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41401
							order[1] = 41402
							order[2] = 41403
							order[3] = 41404
							order[4] = 41405
							order[5] = 0
							super(41400, 41401, order)
						end
					end

					class NoLegComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41377
							order[1] = 41378
							order[2] = 0
							super(41376, 41377, order)
						end
					end

					class NoLegComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41364
							order[1] = 41365
							order[2] = 0
							super(41363, 41364, order)
						end
					end
				end

				class NoLegComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41399
						order[1] = 0
						super(41398, 41399, order)
					end
				end

				class NoLegComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41367
						order[1] = 41368
						order[2] = 41369
						order[3] = 41370
						order[4] = 41371
						order[5] = 41372
						order[6] = 41373
						order[7] = 41374
						order[8] = 0
						super(41366, 41367, order)
					end

					class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41375
							order[1] = 0
							super(41374, 41375, order)
						end
					end
				end
			end

			class NoLegBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40924
					order[1] = 0
					super(40923, 40924, order)
				end
			end

			class NoLegPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41608
					order[1] = 0
					super(41607, 41608, order)
				end
			end

			class NoLegMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41468
					order[1] = 40223
					order[2] = 0
					super(41467, 41468, order)
				end
			end

			class NoLegMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41470
					order[1] = 40990
					order[2] = 0
					super(41469, 41470, order)
				end
			end

			class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41472
					order[1] = 41473
					order[2] = 41474
					order[3] = 41475
					order[4] = 41476
					order[5] = 41477
					order[6] = 41478
					order[7] = 41479
					order[8] = 41480
					order[9] = 0
					super(41471, 41472, order)
				end
			end

			class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42582
					order[1] = 0
					super(42581, 42582, order)
				end
			end

			class NoLegOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41492
					order[1] = 0
					super(41491, 41492, order)
				end
			end

			class NoLegOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41513
					order[1] = 41514
					order[2] = 0
					super(41512, 41513, order)
				end
			end

			class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41516
					order[1] = 0
					super(41515, 41516, order)
				end
			end

			class NoLegOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41528
					order[1] = 41529
					order[2] = 0
					super(41527, 41528, order)
				end
			end

			class NoLegStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40242
					order[1] = 41700
					order[2] = 40243
					order[3] = 42583
					order[4] = 42584
					order[5] = 40244
					order[6] = 40245
					order[7] = 41702
					order[8] = 40246
					order[9] = 40247
					order[10] = 42585
					order[11] = 42586
					order[12] = 41703
					order[13] = 41704
					order[14] = 41705
					order[15] = 41706
					order[16] = 41707
					order[17] = 41708
					order[18] = 41648
					order[19] = 41649
					order[20] = 41650
					order[21] = 41651
					order[22] = 41652
					order[23] = 41653
					order[24] = 41654
					order[25] = 42588
					order[26] = 41655
					order[27] = 41656
					order[28] = 41657
					order[29] = 41658
					order[30] = 41659
					order[31] = 41660
					order[32] = 41661
					order[33] = 41662
					order[34] = 41663
					order[35] = 41664
					order[36] = 41665
					order[37] = 41666
					order[38] = 41667
					order[39] = 41668
					order[40] = 41669
					order[41] = 41670
					order[42] = 41671
					order[43] = 41672
					order[44] = 41673
					order[45] = 40249
					order[46] = 40250
					order[47] = 40252
					order[48] = 40253
					order[49] = 40254
					order[50] = 40255
					order[51] = 40256
					order[52] = 40257
					order[53] = 40258
					order[54] = 40260
					order[55] = 40261
					order[56] = 40262
					order[57] = 40263
					order[58] = 40264
					order[59] = 41641
					order[60] = 41642
					order[61] = 40265
					order[62] = 40267
					order[63] = 40268
					order[64] = 40270
					order[65] = 40271
					order[66] = 40272
					order[67] = 40273
					order[68] = 40274
					order[69] = 40275
					order[70] = 40276
					order[71] = 41643
					order[72] = 41644
					order[73] = 41645
					order[74] = 40279
					order[75] = 40280
					order[76] = 40281
					order[77] = 42399
					order[78] = 40282
					order[79] = 40283
					order[80] = 43108
					order[81] = 40284
					order[82] = 40285
					order[83] = 40286
					order[84] = 40287
					order[85] = 40288
					order[86] = 42400
					order[87] = 42401
					order[88] = 42402
					order[89] = 42403
					order[90] = 40289
					order[91] = 40290
					order[92] = 40291
					order[93] = 41549
					order[94] = 41550
					order[95] = 41551
					order[96] = 41552
					order[97] = 41553
					order[98] = 41554
					order[99] = 41555
					order[100] = 42404
					order[101] = 40374
					order[102] = 40418
					order[103] = 41429
					order[104] = 41430
					order[105] = 41431
					order[106] = 41432
					order[107] = 41433
					order[108] = 42194
					order[109] = 42195
					order[110] = 41434
					order[111] = 41435
					order[112] = 41436
					order[113] = 41437
					order[114] = 41438
					order[115] = 41219
					order[116] = 41439
					order[117] = 41440
					order[118] = 41441
					order[119] = 41442
					order[120] = 41443
					order[121] = 41444
					order[122] = 41445
					order[123] = 41446
					order[124] = 41447
					order[125] = 41448
					order[126] = 41449
					order[127] = 41450
					order[128] = 41451
					order[129] = 43095
					order[130] = 41408
					order[131] = 40248
					order[132] = 40978
					order[133] = 40979
					order[134] = 0
					super(40241, 40242, order)
				end

				class NoLegStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41675
						order[1] = 41676
						order[2] = 0
						super(41674, 41675, order)
					end
				end

				class NoLegStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41453
						order[1] = 41454
						order[2] = 41455
						order[3] = 0
						super(41452, 41453, order)
					end
				end

				class NoLegStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41678
						order[1] = 41679
						order[2] = 0
						super(41677, 41678, order)
					end
				end

				class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41647
						order[1] = 0
						super(41646, 41647, order)
					end
				end

				class NoLegStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41687
						order[1] = 41688
						order[2] = 41689
						order[3] = 41690
						order[4] = 41691
						order[5] = 41692
						order[6] = 41693
						order[7] = 41694
						order[8] = 41695
						order[9] = 41696
						order[10] = 41697
						order[11] = 41680
						order[12] = 41698
						order[13] = 41699
						order[14] = 0
						super(41686, 41687, order)
					end

					class NoLegStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41681
							order[1] = 41682
							order[2] = 41683
							order[3] = 0
							super(41680, 41681, order)
						end

						class NoLegStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41684
								order[1] = 41685
								order[2] = 41935
								order[3] = 0
								super(41683, 41684, order)
							end
						end
					end
				end

				class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40251
						order[1] = 0
						super(40942, 40251, order)
					end
				end

				class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40259
						order[1] = 0
						super(40943, 40259, order)
					end
				end

				class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40266
						order[1] = 0
						super(40940, 40266, order)
					end
				end

				class NoLegStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41639
						order[1] = 41640
						order[2] = 0
						super(41638, 41639, order)
					end
				end

				class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40269
						order[1] = 0
						super(40941, 40269, order)
					end
				end

				class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40293
						order[1] = 0
						super(40930, 40293, order)
					end
				end

				class NoLegPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41590
						order[1] = 41591
						order[2] = 0
						super(41589, 41590, order)
					end
				end

				class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40305
						order[1] = 0
						super(40931, 40305, order)
					end
				end

				class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40311
						order[1] = 0
						super(40932, 40311, order)
					end
				end

				class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40318
						order[1] = 0
						super(40933, 40318, order)
					end
				end

				class NoLegPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42460
						order[1] = 42461
						order[2] = 0
						super(42459, 42460, order)
					end
				end

				class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41562
						order[1] = 0
						super(41561, 41562, order)
					end
				end

				class NoLegPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41597
						order[1] = 41598
						order[2] = 0
						super(41596, 41597, order)
					end
				end

				class NoLegPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41594
						order[1] = 41595
						order[2] = 0
						super(41593, 41594, order)
					end
				end

				class NoLegPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43110
						order[1] = 42486
						order[2] = 42487
						order[3] = 0
						super(42485, 43110, order)
					end
				end

				class NoLegDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42367
						order[1] = 42368
						order[2] = 42369
						order[3] = 42370
						order[4] = 42371
						order[5] = 42372
						order[6] = 42386
						order[7] = 42373
						order[8] = 42374
						order[9] = 42375
						order[10] = 42376
						order[11] = 42377
						order[12] = 42378
						order[13] = 42379
						order[14] = 42380
						order[15] = 42381
						order[16] = 42382
						order[17] = 42383
						order[18] = 42384
						order[19] = 42385
						order[20] = 0
						super(42366, 42367, order)
					end

					class NoLegDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42387
							order[1] = 0
							super(42386, 42387, order)
						end
					end
				end

				class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42365
						order[1] = 0
						super(42364, 42365, order)
					end
				end

				class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42311
						order[1] = 0
						super(42310, 42311, order)
					end
				end

				class NoLegReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 42535
						order[1] = 42536
						order[2] = 42537
						order[3] = 42538
						order[4] = 42539
						order[5] = 42540
						order[6] = 42564
						order[7] = 42530
						order[8] = 42541
						order[9] = 42542
						order[10] = 42543
						order[11] = 42544
						order[12] = 42545
						order[13] = 42546
						order[14] = 42547
						order[15] = 42548
						order[16] = 42549
						order[17] = 42550
						order[18] = 42551
						order[19] = 42552
						order[20] = 42560
						order[21] = 42553
						order[22] = 42554
						order[23] = 42508
						order[24] = 42555
						order[25] = 42556
						order[26] = 42557
						order[27] = 42558
						order[28] = 42559
						order[29] = 0
						super(42534, 42535, order)
					end

					class NoLegReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 42565
							order[1] = 42566
							order[2] = 42567
							order[3] = 42568
							order[4] = 0
							super(42564, 42565, order)
						end
					end

					class NoLegReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42531
							order[1] = 42532
							order[2] = 42533
							order[3] = 0
							super(42530, 42531, order)
						end
					end

					class NoLegReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42561
							order[1] = 42562
							order[2] = 42563
							order[3] = 0
							super(42560, 42561, order)
						end
					end

					class NoLegReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 42509
							order[1] = 42571
							order[2] = 42510
							order[3] = 42511
							order[4] = 42512
							order[5] = 42513
							order[6] = 42514
							order[7] = 42515
							order[8] = 42516
							order[9] = 42517
							order[10] = 42518
							order[11] = 42519
							order[12] = 42520
							order[13] = 42521
							order[14] = 42522
							order[15] = 42523
							order[16] = 42524
							order[17] = 42525
							order[18] = 42526
							order[19] = 42527
							order[20] = 42528
							order[21] = 42529
							order[22] = 42569
							order[23] = 0
							super(42508, 42509, order)
						end

						class NoLegReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 42572
								order[1] = 42573
								order[2] = 0
								super(42571, 42572, order)
							end
						end

						class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 42570
								order[1] = 0
								super(42569, 42570, order)
							end
						end
					end
				end

				class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42420
						order[1] = 0
						super(42419, 42420, order)
					end
				end

				class NoLegPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42406
						order[1] = 42407
						order[2] = 0
						super(42405, 42406, order)
					end
				end

				class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40361
						order[1] = 0
						super(40929, 40361, order)
					end
				end

				class NoLegNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40368
						order[1] = 40369
						order[2] = 0
						super(40367, 40368, order)
					end
				end

				class NoLegSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40903
						order[1] = 40366
						order[2] = 40370
						order[3] = 40905
						order[4] = 40906
						order[5] = 0
						super(40902, 40903, order)
					end
				end

				class NoLegPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40375
						order[1] = 41533
						order[2] = 41534
						order[3] = 40376
						order[4] = 40377
						order[5] = 40378
						order[6] = 40379
						order[7] = 40380
						order[8] = 40381
						order[9] = 40382
						order[10] = 40383
						order[11] = 40384
						order[12] = 40385
						order[13] = 41535
						order[14] = 41536
						order[15] = 41537
						order[16] = 41538
						order[17] = 40386
						order[18] = 40387
						order[19] = 40388
						order[20] = 40389
						order[21] = 41539
						order[22] = 41540
						order[23] = 41541
						order[24] = 41542
						order[25] = 40390
						order[26] = 40391
						order[27] = 40392
						order[28] = 40393
						order[29] = 40394
						order[30] = 40395
						order[31] = 40414
						order[32] = 40396
						order[33] = 40397
						order[34] = 40398
						order[35] = 40399
						order[36] = 40927
						order[37] = 40401
						order[38] = 40402
						order[39] = 40403
						order[40] = 41543
						order[41] = 41544
						order[42] = 40404
						order[43] = 41530
						order[44] = 41545
						order[45] = 41546
						order[46] = 41547
						order[47] = 41548
						order[48] = 40405
						order[49] = 40406
						order[50] = 40407
						order[51] = 40408
						order[52] = 40928
						order[53] = 40410
						order[54] = 40411
						order[55] = 40412
						order[56] = 40413
						order[57] = 0
						super(40374, 40375, order)
					end

					class NoLegPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40415
							order[1] = 40416
							order[2] = 40417
							order[3] = 0
							super(40414, 40415, order)
						end
					end

					class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40400
							order[1] = 0
							super(40927, 40400, order)
						end
					end

					class NoLegPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41531
							order[1] = 41532
							order[2] = 0
							super(41530, 41531, order)
						end
					end

					class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40409
							order[1] = 0
							super(40928, 40409, order)
						end
					end
				end

				class NoLegPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40419
						order[1] = 40420
						order[2] = 42497
						order[3] = 42498
						order[4] = 42499
						order[5] = 42500
						order[6] = 42501
						order[7] = 42502
						order[8] = 42503
						order[9] = 42488
						order[10] = 42489
						order[11] = 42490
						order[12] = 42491
						order[13] = 42492
						order[14] = 42493
						order[15] = 42494
						order[16] = 40421
						order[17] = 40422
						order[18] = 40423
						order[19] = 40424
						order[20] = 40425
						order[21] = 40426
						order[22] = 40427
						order[23] = 40428
						order[24] = 40429
						order[25] = 40430
						order[26] = 40431
						order[27] = 40432
						order[28] = 40433
						order[29] = 40434
						order[30] = 40435
						order[31] = 40436
						order[32] = 40437
						order[33] = 40438
						order[34] = 40439
						order[35] = 40440
						order[36] = 40441
						order[37] = 40442
						order[38] = 40443
						order[39] = 40444
						order[40] = 40445
						order[41] = 40446
						order[42] = 40447
						order[43] = 0
						super(40418, 40419, order)
					end

					class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42505
							order[1] = 0
							super(42504, 42505, order)
						end
					end

					class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42496
							order[1] = 0
							super(42495, 42496, order)
						end
					end
				end

				class NoLegDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41461
						order[1] = 0
						super(41460, 41461, order)
					end
				end

				class NoLegDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41457
						order[1] = 41458
						order[2] = 41459
						order[3] = 0
						super(41456, 41457, order)
					end
				end

				class NoLegDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41409
						order[1] = 41410
						order[2] = 41411
						order[3] = 41412
						order[4] = 41413
						order[5] = 41414
						order[6] = 41415
						order[7] = 41416
						order[8] = 41417
						order[9] = 41418
						order[10] = 41419
						order[11] = 41420
						order[12] = 41421
						order[13] = 41422
						order[14] = 0
						super(41408, 41409, order)
					end

					class NoLegDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41423
							order[1] = 41424
							order[2] = 41425
							order[3] = 0
							super(41422, 41423, order)
						end

						class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41426
								order[1] = 41427
								order[2] = 41428
								order[3] = 0
								super(41425, 41426, order)
							end
						end
					end
				end
			end

			class NoLegProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 40449
					order[1] = 40450
					order[2] = 40451
					order[3] = 40939
					order[4] = 40453
					order[5] = 40454
					order[6] = 40455
					order[7] = 42506
					order[8] = 42507
					order[9] = 40456
					order[10] = 40457
					order[11] = 40458
					order[12] = 40524
					order[13] = 40525
					order[14] = 40526
					order[15] = 40528
					order[16] = 40529
					order[17] = 40530
					order[18] = 40531
					order[19] = 40532
					order[20] = 40476
					order[21] = 40478
					order[22] = 40479
					order[23] = 40480
					order[24] = 40481
					order[25] = 40482
					order[26] = 40483
					order[27] = 40484
					order[28] = 40485
					order[29] = 40486
					order[30] = 40487
					order[31] = 40488
					order[32] = 40489
					order[33] = 40490
					order[34] = 40491
					order[35] = 40492
					order[36] = 40493
					order[37] = 40494
					order[38] = 40498
					order[39] = 40499
					order[40] = 40501
					order[41] = 40502
					order[42] = 40503
					order[43] = 40504
					order[44] = 40505
					order[45] = 40506
					order[46] = 40507
					order[47] = 40508
					order[48] = 40509
					order[49] = 40511
					order[50] = 40512
					order[51] = 40513
					order[52] = 40514
					order[53] = 40515
					order[54] = 40459
					order[55] = 40460
					order[56] = 40461
					order[57] = 40462
					order[58] = 40463
					order[59] = 40464
					order[60] = 40465
					order[61] = 40516
					order[62] = 40518
					order[63] = 40519
					order[64] = 40520
					order[65] = 40521
					order[66] = 40522
					order[67] = 40523
					order[68] = 40466
					order[69] = 40467
					order[70] = 40468
					order[71] = 40469
					order[72] = 40470
					order[73] = 41407
					order[74] = 40472
					order[75] = 40980
					order[76] = 40981
					order[77] = 40533
					order[78] = 0
					super(40448, 40449, order)
				end

				class NoLegProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40452
						order[1] = 0
						super(40939, 40452, order)
					end
				end

				class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40527
						order[1] = 0
						super(40935, 40527, order)
					end
				end

				class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40477
						order[1] = 0
						super(40936, 40477, order)
					end
				end

				class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40496
						order[1] = 40497
						order[2] = 0
						super(40495, 40496, order)
					end
				end

				class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40500
						order[1] = 0
						super(40937, 40500, order)
					end
				end

				class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40510
						order[1] = 0
						super(40938, 40510, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40517
						order[1] = 0
						super(40934, 40517, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40474
						order[1] = 40475
						order[2] = 0
						super(40473, 40474, order)
					end
				end

				class NoLegProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40534
						order[1] = 40535
						order[2] = 40536
						order[3] = 2380
						order[4] = 40537
						order[5] = 0
						super(40533, 40534, order)
					end

					class NoLegProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40538
							order[1] = 40539
							order[2] = 0
							super(40537, 40538, order)
						end
					end
				end
			end

			class NoLegAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41336
					order[1] = 41337
					order[2] = 41316
					order[3] = 0
					super(41335, 41336, order)
				end

				class NoLegAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41317
						order[1] = 41318
						order[2] = 41319
						order[3] = 41320
						order[4] = 41321
						order[5] = 41322
						order[6] = 41323
						order[7] = 41324
						order[8] = 41325
						order[9] = 41326
						order[10] = 41327
						order[11] = 41328
						order[12] = 41329
						order[13] = 41330
						order[14] = 41331
						order[15] = 41332
						order[16] = 41333
						order[17] = 41334
						order[18] = 0
						super(41316, 41317, order)
					end
				end
			end

			class NoLegProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 41618
					order[1] = 41619
					order[2] = 41620
					order[3] = 41621
					order[4] = 41622
					order[5] = 41623
					order[6] = 41624
					order[7] = 41614
					order[8] = 41625
					order[9] = 41635
					order[10] = 41617
					order[11] = 0
					super(41616, 41618, order)
				end

				class NoLegProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41615
						order[1] = 0
						super(41614, 41615, order)
					end
				end

				class NoLegProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41626
						order[1] = 41627
						order[2] = 41628
						order[3] = 41629
						order[4] = 41630
						order[5] = 41631
						order[6] = 41632
						order[7] = 41633
						order[8] = 0
						super(41625, 41626, order)
					end

					class NoLegProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41634
							order[1] = 0
							super(41633, 41634, order)
						end
					end
				end

				class NoLegProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41636
						order[1] = 41637
						order[2] = 0
						super(41635, 41636, order)
					end
				end
			end

			class NoLegCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 41345
					order[1] = 41346
					order[2] = 41347
					order[3] = 41348
					order[4] = 41349
					order[5] = 41350
					order[6] = 41351
					order[7] = 41352
					order[8] = 41353
					order[9] = 41354
					order[10] = 41355
					order[11] = 41342
					order[12] = 42308
					order[13] = 42309
					order[14] = 41356
					order[15] = 41357
					order[16] = 42299
					order[17] = 42300
					order[18] = 42301
					order[19] = 42302
					order[20] = 42303
					order[21] = 42304
					order[22] = 42305
					order[23] = 41358
					order[24] = 41359
					order[25] = 41360
					order[26] = 41361
					order[27] = 41362
					order[28] = 0
					super(41344, 41345, order)
				end

				class NoLegCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41343
						order[1] = 0
						super(41342, 41343, order)
					end
				end

				class NoLegCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42307
						order[1] = 0
						super(42306, 42307, order)
					end
				end
			end

			class NoLegPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41604
					order[1] = 41601
					order[2] = 41602
					order[3] = 41603
					order[4] = 41600
					order[5] = 0
					super(41599, 41604, order)
				end

				class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41605
						order[1] = 41606
						order[2] = 0
						super(41604, 41605, order)
					end
				end
			end

			class NoLegExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42389
					order[1] = 42390
					order[2] = 0
					super(42388, 42389, order)
				end
			end

			class NoLegContractualDefinitions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42199
					order[1] = 0
					super(42198, 42199, order)
				end
			end

			class NoLegFinancingTermSupplements < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42201
					order[1] = 42202
					order[2] = 0
					super(42200, 42201, order)
				end
			end

			class NoLegContractualMatrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42204
					order[1] = 42205
					order[2] = 42206
					order[3] = 0
					super(42203, 42204, order)
				end
			end
		end

		class NoRelatedInstruments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1648
				order[1] = 1649
				order[2] = 1650
				order[3] = 1651
				order[4] = 1652
				order[5] = 1653
				order[6] = 2413
				order[7] = 2414
				order[8] = 2415
				order[9] = 2417
				order[10] = 0
				super(1647, 1648, order)
			end
		end

		class NoPriceQualifiers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 2710
				order[1] = 0
				super(2709, 2710, order)
			end
		end

		class NoRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1446
				order[1] = 1447
				order[2] = 1448
				order[3] = 2412
				order[4] = 2796
				order[5] = 0
				super(1445, 1446, order)
			end
		end

		class NoOfSecSizes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1178
				order[1] = 1179
				order[2] = 0
				super(1177, 1178, order)
			end
		end

		class NoTradePriceConditions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 1839
				order[1] = 0
				super(1838, 1839, order)
			end
		end

		class NoTrdRegPublications < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2669
				order[1] = 2670
				order[2] = 0
				super(2668, 2669, order)
			end
		end

		class NoRelatedTrades < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 1856
				order[1] = 1857
				order[2] = 2103
				order[3] = 1858
				order[4] = 1859
				order[5] = 1860
				order[6] = 0
				super(1855, 1856, order)
			end
		end

		class NoStatsIndicators < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 1176
				order[1] = 0
				super(1175, 1176, order)
			end
		end

		class NoPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 448
				order[1] = 447
				order[2] = 452
				order[3] = 2376
				order[4] = 802
				order[5] = 0
				super(453, 448, order)
			end

			class NoPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 523
					order[1] = 803
					order[2] = 0
					super(802, 523, order)
				end
			end
		end
	end

	class NoRoutingIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 216
			order[1] = 217
			order[2] = 0
			super(215, 216, order)
		end
	end
end

class MarketDataRequestReject < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("Y") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoAltMDSource < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 817
			order[1] = 0
			super(816, 817, order)
		end
	end
end

class QuoteCancel < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("Z") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoTargetPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1462
			order[1] = 1463
			order[2] = 1464
			order[3] = 1818
			order[4] = 2433
			order[5] = 0
			super(1461, 1462, order)
		end

		class NoTargetPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2434
				order[1] = 2435
				order[2] = 0
				super(2433, 2434, order)
			end
		end
	end

	class NoQuoteEntries < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(180)
			order[0] = 55
			order[1] = 65
			order[2] = 48
			order[3] = 22
			order[4] = 460
			order[5] = 1227
			order[6] = 1151
			order[7] = 461
			order[8] = 2891
			order[9] = 167
			order[10] = 762
			order[11] = 200
			order[12] = 541
			order[13] = 1079
			order[14] = 966
			order[15] = 1049
			order[16] = 965
			order[17] = 224
			order[18] = 1449
			order[19] = 1450
			order[20] = 1451
			order[21] = 1452
			order[22] = 1457
			order[23] = 1458
			order[24] = 1739
			order[25] = 2210
			order[26] = 1938
			order[27] = 1939
			order[28] = 1940
			order[29] = 2735
			order[30] = 1941
			order[31] = 1575
			order[32] = 1942
			order[33] = 1943
			order[34] = 1944
			order[35] = 1945
			order[36] = 1946
			order[37] = 1947
			order[38] = 1948
			order[39] = 1949
			order[40] = 1950
			order[41] = 2879
			order[42] = 1951
			order[43] = 1952
			order[44] = 1953
			order[45] = 1954
			order[46] = 1955
			order[47] = 1956
			order[48] = 1957
			order[49] = 1958
			order[50] = 1959
			order[51] = 1960
			order[52] = 1577
			order[53] = 1580
			order[54] = 1581
			order[55] = 1678
			order[56] = 1697
			order[57] = 225
			order[58] = 239
			order[59] = 226
			order[60] = 227
			order[61] = 228
			order[62] = 255
			order[63] = 543
			order[64] = 470
			order[65] = 471
			order[66] = 472
			order[67] = 240
			order[68] = 202
			order[69] = 2578
			order[70] = 2577
			order[71] = 947
			order[72] = 2904
			order[73] = 967
			order[74] = 968
			order[75] = 1698
			order[76] = 1866
			order[77] = 2600
			order[78] = 2001
			order[79] = 2601
			order[80] = 1478
			order[81] = 1479
			order[82] = 1480
			order[83] = 1481
			order[84] = 206
			order[85] = 231
			order[86] = 1435
			order[87] = 2353
			order[88] = 1439
			order[89] = 969
			order[90] = 1146
			order[91] = 996
			order[92] = 1147
			order[93] = 1716
			order[94] = 2905
			order[95] = 1191
			order[96] = 1192
			order[97] = 1717
			order[98] = 2906
			order[99] = 1193
			order[100] = 2579
			order[101] = 1194
			order[102] = 1482
			order[103] = 1195
			order[104] = 2753
			order[105] = 1196
			order[106] = 1197
			order[107] = 2002
			order[108] = 2140
			order[109] = 1524
			order[110] = 2907
			order[111] = 1198
			order[112] = 1199
			order[113] = 1200
			order[114] = 201
			order[115] = 2681
			order[116] = 2685
			order[117] = 1244
			order[118] = 1242
			order[119] = 2575
			order[120] = 2574
			order[121] = 997
			order[122] = 223
			order[123] = 207
			order[124] = 970
			order[125] = 971
			order[126] = 106
			order[127] = 348
			order[128] = 349
			order[129] = 2737
			order[130] = 2714
			order[131] = 2715
			order[132] = 2716
			order[133] = 107
			order[134] = 350
			order[135] = 351
			order[136] = 691
			order[137] = 667
			order[138] = 875
			order[139] = 876
			order[140] = 873
			order[141] = 874
			order[142] = 1687
			order[143] = 1787
			order[144] = 2141
			order[145] = 2142
			order[146] = 2143
			order[147] = 2752
			order[148] = 2144
			order[149] = 2145
			order[150] = 2576
			order[151] = 2962
			order[152] = 2602
			order[153] = 2603
			order[154] = 913
			order[155] = 914
			order[156] = 1961
			order[157] = 915
			order[158] = 918
			order[159] = 2952
			order[160] = 1962
			order[161] = 1963
			order[162] = 1964
			order[163] = 1965
			order[164] = 1966
			order[165] = 1967
			order[166] = 1968
			order[167] = 1969
			order[168] = 1970
			order[169] = 1513
			order[170] = 1525
			order[171] = 1527
			order[172] = 788
			order[173] = 916
			order[174] = 917
			order[175] = 919
			order[176] = 898
			order[177] = 711
			order[178] = 555
			order[179] = 0
			super(295, 55, order)
		end

		class NoSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 455
				order[1] = 456
				order[2] = 2957
				order[3] = 0
				super(454, 455, order)
			end
		end

		class NoSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1977
				order[1] = 1978
				order[2] = 1979
				order[3] = 2741
				order[4] = 0
				super(1976, 1977, order)
			end
		end

		class NoAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2305
				order[1] = 2306
				order[2] = 2307
				order[3] = 0
				super(2304, 2305, order)
			end
		end

		class NoEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 865
				order[1] = 866
				order[2] = 1145
				order[3] = 1827
				order[4] = 1826
				order[5] = 2340
				order[6] = 867
				order[7] = 868
				order[8] = 1578
				order[9] = 1579
				order[10] = 0
				super(864, 865, order)
			end
		end

		class NoInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1019
				order[1] = 1050
				order[2] = 1051
				order[3] = 2378
				order[4] = 1052
				order[5] = 0
				super(1018, 1019, order)
			end

			class NoInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1053
					order[1] = 1054
					order[2] = 0
					super(1052, 1053, order)
				end
			end
		end

		class NoComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 1484
				order[1] = 2117
				order[2] = 2118
				order[3] = 2119
				order[4] = 1485
				order[5] = 2120
				order[6] = 2121
				order[7] = 2122
				order[8] = 2941
				order[9] = 1486
				order[10] = 2123
				order[11] = 1487
				order[12] = 1488
				order[13] = 1489
				order[14] = 1490
				order[15] = 1491
				order[16] = 2124
				order[17] = 2942
				order[18] = 2125
				order[19] = 2943
				order[20] = 2126
				order[21] = 2127
				order[22] = 2407
				order[23] = 2408
				order[24] = 2128
				order[25] = 2129
				order[26] = 2130
				order[27] = 2131
				order[28] = 2132
				order[29] = 41013
				order[30] = 41020
				order[31] = 41021
				order[32] = 41022
				order[33] = 41023
				order[34] = 41024
				order[35] = 41025
				order[36] = 41026
				order[37] = 41027
				order[38] = 41028
				order[39] = 41010
				order[40] = 2133
				order[41] = 2134
				order[42] = 2135
				order[43] = 2136
				order[44] = 2137
				order[45] = 41029
				order[46] = 40997
				order[47] = 2597
				order[48] = 2598
				order[49] = 2599
				order[50] = 2138
				order[51] = 2139
				order[52] = 0
				super(1483, 1484, order)
			end

			class NoComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1492
					order[1] = 1493
					order[2] = 1494
					order[3] = 0
					super(1491, 1492, order)
				end

				class NoComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1495
						order[1] = 1496
						order[2] = 0
						super(1494, 1495, order)
					end
				end
			end

			class NoComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41014
					order[1] = 41015
					order[2] = 41016
					order[3] = 41017
					order[4] = 0
					super(41013, 41014, order)
				end
			end

			class NoComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41019
					order[1] = 0
					super(41018, 41019, order)
				end
			end

			class NoComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41011
					order[1] = 41012
					order[2] = 41031
					order[3] = 41007
					order[4] = 40994
					order[5] = 0
					super(41010, 41011, order)
				end

				class NoComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41032
						order[1] = 41033
						order[2] = 41034
						order[3] = 41035
						order[4] = 41036
						order[5] = 0
						super(41031, 41032, order)
					end
				end

				class NoComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41008
						order[1] = 41009
						order[2] = 0
						super(41007, 41008, order)
					end
				end

				class NoComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40995
						order[1] = 40996
						order[2] = 0
						super(40994, 40995, order)
					end
				end
			end

			class NoComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41030
					order[1] = 0
					super(41029, 41030, order)
				end
			end

			class NoComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40998
					order[1] = 40999
					order[2] = 41000
					order[3] = 41001
					order[4] = 41002
					order[5] = 41003
					order[6] = 41004
					order[7] = 41005
					order[8] = 0
					super(40997, 40998, order)
				end

				class NoComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41006
						order[1] = 0
						super(41005, 41006, order)
					end
				end
			end
		end

		class NoBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40471
				order[1] = 0
				super(40278, 40471, order)
			end
		end

		class NoPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41231
				order[1] = 0
				super(41230, 41231, order)
			end
		end

		class NoMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41093
				order[1] = 40991
				order[2] = 0
				super(41092, 41093, order)
			end
		end

		class NoMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41095
				order[1] = 40992
				order[2] = 0
				super(41094, 41095, order)
			end
		end

		class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41097
				order[1] = 41098
				order[2] = 41099
				order[3] = 41100
				order[4] = 41101
				order[5] = 41102
				order[6] = 41103
				order[7] = 41104
				order[8] = 41105
				order[9] = 0
				super(41096, 41097, order)
			end
		end

		class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42776
				order[1] = 0
				super(42775, 42776, order)
			end
		end

		class NoOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41117
				order[1] = 0
				super(41116, 41117, order)
			end
		end

		class NoOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41138
				order[1] = 41139
				order[2] = 0
				super(41137, 41138, order)
			end
		end

		class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41141
				order[1] = 0
				super(41140, 41141, order)
			end
		end

		class NoOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41153
				order[1] = 41154
				order[2] = 0
				super(41152, 41153, order)
			end
		end

		class NoStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40050
				order[1] = 41303
				order[2] = 40051
				order[3] = 42784
				order[4] = 42785
				order[5] = 40052
				order[6] = 40053
				order[7] = 41305
				order[8] = 40054
				order[9] = 40055
				order[10] = 42786
				order[11] = 42787
				order[12] = 41306
				order[13] = 41307
				order[14] = 41308
				order[15] = 41309
				order[16] = 41310
				order[17] = 41311
				order[18] = 41251
				order[19] = 41252
				order[20] = 41253
				order[21] = 41254
				order[22] = 41255
				order[23] = 41256
				order[24] = 41257
				order[25] = 42587
				order[26] = 41258
				order[27] = 41259
				order[28] = 41260
				order[29] = 41261
				order[30] = 41262
				order[31] = 41263
				order[32] = 41264
				order[33] = 41265
				order[34] = 41266
				order[35] = 41267
				order[36] = 41268
				order[37] = 41269
				order[38] = 41270
				order[39] = 41271
				order[40] = 41272
				order[41] = 41273
				order[42] = 41274
				order[43] = 41275
				order[44] = 41276
				order[45] = 40907
				order[46] = 40908
				order[47] = 40910
				order[48] = 40911
				order[49] = 40912
				order[50] = 40913
				order[51] = 40914
				order[52] = 40065
				order[53] = 40066
				order[54] = 40068
				order[55] = 40069
				order[56] = 40070
				order[57] = 40071
				order[58] = 40072
				order[59] = 41244
				order[60] = 41245
				order[61] = 40073
				order[62] = 40075
				order[63] = 40076
				order[64] = 40078
				order[65] = 40079
				order[66] = 40080
				order[67] = 40081
				order[68] = 40082
				order[69] = 40083
				order[70] = 40084
				order[71] = 41246
				order[72] = 41247
				order[73] = 41248
				order[74] = 40738
				order[75] = 40739
				order[76] = 40740
				order[77] = 42600
				order[78] = 40741
				order[79] = 40742
				order[80] = 43106
				order[81] = 40743
				order[82] = 40744
				order[83] = 40745
				order[84] = 40746
				order[85] = 40747
				order[86] = 42601
				order[87] = 42602
				order[88] = 42603
				order[89] = 42604
				order[90] = 40748
				order[91] = 40749
				order[92] = 40750
				order[93] = 41180
				order[94] = 41181
				order[95] = 41182
				order[96] = 41183
				order[97] = 41184
				order[98] = 41185
				order[99] = 41186
				order[100] = 42605
				order[101] = 40828
				order[102] = 40872
				order[103] = 41058
				order[104] = 41059
				order[105] = 41060
				order[106] = 41061
				order[107] = 41062
				order[108] = 42192
				order[109] = 42193
				order[110] = 41063
				order[111] = 41064
				order[112] = 41065
				order[113] = 41066
				order[114] = 41067
				order[115] = 41218
				order[116] = 41068
				order[117] = 41069
				order[118] = 41070
				order[119] = 41071
				order[120] = 41072
				order[121] = 41073
				order[122] = 41074
				order[123] = 41075
				order[124] = 41076
				order[125] = 41077
				order[126] = 41078
				order[127] = 41079
				order[128] = 41080
				order[129] = 43094
				order[130] = 41037
				order[131] = 40056
				order[132] = 40982
				order[133] = 40983
				order[134] = 0
				super(40049, 40050, order)
			end

			class NoStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41278
					order[1] = 41279
					order[2] = 0
					super(41277, 41278, order)
				end
			end

			class NoStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41238
					order[1] = 41239
					order[2] = 41240
					order[3] = 0
					super(41237, 41238, order)
				end
			end

			class NoStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41281
					order[1] = 41282
					order[2] = 0
					super(41280, 41281, order)
				end
			end

			class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41250
					order[1] = 0
					super(41249, 41250, order)
				end
			end

			class NoStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41290
					order[1] = 41291
					order[2] = 41292
					order[3] = 41293
					order[4] = 41294
					order[5] = 41295
					order[6] = 41296
					order[7] = 41297
					order[8] = 41298
					order[9] = 41299
					order[10] = 41300
					order[11] = 41283
					order[12] = 41301
					order[13] = 41302
					order[14] = 0
					super(41289, 41290, order)
				end

				class NoStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41284
						order[1] = 41285
						order[2] = 41286
						order[3] = 0
						super(41283, 41284, order)
					end

					class NoStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41287
							order[1] = 41288
							order[2] = 41588
							order[3] = 0
							super(41286, 41287, order)
						end
					end
				end
			end

			class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40909
					order[1] = 0
					super(40960, 40909, order)
				end
			end

			class NoStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40067
					order[1] = 0
					super(40961, 40067, order)
				end
			end

			class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40074
					order[1] = 0
					super(40958, 40074, order)
				end
			end

			class NoStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41242
					order[1] = 41243
					order[2] = 0
					super(41241, 41242, order)
				end
			end

			class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40077
					order[1] = 0
					super(40959, 40077, order)
				end
			end

			class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40752
					order[1] = 0
					super(40947, 40752, order)
				end
			end

			class NoPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41221
					order[1] = 41222
					order[2] = 0
					super(41220, 41221, order)
				end
			end

			class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40763
					order[1] = 0
					super(40948, 40763, order)
				end
			end

			class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40769
					order[1] = 0
					super(40949, 40769, order)
				end
			end

			class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40776
					order[1] = 0
					super(40950, 40776, order)
				end
			end

			class NoPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42661
					order[1] = 42662
					order[2] = 0
					super(42660, 42661, order)
				end
			end

			class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41193
					order[1] = 0
					super(41192, 41193, order)
				end
			end

			class NoPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41228
					order[1] = 41229
					order[2] = 0
					super(41227, 41228, order)
				end
			end

			class NoPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41225
					order[1] = 41226
					order[2] = 0
					super(41224, 41225, order)
				end
			end

			class NoPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43109
					order[1] = 42684
					order[2] = 42685
					order[3] = 0
					super(42683, 43109, order)
				end
			end

			class NoDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42275
					order[1] = 42276
					order[2] = 42277
					order[3] = 42278
					order[4] = 42279
					order[5] = 42280
					order[6] = 42294
					order[7] = 42281
					order[8] = 42282
					order[9] = 42283
					order[10] = 42284
					order[11] = 42285
					order[12] = 42286
					order[13] = 42287
					order[14] = 42288
					order[15] = 42289
					order[16] = 42290
					order[17] = 42291
					order[18] = 42292
					order[19] = 42293
					order[20] = 0
					super(42274, 42275, order)
				end

				class NoDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42295
						order[1] = 0
						super(42294, 42295, order)
					end
				end
			end

			class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42273
					order[1] = 0
					super(42272, 42273, order)
				end
			end

			class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42237
					order[1] = 0
					super(42236, 42237, order)
				end
			end

			class NoReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42736
					order[1] = 42737
					order[2] = 42738
					order[3] = 42739
					order[4] = 42740
					order[5] = 42741
					order[6] = 42765
					order[7] = 42731
					order[8] = 42742
					order[9] = 42743
					order[10] = 42744
					order[11] = 42745
					order[12] = 42746
					order[13] = 42747
					order[14] = 42748
					order[15] = 42749
					order[16] = 42750
					order[17] = 42751
					order[18] = 42752
					order[19] = 42753
					order[20] = 42761
					order[21] = 42754
					order[22] = 42755
					order[23] = 42709
					order[24] = 42756
					order[25] = 42757
					order[26] = 42758
					order[27] = 42759
					order[28] = 42760
					order[29] = 0
					super(42735, 42736, order)
				end

				class NoReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42766
						order[1] = 42767
						order[2] = 42768
						order[3] = 42769
						order[4] = 0
						super(42765, 42766, order)
					end
				end

				class NoReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42732
						order[1] = 42733
						order[2] = 42734
						order[3] = 0
						super(42731, 42732, order)
					end
				end

				class NoReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42762
						order[1] = 42763
						order[2] = 42764
						order[3] = 0
						super(42761, 42762, order)
					end
				end

				class NoReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42710
						order[1] = 42772
						order[2] = 42711
						order[3] = 42712
						order[4] = 42713
						order[5] = 42714
						order[6] = 42715
						order[7] = 42716
						order[8] = 42717
						order[9] = 42718
						order[10] = 42719
						order[11] = 42720
						order[12] = 42721
						order[13] = 42722
						order[14] = 42723
						order[15] = 42724
						order[16] = 42725
						order[17] = 42726
						order[18] = 42727
						order[19] = 42728
						order[20] = 42729
						order[21] = 42730
						order[22] = 42770
						order[23] = 0
						super(42709, 42710, order)
					end

					class NoReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42773
							order[1] = 42774
							order[2] = 0
							super(42772, 42773, order)
						end
					end

					class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42771
							order[1] = 0
							super(42770, 42771, order)
						end
					end
				end
			end

			class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42621
					order[1] = 0
					super(42620, 42621, order)
				end
			end

			class NoPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42607
					order[1] = 42608
					order[2] = 0
					super(42606, 42607, order)
				end
			end

			class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40819
					order[1] = 0
					super(40946, 40819, order)
				end
			end

			class NoNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40826
					order[1] = 40827
					order[2] = 0
					super(40825, 40826, order)
				end
			end

			class NoSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40086
					order[1] = 40373
					order[2] = 40655
					order[3] = 40088
					order[4] = 40089
					order[5] = 0
					super(40085, 40086, order)
				end
			end

			class NoPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40829
					order[1] = 41164
					order[2] = 41165
					order[3] = 40830
					order[4] = 40831
					order[5] = 40832
					order[6] = 40833
					order[7] = 40834
					order[8] = 40835
					order[9] = 40836
					order[10] = 40837
					order[11] = 40838
					order[12] = 40839
					order[13] = 41166
					order[14] = 41167
					order[15] = 41168
					order[16] = 41169
					order[17] = 40840
					order[18] = 40841
					order[19] = 40842
					order[20] = 40843
					order[21] = 41170
					order[22] = 41171
					order[23] = 41172
					order[24] = 41173
					order[25] = 40844
					order[26] = 40845
					order[27] = 40846
					order[28] = 40847
					order[29] = 40848
					order[30] = 40849
					order[31] = 40868
					order[32] = 40850
					order[33] = 40851
					order[34] = 40852
					order[35] = 40853
					order[36] = 40977
					order[37] = 40855
					order[38] = 40856
					order[39] = 40857
					order[40] = 41174
					order[41] = 41175
					order[42] = 40858
					order[43] = 41161
					order[44] = 41176
					order[45] = 41177
					order[46] = 41178
					order[47] = 41179
					order[48] = 40859
					order[49] = 40860
					order[50] = 40861
					order[51] = 40862
					order[52] = 40945
					order[53] = 40864
					order[54] = 40865
					order[55] = 40866
					order[56] = 40867
					order[57] = 0
					super(40828, 40829, order)
				end

				class NoPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40869
						order[1] = 40870
						order[2] = 40871
						order[3] = 0
						super(40868, 40869, order)
					end
				end

				class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40854
						order[1] = 0
						super(40977, 40854, order)
					end
				end

				class NoPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41162
						order[1] = 41163
						order[2] = 0
						super(41161, 41162, order)
					end
				end

				class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40863
						order[1] = 0
						super(40945, 40863, order)
					end
				end
			end

			class NoPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40873
					order[1] = 40874
					order[2] = 42698
					order[3] = 42699
					order[4] = 42700
					order[5] = 42701
					order[6] = 42702
					order[7] = 42703
					order[8] = 42704
					order[9] = 42689
					order[10] = 42690
					order[11] = 42691
					order[12] = 42692
					order[13] = 42693
					order[14] = 42694
					order[15] = 42695
					order[16] = 40875
					order[17] = 40876
					order[18] = 40877
					order[19] = 40878
					order[20] = 40879
					order[21] = 40880
					order[22] = 40881
					order[23] = 40882
					order[24] = 40883
					order[25] = 40884
					order[26] = 40885
					order[27] = 40886
					order[28] = 40887
					order[29] = 40888
					order[30] = 40889
					order[31] = 40890
					order[32] = 40891
					order[33] = 40892
					order[34] = 40893
					order[35] = 40894
					order[36] = 40895
					order[37] = 40896
					order[38] = 40897
					order[39] = 40898
					order[40] = 40899
					order[41] = 40900
					order[42] = 40901
					order[43] = 0
					super(40872, 40873, order)
				end

				class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42706
						order[1] = 0
						super(42705, 42706, order)
					end
				end

				class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42697
						order[1] = 0
						super(42696, 42697, order)
					end
				end
			end

			class NoDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41086
					order[1] = 0
					super(41085, 41086, order)
				end
			end

			class NoDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41082
					order[1] = 41083
					order[2] = 41084
					order[3] = 0
					super(41081, 41082, order)
				end
			end

			class NoDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41038
					order[1] = 41039
					order[2] = 41040
					order[3] = 41041
					order[4] = 41042
					order[5] = 41043
					order[6] = 41044
					order[7] = 41045
					order[8] = 41046
					order[9] = 41047
					order[10] = 41048
					order[11] = 41049
					order[12] = 41050
					order[13] = 41051
					order[14] = 0
					super(41037, 41038, order)
				end

				class NoDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41052
						order[1] = 41053
						order[2] = 41054
						order[3] = 0
						super(41051, 41052, order)
					end

					class NoDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41055
							order[1] = 41056
							order[2] = 41057
							order[3] = 0
							super(41054, 41055, order)
						end
					end
				end
			end
		end

		class NoProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40091
				order[1] = 40092
				order[2] = 40093
				order[3] = 40957
				order[4] = 40095
				order[5] = 40096
				order[6] = 40097
				order[7] = 42707
				order[8] = 42708
				order[9] = 40098
				order[10] = 40099
				order[11] = 40100
				order[12] = 40114
				order[13] = 40115
				order[14] = 40116
				order[15] = 40118
				order[16] = 40119
				order[17] = 40120
				order[18] = 40121
				order[19] = 40122
				order[20] = 40123
				order[21] = 40125
				order[22] = 40126
				order[23] = 40127
				order[24] = 40128
				order[25] = 40129
				order[26] = 40130
				order[27] = 40131
				order[28] = 40132
				order[29] = 40133
				order[30] = 40134
				order[31] = 40135
				order[32] = 40136
				order[33] = 40137
				order[34] = 40138
				order[35] = 40139
				order[36] = 40140
				order[37] = 40141
				order[38] = 40145
				order[39] = 40146
				order[40] = 40148
				order[41] = 40149
				order[42] = 40150
				order[43] = 40151
				order[44] = 40152
				order[45] = 40153
				order[46] = 40154
				order[47] = 40155
				order[48] = 40156
				order[49] = 40158
				order[50] = 40159
				order[51] = 40160
				order[52] = 40161
				order[53] = 40162
				order[54] = 40101
				order[55] = 40102
				order[56] = 40103
				order[57] = 40104
				order[58] = 40105
				order[59] = 40106
				order[60] = 40107
				order[61] = 40163
				order[62] = 40165
				order[63] = 40166
				order[64] = 40167
				order[65] = 40168
				order[66] = 40169
				order[67] = 40170
				order[68] = 40108
				order[69] = 40109
				order[70] = 40110
				order[71] = 40111
				order[72] = 40112
				order[73] = 41406
				order[74] = 40113
				order[75] = 40986
				order[76] = 40987
				order[77] = 40174
				order[78] = 0
				super(40090, 40091, order)
			end

			class NoProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40094
					order[1] = 0
					super(40957, 40094, order)
				end
			end

			class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40117
					order[1] = 0
					super(40953, 40117, order)
				end
			end

			class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40124
					order[1] = 0
					super(40954, 40124, order)
				end
			end

			class NoProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40143
					order[1] = 40144
					order[2] = 0
					super(40142, 40143, order)
				end
			end

			class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40147
					order[1] = 0
					super(40955, 40147, order)
				end
			end

			class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40157
					order[1] = 0
					super(40956, 40157, order)
				end
			end

			class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40164
					order[1] = 0
					super(40952, 40164, order)
				end
			end

			class NoProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40172
					order[1] = 40173
					order[2] = 0
					super(40171, 40172, order)
				end
			end

			class NoProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40175
					order[1] = 40176
					order[2] = 40177
					order[3] = 2385
					order[4] = 40178
					order[5] = 0
					super(40174, 40175, order)
				end

				class NoProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40179
						order[1] = 40180
						order[2] = 0
						super(40178, 40179, order)
					end
				end
			end
		end

		class NoAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40020
				order[1] = 40021
				order[2] = 40000
				order[3] = 0
				super(40019, 40020, order)
			end

			class NoAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 40001
					order[1] = 40002
					order[2] = 40003
					order[3] = 40004
					order[4] = 40005
					order[5] = 40006
					order[6] = 40007
					order[7] = 40008
					order[8] = 40009
					order[9] = 40010
					order[10] = 40011
					order[11] = 40012
					order[12] = 40013
					order[13] = 40014
					order[14] = 40015
					order[15] = 40016
					order[16] = 40017
					order[17] = 40018
					order[18] = 0
					super(40000, 40001, order)
				end
			end
		end

		class NoProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 40182
				order[1] = 40183
				order[2] = 40184
				order[3] = 40185
				order[4] = 40186
				order[5] = 40187
				order[6] = 40188
				order[7] = 40951
				order[8] = 40191
				order[9] = 40201
				order[10] = 40190
				order[11] = 0
				super(40181, 40182, order)
			end

			class NoProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40189
					order[1] = 0
					super(40951, 40189, order)
				end
			end

			class NoProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40192
					order[1] = 40193
					order[2] = 40194
					order[3] = 40195
					order[4] = 40196
					order[5] = 40197
					order[6] = 40198
					order[7] = 40199
					order[8] = 0
					super(40191, 40192, order)
				end

				class NoProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40200
						order[1] = 0
						super(40199, 40200, order)
					end
				end
			end

			class NoProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40202
					order[1] = 40203
					order[2] = 0
					super(40201, 40202, order)
				end
			end
		end

		class NoCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 40023
				order[1] = 40024
				order[2] = 40916
				order[3] = 40917
				order[4] = 40025
				order[5] = 40026
				order[6] = 40027
				order[7] = 40028
				order[8] = 40029
				order[9] = 40030
				order[10] = 40031
				order[11] = 40277
				order[12] = 42216
				order[13] = 42217
				order[14] = 40033
				order[15] = 40034
				order[16] = 42207
				order[17] = 42208
				order[18] = 42209
				order[19] = 42210
				order[20] = 42211
				order[21] = 42212
				order[22] = 42213
				order[23] = 40035
				order[24] = 40036
				order[25] = 40037
				order[26] = 40038
				order[27] = 40039
				order[28] = 0
				super(40022, 40023, order)
			end

			class NoCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40032
					order[1] = 0
					super(40277, 40032, order)
				end
			end

			class NoCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42215
					order[1] = 0
					super(42214, 42215, order)
				end
			end
		end

		class NoPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40209
				order[1] = 40205
				order[2] = 40206
				order[3] = 40207
				order[4] = 40208
				order[5] = 0
				super(40204, 40209, order)
			end

			class NoPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40210
					order[1] = 40211
					order[2] = 0
					super(40209, 40210, order)
				end
			end
		end

		class NoExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42297
				order[1] = 42298
				order[2] = 0
				super(42296, 42297, order)
			end
		end

		class NoContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40041
				order[1] = 0
				super(40040, 40041, order)
			end
		end

		class NoFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40047
				order[1] = 40048
				order[2] = 0
				super(40046, 40047, order)
			end
		end

		class NoContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40043
				order[1] = 40044
				order[2] = 40045
				order[3] = 0
				super(40042, 40043, order)
			end
		end

		class NoUnderlyings < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(188)
				order[0] = 311
				order[1] = 312
				order[2] = 309
				order[3] = 305
				order[4] = 2874
				order[5] = 462
				order[6] = 463
				order[7] = 2894
				order[8] = 310
				order[9] = 763
				order[10] = 313
				order[11] = 542
				order[12] = 1213
				order[13] = 1837
				order[14] = 241
				order[15] = 1453
				order[16] = 1454
				order[17] = 2614
				order[18] = 2615
				order[19] = 2921
				order[20] = 2616
				order[21] = 2617
				order[22] = 2619
				order[23] = 1455
				order[24] = 1456
				order[25] = 1459
				order[26] = 1460
				order[27] = 242
				order[28] = 243
				order[29] = 244
				order[30] = 245
				order[31] = 246
				order[32] = 256
				order[33] = 595
				order[34] = 592
				order[35] = 593
				order[36] = 594
				order[37] = 247
				order[38] = 316
				order[39] = 941
				order[40] = 2917
				order[41] = 317
				order[42] = 436
				order[43] = 1437
				order[44] = 2363
				order[45] = 1441
				order[46] = 998
				order[47] = 1423
				order[48] = 1718
				order[49] = 2918
				order[50] = 1424
				order[51] = 1425
				order[52] = 1719
				order[53] = 2919
				order[54] = 1000
				order[55] = 1419
				order[56] = 1526
				order[57] = 2920
				order[58] = 435
				order[59] = 308
				order[60] = 306
				order[61] = 362
				order[62] = 363
				order[63] = 2742
				order[64] = 2720
				order[65] = 2721
				order[66] = 2722
				order[67] = 2723
				order[68] = 2724
				order[69] = 307
				order[70] = 364
				order[71] = 365
				order[72] = 877
				order[73] = 878
				order[74] = 972
				order[75] = 318
				order[76] = 2916
				order[77] = 879
				order[78] = 975
				order[79] = 973
				order[80] = 974
				order[81] = 810
				order[82] = 882
				order[83] = 883
				order[84] = 884
				order[85] = 885
				order[86] = 886
				order[87] = 2885
				order[88] = 2886
				order[89] = 1044
				order[90] = 1045
				order[91] = 1046
				order[92] = 1038
				order[93] = 1039
				order[94] = 315
				order[95] = 2683
				order[96] = 2687
				order[97] = 1988
				order[98] = 1989
				order[99] = 1990
				order[100] = 1991
				order[101] = 1992
				order[102] = 1993
				order[103] = 2881
				order[104] = 1994
				order[105] = 1995
				order[106] = 1996
				order[107] = 1997
				order[108] = 2620
				order[109] = 2621
				order[110] = 1998
				order[111] = 1999
				order[112] = 2000
				order[113] = 2003
				order[114] = 2004
				order[115] = 2005
				order[116] = 2006
				order[117] = 2284
				order[118] = 2285
				order[119] = 2286
				order[120] = 2287
				order[121] = 2288
				order[122] = 2007
				order[123] = 2008
				order[124] = 2009
				order[125] = 2010
				order[126] = 2011
				order[127] = 2012
				order[128] = 2491
				order[129] = 2013
				order[130] = 2014
				order[131] = 2015
				order[132] = 2744
				order[133] = 2016
				order[134] = 2289
				order[135] = 2017
				order[136] = 2018
				order[137] = 2019
				order[138] = 2020
				order[139] = 2021
				order[140] = 2022
				order[141] = 2290
				order[142] = 2622
				order[143] = 2291
				order[144] = 2623
				order[145] = 2292
				order[146] = 2023
				order[147] = 2024
				order[148] = 2025
				order[149] = 2026
				order[150] = 2027
				order[151] = 2028
				order[152] = 2029
				order[153] = 2757
				order[154] = 2030
				order[155] = 2031
				order[156] = 2293
				order[157] = 2294
				order[158] = 2032
				order[159] = 2033
				order[160] = 2034
				order[161] = 2035
				order[162] = 2036
				order[163] = 2037
				order[164] = 2038
				order[165] = 2039
				order[166] = 2040
				order[167] = 2041
				order[168] = 2042
				order[169] = 2043
				order[170] = 2044
				order[171] = 41314
				order[172] = 41315
				order[173] = 2295
				order[174] = 2296
				order[175] = 2297
				order[176] = 2756
				order[177] = 2298
				order[178] = 2299
				order[179] = 2624
				order[180] = 2625
				order[181] = 2626
				order[182] = 2627
				order[183] = 2628
				order[184] = 2629
				order[185] = 2630
				order[186] = 2631
				order[187] = 0
				super(711, 311, order)
			end

			class NoUnderlyingSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 458
					order[1] = 459
					order[2] = 2959
					order[3] = 0
					super(457, 458, order)
				end
			end

			class NoUnderlyingStips < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 888
					order[1] = 889
					order[2] = 0
					super(887, 888, order)
				end
			end

			class NoUndlyInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 1059
					order[1] = 1060
					order[2] = 1061
					order[3] = 2391
					order[4] = 1062
					order[5] = 0
					super(1058, 1059, order)
				end

				class NoUndlyInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1063
						order[1] = 1064
						order[2] = 0
						super(1062, 1063, order)
					end
				end
			end

			class NoUnderlyingEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 1982
					order[1] = 1983
					order[2] = 1984
					order[3] = 1985
					order[4] = 1986
					order[5] = 2342
					order[6] = 1987
					order[7] = 2071
					order[8] = 2072
					order[9] = 2073
					order[10] = 0
					super(1981, 1982, order)
				end
			end

			class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2081
					order[1] = 2082
					order[2] = 2083
					order[3] = 2745
					order[4] = 0
					super(2080, 2081, order)
				end
			end

			class NoUnderlyingAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2313
					order[1] = 2314
					order[2] = 2315
					order[3] = 0
					super(2312, 2313, order)
				end
			end

			class NoUnderlyingComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2046
					order[1] = 2261
					order[2] = 2262
					order[3] = 2263
					order[4] = 2047
					order[5] = 2264
					order[6] = 2265
					order[7] = 2266
					order[8] = 2947
					order[9] = 2048
					order[10] = 2267
					order[11] = 2049
					order[12] = 2050
					order[13] = 2051
					order[14] = 2052
					order[15] = 2053
					order[16] = 2268
					order[17] = 2948
					order[18] = 2269
					order[19] = 2949
					order[20] = 2270
					order[21] = 2271
					order[22] = 2419
					order[23] = 2420
					order[24] = 2272
					order[25] = 2273
					order[26] = 2274
					order[27] = 2275
					order[28] = 2276
					order[29] = 41732
					order[30] = 41739
					order[31] = 41740
					order[32] = 41741
					order[33] = 41742
					order[34] = 41743
					order[35] = 41744
					order[36] = 41745
					order[37] = 41746
					order[38] = 41747
					order[39] = 41729
					order[40] = 2277
					order[41] = 2278
					order[42] = 2279
					order[43] = 2280
					order[44] = 2281
					order[45] = 41748
					order[46] = 41716
					order[47] = 2611
					order[48] = 2612
					order[49] = 2613
					order[50] = 2282
					order[51] = 2283
					order[52] = 0
					super(2045, 2046, order)
				end

				class NoUnderlyingComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2054
						order[1] = 2055
						order[2] = 2056
						order[3] = 0
						super(2053, 2054, order)
					end

					class NoUnderlyingComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2057
							order[1] = 2058
							order[2] = 0
							super(2056, 2057, order)
						end
					end
				end

				class NoUnderlyingComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41733
						order[1] = 41734
						order[2] = 41735
						order[3] = 41736
						order[4] = 0
						super(41732, 41733, order)
					end
				end

				class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41738
						order[1] = 0
						super(41737, 41738, order)
					end
				end

				class NoUnderlyingComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41730
						order[1] = 41731
						order[2] = 41750
						order[3] = 41726
						order[4] = 41713
						order[5] = 0
						super(41729, 41730, order)
					end

					class NoUnderlyingComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41751
							order[1] = 41752
							order[2] = 41753
							order[3] = 41754
							order[4] = 41755
							order[5] = 0
							super(41750, 41751, order)
						end
					end

					class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41727
							order[1] = 41728
							order[2] = 0
							super(41726, 41727, order)
						end
					end

					class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41714
							order[1] = 41715
							order[2] = 0
							super(41713, 41714, order)
						end
					end
				end

				class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41749
						order[1] = 0
						super(41748, 41749, order)
					end
				end

				class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41717
						order[1] = 41718
						order[2] = 41719
						order[3] = 41720
						order[4] = 41721
						order[5] = 41722
						order[6] = 41723
						order[7] = 41724
						order[8] = 0
						super(41716, 41717, order)
					end

					class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41725
							order[1] = 0
							super(41724, 41725, order)
						end
					end
				end
			end

			class NoUnderlyingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40963
					order[1] = 0
					super(40962, 40963, order)
				end
			end

			class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41948
					order[1] = 0
					super(41947, 41948, order)
				end
			end

			class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41865
					order[1] = 41338
					order[2] = 0
					super(41864, 41865, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41867
					order[1] = 41339
					order[2] = 0
					super(41866, 41867, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41869
					order[1] = 41870
					order[2] = 41871
					order[3] = 41872
					order[4] = 41873
					order[5] = 41874
					order[6] = 41875
					order[7] = 41876
					order[8] = 41877
					order[9] = 0
					super(41868, 41869, order)
				end
			end

			class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 43075
					order[1] = 0
					super(43074, 43075, order)
				end
			end

			class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41821
					order[1] = 0
					super(41820, 41821, order)
				end
			end

			class NoUnderlyingOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41842
					order[1] = 41843
					order[2] = 0
					super(41841, 41842, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41845
					order[1] = 0
					super(41844, 41845, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41857
					order[1] = 41858
					order[2] = 0
					super(41856, 41857, order)
				end
			end

			class NoUnderlyingStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40541
					order[1] = 42016
					order[2] = 40542
					order[3] = 43083
					order[4] = 43084
					order[5] = 40543
					order[6] = 40544
					order[7] = 42018
					order[8] = 40545
					order[9] = 40546
					order[10] = 43085
					order[11] = 43086
					order[12] = 42019
					order[13] = 42020
					order[14] = 42021
					order[15] = 42022
					order[16] = 42023
					order[17] = 42024
					order[18] = 41964
					order[19] = 41965
					order[20] = 41966
					order[21] = 41967
					order[22] = 41968
					order[23] = 41969
					order[24] = 41970
					order[25] = 42589
					order[26] = 41971
					order[27] = 41972
					order[28] = 41973
					order[29] = 41974
					order[30] = 41975
					order[31] = 41976
					order[32] = 41977
					order[33] = 41978
					order[34] = 41979
					order[35] = 41980
					order[36] = 41981
					order[37] = 41982
					order[38] = 41983
					order[39] = 41984
					order[40] = 41985
					order[41] = 41986
					order[42] = 41987
					order[43] = 41988
					order[44] = 41989
					order[45] = 40057
					order[46] = 40058
					order[47] = 40060
					order[48] = 40061
					order[49] = 40062
					order[50] = 40063
					order[51] = 40064
					order[52] = 40548
					order[53] = 40549
					order[54] = 40551
					order[55] = 40552
					order[56] = 40553
					order[57] = 40554
					order[58] = 40555
					order[59] = 41957
					order[60] = 41958
					order[61] = 40556
					order[62] = 40558
					order[63] = 40559
					order[64] = 40561
					order[65] = 40562
					order[66] = 40563
					order[67] = 40564
					order[68] = 40565
					order[69] = 40566
					order[70] = 40567
					order[71] = 41959
					order[72] = 41960
					order[73] = 41961
					order[74] = 40568
					order[75] = 40569
					order[76] = 40570
					order[77] = 42895
					order[78] = 40571
					order[79] = 40572
					order[80] = 43107
					order[81] = 40573
					order[82] = 40574
					order[83] = 40575
					order[84] = 40576
					order[85] = 40577
					order[86] = 42896
					order[87] = 42897
					order[88] = 42898
					order[89] = 42899
					order[90] = 40578
					order[91] = 40579
					order[92] = 40580
					order[93] = 41897
					order[94] = 41898
					order[95] = 41899
					order[96] = 41900
					order[97] = 41901
					order[98] = 41902
					order[99] = 41903
					order[100] = 42900
					order[101] = 40664
					order[102] = 40708
					order[103] = 41777
					order[104] = 41778
					order[105] = 41779
					order[106] = 41780
					order[107] = 41781
					order[108] = 42196
					order[109] = 42197
					order[110] = 41782
					order[111] = 41783
					order[112] = 41784
					order[113] = 41785
					order[114] = 41786
					order[115] = 41587
					order[116] = 41787
					order[117] = 41788
					order[118] = 41789
					order[119] = 41790
					order[120] = 41791
					order[121] = 41792
					order[122] = 41793
					order[123] = 41794
					order[124] = 41795
					order[125] = 41796
					order[126] = 41797
					order[127] = 41798
					order[128] = 41799
					order[129] = 43096
					order[130] = 41756
					order[131] = 40547
					order[132] = 40988
					order[133] = 40989
					order[134] = 0
					super(40540, 40541, order)
				end

				class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41991
						order[1] = 41992
						order[2] = 0
						super(41990, 41991, order)
					end
				end

				class NoUnderlyingStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41801
						order[1] = 41802
						order[2] = 41803
						order[3] = 0
						super(41800, 41801, order)
					end
				end

				class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41994
						order[1] = 41995
						order[2] = 0
						super(41993, 41994, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41963
						order[1] = 0
						super(41962, 41963, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 42003
						order[1] = 42004
						order[2] = 42005
						order[3] = 42006
						order[4] = 42007
						order[5] = 42008
						order[6] = 42009
						order[7] = 42010
						order[8] = 42011
						order[9] = 42012
						order[10] = 42013
						order[11] = 41996
						order[12] = 42014
						order[13] = 42015
						order[14] = 0
						super(42002, 42003, order)
					end

					class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41997
							order[1] = 41998
							order[2] = 41999
							order[3] = 0
							super(41996, 41997, order)
						end

						class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 42000
								order[1] = 42001
								order[2] = 41936
								order[3] = 0
								super(41999, 42000, order)
							end
						end
					end
				end

				class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40059
						order[1] = 0
						super(40975, 40059, order)
					end
				end

				class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40550
						order[1] = 0
						super(40976, 40550, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40557
						order[1] = 0
						super(40973, 40557, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41955
						order[1] = 41956
						order[2] = 0
						super(41954, 41955, order)
					end
				end

				class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40560
						order[1] = 0
						super(40974, 40560, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40582
						order[1] = 0
						super(40969, 40582, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41938
						order[1] = 41939
						order[2] = 0
						super(41937, 41938, order)
					end
				end

				class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40594
						order[1] = 0
						super(40970, 40594, order)
					end
				end

				class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40600
						order[1] = 0
						super(40971, 40600, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40607
						order[1] = 0
						super(40972, 40607, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42956
						order[1] = 42957
						order[2] = 0
						super(42955, 42956, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41910
						order[1] = 0
						super(41909, 41910, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41945
						order[1] = 41946
						order[2] = 0
						super(41944, 41945, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41942
						order[1] = 41943
						order[2] = 0
						super(41941, 41942, order)
					end
				end

				class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43111
						order[1] = 42982
						order[2] = 42983
						order[3] = 0
						super(42981, 43111, order)
					end
				end

				class NoUnderlyingDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42863
						order[1] = 42864
						order[2] = 42865
						order[3] = 42866
						order[4] = 42867
						order[5] = 42868
						order[6] = 42882
						order[7] = 42869
						order[8] = 42870
						order[9] = 42871
						order[10] = 42872
						order[11] = 42873
						order[12] = 42874
						order[13] = 42875
						order[14] = 42876
						order[15] = 42877
						order[16] = 42878
						order[17] = 42879
						order[18] = 42880
						order[19] = 42881
						order[20] = 0
						super(42862, 42863, order)
					end

					class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42883
							order[1] = 0
							super(42882, 42883, order)
						end
					end
				end

				class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42854
						order[1] = 0
						super(42853, 42854, order)
					end
				end

				class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42800
						order[1] = 0
						super(42799, 42800, order)
					end
				end

				class NoUnderlyingReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 43035
						order[1] = 43036
						order[2] = 43037
						order[3] = 43038
						order[4] = 43039
						order[5] = 43040
						order[6] = 43064
						order[7] = 43030
						order[8] = 43041
						order[9] = 43042
						order[10] = 43043
						order[11] = 43044
						order[12] = 43045
						order[13] = 43046
						order[14] = 43047
						order[15] = 43048
						order[16] = 43049
						order[17] = 43050
						order[18] = 43051
						order[19] = 43052
						order[20] = 43060
						order[21] = 43053
						order[22] = 43054
						order[23] = 43008
						order[24] = 43055
						order[25] = 43056
						order[26] = 43057
						order[27] = 43058
						order[28] = 43059
						order[29] = 0
						super(43034, 43035, order)
					end

					class NoUnderlyingReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 43065
							order[1] = 43066
							order[2] = 43067
							order[3] = 43068
							order[4] = 0
							super(43064, 43065, order)
						end
					end

					class NoUnderlyingReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43031
							order[1] = 43032
							order[2] = 43033
							order[3] = 0
							super(43030, 43031, order)
						end
					end

					class NoUnderlyingReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43061
							order[1] = 43062
							order[2] = 43063
							order[3] = 0
							super(43060, 43061, order)
						end
					end

					class NoUnderlyingReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 43009
							order[1] = 43071
							order[2] = 43010
							order[3] = 43011
							order[4] = 43012
							order[5] = 43013
							order[6] = 43014
							order[7] = 43015
							order[8] = 43016
							order[9] = 43017
							order[10] = 43018
							order[11] = 43019
							order[12] = 43020
							order[13] = 43021
							order[14] = 43022
							order[15] = 43023
							order[16] = 43024
							order[17] = 43025
							order[18] = 43026
							order[19] = 43027
							order[20] = 43028
							order[21] = 43029
							order[22] = 43069
							order[23] = 0
							super(43008, 43009, order)
						end

						class NoUnderlyingReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 43072
								order[1] = 43073
								order[2] = 0
								super(43071, 43072, order)
							end
						end

						class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 43070
								order[1] = 0
								super(43069, 43070, order)
							end
						end
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42916
						order[1] = 0
						super(42915, 42916, order)
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42902
						order[1] = 42903
						order[2] = 0
						super(42901, 42902, order)
					end
				end

				class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40650
						order[1] = 0
						super(40968, 40650, order)
					end
				end

				class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40657
						order[1] = 40658
						order[2] = 0
						super(40656, 40657, order)
					end
				end

				class NoUnderlyingSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40660
						order[1] = 40904
						order[2] = 40915
						order[3] = 40662
						order[4] = 40663
						order[5] = 0
						super(40659, 40660, order)
					end
				end

				class NoUnderlyingPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40665
						order[1] = 41881
						order[2] = 41882
						order[3] = 40666
						order[4] = 40667
						order[5] = 40668
						order[6] = 40669
						order[7] = 40670
						order[8] = 40671
						order[9] = 40672
						order[10] = 40673
						order[11] = 40674
						order[12] = 40675
						order[13] = 41883
						order[14] = 41884
						order[15] = 41885
						order[16] = 41886
						order[17] = 40676
						order[18] = 40677
						order[19] = 40678
						order[20] = 40679
						order[21] = 41887
						order[22] = 41888
						order[23] = 41889
						order[24] = 41890
						order[25] = 40680
						order[26] = 40681
						order[27] = 40682
						order[28] = 40683
						order[29] = 40684
						order[30] = 40685
						order[31] = 40704
						order[32] = 40686
						order[33] = 40687
						order[34] = 40688
						order[35] = 40689
						order[36] = 40966
						order[37] = 40691
						order[38] = 40692
						order[39] = 40693
						order[40] = 41891
						order[41] = 41892
						order[42] = 40694
						order[43] = 41878
						order[44] = 41893
						order[45] = 41894
						order[46] = 41895
						order[47] = 41896
						order[48] = 40695
						order[49] = 40696
						order[50] = 40697
						order[51] = 40698
						order[52] = 40967
						order[53] = 40700
						order[54] = 40701
						order[55] = 40702
						order[56] = 40703
						order[57] = 0
						super(40664, 40665, order)
					end

					class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40705
							order[1] = 40706
							order[2] = 40707
							order[3] = 0
							super(40704, 40705, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40690
							order[1] = 0
							super(40966, 40690, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41879
							order[1] = 41880
							order[2] = 0
							super(41878, 41879, order)
						end
					end

					class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40699
							order[1] = 0
							super(40967, 40699, order)
						end
					end
				end

				class NoUnderlyingPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40709
						order[1] = 40710
						order[2] = 42993
						order[3] = 42994
						order[4] = 42995
						order[5] = 42996
						order[6] = 42997
						order[7] = 42998
						order[8] = 42999
						order[9] = 42984
						order[10] = 42985
						order[11] = 42986
						order[12] = 42987
						order[13] = 42988
						order[14] = 42989
						order[15] = 42990
						order[16] = 40711
						order[17] = 40712
						order[18] = 40713
						order[19] = 40714
						order[20] = 40715
						order[21] = 40716
						order[22] = 40717
						order[23] = 40718
						order[24] = 40719
						order[25] = 40720
						order[26] = 40721
						order[27] = 40722
						order[28] = 40723
						order[29] = 40724
						order[30] = 40725
						order[31] = 40726
						order[32] = 40727
						order[33] = 40728
						order[34] = 40729
						order[35] = 40730
						order[36] = 40731
						order[37] = 40732
						order[38] = 40733
						order[39] = 40734
						order[40] = 40735
						order[41] = 40736
						order[42] = 40737
						order[43] = 0
						super(40708, 40709, order)
					end

					class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43001
							order[1] = 0
							super(43000, 43001, order)
						end
					end

					class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42992
							order[1] = 0
							super(42991, 42992, order)
						end
					end
				end

				class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41809
						order[1] = 0
						super(41808, 41809, order)
					end
				end

				class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41805
						order[1] = 41806
						order[2] = 41807
						order[3] = 0
						super(41804, 41805, order)
					end
				end

				class NoUnderlyingDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41757
						order[1] = 41758
						order[2] = 41759
						order[3] = 41760
						order[4] = 41761
						order[5] = 41762
						order[6] = 41763
						order[7] = 41764
						order[8] = 41765
						order[9] = 41766
						order[10] = 41767
						order[11] = 41768
						order[12] = 41769
						order[13] = 41770
						order[14] = 0
						super(41756, 41757, order)
					end

					class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41771
							order[1] = 41772
							order[2] = 41773
							order[3] = 0
							super(41770, 41771, order)
						end

						class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41774
								order[1] = 41775
								order[2] = 41776
								order[3] = 0
								super(41773, 41774, order)
							end
						end
					end
				end
			end

			class NoUnderlyingProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 42150
					order[1] = 42151
					order[2] = 42152
					order[3] = 42190
					order[4] = 42153
					order[5] = 42154
					order[6] = 42155
					order[7] = 43002
					order[8] = 43003
					order[9] = 42156
					order[10] = 42157
					order[11] = 42158
					order[12] = 42104
					order[13] = 42105
					order[14] = 42106
					order[15] = 42107
					order[16] = 42108
					order[17] = 42109
					order[18] = 42110
					order[19] = 42111
					order[20] = 42115
					order[21] = 42116
					order[22] = 42117
					order[23] = 42118
					order[24] = 42119
					order[25] = 42120
					order[26] = 42121
					order[27] = 42122
					order[28] = 42123
					order[29] = 42124
					order[30] = 42125
					order[31] = 42126
					order[32] = 42127
					order[33] = 42128
					order[34] = 42129
					order[35] = 42130
					order[36] = 42131
					order[37] = 42132
					order[38] = 42133
					order[39] = 42134
					order[40] = 42135
					order[41] = 42136
					order[42] = 42137
					order[43] = 42138
					order[44] = 42139
					order[45] = 42140
					order[46] = 42141
					order[47] = 42142
					order[48] = 42143
					order[49] = 42144
					order[50] = 42145
					order[51] = 42146
					order[52] = 42147
					order[53] = 42148
					order[54] = 42159
					order[55] = 42160
					order[56] = 42161
					order[57] = 42162
					order[58] = 42163
					order[59] = 42164
					order[60] = 42165
					order[61] = 42092
					order[62] = 42093
					order[63] = 42094
					order[64] = 42095
					order[65] = 42096
					order[66] = 42097
					order[67] = 42098
					order[68] = 42166
					order[69] = 42167
					order[70] = 42168
					order[71] = 42169
					order[72] = 42102
					order[73] = 42103
					order[74] = 42170
					order[75] = 42171
					order[76] = 42172
					order[77] = 42173
					order[78] = 0
					super(42149, 42150, order)
				end

				class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42191
						order[1] = 0
						super(42190, 42191, order)
					end
				end

				class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42183
						order[1] = 0
						super(42182, 42183, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42185
						order[1] = 0
						super(42184, 42185, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42113
						order[1] = 42114
						order[2] = 0
						super(42112, 42113, order)
					end
				end

				class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42187
						order[1] = 0
						super(42186, 42187, order)
					end
				end

				class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42189
						order[1] = 0
						super(42188, 42189, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42181
						order[1] = 0
						super(42180, 42181, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42100
						order[1] = 42101
						order[2] = 0
						super(42099, 42100, order)
					end
				end

				class NoUnderlyingProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 42174
						order[1] = 42175
						order[2] = 42176
						order[3] = 40918
						order[4] = 42177
						order[5] = 0
						super(42173, 42174, order)
					end

					class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42178
							order[1] = 42179
							order[2] = 0
							super(42177, 42178, order)
						end
					end
				end
			end

			class NoUnderlyingAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42037
					order[1] = 42038
					order[2] = 41340
					order[3] = 0
					super(42036, 42037, order)
				end

				class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41341
						order[1] = 41701
						order[2] = 41709
						order[3] = 41710
						order[4] = 41711
						order[5] = 41712
						order[6] = 42017
						order[7] = 42025
						order[8] = 42026
						order[9] = 42027
						order[10] = 42028
						order[11] = 42029
						order[12] = 42030
						order[13] = 42031
						order[14] = 42032
						order[15] = 42033
						order[16] = 42034
						order[17] = 42035
						order[18] = 0
						super(41340, 41341, order)
					end
				end
			end

			class NoUnderlyingProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 42069
					order[1] = 42070
					order[2] = 42071
					order[3] = 42072
					order[4] = 42073
					order[5] = 42074
					order[6] = 42075
					order[7] = 42090
					order[8] = 42077
					order[9] = 42087
					order[10] = 42076
					order[11] = 0
					super(42068, 42069, order)
				end

				class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42091
						order[1] = 0
						super(42090, 42091, order)
					end
				end

				class NoUnderlyingProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 42078
						order[1] = 42079
						order[2] = 42080
						order[3] = 42081
						order[4] = 42082
						order[5] = 42083
						order[6] = 42084
						order[7] = 42085
						order[8] = 0
						super(42077, 42078, order)
					end

					class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42086
							order[1] = 0
							super(42085, 42086, order)
						end
					end
				end

				class NoUnderlyingProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42088
						order[1] = 42089
						order[2] = 0
						super(42087, 42088, order)
					end
				end
			end

			class NoUnderlyingCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 42042
					order[1] = 42043
					order[2] = 42044
					order[3] = 42045
					order[4] = 42046
					order[5] = 42047
					order[6] = 42048
					order[7] = 42049
					order[8] = 42050
					order[9] = 42051
					order[10] = 42052
					order[11] = 42039
					order[12] = 42797
					order[13] = 42798
					order[14] = 42053
					order[15] = 42054
					order[16] = 42790
					order[17] = 42791
					order[18] = 42792
					order[19] = 42793
					order[20] = 42794
					order[21] = 42795
					order[22] = 42796
					order[23] = 42055
					order[24] = 42056
					order[25] = 42057
					order[26] = 42058
					order[27] = 42059
					order[28] = 0
					super(42041, 42042, order)
				end

				class NoUnderlyingCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42040
						order[1] = 0
						super(42039, 42040, order)
					end
				end

				class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42789
						order[1] = 0
						super(42788, 42789, order)
					end
				end
			end

			class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42065
					order[1] = 42061
					order[2] = 42062
					order[3] = 42063
					order[4] = 42064
					order[5] = 0
					super(42060, 42065, order)
				end

				class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42066
						order[1] = 42067
						order[2] = 0
						super(42065, 42066, order)
					end
				end
			end

			class NoUnderlyingRateSpreadSteps < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 43006
					order[1] = 43007
					order[2] = 0
					super(43005, 43006, order)
				end
			end

			class NoUnderlyingDividendPayments < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42856
					order[1] = 42857
					order[2] = 42858
					order[3] = 42859
					order[4] = 0
					super(42855, 42856, order)
				end
			end

			class NoUnderlyingExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42885
					order[1] = 42886
					order[2] = 0
					super(42884, 42885, order)
				end
			end
		end

		class NoLegs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(176)
				order[0] = 600
				order[1] = 601
				order[2] = 602
				order[3] = 603
				order[4] = 1788
				order[5] = 607
				order[6] = 1594
				order[7] = 608
				order[8] = 2893
				order[9] = 609
				order[10] = 764
				order[11] = 610
				order[12] = 611
				order[13] = 1212
				order[14] = 2146
				order[15] = 2147
				order[16] = 2148
				order[17] = 248
				order[18] = 2149
				order[19] = 2150
				order[20] = 2151
				order[21] = 2152
				order[22] = 2153
				order[23] = 2154
				order[24] = 2155
				order[25] = 2348
				order[26] = 2067
				order[27] = 2068
				order[28] = 2069
				order[29] = 2739
				order[30] = 2070
				order[31] = 2156
				order[32] = 2157
				order[33] = 2158
				order[34] = 2159
				order[35] = 2160
				order[36] = 2161
				order[37] = 2162
				order[38] = 2163
				order[39] = 2164
				order[40] = 2165
				order[41] = 2880
				order[42] = 2166
				order[43] = 2167
				order[44] = 2168
				order[45] = 2169
				order[46] = 2170
				order[47] = 2171
				order[48] = 2172
				order[49] = 2173
				order[50] = 2174
				order[51] = 2175
				order[52] = 2176
				order[53] = 2177
				order[54] = 2178
				order[55] = 2179
				order[56] = 2180
				order[57] = 249
				order[58] = 250
				order[59] = 251
				order[60] = 252
				order[61] = 253
				order[62] = 257
				order[63] = 599
				order[64] = 596
				order[65] = 597
				order[66] = 598
				order[67] = 254
				order[68] = 612
				order[69] = 942
				order[70] = 2908
				order[71] = 2181
				order[72] = 2182
				order[73] = 2183
				order[74] = 2184
				order[75] = 2604
				order[76] = 2185
				order[77] = 2605
				order[78] = 2186
				order[79] = 2187
				order[80] = 2188
				order[81] = 2189
				order[82] = 613
				order[83] = 614
				order[84] = 1436
				order[85] = 2354
				order[86] = 1440
				order[87] = 2190
				order[88] = 2191
				order[89] = 999
				order[90] = 1224
				order[91] = 1720
				order[92] = 2909
				order[93] = 1421
				order[94] = 1422
				order[95] = 1721
				order[96] = 2910
				order[97] = 2192
				order[98] = 1001
				order[99] = 1420
				order[100] = 2193
				order[101] = 2194
				order[102] = 2755
				order[103] = 2195
				order[104] = 2196
				order[105] = 2197
				order[106] = 2198
				order[107] = 1528
				order[108] = 2911
				order[109] = 2199
				order[110] = 2200
				order[111] = 2201
				order[112] = 2202
				order[113] = 2203
				order[114] = 615
				order[115] = 616
				order[116] = 2205
				order[117] = 2206
				order[118] = 617
				order[119] = 618
				order[120] = 619
				order[121] = 2740
				order[122] = 2717
				order[123] = 2718
				order[124] = 2719
				order[125] = 620
				order[126] = 621
				order[127] = 622
				order[128] = 2207
				order[129] = 2208
				order[130] = 623
				order[131] = 624
				order[132] = 556
				order[133] = 2898
				order[134] = 740
				order[135] = 739
				order[136] = 955
				order[137] = 956
				order[138] = 1358
				order[139] = 2682
				order[140] = 2686
				order[141] = 1017
				order[142] = 566
				order[143] = 2209
				order[144] = 2211
				order[145] = 2212
				order[146] = 2213
				order[147] = 2754
				order[148] = 2214
				order[149] = 2215
				order[150] = 2606
				order[151] = 2607
				order[152] = 2497
				order[153] = 2498
				order[154] = 2499
				order[155] = 2496
				order[156] = 2495
				order[157] = 2953
				order[158] = 2511
				order[159] = 2510
				order[160] = 2512
				order[161] = 2509
				order[162] = 2500
				order[163] = 2502
				order[164] = 2501
				order[165] = 2503
				order[166] = 2507
				order[167] = 2505
				order[168] = 2494
				order[169] = 2493
				order[170] = 2514
				order[171] = 2513
				order[172] = 2506
				order[173] = 2504
				order[174] = 2508
				order[175] = 0
				super(555, 600, order)
			end

			class NoLegSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 605
					order[1] = 606
					order[2] = 2958
					order[3] = 0
					super(604, 605, order)
				end
			end

			class NoLegSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2077
					order[1] = 2078
					order[2] = 2079
					order[3] = 2743
					order[4] = 0
					super(2076, 2077, order)
				end
			end

			class NoLegAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2309
					order[1] = 2310
					order[2] = 2311
					order[3] = 0
					super(2308, 2309, order)
				end
			end

			class NoLegEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 2060
					order[1] = 2061
					order[2] = 2062
					order[3] = 2063
					order[4] = 2064
					order[5] = 2341
					order[6] = 2065
					order[7] = 2066
					order[8] = 2074
					order[9] = 2075
					order[10] = 0
					super(2059, 2060, order)
				end
			end

			class NoLegInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 2255
					order[1] = 2256
					order[2] = 2257
					order[3] = 2379
					order[4] = 2258
					order[5] = 0
					super(2254, 2255, order)
				end

				class NoLegInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2259
						order[1] = 2260
						order[2] = 0
						super(2258, 2259, order)
					end
				end
			end

			class NoLegComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2219
					order[1] = 2220
					order[2] = 2221
					order[3] = 2222
					order[4] = 2223
					order[5] = 2224
					order[6] = 2225
					order[7] = 2226
					order[8] = 2944
					order[9] = 2227
					order[10] = 2228
					order[11] = 2229
					order[12] = 2230
					order[13] = 2231
					order[14] = 2232
					order[15] = 2250
					order[16] = 2233
					order[17] = 2945
					order[18] = 2234
					order[19] = 2946
					order[20] = 2235
					order[21] = 2236
					order[22] = 2409
					order[23] = 2410
					order[24] = 2237
					order[25] = 2238
					order[26] = 2239
					order[27] = 2240
					order[28] = 2241
					order[29] = 41382
					order[30] = 41389
					order[31] = 41390
					order[32] = 41391
					order[33] = 41392
					order[34] = 41393
					order[35] = 41394
					order[36] = 41395
					order[37] = 41396
					order[38] = 41397
					order[39] = 41379
					order[40] = 2242
					order[41] = 2243
					order[42] = 2244
					order[43] = 2245
					order[44] = 2246
					order[45] = 41398
					order[46] = 41366
					order[47] = 2608
					order[48] = 2609
					order[49] = 2610
					order[50] = 2248
					order[51] = 2249
					order[52] = 0
					super(2218, 2219, order)
				end

				class NoLegComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2251
						order[1] = 2252
						order[2] = 2253
						order[3] = 0
						super(2250, 2251, order)
					end

					class NoLegComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2204
							order[1] = 2247
							order[2] = 0
							super(2253, 2204, order)
						end
					end
				end

				class NoLegComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41383
						order[1] = 41384
						order[2] = 41385
						order[3] = 41386
						order[4] = 0
						super(41382, 41383, order)
					end
				end

				class NoLegComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41388
						order[1] = 0
						super(41387, 41388, order)
					end
				end

				class NoLegComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41380
						order[1] = 41381
						order[2] = 41400
						order[3] = 41376
						order[4] = 41363
						order[5] = 0
						super(41379, 41380, order)
					end

					class NoLegComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41401
							order[1] = 41402
							order[2] = 41403
							order[3] = 41404
							order[4] = 41405
							order[5] = 0
							super(41400, 41401, order)
						end
					end

					class NoLegComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41377
							order[1] = 41378
							order[2] = 0
							super(41376, 41377, order)
						end
					end

					class NoLegComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41364
							order[1] = 41365
							order[2] = 0
							super(41363, 41364, order)
						end
					end
				end

				class NoLegComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41399
						order[1] = 0
						super(41398, 41399, order)
					end
				end

				class NoLegComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41367
						order[1] = 41368
						order[2] = 41369
						order[3] = 41370
						order[4] = 41371
						order[5] = 41372
						order[6] = 41373
						order[7] = 41374
						order[8] = 0
						super(41366, 41367, order)
					end

					class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41375
							order[1] = 0
							super(41374, 41375, order)
						end
					end
				end
			end

			class NoLegBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40924
					order[1] = 0
					super(40923, 40924, order)
				end
			end

			class NoLegPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41608
					order[1] = 0
					super(41607, 41608, order)
				end
			end

			class NoLegMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41468
					order[1] = 40223
					order[2] = 0
					super(41467, 41468, order)
				end
			end

			class NoLegMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41470
					order[1] = 40990
					order[2] = 0
					super(41469, 41470, order)
				end
			end

			class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41472
					order[1] = 41473
					order[2] = 41474
					order[3] = 41475
					order[4] = 41476
					order[5] = 41477
					order[6] = 41478
					order[7] = 41479
					order[8] = 41480
					order[9] = 0
					super(41471, 41472, order)
				end
			end

			class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42582
					order[1] = 0
					super(42581, 42582, order)
				end
			end

			class NoLegOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41492
					order[1] = 0
					super(41491, 41492, order)
				end
			end

			class NoLegOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41513
					order[1] = 41514
					order[2] = 0
					super(41512, 41513, order)
				end
			end

			class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41516
					order[1] = 0
					super(41515, 41516, order)
				end
			end

			class NoLegOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41528
					order[1] = 41529
					order[2] = 0
					super(41527, 41528, order)
				end
			end

			class NoLegStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40242
					order[1] = 41700
					order[2] = 40243
					order[3] = 42583
					order[4] = 42584
					order[5] = 40244
					order[6] = 40245
					order[7] = 41702
					order[8] = 40246
					order[9] = 40247
					order[10] = 42585
					order[11] = 42586
					order[12] = 41703
					order[13] = 41704
					order[14] = 41705
					order[15] = 41706
					order[16] = 41707
					order[17] = 41708
					order[18] = 41648
					order[19] = 41649
					order[20] = 41650
					order[21] = 41651
					order[22] = 41652
					order[23] = 41653
					order[24] = 41654
					order[25] = 42588
					order[26] = 41655
					order[27] = 41656
					order[28] = 41657
					order[29] = 41658
					order[30] = 41659
					order[31] = 41660
					order[32] = 41661
					order[33] = 41662
					order[34] = 41663
					order[35] = 41664
					order[36] = 41665
					order[37] = 41666
					order[38] = 41667
					order[39] = 41668
					order[40] = 41669
					order[41] = 41670
					order[42] = 41671
					order[43] = 41672
					order[44] = 41673
					order[45] = 40249
					order[46] = 40250
					order[47] = 40252
					order[48] = 40253
					order[49] = 40254
					order[50] = 40255
					order[51] = 40256
					order[52] = 40257
					order[53] = 40258
					order[54] = 40260
					order[55] = 40261
					order[56] = 40262
					order[57] = 40263
					order[58] = 40264
					order[59] = 41641
					order[60] = 41642
					order[61] = 40265
					order[62] = 40267
					order[63] = 40268
					order[64] = 40270
					order[65] = 40271
					order[66] = 40272
					order[67] = 40273
					order[68] = 40274
					order[69] = 40275
					order[70] = 40276
					order[71] = 41643
					order[72] = 41644
					order[73] = 41645
					order[74] = 40279
					order[75] = 40280
					order[76] = 40281
					order[77] = 42399
					order[78] = 40282
					order[79] = 40283
					order[80] = 43108
					order[81] = 40284
					order[82] = 40285
					order[83] = 40286
					order[84] = 40287
					order[85] = 40288
					order[86] = 42400
					order[87] = 42401
					order[88] = 42402
					order[89] = 42403
					order[90] = 40289
					order[91] = 40290
					order[92] = 40291
					order[93] = 41549
					order[94] = 41550
					order[95] = 41551
					order[96] = 41552
					order[97] = 41553
					order[98] = 41554
					order[99] = 41555
					order[100] = 42404
					order[101] = 40374
					order[102] = 40418
					order[103] = 41429
					order[104] = 41430
					order[105] = 41431
					order[106] = 41432
					order[107] = 41433
					order[108] = 42194
					order[109] = 42195
					order[110] = 41434
					order[111] = 41435
					order[112] = 41436
					order[113] = 41437
					order[114] = 41438
					order[115] = 41219
					order[116] = 41439
					order[117] = 41440
					order[118] = 41441
					order[119] = 41442
					order[120] = 41443
					order[121] = 41444
					order[122] = 41445
					order[123] = 41446
					order[124] = 41447
					order[125] = 41448
					order[126] = 41449
					order[127] = 41450
					order[128] = 41451
					order[129] = 43095
					order[130] = 41408
					order[131] = 40248
					order[132] = 40978
					order[133] = 40979
					order[134] = 0
					super(40241, 40242, order)
				end

				class NoLegStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41675
						order[1] = 41676
						order[2] = 0
						super(41674, 41675, order)
					end
				end

				class NoLegStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41453
						order[1] = 41454
						order[2] = 41455
						order[3] = 0
						super(41452, 41453, order)
					end
				end

				class NoLegStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41678
						order[1] = 41679
						order[2] = 0
						super(41677, 41678, order)
					end
				end

				class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41647
						order[1] = 0
						super(41646, 41647, order)
					end
				end

				class NoLegStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41687
						order[1] = 41688
						order[2] = 41689
						order[3] = 41690
						order[4] = 41691
						order[5] = 41692
						order[6] = 41693
						order[7] = 41694
						order[8] = 41695
						order[9] = 41696
						order[10] = 41697
						order[11] = 41680
						order[12] = 41698
						order[13] = 41699
						order[14] = 0
						super(41686, 41687, order)
					end

					class NoLegStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41681
							order[1] = 41682
							order[2] = 41683
							order[3] = 0
							super(41680, 41681, order)
						end

						class NoLegStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41684
								order[1] = 41685
								order[2] = 41935
								order[3] = 0
								super(41683, 41684, order)
							end
						end
					end
				end

				class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40251
						order[1] = 0
						super(40942, 40251, order)
					end
				end

				class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40259
						order[1] = 0
						super(40943, 40259, order)
					end
				end

				class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40266
						order[1] = 0
						super(40940, 40266, order)
					end
				end

				class NoLegStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41639
						order[1] = 41640
						order[2] = 0
						super(41638, 41639, order)
					end
				end

				class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40269
						order[1] = 0
						super(40941, 40269, order)
					end
				end

				class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40293
						order[1] = 0
						super(40930, 40293, order)
					end
				end

				class NoLegPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41590
						order[1] = 41591
						order[2] = 0
						super(41589, 41590, order)
					end
				end

				class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40305
						order[1] = 0
						super(40931, 40305, order)
					end
				end

				class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40311
						order[1] = 0
						super(40932, 40311, order)
					end
				end

				class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40318
						order[1] = 0
						super(40933, 40318, order)
					end
				end

				class NoLegPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42460
						order[1] = 42461
						order[2] = 0
						super(42459, 42460, order)
					end
				end

				class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41562
						order[1] = 0
						super(41561, 41562, order)
					end
				end

				class NoLegPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41597
						order[1] = 41598
						order[2] = 0
						super(41596, 41597, order)
					end
				end

				class NoLegPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41594
						order[1] = 41595
						order[2] = 0
						super(41593, 41594, order)
					end
				end

				class NoLegPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43110
						order[1] = 42486
						order[2] = 42487
						order[3] = 0
						super(42485, 43110, order)
					end
				end

				class NoLegDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42367
						order[1] = 42368
						order[2] = 42369
						order[3] = 42370
						order[4] = 42371
						order[5] = 42372
						order[6] = 42386
						order[7] = 42373
						order[8] = 42374
						order[9] = 42375
						order[10] = 42376
						order[11] = 42377
						order[12] = 42378
						order[13] = 42379
						order[14] = 42380
						order[15] = 42381
						order[16] = 42382
						order[17] = 42383
						order[18] = 42384
						order[19] = 42385
						order[20] = 0
						super(42366, 42367, order)
					end

					class NoLegDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42387
							order[1] = 0
							super(42386, 42387, order)
						end
					end
				end

				class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42365
						order[1] = 0
						super(42364, 42365, order)
					end
				end

				class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42311
						order[1] = 0
						super(42310, 42311, order)
					end
				end

				class NoLegReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 42535
						order[1] = 42536
						order[2] = 42537
						order[3] = 42538
						order[4] = 42539
						order[5] = 42540
						order[6] = 42564
						order[7] = 42530
						order[8] = 42541
						order[9] = 42542
						order[10] = 42543
						order[11] = 42544
						order[12] = 42545
						order[13] = 42546
						order[14] = 42547
						order[15] = 42548
						order[16] = 42549
						order[17] = 42550
						order[18] = 42551
						order[19] = 42552
						order[20] = 42560
						order[21] = 42553
						order[22] = 42554
						order[23] = 42508
						order[24] = 42555
						order[25] = 42556
						order[26] = 42557
						order[27] = 42558
						order[28] = 42559
						order[29] = 0
						super(42534, 42535, order)
					end

					class NoLegReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 42565
							order[1] = 42566
							order[2] = 42567
							order[3] = 42568
							order[4] = 0
							super(42564, 42565, order)
						end
					end

					class NoLegReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42531
							order[1] = 42532
							order[2] = 42533
							order[3] = 0
							super(42530, 42531, order)
						end
					end

					class NoLegReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42561
							order[1] = 42562
							order[2] = 42563
							order[3] = 0
							super(42560, 42561, order)
						end
					end

					class NoLegReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 42509
							order[1] = 42571
							order[2] = 42510
							order[3] = 42511
							order[4] = 42512
							order[5] = 42513
							order[6] = 42514
							order[7] = 42515
							order[8] = 42516
							order[9] = 42517
							order[10] = 42518
							order[11] = 42519
							order[12] = 42520
							order[13] = 42521
							order[14] = 42522
							order[15] = 42523
							order[16] = 42524
							order[17] = 42525
							order[18] = 42526
							order[19] = 42527
							order[20] = 42528
							order[21] = 42529
							order[22] = 42569
							order[23] = 0
							super(42508, 42509, order)
						end

						class NoLegReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 42572
								order[1] = 42573
								order[2] = 0
								super(42571, 42572, order)
							end
						end

						class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 42570
								order[1] = 0
								super(42569, 42570, order)
							end
						end
					end
				end

				class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42420
						order[1] = 0
						super(42419, 42420, order)
					end
				end

				class NoLegPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42406
						order[1] = 42407
						order[2] = 0
						super(42405, 42406, order)
					end
				end

				class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40361
						order[1] = 0
						super(40929, 40361, order)
					end
				end

				class NoLegNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40368
						order[1] = 40369
						order[2] = 0
						super(40367, 40368, order)
					end
				end

				class NoLegSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40903
						order[1] = 40366
						order[2] = 40370
						order[3] = 40905
						order[4] = 40906
						order[5] = 0
						super(40902, 40903, order)
					end
				end

				class NoLegPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40375
						order[1] = 41533
						order[2] = 41534
						order[3] = 40376
						order[4] = 40377
						order[5] = 40378
						order[6] = 40379
						order[7] = 40380
						order[8] = 40381
						order[9] = 40382
						order[10] = 40383
						order[11] = 40384
						order[12] = 40385
						order[13] = 41535
						order[14] = 41536
						order[15] = 41537
						order[16] = 41538
						order[17] = 40386
						order[18] = 40387
						order[19] = 40388
						order[20] = 40389
						order[21] = 41539
						order[22] = 41540
						order[23] = 41541
						order[24] = 41542
						order[25] = 40390
						order[26] = 40391
						order[27] = 40392
						order[28] = 40393
						order[29] = 40394
						order[30] = 40395
						order[31] = 40414
						order[32] = 40396
						order[33] = 40397
						order[34] = 40398
						order[35] = 40399
						order[36] = 40927
						order[37] = 40401
						order[38] = 40402
						order[39] = 40403
						order[40] = 41543
						order[41] = 41544
						order[42] = 40404
						order[43] = 41530
						order[44] = 41545
						order[45] = 41546
						order[46] = 41547
						order[47] = 41548
						order[48] = 40405
						order[49] = 40406
						order[50] = 40407
						order[51] = 40408
						order[52] = 40928
						order[53] = 40410
						order[54] = 40411
						order[55] = 40412
						order[56] = 40413
						order[57] = 0
						super(40374, 40375, order)
					end

					class NoLegPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40415
							order[1] = 40416
							order[2] = 40417
							order[3] = 0
							super(40414, 40415, order)
						end
					end

					class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40400
							order[1] = 0
							super(40927, 40400, order)
						end
					end

					class NoLegPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41531
							order[1] = 41532
							order[2] = 0
							super(41530, 41531, order)
						end
					end

					class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40409
							order[1] = 0
							super(40928, 40409, order)
						end
					end
				end

				class NoLegPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40419
						order[1] = 40420
						order[2] = 42497
						order[3] = 42498
						order[4] = 42499
						order[5] = 42500
						order[6] = 42501
						order[7] = 42502
						order[8] = 42503
						order[9] = 42488
						order[10] = 42489
						order[11] = 42490
						order[12] = 42491
						order[13] = 42492
						order[14] = 42493
						order[15] = 42494
						order[16] = 40421
						order[17] = 40422
						order[18] = 40423
						order[19] = 40424
						order[20] = 40425
						order[21] = 40426
						order[22] = 40427
						order[23] = 40428
						order[24] = 40429
						order[25] = 40430
						order[26] = 40431
						order[27] = 40432
						order[28] = 40433
						order[29] = 40434
						order[30] = 40435
						order[31] = 40436
						order[32] = 40437
						order[33] = 40438
						order[34] = 40439
						order[35] = 40440
						order[36] = 40441
						order[37] = 40442
						order[38] = 40443
						order[39] = 40444
						order[40] = 40445
						order[41] = 40446
						order[42] = 40447
						order[43] = 0
						super(40418, 40419, order)
					end

					class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42505
							order[1] = 0
							super(42504, 42505, order)
						end
					end

					class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42496
							order[1] = 0
							super(42495, 42496, order)
						end
					end
				end

				class NoLegDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41461
						order[1] = 0
						super(41460, 41461, order)
					end
				end

				class NoLegDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41457
						order[1] = 41458
						order[2] = 41459
						order[3] = 0
						super(41456, 41457, order)
					end
				end

				class NoLegDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41409
						order[1] = 41410
						order[2] = 41411
						order[3] = 41412
						order[4] = 41413
						order[5] = 41414
						order[6] = 41415
						order[7] = 41416
						order[8] = 41417
						order[9] = 41418
						order[10] = 41419
						order[11] = 41420
						order[12] = 41421
						order[13] = 41422
						order[14] = 0
						super(41408, 41409, order)
					end

					class NoLegDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41423
							order[1] = 41424
							order[2] = 41425
							order[3] = 0
							super(41422, 41423, order)
						end

						class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41426
								order[1] = 41427
								order[2] = 41428
								order[3] = 0
								super(41425, 41426, order)
							end
						end
					end
				end
			end

			class NoLegProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 40449
					order[1] = 40450
					order[2] = 40451
					order[3] = 40939
					order[4] = 40453
					order[5] = 40454
					order[6] = 40455
					order[7] = 42506
					order[8] = 42507
					order[9] = 40456
					order[10] = 40457
					order[11] = 40458
					order[12] = 40524
					order[13] = 40525
					order[14] = 40526
					order[15] = 40528
					order[16] = 40529
					order[17] = 40530
					order[18] = 40531
					order[19] = 40532
					order[20] = 40476
					order[21] = 40478
					order[22] = 40479
					order[23] = 40480
					order[24] = 40481
					order[25] = 40482
					order[26] = 40483
					order[27] = 40484
					order[28] = 40485
					order[29] = 40486
					order[30] = 40487
					order[31] = 40488
					order[32] = 40489
					order[33] = 40490
					order[34] = 40491
					order[35] = 40492
					order[36] = 40493
					order[37] = 40494
					order[38] = 40498
					order[39] = 40499
					order[40] = 40501
					order[41] = 40502
					order[42] = 40503
					order[43] = 40504
					order[44] = 40505
					order[45] = 40506
					order[46] = 40507
					order[47] = 40508
					order[48] = 40509
					order[49] = 40511
					order[50] = 40512
					order[51] = 40513
					order[52] = 40514
					order[53] = 40515
					order[54] = 40459
					order[55] = 40460
					order[56] = 40461
					order[57] = 40462
					order[58] = 40463
					order[59] = 40464
					order[60] = 40465
					order[61] = 40516
					order[62] = 40518
					order[63] = 40519
					order[64] = 40520
					order[65] = 40521
					order[66] = 40522
					order[67] = 40523
					order[68] = 40466
					order[69] = 40467
					order[70] = 40468
					order[71] = 40469
					order[72] = 40470
					order[73] = 41407
					order[74] = 40472
					order[75] = 40980
					order[76] = 40981
					order[77] = 40533
					order[78] = 0
					super(40448, 40449, order)
				end

				class NoLegProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40452
						order[1] = 0
						super(40939, 40452, order)
					end
				end

				class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40527
						order[1] = 0
						super(40935, 40527, order)
					end
				end

				class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40477
						order[1] = 0
						super(40936, 40477, order)
					end
				end

				class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40496
						order[1] = 40497
						order[2] = 0
						super(40495, 40496, order)
					end
				end

				class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40500
						order[1] = 0
						super(40937, 40500, order)
					end
				end

				class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40510
						order[1] = 0
						super(40938, 40510, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40517
						order[1] = 0
						super(40934, 40517, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40474
						order[1] = 40475
						order[2] = 0
						super(40473, 40474, order)
					end
				end

				class NoLegProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40534
						order[1] = 40535
						order[2] = 40536
						order[3] = 2380
						order[4] = 40537
						order[5] = 0
						super(40533, 40534, order)
					end

					class NoLegProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40538
							order[1] = 40539
							order[2] = 0
							super(40537, 40538, order)
						end
					end
				end
			end

			class NoLegAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41336
					order[1] = 41337
					order[2] = 41316
					order[3] = 0
					super(41335, 41336, order)
				end

				class NoLegAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41317
						order[1] = 41318
						order[2] = 41319
						order[3] = 41320
						order[4] = 41321
						order[5] = 41322
						order[6] = 41323
						order[7] = 41324
						order[8] = 41325
						order[9] = 41326
						order[10] = 41327
						order[11] = 41328
						order[12] = 41329
						order[13] = 41330
						order[14] = 41331
						order[15] = 41332
						order[16] = 41333
						order[17] = 41334
						order[18] = 0
						super(41316, 41317, order)
					end
				end
			end

			class NoLegProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 41618
					order[1] = 41619
					order[2] = 41620
					order[3] = 41621
					order[4] = 41622
					order[5] = 41623
					order[6] = 41624
					order[7] = 41614
					order[8] = 41625
					order[9] = 41635
					order[10] = 41617
					order[11] = 0
					super(41616, 41618, order)
				end

				class NoLegProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41615
						order[1] = 0
						super(41614, 41615, order)
					end
				end

				class NoLegProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41626
						order[1] = 41627
						order[2] = 41628
						order[3] = 41629
						order[4] = 41630
						order[5] = 41631
						order[6] = 41632
						order[7] = 41633
						order[8] = 0
						super(41625, 41626, order)
					end

					class NoLegProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41634
							order[1] = 0
							super(41633, 41634, order)
						end
					end
				end

				class NoLegProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41636
						order[1] = 41637
						order[2] = 0
						super(41635, 41636, order)
					end
				end
			end

			class NoLegCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 41345
					order[1] = 41346
					order[2] = 41347
					order[3] = 41348
					order[4] = 41349
					order[5] = 41350
					order[6] = 41351
					order[7] = 41352
					order[8] = 41353
					order[9] = 41354
					order[10] = 41355
					order[11] = 41342
					order[12] = 42308
					order[13] = 42309
					order[14] = 41356
					order[15] = 41357
					order[16] = 42299
					order[17] = 42300
					order[18] = 42301
					order[19] = 42302
					order[20] = 42303
					order[21] = 42304
					order[22] = 42305
					order[23] = 41358
					order[24] = 41359
					order[25] = 41360
					order[26] = 41361
					order[27] = 41362
					order[28] = 0
					super(41344, 41345, order)
				end

				class NoLegCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41343
						order[1] = 0
						super(41342, 41343, order)
					end
				end

				class NoLegCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42307
						order[1] = 0
						super(42306, 42307, order)
					end
				end
			end

			class NoLegPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41604
					order[1] = 41601
					order[2] = 41602
					order[3] = 41603
					order[4] = 41600
					order[5] = 0
					super(41599, 41604, order)
				end

				class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41605
						order[1] = 41606
						order[2] = 0
						super(41604, 41605, order)
					end
				end
			end

			class NoLegExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42389
					order[1] = 42390
					order[2] = 0
					super(42388, 42389, order)
				end
			end

			class NoLegContractualDefinitions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42199
					order[1] = 0
					super(42198, 42199, order)
				end
			end

			class NoLegFinancingTermSupplements < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42201
					order[1] = 42202
					order[2] = 0
					super(42200, 42201, order)
				end
			end

			class NoLegContractualMatrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42204
					order[1] = 42205
					order[2] = 42206
					order[3] = 0
					super(42203, 42204, order)
				end
			end
		end
	end
end

class QuoteStatusRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("a") )
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoTargetPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1462
			order[1] = 1463
			order[2] = 1464
			order[3] = 1818
			order[4] = 2433
			order[5] = 0
			super(1461, 1462, order)
		end

		class NoTargetPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2434
				order[1] = 2435
				order[2] = 0
				super(2433, 2434, order)
			end
		end
	end
end

class MassQuoteAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("b") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoTargetPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1462
			order[1] = 1463
			order[2] = 1464
			order[3] = 1818
			order[4] = 2433
			order[5] = 0
			super(1461, 1462, order)
		end

		class NoTargetPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2434
				order[1] = 2435
				order[2] = 0
				super(2433, 2434, order)
			end
		end
	end

	class NoQuoteSets < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(196)
			order[0] = 302
			order[1] = 311
			order[2] = 312
			order[3] = 309
			order[4] = 305
			order[5] = 2874
			order[6] = 462
			order[7] = 463
			order[8] = 2894
			order[9] = 310
			order[10] = 763
			order[11] = 313
			order[12] = 542
			order[13] = 1213
			order[14] = 1837
			order[15] = 241
			order[16] = 1453
			order[17] = 1454
			order[18] = 2614
			order[19] = 2615
			order[20] = 2921
			order[21] = 2616
			order[22] = 2617
			order[23] = 2619
			order[24] = 1455
			order[25] = 1456
			order[26] = 1459
			order[27] = 1460
			order[28] = 242
			order[29] = 243
			order[30] = 244
			order[31] = 245
			order[32] = 246
			order[33] = 256
			order[34] = 595
			order[35] = 592
			order[36] = 593
			order[37] = 594
			order[38] = 247
			order[39] = 316
			order[40] = 941
			order[41] = 2917
			order[42] = 317
			order[43] = 436
			order[44] = 1437
			order[45] = 2363
			order[46] = 1441
			order[47] = 998
			order[48] = 1423
			order[49] = 1718
			order[50] = 2918
			order[51] = 1424
			order[52] = 1425
			order[53] = 1719
			order[54] = 2919
			order[55] = 1000
			order[56] = 1419
			order[57] = 1526
			order[58] = 2920
			order[59] = 435
			order[60] = 308
			order[61] = 306
			order[62] = 362
			order[63] = 363
			order[64] = 2742
			order[65] = 2720
			order[66] = 2721
			order[67] = 2722
			order[68] = 2723
			order[69] = 2724
			order[70] = 307
			order[71] = 364
			order[72] = 365
			order[73] = 877
			order[74] = 878
			order[75] = 972
			order[76] = 318
			order[77] = 2916
			order[78] = 879
			order[79] = 975
			order[80] = 973
			order[81] = 974
			order[82] = 810
			order[83] = 882
			order[84] = 883
			order[85] = 884
			order[86] = 885
			order[87] = 886
			order[88] = 2885
			order[89] = 2886
			order[90] = 1044
			order[91] = 1045
			order[92] = 1046
			order[93] = 1038
			order[94] = 1039
			order[95] = 315
			order[96] = 2683
			order[97] = 2687
			order[98] = 1988
			order[99] = 1989
			order[100] = 1990
			order[101] = 1991
			order[102] = 1992
			order[103] = 1993
			order[104] = 2881
			order[105] = 1994
			order[106] = 1995
			order[107] = 1996
			order[108] = 1997
			order[109] = 2620
			order[110] = 2621
			order[111] = 1998
			order[112] = 1999
			order[113] = 2000
			order[114] = 2003
			order[115] = 2004
			order[116] = 2005
			order[117] = 2006
			order[118] = 2284
			order[119] = 2285
			order[120] = 2286
			order[121] = 2287
			order[122] = 2288
			order[123] = 2007
			order[124] = 2008
			order[125] = 2009
			order[126] = 2010
			order[127] = 2011
			order[128] = 2012
			order[129] = 2491
			order[130] = 2013
			order[131] = 2014
			order[132] = 2015
			order[133] = 2744
			order[134] = 2016
			order[135] = 2289
			order[136] = 2017
			order[137] = 2018
			order[138] = 2019
			order[139] = 2020
			order[140] = 2021
			order[141] = 2022
			order[142] = 2290
			order[143] = 2622
			order[144] = 2291
			order[145] = 2623
			order[146] = 2292
			order[147] = 2023
			order[148] = 2024
			order[149] = 2025
			order[150] = 2026
			order[151] = 2027
			order[152] = 2028
			order[153] = 2029
			order[154] = 2757
			order[155] = 2030
			order[156] = 2031
			order[157] = 2293
			order[158] = 2294
			order[159] = 2032
			order[160] = 2033
			order[161] = 2034
			order[162] = 2035
			order[163] = 2036
			order[164] = 2037
			order[165] = 2038
			order[166] = 2039
			order[167] = 2040
			order[168] = 2041
			order[169] = 2042
			order[170] = 2043
			order[171] = 2044
			order[172] = 41314
			order[173] = 41315
			order[174] = 2295
			order[175] = 2296
			order[176] = 2297
			order[177] = 2756
			order[178] = 2298
			order[179] = 2299
			order[180] = 2624
			order[181] = 2625
			order[182] = 2626
			order[183] = 2627
			order[184] = 2628
			order[185] = 2629
			order[186] = 2630
			order[187] = 2631
			order[188] = 367
			order[189] = 304
			order[190] = 1168
			order[191] = 1169
			order[192] = 1170
			order[193] = 893
			order[194] = 295
			order[195] = 0
			super(296, 302, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end

		class NoQuoteEntries < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(186)
				order[0] = 299
				order[1] = 55
				order[2] = 65
				order[3] = 48
				order[4] = 22
				order[5] = 460
				order[6] = 1227
				order[7] = 1151
				order[8] = 461
				order[9] = 2891
				order[10] = 167
				order[11] = 762
				order[12] = 200
				order[13] = 541
				order[14] = 1079
				order[15] = 966
				order[16] = 1049
				order[17] = 965
				order[18] = 224
				order[19] = 1449
				order[20] = 1450
				order[21] = 1451
				order[22] = 1452
				order[23] = 1457
				order[24] = 1458
				order[25] = 1739
				order[26] = 2210
				order[27] = 1938
				order[28] = 1939
				order[29] = 1940
				order[30] = 2735
				order[31] = 1941
				order[32] = 1575
				order[33] = 1942
				order[34] = 1943
				order[35] = 1944
				order[36] = 1945
				order[37] = 1946
				order[38] = 1947
				order[39] = 1948
				order[40] = 1949
				order[41] = 1950
				order[42] = 2879
				order[43] = 1951
				order[44] = 1952
				order[45] = 1953
				order[46] = 1954
				order[47] = 1955
				order[48] = 1956
				order[49] = 1957
				order[50] = 1958
				order[51] = 1959
				order[52] = 1960
				order[53] = 1577
				order[54] = 1580
				order[55] = 1581
				order[56] = 1678
				order[57] = 1697
				order[58] = 225
				order[59] = 239
				order[60] = 226
				order[61] = 227
				order[62] = 228
				order[63] = 255
				order[64] = 543
				order[65] = 470
				order[66] = 471
				order[67] = 472
				order[68] = 240
				order[69] = 202
				order[70] = 2578
				order[71] = 2577
				order[72] = 947
				order[73] = 2904
				order[74] = 967
				order[75] = 968
				order[76] = 1698
				order[77] = 1866
				order[78] = 2600
				order[79] = 2001
				order[80] = 2601
				order[81] = 1478
				order[82] = 1479
				order[83] = 1480
				order[84] = 1481
				order[85] = 206
				order[86] = 231
				order[87] = 1435
				order[88] = 2353
				order[89] = 1439
				order[90] = 969
				order[91] = 1146
				order[92] = 996
				order[93] = 1147
				order[94] = 1716
				order[95] = 2905
				order[96] = 1191
				order[97] = 1192
				order[98] = 1717
				order[99] = 2906
				order[100] = 1193
				order[101] = 2579
				order[102] = 1194
				order[103] = 1482
				order[104] = 1195
				order[105] = 2753
				order[106] = 1196
				order[107] = 1197
				order[108] = 2002
				order[109] = 2140
				order[110] = 1524
				order[111] = 2907
				order[112] = 1198
				order[113] = 1199
				order[114] = 1200
				order[115] = 201
				order[116] = 2681
				order[117] = 2685
				order[118] = 1244
				order[119] = 1242
				order[120] = 2575
				order[121] = 2574
				order[122] = 997
				order[123] = 223
				order[124] = 207
				order[125] = 970
				order[126] = 971
				order[127] = 106
				order[128] = 348
				order[129] = 349
				order[130] = 2737
				order[131] = 2714
				order[132] = 2715
				order[133] = 2716
				order[134] = 107
				order[135] = 350
				order[136] = 351
				order[137] = 691
				order[138] = 667
				order[139] = 875
				order[140] = 876
				order[141] = 873
				order[142] = 874
				order[143] = 1687
				order[144] = 1787
				order[145] = 2141
				order[146] = 2142
				order[147] = 2143
				order[148] = 2752
				order[149] = 2144
				order[150] = 2145
				order[151] = 2576
				order[152] = 2962
				order[153] = 2602
				order[154] = 2603
				order[155] = 555
				order[156] = 132
				order[157] = 133
				order[158] = 134
				order[159] = 135
				order[160] = 62
				order[161] = 188
				order[162] = 190
				order[163] = 189
				order[164] = 191
				order[165] = 631
				order[166] = 632
				order[167] = 633
				order[168] = 634
				order[169] = 60
				order[170] = 336
				order[171] = 625
				order[172] = 64
				order[173] = 40
				order[174] = 193
				order[175] = 192
				order[176] = 642
				order[177] = 643
				order[178] = 15
				order[179] = 2897
				order[180] = 775
				order[181] = 528
				order[182] = 529
				order[183] = 1167
				order[184] = 368
				order[185] = 0
				super(295, 299, order)
			end

			class NoSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 455
					order[1] = 456
					order[2] = 2957
					order[3] = 0
					super(454, 455, order)
				end
			end

			class NoSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 1977
					order[1] = 1978
					order[2] = 1979
					order[3] = 2741
					order[4] = 0
					super(1976, 1977, order)
				end
			end

			class NoAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2305
					order[1] = 2306
					order[2] = 2307
					order[3] = 0
					super(2304, 2305, order)
				end
			end

			class NoEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 865
					order[1] = 866
					order[2] = 1145
					order[3] = 1827
					order[4] = 1826
					order[5] = 2340
					order[6] = 867
					order[7] = 868
					order[8] = 1578
					order[9] = 1579
					order[10] = 0
					super(864, 865, order)
				end
			end

			class NoInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 1019
					order[1] = 1050
					order[2] = 1051
					order[3] = 2378
					order[4] = 1052
					order[5] = 0
					super(1018, 1019, order)
				end

				class NoInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1053
						order[1] = 1054
						order[2] = 0
						super(1052, 1053, order)
					end
				end
			end

			class NoComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 1484
					order[1] = 2117
					order[2] = 2118
					order[3] = 2119
					order[4] = 1485
					order[5] = 2120
					order[6] = 2121
					order[7] = 2122
					order[8] = 2941
					order[9] = 1486
					order[10] = 2123
					order[11] = 1487
					order[12] = 1488
					order[13] = 1489
					order[14] = 1490
					order[15] = 1491
					order[16] = 2124
					order[17] = 2942
					order[18] = 2125
					order[19] = 2943
					order[20] = 2126
					order[21] = 2127
					order[22] = 2407
					order[23] = 2408
					order[24] = 2128
					order[25] = 2129
					order[26] = 2130
					order[27] = 2131
					order[28] = 2132
					order[29] = 41013
					order[30] = 41020
					order[31] = 41021
					order[32] = 41022
					order[33] = 41023
					order[34] = 41024
					order[35] = 41025
					order[36] = 41026
					order[37] = 41027
					order[38] = 41028
					order[39] = 41010
					order[40] = 2133
					order[41] = 2134
					order[42] = 2135
					order[43] = 2136
					order[44] = 2137
					order[45] = 41029
					order[46] = 40997
					order[47] = 2597
					order[48] = 2598
					order[49] = 2599
					order[50] = 2138
					order[51] = 2139
					order[52] = 0
					super(1483, 1484, order)
				end

				class NoComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 1492
						order[1] = 1493
						order[2] = 1494
						order[3] = 0
						super(1491, 1492, order)
					end

					class NoComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 1495
							order[1] = 1496
							order[2] = 0
							super(1494, 1495, order)
						end
					end
				end

				class NoComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41014
						order[1] = 41015
						order[2] = 41016
						order[3] = 41017
						order[4] = 0
						super(41013, 41014, order)
					end
				end

				class NoComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41019
						order[1] = 0
						super(41018, 41019, order)
					end
				end

				class NoComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41011
						order[1] = 41012
						order[2] = 41031
						order[3] = 41007
						order[4] = 40994
						order[5] = 0
						super(41010, 41011, order)
					end

					class NoComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41032
							order[1] = 41033
							order[2] = 41034
							order[3] = 41035
							order[4] = 41036
							order[5] = 0
							super(41031, 41032, order)
						end
					end

					class NoComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41008
							order[1] = 41009
							order[2] = 0
							super(41007, 41008, order)
						end
					end

					class NoComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40995
							order[1] = 40996
							order[2] = 0
							super(40994, 40995, order)
						end
					end
				end

				class NoComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41030
						order[1] = 0
						super(41029, 41030, order)
					end
				end

				class NoComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 40998
						order[1] = 40999
						order[2] = 41000
						order[3] = 41001
						order[4] = 41002
						order[5] = 41003
						order[6] = 41004
						order[7] = 41005
						order[8] = 0
						super(40997, 40998, order)
					end

					class NoComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41006
							order[1] = 0
							super(41005, 41006, order)
						end
					end
				end
			end

			class NoBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40471
					order[1] = 0
					super(40278, 40471, order)
				end
			end

			class NoPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41231
					order[1] = 0
					super(41230, 41231, order)
				end
			end

			class NoMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41093
					order[1] = 40991
					order[2] = 0
					super(41092, 41093, order)
				end
			end

			class NoMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41095
					order[1] = 40992
					order[2] = 0
					super(41094, 41095, order)
				end
			end

			class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41097
					order[1] = 41098
					order[2] = 41099
					order[3] = 41100
					order[4] = 41101
					order[5] = 41102
					order[6] = 41103
					order[7] = 41104
					order[8] = 41105
					order[9] = 0
					super(41096, 41097, order)
				end
			end

			class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42776
					order[1] = 0
					super(42775, 42776, order)
				end
			end

			class NoOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41117
					order[1] = 0
					super(41116, 41117, order)
				end
			end

			class NoOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41138
					order[1] = 41139
					order[2] = 0
					super(41137, 41138, order)
				end
			end

			class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41141
					order[1] = 0
					super(41140, 41141, order)
				end
			end

			class NoOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41153
					order[1] = 41154
					order[2] = 0
					super(41152, 41153, order)
				end
			end

			class NoStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40050
					order[1] = 41303
					order[2] = 40051
					order[3] = 42784
					order[4] = 42785
					order[5] = 40052
					order[6] = 40053
					order[7] = 41305
					order[8] = 40054
					order[9] = 40055
					order[10] = 42786
					order[11] = 42787
					order[12] = 41306
					order[13] = 41307
					order[14] = 41308
					order[15] = 41309
					order[16] = 41310
					order[17] = 41311
					order[18] = 41251
					order[19] = 41252
					order[20] = 41253
					order[21] = 41254
					order[22] = 41255
					order[23] = 41256
					order[24] = 41257
					order[25] = 42587
					order[26] = 41258
					order[27] = 41259
					order[28] = 41260
					order[29] = 41261
					order[30] = 41262
					order[31] = 41263
					order[32] = 41264
					order[33] = 41265
					order[34] = 41266
					order[35] = 41267
					order[36] = 41268
					order[37] = 41269
					order[38] = 41270
					order[39] = 41271
					order[40] = 41272
					order[41] = 41273
					order[42] = 41274
					order[43] = 41275
					order[44] = 41276
					order[45] = 40907
					order[46] = 40908
					order[47] = 40910
					order[48] = 40911
					order[49] = 40912
					order[50] = 40913
					order[51] = 40914
					order[52] = 40065
					order[53] = 40066
					order[54] = 40068
					order[55] = 40069
					order[56] = 40070
					order[57] = 40071
					order[58] = 40072
					order[59] = 41244
					order[60] = 41245
					order[61] = 40073
					order[62] = 40075
					order[63] = 40076
					order[64] = 40078
					order[65] = 40079
					order[66] = 40080
					order[67] = 40081
					order[68] = 40082
					order[69] = 40083
					order[70] = 40084
					order[71] = 41246
					order[72] = 41247
					order[73] = 41248
					order[74] = 40738
					order[75] = 40739
					order[76] = 40740
					order[77] = 42600
					order[78] = 40741
					order[79] = 40742
					order[80] = 43106
					order[81] = 40743
					order[82] = 40744
					order[83] = 40745
					order[84] = 40746
					order[85] = 40747
					order[86] = 42601
					order[87] = 42602
					order[88] = 42603
					order[89] = 42604
					order[90] = 40748
					order[91] = 40749
					order[92] = 40750
					order[93] = 41180
					order[94] = 41181
					order[95] = 41182
					order[96] = 41183
					order[97] = 41184
					order[98] = 41185
					order[99] = 41186
					order[100] = 42605
					order[101] = 40828
					order[102] = 40872
					order[103] = 41058
					order[104] = 41059
					order[105] = 41060
					order[106] = 41061
					order[107] = 41062
					order[108] = 42192
					order[109] = 42193
					order[110] = 41063
					order[111] = 41064
					order[112] = 41065
					order[113] = 41066
					order[114] = 41067
					order[115] = 41218
					order[116] = 41068
					order[117] = 41069
					order[118] = 41070
					order[119] = 41071
					order[120] = 41072
					order[121] = 41073
					order[122] = 41074
					order[123] = 41075
					order[124] = 41076
					order[125] = 41077
					order[126] = 41078
					order[127] = 41079
					order[128] = 41080
					order[129] = 43094
					order[130] = 41037
					order[131] = 40056
					order[132] = 40982
					order[133] = 40983
					order[134] = 0
					super(40049, 40050, order)
				end

				class NoStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41278
						order[1] = 41279
						order[2] = 0
						super(41277, 41278, order)
					end
				end

				class NoStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41238
						order[1] = 41239
						order[2] = 41240
						order[3] = 0
						super(41237, 41238, order)
					end
				end

				class NoStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41281
						order[1] = 41282
						order[2] = 0
						super(41280, 41281, order)
					end
				end

				class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41250
						order[1] = 0
						super(41249, 41250, order)
					end
				end

				class NoStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41290
						order[1] = 41291
						order[2] = 41292
						order[3] = 41293
						order[4] = 41294
						order[5] = 41295
						order[6] = 41296
						order[7] = 41297
						order[8] = 41298
						order[9] = 41299
						order[10] = 41300
						order[11] = 41283
						order[12] = 41301
						order[13] = 41302
						order[14] = 0
						super(41289, 41290, order)
					end

					class NoStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41284
							order[1] = 41285
							order[2] = 41286
							order[3] = 0
							super(41283, 41284, order)
						end

						class NoStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41287
								order[1] = 41288
								order[2] = 41588
								order[3] = 0
								super(41286, 41287, order)
							end
						end
					end
				end

				class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40909
						order[1] = 0
						super(40960, 40909, order)
					end
				end

				class NoStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40067
						order[1] = 0
						super(40961, 40067, order)
					end
				end

				class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40074
						order[1] = 0
						super(40958, 40074, order)
					end
				end

				class NoStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41242
						order[1] = 41243
						order[2] = 0
						super(41241, 41242, order)
					end
				end

				class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40077
						order[1] = 0
						super(40959, 40077, order)
					end
				end

				class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40752
						order[1] = 0
						super(40947, 40752, order)
					end
				end

				class NoPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41221
						order[1] = 41222
						order[2] = 0
						super(41220, 41221, order)
					end
				end

				class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40763
						order[1] = 0
						super(40948, 40763, order)
					end
				end

				class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40769
						order[1] = 0
						super(40949, 40769, order)
					end
				end

				class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40776
						order[1] = 0
						super(40950, 40776, order)
					end
				end

				class NoPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42661
						order[1] = 42662
						order[2] = 0
						super(42660, 42661, order)
					end
				end

				class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41193
						order[1] = 0
						super(41192, 41193, order)
					end
				end

				class NoPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41228
						order[1] = 41229
						order[2] = 0
						super(41227, 41228, order)
					end
				end

				class NoPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41225
						order[1] = 41226
						order[2] = 0
						super(41224, 41225, order)
					end
				end

				class NoPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43109
						order[1] = 42684
						order[2] = 42685
						order[3] = 0
						super(42683, 43109, order)
					end
				end

				class NoDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42275
						order[1] = 42276
						order[2] = 42277
						order[3] = 42278
						order[4] = 42279
						order[5] = 42280
						order[6] = 42294
						order[7] = 42281
						order[8] = 42282
						order[9] = 42283
						order[10] = 42284
						order[11] = 42285
						order[12] = 42286
						order[13] = 42287
						order[14] = 42288
						order[15] = 42289
						order[16] = 42290
						order[17] = 42291
						order[18] = 42292
						order[19] = 42293
						order[20] = 0
						super(42274, 42275, order)
					end

					class NoDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42295
							order[1] = 0
							super(42294, 42295, order)
						end
					end
				end

				class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42273
						order[1] = 0
						super(42272, 42273, order)
					end
				end

				class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42237
						order[1] = 0
						super(42236, 42237, order)
					end
				end

				class NoReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 42736
						order[1] = 42737
						order[2] = 42738
						order[3] = 42739
						order[4] = 42740
						order[5] = 42741
						order[6] = 42765
						order[7] = 42731
						order[8] = 42742
						order[9] = 42743
						order[10] = 42744
						order[11] = 42745
						order[12] = 42746
						order[13] = 42747
						order[14] = 42748
						order[15] = 42749
						order[16] = 42750
						order[17] = 42751
						order[18] = 42752
						order[19] = 42753
						order[20] = 42761
						order[21] = 42754
						order[22] = 42755
						order[23] = 42709
						order[24] = 42756
						order[25] = 42757
						order[26] = 42758
						order[27] = 42759
						order[28] = 42760
						order[29] = 0
						super(42735, 42736, order)
					end

					class NoReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 42766
							order[1] = 42767
							order[2] = 42768
							order[3] = 42769
							order[4] = 0
							super(42765, 42766, order)
						end
					end

					class NoReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42732
							order[1] = 42733
							order[2] = 42734
							order[3] = 0
							super(42731, 42732, order)
						end
					end

					class NoReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42762
							order[1] = 42763
							order[2] = 42764
							order[3] = 0
							super(42761, 42762, order)
						end
					end

					class NoReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 42710
							order[1] = 42772
							order[2] = 42711
							order[3] = 42712
							order[4] = 42713
							order[5] = 42714
							order[6] = 42715
							order[7] = 42716
							order[8] = 42717
							order[9] = 42718
							order[10] = 42719
							order[11] = 42720
							order[12] = 42721
							order[13] = 42722
							order[14] = 42723
							order[15] = 42724
							order[16] = 42725
							order[17] = 42726
							order[18] = 42727
							order[19] = 42728
							order[20] = 42729
							order[21] = 42730
							order[22] = 42770
							order[23] = 0
							super(42709, 42710, order)
						end

						class NoReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 42773
								order[1] = 42774
								order[2] = 0
								super(42772, 42773, order)
							end
						end

						class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 42771
								order[1] = 0
								super(42770, 42771, order)
							end
						end
					end
				end

				class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42621
						order[1] = 0
						super(42620, 42621, order)
					end
				end

				class NoPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42607
						order[1] = 42608
						order[2] = 0
						super(42606, 42607, order)
					end
				end

				class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40819
						order[1] = 0
						super(40946, 40819, order)
					end
				end

				class NoNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40826
						order[1] = 40827
						order[2] = 0
						super(40825, 40826, order)
					end
				end

				class NoSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40086
						order[1] = 40373
						order[2] = 40655
						order[3] = 40088
						order[4] = 40089
						order[5] = 0
						super(40085, 40086, order)
					end
				end

				class NoPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40829
						order[1] = 41164
						order[2] = 41165
						order[3] = 40830
						order[4] = 40831
						order[5] = 40832
						order[6] = 40833
						order[7] = 40834
						order[8] = 40835
						order[9] = 40836
						order[10] = 40837
						order[11] = 40838
						order[12] = 40839
						order[13] = 41166
						order[14] = 41167
						order[15] = 41168
						order[16] = 41169
						order[17] = 40840
						order[18] = 40841
						order[19] = 40842
						order[20] = 40843
						order[21] = 41170
						order[22] = 41171
						order[23] = 41172
						order[24] = 41173
						order[25] = 40844
						order[26] = 40845
						order[27] = 40846
						order[28] = 40847
						order[29] = 40848
						order[30] = 40849
						order[31] = 40868
						order[32] = 40850
						order[33] = 40851
						order[34] = 40852
						order[35] = 40853
						order[36] = 40977
						order[37] = 40855
						order[38] = 40856
						order[39] = 40857
						order[40] = 41174
						order[41] = 41175
						order[42] = 40858
						order[43] = 41161
						order[44] = 41176
						order[45] = 41177
						order[46] = 41178
						order[47] = 41179
						order[48] = 40859
						order[49] = 40860
						order[50] = 40861
						order[51] = 40862
						order[52] = 40945
						order[53] = 40864
						order[54] = 40865
						order[55] = 40866
						order[56] = 40867
						order[57] = 0
						super(40828, 40829, order)
					end

					class NoPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40869
							order[1] = 40870
							order[2] = 40871
							order[3] = 0
							super(40868, 40869, order)
						end
					end

					class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40854
							order[1] = 0
							super(40977, 40854, order)
						end
					end

					class NoPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41162
							order[1] = 41163
							order[2] = 0
							super(41161, 41162, order)
						end
					end

					class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40863
							order[1] = 0
							super(40945, 40863, order)
						end
					end
				end

				class NoPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40873
						order[1] = 40874
						order[2] = 42698
						order[3] = 42699
						order[4] = 42700
						order[5] = 42701
						order[6] = 42702
						order[7] = 42703
						order[8] = 42704
						order[9] = 42689
						order[10] = 42690
						order[11] = 42691
						order[12] = 42692
						order[13] = 42693
						order[14] = 42694
						order[15] = 42695
						order[16] = 40875
						order[17] = 40876
						order[18] = 40877
						order[19] = 40878
						order[20] = 40879
						order[21] = 40880
						order[22] = 40881
						order[23] = 40882
						order[24] = 40883
						order[25] = 40884
						order[26] = 40885
						order[27] = 40886
						order[28] = 40887
						order[29] = 40888
						order[30] = 40889
						order[31] = 40890
						order[32] = 40891
						order[33] = 40892
						order[34] = 40893
						order[35] = 40894
						order[36] = 40895
						order[37] = 40896
						order[38] = 40897
						order[39] = 40898
						order[40] = 40899
						order[41] = 40900
						order[42] = 40901
						order[43] = 0
						super(40872, 40873, order)
					end

					class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42706
							order[1] = 0
							super(42705, 42706, order)
						end
					end

					class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42697
							order[1] = 0
							super(42696, 42697, order)
						end
					end
				end

				class NoDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41086
						order[1] = 0
						super(41085, 41086, order)
					end
				end

				class NoDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41082
						order[1] = 41083
						order[2] = 41084
						order[3] = 0
						super(41081, 41082, order)
					end
				end

				class NoDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41038
						order[1] = 41039
						order[2] = 41040
						order[3] = 41041
						order[4] = 41042
						order[5] = 41043
						order[6] = 41044
						order[7] = 41045
						order[8] = 41046
						order[9] = 41047
						order[10] = 41048
						order[11] = 41049
						order[12] = 41050
						order[13] = 41051
						order[14] = 0
						super(41037, 41038, order)
					end

					class NoDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41052
							order[1] = 41053
							order[2] = 41054
							order[3] = 0
							super(41051, 41052, order)
						end

						class NoDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41055
								order[1] = 41056
								order[2] = 41057
								order[3] = 0
								super(41054, 41055, order)
							end
						end
					end
				end
			end

			class NoProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 40091
					order[1] = 40092
					order[2] = 40093
					order[3] = 40957
					order[4] = 40095
					order[5] = 40096
					order[6] = 40097
					order[7] = 42707
					order[8] = 42708
					order[9] = 40098
					order[10] = 40099
					order[11] = 40100
					order[12] = 40114
					order[13] = 40115
					order[14] = 40116
					order[15] = 40118
					order[16] = 40119
					order[17] = 40120
					order[18] = 40121
					order[19] = 40122
					order[20] = 40123
					order[21] = 40125
					order[22] = 40126
					order[23] = 40127
					order[24] = 40128
					order[25] = 40129
					order[26] = 40130
					order[27] = 40131
					order[28] = 40132
					order[29] = 40133
					order[30] = 40134
					order[31] = 40135
					order[32] = 40136
					order[33] = 40137
					order[34] = 40138
					order[35] = 40139
					order[36] = 40140
					order[37] = 40141
					order[38] = 40145
					order[39] = 40146
					order[40] = 40148
					order[41] = 40149
					order[42] = 40150
					order[43] = 40151
					order[44] = 40152
					order[45] = 40153
					order[46] = 40154
					order[47] = 40155
					order[48] = 40156
					order[49] = 40158
					order[50] = 40159
					order[51] = 40160
					order[52] = 40161
					order[53] = 40162
					order[54] = 40101
					order[55] = 40102
					order[56] = 40103
					order[57] = 40104
					order[58] = 40105
					order[59] = 40106
					order[60] = 40107
					order[61] = 40163
					order[62] = 40165
					order[63] = 40166
					order[64] = 40167
					order[65] = 40168
					order[66] = 40169
					order[67] = 40170
					order[68] = 40108
					order[69] = 40109
					order[70] = 40110
					order[71] = 40111
					order[72] = 40112
					order[73] = 41406
					order[74] = 40113
					order[75] = 40986
					order[76] = 40987
					order[77] = 40174
					order[78] = 0
					super(40090, 40091, order)
				end

				class NoProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40094
						order[1] = 0
						super(40957, 40094, order)
					end
				end

				class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40117
						order[1] = 0
						super(40953, 40117, order)
					end
				end

				class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40124
						order[1] = 0
						super(40954, 40124, order)
					end
				end

				class NoProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40143
						order[1] = 40144
						order[2] = 0
						super(40142, 40143, order)
					end
				end

				class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40147
						order[1] = 0
						super(40955, 40147, order)
					end
				end

				class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40157
						order[1] = 0
						super(40956, 40157, order)
					end
				end

				class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40164
						order[1] = 0
						super(40952, 40164, order)
					end
				end

				class NoProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40172
						order[1] = 40173
						order[2] = 0
						super(40171, 40172, order)
					end
				end

				class NoProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40175
						order[1] = 40176
						order[2] = 40177
						order[3] = 2385
						order[4] = 40178
						order[5] = 0
						super(40174, 40175, order)
					end

					class NoProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40179
							order[1] = 40180
							order[2] = 0
							super(40178, 40179, order)
						end
					end
				end
			end

			class NoAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40020
					order[1] = 40021
					order[2] = 40000
					order[3] = 0
					super(40019, 40020, order)
				end

				class NoAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 40001
						order[1] = 40002
						order[2] = 40003
						order[3] = 40004
						order[4] = 40005
						order[5] = 40006
						order[6] = 40007
						order[7] = 40008
						order[8] = 40009
						order[9] = 40010
						order[10] = 40011
						order[11] = 40012
						order[12] = 40013
						order[13] = 40014
						order[14] = 40015
						order[15] = 40016
						order[16] = 40017
						order[17] = 40018
						order[18] = 0
						super(40000, 40001, order)
					end
				end
			end

			class NoProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 40182
					order[1] = 40183
					order[2] = 40184
					order[3] = 40185
					order[4] = 40186
					order[5] = 40187
					order[6] = 40188
					order[7] = 40951
					order[8] = 40191
					order[9] = 40201
					order[10] = 40190
					order[11] = 0
					super(40181, 40182, order)
				end

				class NoProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40189
						order[1] = 0
						super(40951, 40189, order)
					end
				end

				class NoProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 40192
						order[1] = 40193
						order[2] = 40194
						order[3] = 40195
						order[4] = 40196
						order[5] = 40197
						order[6] = 40198
						order[7] = 40199
						order[8] = 0
						super(40191, 40192, order)
					end

					class NoProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40200
							order[1] = 0
							super(40199, 40200, order)
						end
					end
				end

				class NoProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40202
						order[1] = 40203
						order[2] = 0
						super(40201, 40202, order)
					end
				end
			end

			class NoCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 40023
					order[1] = 40024
					order[2] = 40916
					order[3] = 40917
					order[4] = 40025
					order[5] = 40026
					order[6] = 40027
					order[7] = 40028
					order[8] = 40029
					order[9] = 40030
					order[10] = 40031
					order[11] = 40277
					order[12] = 42216
					order[13] = 42217
					order[14] = 40033
					order[15] = 40034
					order[16] = 42207
					order[17] = 42208
					order[18] = 42209
					order[19] = 42210
					order[20] = 42211
					order[21] = 42212
					order[22] = 42213
					order[23] = 40035
					order[24] = 40036
					order[25] = 40037
					order[26] = 40038
					order[27] = 40039
					order[28] = 0
					super(40022, 40023, order)
				end

				class NoCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40032
						order[1] = 0
						super(40277, 40032, order)
					end
				end

				class NoCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42215
						order[1] = 0
						super(42214, 42215, order)
					end
				end
			end

			class NoPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40209
					order[1] = 40205
					order[2] = 40206
					order[3] = 40207
					order[4] = 40208
					order[5] = 0
					super(40204, 40209, order)
				end

				class NoPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40210
						order[1] = 40211
						order[2] = 0
						super(40209, 40210, order)
					end
				end
			end

			class NoExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42297
					order[1] = 42298
					order[2] = 0
					super(42296, 42297, order)
				end
			end

			class NoLegs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(176)
					order[0] = 600
					order[1] = 601
					order[2] = 602
					order[3] = 603
					order[4] = 1788
					order[5] = 607
					order[6] = 1594
					order[7] = 608
					order[8] = 2893
					order[9] = 609
					order[10] = 764
					order[11] = 610
					order[12] = 611
					order[13] = 1212
					order[14] = 2146
					order[15] = 2147
					order[16] = 2148
					order[17] = 248
					order[18] = 2149
					order[19] = 2150
					order[20] = 2151
					order[21] = 2152
					order[22] = 2153
					order[23] = 2154
					order[24] = 2155
					order[25] = 2348
					order[26] = 2067
					order[27] = 2068
					order[28] = 2069
					order[29] = 2739
					order[30] = 2070
					order[31] = 2156
					order[32] = 2157
					order[33] = 2158
					order[34] = 2159
					order[35] = 2160
					order[36] = 2161
					order[37] = 2162
					order[38] = 2163
					order[39] = 2164
					order[40] = 2165
					order[41] = 2880
					order[42] = 2166
					order[43] = 2167
					order[44] = 2168
					order[45] = 2169
					order[46] = 2170
					order[47] = 2171
					order[48] = 2172
					order[49] = 2173
					order[50] = 2174
					order[51] = 2175
					order[52] = 2176
					order[53] = 2177
					order[54] = 2178
					order[55] = 2179
					order[56] = 2180
					order[57] = 249
					order[58] = 250
					order[59] = 251
					order[60] = 252
					order[61] = 253
					order[62] = 257
					order[63] = 599
					order[64] = 596
					order[65] = 597
					order[66] = 598
					order[67] = 254
					order[68] = 612
					order[69] = 942
					order[70] = 2908
					order[71] = 2181
					order[72] = 2182
					order[73] = 2183
					order[74] = 2184
					order[75] = 2604
					order[76] = 2185
					order[77] = 2605
					order[78] = 2186
					order[79] = 2187
					order[80] = 2188
					order[81] = 2189
					order[82] = 613
					order[83] = 614
					order[84] = 1436
					order[85] = 2354
					order[86] = 1440
					order[87] = 2190
					order[88] = 2191
					order[89] = 999
					order[90] = 1224
					order[91] = 1720
					order[92] = 2909
					order[93] = 1421
					order[94] = 1422
					order[95] = 1721
					order[96] = 2910
					order[97] = 2192
					order[98] = 1001
					order[99] = 1420
					order[100] = 2193
					order[101] = 2194
					order[102] = 2755
					order[103] = 2195
					order[104] = 2196
					order[105] = 2197
					order[106] = 2198
					order[107] = 1528
					order[108] = 2911
					order[109] = 2199
					order[110] = 2200
					order[111] = 2201
					order[112] = 2202
					order[113] = 2203
					order[114] = 615
					order[115] = 616
					order[116] = 2205
					order[117] = 2206
					order[118] = 617
					order[119] = 618
					order[120] = 619
					order[121] = 2740
					order[122] = 2717
					order[123] = 2718
					order[124] = 2719
					order[125] = 620
					order[126] = 621
					order[127] = 622
					order[128] = 2207
					order[129] = 2208
					order[130] = 623
					order[131] = 624
					order[132] = 556
					order[133] = 2898
					order[134] = 740
					order[135] = 739
					order[136] = 955
					order[137] = 956
					order[138] = 1358
					order[139] = 2682
					order[140] = 2686
					order[141] = 1017
					order[142] = 566
					order[143] = 2209
					order[144] = 2211
					order[145] = 2212
					order[146] = 2213
					order[147] = 2754
					order[148] = 2214
					order[149] = 2215
					order[150] = 2606
					order[151] = 2607
					order[152] = 2497
					order[153] = 2498
					order[154] = 2499
					order[155] = 2496
					order[156] = 2495
					order[157] = 2953
					order[158] = 2511
					order[159] = 2510
					order[160] = 2512
					order[161] = 2509
					order[162] = 2500
					order[163] = 2502
					order[164] = 2501
					order[165] = 2503
					order[166] = 2507
					order[167] = 2505
					order[168] = 2494
					order[169] = 2493
					order[170] = 2514
					order[171] = 2513
					order[172] = 2506
					order[173] = 2504
					order[174] = 2508
					order[175] = 0
					super(555, 600, order)
				end

				class NoLegSecurityAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 605
						order[1] = 606
						order[2] = 2958
						order[3] = 0
						super(604, 605, order)
					end
				end

				class NoLegSecondaryAssetClasses < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 2077
						order[1] = 2078
						order[2] = 2079
						order[3] = 2743
						order[4] = 0
						super(2076, 2077, order)
					end
				end

				class NoLegAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2309
						order[1] = 2310
						order[2] = 2311
						order[3] = 0
						super(2308, 2309, order)
					end
				end

				class NoLegEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(11)
						order[0] = 2060
						order[1] = 2061
						order[2] = 2062
						order[3] = 2063
						order[4] = 2064
						order[5] = 2341
						order[6] = 2065
						order[7] = 2066
						order[8] = 2074
						order[9] = 2075
						order[10] = 0
						super(2059, 2060, order)
					end
				end

				class NoLegInstrumentParties < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 2255
						order[1] = 2256
						order[2] = 2257
						order[3] = 2379
						order[4] = 2258
						order[5] = 0
						super(2254, 2255, order)
					end

					class NoLegInstrumentPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2259
							order[1] = 2260
							order[2] = 0
							super(2258, 2259, order)
						end
					end
				end

				class NoLegComplexEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(53)
						order[0] = 2219
						order[1] = 2220
						order[2] = 2221
						order[3] = 2222
						order[4] = 2223
						order[5] = 2224
						order[6] = 2225
						order[7] = 2226
						order[8] = 2944
						order[9] = 2227
						order[10] = 2228
						order[11] = 2229
						order[12] = 2230
						order[13] = 2231
						order[14] = 2232
						order[15] = 2250
						order[16] = 2233
						order[17] = 2945
						order[18] = 2234
						order[19] = 2946
						order[20] = 2235
						order[21] = 2236
						order[22] = 2409
						order[23] = 2410
						order[24] = 2237
						order[25] = 2238
						order[26] = 2239
						order[27] = 2240
						order[28] = 2241
						order[29] = 41382
						order[30] = 41389
						order[31] = 41390
						order[32] = 41391
						order[33] = 41392
						order[34] = 41393
						order[35] = 41394
						order[36] = 41395
						order[37] = 41396
						order[38] = 41397
						order[39] = 41379
						order[40] = 2242
						order[41] = 2243
						order[42] = 2244
						order[43] = 2245
						order[44] = 2246
						order[45] = 41398
						order[46] = 41366
						order[47] = 2608
						order[48] = 2609
						order[49] = 2610
						order[50] = 2248
						order[51] = 2249
						order[52] = 0
						super(2218, 2219, order)
					end

					class NoLegComplexEventDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 2251
							order[1] = 2252
							order[2] = 2253
							order[3] = 0
							super(2250, 2251, order)
						end

						class NoLegComplexEventTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 2204
								order[1] = 2247
								order[2] = 0
								super(2253, 2204, order)
							end
						end
					end

					class NoLegComplexEventRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 41383
							order[1] = 41384
							order[2] = 41385
							order[3] = 41386
							order[4] = 0
							super(41382, 41383, order)
						end
					end

					class NoLegComplexEventDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41388
							order[1] = 0
							super(41387, 41388, order)
						end
					end

					class NoLegComplexEventPeriods < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41380
							order[1] = 41381
							order[2] = 41400
							order[3] = 41376
							order[4] = 41363
							order[5] = 0
							super(41379, 41380, order)
						end

						class NoLegComplexEventSchedules < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(6)
								order[0] = 41401
								order[1] = 41402
								order[2] = 41403
								order[3] = 41404
								order[4] = 41405
								order[5] = 0
								super(41400, 41401, order)
							end
						end

						class NoLegComplexEventPeriodDateTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 41377
								order[1] = 41378
								order[2] = 0
								super(41376, 41377, order)
							end
						end

						class NoLegComplexEventAveragingObservations < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 41364
								order[1] = 41365
								order[2] = 0
								super(41363, 41364, order)
							end
						end
					end

					class NoLegComplexEventCreditEventSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41399
							order[1] = 0
							super(41398, 41399, order)
						end
					end

					class NoLegComplexEventCreditEvents < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(9)
							order[0] = 41367
							order[1] = 41368
							order[2] = 41369
							order[3] = 41370
							order[4] = 41371
							order[5] = 41372
							order[6] = 41373
							order[7] = 41374
							order[8] = 0
							super(41366, 41367, order)
						end

						class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 41375
								order[1] = 0
								super(41374, 41375, order)
							end
						end
					end
				end

				class NoLegBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40924
						order[1] = 0
						super(40923, 40924, order)
					end
				end

				class NoLegPricingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41608
						order[1] = 0
						super(41607, 41608, order)
					end
				end

				class NoLegMarketDisruptionEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41468
						order[1] = 40223
						order[2] = 0
						super(41467, 41468, order)
					end
				end

				class NoLegMarketDisruptionFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41470
						order[1] = 40990
						order[2] = 0
						super(41469, 41470, order)
					end
				end

				class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(10)
						order[0] = 41472
						order[1] = 41473
						order[2] = 41474
						order[3] = 41475
						order[4] = 41476
						order[5] = 41477
						order[6] = 41478
						order[7] = 41479
						order[8] = 41480
						order[9] = 0
						super(41471, 41472, order)
					end
				end

				class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42582
						order[1] = 0
						super(42581, 42582, order)
					end
				end

				class NoLegOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41492
						order[1] = 0
						super(41491, 41492, order)
					end
				end

				class NoLegOptionExerciseDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41513
						order[1] = 41514
						order[2] = 0
						super(41512, 41513, order)
					end
				end

				class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41516
						order[1] = 0
						super(41515, 41516, order)
					end
				end

				class NoLegOptionExerciseExpirationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41528
						order[1] = 41529
						order[2] = 0
						super(41527, 41528, order)
					end
				end

				class NoLegStreams < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(135)
						order[0] = 40242
						order[1] = 41700
						order[2] = 40243
						order[3] = 42583
						order[4] = 42584
						order[5] = 40244
						order[6] = 40245
						order[7] = 41702
						order[8] = 40246
						order[9] = 40247
						order[10] = 42585
						order[11] = 42586
						order[12] = 41703
						order[13] = 41704
						order[14] = 41705
						order[15] = 41706
						order[16] = 41707
						order[17] = 41708
						order[18] = 41648
						order[19] = 41649
						order[20] = 41650
						order[21] = 41651
						order[22] = 41652
						order[23] = 41653
						order[24] = 41654
						order[25] = 42588
						order[26] = 41655
						order[27] = 41656
						order[28] = 41657
						order[29] = 41658
						order[30] = 41659
						order[31] = 41660
						order[32] = 41661
						order[33] = 41662
						order[34] = 41663
						order[35] = 41664
						order[36] = 41665
						order[37] = 41666
						order[38] = 41667
						order[39] = 41668
						order[40] = 41669
						order[41] = 41670
						order[42] = 41671
						order[43] = 41672
						order[44] = 41673
						order[45] = 40249
						order[46] = 40250
						order[47] = 40252
						order[48] = 40253
						order[49] = 40254
						order[50] = 40255
						order[51] = 40256
						order[52] = 40257
						order[53] = 40258
						order[54] = 40260
						order[55] = 40261
						order[56] = 40262
						order[57] = 40263
						order[58] = 40264
						order[59] = 41641
						order[60] = 41642
						order[61] = 40265
						order[62] = 40267
						order[63] = 40268
						order[64] = 40270
						order[65] = 40271
						order[66] = 40272
						order[67] = 40273
						order[68] = 40274
						order[69] = 40275
						order[70] = 40276
						order[71] = 41643
						order[72] = 41644
						order[73] = 41645
						order[74] = 40279
						order[75] = 40280
						order[76] = 40281
						order[77] = 42399
						order[78] = 40282
						order[79] = 40283
						order[80] = 43108
						order[81] = 40284
						order[82] = 40285
						order[83] = 40286
						order[84] = 40287
						order[85] = 40288
						order[86] = 42400
						order[87] = 42401
						order[88] = 42402
						order[89] = 42403
						order[90] = 40289
						order[91] = 40290
						order[92] = 40291
						order[93] = 41549
						order[94] = 41550
						order[95] = 41551
						order[96] = 41552
						order[97] = 41553
						order[98] = 41554
						order[99] = 41555
						order[100] = 42404
						order[101] = 40374
						order[102] = 40418
						order[103] = 41429
						order[104] = 41430
						order[105] = 41431
						order[106] = 41432
						order[107] = 41433
						order[108] = 42194
						order[109] = 42195
						order[110] = 41434
						order[111] = 41435
						order[112] = 41436
						order[113] = 41437
						order[114] = 41438
						order[115] = 41219
						order[116] = 41439
						order[117] = 41440
						order[118] = 41441
						order[119] = 41442
						order[120] = 41443
						order[121] = 41444
						order[122] = 41445
						order[123] = 41446
						order[124] = 41447
						order[125] = 41448
						order[126] = 41449
						order[127] = 41450
						order[128] = 41451
						order[129] = 43095
						order[130] = 41408
						order[131] = 40248
						order[132] = 40978
						order[133] = 40979
						order[134] = 0
						super(40241, 40242, order)
					end

					class NoLegStreamCommodityAltIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41675
							order[1] = 41676
							order[2] = 0
							super(41674, 41675, order)
						end
					end

					class NoLegStreamAssetAttributes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41453
							order[1] = 41454
							order[2] = 41455
							order[3] = 0
							super(41452, 41453, order)
						end
					end

					class NoLegStreamCommodityDataSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41678
							order[1] = 41679
							order[2] = 0
							super(41677, 41678, order)
						end
					end

					class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41647
							order[1] = 0
							super(41646, 41647, order)
						end
					end

					class NoLegStreamCommoditySettlPeriods < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(15)
							order[0] = 41687
							order[1] = 41688
							order[2] = 41689
							order[3] = 41690
							order[4] = 41691
							order[5] = 41692
							order[6] = 41693
							order[7] = 41694
							order[8] = 41695
							order[9] = 41696
							order[10] = 41697
							order[11] = 41680
							order[12] = 41698
							order[13] = 41699
							order[14] = 0
							super(41686, 41687, order)
						end

						class NoLegStreamCommoditySettlDays < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41681
								order[1] = 41682
								order[2] = 41683
								order[3] = 0
								super(41680, 41681, order)
							end

							class NoLegStreamCommoditySettlTimes < Quickfix::Group
								def initialize
									order = Quickfix::IntArray.new(4)
									order[0] = 41684
									order[1] = 41685
									order[2] = 41935
									order[3] = 0
									super(41683, 41684, order)
								end
							end
						end
					end

					class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40251
							order[1] = 0
							super(40942, 40251, order)
						end
					end

					class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40259
							order[1] = 0
							super(40943, 40259, order)
						end
					end

					class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40266
							order[1] = 0
							super(40940, 40266, order)
						end
					end

					class NoLegStreamCalculationPeriodDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41639
							order[1] = 41640
							order[2] = 0
							super(41638, 41639, order)
						end
					end

					class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40269
							order[1] = 0
							super(40941, 40269, order)
						end
					end

					class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40293
							order[1] = 0
							super(40930, 40293, order)
						end
					end

					class NoLegPaymentStreamPaymentDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41590
							order[1] = 41591
							order[2] = 0
							super(41589, 41590, order)
						end
					end

					class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40305
							order[1] = 0
							super(40931, 40305, order)
						end
					end

					class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40311
							order[1] = 0
							super(40932, 40311, order)
						end
					end

					class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40318
							order[1] = 0
							super(40933, 40318, order)
						end
					end

					class NoLegPaymentStreamFixingDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42460
							order[1] = 42461
							order[2] = 0
							super(42459, 42460, order)
						end
					end

					class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41562
							order[1] = 0
							super(41561, 41562, order)
						end
					end

					class NoLegPaymentStreamPricingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41597
							order[1] = 41598
							order[2] = 0
							super(41596, 41597, order)
						end
					end

					class NoLegPaymentStreamPricingDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41594
							order[1] = 41595
							order[2] = 0
							super(41593, 41594, order)
						end
					end

					class NoLegPaymentStreamFormulas < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43110
							order[1] = 42486
							order[2] = 42487
							order[3] = 0
							super(42485, 43110, order)
						end
					end

					class NoLegDividendPeriods < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(21)
							order[0] = 42367
							order[1] = 42368
							order[2] = 42369
							order[3] = 42370
							order[4] = 42371
							order[5] = 42372
							order[6] = 42386
							order[7] = 42373
							order[8] = 42374
							order[9] = 42375
							order[10] = 42376
							order[11] = 42377
							order[12] = 42378
							order[13] = 42379
							order[14] = 42380
							order[15] = 42381
							order[16] = 42382
							order[17] = 42383
							order[18] = 42384
							order[19] = 42385
							order[20] = 0
							super(42366, 42367, order)
						end

						class NoLegDividendPeriodBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 42387
								order[1] = 0
								super(42386, 42387, order)
							end
						end
					end

					class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42365
							order[1] = 0
							super(42364, 42365, order)
						end
					end

					class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42311
							order[1] = 0
							super(42310, 42311, order)
						end
					end

					class NoLegReturnRates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(30)
							order[0] = 42535
							order[1] = 42536
							order[2] = 42537
							order[3] = 42538
							order[4] = 42539
							order[5] = 42540
							order[6] = 42564
							order[7] = 42530
							order[8] = 42541
							order[9] = 42542
							order[10] = 42543
							order[11] = 42544
							order[12] = 42545
							order[13] = 42546
							order[14] = 42547
							order[15] = 42548
							order[16] = 42549
							order[17] = 42550
							order[18] = 42551
							order[19] = 42552
							order[20] = 42560
							order[21] = 42553
							order[22] = 42554
							order[23] = 42508
							order[24] = 42555
							order[25] = 42556
							order[26] = 42557
							order[27] = 42558
							order[28] = 42559
							order[29] = 0
							super(42534, 42535, order)
						end

						class NoLegReturnRatePrices < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(5)
								order[0] = 42565
								order[1] = 42566
								order[2] = 42567
								order[3] = 42568
								order[4] = 0
								super(42564, 42565, order)
							end
						end

						class NoLegReturnRateFXConversions < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 42531
								order[1] = 42532
								order[2] = 42533
								order[3] = 0
								super(42530, 42531, order)
							end
						end

						class NoLegReturnRateInformationSources < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 42561
								order[1] = 42562
								order[2] = 42563
								order[3] = 0
								super(42560, 42561, order)
							end
						end

						class NoLegReturnRateDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(24)
								order[0] = 42509
								order[1] = 42571
								order[2] = 42510
								order[3] = 42511
								order[4] = 42512
								order[5] = 42513
								order[6] = 42514
								order[7] = 42515
								order[8] = 42516
								order[9] = 42517
								order[10] = 42518
								order[11] = 42519
								order[12] = 42520
								order[13] = 42521
								order[14] = 42522
								order[15] = 42523
								order[16] = 42524
								order[17] = 42525
								order[18] = 42526
								order[19] = 42527
								order[20] = 42528
								order[21] = 42529
								order[22] = 42569
								order[23] = 0
								super(42508, 42509, order)
							end

							class NoLegReturnRateValuationDates < Quickfix::Group
								def initialize
									order = Quickfix::IntArray.new(3)
									order[0] = 42572
									order[1] = 42573
									order[2] = 0
									super(42571, 42572, order)
								end
							end

							class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
								def initialize
									order = Quickfix::IntArray.new(2)
									order[0] = 42570
									order[1] = 0
									super(42569, 42570, order)
								end
							end
						end
					end

					class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42420
							order[1] = 0
							super(42419, 42420, order)
						end
					end

					class NoLegPaymentStreamCompoundingDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42406
							order[1] = 42407
							order[2] = 0
							super(42405, 42406, order)
						end
					end

					class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40361
							order[1] = 0
							super(40929, 40361, order)
						end
					end

					class NoLegNonDeliverableFixingDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40368
							order[1] = 40369
							order[2] = 0
							super(40367, 40368, order)
						end
					end

					class NoLegSettlRateFallbacks < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 40903
							order[1] = 40366
							order[2] = 40370
							order[3] = 40905
							order[4] = 40906
							order[5] = 0
							super(40902, 40903, order)
						end
					end

					class NoLegPaymentSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(58)
							order[0] = 40375
							order[1] = 41533
							order[2] = 41534
							order[3] = 40376
							order[4] = 40377
							order[5] = 40378
							order[6] = 40379
							order[7] = 40380
							order[8] = 40381
							order[9] = 40382
							order[10] = 40383
							order[11] = 40384
							order[12] = 40385
							order[13] = 41535
							order[14] = 41536
							order[15] = 41537
							order[16] = 41538
							order[17] = 40386
							order[18] = 40387
							order[19] = 40388
							order[20] = 40389
							order[21] = 41539
							order[22] = 41540
							order[23] = 41541
							order[24] = 41542
							order[25] = 40390
							order[26] = 40391
							order[27] = 40392
							order[28] = 40393
							order[29] = 40394
							order[30] = 40395
							order[31] = 40414
							order[32] = 40396
							order[33] = 40397
							order[34] = 40398
							order[35] = 40399
							order[36] = 40927
							order[37] = 40401
							order[38] = 40402
							order[39] = 40403
							order[40] = 41543
							order[41] = 41544
							order[42] = 40404
							order[43] = 41530
							order[44] = 41545
							order[45] = 41546
							order[46] = 41547
							order[47] = 41548
							order[48] = 40405
							order[49] = 40406
							order[50] = 40407
							order[51] = 40408
							order[52] = 40928
							order[53] = 40410
							order[54] = 40411
							order[55] = 40412
							order[56] = 40413
							order[57] = 0
							super(40374, 40375, order)
						end

						class NoLegPaymentScheduleRateSources < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 40415
								order[1] = 40416
								order[2] = 40417
								order[3] = 0
								super(40414, 40415, order)
							end
						end

						class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 40400
								order[1] = 0
								super(40927, 40400, order)
							end
						end

						class NoLegPaymentScheduleFixingDays < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 41531
								order[1] = 41532
								order[2] = 0
								super(41530, 41531, order)
							end
						end

						class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 40409
								order[1] = 0
								super(40928, 40409, order)
							end
						end
					end

					class NoLegPaymentStubs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(44)
							order[0] = 40419
							order[1] = 40420
							order[2] = 42497
							order[3] = 42498
							order[4] = 42499
							order[5] = 42500
							order[6] = 42501
							order[7] = 42502
							order[8] = 42503
							order[9] = 42488
							order[10] = 42489
							order[11] = 42490
							order[12] = 42491
							order[13] = 42492
							order[14] = 42493
							order[15] = 42494
							order[16] = 40421
							order[17] = 40422
							order[18] = 40423
							order[19] = 40424
							order[20] = 40425
							order[21] = 40426
							order[22] = 40427
							order[23] = 40428
							order[24] = 40429
							order[25] = 40430
							order[26] = 40431
							order[27] = 40432
							order[28] = 40433
							order[29] = 40434
							order[30] = 40435
							order[31] = 40436
							order[32] = 40437
							order[33] = 40438
							order[34] = 40439
							order[35] = 40440
							order[36] = 40441
							order[37] = 40442
							order[38] = 40443
							order[39] = 40444
							order[40] = 40445
							order[41] = 40446
							order[42] = 40447
							order[43] = 0
							super(40418, 40419, order)
						end

						class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 42505
								order[1] = 0
								super(42504, 42505, order)
							end
						end

						class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 42496
								order[1] = 0
								super(42495, 42496, order)
							end
						end
					end

					class NoLegDeliveryStreamCommoditySources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41461
							order[1] = 0
							super(41460, 41461, order)
						end
					end

					class NoLegDeliveryStreamCycles < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41457
							order[1] = 41458
							order[2] = 41459
							order[3] = 0
							super(41456, 41457, order)
						end
					end

					class NoLegDeliverySchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(15)
							order[0] = 41409
							order[1] = 41410
							order[2] = 41411
							order[3] = 41412
							order[4] = 41413
							order[5] = 41414
							order[6] = 41415
							order[7] = 41416
							order[8] = 41417
							order[9] = 41418
							order[10] = 41419
							order[11] = 41420
							order[12] = 41421
							order[13] = 41422
							order[14] = 0
							super(41408, 41409, order)
						end

						class NoLegDeliveryScheduleSettlDays < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41423
								order[1] = 41424
								order[2] = 41425
								order[3] = 0
								super(41422, 41423, order)
							end

							class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
								def initialize
									order = Quickfix::IntArray.new(4)
									order[0] = 41426
									order[1] = 41427
									order[2] = 41428
									order[3] = 0
									super(41425, 41426, order)
								end
							end
						end
					end
				end

				class NoLegProvisions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(79)
						order[0] = 40449
						order[1] = 40450
						order[2] = 40451
						order[3] = 40939
						order[4] = 40453
						order[5] = 40454
						order[6] = 40455
						order[7] = 42506
						order[8] = 42507
						order[9] = 40456
						order[10] = 40457
						order[11] = 40458
						order[12] = 40524
						order[13] = 40525
						order[14] = 40526
						order[15] = 40528
						order[16] = 40529
						order[17] = 40530
						order[18] = 40531
						order[19] = 40532
						order[20] = 40476
						order[21] = 40478
						order[22] = 40479
						order[23] = 40480
						order[24] = 40481
						order[25] = 40482
						order[26] = 40483
						order[27] = 40484
						order[28] = 40485
						order[29] = 40486
						order[30] = 40487
						order[31] = 40488
						order[32] = 40489
						order[33] = 40490
						order[34] = 40491
						order[35] = 40492
						order[36] = 40493
						order[37] = 40494
						order[38] = 40498
						order[39] = 40499
						order[40] = 40501
						order[41] = 40502
						order[42] = 40503
						order[43] = 40504
						order[44] = 40505
						order[45] = 40506
						order[46] = 40507
						order[47] = 40508
						order[48] = 40509
						order[49] = 40511
						order[50] = 40512
						order[51] = 40513
						order[52] = 40514
						order[53] = 40515
						order[54] = 40459
						order[55] = 40460
						order[56] = 40461
						order[57] = 40462
						order[58] = 40463
						order[59] = 40464
						order[60] = 40465
						order[61] = 40516
						order[62] = 40518
						order[63] = 40519
						order[64] = 40520
						order[65] = 40521
						order[66] = 40522
						order[67] = 40523
						order[68] = 40466
						order[69] = 40467
						order[70] = 40468
						order[71] = 40469
						order[72] = 40470
						order[73] = 41407
						order[74] = 40472
						order[75] = 40980
						order[76] = 40981
						order[77] = 40533
						order[78] = 0
						super(40448, 40449, order)
					end

					class NoLegProvisionDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40452
							order[1] = 0
							super(40939, 40452, order)
						end
					end

					class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40527
							order[1] = 0
							super(40935, 40527, order)
						end
					end

					class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40477
							order[1] = 0
							super(40936, 40477, order)
						end
					end

					class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40496
							order[1] = 40497
							order[2] = 0
							super(40495, 40496, order)
						end
					end

					class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40500
							order[1] = 0
							super(40937, 40500, order)
						end
					end

					class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40510
							order[1] = 0
							super(40938, 40510, order)
						end
					end

					class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40517
							order[1] = 0
							super(40934, 40517, order)
						end
					end

					class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40474
							order[1] = 40475
							order[2] = 0
							super(40473, 40474, order)
						end
					end

					class NoLegProvisionPartyIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 40534
							order[1] = 40535
							order[2] = 40536
							order[3] = 2380
							order[4] = 40537
							order[5] = 0
							super(40533, 40534, order)
						end

						class NoLegProvisionPartySubIDs < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 40538
								order[1] = 40539
								order[2] = 0
								super(40537, 40538, order)
							end
						end
					end
				end

				class NoLegAdditionalTerms < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41336
						order[1] = 41337
						order[2] = 41316
						order[3] = 0
						super(41335, 41336, order)
					end

					class NoLegAdditionalTermBondRefs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(19)
							order[0] = 41317
							order[1] = 41318
							order[2] = 41319
							order[3] = 41320
							order[4] = 41321
							order[5] = 41322
							order[6] = 41323
							order[7] = 41324
							order[8] = 41325
							order[9] = 41326
							order[10] = 41327
							order[11] = 41328
							order[12] = 41329
							order[13] = 41330
							order[14] = 41331
							order[15] = 41332
							order[16] = 41333
							order[17] = 41334
							order[18] = 0
							super(41316, 41317, order)
						end
					end
				end

				class NoLegProtectionTerms < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(12)
						order[0] = 41618
						order[1] = 41619
						order[2] = 41620
						order[3] = 41621
						order[4] = 41622
						order[5] = 41623
						order[6] = 41624
						order[7] = 41614
						order[8] = 41625
						order[9] = 41635
						order[10] = 41617
						order[11] = 0
						super(41616, 41618, order)
					end

					class NoLegProtectionTermEventNewsSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41615
							order[1] = 0
							super(41614, 41615, order)
						end
					end

					class NoLegProtectionTermEvents < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(9)
							order[0] = 41626
							order[1] = 41627
							order[2] = 41628
							order[3] = 41629
							order[4] = 41630
							order[5] = 41631
							order[6] = 41632
							order[7] = 41633
							order[8] = 0
							super(41625, 41626, order)
						end

						class NoLegProtectionTermEventQualifiers < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 41634
								order[1] = 0
								super(41633, 41634, order)
							end
						end
					end

					class NoLegProtectionTermObligations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41636
							order[1] = 41637
							order[2] = 0
							super(41635, 41636, order)
						end
					end
				end

				class NoLegCashSettlTerms < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(29)
						order[0] = 41345
						order[1] = 41346
						order[2] = 41347
						order[3] = 41348
						order[4] = 41349
						order[5] = 41350
						order[6] = 41351
						order[7] = 41352
						order[8] = 41353
						order[9] = 41354
						order[10] = 41355
						order[11] = 41342
						order[12] = 42308
						order[13] = 42309
						order[14] = 41356
						order[15] = 41357
						order[16] = 42299
						order[17] = 42300
						order[18] = 42301
						order[19] = 42302
						order[20] = 42303
						order[21] = 42304
						order[22] = 42305
						order[23] = 41358
						order[24] = 41359
						order[25] = 41360
						order[26] = 41361
						order[27] = 41362
						order[28] = 0
						super(41344, 41345, order)
					end

					class NoLegCashSettlDealers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41343
							order[1] = 0
							super(41342, 41343, order)
						end
					end

					class NoLegCashSettlDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42307
							order[1] = 0
							super(42306, 42307, order)
						end
					end
				end

				class NoLegPhysicalSettlTerms < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41604
						order[1] = 41601
						order[2] = 41602
						order[3] = 41603
						order[4] = 41600
						order[5] = 0
						super(41599, 41604, order)
					end

					class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41605
							order[1] = 41606
							order[2] = 0
							super(41604, 41605, order)
						end
					end
				end

				class NoLegExtraordinaryEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42389
						order[1] = 42390
						order[2] = 0
						super(42388, 42389, order)
					end
				end

				class NoLegContractualDefinitions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42199
						order[1] = 0
						super(42198, 42199, order)
					end
				end

				class NoLegFinancingTermSupplements < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42201
						order[1] = 42202
						order[2] = 0
						super(42200, 42201, order)
					end
				end

				class NoLegContractualMatrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42204
						order[1] = 42205
						order[2] = 42206
						order[3] = 0
						super(42203, 42204, order)
					end
				end
			end
		end
	end
end

class SecurityDefinitionRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("c") )
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoInstrAttrib < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 871
			order[1] = 872
			order[2] = 0
			super(870, 871, order)
		end
	end

	class NoIndexRollMonths < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2733
			order[1] = 0
			super(2734, 2733, order)
		end
	end

	class NoReferenceDataDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2747
			order[1] = 2748
			order[2] = 0
			super(2746, 2747, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoRelatedInstruments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 1648
			order[1] = 1649
			order[2] = 1650
			order[3] = 1651
			order[4] = 1652
			order[5] = 1653
			order[6] = 2413
			order[7] = 2414
			order[8] = 2415
			order[9] = 2417
			order[10] = 0
			super(1647, 1648, order)
		end
	end

	class NoStipulations < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 233
			order[1] = 234
			order[2] = 0
			super(232, 233, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end
end

class SecurityDefinition < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("d") )
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoInstrAttrib < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 871
			order[1] = 872
			order[2] = 0
			super(870, 871, order)
		end
	end

	class NoIndexRollMonths < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2733
			order[1] = 0
			super(2734, 2733, order)
		end
	end

	class NoReferenceDataDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2747
			order[1] = 2748
			order[2] = 0
			super(2746, 2747, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoRelatedInstruments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 1648
			order[1] = 1649
			order[2] = 1650
			order[3] = 1651
			order[4] = 1652
			order[5] = 1653
			order[6] = 2413
			order[7] = 2414
			order[8] = 2415
			order[9] = 2417
			order[10] = 0
			super(1647, 1648, order)
		end
	end

	class NoSecurityClassifications < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1583
			order[1] = 1584
			order[2] = 0
			super(1582, 1583, order)
		end
	end

	class NoStipulations < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 233
			order[1] = 234
			order[2] = 0
			super(232, 233, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoMarketSegments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 1301
			order[1] = 1300
			order[2] = 1201
			order[3] = 0
			super(1310, 1301, order)
		end

		class NoTickRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(8)
				order[0] = 1206
				order[1] = 1207
				order[2] = 1208
				order[3] = 1209
				order[4] = 2571
				order[5] = 1830
				order[6] = 1831
				order[7] = 0
				super(1205, 1206, order)
			end
		end

		class NoLotTypeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1093
				order[1] = 1231
				order[2] = 0
				super(1234, 1093, order)
			end
		end

		class NoPriceRangeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 2551
				order[1] = 2552
				order[2] = 2553
				order[3] = 2554
				order[4] = 2556
				order[5] = 2555
				order[6] = 0
				super(2550, 2551, order)
			end
		end

		class NoQuoteSizeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 647
				order[1] = 648
				order[2] = 2447
				order[3] = 0
				super(2558, 647, order)
			end
		end

		class NoTradingSessionRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 336
				order[1] = 625
				order[2] = 0
				super(1309, 336, order)
			end

			class NoOrdTypeRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40
					order[1] = 0
					super(1237, 40, order)
				end
			end

			class NoTimeInForceRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 59
					order[1] = 0
					super(1239, 59, order)
				end
			end

			class NoExecInstRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 1308
					order[1] = 0
					super(1232, 1308, order)
				end
			end

			class NoAuctionTypeRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1803
					order[1] = 2549
					order[2] = 0
					super(2548, 1803, order)
				end
			end

			class NoMatchRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 1142
					order[1] = 574
					order[2] = 2569
					order[3] = 2570
					order[4] = 0
					super(1235, 1142, order)
				end
			end

			class NoMDFeedTypes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 1022
					order[1] = 1683
					order[2] = 264
					order[3] = 2563
					order[4] = 2564
					order[5] = 2565
					order[6] = 2566
					order[7] = 1021
					order[8] = 1173
					order[9] = 2567
					order[10] = 2568
					order[11] = 0
					super(1141, 1022, order)
				end
			end
		end

		class NoNestedInstrAttrib < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1210
				order[1] = 1211
				order[2] = 0
				super(1312, 1210, order)
			end
		end

		class NoStrikeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 1223
				order[1] = 1202
				order[2] = 1203
				order[3] = 1204
				order[4] = 1304
				order[5] = 1236
				order[6] = 0
				super(1201, 1223, order)
			end

			class NoMaturityRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(7)
					order[0] = 1222
					order[1] = 1303
					order[2] = 1302
					order[3] = 1241
					order[4] = 1226
					order[5] = 1229
					order[6] = 0
					super(1236, 1222, order)
				end
			end
		end
	end
end

class SecurityStatusRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("e") )
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoInstrAttrib < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 871
			order[1] = 872
			order[2] = 0
			super(870, 871, order)
		end
	end

	class NoIndexRollMonths < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2733
			order[1] = 0
			super(2734, 2733, order)
		end
	end

	class NoReferenceDataDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2747
			order[1] = 2748
			order[2] = 0
			super(2746, 2747, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoRelatedInstruments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 1648
			order[1] = 1649
			order[2] = 1650
			order[3] = 1651
			order[4] = 1652
			order[5] = 1653
			order[6] = 2413
			order[7] = 2414
			order[8] = 2415
			order[9] = 2417
			order[10] = 0
			super(1647, 1648, order)
		end
	end
end

class SecurityStatus < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("f") )
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoInstrAttrib < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 871
			order[1] = 872
			order[2] = 0
			super(870, 871, order)
		end
	end

	class NoIndexRollMonths < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2733
			order[1] = 0
			super(2734, 2733, order)
		end
	end

	class NoReferenceDataDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2747
			order[1] = 2748
			order[2] = 0
			super(2746, 2747, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoRelatedInstruments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 1648
			order[1] = 1649
			order[2] = 1650
			order[3] = 1651
			order[4] = 1652
			order[5] = 1653
			order[6] = 2413
			order[7] = 2414
			order[8] = 2415
			order[9] = 2417
			order[10] = 0
			super(1647, 1648, order)
		end
	end

	class NoClearingPriceParameters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(17)
			order[0] = 2581
			order[1] = 2582
			order[2] = 2583
			order[3] = 2584
			order[4] = 2585
			order[5] = 2586
			order[6] = 2588
			order[7] = 2587
			order[8] = 2589
			order[9] = 1190
			order[10] = 2590
			order[11] = 2591
			order[12] = 1592
			order[13] = 1188
			order[14] = 2528
			order[15] = 2592
			order[16] = 0
			super(2580, 2581, order)
		end
	end
end

class TradingSessionStatusRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("g") )
	end
end

class TradingSessionStatus < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("h") )
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end
end

class MassQuote < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("i") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoQuoteSets < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(193)
			order[0] = 302
			order[1] = 311
			order[2] = 312
			order[3] = 309
			order[4] = 305
			order[5] = 2874
			order[6] = 462
			order[7] = 463
			order[8] = 2894
			order[9] = 310
			order[10] = 763
			order[11] = 313
			order[12] = 542
			order[13] = 1213
			order[14] = 1837
			order[15] = 241
			order[16] = 1453
			order[17] = 1454
			order[18] = 2614
			order[19] = 2615
			order[20] = 2921
			order[21] = 2616
			order[22] = 2617
			order[23] = 2619
			order[24] = 1455
			order[25] = 1456
			order[26] = 1459
			order[27] = 1460
			order[28] = 242
			order[29] = 243
			order[30] = 244
			order[31] = 245
			order[32] = 246
			order[33] = 256
			order[34] = 595
			order[35] = 592
			order[36] = 593
			order[37] = 594
			order[38] = 247
			order[39] = 316
			order[40] = 941
			order[41] = 2917
			order[42] = 317
			order[43] = 436
			order[44] = 1437
			order[45] = 2363
			order[46] = 1441
			order[47] = 998
			order[48] = 1423
			order[49] = 1718
			order[50] = 2918
			order[51] = 1424
			order[52] = 1425
			order[53] = 1719
			order[54] = 2919
			order[55] = 1000
			order[56] = 1419
			order[57] = 1526
			order[58] = 2920
			order[59] = 435
			order[60] = 308
			order[61] = 306
			order[62] = 362
			order[63] = 363
			order[64] = 2742
			order[65] = 2720
			order[66] = 2721
			order[67] = 2722
			order[68] = 2723
			order[69] = 2724
			order[70] = 307
			order[71] = 364
			order[72] = 365
			order[73] = 877
			order[74] = 878
			order[75] = 972
			order[76] = 318
			order[77] = 2916
			order[78] = 879
			order[79] = 975
			order[80] = 973
			order[81] = 974
			order[82] = 810
			order[83] = 882
			order[84] = 883
			order[85] = 884
			order[86] = 885
			order[87] = 886
			order[88] = 2885
			order[89] = 2886
			order[90] = 1044
			order[91] = 1045
			order[92] = 1046
			order[93] = 1038
			order[94] = 1039
			order[95] = 315
			order[96] = 2683
			order[97] = 2687
			order[98] = 1988
			order[99] = 1989
			order[100] = 1990
			order[101] = 1991
			order[102] = 1992
			order[103] = 1993
			order[104] = 2881
			order[105] = 1994
			order[106] = 1995
			order[107] = 1996
			order[108] = 1997
			order[109] = 2620
			order[110] = 2621
			order[111] = 1998
			order[112] = 1999
			order[113] = 2000
			order[114] = 2003
			order[115] = 2004
			order[116] = 2005
			order[117] = 2006
			order[118] = 2284
			order[119] = 2285
			order[120] = 2286
			order[121] = 2287
			order[122] = 2288
			order[123] = 2007
			order[124] = 2008
			order[125] = 2009
			order[126] = 2010
			order[127] = 2011
			order[128] = 2012
			order[129] = 2491
			order[130] = 2013
			order[131] = 2014
			order[132] = 2015
			order[133] = 2744
			order[134] = 2016
			order[135] = 2289
			order[136] = 2017
			order[137] = 2018
			order[138] = 2019
			order[139] = 2020
			order[140] = 2021
			order[141] = 2022
			order[142] = 2290
			order[143] = 2622
			order[144] = 2291
			order[145] = 2623
			order[146] = 2292
			order[147] = 2023
			order[148] = 2024
			order[149] = 2025
			order[150] = 2026
			order[151] = 2027
			order[152] = 2028
			order[153] = 2029
			order[154] = 2757
			order[155] = 2030
			order[156] = 2031
			order[157] = 2293
			order[158] = 2294
			order[159] = 2032
			order[160] = 2033
			order[161] = 2034
			order[162] = 2035
			order[163] = 2036
			order[164] = 2037
			order[165] = 2038
			order[166] = 2039
			order[167] = 2040
			order[168] = 2041
			order[169] = 2042
			order[170] = 2043
			order[171] = 2044
			order[172] = 41314
			order[173] = 41315
			order[174] = 2295
			order[175] = 2296
			order[176] = 2297
			order[177] = 2756
			order[178] = 2298
			order[179] = 2299
			order[180] = 2624
			order[181] = 2625
			order[182] = 2626
			order[183] = 2627
			order[184] = 2628
			order[185] = 2629
			order[186] = 2630
			order[187] = 2631
			order[188] = 367
			order[189] = 304
			order[190] = 893
			order[191] = 295
			order[192] = 0
			super(296, 302, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end

		class NoQuoteEntries < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(186)
				order[0] = 299
				order[1] = 55
				order[2] = 65
				order[3] = 48
				order[4] = 22
				order[5] = 460
				order[6] = 1227
				order[7] = 1151
				order[8] = 461
				order[9] = 2891
				order[10] = 167
				order[11] = 762
				order[12] = 200
				order[13] = 541
				order[14] = 1079
				order[15] = 966
				order[16] = 1049
				order[17] = 965
				order[18] = 224
				order[19] = 1449
				order[20] = 1450
				order[21] = 1451
				order[22] = 1452
				order[23] = 1457
				order[24] = 1458
				order[25] = 1739
				order[26] = 2210
				order[27] = 1938
				order[28] = 1939
				order[29] = 1940
				order[30] = 2735
				order[31] = 1941
				order[32] = 1575
				order[33] = 1942
				order[34] = 1943
				order[35] = 1944
				order[36] = 1945
				order[37] = 1946
				order[38] = 1947
				order[39] = 1948
				order[40] = 1949
				order[41] = 1950
				order[42] = 2879
				order[43] = 1951
				order[44] = 1952
				order[45] = 1953
				order[46] = 1954
				order[47] = 1955
				order[48] = 1956
				order[49] = 1957
				order[50] = 1958
				order[51] = 1959
				order[52] = 1960
				order[53] = 1577
				order[54] = 1580
				order[55] = 1581
				order[56] = 1678
				order[57] = 1697
				order[58] = 225
				order[59] = 239
				order[60] = 226
				order[61] = 227
				order[62] = 228
				order[63] = 255
				order[64] = 543
				order[65] = 470
				order[66] = 471
				order[67] = 472
				order[68] = 240
				order[69] = 202
				order[70] = 2578
				order[71] = 2577
				order[72] = 947
				order[73] = 2904
				order[74] = 967
				order[75] = 968
				order[76] = 1698
				order[77] = 1866
				order[78] = 2600
				order[79] = 2001
				order[80] = 2601
				order[81] = 1478
				order[82] = 1479
				order[83] = 1480
				order[84] = 1481
				order[85] = 206
				order[86] = 231
				order[87] = 1435
				order[88] = 2353
				order[89] = 1439
				order[90] = 969
				order[91] = 1146
				order[92] = 996
				order[93] = 1147
				order[94] = 1716
				order[95] = 2905
				order[96] = 1191
				order[97] = 1192
				order[98] = 1717
				order[99] = 2906
				order[100] = 1193
				order[101] = 2579
				order[102] = 1194
				order[103] = 1482
				order[104] = 1195
				order[105] = 2753
				order[106] = 1196
				order[107] = 1197
				order[108] = 2002
				order[109] = 2140
				order[110] = 1524
				order[111] = 2907
				order[112] = 1198
				order[113] = 1199
				order[114] = 1200
				order[115] = 201
				order[116] = 2681
				order[117] = 2685
				order[118] = 1244
				order[119] = 1242
				order[120] = 2575
				order[121] = 2574
				order[122] = 997
				order[123] = 223
				order[124] = 207
				order[125] = 970
				order[126] = 971
				order[127] = 106
				order[128] = 348
				order[129] = 349
				order[130] = 2737
				order[131] = 2714
				order[132] = 2715
				order[133] = 2716
				order[134] = 107
				order[135] = 350
				order[136] = 351
				order[137] = 691
				order[138] = 667
				order[139] = 875
				order[140] = 876
				order[141] = 873
				order[142] = 874
				order[143] = 1687
				order[144] = 1787
				order[145] = 2141
				order[146] = 2142
				order[147] = 2143
				order[148] = 2752
				order[149] = 2144
				order[150] = 2145
				order[151] = 2576
				order[152] = 2962
				order[153] = 2602
				order[154] = 2603
				order[155] = 555
				order[156] = 132
				order[157] = 133
				order[158] = 1749
				order[159] = 1750
				order[160] = 134
				order[161] = 135
				order[162] = 62
				order[163] = 188
				order[164] = 190
				order[165] = 189
				order[166] = 191
				order[167] = 631
				order[168] = 632
				order[169] = 633
				order[170] = 634
				order[171] = 60
				order[172] = 336
				order[173] = 625
				order[174] = 64
				order[175] = 40
				order[176] = 193
				order[177] = 192
				order[178] = 642
				order[179] = 643
				order[180] = 15
				order[181] = 2897
				order[182] = 775
				order[183] = 528
				order[184] = 529
				order[185] = 0
				super(295, 299, order)
			end

			class NoSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 455
					order[1] = 456
					order[2] = 2957
					order[3] = 0
					super(454, 455, order)
				end
			end

			class NoSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 1977
					order[1] = 1978
					order[2] = 1979
					order[3] = 2741
					order[4] = 0
					super(1976, 1977, order)
				end
			end

			class NoAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2305
					order[1] = 2306
					order[2] = 2307
					order[3] = 0
					super(2304, 2305, order)
				end
			end

			class NoEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 865
					order[1] = 866
					order[2] = 1145
					order[3] = 1827
					order[4] = 1826
					order[5] = 2340
					order[6] = 867
					order[7] = 868
					order[8] = 1578
					order[9] = 1579
					order[10] = 0
					super(864, 865, order)
				end
			end

			class NoInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 1019
					order[1] = 1050
					order[2] = 1051
					order[3] = 2378
					order[4] = 1052
					order[5] = 0
					super(1018, 1019, order)
				end

				class NoInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1053
						order[1] = 1054
						order[2] = 0
						super(1052, 1053, order)
					end
				end
			end

			class NoComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 1484
					order[1] = 2117
					order[2] = 2118
					order[3] = 2119
					order[4] = 1485
					order[5] = 2120
					order[6] = 2121
					order[7] = 2122
					order[8] = 2941
					order[9] = 1486
					order[10] = 2123
					order[11] = 1487
					order[12] = 1488
					order[13] = 1489
					order[14] = 1490
					order[15] = 1491
					order[16] = 2124
					order[17] = 2942
					order[18] = 2125
					order[19] = 2943
					order[20] = 2126
					order[21] = 2127
					order[22] = 2407
					order[23] = 2408
					order[24] = 2128
					order[25] = 2129
					order[26] = 2130
					order[27] = 2131
					order[28] = 2132
					order[29] = 41013
					order[30] = 41020
					order[31] = 41021
					order[32] = 41022
					order[33] = 41023
					order[34] = 41024
					order[35] = 41025
					order[36] = 41026
					order[37] = 41027
					order[38] = 41028
					order[39] = 41010
					order[40] = 2133
					order[41] = 2134
					order[42] = 2135
					order[43] = 2136
					order[44] = 2137
					order[45] = 41029
					order[46] = 40997
					order[47] = 2597
					order[48] = 2598
					order[49] = 2599
					order[50] = 2138
					order[51] = 2139
					order[52] = 0
					super(1483, 1484, order)
				end

				class NoComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 1492
						order[1] = 1493
						order[2] = 1494
						order[3] = 0
						super(1491, 1492, order)
					end

					class NoComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 1495
							order[1] = 1496
							order[2] = 0
							super(1494, 1495, order)
						end
					end
				end

				class NoComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41014
						order[1] = 41015
						order[2] = 41016
						order[3] = 41017
						order[4] = 0
						super(41013, 41014, order)
					end
				end

				class NoComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41019
						order[1] = 0
						super(41018, 41019, order)
					end
				end

				class NoComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41011
						order[1] = 41012
						order[2] = 41031
						order[3] = 41007
						order[4] = 40994
						order[5] = 0
						super(41010, 41011, order)
					end

					class NoComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41032
							order[1] = 41033
							order[2] = 41034
							order[3] = 41035
							order[4] = 41036
							order[5] = 0
							super(41031, 41032, order)
						end
					end

					class NoComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41008
							order[1] = 41009
							order[2] = 0
							super(41007, 41008, order)
						end
					end

					class NoComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40995
							order[1] = 40996
							order[2] = 0
							super(40994, 40995, order)
						end
					end
				end

				class NoComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41030
						order[1] = 0
						super(41029, 41030, order)
					end
				end

				class NoComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 40998
						order[1] = 40999
						order[2] = 41000
						order[3] = 41001
						order[4] = 41002
						order[5] = 41003
						order[6] = 41004
						order[7] = 41005
						order[8] = 0
						super(40997, 40998, order)
					end

					class NoComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41006
							order[1] = 0
							super(41005, 41006, order)
						end
					end
				end
			end

			class NoBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40471
					order[1] = 0
					super(40278, 40471, order)
				end
			end

			class NoPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41231
					order[1] = 0
					super(41230, 41231, order)
				end
			end

			class NoMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41093
					order[1] = 40991
					order[2] = 0
					super(41092, 41093, order)
				end
			end

			class NoMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41095
					order[1] = 40992
					order[2] = 0
					super(41094, 41095, order)
				end
			end

			class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41097
					order[1] = 41098
					order[2] = 41099
					order[3] = 41100
					order[4] = 41101
					order[5] = 41102
					order[6] = 41103
					order[7] = 41104
					order[8] = 41105
					order[9] = 0
					super(41096, 41097, order)
				end
			end

			class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42776
					order[1] = 0
					super(42775, 42776, order)
				end
			end

			class NoOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41117
					order[1] = 0
					super(41116, 41117, order)
				end
			end

			class NoOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41138
					order[1] = 41139
					order[2] = 0
					super(41137, 41138, order)
				end
			end

			class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41141
					order[1] = 0
					super(41140, 41141, order)
				end
			end

			class NoOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41153
					order[1] = 41154
					order[2] = 0
					super(41152, 41153, order)
				end
			end

			class NoStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40050
					order[1] = 41303
					order[2] = 40051
					order[3] = 42784
					order[4] = 42785
					order[5] = 40052
					order[6] = 40053
					order[7] = 41305
					order[8] = 40054
					order[9] = 40055
					order[10] = 42786
					order[11] = 42787
					order[12] = 41306
					order[13] = 41307
					order[14] = 41308
					order[15] = 41309
					order[16] = 41310
					order[17] = 41311
					order[18] = 41251
					order[19] = 41252
					order[20] = 41253
					order[21] = 41254
					order[22] = 41255
					order[23] = 41256
					order[24] = 41257
					order[25] = 42587
					order[26] = 41258
					order[27] = 41259
					order[28] = 41260
					order[29] = 41261
					order[30] = 41262
					order[31] = 41263
					order[32] = 41264
					order[33] = 41265
					order[34] = 41266
					order[35] = 41267
					order[36] = 41268
					order[37] = 41269
					order[38] = 41270
					order[39] = 41271
					order[40] = 41272
					order[41] = 41273
					order[42] = 41274
					order[43] = 41275
					order[44] = 41276
					order[45] = 40907
					order[46] = 40908
					order[47] = 40910
					order[48] = 40911
					order[49] = 40912
					order[50] = 40913
					order[51] = 40914
					order[52] = 40065
					order[53] = 40066
					order[54] = 40068
					order[55] = 40069
					order[56] = 40070
					order[57] = 40071
					order[58] = 40072
					order[59] = 41244
					order[60] = 41245
					order[61] = 40073
					order[62] = 40075
					order[63] = 40076
					order[64] = 40078
					order[65] = 40079
					order[66] = 40080
					order[67] = 40081
					order[68] = 40082
					order[69] = 40083
					order[70] = 40084
					order[71] = 41246
					order[72] = 41247
					order[73] = 41248
					order[74] = 40738
					order[75] = 40739
					order[76] = 40740
					order[77] = 42600
					order[78] = 40741
					order[79] = 40742
					order[80] = 43106
					order[81] = 40743
					order[82] = 40744
					order[83] = 40745
					order[84] = 40746
					order[85] = 40747
					order[86] = 42601
					order[87] = 42602
					order[88] = 42603
					order[89] = 42604
					order[90] = 40748
					order[91] = 40749
					order[92] = 40750
					order[93] = 41180
					order[94] = 41181
					order[95] = 41182
					order[96] = 41183
					order[97] = 41184
					order[98] = 41185
					order[99] = 41186
					order[100] = 42605
					order[101] = 40828
					order[102] = 40872
					order[103] = 41058
					order[104] = 41059
					order[105] = 41060
					order[106] = 41061
					order[107] = 41062
					order[108] = 42192
					order[109] = 42193
					order[110] = 41063
					order[111] = 41064
					order[112] = 41065
					order[113] = 41066
					order[114] = 41067
					order[115] = 41218
					order[116] = 41068
					order[117] = 41069
					order[118] = 41070
					order[119] = 41071
					order[120] = 41072
					order[121] = 41073
					order[122] = 41074
					order[123] = 41075
					order[124] = 41076
					order[125] = 41077
					order[126] = 41078
					order[127] = 41079
					order[128] = 41080
					order[129] = 43094
					order[130] = 41037
					order[131] = 40056
					order[132] = 40982
					order[133] = 40983
					order[134] = 0
					super(40049, 40050, order)
				end

				class NoStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41278
						order[1] = 41279
						order[2] = 0
						super(41277, 41278, order)
					end
				end

				class NoStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41238
						order[1] = 41239
						order[2] = 41240
						order[3] = 0
						super(41237, 41238, order)
					end
				end

				class NoStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41281
						order[1] = 41282
						order[2] = 0
						super(41280, 41281, order)
					end
				end

				class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41250
						order[1] = 0
						super(41249, 41250, order)
					end
				end

				class NoStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41290
						order[1] = 41291
						order[2] = 41292
						order[3] = 41293
						order[4] = 41294
						order[5] = 41295
						order[6] = 41296
						order[7] = 41297
						order[8] = 41298
						order[9] = 41299
						order[10] = 41300
						order[11] = 41283
						order[12] = 41301
						order[13] = 41302
						order[14] = 0
						super(41289, 41290, order)
					end

					class NoStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41284
							order[1] = 41285
							order[2] = 41286
							order[3] = 0
							super(41283, 41284, order)
						end

						class NoStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41287
								order[1] = 41288
								order[2] = 41588
								order[3] = 0
								super(41286, 41287, order)
							end
						end
					end
				end

				class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40909
						order[1] = 0
						super(40960, 40909, order)
					end
				end

				class NoStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40067
						order[1] = 0
						super(40961, 40067, order)
					end
				end

				class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40074
						order[1] = 0
						super(40958, 40074, order)
					end
				end

				class NoStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41242
						order[1] = 41243
						order[2] = 0
						super(41241, 41242, order)
					end
				end

				class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40077
						order[1] = 0
						super(40959, 40077, order)
					end
				end

				class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40752
						order[1] = 0
						super(40947, 40752, order)
					end
				end

				class NoPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41221
						order[1] = 41222
						order[2] = 0
						super(41220, 41221, order)
					end
				end

				class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40763
						order[1] = 0
						super(40948, 40763, order)
					end
				end

				class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40769
						order[1] = 0
						super(40949, 40769, order)
					end
				end

				class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40776
						order[1] = 0
						super(40950, 40776, order)
					end
				end

				class NoPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42661
						order[1] = 42662
						order[2] = 0
						super(42660, 42661, order)
					end
				end

				class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41193
						order[1] = 0
						super(41192, 41193, order)
					end
				end

				class NoPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41228
						order[1] = 41229
						order[2] = 0
						super(41227, 41228, order)
					end
				end

				class NoPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41225
						order[1] = 41226
						order[2] = 0
						super(41224, 41225, order)
					end
				end

				class NoPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43109
						order[1] = 42684
						order[2] = 42685
						order[3] = 0
						super(42683, 43109, order)
					end
				end

				class NoDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42275
						order[1] = 42276
						order[2] = 42277
						order[3] = 42278
						order[4] = 42279
						order[5] = 42280
						order[6] = 42294
						order[7] = 42281
						order[8] = 42282
						order[9] = 42283
						order[10] = 42284
						order[11] = 42285
						order[12] = 42286
						order[13] = 42287
						order[14] = 42288
						order[15] = 42289
						order[16] = 42290
						order[17] = 42291
						order[18] = 42292
						order[19] = 42293
						order[20] = 0
						super(42274, 42275, order)
					end

					class NoDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42295
							order[1] = 0
							super(42294, 42295, order)
						end
					end
				end

				class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42273
						order[1] = 0
						super(42272, 42273, order)
					end
				end

				class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42237
						order[1] = 0
						super(42236, 42237, order)
					end
				end

				class NoReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 42736
						order[1] = 42737
						order[2] = 42738
						order[3] = 42739
						order[4] = 42740
						order[5] = 42741
						order[6] = 42765
						order[7] = 42731
						order[8] = 42742
						order[9] = 42743
						order[10] = 42744
						order[11] = 42745
						order[12] = 42746
						order[13] = 42747
						order[14] = 42748
						order[15] = 42749
						order[16] = 42750
						order[17] = 42751
						order[18] = 42752
						order[19] = 42753
						order[20] = 42761
						order[21] = 42754
						order[22] = 42755
						order[23] = 42709
						order[24] = 42756
						order[25] = 42757
						order[26] = 42758
						order[27] = 42759
						order[28] = 42760
						order[29] = 0
						super(42735, 42736, order)
					end

					class NoReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 42766
							order[1] = 42767
							order[2] = 42768
							order[3] = 42769
							order[4] = 0
							super(42765, 42766, order)
						end
					end

					class NoReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42732
							order[1] = 42733
							order[2] = 42734
							order[3] = 0
							super(42731, 42732, order)
						end
					end

					class NoReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42762
							order[1] = 42763
							order[2] = 42764
							order[3] = 0
							super(42761, 42762, order)
						end
					end

					class NoReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 42710
							order[1] = 42772
							order[2] = 42711
							order[3] = 42712
							order[4] = 42713
							order[5] = 42714
							order[6] = 42715
							order[7] = 42716
							order[8] = 42717
							order[9] = 42718
							order[10] = 42719
							order[11] = 42720
							order[12] = 42721
							order[13] = 42722
							order[14] = 42723
							order[15] = 42724
							order[16] = 42725
							order[17] = 42726
							order[18] = 42727
							order[19] = 42728
							order[20] = 42729
							order[21] = 42730
							order[22] = 42770
							order[23] = 0
							super(42709, 42710, order)
						end

						class NoReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 42773
								order[1] = 42774
								order[2] = 0
								super(42772, 42773, order)
							end
						end

						class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 42771
								order[1] = 0
								super(42770, 42771, order)
							end
						end
					end
				end

				class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42621
						order[1] = 0
						super(42620, 42621, order)
					end
				end

				class NoPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42607
						order[1] = 42608
						order[2] = 0
						super(42606, 42607, order)
					end
				end

				class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40819
						order[1] = 0
						super(40946, 40819, order)
					end
				end

				class NoNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40826
						order[1] = 40827
						order[2] = 0
						super(40825, 40826, order)
					end
				end

				class NoSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40086
						order[1] = 40373
						order[2] = 40655
						order[3] = 40088
						order[4] = 40089
						order[5] = 0
						super(40085, 40086, order)
					end
				end

				class NoPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40829
						order[1] = 41164
						order[2] = 41165
						order[3] = 40830
						order[4] = 40831
						order[5] = 40832
						order[6] = 40833
						order[7] = 40834
						order[8] = 40835
						order[9] = 40836
						order[10] = 40837
						order[11] = 40838
						order[12] = 40839
						order[13] = 41166
						order[14] = 41167
						order[15] = 41168
						order[16] = 41169
						order[17] = 40840
						order[18] = 40841
						order[19] = 40842
						order[20] = 40843
						order[21] = 41170
						order[22] = 41171
						order[23] = 41172
						order[24] = 41173
						order[25] = 40844
						order[26] = 40845
						order[27] = 40846
						order[28] = 40847
						order[29] = 40848
						order[30] = 40849
						order[31] = 40868
						order[32] = 40850
						order[33] = 40851
						order[34] = 40852
						order[35] = 40853
						order[36] = 40977
						order[37] = 40855
						order[38] = 40856
						order[39] = 40857
						order[40] = 41174
						order[41] = 41175
						order[42] = 40858
						order[43] = 41161
						order[44] = 41176
						order[45] = 41177
						order[46] = 41178
						order[47] = 41179
						order[48] = 40859
						order[49] = 40860
						order[50] = 40861
						order[51] = 40862
						order[52] = 40945
						order[53] = 40864
						order[54] = 40865
						order[55] = 40866
						order[56] = 40867
						order[57] = 0
						super(40828, 40829, order)
					end

					class NoPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40869
							order[1] = 40870
							order[2] = 40871
							order[3] = 0
							super(40868, 40869, order)
						end
					end

					class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40854
							order[1] = 0
							super(40977, 40854, order)
						end
					end

					class NoPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41162
							order[1] = 41163
							order[2] = 0
							super(41161, 41162, order)
						end
					end

					class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40863
							order[1] = 0
							super(40945, 40863, order)
						end
					end
				end

				class NoPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40873
						order[1] = 40874
						order[2] = 42698
						order[3] = 42699
						order[4] = 42700
						order[5] = 42701
						order[6] = 42702
						order[7] = 42703
						order[8] = 42704
						order[9] = 42689
						order[10] = 42690
						order[11] = 42691
						order[12] = 42692
						order[13] = 42693
						order[14] = 42694
						order[15] = 42695
						order[16] = 40875
						order[17] = 40876
						order[18] = 40877
						order[19] = 40878
						order[20] = 40879
						order[21] = 40880
						order[22] = 40881
						order[23] = 40882
						order[24] = 40883
						order[25] = 40884
						order[26] = 40885
						order[27] = 40886
						order[28] = 40887
						order[29] = 40888
						order[30] = 40889
						order[31] = 40890
						order[32] = 40891
						order[33] = 40892
						order[34] = 40893
						order[35] = 40894
						order[36] = 40895
						order[37] = 40896
						order[38] = 40897
						order[39] = 40898
						order[40] = 40899
						order[41] = 40900
						order[42] = 40901
						order[43] = 0
						super(40872, 40873, order)
					end

					class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42706
							order[1] = 0
							super(42705, 42706, order)
						end
					end

					class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42697
							order[1] = 0
							super(42696, 42697, order)
						end
					end
				end

				class NoDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41086
						order[1] = 0
						super(41085, 41086, order)
					end
				end

				class NoDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41082
						order[1] = 41083
						order[2] = 41084
						order[3] = 0
						super(41081, 41082, order)
					end
				end

				class NoDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41038
						order[1] = 41039
						order[2] = 41040
						order[3] = 41041
						order[4] = 41042
						order[5] = 41043
						order[6] = 41044
						order[7] = 41045
						order[8] = 41046
						order[9] = 41047
						order[10] = 41048
						order[11] = 41049
						order[12] = 41050
						order[13] = 41051
						order[14] = 0
						super(41037, 41038, order)
					end

					class NoDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41052
							order[1] = 41053
							order[2] = 41054
							order[3] = 0
							super(41051, 41052, order)
						end

						class NoDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41055
								order[1] = 41056
								order[2] = 41057
								order[3] = 0
								super(41054, 41055, order)
							end
						end
					end
				end
			end

			class NoProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 40091
					order[1] = 40092
					order[2] = 40093
					order[3] = 40957
					order[4] = 40095
					order[5] = 40096
					order[6] = 40097
					order[7] = 42707
					order[8] = 42708
					order[9] = 40098
					order[10] = 40099
					order[11] = 40100
					order[12] = 40114
					order[13] = 40115
					order[14] = 40116
					order[15] = 40118
					order[16] = 40119
					order[17] = 40120
					order[18] = 40121
					order[19] = 40122
					order[20] = 40123
					order[21] = 40125
					order[22] = 40126
					order[23] = 40127
					order[24] = 40128
					order[25] = 40129
					order[26] = 40130
					order[27] = 40131
					order[28] = 40132
					order[29] = 40133
					order[30] = 40134
					order[31] = 40135
					order[32] = 40136
					order[33] = 40137
					order[34] = 40138
					order[35] = 40139
					order[36] = 40140
					order[37] = 40141
					order[38] = 40145
					order[39] = 40146
					order[40] = 40148
					order[41] = 40149
					order[42] = 40150
					order[43] = 40151
					order[44] = 40152
					order[45] = 40153
					order[46] = 40154
					order[47] = 40155
					order[48] = 40156
					order[49] = 40158
					order[50] = 40159
					order[51] = 40160
					order[52] = 40161
					order[53] = 40162
					order[54] = 40101
					order[55] = 40102
					order[56] = 40103
					order[57] = 40104
					order[58] = 40105
					order[59] = 40106
					order[60] = 40107
					order[61] = 40163
					order[62] = 40165
					order[63] = 40166
					order[64] = 40167
					order[65] = 40168
					order[66] = 40169
					order[67] = 40170
					order[68] = 40108
					order[69] = 40109
					order[70] = 40110
					order[71] = 40111
					order[72] = 40112
					order[73] = 41406
					order[74] = 40113
					order[75] = 40986
					order[76] = 40987
					order[77] = 40174
					order[78] = 0
					super(40090, 40091, order)
				end

				class NoProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40094
						order[1] = 0
						super(40957, 40094, order)
					end
				end

				class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40117
						order[1] = 0
						super(40953, 40117, order)
					end
				end

				class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40124
						order[1] = 0
						super(40954, 40124, order)
					end
				end

				class NoProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40143
						order[1] = 40144
						order[2] = 0
						super(40142, 40143, order)
					end
				end

				class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40147
						order[1] = 0
						super(40955, 40147, order)
					end
				end

				class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40157
						order[1] = 0
						super(40956, 40157, order)
					end
				end

				class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40164
						order[1] = 0
						super(40952, 40164, order)
					end
				end

				class NoProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40172
						order[1] = 40173
						order[2] = 0
						super(40171, 40172, order)
					end
				end

				class NoProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40175
						order[1] = 40176
						order[2] = 40177
						order[3] = 2385
						order[4] = 40178
						order[5] = 0
						super(40174, 40175, order)
					end

					class NoProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40179
							order[1] = 40180
							order[2] = 0
							super(40178, 40179, order)
						end
					end
				end
			end

			class NoAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40020
					order[1] = 40021
					order[2] = 40000
					order[3] = 0
					super(40019, 40020, order)
				end

				class NoAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 40001
						order[1] = 40002
						order[2] = 40003
						order[3] = 40004
						order[4] = 40005
						order[5] = 40006
						order[6] = 40007
						order[7] = 40008
						order[8] = 40009
						order[9] = 40010
						order[10] = 40011
						order[11] = 40012
						order[12] = 40013
						order[13] = 40014
						order[14] = 40015
						order[15] = 40016
						order[16] = 40017
						order[17] = 40018
						order[18] = 0
						super(40000, 40001, order)
					end
				end
			end

			class NoProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 40182
					order[1] = 40183
					order[2] = 40184
					order[3] = 40185
					order[4] = 40186
					order[5] = 40187
					order[6] = 40188
					order[7] = 40951
					order[8] = 40191
					order[9] = 40201
					order[10] = 40190
					order[11] = 0
					super(40181, 40182, order)
				end

				class NoProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40189
						order[1] = 0
						super(40951, 40189, order)
					end
				end

				class NoProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 40192
						order[1] = 40193
						order[2] = 40194
						order[3] = 40195
						order[4] = 40196
						order[5] = 40197
						order[6] = 40198
						order[7] = 40199
						order[8] = 0
						super(40191, 40192, order)
					end

					class NoProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40200
							order[1] = 0
							super(40199, 40200, order)
						end
					end
				end

				class NoProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40202
						order[1] = 40203
						order[2] = 0
						super(40201, 40202, order)
					end
				end
			end

			class NoCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 40023
					order[1] = 40024
					order[2] = 40916
					order[3] = 40917
					order[4] = 40025
					order[5] = 40026
					order[6] = 40027
					order[7] = 40028
					order[8] = 40029
					order[9] = 40030
					order[10] = 40031
					order[11] = 40277
					order[12] = 42216
					order[13] = 42217
					order[14] = 40033
					order[15] = 40034
					order[16] = 42207
					order[17] = 42208
					order[18] = 42209
					order[19] = 42210
					order[20] = 42211
					order[21] = 42212
					order[22] = 42213
					order[23] = 40035
					order[24] = 40036
					order[25] = 40037
					order[26] = 40038
					order[27] = 40039
					order[28] = 0
					super(40022, 40023, order)
				end

				class NoCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40032
						order[1] = 0
						super(40277, 40032, order)
					end
				end

				class NoCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42215
						order[1] = 0
						super(42214, 42215, order)
					end
				end
			end

			class NoPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40209
					order[1] = 40205
					order[2] = 40206
					order[3] = 40207
					order[4] = 40208
					order[5] = 0
					super(40204, 40209, order)
				end

				class NoPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40210
						order[1] = 40211
						order[2] = 0
						super(40209, 40210, order)
					end
				end
			end

			class NoExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42297
					order[1] = 42298
					order[2] = 0
					super(42296, 42297, order)
				end
			end

			class NoLegs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(176)
					order[0] = 600
					order[1] = 601
					order[2] = 602
					order[3] = 603
					order[4] = 1788
					order[5] = 607
					order[6] = 1594
					order[7] = 608
					order[8] = 2893
					order[9] = 609
					order[10] = 764
					order[11] = 610
					order[12] = 611
					order[13] = 1212
					order[14] = 2146
					order[15] = 2147
					order[16] = 2148
					order[17] = 248
					order[18] = 2149
					order[19] = 2150
					order[20] = 2151
					order[21] = 2152
					order[22] = 2153
					order[23] = 2154
					order[24] = 2155
					order[25] = 2348
					order[26] = 2067
					order[27] = 2068
					order[28] = 2069
					order[29] = 2739
					order[30] = 2070
					order[31] = 2156
					order[32] = 2157
					order[33] = 2158
					order[34] = 2159
					order[35] = 2160
					order[36] = 2161
					order[37] = 2162
					order[38] = 2163
					order[39] = 2164
					order[40] = 2165
					order[41] = 2880
					order[42] = 2166
					order[43] = 2167
					order[44] = 2168
					order[45] = 2169
					order[46] = 2170
					order[47] = 2171
					order[48] = 2172
					order[49] = 2173
					order[50] = 2174
					order[51] = 2175
					order[52] = 2176
					order[53] = 2177
					order[54] = 2178
					order[55] = 2179
					order[56] = 2180
					order[57] = 249
					order[58] = 250
					order[59] = 251
					order[60] = 252
					order[61] = 253
					order[62] = 257
					order[63] = 599
					order[64] = 596
					order[65] = 597
					order[66] = 598
					order[67] = 254
					order[68] = 612
					order[69] = 942
					order[70] = 2908
					order[71] = 2181
					order[72] = 2182
					order[73] = 2183
					order[74] = 2184
					order[75] = 2604
					order[76] = 2185
					order[77] = 2605
					order[78] = 2186
					order[79] = 2187
					order[80] = 2188
					order[81] = 2189
					order[82] = 613
					order[83] = 614
					order[84] = 1436
					order[85] = 2354
					order[86] = 1440
					order[87] = 2190
					order[88] = 2191
					order[89] = 999
					order[90] = 1224
					order[91] = 1720
					order[92] = 2909
					order[93] = 1421
					order[94] = 1422
					order[95] = 1721
					order[96] = 2910
					order[97] = 2192
					order[98] = 1001
					order[99] = 1420
					order[100] = 2193
					order[101] = 2194
					order[102] = 2755
					order[103] = 2195
					order[104] = 2196
					order[105] = 2197
					order[106] = 2198
					order[107] = 1528
					order[108] = 2911
					order[109] = 2199
					order[110] = 2200
					order[111] = 2201
					order[112] = 2202
					order[113] = 2203
					order[114] = 615
					order[115] = 616
					order[116] = 2205
					order[117] = 2206
					order[118] = 617
					order[119] = 618
					order[120] = 619
					order[121] = 2740
					order[122] = 2717
					order[123] = 2718
					order[124] = 2719
					order[125] = 620
					order[126] = 621
					order[127] = 622
					order[128] = 2207
					order[129] = 2208
					order[130] = 623
					order[131] = 624
					order[132] = 556
					order[133] = 2898
					order[134] = 740
					order[135] = 739
					order[136] = 955
					order[137] = 956
					order[138] = 1358
					order[139] = 2682
					order[140] = 2686
					order[141] = 1017
					order[142] = 566
					order[143] = 2209
					order[144] = 2211
					order[145] = 2212
					order[146] = 2213
					order[147] = 2754
					order[148] = 2214
					order[149] = 2215
					order[150] = 2606
					order[151] = 2607
					order[152] = 2497
					order[153] = 2498
					order[154] = 2499
					order[155] = 2496
					order[156] = 2495
					order[157] = 2953
					order[158] = 2511
					order[159] = 2510
					order[160] = 2512
					order[161] = 2509
					order[162] = 2500
					order[163] = 2502
					order[164] = 2501
					order[165] = 2503
					order[166] = 2507
					order[167] = 2505
					order[168] = 2494
					order[169] = 2493
					order[170] = 2514
					order[171] = 2513
					order[172] = 2506
					order[173] = 2504
					order[174] = 2508
					order[175] = 0
					super(555, 600, order)
				end

				class NoLegSecurityAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 605
						order[1] = 606
						order[2] = 2958
						order[3] = 0
						super(604, 605, order)
					end
				end

				class NoLegSecondaryAssetClasses < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 2077
						order[1] = 2078
						order[2] = 2079
						order[3] = 2743
						order[4] = 0
						super(2076, 2077, order)
					end
				end

				class NoLegAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2309
						order[1] = 2310
						order[2] = 2311
						order[3] = 0
						super(2308, 2309, order)
					end
				end

				class NoLegEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(11)
						order[0] = 2060
						order[1] = 2061
						order[2] = 2062
						order[3] = 2063
						order[4] = 2064
						order[5] = 2341
						order[6] = 2065
						order[7] = 2066
						order[8] = 2074
						order[9] = 2075
						order[10] = 0
						super(2059, 2060, order)
					end
				end

				class NoLegInstrumentParties < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 2255
						order[1] = 2256
						order[2] = 2257
						order[3] = 2379
						order[4] = 2258
						order[5] = 0
						super(2254, 2255, order)
					end

					class NoLegInstrumentPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2259
							order[1] = 2260
							order[2] = 0
							super(2258, 2259, order)
						end
					end
				end

				class NoLegComplexEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(53)
						order[0] = 2219
						order[1] = 2220
						order[2] = 2221
						order[3] = 2222
						order[4] = 2223
						order[5] = 2224
						order[6] = 2225
						order[7] = 2226
						order[8] = 2944
						order[9] = 2227
						order[10] = 2228
						order[11] = 2229
						order[12] = 2230
						order[13] = 2231
						order[14] = 2232
						order[15] = 2250
						order[16] = 2233
						order[17] = 2945
						order[18] = 2234
						order[19] = 2946
						order[20] = 2235
						order[21] = 2236
						order[22] = 2409
						order[23] = 2410
						order[24] = 2237
						order[25] = 2238
						order[26] = 2239
						order[27] = 2240
						order[28] = 2241
						order[29] = 41382
						order[30] = 41389
						order[31] = 41390
						order[32] = 41391
						order[33] = 41392
						order[34] = 41393
						order[35] = 41394
						order[36] = 41395
						order[37] = 41396
						order[38] = 41397
						order[39] = 41379
						order[40] = 2242
						order[41] = 2243
						order[42] = 2244
						order[43] = 2245
						order[44] = 2246
						order[45] = 41398
						order[46] = 41366
						order[47] = 2608
						order[48] = 2609
						order[49] = 2610
						order[50] = 2248
						order[51] = 2249
						order[52] = 0
						super(2218, 2219, order)
					end

					class NoLegComplexEventDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 2251
							order[1] = 2252
							order[2] = 2253
							order[3] = 0
							super(2250, 2251, order)
						end

						class NoLegComplexEventTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 2204
								order[1] = 2247
								order[2] = 0
								super(2253, 2204, order)
							end
						end
					end

					class NoLegComplexEventRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 41383
							order[1] = 41384
							order[2] = 41385
							order[3] = 41386
							order[4] = 0
							super(41382, 41383, order)
						end
					end

					class NoLegComplexEventDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41388
							order[1] = 0
							super(41387, 41388, order)
						end
					end

					class NoLegComplexEventPeriods < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41380
							order[1] = 41381
							order[2] = 41400
							order[3] = 41376
							order[4] = 41363
							order[5] = 0
							super(41379, 41380, order)
						end

						class NoLegComplexEventSchedules < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(6)
								order[0] = 41401
								order[1] = 41402
								order[2] = 41403
								order[3] = 41404
								order[4] = 41405
								order[5] = 0
								super(41400, 41401, order)
							end
						end

						class NoLegComplexEventPeriodDateTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 41377
								order[1] = 41378
								order[2] = 0
								super(41376, 41377, order)
							end
						end

						class NoLegComplexEventAveragingObservations < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 41364
								order[1] = 41365
								order[2] = 0
								super(41363, 41364, order)
							end
						end
					end

					class NoLegComplexEventCreditEventSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41399
							order[1] = 0
							super(41398, 41399, order)
						end
					end

					class NoLegComplexEventCreditEvents < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(9)
							order[0] = 41367
							order[1] = 41368
							order[2] = 41369
							order[3] = 41370
							order[4] = 41371
							order[5] = 41372
							order[6] = 41373
							order[7] = 41374
							order[8] = 0
							super(41366, 41367, order)
						end

						class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 41375
								order[1] = 0
								super(41374, 41375, order)
							end
						end
					end
				end

				class NoLegBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40924
						order[1] = 0
						super(40923, 40924, order)
					end
				end

				class NoLegPricingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41608
						order[1] = 0
						super(41607, 41608, order)
					end
				end

				class NoLegMarketDisruptionEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41468
						order[1] = 40223
						order[2] = 0
						super(41467, 41468, order)
					end
				end

				class NoLegMarketDisruptionFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41470
						order[1] = 40990
						order[2] = 0
						super(41469, 41470, order)
					end
				end

				class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(10)
						order[0] = 41472
						order[1] = 41473
						order[2] = 41474
						order[3] = 41475
						order[4] = 41476
						order[5] = 41477
						order[6] = 41478
						order[7] = 41479
						order[8] = 41480
						order[9] = 0
						super(41471, 41472, order)
					end
				end

				class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42582
						order[1] = 0
						super(42581, 42582, order)
					end
				end

				class NoLegOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41492
						order[1] = 0
						super(41491, 41492, order)
					end
				end

				class NoLegOptionExerciseDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41513
						order[1] = 41514
						order[2] = 0
						super(41512, 41513, order)
					end
				end

				class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41516
						order[1] = 0
						super(41515, 41516, order)
					end
				end

				class NoLegOptionExerciseExpirationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41528
						order[1] = 41529
						order[2] = 0
						super(41527, 41528, order)
					end
				end

				class NoLegStreams < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(135)
						order[0] = 40242
						order[1] = 41700
						order[2] = 40243
						order[3] = 42583
						order[4] = 42584
						order[5] = 40244
						order[6] = 40245
						order[7] = 41702
						order[8] = 40246
						order[9] = 40247
						order[10] = 42585
						order[11] = 42586
						order[12] = 41703
						order[13] = 41704
						order[14] = 41705
						order[15] = 41706
						order[16] = 41707
						order[17] = 41708
						order[18] = 41648
						order[19] = 41649
						order[20] = 41650
						order[21] = 41651
						order[22] = 41652
						order[23] = 41653
						order[24] = 41654
						order[25] = 42588
						order[26] = 41655
						order[27] = 41656
						order[28] = 41657
						order[29] = 41658
						order[30] = 41659
						order[31] = 41660
						order[32] = 41661
						order[33] = 41662
						order[34] = 41663
						order[35] = 41664
						order[36] = 41665
						order[37] = 41666
						order[38] = 41667
						order[39] = 41668
						order[40] = 41669
						order[41] = 41670
						order[42] = 41671
						order[43] = 41672
						order[44] = 41673
						order[45] = 40249
						order[46] = 40250
						order[47] = 40252
						order[48] = 40253
						order[49] = 40254
						order[50] = 40255
						order[51] = 40256
						order[52] = 40257
						order[53] = 40258
						order[54] = 40260
						order[55] = 40261
						order[56] = 40262
						order[57] = 40263
						order[58] = 40264
						order[59] = 41641
						order[60] = 41642
						order[61] = 40265
						order[62] = 40267
						order[63] = 40268
						order[64] = 40270
						order[65] = 40271
						order[66] = 40272
						order[67] = 40273
						order[68] = 40274
						order[69] = 40275
						order[70] = 40276
						order[71] = 41643
						order[72] = 41644
						order[73] = 41645
						order[74] = 40279
						order[75] = 40280
						order[76] = 40281
						order[77] = 42399
						order[78] = 40282
						order[79] = 40283
						order[80] = 43108
						order[81] = 40284
						order[82] = 40285
						order[83] = 40286
						order[84] = 40287
						order[85] = 40288
						order[86] = 42400
						order[87] = 42401
						order[88] = 42402
						order[89] = 42403
						order[90] = 40289
						order[91] = 40290
						order[92] = 40291
						order[93] = 41549
						order[94] = 41550
						order[95] = 41551
						order[96] = 41552
						order[97] = 41553
						order[98] = 41554
						order[99] = 41555
						order[100] = 42404
						order[101] = 40374
						order[102] = 40418
						order[103] = 41429
						order[104] = 41430
						order[105] = 41431
						order[106] = 41432
						order[107] = 41433
						order[108] = 42194
						order[109] = 42195
						order[110] = 41434
						order[111] = 41435
						order[112] = 41436
						order[113] = 41437
						order[114] = 41438
						order[115] = 41219
						order[116] = 41439
						order[117] = 41440
						order[118] = 41441
						order[119] = 41442
						order[120] = 41443
						order[121] = 41444
						order[122] = 41445
						order[123] = 41446
						order[124] = 41447
						order[125] = 41448
						order[126] = 41449
						order[127] = 41450
						order[128] = 41451
						order[129] = 43095
						order[130] = 41408
						order[131] = 40248
						order[132] = 40978
						order[133] = 40979
						order[134] = 0
						super(40241, 40242, order)
					end

					class NoLegStreamCommodityAltIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41675
							order[1] = 41676
							order[2] = 0
							super(41674, 41675, order)
						end
					end

					class NoLegStreamAssetAttributes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41453
							order[1] = 41454
							order[2] = 41455
							order[3] = 0
							super(41452, 41453, order)
						end
					end

					class NoLegStreamCommodityDataSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41678
							order[1] = 41679
							order[2] = 0
							super(41677, 41678, order)
						end
					end

					class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41647
							order[1] = 0
							super(41646, 41647, order)
						end
					end

					class NoLegStreamCommoditySettlPeriods < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(15)
							order[0] = 41687
							order[1] = 41688
							order[2] = 41689
							order[3] = 41690
							order[4] = 41691
							order[5] = 41692
							order[6] = 41693
							order[7] = 41694
							order[8] = 41695
							order[9] = 41696
							order[10] = 41697
							order[11] = 41680
							order[12] = 41698
							order[13] = 41699
							order[14] = 0
							super(41686, 41687, order)
						end

						class NoLegStreamCommoditySettlDays < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41681
								order[1] = 41682
								order[2] = 41683
								order[3] = 0
								super(41680, 41681, order)
							end

							class NoLegStreamCommoditySettlTimes < Quickfix::Group
								def initialize
									order = Quickfix::IntArray.new(4)
									order[0] = 41684
									order[1] = 41685
									order[2] = 41935
									order[3] = 0
									super(41683, 41684, order)
								end
							end
						end
					end

					class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40251
							order[1] = 0
							super(40942, 40251, order)
						end
					end

					class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40259
							order[1] = 0
							super(40943, 40259, order)
						end
					end

					class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40266
							order[1] = 0
							super(40940, 40266, order)
						end
					end

					class NoLegStreamCalculationPeriodDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41639
							order[1] = 41640
							order[2] = 0
							super(41638, 41639, order)
						end
					end

					class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40269
							order[1] = 0
							super(40941, 40269, order)
						end
					end

					class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40293
							order[1] = 0
							super(40930, 40293, order)
						end
					end

					class NoLegPaymentStreamPaymentDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41590
							order[1] = 41591
							order[2] = 0
							super(41589, 41590, order)
						end
					end

					class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40305
							order[1] = 0
							super(40931, 40305, order)
						end
					end

					class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40311
							order[1] = 0
							super(40932, 40311, order)
						end
					end

					class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40318
							order[1] = 0
							super(40933, 40318, order)
						end
					end

					class NoLegPaymentStreamFixingDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42460
							order[1] = 42461
							order[2] = 0
							super(42459, 42460, order)
						end
					end

					class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41562
							order[1] = 0
							super(41561, 41562, order)
						end
					end

					class NoLegPaymentStreamPricingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41597
							order[1] = 41598
							order[2] = 0
							super(41596, 41597, order)
						end
					end

					class NoLegPaymentStreamPricingDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41594
							order[1] = 41595
							order[2] = 0
							super(41593, 41594, order)
						end
					end

					class NoLegPaymentStreamFormulas < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43110
							order[1] = 42486
							order[2] = 42487
							order[3] = 0
							super(42485, 43110, order)
						end
					end

					class NoLegDividendPeriods < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(21)
							order[0] = 42367
							order[1] = 42368
							order[2] = 42369
							order[3] = 42370
							order[4] = 42371
							order[5] = 42372
							order[6] = 42386
							order[7] = 42373
							order[8] = 42374
							order[9] = 42375
							order[10] = 42376
							order[11] = 42377
							order[12] = 42378
							order[13] = 42379
							order[14] = 42380
							order[15] = 42381
							order[16] = 42382
							order[17] = 42383
							order[18] = 42384
							order[19] = 42385
							order[20] = 0
							super(42366, 42367, order)
						end

						class NoLegDividendPeriodBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 42387
								order[1] = 0
								super(42386, 42387, order)
							end
						end
					end

					class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42365
							order[1] = 0
							super(42364, 42365, order)
						end
					end

					class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42311
							order[1] = 0
							super(42310, 42311, order)
						end
					end

					class NoLegReturnRates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(30)
							order[0] = 42535
							order[1] = 42536
							order[2] = 42537
							order[3] = 42538
							order[4] = 42539
							order[5] = 42540
							order[6] = 42564
							order[7] = 42530
							order[8] = 42541
							order[9] = 42542
							order[10] = 42543
							order[11] = 42544
							order[12] = 42545
							order[13] = 42546
							order[14] = 42547
							order[15] = 42548
							order[16] = 42549
							order[17] = 42550
							order[18] = 42551
							order[19] = 42552
							order[20] = 42560
							order[21] = 42553
							order[22] = 42554
							order[23] = 42508
							order[24] = 42555
							order[25] = 42556
							order[26] = 42557
							order[27] = 42558
							order[28] = 42559
							order[29] = 0
							super(42534, 42535, order)
						end

						class NoLegReturnRatePrices < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(5)
								order[0] = 42565
								order[1] = 42566
								order[2] = 42567
								order[3] = 42568
								order[4] = 0
								super(42564, 42565, order)
							end
						end

						class NoLegReturnRateFXConversions < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 42531
								order[1] = 42532
								order[2] = 42533
								order[3] = 0
								super(42530, 42531, order)
							end
						end

						class NoLegReturnRateInformationSources < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 42561
								order[1] = 42562
								order[2] = 42563
								order[3] = 0
								super(42560, 42561, order)
							end
						end

						class NoLegReturnRateDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(24)
								order[0] = 42509
								order[1] = 42571
								order[2] = 42510
								order[3] = 42511
								order[4] = 42512
								order[5] = 42513
								order[6] = 42514
								order[7] = 42515
								order[8] = 42516
								order[9] = 42517
								order[10] = 42518
								order[11] = 42519
								order[12] = 42520
								order[13] = 42521
								order[14] = 42522
								order[15] = 42523
								order[16] = 42524
								order[17] = 42525
								order[18] = 42526
								order[19] = 42527
								order[20] = 42528
								order[21] = 42529
								order[22] = 42569
								order[23] = 0
								super(42508, 42509, order)
							end

							class NoLegReturnRateValuationDates < Quickfix::Group
								def initialize
									order = Quickfix::IntArray.new(3)
									order[0] = 42572
									order[1] = 42573
									order[2] = 0
									super(42571, 42572, order)
								end
							end

							class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
								def initialize
									order = Quickfix::IntArray.new(2)
									order[0] = 42570
									order[1] = 0
									super(42569, 42570, order)
								end
							end
						end
					end

					class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42420
							order[1] = 0
							super(42419, 42420, order)
						end
					end

					class NoLegPaymentStreamCompoundingDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42406
							order[1] = 42407
							order[2] = 0
							super(42405, 42406, order)
						end
					end

					class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40361
							order[1] = 0
							super(40929, 40361, order)
						end
					end

					class NoLegNonDeliverableFixingDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40368
							order[1] = 40369
							order[2] = 0
							super(40367, 40368, order)
						end
					end

					class NoLegSettlRateFallbacks < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 40903
							order[1] = 40366
							order[2] = 40370
							order[3] = 40905
							order[4] = 40906
							order[5] = 0
							super(40902, 40903, order)
						end
					end

					class NoLegPaymentSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(58)
							order[0] = 40375
							order[1] = 41533
							order[2] = 41534
							order[3] = 40376
							order[4] = 40377
							order[5] = 40378
							order[6] = 40379
							order[7] = 40380
							order[8] = 40381
							order[9] = 40382
							order[10] = 40383
							order[11] = 40384
							order[12] = 40385
							order[13] = 41535
							order[14] = 41536
							order[15] = 41537
							order[16] = 41538
							order[17] = 40386
							order[18] = 40387
							order[19] = 40388
							order[20] = 40389
							order[21] = 41539
							order[22] = 41540
							order[23] = 41541
							order[24] = 41542
							order[25] = 40390
							order[26] = 40391
							order[27] = 40392
							order[28] = 40393
							order[29] = 40394
							order[30] = 40395
							order[31] = 40414
							order[32] = 40396
							order[33] = 40397
							order[34] = 40398
							order[35] = 40399
							order[36] = 40927
							order[37] = 40401
							order[38] = 40402
							order[39] = 40403
							order[40] = 41543
							order[41] = 41544
							order[42] = 40404
							order[43] = 41530
							order[44] = 41545
							order[45] = 41546
							order[46] = 41547
							order[47] = 41548
							order[48] = 40405
							order[49] = 40406
							order[50] = 40407
							order[51] = 40408
							order[52] = 40928
							order[53] = 40410
							order[54] = 40411
							order[55] = 40412
							order[56] = 40413
							order[57] = 0
							super(40374, 40375, order)
						end

						class NoLegPaymentScheduleRateSources < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 40415
								order[1] = 40416
								order[2] = 40417
								order[3] = 0
								super(40414, 40415, order)
							end
						end

						class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 40400
								order[1] = 0
								super(40927, 40400, order)
							end
						end

						class NoLegPaymentScheduleFixingDays < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 41531
								order[1] = 41532
								order[2] = 0
								super(41530, 41531, order)
							end
						end

						class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 40409
								order[1] = 0
								super(40928, 40409, order)
							end
						end
					end

					class NoLegPaymentStubs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(44)
							order[0] = 40419
							order[1] = 40420
							order[2] = 42497
							order[3] = 42498
							order[4] = 42499
							order[5] = 42500
							order[6] = 42501
							order[7] = 42502
							order[8] = 42503
							order[9] = 42488
							order[10] = 42489
							order[11] = 42490
							order[12] = 42491
							order[13] = 42492
							order[14] = 42493
							order[15] = 42494
							order[16] = 40421
							order[17] = 40422
							order[18] = 40423
							order[19] = 40424
							order[20] = 40425
							order[21] = 40426
							order[22] = 40427
							order[23] = 40428
							order[24] = 40429
							order[25] = 40430
							order[26] = 40431
							order[27] = 40432
							order[28] = 40433
							order[29] = 40434
							order[30] = 40435
							order[31] = 40436
							order[32] = 40437
							order[33] = 40438
							order[34] = 40439
							order[35] = 40440
							order[36] = 40441
							order[37] = 40442
							order[38] = 40443
							order[39] = 40444
							order[40] = 40445
							order[41] = 40446
							order[42] = 40447
							order[43] = 0
							super(40418, 40419, order)
						end

						class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 42505
								order[1] = 0
								super(42504, 42505, order)
							end
						end

						class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 42496
								order[1] = 0
								super(42495, 42496, order)
							end
						end
					end

					class NoLegDeliveryStreamCommoditySources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41461
							order[1] = 0
							super(41460, 41461, order)
						end
					end

					class NoLegDeliveryStreamCycles < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41457
							order[1] = 41458
							order[2] = 41459
							order[3] = 0
							super(41456, 41457, order)
						end
					end

					class NoLegDeliverySchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(15)
							order[0] = 41409
							order[1] = 41410
							order[2] = 41411
							order[3] = 41412
							order[4] = 41413
							order[5] = 41414
							order[6] = 41415
							order[7] = 41416
							order[8] = 41417
							order[9] = 41418
							order[10] = 41419
							order[11] = 41420
							order[12] = 41421
							order[13] = 41422
							order[14] = 0
							super(41408, 41409, order)
						end

						class NoLegDeliveryScheduleSettlDays < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41423
								order[1] = 41424
								order[2] = 41425
								order[3] = 0
								super(41422, 41423, order)
							end

							class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
								def initialize
									order = Quickfix::IntArray.new(4)
									order[0] = 41426
									order[1] = 41427
									order[2] = 41428
									order[3] = 0
									super(41425, 41426, order)
								end
							end
						end
					end
				end

				class NoLegProvisions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(79)
						order[0] = 40449
						order[1] = 40450
						order[2] = 40451
						order[3] = 40939
						order[4] = 40453
						order[5] = 40454
						order[6] = 40455
						order[7] = 42506
						order[8] = 42507
						order[9] = 40456
						order[10] = 40457
						order[11] = 40458
						order[12] = 40524
						order[13] = 40525
						order[14] = 40526
						order[15] = 40528
						order[16] = 40529
						order[17] = 40530
						order[18] = 40531
						order[19] = 40532
						order[20] = 40476
						order[21] = 40478
						order[22] = 40479
						order[23] = 40480
						order[24] = 40481
						order[25] = 40482
						order[26] = 40483
						order[27] = 40484
						order[28] = 40485
						order[29] = 40486
						order[30] = 40487
						order[31] = 40488
						order[32] = 40489
						order[33] = 40490
						order[34] = 40491
						order[35] = 40492
						order[36] = 40493
						order[37] = 40494
						order[38] = 40498
						order[39] = 40499
						order[40] = 40501
						order[41] = 40502
						order[42] = 40503
						order[43] = 40504
						order[44] = 40505
						order[45] = 40506
						order[46] = 40507
						order[47] = 40508
						order[48] = 40509
						order[49] = 40511
						order[50] = 40512
						order[51] = 40513
						order[52] = 40514
						order[53] = 40515
						order[54] = 40459
						order[55] = 40460
						order[56] = 40461
						order[57] = 40462
						order[58] = 40463
						order[59] = 40464
						order[60] = 40465
						order[61] = 40516
						order[62] = 40518
						order[63] = 40519
						order[64] = 40520
						order[65] = 40521
						order[66] = 40522
						order[67] = 40523
						order[68] = 40466
						order[69] = 40467
						order[70] = 40468
						order[71] = 40469
						order[72] = 40470
						order[73] = 41407
						order[74] = 40472
						order[75] = 40980
						order[76] = 40981
						order[77] = 40533
						order[78] = 0
						super(40448, 40449, order)
					end

					class NoLegProvisionDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40452
							order[1] = 0
							super(40939, 40452, order)
						end
					end

					class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40527
							order[1] = 0
							super(40935, 40527, order)
						end
					end

					class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40477
							order[1] = 0
							super(40936, 40477, order)
						end
					end

					class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40496
							order[1] = 40497
							order[2] = 0
							super(40495, 40496, order)
						end
					end

					class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40500
							order[1] = 0
							super(40937, 40500, order)
						end
					end

					class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40510
							order[1] = 0
							super(40938, 40510, order)
						end
					end

					class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40517
							order[1] = 0
							super(40934, 40517, order)
						end
					end

					class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40474
							order[1] = 40475
							order[2] = 0
							super(40473, 40474, order)
						end
					end

					class NoLegProvisionPartyIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 40534
							order[1] = 40535
							order[2] = 40536
							order[3] = 2380
							order[4] = 40537
							order[5] = 0
							super(40533, 40534, order)
						end

						class NoLegProvisionPartySubIDs < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 40538
								order[1] = 40539
								order[2] = 0
								super(40537, 40538, order)
							end
						end
					end
				end

				class NoLegAdditionalTerms < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41336
						order[1] = 41337
						order[2] = 41316
						order[3] = 0
						super(41335, 41336, order)
					end

					class NoLegAdditionalTermBondRefs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(19)
							order[0] = 41317
							order[1] = 41318
							order[2] = 41319
							order[3] = 41320
							order[4] = 41321
							order[5] = 41322
							order[6] = 41323
							order[7] = 41324
							order[8] = 41325
							order[9] = 41326
							order[10] = 41327
							order[11] = 41328
							order[12] = 41329
							order[13] = 41330
							order[14] = 41331
							order[15] = 41332
							order[16] = 41333
							order[17] = 41334
							order[18] = 0
							super(41316, 41317, order)
						end
					end
				end

				class NoLegProtectionTerms < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(12)
						order[0] = 41618
						order[1] = 41619
						order[2] = 41620
						order[3] = 41621
						order[4] = 41622
						order[5] = 41623
						order[6] = 41624
						order[7] = 41614
						order[8] = 41625
						order[9] = 41635
						order[10] = 41617
						order[11] = 0
						super(41616, 41618, order)
					end

					class NoLegProtectionTermEventNewsSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41615
							order[1] = 0
							super(41614, 41615, order)
						end
					end

					class NoLegProtectionTermEvents < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(9)
							order[0] = 41626
							order[1] = 41627
							order[2] = 41628
							order[3] = 41629
							order[4] = 41630
							order[5] = 41631
							order[6] = 41632
							order[7] = 41633
							order[8] = 0
							super(41625, 41626, order)
						end

						class NoLegProtectionTermEventQualifiers < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 41634
								order[1] = 0
								super(41633, 41634, order)
							end
						end
					end

					class NoLegProtectionTermObligations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41636
							order[1] = 41637
							order[2] = 0
							super(41635, 41636, order)
						end
					end
				end

				class NoLegCashSettlTerms < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(29)
						order[0] = 41345
						order[1] = 41346
						order[2] = 41347
						order[3] = 41348
						order[4] = 41349
						order[5] = 41350
						order[6] = 41351
						order[7] = 41352
						order[8] = 41353
						order[9] = 41354
						order[10] = 41355
						order[11] = 41342
						order[12] = 42308
						order[13] = 42309
						order[14] = 41356
						order[15] = 41357
						order[16] = 42299
						order[17] = 42300
						order[18] = 42301
						order[19] = 42302
						order[20] = 42303
						order[21] = 42304
						order[22] = 42305
						order[23] = 41358
						order[24] = 41359
						order[25] = 41360
						order[26] = 41361
						order[27] = 41362
						order[28] = 0
						super(41344, 41345, order)
					end

					class NoLegCashSettlDealers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41343
							order[1] = 0
							super(41342, 41343, order)
						end
					end

					class NoLegCashSettlDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42307
							order[1] = 0
							super(42306, 42307, order)
						end
					end
				end

				class NoLegPhysicalSettlTerms < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41604
						order[1] = 41601
						order[2] = 41602
						order[3] = 41603
						order[4] = 41600
						order[5] = 0
						super(41599, 41604, order)
					end

					class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41605
							order[1] = 41606
							order[2] = 0
							super(41604, 41605, order)
						end
					end
				end

				class NoLegExtraordinaryEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42389
						order[1] = 42390
						order[2] = 0
						super(42388, 42389, order)
					end
				end

				class NoLegContractualDefinitions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42199
						order[1] = 0
						super(42198, 42199, order)
					end
				end

				class NoLegFinancingTermSupplements < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42201
						order[1] = 42202
						order[2] = 0
						super(42200, 42201, order)
					end
				end

				class NoLegContractualMatrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42204
						order[1] = 42205
						order[2] = 42206
						order[3] = 0
						super(42203, 42204, order)
					end
				end
			end
		end
	end
end

class BusinessMessageReject < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("j") )
	end
end

class BidRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("k") )
	end

	class NoBidDescriptors < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 399
			order[1] = 400
			order[2] = 401
			order[3] = 404
			order[4] = 441
			order[5] = 402
			order[6] = 403
			order[7] = 405
			order[8] = 406
			order[9] = 407
			order[10] = 408
			order[11] = 0
			super(398, 399, order)
		end
	end

	class NoBidComponents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 66
			order[1] = 54
			order[2] = 336
			order[3] = 625
			order[4] = 430
			order[5] = 63
			order[6] = 64
			order[7] = 1
			order[8] = 660
			order[9] = 0
			super(420, 66, order)
		end
	end
end

class BidResponse < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("l") )
	end

	class NoBidComponents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(22)
			order[0] = 12
			order[1] = 13
			order[2] = 479
			order[3] = 2922
			order[4] = 1233
			order[5] = 1238
			order[6] = 497
			order[7] = 66
			order[8] = 421
			order[9] = 54
			order[10] = 44
			order[11] = 423
			order[12] = 406
			order[13] = 430
			order[14] = 63
			order[15] = 64
			order[16] = 336
			order[17] = 625
			order[18] = 58
			order[19] = 354
			order[20] = 355
			order[21] = 0
			super(420, 12, order)
		end
	end
end

class ListStrikePrice < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("m") )
	end

	class NoStrikes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(166)
			order[0] = 55
			order[1] = 65
			order[2] = 48
			order[3] = 22
			order[4] = 460
			order[5] = 1227
			order[6] = 1151
			order[7] = 461
			order[8] = 2891
			order[9] = 167
			order[10] = 762
			order[11] = 200
			order[12] = 541
			order[13] = 1079
			order[14] = 966
			order[15] = 1049
			order[16] = 965
			order[17] = 224
			order[18] = 1449
			order[19] = 1450
			order[20] = 1451
			order[21] = 1452
			order[22] = 1457
			order[23] = 1458
			order[24] = 1739
			order[25] = 2210
			order[26] = 1938
			order[27] = 1939
			order[28] = 1940
			order[29] = 2735
			order[30] = 1941
			order[31] = 1575
			order[32] = 1942
			order[33] = 1943
			order[34] = 1944
			order[35] = 1945
			order[36] = 1946
			order[37] = 1947
			order[38] = 1948
			order[39] = 1949
			order[40] = 1950
			order[41] = 2879
			order[42] = 1951
			order[43] = 1952
			order[44] = 1953
			order[45] = 1954
			order[46] = 1955
			order[47] = 1956
			order[48] = 1957
			order[49] = 1958
			order[50] = 1959
			order[51] = 1960
			order[52] = 1577
			order[53] = 1580
			order[54] = 1581
			order[55] = 1678
			order[56] = 1697
			order[57] = 225
			order[58] = 239
			order[59] = 226
			order[60] = 227
			order[61] = 228
			order[62] = 255
			order[63] = 543
			order[64] = 470
			order[65] = 471
			order[66] = 472
			order[67] = 240
			order[68] = 202
			order[69] = 2578
			order[70] = 2577
			order[71] = 947
			order[72] = 2904
			order[73] = 967
			order[74] = 968
			order[75] = 1698
			order[76] = 1866
			order[77] = 2600
			order[78] = 2001
			order[79] = 2601
			order[80] = 1478
			order[81] = 1479
			order[82] = 1480
			order[83] = 1481
			order[84] = 206
			order[85] = 231
			order[86] = 1435
			order[87] = 2353
			order[88] = 1439
			order[89] = 969
			order[90] = 1146
			order[91] = 996
			order[92] = 1147
			order[93] = 1716
			order[94] = 2905
			order[95] = 1191
			order[96] = 1192
			order[97] = 1717
			order[98] = 2906
			order[99] = 1193
			order[100] = 2579
			order[101] = 1194
			order[102] = 1482
			order[103] = 1195
			order[104] = 2753
			order[105] = 1196
			order[106] = 1197
			order[107] = 2002
			order[108] = 2140
			order[109] = 1524
			order[110] = 2907
			order[111] = 1198
			order[112] = 1199
			order[113] = 1200
			order[114] = 201
			order[115] = 2681
			order[116] = 2685
			order[117] = 1244
			order[118] = 1242
			order[119] = 2575
			order[120] = 2574
			order[121] = 997
			order[122] = 223
			order[123] = 207
			order[124] = 970
			order[125] = 971
			order[126] = 106
			order[127] = 348
			order[128] = 349
			order[129] = 2737
			order[130] = 2714
			order[131] = 2715
			order[132] = 2716
			order[133] = 107
			order[134] = 350
			order[135] = 351
			order[136] = 691
			order[137] = 667
			order[138] = 875
			order[139] = 876
			order[140] = 873
			order[141] = 874
			order[142] = 1687
			order[143] = 1787
			order[144] = 2141
			order[145] = 2142
			order[146] = 2143
			order[147] = 2752
			order[148] = 2144
			order[149] = 2145
			order[150] = 2576
			order[151] = 2962
			order[152] = 2602
			order[153] = 2603
			order[154] = 711
			order[155] = 140
			order[156] = 11
			order[157] = 526
			order[158] = 54
			order[159] = 44
			order[160] = 15
			order[161] = 2897
			order[162] = 58
			order[163] = 354
			order[164] = 355
			order[165] = 0
			super(428, 55, order)
		end

		class NoSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 455
				order[1] = 456
				order[2] = 2957
				order[3] = 0
				super(454, 455, order)
			end
		end

		class NoSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1977
				order[1] = 1978
				order[2] = 1979
				order[3] = 2741
				order[4] = 0
				super(1976, 1977, order)
			end
		end

		class NoAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2305
				order[1] = 2306
				order[2] = 2307
				order[3] = 0
				super(2304, 2305, order)
			end
		end

		class NoEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 865
				order[1] = 866
				order[2] = 1145
				order[3] = 1827
				order[4] = 1826
				order[5] = 2340
				order[6] = 867
				order[7] = 868
				order[8] = 1578
				order[9] = 1579
				order[10] = 0
				super(864, 865, order)
			end
		end

		class NoInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1019
				order[1] = 1050
				order[2] = 1051
				order[3] = 2378
				order[4] = 1052
				order[5] = 0
				super(1018, 1019, order)
			end

			class NoInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1053
					order[1] = 1054
					order[2] = 0
					super(1052, 1053, order)
				end
			end
		end

		class NoComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 1484
				order[1] = 2117
				order[2] = 2118
				order[3] = 2119
				order[4] = 1485
				order[5] = 2120
				order[6] = 2121
				order[7] = 2122
				order[8] = 2941
				order[9] = 1486
				order[10] = 2123
				order[11] = 1487
				order[12] = 1488
				order[13] = 1489
				order[14] = 1490
				order[15] = 1491
				order[16] = 2124
				order[17] = 2942
				order[18] = 2125
				order[19] = 2943
				order[20] = 2126
				order[21] = 2127
				order[22] = 2407
				order[23] = 2408
				order[24] = 2128
				order[25] = 2129
				order[26] = 2130
				order[27] = 2131
				order[28] = 2132
				order[29] = 41013
				order[30] = 41020
				order[31] = 41021
				order[32] = 41022
				order[33] = 41023
				order[34] = 41024
				order[35] = 41025
				order[36] = 41026
				order[37] = 41027
				order[38] = 41028
				order[39] = 41010
				order[40] = 2133
				order[41] = 2134
				order[42] = 2135
				order[43] = 2136
				order[44] = 2137
				order[45] = 41029
				order[46] = 40997
				order[47] = 2597
				order[48] = 2598
				order[49] = 2599
				order[50] = 2138
				order[51] = 2139
				order[52] = 0
				super(1483, 1484, order)
			end

			class NoComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1492
					order[1] = 1493
					order[2] = 1494
					order[3] = 0
					super(1491, 1492, order)
				end

				class NoComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1495
						order[1] = 1496
						order[2] = 0
						super(1494, 1495, order)
					end
				end
			end

			class NoComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41014
					order[1] = 41015
					order[2] = 41016
					order[3] = 41017
					order[4] = 0
					super(41013, 41014, order)
				end
			end

			class NoComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41019
					order[1] = 0
					super(41018, 41019, order)
				end
			end

			class NoComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41011
					order[1] = 41012
					order[2] = 41031
					order[3] = 41007
					order[4] = 40994
					order[5] = 0
					super(41010, 41011, order)
				end

				class NoComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41032
						order[1] = 41033
						order[2] = 41034
						order[3] = 41035
						order[4] = 41036
						order[5] = 0
						super(41031, 41032, order)
					end
				end

				class NoComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41008
						order[1] = 41009
						order[2] = 0
						super(41007, 41008, order)
					end
				end

				class NoComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40995
						order[1] = 40996
						order[2] = 0
						super(40994, 40995, order)
					end
				end
			end

			class NoComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41030
					order[1] = 0
					super(41029, 41030, order)
				end
			end

			class NoComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40998
					order[1] = 40999
					order[2] = 41000
					order[3] = 41001
					order[4] = 41002
					order[5] = 41003
					order[6] = 41004
					order[7] = 41005
					order[8] = 0
					super(40997, 40998, order)
				end

				class NoComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41006
						order[1] = 0
						super(41005, 41006, order)
					end
				end
			end
		end

		class NoBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40471
				order[1] = 0
				super(40278, 40471, order)
			end
		end

		class NoPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41231
				order[1] = 0
				super(41230, 41231, order)
			end
		end

		class NoMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41093
				order[1] = 40991
				order[2] = 0
				super(41092, 41093, order)
			end
		end

		class NoMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41095
				order[1] = 40992
				order[2] = 0
				super(41094, 41095, order)
			end
		end

		class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41097
				order[1] = 41098
				order[2] = 41099
				order[3] = 41100
				order[4] = 41101
				order[5] = 41102
				order[6] = 41103
				order[7] = 41104
				order[8] = 41105
				order[9] = 0
				super(41096, 41097, order)
			end
		end

		class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42776
				order[1] = 0
				super(42775, 42776, order)
			end
		end

		class NoOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41117
				order[1] = 0
				super(41116, 41117, order)
			end
		end

		class NoOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41138
				order[1] = 41139
				order[2] = 0
				super(41137, 41138, order)
			end
		end

		class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41141
				order[1] = 0
				super(41140, 41141, order)
			end
		end

		class NoOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41153
				order[1] = 41154
				order[2] = 0
				super(41152, 41153, order)
			end
		end

		class NoStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40050
				order[1] = 41303
				order[2] = 40051
				order[3] = 42784
				order[4] = 42785
				order[5] = 40052
				order[6] = 40053
				order[7] = 41305
				order[8] = 40054
				order[9] = 40055
				order[10] = 42786
				order[11] = 42787
				order[12] = 41306
				order[13] = 41307
				order[14] = 41308
				order[15] = 41309
				order[16] = 41310
				order[17] = 41311
				order[18] = 41251
				order[19] = 41252
				order[20] = 41253
				order[21] = 41254
				order[22] = 41255
				order[23] = 41256
				order[24] = 41257
				order[25] = 42587
				order[26] = 41258
				order[27] = 41259
				order[28] = 41260
				order[29] = 41261
				order[30] = 41262
				order[31] = 41263
				order[32] = 41264
				order[33] = 41265
				order[34] = 41266
				order[35] = 41267
				order[36] = 41268
				order[37] = 41269
				order[38] = 41270
				order[39] = 41271
				order[40] = 41272
				order[41] = 41273
				order[42] = 41274
				order[43] = 41275
				order[44] = 41276
				order[45] = 40907
				order[46] = 40908
				order[47] = 40910
				order[48] = 40911
				order[49] = 40912
				order[50] = 40913
				order[51] = 40914
				order[52] = 40065
				order[53] = 40066
				order[54] = 40068
				order[55] = 40069
				order[56] = 40070
				order[57] = 40071
				order[58] = 40072
				order[59] = 41244
				order[60] = 41245
				order[61] = 40073
				order[62] = 40075
				order[63] = 40076
				order[64] = 40078
				order[65] = 40079
				order[66] = 40080
				order[67] = 40081
				order[68] = 40082
				order[69] = 40083
				order[70] = 40084
				order[71] = 41246
				order[72] = 41247
				order[73] = 41248
				order[74] = 40738
				order[75] = 40739
				order[76] = 40740
				order[77] = 42600
				order[78] = 40741
				order[79] = 40742
				order[80] = 43106
				order[81] = 40743
				order[82] = 40744
				order[83] = 40745
				order[84] = 40746
				order[85] = 40747
				order[86] = 42601
				order[87] = 42602
				order[88] = 42603
				order[89] = 42604
				order[90] = 40748
				order[91] = 40749
				order[92] = 40750
				order[93] = 41180
				order[94] = 41181
				order[95] = 41182
				order[96] = 41183
				order[97] = 41184
				order[98] = 41185
				order[99] = 41186
				order[100] = 42605
				order[101] = 40828
				order[102] = 40872
				order[103] = 41058
				order[104] = 41059
				order[105] = 41060
				order[106] = 41061
				order[107] = 41062
				order[108] = 42192
				order[109] = 42193
				order[110] = 41063
				order[111] = 41064
				order[112] = 41065
				order[113] = 41066
				order[114] = 41067
				order[115] = 41218
				order[116] = 41068
				order[117] = 41069
				order[118] = 41070
				order[119] = 41071
				order[120] = 41072
				order[121] = 41073
				order[122] = 41074
				order[123] = 41075
				order[124] = 41076
				order[125] = 41077
				order[126] = 41078
				order[127] = 41079
				order[128] = 41080
				order[129] = 43094
				order[130] = 41037
				order[131] = 40056
				order[132] = 40982
				order[133] = 40983
				order[134] = 0
				super(40049, 40050, order)
			end

			class NoStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41278
					order[1] = 41279
					order[2] = 0
					super(41277, 41278, order)
				end
			end

			class NoStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41238
					order[1] = 41239
					order[2] = 41240
					order[3] = 0
					super(41237, 41238, order)
				end
			end

			class NoStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41281
					order[1] = 41282
					order[2] = 0
					super(41280, 41281, order)
				end
			end

			class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41250
					order[1] = 0
					super(41249, 41250, order)
				end
			end

			class NoStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41290
					order[1] = 41291
					order[2] = 41292
					order[3] = 41293
					order[4] = 41294
					order[5] = 41295
					order[6] = 41296
					order[7] = 41297
					order[8] = 41298
					order[9] = 41299
					order[10] = 41300
					order[11] = 41283
					order[12] = 41301
					order[13] = 41302
					order[14] = 0
					super(41289, 41290, order)
				end

				class NoStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41284
						order[1] = 41285
						order[2] = 41286
						order[3] = 0
						super(41283, 41284, order)
					end

					class NoStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41287
							order[1] = 41288
							order[2] = 41588
							order[3] = 0
							super(41286, 41287, order)
						end
					end
				end
			end

			class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40909
					order[1] = 0
					super(40960, 40909, order)
				end
			end

			class NoStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40067
					order[1] = 0
					super(40961, 40067, order)
				end
			end

			class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40074
					order[1] = 0
					super(40958, 40074, order)
				end
			end

			class NoStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41242
					order[1] = 41243
					order[2] = 0
					super(41241, 41242, order)
				end
			end

			class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40077
					order[1] = 0
					super(40959, 40077, order)
				end
			end

			class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40752
					order[1] = 0
					super(40947, 40752, order)
				end
			end

			class NoPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41221
					order[1] = 41222
					order[2] = 0
					super(41220, 41221, order)
				end
			end

			class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40763
					order[1] = 0
					super(40948, 40763, order)
				end
			end

			class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40769
					order[1] = 0
					super(40949, 40769, order)
				end
			end

			class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40776
					order[1] = 0
					super(40950, 40776, order)
				end
			end

			class NoPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42661
					order[1] = 42662
					order[2] = 0
					super(42660, 42661, order)
				end
			end

			class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41193
					order[1] = 0
					super(41192, 41193, order)
				end
			end

			class NoPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41228
					order[1] = 41229
					order[2] = 0
					super(41227, 41228, order)
				end
			end

			class NoPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41225
					order[1] = 41226
					order[2] = 0
					super(41224, 41225, order)
				end
			end

			class NoPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43109
					order[1] = 42684
					order[2] = 42685
					order[3] = 0
					super(42683, 43109, order)
				end
			end

			class NoDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42275
					order[1] = 42276
					order[2] = 42277
					order[3] = 42278
					order[4] = 42279
					order[5] = 42280
					order[6] = 42294
					order[7] = 42281
					order[8] = 42282
					order[9] = 42283
					order[10] = 42284
					order[11] = 42285
					order[12] = 42286
					order[13] = 42287
					order[14] = 42288
					order[15] = 42289
					order[16] = 42290
					order[17] = 42291
					order[18] = 42292
					order[19] = 42293
					order[20] = 0
					super(42274, 42275, order)
				end

				class NoDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42295
						order[1] = 0
						super(42294, 42295, order)
					end
				end
			end

			class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42273
					order[1] = 0
					super(42272, 42273, order)
				end
			end

			class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42237
					order[1] = 0
					super(42236, 42237, order)
				end
			end

			class NoReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42736
					order[1] = 42737
					order[2] = 42738
					order[3] = 42739
					order[4] = 42740
					order[5] = 42741
					order[6] = 42765
					order[7] = 42731
					order[8] = 42742
					order[9] = 42743
					order[10] = 42744
					order[11] = 42745
					order[12] = 42746
					order[13] = 42747
					order[14] = 42748
					order[15] = 42749
					order[16] = 42750
					order[17] = 42751
					order[18] = 42752
					order[19] = 42753
					order[20] = 42761
					order[21] = 42754
					order[22] = 42755
					order[23] = 42709
					order[24] = 42756
					order[25] = 42757
					order[26] = 42758
					order[27] = 42759
					order[28] = 42760
					order[29] = 0
					super(42735, 42736, order)
				end

				class NoReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42766
						order[1] = 42767
						order[2] = 42768
						order[3] = 42769
						order[4] = 0
						super(42765, 42766, order)
					end
				end

				class NoReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42732
						order[1] = 42733
						order[2] = 42734
						order[3] = 0
						super(42731, 42732, order)
					end
				end

				class NoReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42762
						order[1] = 42763
						order[2] = 42764
						order[3] = 0
						super(42761, 42762, order)
					end
				end

				class NoReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42710
						order[1] = 42772
						order[2] = 42711
						order[3] = 42712
						order[4] = 42713
						order[5] = 42714
						order[6] = 42715
						order[7] = 42716
						order[8] = 42717
						order[9] = 42718
						order[10] = 42719
						order[11] = 42720
						order[12] = 42721
						order[13] = 42722
						order[14] = 42723
						order[15] = 42724
						order[16] = 42725
						order[17] = 42726
						order[18] = 42727
						order[19] = 42728
						order[20] = 42729
						order[21] = 42730
						order[22] = 42770
						order[23] = 0
						super(42709, 42710, order)
					end

					class NoReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42773
							order[1] = 42774
							order[2] = 0
							super(42772, 42773, order)
						end
					end

					class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42771
							order[1] = 0
							super(42770, 42771, order)
						end
					end
				end
			end

			class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42621
					order[1] = 0
					super(42620, 42621, order)
				end
			end

			class NoPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42607
					order[1] = 42608
					order[2] = 0
					super(42606, 42607, order)
				end
			end

			class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40819
					order[1] = 0
					super(40946, 40819, order)
				end
			end

			class NoNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40826
					order[1] = 40827
					order[2] = 0
					super(40825, 40826, order)
				end
			end

			class NoSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40086
					order[1] = 40373
					order[2] = 40655
					order[3] = 40088
					order[4] = 40089
					order[5] = 0
					super(40085, 40086, order)
				end
			end

			class NoPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40829
					order[1] = 41164
					order[2] = 41165
					order[3] = 40830
					order[4] = 40831
					order[5] = 40832
					order[6] = 40833
					order[7] = 40834
					order[8] = 40835
					order[9] = 40836
					order[10] = 40837
					order[11] = 40838
					order[12] = 40839
					order[13] = 41166
					order[14] = 41167
					order[15] = 41168
					order[16] = 41169
					order[17] = 40840
					order[18] = 40841
					order[19] = 40842
					order[20] = 40843
					order[21] = 41170
					order[22] = 41171
					order[23] = 41172
					order[24] = 41173
					order[25] = 40844
					order[26] = 40845
					order[27] = 40846
					order[28] = 40847
					order[29] = 40848
					order[30] = 40849
					order[31] = 40868
					order[32] = 40850
					order[33] = 40851
					order[34] = 40852
					order[35] = 40853
					order[36] = 40977
					order[37] = 40855
					order[38] = 40856
					order[39] = 40857
					order[40] = 41174
					order[41] = 41175
					order[42] = 40858
					order[43] = 41161
					order[44] = 41176
					order[45] = 41177
					order[46] = 41178
					order[47] = 41179
					order[48] = 40859
					order[49] = 40860
					order[50] = 40861
					order[51] = 40862
					order[52] = 40945
					order[53] = 40864
					order[54] = 40865
					order[55] = 40866
					order[56] = 40867
					order[57] = 0
					super(40828, 40829, order)
				end

				class NoPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40869
						order[1] = 40870
						order[2] = 40871
						order[3] = 0
						super(40868, 40869, order)
					end
				end

				class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40854
						order[1] = 0
						super(40977, 40854, order)
					end
				end

				class NoPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41162
						order[1] = 41163
						order[2] = 0
						super(41161, 41162, order)
					end
				end

				class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40863
						order[1] = 0
						super(40945, 40863, order)
					end
				end
			end

			class NoPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40873
					order[1] = 40874
					order[2] = 42698
					order[3] = 42699
					order[4] = 42700
					order[5] = 42701
					order[6] = 42702
					order[7] = 42703
					order[8] = 42704
					order[9] = 42689
					order[10] = 42690
					order[11] = 42691
					order[12] = 42692
					order[13] = 42693
					order[14] = 42694
					order[15] = 42695
					order[16] = 40875
					order[17] = 40876
					order[18] = 40877
					order[19] = 40878
					order[20] = 40879
					order[21] = 40880
					order[22] = 40881
					order[23] = 40882
					order[24] = 40883
					order[25] = 40884
					order[26] = 40885
					order[27] = 40886
					order[28] = 40887
					order[29] = 40888
					order[30] = 40889
					order[31] = 40890
					order[32] = 40891
					order[33] = 40892
					order[34] = 40893
					order[35] = 40894
					order[36] = 40895
					order[37] = 40896
					order[38] = 40897
					order[39] = 40898
					order[40] = 40899
					order[41] = 40900
					order[42] = 40901
					order[43] = 0
					super(40872, 40873, order)
				end

				class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42706
						order[1] = 0
						super(42705, 42706, order)
					end
				end

				class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42697
						order[1] = 0
						super(42696, 42697, order)
					end
				end
			end

			class NoDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41086
					order[1] = 0
					super(41085, 41086, order)
				end
			end

			class NoDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41082
					order[1] = 41083
					order[2] = 41084
					order[3] = 0
					super(41081, 41082, order)
				end
			end

			class NoDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41038
					order[1] = 41039
					order[2] = 41040
					order[3] = 41041
					order[4] = 41042
					order[5] = 41043
					order[6] = 41044
					order[7] = 41045
					order[8] = 41046
					order[9] = 41047
					order[10] = 41048
					order[11] = 41049
					order[12] = 41050
					order[13] = 41051
					order[14] = 0
					super(41037, 41038, order)
				end

				class NoDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41052
						order[1] = 41053
						order[2] = 41054
						order[3] = 0
						super(41051, 41052, order)
					end

					class NoDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41055
							order[1] = 41056
							order[2] = 41057
							order[3] = 0
							super(41054, 41055, order)
						end
					end
				end
			end
		end

		class NoProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40091
				order[1] = 40092
				order[2] = 40093
				order[3] = 40957
				order[4] = 40095
				order[5] = 40096
				order[6] = 40097
				order[7] = 42707
				order[8] = 42708
				order[9] = 40098
				order[10] = 40099
				order[11] = 40100
				order[12] = 40114
				order[13] = 40115
				order[14] = 40116
				order[15] = 40118
				order[16] = 40119
				order[17] = 40120
				order[18] = 40121
				order[19] = 40122
				order[20] = 40123
				order[21] = 40125
				order[22] = 40126
				order[23] = 40127
				order[24] = 40128
				order[25] = 40129
				order[26] = 40130
				order[27] = 40131
				order[28] = 40132
				order[29] = 40133
				order[30] = 40134
				order[31] = 40135
				order[32] = 40136
				order[33] = 40137
				order[34] = 40138
				order[35] = 40139
				order[36] = 40140
				order[37] = 40141
				order[38] = 40145
				order[39] = 40146
				order[40] = 40148
				order[41] = 40149
				order[42] = 40150
				order[43] = 40151
				order[44] = 40152
				order[45] = 40153
				order[46] = 40154
				order[47] = 40155
				order[48] = 40156
				order[49] = 40158
				order[50] = 40159
				order[51] = 40160
				order[52] = 40161
				order[53] = 40162
				order[54] = 40101
				order[55] = 40102
				order[56] = 40103
				order[57] = 40104
				order[58] = 40105
				order[59] = 40106
				order[60] = 40107
				order[61] = 40163
				order[62] = 40165
				order[63] = 40166
				order[64] = 40167
				order[65] = 40168
				order[66] = 40169
				order[67] = 40170
				order[68] = 40108
				order[69] = 40109
				order[70] = 40110
				order[71] = 40111
				order[72] = 40112
				order[73] = 41406
				order[74] = 40113
				order[75] = 40986
				order[76] = 40987
				order[77] = 40174
				order[78] = 0
				super(40090, 40091, order)
			end

			class NoProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40094
					order[1] = 0
					super(40957, 40094, order)
				end
			end

			class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40117
					order[1] = 0
					super(40953, 40117, order)
				end
			end

			class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40124
					order[1] = 0
					super(40954, 40124, order)
				end
			end

			class NoProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40143
					order[1] = 40144
					order[2] = 0
					super(40142, 40143, order)
				end
			end

			class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40147
					order[1] = 0
					super(40955, 40147, order)
				end
			end

			class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40157
					order[1] = 0
					super(40956, 40157, order)
				end
			end

			class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40164
					order[1] = 0
					super(40952, 40164, order)
				end
			end

			class NoProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40172
					order[1] = 40173
					order[2] = 0
					super(40171, 40172, order)
				end
			end

			class NoProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40175
					order[1] = 40176
					order[2] = 40177
					order[3] = 2385
					order[4] = 40178
					order[5] = 0
					super(40174, 40175, order)
				end

				class NoProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40179
						order[1] = 40180
						order[2] = 0
						super(40178, 40179, order)
					end
				end
			end
		end

		class NoAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40020
				order[1] = 40021
				order[2] = 40000
				order[3] = 0
				super(40019, 40020, order)
			end

			class NoAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 40001
					order[1] = 40002
					order[2] = 40003
					order[3] = 40004
					order[4] = 40005
					order[5] = 40006
					order[6] = 40007
					order[7] = 40008
					order[8] = 40009
					order[9] = 40010
					order[10] = 40011
					order[11] = 40012
					order[12] = 40013
					order[13] = 40014
					order[14] = 40015
					order[15] = 40016
					order[16] = 40017
					order[17] = 40018
					order[18] = 0
					super(40000, 40001, order)
				end
			end
		end

		class NoProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 40182
				order[1] = 40183
				order[2] = 40184
				order[3] = 40185
				order[4] = 40186
				order[5] = 40187
				order[6] = 40188
				order[7] = 40951
				order[8] = 40191
				order[9] = 40201
				order[10] = 40190
				order[11] = 0
				super(40181, 40182, order)
			end

			class NoProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40189
					order[1] = 0
					super(40951, 40189, order)
				end
			end

			class NoProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40192
					order[1] = 40193
					order[2] = 40194
					order[3] = 40195
					order[4] = 40196
					order[5] = 40197
					order[6] = 40198
					order[7] = 40199
					order[8] = 0
					super(40191, 40192, order)
				end

				class NoProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40200
						order[1] = 0
						super(40199, 40200, order)
					end
				end
			end

			class NoProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40202
					order[1] = 40203
					order[2] = 0
					super(40201, 40202, order)
				end
			end
		end

		class NoCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 40023
				order[1] = 40024
				order[2] = 40916
				order[3] = 40917
				order[4] = 40025
				order[5] = 40026
				order[6] = 40027
				order[7] = 40028
				order[8] = 40029
				order[9] = 40030
				order[10] = 40031
				order[11] = 40277
				order[12] = 42216
				order[13] = 42217
				order[14] = 40033
				order[15] = 40034
				order[16] = 42207
				order[17] = 42208
				order[18] = 42209
				order[19] = 42210
				order[20] = 42211
				order[21] = 42212
				order[22] = 42213
				order[23] = 40035
				order[24] = 40036
				order[25] = 40037
				order[26] = 40038
				order[27] = 40039
				order[28] = 0
				super(40022, 40023, order)
			end

			class NoCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40032
					order[1] = 0
					super(40277, 40032, order)
				end
			end

			class NoCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42215
					order[1] = 0
					super(42214, 42215, order)
				end
			end
		end

		class NoPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40209
				order[1] = 40205
				order[2] = 40206
				order[3] = 40207
				order[4] = 40208
				order[5] = 0
				super(40204, 40209, order)
			end

			class NoPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40210
					order[1] = 40211
					order[2] = 0
					super(40209, 40210, order)
				end
			end
		end

		class NoExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42297
				order[1] = 42298
				order[2] = 0
				super(42296, 42297, order)
			end
		end

		class NoUnderlyings < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(188)
				order[0] = 311
				order[1] = 312
				order[2] = 309
				order[3] = 305
				order[4] = 2874
				order[5] = 462
				order[6] = 463
				order[7] = 2894
				order[8] = 310
				order[9] = 763
				order[10] = 313
				order[11] = 542
				order[12] = 1213
				order[13] = 1837
				order[14] = 241
				order[15] = 1453
				order[16] = 1454
				order[17] = 2614
				order[18] = 2615
				order[19] = 2921
				order[20] = 2616
				order[21] = 2617
				order[22] = 2619
				order[23] = 1455
				order[24] = 1456
				order[25] = 1459
				order[26] = 1460
				order[27] = 242
				order[28] = 243
				order[29] = 244
				order[30] = 245
				order[31] = 246
				order[32] = 256
				order[33] = 595
				order[34] = 592
				order[35] = 593
				order[36] = 594
				order[37] = 247
				order[38] = 316
				order[39] = 941
				order[40] = 2917
				order[41] = 317
				order[42] = 436
				order[43] = 1437
				order[44] = 2363
				order[45] = 1441
				order[46] = 998
				order[47] = 1423
				order[48] = 1718
				order[49] = 2918
				order[50] = 1424
				order[51] = 1425
				order[52] = 1719
				order[53] = 2919
				order[54] = 1000
				order[55] = 1419
				order[56] = 1526
				order[57] = 2920
				order[58] = 435
				order[59] = 308
				order[60] = 306
				order[61] = 362
				order[62] = 363
				order[63] = 2742
				order[64] = 2720
				order[65] = 2721
				order[66] = 2722
				order[67] = 2723
				order[68] = 2724
				order[69] = 307
				order[70] = 364
				order[71] = 365
				order[72] = 877
				order[73] = 878
				order[74] = 972
				order[75] = 318
				order[76] = 2916
				order[77] = 879
				order[78] = 975
				order[79] = 973
				order[80] = 974
				order[81] = 810
				order[82] = 882
				order[83] = 883
				order[84] = 884
				order[85] = 885
				order[86] = 886
				order[87] = 2885
				order[88] = 2886
				order[89] = 1044
				order[90] = 1045
				order[91] = 1046
				order[92] = 1038
				order[93] = 1039
				order[94] = 315
				order[95] = 2683
				order[96] = 2687
				order[97] = 1988
				order[98] = 1989
				order[99] = 1990
				order[100] = 1991
				order[101] = 1992
				order[102] = 1993
				order[103] = 2881
				order[104] = 1994
				order[105] = 1995
				order[106] = 1996
				order[107] = 1997
				order[108] = 2620
				order[109] = 2621
				order[110] = 1998
				order[111] = 1999
				order[112] = 2000
				order[113] = 2003
				order[114] = 2004
				order[115] = 2005
				order[116] = 2006
				order[117] = 2284
				order[118] = 2285
				order[119] = 2286
				order[120] = 2287
				order[121] = 2288
				order[122] = 2007
				order[123] = 2008
				order[124] = 2009
				order[125] = 2010
				order[126] = 2011
				order[127] = 2012
				order[128] = 2491
				order[129] = 2013
				order[130] = 2014
				order[131] = 2015
				order[132] = 2744
				order[133] = 2016
				order[134] = 2289
				order[135] = 2017
				order[136] = 2018
				order[137] = 2019
				order[138] = 2020
				order[139] = 2021
				order[140] = 2022
				order[141] = 2290
				order[142] = 2622
				order[143] = 2291
				order[144] = 2623
				order[145] = 2292
				order[146] = 2023
				order[147] = 2024
				order[148] = 2025
				order[149] = 2026
				order[150] = 2027
				order[151] = 2028
				order[152] = 2029
				order[153] = 2757
				order[154] = 2030
				order[155] = 2031
				order[156] = 2293
				order[157] = 2294
				order[158] = 2032
				order[159] = 2033
				order[160] = 2034
				order[161] = 2035
				order[162] = 2036
				order[163] = 2037
				order[164] = 2038
				order[165] = 2039
				order[166] = 2040
				order[167] = 2041
				order[168] = 2042
				order[169] = 2043
				order[170] = 2044
				order[171] = 41314
				order[172] = 41315
				order[173] = 2295
				order[174] = 2296
				order[175] = 2297
				order[176] = 2756
				order[177] = 2298
				order[178] = 2299
				order[179] = 2624
				order[180] = 2625
				order[181] = 2626
				order[182] = 2627
				order[183] = 2628
				order[184] = 2629
				order[185] = 2630
				order[186] = 2631
				order[187] = 0
				super(711, 311, order)
			end

			class NoUnderlyingSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 458
					order[1] = 459
					order[2] = 2959
					order[3] = 0
					super(457, 458, order)
				end
			end

			class NoUnderlyingStips < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 888
					order[1] = 889
					order[2] = 0
					super(887, 888, order)
				end
			end

			class NoUndlyInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 1059
					order[1] = 1060
					order[2] = 1061
					order[3] = 2391
					order[4] = 1062
					order[5] = 0
					super(1058, 1059, order)
				end

				class NoUndlyInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1063
						order[1] = 1064
						order[2] = 0
						super(1062, 1063, order)
					end
				end
			end

			class NoUnderlyingEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 1982
					order[1] = 1983
					order[2] = 1984
					order[3] = 1985
					order[4] = 1986
					order[5] = 2342
					order[6] = 1987
					order[7] = 2071
					order[8] = 2072
					order[9] = 2073
					order[10] = 0
					super(1981, 1982, order)
				end
			end

			class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2081
					order[1] = 2082
					order[2] = 2083
					order[3] = 2745
					order[4] = 0
					super(2080, 2081, order)
				end
			end

			class NoUnderlyingAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2313
					order[1] = 2314
					order[2] = 2315
					order[3] = 0
					super(2312, 2313, order)
				end
			end

			class NoUnderlyingComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2046
					order[1] = 2261
					order[2] = 2262
					order[3] = 2263
					order[4] = 2047
					order[5] = 2264
					order[6] = 2265
					order[7] = 2266
					order[8] = 2947
					order[9] = 2048
					order[10] = 2267
					order[11] = 2049
					order[12] = 2050
					order[13] = 2051
					order[14] = 2052
					order[15] = 2053
					order[16] = 2268
					order[17] = 2948
					order[18] = 2269
					order[19] = 2949
					order[20] = 2270
					order[21] = 2271
					order[22] = 2419
					order[23] = 2420
					order[24] = 2272
					order[25] = 2273
					order[26] = 2274
					order[27] = 2275
					order[28] = 2276
					order[29] = 41732
					order[30] = 41739
					order[31] = 41740
					order[32] = 41741
					order[33] = 41742
					order[34] = 41743
					order[35] = 41744
					order[36] = 41745
					order[37] = 41746
					order[38] = 41747
					order[39] = 41729
					order[40] = 2277
					order[41] = 2278
					order[42] = 2279
					order[43] = 2280
					order[44] = 2281
					order[45] = 41748
					order[46] = 41716
					order[47] = 2611
					order[48] = 2612
					order[49] = 2613
					order[50] = 2282
					order[51] = 2283
					order[52] = 0
					super(2045, 2046, order)
				end

				class NoUnderlyingComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2054
						order[1] = 2055
						order[2] = 2056
						order[3] = 0
						super(2053, 2054, order)
					end

					class NoUnderlyingComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2057
							order[1] = 2058
							order[2] = 0
							super(2056, 2057, order)
						end
					end
				end

				class NoUnderlyingComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41733
						order[1] = 41734
						order[2] = 41735
						order[3] = 41736
						order[4] = 0
						super(41732, 41733, order)
					end
				end

				class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41738
						order[1] = 0
						super(41737, 41738, order)
					end
				end

				class NoUnderlyingComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41730
						order[1] = 41731
						order[2] = 41750
						order[3] = 41726
						order[4] = 41713
						order[5] = 0
						super(41729, 41730, order)
					end

					class NoUnderlyingComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41751
							order[1] = 41752
							order[2] = 41753
							order[3] = 41754
							order[4] = 41755
							order[5] = 0
							super(41750, 41751, order)
						end
					end

					class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41727
							order[1] = 41728
							order[2] = 0
							super(41726, 41727, order)
						end
					end

					class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41714
							order[1] = 41715
							order[2] = 0
							super(41713, 41714, order)
						end
					end
				end

				class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41749
						order[1] = 0
						super(41748, 41749, order)
					end
				end

				class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41717
						order[1] = 41718
						order[2] = 41719
						order[3] = 41720
						order[4] = 41721
						order[5] = 41722
						order[6] = 41723
						order[7] = 41724
						order[8] = 0
						super(41716, 41717, order)
					end

					class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41725
							order[1] = 0
							super(41724, 41725, order)
						end
					end
				end
			end

			class NoUnderlyingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40963
					order[1] = 0
					super(40962, 40963, order)
				end
			end

			class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41948
					order[1] = 0
					super(41947, 41948, order)
				end
			end

			class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41865
					order[1] = 41338
					order[2] = 0
					super(41864, 41865, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41867
					order[1] = 41339
					order[2] = 0
					super(41866, 41867, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41869
					order[1] = 41870
					order[2] = 41871
					order[3] = 41872
					order[4] = 41873
					order[5] = 41874
					order[6] = 41875
					order[7] = 41876
					order[8] = 41877
					order[9] = 0
					super(41868, 41869, order)
				end
			end

			class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 43075
					order[1] = 0
					super(43074, 43075, order)
				end
			end

			class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41821
					order[1] = 0
					super(41820, 41821, order)
				end
			end

			class NoUnderlyingOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41842
					order[1] = 41843
					order[2] = 0
					super(41841, 41842, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41845
					order[1] = 0
					super(41844, 41845, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41857
					order[1] = 41858
					order[2] = 0
					super(41856, 41857, order)
				end
			end

			class NoUnderlyingStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40541
					order[1] = 42016
					order[2] = 40542
					order[3] = 43083
					order[4] = 43084
					order[5] = 40543
					order[6] = 40544
					order[7] = 42018
					order[8] = 40545
					order[9] = 40546
					order[10] = 43085
					order[11] = 43086
					order[12] = 42019
					order[13] = 42020
					order[14] = 42021
					order[15] = 42022
					order[16] = 42023
					order[17] = 42024
					order[18] = 41964
					order[19] = 41965
					order[20] = 41966
					order[21] = 41967
					order[22] = 41968
					order[23] = 41969
					order[24] = 41970
					order[25] = 42589
					order[26] = 41971
					order[27] = 41972
					order[28] = 41973
					order[29] = 41974
					order[30] = 41975
					order[31] = 41976
					order[32] = 41977
					order[33] = 41978
					order[34] = 41979
					order[35] = 41980
					order[36] = 41981
					order[37] = 41982
					order[38] = 41983
					order[39] = 41984
					order[40] = 41985
					order[41] = 41986
					order[42] = 41987
					order[43] = 41988
					order[44] = 41989
					order[45] = 40057
					order[46] = 40058
					order[47] = 40060
					order[48] = 40061
					order[49] = 40062
					order[50] = 40063
					order[51] = 40064
					order[52] = 40548
					order[53] = 40549
					order[54] = 40551
					order[55] = 40552
					order[56] = 40553
					order[57] = 40554
					order[58] = 40555
					order[59] = 41957
					order[60] = 41958
					order[61] = 40556
					order[62] = 40558
					order[63] = 40559
					order[64] = 40561
					order[65] = 40562
					order[66] = 40563
					order[67] = 40564
					order[68] = 40565
					order[69] = 40566
					order[70] = 40567
					order[71] = 41959
					order[72] = 41960
					order[73] = 41961
					order[74] = 40568
					order[75] = 40569
					order[76] = 40570
					order[77] = 42895
					order[78] = 40571
					order[79] = 40572
					order[80] = 43107
					order[81] = 40573
					order[82] = 40574
					order[83] = 40575
					order[84] = 40576
					order[85] = 40577
					order[86] = 42896
					order[87] = 42897
					order[88] = 42898
					order[89] = 42899
					order[90] = 40578
					order[91] = 40579
					order[92] = 40580
					order[93] = 41897
					order[94] = 41898
					order[95] = 41899
					order[96] = 41900
					order[97] = 41901
					order[98] = 41902
					order[99] = 41903
					order[100] = 42900
					order[101] = 40664
					order[102] = 40708
					order[103] = 41777
					order[104] = 41778
					order[105] = 41779
					order[106] = 41780
					order[107] = 41781
					order[108] = 42196
					order[109] = 42197
					order[110] = 41782
					order[111] = 41783
					order[112] = 41784
					order[113] = 41785
					order[114] = 41786
					order[115] = 41587
					order[116] = 41787
					order[117] = 41788
					order[118] = 41789
					order[119] = 41790
					order[120] = 41791
					order[121] = 41792
					order[122] = 41793
					order[123] = 41794
					order[124] = 41795
					order[125] = 41796
					order[126] = 41797
					order[127] = 41798
					order[128] = 41799
					order[129] = 43096
					order[130] = 41756
					order[131] = 40547
					order[132] = 40988
					order[133] = 40989
					order[134] = 0
					super(40540, 40541, order)
				end

				class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41991
						order[1] = 41992
						order[2] = 0
						super(41990, 41991, order)
					end
				end

				class NoUnderlyingStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41801
						order[1] = 41802
						order[2] = 41803
						order[3] = 0
						super(41800, 41801, order)
					end
				end

				class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41994
						order[1] = 41995
						order[2] = 0
						super(41993, 41994, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41963
						order[1] = 0
						super(41962, 41963, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 42003
						order[1] = 42004
						order[2] = 42005
						order[3] = 42006
						order[4] = 42007
						order[5] = 42008
						order[6] = 42009
						order[7] = 42010
						order[8] = 42011
						order[9] = 42012
						order[10] = 42013
						order[11] = 41996
						order[12] = 42014
						order[13] = 42015
						order[14] = 0
						super(42002, 42003, order)
					end

					class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41997
							order[1] = 41998
							order[2] = 41999
							order[3] = 0
							super(41996, 41997, order)
						end

						class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 42000
								order[1] = 42001
								order[2] = 41936
								order[3] = 0
								super(41999, 42000, order)
							end
						end
					end
				end

				class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40059
						order[1] = 0
						super(40975, 40059, order)
					end
				end

				class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40550
						order[1] = 0
						super(40976, 40550, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40557
						order[1] = 0
						super(40973, 40557, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41955
						order[1] = 41956
						order[2] = 0
						super(41954, 41955, order)
					end
				end

				class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40560
						order[1] = 0
						super(40974, 40560, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40582
						order[1] = 0
						super(40969, 40582, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41938
						order[1] = 41939
						order[2] = 0
						super(41937, 41938, order)
					end
				end

				class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40594
						order[1] = 0
						super(40970, 40594, order)
					end
				end

				class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40600
						order[1] = 0
						super(40971, 40600, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40607
						order[1] = 0
						super(40972, 40607, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42956
						order[1] = 42957
						order[2] = 0
						super(42955, 42956, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41910
						order[1] = 0
						super(41909, 41910, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41945
						order[1] = 41946
						order[2] = 0
						super(41944, 41945, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41942
						order[1] = 41943
						order[2] = 0
						super(41941, 41942, order)
					end
				end

				class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43111
						order[1] = 42982
						order[2] = 42983
						order[3] = 0
						super(42981, 43111, order)
					end
				end

				class NoUnderlyingDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42863
						order[1] = 42864
						order[2] = 42865
						order[3] = 42866
						order[4] = 42867
						order[5] = 42868
						order[6] = 42882
						order[7] = 42869
						order[8] = 42870
						order[9] = 42871
						order[10] = 42872
						order[11] = 42873
						order[12] = 42874
						order[13] = 42875
						order[14] = 42876
						order[15] = 42877
						order[16] = 42878
						order[17] = 42879
						order[18] = 42880
						order[19] = 42881
						order[20] = 0
						super(42862, 42863, order)
					end

					class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42883
							order[1] = 0
							super(42882, 42883, order)
						end
					end
				end

				class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42854
						order[1] = 0
						super(42853, 42854, order)
					end
				end

				class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42800
						order[1] = 0
						super(42799, 42800, order)
					end
				end

				class NoUnderlyingReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 43035
						order[1] = 43036
						order[2] = 43037
						order[3] = 43038
						order[4] = 43039
						order[5] = 43040
						order[6] = 43064
						order[7] = 43030
						order[8] = 43041
						order[9] = 43042
						order[10] = 43043
						order[11] = 43044
						order[12] = 43045
						order[13] = 43046
						order[14] = 43047
						order[15] = 43048
						order[16] = 43049
						order[17] = 43050
						order[18] = 43051
						order[19] = 43052
						order[20] = 43060
						order[21] = 43053
						order[22] = 43054
						order[23] = 43008
						order[24] = 43055
						order[25] = 43056
						order[26] = 43057
						order[27] = 43058
						order[28] = 43059
						order[29] = 0
						super(43034, 43035, order)
					end

					class NoUnderlyingReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 43065
							order[1] = 43066
							order[2] = 43067
							order[3] = 43068
							order[4] = 0
							super(43064, 43065, order)
						end
					end

					class NoUnderlyingReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43031
							order[1] = 43032
							order[2] = 43033
							order[3] = 0
							super(43030, 43031, order)
						end
					end

					class NoUnderlyingReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43061
							order[1] = 43062
							order[2] = 43063
							order[3] = 0
							super(43060, 43061, order)
						end
					end

					class NoUnderlyingReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 43009
							order[1] = 43071
							order[2] = 43010
							order[3] = 43011
							order[4] = 43012
							order[5] = 43013
							order[6] = 43014
							order[7] = 43015
							order[8] = 43016
							order[9] = 43017
							order[10] = 43018
							order[11] = 43019
							order[12] = 43020
							order[13] = 43021
							order[14] = 43022
							order[15] = 43023
							order[16] = 43024
							order[17] = 43025
							order[18] = 43026
							order[19] = 43027
							order[20] = 43028
							order[21] = 43029
							order[22] = 43069
							order[23] = 0
							super(43008, 43009, order)
						end

						class NoUnderlyingReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 43072
								order[1] = 43073
								order[2] = 0
								super(43071, 43072, order)
							end
						end

						class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 43070
								order[1] = 0
								super(43069, 43070, order)
							end
						end
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42916
						order[1] = 0
						super(42915, 42916, order)
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42902
						order[1] = 42903
						order[2] = 0
						super(42901, 42902, order)
					end
				end

				class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40650
						order[1] = 0
						super(40968, 40650, order)
					end
				end

				class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40657
						order[1] = 40658
						order[2] = 0
						super(40656, 40657, order)
					end
				end

				class NoUnderlyingSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40660
						order[1] = 40904
						order[2] = 40915
						order[3] = 40662
						order[4] = 40663
						order[5] = 0
						super(40659, 40660, order)
					end
				end

				class NoUnderlyingPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40665
						order[1] = 41881
						order[2] = 41882
						order[3] = 40666
						order[4] = 40667
						order[5] = 40668
						order[6] = 40669
						order[7] = 40670
						order[8] = 40671
						order[9] = 40672
						order[10] = 40673
						order[11] = 40674
						order[12] = 40675
						order[13] = 41883
						order[14] = 41884
						order[15] = 41885
						order[16] = 41886
						order[17] = 40676
						order[18] = 40677
						order[19] = 40678
						order[20] = 40679
						order[21] = 41887
						order[22] = 41888
						order[23] = 41889
						order[24] = 41890
						order[25] = 40680
						order[26] = 40681
						order[27] = 40682
						order[28] = 40683
						order[29] = 40684
						order[30] = 40685
						order[31] = 40704
						order[32] = 40686
						order[33] = 40687
						order[34] = 40688
						order[35] = 40689
						order[36] = 40966
						order[37] = 40691
						order[38] = 40692
						order[39] = 40693
						order[40] = 41891
						order[41] = 41892
						order[42] = 40694
						order[43] = 41878
						order[44] = 41893
						order[45] = 41894
						order[46] = 41895
						order[47] = 41896
						order[48] = 40695
						order[49] = 40696
						order[50] = 40697
						order[51] = 40698
						order[52] = 40967
						order[53] = 40700
						order[54] = 40701
						order[55] = 40702
						order[56] = 40703
						order[57] = 0
						super(40664, 40665, order)
					end

					class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40705
							order[1] = 40706
							order[2] = 40707
							order[3] = 0
							super(40704, 40705, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40690
							order[1] = 0
							super(40966, 40690, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41879
							order[1] = 41880
							order[2] = 0
							super(41878, 41879, order)
						end
					end

					class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40699
							order[1] = 0
							super(40967, 40699, order)
						end
					end
				end

				class NoUnderlyingPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40709
						order[1] = 40710
						order[2] = 42993
						order[3] = 42994
						order[4] = 42995
						order[5] = 42996
						order[6] = 42997
						order[7] = 42998
						order[8] = 42999
						order[9] = 42984
						order[10] = 42985
						order[11] = 42986
						order[12] = 42987
						order[13] = 42988
						order[14] = 42989
						order[15] = 42990
						order[16] = 40711
						order[17] = 40712
						order[18] = 40713
						order[19] = 40714
						order[20] = 40715
						order[21] = 40716
						order[22] = 40717
						order[23] = 40718
						order[24] = 40719
						order[25] = 40720
						order[26] = 40721
						order[27] = 40722
						order[28] = 40723
						order[29] = 40724
						order[30] = 40725
						order[31] = 40726
						order[32] = 40727
						order[33] = 40728
						order[34] = 40729
						order[35] = 40730
						order[36] = 40731
						order[37] = 40732
						order[38] = 40733
						order[39] = 40734
						order[40] = 40735
						order[41] = 40736
						order[42] = 40737
						order[43] = 0
						super(40708, 40709, order)
					end

					class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43001
							order[1] = 0
							super(43000, 43001, order)
						end
					end

					class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42992
							order[1] = 0
							super(42991, 42992, order)
						end
					end
				end

				class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41809
						order[1] = 0
						super(41808, 41809, order)
					end
				end

				class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41805
						order[1] = 41806
						order[2] = 41807
						order[3] = 0
						super(41804, 41805, order)
					end
				end

				class NoUnderlyingDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41757
						order[1] = 41758
						order[2] = 41759
						order[3] = 41760
						order[4] = 41761
						order[5] = 41762
						order[6] = 41763
						order[7] = 41764
						order[8] = 41765
						order[9] = 41766
						order[10] = 41767
						order[11] = 41768
						order[12] = 41769
						order[13] = 41770
						order[14] = 0
						super(41756, 41757, order)
					end

					class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41771
							order[1] = 41772
							order[2] = 41773
							order[3] = 0
							super(41770, 41771, order)
						end

						class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41774
								order[1] = 41775
								order[2] = 41776
								order[3] = 0
								super(41773, 41774, order)
							end
						end
					end
				end
			end

			class NoUnderlyingProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 42150
					order[1] = 42151
					order[2] = 42152
					order[3] = 42190
					order[4] = 42153
					order[5] = 42154
					order[6] = 42155
					order[7] = 43002
					order[8] = 43003
					order[9] = 42156
					order[10] = 42157
					order[11] = 42158
					order[12] = 42104
					order[13] = 42105
					order[14] = 42106
					order[15] = 42107
					order[16] = 42108
					order[17] = 42109
					order[18] = 42110
					order[19] = 42111
					order[20] = 42115
					order[21] = 42116
					order[22] = 42117
					order[23] = 42118
					order[24] = 42119
					order[25] = 42120
					order[26] = 42121
					order[27] = 42122
					order[28] = 42123
					order[29] = 42124
					order[30] = 42125
					order[31] = 42126
					order[32] = 42127
					order[33] = 42128
					order[34] = 42129
					order[35] = 42130
					order[36] = 42131
					order[37] = 42132
					order[38] = 42133
					order[39] = 42134
					order[40] = 42135
					order[41] = 42136
					order[42] = 42137
					order[43] = 42138
					order[44] = 42139
					order[45] = 42140
					order[46] = 42141
					order[47] = 42142
					order[48] = 42143
					order[49] = 42144
					order[50] = 42145
					order[51] = 42146
					order[52] = 42147
					order[53] = 42148
					order[54] = 42159
					order[55] = 42160
					order[56] = 42161
					order[57] = 42162
					order[58] = 42163
					order[59] = 42164
					order[60] = 42165
					order[61] = 42092
					order[62] = 42093
					order[63] = 42094
					order[64] = 42095
					order[65] = 42096
					order[66] = 42097
					order[67] = 42098
					order[68] = 42166
					order[69] = 42167
					order[70] = 42168
					order[71] = 42169
					order[72] = 42102
					order[73] = 42103
					order[74] = 42170
					order[75] = 42171
					order[76] = 42172
					order[77] = 42173
					order[78] = 0
					super(42149, 42150, order)
				end

				class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42191
						order[1] = 0
						super(42190, 42191, order)
					end
				end

				class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42183
						order[1] = 0
						super(42182, 42183, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42185
						order[1] = 0
						super(42184, 42185, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42113
						order[1] = 42114
						order[2] = 0
						super(42112, 42113, order)
					end
				end

				class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42187
						order[1] = 0
						super(42186, 42187, order)
					end
				end

				class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42189
						order[1] = 0
						super(42188, 42189, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42181
						order[1] = 0
						super(42180, 42181, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42100
						order[1] = 42101
						order[2] = 0
						super(42099, 42100, order)
					end
				end

				class NoUnderlyingProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 42174
						order[1] = 42175
						order[2] = 42176
						order[3] = 40918
						order[4] = 42177
						order[5] = 0
						super(42173, 42174, order)
					end

					class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42178
							order[1] = 42179
							order[2] = 0
							super(42177, 42178, order)
						end
					end
				end
			end

			class NoUnderlyingAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42037
					order[1] = 42038
					order[2] = 41340
					order[3] = 0
					super(42036, 42037, order)
				end

				class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41341
						order[1] = 41701
						order[2] = 41709
						order[3] = 41710
						order[4] = 41711
						order[5] = 41712
						order[6] = 42017
						order[7] = 42025
						order[8] = 42026
						order[9] = 42027
						order[10] = 42028
						order[11] = 42029
						order[12] = 42030
						order[13] = 42031
						order[14] = 42032
						order[15] = 42033
						order[16] = 42034
						order[17] = 42035
						order[18] = 0
						super(41340, 41341, order)
					end
				end
			end

			class NoUnderlyingProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 42069
					order[1] = 42070
					order[2] = 42071
					order[3] = 42072
					order[4] = 42073
					order[5] = 42074
					order[6] = 42075
					order[7] = 42090
					order[8] = 42077
					order[9] = 42087
					order[10] = 42076
					order[11] = 0
					super(42068, 42069, order)
				end

				class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42091
						order[1] = 0
						super(42090, 42091, order)
					end
				end

				class NoUnderlyingProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 42078
						order[1] = 42079
						order[2] = 42080
						order[3] = 42081
						order[4] = 42082
						order[5] = 42083
						order[6] = 42084
						order[7] = 42085
						order[8] = 0
						super(42077, 42078, order)
					end

					class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42086
							order[1] = 0
							super(42085, 42086, order)
						end
					end
				end

				class NoUnderlyingProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42088
						order[1] = 42089
						order[2] = 0
						super(42087, 42088, order)
					end
				end
			end

			class NoUnderlyingCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 42042
					order[1] = 42043
					order[2] = 42044
					order[3] = 42045
					order[4] = 42046
					order[5] = 42047
					order[6] = 42048
					order[7] = 42049
					order[8] = 42050
					order[9] = 42051
					order[10] = 42052
					order[11] = 42039
					order[12] = 42797
					order[13] = 42798
					order[14] = 42053
					order[15] = 42054
					order[16] = 42790
					order[17] = 42791
					order[18] = 42792
					order[19] = 42793
					order[20] = 42794
					order[21] = 42795
					order[22] = 42796
					order[23] = 42055
					order[24] = 42056
					order[25] = 42057
					order[26] = 42058
					order[27] = 42059
					order[28] = 0
					super(42041, 42042, order)
				end

				class NoUnderlyingCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42040
						order[1] = 0
						super(42039, 42040, order)
					end
				end

				class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42789
						order[1] = 0
						super(42788, 42789, order)
					end
				end
			end

			class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42065
					order[1] = 42061
					order[2] = 42062
					order[3] = 42063
					order[4] = 42064
					order[5] = 0
					super(42060, 42065, order)
				end

				class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42066
						order[1] = 42067
						order[2] = 0
						super(42065, 42066, order)
					end
				end
			end

			class NoUnderlyingRateSpreadSteps < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 43006
					order[1] = 43007
					order[2] = 0
					super(43005, 43006, order)
				end
			end

			class NoUnderlyingDividendPayments < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42856
					order[1] = 42857
					order[2] = 42858
					order[3] = 42859
					order[4] = 0
					super(42855, 42856, order)
				end
			end

			class NoUnderlyingExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42885
					order[1] = 42886
					order[2] = 0
					super(42884, 42885, order)
				end
			end
		end
	end
end

class RegistrationInstructions < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("o") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoRegistDtls < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(9)
			order[0] = 509
			order[1] = 511
			order[2] = 474
			order[3] = 482
			order[4] = 539
			order[5] = 522
			order[6] = 486
			order[7] = 475
			order[8] = 0
			super(473, 509, order)
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end

	class NoDistribInsts < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(9)
			order[0] = 477
			order[1] = 512
			order[2] = 478
			order[3] = 498
			order[4] = 499
			order[5] = 500
			order[6] = 501
			order[7] = 502
			order[8] = 0
			super(510, 477, order)
		end
	end
end

class RegistrationInstructionsResponse < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("p") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end
end

class OrderMassCancelRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("q") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoTargetPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1462
			order[1] = 1463
			order[2] = 1464
			order[3] = 1818
			order[4] = 2433
			order[5] = 0
			super(1461, 1462, order)
		end

		class NoTargetPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2434
				order[1] = 2435
				order[2] = 0
				super(2433, 2434, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoUnderlyingSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 458
			order[1] = 459
			order[2] = 2959
			order[3] = 0
			super(457, 458, order)
		end
	end

	class NoUnderlyingStips < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 888
			order[1] = 889
			order[2] = 0
			super(887, 888, order)
		end
	end

	class NoUndlyInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1059
			order[1] = 1060
			order[2] = 1061
			order[3] = 2391
			order[4] = 1062
			order[5] = 0
			super(1058, 1059, order)
		end

		class NoUndlyInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1063
				order[1] = 1064
				order[2] = 0
				super(1062, 1063, order)
			end
		end
	end

	class NoUnderlyingEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 1982
			order[1] = 1983
			order[2] = 1984
			order[3] = 1985
			order[4] = 1986
			order[5] = 2342
			order[6] = 1987
			order[7] = 2071
			order[8] = 2072
			order[9] = 2073
			order[10] = 0
			super(1981, 1982, order)
		end
	end

	class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 2081
			order[1] = 2082
			order[2] = 2083
			order[3] = 2745
			order[4] = 0
			super(2080, 2081, order)
		end
	end

	class NoUnderlyingAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2313
			order[1] = 2314
			order[2] = 2315
			order[3] = 0
			super(2312, 2313, order)
		end
	end

	class NoUnderlyingComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 2046
			order[1] = 2261
			order[2] = 2262
			order[3] = 2263
			order[4] = 2047
			order[5] = 2264
			order[6] = 2265
			order[7] = 2266
			order[8] = 2947
			order[9] = 2048
			order[10] = 2267
			order[11] = 2049
			order[12] = 2050
			order[13] = 2051
			order[14] = 2052
			order[15] = 2053
			order[16] = 2268
			order[17] = 2948
			order[18] = 2269
			order[19] = 2949
			order[20] = 2270
			order[21] = 2271
			order[22] = 2419
			order[23] = 2420
			order[24] = 2272
			order[25] = 2273
			order[26] = 2274
			order[27] = 2275
			order[28] = 2276
			order[29] = 41732
			order[30] = 41739
			order[31] = 41740
			order[32] = 41741
			order[33] = 41742
			order[34] = 41743
			order[35] = 41744
			order[36] = 41745
			order[37] = 41746
			order[38] = 41747
			order[39] = 41729
			order[40] = 2277
			order[41] = 2278
			order[42] = 2279
			order[43] = 2280
			order[44] = 2281
			order[45] = 41748
			order[46] = 41716
			order[47] = 2611
			order[48] = 2612
			order[49] = 2613
			order[50] = 2282
			order[51] = 2283
			order[52] = 0
			super(2045, 2046, order)
		end

		class NoUnderlyingComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2054
				order[1] = 2055
				order[2] = 2056
				order[3] = 0
				super(2053, 2054, order)
			end

			class NoUnderlyingComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2057
					order[1] = 2058
					order[2] = 0
					super(2056, 2057, order)
				end
			end
		end

		class NoUnderlyingComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41733
				order[1] = 41734
				order[2] = 41735
				order[3] = 41736
				order[4] = 0
				super(41732, 41733, order)
			end
		end

		class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41738
				order[1] = 0
				super(41737, 41738, order)
			end
		end

		class NoUnderlyingComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41730
				order[1] = 41731
				order[2] = 41750
				order[3] = 41726
				order[4] = 41713
				order[5] = 0
				super(41729, 41730, order)
			end

			class NoUnderlyingComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41751
					order[1] = 41752
					order[2] = 41753
					order[3] = 41754
					order[4] = 41755
					order[5] = 0
					super(41750, 41751, order)
				end
			end

			class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41727
					order[1] = 41728
					order[2] = 0
					super(41726, 41727, order)
				end
			end

			class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41714
					order[1] = 41715
					order[2] = 0
					super(41713, 41714, order)
				end
			end
		end

		class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41749
				order[1] = 0
				super(41748, 41749, order)
			end
		end

		class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 41717
				order[1] = 41718
				order[2] = 41719
				order[3] = 41720
				order[4] = 41721
				order[5] = 41722
				order[6] = 41723
				order[7] = 41724
				order[8] = 0
				super(41716, 41717, order)
			end

			class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41725
					order[1] = 0
					super(41724, 41725, order)
				end
			end
		end
	end

	class NoUnderlyingBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40963
			order[1] = 0
			super(40962, 40963, order)
		end
	end

	class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41948
			order[1] = 0
			super(41947, 41948, order)
		end
	end

	class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41865
			order[1] = 41338
			order[2] = 0
			super(41864, 41865, order)
		end
	end

	class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41867
			order[1] = 41339
			order[2] = 0
			super(41866, 41867, order)
		end
	end

	class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41869
			order[1] = 41870
			order[2] = 41871
			order[3] = 41872
			order[4] = 41873
			order[5] = 41874
			order[6] = 41875
			order[7] = 41876
			order[8] = 41877
			order[9] = 0
			super(41868, 41869, order)
		end
	end

	class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 43075
			order[1] = 0
			super(43074, 43075, order)
		end
	end

	class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41821
			order[1] = 0
			super(41820, 41821, order)
		end
	end

	class NoUnderlyingOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41842
			order[1] = 41843
			order[2] = 0
			super(41841, 41842, order)
		end
	end

	class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41845
			order[1] = 0
			super(41844, 41845, order)
		end
	end

	class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41857
			order[1] = 41858
			order[2] = 0
			super(41856, 41857, order)
		end
	end

	class NoUnderlyingStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40541
			order[1] = 42016
			order[2] = 40542
			order[3] = 43083
			order[4] = 43084
			order[5] = 40543
			order[6] = 40544
			order[7] = 42018
			order[8] = 40545
			order[9] = 40546
			order[10] = 43085
			order[11] = 43086
			order[12] = 42019
			order[13] = 42020
			order[14] = 42021
			order[15] = 42022
			order[16] = 42023
			order[17] = 42024
			order[18] = 41964
			order[19] = 41965
			order[20] = 41966
			order[21] = 41967
			order[22] = 41968
			order[23] = 41969
			order[24] = 41970
			order[25] = 42589
			order[26] = 41971
			order[27] = 41972
			order[28] = 41973
			order[29] = 41974
			order[30] = 41975
			order[31] = 41976
			order[32] = 41977
			order[33] = 41978
			order[34] = 41979
			order[35] = 41980
			order[36] = 41981
			order[37] = 41982
			order[38] = 41983
			order[39] = 41984
			order[40] = 41985
			order[41] = 41986
			order[42] = 41987
			order[43] = 41988
			order[44] = 41989
			order[45] = 40057
			order[46] = 40058
			order[47] = 40060
			order[48] = 40061
			order[49] = 40062
			order[50] = 40063
			order[51] = 40064
			order[52] = 40548
			order[53] = 40549
			order[54] = 40551
			order[55] = 40552
			order[56] = 40553
			order[57] = 40554
			order[58] = 40555
			order[59] = 41957
			order[60] = 41958
			order[61] = 40556
			order[62] = 40558
			order[63] = 40559
			order[64] = 40561
			order[65] = 40562
			order[66] = 40563
			order[67] = 40564
			order[68] = 40565
			order[69] = 40566
			order[70] = 40567
			order[71] = 41959
			order[72] = 41960
			order[73] = 41961
			order[74] = 40568
			order[75] = 40569
			order[76] = 40570
			order[77] = 42895
			order[78] = 40571
			order[79] = 40572
			order[80] = 43107
			order[81] = 40573
			order[82] = 40574
			order[83] = 40575
			order[84] = 40576
			order[85] = 40577
			order[86] = 42896
			order[87] = 42897
			order[88] = 42898
			order[89] = 42899
			order[90] = 40578
			order[91] = 40579
			order[92] = 40580
			order[93] = 41897
			order[94] = 41898
			order[95] = 41899
			order[96] = 41900
			order[97] = 41901
			order[98] = 41902
			order[99] = 41903
			order[100] = 42900
			order[101] = 40664
			order[102] = 40708
			order[103] = 41777
			order[104] = 41778
			order[105] = 41779
			order[106] = 41780
			order[107] = 41781
			order[108] = 42196
			order[109] = 42197
			order[110] = 41782
			order[111] = 41783
			order[112] = 41784
			order[113] = 41785
			order[114] = 41786
			order[115] = 41587
			order[116] = 41787
			order[117] = 41788
			order[118] = 41789
			order[119] = 41790
			order[120] = 41791
			order[121] = 41792
			order[122] = 41793
			order[123] = 41794
			order[124] = 41795
			order[125] = 41796
			order[126] = 41797
			order[127] = 41798
			order[128] = 41799
			order[129] = 43096
			order[130] = 41756
			order[131] = 40547
			order[132] = 40988
			order[133] = 40989
			order[134] = 0
			super(40540, 40541, order)
		end

		class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41991
				order[1] = 41992
				order[2] = 0
				super(41990, 41991, order)
			end
		end

		class NoUnderlyingStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41801
				order[1] = 41802
				order[2] = 41803
				order[3] = 0
				super(41800, 41801, order)
			end
		end

		class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41994
				order[1] = 41995
				order[2] = 0
				super(41993, 41994, order)
			end
		end

		class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41963
				order[1] = 0
				super(41962, 41963, order)
			end
		end

		class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 42003
				order[1] = 42004
				order[2] = 42005
				order[3] = 42006
				order[4] = 42007
				order[5] = 42008
				order[6] = 42009
				order[7] = 42010
				order[8] = 42011
				order[9] = 42012
				order[10] = 42013
				order[11] = 41996
				order[12] = 42014
				order[13] = 42015
				order[14] = 0
				super(42002, 42003, order)
			end

			class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41997
					order[1] = 41998
					order[2] = 41999
					order[3] = 0
					super(41996, 41997, order)
				end

				class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42000
						order[1] = 42001
						order[2] = 41936
						order[3] = 0
						super(41999, 42000, order)
					end
				end
			end
		end

		class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40059
				order[1] = 0
				super(40975, 40059, order)
			end
		end

		class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40550
				order[1] = 0
				super(40976, 40550, order)
			end
		end

		class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40557
				order[1] = 0
				super(40973, 40557, order)
			end
		end

		class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41955
				order[1] = 41956
				order[2] = 0
				super(41954, 41955, order)
			end
		end

		class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40560
				order[1] = 0
				super(40974, 40560, order)
			end
		end

		class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40582
				order[1] = 0
				super(40969, 40582, order)
			end
		end

		class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41938
				order[1] = 41939
				order[2] = 0
				super(41937, 41938, order)
			end
		end

		class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40594
				order[1] = 0
				super(40970, 40594, order)
			end
		end

		class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40600
				order[1] = 0
				super(40971, 40600, order)
			end
		end

		class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40607
				order[1] = 0
				super(40972, 40607, order)
			end
		end

		class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42956
				order[1] = 42957
				order[2] = 0
				super(42955, 42956, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41910
				order[1] = 0
				super(41909, 41910, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41945
				order[1] = 41946
				order[2] = 0
				super(41944, 41945, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41942
				order[1] = 41943
				order[2] = 0
				super(41941, 41942, order)
			end
		end

		class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43111
				order[1] = 42982
				order[2] = 42983
				order[3] = 0
				super(42981, 43111, order)
			end
		end

		class NoUnderlyingDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42863
				order[1] = 42864
				order[2] = 42865
				order[3] = 42866
				order[4] = 42867
				order[5] = 42868
				order[6] = 42882
				order[7] = 42869
				order[8] = 42870
				order[9] = 42871
				order[10] = 42872
				order[11] = 42873
				order[12] = 42874
				order[13] = 42875
				order[14] = 42876
				order[15] = 42877
				order[16] = 42878
				order[17] = 42879
				order[18] = 42880
				order[19] = 42881
				order[20] = 0
				super(42862, 42863, order)
			end

			class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42883
					order[1] = 0
					super(42882, 42883, order)
				end
			end
		end

		class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42854
				order[1] = 0
				super(42853, 42854, order)
			end
		end

		class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42800
				order[1] = 0
				super(42799, 42800, order)
			end
		end

		class NoUnderlyingReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 43035
				order[1] = 43036
				order[2] = 43037
				order[3] = 43038
				order[4] = 43039
				order[5] = 43040
				order[6] = 43064
				order[7] = 43030
				order[8] = 43041
				order[9] = 43042
				order[10] = 43043
				order[11] = 43044
				order[12] = 43045
				order[13] = 43046
				order[14] = 43047
				order[15] = 43048
				order[16] = 43049
				order[17] = 43050
				order[18] = 43051
				order[19] = 43052
				order[20] = 43060
				order[21] = 43053
				order[22] = 43054
				order[23] = 43008
				order[24] = 43055
				order[25] = 43056
				order[26] = 43057
				order[27] = 43058
				order[28] = 43059
				order[29] = 0
				super(43034, 43035, order)
			end

			class NoUnderlyingReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 43065
					order[1] = 43066
					order[2] = 43067
					order[3] = 43068
					order[4] = 0
					super(43064, 43065, order)
				end
			end

			class NoUnderlyingReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43031
					order[1] = 43032
					order[2] = 43033
					order[3] = 0
					super(43030, 43031, order)
				end
			end

			class NoUnderlyingReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43061
					order[1] = 43062
					order[2] = 43063
					order[3] = 0
					super(43060, 43061, order)
				end
			end

			class NoUnderlyingReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 43009
					order[1] = 43071
					order[2] = 43010
					order[3] = 43011
					order[4] = 43012
					order[5] = 43013
					order[6] = 43014
					order[7] = 43015
					order[8] = 43016
					order[9] = 43017
					order[10] = 43018
					order[11] = 43019
					order[12] = 43020
					order[13] = 43021
					order[14] = 43022
					order[15] = 43023
					order[16] = 43024
					order[17] = 43025
					order[18] = 43026
					order[19] = 43027
					order[20] = 43028
					order[21] = 43029
					order[22] = 43069
					order[23] = 0
					super(43008, 43009, order)
				end

				class NoUnderlyingReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 43072
						order[1] = 43073
						order[2] = 0
						super(43071, 43072, order)
					end
				end

				class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43070
						order[1] = 0
						super(43069, 43070, order)
					end
				end
			end
		end

		class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42916
				order[1] = 0
				super(42915, 42916, order)
			end
		end

		class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42902
				order[1] = 42903
				order[2] = 0
				super(42901, 42902, order)
			end
		end

		class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40650
				order[1] = 0
				super(40968, 40650, order)
			end
		end

		class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40657
				order[1] = 40658
				order[2] = 0
				super(40656, 40657, order)
			end
		end

		class NoUnderlyingSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40660
				order[1] = 40904
				order[2] = 40915
				order[3] = 40662
				order[4] = 40663
				order[5] = 0
				super(40659, 40660, order)
			end
		end

		class NoUnderlyingPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40665
				order[1] = 41881
				order[2] = 41882
				order[3] = 40666
				order[4] = 40667
				order[5] = 40668
				order[6] = 40669
				order[7] = 40670
				order[8] = 40671
				order[9] = 40672
				order[10] = 40673
				order[11] = 40674
				order[12] = 40675
				order[13] = 41883
				order[14] = 41884
				order[15] = 41885
				order[16] = 41886
				order[17] = 40676
				order[18] = 40677
				order[19] = 40678
				order[20] = 40679
				order[21] = 41887
				order[22] = 41888
				order[23] = 41889
				order[24] = 41890
				order[25] = 40680
				order[26] = 40681
				order[27] = 40682
				order[28] = 40683
				order[29] = 40684
				order[30] = 40685
				order[31] = 40704
				order[32] = 40686
				order[33] = 40687
				order[34] = 40688
				order[35] = 40689
				order[36] = 40966
				order[37] = 40691
				order[38] = 40692
				order[39] = 40693
				order[40] = 41891
				order[41] = 41892
				order[42] = 40694
				order[43] = 41878
				order[44] = 41893
				order[45] = 41894
				order[46] = 41895
				order[47] = 41896
				order[48] = 40695
				order[49] = 40696
				order[50] = 40697
				order[51] = 40698
				order[52] = 40967
				order[53] = 40700
				order[54] = 40701
				order[55] = 40702
				order[56] = 40703
				order[57] = 0
				super(40664, 40665, order)
			end

			class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40705
					order[1] = 40706
					order[2] = 40707
					order[3] = 0
					super(40704, 40705, order)
				end
			end

			class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40690
					order[1] = 0
					super(40966, 40690, order)
				end
			end

			class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41879
					order[1] = 41880
					order[2] = 0
					super(41878, 41879, order)
				end
			end

			class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40699
					order[1] = 0
					super(40967, 40699, order)
				end
			end
		end

		class NoUnderlyingPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40709
				order[1] = 40710
				order[2] = 42993
				order[3] = 42994
				order[4] = 42995
				order[5] = 42996
				order[6] = 42997
				order[7] = 42998
				order[8] = 42999
				order[9] = 42984
				order[10] = 42985
				order[11] = 42986
				order[12] = 42987
				order[13] = 42988
				order[14] = 42989
				order[15] = 42990
				order[16] = 40711
				order[17] = 40712
				order[18] = 40713
				order[19] = 40714
				order[20] = 40715
				order[21] = 40716
				order[22] = 40717
				order[23] = 40718
				order[24] = 40719
				order[25] = 40720
				order[26] = 40721
				order[27] = 40722
				order[28] = 40723
				order[29] = 40724
				order[30] = 40725
				order[31] = 40726
				order[32] = 40727
				order[33] = 40728
				order[34] = 40729
				order[35] = 40730
				order[36] = 40731
				order[37] = 40732
				order[38] = 40733
				order[39] = 40734
				order[40] = 40735
				order[41] = 40736
				order[42] = 40737
				order[43] = 0
				super(40708, 40709, order)
			end

			class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 43001
					order[1] = 0
					super(43000, 43001, order)
				end
			end

			class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42992
					order[1] = 0
					super(42991, 42992, order)
				end
			end
		end

		class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41809
				order[1] = 0
				super(41808, 41809, order)
			end
		end

		class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41805
				order[1] = 41806
				order[2] = 41807
				order[3] = 0
				super(41804, 41805, order)
			end
		end

		class NoUnderlyingDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41757
				order[1] = 41758
				order[2] = 41759
				order[3] = 41760
				order[4] = 41761
				order[5] = 41762
				order[6] = 41763
				order[7] = 41764
				order[8] = 41765
				order[9] = 41766
				order[10] = 41767
				order[11] = 41768
				order[12] = 41769
				order[13] = 41770
				order[14] = 0
				super(41756, 41757, order)
			end

			class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41771
					order[1] = 41772
					order[2] = 41773
					order[3] = 0
					super(41770, 41771, order)
				end

				class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41774
						order[1] = 41775
						order[2] = 41776
						order[3] = 0
						super(41773, 41774, order)
					end
				end
			end
		end
	end

	class NoUnderlyingProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 42150
			order[1] = 42151
			order[2] = 42152
			order[3] = 42190
			order[4] = 42153
			order[5] = 42154
			order[6] = 42155
			order[7] = 43002
			order[8] = 43003
			order[9] = 42156
			order[10] = 42157
			order[11] = 42158
			order[12] = 42104
			order[13] = 42105
			order[14] = 42106
			order[15] = 42107
			order[16] = 42108
			order[17] = 42109
			order[18] = 42110
			order[19] = 42111
			order[20] = 42115
			order[21] = 42116
			order[22] = 42117
			order[23] = 42118
			order[24] = 42119
			order[25] = 42120
			order[26] = 42121
			order[27] = 42122
			order[28] = 42123
			order[29] = 42124
			order[30] = 42125
			order[31] = 42126
			order[32] = 42127
			order[33] = 42128
			order[34] = 42129
			order[35] = 42130
			order[36] = 42131
			order[37] = 42132
			order[38] = 42133
			order[39] = 42134
			order[40] = 42135
			order[41] = 42136
			order[42] = 42137
			order[43] = 42138
			order[44] = 42139
			order[45] = 42140
			order[46] = 42141
			order[47] = 42142
			order[48] = 42143
			order[49] = 42144
			order[50] = 42145
			order[51] = 42146
			order[52] = 42147
			order[53] = 42148
			order[54] = 42159
			order[55] = 42160
			order[56] = 42161
			order[57] = 42162
			order[58] = 42163
			order[59] = 42164
			order[60] = 42165
			order[61] = 42092
			order[62] = 42093
			order[63] = 42094
			order[64] = 42095
			order[65] = 42096
			order[66] = 42097
			order[67] = 42098
			order[68] = 42166
			order[69] = 42167
			order[70] = 42168
			order[71] = 42169
			order[72] = 42102
			order[73] = 42103
			order[74] = 42170
			order[75] = 42171
			order[76] = 42172
			order[77] = 42173
			order[78] = 0
			super(42149, 42150, order)
		end

		class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42191
				order[1] = 0
				super(42190, 42191, order)
			end
		end

		class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42183
				order[1] = 0
				super(42182, 42183, order)
			end
		end

		class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42185
				order[1] = 0
				super(42184, 42185, order)
			end
		end

		class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42113
				order[1] = 42114
				order[2] = 0
				super(42112, 42113, order)
			end
		end

		class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42187
				order[1] = 0
				super(42186, 42187, order)
			end
		end

		class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42189
				order[1] = 0
				super(42188, 42189, order)
			end
		end

		class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42181
				order[1] = 0
				super(42180, 42181, order)
			end
		end

		class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42100
				order[1] = 42101
				order[2] = 0
				super(42099, 42100, order)
			end
		end

		class NoUnderlyingProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42174
				order[1] = 42175
				order[2] = 42176
				order[3] = 40918
				order[4] = 42177
				order[5] = 0
				super(42173, 42174, order)
			end

			class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42178
					order[1] = 42179
					order[2] = 0
					super(42177, 42178, order)
				end
			end
		end
	end

	class NoUnderlyingAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 42037
			order[1] = 42038
			order[2] = 41340
			order[3] = 0
			super(42036, 42037, order)
		end

		class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 41341
				order[1] = 41701
				order[2] = 41709
				order[3] = 41710
				order[4] = 41711
				order[5] = 41712
				order[6] = 42017
				order[7] = 42025
				order[8] = 42026
				order[9] = 42027
				order[10] = 42028
				order[11] = 42029
				order[12] = 42030
				order[13] = 42031
				order[14] = 42032
				order[15] = 42033
				order[16] = 42034
				order[17] = 42035
				order[18] = 0
				super(41340, 41341, order)
			end
		end
	end

	class NoUnderlyingProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 42069
			order[1] = 42070
			order[2] = 42071
			order[3] = 42072
			order[4] = 42073
			order[5] = 42074
			order[6] = 42075
			order[7] = 42090
			order[8] = 42077
			order[9] = 42087
			order[10] = 42076
			order[11] = 0
			super(42068, 42069, order)
		end

		class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42091
				order[1] = 0
				super(42090, 42091, order)
			end
		end

		class NoUnderlyingProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 42078
				order[1] = 42079
				order[2] = 42080
				order[3] = 42081
				order[4] = 42082
				order[5] = 42083
				order[6] = 42084
				order[7] = 42085
				order[8] = 0
				super(42077, 42078, order)
			end

			class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42086
					order[1] = 0
					super(42085, 42086, order)
				end
			end
		end

		class NoUnderlyingProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42088
				order[1] = 42089
				order[2] = 0
				super(42087, 42088, order)
			end
		end
	end

	class NoUnderlyingCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 42042
			order[1] = 42043
			order[2] = 42044
			order[3] = 42045
			order[4] = 42046
			order[5] = 42047
			order[6] = 42048
			order[7] = 42049
			order[8] = 42050
			order[9] = 42051
			order[10] = 42052
			order[11] = 42039
			order[12] = 42797
			order[13] = 42798
			order[14] = 42053
			order[15] = 42054
			order[16] = 42790
			order[17] = 42791
			order[18] = 42792
			order[19] = 42793
			order[20] = 42794
			order[21] = 42795
			order[22] = 42796
			order[23] = 42055
			order[24] = 42056
			order[25] = 42057
			order[26] = 42058
			order[27] = 42059
			order[28] = 0
			super(42041, 42042, order)
		end

		class NoUnderlyingCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42040
				order[1] = 0
				super(42039, 42040, order)
			end
		end

		class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42789
				order[1] = 0
				super(42788, 42789, order)
			end
		end
	end

	class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 42065
			order[1] = 42061
			order[2] = 42062
			order[3] = 42063
			order[4] = 42064
			order[5] = 0
			super(42060, 42065, order)
		end

		class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42066
				order[1] = 42067
				order[2] = 0
				super(42065, 42066, order)
			end
		end
	end

	class NoUnderlyingRateSpreadSteps < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 43006
			order[1] = 43007
			order[2] = 0
			super(43005, 43006, order)
		end
	end

	class NoUnderlyingDividendPayments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 42856
			order[1] = 42857
			order[2] = 42858
			order[3] = 42859
			order[4] = 0
			super(42855, 42856, order)
		end
	end

	class NoUnderlyingExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42885
			order[1] = 42886
			order[2] = 0
			super(42884, 42885, order)
		end
	end
end

class OrderMassCancelReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("r") )
	end

	class NoAffectedOrders < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 1824
			order[1] = 535
			order[2] = 536
			order[3] = 0
			super(534, 1824, order)
		end
	end

	class NoNotAffectedOrders < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1372
			order[1] = 1371
			order[2] = 1825
			order[3] = 2677
			order[4] = 0
			super(1370, 1372, order)
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoTargetPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1462
			order[1] = 1463
			order[2] = 1464
			order[3] = 1818
			order[4] = 2433
			order[5] = 0
			super(1461, 1462, order)
		end

		class NoTargetPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2434
				order[1] = 2435
				order[2] = 0
				super(2433, 2434, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoUnderlyingSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 458
			order[1] = 459
			order[2] = 2959
			order[3] = 0
			super(457, 458, order)
		end
	end

	class NoUnderlyingStips < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 888
			order[1] = 889
			order[2] = 0
			super(887, 888, order)
		end
	end

	class NoUndlyInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1059
			order[1] = 1060
			order[2] = 1061
			order[3] = 2391
			order[4] = 1062
			order[5] = 0
			super(1058, 1059, order)
		end

		class NoUndlyInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1063
				order[1] = 1064
				order[2] = 0
				super(1062, 1063, order)
			end
		end
	end

	class NoUnderlyingEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 1982
			order[1] = 1983
			order[2] = 1984
			order[3] = 1985
			order[4] = 1986
			order[5] = 2342
			order[6] = 1987
			order[7] = 2071
			order[8] = 2072
			order[9] = 2073
			order[10] = 0
			super(1981, 1982, order)
		end
	end

	class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 2081
			order[1] = 2082
			order[2] = 2083
			order[3] = 2745
			order[4] = 0
			super(2080, 2081, order)
		end
	end

	class NoUnderlyingAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2313
			order[1] = 2314
			order[2] = 2315
			order[3] = 0
			super(2312, 2313, order)
		end
	end

	class NoUnderlyingComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 2046
			order[1] = 2261
			order[2] = 2262
			order[3] = 2263
			order[4] = 2047
			order[5] = 2264
			order[6] = 2265
			order[7] = 2266
			order[8] = 2947
			order[9] = 2048
			order[10] = 2267
			order[11] = 2049
			order[12] = 2050
			order[13] = 2051
			order[14] = 2052
			order[15] = 2053
			order[16] = 2268
			order[17] = 2948
			order[18] = 2269
			order[19] = 2949
			order[20] = 2270
			order[21] = 2271
			order[22] = 2419
			order[23] = 2420
			order[24] = 2272
			order[25] = 2273
			order[26] = 2274
			order[27] = 2275
			order[28] = 2276
			order[29] = 41732
			order[30] = 41739
			order[31] = 41740
			order[32] = 41741
			order[33] = 41742
			order[34] = 41743
			order[35] = 41744
			order[36] = 41745
			order[37] = 41746
			order[38] = 41747
			order[39] = 41729
			order[40] = 2277
			order[41] = 2278
			order[42] = 2279
			order[43] = 2280
			order[44] = 2281
			order[45] = 41748
			order[46] = 41716
			order[47] = 2611
			order[48] = 2612
			order[49] = 2613
			order[50] = 2282
			order[51] = 2283
			order[52] = 0
			super(2045, 2046, order)
		end

		class NoUnderlyingComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2054
				order[1] = 2055
				order[2] = 2056
				order[3] = 0
				super(2053, 2054, order)
			end

			class NoUnderlyingComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2057
					order[1] = 2058
					order[2] = 0
					super(2056, 2057, order)
				end
			end
		end

		class NoUnderlyingComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41733
				order[1] = 41734
				order[2] = 41735
				order[3] = 41736
				order[4] = 0
				super(41732, 41733, order)
			end
		end

		class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41738
				order[1] = 0
				super(41737, 41738, order)
			end
		end

		class NoUnderlyingComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41730
				order[1] = 41731
				order[2] = 41750
				order[3] = 41726
				order[4] = 41713
				order[5] = 0
				super(41729, 41730, order)
			end

			class NoUnderlyingComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41751
					order[1] = 41752
					order[2] = 41753
					order[3] = 41754
					order[4] = 41755
					order[5] = 0
					super(41750, 41751, order)
				end
			end

			class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41727
					order[1] = 41728
					order[2] = 0
					super(41726, 41727, order)
				end
			end

			class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41714
					order[1] = 41715
					order[2] = 0
					super(41713, 41714, order)
				end
			end
		end

		class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41749
				order[1] = 0
				super(41748, 41749, order)
			end
		end

		class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 41717
				order[1] = 41718
				order[2] = 41719
				order[3] = 41720
				order[4] = 41721
				order[5] = 41722
				order[6] = 41723
				order[7] = 41724
				order[8] = 0
				super(41716, 41717, order)
			end

			class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41725
					order[1] = 0
					super(41724, 41725, order)
				end
			end
		end
	end

	class NoUnderlyingBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40963
			order[1] = 0
			super(40962, 40963, order)
		end
	end

	class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41948
			order[1] = 0
			super(41947, 41948, order)
		end
	end

	class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41865
			order[1] = 41338
			order[2] = 0
			super(41864, 41865, order)
		end
	end

	class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41867
			order[1] = 41339
			order[2] = 0
			super(41866, 41867, order)
		end
	end

	class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41869
			order[1] = 41870
			order[2] = 41871
			order[3] = 41872
			order[4] = 41873
			order[5] = 41874
			order[6] = 41875
			order[7] = 41876
			order[8] = 41877
			order[9] = 0
			super(41868, 41869, order)
		end
	end

	class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 43075
			order[1] = 0
			super(43074, 43075, order)
		end
	end

	class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41821
			order[1] = 0
			super(41820, 41821, order)
		end
	end

	class NoUnderlyingOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41842
			order[1] = 41843
			order[2] = 0
			super(41841, 41842, order)
		end
	end

	class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41845
			order[1] = 0
			super(41844, 41845, order)
		end
	end

	class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41857
			order[1] = 41858
			order[2] = 0
			super(41856, 41857, order)
		end
	end

	class NoUnderlyingStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40541
			order[1] = 42016
			order[2] = 40542
			order[3] = 43083
			order[4] = 43084
			order[5] = 40543
			order[6] = 40544
			order[7] = 42018
			order[8] = 40545
			order[9] = 40546
			order[10] = 43085
			order[11] = 43086
			order[12] = 42019
			order[13] = 42020
			order[14] = 42021
			order[15] = 42022
			order[16] = 42023
			order[17] = 42024
			order[18] = 41964
			order[19] = 41965
			order[20] = 41966
			order[21] = 41967
			order[22] = 41968
			order[23] = 41969
			order[24] = 41970
			order[25] = 42589
			order[26] = 41971
			order[27] = 41972
			order[28] = 41973
			order[29] = 41974
			order[30] = 41975
			order[31] = 41976
			order[32] = 41977
			order[33] = 41978
			order[34] = 41979
			order[35] = 41980
			order[36] = 41981
			order[37] = 41982
			order[38] = 41983
			order[39] = 41984
			order[40] = 41985
			order[41] = 41986
			order[42] = 41987
			order[43] = 41988
			order[44] = 41989
			order[45] = 40057
			order[46] = 40058
			order[47] = 40060
			order[48] = 40061
			order[49] = 40062
			order[50] = 40063
			order[51] = 40064
			order[52] = 40548
			order[53] = 40549
			order[54] = 40551
			order[55] = 40552
			order[56] = 40553
			order[57] = 40554
			order[58] = 40555
			order[59] = 41957
			order[60] = 41958
			order[61] = 40556
			order[62] = 40558
			order[63] = 40559
			order[64] = 40561
			order[65] = 40562
			order[66] = 40563
			order[67] = 40564
			order[68] = 40565
			order[69] = 40566
			order[70] = 40567
			order[71] = 41959
			order[72] = 41960
			order[73] = 41961
			order[74] = 40568
			order[75] = 40569
			order[76] = 40570
			order[77] = 42895
			order[78] = 40571
			order[79] = 40572
			order[80] = 43107
			order[81] = 40573
			order[82] = 40574
			order[83] = 40575
			order[84] = 40576
			order[85] = 40577
			order[86] = 42896
			order[87] = 42897
			order[88] = 42898
			order[89] = 42899
			order[90] = 40578
			order[91] = 40579
			order[92] = 40580
			order[93] = 41897
			order[94] = 41898
			order[95] = 41899
			order[96] = 41900
			order[97] = 41901
			order[98] = 41902
			order[99] = 41903
			order[100] = 42900
			order[101] = 40664
			order[102] = 40708
			order[103] = 41777
			order[104] = 41778
			order[105] = 41779
			order[106] = 41780
			order[107] = 41781
			order[108] = 42196
			order[109] = 42197
			order[110] = 41782
			order[111] = 41783
			order[112] = 41784
			order[113] = 41785
			order[114] = 41786
			order[115] = 41587
			order[116] = 41787
			order[117] = 41788
			order[118] = 41789
			order[119] = 41790
			order[120] = 41791
			order[121] = 41792
			order[122] = 41793
			order[123] = 41794
			order[124] = 41795
			order[125] = 41796
			order[126] = 41797
			order[127] = 41798
			order[128] = 41799
			order[129] = 43096
			order[130] = 41756
			order[131] = 40547
			order[132] = 40988
			order[133] = 40989
			order[134] = 0
			super(40540, 40541, order)
		end

		class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41991
				order[1] = 41992
				order[2] = 0
				super(41990, 41991, order)
			end
		end

		class NoUnderlyingStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41801
				order[1] = 41802
				order[2] = 41803
				order[3] = 0
				super(41800, 41801, order)
			end
		end

		class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41994
				order[1] = 41995
				order[2] = 0
				super(41993, 41994, order)
			end
		end

		class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41963
				order[1] = 0
				super(41962, 41963, order)
			end
		end

		class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 42003
				order[1] = 42004
				order[2] = 42005
				order[3] = 42006
				order[4] = 42007
				order[5] = 42008
				order[6] = 42009
				order[7] = 42010
				order[8] = 42011
				order[9] = 42012
				order[10] = 42013
				order[11] = 41996
				order[12] = 42014
				order[13] = 42015
				order[14] = 0
				super(42002, 42003, order)
			end

			class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41997
					order[1] = 41998
					order[2] = 41999
					order[3] = 0
					super(41996, 41997, order)
				end

				class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42000
						order[1] = 42001
						order[2] = 41936
						order[3] = 0
						super(41999, 42000, order)
					end
				end
			end
		end

		class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40059
				order[1] = 0
				super(40975, 40059, order)
			end
		end

		class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40550
				order[1] = 0
				super(40976, 40550, order)
			end
		end

		class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40557
				order[1] = 0
				super(40973, 40557, order)
			end
		end

		class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41955
				order[1] = 41956
				order[2] = 0
				super(41954, 41955, order)
			end
		end

		class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40560
				order[1] = 0
				super(40974, 40560, order)
			end
		end

		class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40582
				order[1] = 0
				super(40969, 40582, order)
			end
		end

		class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41938
				order[1] = 41939
				order[2] = 0
				super(41937, 41938, order)
			end
		end

		class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40594
				order[1] = 0
				super(40970, 40594, order)
			end
		end

		class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40600
				order[1] = 0
				super(40971, 40600, order)
			end
		end

		class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40607
				order[1] = 0
				super(40972, 40607, order)
			end
		end

		class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42956
				order[1] = 42957
				order[2] = 0
				super(42955, 42956, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41910
				order[1] = 0
				super(41909, 41910, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41945
				order[1] = 41946
				order[2] = 0
				super(41944, 41945, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41942
				order[1] = 41943
				order[2] = 0
				super(41941, 41942, order)
			end
		end

		class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43111
				order[1] = 42982
				order[2] = 42983
				order[3] = 0
				super(42981, 43111, order)
			end
		end

		class NoUnderlyingDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42863
				order[1] = 42864
				order[2] = 42865
				order[3] = 42866
				order[4] = 42867
				order[5] = 42868
				order[6] = 42882
				order[7] = 42869
				order[8] = 42870
				order[9] = 42871
				order[10] = 42872
				order[11] = 42873
				order[12] = 42874
				order[13] = 42875
				order[14] = 42876
				order[15] = 42877
				order[16] = 42878
				order[17] = 42879
				order[18] = 42880
				order[19] = 42881
				order[20] = 0
				super(42862, 42863, order)
			end

			class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42883
					order[1] = 0
					super(42882, 42883, order)
				end
			end
		end

		class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42854
				order[1] = 0
				super(42853, 42854, order)
			end
		end

		class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42800
				order[1] = 0
				super(42799, 42800, order)
			end
		end

		class NoUnderlyingReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 43035
				order[1] = 43036
				order[2] = 43037
				order[3] = 43038
				order[4] = 43039
				order[5] = 43040
				order[6] = 43064
				order[7] = 43030
				order[8] = 43041
				order[9] = 43042
				order[10] = 43043
				order[11] = 43044
				order[12] = 43045
				order[13] = 43046
				order[14] = 43047
				order[15] = 43048
				order[16] = 43049
				order[17] = 43050
				order[18] = 43051
				order[19] = 43052
				order[20] = 43060
				order[21] = 43053
				order[22] = 43054
				order[23] = 43008
				order[24] = 43055
				order[25] = 43056
				order[26] = 43057
				order[27] = 43058
				order[28] = 43059
				order[29] = 0
				super(43034, 43035, order)
			end

			class NoUnderlyingReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 43065
					order[1] = 43066
					order[2] = 43067
					order[3] = 43068
					order[4] = 0
					super(43064, 43065, order)
				end
			end

			class NoUnderlyingReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43031
					order[1] = 43032
					order[2] = 43033
					order[3] = 0
					super(43030, 43031, order)
				end
			end

			class NoUnderlyingReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43061
					order[1] = 43062
					order[2] = 43063
					order[3] = 0
					super(43060, 43061, order)
				end
			end

			class NoUnderlyingReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 43009
					order[1] = 43071
					order[2] = 43010
					order[3] = 43011
					order[4] = 43012
					order[5] = 43013
					order[6] = 43014
					order[7] = 43015
					order[8] = 43016
					order[9] = 43017
					order[10] = 43018
					order[11] = 43019
					order[12] = 43020
					order[13] = 43021
					order[14] = 43022
					order[15] = 43023
					order[16] = 43024
					order[17] = 43025
					order[18] = 43026
					order[19] = 43027
					order[20] = 43028
					order[21] = 43029
					order[22] = 43069
					order[23] = 0
					super(43008, 43009, order)
				end

				class NoUnderlyingReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 43072
						order[1] = 43073
						order[2] = 0
						super(43071, 43072, order)
					end
				end

				class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43070
						order[1] = 0
						super(43069, 43070, order)
					end
				end
			end
		end

		class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42916
				order[1] = 0
				super(42915, 42916, order)
			end
		end

		class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42902
				order[1] = 42903
				order[2] = 0
				super(42901, 42902, order)
			end
		end

		class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40650
				order[1] = 0
				super(40968, 40650, order)
			end
		end

		class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40657
				order[1] = 40658
				order[2] = 0
				super(40656, 40657, order)
			end
		end

		class NoUnderlyingSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40660
				order[1] = 40904
				order[2] = 40915
				order[3] = 40662
				order[4] = 40663
				order[5] = 0
				super(40659, 40660, order)
			end
		end

		class NoUnderlyingPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40665
				order[1] = 41881
				order[2] = 41882
				order[3] = 40666
				order[4] = 40667
				order[5] = 40668
				order[6] = 40669
				order[7] = 40670
				order[8] = 40671
				order[9] = 40672
				order[10] = 40673
				order[11] = 40674
				order[12] = 40675
				order[13] = 41883
				order[14] = 41884
				order[15] = 41885
				order[16] = 41886
				order[17] = 40676
				order[18] = 40677
				order[19] = 40678
				order[20] = 40679
				order[21] = 41887
				order[22] = 41888
				order[23] = 41889
				order[24] = 41890
				order[25] = 40680
				order[26] = 40681
				order[27] = 40682
				order[28] = 40683
				order[29] = 40684
				order[30] = 40685
				order[31] = 40704
				order[32] = 40686
				order[33] = 40687
				order[34] = 40688
				order[35] = 40689
				order[36] = 40966
				order[37] = 40691
				order[38] = 40692
				order[39] = 40693
				order[40] = 41891
				order[41] = 41892
				order[42] = 40694
				order[43] = 41878
				order[44] = 41893
				order[45] = 41894
				order[46] = 41895
				order[47] = 41896
				order[48] = 40695
				order[49] = 40696
				order[50] = 40697
				order[51] = 40698
				order[52] = 40967
				order[53] = 40700
				order[54] = 40701
				order[55] = 40702
				order[56] = 40703
				order[57] = 0
				super(40664, 40665, order)
			end

			class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40705
					order[1] = 40706
					order[2] = 40707
					order[3] = 0
					super(40704, 40705, order)
				end
			end

			class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40690
					order[1] = 0
					super(40966, 40690, order)
				end
			end

			class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41879
					order[1] = 41880
					order[2] = 0
					super(41878, 41879, order)
				end
			end

			class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40699
					order[1] = 0
					super(40967, 40699, order)
				end
			end
		end

		class NoUnderlyingPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40709
				order[1] = 40710
				order[2] = 42993
				order[3] = 42994
				order[4] = 42995
				order[5] = 42996
				order[6] = 42997
				order[7] = 42998
				order[8] = 42999
				order[9] = 42984
				order[10] = 42985
				order[11] = 42986
				order[12] = 42987
				order[13] = 42988
				order[14] = 42989
				order[15] = 42990
				order[16] = 40711
				order[17] = 40712
				order[18] = 40713
				order[19] = 40714
				order[20] = 40715
				order[21] = 40716
				order[22] = 40717
				order[23] = 40718
				order[24] = 40719
				order[25] = 40720
				order[26] = 40721
				order[27] = 40722
				order[28] = 40723
				order[29] = 40724
				order[30] = 40725
				order[31] = 40726
				order[32] = 40727
				order[33] = 40728
				order[34] = 40729
				order[35] = 40730
				order[36] = 40731
				order[37] = 40732
				order[38] = 40733
				order[39] = 40734
				order[40] = 40735
				order[41] = 40736
				order[42] = 40737
				order[43] = 0
				super(40708, 40709, order)
			end

			class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 43001
					order[1] = 0
					super(43000, 43001, order)
				end
			end

			class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42992
					order[1] = 0
					super(42991, 42992, order)
				end
			end
		end

		class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41809
				order[1] = 0
				super(41808, 41809, order)
			end
		end

		class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41805
				order[1] = 41806
				order[2] = 41807
				order[3] = 0
				super(41804, 41805, order)
			end
		end

		class NoUnderlyingDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41757
				order[1] = 41758
				order[2] = 41759
				order[3] = 41760
				order[4] = 41761
				order[5] = 41762
				order[6] = 41763
				order[7] = 41764
				order[8] = 41765
				order[9] = 41766
				order[10] = 41767
				order[11] = 41768
				order[12] = 41769
				order[13] = 41770
				order[14] = 0
				super(41756, 41757, order)
			end

			class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41771
					order[1] = 41772
					order[2] = 41773
					order[3] = 0
					super(41770, 41771, order)
				end

				class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41774
						order[1] = 41775
						order[2] = 41776
						order[3] = 0
						super(41773, 41774, order)
					end
				end
			end
		end
	end

	class NoUnderlyingProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 42150
			order[1] = 42151
			order[2] = 42152
			order[3] = 42190
			order[4] = 42153
			order[5] = 42154
			order[6] = 42155
			order[7] = 43002
			order[8] = 43003
			order[9] = 42156
			order[10] = 42157
			order[11] = 42158
			order[12] = 42104
			order[13] = 42105
			order[14] = 42106
			order[15] = 42107
			order[16] = 42108
			order[17] = 42109
			order[18] = 42110
			order[19] = 42111
			order[20] = 42115
			order[21] = 42116
			order[22] = 42117
			order[23] = 42118
			order[24] = 42119
			order[25] = 42120
			order[26] = 42121
			order[27] = 42122
			order[28] = 42123
			order[29] = 42124
			order[30] = 42125
			order[31] = 42126
			order[32] = 42127
			order[33] = 42128
			order[34] = 42129
			order[35] = 42130
			order[36] = 42131
			order[37] = 42132
			order[38] = 42133
			order[39] = 42134
			order[40] = 42135
			order[41] = 42136
			order[42] = 42137
			order[43] = 42138
			order[44] = 42139
			order[45] = 42140
			order[46] = 42141
			order[47] = 42142
			order[48] = 42143
			order[49] = 42144
			order[50] = 42145
			order[51] = 42146
			order[52] = 42147
			order[53] = 42148
			order[54] = 42159
			order[55] = 42160
			order[56] = 42161
			order[57] = 42162
			order[58] = 42163
			order[59] = 42164
			order[60] = 42165
			order[61] = 42092
			order[62] = 42093
			order[63] = 42094
			order[64] = 42095
			order[65] = 42096
			order[66] = 42097
			order[67] = 42098
			order[68] = 42166
			order[69] = 42167
			order[70] = 42168
			order[71] = 42169
			order[72] = 42102
			order[73] = 42103
			order[74] = 42170
			order[75] = 42171
			order[76] = 42172
			order[77] = 42173
			order[78] = 0
			super(42149, 42150, order)
		end

		class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42191
				order[1] = 0
				super(42190, 42191, order)
			end
		end

		class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42183
				order[1] = 0
				super(42182, 42183, order)
			end
		end

		class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42185
				order[1] = 0
				super(42184, 42185, order)
			end
		end

		class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42113
				order[1] = 42114
				order[2] = 0
				super(42112, 42113, order)
			end
		end

		class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42187
				order[1] = 0
				super(42186, 42187, order)
			end
		end

		class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42189
				order[1] = 0
				super(42188, 42189, order)
			end
		end

		class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42181
				order[1] = 0
				super(42180, 42181, order)
			end
		end

		class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42100
				order[1] = 42101
				order[2] = 0
				super(42099, 42100, order)
			end
		end

		class NoUnderlyingProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42174
				order[1] = 42175
				order[2] = 42176
				order[3] = 40918
				order[4] = 42177
				order[5] = 0
				super(42173, 42174, order)
			end

			class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42178
					order[1] = 42179
					order[2] = 0
					super(42177, 42178, order)
				end
			end
		end
	end

	class NoUnderlyingAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 42037
			order[1] = 42038
			order[2] = 41340
			order[3] = 0
			super(42036, 42037, order)
		end

		class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 41341
				order[1] = 41701
				order[2] = 41709
				order[3] = 41710
				order[4] = 41711
				order[5] = 41712
				order[6] = 42017
				order[7] = 42025
				order[8] = 42026
				order[9] = 42027
				order[10] = 42028
				order[11] = 42029
				order[12] = 42030
				order[13] = 42031
				order[14] = 42032
				order[15] = 42033
				order[16] = 42034
				order[17] = 42035
				order[18] = 0
				super(41340, 41341, order)
			end
		end
	end

	class NoUnderlyingProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 42069
			order[1] = 42070
			order[2] = 42071
			order[3] = 42072
			order[4] = 42073
			order[5] = 42074
			order[6] = 42075
			order[7] = 42090
			order[8] = 42077
			order[9] = 42087
			order[10] = 42076
			order[11] = 0
			super(42068, 42069, order)
		end

		class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42091
				order[1] = 0
				super(42090, 42091, order)
			end
		end

		class NoUnderlyingProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 42078
				order[1] = 42079
				order[2] = 42080
				order[3] = 42081
				order[4] = 42082
				order[5] = 42083
				order[6] = 42084
				order[7] = 42085
				order[8] = 0
				super(42077, 42078, order)
			end

			class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42086
					order[1] = 0
					super(42085, 42086, order)
				end
			end
		end

		class NoUnderlyingProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42088
				order[1] = 42089
				order[2] = 0
				super(42087, 42088, order)
			end
		end
	end

	class NoUnderlyingCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 42042
			order[1] = 42043
			order[2] = 42044
			order[3] = 42045
			order[4] = 42046
			order[5] = 42047
			order[6] = 42048
			order[7] = 42049
			order[8] = 42050
			order[9] = 42051
			order[10] = 42052
			order[11] = 42039
			order[12] = 42797
			order[13] = 42798
			order[14] = 42053
			order[15] = 42054
			order[16] = 42790
			order[17] = 42791
			order[18] = 42792
			order[19] = 42793
			order[20] = 42794
			order[21] = 42795
			order[22] = 42796
			order[23] = 42055
			order[24] = 42056
			order[25] = 42057
			order[26] = 42058
			order[27] = 42059
			order[28] = 0
			super(42041, 42042, order)
		end

		class NoUnderlyingCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42040
				order[1] = 0
				super(42039, 42040, order)
			end
		end

		class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42789
				order[1] = 0
				super(42788, 42789, order)
			end
		end
	end

	class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 42065
			order[1] = 42061
			order[2] = 42062
			order[3] = 42063
			order[4] = 42064
			order[5] = 0
			super(42060, 42065, order)
		end

		class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42066
				order[1] = 42067
				order[2] = 0
				super(42065, 42066, order)
			end
		end
	end

	class NoUnderlyingRateSpreadSteps < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 43006
			order[1] = 43007
			order[2] = 0
			super(43005, 43006, order)
		end
	end

	class NoUnderlyingDividendPayments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 42856
			order[1] = 42857
			order[2] = 42858
			order[3] = 42859
			order[4] = 0
			super(42855, 42856, order)
		end
	end

	class NoUnderlyingExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42885
			order[1] = 42886
			order[2] = 0
			super(42884, 42885, order)
		end
	end
end

class NewOrderCross < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("s") )
	end

	class NoRootPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1117
			order[1] = 1118
			order[2] = 1119
			order[3] = 2388
			order[4] = 1120
			order[5] = 0
			super(1116, 1117, order)
		end

		class NoRootPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1121
				order[1] = 1122
				order[2] = 0
				super(1120, 1121, order)
			end
		end
	end

	class NoSides < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(58)
			order[0] = 54
			order[1] = 2102
			order[2] = 41
			order[3] = 11
			order[4] = 526
			order[5] = 583
			order[6] = 586
			order[7] = 453
			order[8] = 1829
			order[9] = 1690
			order[10] = 229
			order[11] = 75
			order[12] = 1
			order[13] = 660
			order[14] = 581
			order[15] = 589
			order[16] = 590
			order[17] = 591
			order[18] = 70
			order[19] = 78
			order[20] = 854
			order[21] = 38
			order[22] = 152
			order[23] = 516
			order[24] = 468
			order[25] = 469
			order[26] = 12
			order[27] = 13
			order[28] = 479
			order[29] = 2922
			order[30] = 1233
			order[31] = 1238
			order[32] = 497
			order[33] = 2639
			order[34] = 528
			order[35] = 529
			order[36] = 1724
			order[37] = 1725
			order[38] = 1726
			order[39] = 2883
			order[40] = 1091
			order[41] = 582
			order[42] = 121
			order[43] = 120
			order[44] = 2899
			order[45] = 775
			order[46] = 58
			order[47] = 354
			order[48] = 355
			order[49] = 1816
			order[50] = 77
			order[51] = 203
			order[52] = 544
			order[53] = 635
			order[54] = 377
			order[55] = 659
			order[56] = 962
			order[57] = 0
			super(552, 54, order)
		end

		class NoPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 448
				order[1] = 447
				order[2] = 452
				order[3] = 2376
				order[4] = 802
				order[5] = 0
				super(453, 448, order)
			end

			class NoPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 523
					order[1] = 803
					order[2] = 0
					super(802, 523, order)
				end
			end
		end

		class NoCrossLegs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(20)
				order[0] = 654
				order[1] = 685
				order[2] = 690
				order[3] = 683
				order[4] = 1366
				order[5] = 670
				order[6] = 1817
				order[7] = 564
				order[8] = 565
				order[9] = 948
				order[10] = 587
				order[11] = 588
				order[12] = 675
				order[13] = 2900
				order[14] = 1379
				order[15] = 1381
				order[16] = 1383
				order[17] = 1384
				order[18] = 1689
				order[19] = 0
				super(1829, 654, order)
			end

			class NoLegStipulations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 688
					order[1] = 689
					order[2] = 0
					super(683, 688, order)
				end
			end

			class NoLegAllocs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 671
					order[1] = 672
					order[2] = 756
					order[3] = 673
					order[4] = 674
					order[5] = 1367
					order[6] = 2928
					order[7] = 1756
					order[8] = 1757
					order[9] = 1758
					order[10] = 1759
					order[11] = 0
					super(670, 671, order)
				end

				class NoNested2PartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 757
						order[1] = 758
						order[2] = 759
						order[3] = 2381
						order[4] = 806
						order[5] = 0
						super(756, 757, order)
					end

					class NoNested2PartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 760
							order[1] = 807
							order[2] = 0
							super(806, 760, order)
						end
					end
				end
			end

			class NoNested3PartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 949
					order[1] = 950
					order[2] = 951
					order[3] = 2382
					order[4] = 952
					order[5] = 0
					super(948, 949, order)
				end

				class NoNested3PartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 953
						order[1] = 954
						order[2] = 0
						super(952, 953, order)
					end
				end
			end
		end

		class NoAllocs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(14)
				order[0] = 79
				order[1] = 661
				order[2] = 736
				order[3] = 2927
				order[4] = 467
				order[5] = 2727
				order[6] = 539
				order[7] = 209
				order[8] = 80
				order[9] = 1752
				order[10] = 1753
				order[11] = 1754
				order[12] = 1755
				order[13] = 0
				super(78, 79, order)
			end

			class NoNestedPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 524
					order[1] = 525
					order[2] = 538
					order[3] = 2384
					order[4] = 804
					order[5] = 0
					super(539, 524, order)
				end

				class NoNestedPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 545
						order[1] = 805
						order[2] = 0
						super(804, 545, order)
					end
				end
			end
		end

		class NoCommissions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(17)
				order[0] = 2640
				order[1] = 2641
				order[2] = 2725
				order[3] = 2642
				order[4] = 2643
				order[5] = 2923
				order[6] = 2644
				order[7] = 2645
				order[8] = 2924
				order[9] = 2646
				order[10] = 2647
				order[11] = 2648
				order[12] = 2649
				order[13] = 2650
				order[14] = 2651
				order[15] = 2652
				order[16] = 0
				super(2639, 2640, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoTradingSessions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 336
			order[1] = 625
			order[2] = 0
			super(386, 336, order)
		end
	end

	class NoStipulations < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 233
			order[1] = 234
			order[2] = 0
			super(232, 233, order)
		end
	end

	class NoStrategyParameters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 958
			order[1] = 959
			order[2] = 960
			order[3] = 0
			super(957, 958, order)
		end
	end
end

class CrossOrderCancelReplaceRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("t") )
	end

	class NoRootPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1117
			order[1] = 1118
			order[2] = 1119
			order[3] = 2388
			order[4] = 1120
			order[5] = 0
			super(1116, 1117, order)
		end

		class NoRootPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1121
				order[1] = 1122
				order[2] = 0
				super(1120, 1121, order)
			end
		end
	end

	class NoSides < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(58)
			order[0] = 54
			order[1] = 2102
			order[2] = 41
			order[3] = 11
			order[4] = 526
			order[5] = 583
			order[6] = 586
			order[7] = 453
			order[8] = 1829
			order[9] = 1690
			order[10] = 229
			order[11] = 75
			order[12] = 1
			order[13] = 660
			order[14] = 581
			order[15] = 589
			order[16] = 590
			order[17] = 591
			order[18] = 70
			order[19] = 78
			order[20] = 854
			order[21] = 38
			order[22] = 152
			order[23] = 516
			order[24] = 468
			order[25] = 469
			order[26] = 12
			order[27] = 13
			order[28] = 479
			order[29] = 2922
			order[30] = 1233
			order[31] = 1238
			order[32] = 497
			order[33] = 2639
			order[34] = 528
			order[35] = 529
			order[36] = 1724
			order[37] = 1725
			order[38] = 1726
			order[39] = 2883
			order[40] = 1091
			order[41] = 582
			order[42] = 121
			order[43] = 120
			order[44] = 2899
			order[45] = 775
			order[46] = 58
			order[47] = 354
			order[48] = 355
			order[49] = 1816
			order[50] = 77
			order[51] = 203
			order[52] = 544
			order[53] = 635
			order[54] = 377
			order[55] = 659
			order[56] = 962
			order[57] = 0
			super(552, 54, order)
		end

		class NoPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 448
				order[1] = 447
				order[2] = 452
				order[3] = 2376
				order[4] = 802
				order[5] = 0
				super(453, 448, order)
			end

			class NoPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 523
					order[1] = 803
					order[2] = 0
					super(802, 523, order)
				end
			end
		end

		class NoCrossLegs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(20)
				order[0] = 654
				order[1] = 685
				order[2] = 690
				order[3] = 683
				order[4] = 1366
				order[5] = 670
				order[6] = 1817
				order[7] = 564
				order[8] = 565
				order[9] = 948
				order[10] = 587
				order[11] = 588
				order[12] = 675
				order[13] = 2900
				order[14] = 1379
				order[15] = 1381
				order[16] = 1383
				order[17] = 1384
				order[18] = 1689
				order[19] = 0
				super(1829, 654, order)
			end

			class NoLegStipulations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 688
					order[1] = 689
					order[2] = 0
					super(683, 688, order)
				end
			end

			class NoLegAllocs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 671
					order[1] = 672
					order[2] = 756
					order[3] = 673
					order[4] = 674
					order[5] = 1367
					order[6] = 2928
					order[7] = 1756
					order[8] = 1757
					order[9] = 1758
					order[10] = 1759
					order[11] = 0
					super(670, 671, order)
				end

				class NoNested2PartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 757
						order[1] = 758
						order[2] = 759
						order[3] = 2381
						order[4] = 806
						order[5] = 0
						super(756, 757, order)
					end

					class NoNested2PartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 760
							order[1] = 807
							order[2] = 0
							super(806, 760, order)
						end
					end
				end
			end

			class NoNested3PartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 949
					order[1] = 950
					order[2] = 951
					order[3] = 2382
					order[4] = 952
					order[5] = 0
					super(948, 949, order)
				end

				class NoNested3PartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 953
						order[1] = 954
						order[2] = 0
						super(952, 953, order)
					end
				end
			end
		end

		class NoAllocs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(14)
				order[0] = 79
				order[1] = 661
				order[2] = 736
				order[3] = 2927
				order[4] = 467
				order[5] = 2727
				order[6] = 539
				order[7] = 209
				order[8] = 80
				order[9] = 1752
				order[10] = 1753
				order[11] = 1754
				order[12] = 1755
				order[13] = 0
				super(78, 79, order)
			end

			class NoNestedPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 524
					order[1] = 525
					order[2] = 538
					order[3] = 2384
					order[4] = 804
					order[5] = 0
					super(539, 524, order)
				end

				class NoNestedPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 545
						order[1] = 805
						order[2] = 0
						super(804, 545, order)
					end
				end
			end
		end

		class NoCommissions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(17)
				order[0] = 2640
				order[1] = 2641
				order[2] = 2725
				order[3] = 2642
				order[4] = 2643
				order[5] = 2923
				order[6] = 2644
				order[7] = 2645
				order[8] = 2924
				order[9] = 2646
				order[10] = 2647
				order[11] = 2648
				order[12] = 2649
				order[13] = 2650
				order[14] = 2651
				order[15] = 2652
				order[16] = 0
				super(2639, 2640, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoTradingSessions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 336
			order[1] = 625
			order[2] = 0
			super(386, 336, order)
		end
	end

	class NoStipulations < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 233
			order[1] = 234
			order[2] = 0
			super(232, 233, order)
		end
	end

	class NoStrategyParameters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 958
			order[1] = 959
			order[2] = 960
			order[3] = 0
			super(957, 958, order)
		end
	end
end

class CrossOrderCancelRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("u") )
	end

	class NoRootPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1117
			order[1] = 1118
			order[2] = 1119
			order[3] = 2388
			order[4] = 1120
			order[5] = 0
			super(1116, 1117, order)
		end

		class NoRootPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1121
				order[1] = 1122
				order[2] = 0
				super(1120, 1121, order)
			end
		end
	end

	class NoSides < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(22)
			order[0] = 54
			order[1] = 41
			order[2] = 11
			order[3] = 526
			order[4] = 583
			order[5] = 586
			order[6] = 453
			order[7] = 229
			order[8] = 75
			order[9] = 38
			order[10] = 152
			order[11] = 516
			order[12] = 468
			order[13] = 469
			order[14] = 376
			order[15] = 2404
			order[16] = 2351
			order[17] = 2352
			order[18] = 58
			order[19] = 354
			order[20] = 355
			order[21] = 0
			super(552, 54, order)
		end

		class NoPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 448
				order[1] = 447
				order[2] = 452
				order[3] = 2376
				order[4] = 802
				order[5] = 0
				super(453, 448, order)
			end

			class NoPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 523
					order[1] = 803
					order[2] = 0
					super(802, 523, order)
				end
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end
end

class SecurityTypeRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("v") )
	end
end

class SecurityTypes < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("w") )
	end

	class NoSecurityTypes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 167
			order[1] = 762
			order[2] = 460
			order[3] = 461
			order[4] = 2891
			order[5] = 60
			order[6] = 0
			super(558, 167, order)
		end
	end
end

class SecurityListRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("x") )
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoInstrAttrib < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 871
			order[1] = 872
			order[2] = 0
			super(870, 871, order)
		end
	end

	class NoIndexRollMonths < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2733
			order[1] = 0
			super(2734, 2733, order)
		end
	end

	class NoReferenceDataDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2747
			order[1] = 2748
			order[2] = 0
			super(2746, 2747, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoRelatedInstruments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 1648
			order[1] = 1649
			order[2] = 1650
			order[3] = 1651
			order[4] = 1652
			order[5] = 1653
			order[6] = 2413
			order[7] = 2414
			order[8] = 2415
			order[9] = 2417
			order[10] = 0
			super(1647, 1648, order)
		end
	end
end

class SecurityList < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("y") )
	end

	class NoRelatedSym < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(211)
			order[0] = 55
			order[1] = 65
			order[2] = 48
			order[3] = 22
			order[4] = 460
			order[5] = 1227
			order[6] = 1151
			order[7] = 461
			order[8] = 2891
			order[9] = 167
			order[10] = 762
			order[11] = 200
			order[12] = 541
			order[13] = 1079
			order[14] = 966
			order[15] = 1049
			order[16] = 965
			order[17] = 224
			order[18] = 1449
			order[19] = 1450
			order[20] = 1451
			order[21] = 1452
			order[22] = 1457
			order[23] = 1458
			order[24] = 1739
			order[25] = 2210
			order[26] = 1938
			order[27] = 1939
			order[28] = 1940
			order[29] = 2735
			order[30] = 1941
			order[31] = 1575
			order[32] = 1942
			order[33] = 1943
			order[34] = 1944
			order[35] = 1945
			order[36] = 1946
			order[37] = 1947
			order[38] = 1948
			order[39] = 1949
			order[40] = 1950
			order[41] = 2879
			order[42] = 1951
			order[43] = 1952
			order[44] = 1953
			order[45] = 1954
			order[46] = 1955
			order[47] = 1956
			order[48] = 1957
			order[49] = 1958
			order[50] = 1959
			order[51] = 1960
			order[52] = 1577
			order[53] = 1580
			order[54] = 1581
			order[55] = 1678
			order[56] = 1697
			order[57] = 225
			order[58] = 239
			order[59] = 226
			order[60] = 227
			order[61] = 228
			order[62] = 255
			order[63] = 543
			order[64] = 470
			order[65] = 471
			order[66] = 472
			order[67] = 240
			order[68] = 202
			order[69] = 2578
			order[70] = 2577
			order[71] = 947
			order[72] = 2904
			order[73] = 967
			order[74] = 968
			order[75] = 1698
			order[76] = 1866
			order[77] = 2600
			order[78] = 2001
			order[79] = 2601
			order[80] = 1478
			order[81] = 1479
			order[82] = 1480
			order[83] = 1481
			order[84] = 206
			order[85] = 231
			order[86] = 1435
			order[87] = 2353
			order[88] = 1439
			order[89] = 969
			order[90] = 1146
			order[91] = 996
			order[92] = 1147
			order[93] = 1716
			order[94] = 2905
			order[95] = 1191
			order[96] = 1192
			order[97] = 1717
			order[98] = 2906
			order[99] = 1193
			order[100] = 2579
			order[101] = 1194
			order[102] = 1482
			order[103] = 1195
			order[104] = 2753
			order[105] = 1196
			order[106] = 1197
			order[107] = 2002
			order[108] = 2140
			order[109] = 1524
			order[110] = 2907
			order[111] = 1198
			order[112] = 1199
			order[113] = 1200
			order[114] = 201
			order[115] = 2681
			order[116] = 2685
			order[117] = 1244
			order[118] = 1242
			order[119] = 2575
			order[120] = 2574
			order[121] = 997
			order[122] = 223
			order[123] = 207
			order[124] = 970
			order[125] = 971
			order[126] = 106
			order[127] = 348
			order[128] = 349
			order[129] = 2737
			order[130] = 2714
			order[131] = 2715
			order[132] = 2716
			order[133] = 107
			order[134] = 350
			order[135] = 351
			order[136] = 691
			order[137] = 667
			order[138] = 875
			order[139] = 876
			order[140] = 873
			order[141] = 874
			order[142] = 1687
			order[143] = 1787
			order[144] = 2141
			order[145] = 2142
			order[146] = 2143
			order[147] = 2752
			order[148] = 2144
			order[149] = 2145
			order[150] = 2576
			order[151] = 2962
			order[152] = 2602
			order[153] = 2603
			order[154] = 668
			order[155] = 869
			order[156] = 2736
			order[157] = 2738
			order[158] = 1582
			order[159] = 913
			order[160] = 914
			order[161] = 1961
			order[162] = 915
			order[163] = 918
			order[164] = 2952
			order[165] = 1962
			order[166] = 1963
			order[167] = 1964
			order[168] = 1965
			order[169] = 1966
			order[170] = 1967
			order[171] = 1968
			order[172] = 1969
			order[173] = 1970
			order[174] = 1513
			order[175] = 1525
			order[176] = 1527
			order[177] = 788
			order[178] = 916
			order[179] = 917
			order[180] = 919
			order[181] = 898
			order[182] = 1201
			order[183] = 711
			order[184] = 15
			order[185] = 2897
			order[186] = 232
			order[187] = 555
			order[188] = 1647
			order[189] = 218
			order[190] = 220
			order[191] = 2950
			order[192] = 221
			order[193] = 222
			order[194] = 662
			order[195] = 663
			order[196] = 699
			order[197] = 761
			order[198] = 235
			order[199] = 236
			order[200] = 701
			order[201] = 696
			order[202] = 697
			order[203] = 698
			order[204] = 1919
			order[205] = 1504
			order[206] = 1606
			order[207] = 58
			order[208] = 354
			order[209] = 355
			order[210] = 0
			super(146, 55, order)
		end

		class NoSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 455
				order[1] = 456
				order[2] = 2957
				order[3] = 0
				super(454, 455, order)
			end
		end

		class NoSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1977
				order[1] = 1978
				order[2] = 1979
				order[3] = 2741
				order[4] = 0
				super(1976, 1977, order)
			end
		end

		class NoAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2305
				order[1] = 2306
				order[2] = 2307
				order[3] = 0
				super(2304, 2305, order)
			end
		end

		class NoEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 865
				order[1] = 866
				order[2] = 1145
				order[3] = 1827
				order[4] = 1826
				order[5] = 2340
				order[6] = 867
				order[7] = 868
				order[8] = 1578
				order[9] = 1579
				order[10] = 0
				super(864, 865, order)
			end
		end

		class NoInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1019
				order[1] = 1050
				order[2] = 1051
				order[3] = 2378
				order[4] = 1052
				order[5] = 0
				super(1018, 1019, order)
			end

			class NoInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1053
					order[1] = 1054
					order[2] = 0
					super(1052, 1053, order)
				end
			end
		end

		class NoComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 1484
				order[1] = 2117
				order[2] = 2118
				order[3] = 2119
				order[4] = 1485
				order[5] = 2120
				order[6] = 2121
				order[7] = 2122
				order[8] = 2941
				order[9] = 1486
				order[10] = 2123
				order[11] = 1487
				order[12] = 1488
				order[13] = 1489
				order[14] = 1490
				order[15] = 1491
				order[16] = 2124
				order[17] = 2942
				order[18] = 2125
				order[19] = 2943
				order[20] = 2126
				order[21] = 2127
				order[22] = 2407
				order[23] = 2408
				order[24] = 2128
				order[25] = 2129
				order[26] = 2130
				order[27] = 2131
				order[28] = 2132
				order[29] = 41013
				order[30] = 41020
				order[31] = 41021
				order[32] = 41022
				order[33] = 41023
				order[34] = 41024
				order[35] = 41025
				order[36] = 41026
				order[37] = 41027
				order[38] = 41028
				order[39] = 41010
				order[40] = 2133
				order[41] = 2134
				order[42] = 2135
				order[43] = 2136
				order[44] = 2137
				order[45] = 41029
				order[46] = 40997
				order[47] = 2597
				order[48] = 2598
				order[49] = 2599
				order[50] = 2138
				order[51] = 2139
				order[52] = 0
				super(1483, 1484, order)
			end

			class NoComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1492
					order[1] = 1493
					order[2] = 1494
					order[3] = 0
					super(1491, 1492, order)
				end

				class NoComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1495
						order[1] = 1496
						order[2] = 0
						super(1494, 1495, order)
					end
				end
			end

			class NoComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41014
					order[1] = 41015
					order[2] = 41016
					order[3] = 41017
					order[4] = 0
					super(41013, 41014, order)
				end
			end

			class NoComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41019
					order[1] = 0
					super(41018, 41019, order)
				end
			end

			class NoComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41011
					order[1] = 41012
					order[2] = 41031
					order[3] = 41007
					order[4] = 40994
					order[5] = 0
					super(41010, 41011, order)
				end

				class NoComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41032
						order[1] = 41033
						order[2] = 41034
						order[3] = 41035
						order[4] = 41036
						order[5] = 0
						super(41031, 41032, order)
					end
				end

				class NoComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41008
						order[1] = 41009
						order[2] = 0
						super(41007, 41008, order)
					end
				end

				class NoComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40995
						order[1] = 40996
						order[2] = 0
						super(40994, 40995, order)
					end
				end
			end

			class NoComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41030
					order[1] = 0
					super(41029, 41030, order)
				end
			end

			class NoComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40998
					order[1] = 40999
					order[2] = 41000
					order[3] = 41001
					order[4] = 41002
					order[5] = 41003
					order[6] = 41004
					order[7] = 41005
					order[8] = 0
					super(40997, 40998, order)
				end

				class NoComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41006
						order[1] = 0
						super(41005, 41006, order)
					end
				end
			end
		end

		class NoBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40471
				order[1] = 0
				super(40278, 40471, order)
			end
		end

		class NoPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41231
				order[1] = 0
				super(41230, 41231, order)
			end
		end

		class NoMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41093
				order[1] = 40991
				order[2] = 0
				super(41092, 41093, order)
			end
		end

		class NoMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41095
				order[1] = 40992
				order[2] = 0
				super(41094, 41095, order)
			end
		end

		class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41097
				order[1] = 41098
				order[2] = 41099
				order[3] = 41100
				order[4] = 41101
				order[5] = 41102
				order[6] = 41103
				order[7] = 41104
				order[8] = 41105
				order[9] = 0
				super(41096, 41097, order)
			end
		end

		class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42776
				order[1] = 0
				super(42775, 42776, order)
			end
		end

		class NoOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41117
				order[1] = 0
				super(41116, 41117, order)
			end
		end

		class NoOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41138
				order[1] = 41139
				order[2] = 0
				super(41137, 41138, order)
			end
		end

		class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41141
				order[1] = 0
				super(41140, 41141, order)
			end
		end

		class NoOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41153
				order[1] = 41154
				order[2] = 0
				super(41152, 41153, order)
			end
		end

		class NoStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40050
				order[1] = 41303
				order[2] = 40051
				order[3] = 42784
				order[4] = 42785
				order[5] = 40052
				order[6] = 40053
				order[7] = 41305
				order[8] = 40054
				order[9] = 40055
				order[10] = 42786
				order[11] = 42787
				order[12] = 41306
				order[13] = 41307
				order[14] = 41308
				order[15] = 41309
				order[16] = 41310
				order[17] = 41311
				order[18] = 41251
				order[19] = 41252
				order[20] = 41253
				order[21] = 41254
				order[22] = 41255
				order[23] = 41256
				order[24] = 41257
				order[25] = 42587
				order[26] = 41258
				order[27] = 41259
				order[28] = 41260
				order[29] = 41261
				order[30] = 41262
				order[31] = 41263
				order[32] = 41264
				order[33] = 41265
				order[34] = 41266
				order[35] = 41267
				order[36] = 41268
				order[37] = 41269
				order[38] = 41270
				order[39] = 41271
				order[40] = 41272
				order[41] = 41273
				order[42] = 41274
				order[43] = 41275
				order[44] = 41276
				order[45] = 40907
				order[46] = 40908
				order[47] = 40910
				order[48] = 40911
				order[49] = 40912
				order[50] = 40913
				order[51] = 40914
				order[52] = 40065
				order[53] = 40066
				order[54] = 40068
				order[55] = 40069
				order[56] = 40070
				order[57] = 40071
				order[58] = 40072
				order[59] = 41244
				order[60] = 41245
				order[61] = 40073
				order[62] = 40075
				order[63] = 40076
				order[64] = 40078
				order[65] = 40079
				order[66] = 40080
				order[67] = 40081
				order[68] = 40082
				order[69] = 40083
				order[70] = 40084
				order[71] = 41246
				order[72] = 41247
				order[73] = 41248
				order[74] = 40738
				order[75] = 40739
				order[76] = 40740
				order[77] = 42600
				order[78] = 40741
				order[79] = 40742
				order[80] = 43106
				order[81] = 40743
				order[82] = 40744
				order[83] = 40745
				order[84] = 40746
				order[85] = 40747
				order[86] = 42601
				order[87] = 42602
				order[88] = 42603
				order[89] = 42604
				order[90] = 40748
				order[91] = 40749
				order[92] = 40750
				order[93] = 41180
				order[94] = 41181
				order[95] = 41182
				order[96] = 41183
				order[97] = 41184
				order[98] = 41185
				order[99] = 41186
				order[100] = 42605
				order[101] = 40828
				order[102] = 40872
				order[103] = 41058
				order[104] = 41059
				order[105] = 41060
				order[106] = 41061
				order[107] = 41062
				order[108] = 42192
				order[109] = 42193
				order[110] = 41063
				order[111] = 41064
				order[112] = 41065
				order[113] = 41066
				order[114] = 41067
				order[115] = 41218
				order[116] = 41068
				order[117] = 41069
				order[118] = 41070
				order[119] = 41071
				order[120] = 41072
				order[121] = 41073
				order[122] = 41074
				order[123] = 41075
				order[124] = 41076
				order[125] = 41077
				order[126] = 41078
				order[127] = 41079
				order[128] = 41080
				order[129] = 43094
				order[130] = 41037
				order[131] = 40056
				order[132] = 40982
				order[133] = 40983
				order[134] = 0
				super(40049, 40050, order)
			end

			class NoStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41278
					order[1] = 41279
					order[2] = 0
					super(41277, 41278, order)
				end
			end

			class NoStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41238
					order[1] = 41239
					order[2] = 41240
					order[3] = 0
					super(41237, 41238, order)
				end
			end

			class NoStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41281
					order[1] = 41282
					order[2] = 0
					super(41280, 41281, order)
				end
			end

			class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41250
					order[1] = 0
					super(41249, 41250, order)
				end
			end

			class NoStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41290
					order[1] = 41291
					order[2] = 41292
					order[3] = 41293
					order[4] = 41294
					order[5] = 41295
					order[6] = 41296
					order[7] = 41297
					order[8] = 41298
					order[9] = 41299
					order[10] = 41300
					order[11] = 41283
					order[12] = 41301
					order[13] = 41302
					order[14] = 0
					super(41289, 41290, order)
				end

				class NoStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41284
						order[1] = 41285
						order[2] = 41286
						order[3] = 0
						super(41283, 41284, order)
					end

					class NoStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41287
							order[1] = 41288
							order[2] = 41588
							order[3] = 0
							super(41286, 41287, order)
						end
					end
				end
			end

			class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40909
					order[1] = 0
					super(40960, 40909, order)
				end
			end

			class NoStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40067
					order[1] = 0
					super(40961, 40067, order)
				end
			end

			class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40074
					order[1] = 0
					super(40958, 40074, order)
				end
			end

			class NoStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41242
					order[1] = 41243
					order[2] = 0
					super(41241, 41242, order)
				end
			end

			class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40077
					order[1] = 0
					super(40959, 40077, order)
				end
			end

			class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40752
					order[1] = 0
					super(40947, 40752, order)
				end
			end

			class NoPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41221
					order[1] = 41222
					order[2] = 0
					super(41220, 41221, order)
				end
			end

			class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40763
					order[1] = 0
					super(40948, 40763, order)
				end
			end

			class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40769
					order[1] = 0
					super(40949, 40769, order)
				end
			end

			class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40776
					order[1] = 0
					super(40950, 40776, order)
				end
			end

			class NoPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42661
					order[1] = 42662
					order[2] = 0
					super(42660, 42661, order)
				end
			end

			class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41193
					order[1] = 0
					super(41192, 41193, order)
				end
			end

			class NoPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41228
					order[1] = 41229
					order[2] = 0
					super(41227, 41228, order)
				end
			end

			class NoPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41225
					order[1] = 41226
					order[2] = 0
					super(41224, 41225, order)
				end
			end

			class NoPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43109
					order[1] = 42684
					order[2] = 42685
					order[3] = 0
					super(42683, 43109, order)
				end
			end

			class NoDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42275
					order[1] = 42276
					order[2] = 42277
					order[3] = 42278
					order[4] = 42279
					order[5] = 42280
					order[6] = 42294
					order[7] = 42281
					order[8] = 42282
					order[9] = 42283
					order[10] = 42284
					order[11] = 42285
					order[12] = 42286
					order[13] = 42287
					order[14] = 42288
					order[15] = 42289
					order[16] = 42290
					order[17] = 42291
					order[18] = 42292
					order[19] = 42293
					order[20] = 0
					super(42274, 42275, order)
				end

				class NoDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42295
						order[1] = 0
						super(42294, 42295, order)
					end
				end
			end

			class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42273
					order[1] = 0
					super(42272, 42273, order)
				end
			end

			class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42237
					order[1] = 0
					super(42236, 42237, order)
				end
			end

			class NoReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42736
					order[1] = 42737
					order[2] = 42738
					order[3] = 42739
					order[4] = 42740
					order[5] = 42741
					order[6] = 42765
					order[7] = 42731
					order[8] = 42742
					order[9] = 42743
					order[10] = 42744
					order[11] = 42745
					order[12] = 42746
					order[13] = 42747
					order[14] = 42748
					order[15] = 42749
					order[16] = 42750
					order[17] = 42751
					order[18] = 42752
					order[19] = 42753
					order[20] = 42761
					order[21] = 42754
					order[22] = 42755
					order[23] = 42709
					order[24] = 42756
					order[25] = 42757
					order[26] = 42758
					order[27] = 42759
					order[28] = 42760
					order[29] = 0
					super(42735, 42736, order)
				end

				class NoReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42766
						order[1] = 42767
						order[2] = 42768
						order[3] = 42769
						order[4] = 0
						super(42765, 42766, order)
					end
				end

				class NoReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42732
						order[1] = 42733
						order[2] = 42734
						order[3] = 0
						super(42731, 42732, order)
					end
				end

				class NoReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42762
						order[1] = 42763
						order[2] = 42764
						order[3] = 0
						super(42761, 42762, order)
					end
				end

				class NoReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42710
						order[1] = 42772
						order[2] = 42711
						order[3] = 42712
						order[4] = 42713
						order[5] = 42714
						order[6] = 42715
						order[7] = 42716
						order[8] = 42717
						order[9] = 42718
						order[10] = 42719
						order[11] = 42720
						order[12] = 42721
						order[13] = 42722
						order[14] = 42723
						order[15] = 42724
						order[16] = 42725
						order[17] = 42726
						order[18] = 42727
						order[19] = 42728
						order[20] = 42729
						order[21] = 42730
						order[22] = 42770
						order[23] = 0
						super(42709, 42710, order)
					end

					class NoReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42773
							order[1] = 42774
							order[2] = 0
							super(42772, 42773, order)
						end
					end

					class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42771
							order[1] = 0
							super(42770, 42771, order)
						end
					end
				end
			end

			class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42621
					order[1] = 0
					super(42620, 42621, order)
				end
			end

			class NoPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42607
					order[1] = 42608
					order[2] = 0
					super(42606, 42607, order)
				end
			end

			class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40819
					order[1] = 0
					super(40946, 40819, order)
				end
			end

			class NoNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40826
					order[1] = 40827
					order[2] = 0
					super(40825, 40826, order)
				end
			end

			class NoSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40086
					order[1] = 40373
					order[2] = 40655
					order[3] = 40088
					order[4] = 40089
					order[5] = 0
					super(40085, 40086, order)
				end
			end

			class NoPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40829
					order[1] = 41164
					order[2] = 41165
					order[3] = 40830
					order[4] = 40831
					order[5] = 40832
					order[6] = 40833
					order[7] = 40834
					order[8] = 40835
					order[9] = 40836
					order[10] = 40837
					order[11] = 40838
					order[12] = 40839
					order[13] = 41166
					order[14] = 41167
					order[15] = 41168
					order[16] = 41169
					order[17] = 40840
					order[18] = 40841
					order[19] = 40842
					order[20] = 40843
					order[21] = 41170
					order[22] = 41171
					order[23] = 41172
					order[24] = 41173
					order[25] = 40844
					order[26] = 40845
					order[27] = 40846
					order[28] = 40847
					order[29] = 40848
					order[30] = 40849
					order[31] = 40868
					order[32] = 40850
					order[33] = 40851
					order[34] = 40852
					order[35] = 40853
					order[36] = 40977
					order[37] = 40855
					order[38] = 40856
					order[39] = 40857
					order[40] = 41174
					order[41] = 41175
					order[42] = 40858
					order[43] = 41161
					order[44] = 41176
					order[45] = 41177
					order[46] = 41178
					order[47] = 41179
					order[48] = 40859
					order[49] = 40860
					order[50] = 40861
					order[51] = 40862
					order[52] = 40945
					order[53] = 40864
					order[54] = 40865
					order[55] = 40866
					order[56] = 40867
					order[57] = 0
					super(40828, 40829, order)
				end

				class NoPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40869
						order[1] = 40870
						order[2] = 40871
						order[3] = 0
						super(40868, 40869, order)
					end
				end

				class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40854
						order[1] = 0
						super(40977, 40854, order)
					end
				end

				class NoPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41162
						order[1] = 41163
						order[2] = 0
						super(41161, 41162, order)
					end
				end

				class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40863
						order[1] = 0
						super(40945, 40863, order)
					end
				end
			end

			class NoPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40873
					order[1] = 40874
					order[2] = 42698
					order[3] = 42699
					order[4] = 42700
					order[5] = 42701
					order[6] = 42702
					order[7] = 42703
					order[8] = 42704
					order[9] = 42689
					order[10] = 42690
					order[11] = 42691
					order[12] = 42692
					order[13] = 42693
					order[14] = 42694
					order[15] = 42695
					order[16] = 40875
					order[17] = 40876
					order[18] = 40877
					order[19] = 40878
					order[20] = 40879
					order[21] = 40880
					order[22] = 40881
					order[23] = 40882
					order[24] = 40883
					order[25] = 40884
					order[26] = 40885
					order[27] = 40886
					order[28] = 40887
					order[29] = 40888
					order[30] = 40889
					order[31] = 40890
					order[32] = 40891
					order[33] = 40892
					order[34] = 40893
					order[35] = 40894
					order[36] = 40895
					order[37] = 40896
					order[38] = 40897
					order[39] = 40898
					order[40] = 40899
					order[41] = 40900
					order[42] = 40901
					order[43] = 0
					super(40872, 40873, order)
				end

				class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42706
						order[1] = 0
						super(42705, 42706, order)
					end
				end

				class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42697
						order[1] = 0
						super(42696, 42697, order)
					end
				end
			end

			class NoDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41086
					order[1] = 0
					super(41085, 41086, order)
				end
			end

			class NoDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41082
					order[1] = 41083
					order[2] = 41084
					order[3] = 0
					super(41081, 41082, order)
				end
			end

			class NoDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41038
					order[1] = 41039
					order[2] = 41040
					order[3] = 41041
					order[4] = 41042
					order[5] = 41043
					order[6] = 41044
					order[7] = 41045
					order[8] = 41046
					order[9] = 41047
					order[10] = 41048
					order[11] = 41049
					order[12] = 41050
					order[13] = 41051
					order[14] = 0
					super(41037, 41038, order)
				end

				class NoDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41052
						order[1] = 41053
						order[2] = 41054
						order[3] = 0
						super(41051, 41052, order)
					end

					class NoDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41055
							order[1] = 41056
							order[2] = 41057
							order[3] = 0
							super(41054, 41055, order)
						end
					end
				end
			end
		end

		class NoProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40091
				order[1] = 40092
				order[2] = 40093
				order[3] = 40957
				order[4] = 40095
				order[5] = 40096
				order[6] = 40097
				order[7] = 42707
				order[8] = 42708
				order[9] = 40098
				order[10] = 40099
				order[11] = 40100
				order[12] = 40114
				order[13] = 40115
				order[14] = 40116
				order[15] = 40118
				order[16] = 40119
				order[17] = 40120
				order[18] = 40121
				order[19] = 40122
				order[20] = 40123
				order[21] = 40125
				order[22] = 40126
				order[23] = 40127
				order[24] = 40128
				order[25] = 40129
				order[26] = 40130
				order[27] = 40131
				order[28] = 40132
				order[29] = 40133
				order[30] = 40134
				order[31] = 40135
				order[32] = 40136
				order[33] = 40137
				order[34] = 40138
				order[35] = 40139
				order[36] = 40140
				order[37] = 40141
				order[38] = 40145
				order[39] = 40146
				order[40] = 40148
				order[41] = 40149
				order[42] = 40150
				order[43] = 40151
				order[44] = 40152
				order[45] = 40153
				order[46] = 40154
				order[47] = 40155
				order[48] = 40156
				order[49] = 40158
				order[50] = 40159
				order[51] = 40160
				order[52] = 40161
				order[53] = 40162
				order[54] = 40101
				order[55] = 40102
				order[56] = 40103
				order[57] = 40104
				order[58] = 40105
				order[59] = 40106
				order[60] = 40107
				order[61] = 40163
				order[62] = 40165
				order[63] = 40166
				order[64] = 40167
				order[65] = 40168
				order[66] = 40169
				order[67] = 40170
				order[68] = 40108
				order[69] = 40109
				order[70] = 40110
				order[71] = 40111
				order[72] = 40112
				order[73] = 41406
				order[74] = 40113
				order[75] = 40986
				order[76] = 40987
				order[77] = 40174
				order[78] = 0
				super(40090, 40091, order)
			end

			class NoProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40094
					order[1] = 0
					super(40957, 40094, order)
				end
			end

			class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40117
					order[1] = 0
					super(40953, 40117, order)
				end
			end

			class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40124
					order[1] = 0
					super(40954, 40124, order)
				end
			end

			class NoProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40143
					order[1] = 40144
					order[2] = 0
					super(40142, 40143, order)
				end
			end

			class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40147
					order[1] = 0
					super(40955, 40147, order)
				end
			end

			class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40157
					order[1] = 0
					super(40956, 40157, order)
				end
			end

			class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40164
					order[1] = 0
					super(40952, 40164, order)
				end
			end

			class NoProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40172
					order[1] = 40173
					order[2] = 0
					super(40171, 40172, order)
				end
			end

			class NoProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40175
					order[1] = 40176
					order[2] = 40177
					order[3] = 2385
					order[4] = 40178
					order[5] = 0
					super(40174, 40175, order)
				end

				class NoProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40179
						order[1] = 40180
						order[2] = 0
						super(40178, 40179, order)
					end
				end
			end
		end

		class NoAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40020
				order[1] = 40021
				order[2] = 40000
				order[3] = 0
				super(40019, 40020, order)
			end

			class NoAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 40001
					order[1] = 40002
					order[2] = 40003
					order[3] = 40004
					order[4] = 40005
					order[5] = 40006
					order[6] = 40007
					order[7] = 40008
					order[8] = 40009
					order[9] = 40010
					order[10] = 40011
					order[11] = 40012
					order[12] = 40013
					order[13] = 40014
					order[14] = 40015
					order[15] = 40016
					order[16] = 40017
					order[17] = 40018
					order[18] = 0
					super(40000, 40001, order)
				end
			end
		end

		class NoProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 40182
				order[1] = 40183
				order[2] = 40184
				order[3] = 40185
				order[4] = 40186
				order[5] = 40187
				order[6] = 40188
				order[7] = 40951
				order[8] = 40191
				order[9] = 40201
				order[10] = 40190
				order[11] = 0
				super(40181, 40182, order)
			end

			class NoProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40189
					order[1] = 0
					super(40951, 40189, order)
				end
			end

			class NoProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40192
					order[1] = 40193
					order[2] = 40194
					order[3] = 40195
					order[4] = 40196
					order[5] = 40197
					order[6] = 40198
					order[7] = 40199
					order[8] = 0
					super(40191, 40192, order)
				end

				class NoProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40200
						order[1] = 0
						super(40199, 40200, order)
					end
				end
			end

			class NoProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40202
					order[1] = 40203
					order[2] = 0
					super(40201, 40202, order)
				end
			end
		end

		class NoCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 40023
				order[1] = 40024
				order[2] = 40916
				order[3] = 40917
				order[4] = 40025
				order[5] = 40026
				order[6] = 40027
				order[7] = 40028
				order[8] = 40029
				order[9] = 40030
				order[10] = 40031
				order[11] = 40277
				order[12] = 42216
				order[13] = 42217
				order[14] = 40033
				order[15] = 40034
				order[16] = 42207
				order[17] = 42208
				order[18] = 42209
				order[19] = 42210
				order[20] = 42211
				order[21] = 42212
				order[22] = 42213
				order[23] = 40035
				order[24] = 40036
				order[25] = 40037
				order[26] = 40038
				order[27] = 40039
				order[28] = 0
				super(40022, 40023, order)
			end

			class NoCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40032
					order[1] = 0
					super(40277, 40032, order)
				end
			end

			class NoCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42215
					order[1] = 0
					super(42214, 42215, order)
				end
			end
		end

		class NoPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40209
				order[1] = 40205
				order[2] = 40206
				order[3] = 40207
				order[4] = 40208
				order[5] = 0
				super(40204, 40209, order)
			end

			class NoPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40210
					order[1] = 40211
					order[2] = 0
					super(40209, 40210, order)
				end
			end
		end

		class NoExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42297
				order[1] = 42298
				order[2] = 0
				super(42296, 42297, order)
			end
		end

		class NoInstrAttrib < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 871
				order[1] = 872
				order[2] = 0
				super(870, 871, order)
			end
		end

		class NoIndexRollMonths < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 2733
				order[1] = 0
				super(2734, 2733, order)
			end
		end

		class NoReferenceDataDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2747
				order[1] = 2748
				order[2] = 0
				super(2746, 2747, order)
			end
		end

		class NoSecurityClassifications < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1583
				order[1] = 1584
				order[2] = 0
				super(1582, 1583, order)
			end
		end

		class NoContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40041
				order[1] = 0
				super(40040, 40041, order)
			end
		end

		class NoFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40047
				order[1] = 40048
				order[2] = 0
				super(40046, 40047, order)
			end
		end

		class NoContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40043
				order[1] = 40044
				order[2] = 40045
				order[3] = 0
				super(40042, 40043, order)
			end
		end

		class NoTickRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(8)
				order[0] = 1206
				order[1] = 1207
				order[2] = 1208
				order[3] = 1209
				order[4] = 2571
				order[5] = 1830
				order[6] = 1831
				order[7] = 0
				super(1205, 1206, order)
			end
		end

		class NoLotTypeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1093
				order[1] = 1231
				order[2] = 0
				super(1234, 1093, order)
			end
		end

		class NoPriceRangeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 2551
				order[1] = 2552
				order[2] = 2553
				order[3] = 2554
				order[4] = 2556
				order[5] = 2555
				order[6] = 0
				super(2550, 2551, order)
			end
		end

		class NoQuoteSizeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 647
				order[1] = 648
				order[2] = 2447
				order[3] = 0
				super(2558, 647, order)
			end
		end

		class NoTradingSessionRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 336
				order[1] = 625
				order[2] = 0
				super(1309, 336, order)
			end

			class NoOrdTypeRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40
					order[1] = 0
					super(1237, 40, order)
				end
			end

			class NoTimeInForceRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 59
					order[1] = 0
					super(1239, 59, order)
				end
			end

			class NoExecInstRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 1308
					order[1] = 0
					super(1232, 1308, order)
				end
			end

			class NoAuctionTypeRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1803
					order[1] = 2549
					order[2] = 0
					super(2548, 1803, order)
				end
			end

			class NoMatchRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 1142
					order[1] = 574
					order[2] = 2569
					order[3] = 2570
					order[4] = 0
					super(1235, 1142, order)
				end
			end

			class NoMDFeedTypes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 1022
					order[1] = 1683
					order[2] = 264
					order[3] = 2563
					order[4] = 2564
					order[5] = 2565
					order[6] = 2566
					order[7] = 1021
					order[8] = 1173
					order[9] = 2567
					order[10] = 2568
					order[11] = 0
					super(1141, 1022, order)
				end
			end
		end

		class NoNestedInstrAttrib < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1210
				order[1] = 1211
				order[2] = 0
				super(1312, 1210, order)
			end
		end

		class NoStrikeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 1223
				order[1] = 1202
				order[2] = 1203
				order[3] = 1204
				order[4] = 1304
				order[5] = 1236
				order[6] = 0
				super(1201, 1223, order)
			end

			class NoMaturityRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(7)
					order[0] = 1222
					order[1] = 1303
					order[2] = 1302
					order[3] = 1241
					order[4] = 1226
					order[5] = 1229
					order[6] = 0
					super(1236, 1222, order)
				end
			end
		end

		class NoUnderlyings < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(188)
				order[0] = 311
				order[1] = 312
				order[2] = 309
				order[3] = 305
				order[4] = 2874
				order[5] = 462
				order[6] = 463
				order[7] = 2894
				order[8] = 310
				order[9] = 763
				order[10] = 313
				order[11] = 542
				order[12] = 1213
				order[13] = 1837
				order[14] = 241
				order[15] = 1453
				order[16] = 1454
				order[17] = 2614
				order[18] = 2615
				order[19] = 2921
				order[20] = 2616
				order[21] = 2617
				order[22] = 2619
				order[23] = 1455
				order[24] = 1456
				order[25] = 1459
				order[26] = 1460
				order[27] = 242
				order[28] = 243
				order[29] = 244
				order[30] = 245
				order[31] = 246
				order[32] = 256
				order[33] = 595
				order[34] = 592
				order[35] = 593
				order[36] = 594
				order[37] = 247
				order[38] = 316
				order[39] = 941
				order[40] = 2917
				order[41] = 317
				order[42] = 436
				order[43] = 1437
				order[44] = 2363
				order[45] = 1441
				order[46] = 998
				order[47] = 1423
				order[48] = 1718
				order[49] = 2918
				order[50] = 1424
				order[51] = 1425
				order[52] = 1719
				order[53] = 2919
				order[54] = 1000
				order[55] = 1419
				order[56] = 1526
				order[57] = 2920
				order[58] = 435
				order[59] = 308
				order[60] = 306
				order[61] = 362
				order[62] = 363
				order[63] = 2742
				order[64] = 2720
				order[65] = 2721
				order[66] = 2722
				order[67] = 2723
				order[68] = 2724
				order[69] = 307
				order[70] = 364
				order[71] = 365
				order[72] = 877
				order[73] = 878
				order[74] = 972
				order[75] = 318
				order[76] = 2916
				order[77] = 879
				order[78] = 975
				order[79] = 973
				order[80] = 974
				order[81] = 810
				order[82] = 882
				order[83] = 883
				order[84] = 884
				order[85] = 885
				order[86] = 886
				order[87] = 2885
				order[88] = 2886
				order[89] = 1044
				order[90] = 1045
				order[91] = 1046
				order[92] = 1038
				order[93] = 1039
				order[94] = 315
				order[95] = 2683
				order[96] = 2687
				order[97] = 1988
				order[98] = 1989
				order[99] = 1990
				order[100] = 1991
				order[101] = 1992
				order[102] = 1993
				order[103] = 2881
				order[104] = 1994
				order[105] = 1995
				order[106] = 1996
				order[107] = 1997
				order[108] = 2620
				order[109] = 2621
				order[110] = 1998
				order[111] = 1999
				order[112] = 2000
				order[113] = 2003
				order[114] = 2004
				order[115] = 2005
				order[116] = 2006
				order[117] = 2284
				order[118] = 2285
				order[119] = 2286
				order[120] = 2287
				order[121] = 2288
				order[122] = 2007
				order[123] = 2008
				order[124] = 2009
				order[125] = 2010
				order[126] = 2011
				order[127] = 2012
				order[128] = 2491
				order[129] = 2013
				order[130] = 2014
				order[131] = 2015
				order[132] = 2744
				order[133] = 2016
				order[134] = 2289
				order[135] = 2017
				order[136] = 2018
				order[137] = 2019
				order[138] = 2020
				order[139] = 2021
				order[140] = 2022
				order[141] = 2290
				order[142] = 2622
				order[143] = 2291
				order[144] = 2623
				order[145] = 2292
				order[146] = 2023
				order[147] = 2024
				order[148] = 2025
				order[149] = 2026
				order[150] = 2027
				order[151] = 2028
				order[152] = 2029
				order[153] = 2757
				order[154] = 2030
				order[155] = 2031
				order[156] = 2293
				order[157] = 2294
				order[158] = 2032
				order[159] = 2033
				order[160] = 2034
				order[161] = 2035
				order[162] = 2036
				order[163] = 2037
				order[164] = 2038
				order[165] = 2039
				order[166] = 2040
				order[167] = 2041
				order[168] = 2042
				order[169] = 2043
				order[170] = 2044
				order[171] = 41314
				order[172] = 41315
				order[173] = 2295
				order[174] = 2296
				order[175] = 2297
				order[176] = 2756
				order[177] = 2298
				order[178] = 2299
				order[179] = 2624
				order[180] = 2625
				order[181] = 2626
				order[182] = 2627
				order[183] = 2628
				order[184] = 2629
				order[185] = 2630
				order[186] = 2631
				order[187] = 0
				super(711, 311, order)
			end

			class NoUnderlyingSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 458
					order[1] = 459
					order[2] = 2959
					order[3] = 0
					super(457, 458, order)
				end
			end

			class NoUnderlyingStips < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 888
					order[1] = 889
					order[2] = 0
					super(887, 888, order)
				end
			end

			class NoUndlyInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 1059
					order[1] = 1060
					order[2] = 1061
					order[3] = 2391
					order[4] = 1062
					order[5] = 0
					super(1058, 1059, order)
				end

				class NoUndlyInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1063
						order[1] = 1064
						order[2] = 0
						super(1062, 1063, order)
					end
				end
			end

			class NoUnderlyingEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 1982
					order[1] = 1983
					order[2] = 1984
					order[3] = 1985
					order[4] = 1986
					order[5] = 2342
					order[6] = 1987
					order[7] = 2071
					order[8] = 2072
					order[9] = 2073
					order[10] = 0
					super(1981, 1982, order)
				end
			end

			class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2081
					order[1] = 2082
					order[2] = 2083
					order[3] = 2745
					order[4] = 0
					super(2080, 2081, order)
				end
			end

			class NoUnderlyingAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2313
					order[1] = 2314
					order[2] = 2315
					order[3] = 0
					super(2312, 2313, order)
				end
			end

			class NoUnderlyingComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2046
					order[1] = 2261
					order[2] = 2262
					order[3] = 2263
					order[4] = 2047
					order[5] = 2264
					order[6] = 2265
					order[7] = 2266
					order[8] = 2947
					order[9] = 2048
					order[10] = 2267
					order[11] = 2049
					order[12] = 2050
					order[13] = 2051
					order[14] = 2052
					order[15] = 2053
					order[16] = 2268
					order[17] = 2948
					order[18] = 2269
					order[19] = 2949
					order[20] = 2270
					order[21] = 2271
					order[22] = 2419
					order[23] = 2420
					order[24] = 2272
					order[25] = 2273
					order[26] = 2274
					order[27] = 2275
					order[28] = 2276
					order[29] = 41732
					order[30] = 41739
					order[31] = 41740
					order[32] = 41741
					order[33] = 41742
					order[34] = 41743
					order[35] = 41744
					order[36] = 41745
					order[37] = 41746
					order[38] = 41747
					order[39] = 41729
					order[40] = 2277
					order[41] = 2278
					order[42] = 2279
					order[43] = 2280
					order[44] = 2281
					order[45] = 41748
					order[46] = 41716
					order[47] = 2611
					order[48] = 2612
					order[49] = 2613
					order[50] = 2282
					order[51] = 2283
					order[52] = 0
					super(2045, 2046, order)
				end

				class NoUnderlyingComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2054
						order[1] = 2055
						order[2] = 2056
						order[3] = 0
						super(2053, 2054, order)
					end

					class NoUnderlyingComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2057
							order[1] = 2058
							order[2] = 0
							super(2056, 2057, order)
						end
					end
				end

				class NoUnderlyingComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41733
						order[1] = 41734
						order[2] = 41735
						order[3] = 41736
						order[4] = 0
						super(41732, 41733, order)
					end
				end

				class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41738
						order[1] = 0
						super(41737, 41738, order)
					end
				end

				class NoUnderlyingComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41730
						order[1] = 41731
						order[2] = 41750
						order[3] = 41726
						order[4] = 41713
						order[5] = 0
						super(41729, 41730, order)
					end

					class NoUnderlyingComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41751
							order[1] = 41752
							order[2] = 41753
							order[3] = 41754
							order[4] = 41755
							order[5] = 0
							super(41750, 41751, order)
						end
					end

					class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41727
							order[1] = 41728
							order[2] = 0
							super(41726, 41727, order)
						end
					end

					class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41714
							order[1] = 41715
							order[2] = 0
							super(41713, 41714, order)
						end
					end
				end

				class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41749
						order[1] = 0
						super(41748, 41749, order)
					end
				end

				class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41717
						order[1] = 41718
						order[2] = 41719
						order[3] = 41720
						order[4] = 41721
						order[5] = 41722
						order[6] = 41723
						order[7] = 41724
						order[8] = 0
						super(41716, 41717, order)
					end

					class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41725
							order[1] = 0
							super(41724, 41725, order)
						end
					end
				end
			end

			class NoUnderlyingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40963
					order[1] = 0
					super(40962, 40963, order)
				end
			end

			class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41948
					order[1] = 0
					super(41947, 41948, order)
				end
			end

			class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41865
					order[1] = 41338
					order[2] = 0
					super(41864, 41865, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41867
					order[1] = 41339
					order[2] = 0
					super(41866, 41867, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41869
					order[1] = 41870
					order[2] = 41871
					order[3] = 41872
					order[4] = 41873
					order[5] = 41874
					order[6] = 41875
					order[7] = 41876
					order[8] = 41877
					order[9] = 0
					super(41868, 41869, order)
				end
			end

			class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 43075
					order[1] = 0
					super(43074, 43075, order)
				end
			end

			class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41821
					order[1] = 0
					super(41820, 41821, order)
				end
			end

			class NoUnderlyingOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41842
					order[1] = 41843
					order[2] = 0
					super(41841, 41842, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41845
					order[1] = 0
					super(41844, 41845, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41857
					order[1] = 41858
					order[2] = 0
					super(41856, 41857, order)
				end
			end

			class NoUnderlyingStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40541
					order[1] = 42016
					order[2] = 40542
					order[3] = 43083
					order[4] = 43084
					order[5] = 40543
					order[6] = 40544
					order[7] = 42018
					order[8] = 40545
					order[9] = 40546
					order[10] = 43085
					order[11] = 43086
					order[12] = 42019
					order[13] = 42020
					order[14] = 42021
					order[15] = 42022
					order[16] = 42023
					order[17] = 42024
					order[18] = 41964
					order[19] = 41965
					order[20] = 41966
					order[21] = 41967
					order[22] = 41968
					order[23] = 41969
					order[24] = 41970
					order[25] = 42589
					order[26] = 41971
					order[27] = 41972
					order[28] = 41973
					order[29] = 41974
					order[30] = 41975
					order[31] = 41976
					order[32] = 41977
					order[33] = 41978
					order[34] = 41979
					order[35] = 41980
					order[36] = 41981
					order[37] = 41982
					order[38] = 41983
					order[39] = 41984
					order[40] = 41985
					order[41] = 41986
					order[42] = 41987
					order[43] = 41988
					order[44] = 41989
					order[45] = 40057
					order[46] = 40058
					order[47] = 40060
					order[48] = 40061
					order[49] = 40062
					order[50] = 40063
					order[51] = 40064
					order[52] = 40548
					order[53] = 40549
					order[54] = 40551
					order[55] = 40552
					order[56] = 40553
					order[57] = 40554
					order[58] = 40555
					order[59] = 41957
					order[60] = 41958
					order[61] = 40556
					order[62] = 40558
					order[63] = 40559
					order[64] = 40561
					order[65] = 40562
					order[66] = 40563
					order[67] = 40564
					order[68] = 40565
					order[69] = 40566
					order[70] = 40567
					order[71] = 41959
					order[72] = 41960
					order[73] = 41961
					order[74] = 40568
					order[75] = 40569
					order[76] = 40570
					order[77] = 42895
					order[78] = 40571
					order[79] = 40572
					order[80] = 43107
					order[81] = 40573
					order[82] = 40574
					order[83] = 40575
					order[84] = 40576
					order[85] = 40577
					order[86] = 42896
					order[87] = 42897
					order[88] = 42898
					order[89] = 42899
					order[90] = 40578
					order[91] = 40579
					order[92] = 40580
					order[93] = 41897
					order[94] = 41898
					order[95] = 41899
					order[96] = 41900
					order[97] = 41901
					order[98] = 41902
					order[99] = 41903
					order[100] = 42900
					order[101] = 40664
					order[102] = 40708
					order[103] = 41777
					order[104] = 41778
					order[105] = 41779
					order[106] = 41780
					order[107] = 41781
					order[108] = 42196
					order[109] = 42197
					order[110] = 41782
					order[111] = 41783
					order[112] = 41784
					order[113] = 41785
					order[114] = 41786
					order[115] = 41587
					order[116] = 41787
					order[117] = 41788
					order[118] = 41789
					order[119] = 41790
					order[120] = 41791
					order[121] = 41792
					order[122] = 41793
					order[123] = 41794
					order[124] = 41795
					order[125] = 41796
					order[126] = 41797
					order[127] = 41798
					order[128] = 41799
					order[129] = 43096
					order[130] = 41756
					order[131] = 40547
					order[132] = 40988
					order[133] = 40989
					order[134] = 0
					super(40540, 40541, order)
				end

				class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41991
						order[1] = 41992
						order[2] = 0
						super(41990, 41991, order)
					end
				end

				class NoUnderlyingStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41801
						order[1] = 41802
						order[2] = 41803
						order[3] = 0
						super(41800, 41801, order)
					end
				end

				class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41994
						order[1] = 41995
						order[2] = 0
						super(41993, 41994, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41963
						order[1] = 0
						super(41962, 41963, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 42003
						order[1] = 42004
						order[2] = 42005
						order[3] = 42006
						order[4] = 42007
						order[5] = 42008
						order[6] = 42009
						order[7] = 42010
						order[8] = 42011
						order[9] = 42012
						order[10] = 42013
						order[11] = 41996
						order[12] = 42014
						order[13] = 42015
						order[14] = 0
						super(42002, 42003, order)
					end

					class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41997
							order[1] = 41998
							order[2] = 41999
							order[3] = 0
							super(41996, 41997, order)
						end

						class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 42000
								order[1] = 42001
								order[2] = 41936
								order[3] = 0
								super(41999, 42000, order)
							end
						end
					end
				end

				class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40059
						order[1] = 0
						super(40975, 40059, order)
					end
				end

				class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40550
						order[1] = 0
						super(40976, 40550, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40557
						order[1] = 0
						super(40973, 40557, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41955
						order[1] = 41956
						order[2] = 0
						super(41954, 41955, order)
					end
				end

				class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40560
						order[1] = 0
						super(40974, 40560, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40582
						order[1] = 0
						super(40969, 40582, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41938
						order[1] = 41939
						order[2] = 0
						super(41937, 41938, order)
					end
				end

				class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40594
						order[1] = 0
						super(40970, 40594, order)
					end
				end

				class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40600
						order[1] = 0
						super(40971, 40600, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40607
						order[1] = 0
						super(40972, 40607, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42956
						order[1] = 42957
						order[2] = 0
						super(42955, 42956, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41910
						order[1] = 0
						super(41909, 41910, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41945
						order[1] = 41946
						order[2] = 0
						super(41944, 41945, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41942
						order[1] = 41943
						order[2] = 0
						super(41941, 41942, order)
					end
				end

				class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43111
						order[1] = 42982
						order[2] = 42983
						order[3] = 0
						super(42981, 43111, order)
					end
				end

				class NoUnderlyingDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42863
						order[1] = 42864
						order[2] = 42865
						order[3] = 42866
						order[4] = 42867
						order[5] = 42868
						order[6] = 42882
						order[7] = 42869
						order[8] = 42870
						order[9] = 42871
						order[10] = 42872
						order[11] = 42873
						order[12] = 42874
						order[13] = 42875
						order[14] = 42876
						order[15] = 42877
						order[16] = 42878
						order[17] = 42879
						order[18] = 42880
						order[19] = 42881
						order[20] = 0
						super(42862, 42863, order)
					end

					class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42883
							order[1] = 0
							super(42882, 42883, order)
						end
					end
				end

				class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42854
						order[1] = 0
						super(42853, 42854, order)
					end
				end

				class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42800
						order[1] = 0
						super(42799, 42800, order)
					end
				end

				class NoUnderlyingReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 43035
						order[1] = 43036
						order[2] = 43037
						order[3] = 43038
						order[4] = 43039
						order[5] = 43040
						order[6] = 43064
						order[7] = 43030
						order[8] = 43041
						order[9] = 43042
						order[10] = 43043
						order[11] = 43044
						order[12] = 43045
						order[13] = 43046
						order[14] = 43047
						order[15] = 43048
						order[16] = 43049
						order[17] = 43050
						order[18] = 43051
						order[19] = 43052
						order[20] = 43060
						order[21] = 43053
						order[22] = 43054
						order[23] = 43008
						order[24] = 43055
						order[25] = 43056
						order[26] = 43057
						order[27] = 43058
						order[28] = 43059
						order[29] = 0
						super(43034, 43035, order)
					end

					class NoUnderlyingReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 43065
							order[1] = 43066
							order[2] = 43067
							order[3] = 43068
							order[4] = 0
							super(43064, 43065, order)
						end
					end

					class NoUnderlyingReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43031
							order[1] = 43032
							order[2] = 43033
							order[3] = 0
							super(43030, 43031, order)
						end
					end

					class NoUnderlyingReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43061
							order[1] = 43062
							order[2] = 43063
							order[3] = 0
							super(43060, 43061, order)
						end
					end

					class NoUnderlyingReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 43009
							order[1] = 43071
							order[2] = 43010
							order[3] = 43011
							order[4] = 43012
							order[5] = 43013
							order[6] = 43014
							order[7] = 43015
							order[8] = 43016
							order[9] = 43017
							order[10] = 43018
							order[11] = 43019
							order[12] = 43020
							order[13] = 43021
							order[14] = 43022
							order[15] = 43023
							order[16] = 43024
							order[17] = 43025
							order[18] = 43026
							order[19] = 43027
							order[20] = 43028
							order[21] = 43029
							order[22] = 43069
							order[23] = 0
							super(43008, 43009, order)
						end

						class NoUnderlyingReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 43072
								order[1] = 43073
								order[2] = 0
								super(43071, 43072, order)
							end
						end

						class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 43070
								order[1] = 0
								super(43069, 43070, order)
							end
						end
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42916
						order[1] = 0
						super(42915, 42916, order)
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42902
						order[1] = 42903
						order[2] = 0
						super(42901, 42902, order)
					end
				end

				class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40650
						order[1] = 0
						super(40968, 40650, order)
					end
				end

				class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40657
						order[1] = 40658
						order[2] = 0
						super(40656, 40657, order)
					end
				end

				class NoUnderlyingSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40660
						order[1] = 40904
						order[2] = 40915
						order[3] = 40662
						order[4] = 40663
						order[5] = 0
						super(40659, 40660, order)
					end
				end

				class NoUnderlyingPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40665
						order[1] = 41881
						order[2] = 41882
						order[3] = 40666
						order[4] = 40667
						order[5] = 40668
						order[6] = 40669
						order[7] = 40670
						order[8] = 40671
						order[9] = 40672
						order[10] = 40673
						order[11] = 40674
						order[12] = 40675
						order[13] = 41883
						order[14] = 41884
						order[15] = 41885
						order[16] = 41886
						order[17] = 40676
						order[18] = 40677
						order[19] = 40678
						order[20] = 40679
						order[21] = 41887
						order[22] = 41888
						order[23] = 41889
						order[24] = 41890
						order[25] = 40680
						order[26] = 40681
						order[27] = 40682
						order[28] = 40683
						order[29] = 40684
						order[30] = 40685
						order[31] = 40704
						order[32] = 40686
						order[33] = 40687
						order[34] = 40688
						order[35] = 40689
						order[36] = 40966
						order[37] = 40691
						order[38] = 40692
						order[39] = 40693
						order[40] = 41891
						order[41] = 41892
						order[42] = 40694
						order[43] = 41878
						order[44] = 41893
						order[45] = 41894
						order[46] = 41895
						order[47] = 41896
						order[48] = 40695
						order[49] = 40696
						order[50] = 40697
						order[51] = 40698
						order[52] = 40967
						order[53] = 40700
						order[54] = 40701
						order[55] = 40702
						order[56] = 40703
						order[57] = 0
						super(40664, 40665, order)
					end

					class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40705
							order[1] = 40706
							order[2] = 40707
							order[3] = 0
							super(40704, 40705, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40690
							order[1] = 0
							super(40966, 40690, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41879
							order[1] = 41880
							order[2] = 0
							super(41878, 41879, order)
						end
					end

					class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40699
							order[1] = 0
							super(40967, 40699, order)
						end
					end
				end

				class NoUnderlyingPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40709
						order[1] = 40710
						order[2] = 42993
						order[3] = 42994
						order[4] = 42995
						order[5] = 42996
						order[6] = 42997
						order[7] = 42998
						order[8] = 42999
						order[9] = 42984
						order[10] = 42985
						order[11] = 42986
						order[12] = 42987
						order[13] = 42988
						order[14] = 42989
						order[15] = 42990
						order[16] = 40711
						order[17] = 40712
						order[18] = 40713
						order[19] = 40714
						order[20] = 40715
						order[21] = 40716
						order[22] = 40717
						order[23] = 40718
						order[24] = 40719
						order[25] = 40720
						order[26] = 40721
						order[27] = 40722
						order[28] = 40723
						order[29] = 40724
						order[30] = 40725
						order[31] = 40726
						order[32] = 40727
						order[33] = 40728
						order[34] = 40729
						order[35] = 40730
						order[36] = 40731
						order[37] = 40732
						order[38] = 40733
						order[39] = 40734
						order[40] = 40735
						order[41] = 40736
						order[42] = 40737
						order[43] = 0
						super(40708, 40709, order)
					end

					class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43001
							order[1] = 0
							super(43000, 43001, order)
						end
					end

					class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42992
							order[1] = 0
							super(42991, 42992, order)
						end
					end
				end

				class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41809
						order[1] = 0
						super(41808, 41809, order)
					end
				end

				class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41805
						order[1] = 41806
						order[2] = 41807
						order[3] = 0
						super(41804, 41805, order)
					end
				end

				class NoUnderlyingDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41757
						order[1] = 41758
						order[2] = 41759
						order[3] = 41760
						order[4] = 41761
						order[5] = 41762
						order[6] = 41763
						order[7] = 41764
						order[8] = 41765
						order[9] = 41766
						order[10] = 41767
						order[11] = 41768
						order[12] = 41769
						order[13] = 41770
						order[14] = 0
						super(41756, 41757, order)
					end

					class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41771
							order[1] = 41772
							order[2] = 41773
							order[3] = 0
							super(41770, 41771, order)
						end

						class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41774
								order[1] = 41775
								order[2] = 41776
								order[3] = 0
								super(41773, 41774, order)
							end
						end
					end
				end
			end

			class NoUnderlyingProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 42150
					order[1] = 42151
					order[2] = 42152
					order[3] = 42190
					order[4] = 42153
					order[5] = 42154
					order[6] = 42155
					order[7] = 43002
					order[8] = 43003
					order[9] = 42156
					order[10] = 42157
					order[11] = 42158
					order[12] = 42104
					order[13] = 42105
					order[14] = 42106
					order[15] = 42107
					order[16] = 42108
					order[17] = 42109
					order[18] = 42110
					order[19] = 42111
					order[20] = 42115
					order[21] = 42116
					order[22] = 42117
					order[23] = 42118
					order[24] = 42119
					order[25] = 42120
					order[26] = 42121
					order[27] = 42122
					order[28] = 42123
					order[29] = 42124
					order[30] = 42125
					order[31] = 42126
					order[32] = 42127
					order[33] = 42128
					order[34] = 42129
					order[35] = 42130
					order[36] = 42131
					order[37] = 42132
					order[38] = 42133
					order[39] = 42134
					order[40] = 42135
					order[41] = 42136
					order[42] = 42137
					order[43] = 42138
					order[44] = 42139
					order[45] = 42140
					order[46] = 42141
					order[47] = 42142
					order[48] = 42143
					order[49] = 42144
					order[50] = 42145
					order[51] = 42146
					order[52] = 42147
					order[53] = 42148
					order[54] = 42159
					order[55] = 42160
					order[56] = 42161
					order[57] = 42162
					order[58] = 42163
					order[59] = 42164
					order[60] = 42165
					order[61] = 42092
					order[62] = 42093
					order[63] = 42094
					order[64] = 42095
					order[65] = 42096
					order[66] = 42097
					order[67] = 42098
					order[68] = 42166
					order[69] = 42167
					order[70] = 42168
					order[71] = 42169
					order[72] = 42102
					order[73] = 42103
					order[74] = 42170
					order[75] = 42171
					order[76] = 42172
					order[77] = 42173
					order[78] = 0
					super(42149, 42150, order)
				end

				class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42191
						order[1] = 0
						super(42190, 42191, order)
					end
				end

				class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42183
						order[1] = 0
						super(42182, 42183, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42185
						order[1] = 0
						super(42184, 42185, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42113
						order[1] = 42114
						order[2] = 0
						super(42112, 42113, order)
					end
				end

				class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42187
						order[1] = 0
						super(42186, 42187, order)
					end
				end

				class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42189
						order[1] = 0
						super(42188, 42189, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42181
						order[1] = 0
						super(42180, 42181, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42100
						order[1] = 42101
						order[2] = 0
						super(42099, 42100, order)
					end
				end

				class NoUnderlyingProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 42174
						order[1] = 42175
						order[2] = 42176
						order[3] = 40918
						order[4] = 42177
						order[5] = 0
						super(42173, 42174, order)
					end

					class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42178
							order[1] = 42179
							order[2] = 0
							super(42177, 42178, order)
						end
					end
				end
			end

			class NoUnderlyingAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42037
					order[1] = 42038
					order[2] = 41340
					order[3] = 0
					super(42036, 42037, order)
				end

				class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41341
						order[1] = 41701
						order[2] = 41709
						order[3] = 41710
						order[4] = 41711
						order[5] = 41712
						order[6] = 42017
						order[7] = 42025
						order[8] = 42026
						order[9] = 42027
						order[10] = 42028
						order[11] = 42029
						order[12] = 42030
						order[13] = 42031
						order[14] = 42032
						order[15] = 42033
						order[16] = 42034
						order[17] = 42035
						order[18] = 0
						super(41340, 41341, order)
					end
				end
			end

			class NoUnderlyingProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 42069
					order[1] = 42070
					order[2] = 42071
					order[3] = 42072
					order[4] = 42073
					order[5] = 42074
					order[6] = 42075
					order[7] = 42090
					order[8] = 42077
					order[9] = 42087
					order[10] = 42076
					order[11] = 0
					super(42068, 42069, order)
				end

				class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42091
						order[1] = 0
						super(42090, 42091, order)
					end
				end

				class NoUnderlyingProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 42078
						order[1] = 42079
						order[2] = 42080
						order[3] = 42081
						order[4] = 42082
						order[5] = 42083
						order[6] = 42084
						order[7] = 42085
						order[8] = 0
						super(42077, 42078, order)
					end

					class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42086
							order[1] = 0
							super(42085, 42086, order)
						end
					end
				end

				class NoUnderlyingProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42088
						order[1] = 42089
						order[2] = 0
						super(42087, 42088, order)
					end
				end
			end

			class NoUnderlyingCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 42042
					order[1] = 42043
					order[2] = 42044
					order[3] = 42045
					order[4] = 42046
					order[5] = 42047
					order[6] = 42048
					order[7] = 42049
					order[8] = 42050
					order[9] = 42051
					order[10] = 42052
					order[11] = 42039
					order[12] = 42797
					order[13] = 42798
					order[14] = 42053
					order[15] = 42054
					order[16] = 42790
					order[17] = 42791
					order[18] = 42792
					order[19] = 42793
					order[20] = 42794
					order[21] = 42795
					order[22] = 42796
					order[23] = 42055
					order[24] = 42056
					order[25] = 42057
					order[26] = 42058
					order[27] = 42059
					order[28] = 0
					super(42041, 42042, order)
				end

				class NoUnderlyingCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42040
						order[1] = 0
						super(42039, 42040, order)
					end
				end

				class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42789
						order[1] = 0
						super(42788, 42789, order)
					end
				end
			end

			class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42065
					order[1] = 42061
					order[2] = 42062
					order[3] = 42063
					order[4] = 42064
					order[5] = 0
					super(42060, 42065, order)
				end

				class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42066
						order[1] = 42067
						order[2] = 0
						super(42065, 42066, order)
					end
				end
			end

			class NoUnderlyingRateSpreadSteps < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 43006
					order[1] = 43007
					order[2] = 0
					super(43005, 43006, order)
				end
			end

			class NoUnderlyingDividendPayments < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42856
					order[1] = 42857
					order[2] = 42858
					order[3] = 42859
					order[4] = 0
					super(42855, 42856, order)
				end
			end

			class NoUnderlyingExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42885
					order[1] = 42886
					order[2] = 0
					super(42884, 42885, order)
				end
			end
		end

		class NoStipulations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 233
				order[1] = 234
				order[2] = 0
				super(232, 233, order)
			end
		end

		class NoLegs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(162)
				order[0] = 600
				order[1] = 601
				order[2] = 602
				order[3] = 603
				order[4] = 1788
				order[5] = 607
				order[6] = 1594
				order[7] = 608
				order[8] = 2893
				order[9] = 609
				order[10] = 764
				order[11] = 610
				order[12] = 611
				order[13] = 1212
				order[14] = 2146
				order[15] = 2147
				order[16] = 2148
				order[17] = 248
				order[18] = 2149
				order[19] = 2150
				order[20] = 2151
				order[21] = 2152
				order[22] = 2153
				order[23] = 2154
				order[24] = 2155
				order[25] = 2348
				order[26] = 2067
				order[27] = 2068
				order[28] = 2069
				order[29] = 2739
				order[30] = 2070
				order[31] = 2156
				order[32] = 2157
				order[33] = 2158
				order[34] = 2159
				order[35] = 2160
				order[36] = 2161
				order[37] = 2162
				order[38] = 2163
				order[39] = 2164
				order[40] = 2165
				order[41] = 2880
				order[42] = 2166
				order[43] = 2167
				order[44] = 2168
				order[45] = 2169
				order[46] = 2170
				order[47] = 2171
				order[48] = 2172
				order[49] = 2173
				order[50] = 2174
				order[51] = 2175
				order[52] = 2176
				order[53] = 2177
				order[54] = 2178
				order[55] = 2179
				order[56] = 2180
				order[57] = 249
				order[58] = 250
				order[59] = 251
				order[60] = 252
				order[61] = 253
				order[62] = 257
				order[63] = 599
				order[64] = 596
				order[65] = 597
				order[66] = 598
				order[67] = 254
				order[68] = 612
				order[69] = 942
				order[70] = 2908
				order[71] = 2181
				order[72] = 2182
				order[73] = 2183
				order[74] = 2184
				order[75] = 2604
				order[76] = 2185
				order[77] = 2605
				order[78] = 2186
				order[79] = 2187
				order[80] = 2188
				order[81] = 2189
				order[82] = 613
				order[83] = 614
				order[84] = 1436
				order[85] = 2354
				order[86] = 1440
				order[87] = 2190
				order[88] = 2191
				order[89] = 999
				order[90] = 1224
				order[91] = 1720
				order[92] = 2909
				order[93] = 1421
				order[94] = 1422
				order[95] = 1721
				order[96] = 2910
				order[97] = 2192
				order[98] = 1001
				order[99] = 1420
				order[100] = 2193
				order[101] = 2194
				order[102] = 2755
				order[103] = 2195
				order[104] = 2196
				order[105] = 2197
				order[106] = 2198
				order[107] = 1528
				order[108] = 2911
				order[109] = 2199
				order[110] = 2200
				order[111] = 2201
				order[112] = 2202
				order[113] = 2203
				order[114] = 615
				order[115] = 616
				order[116] = 2205
				order[117] = 2206
				order[118] = 617
				order[119] = 618
				order[120] = 619
				order[121] = 2740
				order[122] = 2717
				order[123] = 2718
				order[124] = 2719
				order[125] = 620
				order[126] = 621
				order[127] = 622
				order[128] = 2207
				order[129] = 2208
				order[130] = 623
				order[131] = 624
				order[132] = 556
				order[133] = 2898
				order[134] = 740
				order[135] = 739
				order[136] = 955
				order[137] = 956
				order[138] = 1358
				order[139] = 2682
				order[140] = 2686
				order[141] = 1017
				order[142] = 566
				order[143] = 2209
				order[144] = 2211
				order[145] = 2212
				order[146] = 2213
				order[147] = 2754
				order[148] = 2214
				order[149] = 2215
				order[150] = 2606
				order[151] = 2607
				order[152] = 690
				order[153] = 587
				order[154] = 683
				order[155] = 676
				order[156] = 2951
				order[157] = 677
				order[158] = 678
				order[159] = 679
				order[160] = 680
				order[161] = 0
				super(555, 600, order)
			end

			class NoLegSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 605
					order[1] = 606
					order[2] = 2958
					order[3] = 0
					super(604, 605, order)
				end
			end

			class NoLegSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2077
					order[1] = 2078
					order[2] = 2079
					order[3] = 2743
					order[4] = 0
					super(2076, 2077, order)
				end
			end

			class NoLegAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2309
					order[1] = 2310
					order[2] = 2311
					order[3] = 0
					super(2308, 2309, order)
				end
			end

			class NoLegEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 2060
					order[1] = 2061
					order[2] = 2062
					order[3] = 2063
					order[4] = 2064
					order[5] = 2341
					order[6] = 2065
					order[7] = 2066
					order[8] = 2074
					order[9] = 2075
					order[10] = 0
					super(2059, 2060, order)
				end
			end

			class NoLegInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 2255
					order[1] = 2256
					order[2] = 2257
					order[3] = 2379
					order[4] = 2258
					order[5] = 0
					super(2254, 2255, order)
				end

				class NoLegInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2259
						order[1] = 2260
						order[2] = 0
						super(2258, 2259, order)
					end
				end
			end

			class NoLegComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2219
					order[1] = 2220
					order[2] = 2221
					order[3] = 2222
					order[4] = 2223
					order[5] = 2224
					order[6] = 2225
					order[7] = 2226
					order[8] = 2944
					order[9] = 2227
					order[10] = 2228
					order[11] = 2229
					order[12] = 2230
					order[13] = 2231
					order[14] = 2232
					order[15] = 2250
					order[16] = 2233
					order[17] = 2945
					order[18] = 2234
					order[19] = 2946
					order[20] = 2235
					order[21] = 2236
					order[22] = 2409
					order[23] = 2410
					order[24] = 2237
					order[25] = 2238
					order[26] = 2239
					order[27] = 2240
					order[28] = 2241
					order[29] = 41382
					order[30] = 41389
					order[31] = 41390
					order[32] = 41391
					order[33] = 41392
					order[34] = 41393
					order[35] = 41394
					order[36] = 41395
					order[37] = 41396
					order[38] = 41397
					order[39] = 41379
					order[40] = 2242
					order[41] = 2243
					order[42] = 2244
					order[43] = 2245
					order[44] = 2246
					order[45] = 41398
					order[46] = 41366
					order[47] = 2608
					order[48] = 2609
					order[49] = 2610
					order[50] = 2248
					order[51] = 2249
					order[52] = 0
					super(2218, 2219, order)
				end

				class NoLegComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2251
						order[1] = 2252
						order[2] = 2253
						order[3] = 0
						super(2250, 2251, order)
					end

					class NoLegComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2204
							order[1] = 2247
							order[2] = 0
							super(2253, 2204, order)
						end
					end
				end

				class NoLegComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41383
						order[1] = 41384
						order[2] = 41385
						order[3] = 41386
						order[4] = 0
						super(41382, 41383, order)
					end
				end

				class NoLegComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41388
						order[1] = 0
						super(41387, 41388, order)
					end
				end

				class NoLegComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41380
						order[1] = 41381
						order[2] = 41400
						order[3] = 41376
						order[4] = 41363
						order[5] = 0
						super(41379, 41380, order)
					end

					class NoLegComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41401
							order[1] = 41402
							order[2] = 41403
							order[3] = 41404
							order[4] = 41405
							order[5] = 0
							super(41400, 41401, order)
						end
					end

					class NoLegComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41377
							order[1] = 41378
							order[2] = 0
							super(41376, 41377, order)
						end
					end

					class NoLegComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41364
							order[1] = 41365
							order[2] = 0
							super(41363, 41364, order)
						end
					end
				end

				class NoLegComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41399
						order[1] = 0
						super(41398, 41399, order)
					end
				end

				class NoLegComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41367
						order[1] = 41368
						order[2] = 41369
						order[3] = 41370
						order[4] = 41371
						order[5] = 41372
						order[6] = 41373
						order[7] = 41374
						order[8] = 0
						super(41366, 41367, order)
					end

					class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41375
							order[1] = 0
							super(41374, 41375, order)
						end
					end
				end
			end

			class NoLegBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40924
					order[1] = 0
					super(40923, 40924, order)
				end
			end

			class NoLegPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41608
					order[1] = 0
					super(41607, 41608, order)
				end
			end

			class NoLegMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41468
					order[1] = 40223
					order[2] = 0
					super(41467, 41468, order)
				end
			end

			class NoLegMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41470
					order[1] = 40990
					order[2] = 0
					super(41469, 41470, order)
				end
			end

			class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41472
					order[1] = 41473
					order[2] = 41474
					order[3] = 41475
					order[4] = 41476
					order[5] = 41477
					order[6] = 41478
					order[7] = 41479
					order[8] = 41480
					order[9] = 0
					super(41471, 41472, order)
				end
			end

			class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42582
					order[1] = 0
					super(42581, 42582, order)
				end
			end

			class NoLegOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41492
					order[1] = 0
					super(41491, 41492, order)
				end
			end

			class NoLegOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41513
					order[1] = 41514
					order[2] = 0
					super(41512, 41513, order)
				end
			end

			class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41516
					order[1] = 0
					super(41515, 41516, order)
				end
			end

			class NoLegOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41528
					order[1] = 41529
					order[2] = 0
					super(41527, 41528, order)
				end
			end

			class NoLegStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40242
					order[1] = 41700
					order[2] = 40243
					order[3] = 42583
					order[4] = 42584
					order[5] = 40244
					order[6] = 40245
					order[7] = 41702
					order[8] = 40246
					order[9] = 40247
					order[10] = 42585
					order[11] = 42586
					order[12] = 41703
					order[13] = 41704
					order[14] = 41705
					order[15] = 41706
					order[16] = 41707
					order[17] = 41708
					order[18] = 41648
					order[19] = 41649
					order[20] = 41650
					order[21] = 41651
					order[22] = 41652
					order[23] = 41653
					order[24] = 41654
					order[25] = 42588
					order[26] = 41655
					order[27] = 41656
					order[28] = 41657
					order[29] = 41658
					order[30] = 41659
					order[31] = 41660
					order[32] = 41661
					order[33] = 41662
					order[34] = 41663
					order[35] = 41664
					order[36] = 41665
					order[37] = 41666
					order[38] = 41667
					order[39] = 41668
					order[40] = 41669
					order[41] = 41670
					order[42] = 41671
					order[43] = 41672
					order[44] = 41673
					order[45] = 40249
					order[46] = 40250
					order[47] = 40252
					order[48] = 40253
					order[49] = 40254
					order[50] = 40255
					order[51] = 40256
					order[52] = 40257
					order[53] = 40258
					order[54] = 40260
					order[55] = 40261
					order[56] = 40262
					order[57] = 40263
					order[58] = 40264
					order[59] = 41641
					order[60] = 41642
					order[61] = 40265
					order[62] = 40267
					order[63] = 40268
					order[64] = 40270
					order[65] = 40271
					order[66] = 40272
					order[67] = 40273
					order[68] = 40274
					order[69] = 40275
					order[70] = 40276
					order[71] = 41643
					order[72] = 41644
					order[73] = 41645
					order[74] = 40279
					order[75] = 40280
					order[76] = 40281
					order[77] = 42399
					order[78] = 40282
					order[79] = 40283
					order[80] = 43108
					order[81] = 40284
					order[82] = 40285
					order[83] = 40286
					order[84] = 40287
					order[85] = 40288
					order[86] = 42400
					order[87] = 42401
					order[88] = 42402
					order[89] = 42403
					order[90] = 40289
					order[91] = 40290
					order[92] = 40291
					order[93] = 41549
					order[94] = 41550
					order[95] = 41551
					order[96] = 41552
					order[97] = 41553
					order[98] = 41554
					order[99] = 41555
					order[100] = 42404
					order[101] = 40374
					order[102] = 40418
					order[103] = 41429
					order[104] = 41430
					order[105] = 41431
					order[106] = 41432
					order[107] = 41433
					order[108] = 42194
					order[109] = 42195
					order[110] = 41434
					order[111] = 41435
					order[112] = 41436
					order[113] = 41437
					order[114] = 41438
					order[115] = 41219
					order[116] = 41439
					order[117] = 41440
					order[118] = 41441
					order[119] = 41442
					order[120] = 41443
					order[121] = 41444
					order[122] = 41445
					order[123] = 41446
					order[124] = 41447
					order[125] = 41448
					order[126] = 41449
					order[127] = 41450
					order[128] = 41451
					order[129] = 43095
					order[130] = 41408
					order[131] = 40248
					order[132] = 40978
					order[133] = 40979
					order[134] = 0
					super(40241, 40242, order)
				end

				class NoLegStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41675
						order[1] = 41676
						order[2] = 0
						super(41674, 41675, order)
					end
				end

				class NoLegStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41453
						order[1] = 41454
						order[2] = 41455
						order[3] = 0
						super(41452, 41453, order)
					end
				end

				class NoLegStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41678
						order[1] = 41679
						order[2] = 0
						super(41677, 41678, order)
					end
				end

				class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41647
						order[1] = 0
						super(41646, 41647, order)
					end
				end

				class NoLegStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41687
						order[1] = 41688
						order[2] = 41689
						order[3] = 41690
						order[4] = 41691
						order[5] = 41692
						order[6] = 41693
						order[7] = 41694
						order[8] = 41695
						order[9] = 41696
						order[10] = 41697
						order[11] = 41680
						order[12] = 41698
						order[13] = 41699
						order[14] = 0
						super(41686, 41687, order)
					end

					class NoLegStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41681
							order[1] = 41682
							order[2] = 41683
							order[3] = 0
							super(41680, 41681, order)
						end

						class NoLegStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41684
								order[1] = 41685
								order[2] = 41935
								order[3] = 0
								super(41683, 41684, order)
							end
						end
					end
				end

				class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40251
						order[1] = 0
						super(40942, 40251, order)
					end
				end

				class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40259
						order[1] = 0
						super(40943, 40259, order)
					end
				end

				class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40266
						order[1] = 0
						super(40940, 40266, order)
					end
				end

				class NoLegStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41639
						order[1] = 41640
						order[2] = 0
						super(41638, 41639, order)
					end
				end

				class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40269
						order[1] = 0
						super(40941, 40269, order)
					end
				end

				class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40293
						order[1] = 0
						super(40930, 40293, order)
					end
				end

				class NoLegPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41590
						order[1] = 41591
						order[2] = 0
						super(41589, 41590, order)
					end
				end

				class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40305
						order[1] = 0
						super(40931, 40305, order)
					end
				end

				class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40311
						order[1] = 0
						super(40932, 40311, order)
					end
				end

				class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40318
						order[1] = 0
						super(40933, 40318, order)
					end
				end

				class NoLegPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42460
						order[1] = 42461
						order[2] = 0
						super(42459, 42460, order)
					end
				end

				class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41562
						order[1] = 0
						super(41561, 41562, order)
					end
				end

				class NoLegPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41597
						order[1] = 41598
						order[2] = 0
						super(41596, 41597, order)
					end
				end

				class NoLegPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41594
						order[1] = 41595
						order[2] = 0
						super(41593, 41594, order)
					end
				end

				class NoLegPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43110
						order[1] = 42486
						order[2] = 42487
						order[3] = 0
						super(42485, 43110, order)
					end
				end

				class NoLegDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42367
						order[1] = 42368
						order[2] = 42369
						order[3] = 42370
						order[4] = 42371
						order[5] = 42372
						order[6] = 42386
						order[7] = 42373
						order[8] = 42374
						order[9] = 42375
						order[10] = 42376
						order[11] = 42377
						order[12] = 42378
						order[13] = 42379
						order[14] = 42380
						order[15] = 42381
						order[16] = 42382
						order[17] = 42383
						order[18] = 42384
						order[19] = 42385
						order[20] = 0
						super(42366, 42367, order)
					end

					class NoLegDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42387
							order[1] = 0
							super(42386, 42387, order)
						end
					end
				end

				class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42365
						order[1] = 0
						super(42364, 42365, order)
					end
				end

				class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42311
						order[1] = 0
						super(42310, 42311, order)
					end
				end

				class NoLegReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 42535
						order[1] = 42536
						order[2] = 42537
						order[3] = 42538
						order[4] = 42539
						order[5] = 42540
						order[6] = 42564
						order[7] = 42530
						order[8] = 42541
						order[9] = 42542
						order[10] = 42543
						order[11] = 42544
						order[12] = 42545
						order[13] = 42546
						order[14] = 42547
						order[15] = 42548
						order[16] = 42549
						order[17] = 42550
						order[18] = 42551
						order[19] = 42552
						order[20] = 42560
						order[21] = 42553
						order[22] = 42554
						order[23] = 42508
						order[24] = 42555
						order[25] = 42556
						order[26] = 42557
						order[27] = 42558
						order[28] = 42559
						order[29] = 0
						super(42534, 42535, order)
					end

					class NoLegReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 42565
							order[1] = 42566
							order[2] = 42567
							order[3] = 42568
							order[4] = 0
							super(42564, 42565, order)
						end
					end

					class NoLegReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42531
							order[1] = 42532
							order[2] = 42533
							order[3] = 0
							super(42530, 42531, order)
						end
					end

					class NoLegReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42561
							order[1] = 42562
							order[2] = 42563
							order[3] = 0
							super(42560, 42561, order)
						end
					end

					class NoLegReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 42509
							order[1] = 42571
							order[2] = 42510
							order[3] = 42511
							order[4] = 42512
							order[5] = 42513
							order[6] = 42514
							order[7] = 42515
							order[8] = 42516
							order[9] = 42517
							order[10] = 42518
							order[11] = 42519
							order[12] = 42520
							order[13] = 42521
							order[14] = 42522
							order[15] = 42523
							order[16] = 42524
							order[17] = 42525
							order[18] = 42526
							order[19] = 42527
							order[20] = 42528
							order[21] = 42529
							order[22] = 42569
							order[23] = 0
							super(42508, 42509, order)
						end

						class NoLegReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 42572
								order[1] = 42573
								order[2] = 0
								super(42571, 42572, order)
							end
						end

						class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 42570
								order[1] = 0
								super(42569, 42570, order)
							end
						end
					end
				end

				class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42420
						order[1] = 0
						super(42419, 42420, order)
					end
				end

				class NoLegPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42406
						order[1] = 42407
						order[2] = 0
						super(42405, 42406, order)
					end
				end

				class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40361
						order[1] = 0
						super(40929, 40361, order)
					end
				end

				class NoLegNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40368
						order[1] = 40369
						order[2] = 0
						super(40367, 40368, order)
					end
				end

				class NoLegSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40903
						order[1] = 40366
						order[2] = 40370
						order[3] = 40905
						order[4] = 40906
						order[5] = 0
						super(40902, 40903, order)
					end
				end

				class NoLegPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40375
						order[1] = 41533
						order[2] = 41534
						order[3] = 40376
						order[4] = 40377
						order[5] = 40378
						order[6] = 40379
						order[7] = 40380
						order[8] = 40381
						order[9] = 40382
						order[10] = 40383
						order[11] = 40384
						order[12] = 40385
						order[13] = 41535
						order[14] = 41536
						order[15] = 41537
						order[16] = 41538
						order[17] = 40386
						order[18] = 40387
						order[19] = 40388
						order[20] = 40389
						order[21] = 41539
						order[22] = 41540
						order[23] = 41541
						order[24] = 41542
						order[25] = 40390
						order[26] = 40391
						order[27] = 40392
						order[28] = 40393
						order[29] = 40394
						order[30] = 40395
						order[31] = 40414
						order[32] = 40396
						order[33] = 40397
						order[34] = 40398
						order[35] = 40399
						order[36] = 40927
						order[37] = 40401
						order[38] = 40402
						order[39] = 40403
						order[40] = 41543
						order[41] = 41544
						order[42] = 40404
						order[43] = 41530
						order[44] = 41545
						order[45] = 41546
						order[46] = 41547
						order[47] = 41548
						order[48] = 40405
						order[49] = 40406
						order[50] = 40407
						order[51] = 40408
						order[52] = 40928
						order[53] = 40410
						order[54] = 40411
						order[55] = 40412
						order[56] = 40413
						order[57] = 0
						super(40374, 40375, order)
					end

					class NoLegPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40415
							order[1] = 40416
							order[2] = 40417
							order[3] = 0
							super(40414, 40415, order)
						end
					end

					class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40400
							order[1] = 0
							super(40927, 40400, order)
						end
					end

					class NoLegPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41531
							order[1] = 41532
							order[2] = 0
							super(41530, 41531, order)
						end
					end

					class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40409
							order[1] = 0
							super(40928, 40409, order)
						end
					end
				end

				class NoLegPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40419
						order[1] = 40420
						order[2] = 42497
						order[3] = 42498
						order[4] = 42499
						order[5] = 42500
						order[6] = 42501
						order[7] = 42502
						order[8] = 42503
						order[9] = 42488
						order[10] = 42489
						order[11] = 42490
						order[12] = 42491
						order[13] = 42492
						order[14] = 42493
						order[15] = 42494
						order[16] = 40421
						order[17] = 40422
						order[18] = 40423
						order[19] = 40424
						order[20] = 40425
						order[21] = 40426
						order[22] = 40427
						order[23] = 40428
						order[24] = 40429
						order[25] = 40430
						order[26] = 40431
						order[27] = 40432
						order[28] = 40433
						order[29] = 40434
						order[30] = 40435
						order[31] = 40436
						order[32] = 40437
						order[33] = 40438
						order[34] = 40439
						order[35] = 40440
						order[36] = 40441
						order[37] = 40442
						order[38] = 40443
						order[39] = 40444
						order[40] = 40445
						order[41] = 40446
						order[42] = 40447
						order[43] = 0
						super(40418, 40419, order)
					end

					class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42505
							order[1] = 0
							super(42504, 42505, order)
						end
					end

					class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42496
							order[1] = 0
							super(42495, 42496, order)
						end
					end
				end

				class NoLegDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41461
						order[1] = 0
						super(41460, 41461, order)
					end
				end

				class NoLegDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41457
						order[1] = 41458
						order[2] = 41459
						order[3] = 0
						super(41456, 41457, order)
					end
				end

				class NoLegDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41409
						order[1] = 41410
						order[2] = 41411
						order[3] = 41412
						order[4] = 41413
						order[5] = 41414
						order[6] = 41415
						order[7] = 41416
						order[8] = 41417
						order[9] = 41418
						order[10] = 41419
						order[11] = 41420
						order[12] = 41421
						order[13] = 41422
						order[14] = 0
						super(41408, 41409, order)
					end

					class NoLegDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41423
							order[1] = 41424
							order[2] = 41425
							order[3] = 0
							super(41422, 41423, order)
						end

						class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41426
								order[1] = 41427
								order[2] = 41428
								order[3] = 0
								super(41425, 41426, order)
							end
						end
					end
				end
			end

			class NoLegProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 40449
					order[1] = 40450
					order[2] = 40451
					order[3] = 40939
					order[4] = 40453
					order[5] = 40454
					order[6] = 40455
					order[7] = 42506
					order[8] = 42507
					order[9] = 40456
					order[10] = 40457
					order[11] = 40458
					order[12] = 40524
					order[13] = 40525
					order[14] = 40526
					order[15] = 40528
					order[16] = 40529
					order[17] = 40530
					order[18] = 40531
					order[19] = 40532
					order[20] = 40476
					order[21] = 40478
					order[22] = 40479
					order[23] = 40480
					order[24] = 40481
					order[25] = 40482
					order[26] = 40483
					order[27] = 40484
					order[28] = 40485
					order[29] = 40486
					order[30] = 40487
					order[31] = 40488
					order[32] = 40489
					order[33] = 40490
					order[34] = 40491
					order[35] = 40492
					order[36] = 40493
					order[37] = 40494
					order[38] = 40498
					order[39] = 40499
					order[40] = 40501
					order[41] = 40502
					order[42] = 40503
					order[43] = 40504
					order[44] = 40505
					order[45] = 40506
					order[46] = 40507
					order[47] = 40508
					order[48] = 40509
					order[49] = 40511
					order[50] = 40512
					order[51] = 40513
					order[52] = 40514
					order[53] = 40515
					order[54] = 40459
					order[55] = 40460
					order[56] = 40461
					order[57] = 40462
					order[58] = 40463
					order[59] = 40464
					order[60] = 40465
					order[61] = 40516
					order[62] = 40518
					order[63] = 40519
					order[64] = 40520
					order[65] = 40521
					order[66] = 40522
					order[67] = 40523
					order[68] = 40466
					order[69] = 40467
					order[70] = 40468
					order[71] = 40469
					order[72] = 40470
					order[73] = 41407
					order[74] = 40472
					order[75] = 40980
					order[76] = 40981
					order[77] = 40533
					order[78] = 0
					super(40448, 40449, order)
				end

				class NoLegProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40452
						order[1] = 0
						super(40939, 40452, order)
					end
				end

				class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40527
						order[1] = 0
						super(40935, 40527, order)
					end
				end

				class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40477
						order[1] = 0
						super(40936, 40477, order)
					end
				end

				class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40496
						order[1] = 40497
						order[2] = 0
						super(40495, 40496, order)
					end
				end

				class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40500
						order[1] = 0
						super(40937, 40500, order)
					end
				end

				class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40510
						order[1] = 0
						super(40938, 40510, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40517
						order[1] = 0
						super(40934, 40517, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40474
						order[1] = 40475
						order[2] = 0
						super(40473, 40474, order)
					end
				end

				class NoLegProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40534
						order[1] = 40535
						order[2] = 40536
						order[3] = 2380
						order[4] = 40537
						order[5] = 0
						super(40533, 40534, order)
					end

					class NoLegProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40538
							order[1] = 40539
							order[2] = 0
							super(40537, 40538, order)
						end
					end
				end
			end

			class NoLegAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41336
					order[1] = 41337
					order[2] = 41316
					order[3] = 0
					super(41335, 41336, order)
				end

				class NoLegAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41317
						order[1] = 41318
						order[2] = 41319
						order[3] = 41320
						order[4] = 41321
						order[5] = 41322
						order[6] = 41323
						order[7] = 41324
						order[8] = 41325
						order[9] = 41326
						order[10] = 41327
						order[11] = 41328
						order[12] = 41329
						order[13] = 41330
						order[14] = 41331
						order[15] = 41332
						order[16] = 41333
						order[17] = 41334
						order[18] = 0
						super(41316, 41317, order)
					end
				end
			end

			class NoLegProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 41618
					order[1] = 41619
					order[2] = 41620
					order[3] = 41621
					order[4] = 41622
					order[5] = 41623
					order[6] = 41624
					order[7] = 41614
					order[8] = 41625
					order[9] = 41635
					order[10] = 41617
					order[11] = 0
					super(41616, 41618, order)
				end

				class NoLegProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41615
						order[1] = 0
						super(41614, 41615, order)
					end
				end

				class NoLegProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41626
						order[1] = 41627
						order[2] = 41628
						order[3] = 41629
						order[4] = 41630
						order[5] = 41631
						order[6] = 41632
						order[7] = 41633
						order[8] = 0
						super(41625, 41626, order)
					end

					class NoLegProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41634
							order[1] = 0
							super(41633, 41634, order)
						end
					end
				end

				class NoLegProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41636
						order[1] = 41637
						order[2] = 0
						super(41635, 41636, order)
					end
				end
			end

			class NoLegCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 41345
					order[1] = 41346
					order[2] = 41347
					order[3] = 41348
					order[4] = 41349
					order[5] = 41350
					order[6] = 41351
					order[7] = 41352
					order[8] = 41353
					order[9] = 41354
					order[10] = 41355
					order[11] = 41342
					order[12] = 42308
					order[13] = 42309
					order[14] = 41356
					order[15] = 41357
					order[16] = 42299
					order[17] = 42300
					order[18] = 42301
					order[19] = 42302
					order[20] = 42303
					order[21] = 42304
					order[22] = 42305
					order[23] = 41358
					order[24] = 41359
					order[25] = 41360
					order[26] = 41361
					order[27] = 41362
					order[28] = 0
					super(41344, 41345, order)
				end

				class NoLegCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41343
						order[1] = 0
						super(41342, 41343, order)
					end
				end

				class NoLegCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42307
						order[1] = 0
						super(42306, 42307, order)
					end
				end
			end

			class NoLegPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41604
					order[1] = 41601
					order[2] = 41602
					order[3] = 41603
					order[4] = 41600
					order[5] = 0
					super(41599, 41604, order)
				end

				class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41605
						order[1] = 41606
						order[2] = 0
						super(41604, 41605, order)
					end
				end
			end

			class NoLegExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42389
					order[1] = 42390
					order[2] = 0
					super(42388, 42389, order)
				end
			end

			class NoLegStipulations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 688
					order[1] = 689
					order[2] = 0
					super(683, 688, order)
				end
			end
		end

		class NoRelatedInstruments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1648
				order[1] = 1649
				order[2] = 1650
				order[3] = 1651
				order[4] = 1652
				order[5] = 1653
				order[6] = 2413
				order[7] = 2414
				order[8] = 2415
				order[9] = 2417
				order[10] = 0
				super(1647, 1648, order)
			end
		end

		class NoPriceMovements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1920
				order[1] = 1918
				order[2] = 0
				super(1919, 1920, order)
			end

			class NoPriceMovementValues < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1921
					order[1] = 1922
					order[2] = 1923
					order[3] = 0
					super(1920, 1921, order)
				end
			end

			class NoClearingAccountTypes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 1816
					order[1] = 0
					super(1918, 1816, order)
				end
			end
		end
	end
end

class DerivativeSecurityListRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("z") )
	end

	class NoUnderlyingSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 458
			order[1] = 459
			order[2] = 2959
			order[3] = 0
			super(457, 458, order)
		end
	end

	class NoUnderlyingStips < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 888
			order[1] = 889
			order[2] = 0
			super(887, 888, order)
		end
	end

	class NoUndlyInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1059
			order[1] = 1060
			order[2] = 1061
			order[3] = 2391
			order[4] = 1062
			order[5] = 0
			super(1058, 1059, order)
		end

		class NoUndlyInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1063
				order[1] = 1064
				order[2] = 0
				super(1062, 1063, order)
			end
		end
	end

	class NoUnderlyingEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 1982
			order[1] = 1983
			order[2] = 1984
			order[3] = 1985
			order[4] = 1986
			order[5] = 2342
			order[6] = 1987
			order[7] = 2071
			order[8] = 2072
			order[9] = 2073
			order[10] = 0
			super(1981, 1982, order)
		end
	end

	class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 2081
			order[1] = 2082
			order[2] = 2083
			order[3] = 2745
			order[4] = 0
			super(2080, 2081, order)
		end
	end

	class NoUnderlyingAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2313
			order[1] = 2314
			order[2] = 2315
			order[3] = 0
			super(2312, 2313, order)
		end
	end

	class NoUnderlyingComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 2046
			order[1] = 2261
			order[2] = 2262
			order[3] = 2263
			order[4] = 2047
			order[5] = 2264
			order[6] = 2265
			order[7] = 2266
			order[8] = 2947
			order[9] = 2048
			order[10] = 2267
			order[11] = 2049
			order[12] = 2050
			order[13] = 2051
			order[14] = 2052
			order[15] = 2053
			order[16] = 2268
			order[17] = 2948
			order[18] = 2269
			order[19] = 2949
			order[20] = 2270
			order[21] = 2271
			order[22] = 2419
			order[23] = 2420
			order[24] = 2272
			order[25] = 2273
			order[26] = 2274
			order[27] = 2275
			order[28] = 2276
			order[29] = 41732
			order[30] = 41739
			order[31] = 41740
			order[32] = 41741
			order[33] = 41742
			order[34] = 41743
			order[35] = 41744
			order[36] = 41745
			order[37] = 41746
			order[38] = 41747
			order[39] = 41729
			order[40] = 2277
			order[41] = 2278
			order[42] = 2279
			order[43] = 2280
			order[44] = 2281
			order[45] = 41748
			order[46] = 41716
			order[47] = 2611
			order[48] = 2612
			order[49] = 2613
			order[50] = 2282
			order[51] = 2283
			order[52] = 0
			super(2045, 2046, order)
		end

		class NoUnderlyingComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2054
				order[1] = 2055
				order[2] = 2056
				order[3] = 0
				super(2053, 2054, order)
			end

			class NoUnderlyingComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2057
					order[1] = 2058
					order[2] = 0
					super(2056, 2057, order)
				end
			end
		end

		class NoUnderlyingComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41733
				order[1] = 41734
				order[2] = 41735
				order[3] = 41736
				order[4] = 0
				super(41732, 41733, order)
			end
		end

		class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41738
				order[1] = 0
				super(41737, 41738, order)
			end
		end

		class NoUnderlyingComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41730
				order[1] = 41731
				order[2] = 41750
				order[3] = 41726
				order[4] = 41713
				order[5] = 0
				super(41729, 41730, order)
			end

			class NoUnderlyingComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41751
					order[1] = 41752
					order[2] = 41753
					order[3] = 41754
					order[4] = 41755
					order[5] = 0
					super(41750, 41751, order)
				end
			end

			class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41727
					order[1] = 41728
					order[2] = 0
					super(41726, 41727, order)
				end
			end

			class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41714
					order[1] = 41715
					order[2] = 0
					super(41713, 41714, order)
				end
			end
		end

		class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41749
				order[1] = 0
				super(41748, 41749, order)
			end
		end

		class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 41717
				order[1] = 41718
				order[2] = 41719
				order[3] = 41720
				order[4] = 41721
				order[5] = 41722
				order[6] = 41723
				order[7] = 41724
				order[8] = 0
				super(41716, 41717, order)
			end

			class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41725
					order[1] = 0
					super(41724, 41725, order)
				end
			end
		end
	end

	class NoUnderlyingBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40963
			order[1] = 0
			super(40962, 40963, order)
		end
	end

	class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41948
			order[1] = 0
			super(41947, 41948, order)
		end
	end

	class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41865
			order[1] = 41338
			order[2] = 0
			super(41864, 41865, order)
		end
	end

	class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41867
			order[1] = 41339
			order[2] = 0
			super(41866, 41867, order)
		end
	end

	class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41869
			order[1] = 41870
			order[2] = 41871
			order[3] = 41872
			order[4] = 41873
			order[5] = 41874
			order[6] = 41875
			order[7] = 41876
			order[8] = 41877
			order[9] = 0
			super(41868, 41869, order)
		end
	end

	class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 43075
			order[1] = 0
			super(43074, 43075, order)
		end
	end

	class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41821
			order[1] = 0
			super(41820, 41821, order)
		end
	end

	class NoUnderlyingOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41842
			order[1] = 41843
			order[2] = 0
			super(41841, 41842, order)
		end
	end

	class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41845
			order[1] = 0
			super(41844, 41845, order)
		end
	end

	class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41857
			order[1] = 41858
			order[2] = 0
			super(41856, 41857, order)
		end
	end

	class NoUnderlyingStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40541
			order[1] = 42016
			order[2] = 40542
			order[3] = 43083
			order[4] = 43084
			order[5] = 40543
			order[6] = 40544
			order[7] = 42018
			order[8] = 40545
			order[9] = 40546
			order[10] = 43085
			order[11] = 43086
			order[12] = 42019
			order[13] = 42020
			order[14] = 42021
			order[15] = 42022
			order[16] = 42023
			order[17] = 42024
			order[18] = 41964
			order[19] = 41965
			order[20] = 41966
			order[21] = 41967
			order[22] = 41968
			order[23] = 41969
			order[24] = 41970
			order[25] = 42589
			order[26] = 41971
			order[27] = 41972
			order[28] = 41973
			order[29] = 41974
			order[30] = 41975
			order[31] = 41976
			order[32] = 41977
			order[33] = 41978
			order[34] = 41979
			order[35] = 41980
			order[36] = 41981
			order[37] = 41982
			order[38] = 41983
			order[39] = 41984
			order[40] = 41985
			order[41] = 41986
			order[42] = 41987
			order[43] = 41988
			order[44] = 41989
			order[45] = 40057
			order[46] = 40058
			order[47] = 40060
			order[48] = 40061
			order[49] = 40062
			order[50] = 40063
			order[51] = 40064
			order[52] = 40548
			order[53] = 40549
			order[54] = 40551
			order[55] = 40552
			order[56] = 40553
			order[57] = 40554
			order[58] = 40555
			order[59] = 41957
			order[60] = 41958
			order[61] = 40556
			order[62] = 40558
			order[63] = 40559
			order[64] = 40561
			order[65] = 40562
			order[66] = 40563
			order[67] = 40564
			order[68] = 40565
			order[69] = 40566
			order[70] = 40567
			order[71] = 41959
			order[72] = 41960
			order[73] = 41961
			order[74] = 40568
			order[75] = 40569
			order[76] = 40570
			order[77] = 42895
			order[78] = 40571
			order[79] = 40572
			order[80] = 43107
			order[81] = 40573
			order[82] = 40574
			order[83] = 40575
			order[84] = 40576
			order[85] = 40577
			order[86] = 42896
			order[87] = 42897
			order[88] = 42898
			order[89] = 42899
			order[90] = 40578
			order[91] = 40579
			order[92] = 40580
			order[93] = 41897
			order[94] = 41898
			order[95] = 41899
			order[96] = 41900
			order[97] = 41901
			order[98] = 41902
			order[99] = 41903
			order[100] = 42900
			order[101] = 40664
			order[102] = 40708
			order[103] = 41777
			order[104] = 41778
			order[105] = 41779
			order[106] = 41780
			order[107] = 41781
			order[108] = 42196
			order[109] = 42197
			order[110] = 41782
			order[111] = 41783
			order[112] = 41784
			order[113] = 41785
			order[114] = 41786
			order[115] = 41587
			order[116] = 41787
			order[117] = 41788
			order[118] = 41789
			order[119] = 41790
			order[120] = 41791
			order[121] = 41792
			order[122] = 41793
			order[123] = 41794
			order[124] = 41795
			order[125] = 41796
			order[126] = 41797
			order[127] = 41798
			order[128] = 41799
			order[129] = 43096
			order[130] = 41756
			order[131] = 40547
			order[132] = 40988
			order[133] = 40989
			order[134] = 0
			super(40540, 40541, order)
		end

		class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41991
				order[1] = 41992
				order[2] = 0
				super(41990, 41991, order)
			end
		end

		class NoUnderlyingStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41801
				order[1] = 41802
				order[2] = 41803
				order[3] = 0
				super(41800, 41801, order)
			end
		end

		class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41994
				order[1] = 41995
				order[2] = 0
				super(41993, 41994, order)
			end
		end

		class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41963
				order[1] = 0
				super(41962, 41963, order)
			end
		end

		class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 42003
				order[1] = 42004
				order[2] = 42005
				order[3] = 42006
				order[4] = 42007
				order[5] = 42008
				order[6] = 42009
				order[7] = 42010
				order[8] = 42011
				order[9] = 42012
				order[10] = 42013
				order[11] = 41996
				order[12] = 42014
				order[13] = 42015
				order[14] = 0
				super(42002, 42003, order)
			end

			class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41997
					order[1] = 41998
					order[2] = 41999
					order[3] = 0
					super(41996, 41997, order)
				end

				class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42000
						order[1] = 42001
						order[2] = 41936
						order[3] = 0
						super(41999, 42000, order)
					end
				end
			end
		end

		class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40059
				order[1] = 0
				super(40975, 40059, order)
			end
		end

		class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40550
				order[1] = 0
				super(40976, 40550, order)
			end
		end

		class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40557
				order[1] = 0
				super(40973, 40557, order)
			end
		end

		class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41955
				order[1] = 41956
				order[2] = 0
				super(41954, 41955, order)
			end
		end

		class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40560
				order[1] = 0
				super(40974, 40560, order)
			end
		end

		class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40582
				order[1] = 0
				super(40969, 40582, order)
			end
		end

		class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41938
				order[1] = 41939
				order[2] = 0
				super(41937, 41938, order)
			end
		end

		class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40594
				order[1] = 0
				super(40970, 40594, order)
			end
		end

		class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40600
				order[1] = 0
				super(40971, 40600, order)
			end
		end

		class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40607
				order[1] = 0
				super(40972, 40607, order)
			end
		end

		class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42956
				order[1] = 42957
				order[2] = 0
				super(42955, 42956, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41910
				order[1] = 0
				super(41909, 41910, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41945
				order[1] = 41946
				order[2] = 0
				super(41944, 41945, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41942
				order[1] = 41943
				order[2] = 0
				super(41941, 41942, order)
			end
		end

		class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43111
				order[1] = 42982
				order[2] = 42983
				order[3] = 0
				super(42981, 43111, order)
			end
		end

		class NoUnderlyingDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42863
				order[1] = 42864
				order[2] = 42865
				order[3] = 42866
				order[4] = 42867
				order[5] = 42868
				order[6] = 42882
				order[7] = 42869
				order[8] = 42870
				order[9] = 42871
				order[10] = 42872
				order[11] = 42873
				order[12] = 42874
				order[13] = 42875
				order[14] = 42876
				order[15] = 42877
				order[16] = 42878
				order[17] = 42879
				order[18] = 42880
				order[19] = 42881
				order[20] = 0
				super(42862, 42863, order)
			end

			class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42883
					order[1] = 0
					super(42882, 42883, order)
				end
			end
		end

		class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42854
				order[1] = 0
				super(42853, 42854, order)
			end
		end

		class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42800
				order[1] = 0
				super(42799, 42800, order)
			end
		end

		class NoUnderlyingReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 43035
				order[1] = 43036
				order[2] = 43037
				order[3] = 43038
				order[4] = 43039
				order[5] = 43040
				order[6] = 43064
				order[7] = 43030
				order[8] = 43041
				order[9] = 43042
				order[10] = 43043
				order[11] = 43044
				order[12] = 43045
				order[13] = 43046
				order[14] = 43047
				order[15] = 43048
				order[16] = 43049
				order[17] = 43050
				order[18] = 43051
				order[19] = 43052
				order[20] = 43060
				order[21] = 43053
				order[22] = 43054
				order[23] = 43008
				order[24] = 43055
				order[25] = 43056
				order[26] = 43057
				order[27] = 43058
				order[28] = 43059
				order[29] = 0
				super(43034, 43035, order)
			end

			class NoUnderlyingReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 43065
					order[1] = 43066
					order[2] = 43067
					order[3] = 43068
					order[4] = 0
					super(43064, 43065, order)
				end
			end

			class NoUnderlyingReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43031
					order[1] = 43032
					order[2] = 43033
					order[3] = 0
					super(43030, 43031, order)
				end
			end

			class NoUnderlyingReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43061
					order[1] = 43062
					order[2] = 43063
					order[3] = 0
					super(43060, 43061, order)
				end
			end

			class NoUnderlyingReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 43009
					order[1] = 43071
					order[2] = 43010
					order[3] = 43011
					order[4] = 43012
					order[5] = 43013
					order[6] = 43014
					order[7] = 43015
					order[8] = 43016
					order[9] = 43017
					order[10] = 43018
					order[11] = 43019
					order[12] = 43020
					order[13] = 43021
					order[14] = 43022
					order[15] = 43023
					order[16] = 43024
					order[17] = 43025
					order[18] = 43026
					order[19] = 43027
					order[20] = 43028
					order[21] = 43029
					order[22] = 43069
					order[23] = 0
					super(43008, 43009, order)
				end

				class NoUnderlyingReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 43072
						order[1] = 43073
						order[2] = 0
						super(43071, 43072, order)
					end
				end

				class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43070
						order[1] = 0
						super(43069, 43070, order)
					end
				end
			end
		end

		class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42916
				order[1] = 0
				super(42915, 42916, order)
			end
		end

		class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42902
				order[1] = 42903
				order[2] = 0
				super(42901, 42902, order)
			end
		end

		class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40650
				order[1] = 0
				super(40968, 40650, order)
			end
		end

		class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40657
				order[1] = 40658
				order[2] = 0
				super(40656, 40657, order)
			end
		end

		class NoUnderlyingSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40660
				order[1] = 40904
				order[2] = 40915
				order[3] = 40662
				order[4] = 40663
				order[5] = 0
				super(40659, 40660, order)
			end
		end

		class NoUnderlyingPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40665
				order[1] = 41881
				order[2] = 41882
				order[3] = 40666
				order[4] = 40667
				order[5] = 40668
				order[6] = 40669
				order[7] = 40670
				order[8] = 40671
				order[9] = 40672
				order[10] = 40673
				order[11] = 40674
				order[12] = 40675
				order[13] = 41883
				order[14] = 41884
				order[15] = 41885
				order[16] = 41886
				order[17] = 40676
				order[18] = 40677
				order[19] = 40678
				order[20] = 40679
				order[21] = 41887
				order[22] = 41888
				order[23] = 41889
				order[24] = 41890
				order[25] = 40680
				order[26] = 40681
				order[27] = 40682
				order[28] = 40683
				order[29] = 40684
				order[30] = 40685
				order[31] = 40704
				order[32] = 40686
				order[33] = 40687
				order[34] = 40688
				order[35] = 40689
				order[36] = 40966
				order[37] = 40691
				order[38] = 40692
				order[39] = 40693
				order[40] = 41891
				order[41] = 41892
				order[42] = 40694
				order[43] = 41878
				order[44] = 41893
				order[45] = 41894
				order[46] = 41895
				order[47] = 41896
				order[48] = 40695
				order[49] = 40696
				order[50] = 40697
				order[51] = 40698
				order[52] = 40967
				order[53] = 40700
				order[54] = 40701
				order[55] = 40702
				order[56] = 40703
				order[57] = 0
				super(40664, 40665, order)
			end

			class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40705
					order[1] = 40706
					order[2] = 40707
					order[3] = 0
					super(40704, 40705, order)
				end
			end

			class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40690
					order[1] = 0
					super(40966, 40690, order)
				end
			end

			class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41879
					order[1] = 41880
					order[2] = 0
					super(41878, 41879, order)
				end
			end

			class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40699
					order[1] = 0
					super(40967, 40699, order)
				end
			end
		end

		class NoUnderlyingPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40709
				order[1] = 40710
				order[2] = 42993
				order[3] = 42994
				order[4] = 42995
				order[5] = 42996
				order[6] = 42997
				order[7] = 42998
				order[8] = 42999
				order[9] = 42984
				order[10] = 42985
				order[11] = 42986
				order[12] = 42987
				order[13] = 42988
				order[14] = 42989
				order[15] = 42990
				order[16] = 40711
				order[17] = 40712
				order[18] = 40713
				order[19] = 40714
				order[20] = 40715
				order[21] = 40716
				order[22] = 40717
				order[23] = 40718
				order[24] = 40719
				order[25] = 40720
				order[26] = 40721
				order[27] = 40722
				order[28] = 40723
				order[29] = 40724
				order[30] = 40725
				order[31] = 40726
				order[32] = 40727
				order[33] = 40728
				order[34] = 40729
				order[35] = 40730
				order[36] = 40731
				order[37] = 40732
				order[38] = 40733
				order[39] = 40734
				order[40] = 40735
				order[41] = 40736
				order[42] = 40737
				order[43] = 0
				super(40708, 40709, order)
			end

			class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 43001
					order[1] = 0
					super(43000, 43001, order)
				end
			end

			class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42992
					order[1] = 0
					super(42991, 42992, order)
				end
			end
		end

		class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41809
				order[1] = 0
				super(41808, 41809, order)
			end
		end

		class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41805
				order[1] = 41806
				order[2] = 41807
				order[3] = 0
				super(41804, 41805, order)
			end
		end

		class NoUnderlyingDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41757
				order[1] = 41758
				order[2] = 41759
				order[3] = 41760
				order[4] = 41761
				order[5] = 41762
				order[6] = 41763
				order[7] = 41764
				order[8] = 41765
				order[9] = 41766
				order[10] = 41767
				order[11] = 41768
				order[12] = 41769
				order[13] = 41770
				order[14] = 0
				super(41756, 41757, order)
			end

			class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41771
					order[1] = 41772
					order[2] = 41773
					order[3] = 0
					super(41770, 41771, order)
				end

				class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41774
						order[1] = 41775
						order[2] = 41776
						order[3] = 0
						super(41773, 41774, order)
					end
				end
			end
		end
	end

	class NoUnderlyingProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 42150
			order[1] = 42151
			order[2] = 42152
			order[3] = 42190
			order[4] = 42153
			order[5] = 42154
			order[6] = 42155
			order[7] = 43002
			order[8] = 43003
			order[9] = 42156
			order[10] = 42157
			order[11] = 42158
			order[12] = 42104
			order[13] = 42105
			order[14] = 42106
			order[15] = 42107
			order[16] = 42108
			order[17] = 42109
			order[18] = 42110
			order[19] = 42111
			order[20] = 42115
			order[21] = 42116
			order[22] = 42117
			order[23] = 42118
			order[24] = 42119
			order[25] = 42120
			order[26] = 42121
			order[27] = 42122
			order[28] = 42123
			order[29] = 42124
			order[30] = 42125
			order[31] = 42126
			order[32] = 42127
			order[33] = 42128
			order[34] = 42129
			order[35] = 42130
			order[36] = 42131
			order[37] = 42132
			order[38] = 42133
			order[39] = 42134
			order[40] = 42135
			order[41] = 42136
			order[42] = 42137
			order[43] = 42138
			order[44] = 42139
			order[45] = 42140
			order[46] = 42141
			order[47] = 42142
			order[48] = 42143
			order[49] = 42144
			order[50] = 42145
			order[51] = 42146
			order[52] = 42147
			order[53] = 42148
			order[54] = 42159
			order[55] = 42160
			order[56] = 42161
			order[57] = 42162
			order[58] = 42163
			order[59] = 42164
			order[60] = 42165
			order[61] = 42092
			order[62] = 42093
			order[63] = 42094
			order[64] = 42095
			order[65] = 42096
			order[66] = 42097
			order[67] = 42098
			order[68] = 42166
			order[69] = 42167
			order[70] = 42168
			order[71] = 42169
			order[72] = 42102
			order[73] = 42103
			order[74] = 42170
			order[75] = 42171
			order[76] = 42172
			order[77] = 42173
			order[78] = 0
			super(42149, 42150, order)
		end

		class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42191
				order[1] = 0
				super(42190, 42191, order)
			end
		end

		class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42183
				order[1] = 0
				super(42182, 42183, order)
			end
		end

		class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42185
				order[1] = 0
				super(42184, 42185, order)
			end
		end

		class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42113
				order[1] = 42114
				order[2] = 0
				super(42112, 42113, order)
			end
		end

		class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42187
				order[1] = 0
				super(42186, 42187, order)
			end
		end

		class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42189
				order[1] = 0
				super(42188, 42189, order)
			end
		end

		class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42181
				order[1] = 0
				super(42180, 42181, order)
			end
		end

		class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42100
				order[1] = 42101
				order[2] = 0
				super(42099, 42100, order)
			end
		end

		class NoUnderlyingProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42174
				order[1] = 42175
				order[2] = 42176
				order[3] = 40918
				order[4] = 42177
				order[5] = 0
				super(42173, 42174, order)
			end

			class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42178
					order[1] = 42179
					order[2] = 0
					super(42177, 42178, order)
				end
			end
		end
	end

	class NoUnderlyingAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 42037
			order[1] = 42038
			order[2] = 41340
			order[3] = 0
			super(42036, 42037, order)
		end

		class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 41341
				order[1] = 41701
				order[2] = 41709
				order[3] = 41710
				order[4] = 41711
				order[5] = 41712
				order[6] = 42017
				order[7] = 42025
				order[8] = 42026
				order[9] = 42027
				order[10] = 42028
				order[11] = 42029
				order[12] = 42030
				order[13] = 42031
				order[14] = 42032
				order[15] = 42033
				order[16] = 42034
				order[17] = 42035
				order[18] = 0
				super(41340, 41341, order)
			end
		end
	end

	class NoUnderlyingProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 42069
			order[1] = 42070
			order[2] = 42071
			order[3] = 42072
			order[4] = 42073
			order[5] = 42074
			order[6] = 42075
			order[7] = 42090
			order[8] = 42077
			order[9] = 42087
			order[10] = 42076
			order[11] = 0
			super(42068, 42069, order)
		end

		class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42091
				order[1] = 0
				super(42090, 42091, order)
			end
		end

		class NoUnderlyingProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 42078
				order[1] = 42079
				order[2] = 42080
				order[3] = 42081
				order[4] = 42082
				order[5] = 42083
				order[6] = 42084
				order[7] = 42085
				order[8] = 0
				super(42077, 42078, order)
			end

			class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42086
					order[1] = 0
					super(42085, 42086, order)
				end
			end
		end

		class NoUnderlyingProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42088
				order[1] = 42089
				order[2] = 0
				super(42087, 42088, order)
			end
		end
	end

	class NoUnderlyingCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 42042
			order[1] = 42043
			order[2] = 42044
			order[3] = 42045
			order[4] = 42046
			order[5] = 42047
			order[6] = 42048
			order[7] = 42049
			order[8] = 42050
			order[9] = 42051
			order[10] = 42052
			order[11] = 42039
			order[12] = 42797
			order[13] = 42798
			order[14] = 42053
			order[15] = 42054
			order[16] = 42790
			order[17] = 42791
			order[18] = 42792
			order[19] = 42793
			order[20] = 42794
			order[21] = 42795
			order[22] = 42796
			order[23] = 42055
			order[24] = 42056
			order[25] = 42057
			order[26] = 42058
			order[27] = 42059
			order[28] = 0
			super(42041, 42042, order)
		end

		class NoUnderlyingCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42040
				order[1] = 0
				super(42039, 42040, order)
			end
		end

		class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42789
				order[1] = 0
				super(42788, 42789, order)
			end
		end
	end

	class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 42065
			order[1] = 42061
			order[2] = 42062
			order[3] = 42063
			order[4] = 42064
			order[5] = 0
			super(42060, 42065, order)
		end

		class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42066
				order[1] = 42067
				order[2] = 0
				super(42065, 42066, order)
			end
		end
	end

	class NoUnderlyingRateSpreadSteps < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 43006
			order[1] = 43007
			order[2] = 0
			super(43005, 43006, order)
		end
	end

	class NoUnderlyingDividendPayments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 42856
			order[1] = 42857
			order[2] = 42858
			order[3] = 42859
			order[4] = 0
			super(42855, 42856, order)
		end
	end

	class NoUnderlyingExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42885
			order[1] = 42886
			order[2] = 0
			super(42884, 42885, order)
		end
	end

	class NoDerivativeSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1219
			order[1] = 1220
			order[2] = 0
			super(1218, 1219, order)
		end
	end

	class NoDerivativeEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1287
			order[1] = 1288
			order[2] = 1289
			order[3] = 1290
			order[4] = 1291
			order[5] = 0
			super(1286, 1287, order)
		end
	end

	class NoDerivativeInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1293
			order[1] = 1294
			order[2] = 1295
			order[3] = 2377
			order[4] = 1296
			order[5] = 0
			super(1292, 1293, order)
		end

		class NoDerivativeInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1297
				order[1] = 1298
				order[2] = 0
				super(1296, 1297, order)
			end
		end
	end
end

class DerivativeSecurityList < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AA") )
	end

	class NoUnderlyingSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 458
			order[1] = 459
			order[2] = 2959
			order[3] = 0
			super(457, 458, order)
		end
	end

	class NoUnderlyingStips < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 888
			order[1] = 889
			order[2] = 0
			super(887, 888, order)
		end
	end

	class NoUndlyInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1059
			order[1] = 1060
			order[2] = 1061
			order[3] = 2391
			order[4] = 1062
			order[5] = 0
			super(1058, 1059, order)
		end

		class NoUndlyInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1063
				order[1] = 1064
				order[2] = 0
				super(1062, 1063, order)
			end
		end
	end

	class NoUnderlyingEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 1982
			order[1] = 1983
			order[2] = 1984
			order[3] = 1985
			order[4] = 1986
			order[5] = 2342
			order[6] = 1987
			order[7] = 2071
			order[8] = 2072
			order[9] = 2073
			order[10] = 0
			super(1981, 1982, order)
		end
	end

	class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 2081
			order[1] = 2082
			order[2] = 2083
			order[3] = 2745
			order[4] = 0
			super(2080, 2081, order)
		end
	end

	class NoUnderlyingAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2313
			order[1] = 2314
			order[2] = 2315
			order[3] = 0
			super(2312, 2313, order)
		end
	end

	class NoUnderlyingComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 2046
			order[1] = 2261
			order[2] = 2262
			order[3] = 2263
			order[4] = 2047
			order[5] = 2264
			order[6] = 2265
			order[7] = 2266
			order[8] = 2947
			order[9] = 2048
			order[10] = 2267
			order[11] = 2049
			order[12] = 2050
			order[13] = 2051
			order[14] = 2052
			order[15] = 2053
			order[16] = 2268
			order[17] = 2948
			order[18] = 2269
			order[19] = 2949
			order[20] = 2270
			order[21] = 2271
			order[22] = 2419
			order[23] = 2420
			order[24] = 2272
			order[25] = 2273
			order[26] = 2274
			order[27] = 2275
			order[28] = 2276
			order[29] = 41732
			order[30] = 41739
			order[31] = 41740
			order[32] = 41741
			order[33] = 41742
			order[34] = 41743
			order[35] = 41744
			order[36] = 41745
			order[37] = 41746
			order[38] = 41747
			order[39] = 41729
			order[40] = 2277
			order[41] = 2278
			order[42] = 2279
			order[43] = 2280
			order[44] = 2281
			order[45] = 41748
			order[46] = 41716
			order[47] = 2611
			order[48] = 2612
			order[49] = 2613
			order[50] = 2282
			order[51] = 2283
			order[52] = 0
			super(2045, 2046, order)
		end

		class NoUnderlyingComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2054
				order[1] = 2055
				order[2] = 2056
				order[3] = 0
				super(2053, 2054, order)
			end

			class NoUnderlyingComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2057
					order[1] = 2058
					order[2] = 0
					super(2056, 2057, order)
				end
			end
		end

		class NoUnderlyingComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41733
				order[1] = 41734
				order[2] = 41735
				order[3] = 41736
				order[4] = 0
				super(41732, 41733, order)
			end
		end

		class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41738
				order[1] = 0
				super(41737, 41738, order)
			end
		end

		class NoUnderlyingComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41730
				order[1] = 41731
				order[2] = 41750
				order[3] = 41726
				order[4] = 41713
				order[5] = 0
				super(41729, 41730, order)
			end

			class NoUnderlyingComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41751
					order[1] = 41752
					order[2] = 41753
					order[3] = 41754
					order[4] = 41755
					order[5] = 0
					super(41750, 41751, order)
				end
			end

			class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41727
					order[1] = 41728
					order[2] = 0
					super(41726, 41727, order)
				end
			end

			class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41714
					order[1] = 41715
					order[2] = 0
					super(41713, 41714, order)
				end
			end
		end

		class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41749
				order[1] = 0
				super(41748, 41749, order)
			end
		end

		class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 41717
				order[1] = 41718
				order[2] = 41719
				order[3] = 41720
				order[4] = 41721
				order[5] = 41722
				order[6] = 41723
				order[7] = 41724
				order[8] = 0
				super(41716, 41717, order)
			end

			class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41725
					order[1] = 0
					super(41724, 41725, order)
				end
			end
		end
	end

	class NoUnderlyingBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40963
			order[1] = 0
			super(40962, 40963, order)
		end
	end

	class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41948
			order[1] = 0
			super(41947, 41948, order)
		end
	end

	class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41865
			order[1] = 41338
			order[2] = 0
			super(41864, 41865, order)
		end
	end

	class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41867
			order[1] = 41339
			order[2] = 0
			super(41866, 41867, order)
		end
	end

	class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41869
			order[1] = 41870
			order[2] = 41871
			order[3] = 41872
			order[4] = 41873
			order[5] = 41874
			order[6] = 41875
			order[7] = 41876
			order[8] = 41877
			order[9] = 0
			super(41868, 41869, order)
		end
	end

	class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 43075
			order[1] = 0
			super(43074, 43075, order)
		end
	end

	class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41821
			order[1] = 0
			super(41820, 41821, order)
		end
	end

	class NoUnderlyingOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41842
			order[1] = 41843
			order[2] = 0
			super(41841, 41842, order)
		end
	end

	class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41845
			order[1] = 0
			super(41844, 41845, order)
		end
	end

	class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41857
			order[1] = 41858
			order[2] = 0
			super(41856, 41857, order)
		end
	end

	class NoUnderlyingStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40541
			order[1] = 42016
			order[2] = 40542
			order[3] = 43083
			order[4] = 43084
			order[5] = 40543
			order[6] = 40544
			order[7] = 42018
			order[8] = 40545
			order[9] = 40546
			order[10] = 43085
			order[11] = 43086
			order[12] = 42019
			order[13] = 42020
			order[14] = 42021
			order[15] = 42022
			order[16] = 42023
			order[17] = 42024
			order[18] = 41964
			order[19] = 41965
			order[20] = 41966
			order[21] = 41967
			order[22] = 41968
			order[23] = 41969
			order[24] = 41970
			order[25] = 42589
			order[26] = 41971
			order[27] = 41972
			order[28] = 41973
			order[29] = 41974
			order[30] = 41975
			order[31] = 41976
			order[32] = 41977
			order[33] = 41978
			order[34] = 41979
			order[35] = 41980
			order[36] = 41981
			order[37] = 41982
			order[38] = 41983
			order[39] = 41984
			order[40] = 41985
			order[41] = 41986
			order[42] = 41987
			order[43] = 41988
			order[44] = 41989
			order[45] = 40057
			order[46] = 40058
			order[47] = 40060
			order[48] = 40061
			order[49] = 40062
			order[50] = 40063
			order[51] = 40064
			order[52] = 40548
			order[53] = 40549
			order[54] = 40551
			order[55] = 40552
			order[56] = 40553
			order[57] = 40554
			order[58] = 40555
			order[59] = 41957
			order[60] = 41958
			order[61] = 40556
			order[62] = 40558
			order[63] = 40559
			order[64] = 40561
			order[65] = 40562
			order[66] = 40563
			order[67] = 40564
			order[68] = 40565
			order[69] = 40566
			order[70] = 40567
			order[71] = 41959
			order[72] = 41960
			order[73] = 41961
			order[74] = 40568
			order[75] = 40569
			order[76] = 40570
			order[77] = 42895
			order[78] = 40571
			order[79] = 40572
			order[80] = 43107
			order[81] = 40573
			order[82] = 40574
			order[83] = 40575
			order[84] = 40576
			order[85] = 40577
			order[86] = 42896
			order[87] = 42897
			order[88] = 42898
			order[89] = 42899
			order[90] = 40578
			order[91] = 40579
			order[92] = 40580
			order[93] = 41897
			order[94] = 41898
			order[95] = 41899
			order[96] = 41900
			order[97] = 41901
			order[98] = 41902
			order[99] = 41903
			order[100] = 42900
			order[101] = 40664
			order[102] = 40708
			order[103] = 41777
			order[104] = 41778
			order[105] = 41779
			order[106] = 41780
			order[107] = 41781
			order[108] = 42196
			order[109] = 42197
			order[110] = 41782
			order[111] = 41783
			order[112] = 41784
			order[113] = 41785
			order[114] = 41786
			order[115] = 41587
			order[116] = 41787
			order[117] = 41788
			order[118] = 41789
			order[119] = 41790
			order[120] = 41791
			order[121] = 41792
			order[122] = 41793
			order[123] = 41794
			order[124] = 41795
			order[125] = 41796
			order[126] = 41797
			order[127] = 41798
			order[128] = 41799
			order[129] = 43096
			order[130] = 41756
			order[131] = 40547
			order[132] = 40988
			order[133] = 40989
			order[134] = 0
			super(40540, 40541, order)
		end

		class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41991
				order[1] = 41992
				order[2] = 0
				super(41990, 41991, order)
			end
		end

		class NoUnderlyingStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41801
				order[1] = 41802
				order[2] = 41803
				order[3] = 0
				super(41800, 41801, order)
			end
		end

		class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41994
				order[1] = 41995
				order[2] = 0
				super(41993, 41994, order)
			end
		end

		class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41963
				order[1] = 0
				super(41962, 41963, order)
			end
		end

		class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 42003
				order[1] = 42004
				order[2] = 42005
				order[3] = 42006
				order[4] = 42007
				order[5] = 42008
				order[6] = 42009
				order[7] = 42010
				order[8] = 42011
				order[9] = 42012
				order[10] = 42013
				order[11] = 41996
				order[12] = 42014
				order[13] = 42015
				order[14] = 0
				super(42002, 42003, order)
			end

			class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41997
					order[1] = 41998
					order[2] = 41999
					order[3] = 0
					super(41996, 41997, order)
				end

				class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42000
						order[1] = 42001
						order[2] = 41936
						order[3] = 0
						super(41999, 42000, order)
					end
				end
			end
		end

		class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40059
				order[1] = 0
				super(40975, 40059, order)
			end
		end

		class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40550
				order[1] = 0
				super(40976, 40550, order)
			end
		end

		class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40557
				order[1] = 0
				super(40973, 40557, order)
			end
		end

		class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41955
				order[1] = 41956
				order[2] = 0
				super(41954, 41955, order)
			end
		end

		class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40560
				order[1] = 0
				super(40974, 40560, order)
			end
		end

		class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40582
				order[1] = 0
				super(40969, 40582, order)
			end
		end

		class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41938
				order[1] = 41939
				order[2] = 0
				super(41937, 41938, order)
			end
		end

		class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40594
				order[1] = 0
				super(40970, 40594, order)
			end
		end

		class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40600
				order[1] = 0
				super(40971, 40600, order)
			end
		end

		class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40607
				order[1] = 0
				super(40972, 40607, order)
			end
		end

		class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42956
				order[1] = 42957
				order[2] = 0
				super(42955, 42956, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41910
				order[1] = 0
				super(41909, 41910, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41945
				order[1] = 41946
				order[2] = 0
				super(41944, 41945, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41942
				order[1] = 41943
				order[2] = 0
				super(41941, 41942, order)
			end
		end

		class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43111
				order[1] = 42982
				order[2] = 42983
				order[3] = 0
				super(42981, 43111, order)
			end
		end

		class NoUnderlyingDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42863
				order[1] = 42864
				order[2] = 42865
				order[3] = 42866
				order[4] = 42867
				order[5] = 42868
				order[6] = 42882
				order[7] = 42869
				order[8] = 42870
				order[9] = 42871
				order[10] = 42872
				order[11] = 42873
				order[12] = 42874
				order[13] = 42875
				order[14] = 42876
				order[15] = 42877
				order[16] = 42878
				order[17] = 42879
				order[18] = 42880
				order[19] = 42881
				order[20] = 0
				super(42862, 42863, order)
			end

			class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42883
					order[1] = 0
					super(42882, 42883, order)
				end
			end
		end

		class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42854
				order[1] = 0
				super(42853, 42854, order)
			end
		end

		class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42800
				order[1] = 0
				super(42799, 42800, order)
			end
		end

		class NoUnderlyingReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 43035
				order[1] = 43036
				order[2] = 43037
				order[3] = 43038
				order[4] = 43039
				order[5] = 43040
				order[6] = 43064
				order[7] = 43030
				order[8] = 43041
				order[9] = 43042
				order[10] = 43043
				order[11] = 43044
				order[12] = 43045
				order[13] = 43046
				order[14] = 43047
				order[15] = 43048
				order[16] = 43049
				order[17] = 43050
				order[18] = 43051
				order[19] = 43052
				order[20] = 43060
				order[21] = 43053
				order[22] = 43054
				order[23] = 43008
				order[24] = 43055
				order[25] = 43056
				order[26] = 43057
				order[27] = 43058
				order[28] = 43059
				order[29] = 0
				super(43034, 43035, order)
			end

			class NoUnderlyingReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 43065
					order[1] = 43066
					order[2] = 43067
					order[3] = 43068
					order[4] = 0
					super(43064, 43065, order)
				end
			end

			class NoUnderlyingReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43031
					order[1] = 43032
					order[2] = 43033
					order[3] = 0
					super(43030, 43031, order)
				end
			end

			class NoUnderlyingReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43061
					order[1] = 43062
					order[2] = 43063
					order[3] = 0
					super(43060, 43061, order)
				end
			end

			class NoUnderlyingReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 43009
					order[1] = 43071
					order[2] = 43010
					order[3] = 43011
					order[4] = 43012
					order[5] = 43013
					order[6] = 43014
					order[7] = 43015
					order[8] = 43016
					order[9] = 43017
					order[10] = 43018
					order[11] = 43019
					order[12] = 43020
					order[13] = 43021
					order[14] = 43022
					order[15] = 43023
					order[16] = 43024
					order[17] = 43025
					order[18] = 43026
					order[19] = 43027
					order[20] = 43028
					order[21] = 43029
					order[22] = 43069
					order[23] = 0
					super(43008, 43009, order)
				end

				class NoUnderlyingReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 43072
						order[1] = 43073
						order[2] = 0
						super(43071, 43072, order)
					end
				end

				class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43070
						order[1] = 0
						super(43069, 43070, order)
					end
				end
			end
		end

		class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42916
				order[1] = 0
				super(42915, 42916, order)
			end
		end

		class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42902
				order[1] = 42903
				order[2] = 0
				super(42901, 42902, order)
			end
		end

		class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40650
				order[1] = 0
				super(40968, 40650, order)
			end
		end

		class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40657
				order[1] = 40658
				order[2] = 0
				super(40656, 40657, order)
			end
		end

		class NoUnderlyingSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40660
				order[1] = 40904
				order[2] = 40915
				order[3] = 40662
				order[4] = 40663
				order[5] = 0
				super(40659, 40660, order)
			end
		end

		class NoUnderlyingPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40665
				order[1] = 41881
				order[2] = 41882
				order[3] = 40666
				order[4] = 40667
				order[5] = 40668
				order[6] = 40669
				order[7] = 40670
				order[8] = 40671
				order[9] = 40672
				order[10] = 40673
				order[11] = 40674
				order[12] = 40675
				order[13] = 41883
				order[14] = 41884
				order[15] = 41885
				order[16] = 41886
				order[17] = 40676
				order[18] = 40677
				order[19] = 40678
				order[20] = 40679
				order[21] = 41887
				order[22] = 41888
				order[23] = 41889
				order[24] = 41890
				order[25] = 40680
				order[26] = 40681
				order[27] = 40682
				order[28] = 40683
				order[29] = 40684
				order[30] = 40685
				order[31] = 40704
				order[32] = 40686
				order[33] = 40687
				order[34] = 40688
				order[35] = 40689
				order[36] = 40966
				order[37] = 40691
				order[38] = 40692
				order[39] = 40693
				order[40] = 41891
				order[41] = 41892
				order[42] = 40694
				order[43] = 41878
				order[44] = 41893
				order[45] = 41894
				order[46] = 41895
				order[47] = 41896
				order[48] = 40695
				order[49] = 40696
				order[50] = 40697
				order[51] = 40698
				order[52] = 40967
				order[53] = 40700
				order[54] = 40701
				order[55] = 40702
				order[56] = 40703
				order[57] = 0
				super(40664, 40665, order)
			end

			class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40705
					order[1] = 40706
					order[2] = 40707
					order[3] = 0
					super(40704, 40705, order)
				end
			end

			class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40690
					order[1] = 0
					super(40966, 40690, order)
				end
			end

			class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41879
					order[1] = 41880
					order[2] = 0
					super(41878, 41879, order)
				end
			end

			class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40699
					order[1] = 0
					super(40967, 40699, order)
				end
			end
		end

		class NoUnderlyingPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40709
				order[1] = 40710
				order[2] = 42993
				order[3] = 42994
				order[4] = 42995
				order[5] = 42996
				order[6] = 42997
				order[7] = 42998
				order[8] = 42999
				order[9] = 42984
				order[10] = 42985
				order[11] = 42986
				order[12] = 42987
				order[13] = 42988
				order[14] = 42989
				order[15] = 42990
				order[16] = 40711
				order[17] = 40712
				order[18] = 40713
				order[19] = 40714
				order[20] = 40715
				order[21] = 40716
				order[22] = 40717
				order[23] = 40718
				order[24] = 40719
				order[25] = 40720
				order[26] = 40721
				order[27] = 40722
				order[28] = 40723
				order[29] = 40724
				order[30] = 40725
				order[31] = 40726
				order[32] = 40727
				order[33] = 40728
				order[34] = 40729
				order[35] = 40730
				order[36] = 40731
				order[37] = 40732
				order[38] = 40733
				order[39] = 40734
				order[40] = 40735
				order[41] = 40736
				order[42] = 40737
				order[43] = 0
				super(40708, 40709, order)
			end

			class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 43001
					order[1] = 0
					super(43000, 43001, order)
				end
			end

			class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42992
					order[1] = 0
					super(42991, 42992, order)
				end
			end
		end

		class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41809
				order[1] = 0
				super(41808, 41809, order)
			end
		end

		class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41805
				order[1] = 41806
				order[2] = 41807
				order[3] = 0
				super(41804, 41805, order)
			end
		end

		class NoUnderlyingDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41757
				order[1] = 41758
				order[2] = 41759
				order[3] = 41760
				order[4] = 41761
				order[5] = 41762
				order[6] = 41763
				order[7] = 41764
				order[8] = 41765
				order[9] = 41766
				order[10] = 41767
				order[11] = 41768
				order[12] = 41769
				order[13] = 41770
				order[14] = 0
				super(41756, 41757, order)
			end

			class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41771
					order[1] = 41772
					order[2] = 41773
					order[3] = 0
					super(41770, 41771, order)
				end

				class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41774
						order[1] = 41775
						order[2] = 41776
						order[3] = 0
						super(41773, 41774, order)
					end
				end
			end
		end
	end

	class NoUnderlyingProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 42150
			order[1] = 42151
			order[2] = 42152
			order[3] = 42190
			order[4] = 42153
			order[5] = 42154
			order[6] = 42155
			order[7] = 43002
			order[8] = 43003
			order[9] = 42156
			order[10] = 42157
			order[11] = 42158
			order[12] = 42104
			order[13] = 42105
			order[14] = 42106
			order[15] = 42107
			order[16] = 42108
			order[17] = 42109
			order[18] = 42110
			order[19] = 42111
			order[20] = 42115
			order[21] = 42116
			order[22] = 42117
			order[23] = 42118
			order[24] = 42119
			order[25] = 42120
			order[26] = 42121
			order[27] = 42122
			order[28] = 42123
			order[29] = 42124
			order[30] = 42125
			order[31] = 42126
			order[32] = 42127
			order[33] = 42128
			order[34] = 42129
			order[35] = 42130
			order[36] = 42131
			order[37] = 42132
			order[38] = 42133
			order[39] = 42134
			order[40] = 42135
			order[41] = 42136
			order[42] = 42137
			order[43] = 42138
			order[44] = 42139
			order[45] = 42140
			order[46] = 42141
			order[47] = 42142
			order[48] = 42143
			order[49] = 42144
			order[50] = 42145
			order[51] = 42146
			order[52] = 42147
			order[53] = 42148
			order[54] = 42159
			order[55] = 42160
			order[56] = 42161
			order[57] = 42162
			order[58] = 42163
			order[59] = 42164
			order[60] = 42165
			order[61] = 42092
			order[62] = 42093
			order[63] = 42094
			order[64] = 42095
			order[65] = 42096
			order[66] = 42097
			order[67] = 42098
			order[68] = 42166
			order[69] = 42167
			order[70] = 42168
			order[71] = 42169
			order[72] = 42102
			order[73] = 42103
			order[74] = 42170
			order[75] = 42171
			order[76] = 42172
			order[77] = 42173
			order[78] = 0
			super(42149, 42150, order)
		end

		class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42191
				order[1] = 0
				super(42190, 42191, order)
			end
		end

		class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42183
				order[1] = 0
				super(42182, 42183, order)
			end
		end

		class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42185
				order[1] = 0
				super(42184, 42185, order)
			end
		end

		class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42113
				order[1] = 42114
				order[2] = 0
				super(42112, 42113, order)
			end
		end

		class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42187
				order[1] = 0
				super(42186, 42187, order)
			end
		end

		class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42189
				order[1] = 0
				super(42188, 42189, order)
			end
		end

		class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42181
				order[1] = 0
				super(42180, 42181, order)
			end
		end

		class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42100
				order[1] = 42101
				order[2] = 0
				super(42099, 42100, order)
			end
		end

		class NoUnderlyingProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42174
				order[1] = 42175
				order[2] = 42176
				order[3] = 40918
				order[4] = 42177
				order[5] = 0
				super(42173, 42174, order)
			end

			class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42178
					order[1] = 42179
					order[2] = 0
					super(42177, 42178, order)
				end
			end
		end
	end

	class NoUnderlyingAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 42037
			order[1] = 42038
			order[2] = 41340
			order[3] = 0
			super(42036, 42037, order)
		end

		class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 41341
				order[1] = 41701
				order[2] = 41709
				order[3] = 41710
				order[4] = 41711
				order[5] = 41712
				order[6] = 42017
				order[7] = 42025
				order[8] = 42026
				order[9] = 42027
				order[10] = 42028
				order[11] = 42029
				order[12] = 42030
				order[13] = 42031
				order[14] = 42032
				order[15] = 42033
				order[16] = 42034
				order[17] = 42035
				order[18] = 0
				super(41340, 41341, order)
			end
		end
	end

	class NoUnderlyingProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 42069
			order[1] = 42070
			order[2] = 42071
			order[3] = 42072
			order[4] = 42073
			order[5] = 42074
			order[6] = 42075
			order[7] = 42090
			order[8] = 42077
			order[9] = 42087
			order[10] = 42076
			order[11] = 0
			super(42068, 42069, order)
		end

		class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42091
				order[1] = 0
				super(42090, 42091, order)
			end
		end

		class NoUnderlyingProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 42078
				order[1] = 42079
				order[2] = 42080
				order[3] = 42081
				order[4] = 42082
				order[5] = 42083
				order[6] = 42084
				order[7] = 42085
				order[8] = 0
				super(42077, 42078, order)
			end

			class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42086
					order[1] = 0
					super(42085, 42086, order)
				end
			end
		end

		class NoUnderlyingProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42088
				order[1] = 42089
				order[2] = 0
				super(42087, 42088, order)
			end
		end
	end

	class NoUnderlyingCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 42042
			order[1] = 42043
			order[2] = 42044
			order[3] = 42045
			order[4] = 42046
			order[5] = 42047
			order[6] = 42048
			order[7] = 42049
			order[8] = 42050
			order[9] = 42051
			order[10] = 42052
			order[11] = 42039
			order[12] = 42797
			order[13] = 42798
			order[14] = 42053
			order[15] = 42054
			order[16] = 42790
			order[17] = 42791
			order[18] = 42792
			order[19] = 42793
			order[20] = 42794
			order[21] = 42795
			order[22] = 42796
			order[23] = 42055
			order[24] = 42056
			order[25] = 42057
			order[26] = 42058
			order[27] = 42059
			order[28] = 0
			super(42041, 42042, order)
		end

		class NoUnderlyingCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42040
				order[1] = 0
				super(42039, 42040, order)
			end
		end

		class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42789
				order[1] = 0
				super(42788, 42789, order)
			end
		end
	end

	class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 42065
			order[1] = 42061
			order[2] = 42062
			order[3] = 42063
			order[4] = 42064
			order[5] = 0
			super(42060, 42065, order)
		end

		class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42066
				order[1] = 42067
				order[2] = 0
				super(42065, 42066, order)
			end
		end
	end

	class NoUnderlyingRateSpreadSteps < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 43006
			order[1] = 43007
			order[2] = 0
			super(43005, 43006, order)
		end
	end

	class NoUnderlyingDividendPayments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 42856
			order[1] = 42857
			order[2] = 42858
			order[3] = 42859
			order[4] = 0
			super(42855, 42856, order)
		end
	end

	class NoUnderlyingExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42885
			order[1] = 42886
			order[2] = 0
			super(42884, 42885, order)
		end
	end

	class NoDerivativeSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1219
			order[1] = 1220
			order[2] = 0
			super(1218, 1219, order)
		end
	end

	class NoDerivativeEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1287
			order[1] = 1288
			order[2] = 1289
			order[3] = 1290
			order[4] = 1291
			order[5] = 0
			super(1286, 1287, order)
		end
	end

	class NoDerivativeInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1293
			order[1] = 1294
			order[2] = 1295
			order[3] = 2377
			order[4] = 1296
			order[5] = 0
			super(1292, 1293, order)
		end

		class NoDerivativeInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1297
				order[1] = 1298
				order[2] = 0
				super(1296, 1297, order)
			end
		end
	end

	class NoDerivativeInstrAttrib < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1313
			order[1] = 1314
			order[2] = 0
			super(1311, 1313, order)
		end
	end

	class NoMarketSegments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 1301
			order[1] = 1300
			order[2] = 1201
			order[3] = 0
			super(1310, 1301, order)
		end

		class NoTickRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(8)
				order[0] = 1206
				order[1] = 1207
				order[2] = 1208
				order[3] = 1209
				order[4] = 2571
				order[5] = 1830
				order[6] = 1831
				order[7] = 0
				super(1205, 1206, order)
			end
		end

		class NoLotTypeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1093
				order[1] = 1231
				order[2] = 0
				super(1234, 1093, order)
			end
		end

		class NoPriceRangeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 2551
				order[1] = 2552
				order[2] = 2553
				order[3] = 2554
				order[4] = 2556
				order[5] = 2555
				order[6] = 0
				super(2550, 2551, order)
			end
		end

		class NoQuoteSizeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 647
				order[1] = 648
				order[2] = 2447
				order[3] = 0
				super(2558, 647, order)
			end
		end

		class NoTradingSessionRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 336
				order[1] = 625
				order[2] = 0
				super(1309, 336, order)
			end

			class NoOrdTypeRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40
					order[1] = 0
					super(1237, 40, order)
				end
			end

			class NoTimeInForceRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 59
					order[1] = 0
					super(1239, 59, order)
				end
			end

			class NoExecInstRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 1308
					order[1] = 0
					super(1232, 1308, order)
				end
			end

			class NoAuctionTypeRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1803
					order[1] = 2549
					order[2] = 0
					super(2548, 1803, order)
				end
			end

			class NoMatchRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 1142
					order[1] = 574
					order[2] = 2569
					order[3] = 2570
					order[4] = 0
					super(1235, 1142, order)
				end
			end

			class NoMDFeedTypes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 1022
					order[1] = 1683
					order[2] = 264
					order[3] = 2563
					order[4] = 2564
					order[5] = 2565
					order[6] = 2566
					order[7] = 1021
					order[8] = 1173
					order[9] = 2567
					order[10] = 2568
					order[11] = 0
					super(1141, 1022, order)
				end
			end
		end

		class NoNestedInstrAttrib < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1210
				order[1] = 1211
				order[2] = 0
				super(1312, 1210, order)
			end
		end

		class NoStrikeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 1223
				order[1] = 1202
				order[2] = 1203
				order[3] = 1204
				order[4] = 1304
				order[5] = 1236
				order[6] = 0
				super(1201, 1223, order)
			end

			class NoMaturityRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(7)
					order[0] = 1222
					order[1] = 1303
					order[2] = 1302
					order[3] = 1241
					order[4] = 1226
					order[5] = 1229
					order[6] = 0
					super(1236, 1222, order)
				end
			end
		end
	end

	class NoSecurityClassifications < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1583
			order[1] = 1584
			order[2] = 0
			super(1582, 1583, order)
		end
	end

	class NoRelatedSym < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(172)
			order[0] = 55
			order[1] = 65
			order[2] = 48
			order[3] = 22
			order[4] = 460
			order[5] = 1227
			order[6] = 1151
			order[7] = 461
			order[8] = 2891
			order[9] = 167
			order[10] = 762
			order[11] = 200
			order[12] = 541
			order[13] = 1079
			order[14] = 966
			order[15] = 1049
			order[16] = 965
			order[17] = 224
			order[18] = 1449
			order[19] = 1450
			order[20] = 1451
			order[21] = 1452
			order[22] = 1457
			order[23] = 1458
			order[24] = 1739
			order[25] = 2210
			order[26] = 1938
			order[27] = 1939
			order[28] = 1940
			order[29] = 2735
			order[30] = 1941
			order[31] = 1575
			order[32] = 1942
			order[33] = 1943
			order[34] = 1944
			order[35] = 1945
			order[36] = 1946
			order[37] = 1947
			order[38] = 1948
			order[39] = 1949
			order[40] = 1950
			order[41] = 2879
			order[42] = 1951
			order[43] = 1952
			order[44] = 1953
			order[45] = 1954
			order[46] = 1955
			order[47] = 1956
			order[48] = 1957
			order[49] = 1958
			order[50] = 1959
			order[51] = 1960
			order[52] = 1577
			order[53] = 1580
			order[54] = 1581
			order[55] = 1678
			order[56] = 1697
			order[57] = 225
			order[58] = 239
			order[59] = 226
			order[60] = 227
			order[61] = 228
			order[62] = 255
			order[63] = 543
			order[64] = 470
			order[65] = 471
			order[66] = 472
			order[67] = 240
			order[68] = 202
			order[69] = 2578
			order[70] = 2577
			order[71] = 947
			order[72] = 2904
			order[73] = 967
			order[74] = 968
			order[75] = 1698
			order[76] = 1866
			order[77] = 2600
			order[78] = 2001
			order[79] = 2601
			order[80] = 1478
			order[81] = 1479
			order[82] = 1480
			order[83] = 1481
			order[84] = 206
			order[85] = 231
			order[86] = 1435
			order[87] = 2353
			order[88] = 1439
			order[89] = 969
			order[90] = 1146
			order[91] = 996
			order[92] = 1147
			order[93] = 1716
			order[94] = 2905
			order[95] = 1191
			order[96] = 1192
			order[97] = 1717
			order[98] = 2906
			order[99] = 1193
			order[100] = 2579
			order[101] = 1194
			order[102] = 1482
			order[103] = 1195
			order[104] = 2753
			order[105] = 1196
			order[106] = 1197
			order[107] = 2002
			order[108] = 2140
			order[109] = 1524
			order[110] = 2907
			order[111] = 1198
			order[112] = 1199
			order[113] = 1200
			order[114] = 201
			order[115] = 2681
			order[116] = 2685
			order[117] = 1244
			order[118] = 1242
			order[119] = 2575
			order[120] = 2574
			order[121] = 997
			order[122] = 223
			order[123] = 207
			order[124] = 970
			order[125] = 971
			order[126] = 106
			order[127] = 348
			order[128] = 349
			order[129] = 2737
			order[130] = 2714
			order[131] = 2715
			order[132] = 2716
			order[133] = 107
			order[134] = 350
			order[135] = 351
			order[136] = 691
			order[137] = 667
			order[138] = 875
			order[139] = 876
			order[140] = 873
			order[141] = 874
			order[142] = 1687
			order[143] = 1787
			order[144] = 2141
			order[145] = 2142
			order[146] = 2143
			order[147] = 2752
			order[148] = 2144
			order[149] = 2145
			order[150] = 2576
			order[151] = 2962
			order[152] = 2602
			order[153] = 2603
			order[154] = 1305
			order[155] = 1221
			order[156] = 1230
			order[157] = 1240
			order[158] = 15
			order[159] = 2897
			order[160] = 292
			order[161] = 668
			order[162] = 869
			order[163] = 2736
			order[164] = 2738
			order[165] = 555
			order[166] = 1504
			order[167] = 1606
			order[168] = 58
			order[169] = 354
			order[170] = 355
			order[171] = 0
			super(146, 55, order)
		end

		class NoSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 455
				order[1] = 456
				order[2] = 2957
				order[3] = 0
				super(454, 455, order)
			end
		end

		class NoSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1977
				order[1] = 1978
				order[2] = 1979
				order[3] = 2741
				order[4] = 0
				super(1976, 1977, order)
			end
		end

		class NoAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2305
				order[1] = 2306
				order[2] = 2307
				order[3] = 0
				super(2304, 2305, order)
			end
		end

		class NoEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 865
				order[1] = 866
				order[2] = 1145
				order[3] = 1827
				order[4] = 1826
				order[5] = 2340
				order[6] = 867
				order[7] = 868
				order[8] = 1578
				order[9] = 1579
				order[10] = 0
				super(864, 865, order)
			end
		end

		class NoInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1019
				order[1] = 1050
				order[2] = 1051
				order[3] = 2378
				order[4] = 1052
				order[5] = 0
				super(1018, 1019, order)
			end

			class NoInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1053
					order[1] = 1054
					order[2] = 0
					super(1052, 1053, order)
				end
			end
		end

		class NoComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 1484
				order[1] = 2117
				order[2] = 2118
				order[3] = 2119
				order[4] = 1485
				order[5] = 2120
				order[6] = 2121
				order[7] = 2122
				order[8] = 2941
				order[9] = 1486
				order[10] = 2123
				order[11] = 1487
				order[12] = 1488
				order[13] = 1489
				order[14] = 1490
				order[15] = 1491
				order[16] = 2124
				order[17] = 2942
				order[18] = 2125
				order[19] = 2943
				order[20] = 2126
				order[21] = 2127
				order[22] = 2407
				order[23] = 2408
				order[24] = 2128
				order[25] = 2129
				order[26] = 2130
				order[27] = 2131
				order[28] = 2132
				order[29] = 41013
				order[30] = 41020
				order[31] = 41021
				order[32] = 41022
				order[33] = 41023
				order[34] = 41024
				order[35] = 41025
				order[36] = 41026
				order[37] = 41027
				order[38] = 41028
				order[39] = 41010
				order[40] = 2133
				order[41] = 2134
				order[42] = 2135
				order[43] = 2136
				order[44] = 2137
				order[45] = 41029
				order[46] = 40997
				order[47] = 2597
				order[48] = 2598
				order[49] = 2599
				order[50] = 2138
				order[51] = 2139
				order[52] = 0
				super(1483, 1484, order)
			end

			class NoComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1492
					order[1] = 1493
					order[2] = 1494
					order[3] = 0
					super(1491, 1492, order)
				end

				class NoComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1495
						order[1] = 1496
						order[2] = 0
						super(1494, 1495, order)
					end
				end
			end

			class NoComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41014
					order[1] = 41015
					order[2] = 41016
					order[3] = 41017
					order[4] = 0
					super(41013, 41014, order)
				end
			end

			class NoComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41019
					order[1] = 0
					super(41018, 41019, order)
				end
			end

			class NoComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41011
					order[1] = 41012
					order[2] = 41031
					order[3] = 41007
					order[4] = 40994
					order[5] = 0
					super(41010, 41011, order)
				end

				class NoComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41032
						order[1] = 41033
						order[2] = 41034
						order[3] = 41035
						order[4] = 41036
						order[5] = 0
						super(41031, 41032, order)
					end
				end

				class NoComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41008
						order[1] = 41009
						order[2] = 0
						super(41007, 41008, order)
					end
				end

				class NoComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40995
						order[1] = 40996
						order[2] = 0
						super(40994, 40995, order)
					end
				end
			end

			class NoComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41030
					order[1] = 0
					super(41029, 41030, order)
				end
			end

			class NoComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40998
					order[1] = 40999
					order[2] = 41000
					order[3] = 41001
					order[4] = 41002
					order[5] = 41003
					order[6] = 41004
					order[7] = 41005
					order[8] = 0
					super(40997, 40998, order)
				end

				class NoComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41006
						order[1] = 0
						super(41005, 41006, order)
					end
				end
			end
		end

		class NoBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40471
				order[1] = 0
				super(40278, 40471, order)
			end
		end

		class NoPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41231
				order[1] = 0
				super(41230, 41231, order)
			end
		end

		class NoMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41093
				order[1] = 40991
				order[2] = 0
				super(41092, 41093, order)
			end
		end

		class NoMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41095
				order[1] = 40992
				order[2] = 0
				super(41094, 41095, order)
			end
		end

		class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41097
				order[1] = 41098
				order[2] = 41099
				order[3] = 41100
				order[4] = 41101
				order[5] = 41102
				order[6] = 41103
				order[7] = 41104
				order[8] = 41105
				order[9] = 0
				super(41096, 41097, order)
			end
		end

		class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42776
				order[1] = 0
				super(42775, 42776, order)
			end
		end

		class NoOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41117
				order[1] = 0
				super(41116, 41117, order)
			end
		end

		class NoOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41138
				order[1] = 41139
				order[2] = 0
				super(41137, 41138, order)
			end
		end

		class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41141
				order[1] = 0
				super(41140, 41141, order)
			end
		end

		class NoOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41153
				order[1] = 41154
				order[2] = 0
				super(41152, 41153, order)
			end
		end

		class NoStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40050
				order[1] = 41303
				order[2] = 40051
				order[3] = 42784
				order[4] = 42785
				order[5] = 40052
				order[6] = 40053
				order[7] = 41305
				order[8] = 40054
				order[9] = 40055
				order[10] = 42786
				order[11] = 42787
				order[12] = 41306
				order[13] = 41307
				order[14] = 41308
				order[15] = 41309
				order[16] = 41310
				order[17] = 41311
				order[18] = 41251
				order[19] = 41252
				order[20] = 41253
				order[21] = 41254
				order[22] = 41255
				order[23] = 41256
				order[24] = 41257
				order[25] = 42587
				order[26] = 41258
				order[27] = 41259
				order[28] = 41260
				order[29] = 41261
				order[30] = 41262
				order[31] = 41263
				order[32] = 41264
				order[33] = 41265
				order[34] = 41266
				order[35] = 41267
				order[36] = 41268
				order[37] = 41269
				order[38] = 41270
				order[39] = 41271
				order[40] = 41272
				order[41] = 41273
				order[42] = 41274
				order[43] = 41275
				order[44] = 41276
				order[45] = 40907
				order[46] = 40908
				order[47] = 40910
				order[48] = 40911
				order[49] = 40912
				order[50] = 40913
				order[51] = 40914
				order[52] = 40065
				order[53] = 40066
				order[54] = 40068
				order[55] = 40069
				order[56] = 40070
				order[57] = 40071
				order[58] = 40072
				order[59] = 41244
				order[60] = 41245
				order[61] = 40073
				order[62] = 40075
				order[63] = 40076
				order[64] = 40078
				order[65] = 40079
				order[66] = 40080
				order[67] = 40081
				order[68] = 40082
				order[69] = 40083
				order[70] = 40084
				order[71] = 41246
				order[72] = 41247
				order[73] = 41248
				order[74] = 40738
				order[75] = 40739
				order[76] = 40740
				order[77] = 42600
				order[78] = 40741
				order[79] = 40742
				order[80] = 43106
				order[81] = 40743
				order[82] = 40744
				order[83] = 40745
				order[84] = 40746
				order[85] = 40747
				order[86] = 42601
				order[87] = 42602
				order[88] = 42603
				order[89] = 42604
				order[90] = 40748
				order[91] = 40749
				order[92] = 40750
				order[93] = 41180
				order[94] = 41181
				order[95] = 41182
				order[96] = 41183
				order[97] = 41184
				order[98] = 41185
				order[99] = 41186
				order[100] = 42605
				order[101] = 40828
				order[102] = 40872
				order[103] = 41058
				order[104] = 41059
				order[105] = 41060
				order[106] = 41061
				order[107] = 41062
				order[108] = 42192
				order[109] = 42193
				order[110] = 41063
				order[111] = 41064
				order[112] = 41065
				order[113] = 41066
				order[114] = 41067
				order[115] = 41218
				order[116] = 41068
				order[117] = 41069
				order[118] = 41070
				order[119] = 41071
				order[120] = 41072
				order[121] = 41073
				order[122] = 41074
				order[123] = 41075
				order[124] = 41076
				order[125] = 41077
				order[126] = 41078
				order[127] = 41079
				order[128] = 41080
				order[129] = 43094
				order[130] = 41037
				order[131] = 40056
				order[132] = 40982
				order[133] = 40983
				order[134] = 0
				super(40049, 40050, order)
			end

			class NoStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41278
					order[1] = 41279
					order[2] = 0
					super(41277, 41278, order)
				end
			end

			class NoStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41238
					order[1] = 41239
					order[2] = 41240
					order[3] = 0
					super(41237, 41238, order)
				end
			end

			class NoStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41281
					order[1] = 41282
					order[2] = 0
					super(41280, 41281, order)
				end
			end

			class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41250
					order[1] = 0
					super(41249, 41250, order)
				end
			end

			class NoStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41290
					order[1] = 41291
					order[2] = 41292
					order[3] = 41293
					order[4] = 41294
					order[5] = 41295
					order[6] = 41296
					order[7] = 41297
					order[8] = 41298
					order[9] = 41299
					order[10] = 41300
					order[11] = 41283
					order[12] = 41301
					order[13] = 41302
					order[14] = 0
					super(41289, 41290, order)
				end

				class NoStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41284
						order[1] = 41285
						order[2] = 41286
						order[3] = 0
						super(41283, 41284, order)
					end

					class NoStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41287
							order[1] = 41288
							order[2] = 41588
							order[3] = 0
							super(41286, 41287, order)
						end
					end
				end
			end

			class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40909
					order[1] = 0
					super(40960, 40909, order)
				end
			end

			class NoStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40067
					order[1] = 0
					super(40961, 40067, order)
				end
			end

			class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40074
					order[1] = 0
					super(40958, 40074, order)
				end
			end

			class NoStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41242
					order[1] = 41243
					order[2] = 0
					super(41241, 41242, order)
				end
			end

			class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40077
					order[1] = 0
					super(40959, 40077, order)
				end
			end

			class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40752
					order[1] = 0
					super(40947, 40752, order)
				end
			end

			class NoPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41221
					order[1] = 41222
					order[2] = 0
					super(41220, 41221, order)
				end
			end

			class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40763
					order[1] = 0
					super(40948, 40763, order)
				end
			end

			class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40769
					order[1] = 0
					super(40949, 40769, order)
				end
			end

			class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40776
					order[1] = 0
					super(40950, 40776, order)
				end
			end

			class NoPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42661
					order[1] = 42662
					order[2] = 0
					super(42660, 42661, order)
				end
			end

			class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41193
					order[1] = 0
					super(41192, 41193, order)
				end
			end

			class NoPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41228
					order[1] = 41229
					order[2] = 0
					super(41227, 41228, order)
				end
			end

			class NoPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41225
					order[1] = 41226
					order[2] = 0
					super(41224, 41225, order)
				end
			end

			class NoPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43109
					order[1] = 42684
					order[2] = 42685
					order[3] = 0
					super(42683, 43109, order)
				end
			end

			class NoDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42275
					order[1] = 42276
					order[2] = 42277
					order[3] = 42278
					order[4] = 42279
					order[5] = 42280
					order[6] = 42294
					order[7] = 42281
					order[8] = 42282
					order[9] = 42283
					order[10] = 42284
					order[11] = 42285
					order[12] = 42286
					order[13] = 42287
					order[14] = 42288
					order[15] = 42289
					order[16] = 42290
					order[17] = 42291
					order[18] = 42292
					order[19] = 42293
					order[20] = 0
					super(42274, 42275, order)
				end

				class NoDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42295
						order[1] = 0
						super(42294, 42295, order)
					end
				end
			end

			class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42273
					order[1] = 0
					super(42272, 42273, order)
				end
			end

			class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42237
					order[1] = 0
					super(42236, 42237, order)
				end
			end

			class NoReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42736
					order[1] = 42737
					order[2] = 42738
					order[3] = 42739
					order[4] = 42740
					order[5] = 42741
					order[6] = 42765
					order[7] = 42731
					order[8] = 42742
					order[9] = 42743
					order[10] = 42744
					order[11] = 42745
					order[12] = 42746
					order[13] = 42747
					order[14] = 42748
					order[15] = 42749
					order[16] = 42750
					order[17] = 42751
					order[18] = 42752
					order[19] = 42753
					order[20] = 42761
					order[21] = 42754
					order[22] = 42755
					order[23] = 42709
					order[24] = 42756
					order[25] = 42757
					order[26] = 42758
					order[27] = 42759
					order[28] = 42760
					order[29] = 0
					super(42735, 42736, order)
				end

				class NoReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42766
						order[1] = 42767
						order[2] = 42768
						order[3] = 42769
						order[4] = 0
						super(42765, 42766, order)
					end
				end

				class NoReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42732
						order[1] = 42733
						order[2] = 42734
						order[3] = 0
						super(42731, 42732, order)
					end
				end

				class NoReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42762
						order[1] = 42763
						order[2] = 42764
						order[3] = 0
						super(42761, 42762, order)
					end
				end

				class NoReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42710
						order[1] = 42772
						order[2] = 42711
						order[3] = 42712
						order[4] = 42713
						order[5] = 42714
						order[6] = 42715
						order[7] = 42716
						order[8] = 42717
						order[9] = 42718
						order[10] = 42719
						order[11] = 42720
						order[12] = 42721
						order[13] = 42722
						order[14] = 42723
						order[15] = 42724
						order[16] = 42725
						order[17] = 42726
						order[18] = 42727
						order[19] = 42728
						order[20] = 42729
						order[21] = 42730
						order[22] = 42770
						order[23] = 0
						super(42709, 42710, order)
					end

					class NoReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42773
							order[1] = 42774
							order[2] = 0
							super(42772, 42773, order)
						end
					end

					class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42771
							order[1] = 0
							super(42770, 42771, order)
						end
					end
				end
			end

			class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42621
					order[1] = 0
					super(42620, 42621, order)
				end
			end

			class NoPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42607
					order[1] = 42608
					order[2] = 0
					super(42606, 42607, order)
				end
			end

			class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40819
					order[1] = 0
					super(40946, 40819, order)
				end
			end

			class NoNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40826
					order[1] = 40827
					order[2] = 0
					super(40825, 40826, order)
				end
			end

			class NoSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40086
					order[1] = 40373
					order[2] = 40655
					order[3] = 40088
					order[4] = 40089
					order[5] = 0
					super(40085, 40086, order)
				end
			end

			class NoPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40829
					order[1] = 41164
					order[2] = 41165
					order[3] = 40830
					order[4] = 40831
					order[5] = 40832
					order[6] = 40833
					order[7] = 40834
					order[8] = 40835
					order[9] = 40836
					order[10] = 40837
					order[11] = 40838
					order[12] = 40839
					order[13] = 41166
					order[14] = 41167
					order[15] = 41168
					order[16] = 41169
					order[17] = 40840
					order[18] = 40841
					order[19] = 40842
					order[20] = 40843
					order[21] = 41170
					order[22] = 41171
					order[23] = 41172
					order[24] = 41173
					order[25] = 40844
					order[26] = 40845
					order[27] = 40846
					order[28] = 40847
					order[29] = 40848
					order[30] = 40849
					order[31] = 40868
					order[32] = 40850
					order[33] = 40851
					order[34] = 40852
					order[35] = 40853
					order[36] = 40977
					order[37] = 40855
					order[38] = 40856
					order[39] = 40857
					order[40] = 41174
					order[41] = 41175
					order[42] = 40858
					order[43] = 41161
					order[44] = 41176
					order[45] = 41177
					order[46] = 41178
					order[47] = 41179
					order[48] = 40859
					order[49] = 40860
					order[50] = 40861
					order[51] = 40862
					order[52] = 40945
					order[53] = 40864
					order[54] = 40865
					order[55] = 40866
					order[56] = 40867
					order[57] = 0
					super(40828, 40829, order)
				end

				class NoPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40869
						order[1] = 40870
						order[2] = 40871
						order[3] = 0
						super(40868, 40869, order)
					end
				end

				class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40854
						order[1] = 0
						super(40977, 40854, order)
					end
				end

				class NoPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41162
						order[1] = 41163
						order[2] = 0
						super(41161, 41162, order)
					end
				end

				class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40863
						order[1] = 0
						super(40945, 40863, order)
					end
				end
			end

			class NoPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40873
					order[1] = 40874
					order[2] = 42698
					order[3] = 42699
					order[4] = 42700
					order[5] = 42701
					order[6] = 42702
					order[7] = 42703
					order[8] = 42704
					order[9] = 42689
					order[10] = 42690
					order[11] = 42691
					order[12] = 42692
					order[13] = 42693
					order[14] = 42694
					order[15] = 42695
					order[16] = 40875
					order[17] = 40876
					order[18] = 40877
					order[19] = 40878
					order[20] = 40879
					order[21] = 40880
					order[22] = 40881
					order[23] = 40882
					order[24] = 40883
					order[25] = 40884
					order[26] = 40885
					order[27] = 40886
					order[28] = 40887
					order[29] = 40888
					order[30] = 40889
					order[31] = 40890
					order[32] = 40891
					order[33] = 40892
					order[34] = 40893
					order[35] = 40894
					order[36] = 40895
					order[37] = 40896
					order[38] = 40897
					order[39] = 40898
					order[40] = 40899
					order[41] = 40900
					order[42] = 40901
					order[43] = 0
					super(40872, 40873, order)
				end

				class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42706
						order[1] = 0
						super(42705, 42706, order)
					end
				end

				class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42697
						order[1] = 0
						super(42696, 42697, order)
					end
				end
			end

			class NoDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41086
					order[1] = 0
					super(41085, 41086, order)
				end
			end

			class NoDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41082
					order[1] = 41083
					order[2] = 41084
					order[3] = 0
					super(41081, 41082, order)
				end
			end

			class NoDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41038
					order[1] = 41039
					order[2] = 41040
					order[3] = 41041
					order[4] = 41042
					order[5] = 41043
					order[6] = 41044
					order[7] = 41045
					order[8] = 41046
					order[9] = 41047
					order[10] = 41048
					order[11] = 41049
					order[12] = 41050
					order[13] = 41051
					order[14] = 0
					super(41037, 41038, order)
				end

				class NoDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41052
						order[1] = 41053
						order[2] = 41054
						order[3] = 0
						super(41051, 41052, order)
					end

					class NoDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41055
							order[1] = 41056
							order[2] = 41057
							order[3] = 0
							super(41054, 41055, order)
						end
					end
				end
			end
		end

		class NoProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40091
				order[1] = 40092
				order[2] = 40093
				order[3] = 40957
				order[4] = 40095
				order[5] = 40096
				order[6] = 40097
				order[7] = 42707
				order[8] = 42708
				order[9] = 40098
				order[10] = 40099
				order[11] = 40100
				order[12] = 40114
				order[13] = 40115
				order[14] = 40116
				order[15] = 40118
				order[16] = 40119
				order[17] = 40120
				order[18] = 40121
				order[19] = 40122
				order[20] = 40123
				order[21] = 40125
				order[22] = 40126
				order[23] = 40127
				order[24] = 40128
				order[25] = 40129
				order[26] = 40130
				order[27] = 40131
				order[28] = 40132
				order[29] = 40133
				order[30] = 40134
				order[31] = 40135
				order[32] = 40136
				order[33] = 40137
				order[34] = 40138
				order[35] = 40139
				order[36] = 40140
				order[37] = 40141
				order[38] = 40145
				order[39] = 40146
				order[40] = 40148
				order[41] = 40149
				order[42] = 40150
				order[43] = 40151
				order[44] = 40152
				order[45] = 40153
				order[46] = 40154
				order[47] = 40155
				order[48] = 40156
				order[49] = 40158
				order[50] = 40159
				order[51] = 40160
				order[52] = 40161
				order[53] = 40162
				order[54] = 40101
				order[55] = 40102
				order[56] = 40103
				order[57] = 40104
				order[58] = 40105
				order[59] = 40106
				order[60] = 40107
				order[61] = 40163
				order[62] = 40165
				order[63] = 40166
				order[64] = 40167
				order[65] = 40168
				order[66] = 40169
				order[67] = 40170
				order[68] = 40108
				order[69] = 40109
				order[70] = 40110
				order[71] = 40111
				order[72] = 40112
				order[73] = 41406
				order[74] = 40113
				order[75] = 40986
				order[76] = 40987
				order[77] = 40174
				order[78] = 0
				super(40090, 40091, order)
			end

			class NoProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40094
					order[1] = 0
					super(40957, 40094, order)
				end
			end

			class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40117
					order[1] = 0
					super(40953, 40117, order)
				end
			end

			class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40124
					order[1] = 0
					super(40954, 40124, order)
				end
			end

			class NoProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40143
					order[1] = 40144
					order[2] = 0
					super(40142, 40143, order)
				end
			end

			class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40147
					order[1] = 0
					super(40955, 40147, order)
				end
			end

			class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40157
					order[1] = 0
					super(40956, 40157, order)
				end
			end

			class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40164
					order[1] = 0
					super(40952, 40164, order)
				end
			end

			class NoProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40172
					order[1] = 40173
					order[2] = 0
					super(40171, 40172, order)
				end
			end

			class NoProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40175
					order[1] = 40176
					order[2] = 40177
					order[3] = 2385
					order[4] = 40178
					order[5] = 0
					super(40174, 40175, order)
				end

				class NoProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40179
						order[1] = 40180
						order[2] = 0
						super(40178, 40179, order)
					end
				end
			end
		end

		class NoAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40020
				order[1] = 40021
				order[2] = 40000
				order[3] = 0
				super(40019, 40020, order)
			end

			class NoAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 40001
					order[1] = 40002
					order[2] = 40003
					order[3] = 40004
					order[4] = 40005
					order[5] = 40006
					order[6] = 40007
					order[7] = 40008
					order[8] = 40009
					order[9] = 40010
					order[10] = 40011
					order[11] = 40012
					order[12] = 40013
					order[13] = 40014
					order[14] = 40015
					order[15] = 40016
					order[16] = 40017
					order[17] = 40018
					order[18] = 0
					super(40000, 40001, order)
				end
			end
		end

		class NoProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 40182
				order[1] = 40183
				order[2] = 40184
				order[3] = 40185
				order[4] = 40186
				order[5] = 40187
				order[6] = 40188
				order[7] = 40951
				order[8] = 40191
				order[9] = 40201
				order[10] = 40190
				order[11] = 0
				super(40181, 40182, order)
			end

			class NoProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40189
					order[1] = 0
					super(40951, 40189, order)
				end
			end

			class NoProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40192
					order[1] = 40193
					order[2] = 40194
					order[3] = 40195
					order[4] = 40196
					order[5] = 40197
					order[6] = 40198
					order[7] = 40199
					order[8] = 0
					super(40191, 40192, order)
				end

				class NoProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40200
						order[1] = 0
						super(40199, 40200, order)
					end
				end
			end

			class NoProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40202
					order[1] = 40203
					order[2] = 0
					super(40201, 40202, order)
				end
			end
		end

		class NoCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 40023
				order[1] = 40024
				order[2] = 40916
				order[3] = 40917
				order[4] = 40025
				order[5] = 40026
				order[6] = 40027
				order[7] = 40028
				order[8] = 40029
				order[9] = 40030
				order[10] = 40031
				order[11] = 40277
				order[12] = 42216
				order[13] = 42217
				order[14] = 40033
				order[15] = 40034
				order[16] = 42207
				order[17] = 42208
				order[18] = 42209
				order[19] = 42210
				order[20] = 42211
				order[21] = 42212
				order[22] = 42213
				order[23] = 40035
				order[24] = 40036
				order[25] = 40037
				order[26] = 40038
				order[27] = 40039
				order[28] = 0
				super(40022, 40023, order)
			end

			class NoCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40032
					order[1] = 0
					super(40277, 40032, order)
				end
			end

			class NoCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42215
					order[1] = 0
					super(42214, 42215, order)
				end
			end
		end

		class NoPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40209
				order[1] = 40205
				order[2] = 40206
				order[3] = 40207
				order[4] = 40208
				order[5] = 0
				super(40204, 40209, order)
			end

			class NoPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40210
					order[1] = 40211
					order[2] = 0
					super(40209, 40210, order)
				end
			end
		end

		class NoExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42297
				order[1] = 42298
				order[2] = 0
				super(42296, 42297, order)
			end
		end

		class NoInstrAttrib < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 871
				order[1] = 872
				order[2] = 0
				super(870, 871, order)
			end
		end

		class NoIndexRollMonths < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 2733
				order[1] = 0
				super(2734, 2733, order)
			end
		end

		class NoReferenceDataDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2747
				order[1] = 2748
				order[2] = 0
				super(2746, 2747, order)
			end
		end

		class NoLegs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(176)
				order[0] = 600
				order[1] = 601
				order[2] = 602
				order[3] = 603
				order[4] = 1788
				order[5] = 607
				order[6] = 1594
				order[7] = 608
				order[8] = 2893
				order[9] = 609
				order[10] = 764
				order[11] = 610
				order[12] = 611
				order[13] = 1212
				order[14] = 2146
				order[15] = 2147
				order[16] = 2148
				order[17] = 248
				order[18] = 2149
				order[19] = 2150
				order[20] = 2151
				order[21] = 2152
				order[22] = 2153
				order[23] = 2154
				order[24] = 2155
				order[25] = 2348
				order[26] = 2067
				order[27] = 2068
				order[28] = 2069
				order[29] = 2739
				order[30] = 2070
				order[31] = 2156
				order[32] = 2157
				order[33] = 2158
				order[34] = 2159
				order[35] = 2160
				order[36] = 2161
				order[37] = 2162
				order[38] = 2163
				order[39] = 2164
				order[40] = 2165
				order[41] = 2880
				order[42] = 2166
				order[43] = 2167
				order[44] = 2168
				order[45] = 2169
				order[46] = 2170
				order[47] = 2171
				order[48] = 2172
				order[49] = 2173
				order[50] = 2174
				order[51] = 2175
				order[52] = 2176
				order[53] = 2177
				order[54] = 2178
				order[55] = 2179
				order[56] = 2180
				order[57] = 249
				order[58] = 250
				order[59] = 251
				order[60] = 252
				order[61] = 253
				order[62] = 257
				order[63] = 599
				order[64] = 596
				order[65] = 597
				order[66] = 598
				order[67] = 254
				order[68] = 612
				order[69] = 942
				order[70] = 2908
				order[71] = 2181
				order[72] = 2182
				order[73] = 2183
				order[74] = 2184
				order[75] = 2604
				order[76] = 2185
				order[77] = 2605
				order[78] = 2186
				order[79] = 2187
				order[80] = 2188
				order[81] = 2189
				order[82] = 613
				order[83] = 614
				order[84] = 1436
				order[85] = 2354
				order[86] = 1440
				order[87] = 2190
				order[88] = 2191
				order[89] = 999
				order[90] = 1224
				order[91] = 1720
				order[92] = 2909
				order[93] = 1421
				order[94] = 1422
				order[95] = 1721
				order[96] = 2910
				order[97] = 2192
				order[98] = 1001
				order[99] = 1420
				order[100] = 2193
				order[101] = 2194
				order[102] = 2755
				order[103] = 2195
				order[104] = 2196
				order[105] = 2197
				order[106] = 2198
				order[107] = 1528
				order[108] = 2911
				order[109] = 2199
				order[110] = 2200
				order[111] = 2201
				order[112] = 2202
				order[113] = 2203
				order[114] = 615
				order[115] = 616
				order[116] = 2205
				order[117] = 2206
				order[118] = 617
				order[119] = 618
				order[120] = 619
				order[121] = 2740
				order[122] = 2717
				order[123] = 2718
				order[124] = 2719
				order[125] = 620
				order[126] = 621
				order[127] = 622
				order[128] = 2207
				order[129] = 2208
				order[130] = 623
				order[131] = 624
				order[132] = 556
				order[133] = 2898
				order[134] = 740
				order[135] = 739
				order[136] = 955
				order[137] = 956
				order[138] = 1358
				order[139] = 2682
				order[140] = 2686
				order[141] = 1017
				order[142] = 566
				order[143] = 2209
				order[144] = 2211
				order[145] = 2212
				order[146] = 2213
				order[147] = 2754
				order[148] = 2214
				order[149] = 2215
				order[150] = 2606
				order[151] = 2607
				order[152] = 2497
				order[153] = 2498
				order[154] = 2499
				order[155] = 2496
				order[156] = 2495
				order[157] = 2953
				order[158] = 2511
				order[159] = 2510
				order[160] = 2512
				order[161] = 2509
				order[162] = 2500
				order[163] = 2502
				order[164] = 2501
				order[165] = 2503
				order[166] = 2507
				order[167] = 2505
				order[168] = 2494
				order[169] = 2493
				order[170] = 2514
				order[171] = 2513
				order[172] = 2506
				order[173] = 2504
				order[174] = 2508
				order[175] = 0
				super(555, 600, order)
			end

			class NoLegSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 605
					order[1] = 606
					order[2] = 2958
					order[3] = 0
					super(604, 605, order)
				end
			end

			class NoLegSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2077
					order[1] = 2078
					order[2] = 2079
					order[3] = 2743
					order[4] = 0
					super(2076, 2077, order)
				end
			end

			class NoLegAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2309
					order[1] = 2310
					order[2] = 2311
					order[3] = 0
					super(2308, 2309, order)
				end
			end

			class NoLegEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 2060
					order[1] = 2061
					order[2] = 2062
					order[3] = 2063
					order[4] = 2064
					order[5] = 2341
					order[6] = 2065
					order[7] = 2066
					order[8] = 2074
					order[9] = 2075
					order[10] = 0
					super(2059, 2060, order)
				end
			end

			class NoLegInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 2255
					order[1] = 2256
					order[2] = 2257
					order[3] = 2379
					order[4] = 2258
					order[5] = 0
					super(2254, 2255, order)
				end

				class NoLegInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2259
						order[1] = 2260
						order[2] = 0
						super(2258, 2259, order)
					end
				end
			end

			class NoLegComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2219
					order[1] = 2220
					order[2] = 2221
					order[3] = 2222
					order[4] = 2223
					order[5] = 2224
					order[6] = 2225
					order[7] = 2226
					order[8] = 2944
					order[9] = 2227
					order[10] = 2228
					order[11] = 2229
					order[12] = 2230
					order[13] = 2231
					order[14] = 2232
					order[15] = 2250
					order[16] = 2233
					order[17] = 2945
					order[18] = 2234
					order[19] = 2946
					order[20] = 2235
					order[21] = 2236
					order[22] = 2409
					order[23] = 2410
					order[24] = 2237
					order[25] = 2238
					order[26] = 2239
					order[27] = 2240
					order[28] = 2241
					order[29] = 41382
					order[30] = 41389
					order[31] = 41390
					order[32] = 41391
					order[33] = 41392
					order[34] = 41393
					order[35] = 41394
					order[36] = 41395
					order[37] = 41396
					order[38] = 41397
					order[39] = 41379
					order[40] = 2242
					order[41] = 2243
					order[42] = 2244
					order[43] = 2245
					order[44] = 2246
					order[45] = 41398
					order[46] = 41366
					order[47] = 2608
					order[48] = 2609
					order[49] = 2610
					order[50] = 2248
					order[51] = 2249
					order[52] = 0
					super(2218, 2219, order)
				end

				class NoLegComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2251
						order[1] = 2252
						order[2] = 2253
						order[3] = 0
						super(2250, 2251, order)
					end

					class NoLegComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2204
							order[1] = 2247
							order[2] = 0
							super(2253, 2204, order)
						end
					end
				end

				class NoLegComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41383
						order[1] = 41384
						order[2] = 41385
						order[3] = 41386
						order[4] = 0
						super(41382, 41383, order)
					end
				end

				class NoLegComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41388
						order[1] = 0
						super(41387, 41388, order)
					end
				end

				class NoLegComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41380
						order[1] = 41381
						order[2] = 41400
						order[3] = 41376
						order[4] = 41363
						order[5] = 0
						super(41379, 41380, order)
					end

					class NoLegComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41401
							order[1] = 41402
							order[2] = 41403
							order[3] = 41404
							order[4] = 41405
							order[5] = 0
							super(41400, 41401, order)
						end
					end

					class NoLegComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41377
							order[1] = 41378
							order[2] = 0
							super(41376, 41377, order)
						end
					end

					class NoLegComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41364
							order[1] = 41365
							order[2] = 0
							super(41363, 41364, order)
						end
					end
				end

				class NoLegComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41399
						order[1] = 0
						super(41398, 41399, order)
					end
				end

				class NoLegComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41367
						order[1] = 41368
						order[2] = 41369
						order[3] = 41370
						order[4] = 41371
						order[5] = 41372
						order[6] = 41373
						order[7] = 41374
						order[8] = 0
						super(41366, 41367, order)
					end

					class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41375
							order[1] = 0
							super(41374, 41375, order)
						end
					end
				end
			end

			class NoLegBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40924
					order[1] = 0
					super(40923, 40924, order)
				end
			end

			class NoLegPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41608
					order[1] = 0
					super(41607, 41608, order)
				end
			end

			class NoLegMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41468
					order[1] = 40223
					order[2] = 0
					super(41467, 41468, order)
				end
			end

			class NoLegMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41470
					order[1] = 40990
					order[2] = 0
					super(41469, 41470, order)
				end
			end

			class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41472
					order[1] = 41473
					order[2] = 41474
					order[3] = 41475
					order[4] = 41476
					order[5] = 41477
					order[6] = 41478
					order[7] = 41479
					order[8] = 41480
					order[9] = 0
					super(41471, 41472, order)
				end
			end

			class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42582
					order[1] = 0
					super(42581, 42582, order)
				end
			end

			class NoLegOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41492
					order[1] = 0
					super(41491, 41492, order)
				end
			end

			class NoLegOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41513
					order[1] = 41514
					order[2] = 0
					super(41512, 41513, order)
				end
			end

			class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41516
					order[1] = 0
					super(41515, 41516, order)
				end
			end

			class NoLegOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41528
					order[1] = 41529
					order[2] = 0
					super(41527, 41528, order)
				end
			end

			class NoLegStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40242
					order[1] = 41700
					order[2] = 40243
					order[3] = 42583
					order[4] = 42584
					order[5] = 40244
					order[6] = 40245
					order[7] = 41702
					order[8] = 40246
					order[9] = 40247
					order[10] = 42585
					order[11] = 42586
					order[12] = 41703
					order[13] = 41704
					order[14] = 41705
					order[15] = 41706
					order[16] = 41707
					order[17] = 41708
					order[18] = 41648
					order[19] = 41649
					order[20] = 41650
					order[21] = 41651
					order[22] = 41652
					order[23] = 41653
					order[24] = 41654
					order[25] = 42588
					order[26] = 41655
					order[27] = 41656
					order[28] = 41657
					order[29] = 41658
					order[30] = 41659
					order[31] = 41660
					order[32] = 41661
					order[33] = 41662
					order[34] = 41663
					order[35] = 41664
					order[36] = 41665
					order[37] = 41666
					order[38] = 41667
					order[39] = 41668
					order[40] = 41669
					order[41] = 41670
					order[42] = 41671
					order[43] = 41672
					order[44] = 41673
					order[45] = 40249
					order[46] = 40250
					order[47] = 40252
					order[48] = 40253
					order[49] = 40254
					order[50] = 40255
					order[51] = 40256
					order[52] = 40257
					order[53] = 40258
					order[54] = 40260
					order[55] = 40261
					order[56] = 40262
					order[57] = 40263
					order[58] = 40264
					order[59] = 41641
					order[60] = 41642
					order[61] = 40265
					order[62] = 40267
					order[63] = 40268
					order[64] = 40270
					order[65] = 40271
					order[66] = 40272
					order[67] = 40273
					order[68] = 40274
					order[69] = 40275
					order[70] = 40276
					order[71] = 41643
					order[72] = 41644
					order[73] = 41645
					order[74] = 40279
					order[75] = 40280
					order[76] = 40281
					order[77] = 42399
					order[78] = 40282
					order[79] = 40283
					order[80] = 43108
					order[81] = 40284
					order[82] = 40285
					order[83] = 40286
					order[84] = 40287
					order[85] = 40288
					order[86] = 42400
					order[87] = 42401
					order[88] = 42402
					order[89] = 42403
					order[90] = 40289
					order[91] = 40290
					order[92] = 40291
					order[93] = 41549
					order[94] = 41550
					order[95] = 41551
					order[96] = 41552
					order[97] = 41553
					order[98] = 41554
					order[99] = 41555
					order[100] = 42404
					order[101] = 40374
					order[102] = 40418
					order[103] = 41429
					order[104] = 41430
					order[105] = 41431
					order[106] = 41432
					order[107] = 41433
					order[108] = 42194
					order[109] = 42195
					order[110] = 41434
					order[111] = 41435
					order[112] = 41436
					order[113] = 41437
					order[114] = 41438
					order[115] = 41219
					order[116] = 41439
					order[117] = 41440
					order[118] = 41441
					order[119] = 41442
					order[120] = 41443
					order[121] = 41444
					order[122] = 41445
					order[123] = 41446
					order[124] = 41447
					order[125] = 41448
					order[126] = 41449
					order[127] = 41450
					order[128] = 41451
					order[129] = 43095
					order[130] = 41408
					order[131] = 40248
					order[132] = 40978
					order[133] = 40979
					order[134] = 0
					super(40241, 40242, order)
				end

				class NoLegStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41675
						order[1] = 41676
						order[2] = 0
						super(41674, 41675, order)
					end
				end

				class NoLegStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41453
						order[1] = 41454
						order[2] = 41455
						order[3] = 0
						super(41452, 41453, order)
					end
				end

				class NoLegStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41678
						order[1] = 41679
						order[2] = 0
						super(41677, 41678, order)
					end
				end

				class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41647
						order[1] = 0
						super(41646, 41647, order)
					end
				end

				class NoLegStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41687
						order[1] = 41688
						order[2] = 41689
						order[3] = 41690
						order[4] = 41691
						order[5] = 41692
						order[6] = 41693
						order[7] = 41694
						order[8] = 41695
						order[9] = 41696
						order[10] = 41697
						order[11] = 41680
						order[12] = 41698
						order[13] = 41699
						order[14] = 0
						super(41686, 41687, order)
					end

					class NoLegStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41681
							order[1] = 41682
							order[2] = 41683
							order[3] = 0
							super(41680, 41681, order)
						end

						class NoLegStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41684
								order[1] = 41685
								order[2] = 41935
								order[3] = 0
								super(41683, 41684, order)
							end
						end
					end
				end

				class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40251
						order[1] = 0
						super(40942, 40251, order)
					end
				end

				class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40259
						order[1] = 0
						super(40943, 40259, order)
					end
				end

				class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40266
						order[1] = 0
						super(40940, 40266, order)
					end
				end

				class NoLegStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41639
						order[1] = 41640
						order[2] = 0
						super(41638, 41639, order)
					end
				end

				class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40269
						order[1] = 0
						super(40941, 40269, order)
					end
				end

				class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40293
						order[1] = 0
						super(40930, 40293, order)
					end
				end

				class NoLegPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41590
						order[1] = 41591
						order[2] = 0
						super(41589, 41590, order)
					end
				end

				class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40305
						order[1] = 0
						super(40931, 40305, order)
					end
				end

				class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40311
						order[1] = 0
						super(40932, 40311, order)
					end
				end

				class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40318
						order[1] = 0
						super(40933, 40318, order)
					end
				end

				class NoLegPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42460
						order[1] = 42461
						order[2] = 0
						super(42459, 42460, order)
					end
				end

				class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41562
						order[1] = 0
						super(41561, 41562, order)
					end
				end

				class NoLegPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41597
						order[1] = 41598
						order[2] = 0
						super(41596, 41597, order)
					end
				end

				class NoLegPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41594
						order[1] = 41595
						order[2] = 0
						super(41593, 41594, order)
					end
				end

				class NoLegPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43110
						order[1] = 42486
						order[2] = 42487
						order[3] = 0
						super(42485, 43110, order)
					end
				end

				class NoLegDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42367
						order[1] = 42368
						order[2] = 42369
						order[3] = 42370
						order[4] = 42371
						order[5] = 42372
						order[6] = 42386
						order[7] = 42373
						order[8] = 42374
						order[9] = 42375
						order[10] = 42376
						order[11] = 42377
						order[12] = 42378
						order[13] = 42379
						order[14] = 42380
						order[15] = 42381
						order[16] = 42382
						order[17] = 42383
						order[18] = 42384
						order[19] = 42385
						order[20] = 0
						super(42366, 42367, order)
					end

					class NoLegDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42387
							order[1] = 0
							super(42386, 42387, order)
						end
					end
				end

				class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42365
						order[1] = 0
						super(42364, 42365, order)
					end
				end

				class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42311
						order[1] = 0
						super(42310, 42311, order)
					end
				end

				class NoLegReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 42535
						order[1] = 42536
						order[2] = 42537
						order[3] = 42538
						order[4] = 42539
						order[5] = 42540
						order[6] = 42564
						order[7] = 42530
						order[8] = 42541
						order[9] = 42542
						order[10] = 42543
						order[11] = 42544
						order[12] = 42545
						order[13] = 42546
						order[14] = 42547
						order[15] = 42548
						order[16] = 42549
						order[17] = 42550
						order[18] = 42551
						order[19] = 42552
						order[20] = 42560
						order[21] = 42553
						order[22] = 42554
						order[23] = 42508
						order[24] = 42555
						order[25] = 42556
						order[26] = 42557
						order[27] = 42558
						order[28] = 42559
						order[29] = 0
						super(42534, 42535, order)
					end

					class NoLegReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 42565
							order[1] = 42566
							order[2] = 42567
							order[3] = 42568
							order[4] = 0
							super(42564, 42565, order)
						end
					end

					class NoLegReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42531
							order[1] = 42532
							order[2] = 42533
							order[3] = 0
							super(42530, 42531, order)
						end
					end

					class NoLegReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42561
							order[1] = 42562
							order[2] = 42563
							order[3] = 0
							super(42560, 42561, order)
						end
					end

					class NoLegReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 42509
							order[1] = 42571
							order[2] = 42510
							order[3] = 42511
							order[4] = 42512
							order[5] = 42513
							order[6] = 42514
							order[7] = 42515
							order[8] = 42516
							order[9] = 42517
							order[10] = 42518
							order[11] = 42519
							order[12] = 42520
							order[13] = 42521
							order[14] = 42522
							order[15] = 42523
							order[16] = 42524
							order[17] = 42525
							order[18] = 42526
							order[19] = 42527
							order[20] = 42528
							order[21] = 42529
							order[22] = 42569
							order[23] = 0
							super(42508, 42509, order)
						end

						class NoLegReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 42572
								order[1] = 42573
								order[2] = 0
								super(42571, 42572, order)
							end
						end

						class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 42570
								order[1] = 0
								super(42569, 42570, order)
							end
						end
					end
				end

				class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42420
						order[1] = 0
						super(42419, 42420, order)
					end
				end

				class NoLegPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42406
						order[1] = 42407
						order[2] = 0
						super(42405, 42406, order)
					end
				end

				class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40361
						order[1] = 0
						super(40929, 40361, order)
					end
				end

				class NoLegNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40368
						order[1] = 40369
						order[2] = 0
						super(40367, 40368, order)
					end
				end

				class NoLegSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40903
						order[1] = 40366
						order[2] = 40370
						order[3] = 40905
						order[4] = 40906
						order[5] = 0
						super(40902, 40903, order)
					end
				end

				class NoLegPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40375
						order[1] = 41533
						order[2] = 41534
						order[3] = 40376
						order[4] = 40377
						order[5] = 40378
						order[6] = 40379
						order[7] = 40380
						order[8] = 40381
						order[9] = 40382
						order[10] = 40383
						order[11] = 40384
						order[12] = 40385
						order[13] = 41535
						order[14] = 41536
						order[15] = 41537
						order[16] = 41538
						order[17] = 40386
						order[18] = 40387
						order[19] = 40388
						order[20] = 40389
						order[21] = 41539
						order[22] = 41540
						order[23] = 41541
						order[24] = 41542
						order[25] = 40390
						order[26] = 40391
						order[27] = 40392
						order[28] = 40393
						order[29] = 40394
						order[30] = 40395
						order[31] = 40414
						order[32] = 40396
						order[33] = 40397
						order[34] = 40398
						order[35] = 40399
						order[36] = 40927
						order[37] = 40401
						order[38] = 40402
						order[39] = 40403
						order[40] = 41543
						order[41] = 41544
						order[42] = 40404
						order[43] = 41530
						order[44] = 41545
						order[45] = 41546
						order[46] = 41547
						order[47] = 41548
						order[48] = 40405
						order[49] = 40406
						order[50] = 40407
						order[51] = 40408
						order[52] = 40928
						order[53] = 40410
						order[54] = 40411
						order[55] = 40412
						order[56] = 40413
						order[57] = 0
						super(40374, 40375, order)
					end

					class NoLegPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40415
							order[1] = 40416
							order[2] = 40417
							order[3] = 0
							super(40414, 40415, order)
						end
					end

					class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40400
							order[1] = 0
							super(40927, 40400, order)
						end
					end

					class NoLegPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41531
							order[1] = 41532
							order[2] = 0
							super(41530, 41531, order)
						end
					end

					class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40409
							order[1] = 0
							super(40928, 40409, order)
						end
					end
				end

				class NoLegPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40419
						order[1] = 40420
						order[2] = 42497
						order[3] = 42498
						order[4] = 42499
						order[5] = 42500
						order[6] = 42501
						order[7] = 42502
						order[8] = 42503
						order[9] = 42488
						order[10] = 42489
						order[11] = 42490
						order[12] = 42491
						order[13] = 42492
						order[14] = 42493
						order[15] = 42494
						order[16] = 40421
						order[17] = 40422
						order[18] = 40423
						order[19] = 40424
						order[20] = 40425
						order[21] = 40426
						order[22] = 40427
						order[23] = 40428
						order[24] = 40429
						order[25] = 40430
						order[26] = 40431
						order[27] = 40432
						order[28] = 40433
						order[29] = 40434
						order[30] = 40435
						order[31] = 40436
						order[32] = 40437
						order[33] = 40438
						order[34] = 40439
						order[35] = 40440
						order[36] = 40441
						order[37] = 40442
						order[38] = 40443
						order[39] = 40444
						order[40] = 40445
						order[41] = 40446
						order[42] = 40447
						order[43] = 0
						super(40418, 40419, order)
					end

					class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42505
							order[1] = 0
							super(42504, 42505, order)
						end
					end

					class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42496
							order[1] = 0
							super(42495, 42496, order)
						end
					end
				end

				class NoLegDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41461
						order[1] = 0
						super(41460, 41461, order)
					end
				end

				class NoLegDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41457
						order[1] = 41458
						order[2] = 41459
						order[3] = 0
						super(41456, 41457, order)
					end
				end

				class NoLegDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41409
						order[1] = 41410
						order[2] = 41411
						order[3] = 41412
						order[4] = 41413
						order[5] = 41414
						order[6] = 41415
						order[7] = 41416
						order[8] = 41417
						order[9] = 41418
						order[10] = 41419
						order[11] = 41420
						order[12] = 41421
						order[13] = 41422
						order[14] = 0
						super(41408, 41409, order)
					end

					class NoLegDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41423
							order[1] = 41424
							order[2] = 41425
							order[3] = 0
							super(41422, 41423, order)
						end

						class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41426
								order[1] = 41427
								order[2] = 41428
								order[3] = 0
								super(41425, 41426, order)
							end
						end
					end
				end
			end

			class NoLegProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 40449
					order[1] = 40450
					order[2] = 40451
					order[3] = 40939
					order[4] = 40453
					order[5] = 40454
					order[6] = 40455
					order[7] = 42506
					order[8] = 42507
					order[9] = 40456
					order[10] = 40457
					order[11] = 40458
					order[12] = 40524
					order[13] = 40525
					order[14] = 40526
					order[15] = 40528
					order[16] = 40529
					order[17] = 40530
					order[18] = 40531
					order[19] = 40532
					order[20] = 40476
					order[21] = 40478
					order[22] = 40479
					order[23] = 40480
					order[24] = 40481
					order[25] = 40482
					order[26] = 40483
					order[27] = 40484
					order[28] = 40485
					order[29] = 40486
					order[30] = 40487
					order[31] = 40488
					order[32] = 40489
					order[33] = 40490
					order[34] = 40491
					order[35] = 40492
					order[36] = 40493
					order[37] = 40494
					order[38] = 40498
					order[39] = 40499
					order[40] = 40501
					order[41] = 40502
					order[42] = 40503
					order[43] = 40504
					order[44] = 40505
					order[45] = 40506
					order[46] = 40507
					order[47] = 40508
					order[48] = 40509
					order[49] = 40511
					order[50] = 40512
					order[51] = 40513
					order[52] = 40514
					order[53] = 40515
					order[54] = 40459
					order[55] = 40460
					order[56] = 40461
					order[57] = 40462
					order[58] = 40463
					order[59] = 40464
					order[60] = 40465
					order[61] = 40516
					order[62] = 40518
					order[63] = 40519
					order[64] = 40520
					order[65] = 40521
					order[66] = 40522
					order[67] = 40523
					order[68] = 40466
					order[69] = 40467
					order[70] = 40468
					order[71] = 40469
					order[72] = 40470
					order[73] = 41407
					order[74] = 40472
					order[75] = 40980
					order[76] = 40981
					order[77] = 40533
					order[78] = 0
					super(40448, 40449, order)
				end

				class NoLegProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40452
						order[1] = 0
						super(40939, 40452, order)
					end
				end

				class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40527
						order[1] = 0
						super(40935, 40527, order)
					end
				end

				class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40477
						order[1] = 0
						super(40936, 40477, order)
					end
				end

				class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40496
						order[1] = 40497
						order[2] = 0
						super(40495, 40496, order)
					end
				end

				class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40500
						order[1] = 0
						super(40937, 40500, order)
					end
				end

				class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40510
						order[1] = 0
						super(40938, 40510, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40517
						order[1] = 0
						super(40934, 40517, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40474
						order[1] = 40475
						order[2] = 0
						super(40473, 40474, order)
					end
				end

				class NoLegProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40534
						order[1] = 40535
						order[2] = 40536
						order[3] = 2380
						order[4] = 40537
						order[5] = 0
						super(40533, 40534, order)
					end

					class NoLegProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40538
							order[1] = 40539
							order[2] = 0
							super(40537, 40538, order)
						end
					end
				end
			end

			class NoLegAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41336
					order[1] = 41337
					order[2] = 41316
					order[3] = 0
					super(41335, 41336, order)
				end

				class NoLegAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41317
						order[1] = 41318
						order[2] = 41319
						order[3] = 41320
						order[4] = 41321
						order[5] = 41322
						order[6] = 41323
						order[7] = 41324
						order[8] = 41325
						order[9] = 41326
						order[10] = 41327
						order[11] = 41328
						order[12] = 41329
						order[13] = 41330
						order[14] = 41331
						order[15] = 41332
						order[16] = 41333
						order[17] = 41334
						order[18] = 0
						super(41316, 41317, order)
					end
				end
			end

			class NoLegProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 41618
					order[1] = 41619
					order[2] = 41620
					order[3] = 41621
					order[4] = 41622
					order[5] = 41623
					order[6] = 41624
					order[7] = 41614
					order[8] = 41625
					order[9] = 41635
					order[10] = 41617
					order[11] = 0
					super(41616, 41618, order)
				end

				class NoLegProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41615
						order[1] = 0
						super(41614, 41615, order)
					end
				end

				class NoLegProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41626
						order[1] = 41627
						order[2] = 41628
						order[3] = 41629
						order[4] = 41630
						order[5] = 41631
						order[6] = 41632
						order[7] = 41633
						order[8] = 0
						super(41625, 41626, order)
					end

					class NoLegProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41634
							order[1] = 0
							super(41633, 41634, order)
						end
					end
				end

				class NoLegProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41636
						order[1] = 41637
						order[2] = 0
						super(41635, 41636, order)
					end
				end
			end

			class NoLegCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 41345
					order[1] = 41346
					order[2] = 41347
					order[3] = 41348
					order[4] = 41349
					order[5] = 41350
					order[6] = 41351
					order[7] = 41352
					order[8] = 41353
					order[9] = 41354
					order[10] = 41355
					order[11] = 41342
					order[12] = 42308
					order[13] = 42309
					order[14] = 41356
					order[15] = 41357
					order[16] = 42299
					order[17] = 42300
					order[18] = 42301
					order[19] = 42302
					order[20] = 42303
					order[21] = 42304
					order[22] = 42305
					order[23] = 41358
					order[24] = 41359
					order[25] = 41360
					order[26] = 41361
					order[27] = 41362
					order[28] = 0
					super(41344, 41345, order)
				end

				class NoLegCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41343
						order[1] = 0
						super(41342, 41343, order)
					end
				end

				class NoLegCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42307
						order[1] = 0
						super(42306, 42307, order)
					end
				end
			end

			class NoLegPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41604
					order[1] = 41601
					order[2] = 41602
					order[3] = 41603
					order[4] = 41600
					order[5] = 0
					super(41599, 41604, order)
				end

				class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41605
						order[1] = 41606
						order[2] = 0
						super(41604, 41605, order)
					end
				end
			end

			class NoLegExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42389
					order[1] = 42390
					order[2] = 0
					super(42388, 42389, order)
				end
			end

			class NoLegContractualDefinitions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42199
					order[1] = 0
					super(42198, 42199, order)
				end
			end

			class NoLegFinancingTermSupplements < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42201
					order[1] = 42202
					order[2] = 0
					super(42200, 42201, order)
				end
			end

			class NoLegContractualMatrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42204
					order[1] = 42205
					order[2] = 42206
					order[3] = 0
					super(42203, 42204, order)
				end
			end
		end
	end
end

class NewOrderMultileg < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AB") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoTargetPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1462
			order[1] = 1463
			order[2] = 1464
			order[3] = 1818
			order[4] = 2433
			order[5] = 0
			super(1461, 1462, order)
		end

		class NoTargetPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2434
				order[1] = 2435
				order[2] = 0
				super(2433, 2434, order)
			end
		end
	end

	class NoAllocs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 79
			order[1] = 661
			order[2] = 736
			order[3] = 2927
			order[4] = 467
			order[5] = 2727
			order[6] = 948
			order[7] = 80
			order[8] = 1752
			order[9] = 1753
			order[10] = 1754
			order[11] = 1755
			order[12] = 0
			super(78, 79, order)
		end

		class NoNested3PartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 949
				order[1] = 950
				order[2] = 951
				order[3] = 2382
				order[4] = 952
				order[5] = 0
				super(948, 949, order)
			end

			class NoNested3PartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 953
					order[1] = 954
					order[2] = 0
					super(952, 953, order)
				end
			end
		end
	end

	class NoValueChecks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1869
			order[1] = 1870
			order[2] = 0
			super(1868, 1869, order)
		end
	end

	class NoMatchInst < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1625
			order[1] = 1673
			order[2] = 1626
			order[3] = 1627
			order[4] = 0
			super(1624, 1625, order)
		end
	end

	class NoDisclosureInstructions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1813
			order[1] = 1814
			order[2] = 0
			super(1812, 1813, order)
		end
	end

	class NoTradingSessions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 336
			order[1] = 625
			order[2] = 0
			super(386, 336, order)
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(174)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 685
			order[153] = 687
			order[154] = 690
			order[155] = 683
			order[156] = 1366
			order[157] = 670
			order[158] = 2680
			order[159] = 1817
			order[160] = 564
			order[161] = 565
			order[162] = 539
			order[163] = 654
			order[164] = 587
			order[165] = 588
			order[166] = 675
			order[167] = 2900
			order[168] = 1379
			order[169] = 1381
			order[170] = 1383
			order[171] = 1384
			order[172] = 1689
			order[173] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegStipulations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 688
				order[1] = 689
				order[2] = 0
				super(683, 688, order)
			end
		end

		class NoLegAllocs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 671
				order[1] = 672
				order[2] = 756
				order[3] = 673
				order[4] = 674
				order[5] = 1367
				order[6] = 2928
				order[7] = 1756
				order[8] = 1757
				order[9] = 1758
				order[10] = 1759
				order[11] = 0
				super(670, 671, order)
			end

			class NoNested2PartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 757
					order[1] = 758
					order[2] = 759
					order[3] = 2381
					order[4] = 806
					order[5] = 0
					super(756, 757, order)
				end

				class NoNested2PartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 760
						order[1] = 807
						order[2] = 0
						super(806, 760, order)
					end
				end
			end
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end

	class NoCommissions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(17)
			order[0] = 2640
			order[1] = 2641
			order[2] = 2725
			order[3] = 2642
			order[4] = 2643
			order[5] = 2923
			order[6] = 2644
			order[7] = 2645
			order[8] = 2924
			order[9] = 2646
			order[10] = 2647
			order[11] = 2648
			order[12] = 2649
			order[13] = 2650
			order[14] = 2651
			order[15] = 2652
			order[16] = 0
			super(2639, 2640, order)
		end
	end

	class NoOrderAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2594
			order[1] = 2595
			order[2] = 0
			super(2593, 2594, order)
		end
	end

	class NoStrategyParameters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 958
			order[1] = 959
			order[2] = 960
			order[3] = 0
			super(957, 958, order)
		end
	end
end

class MultilegOrderCancelReplace < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AC") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoTargetPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1462
			order[1] = 1463
			order[2] = 1464
			order[3] = 1818
			order[4] = 2433
			order[5] = 0
			super(1461, 1462, order)
		end

		class NoTargetPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2434
				order[1] = 2435
				order[2] = 0
				super(2433, 2434, order)
			end
		end
	end

	class NoAllocs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 79
			order[1] = 661
			order[2] = 736
			order[3] = 2927
			order[4] = 467
			order[5] = 2727
			order[6] = 948
			order[7] = 80
			order[8] = 1752
			order[9] = 1753
			order[10] = 1754
			order[11] = 1755
			order[12] = 0
			super(78, 79, order)
		end

		class NoNested3PartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 949
				order[1] = 950
				order[2] = 951
				order[3] = 2382
				order[4] = 952
				order[5] = 0
				super(948, 949, order)
			end

			class NoNested3PartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 953
					order[1] = 954
					order[2] = 0
					super(952, 953, order)
				end
			end
		end
	end

	class NoValueChecks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1869
			order[1] = 1870
			order[2] = 0
			super(1868, 1869, order)
		end
	end

	class NoMatchInst < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1625
			order[1] = 1673
			order[2] = 1626
			order[3] = 1627
			order[4] = 0
			super(1624, 1625, order)
		end
	end

	class NoDisclosureInstructions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1813
			order[1] = 1814
			order[2] = 0
			super(1812, 1813, order)
		end
	end

	class NoTradingSessions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 336
			order[1] = 625
			order[2] = 0
			super(386, 336, order)
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(174)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 685
			order[153] = 687
			order[154] = 690
			order[155] = 683
			order[156] = 1366
			order[157] = 670
			order[158] = 2680
			order[159] = 1817
			order[160] = 564
			order[161] = 565
			order[162] = 539
			order[163] = 654
			order[164] = 587
			order[165] = 588
			order[166] = 675
			order[167] = 2900
			order[168] = 1379
			order[169] = 1381
			order[170] = 1383
			order[171] = 1384
			order[172] = 1689
			order[173] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegStipulations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 688
				order[1] = 689
				order[2] = 0
				super(683, 688, order)
			end
		end

		class NoLegAllocs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 671
				order[1] = 672
				order[2] = 756
				order[3] = 673
				order[4] = 674
				order[5] = 1367
				order[6] = 2928
				order[7] = 1756
				order[8] = 1757
				order[9] = 1758
				order[10] = 1759
				order[11] = 0
				super(670, 671, order)
			end

			class NoNested2PartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 757
					order[1] = 758
					order[2] = 759
					order[3] = 2381
					order[4] = 806
					order[5] = 0
					super(756, 757, order)
				end

				class NoNested2PartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 760
						order[1] = 807
						order[2] = 0
						super(806, 760, order)
					end
				end
			end
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end

	class NoCommissions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(17)
			order[0] = 2640
			order[1] = 2641
			order[2] = 2725
			order[3] = 2642
			order[4] = 2643
			order[5] = 2923
			order[6] = 2644
			order[7] = 2645
			order[8] = 2924
			order[9] = 2646
			order[10] = 2647
			order[11] = 2648
			order[12] = 2649
			order[13] = 2650
			order[14] = 2651
			order[15] = 2652
			order[16] = 0
			super(2639, 2640, order)
		end
	end

	class NoOrderAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2594
			order[1] = 2595
			order[2] = 0
			super(2593, 2594, order)
		end
	end

	class NoStrategyParameters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 958
			order[1] = 959
			order[2] = 960
			order[3] = 0
			super(957, 958, order)
		end
	end
end

class TradeCaptureReportRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AD") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoInstrAttrib < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 871
			order[1] = 872
			order[2] = 0
			super(870, 871, order)
		end
	end

	class NoIndexRollMonths < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2733
			order[1] = 0
			super(2734, 2733, order)
		end
	end

	class NoReferenceDataDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2747
			order[1] = 2748
			order[2] = 0
			super(2746, 2747, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 75
			order[1] = 779
			order[2] = 60
			order[3] = 0
			super(580, 75, order)
		end
	end
end

class TradeCaptureReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AE") )
	end

	class NoTradePriceConditions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 1839
			order[1] = 0
			super(1838, 1839, order)
		end
	end

	class NoRegulatoryTradeIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 1903
			order[1] = 1905
			order[2] = 1904
			order[3] = 1906
			order[4] = 2411
			order[5] = 2397
			order[6] = 0
			super(1907, 1903, order)
		end
	end

	class NoPriceQualifiers < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2710
			order[1] = 0
			super(2709, 2710, order)
		end
	end

	class NoRootPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1117
			order[1] = 1118
			order[2] = 1119
			order[3] = 2388
			order[4] = 1120
			order[5] = 0
			super(1116, 1117, order)
		end

		class NoRootPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1121
				order[1] = 1122
				order[2] = 0
				super(1120, 1121, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoInstrAttrib < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 871
			order[1] = 872
			order[2] = 0
			super(870, 871, order)
		end
	end

	class NoIndexRollMonths < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2733
			order[1] = 0
			super(2734, 2733, order)
		end
	end

	class NoReferenceDataDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2747
			order[1] = 2748
			order[2] = 0
			super(2746, 2747, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoPayments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(41)
			order[0] = 40213
			order[1] = 40993
			order[2] = 40214
			order[3] = 40215
			order[4] = 43087
			order[5] = 40216
			order[6] = 40217
			order[7] = 42598
			order[8] = 42599
			order[9] = 43097
			order[10] = 43098
			order[11] = 43100
			order[12] = 43099
			order[13] = 43101
			order[14] = 43105
			order[15] = 43104
			order[16] = 43103
			order[17] = 43102
			order[18] = 40218
			order[19] = 40919
			order[20] = 41155
			order[21] = 40219
			order[22] = 40220
			order[23] = 40944
			order[24] = 41156
			order[25] = 41157
			order[26] = 41158
			order[27] = 41159
			order[28] = 40222
			order[29] = 41160
			order[30] = 40224
			order[31] = 40225
			order[32] = 40226
			order[33] = 40227
			order[34] = 492
			order[35] = 40230
			order[36] = 41304
			order[37] = 40229
			order[38] = 40984
			order[39] = 40985
			order[40] = 0
			super(40212, 40213, order)
		end

		class NoPaymentBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40221
				order[1] = 0
				super(40944, 40221, order)
			end
		end

		class NoPaymentSettls < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40231
				order[1] = 40232
				order[2] = 40233
				order[3] = 0
				super(40230, 40231, order)
			end

			class NoPaymentSettlPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40234
					order[1] = 40235
					order[2] = 40236
					order[3] = 40237
					order[4] = 40238
					order[5] = 0
					super(40233, 40234, order)
				end

				class NoPaymentSettlPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40239
						order[1] = 40240
						order[2] = 0
						super(40238, 40239, order)
					end
				end
			end
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoRelatedInstruments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 1648
			order[1] = 1649
			order[2] = 1650
			order[3] = 1651
			order[4] = 1652
			order[5] = 1653
			order[6] = 2413
			order[7] = 2414
			order[8] = 2415
			order[9] = 2417
			order[10] = 0
			super(1647, 1648, order)
		end
	end

	class NoCollateralAmounts < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(17)
			order[0] = 1704
			order[1] = 1705
			order[2] = 2929
			order[3] = 2632
			order[4] = 2090
			order[5] = 2091
			order[6] = 1706
			order[7] = 2092
			order[8] = 2093
			order[9] = 1902
			order[10] = 2350
			order[11] = 2690
			order[12] = 2689
			order[13] = 2840
			order[14] = 2845
			order[15] = 2841
			order[16] = 0
			super(1703, 1704, order)
		end

		class NoCollateralReinvestments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2844
				order[1] = 2842
				order[2] = 2843
				order[3] = 2931
				order[4] = 0
				super(2845, 2844, order)
			end
		end
	end

	class NoRateSources < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1446
			order[1] = 1447
			order[2] = 1448
			order[3] = 2412
			order[4] = 2796
			order[5] = 0
			super(1445, 1446, order)
		end
	end

	class NoTransactionAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2872
			order[1] = 2873
			order[2] = 0
			super(2871, 2872, order)
		end
	end

	class NoPosAmt < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 707
			order[1] = 708
			order[2] = 2096
			order[3] = 1055
			order[4] = 2937
			order[5] = 2097
			order[6] = 2098
			order[7] = 1585
			order[8] = 2099
			order[9] = 2100
			order[10] = 2876
			order[11] = 2877
			order[12] = 0
			super(753, 707, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(212)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 1586
			order[176] = 685
			order[177] = 687
			order[178] = 2346
			order[179] = 690
			order[180] = 990
			order[181] = 1152
			order[182] = 683
			order[183] = 2680
			order[184] = 1817
			order[185] = 564
			order[186] = 565
			order[187] = 539
			order[188] = 654
			order[189] = 587
			order[190] = 588
			order[191] = 637
			order[192] = 686
			order[193] = 675
			order[194] = 2900
			order[195] = 1073
			order[196] = 1074
			order[197] = 1075
			order[198] = 1689
			order[199] = 1379
			order[200] = 1381
			order[201] = 1383
			order[202] = 1384
			order[203] = 1418
			order[204] = 1591
			order[205] = 2358
			order[206] = 2357
			order[207] = 2360
			order[208] = 2359
			order[209] = 1342
			order[210] = 2492
			order[211] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end

		class NoLegPosAmt < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1587
				order[1] = 1588
				order[2] = 1589
				order[3] = 2938
				order[4] = 1590
				order[5] = 0
				super(1586, 1587, order)
			end
		end

		class NoLegStipulations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 688
				order[1] = 689
				order[2] = 0
				super(683, 688, order)
			end
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end

		class NoOfLegUnderlyings < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(16)
				order[0] = 1330
				order[1] = 1331
				order[2] = 1332
				order[3] = 1333
				order[4] = 1344
				order[5] = 1337
				order[6] = 1338
				order[7] = 1339
				order[8] = 1345
				order[9] = 1405
				order[10] = 1340
				order[11] = 1391
				order[12] = 1343
				order[13] = 1341
				order[14] = 1392
				order[15] = 0
				super(1342, 1330, order)
			end

			class NoUnderlyingLegSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1335
					order[1] = 1336
					order[2] = 0
					super(1334, 1335, order)
				end
			end
		end
	end

	class NoTrdRegTimestamps < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 769
			order[1] = 770
			order[2] = 771
			order[3] = 2839
			order[4] = 1033
			order[5] = 1034
			order[6] = 1035
			order[7] = 1727
			order[8] = 2831
			order[9] = 2832
			order[10] = 2833
			order[11] = 2834
			order[12] = 0
			super(768, 769, order)
		end
	end

	class NoTradeQtys < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1842
			order[1] = 1843
			order[2] = 0
			super(1841, 1842, order)
		end
	end

	class NoSides < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(145)
			order[0] = 54
			order[1] = 2102
			order[2] = 1427
			order[3] = 1428
			order[4] = 1429
			order[5] = 1009
			order[6] = 1597
			order[7] = 1599
			order[8] = 1598
			order[9] = 1005
			order[10] = 1506
			order[11] = 1507
			order[12] = 1006
			order[13] = 1007
			order[14] = 83
			order[15] = 1008
			order[16] = 430
			order[17] = 1154
			order[18] = 2901
			order[19] = 1155
			order[20] = 2902
			order[21] = 453
			order[22] = 1671
			order[23] = 1
			order[24] = 660
			order[25] = 581
			order[26] = 522
			order[27] = 1630
			order[28] = 81
			order[29] = 575
			order[30] = 576
			order[31] = 635
			order[32] = 1971
			order[33] = 2671
			order[34] = 2418
			order[35] = 578
			order[36] = 579
			order[37] = 376
			order[38] = 2404
			order[39] = 2351
			order[40] = 2352
			order[41] = 377
			order[42] = 582
			order[43] = 336
			order[44] = 625
			order[45] = 943
			order[46] = 2356
			order[47] = 12
			order[48] = 13
			order[49] = 479
			order[50] = 2922
			order[51] = 1233
			order[52] = 1238
			order[53] = 497
			order[54] = 2639
			order[55] = 157
			order[56] = 230
			order[57] = 158
			order[58] = 159
			order[59] = 738
			order[60] = 920
			order[61] = 921
			order[62] = 922
			order[63] = 238
			order[64] = 237
			order[65] = 118
			order[66] = 119
			order[67] = 155
			order[68] = 156
			order[69] = 77
			order[70] = 58
			order[71] = 354
			order[72] = 355
			order[73] = 752
			order[74] = 518
			order[75] = 232
			order[76] = 136
			order[77] = 825
			order[78] = 826
			order[79] = 1848
			order[80] = 1730
			order[81] = 2771
			order[82] = 2759
			order[83] = 2767
			order[84] = 1853
			order[85] = 1854
			order[86] = 1852
			order[87] = 591
			order[88] = 70
			order[89] = 78
			order[90] = 1016
			order[91] = 1158
			order[92] = 1072
			order[93] = 1057
			order[94] = 1139
			order[95] = 1690
			order[96] = 1115
			order[97] = 1444
			order[98] = 1851
			order[99] = 37
			order[100] = 198
			order[101] = 11
			order[102] = 526
			order[103] = 66
			order[104] = 1080
			order[105] = 1081
			order[106] = 1431
			order[107] = 1091
			order[108] = 40
			order[109] = 44
			order[110] = 99
			order[111] = 18
			order[112] = 39
			order[113] = 151
			order[114] = 14
			order[115] = 59
			order[116] = 126
			order[117] = 2362
			order[118] = 2964
			order[119] = 1629
			order[120] = 1916
			order[121] = 528
			order[122] = 529
			order[123] = 775
			order[124] = 1432
			order[125] = 1724
			order[126] = 2704
			order[127] = 821
			order[128] = 1093
			order[129] = 483
			order[130] = 586
			order[131] = 2766
			order[132] = 1031
			order[133] = 1032
			order[134] = 702
			order[135] = 1855
			order[136] = 1861
			order[137] = 1980
			order[138] = 2344
			order[139] = 29
			order[140] = 2334
			order[141] = 2335
			order[142] = 2361
			order[143] = 2691
			order[144] = 0
			super(552, 54, order)
		end

		class NoPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 448
				order[1] = 447
				order[2] = 452
				order[3] = 2376
				order[4] = 802
				order[5] = 0
				super(453, 448, order)
			end

			class NoPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 523
					order[1] = 803
					order[2] = 0
					super(802, 523, order)
				end
			end
		end

		class NoPartyDetails < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 1691
				order[1] = 1692
				order[2] = 1693
				order[3] = 1674
				order[4] = 1694
				order[5] = 1516
				order[6] = 1562
				order[7] = 1672
				order[8] = 0
				super(1671, 1691, order)
			end

			class NoPartyDetailSubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1695
					order[1] = 1696
					order[2] = 0
					super(1694, 1695, order)
				end
			end

			class NoPartyDetailAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1517
					order[1] = 1518
					order[2] = 1519
					order[3] = 0
					super(1516, 1517, order)
				end

				class NoPartyDetailAltSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1520
						order[1] = 1521
						order[2] = 0
						super(1519, 1520, order)
					end
				end
			end

			class NoRelatedPartyDetailID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(8)
					order[0] = 1563
					order[1] = 1564
					order[2] = 1565
					order[3] = 1675
					order[4] = 1566
					order[5] = 1569
					order[6] = 1514
					order[7] = 0
					super(1562, 1563, order)
				end

				class NoRelatedPartyDetailSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1567
						order[1] = 1568
						order[2] = 0
						super(1566, 1567, order)
					end
				end

				class NoRelatedPartyDetailAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 1570
						order[1] = 1571
						order[2] = 1572
						order[3] = 0
						super(1569, 1570, order)
					end

					class NoRelatedPartyDetailAltSubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 1573
							order[1] = 1574
							order[2] = 0
							super(1572, 1573, order)
						end
					end
				end

				class NoPartyRelationships < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 1515
						order[1] = 0
						super(1514, 1515, order)
					end
				end
			end
		end

		class NoLimitAmts < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 1631
				order[1] = 1632
				order[2] = 1633
				order[3] = 2394
				order[4] = 2395
				order[5] = 1634
				order[6] = 2935
				order[7] = 2396
				order[8] = 0
				super(1630, 1631, order)
			end
		end

		class NoClearingInstructions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 577
				order[1] = 0
				super(576, 577, order)
			end
		end

		class NoSideRegulatoryTradeIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 1972
				order[1] = 1973
				order[2] = 1974
				order[3] = 1975
				order[4] = 2416
				order[5] = 2398
				order[6] = 0
				super(1971, 1972, order)
			end
		end

		class NoCommissions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(17)
				order[0] = 2640
				order[1] = 2641
				order[2] = 2725
				order[3] = 2642
				order[4] = 2643
				order[5] = 2923
				order[6] = 2644
				order[7] = 2645
				order[8] = 2924
				order[9] = 2646
				order[10] = 2647
				order[11] = 2648
				order[12] = 2649
				order[13] = 2650
				order[14] = 2651
				order[15] = 2652
				order[16] = 0
				super(2639, 2640, order)
			end
		end

		class NoContAmts < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 519
				order[1] = 520
				order[2] = 521
				order[3] = 0
				super(518, 519, order)
			end
		end

		class NoStipulations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 233
				order[1] = 234
				order[2] = 0
				super(232, 233, order)
			end
		end

		class NoMiscFees < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 137
				order[1] = 138
				order[2] = 139
				order[3] = 2712
				order[4] = 2633
				order[5] = 891
				order[6] = 2216
				order[7] = 2217
				order[8] = 2713
				order[9] = 0
				super(136, 137, order)
			end

			class NoMiscFeeSubTypes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 2634
					order[1] = 2635
					order[2] = 2636
					order[3] = 2637
					order[4] = 2638
					order[5] = 0
					super(2633, 2634, order)
				end
			end
		end

		class NoAllocs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(34)
				order[0] = 79
				order[1] = 661
				order[2] = 736
				order[3] = 2927
				order[4] = 467
				order[5] = 1593
				order[6] = 2727
				order[7] = 1908
				order[8] = 1729
				order[9] = 756
				order[10] = 209
				order[11] = 80
				order[12] = 2515
				order[13] = 1752
				order[14] = 1753
				order[15] = 1754
				order[16] = 1755
				order[17] = 993
				order[18] = 1002
				order[19] = 989
				order[20] = 1136
				order[21] = 1844
				order[22] = 1840
				order[23] = 1735
				order[24] = 161
				order[25] = 360
				order[26] = 361
				order[27] = 1732
				order[28] = 1733
				order[29] = 1734
				order[30] = 2392
				order[31] = 2393
				order[32] = 2653
				order[33] = 0
				super(78, 79, order)
			end

			class NoAllocRegulatoryTradeIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(7)
					order[0] = 1909
					order[1] = 1910
					order[2] = 1911
					order[3] = 1912
					order[4] = 2406
					order[5] = 2399
					order[6] = 0
					super(1908, 1909, order)
				end
			end

			class NoNested2PartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 757
					order[1] = 758
					order[2] = 759
					order[3] = 2381
					order[4] = 806
					order[5] = 0
					super(756, 757, order)
				end

				class NoNested2PartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 760
						order[1] = 807
						order[2] = 0
						super(806, 760, order)
					end
				end
			end

			class NoTradeAllocAmts < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 1845
					order[1] = 1846
					order[2] = 1847
					order[3] = 2933
					order[4] = 1850
					order[5] = 0
					super(1844, 1845, order)
				end
			end

			class NoAllocCommissions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(17)
					order[0] = 2654
					order[1] = 2655
					order[2] = 2726
					order[3] = 2656
					order[4] = 2657
					order[5] = 2925
					order[6] = 2658
					order[7] = 2659
					order[8] = 2926
					order[9] = 2660
					order[10] = 2661
					order[11] = 2662
					order[12] = 2663
					order[13] = 2664
					order[14] = 2665
					order[15] = 2666
					order[16] = 0
					super(2653, 2654, order)
				end
			end
		end

		class NoSideTrdRegTS < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1012
				order[1] = 1013
				order[2] = 1014
				order[3] = 0
				super(1016, 1012, order)
			end
		end

		class NoSettlDetails < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1164
				order[1] = 169
				order[2] = 170
				order[3] = 171
				order[4] = 781
				order[5] = 0
				super(1158, 1164, order)
			end

			class NoSettlPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 782
					order[1] = 783
					order[2] = 784
					order[3] = 2389
					order[4] = 801
					order[5] = 0
					super(781, 782, order)
				end

				class NoSettlPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 785
						order[1] = 786
						order[2] = 0
						super(801, 785, order)
					end
				end
			end
		end

		class NoOrders < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 2887
				order[1] = 2888
				order[2] = 2836
				order[3] = 2889
				order[4] = 2890
				order[5] = 2835
				order[6] = 0
				super(73, 2887, order)
			end
		end

		class NoMatchInst < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1625
				order[1] = 1673
				order[2] = 1626
				order[3] = 1627
				order[4] = 0
				super(1624, 1625, order)
			end
		end

		class NoOrderAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2594
				order[1] = 2595
				order[2] = 0
				super(2593, 2594, order)
			end
		end

		class NoPositions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 703
				order[1] = 704
				order[2] = 705
				order[3] = 1654
				order[4] = 706
				order[5] = 976
				order[6] = 0
				super(702, 703, order)
			end
		end

		class NoRelatedTrades < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 1856
				order[1] = 1857
				order[2] = 2103
				order[3] = 1858
				order[4] = 1859
				order[5] = 1860
				order[6] = 0
				super(1855, 1856, order)
			end
		end

		class NoRelatedPositions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1862
				order[1] = 1863
				order[2] = 1864
				order[3] = 0
				super(1861, 1862, order)
			end
		end

		class NoSideCollateralAmounts < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(17)
				order[0] = 2702
				order[1] = 2695
				order[2] = 2930
				order[3] = 2694
				order[4] = 2696
				order[5] = 2697
				order[6] = 2701
				order[7] = 2693
				order[8] = 2692
				order[9] = 2703
				order[10] = 2700
				order[11] = 2699
				order[12] = 2698
				order[13] = 2862
				order[14] = 2864
				order[15] = 2863
				order[16] = 0
				super(2691, 2702, order)
			end

			class NoSideCollateralReinvestments < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2867
					order[1] = 2865
					order[2] = 2866
					order[3] = 2932
					order[4] = 0
					super(2864, 2867, order)
				end
			end
		end
	end

	class NoTrdRepIndicators < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1388
			order[1] = 1389
			order[2] = 0
			super(1387, 1388, order)
		end
	end

	class NoTrdRegPublications < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2669
			order[1] = 2670
			order[2] = 0
			super(2668, 2669, order)
		end
	end

	class NoMandatoryClearingJurisdictions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41313
			order[1] = 0
			super(41312, 41313, order)
		end
	end

	class NoAttachments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 2105
			order[1] = 2106
			order[2] = 2107
			order[3] = 2108
			order[4] = 2109
			order[5] = 2110
			order[6] = 2111
			order[7] = 2112
			order[8] = 2113
			order[9] = 0
			super(2104, 2105, order)
		end

		class NoAttachmentKeywords < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 2114
				order[1] = 0
				super(2113, 2114, order)
			end
		end
	end
end

class OrderMassStatusRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AF") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoTargetPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1462
			order[1] = 1463
			order[2] = 1464
			order[3] = 1818
			order[4] = 2433
			order[5] = 0
			super(1461, 1462, order)
		end

		class NoTargetPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2434
				order[1] = 2435
				order[2] = 0
				super(2433, 2434, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoUnderlyingSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 458
			order[1] = 459
			order[2] = 2959
			order[3] = 0
			super(457, 458, order)
		end
	end

	class NoUnderlyingStips < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 888
			order[1] = 889
			order[2] = 0
			super(887, 888, order)
		end
	end

	class NoUndlyInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1059
			order[1] = 1060
			order[2] = 1061
			order[3] = 2391
			order[4] = 1062
			order[5] = 0
			super(1058, 1059, order)
		end

		class NoUndlyInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1063
				order[1] = 1064
				order[2] = 0
				super(1062, 1063, order)
			end
		end
	end

	class NoUnderlyingEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 1982
			order[1] = 1983
			order[2] = 1984
			order[3] = 1985
			order[4] = 1986
			order[5] = 2342
			order[6] = 1987
			order[7] = 2071
			order[8] = 2072
			order[9] = 2073
			order[10] = 0
			super(1981, 1982, order)
		end
	end

	class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 2081
			order[1] = 2082
			order[2] = 2083
			order[3] = 2745
			order[4] = 0
			super(2080, 2081, order)
		end
	end

	class NoUnderlyingAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2313
			order[1] = 2314
			order[2] = 2315
			order[3] = 0
			super(2312, 2313, order)
		end
	end

	class NoUnderlyingComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 2046
			order[1] = 2261
			order[2] = 2262
			order[3] = 2263
			order[4] = 2047
			order[5] = 2264
			order[6] = 2265
			order[7] = 2266
			order[8] = 2947
			order[9] = 2048
			order[10] = 2267
			order[11] = 2049
			order[12] = 2050
			order[13] = 2051
			order[14] = 2052
			order[15] = 2053
			order[16] = 2268
			order[17] = 2948
			order[18] = 2269
			order[19] = 2949
			order[20] = 2270
			order[21] = 2271
			order[22] = 2419
			order[23] = 2420
			order[24] = 2272
			order[25] = 2273
			order[26] = 2274
			order[27] = 2275
			order[28] = 2276
			order[29] = 41732
			order[30] = 41739
			order[31] = 41740
			order[32] = 41741
			order[33] = 41742
			order[34] = 41743
			order[35] = 41744
			order[36] = 41745
			order[37] = 41746
			order[38] = 41747
			order[39] = 41729
			order[40] = 2277
			order[41] = 2278
			order[42] = 2279
			order[43] = 2280
			order[44] = 2281
			order[45] = 41748
			order[46] = 41716
			order[47] = 2611
			order[48] = 2612
			order[49] = 2613
			order[50] = 2282
			order[51] = 2283
			order[52] = 0
			super(2045, 2046, order)
		end

		class NoUnderlyingComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2054
				order[1] = 2055
				order[2] = 2056
				order[3] = 0
				super(2053, 2054, order)
			end

			class NoUnderlyingComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2057
					order[1] = 2058
					order[2] = 0
					super(2056, 2057, order)
				end
			end
		end

		class NoUnderlyingComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41733
				order[1] = 41734
				order[2] = 41735
				order[3] = 41736
				order[4] = 0
				super(41732, 41733, order)
			end
		end

		class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41738
				order[1] = 0
				super(41737, 41738, order)
			end
		end

		class NoUnderlyingComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41730
				order[1] = 41731
				order[2] = 41750
				order[3] = 41726
				order[4] = 41713
				order[5] = 0
				super(41729, 41730, order)
			end

			class NoUnderlyingComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41751
					order[1] = 41752
					order[2] = 41753
					order[3] = 41754
					order[4] = 41755
					order[5] = 0
					super(41750, 41751, order)
				end
			end

			class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41727
					order[1] = 41728
					order[2] = 0
					super(41726, 41727, order)
				end
			end

			class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41714
					order[1] = 41715
					order[2] = 0
					super(41713, 41714, order)
				end
			end
		end

		class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41749
				order[1] = 0
				super(41748, 41749, order)
			end
		end

		class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 41717
				order[1] = 41718
				order[2] = 41719
				order[3] = 41720
				order[4] = 41721
				order[5] = 41722
				order[6] = 41723
				order[7] = 41724
				order[8] = 0
				super(41716, 41717, order)
			end

			class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41725
					order[1] = 0
					super(41724, 41725, order)
				end
			end
		end
	end

	class NoUnderlyingBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40963
			order[1] = 0
			super(40962, 40963, order)
		end
	end

	class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41948
			order[1] = 0
			super(41947, 41948, order)
		end
	end

	class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41865
			order[1] = 41338
			order[2] = 0
			super(41864, 41865, order)
		end
	end

	class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41867
			order[1] = 41339
			order[2] = 0
			super(41866, 41867, order)
		end
	end

	class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41869
			order[1] = 41870
			order[2] = 41871
			order[3] = 41872
			order[4] = 41873
			order[5] = 41874
			order[6] = 41875
			order[7] = 41876
			order[8] = 41877
			order[9] = 0
			super(41868, 41869, order)
		end
	end

	class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 43075
			order[1] = 0
			super(43074, 43075, order)
		end
	end

	class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41821
			order[1] = 0
			super(41820, 41821, order)
		end
	end

	class NoUnderlyingOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41842
			order[1] = 41843
			order[2] = 0
			super(41841, 41842, order)
		end
	end

	class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41845
			order[1] = 0
			super(41844, 41845, order)
		end
	end

	class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41857
			order[1] = 41858
			order[2] = 0
			super(41856, 41857, order)
		end
	end

	class NoUnderlyingStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40541
			order[1] = 42016
			order[2] = 40542
			order[3] = 43083
			order[4] = 43084
			order[5] = 40543
			order[6] = 40544
			order[7] = 42018
			order[8] = 40545
			order[9] = 40546
			order[10] = 43085
			order[11] = 43086
			order[12] = 42019
			order[13] = 42020
			order[14] = 42021
			order[15] = 42022
			order[16] = 42023
			order[17] = 42024
			order[18] = 41964
			order[19] = 41965
			order[20] = 41966
			order[21] = 41967
			order[22] = 41968
			order[23] = 41969
			order[24] = 41970
			order[25] = 42589
			order[26] = 41971
			order[27] = 41972
			order[28] = 41973
			order[29] = 41974
			order[30] = 41975
			order[31] = 41976
			order[32] = 41977
			order[33] = 41978
			order[34] = 41979
			order[35] = 41980
			order[36] = 41981
			order[37] = 41982
			order[38] = 41983
			order[39] = 41984
			order[40] = 41985
			order[41] = 41986
			order[42] = 41987
			order[43] = 41988
			order[44] = 41989
			order[45] = 40057
			order[46] = 40058
			order[47] = 40060
			order[48] = 40061
			order[49] = 40062
			order[50] = 40063
			order[51] = 40064
			order[52] = 40548
			order[53] = 40549
			order[54] = 40551
			order[55] = 40552
			order[56] = 40553
			order[57] = 40554
			order[58] = 40555
			order[59] = 41957
			order[60] = 41958
			order[61] = 40556
			order[62] = 40558
			order[63] = 40559
			order[64] = 40561
			order[65] = 40562
			order[66] = 40563
			order[67] = 40564
			order[68] = 40565
			order[69] = 40566
			order[70] = 40567
			order[71] = 41959
			order[72] = 41960
			order[73] = 41961
			order[74] = 40568
			order[75] = 40569
			order[76] = 40570
			order[77] = 42895
			order[78] = 40571
			order[79] = 40572
			order[80] = 43107
			order[81] = 40573
			order[82] = 40574
			order[83] = 40575
			order[84] = 40576
			order[85] = 40577
			order[86] = 42896
			order[87] = 42897
			order[88] = 42898
			order[89] = 42899
			order[90] = 40578
			order[91] = 40579
			order[92] = 40580
			order[93] = 41897
			order[94] = 41898
			order[95] = 41899
			order[96] = 41900
			order[97] = 41901
			order[98] = 41902
			order[99] = 41903
			order[100] = 42900
			order[101] = 40664
			order[102] = 40708
			order[103] = 41777
			order[104] = 41778
			order[105] = 41779
			order[106] = 41780
			order[107] = 41781
			order[108] = 42196
			order[109] = 42197
			order[110] = 41782
			order[111] = 41783
			order[112] = 41784
			order[113] = 41785
			order[114] = 41786
			order[115] = 41587
			order[116] = 41787
			order[117] = 41788
			order[118] = 41789
			order[119] = 41790
			order[120] = 41791
			order[121] = 41792
			order[122] = 41793
			order[123] = 41794
			order[124] = 41795
			order[125] = 41796
			order[126] = 41797
			order[127] = 41798
			order[128] = 41799
			order[129] = 43096
			order[130] = 41756
			order[131] = 40547
			order[132] = 40988
			order[133] = 40989
			order[134] = 0
			super(40540, 40541, order)
		end

		class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41991
				order[1] = 41992
				order[2] = 0
				super(41990, 41991, order)
			end
		end

		class NoUnderlyingStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41801
				order[1] = 41802
				order[2] = 41803
				order[3] = 0
				super(41800, 41801, order)
			end
		end

		class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41994
				order[1] = 41995
				order[2] = 0
				super(41993, 41994, order)
			end
		end

		class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41963
				order[1] = 0
				super(41962, 41963, order)
			end
		end

		class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 42003
				order[1] = 42004
				order[2] = 42005
				order[3] = 42006
				order[4] = 42007
				order[5] = 42008
				order[6] = 42009
				order[7] = 42010
				order[8] = 42011
				order[9] = 42012
				order[10] = 42013
				order[11] = 41996
				order[12] = 42014
				order[13] = 42015
				order[14] = 0
				super(42002, 42003, order)
			end

			class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41997
					order[1] = 41998
					order[2] = 41999
					order[3] = 0
					super(41996, 41997, order)
				end

				class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42000
						order[1] = 42001
						order[2] = 41936
						order[3] = 0
						super(41999, 42000, order)
					end
				end
			end
		end

		class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40059
				order[1] = 0
				super(40975, 40059, order)
			end
		end

		class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40550
				order[1] = 0
				super(40976, 40550, order)
			end
		end

		class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40557
				order[1] = 0
				super(40973, 40557, order)
			end
		end

		class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41955
				order[1] = 41956
				order[2] = 0
				super(41954, 41955, order)
			end
		end

		class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40560
				order[1] = 0
				super(40974, 40560, order)
			end
		end

		class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40582
				order[1] = 0
				super(40969, 40582, order)
			end
		end

		class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41938
				order[1] = 41939
				order[2] = 0
				super(41937, 41938, order)
			end
		end

		class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40594
				order[1] = 0
				super(40970, 40594, order)
			end
		end

		class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40600
				order[1] = 0
				super(40971, 40600, order)
			end
		end

		class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40607
				order[1] = 0
				super(40972, 40607, order)
			end
		end

		class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42956
				order[1] = 42957
				order[2] = 0
				super(42955, 42956, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41910
				order[1] = 0
				super(41909, 41910, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41945
				order[1] = 41946
				order[2] = 0
				super(41944, 41945, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41942
				order[1] = 41943
				order[2] = 0
				super(41941, 41942, order)
			end
		end

		class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43111
				order[1] = 42982
				order[2] = 42983
				order[3] = 0
				super(42981, 43111, order)
			end
		end

		class NoUnderlyingDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42863
				order[1] = 42864
				order[2] = 42865
				order[3] = 42866
				order[4] = 42867
				order[5] = 42868
				order[6] = 42882
				order[7] = 42869
				order[8] = 42870
				order[9] = 42871
				order[10] = 42872
				order[11] = 42873
				order[12] = 42874
				order[13] = 42875
				order[14] = 42876
				order[15] = 42877
				order[16] = 42878
				order[17] = 42879
				order[18] = 42880
				order[19] = 42881
				order[20] = 0
				super(42862, 42863, order)
			end

			class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42883
					order[1] = 0
					super(42882, 42883, order)
				end
			end
		end

		class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42854
				order[1] = 0
				super(42853, 42854, order)
			end
		end

		class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42800
				order[1] = 0
				super(42799, 42800, order)
			end
		end

		class NoUnderlyingReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 43035
				order[1] = 43036
				order[2] = 43037
				order[3] = 43038
				order[4] = 43039
				order[5] = 43040
				order[6] = 43064
				order[7] = 43030
				order[8] = 43041
				order[9] = 43042
				order[10] = 43043
				order[11] = 43044
				order[12] = 43045
				order[13] = 43046
				order[14] = 43047
				order[15] = 43048
				order[16] = 43049
				order[17] = 43050
				order[18] = 43051
				order[19] = 43052
				order[20] = 43060
				order[21] = 43053
				order[22] = 43054
				order[23] = 43008
				order[24] = 43055
				order[25] = 43056
				order[26] = 43057
				order[27] = 43058
				order[28] = 43059
				order[29] = 0
				super(43034, 43035, order)
			end

			class NoUnderlyingReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 43065
					order[1] = 43066
					order[2] = 43067
					order[3] = 43068
					order[4] = 0
					super(43064, 43065, order)
				end
			end

			class NoUnderlyingReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43031
					order[1] = 43032
					order[2] = 43033
					order[3] = 0
					super(43030, 43031, order)
				end
			end

			class NoUnderlyingReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43061
					order[1] = 43062
					order[2] = 43063
					order[3] = 0
					super(43060, 43061, order)
				end
			end

			class NoUnderlyingReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 43009
					order[1] = 43071
					order[2] = 43010
					order[3] = 43011
					order[4] = 43012
					order[5] = 43013
					order[6] = 43014
					order[7] = 43015
					order[8] = 43016
					order[9] = 43017
					order[10] = 43018
					order[11] = 43019
					order[12] = 43020
					order[13] = 43021
					order[14] = 43022
					order[15] = 43023
					order[16] = 43024
					order[17] = 43025
					order[18] = 43026
					order[19] = 43027
					order[20] = 43028
					order[21] = 43029
					order[22] = 43069
					order[23] = 0
					super(43008, 43009, order)
				end

				class NoUnderlyingReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 43072
						order[1] = 43073
						order[2] = 0
						super(43071, 43072, order)
					end
				end

				class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43070
						order[1] = 0
						super(43069, 43070, order)
					end
				end
			end
		end

		class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42916
				order[1] = 0
				super(42915, 42916, order)
			end
		end

		class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42902
				order[1] = 42903
				order[2] = 0
				super(42901, 42902, order)
			end
		end

		class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40650
				order[1] = 0
				super(40968, 40650, order)
			end
		end

		class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40657
				order[1] = 40658
				order[2] = 0
				super(40656, 40657, order)
			end
		end

		class NoUnderlyingSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40660
				order[1] = 40904
				order[2] = 40915
				order[3] = 40662
				order[4] = 40663
				order[5] = 0
				super(40659, 40660, order)
			end
		end

		class NoUnderlyingPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40665
				order[1] = 41881
				order[2] = 41882
				order[3] = 40666
				order[4] = 40667
				order[5] = 40668
				order[6] = 40669
				order[7] = 40670
				order[8] = 40671
				order[9] = 40672
				order[10] = 40673
				order[11] = 40674
				order[12] = 40675
				order[13] = 41883
				order[14] = 41884
				order[15] = 41885
				order[16] = 41886
				order[17] = 40676
				order[18] = 40677
				order[19] = 40678
				order[20] = 40679
				order[21] = 41887
				order[22] = 41888
				order[23] = 41889
				order[24] = 41890
				order[25] = 40680
				order[26] = 40681
				order[27] = 40682
				order[28] = 40683
				order[29] = 40684
				order[30] = 40685
				order[31] = 40704
				order[32] = 40686
				order[33] = 40687
				order[34] = 40688
				order[35] = 40689
				order[36] = 40966
				order[37] = 40691
				order[38] = 40692
				order[39] = 40693
				order[40] = 41891
				order[41] = 41892
				order[42] = 40694
				order[43] = 41878
				order[44] = 41893
				order[45] = 41894
				order[46] = 41895
				order[47] = 41896
				order[48] = 40695
				order[49] = 40696
				order[50] = 40697
				order[51] = 40698
				order[52] = 40967
				order[53] = 40700
				order[54] = 40701
				order[55] = 40702
				order[56] = 40703
				order[57] = 0
				super(40664, 40665, order)
			end

			class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40705
					order[1] = 40706
					order[2] = 40707
					order[3] = 0
					super(40704, 40705, order)
				end
			end

			class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40690
					order[1] = 0
					super(40966, 40690, order)
				end
			end

			class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41879
					order[1] = 41880
					order[2] = 0
					super(41878, 41879, order)
				end
			end

			class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40699
					order[1] = 0
					super(40967, 40699, order)
				end
			end
		end

		class NoUnderlyingPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40709
				order[1] = 40710
				order[2] = 42993
				order[3] = 42994
				order[4] = 42995
				order[5] = 42996
				order[6] = 42997
				order[7] = 42998
				order[8] = 42999
				order[9] = 42984
				order[10] = 42985
				order[11] = 42986
				order[12] = 42987
				order[13] = 42988
				order[14] = 42989
				order[15] = 42990
				order[16] = 40711
				order[17] = 40712
				order[18] = 40713
				order[19] = 40714
				order[20] = 40715
				order[21] = 40716
				order[22] = 40717
				order[23] = 40718
				order[24] = 40719
				order[25] = 40720
				order[26] = 40721
				order[27] = 40722
				order[28] = 40723
				order[29] = 40724
				order[30] = 40725
				order[31] = 40726
				order[32] = 40727
				order[33] = 40728
				order[34] = 40729
				order[35] = 40730
				order[36] = 40731
				order[37] = 40732
				order[38] = 40733
				order[39] = 40734
				order[40] = 40735
				order[41] = 40736
				order[42] = 40737
				order[43] = 0
				super(40708, 40709, order)
			end

			class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 43001
					order[1] = 0
					super(43000, 43001, order)
				end
			end

			class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42992
					order[1] = 0
					super(42991, 42992, order)
				end
			end
		end

		class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41809
				order[1] = 0
				super(41808, 41809, order)
			end
		end

		class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41805
				order[1] = 41806
				order[2] = 41807
				order[3] = 0
				super(41804, 41805, order)
			end
		end

		class NoUnderlyingDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41757
				order[1] = 41758
				order[2] = 41759
				order[3] = 41760
				order[4] = 41761
				order[5] = 41762
				order[6] = 41763
				order[7] = 41764
				order[8] = 41765
				order[9] = 41766
				order[10] = 41767
				order[11] = 41768
				order[12] = 41769
				order[13] = 41770
				order[14] = 0
				super(41756, 41757, order)
			end

			class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41771
					order[1] = 41772
					order[2] = 41773
					order[3] = 0
					super(41770, 41771, order)
				end

				class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41774
						order[1] = 41775
						order[2] = 41776
						order[3] = 0
						super(41773, 41774, order)
					end
				end
			end
		end
	end

	class NoUnderlyingProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 42150
			order[1] = 42151
			order[2] = 42152
			order[3] = 42190
			order[4] = 42153
			order[5] = 42154
			order[6] = 42155
			order[7] = 43002
			order[8] = 43003
			order[9] = 42156
			order[10] = 42157
			order[11] = 42158
			order[12] = 42104
			order[13] = 42105
			order[14] = 42106
			order[15] = 42107
			order[16] = 42108
			order[17] = 42109
			order[18] = 42110
			order[19] = 42111
			order[20] = 42115
			order[21] = 42116
			order[22] = 42117
			order[23] = 42118
			order[24] = 42119
			order[25] = 42120
			order[26] = 42121
			order[27] = 42122
			order[28] = 42123
			order[29] = 42124
			order[30] = 42125
			order[31] = 42126
			order[32] = 42127
			order[33] = 42128
			order[34] = 42129
			order[35] = 42130
			order[36] = 42131
			order[37] = 42132
			order[38] = 42133
			order[39] = 42134
			order[40] = 42135
			order[41] = 42136
			order[42] = 42137
			order[43] = 42138
			order[44] = 42139
			order[45] = 42140
			order[46] = 42141
			order[47] = 42142
			order[48] = 42143
			order[49] = 42144
			order[50] = 42145
			order[51] = 42146
			order[52] = 42147
			order[53] = 42148
			order[54] = 42159
			order[55] = 42160
			order[56] = 42161
			order[57] = 42162
			order[58] = 42163
			order[59] = 42164
			order[60] = 42165
			order[61] = 42092
			order[62] = 42093
			order[63] = 42094
			order[64] = 42095
			order[65] = 42096
			order[66] = 42097
			order[67] = 42098
			order[68] = 42166
			order[69] = 42167
			order[70] = 42168
			order[71] = 42169
			order[72] = 42102
			order[73] = 42103
			order[74] = 42170
			order[75] = 42171
			order[76] = 42172
			order[77] = 42173
			order[78] = 0
			super(42149, 42150, order)
		end

		class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42191
				order[1] = 0
				super(42190, 42191, order)
			end
		end

		class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42183
				order[1] = 0
				super(42182, 42183, order)
			end
		end

		class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42185
				order[1] = 0
				super(42184, 42185, order)
			end
		end

		class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42113
				order[1] = 42114
				order[2] = 0
				super(42112, 42113, order)
			end
		end

		class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42187
				order[1] = 0
				super(42186, 42187, order)
			end
		end

		class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42189
				order[1] = 0
				super(42188, 42189, order)
			end
		end

		class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42181
				order[1] = 0
				super(42180, 42181, order)
			end
		end

		class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42100
				order[1] = 42101
				order[2] = 0
				super(42099, 42100, order)
			end
		end

		class NoUnderlyingProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42174
				order[1] = 42175
				order[2] = 42176
				order[3] = 40918
				order[4] = 42177
				order[5] = 0
				super(42173, 42174, order)
			end

			class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42178
					order[1] = 42179
					order[2] = 0
					super(42177, 42178, order)
				end
			end
		end
	end

	class NoUnderlyingAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 42037
			order[1] = 42038
			order[2] = 41340
			order[3] = 0
			super(42036, 42037, order)
		end

		class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 41341
				order[1] = 41701
				order[2] = 41709
				order[3] = 41710
				order[4] = 41711
				order[5] = 41712
				order[6] = 42017
				order[7] = 42025
				order[8] = 42026
				order[9] = 42027
				order[10] = 42028
				order[11] = 42029
				order[12] = 42030
				order[13] = 42031
				order[14] = 42032
				order[15] = 42033
				order[16] = 42034
				order[17] = 42035
				order[18] = 0
				super(41340, 41341, order)
			end
		end
	end

	class NoUnderlyingProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 42069
			order[1] = 42070
			order[2] = 42071
			order[3] = 42072
			order[4] = 42073
			order[5] = 42074
			order[6] = 42075
			order[7] = 42090
			order[8] = 42077
			order[9] = 42087
			order[10] = 42076
			order[11] = 0
			super(42068, 42069, order)
		end

		class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42091
				order[1] = 0
				super(42090, 42091, order)
			end
		end

		class NoUnderlyingProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 42078
				order[1] = 42079
				order[2] = 42080
				order[3] = 42081
				order[4] = 42082
				order[5] = 42083
				order[6] = 42084
				order[7] = 42085
				order[8] = 0
				super(42077, 42078, order)
			end

			class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42086
					order[1] = 0
					super(42085, 42086, order)
				end
			end
		end

		class NoUnderlyingProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42088
				order[1] = 42089
				order[2] = 0
				super(42087, 42088, order)
			end
		end
	end

	class NoUnderlyingCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 42042
			order[1] = 42043
			order[2] = 42044
			order[3] = 42045
			order[4] = 42046
			order[5] = 42047
			order[6] = 42048
			order[7] = 42049
			order[8] = 42050
			order[9] = 42051
			order[10] = 42052
			order[11] = 42039
			order[12] = 42797
			order[13] = 42798
			order[14] = 42053
			order[15] = 42054
			order[16] = 42790
			order[17] = 42791
			order[18] = 42792
			order[19] = 42793
			order[20] = 42794
			order[21] = 42795
			order[22] = 42796
			order[23] = 42055
			order[24] = 42056
			order[25] = 42057
			order[26] = 42058
			order[27] = 42059
			order[28] = 0
			super(42041, 42042, order)
		end

		class NoUnderlyingCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42040
				order[1] = 0
				super(42039, 42040, order)
			end
		end

		class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42789
				order[1] = 0
				super(42788, 42789, order)
			end
		end
	end

	class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 42065
			order[1] = 42061
			order[2] = 42062
			order[3] = 42063
			order[4] = 42064
			order[5] = 0
			super(42060, 42065, order)
		end

		class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42066
				order[1] = 42067
				order[2] = 0
				super(42065, 42066, order)
			end
		end
	end

	class NoUnderlyingRateSpreadSteps < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 43006
			order[1] = 43007
			order[2] = 0
			super(43005, 43006, order)
		end
	end

	class NoUnderlyingDividendPayments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 42856
			order[1] = 42857
			order[2] = 42858
			order[3] = 42859
			order[4] = 0
			super(42855, 42856, order)
		end
	end

	class NoUnderlyingExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42885
			order[1] = 42886
			order[2] = 0
			super(42884, 42885, order)
		end
	end
end

class QuoteRequestReject < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AG") )
	end

	class NoRootPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1117
			order[1] = 1118
			order[2] = 1119
			order[3] = 2388
			order[4] = 1120
			order[5] = 0
			super(1116, 1117, order)
		end

		class NoRootPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1121
				order[1] = 1122
				order[2] = 0
				super(1120, 1121, order)
			end
		end
	end

	class NoRelatedSym < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(230)
			order[0] = 55
			order[1] = 65
			order[2] = 48
			order[3] = 22
			order[4] = 460
			order[5] = 1227
			order[6] = 1151
			order[7] = 461
			order[8] = 2891
			order[9] = 167
			order[10] = 762
			order[11] = 200
			order[12] = 541
			order[13] = 1079
			order[14] = 966
			order[15] = 1049
			order[16] = 965
			order[17] = 224
			order[18] = 1449
			order[19] = 1450
			order[20] = 1451
			order[21] = 1452
			order[22] = 1457
			order[23] = 1458
			order[24] = 1739
			order[25] = 2210
			order[26] = 1938
			order[27] = 1939
			order[28] = 1940
			order[29] = 2735
			order[30] = 1941
			order[31] = 1575
			order[32] = 1942
			order[33] = 1943
			order[34] = 1944
			order[35] = 1945
			order[36] = 1946
			order[37] = 1947
			order[38] = 1948
			order[39] = 1949
			order[40] = 1950
			order[41] = 2879
			order[42] = 1951
			order[43] = 1952
			order[44] = 1953
			order[45] = 1954
			order[46] = 1955
			order[47] = 1956
			order[48] = 1957
			order[49] = 1958
			order[50] = 1959
			order[51] = 1960
			order[52] = 1577
			order[53] = 1580
			order[54] = 1581
			order[55] = 1678
			order[56] = 1697
			order[57] = 225
			order[58] = 239
			order[59] = 226
			order[60] = 227
			order[61] = 228
			order[62] = 255
			order[63] = 543
			order[64] = 470
			order[65] = 471
			order[66] = 472
			order[67] = 240
			order[68] = 202
			order[69] = 2578
			order[70] = 2577
			order[71] = 947
			order[72] = 2904
			order[73] = 967
			order[74] = 968
			order[75] = 1698
			order[76] = 1866
			order[77] = 2600
			order[78] = 2001
			order[79] = 2601
			order[80] = 1478
			order[81] = 1479
			order[82] = 1480
			order[83] = 1481
			order[84] = 206
			order[85] = 231
			order[86] = 1435
			order[87] = 2353
			order[88] = 1439
			order[89] = 969
			order[90] = 1146
			order[91] = 996
			order[92] = 1147
			order[93] = 1716
			order[94] = 2905
			order[95] = 1191
			order[96] = 1192
			order[97] = 1717
			order[98] = 2906
			order[99] = 1193
			order[100] = 2579
			order[101] = 1194
			order[102] = 1482
			order[103] = 1195
			order[104] = 2753
			order[105] = 1196
			order[106] = 1197
			order[107] = 2002
			order[108] = 2140
			order[109] = 1524
			order[110] = 2907
			order[111] = 1198
			order[112] = 1199
			order[113] = 1200
			order[114] = 201
			order[115] = 2681
			order[116] = 2685
			order[117] = 1244
			order[118] = 1242
			order[119] = 2575
			order[120] = 2574
			order[121] = 997
			order[122] = 223
			order[123] = 207
			order[124] = 970
			order[125] = 971
			order[126] = 106
			order[127] = 348
			order[128] = 349
			order[129] = 2737
			order[130] = 2714
			order[131] = 2715
			order[132] = 2716
			order[133] = 107
			order[134] = 350
			order[135] = 351
			order[136] = 691
			order[137] = 667
			order[138] = 875
			order[139] = 876
			order[140] = 873
			order[141] = 874
			order[142] = 1687
			order[143] = 1787
			order[144] = 2141
			order[145] = 2142
			order[146] = 2143
			order[147] = 2752
			order[148] = 2144
			order[149] = 2145
			order[150] = 2576
			order[151] = 2962
			order[152] = 2602
			order[153] = 2603
			order[154] = 913
			order[155] = 914
			order[156] = 1961
			order[157] = 915
			order[158] = 918
			order[159] = 2952
			order[160] = 1962
			order[161] = 1963
			order[162] = 1964
			order[163] = 1965
			order[164] = 1966
			order[165] = 1967
			order[166] = 1968
			order[167] = 1969
			order[168] = 1970
			order[169] = 1513
			order[170] = 1525
			order[171] = 1527
			order[172] = 788
			order[173] = 916
			order[174] = 917
			order[175] = 919
			order[176] = 898
			order[177] = 711
			order[178] = 140
			order[179] = 303
			order[180] = 537
			order[181] = 336
			order[182] = 625
			order[183] = 229
			order[184] = 54
			order[185] = 854
			order[186] = 38
			order[187] = 152
			order[188] = 516
			order[189] = 468
			order[190] = 469
			order[191] = 63
			order[192] = 64
			order[193] = 193
			order[194] = 192
			order[195] = 15
			order[196] = 2897
			order[197] = 232
			order[198] = 1
			order[199] = 660
			order[200] = 581
			order[201] = 555
			order[202] = 735
			order[203] = 2115
			order[204] = 692
			order[205] = 2709
			order[206] = 40
			order[207] = 126
			order[208] = 60
			order[209] = 218
			order[210] = 220
			order[211] = 2950
			order[212] = 221
			order[213] = 222
			order[214] = 662
			order[215] = 663
			order[216] = 699
			order[217] = 761
			order[218] = 423
			order[219] = 44
			order[220] = 640
			order[221] = 235
			order[222] = 236
			order[223] = 701
			order[224] = 696
			order[225] = 697
			order[226] = 698
			order[227] = 453
			order[228] = 443
			order[229] = 0
			super(146, 55, order)
		end

		class NoSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 455
				order[1] = 456
				order[2] = 2957
				order[3] = 0
				super(454, 455, order)
			end
		end

		class NoSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1977
				order[1] = 1978
				order[2] = 1979
				order[3] = 2741
				order[4] = 0
				super(1976, 1977, order)
			end
		end

		class NoAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2305
				order[1] = 2306
				order[2] = 2307
				order[3] = 0
				super(2304, 2305, order)
			end
		end

		class NoEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 865
				order[1] = 866
				order[2] = 1145
				order[3] = 1827
				order[4] = 1826
				order[5] = 2340
				order[6] = 867
				order[7] = 868
				order[8] = 1578
				order[9] = 1579
				order[10] = 0
				super(864, 865, order)
			end
		end

		class NoInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1019
				order[1] = 1050
				order[2] = 1051
				order[3] = 2378
				order[4] = 1052
				order[5] = 0
				super(1018, 1019, order)
			end

			class NoInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1053
					order[1] = 1054
					order[2] = 0
					super(1052, 1053, order)
				end
			end
		end

		class NoComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 1484
				order[1] = 2117
				order[2] = 2118
				order[3] = 2119
				order[4] = 1485
				order[5] = 2120
				order[6] = 2121
				order[7] = 2122
				order[8] = 2941
				order[9] = 1486
				order[10] = 2123
				order[11] = 1487
				order[12] = 1488
				order[13] = 1489
				order[14] = 1490
				order[15] = 1491
				order[16] = 2124
				order[17] = 2942
				order[18] = 2125
				order[19] = 2943
				order[20] = 2126
				order[21] = 2127
				order[22] = 2407
				order[23] = 2408
				order[24] = 2128
				order[25] = 2129
				order[26] = 2130
				order[27] = 2131
				order[28] = 2132
				order[29] = 41013
				order[30] = 41020
				order[31] = 41021
				order[32] = 41022
				order[33] = 41023
				order[34] = 41024
				order[35] = 41025
				order[36] = 41026
				order[37] = 41027
				order[38] = 41028
				order[39] = 41010
				order[40] = 2133
				order[41] = 2134
				order[42] = 2135
				order[43] = 2136
				order[44] = 2137
				order[45] = 41029
				order[46] = 40997
				order[47] = 2597
				order[48] = 2598
				order[49] = 2599
				order[50] = 2138
				order[51] = 2139
				order[52] = 0
				super(1483, 1484, order)
			end

			class NoComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1492
					order[1] = 1493
					order[2] = 1494
					order[3] = 0
					super(1491, 1492, order)
				end

				class NoComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1495
						order[1] = 1496
						order[2] = 0
						super(1494, 1495, order)
					end
				end
			end

			class NoComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41014
					order[1] = 41015
					order[2] = 41016
					order[3] = 41017
					order[4] = 0
					super(41013, 41014, order)
				end
			end

			class NoComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41019
					order[1] = 0
					super(41018, 41019, order)
				end
			end

			class NoComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41011
					order[1] = 41012
					order[2] = 41031
					order[3] = 41007
					order[4] = 40994
					order[5] = 0
					super(41010, 41011, order)
				end

				class NoComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41032
						order[1] = 41033
						order[2] = 41034
						order[3] = 41035
						order[4] = 41036
						order[5] = 0
						super(41031, 41032, order)
					end
				end

				class NoComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41008
						order[1] = 41009
						order[2] = 0
						super(41007, 41008, order)
					end
				end

				class NoComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40995
						order[1] = 40996
						order[2] = 0
						super(40994, 40995, order)
					end
				end
			end

			class NoComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41030
					order[1] = 0
					super(41029, 41030, order)
				end
			end

			class NoComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40998
					order[1] = 40999
					order[2] = 41000
					order[3] = 41001
					order[4] = 41002
					order[5] = 41003
					order[6] = 41004
					order[7] = 41005
					order[8] = 0
					super(40997, 40998, order)
				end

				class NoComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41006
						order[1] = 0
						super(41005, 41006, order)
					end
				end
			end
		end

		class NoBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40471
				order[1] = 0
				super(40278, 40471, order)
			end
		end

		class NoPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41231
				order[1] = 0
				super(41230, 41231, order)
			end
		end

		class NoMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41093
				order[1] = 40991
				order[2] = 0
				super(41092, 41093, order)
			end
		end

		class NoMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41095
				order[1] = 40992
				order[2] = 0
				super(41094, 41095, order)
			end
		end

		class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41097
				order[1] = 41098
				order[2] = 41099
				order[3] = 41100
				order[4] = 41101
				order[5] = 41102
				order[6] = 41103
				order[7] = 41104
				order[8] = 41105
				order[9] = 0
				super(41096, 41097, order)
			end
		end

		class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42776
				order[1] = 0
				super(42775, 42776, order)
			end
		end

		class NoOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41117
				order[1] = 0
				super(41116, 41117, order)
			end
		end

		class NoOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41138
				order[1] = 41139
				order[2] = 0
				super(41137, 41138, order)
			end
		end

		class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41141
				order[1] = 0
				super(41140, 41141, order)
			end
		end

		class NoOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41153
				order[1] = 41154
				order[2] = 0
				super(41152, 41153, order)
			end
		end

		class NoStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40050
				order[1] = 41303
				order[2] = 40051
				order[3] = 42784
				order[4] = 42785
				order[5] = 40052
				order[6] = 40053
				order[7] = 41305
				order[8] = 40054
				order[9] = 40055
				order[10] = 42786
				order[11] = 42787
				order[12] = 41306
				order[13] = 41307
				order[14] = 41308
				order[15] = 41309
				order[16] = 41310
				order[17] = 41311
				order[18] = 41251
				order[19] = 41252
				order[20] = 41253
				order[21] = 41254
				order[22] = 41255
				order[23] = 41256
				order[24] = 41257
				order[25] = 42587
				order[26] = 41258
				order[27] = 41259
				order[28] = 41260
				order[29] = 41261
				order[30] = 41262
				order[31] = 41263
				order[32] = 41264
				order[33] = 41265
				order[34] = 41266
				order[35] = 41267
				order[36] = 41268
				order[37] = 41269
				order[38] = 41270
				order[39] = 41271
				order[40] = 41272
				order[41] = 41273
				order[42] = 41274
				order[43] = 41275
				order[44] = 41276
				order[45] = 40907
				order[46] = 40908
				order[47] = 40910
				order[48] = 40911
				order[49] = 40912
				order[50] = 40913
				order[51] = 40914
				order[52] = 40065
				order[53] = 40066
				order[54] = 40068
				order[55] = 40069
				order[56] = 40070
				order[57] = 40071
				order[58] = 40072
				order[59] = 41244
				order[60] = 41245
				order[61] = 40073
				order[62] = 40075
				order[63] = 40076
				order[64] = 40078
				order[65] = 40079
				order[66] = 40080
				order[67] = 40081
				order[68] = 40082
				order[69] = 40083
				order[70] = 40084
				order[71] = 41246
				order[72] = 41247
				order[73] = 41248
				order[74] = 40738
				order[75] = 40739
				order[76] = 40740
				order[77] = 42600
				order[78] = 40741
				order[79] = 40742
				order[80] = 43106
				order[81] = 40743
				order[82] = 40744
				order[83] = 40745
				order[84] = 40746
				order[85] = 40747
				order[86] = 42601
				order[87] = 42602
				order[88] = 42603
				order[89] = 42604
				order[90] = 40748
				order[91] = 40749
				order[92] = 40750
				order[93] = 41180
				order[94] = 41181
				order[95] = 41182
				order[96] = 41183
				order[97] = 41184
				order[98] = 41185
				order[99] = 41186
				order[100] = 42605
				order[101] = 40828
				order[102] = 40872
				order[103] = 41058
				order[104] = 41059
				order[105] = 41060
				order[106] = 41061
				order[107] = 41062
				order[108] = 42192
				order[109] = 42193
				order[110] = 41063
				order[111] = 41064
				order[112] = 41065
				order[113] = 41066
				order[114] = 41067
				order[115] = 41218
				order[116] = 41068
				order[117] = 41069
				order[118] = 41070
				order[119] = 41071
				order[120] = 41072
				order[121] = 41073
				order[122] = 41074
				order[123] = 41075
				order[124] = 41076
				order[125] = 41077
				order[126] = 41078
				order[127] = 41079
				order[128] = 41080
				order[129] = 43094
				order[130] = 41037
				order[131] = 40056
				order[132] = 40982
				order[133] = 40983
				order[134] = 0
				super(40049, 40050, order)
			end

			class NoStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41278
					order[1] = 41279
					order[2] = 0
					super(41277, 41278, order)
				end
			end

			class NoStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41238
					order[1] = 41239
					order[2] = 41240
					order[3] = 0
					super(41237, 41238, order)
				end
			end

			class NoStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41281
					order[1] = 41282
					order[2] = 0
					super(41280, 41281, order)
				end
			end

			class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41250
					order[1] = 0
					super(41249, 41250, order)
				end
			end

			class NoStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41290
					order[1] = 41291
					order[2] = 41292
					order[3] = 41293
					order[4] = 41294
					order[5] = 41295
					order[6] = 41296
					order[7] = 41297
					order[8] = 41298
					order[9] = 41299
					order[10] = 41300
					order[11] = 41283
					order[12] = 41301
					order[13] = 41302
					order[14] = 0
					super(41289, 41290, order)
				end

				class NoStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41284
						order[1] = 41285
						order[2] = 41286
						order[3] = 0
						super(41283, 41284, order)
					end

					class NoStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41287
							order[1] = 41288
							order[2] = 41588
							order[3] = 0
							super(41286, 41287, order)
						end
					end
				end
			end

			class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40909
					order[1] = 0
					super(40960, 40909, order)
				end
			end

			class NoStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40067
					order[1] = 0
					super(40961, 40067, order)
				end
			end

			class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40074
					order[1] = 0
					super(40958, 40074, order)
				end
			end

			class NoStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41242
					order[1] = 41243
					order[2] = 0
					super(41241, 41242, order)
				end
			end

			class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40077
					order[1] = 0
					super(40959, 40077, order)
				end
			end

			class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40752
					order[1] = 0
					super(40947, 40752, order)
				end
			end

			class NoPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41221
					order[1] = 41222
					order[2] = 0
					super(41220, 41221, order)
				end
			end

			class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40763
					order[1] = 0
					super(40948, 40763, order)
				end
			end

			class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40769
					order[1] = 0
					super(40949, 40769, order)
				end
			end

			class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40776
					order[1] = 0
					super(40950, 40776, order)
				end
			end

			class NoPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42661
					order[1] = 42662
					order[2] = 0
					super(42660, 42661, order)
				end
			end

			class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41193
					order[1] = 0
					super(41192, 41193, order)
				end
			end

			class NoPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41228
					order[1] = 41229
					order[2] = 0
					super(41227, 41228, order)
				end
			end

			class NoPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41225
					order[1] = 41226
					order[2] = 0
					super(41224, 41225, order)
				end
			end

			class NoPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43109
					order[1] = 42684
					order[2] = 42685
					order[3] = 0
					super(42683, 43109, order)
				end
			end

			class NoDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42275
					order[1] = 42276
					order[2] = 42277
					order[3] = 42278
					order[4] = 42279
					order[5] = 42280
					order[6] = 42294
					order[7] = 42281
					order[8] = 42282
					order[9] = 42283
					order[10] = 42284
					order[11] = 42285
					order[12] = 42286
					order[13] = 42287
					order[14] = 42288
					order[15] = 42289
					order[16] = 42290
					order[17] = 42291
					order[18] = 42292
					order[19] = 42293
					order[20] = 0
					super(42274, 42275, order)
				end

				class NoDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42295
						order[1] = 0
						super(42294, 42295, order)
					end
				end
			end

			class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42273
					order[1] = 0
					super(42272, 42273, order)
				end
			end

			class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42237
					order[1] = 0
					super(42236, 42237, order)
				end
			end

			class NoReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42736
					order[1] = 42737
					order[2] = 42738
					order[3] = 42739
					order[4] = 42740
					order[5] = 42741
					order[6] = 42765
					order[7] = 42731
					order[8] = 42742
					order[9] = 42743
					order[10] = 42744
					order[11] = 42745
					order[12] = 42746
					order[13] = 42747
					order[14] = 42748
					order[15] = 42749
					order[16] = 42750
					order[17] = 42751
					order[18] = 42752
					order[19] = 42753
					order[20] = 42761
					order[21] = 42754
					order[22] = 42755
					order[23] = 42709
					order[24] = 42756
					order[25] = 42757
					order[26] = 42758
					order[27] = 42759
					order[28] = 42760
					order[29] = 0
					super(42735, 42736, order)
				end

				class NoReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42766
						order[1] = 42767
						order[2] = 42768
						order[3] = 42769
						order[4] = 0
						super(42765, 42766, order)
					end
				end

				class NoReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42732
						order[1] = 42733
						order[2] = 42734
						order[3] = 0
						super(42731, 42732, order)
					end
				end

				class NoReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42762
						order[1] = 42763
						order[2] = 42764
						order[3] = 0
						super(42761, 42762, order)
					end
				end

				class NoReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42710
						order[1] = 42772
						order[2] = 42711
						order[3] = 42712
						order[4] = 42713
						order[5] = 42714
						order[6] = 42715
						order[7] = 42716
						order[8] = 42717
						order[9] = 42718
						order[10] = 42719
						order[11] = 42720
						order[12] = 42721
						order[13] = 42722
						order[14] = 42723
						order[15] = 42724
						order[16] = 42725
						order[17] = 42726
						order[18] = 42727
						order[19] = 42728
						order[20] = 42729
						order[21] = 42730
						order[22] = 42770
						order[23] = 0
						super(42709, 42710, order)
					end

					class NoReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42773
							order[1] = 42774
							order[2] = 0
							super(42772, 42773, order)
						end
					end

					class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42771
							order[1] = 0
							super(42770, 42771, order)
						end
					end
				end
			end

			class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42621
					order[1] = 0
					super(42620, 42621, order)
				end
			end

			class NoPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42607
					order[1] = 42608
					order[2] = 0
					super(42606, 42607, order)
				end
			end

			class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40819
					order[1] = 0
					super(40946, 40819, order)
				end
			end

			class NoNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40826
					order[1] = 40827
					order[2] = 0
					super(40825, 40826, order)
				end
			end

			class NoSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40086
					order[1] = 40373
					order[2] = 40655
					order[3] = 40088
					order[4] = 40089
					order[5] = 0
					super(40085, 40086, order)
				end
			end

			class NoPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40829
					order[1] = 41164
					order[2] = 41165
					order[3] = 40830
					order[4] = 40831
					order[5] = 40832
					order[6] = 40833
					order[7] = 40834
					order[8] = 40835
					order[9] = 40836
					order[10] = 40837
					order[11] = 40838
					order[12] = 40839
					order[13] = 41166
					order[14] = 41167
					order[15] = 41168
					order[16] = 41169
					order[17] = 40840
					order[18] = 40841
					order[19] = 40842
					order[20] = 40843
					order[21] = 41170
					order[22] = 41171
					order[23] = 41172
					order[24] = 41173
					order[25] = 40844
					order[26] = 40845
					order[27] = 40846
					order[28] = 40847
					order[29] = 40848
					order[30] = 40849
					order[31] = 40868
					order[32] = 40850
					order[33] = 40851
					order[34] = 40852
					order[35] = 40853
					order[36] = 40977
					order[37] = 40855
					order[38] = 40856
					order[39] = 40857
					order[40] = 41174
					order[41] = 41175
					order[42] = 40858
					order[43] = 41161
					order[44] = 41176
					order[45] = 41177
					order[46] = 41178
					order[47] = 41179
					order[48] = 40859
					order[49] = 40860
					order[50] = 40861
					order[51] = 40862
					order[52] = 40945
					order[53] = 40864
					order[54] = 40865
					order[55] = 40866
					order[56] = 40867
					order[57] = 0
					super(40828, 40829, order)
				end

				class NoPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40869
						order[1] = 40870
						order[2] = 40871
						order[3] = 0
						super(40868, 40869, order)
					end
				end

				class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40854
						order[1] = 0
						super(40977, 40854, order)
					end
				end

				class NoPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41162
						order[1] = 41163
						order[2] = 0
						super(41161, 41162, order)
					end
				end

				class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40863
						order[1] = 0
						super(40945, 40863, order)
					end
				end
			end

			class NoPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40873
					order[1] = 40874
					order[2] = 42698
					order[3] = 42699
					order[4] = 42700
					order[5] = 42701
					order[6] = 42702
					order[7] = 42703
					order[8] = 42704
					order[9] = 42689
					order[10] = 42690
					order[11] = 42691
					order[12] = 42692
					order[13] = 42693
					order[14] = 42694
					order[15] = 42695
					order[16] = 40875
					order[17] = 40876
					order[18] = 40877
					order[19] = 40878
					order[20] = 40879
					order[21] = 40880
					order[22] = 40881
					order[23] = 40882
					order[24] = 40883
					order[25] = 40884
					order[26] = 40885
					order[27] = 40886
					order[28] = 40887
					order[29] = 40888
					order[30] = 40889
					order[31] = 40890
					order[32] = 40891
					order[33] = 40892
					order[34] = 40893
					order[35] = 40894
					order[36] = 40895
					order[37] = 40896
					order[38] = 40897
					order[39] = 40898
					order[40] = 40899
					order[41] = 40900
					order[42] = 40901
					order[43] = 0
					super(40872, 40873, order)
				end

				class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42706
						order[1] = 0
						super(42705, 42706, order)
					end
				end

				class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42697
						order[1] = 0
						super(42696, 42697, order)
					end
				end
			end

			class NoDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41086
					order[1] = 0
					super(41085, 41086, order)
				end
			end

			class NoDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41082
					order[1] = 41083
					order[2] = 41084
					order[3] = 0
					super(41081, 41082, order)
				end
			end

			class NoDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41038
					order[1] = 41039
					order[2] = 41040
					order[3] = 41041
					order[4] = 41042
					order[5] = 41043
					order[6] = 41044
					order[7] = 41045
					order[8] = 41046
					order[9] = 41047
					order[10] = 41048
					order[11] = 41049
					order[12] = 41050
					order[13] = 41051
					order[14] = 0
					super(41037, 41038, order)
				end

				class NoDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41052
						order[1] = 41053
						order[2] = 41054
						order[3] = 0
						super(41051, 41052, order)
					end

					class NoDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41055
							order[1] = 41056
							order[2] = 41057
							order[3] = 0
							super(41054, 41055, order)
						end
					end
				end
			end
		end

		class NoProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40091
				order[1] = 40092
				order[2] = 40093
				order[3] = 40957
				order[4] = 40095
				order[5] = 40096
				order[6] = 40097
				order[7] = 42707
				order[8] = 42708
				order[9] = 40098
				order[10] = 40099
				order[11] = 40100
				order[12] = 40114
				order[13] = 40115
				order[14] = 40116
				order[15] = 40118
				order[16] = 40119
				order[17] = 40120
				order[18] = 40121
				order[19] = 40122
				order[20] = 40123
				order[21] = 40125
				order[22] = 40126
				order[23] = 40127
				order[24] = 40128
				order[25] = 40129
				order[26] = 40130
				order[27] = 40131
				order[28] = 40132
				order[29] = 40133
				order[30] = 40134
				order[31] = 40135
				order[32] = 40136
				order[33] = 40137
				order[34] = 40138
				order[35] = 40139
				order[36] = 40140
				order[37] = 40141
				order[38] = 40145
				order[39] = 40146
				order[40] = 40148
				order[41] = 40149
				order[42] = 40150
				order[43] = 40151
				order[44] = 40152
				order[45] = 40153
				order[46] = 40154
				order[47] = 40155
				order[48] = 40156
				order[49] = 40158
				order[50] = 40159
				order[51] = 40160
				order[52] = 40161
				order[53] = 40162
				order[54] = 40101
				order[55] = 40102
				order[56] = 40103
				order[57] = 40104
				order[58] = 40105
				order[59] = 40106
				order[60] = 40107
				order[61] = 40163
				order[62] = 40165
				order[63] = 40166
				order[64] = 40167
				order[65] = 40168
				order[66] = 40169
				order[67] = 40170
				order[68] = 40108
				order[69] = 40109
				order[70] = 40110
				order[71] = 40111
				order[72] = 40112
				order[73] = 41406
				order[74] = 40113
				order[75] = 40986
				order[76] = 40987
				order[77] = 40174
				order[78] = 0
				super(40090, 40091, order)
			end

			class NoProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40094
					order[1] = 0
					super(40957, 40094, order)
				end
			end

			class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40117
					order[1] = 0
					super(40953, 40117, order)
				end
			end

			class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40124
					order[1] = 0
					super(40954, 40124, order)
				end
			end

			class NoProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40143
					order[1] = 40144
					order[2] = 0
					super(40142, 40143, order)
				end
			end

			class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40147
					order[1] = 0
					super(40955, 40147, order)
				end
			end

			class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40157
					order[1] = 0
					super(40956, 40157, order)
				end
			end

			class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40164
					order[1] = 0
					super(40952, 40164, order)
				end
			end

			class NoProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40172
					order[1] = 40173
					order[2] = 0
					super(40171, 40172, order)
				end
			end

			class NoProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40175
					order[1] = 40176
					order[2] = 40177
					order[3] = 2385
					order[4] = 40178
					order[5] = 0
					super(40174, 40175, order)
				end

				class NoProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40179
						order[1] = 40180
						order[2] = 0
						super(40178, 40179, order)
					end
				end
			end
		end

		class NoAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40020
				order[1] = 40021
				order[2] = 40000
				order[3] = 0
				super(40019, 40020, order)
			end

			class NoAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 40001
					order[1] = 40002
					order[2] = 40003
					order[3] = 40004
					order[4] = 40005
					order[5] = 40006
					order[6] = 40007
					order[7] = 40008
					order[8] = 40009
					order[9] = 40010
					order[10] = 40011
					order[11] = 40012
					order[12] = 40013
					order[13] = 40014
					order[14] = 40015
					order[15] = 40016
					order[16] = 40017
					order[17] = 40018
					order[18] = 0
					super(40000, 40001, order)
				end
			end
		end

		class NoProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 40182
				order[1] = 40183
				order[2] = 40184
				order[3] = 40185
				order[4] = 40186
				order[5] = 40187
				order[6] = 40188
				order[7] = 40951
				order[8] = 40191
				order[9] = 40201
				order[10] = 40190
				order[11] = 0
				super(40181, 40182, order)
			end

			class NoProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40189
					order[1] = 0
					super(40951, 40189, order)
				end
			end

			class NoProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40192
					order[1] = 40193
					order[2] = 40194
					order[3] = 40195
					order[4] = 40196
					order[5] = 40197
					order[6] = 40198
					order[7] = 40199
					order[8] = 0
					super(40191, 40192, order)
				end

				class NoProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40200
						order[1] = 0
						super(40199, 40200, order)
					end
				end
			end

			class NoProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40202
					order[1] = 40203
					order[2] = 0
					super(40201, 40202, order)
				end
			end
		end

		class NoCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 40023
				order[1] = 40024
				order[2] = 40916
				order[3] = 40917
				order[4] = 40025
				order[5] = 40026
				order[6] = 40027
				order[7] = 40028
				order[8] = 40029
				order[9] = 40030
				order[10] = 40031
				order[11] = 40277
				order[12] = 42216
				order[13] = 42217
				order[14] = 40033
				order[15] = 40034
				order[16] = 42207
				order[17] = 42208
				order[18] = 42209
				order[19] = 42210
				order[20] = 42211
				order[21] = 42212
				order[22] = 42213
				order[23] = 40035
				order[24] = 40036
				order[25] = 40037
				order[26] = 40038
				order[27] = 40039
				order[28] = 0
				super(40022, 40023, order)
			end

			class NoCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40032
					order[1] = 0
					super(40277, 40032, order)
				end
			end

			class NoCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42215
					order[1] = 0
					super(42214, 42215, order)
				end
			end
		end

		class NoPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40209
				order[1] = 40205
				order[2] = 40206
				order[3] = 40207
				order[4] = 40208
				order[5] = 0
				super(40204, 40209, order)
			end

			class NoPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40210
					order[1] = 40211
					order[2] = 0
					super(40209, 40210, order)
				end
			end
		end

		class NoExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42297
				order[1] = 42298
				order[2] = 0
				super(42296, 42297, order)
			end
		end

		class NoContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40041
				order[1] = 0
				super(40040, 40041, order)
			end
		end

		class NoFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40047
				order[1] = 40048
				order[2] = 0
				super(40046, 40047, order)
			end
		end

		class NoContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40043
				order[1] = 40044
				order[2] = 40045
				order[3] = 0
				super(40042, 40043, order)
			end
		end

		class NoUnderlyings < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(188)
				order[0] = 311
				order[1] = 312
				order[2] = 309
				order[3] = 305
				order[4] = 2874
				order[5] = 462
				order[6] = 463
				order[7] = 2894
				order[8] = 310
				order[9] = 763
				order[10] = 313
				order[11] = 542
				order[12] = 1213
				order[13] = 1837
				order[14] = 241
				order[15] = 1453
				order[16] = 1454
				order[17] = 2614
				order[18] = 2615
				order[19] = 2921
				order[20] = 2616
				order[21] = 2617
				order[22] = 2619
				order[23] = 1455
				order[24] = 1456
				order[25] = 1459
				order[26] = 1460
				order[27] = 242
				order[28] = 243
				order[29] = 244
				order[30] = 245
				order[31] = 246
				order[32] = 256
				order[33] = 595
				order[34] = 592
				order[35] = 593
				order[36] = 594
				order[37] = 247
				order[38] = 316
				order[39] = 941
				order[40] = 2917
				order[41] = 317
				order[42] = 436
				order[43] = 1437
				order[44] = 2363
				order[45] = 1441
				order[46] = 998
				order[47] = 1423
				order[48] = 1718
				order[49] = 2918
				order[50] = 1424
				order[51] = 1425
				order[52] = 1719
				order[53] = 2919
				order[54] = 1000
				order[55] = 1419
				order[56] = 1526
				order[57] = 2920
				order[58] = 435
				order[59] = 308
				order[60] = 306
				order[61] = 362
				order[62] = 363
				order[63] = 2742
				order[64] = 2720
				order[65] = 2721
				order[66] = 2722
				order[67] = 2723
				order[68] = 2724
				order[69] = 307
				order[70] = 364
				order[71] = 365
				order[72] = 877
				order[73] = 878
				order[74] = 972
				order[75] = 318
				order[76] = 2916
				order[77] = 879
				order[78] = 975
				order[79] = 973
				order[80] = 974
				order[81] = 810
				order[82] = 882
				order[83] = 883
				order[84] = 884
				order[85] = 885
				order[86] = 886
				order[87] = 2885
				order[88] = 2886
				order[89] = 1044
				order[90] = 1045
				order[91] = 1046
				order[92] = 1038
				order[93] = 1039
				order[94] = 315
				order[95] = 2683
				order[96] = 2687
				order[97] = 1988
				order[98] = 1989
				order[99] = 1990
				order[100] = 1991
				order[101] = 1992
				order[102] = 1993
				order[103] = 2881
				order[104] = 1994
				order[105] = 1995
				order[106] = 1996
				order[107] = 1997
				order[108] = 2620
				order[109] = 2621
				order[110] = 1998
				order[111] = 1999
				order[112] = 2000
				order[113] = 2003
				order[114] = 2004
				order[115] = 2005
				order[116] = 2006
				order[117] = 2284
				order[118] = 2285
				order[119] = 2286
				order[120] = 2287
				order[121] = 2288
				order[122] = 2007
				order[123] = 2008
				order[124] = 2009
				order[125] = 2010
				order[126] = 2011
				order[127] = 2012
				order[128] = 2491
				order[129] = 2013
				order[130] = 2014
				order[131] = 2015
				order[132] = 2744
				order[133] = 2016
				order[134] = 2289
				order[135] = 2017
				order[136] = 2018
				order[137] = 2019
				order[138] = 2020
				order[139] = 2021
				order[140] = 2022
				order[141] = 2290
				order[142] = 2622
				order[143] = 2291
				order[144] = 2623
				order[145] = 2292
				order[146] = 2023
				order[147] = 2024
				order[148] = 2025
				order[149] = 2026
				order[150] = 2027
				order[151] = 2028
				order[152] = 2029
				order[153] = 2757
				order[154] = 2030
				order[155] = 2031
				order[156] = 2293
				order[157] = 2294
				order[158] = 2032
				order[159] = 2033
				order[160] = 2034
				order[161] = 2035
				order[162] = 2036
				order[163] = 2037
				order[164] = 2038
				order[165] = 2039
				order[166] = 2040
				order[167] = 2041
				order[168] = 2042
				order[169] = 2043
				order[170] = 2044
				order[171] = 41314
				order[172] = 41315
				order[173] = 2295
				order[174] = 2296
				order[175] = 2297
				order[176] = 2756
				order[177] = 2298
				order[178] = 2299
				order[179] = 2624
				order[180] = 2625
				order[181] = 2626
				order[182] = 2627
				order[183] = 2628
				order[184] = 2629
				order[185] = 2630
				order[186] = 2631
				order[187] = 0
				super(711, 311, order)
			end

			class NoUnderlyingSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 458
					order[1] = 459
					order[2] = 2959
					order[3] = 0
					super(457, 458, order)
				end
			end

			class NoUnderlyingStips < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 888
					order[1] = 889
					order[2] = 0
					super(887, 888, order)
				end
			end

			class NoUndlyInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 1059
					order[1] = 1060
					order[2] = 1061
					order[3] = 2391
					order[4] = 1062
					order[5] = 0
					super(1058, 1059, order)
				end

				class NoUndlyInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1063
						order[1] = 1064
						order[2] = 0
						super(1062, 1063, order)
					end
				end
			end

			class NoUnderlyingEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 1982
					order[1] = 1983
					order[2] = 1984
					order[3] = 1985
					order[4] = 1986
					order[5] = 2342
					order[6] = 1987
					order[7] = 2071
					order[8] = 2072
					order[9] = 2073
					order[10] = 0
					super(1981, 1982, order)
				end
			end

			class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2081
					order[1] = 2082
					order[2] = 2083
					order[3] = 2745
					order[4] = 0
					super(2080, 2081, order)
				end
			end

			class NoUnderlyingAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2313
					order[1] = 2314
					order[2] = 2315
					order[3] = 0
					super(2312, 2313, order)
				end
			end

			class NoUnderlyingComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2046
					order[1] = 2261
					order[2] = 2262
					order[3] = 2263
					order[4] = 2047
					order[5] = 2264
					order[6] = 2265
					order[7] = 2266
					order[8] = 2947
					order[9] = 2048
					order[10] = 2267
					order[11] = 2049
					order[12] = 2050
					order[13] = 2051
					order[14] = 2052
					order[15] = 2053
					order[16] = 2268
					order[17] = 2948
					order[18] = 2269
					order[19] = 2949
					order[20] = 2270
					order[21] = 2271
					order[22] = 2419
					order[23] = 2420
					order[24] = 2272
					order[25] = 2273
					order[26] = 2274
					order[27] = 2275
					order[28] = 2276
					order[29] = 41732
					order[30] = 41739
					order[31] = 41740
					order[32] = 41741
					order[33] = 41742
					order[34] = 41743
					order[35] = 41744
					order[36] = 41745
					order[37] = 41746
					order[38] = 41747
					order[39] = 41729
					order[40] = 2277
					order[41] = 2278
					order[42] = 2279
					order[43] = 2280
					order[44] = 2281
					order[45] = 41748
					order[46] = 41716
					order[47] = 2611
					order[48] = 2612
					order[49] = 2613
					order[50] = 2282
					order[51] = 2283
					order[52] = 0
					super(2045, 2046, order)
				end

				class NoUnderlyingComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2054
						order[1] = 2055
						order[2] = 2056
						order[3] = 0
						super(2053, 2054, order)
					end

					class NoUnderlyingComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2057
							order[1] = 2058
							order[2] = 0
							super(2056, 2057, order)
						end
					end
				end

				class NoUnderlyingComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41733
						order[1] = 41734
						order[2] = 41735
						order[3] = 41736
						order[4] = 0
						super(41732, 41733, order)
					end
				end

				class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41738
						order[1] = 0
						super(41737, 41738, order)
					end
				end

				class NoUnderlyingComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41730
						order[1] = 41731
						order[2] = 41750
						order[3] = 41726
						order[4] = 41713
						order[5] = 0
						super(41729, 41730, order)
					end

					class NoUnderlyingComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41751
							order[1] = 41752
							order[2] = 41753
							order[3] = 41754
							order[4] = 41755
							order[5] = 0
							super(41750, 41751, order)
						end
					end

					class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41727
							order[1] = 41728
							order[2] = 0
							super(41726, 41727, order)
						end
					end

					class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41714
							order[1] = 41715
							order[2] = 0
							super(41713, 41714, order)
						end
					end
				end

				class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41749
						order[1] = 0
						super(41748, 41749, order)
					end
				end

				class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41717
						order[1] = 41718
						order[2] = 41719
						order[3] = 41720
						order[4] = 41721
						order[5] = 41722
						order[6] = 41723
						order[7] = 41724
						order[8] = 0
						super(41716, 41717, order)
					end

					class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41725
							order[1] = 0
							super(41724, 41725, order)
						end
					end
				end
			end

			class NoUnderlyingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40963
					order[1] = 0
					super(40962, 40963, order)
				end
			end

			class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41948
					order[1] = 0
					super(41947, 41948, order)
				end
			end

			class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41865
					order[1] = 41338
					order[2] = 0
					super(41864, 41865, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41867
					order[1] = 41339
					order[2] = 0
					super(41866, 41867, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41869
					order[1] = 41870
					order[2] = 41871
					order[3] = 41872
					order[4] = 41873
					order[5] = 41874
					order[6] = 41875
					order[7] = 41876
					order[8] = 41877
					order[9] = 0
					super(41868, 41869, order)
				end
			end

			class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 43075
					order[1] = 0
					super(43074, 43075, order)
				end
			end

			class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41821
					order[1] = 0
					super(41820, 41821, order)
				end
			end

			class NoUnderlyingOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41842
					order[1] = 41843
					order[2] = 0
					super(41841, 41842, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41845
					order[1] = 0
					super(41844, 41845, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41857
					order[1] = 41858
					order[2] = 0
					super(41856, 41857, order)
				end
			end

			class NoUnderlyingStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40541
					order[1] = 42016
					order[2] = 40542
					order[3] = 43083
					order[4] = 43084
					order[5] = 40543
					order[6] = 40544
					order[7] = 42018
					order[8] = 40545
					order[9] = 40546
					order[10] = 43085
					order[11] = 43086
					order[12] = 42019
					order[13] = 42020
					order[14] = 42021
					order[15] = 42022
					order[16] = 42023
					order[17] = 42024
					order[18] = 41964
					order[19] = 41965
					order[20] = 41966
					order[21] = 41967
					order[22] = 41968
					order[23] = 41969
					order[24] = 41970
					order[25] = 42589
					order[26] = 41971
					order[27] = 41972
					order[28] = 41973
					order[29] = 41974
					order[30] = 41975
					order[31] = 41976
					order[32] = 41977
					order[33] = 41978
					order[34] = 41979
					order[35] = 41980
					order[36] = 41981
					order[37] = 41982
					order[38] = 41983
					order[39] = 41984
					order[40] = 41985
					order[41] = 41986
					order[42] = 41987
					order[43] = 41988
					order[44] = 41989
					order[45] = 40057
					order[46] = 40058
					order[47] = 40060
					order[48] = 40061
					order[49] = 40062
					order[50] = 40063
					order[51] = 40064
					order[52] = 40548
					order[53] = 40549
					order[54] = 40551
					order[55] = 40552
					order[56] = 40553
					order[57] = 40554
					order[58] = 40555
					order[59] = 41957
					order[60] = 41958
					order[61] = 40556
					order[62] = 40558
					order[63] = 40559
					order[64] = 40561
					order[65] = 40562
					order[66] = 40563
					order[67] = 40564
					order[68] = 40565
					order[69] = 40566
					order[70] = 40567
					order[71] = 41959
					order[72] = 41960
					order[73] = 41961
					order[74] = 40568
					order[75] = 40569
					order[76] = 40570
					order[77] = 42895
					order[78] = 40571
					order[79] = 40572
					order[80] = 43107
					order[81] = 40573
					order[82] = 40574
					order[83] = 40575
					order[84] = 40576
					order[85] = 40577
					order[86] = 42896
					order[87] = 42897
					order[88] = 42898
					order[89] = 42899
					order[90] = 40578
					order[91] = 40579
					order[92] = 40580
					order[93] = 41897
					order[94] = 41898
					order[95] = 41899
					order[96] = 41900
					order[97] = 41901
					order[98] = 41902
					order[99] = 41903
					order[100] = 42900
					order[101] = 40664
					order[102] = 40708
					order[103] = 41777
					order[104] = 41778
					order[105] = 41779
					order[106] = 41780
					order[107] = 41781
					order[108] = 42196
					order[109] = 42197
					order[110] = 41782
					order[111] = 41783
					order[112] = 41784
					order[113] = 41785
					order[114] = 41786
					order[115] = 41587
					order[116] = 41787
					order[117] = 41788
					order[118] = 41789
					order[119] = 41790
					order[120] = 41791
					order[121] = 41792
					order[122] = 41793
					order[123] = 41794
					order[124] = 41795
					order[125] = 41796
					order[126] = 41797
					order[127] = 41798
					order[128] = 41799
					order[129] = 43096
					order[130] = 41756
					order[131] = 40547
					order[132] = 40988
					order[133] = 40989
					order[134] = 0
					super(40540, 40541, order)
				end

				class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41991
						order[1] = 41992
						order[2] = 0
						super(41990, 41991, order)
					end
				end

				class NoUnderlyingStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41801
						order[1] = 41802
						order[2] = 41803
						order[3] = 0
						super(41800, 41801, order)
					end
				end

				class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41994
						order[1] = 41995
						order[2] = 0
						super(41993, 41994, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41963
						order[1] = 0
						super(41962, 41963, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 42003
						order[1] = 42004
						order[2] = 42005
						order[3] = 42006
						order[4] = 42007
						order[5] = 42008
						order[6] = 42009
						order[7] = 42010
						order[8] = 42011
						order[9] = 42012
						order[10] = 42013
						order[11] = 41996
						order[12] = 42014
						order[13] = 42015
						order[14] = 0
						super(42002, 42003, order)
					end

					class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41997
							order[1] = 41998
							order[2] = 41999
							order[3] = 0
							super(41996, 41997, order)
						end

						class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 42000
								order[1] = 42001
								order[2] = 41936
								order[3] = 0
								super(41999, 42000, order)
							end
						end
					end
				end

				class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40059
						order[1] = 0
						super(40975, 40059, order)
					end
				end

				class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40550
						order[1] = 0
						super(40976, 40550, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40557
						order[1] = 0
						super(40973, 40557, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41955
						order[1] = 41956
						order[2] = 0
						super(41954, 41955, order)
					end
				end

				class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40560
						order[1] = 0
						super(40974, 40560, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40582
						order[1] = 0
						super(40969, 40582, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41938
						order[1] = 41939
						order[2] = 0
						super(41937, 41938, order)
					end
				end

				class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40594
						order[1] = 0
						super(40970, 40594, order)
					end
				end

				class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40600
						order[1] = 0
						super(40971, 40600, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40607
						order[1] = 0
						super(40972, 40607, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42956
						order[1] = 42957
						order[2] = 0
						super(42955, 42956, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41910
						order[1] = 0
						super(41909, 41910, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41945
						order[1] = 41946
						order[2] = 0
						super(41944, 41945, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41942
						order[1] = 41943
						order[2] = 0
						super(41941, 41942, order)
					end
				end

				class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43111
						order[1] = 42982
						order[2] = 42983
						order[3] = 0
						super(42981, 43111, order)
					end
				end

				class NoUnderlyingDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42863
						order[1] = 42864
						order[2] = 42865
						order[3] = 42866
						order[4] = 42867
						order[5] = 42868
						order[6] = 42882
						order[7] = 42869
						order[8] = 42870
						order[9] = 42871
						order[10] = 42872
						order[11] = 42873
						order[12] = 42874
						order[13] = 42875
						order[14] = 42876
						order[15] = 42877
						order[16] = 42878
						order[17] = 42879
						order[18] = 42880
						order[19] = 42881
						order[20] = 0
						super(42862, 42863, order)
					end

					class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42883
							order[1] = 0
							super(42882, 42883, order)
						end
					end
				end

				class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42854
						order[1] = 0
						super(42853, 42854, order)
					end
				end

				class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42800
						order[1] = 0
						super(42799, 42800, order)
					end
				end

				class NoUnderlyingReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 43035
						order[1] = 43036
						order[2] = 43037
						order[3] = 43038
						order[4] = 43039
						order[5] = 43040
						order[6] = 43064
						order[7] = 43030
						order[8] = 43041
						order[9] = 43042
						order[10] = 43043
						order[11] = 43044
						order[12] = 43045
						order[13] = 43046
						order[14] = 43047
						order[15] = 43048
						order[16] = 43049
						order[17] = 43050
						order[18] = 43051
						order[19] = 43052
						order[20] = 43060
						order[21] = 43053
						order[22] = 43054
						order[23] = 43008
						order[24] = 43055
						order[25] = 43056
						order[26] = 43057
						order[27] = 43058
						order[28] = 43059
						order[29] = 0
						super(43034, 43035, order)
					end

					class NoUnderlyingReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 43065
							order[1] = 43066
							order[2] = 43067
							order[3] = 43068
							order[4] = 0
							super(43064, 43065, order)
						end
					end

					class NoUnderlyingReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43031
							order[1] = 43032
							order[2] = 43033
							order[3] = 0
							super(43030, 43031, order)
						end
					end

					class NoUnderlyingReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43061
							order[1] = 43062
							order[2] = 43063
							order[3] = 0
							super(43060, 43061, order)
						end
					end

					class NoUnderlyingReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 43009
							order[1] = 43071
							order[2] = 43010
							order[3] = 43011
							order[4] = 43012
							order[5] = 43013
							order[6] = 43014
							order[7] = 43015
							order[8] = 43016
							order[9] = 43017
							order[10] = 43018
							order[11] = 43019
							order[12] = 43020
							order[13] = 43021
							order[14] = 43022
							order[15] = 43023
							order[16] = 43024
							order[17] = 43025
							order[18] = 43026
							order[19] = 43027
							order[20] = 43028
							order[21] = 43029
							order[22] = 43069
							order[23] = 0
							super(43008, 43009, order)
						end

						class NoUnderlyingReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 43072
								order[1] = 43073
								order[2] = 0
								super(43071, 43072, order)
							end
						end

						class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 43070
								order[1] = 0
								super(43069, 43070, order)
							end
						end
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42916
						order[1] = 0
						super(42915, 42916, order)
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42902
						order[1] = 42903
						order[2] = 0
						super(42901, 42902, order)
					end
				end

				class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40650
						order[1] = 0
						super(40968, 40650, order)
					end
				end

				class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40657
						order[1] = 40658
						order[2] = 0
						super(40656, 40657, order)
					end
				end

				class NoUnderlyingSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40660
						order[1] = 40904
						order[2] = 40915
						order[3] = 40662
						order[4] = 40663
						order[5] = 0
						super(40659, 40660, order)
					end
				end

				class NoUnderlyingPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40665
						order[1] = 41881
						order[2] = 41882
						order[3] = 40666
						order[4] = 40667
						order[5] = 40668
						order[6] = 40669
						order[7] = 40670
						order[8] = 40671
						order[9] = 40672
						order[10] = 40673
						order[11] = 40674
						order[12] = 40675
						order[13] = 41883
						order[14] = 41884
						order[15] = 41885
						order[16] = 41886
						order[17] = 40676
						order[18] = 40677
						order[19] = 40678
						order[20] = 40679
						order[21] = 41887
						order[22] = 41888
						order[23] = 41889
						order[24] = 41890
						order[25] = 40680
						order[26] = 40681
						order[27] = 40682
						order[28] = 40683
						order[29] = 40684
						order[30] = 40685
						order[31] = 40704
						order[32] = 40686
						order[33] = 40687
						order[34] = 40688
						order[35] = 40689
						order[36] = 40966
						order[37] = 40691
						order[38] = 40692
						order[39] = 40693
						order[40] = 41891
						order[41] = 41892
						order[42] = 40694
						order[43] = 41878
						order[44] = 41893
						order[45] = 41894
						order[46] = 41895
						order[47] = 41896
						order[48] = 40695
						order[49] = 40696
						order[50] = 40697
						order[51] = 40698
						order[52] = 40967
						order[53] = 40700
						order[54] = 40701
						order[55] = 40702
						order[56] = 40703
						order[57] = 0
						super(40664, 40665, order)
					end

					class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40705
							order[1] = 40706
							order[2] = 40707
							order[3] = 0
							super(40704, 40705, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40690
							order[1] = 0
							super(40966, 40690, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41879
							order[1] = 41880
							order[2] = 0
							super(41878, 41879, order)
						end
					end

					class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40699
							order[1] = 0
							super(40967, 40699, order)
						end
					end
				end

				class NoUnderlyingPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40709
						order[1] = 40710
						order[2] = 42993
						order[3] = 42994
						order[4] = 42995
						order[5] = 42996
						order[6] = 42997
						order[7] = 42998
						order[8] = 42999
						order[9] = 42984
						order[10] = 42985
						order[11] = 42986
						order[12] = 42987
						order[13] = 42988
						order[14] = 42989
						order[15] = 42990
						order[16] = 40711
						order[17] = 40712
						order[18] = 40713
						order[19] = 40714
						order[20] = 40715
						order[21] = 40716
						order[22] = 40717
						order[23] = 40718
						order[24] = 40719
						order[25] = 40720
						order[26] = 40721
						order[27] = 40722
						order[28] = 40723
						order[29] = 40724
						order[30] = 40725
						order[31] = 40726
						order[32] = 40727
						order[33] = 40728
						order[34] = 40729
						order[35] = 40730
						order[36] = 40731
						order[37] = 40732
						order[38] = 40733
						order[39] = 40734
						order[40] = 40735
						order[41] = 40736
						order[42] = 40737
						order[43] = 0
						super(40708, 40709, order)
					end

					class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43001
							order[1] = 0
							super(43000, 43001, order)
						end
					end

					class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42992
							order[1] = 0
							super(42991, 42992, order)
						end
					end
				end

				class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41809
						order[1] = 0
						super(41808, 41809, order)
					end
				end

				class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41805
						order[1] = 41806
						order[2] = 41807
						order[3] = 0
						super(41804, 41805, order)
					end
				end

				class NoUnderlyingDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41757
						order[1] = 41758
						order[2] = 41759
						order[3] = 41760
						order[4] = 41761
						order[5] = 41762
						order[6] = 41763
						order[7] = 41764
						order[8] = 41765
						order[9] = 41766
						order[10] = 41767
						order[11] = 41768
						order[12] = 41769
						order[13] = 41770
						order[14] = 0
						super(41756, 41757, order)
					end

					class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41771
							order[1] = 41772
							order[2] = 41773
							order[3] = 0
							super(41770, 41771, order)
						end

						class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41774
								order[1] = 41775
								order[2] = 41776
								order[3] = 0
								super(41773, 41774, order)
							end
						end
					end
				end
			end

			class NoUnderlyingProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 42150
					order[1] = 42151
					order[2] = 42152
					order[3] = 42190
					order[4] = 42153
					order[5] = 42154
					order[6] = 42155
					order[7] = 43002
					order[8] = 43003
					order[9] = 42156
					order[10] = 42157
					order[11] = 42158
					order[12] = 42104
					order[13] = 42105
					order[14] = 42106
					order[15] = 42107
					order[16] = 42108
					order[17] = 42109
					order[18] = 42110
					order[19] = 42111
					order[20] = 42115
					order[21] = 42116
					order[22] = 42117
					order[23] = 42118
					order[24] = 42119
					order[25] = 42120
					order[26] = 42121
					order[27] = 42122
					order[28] = 42123
					order[29] = 42124
					order[30] = 42125
					order[31] = 42126
					order[32] = 42127
					order[33] = 42128
					order[34] = 42129
					order[35] = 42130
					order[36] = 42131
					order[37] = 42132
					order[38] = 42133
					order[39] = 42134
					order[40] = 42135
					order[41] = 42136
					order[42] = 42137
					order[43] = 42138
					order[44] = 42139
					order[45] = 42140
					order[46] = 42141
					order[47] = 42142
					order[48] = 42143
					order[49] = 42144
					order[50] = 42145
					order[51] = 42146
					order[52] = 42147
					order[53] = 42148
					order[54] = 42159
					order[55] = 42160
					order[56] = 42161
					order[57] = 42162
					order[58] = 42163
					order[59] = 42164
					order[60] = 42165
					order[61] = 42092
					order[62] = 42093
					order[63] = 42094
					order[64] = 42095
					order[65] = 42096
					order[66] = 42097
					order[67] = 42098
					order[68] = 42166
					order[69] = 42167
					order[70] = 42168
					order[71] = 42169
					order[72] = 42102
					order[73] = 42103
					order[74] = 42170
					order[75] = 42171
					order[76] = 42172
					order[77] = 42173
					order[78] = 0
					super(42149, 42150, order)
				end

				class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42191
						order[1] = 0
						super(42190, 42191, order)
					end
				end

				class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42183
						order[1] = 0
						super(42182, 42183, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42185
						order[1] = 0
						super(42184, 42185, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42113
						order[1] = 42114
						order[2] = 0
						super(42112, 42113, order)
					end
				end

				class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42187
						order[1] = 0
						super(42186, 42187, order)
					end
				end

				class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42189
						order[1] = 0
						super(42188, 42189, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42181
						order[1] = 0
						super(42180, 42181, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42100
						order[1] = 42101
						order[2] = 0
						super(42099, 42100, order)
					end
				end

				class NoUnderlyingProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 42174
						order[1] = 42175
						order[2] = 42176
						order[3] = 40918
						order[4] = 42177
						order[5] = 0
						super(42173, 42174, order)
					end

					class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42178
							order[1] = 42179
							order[2] = 0
							super(42177, 42178, order)
						end
					end
				end
			end

			class NoUnderlyingAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42037
					order[1] = 42038
					order[2] = 41340
					order[3] = 0
					super(42036, 42037, order)
				end

				class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41341
						order[1] = 41701
						order[2] = 41709
						order[3] = 41710
						order[4] = 41711
						order[5] = 41712
						order[6] = 42017
						order[7] = 42025
						order[8] = 42026
						order[9] = 42027
						order[10] = 42028
						order[11] = 42029
						order[12] = 42030
						order[13] = 42031
						order[14] = 42032
						order[15] = 42033
						order[16] = 42034
						order[17] = 42035
						order[18] = 0
						super(41340, 41341, order)
					end
				end
			end

			class NoUnderlyingProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 42069
					order[1] = 42070
					order[2] = 42071
					order[3] = 42072
					order[4] = 42073
					order[5] = 42074
					order[6] = 42075
					order[7] = 42090
					order[8] = 42077
					order[9] = 42087
					order[10] = 42076
					order[11] = 0
					super(42068, 42069, order)
				end

				class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42091
						order[1] = 0
						super(42090, 42091, order)
					end
				end

				class NoUnderlyingProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 42078
						order[1] = 42079
						order[2] = 42080
						order[3] = 42081
						order[4] = 42082
						order[5] = 42083
						order[6] = 42084
						order[7] = 42085
						order[8] = 0
						super(42077, 42078, order)
					end

					class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42086
							order[1] = 0
							super(42085, 42086, order)
						end
					end
				end

				class NoUnderlyingProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42088
						order[1] = 42089
						order[2] = 0
						super(42087, 42088, order)
					end
				end
			end

			class NoUnderlyingCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 42042
					order[1] = 42043
					order[2] = 42044
					order[3] = 42045
					order[4] = 42046
					order[5] = 42047
					order[6] = 42048
					order[7] = 42049
					order[8] = 42050
					order[9] = 42051
					order[10] = 42052
					order[11] = 42039
					order[12] = 42797
					order[13] = 42798
					order[14] = 42053
					order[15] = 42054
					order[16] = 42790
					order[17] = 42791
					order[18] = 42792
					order[19] = 42793
					order[20] = 42794
					order[21] = 42795
					order[22] = 42796
					order[23] = 42055
					order[24] = 42056
					order[25] = 42057
					order[26] = 42058
					order[27] = 42059
					order[28] = 0
					super(42041, 42042, order)
				end

				class NoUnderlyingCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42040
						order[1] = 0
						super(42039, 42040, order)
					end
				end

				class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42789
						order[1] = 0
						super(42788, 42789, order)
					end
				end
			end

			class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42065
					order[1] = 42061
					order[2] = 42062
					order[3] = 42063
					order[4] = 42064
					order[5] = 0
					super(42060, 42065, order)
				end

				class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42066
						order[1] = 42067
						order[2] = 0
						super(42065, 42066, order)
					end
				end
			end

			class NoUnderlyingRateSpreadSteps < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 43006
					order[1] = 43007
					order[2] = 0
					super(43005, 43006, order)
				end
			end

			class NoUnderlyingDividendPayments < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42856
					order[1] = 42857
					order[2] = 42858
					order[3] = 42859
					order[4] = 0
					super(42855, 42856, order)
				end
			end

			class NoUnderlyingExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42885
					order[1] = 42886
					order[2] = 0
					super(42884, 42885, order)
				end
			end
		end

		class NoStipulations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 233
				order[1] = 234
				order[2] = 0
				super(232, 233, order)
			end
		end

		class NoLegs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(168)
				order[0] = 600
				order[1] = 601
				order[2] = 602
				order[3] = 603
				order[4] = 1788
				order[5] = 607
				order[6] = 1594
				order[7] = 608
				order[8] = 2893
				order[9] = 609
				order[10] = 764
				order[11] = 610
				order[12] = 611
				order[13] = 1212
				order[14] = 2146
				order[15] = 2147
				order[16] = 2148
				order[17] = 248
				order[18] = 2149
				order[19] = 2150
				order[20] = 2151
				order[21] = 2152
				order[22] = 2153
				order[23] = 2154
				order[24] = 2155
				order[25] = 2348
				order[26] = 2067
				order[27] = 2068
				order[28] = 2069
				order[29] = 2739
				order[30] = 2070
				order[31] = 2156
				order[32] = 2157
				order[33] = 2158
				order[34] = 2159
				order[35] = 2160
				order[36] = 2161
				order[37] = 2162
				order[38] = 2163
				order[39] = 2164
				order[40] = 2165
				order[41] = 2880
				order[42] = 2166
				order[43] = 2167
				order[44] = 2168
				order[45] = 2169
				order[46] = 2170
				order[47] = 2171
				order[48] = 2172
				order[49] = 2173
				order[50] = 2174
				order[51] = 2175
				order[52] = 2176
				order[53] = 2177
				order[54] = 2178
				order[55] = 2179
				order[56] = 2180
				order[57] = 249
				order[58] = 250
				order[59] = 251
				order[60] = 252
				order[61] = 253
				order[62] = 257
				order[63] = 599
				order[64] = 596
				order[65] = 597
				order[66] = 598
				order[67] = 254
				order[68] = 612
				order[69] = 942
				order[70] = 2908
				order[71] = 2181
				order[72] = 2182
				order[73] = 2183
				order[74] = 2184
				order[75] = 2604
				order[76] = 2185
				order[77] = 2605
				order[78] = 2186
				order[79] = 2187
				order[80] = 2188
				order[81] = 2189
				order[82] = 613
				order[83] = 614
				order[84] = 1436
				order[85] = 2354
				order[86] = 1440
				order[87] = 2190
				order[88] = 2191
				order[89] = 999
				order[90] = 1224
				order[91] = 1720
				order[92] = 2909
				order[93] = 1421
				order[94] = 1422
				order[95] = 1721
				order[96] = 2910
				order[97] = 2192
				order[98] = 1001
				order[99] = 1420
				order[100] = 2193
				order[101] = 2194
				order[102] = 2755
				order[103] = 2195
				order[104] = 2196
				order[105] = 2197
				order[106] = 2198
				order[107] = 1528
				order[108] = 2911
				order[109] = 2199
				order[110] = 2200
				order[111] = 2201
				order[112] = 2202
				order[113] = 2203
				order[114] = 615
				order[115] = 616
				order[116] = 2205
				order[117] = 2206
				order[118] = 617
				order[119] = 618
				order[120] = 619
				order[121] = 2740
				order[122] = 2717
				order[123] = 2718
				order[124] = 2719
				order[125] = 620
				order[126] = 621
				order[127] = 622
				order[128] = 2207
				order[129] = 2208
				order[130] = 623
				order[131] = 624
				order[132] = 556
				order[133] = 2898
				order[134] = 740
				order[135] = 739
				order[136] = 955
				order[137] = 956
				order[138] = 1358
				order[139] = 2682
				order[140] = 2686
				order[141] = 1017
				order[142] = 566
				order[143] = 2209
				order[144] = 2211
				order[145] = 2212
				order[146] = 2213
				order[147] = 2754
				order[148] = 2214
				order[149] = 2215
				order[150] = 2606
				order[151] = 2607
				order[152] = 685
				order[153] = 687
				order[154] = 2346
				order[155] = 690
				order[156] = 587
				order[157] = 588
				order[158] = 683
				order[159] = 539
				order[160] = 676
				order[161] = 2951
				order[162] = 677
				order[163] = 678
				order[164] = 679
				order[165] = 680
				order[166] = 654
				order[167] = 0
				super(555, 600, order)
			end

			class NoLegSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 605
					order[1] = 606
					order[2] = 2958
					order[3] = 0
					super(604, 605, order)
				end
			end

			class NoLegSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2077
					order[1] = 2078
					order[2] = 2079
					order[3] = 2743
					order[4] = 0
					super(2076, 2077, order)
				end
			end

			class NoLegAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2309
					order[1] = 2310
					order[2] = 2311
					order[3] = 0
					super(2308, 2309, order)
				end
			end

			class NoLegEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 2060
					order[1] = 2061
					order[2] = 2062
					order[3] = 2063
					order[4] = 2064
					order[5] = 2341
					order[6] = 2065
					order[7] = 2066
					order[8] = 2074
					order[9] = 2075
					order[10] = 0
					super(2059, 2060, order)
				end
			end

			class NoLegInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 2255
					order[1] = 2256
					order[2] = 2257
					order[3] = 2379
					order[4] = 2258
					order[5] = 0
					super(2254, 2255, order)
				end

				class NoLegInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2259
						order[1] = 2260
						order[2] = 0
						super(2258, 2259, order)
					end
				end
			end

			class NoLegComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2219
					order[1] = 2220
					order[2] = 2221
					order[3] = 2222
					order[4] = 2223
					order[5] = 2224
					order[6] = 2225
					order[7] = 2226
					order[8] = 2944
					order[9] = 2227
					order[10] = 2228
					order[11] = 2229
					order[12] = 2230
					order[13] = 2231
					order[14] = 2232
					order[15] = 2250
					order[16] = 2233
					order[17] = 2945
					order[18] = 2234
					order[19] = 2946
					order[20] = 2235
					order[21] = 2236
					order[22] = 2409
					order[23] = 2410
					order[24] = 2237
					order[25] = 2238
					order[26] = 2239
					order[27] = 2240
					order[28] = 2241
					order[29] = 41382
					order[30] = 41389
					order[31] = 41390
					order[32] = 41391
					order[33] = 41392
					order[34] = 41393
					order[35] = 41394
					order[36] = 41395
					order[37] = 41396
					order[38] = 41397
					order[39] = 41379
					order[40] = 2242
					order[41] = 2243
					order[42] = 2244
					order[43] = 2245
					order[44] = 2246
					order[45] = 41398
					order[46] = 41366
					order[47] = 2608
					order[48] = 2609
					order[49] = 2610
					order[50] = 2248
					order[51] = 2249
					order[52] = 0
					super(2218, 2219, order)
				end

				class NoLegComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2251
						order[1] = 2252
						order[2] = 2253
						order[3] = 0
						super(2250, 2251, order)
					end

					class NoLegComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2204
							order[1] = 2247
							order[2] = 0
							super(2253, 2204, order)
						end
					end
				end

				class NoLegComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41383
						order[1] = 41384
						order[2] = 41385
						order[3] = 41386
						order[4] = 0
						super(41382, 41383, order)
					end
				end

				class NoLegComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41388
						order[1] = 0
						super(41387, 41388, order)
					end
				end

				class NoLegComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41380
						order[1] = 41381
						order[2] = 41400
						order[3] = 41376
						order[4] = 41363
						order[5] = 0
						super(41379, 41380, order)
					end

					class NoLegComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41401
							order[1] = 41402
							order[2] = 41403
							order[3] = 41404
							order[4] = 41405
							order[5] = 0
							super(41400, 41401, order)
						end
					end

					class NoLegComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41377
							order[1] = 41378
							order[2] = 0
							super(41376, 41377, order)
						end
					end

					class NoLegComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41364
							order[1] = 41365
							order[2] = 0
							super(41363, 41364, order)
						end
					end
				end

				class NoLegComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41399
						order[1] = 0
						super(41398, 41399, order)
					end
				end

				class NoLegComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41367
						order[1] = 41368
						order[2] = 41369
						order[3] = 41370
						order[4] = 41371
						order[5] = 41372
						order[6] = 41373
						order[7] = 41374
						order[8] = 0
						super(41366, 41367, order)
					end

					class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41375
							order[1] = 0
							super(41374, 41375, order)
						end
					end
				end
			end

			class NoLegBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40924
					order[1] = 0
					super(40923, 40924, order)
				end
			end

			class NoLegPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41608
					order[1] = 0
					super(41607, 41608, order)
				end
			end

			class NoLegMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41468
					order[1] = 40223
					order[2] = 0
					super(41467, 41468, order)
				end
			end

			class NoLegMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41470
					order[1] = 40990
					order[2] = 0
					super(41469, 41470, order)
				end
			end

			class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41472
					order[1] = 41473
					order[2] = 41474
					order[3] = 41475
					order[4] = 41476
					order[5] = 41477
					order[6] = 41478
					order[7] = 41479
					order[8] = 41480
					order[9] = 0
					super(41471, 41472, order)
				end
			end

			class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42582
					order[1] = 0
					super(42581, 42582, order)
				end
			end

			class NoLegOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41492
					order[1] = 0
					super(41491, 41492, order)
				end
			end

			class NoLegOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41513
					order[1] = 41514
					order[2] = 0
					super(41512, 41513, order)
				end
			end

			class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41516
					order[1] = 0
					super(41515, 41516, order)
				end
			end

			class NoLegOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41528
					order[1] = 41529
					order[2] = 0
					super(41527, 41528, order)
				end
			end

			class NoLegStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40242
					order[1] = 41700
					order[2] = 40243
					order[3] = 42583
					order[4] = 42584
					order[5] = 40244
					order[6] = 40245
					order[7] = 41702
					order[8] = 40246
					order[9] = 40247
					order[10] = 42585
					order[11] = 42586
					order[12] = 41703
					order[13] = 41704
					order[14] = 41705
					order[15] = 41706
					order[16] = 41707
					order[17] = 41708
					order[18] = 41648
					order[19] = 41649
					order[20] = 41650
					order[21] = 41651
					order[22] = 41652
					order[23] = 41653
					order[24] = 41654
					order[25] = 42588
					order[26] = 41655
					order[27] = 41656
					order[28] = 41657
					order[29] = 41658
					order[30] = 41659
					order[31] = 41660
					order[32] = 41661
					order[33] = 41662
					order[34] = 41663
					order[35] = 41664
					order[36] = 41665
					order[37] = 41666
					order[38] = 41667
					order[39] = 41668
					order[40] = 41669
					order[41] = 41670
					order[42] = 41671
					order[43] = 41672
					order[44] = 41673
					order[45] = 40249
					order[46] = 40250
					order[47] = 40252
					order[48] = 40253
					order[49] = 40254
					order[50] = 40255
					order[51] = 40256
					order[52] = 40257
					order[53] = 40258
					order[54] = 40260
					order[55] = 40261
					order[56] = 40262
					order[57] = 40263
					order[58] = 40264
					order[59] = 41641
					order[60] = 41642
					order[61] = 40265
					order[62] = 40267
					order[63] = 40268
					order[64] = 40270
					order[65] = 40271
					order[66] = 40272
					order[67] = 40273
					order[68] = 40274
					order[69] = 40275
					order[70] = 40276
					order[71] = 41643
					order[72] = 41644
					order[73] = 41645
					order[74] = 40279
					order[75] = 40280
					order[76] = 40281
					order[77] = 42399
					order[78] = 40282
					order[79] = 40283
					order[80] = 43108
					order[81] = 40284
					order[82] = 40285
					order[83] = 40286
					order[84] = 40287
					order[85] = 40288
					order[86] = 42400
					order[87] = 42401
					order[88] = 42402
					order[89] = 42403
					order[90] = 40289
					order[91] = 40290
					order[92] = 40291
					order[93] = 41549
					order[94] = 41550
					order[95] = 41551
					order[96] = 41552
					order[97] = 41553
					order[98] = 41554
					order[99] = 41555
					order[100] = 42404
					order[101] = 40374
					order[102] = 40418
					order[103] = 41429
					order[104] = 41430
					order[105] = 41431
					order[106] = 41432
					order[107] = 41433
					order[108] = 42194
					order[109] = 42195
					order[110] = 41434
					order[111] = 41435
					order[112] = 41436
					order[113] = 41437
					order[114] = 41438
					order[115] = 41219
					order[116] = 41439
					order[117] = 41440
					order[118] = 41441
					order[119] = 41442
					order[120] = 41443
					order[121] = 41444
					order[122] = 41445
					order[123] = 41446
					order[124] = 41447
					order[125] = 41448
					order[126] = 41449
					order[127] = 41450
					order[128] = 41451
					order[129] = 43095
					order[130] = 41408
					order[131] = 40248
					order[132] = 40978
					order[133] = 40979
					order[134] = 0
					super(40241, 40242, order)
				end

				class NoLegStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41675
						order[1] = 41676
						order[2] = 0
						super(41674, 41675, order)
					end
				end

				class NoLegStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41453
						order[1] = 41454
						order[2] = 41455
						order[3] = 0
						super(41452, 41453, order)
					end
				end

				class NoLegStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41678
						order[1] = 41679
						order[2] = 0
						super(41677, 41678, order)
					end
				end

				class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41647
						order[1] = 0
						super(41646, 41647, order)
					end
				end

				class NoLegStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41687
						order[1] = 41688
						order[2] = 41689
						order[3] = 41690
						order[4] = 41691
						order[5] = 41692
						order[6] = 41693
						order[7] = 41694
						order[8] = 41695
						order[9] = 41696
						order[10] = 41697
						order[11] = 41680
						order[12] = 41698
						order[13] = 41699
						order[14] = 0
						super(41686, 41687, order)
					end

					class NoLegStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41681
							order[1] = 41682
							order[2] = 41683
							order[3] = 0
							super(41680, 41681, order)
						end

						class NoLegStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41684
								order[1] = 41685
								order[2] = 41935
								order[3] = 0
								super(41683, 41684, order)
							end
						end
					end
				end

				class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40251
						order[1] = 0
						super(40942, 40251, order)
					end
				end

				class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40259
						order[1] = 0
						super(40943, 40259, order)
					end
				end

				class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40266
						order[1] = 0
						super(40940, 40266, order)
					end
				end

				class NoLegStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41639
						order[1] = 41640
						order[2] = 0
						super(41638, 41639, order)
					end
				end

				class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40269
						order[1] = 0
						super(40941, 40269, order)
					end
				end

				class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40293
						order[1] = 0
						super(40930, 40293, order)
					end
				end

				class NoLegPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41590
						order[1] = 41591
						order[2] = 0
						super(41589, 41590, order)
					end
				end

				class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40305
						order[1] = 0
						super(40931, 40305, order)
					end
				end

				class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40311
						order[1] = 0
						super(40932, 40311, order)
					end
				end

				class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40318
						order[1] = 0
						super(40933, 40318, order)
					end
				end

				class NoLegPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42460
						order[1] = 42461
						order[2] = 0
						super(42459, 42460, order)
					end
				end

				class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41562
						order[1] = 0
						super(41561, 41562, order)
					end
				end

				class NoLegPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41597
						order[1] = 41598
						order[2] = 0
						super(41596, 41597, order)
					end
				end

				class NoLegPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41594
						order[1] = 41595
						order[2] = 0
						super(41593, 41594, order)
					end
				end

				class NoLegPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43110
						order[1] = 42486
						order[2] = 42487
						order[3] = 0
						super(42485, 43110, order)
					end
				end

				class NoLegDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42367
						order[1] = 42368
						order[2] = 42369
						order[3] = 42370
						order[4] = 42371
						order[5] = 42372
						order[6] = 42386
						order[7] = 42373
						order[8] = 42374
						order[9] = 42375
						order[10] = 42376
						order[11] = 42377
						order[12] = 42378
						order[13] = 42379
						order[14] = 42380
						order[15] = 42381
						order[16] = 42382
						order[17] = 42383
						order[18] = 42384
						order[19] = 42385
						order[20] = 0
						super(42366, 42367, order)
					end

					class NoLegDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42387
							order[1] = 0
							super(42386, 42387, order)
						end
					end
				end

				class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42365
						order[1] = 0
						super(42364, 42365, order)
					end
				end

				class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42311
						order[1] = 0
						super(42310, 42311, order)
					end
				end

				class NoLegReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 42535
						order[1] = 42536
						order[2] = 42537
						order[3] = 42538
						order[4] = 42539
						order[5] = 42540
						order[6] = 42564
						order[7] = 42530
						order[8] = 42541
						order[9] = 42542
						order[10] = 42543
						order[11] = 42544
						order[12] = 42545
						order[13] = 42546
						order[14] = 42547
						order[15] = 42548
						order[16] = 42549
						order[17] = 42550
						order[18] = 42551
						order[19] = 42552
						order[20] = 42560
						order[21] = 42553
						order[22] = 42554
						order[23] = 42508
						order[24] = 42555
						order[25] = 42556
						order[26] = 42557
						order[27] = 42558
						order[28] = 42559
						order[29] = 0
						super(42534, 42535, order)
					end

					class NoLegReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 42565
							order[1] = 42566
							order[2] = 42567
							order[3] = 42568
							order[4] = 0
							super(42564, 42565, order)
						end
					end

					class NoLegReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42531
							order[1] = 42532
							order[2] = 42533
							order[3] = 0
							super(42530, 42531, order)
						end
					end

					class NoLegReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42561
							order[1] = 42562
							order[2] = 42563
							order[3] = 0
							super(42560, 42561, order)
						end
					end

					class NoLegReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 42509
							order[1] = 42571
							order[2] = 42510
							order[3] = 42511
							order[4] = 42512
							order[5] = 42513
							order[6] = 42514
							order[7] = 42515
							order[8] = 42516
							order[9] = 42517
							order[10] = 42518
							order[11] = 42519
							order[12] = 42520
							order[13] = 42521
							order[14] = 42522
							order[15] = 42523
							order[16] = 42524
							order[17] = 42525
							order[18] = 42526
							order[19] = 42527
							order[20] = 42528
							order[21] = 42529
							order[22] = 42569
							order[23] = 0
							super(42508, 42509, order)
						end

						class NoLegReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 42572
								order[1] = 42573
								order[2] = 0
								super(42571, 42572, order)
							end
						end

						class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 42570
								order[1] = 0
								super(42569, 42570, order)
							end
						end
					end
				end

				class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42420
						order[1] = 0
						super(42419, 42420, order)
					end
				end

				class NoLegPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42406
						order[1] = 42407
						order[2] = 0
						super(42405, 42406, order)
					end
				end

				class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40361
						order[1] = 0
						super(40929, 40361, order)
					end
				end

				class NoLegNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40368
						order[1] = 40369
						order[2] = 0
						super(40367, 40368, order)
					end
				end

				class NoLegSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40903
						order[1] = 40366
						order[2] = 40370
						order[3] = 40905
						order[4] = 40906
						order[5] = 0
						super(40902, 40903, order)
					end
				end

				class NoLegPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40375
						order[1] = 41533
						order[2] = 41534
						order[3] = 40376
						order[4] = 40377
						order[5] = 40378
						order[6] = 40379
						order[7] = 40380
						order[8] = 40381
						order[9] = 40382
						order[10] = 40383
						order[11] = 40384
						order[12] = 40385
						order[13] = 41535
						order[14] = 41536
						order[15] = 41537
						order[16] = 41538
						order[17] = 40386
						order[18] = 40387
						order[19] = 40388
						order[20] = 40389
						order[21] = 41539
						order[22] = 41540
						order[23] = 41541
						order[24] = 41542
						order[25] = 40390
						order[26] = 40391
						order[27] = 40392
						order[28] = 40393
						order[29] = 40394
						order[30] = 40395
						order[31] = 40414
						order[32] = 40396
						order[33] = 40397
						order[34] = 40398
						order[35] = 40399
						order[36] = 40927
						order[37] = 40401
						order[38] = 40402
						order[39] = 40403
						order[40] = 41543
						order[41] = 41544
						order[42] = 40404
						order[43] = 41530
						order[44] = 41545
						order[45] = 41546
						order[46] = 41547
						order[47] = 41548
						order[48] = 40405
						order[49] = 40406
						order[50] = 40407
						order[51] = 40408
						order[52] = 40928
						order[53] = 40410
						order[54] = 40411
						order[55] = 40412
						order[56] = 40413
						order[57] = 0
						super(40374, 40375, order)
					end

					class NoLegPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40415
							order[1] = 40416
							order[2] = 40417
							order[3] = 0
							super(40414, 40415, order)
						end
					end

					class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40400
							order[1] = 0
							super(40927, 40400, order)
						end
					end

					class NoLegPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41531
							order[1] = 41532
							order[2] = 0
							super(41530, 41531, order)
						end
					end

					class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40409
							order[1] = 0
							super(40928, 40409, order)
						end
					end
				end

				class NoLegPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40419
						order[1] = 40420
						order[2] = 42497
						order[3] = 42498
						order[4] = 42499
						order[5] = 42500
						order[6] = 42501
						order[7] = 42502
						order[8] = 42503
						order[9] = 42488
						order[10] = 42489
						order[11] = 42490
						order[12] = 42491
						order[13] = 42492
						order[14] = 42493
						order[15] = 42494
						order[16] = 40421
						order[17] = 40422
						order[18] = 40423
						order[19] = 40424
						order[20] = 40425
						order[21] = 40426
						order[22] = 40427
						order[23] = 40428
						order[24] = 40429
						order[25] = 40430
						order[26] = 40431
						order[27] = 40432
						order[28] = 40433
						order[29] = 40434
						order[30] = 40435
						order[31] = 40436
						order[32] = 40437
						order[33] = 40438
						order[34] = 40439
						order[35] = 40440
						order[36] = 40441
						order[37] = 40442
						order[38] = 40443
						order[39] = 40444
						order[40] = 40445
						order[41] = 40446
						order[42] = 40447
						order[43] = 0
						super(40418, 40419, order)
					end

					class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42505
							order[1] = 0
							super(42504, 42505, order)
						end
					end

					class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42496
							order[1] = 0
							super(42495, 42496, order)
						end
					end
				end

				class NoLegDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41461
						order[1] = 0
						super(41460, 41461, order)
					end
				end

				class NoLegDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41457
						order[1] = 41458
						order[2] = 41459
						order[3] = 0
						super(41456, 41457, order)
					end
				end

				class NoLegDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41409
						order[1] = 41410
						order[2] = 41411
						order[3] = 41412
						order[4] = 41413
						order[5] = 41414
						order[6] = 41415
						order[7] = 41416
						order[8] = 41417
						order[9] = 41418
						order[10] = 41419
						order[11] = 41420
						order[12] = 41421
						order[13] = 41422
						order[14] = 0
						super(41408, 41409, order)
					end

					class NoLegDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41423
							order[1] = 41424
							order[2] = 41425
							order[3] = 0
							super(41422, 41423, order)
						end

						class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41426
								order[1] = 41427
								order[2] = 41428
								order[3] = 0
								super(41425, 41426, order)
							end
						end
					end
				end
			end

			class NoLegProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 40449
					order[1] = 40450
					order[2] = 40451
					order[3] = 40939
					order[4] = 40453
					order[5] = 40454
					order[6] = 40455
					order[7] = 42506
					order[8] = 42507
					order[9] = 40456
					order[10] = 40457
					order[11] = 40458
					order[12] = 40524
					order[13] = 40525
					order[14] = 40526
					order[15] = 40528
					order[16] = 40529
					order[17] = 40530
					order[18] = 40531
					order[19] = 40532
					order[20] = 40476
					order[21] = 40478
					order[22] = 40479
					order[23] = 40480
					order[24] = 40481
					order[25] = 40482
					order[26] = 40483
					order[27] = 40484
					order[28] = 40485
					order[29] = 40486
					order[30] = 40487
					order[31] = 40488
					order[32] = 40489
					order[33] = 40490
					order[34] = 40491
					order[35] = 40492
					order[36] = 40493
					order[37] = 40494
					order[38] = 40498
					order[39] = 40499
					order[40] = 40501
					order[41] = 40502
					order[42] = 40503
					order[43] = 40504
					order[44] = 40505
					order[45] = 40506
					order[46] = 40507
					order[47] = 40508
					order[48] = 40509
					order[49] = 40511
					order[50] = 40512
					order[51] = 40513
					order[52] = 40514
					order[53] = 40515
					order[54] = 40459
					order[55] = 40460
					order[56] = 40461
					order[57] = 40462
					order[58] = 40463
					order[59] = 40464
					order[60] = 40465
					order[61] = 40516
					order[62] = 40518
					order[63] = 40519
					order[64] = 40520
					order[65] = 40521
					order[66] = 40522
					order[67] = 40523
					order[68] = 40466
					order[69] = 40467
					order[70] = 40468
					order[71] = 40469
					order[72] = 40470
					order[73] = 41407
					order[74] = 40472
					order[75] = 40980
					order[76] = 40981
					order[77] = 40533
					order[78] = 0
					super(40448, 40449, order)
				end

				class NoLegProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40452
						order[1] = 0
						super(40939, 40452, order)
					end
				end

				class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40527
						order[1] = 0
						super(40935, 40527, order)
					end
				end

				class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40477
						order[1] = 0
						super(40936, 40477, order)
					end
				end

				class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40496
						order[1] = 40497
						order[2] = 0
						super(40495, 40496, order)
					end
				end

				class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40500
						order[1] = 0
						super(40937, 40500, order)
					end
				end

				class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40510
						order[1] = 0
						super(40938, 40510, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40517
						order[1] = 0
						super(40934, 40517, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40474
						order[1] = 40475
						order[2] = 0
						super(40473, 40474, order)
					end
				end

				class NoLegProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40534
						order[1] = 40535
						order[2] = 40536
						order[3] = 2380
						order[4] = 40537
						order[5] = 0
						super(40533, 40534, order)
					end

					class NoLegProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40538
							order[1] = 40539
							order[2] = 0
							super(40537, 40538, order)
						end
					end
				end
			end

			class NoLegAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41336
					order[1] = 41337
					order[2] = 41316
					order[3] = 0
					super(41335, 41336, order)
				end

				class NoLegAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41317
						order[1] = 41318
						order[2] = 41319
						order[3] = 41320
						order[4] = 41321
						order[5] = 41322
						order[6] = 41323
						order[7] = 41324
						order[8] = 41325
						order[9] = 41326
						order[10] = 41327
						order[11] = 41328
						order[12] = 41329
						order[13] = 41330
						order[14] = 41331
						order[15] = 41332
						order[16] = 41333
						order[17] = 41334
						order[18] = 0
						super(41316, 41317, order)
					end
				end
			end

			class NoLegProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 41618
					order[1] = 41619
					order[2] = 41620
					order[3] = 41621
					order[4] = 41622
					order[5] = 41623
					order[6] = 41624
					order[7] = 41614
					order[8] = 41625
					order[9] = 41635
					order[10] = 41617
					order[11] = 0
					super(41616, 41618, order)
				end

				class NoLegProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41615
						order[1] = 0
						super(41614, 41615, order)
					end
				end

				class NoLegProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41626
						order[1] = 41627
						order[2] = 41628
						order[3] = 41629
						order[4] = 41630
						order[5] = 41631
						order[6] = 41632
						order[7] = 41633
						order[8] = 0
						super(41625, 41626, order)
					end

					class NoLegProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41634
							order[1] = 0
							super(41633, 41634, order)
						end
					end
				end

				class NoLegProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41636
						order[1] = 41637
						order[2] = 0
						super(41635, 41636, order)
					end
				end
			end

			class NoLegCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 41345
					order[1] = 41346
					order[2] = 41347
					order[3] = 41348
					order[4] = 41349
					order[5] = 41350
					order[6] = 41351
					order[7] = 41352
					order[8] = 41353
					order[9] = 41354
					order[10] = 41355
					order[11] = 41342
					order[12] = 42308
					order[13] = 42309
					order[14] = 41356
					order[15] = 41357
					order[16] = 42299
					order[17] = 42300
					order[18] = 42301
					order[19] = 42302
					order[20] = 42303
					order[21] = 42304
					order[22] = 42305
					order[23] = 41358
					order[24] = 41359
					order[25] = 41360
					order[26] = 41361
					order[27] = 41362
					order[28] = 0
					super(41344, 41345, order)
				end

				class NoLegCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41343
						order[1] = 0
						super(41342, 41343, order)
					end
				end

				class NoLegCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42307
						order[1] = 0
						super(42306, 42307, order)
					end
				end
			end

			class NoLegPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41604
					order[1] = 41601
					order[2] = 41602
					order[3] = 41603
					order[4] = 41600
					order[5] = 0
					super(41599, 41604, order)
				end

				class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41605
						order[1] = 41606
						order[2] = 0
						super(41604, 41605, order)
					end
				end
			end

			class NoLegExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42389
					order[1] = 42390
					order[2] = 0
					super(42388, 42389, order)
				end
			end

			class NoLegStipulations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 688
					order[1] = 689
					order[2] = 0
					super(683, 688, order)
				end
			end

			class NoNestedPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 524
					order[1] = 525
					order[2] = 538
					order[3] = 2384
					order[4] = 804
					order[5] = 0
					super(539, 524, order)
				end

				class NoNestedPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 545
						order[1] = 805
						order[2] = 0
						super(804, 545, order)
					end
				end
			end
		end

		class NoQuoteQualifiers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 695
				order[1] = 0
				super(735, 695, order)
			end
		end

		class NoPriceQualifiers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 2710
				order[1] = 0
				super(2709, 2710, order)
			end
		end

		class NoPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 448
				order[1] = 447
				order[2] = 452
				order[3] = 2376
				order[4] = 802
				order[5] = 0
				super(453, 448, order)
			end

			class NoPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 523
					order[1] = 803
					order[2] = 0
					super(802, 523, order)
				end
			end
		end
	end
end

class RFQRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AH") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoRelatedSym < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(162)
			order[0] = 55
			order[1] = 65
			order[2] = 48
			order[3] = 22
			order[4] = 460
			order[5] = 1227
			order[6] = 1151
			order[7] = 461
			order[8] = 2891
			order[9] = 167
			order[10] = 762
			order[11] = 200
			order[12] = 541
			order[13] = 1079
			order[14] = 966
			order[15] = 1049
			order[16] = 965
			order[17] = 224
			order[18] = 1449
			order[19] = 1450
			order[20] = 1451
			order[21] = 1452
			order[22] = 1457
			order[23] = 1458
			order[24] = 1739
			order[25] = 2210
			order[26] = 1938
			order[27] = 1939
			order[28] = 1940
			order[29] = 2735
			order[30] = 1941
			order[31] = 1575
			order[32] = 1942
			order[33] = 1943
			order[34] = 1944
			order[35] = 1945
			order[36] = 1946
			order[37] = 1947
			order[38] = 1948
			order[39] = 1949
			order[40] = 1950
			order[41] = 2879
			order[42] = 1951
			order[43] = 1952
			order[44] = 1953
			order[45] = 1954
			order[46] = 1955
			order[47] = 1956
			order[48] = 1957
			order[49] = 1958
			order[50] = 1959
			order[51] = 1960
			order[52] = 1577
			order[53] = 1580
			order[54] = 1581
			order[55] = 1678
			order[56] = 1697
			order[57] = 225
			order[58] = 239
			order[59] = 226
			order[60] = 227
			order[61] = 228
			order[62] = 255
			order[63] = 543
			order[64] = 470
			order[65] = 471
			order[66] = 472
			order[67] = 240
			order[68] = 202
			order[69] = 2578
			order[70] = 2577
			order[71] = 947
			order[72] = 2904
			order[73] = 967
			order[74] = 968
			order[75] = 1698
			order[76] = 1866
			order[77] = 2600
			order[78] = 2001
			order[79] = 2601
			order[80] = 1478
			order[81] = 1479
			order[82] = 1480
			order[83] = 1481
			order[84] = 206
			order[85] = 231
			order[86] = 1435
			order[87] = 2353
			order[88] = 1439
			order[89] = 969
			order[90] = 1146
			order[91] = 996
			order[92] = 1147
			order[93] = 1716
			order[94] = 2905
			order[95] = 1191
			order[96] = 1192
			order[97] = 1717
			order[98] = 2906
			order[99] = 1193
			order[100] = 2579
			order[101] = 1194
			order[102] = 1482
			order[103] = 1195
			order[104] = 2753
			order[105] = 1196
			order[106] = 1197
			order[107] = 2002
			order[108] = 2140
			order[109] = 1524
			order[110] = 2907
			order[111] = 1198
			order[112] = 1199
			order[113] = 1200
			order[114] = 201
			order[115] = 2681
			order[116] = 2685
			order[117] = 1244
			order[118] = 1242
			order[119] = 2575
			order[120] = 2574
			order[121] = 997
			order[122] = 223
			order[123] = 207
			order[124] = 970
			order[125] = 971
			order[126] = 106
			order[127] = 348
			order[128] = 349
			order[129] = 2737
			order[130] = 2714
			order[131] = 2715
			order[132] = 2716
			order[133] = 107
			order[134] = 350
			order[135] = 351
			order[136] = 691
			order[137] = 667
			order[138] = 875
			order[139] = 876
			order[140] = 873
			order[141] = 874
			order[142] = 1687
			order[143] = 1787
			order[144] = 2141
			order[145] = 2142
			order[146] = 2143
			order[147] = 2752
			order[148] = 2144
			order[149] = 2145
			order[150] = 2576
			order[151] = 2962
			order[152] = 2602
			order[153] = 2603
			order[154] = 711
			order[155] = 555
			order[156] = 140
			order[157] = 303
			order[158] = 537
			order[159] = 336
			order[160] = 625
			order[161] = 0
			super(146, 55, order)
		end

		class NoSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 455
				order[1] = 456
				order[2] = 2957
				order[3] = 0
				super(454, 455, order)
			end
		end

		class NoSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1977
				order[1] = 1978
				order[2] = 1979
				order[3] = 2741
				order[4] = 0
				super(1976, 1977, order)
			end
		end

		class NoAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2305
				order[1] = 2306
				order[2] = 2307
				order[3] = 0
				super(2304, 2305, order)
			end
		end

		class NoEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 865
				order[1] = 866
				order[2] = 1145
				order[3] = 1827
				order[4] = 1826
				order[5] = 2340
				order[6] = 867
				order[7] = 868
				order[8] = 1578
				order[9] = 1579
				order[10] = 0
				super(864, 865, order)
			end
		end

		class NoInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1019
				order[1] = 1050
				order[2] = 1051
				order[3] = 2378
				order[4] = 1052
				order[5] = 0
				super(1018, 1019, order)
			end

			class NoInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1053
					order[1] = 1054
					order[2] = 0
					super(1052, 1053, order)
				end
			end
		end

		class NoComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 1484
				order[1] = 2117
				order[2] = 2118
				order[3] = 2119
				order[4] = 1485
				order[5] = 2120
				order[6] = 2121
				order[7] = 2122
				order[8] = 2941
				order[9] = 1486
				order[10] = 2123
				order[11] = 1487
				order[12] = 1488
				order[13] = 1489
				order[14] = 1490
				order[15] = 1491
				order[16] = 2124
				order[17] = 2942
				order[18] = 2125
				order[19] = 2943
				order[20] = 2126
				order[21] = 2127
				order[22] = 2407
				order[23] = 2408
				order[24] = 2128
				order[25] = 2129
				order[26] = 2130
				order[27] = 2131
				order[28] = 2132
				order[29] = 41013
				order[30] = 41020
				order[31] = 41021
				order[32] = 41022
				order[33] = 41023
				order[34] = 41024
				order[35] = 41025
				order[36] = 41026
				order[37] = 41027
				order[38] = 41028
				order[39] = 41010
				order[40] = 2133
				order[41] = 2134
				order[42] = 2135
				order[43] = 2136
				order[44] = 2137
				order[45] = 41029
				order[46] = 40997
				order[47] = 2597
				order[48] = 2598
				order[49] = 2599
				order[50] = 2138
				order[51] = 2139
				order[52] = 0
				super(1483, 1484, order)
			end

			class NoComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1492
					order[1] = 1493
					order[2] = 1494
					order[3] = 0
					super(1491, 1492, order)
				end

				class NoComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1495
						order[1] = 1496
						order[2] = 0
						super(1494, 1495, order)
					end
				end
			end

			class NoComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41014
					order[1] = 41015
					order[2] = 41016
					order[3] = 41017
					order[4] = 0
					super(41013, 41014, order)
				end
			end

			class NoComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41019
					order[1] = 0
					super(41018, 41019, order)
				end
			end

			class NoComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41011
					order[1] = 41012
					order[2] = 41031
					order[3] = 41007
					order[4] = 40994
					order[5] = 0
					super(41010, 41011, order)
				end

				class NoComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41032
						order[1] = 41033
						order[2] = 41034
						order[3] = 41035
						order[4] = 41036
						order[5] = 0
						super(41031, 41032, order)
					end
				end

				class NoComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41008
						order[1] = 41009
						order[2] = 0
						super(41007, 41008, order)
					end
				end

				class NoComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40995
						order[1] = 40996
						order[2] = 0
						super(40994, 40995, order)
					end
				end
			end

			class NoComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41030
					order[1] = 0
					super(41029, 41030, order)
				end
			end

			class NoComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40998
					order[1] = 40999
					order[2] = 41000
					order[3] = 41001
					order[4] = 41002
					order[5] = 41003
					order[6] = 41004
					order[7] = 41005
					order[8] = 0
					super(40997, 40998, order)
				end

				class NoComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41006
						order[1] = 0
						super(41005, 41006, order)
					end
				end
			end
		end

		class NoBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40471
				order[1] = 0
				super(40278, 40471, order)
			end
		end

		class NoPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41231
				order[1] = 0
				super(41230, 41231, order)
			end
		end

		class NoMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41093
				order[1] = 40991
				order[2] = 0
				super(41092, 41093, order)
			end
		end

		class NoMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41095
				order[1] = 40992
				order[2] = 0
				super(41094, 41095, order)
			end
		end

		class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41097
				order[1] = 41098
				order[2] = 41099
				order[3] = 41100
				order[4] = 41101
				order[5] = 41102
				order[6] = 41103
				order[7] = 41104
				order[8] = 41105
				order[9] = 0
				super(41096, 41097, order)
			end
		end

		class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42776
				order[1] = 0
				super(42775, 42776, order)
			end
		end

		class NoOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41117
				order[1] = 0
				super(41116, 41117, order)
			end
		end

		class NoOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41138
				order[1] = 41139
				order[2] = 0
				super(41137, 41138, order)
			end
		end

		class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41141
				order[1] = 0
				super(41140, 41141, order)
			end
		end

		class NoOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41153
				order[1] = 41154
				order[2] = 0
				super(41152, 41153, order)
			end
		end

		class NoStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40050
				order[1] = 41303
				order[2] = 40051
				order[3] = 42784
				order[4] = 42785
				order[5] = 40052
				order[6] = 40053
				order[7] = 41305
				order[8] = 40054
				order[9] = 40055
				order[10] = 42786
				order[11] = 42787
				order[12] = 41306
				order[13] = 41307
				order[14] = 41308
				order[15] = 41309
				order[16] = 41310
				order[17] = 41311
				order[18] = 41251
				order[19] = 41252
				order[20] = 41253
				order[21] = 41254
				order[22] = 41255
				order[23] = 41256
				order[24] = 41257
				order[25] = 42587
				order[26] = 41258
				order[27] = 41259
				order[28] = 41260
				order[29] = 41261
				order[30] = 41262
				order[31] = 41263
				order[32] = 41264
				order[33] = 41265
				order[34] = 41266
				order[35] = 41267
				order[36] = 41268
				order[37] = 41269
				order[38] = 41270
				order[39] = 41271
				order[40] = 41272
				order[41] = 41273
				order[42] = 41274
				order[43] = 41275
				order[44] = 41276
				order[45] = 40907
				order[46] = 40908
				order[47] = 40910
				order[48] = 40911
				order[49] = 40912
				order[50] = 40913
				order[51] = 40914
				order[52] = 40065
				order[53] = 40066
				order[54] = 40068
				order[55] = 40069
				order[56] = 40070
				order[57] = 40071
				order[58] = 40072
				order[59] = 41244
				order[60] = 41245
				order[61] = 40073
				order[62] = 40075
				order[63] = 40076
				order[64] = 40078
				order[65] = 40079
				order[66] = 40080
				order[67] = 40081
				order[68] = 40082
				order[69] = 40083
				order[70] = 40084
				order[71] = 41246
				order[72] = 41247
				order[73] = 41248
				order[74] = 40738
				order[75] = 40739
				order[76] = 40740
				order[77] = 42600
				order[78] = 40741
				order[79] = 40742
				order[80] = 43106
				order[81] = 40743
				order[82] = 40744
				order[83] = 40745
				order[84] = 40746
				order[85] = 40747
				order[86] = 42601
				order[87] = 42602
				order[88] = 42603
				order[89] = 42604
				order[90] = 40748
				order[91] = 40749
				order[92] = 40750
				order[93] = 41180
				order[94] = 41181
				order[95] = 41182
				order[96] = 41183
				order[97] = 41184
				order[98] = 41185
				order[99] = 41186
				order[100] = 42605
				order[101] = 40828
				order[102] = 40872
				order[103] = 41058
				order[104] = 41059
				order[105] = 41060
				order[106] = 41061
				order[107] = 41062
				order[108] = 42192
				order[109] = 42193
				order[110] = 41063
				order[111] = 41064
				order[112] = 41065
				order[113] = 41066
				order[114] = 41067
				order[115] = 41218
				order[116] = 41068
				order[117] = 41069
				order[118] = 41070
				order[119] = 41071
				order[120] = 41072
				order[121] = 41073
				order[122] = 41074
				order[123] = 41075
				order[124] = 41076
				order[125] = 41077
				order[126] = 41078
				order[127] = 41079
				order[128] = 41080
				order[129] = 43094
				order[130] = 41037
				order[131] = 40056
				order[132] = 40982
				order[133] = 40983
				order[134] = 0
				super(40049, 40050, order)
			end

			class NoStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41278
					order[1] = 41279
					order[2] = 0
					super(41277, 41278, order)
				end
			end

			class NoStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41238
					order[1] = 41239
					order[2] = 41240
					order[3] = 0
					super(41237, 41238, order)
				end
			end

			class NoStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41281
					order[1] = 41282
					order[2] = 0
					super(41280, 41281, order)
				end
			end

			class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41250
					order[1] = 0
					super(41249, 41250, order)
				end
			end

			class NoStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41290
					order[1] = 41291
					order[2] = 41292
					order[3] = 41293
					order[4] = 41294
					order[5] = 41295
					order[6] = 41296
					order[7] = 41297
					order[8] = 41298
					order[9] = 41299
					order[10] = 41300
					order[11] = 41283
					order[12] = 41301
					order[13] = 41302
					order[14] = 0
					super(41289, 41290, order)
				end

				class NoStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41284
						order[1] = 41285
						order[2] = 41286
						order[3] = 0
						super(41283, 41284, order)
					end

					class NoStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41287
							order[1] = 41288
							order[2] = 41588
							order[3] = 0
							super(41286, 41287, order)
						end
					end
				end
			end

			class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40909
					order[1] = 0
					super(40960, 40909, order)
				end
			end

			class NoStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40067
					order[1] = 0
					super(40961, 40067, order)
				end
			end

			class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40074
					order[1] = 0
					super(40958, 40074, order)
				end
			end

			class NoStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41242
					order[1] = 41243
					order[2] = 0
					super(41241, 41242, order)
				end
			end

			class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40077
					order[1] = 0
					super(40959, 40077, order)
				end
			end

			class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40752
					order[1] = 0
					super(40947, 40752, order)
				end
			end

			class NoPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41221
					order[1] = 41222
					order[2] = 0
					super(41220, 41221, order)
				end
			end

			class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40763
					order[1] = 0
					super(40948, 40763, order)
				end
			end

			class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40769
					order[1] = 0
					super(40949, 40769, order)
				end
			end

			class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40776
					order[1] = 0
					super(40950, 40776, order)
				end
			end

			class NoPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42661
					order[1] = 42662
					order[2] = 0
					super(42660, 42661, order)
				end
			end

			class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41193
					order[1] = 0
					super(41192, 41193, order)
				end
			end

			class NoPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41228
					order[1] = 41229
					order[2] = 0
					super(41227, 41228, order)
				end
			end

			class NoPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41225
					order[1] = 41226
					order[2] = 0
					super(41224, 41225, order)
				end
			end

			class NoPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43109
					order[1] = 42684
					order[2] = 42685
					order[3] = 0
					super(42683, 43109, order)
				end
			end

			class NoDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42275
					order[1] = 42276
					order[2] = 42277
					order[3] = 42278
					order[4] = 42279
					order[5] = 42280
					order[6] = 42294
					order[7] = 42281
					order[8] = 42282
					order[9] = 42283
					order[10] = 42284
					order[11] = 42285
					order[12] = 42286
					order[13] = 42287
					order[14] = 42288
					order[15] = 42289
					order[16] = 42290
					order[17] = 42291
					order[18] = 42292
					order[19] = 42293
					order[20] = 0
					super(42274, 42275, order)
				end

				class NoDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42295
						order[1] = 0
						super(42294, 42295, order)
					end
				end
			end

			class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42273
					order[1] = 0
					super(42272, 42273, order)
				end
			end

			class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42237
					order[1] = 0
					super(42236, 42237, order)
				end
			end

			class NoReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42736
					order[1] = 42737
					order[2] = 42738
					order[3] = 42739
					order[4] = 42740
					order[5] = 42741
					order[6] = 42765
					order[7] = 42731
					order[8] = 42742
					order[9] = 42743
					order[10] = 42744
					order[11] = 42745
					order[12] = 42746
					order[13] = 42747
					order[14] = 42748
					order[15] = 42749
					order[16] = 42750
					order[17] = 42751
					order[18] = 42752
					order[19] = 42753
					order[20] = 42761
					order[21] = 42754
					order[22] = 42755
					order[23] = 42709
					order[24] = 42756
					order[25] = 42757
					order[26] = 42758
					order[27] = 42759
					order[28] = 42760
					order[29] = 0
					super(42735, 42736, order)
				end

				class NoReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42766
						order[1] = 42767
						order[2] = 42768
						order[3] = 42769
						order[4] = 0
						super(42765, 42766, order)
					end
				end

				class NoReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42732
						order[1] = 42733
						order[2] = 42734
						order[3] = 0
						super(42731, 42732, order)
					end
				end

				class NoReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42762
						order[1] = 42763
						order[2] = 42764
						order[3] = 0
						super(42761, 42762, order)
					end
				end

				class NoReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42710
						order[1] = 42772
						order[2] = 42711
						order[3] = 42712
						order[4] = 42713
						order[5] = 42714
						order[6] = 42715
						order[7] = 42716
						order[8] = 42717
						order[9] = 42718
						order[10] = 42719
						order[11] = 42720
						order[12] = 42721
						order[13] = 42722
						order[14] = 42723
						order[15] = 42724
						order[16] = 42725
						order[17] = 42726
						order[18] = 42727
						order[19] = 42728
						order[20] = 42729
						order[21] = 42730
						order[22] = 42770
						order[23] = 0
						super(42709, 42710, order)
					end

					class NoReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42773
							order[1] = 42774
							order[2] = 0
							super(42772, 42773, order)
						end
					end

					class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42771
							order[1] = 0
							super(42770, 42771, order)
						end
					end
				end
			end

			class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42621
					order[1] = 0
					super(42620, 42621, order)
				end
			end

			class NoPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42607
					order[1] = 42608
					order[2] = 0
					super(42606, 42607, order)
				end
			end

			class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40819
					order[1] = 0
					super(40946, 40819, order)
				end
			end

			class NoNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40826
					order[1] = 40827
					order[2] = 0
					super(40825, 40826, order)
				end
			end

			class NoSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40086
					order[1] = 40373
					order[2] = 40655
					order[3] = 40088
					order[4] = 40089
					order[5] = 0
					super(40085, 40086, order)
				end
			end

			class NoPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40829
					order[1] = 41164
					order[2] = 41165
					order[3] = 40830
					order[4] = 40831
					order[5] = 40832
					order[6] = 40833
					order[7] = 40834
					order[8] = 40835
					order[9] = 40836
					order[10] = 40837
					order[11] = 40838
					order[12] = 40839
					order[13] = 41166
					order[14] = 41167
					order[15] = 41168
					order[16] = 41169
					order[17] = 40840
					order[18] = 40841
					order[19] = 40842
					order[20] = 40843
					order[21] = 41170
					order[22] = 41171
					order[23] = 41172
					order[24] = 41173
					order[25] = 40844
					order[26] = 40845
					order[27] = 40846
					order[28] = 40847
					order[29] = 40848
					order[30] = 40849
					order[31] = 40868
					order[32] = 40850
					order[33] = 40851
					order[34] = 40852
					order[35] = 40853
					order[36] = 40977
					order[37] = 40855
					order[38] = 40856
					order[39] = 40857
					order[40] = 41174
					order[41] = 41175
					order[42] = 40858
					order[43] = 41161
					order[44] = 41176
					order[45] = 41177
					order[46] = 41178
					order[47] = 41179
					order[48] = 40859
					order[49] = 40860
					order[50] = 40861
					order[51] = 40862
					order[52] = 40945
					order[53] = 40864
					order[54] = 40865
					order[55] = 40866
					order[56] = 40867
					order[57] = 0
					super(40828, 40829, order)
				end

				class NoPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40869
						order[1] = 40870
						order[2] = 40871
						order[3] = 0
						super(40868, 40869, order)
					end
				end

				class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40854
						order[1] = 0
						super(40977, 40854, order)
					end
				end

				class NoPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41162
						order[1] = 41163
						order[2] = 0
						super(41161, 41162, order)
					end
				end

				class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40863
						order[1] = 0
						super(40945, 40863, order)
					end
				end
			end

			class NoPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40873
					order[1] = 40874
					order[2] = 42698
					order[3] = 42699
					order[4] = 42700
					order[5] = 42701
					order[6] = 42702
					order[7] = 42703
					order[8] = 42704
					order[9] = 42689
					order[10] = 42690
					order[11] = 42691
					order[12] = 42692
					order[13] = 42693
					order[14] = 42694
					order[15] = 42695
					order[16] = 40875
					order[17] = 40876
					order[18] = 40877
					order[19] = 40878
					order[20] = 40879
					order[21] = 40880
					order[22] = 40881
					order[23] = 40882
					order[24] = 40883
					order[25] = 40884
					order[26] = 40885
					order[27] = 40886
					order[28] = 40887
					order[29] = 40888
					order[30] = 40889
					order[31] = 40890
					order[32] = 40891
					order[33] = 40892
					order[34] = 40893
					order[35] = 40894
					order[36] = 40895
					order[37] = 40896
					order[38] = 40897
					order[39] = 40898
					order[40] = 40899
					order[41] = 40900
					order[42] = 40901
					order[43] = 0
					super(40872, 40873, order)
				end

				class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42706
						order[1] = 0
						super(42705, 42706, order)
					end
				end

				class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42697
						order[1] = 0
						super(42696, 42697, order)
					end
				end
			end

			class NoDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41086
					order[1] = 0
					super(41085, 41086, order)
				end
			end

			class NoDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41082
					order[1] = 41083
					order[2] = 41084
					order[3] = 0
					super(41081, 41082, order)
				end
			end

			class NoDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41038
					order[1] = 41039
					order[2] = 41040
					order[3] = 41041
					order[4] = 41042
					order[5] = 41043
					order[6] = 41044
					order[7] = 41045
					order[8] = 41046
					order[9] = 41047
					order[10] = 41048
					order[11] = 41049
					order[12] = 41050
					order[13] = 41051
					order[14] = 0
					super(41037, 41038, order)
				end

				class NoDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41052
						order[1] = 41053
						order[2] = 41054
						order[3] = 0
						super(41051, 41052, order)
					end

					class NoDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41055
							order[1] = 41056
							order[2] = 41057
							order[3] = 0
							super(41054, 41055, order)
						end
					end
				end
			end
		end

		class NoProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40091
				order[1] = 40092
				order[2] = 40093
				order[3] = 40957
				order[4] = 40095
				order[5] = 40096
				order[6] = 40097
				order[7] = 42707
				order[8] = 42708
				order[9] = 40098
				order[10] = 40099
				order[11] = 40100
				order[12] = 40114
				order[13] = 40115
				order[14] = 40116
				order[15] = 40118
				order[16] = 40119
				order[17] = 40120
				order[18] = 40121
				order[19] = 40122
				order[20] = 40123
				order[21] = 40125
				order[22] = 40126
				order[23] = 40127
				order[24] = 40128
				order[25] = 40129
				order[26] = 40130
				order[27] = 40131
				order[28] = 40132
				order[29] = 40133
				order[30] = 40134
				order[31] = 40135
				order[32] = 40136
				order[33] = 40137
				order[34] = 40138
				order[35] = 40139
				order[36] = 40140
				order[37] = 40141
				order[38] = 40145
				order[39] = 40146
				order[40] = 40148
				order[41] = 40149
				order[42] = 40150
				order[43] = 40151
				order[44] = 40152
				order[45] = 40153
				order[46] = 40154
				order[47] = 40155
				order[48] = 40156
				order[49] = 40158
				order[50] = 40159
				order[51] = 40160
				order[52] = 40161
				order[53] = 40162
				order[54] = 40101
				order[55] = 40102
				order[56] = 40103
				order[57] = 40104
				order[58] = 40105
				order[59] = 40106
				order[60] = 40107
				order[61] = 40163
				order[62] = 40165
				order[63] = 40166
				order[64] = 40167
				order[65] = 40168
				order[66] = 40169
				order[67] = 40170
				order[68] = 40108
				order[69] = 40109
				order[70] = 40110
				order[71] = 40111
				order[72] = 40112
				order[73] = 41406
				order[74] = 40113
				order[75] = 40986
				order[76] = 40987
				order[77] = 40174
				order[78] = 0
				super(40090, 40091, order)
			end

			class NoProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40094
					order[1] = 0
					super(40957, 40094, order)
				end
			end

			class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40117
					order[1] = 0
					super(40953, 40117, order)
				end
			end

			class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40124
					order[1] = 0
					super(40954, 40124, order)
				end
			end

			class NoProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40143
					order[1] = 40144
					order[2] = 0
					super(40142, 40143, order)
				end
			end

			class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40147
					order[1] = 0
					super(40955, 40147, order)
				end
			end

			class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40157
					order[1] = 0
					super(40956, 40157, order)
				end
			end

			class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40164
					order[1] = 0
					super(40952, 40164, order)
				end
			end

			class NoProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40172
					order[1] = 40173
					order[2] = 0
					super(40171, 40172, order)
				end
			end

			class NoProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40175
					order[1] = 40176
					order[2] = 40177
					order[3] = 2385
					order[4] = 40178
					order[5] = 0
					super(40174, 40175, order)
				end

				class NoProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40179
						order[1] = 40180
						order[2] = 0
						super(40178, 40179, order)
					end
				end
			end
		end

		class NoAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40020
				order[1] = 40021
				order[2] = 40000
				order[3] = 0
				super(40019, 40020, order)
			end

			class NoAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 40001
					order[1] = 40002
					order[2] = 40003
					order[3] = 40004
					order[4] = 40005
					order[5] = 40006
					order[6] = 40007
					order[7] = 40008
					order[8] = 40009
					order[9] = 40010
					order[10] = 40011
					order[11] = 40012
					order[12] = 40013
					order[13] = 40014
					order[14] = 40015
					order[15] = 40016
					order[16] = 40017
					order[17] = 40018
					order[18] = 0
					super(40000, 40001, order)
				end
			end
		end

		class NoProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 40182
				order[1] = 40183
				order[2] = 40184
				order[3] = 40185
				order[4] = 40186
				order[5] = 40187
				order[6] = 40188
				order[7] = 40951
				order[8] = 40191
				order[9] = 40201
				order[10] = 40190
				order[11] = 0
				super(40181, 40182, order)
			end

			class NoProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40189
					order[1] = 0
					super(40951, 40189, order)
				end
			end

			class NoProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40192
					order[1] = 40193
					order[2] = 40194
					order[3] = 40195
					order[4] = 40196
					order[5] = 40197
					order[6] = 40198
					order[7] = 40199
					order[8] = 0
					super(40191, 40192, order)
				end

				class NoProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40200
						order[1] = 0
						super(40199, 40200, order)
					end
				end
			end

			class NoProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40202
					order[1] = 40203
					order[2] = 0
					super(40201, 40202, order)
				end
			end
		end

		class NoCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 40023
				order[1] = 40024
				order[2] = 40916
				order[3] = 40917
				order[4] = 40025
				order[5] = 40026
				order[6] = 40027
				order[7] = 40028
				order[8] = 40029
				order[9] = 40030
				order[10] = 40031
				order[11] = 40277
				order[12] = 42216
				order[13] = 42217
				order[14] = 40033
				order[15] = 40034
				order[16] = 42207
				order[17] = 42208
				order[18] = 42209
				order[19] = 42210
				order[20] = 42211
				order[21] = 42212
				order[22] = 42213
				order[23] = 40035
				order[24] = 40036
				order[25] = 40037
				order[26] = 40038
				order[27] = 40039
				order[28] = 0
				super(40022, 40023, order)
			end

			class NoCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40032
					order[1] = 0
					super(40277, 40032, order)
				end
			end

			class NoCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42215
					order[1] = 0
					super(42214, 42215, order)
				end
			end
		end

		class NoPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40209
				order[1] = 40205
				order[2] = 40206
				order[3] = 40207
				order[4] = 40208
				order[5] = 0
				super(40204, 40209, order)
			end

			class NoPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40210
					order[1] = 40211
					order[2] = 0
					super(40209, 40210, order)
				end
			end
		end

		class NoExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42297
				order[1] = 42298
				order[2] = 0
				super(42296, 42297, order)
			end
		end

		class NoUnderlyings < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(188)
				order[0] = 311
				order[1] = 312
				order[2] = 309
				order[3] = 305
				order[4] = 2874
				order[5] = 462
				order[6] = 463
				order[7] = 2894
				order[8] = 310
				order[9] = 763
				order[10] = 313
				order[11] = 542
				order[12] = 1213
				order[13] = 1837
				order[14] = 241
				order[15] = 1453
				order[16] = 1454
				order[17] = 2614
				order[18] = 2615
				order[19] = 2921
				order[20] = 2616
				order[21] = 2617
				order[22] = 2619
				order[23] = 1455
				order[24] = 1456
				order[25] = 1459
				order[26] = 1460
				order[27] = 242
				order[28] = 243
				order[29] = 244
				order[30] = 245
				order[31] = 246
				order[32] = 256
				order[33] = 595
				order[34] = 592
				order[35] = 593
				order[36] = 594
				order[37] = 247
				order[38] = 316
				order[39] = 941
				order[40] = 2917
				order[41] = 317
				order[42] = 436
				order[43] = 1437
				order[44] = 2363
				order[45] = 1441
				order[46] = 998
				order[47] = 1423
				order[48] = 1718
				order[49] = 2918
				order[50] = 1424
				order[51] = 1425
				order[52] = 1719
				order[53] = 2919
				order[54] = 1000
				order[55] = 1419
				order[56] = 1526
				order[57] = 2920
				order[58] = 435
				order[59] = 308
				order[60] = 306
				order[61] = 362
				order[62] = 363
				order[63] = 2742
				order[64] = 2720
				order[65] = 2721
				order[66] = 2722
				order[67] = 2723
				order[68] = 2724
				order[69] = 307
				order[70] = 364
				order[71] = 365
				order[72] = 877
				order[73] = 878
				order[74] = 972
				order[75] = 318
				order[76] = 2916
				order[77] = 879
				order[78] = 975
				order[79] = 973
				order[80] = 974
				order[81] = 810
				order[82] = 882
				order[83] = 883
				order[84] = 884
				order[85] = 885
				order[86] = 886
				order[87] = 2885
				order[88] = 2886
				order[89] = 1044
				order[90] = 1045
				order[91] = 1046
				order[92] = 1038
				order[93] = 1039
				order[94] = 315
				order[95] = 2683
				order[96] = 2687
				order[97] = 1988
				order[98] = 1989
				order[99] = 1990
				order[100] = 1991
				order[101] = 1992
				order[102] = 1993
				order[103] = 2881
				order[104] = 1994
				order[105] = 1995
				order[106] = 1996
				order[107] = 1997
				order[108] = 2620
				order[109] = 2621
				order[110] = 1998
				order[111] = 1999
				order[112] = 2000
				order[113] = 2003
				order[114] = 2004
				order[115] = 2005
				order[116] = 2006
				order[117] = 2284
				order[118] = 2285
				order[119] = 2286
				order[120] = 2287
				order[121] = 2288
				order[122] = 2007
				order[123] = 2008
				order[124] = 2009
				order[125] = 2010
				order[126] = 2011
				order[127] = 2012
				order[128] = 2491
				order[129] = 2013
				order[130] = 2014
				order[131] = 2015
				order[132] = 2744
				order[133] = 2016
				order[134] = 2289
				order[135] = 2017
				order[136] = 2018
				order[137] = 2019
				order[138] = 2020
				order[139] = 2021
				order[140] = 2022
				order[141] = 2290
				order[142] = 2622
				order[143] = 2291
				order[144] = 2623
				order[145] = 2292
				order[146] = 2023
				order[147] = 2024
				order[148] = 2025
				order[149] = 2026
				order[150] = 2027
				order[151] = 2028
				order[152] = 2029
				order[153] = 2757
				order[154] = 2030
				order[155] = 2031
				order[156] = 2293
				order[157] = 2294
				order[158] = 2032
				order[159] = 2033
				order[160] = 2034
				order[161] = 2035
				order[162] = 2036
				order[163] = 2037
				order[164] = 2038
				order[165] = 2039
				order[166] = 2040
				order[167] = 2041
				order[168] = 2042
				order[169] = 2043
				order[170] = 2044
				order[171] = 41314
				order[172] = 41315
				order[173] = 2295
				order[174] = 2296
				order[175] = 2297
				order[176] = 2756
				order[177] = 2298
				order[178] = 2299
				order[179] = 2624
				order[180] = 2625
				order[181] = 2626
				order[182] = 2627
				order[183] = 2628
				order[184] = 2629
				order[185] = 2630
				order[186] = 2631
				order[187] = 0
				super(711, 311, order)
			end

			class NoUnderlyingSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 458
					order[1] = 459
					order[2] = 2959
					order[3] = 0
					super(457, 458, order)
				end
			end

			class NoUnderlyingStips < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 888
					order[1] = 889
					order[2] = 0
					super(887, 888, order)
				end
			end

			class NoUndlyInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 1059
					order[1] = 1060
					order[2] = 1061
					order[3] = 2391
					order[4] = 1062
					order[5] = 0
					super(1058, 1059, order)
				end

				class NoUndlyInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1063
						order[1] = 1064
						order[2] = 0
						super(1062, 1063, order)
					end
				end
			end

			class NoUnderlyingEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 1982
					order[1] = 1983
					order[2] = 1984
					order[3] = 1985
					order[4] = 1986
					order[5] = 2342
					order[6] = 1987
					order[7] = 2071
					order[8] = 2072
					order[9] = 2073
					order[10] = 0
					super(1981, 1982, order)
				end
			end

			class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2081
					order[1] = 2082
					order[2] = 2083
					order[3] = 2745
					order[4] = 0
					super(2080, 2081, order)
				end
			end

			class NoUnderlyingAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2313
					order[1] = 2314
					order[2] = 2315
					order[3] = 0
					super(2312, 2313, order)
				end
			end

			class NoUnderlyingComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2046
					order[1] = 2261
					order[2] = 2262
					order[3] = 2263
					order[4] = 2047
					order[5] = 2264
					order[6] = 2265
					order[7] = 2266
					order[8] = 2947
					order[9] = 2048
					order[10] = 2267
					order[11] = 2049
					order[12] = 2050
					order[13] = 2051
					order[14] = 2052
					order[15] = 2053
					order[16] = 2268
					order[17] = 2948
					order[18] = 2269
					order[19] = 2949
					order[20] = 2270
					order[21] = 2271
					order[22] = 2419
					order[23] = 2420
					order[24] = 2272
					order[25] = 2273
					order[26] = 2274
					order[27] = 2275
					order[28] = 2276
					order[29] = 41732
					order[30] = 41739
					order[31] = 41740
					order[32] = 41741
					order[33] = 41742
					order[34] = 41743
					order[35] = 41744
					order[36] = 41745
					order[37] = 41746
					order[38] = 41747
					order[39] = 41729
					order[40] = 2277
					order[41] = 2278
					order[42] = 2279
					order[43] = 2280
					order[44] = 2281
					order[45] = 41748
					order[46] = 41716
					order[47] = 2611
					order[48] = 2612
					order[49] = 2613
					order[50] = 2282
					order[51] = 2283
					order[52] = 0
					super(2045, 2046, order)
				end

				class NoUnderlyingComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2054
						order[1] = 2055
						order[2] = 2056
						order[3] = 0
						super(2053, 2054, order)
					end

					class NoUnderlyingComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2057
							order[1] = 2058
							order[2] = 0
							super(2056, 2057, order)
						end
					end
				end

				class NoUnderlyingComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41733
						order[1] = 41734
						order[2] = 41735
						order[3] = 41736
						order[4] = 0
						super(41732, 41733, order)
					end
				end

				class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41738
						order[1] = 0
						super(41737, 41738, order)
					end
				end

				class NoUnderlyingComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41730
						order[1] = 41731
						order[2] = 41750
						order[3] = 41726
						order[4] = 41713
						order[5] = 0
						super(41729, 41730, order)
					end

					class NoUnderlyingComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41751
							order[1] = 41752
							order[2] = 41753
							order[3] = 41754
							order[4] = 41755
							order[5] = 0
							super(41750, 41751, order)
						end
					end

					class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41727
							order[1] = 41728
							order[2] = 0
							super(41726, 41727, order)
						end
					end

					class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41714
							order[1] = 41715
							order[2] = 0
							super(41713, 41714, order)
						end
					end
				end

				class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41749
						order[1] = 0
						super(41748, 41749, order)
					end
				end

				class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41717
						order[1] = 41718
						order[2] = 41719
						order[3] = 41720
						order[4] = 41721
						order[5] = 41722
						order[6] = 41723
						order[7] = 41724
						order[8] = 0
						super(41716, 41717, order)
					end

					class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41725
							order[1] = 0
							super(41724, 41725, order)
						end
					end
				end
			end

			class NoUnderlyingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40963
					order[1] = 0
					super(40962, 40963, order)
				end
			end

			class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41948
					order[1] = 0
					super(41947, 41948, order)
				end
			end

			class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41865
					order[1] = 41338
					order[2] = 0
					super(41864, 41865, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41867
					order[1] = 41339
					order[2] = 0
					super(41866, 41867, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41869
					order[1] = 41870
					order[2] = 41871
					order[3] = 41872
					order[4] = 41873
					order[5] = 41874
					order[6] = 41875
					order[7] = 41876
					order[8] = 41877
					order[9] = 0
					super(41868, 41869, order)
				end
			end

			class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 43075
					order[1] = 0
					super(43074, 43075, order)
				end
			end

			class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41821
					order[1] = 0
					super(41820, 41821, order)
				end
			end

			class NoUnderlyingOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41842
					order[1] = 41843
					order[2] = 0
					super(41841, 41842, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41845
					order[1] = 0
					super(41844, 41845, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41857
					order[1] = 41858
					order[2] = 0
					super(41856, 41857, order)
				end
			end

			class NoUnderlyingStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40541
					order[1] = 42016
					order[2] = 40542
					order[3] = 43083
					order[4] = 43084
					order[5] = 40543
					order[6] = 40544
					order[7] = 42018
					order[8] = 40545
					order[9] = 40546
					order[10] = 43085
					order[11] = 43086
					order[12] = 42019
					order[13] = 42020
					order[14] = 42021
					order[15] = 42022
					order[16] = 42023
					order[17] = 42024
					order[18] = 41964
					order[19] = 41965
					order[20] = 41966
					order[21] = 41967
					order[22] = 41968
					order[23] = 41969
					order[24] = 41970
					order[25] = 42589
					order[26] = 41971
					order[27] = 41972
					order[28] = 41973
					order[29] = 41974
					order[30] = 41975
					order[31] = 41976
					order[32] = 41977
					order[33] = 41978
					order[34] = 41979
					order[35] = 41980
					order[36] = 41981
					order[37] = 41982
					order[38] = 41983
					order[39] = 41984
					order[40] = 41985
					order[41] = 41986
					order[42] = 41987
					order[43] = 41988
					order[44] = 41989
					order[45] = 40057
					order[46] = 40058
					order[47] = 40060
					order[48] = 40061
					order[49] = 40062
					order[50] = 40063
					order[51] = 40064
					order[52] = 40548
					order[53] = 40549
					order[54] = 40551
					order[55] = 40552
					order[56] = 40553
					order[57] = 40554
					order[58] = 40555
					order[59] = 41957
					order[60] = 41958
					order[61] = 40556
					order[62] = 40558
					order[63] = 40559
					order[64] = 40561
					order[65] = 40562
					order[66] = 40563
					order[67] = 40564
					order[68] = 40565
					order[69] = 40566
					order[70] = 40567
					order[71] = 41959
					order[72] = 41960
					order[73] = 41961
					order[74] = 40568
					order[75] = 40569
					order[76] = 40570
					order[77] = 42895
					order[78] = 40571
					order[79] = 40572
					order[80] = 43107
					order[81] = 40573
					order[82] = 40574
					order[83] = 40575
					order[84] = 40576
					order[85] = 40577
					order[86] = 42896
					order[87] = 42897
					order[88] = 42898
					order[89] = 42899
					order[90] = 40578
					order[91] = 40579
					order[92] = 40580
					order[93] = 41897
					order[94] = 41898
					order[95] = 41899
					order[96] = 41900
					order[97] = 41901
					order[98] = 41902
					order[99] = 41903
					order[100] = 42900
					order[101] = 40664
					order[102] = 40708
					order[103] = 41777
					order[104] = 41778
					order[105] = 41779
					order[106] = 41780
					order[107] = 41781
					order[108] = 42196
					order[109] = 42197
					order[110] = 41782
					order[111] = 41783
					order[112] = 41784
					order[113] = 41785
					order[114] = 41786
					order[115] = 41587
					order[116] = 41787
					order[117] = 41788
					order[118] = 41789
					order[119] = 41790
					order[120] = 41791
					order[121] = 41792
					order[122] = 41793
					order[123] = 41794
					order[124] = 41795
					order[125] = 41796
					order[126] = 41797
					order[127] = 41798
					order[128] = 41799
					order[129] = 43096
					order[130] = 41756
					order[131] = 40547
					order[132] = 40988
					order[133] = 40989
					order[134] = 0
					super(40540, 40541, order)
				end

				class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41991
						order[1] = 41992
						order[2] = 0
						super(41990, 41991, order)
					end
				end

				class NoUnderlyingStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41801
						order[1] = 41802
						order[2] = 41803
						order[3] = 0
						super(41800, 41801, order)
					end
				end

				class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41994
						order[1] = 41995
						order[2] = 0
						super(41993, 41994, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41963
						order[1] = 0
						super(41962, 41963, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 42003
						order[1] = 42004
						order[2] = 42005
						order[3] = 42006
						order[4] = 42007
						order[5] = 42008
						order[6] = 42009
						order[7] = 42010
						order[8] = 42011
						order[9] = 42012
						order[10] = 42013
						order[11] = 41996
						order[12] = 42014
						order[13] = 42015
						order[14] = 0
						super(42002, 42003, order)
					end

					class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41997
							order[1] = 41998
							order[2] = 41999
							order[3] = 0
							super(41996, 41997, order)
						end

						class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 42000
								order[1] = 42001
								order[2] = 41936
								order[3] = 0
								super(41999, 42000, order)
							end
						end
					end
				end

				class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40059
						order[1] = 0
						super(40975, 40059, order)
					end
				end

				class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40550
						order[1] = 0
						super(40976, 40550, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40557
						order[1] = 0
						super(40973, 40557, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41955
						order[1] = 41956
						order[2] = 0
						super(41954, 41955, order)
					end
				end

				class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40560
						order[1] = 0
						super(40974, 40560, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40582
						order[1] = 0
						super(40969, 40582, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41938
						order[1] = 41939
						order[2] = 0
						super(41937, 41938, order)
					end
				end

				class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40594
						order[1] = 0
						super(40970, 40594, order)
					end
				end

				class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40600
						order[1] = 0
						super(40971, 40600, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40607
						order[1] = 0
						super(40972, 40607, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42956
						order[1] = 42957
						order[2] = 0
						super(42955, 42956, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41910
						order[1] = 0
						super(41909, 41910, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41945
						order[1] = 41946
						order[2] = 0
						super(41944, 41945, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41942
						order[1] = 41943
						order[2] = 0
						super(41941, 41942, order)
					end
				end

				class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43111
						order[1] = 42982
						order[2] = 42983
						order[3] = 0
						super(42981, 43111, order)
					end
				end

				class NoUnderlyingDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42863
						order[1] = 42864
						order[2] = 42865
						order[3] = 42866
						order[4] = 42867
						order[5] = 42868
						order[6] = 42882
						order[7] = 42869
						order[8] = 42870
						order[9] = 42871
						order[10] = 42872
						order[11] = 42873
						order[12] = 42874
						order[13] = 42875
						order[14] = 42876
						order[15] = 42877
						order[16] = 42878
						order[17] = 42879
						order[18] = 42880
						order[19] = 42881
						order[20] = 0
						super(42862, 42863, order)
					end

					class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42883
							order[1] = 0
							super(42882, 42883, order)
						end
					end
				end

				class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42854
						order[1] = 0
						super(42853, 42854, order)
					end
				end

				class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42800
						order[1] = 0
						super(42799, 42800, order)
					end
				end

				class NoUnderlyingReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 43035
						order[1] = 43036
						order[2] = 43037
						order[3] = 43038
						order[4] = 43039
						order[5] = 43040
						order[6] = 43064
						order[7] = 43030
						order[8] = 43041
						order[9] = 43042
						order[10] = 43043
						order[11] = 43044
						order[12] = 43045
						order[13] = 43046
						order[14] = 43047
						order[15] = 43048
						order[16] = 43049
						order[17] = 43050
						order[18] = 43051
						order[19] = 43052
						order[20] = 43060
						order[21] = 43053
						order[22] = 43054
						order[23] = 43008
						order[24] = 43055
						order[25] = 43056
						order[26] = 43057
						order[27] = 43058
						order[28] = 43059
						order[29] = 0
						super(43034, 43035, order)
					end

					class NoUnderlyingReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 43065
							order[1] = 43066
							order[2] = 43067
							order[3] = 43068
							order[4] = 0
							super(43064, 43065, order)
						end
					end

					class NoUnderlyingReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43031
							order[1] = 43032
							order[2] = 43033
							order[3] = 0
							super(43030, 43031, order)
						end
					end

					class NoUnderlyingReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43061
							order[1] = 43062
							order[2] = 43063
							order[3] = 0
							super(43060, 43061, order)
						end
					end

					class NoUnderlyingReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 43009
							order[1] = 43071
							order[2] = 43010
							order[3] = 43011
							order[4] = 43012
							order[5] = 43013
							order[6] = 43014
							order[7] = 43015
							order[8] = 43016
							order[9] = 43017
							order[10] = 43018
							order[11] = 43019
							order[12] = 43020
							order[13] = 43021
							order[14] = 43022
							order[15] = 43023
							order[16] = 43024
							order[17] = 43025
							order[18] = 43026
							order[19] = 43027
							order[20] = 43028
							order[21] = 43029
							order[22] = 43069
							order[23] = 0
							super(43008, 43009, order)
						end

						class NoUnderlyingReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 43072
								order[1] = 43073
								order[2] = 0
								super(43071, 43072, order)
							end
						end

						class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 43070
								order[1] = 0
								super(43069, 43070, order)
							end
						end
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42916
						order[1] = 0
						super(42915, 42916, order)
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42902
						order[1] = 42903
						order[2] = 0
						super(42901, 42902, order)
					end
				end

				class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40650
						order[1] = 0
						super(40968, 40650, order)
					end
				end

				class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40657
						order[1] = 40658
						order[2] = 0
						super(40656, 40657, order)
					end
				end

				class NoUnderlyingSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40660
						order[1] = 40904
						order[2] = 40915
						order[3] = 40662
						order[4] = 40663
						order[5] = 0
						super(40659, 40660, order)
					end
				end

				class NoUnderlyingPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40665
						order[1] = 41881
						order[2] = 41882
						order[3] = 40666
						order[4] = 40667
						order[5] = 40668
						order[6] = 40669
						order[7] = 40670
						order[8] = 40671
						order[9] = 40672
						order[10] = 40673
						order[11] = 40674
						order[12] = 40675
						order[13] = 41883
						order[14] = 41884
						order[15] = 41885
						order[16] = 41886
						order[17] = 40676
						order[18] = 40677
						order[19] = 40678
						order[20] = 40679
						order[21] = 41887
						order[22] = 41888
						order[23] = 41889
						order[24] = 41890
						order[25] = 40680
						order[26] = 40681
						order[27] = 40682
						order[28] = 40683
						order[29] = 40684
						order[30] = 40685
						order[31] = 40704
						order[32] = 40686
						order[33] = 40687
						order[34] = 40688
						order[35] = 40689
						order[36] = 40966
						order[37] = 40691
						order[38] = 40692
						order[39] = 40693
						order[40] = 41891
						order[41] = 41892
						order[42] = 40694
						order[43] = 41878
						order[44] = 41893
						order[45] = 41894
						order[46] = 41895
						order[47] = 41896
						order[48] = 40695
						order[49] = 40696
						order[50] = 40697
						order[51] = 40698
						order[52] = 40967
						order[53] = 40700
						order[54] = 40701
						order[55] = 40702
						order[56] = 40703
						order[57] = 0
						super(40664, 40665, order)
					end

					class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40705
							order[1] = 40706
							order[2] = 40707
							order[3] = 0
							super(40704, 40705, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40690
							order[1] = 0
							super(40966, 40690, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41879
							order[1] = 41880
							order[2] = 0
							super(41878, 41879, order)
						end
					end

					class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40699
							order[1] = 0
							super(40967, 40699, order)
						end
					end
				end

				class NoUnderlyingPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40709
						order[1] = 40710
						order[2] = 42993
						order[3] = 42994
						order[4] = 42995
						order[5] = 42996
						order[6] = 42997
						order[7] = 42998
						order[8] = 42999
						order[9] = 42984
						order[10] = 42985
						order[11] = 42986
						order[12] = 42987
						order[13] = 42988
						order[14] = 42989
						order[15] = 42990
						order[16] = 40711
						order[17] = 40712
						order[18] = 40713
						order[19] = 40714
						order[20] = 40715
						order[21] = 40716
						order[22] = 40717
						order[23] = 40718
						order[24] = 40719
						order[25] = 40720
						order[26] = 40721
						order[27] = 40722
						order[28] = 40723
						order[29] = 40724
						order[30] = 40725
						order[31] = 40726
						order[32] = 40727
						order[33] = 40728
						order[34] = 40729
						order[35] = 40730
						order[36] = 40731
						order[37] = 40732
						order[38] = 40733
						order[39] = 40734
						order[40] = 40735
						order[41] = 40736
						order[42] = 40737
						order[43] = 0
						super(40708, 40709, order)
					end

					class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43001
							order[1] = 0
							super(43000, 43001, order)
						end
					end

					class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42992
							order[1] = 0
							super(42991, 42992, order)
						end
					end
				end

				class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41809
						order[1] = 0
						super(41808, 41809, order)
					end
				end

				class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41805
						order[1] = 41806
						order[2] = 41807
						order[3] = 0
						super(41804, 41805, order)
					end
				end

				class NoUnderlyingDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41757
						order[1] = 41758
						order[2] = 41759
						order[3] = 41760
						order[4] = 41761
						order[5] = 41762
						order[6] = 41763
						order[7] = 41764
						order[8] = 41765
						order[9] = 41766
						order[10] = 41767
						order[11] = 41768
						order[12] = 41769
						order[13] = 41770
						order[14] = 0
						super(41756, 41757, order)
					end

					class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41771
							order[1] = 41772
							order[2] = 41773
							order[3] = 0
							super(41770, 41771, order)
						end

						class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41774
								order[1] = 41775
								order[2] = 41776
								order[3] = 0
								super(41773, 41774, order)
							end
						end
					end
				end
			end

			class NoUnderlyingProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 42150
					order[1] = 42151
					order[2] = 42152
					order[3] = 42190
					order[4] = 42153
					order[5] = 42154
					order[6] = 42155
					order[7] = 43002
					order[8] = 43003
					order[9] = 42156
					order[10] = 42157
					order[11] = 42158
					order[12] = 42104
					order[13] = 42105
					order[14] = 42106
					order[15] = 42107
					order[16] = 42108
					order[17] = 42109
					order[18] = 42110
					order[19] = 42111
					order[20] = 42115
					order[21] = 42116
					order[22] = 42117
					order[23] = 42118
					order[24] = 42119
					order[25] = 42120
					order[26] = 42121
					order[27] = 42122
					order[28] = 42123
					order[29] = 42124
					order[30] = 42125
					order[31] = 42126
					order[32] = 42127
					order[33] = 42128
					order[34] = 42129
					order[35] = 42130
					order[36] = 42131
					order[37] = 42132
					order[38] = 42133
					order[39] = 42134
					order[40] = 42135
					order[41] = 42136
					order[42] = 42137
					order[43] = 42138
					order[44] = 42139
					order[45] = 42140
					order[46] = 42141
					order[47] = 42142
					order[48] = 42143
					order[49] = 42144
					order[50] = 42145
					order[51] = 42146
					order[52] = 42147
					order[53] = 42148
					order[54] = 42159
					order[55] = 42160
					order[56] = 42161
					order[57] = 42162
					order[58] = 42163
					order[59] = 42164
					order[60] = 42165
					order[61] = 42092
					order[62] = 42093
					order[63] = 42094
					order[64] = 42095
					order[65] = 42096
					order[66] = 42097
					order[67] = 42098
					order[68] = 42166
					order[69] = 42167
					order[70] = 42168
					order[71] = 42169
					order[72] = 42102
					order[73] = 42103
					order[74] = 42170
					order[75] = 42171
					order[76] = 42172
					order[77] = 42173
					order[78] = 0
					super(42149, 42150, order)
				end

				class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42191
						order[1] = 0
						super(42190, 42191, order)
					end
				end

				class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42183
						order[1] = 0
						super(42182, 42183, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42185
						order[1] = 0
						super(42184, 42185, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42113
						order[1] = 42114
						order[2] = 0
						super(42112, 42113, order)
					end
				end

				class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42187
						order[1] = 0
						super(42186, 42187, order)
					end
				end

				class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42189
						order[1] = 0
						super(42188, 42189, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42181
						order[1] = 0
						super(42180, 42181, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42100
						order[1] = 42101
						order[2] = 0
						super(42099, 42100, order)
					end
				end

				class NoUnderlyingProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 42174
						order[1] = 42175
						order[2] = 42176
						order[3] = 40918
						order[4] = 42177
						order[5] = 0
						super(42173, 42174, order)
					end

					class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42178
							order[1] = 42179
							order[2] = 0
							super(42177, 42178, order)
						end
					end
				end
			end

			class NoUnderlyingAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42037
					order[1] = 42038
					order[2] = 41340
					order[3] = 0
					super(42036, 42037, order)
				end

				class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41341
						order[1] = 41701
						order[2] = 41709
						order[3] = 41710
						order[4] = 41711
						order[5] = 41712
						order[6] = 42017
						order[7] = 42025
						order[8] = 42026
						order[9] = 42027
						order[10] = 42028
						order[11] = 42029
						order[12] = 42030
						order[13] = 42031
						order[14] = 42032
						order[15] = 42033
						order[16] = 42034
						order[17] = 42035
						order[18] = 0
						super(41340, 41341, order)
					end
				end
			end

			class NoUnderlyingProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 42069
					order[1] = 42070
					order[2] = 42071
					order[3] = 42072
					order[4] = 42073
					order[5] = 42074
					order[6] = 42075
					order[7] = 42090
					order[8] = 42077
					order[9] = 42087
					order[10] = 42076
					order[11] = 0
					super(42068, 42069, order)
				end

				class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42091
						order[1] = 0
						super(42090, 42091, order)
					end
				end

				class NoUnderlyingProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 42078
						order[1] = 42079
						order[2] = 42080
						order[3] = 42081
						order[4] = 42082
						order[5] = 42083
						order[6] = 42084
						order[7] = 42085
						order[8] = 0
						super(42077, 42078, order)
					end

					class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42086
							order[1] = 0
							super(42085, 42086, order)
						end
					end
				end

				class NoUnderlyingProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42088
						order[1] = 42089
						order[2] = 0
						super(42087, 42088, order)
					end
				end
			end

			class NoUnderlyingCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 42042
					order[1] = 42043
					order[2] = 42044
					order[3] = 42045
					order[4] = 42046
					order[5] = 42047
					order[6] = 42048
					order[7] = 42049
					order[8] = 42050
					order[9] = 42051
					order[10] = 42052
					order[11] = 42039
					order[12] = 42797
					order[13] = 42798
					order[14] = 42053
					order[15] = 42054
					order[16] = 42790
					order[17] = 42791
					order[18] = 42792
					order[19] = 42793
					order[20] = 42794
					order[21] = 42795
					order[22] = 42796
					order[23] = 42055
					order[24] = 42056
					order[25] = 42057
					order[26] = 42058
					order[27] = 42059
					order[28] = 0
					super(42041, 42042, order)
				end

				class NoUnderlyingCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42040
						order[1] = 0
						super(42039, 42040, order)
					end
				end

				class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42789
						order[1] = 0
						super(42788, 42789, order)
					end
				end
			end

			class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42065
					order[1] = 42061
					order[2] = 42062
					order[3] = 42063
					order[4] = 42064
					order[5] = 0
					super(42060, 42065, order)
				end

				class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42066
						order[1] = 42067
						order[2] = 0
						super(42065, 42066, order)
					end
				end
			end

			class NoUnderlyingRateSpreadSteps < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 43006
					order[1] = 43007
					order[2] = 0
					super(43005, 43006, order)
				end
			end

			class NoUnderlyingDividendPayments < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42856
					order[1] = 42857
					order[2] = 42858
					order[3] = 42859
					order[4] = 0
					super(42855, 42856, order)
				end
			end

			class NoUnderlyingExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42885
					order[1] = 42886
					order[2] = 0
					super(42884, 42885, order)
				end
			end
		end

		class NoLegs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(176)
				order[0] = 600
				order[1] = 601
				order[2] = 602
				order[3] = 603
				order[4] = 1788
				order[5] = 607
				order[6] = 1594
				order[7] = 608
				order[8] = 2893
				order[9] = 609
				order[10] = 764
				order[11] = 610
				order[12] = 611
				order[13] = 1212
				order[14] = 2146
				order[15] = 2147
				order[16] = 2148
				order[17] = 248
				order[18] = 2149
				order[19] = 2150
				order[20] = 2151
				order[21] = 2152
				order[22] = 2153
				order[23] = 2154
				order[24] = 2155
				order[25] = 2348
				order[26] = 2067
				order[27] = 2068
				order[28] = 2069
				order[29] = 2739
				order[30] = 2070
				order[31] = 2156
				order[32] = 2157
				order[33] = 2158
				order[34] = 2159
				order[35] = 2160
				order[36] = 2161
				order[37] = 2162
				order[38] = 2163
				order[39] = 2164
				order[40] = 2165
				order[41] = 2880
				order[42] = 2166
				order[43] = 2167
				order[44] = 2168
				order[45] = 2169
				order[46] = 2170
				order[47] = 2171
				order[48] = 2172
				order[49] = 2173
				order[50] = 2174
				order[51] = 2175
				order[52] = 2176
				order[53] = 2177
				order[54] = 2178
				order[55] = 2179
				order[56] = 2180
				order[57] = 249
				order[58] = 250
				order[59] = 251
				order[60] = 252
				order[61] = 253
				order[62] = 257
				order[63] = 599
				order[64] = 596
				order[65] = 597
				order[66] = 598
				order[67] = 254
				order[68] = 612
				order[69] = 942
				order[70] = 2908
				order[71] = 2181
				order[72] = 2182
				order[73] = 2183
				order[74] = 2184
				order[75] = 2604
				order[76] = 2185
				order[77] = 2605
				order[78] = 2186
				order[79] = 2187
				order[80] = 2188
				order[81] = 2189
				order[82] = 613
				order[83] = 614
				order[84] = 1436
				order[85] = 2354
				order[86] = 1440
				order[87] = 2190
				order[88] = 2191
				order[89] = 999
				order[90] = 1224
				order[91] = 1720
				order[92] = 2909
				order[93] = 1421
				order[94] = 1422
				order[95] = 1721
				order[96] = 2910
				order[97] = 2192
				order[98] = 1001
				order[99] = 1420
				order[100] = 2193
				order[101] = 2194
				order[102] = 2755
				order[103] = 2195
				order[104] = 2196
				order[105] = 2197
				order[106] = 2198
				order[107] = 1528
				order[108] = 2911
				order[109] = 2199
				order[110] = 2200
				order[111] = 2201
				order[112] = 2202
				order[113] = 2203
				order[114] = 615
				order[115] = 616
				order[116] = 2205
				order[117] = 2206
				order[118] = 617
				order[119] = 618
				order[120] = 619
				order[121] = 2740
				order[122] = 2717
				order[123] = 2718
				order[124] = 2719
				order[125] = 620
				order[126] = 621
				order[127] = 622
				order[128] = 2207
				order[129] = 2208
				order[130] = 623
				order[131] = 624
				order[132] = 556
				order[133] = 2898
				order[134] = 740
				order[135] = 739
				order[136] = 955
				order[137] = 956
				order[138] = 1358
				order[139] = 2682
				order[140] = 2686
				order[141] = 1017
				order[142] = 566
				order[143] = 2209
				order[144] = 2211
				order[145] = 2212
				order[146] = 2213
				order[147] = 2754
				order[148] = 2214
				order[149] = 2215
				order[150] = 2606
				order[151] = 2607
				order[152] = 2497
				order[153] = 2498
				order[154] = 2499
				order[155] = 2496
				order[156] = 2495
				order[157] = 2953
				order[158] = 2511
				order[159] = 2510
				order[160] = 2512
				order[161] = 2509
				order[162] = 2500
				order[163] = 2502
				order[164] = 2501
				order[165] = 2503
				order[166] = 2507
				order[167] = 2505
				order[168] = 2494
				order[169] = 2493
				order[170] = 2514
				order[171] = 2513
				order[172] = 2506
				order[173] = 2504
				order[174] = 2508
				order[175] = 0
				super(555, 600, order)
			end

			class NoLegSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 605
					order[1] = 606
					order[2] = 2958
					order[3] = 0
					super(604, 605, order)
				end
			end

			class NoLegSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2077
					order[1] = 2078
					order[2] = 2079
					order[3] = 2743
					order[4] = 0
					super(2076, 2077, order)
				end
			end

			class NoLegAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2309
					order[1] = 2310
					order[2] = 2311
					order[3] = 0
					super(2308, 2309, order)
				end
			end

			class NoLegEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 2060
					order[1] = 2061
					order[2] = 2062
					order[3] = 2063
					order[4] = 2064
					order[5] = 2341
					order[6] = 2065
					order[7] = 2066
					order[8] = 2074
					order[9] = 2075
					order[10] = 0
					super(2059, 2060, order)
				end
			end

			class NoLegInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 2255
					order[1] = 2256
					order[2] = 2257
					order[3] = 2379
					order[4] = 2258
					order[5] = 0
					super(2254, 2255, order)
				end

				class NoLegInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2259
						order[1] = 2260
						order[2] = 0
						super(2258, 2259, order)
					end
				end
			end

			class NoLegComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2219
					order[1] = 2220
					order[2] = 2221
					order[3] = 2222
					order[4] = 2223
					order[5] = 2224
					order[6] = 2225
					order[7] = 2226
					order[8] = 2944
					order[9] = 2227
					order[10] = 2228
					order[11] = 2229
					order[12] = 2230
					order[13] = 2231
					order[14] = 2232
					order[15] = 2250
					order[16] = 2233
					order[17] = 2945
					order[18] = 2234
					order[19] = 2946
					order[20] = 2235
					order[21] = 2236
					order[22] = 2409
					order[23] = 2410
					order[24] = 2237
					order[25] = 2238
					order[26] = 2239
					order[27] = 2240
					order[28] = 2241
					order[29] = 41382
					order[30] = 41389
					order[31] = 41390
					order[32] = 41391
					order[33] = 41392
					order[34] = 41393
					order[35] = 41394
					order[36] = 41395
					order[37] = 41396
					order[38] = 41397
					order[39] = 41379
					order[40] = 2242
					order[41] = 2243
					order[42] = 2244
					order[43] = 2245
					order[44] = 2246
					order[45] = 41398
					order[46] = 41366
					order[47] = 2608
					order[48] = 2609
					order[49] = 2610
					order[50] = 2248
					order[51] = 2249
					order[52] = 0
					super(2218, 2219, order)
				end

				class NoLegComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2251
						order[1] = 2252
						order[2] = 2253
						order[3] = 0
						super(2250, 2251, order)
					end

					class NoLegComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2204
							order[1] = 2247
							order[2] = 0
							super(2253, 2204, order)
						end
					end
				end

				class NoLegComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41383
						order[1] = 41384
						order[2] = 41385
						order[3] = 41386
						order[4] = 0
						super(41382, 41383, order)
					end
				end

				class NoLegComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41388
						order[1] = 0
						super(41387, 41388, order)
					end
				end

				class NoLegComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41380
						order[1] = 41381
						order[2] = 41400
						order[3] = 41376
						order[4] = 41363
						order[5] = 0
						super(41379, 41380, order)
					end

					class NoLegComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41401
							order[1] = 41402
							order[2] = 41403
							order[3] = 41404
							order[4] = 41405
							order[5] = 0
							super(41400, 41401, order)
						end
					end

					class NoLegComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41377
							order[1] = 41378
							order[2] = 0
							super(41376, 41377, order)
						end
					end

					class NoLegComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41364
							order[1] = 41365
							order[2] = 0
							super(41363, 41364, order)
						end
					end
				end

				class NoLegComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41399
						order[1] = 0
						super(41398, 41399, order)
					end
				end

				class NoLegComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41367
						order[1] = 41368
						order[2] = 41369
						order[3] = 41370
						order[4] = 41371
						order[5] = 41372
						order[6] = 41373
						order[7] = 41374
						order[8] = 0
						super(41366, 41367, order)
					end

					class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41375
							order[1] = 0
							super(41374, 41375, order)
						end
					end
				end
			end

			class NoLegBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40924
					order[1] = 0
					super(40923, 40924, order)
				end
			end

			class NoLegPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41608
					order[1] = 0
					super(41607, 41608, order)
				end
			end

			class NoLegMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41468
					order[1] = 40223
					order[2] = 0
					super(41467, 41468, order)
				end
			end

			class NoLegMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41470
					order[1] = 40990
					order[2] = 0
					super(41469, 41470, order)
				end
			end

			class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41472
					order[1] = 41473
					order[2] = 41474
					order[3] = 41475
					order[4] = 41476
					order[5] = 41477
					order[6] = 41478
					order[7] = 41479
					order[8] = 41480
					order[9] = 0
					super(41471, 41472, order)
				end
			end

			class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42582
					order[1] = 0
					super(42581, 42582, order)
				end
			end

			class NoLegOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41492
					order[1] = 0
					super(41491, 41492, order)
				end
			end

			class NoLegOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41513
					order[1] = 41514
					order[2] = 0
					super(41512, 41513, order)
				end
			end

			class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41516
					order[1] = 0
					super(41515, 41516, order)
				end
			end

			class NoLegOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41528
					order[1] = 41529
					order[2] = 0
					super(41527, 41528, order)
				end
			end

			class NoLegStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40242
					order[1] = 41700
					order[2] = 40243
					order[3] = 42583
					order[4] = 42584
					order[5] = 40244
					order[6] = 40245
					order[7] = 41702
					order[8] = 40246
					order[9] = 40247
					order[10] = 42585
					order[11] = 42586
					order[12] = 41703
					order[13] = 41704
					order[14] = 41705
					order[15] = 41706
					order[16] = 41707
					order[17] = 41708
					order[18] = 41648
					order[19] = 41649
					order[20] = 41650
					order[21] = 41651
					order[22] = 41652
					order[23] = 41653
					order[24] = 41654
					order[25] = 42588
					order[26] = 41655
					order[27] = 41656
					order[28] = 41657
					order[29] = 41658
					order[30] = 41659
					order[31] = 41660
					order[32] = 41661
					order[33] = 41662
					order[34] = 41663
					order[35] = 41664
					order[36] = 41665
					order[37] = 41666
					order[38] = 41667
					order[39] = 41668
					order[40] = 41669
					order[41] = 41670
					order[42] = 41671
					order[43] = 41672
					order[44] = 41673
					order[45] = 40249
					order[46] = 40250
					order[47] = 40252
					order[48] = 40253
					order[49] = 40254
					order[50] = 40255
					order[51] = 40256
					order[52] = 40257
					order[53] = 40258
					order[54] = 40260
					order[55] = 40261
					order[56] = 40262
					order[57] = 40263
					order[58] = 40264
					order[59] = 41641
					order[60] = 41642
					order[61] = 40265
					order[62] = 40267
					order[63] = 40268
					order[64] = 40270
					order[65] = 40271
					order[66] = 40272
					order[67] = 40273
					order[68] = 40274
					order[69] = 40275
					order[70] = 40276
					order[71] = 41643
					order[72] = 41644
					order[73] = 41645
					order[74] = 40279
					order[75] = 40280
					order[76] = 40281
					order[77] = 42399
					order[78] = 40282
					order[79] = 40283
					order[80] = 43108
					order[81] = 40284
					order[82] = 40285
					order[83] = 40286
					order[84] = 40287
					order[85] = 40288
					order[86] = 42400
					order[87] = 42401
					order[88] = 42402
					order[89] = 42403
					order[90] = 40289
					order[91] = 40290
					order[92] = 40291
					order[93] = 41549
					order[94] = 41550
					order[95] = 41551
					order[96] = 41552
					order[97] = 41553
					order[98] = 41554
					order[99] = 41555
					order[100] = 42404
					order[101] = 40374
					order[102] = 40418
					order[103] = 41429
					order[104] = 41430
					order[105] = 41431
					order[106] = 41432
					order[107] = 41433
					order[108] = 42194
					order[109] = 42195
					order[110] = 41434
					order[111] = 41435
					order[112] = 41436
					order[113] = 41437
					order[114] = 41438
					order[115] = 41219
					order[116] = 41439
					order[117] = 41440
					order[118] = 41441
					order[119] = 41442
					order[120] = 41443
					order[121] = 41444
					order[122] = 41445
					order[123] = 41446
					order[124] = 41447
					order[125] = 41448
					order[126] = 41449
					order[127] = 41450
					order[128] = 41451
					order[129] = 43095
					order[130] = 41408
					order[131] = 40248
					order[132] = 40978
					order[133] = 40979
					order[134] = 0
					super(40241, 40242, order)
				end

				class NoLegStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41675
						order[1] = 41676
						order[2] = 0
						super(41674, 41675, order)
					end
				end

				class NoLegStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41453
						order[1] = 41454
						order[2] = 41455
						order[3] = 0
						super(41452, 41453, order)
					end
				end

				class NoLegStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41678
						order[1] = 41679
						order[2] = 0
						super(41677, 41678, order)
					end
				end

				class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41647
						order[1] = 0
						super(41646, 41647, order)
					end
				end

				class NoLegStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41687
						order[1] = 41688
						order[2] = 41689
						order[3] = 41690
						order[4] = 41691
						order[5] = 41692
						order[6] = 41693
						order[7] = 41694
						order[8] = 41695
						order[9] = 41696
						order[10] = 41697
						order[11] = 41680
						order[12] = 41698
						order[13] = 41699
						order[14] = 0
						super(41686, 41687, order)
					end

					class NoLegStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41681
							order[1] = 41682
							order[2] = 41683
							order[3] = 0
							super(41680, 41681, order)
						end

						class NoLegStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41684
								order[1] = 41685
								order[2] = 41935
								order[3] = 0
								super(41683, 41684, order)
							end
						end
					end
				end

				class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40251
						order[1] = 0
						super(40942, 40251, order)
					end
				end

				class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40259
						order[1] = 0
						super(40943, 40259, order)
					end
				end

				class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40266
						order[1] = 0
						super(40940, 40266, order)
					end
				end

				class NoLegStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41639
						order[1] = 41640
						order[2] = 0
						super(41638, 41639, order)
					end
				end

				class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40269
						order[1] = 0
						super(40941, 40269, order)
					end
				end

				class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40293
						order[1] = 0
						super(40930, 40293, order)
					end
				end

				class NoLegPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41590
						order[1] = 41591
						order[2] = 0
						super(41589, 41590, order)
					end
				end

				class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40305
						order[1] = 0
						super(40931, 40305, order)
					end
				end

				class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40311
						order[1] = 0
						super(40932, 40311, order)
					end
				end

				class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40318
						order[1] = 0
						super(40933, 40318, order)
					end
				end

				class NoLegPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42460
						order[1] = 42461
						order[2] = 0
						super(42459, 42460, order)
					end
				end

				class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41562
						order[1] = 0
						super(41561, 41562, order)
					end
				end

				class NoLegPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41597
						order[1] = 41598
						order[2] = 0
						super(41596, 41597, order)
					end
				end

				class NoLegPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41594
						order[1] = 41595
						order[2] = 0
						super(41593, 41594, order)
					end
				end

				class NoLegPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43110
						order[1] = 42486
						order[2] = 42487
						order[3] = 0
						super(42485, 43110, order)
					end
				end

				class NoLegDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42367
						order[1] = 42368
						order[2] = 42369
						order[3] = 42370
						order[4] = 42371
						order[5] = 42372
						order[6] = 42386
						order[7] = 42373
						order[8] = 42374
						order[9] = 42375
						order[10] = 42376
						order[11] = 42377
						order[12] = 42378
						order[13] = 42379
						order[14] = 42380
						order[15] = 42381
						order[16] = 42382
						order[17] = 42383
						order[18] = 42384
						order[19] = 42385
						order[20] = 0
						super(42366, 42367, order)
					end

					class NoLegDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42387
							order[1] = 0
							super(42386, 42387, order)
						end
					end
				end

				class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42365
						order[1] = 0
						super(42364, 42365, order)
					end
				end

				class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42311
						order[1] = 0
						super(42310, 42311, order)
					end
				end

				class NoLegReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 42535
						order[1] = 42536
						order[2] = 42537
						order[3] = 42538
						order[4] = 42539
						order[5] = 42540
						order[6] = 42564
						order[7] = 42530
						order[8] = 42541
						order[9] = 42542
						order[10] = 42543
						order[11] = 42544
						order[12] = 42545
						order[13] = 42546
						order[14] = 42547
						order[15] = 42548
						order[16] = 42549
						order[17] = 42550
						order[18] = 42551
						order[19] = 42552
						order[20] = 42560
						order[21] = 42553
						order[22] = 42554
						order[23] = 42508
						order[24] = 42555
						order[25] = 42556
						order[26] = 42557
						order[27] = 42558
						order[28] = 42559
						order[29] = 0
						super(42534, 42535, order)
					end

					class NoLegReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 42565
							order[1] = 42566
							order[2] = 42567
							order[3] = 42568
							order[4] = 0
							super(42564, 42565, order)
						end
					end

					class NoLegReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42531
							order[1] = 42532
							order[2] = 42533
							order[3] = 0
							super(42530, 42531, order)
						end
					end

					class NoLegReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42561
							order[1] = 42562
							order[2] = 42563
							order[3] = 0
							super(42560, 42561, order)
						end
					end

					class NoLegReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 42509
							order[1] = 42571
							order[2] = 42510
							order[3] = 42511
							order[4] = 42512
							order[5] = 42513
							order[6] = 42514
							order[7] = 42515
							order[8] = 42516
							order[9] = 42517
							order[10] = 42518
							order[11] = 42519
							order[12] = 42520
							order[13] = 42521
							order[14] = 42522
							order[15] = 42523
							order[16] = 42524
							order[17] = 42525
							order[18] = 42526
							order[19] = 42527
							order[20] = 42528
							order[21] = 42529
							order[22] = 42569
							order[23] = 0
							super(42508, 42509, order)
						end

						class NoLegReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 42572
								order[1] = 42573
								order[2] = 0
								super(42571, 42572, order)
							end
						end

						class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 42570
								order[1] = 0
								super(42569, 42570, order)
							end
						end
					end
				end

				class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42420
						order[1] = 0
						super(42419, 42420, order)
					end
				end

				class NoLegPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42406
						order[1] = 42407
						order[2] = 0
						super(42405, 42406, order)
					end
				end

				class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40361
						order[1] = 0
						super(40929, 40361, order)
					end
				end

				class NoLegNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40368
						order[1] = 40369
						order[2] = 0
						super(40367, 40368, order)
					end
				end

				class NoLegSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40903
						order[1] = 40366
						order[2] = 40370
						order[3] = 40905
						order[4] = 40906
						order[5] = 0
						super(40902, 40903, order)
					end
				end

				class NoLegPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40375
						order[1] = 41533
						order[2] = 41534
						order[3] = 40376
						order[4] = 40377
						order[5] = 40378
						order[6] = 40379
						order[7] = 40380
						order[8] = 40381
						order[9] = 40382
						order[10] = 40383
						order[11] = 40384
						order[12] = 40385
						order[13] = 41535
						order[14] = 41536
						order[15] = 41537
						order[16] = 41538
						order[17] = 40386
						order[18] = 40387
						order[19] = 40388
						order[20] = 40389
						order[21] = 41539
						order[22] = 41540
						order[23] = 41541
						order[24] = 41542
						order[25] = 40390
						order[26] = 40391
						order[27] = 40392
						order[28] = 40393
						order[29] = 40394
						order[30] = 40395
						order[31] = 40414
						order[32] = 40396
						order[33] = 40397
						order[34] = 40398
						order[35] = 40399
						order[36] = 40927
						order[37] = 40401
						order[38] = 40402
						order[39] = 40403
						order[40] = 41543
						order[41] = 41544
						order[42] = 40404
						order[43] = 41530
						order[44] = 41545
						order[45] = 41546
						order[46] = 41547
						order[47] = 41548
						order[48] = 40405
						order[49] = 40406
						order[50] = 40407
						order[51] = 40408
						order[52] = 40928
						order[53] = 40410
						order[54] = 40411
						order[55] = 40412
						order[56] = 40413
						order[57] = 0
						super(40374, 40375, order)
					end

					class NoLegPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40415
							order[1] = 40416
							order[2] = 40417
							order[3] = 0
							super(40414, 40415, order)
						end
					end

					class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40400
							order[1] = 0
							super(40927, 40400, order)
						end
					end

					class NoLegPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41531
							order[1] = 41532
							order[2] = 0
							super(41530, 41531, order)
						end
					end

					class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40409
							order[1] = 0
							super(40928, 40409, order)
						end
					end
				end

				class NoLegPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40419
						order[1] = 40420
						order[2] = 42497
						order[3] = 42498
						order[4] = 42499
						order[5] = 42500
						order[6] = 42501
						order[7] = 42502
						order[8] = 42503
						order[9] = 42488
						order[10] = 42489
						order[11] = 42490
						order[12] = 42491
						order[13] = 42492
						order[14] = 42493
						order[15] = 42494
						order[16] = 40421
						order[17] = 40422
						order[18] = 40423
						order[19] = 40424
						order[20] = 40425
						order[21] = 40426
						order[22] = 40427
						order[23] = 40428
						order[24] = 40429
						order[25] = 40430
						order[26] = 40431
						order[27] = 40432
						order[28] = 40433
						order[29] = 40434
						order[30] = 40435
						order[31] = 40436
						order[32] = 40437
						order[33] = 40438
						order[34] = 40439
						order[35] = 40440
						order[36] = 40441
						order[37] = 40442
						order[38] = 40443
						order[39] = 40444
						order[40] = 40445
						order[41] = 40446
						order[42] = 40447
						order[43] = 0
						super(40418, 40419, order)
					end

					class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42505
							order[1] = 0
							super(42504, 42505, order)
						end
					end

					class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42496
							order[1] = 0
							super(42495, 42496, order)
						end
					end
				end

				class NoLegDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41461
						order[1] = 0
						super(41460, 41461, order)
					end
				end

				class NoLegDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41457
						order[1] = 41458
						order[2] = 41459
						order[3] = 0
						super(41456, 41457, order)
					end
				end

				class NoLegDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41409
						order[1] = 41410
						order[2] = 41411
						order[3] = 41412
						order[4] = 41413
						order[5] = 41414
						order[6] = 41415
						order[7] = 41416
						order[8] = 41417
						order[9] = 41418
						order[10] = 41419
						order[11] = 41420
						order[12] = 41421
						order[13] = 41422
						order[14] = 0
						super(41408, 41409, order)
					end

					class NoLegDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41423
							order[1] = 41424
							order[2] = 41425
							order[3] = 0
							super(41422, 41423, order)
						end

						class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41426
								order[1] = 41427
								order[2] = 41428
								order[3] = 0
								super(41425, 41426, order)
							end
						end
					end
				end
			end

			class NoLegProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 40449
					order[1] = 40450
					order[2] = 40451
					order[3] = 40939
					order[4] = 40453
					order[5] = 40454
					order[6] = 40455
					order[7] = 42506
					order[8] = 42507
					order[9] = 40456
					order[10] = 40457
					order[11] = 40458
					order[12] = 40524
					order[13] = 40525
					order[14] = 40526
					order[15] = 40528
					order[16] = 40529
					order[17] = 40530
					order[18] = 40531
					order[19] = 40532
					order[20] = 40476
					order[21] = 40478
					order[22] = 40479
					order[23] = 40480
					order[24] = 40481
					order[25] = 40482
					order[26] = 40483
					order[27] = 40484
					order[28] = 40485
					order[29] = 40486
					order[30] = 40487
					order[31] = 40488
					order[32] = 40489
					order[33] = 40490
					order[34] = 40491
					order[35] = 40492
					order[36] = 40493
					order[37] = 40494
					order[38] = 40498
					order[39] = 40499
					order[40] = 40501
					order[41] = 40502
					order[42] = 40503
					order[43] = 40504
					order[44] = 40505
					order[45] = 40506
					order[46] = 40507
					order[47] = 40508
					order[48] = 40509
					order[49] = 40511
					order[50] = 40512
					order[51] = 40513
					order[52] = 40514
					order[53] = 40515
					order[54] = 40459
					order[55] = 40460
					order[56] = 40461
					order[57] = 40462
					order[58] = 40463
					order[59] = 40464
					order[60] = 40465
					order[61] = 40516
					order[62] = 40518
					order[63] = 40519
					order[64] = 40520
					order[65] = 40521
					order[66] = 40522
					order[67] = 40523
					order[68] = 40466
					order[69] = 40467
					order[70] = 40468
					order[71] = 40469
					order[72] = 40470
					order[73] = 41407
					order[74] = 40472
					order[75] = 40980
					order[76] = 40981
					order[77] = 40533
					order[78] = 0
					super(40448, 40449, order)
				end

				class NoLegProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40452
						order[1] = 0
						super(40939, 40452, order)
					end
				end

				class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40527
						order[1] = 0
						super(40935, 40527, order)
					end
				end

				class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40477
						order[1] = 0
						super(40936, 40477, order)
					end
				end

				class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40496
						order[1] = 40497
						order[2] = 0
						super(40495, 40496, order)
					end
				end

				class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40500
						order[1] = 0
						super(40937, 40500, order)
					end
				end

				class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40510
						order[1] = 0
						super(40938, 40510, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40517
						order[1] = 0
						super(40934, 40517, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40474
						order[1] = 40475
						order[2] = 0
						super(40473, 40474, order)
					end
				end

				class NoLegProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40534
						order[1] = 40535
						order[2] = 40536
						order[3] = 2380
						order[4] = 40537
						order[5] = 0
						super(40533, 40534, order)
					end

					class NoLegProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40538
							order[1] = 40539
							order[2] = 0
							super(40537, 40538, order)
						end
					end
				end
			end

			class NoLegAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41336
					order[1] = 41337
					order[2] = 41316
					order[3] = 0
					super(41335, 41336, order)
				end

				class NoLegAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41317
						order[1] = 41318
						order[2] = 41319
						order[3] = 41320
						order[4] = 41321
						order[5] = 41322
						order[6] = 41323
						order[7] = 41324
						order[8] = 41325
						order[9] = 41326
						order[10] = 41327
						order[11] = 41328
						order[12] = 41329
						order[13] = 41330
						order[14] = 41331
						order[15] = 41332
						order[16] = 41333
						order[17] = 41334
						order[18] = 0
						super(41316, 41317, order)
					end
				end
			end

			class NoLegProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 41618
					order[1] = 41619
					order[2] = 41620
					order[3] = 41621
					order[4] = 41622
					order[5] = 41623
					order[6] = 41624
					order[7] = 41614
					order[8] = 41625
					order[9] = 41635
					order[10] = 41617
					order[11] = 0
					super(41616, 41618, order)
				end

				class NoLegProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41615
						order[1] = 0
						super(41614, 41615, order)
					end
				end

				class NoLegProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41626
						order[1] = 41627
						order[2] = 41628
						order[3] = 41629
						order[4] = 41630
						order[5] = 41631
						order[6] = 41632
						order[7] = 41633
						order[8] = 0
						super(41625, 41626, order)
					end

					class NoLegProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41634
							order[1] = 0
							super(41633, 41634, order)
						end
					end
				end

				class NoLegProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41636
						order[1] = 41637
						order[2] = 0
						super(41635, 41636, order)
					end
				end
			end

			class NoLegCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 41345
					order[1] = 41346
					order[2] = 41347
					order[3] = 41348
					order[4] = 41349
					order[5] = 41350
					order[6] = 41351
					order[7] = 41352
					order[8] = 41353
					order[9] = 41354
					order[10] = 41355
					order[11] = 41342
					order[12] = 42308
					order[13] = 42309
					order[14] = 41356
					order[15] = 41357
					order[16] = 42299
					order[17] = 42300
					order[18] = 42301
					order[19] = 42302
					order[20] = 42303
					order[21] = 42304
					order[22] = 42305
					order[23] = 41358
					order[24] = 41359
					order[25] = 41360
					order[26] = 41361
					order[27] = 41362
					order[28] = 0
					super(41344, 41345, order)
				end

				class NoLegCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41343
						order[1] = 0
						super(41342, 41343, order)
					end
				end

				class NoLegCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42307
						order[1] = 0
						super(42306, 42307, order)
					end
				end
			end

			class NoLegPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41604
					order[1] = 41601
					order[2] = 41602
					order[3] = 41603
					order[4] = 41600
					order[5] = 0
					super(41599, 41604, order)
				end

				class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41605
						order[1] = 41606
						order[2] = 0
						super(41604, 41605, order)
					end
				end
			end

			class NoLegExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42389
					order[1] = 42390
					order[2] = 0
					super(42388, 42389, order)
				end
			end

			class NoLegContractualDefinitions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42199
					order[1] = 0
					super(42198, 42199, order)
				end
			end

			class NoLegFinancingTermSupplements < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42201
					order[1] = 42202
					order[2] = 0
					super(42200, 42201, order)
				end
			end

			class NoLegContractualMatrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42204
					order[1] = 42205
					order[2] = 42206
					order[3] = 0
					super(42203, 42204, order)
				end
			end
		end
	end
end

class QuoteStatusReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AI") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoTargetPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1462
			order[1] = 1463
			order[2] = 1464
			order[3] = 1818
			order[4] = 2433
			order[5] = 0
			super(1461, 1462, order)
		end

		class NoTargetPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2434
				order[1] = 2435
				order[2] = 0
				super(2433, 2434, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoStipulations < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 233
			order[1] = 234
			order[2] = 0
			super(232, 233, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(161)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 685
			order[153] = 687
			order[154] = 2346
			order[155] = 690
			order[156] = 587
			order[157] = 588
			order[158] = 683
			order[159] = 539
			order[160] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegStipulations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 688
				order[1] = 689
				order[2] = 0
				super(683, 688, order)
			end
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end

	class NoQuoteQualifiers < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 695
			order[1] = 0
			super(735, 695, order)
		end
	end

	class NoQuoteAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2707
			order[1] = 2708
			order[2] = 0
			super(2706, 2707, order)
		end
	end

	class NoPriceQualifiers < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2710
			order[1] = 0
			super(2709, 2710, order)
		end
	end

	class NoTrdRegTimestamps < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 769
			order[1] = 770
			order[2] = 771
			order[3] = 2839
			order[4] = 1033
			order[5] = 1034
			order[6] = 1035
			order[7] = 1727
			order[8] = 2831
			order[9] = 2832
			order[10] = 2833
			order[11] = 2834
			order[12] = 0
			super(768, 769, order)
		end
	end
end

class QuoteResponse < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AJ") )
	end

	class NoQuoteQualifiers < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 695
			order[1] = 0
			super(735, 695, order)
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoStipulations < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 233
			order[1] = 234
			order[2] = 0
			super(232, 233, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(173)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 685
			order[153] = 687
			order[154] = 2346
			order[155] = 690
			order[156] = 587
			order[157] = 588
			order[158] = 683
			order[159] = 539
			order[160] = 686
			order[161] = 681
			order[162] = 684
			order[163] = 676
			order[164] = 2951
			order[165] = 677
			order[166] = 678
			order[167] = 679
			order[168] = 680
			order[169] = 654
			order[170] = 1067
			order[171] = 1068
			order[172] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegStipulations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 688
				order[1] = 689
				order[2] = 0
				super(683, 688, order)
			end
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end

	class NoPriceQualifiers < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2710
			order[1] = 0
			super(2709, 2710, order)
		end
	end
end

class Confirmation < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AK") )
	end

	class NoRegulatoryTradeIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 1903
			order[1] = 1905
			order[2] = 1904
			order[3] = 1906
			order[4] = 2411
			order[5] = 2397
			order[6] = 0
			super(1907, 1903, order)
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoOrders < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 11
			order[1] = 37
			order[2] = 198
			order[3] = 526
			order[4] = 66
			order[5] = 756
			order[6] = 38
			order[7] = 799
			order[8] = 800
			order[9] = 40
			order[10] = 0
			super(73, 11, order)
		end

		class NoNested2PartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 757
				order[1] = 758
				order[2] = 759
				order[3] = 2381
				order[4] = 806
				order[5] = 0
				super(756, 757, order)
			end

			class NoNested2PartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 760
					order[1] = 807
					order[2] = 0
					super(806, 760, order)
				end
			end
		end
	end

	class NoExecs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(14)
			order[0] = 32
			order[1] = 17
			order[2] = 527
			order[3] = 31
			order[4] = 669
			order[5] = 29
			order[6] = 1003
			order[7] = 1041
			order[8] = 880
			order[9] = 2749
			order[10] = 2524
			order[11] = 2668
			order[12] = 1838
			order[13] = 0
			super(124, 32, order)
		end

		class NoTrdRegPublications < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2669
				order[1] = 2670
				order[2] = 0
				super(2668, 2669, order)
			end
		end

		class NoTradePriceConditions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 1839
				order[1] = 0
				super(1838, 1839, order)
			end
		end
	end

	class NoTrdRegTimestamps < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 769
			order[1] = 770
			order[2] = 771
			order[3] = 2839
			order[4] = 1033
			order[5] = 1034
			order[6] = 1035
			order[7] = 1727
			order[8] = 2831
			order[9] = 2832
			order[10] = 2833
			order[11] = 2834
			order[12] = 0
			super(768, 769, order)
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoInstrAttrib < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 871
			order[1] = 872
			order[2] = 0
			super(870, 871, order)
		end
	end

	class NoIndexRollMonths < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2733
			order[1] = 0
			super(2734, 2733, order)
		end
	end

	class NoReferenceDataDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2747
			order[1] = 2748
			order[2] = 0
			super(2746, 2747, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoCapacities < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 528
			order[1] = 529
			order[2] = 863
			order[3] = 0
			super(862, 528, order)
		end
	end

	class NoPriceQualifiers < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2710
			order[1] = 0
			super(2709, 2710, order)
		end
	end

	class NoDlvyInst < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 165
			order[1] = 787
			order[2] = 781
			order[3] = 0
			super(85, 165, order)
		end

		class NoSettlPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 782
				order[1] = 783
				order[2] = 784
				order[3] = 2389
				order[4] = 801
				order[5] = 0
				super(781, 782, order)
			end

			class NoSettlPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 785
					order[1] = 786
					order[2] = 0
					super(801, 785, order)
				end
			end
		end
	end

	class NoCommissions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(17)
			order[0] = 2640
			order[1] = 2641
			order[2] = 2725
			order[3] = 2642
			order[4] = 2643
			order[5] = 2923
			order[6] = 2644
			order[7] = 2645
			order[8] = 2924
			order[9] = 2646
			order[10] = 2647
			order[11] = 2648
			order[12] = 2649
			order[13] = 2650
			order[14] = 2651
			order[15] = 2652
			order[16] = 0
			super(2639, 2640, order)
		end
	end

	class NoStipulations < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 233
			order[1] = 234
			order[2] = 0
			super(232, 233, order)
		end
	end

	class NoMiscFees < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 137
			order[1] = 138
			order[2] = 139
			order[3] = 2712
			order[4] = 2633
			order[5] = 891
			order[6] = 2216
			order[7] = 2217
			order[8] = 2713
			order[9] = 0
			super(136, 137, order)
		end

		class NoMiscFeeSubTypes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2634
				order[1] = 2635
				order[2] = 2636
				order[3] = 2637
				order[4] = 2638
				order[5] = 0
				super(2633, 2634, order)
			end
		end
	end

	class NoMatchExceptions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 2773
			order[1] = 2774
			order[2] = 2775
			order[3] = 2776
			order[4] = 2777
			order[5] = 2778
			order[6] = 2779
			order[7] = 2780
			order[8] = 2797
			order[9] = 2798
			order[10] = 0
			super(2772, 2773, order)
		end
	end

	class NoMatchingDataPoints < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 2782
			order[1] = 2783
			order[2] = 2784
			order[3] = 2785
			order[4] = 0
			super(2781, 2782, order)
		end
	end
end

class PositionMaintenanceRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AL") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoRelatedInstruments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 1648
			order[1] = 1649
			order[2] = 1650
			order[3] = 1651
			order[4] = 1652
			order[5] = 1653
			order[6] = 2413
			order[7] = 2414
			order[8] = 2415
			order[9] = 2417
			order[10] = 0
			super(1647, 1648, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoTradingSessions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 336
			order[1] = 625
			order[2] = 0
			super(386, 336, order)
		end
	end

	class NoPositions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 703
			order[1] = 704
			order[2] = 705
			order[3] = 1654
			order[4] = 706
			order[5] = 976
			order[6] = 1836
			order[7] = 1835
			order[8] = 2936
			order[9] = 539
			order[10] = 0
			super(702, 703, order)
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end

	class NoPosAmt < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 707
			order[1] = 708
			order[2] = 2096
			order[3] = 1055
			order[4] = 2937
			order[5] = 2097
			order[6] = 2098
			order[7] = 1585
			order[8] = 2099
			order[9] = 2100
			order[10] = 2876
			order[11] = 2877
			order[12] = 0
			super(753, 707, order)
		end
	end
end

class PositionMaintenanceReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AM") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoRelatedInstruments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 1648
			order[1] = 1649
			order[2] = 1650
			order[3] = 1651
			order[4] = 1652
			order[5] = 1653
			order[6] = 2413
			order[7] = 2414
			order[8] = 2415
			order[9] = 2417
			order[10] = 0
			super(1647, 1648, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoTradingSessions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 336
			order[1] = 625
			order[2] = 0
			super(386, 336, order)
		end
	end

	class NoPositions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 703
			order[1] = 704
			order[2] = 705
			order[3] = 1654
			order[4] = 706
			order[5] = 976
			order[6] = 1836
			order[7] = 1835
			order[8] = 2936
			order[9] = 539
			order[10] = 0
			super(702, 703, order)
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end

	class NoPosAmt < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 707
			order[1] = 708
			order[2] = 2096
			order[3] = 1055
			order[4] = 2937
			order[5] = 2097
			order[6] = 2098
			order[7] = 1585
			order[8] = 2099
			order[9] = 2100
			order[10] = 2876
			order[11] = 2877
			order[12] = 0
			super(753, 707, order)
		end
	end

	class NoRegulatoryTradeIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 1903
			order[1] = 1905
			order[2] = 1904
			order[3] = 1906
			order[4] = 2411
			order[5] = 2397
			order[6] = 0
			super(1907, 1903, order)
		end
	end

	class NoPayments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(41)
			order[0] = 40213
			order[1] = 40993
			order[2] = 40214
			order[3] = 40215
			order[4] = 43087
			order[5] = 40216
			order[6] = 40217
			order[7] = 42598
			order[8] = 42599
			order[9] = 43097
			order[10] = 43098
			order[11] = 43100
			order[12] = 43099
			order[13] = 43101
			order[14] = 43105
			order[15] = 43104
			order[16] = 43103
			order[17] = 43102
			order[18] = 40218
			order[19] = 40919
			order[20] = 41155
			order[21] = 40219
			order[22] = 40220
			order[23] = 40944
			order[24] = 41156
			order[25] = 41157
			order[26] = 41158
			order[27] = 41159
			order[28] = 40222
			order[29] = 41160
			order[30] = 40224
			order[31] = 40225
			order[32] = 40226
			order[33] = 40227
			order[34] = 492
			order[35] = 40230
			order[36] = 41304
			order[37] = 40229
			order[38] = 40984
			order[39] = 40985
			order[40] = 0
			super(40212, 40213, order)
		end

		class NoPaymentBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40221
				order[1] = 0
				super(40944, 40221, order)
			end
		end

		class NoPaymentSettls < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40231
				order[1] = 40232
				order[2] = 40233
				order[3] = 0
				super(40230, 40231, order)
			end

			class NoPaymentSettlPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40234
					order[1] = 40235
					order[2] = 40236
					order[3] = 40237
					order[4] = 40238
					order[5] = 0
					super(40233, 40234, order)
				end

				class NoPaymentSettlPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40239
						order[1] = 40240
						order[2] = 0
						super(40238, 40239, order)
					end
				end
			end
		end
	end

	class NoRelatedTrades < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 1856
			order[1] = 1857
			order[2] = 2103
			order[3] = 1858
			order[4] = 1859
			order[5] = 1860
			order[6] = 0
			super(1855, 1856, order)
		end
	end
end

class RequestForPositions < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AN") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoTradingSessions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 336
			order[1] = 625
			order[2] = 0
			super(386, 336, order)
		end
	end
end

class RequestForPositionsAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AO") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end
end

class PositionReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AP") )
	end

	class NoTransactionAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2872
			order[1] = 2873
			order[2] = 0
			super(2871, 2872, order)
		end
	end

	class NoTrdRegTimestamps < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 769
			order[1] = 770
			order[2] = 771
			order[3] = 2839
			order[4] = 1033
			order[5] = 1034
			order[6] = 1035
			order[7] = 1727
			order[8] = 2831
			order[9] = 2832
			order[10] = 2833
			order[11] = 2834
			order[12] = 0
			super(768, 769, order)
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoRelatedInstruments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 1648
			order[1] = 1649
			order[2] = 1650
			order[3] = 1651
			order[4] = 1652
			order[5] = 1653
			order[6] = 2413
			order[7] = 2414
			order[8] = 2415
			order[9] = 2417
			order[10] = 0
			super(1647, 1648, order)
		end
	end

	class NoCollateralAmounts < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(17)
			order[0] = 1704
			order[1] = 1705
			order[2] = 2929
			order[3] = 2632
			order[4] = 2090
			order[5] = 2091
			order[6] = 1706
			order[7] = 2092
			order[8] = 2093
			order[9] = 1902
			order[10] = 2350
			order[11] = 2690
			order[12] = 2689
			order[13] = 2840
			order[14] = 2845
			order[15] = 2841
			order[16] = 0
			super(1703, 1704, order)
		end

		class NoCollateralReinvestments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2844
				order[1] = 2842
				order[2] = 2843
				order[3] = 2931
				order[4] = 0
				super(2845, 2844, order)
			end
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(192)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 732
			order[188] = 733
			order[189] = 1037
			order[190] = 984
			order[191] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end

		class NoUnderlyingAmounts < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 985
				order[1] = 986
				order[2] = 987
				order[3] = 988
				order[4] = 0
				super(984, 985, order)
			end
		end
	end

	class NoPositions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 703
			order[1] = 704
			order[2] = 705
			order[3] = 1654
			order[4] = 706
			order[5] = 976
			order[6] = 1836
			order[7] = 1835
			order[8] = 2936
			order[9] = 539
			order[10] = 0
			super(702, 703, order)
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end

	class NoPosAmt < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 707
			order[1] = 708
			order[2] = 2096
			order[3] = 1055
			order[4] = 2937
			order[5] = 2097
			order[6] = 2098
			order[7] = 1585
			order[8] = 2099
			order[9] = 2100
			order[10] = 2876
			order[11] = 2877
			order[12] = 0
			super(753, 707, order)
		end
	end

	class NoRegulatoryTradeIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 1903
			order[1] = 1905
			order[2] = 1904
			order[3] = 1906
			order[4] = 2411
			order[5] = 2397
			order[6] = 0
			super(1907, 1903, order)
		end
	end

	class NoPayments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(41)
			order[0] = 40213
			order[1] = 40993
			order[2] = 40214
			order[3] = 40215
			order[4] = 43087
			order[5] = 40216
			order[6] = 40217
			order[7] = 42598
			order[8] = 42599
			order[9] = 43097
			order[10] = 43098
			order[11] = 43100
			order[12] = 43099
			order[13] = 43101
			order[14] = 43105
			order[15] = 43104
			order[16] = 43103
			order[17] = 43102
			order[18] = 40218
			order[19] = 40919
			order[20] = 41155
			order[21] = 40219
			order[22] = 40220
			order[23] = 40944
			order[24] = 41156
			order[25] = 41157
			order[26] = 41158
			order[27] = 41159
			order[28] = 40222
			order[29] = 41160
			order[30] = 40224
			order[31] = 40225
			order[32] = 40226
			order[33] = 40227
			order[34] = 492
			order[35] = 40230
			order[36] = 41304
			order[37] = 40229
			order[38] = 40984
			order[39] = 40985
			order[40] = 0
			super(40212, 40213, order)
		end

		class NoPaymentBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40221
				order[1] = 0
				super(40944, 40221, order)
			end
		end

		class NoPaymentSettls < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40231
				order[1] = 40232
				order[2] = 40233
				order[3] = 0
				super(40230, 40231, order)
			end

			class NoPaymentSettlPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40234
					order[1] = 40235
					order[2] = 40236
					order[3] = 40237
					order[4] = 40238
					order[5] = 0
					super(40233, 40234, order)
				end

				class NoPaymentSettlPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40239
						order[1] = 40240
						order[2] = 0
						super(40238, 40239, order)
					end
				end
			end
		end
	end

	class NoRelatedTrades < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 1856
			order[1] = 1857
			order[2] = 2103
			order[3] = 1858
			order[4] = 1859
			order[5] = 1860
			order[6] = 0
			super(1855, 1856, order)
		end
	end
end

class TradeCaptureReportRequestAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AQ") )
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoInstrAttrib < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 871
			order[1] = 872
			order[2] = 0
			super(870, 871, order)
		end
	end

	class NoIndexRollMonths < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2733
			order[1] = 0
			super(2734, 2733, order)
		end
	end

	class NoReferenceDataDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2747
			order[1] = 2748
			order[2] = 0
			super(2746, 2747, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end
end

class TradeCaptureReportAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AR") )
	end

	class NoRootPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1117
			order[1] = 1118
			order[2] = 1119
			order[3] = 2388
			order[4] = 1120
			order[5] = 0
			super(1116, 1117, order)
		end

		class NoRootPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1121
				order[1] = 1122
				order[2] = 0
				super(1120, 1121, order)
			end
		end
	end

	class NoPriceQualifiers < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2710
			order[1] = 0
			super(2709, 2710, order)
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoInstrAttrib < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 871
			order[1] = 872
			order[2] = 0
			super(870, 871, order)
		end
	end

	class NoIndexRollMonths < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2733
			order[1] = 0
			super(2734, 2733, order)
		end
	end

	class NoReferenceDataDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2747
			order[1] = 2748
			order[2] = 0
			super(2746, 2747, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoTrdRepIndicators < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1388
			order[1] = 1389
			order[2] = 0
			super(1387, 1388, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(212)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 1586
			order[176] = 685
			order[177] = 687
			order[178] = 2346
			order[179] = 690
			order[180] = 990
			order[181] = 1152
			order[182] = 683
			order[183] = 2680
			order[184] = 1817
			order[185] = 564
			order[186] = 565
			order[187] = 539
			order[188] = 654
			order[189] = 587
			order[190] = 588
			order[191] = 637
			order[192] = 686
			order[193] = 675
			order[194] = 2900
			order[195] = 1073
			order[196] = 1074
			order[197] = 1075
			order[198] = 1689
			order[199] = 1379
			order[200] = 1381
			order[201] = 1383
			order[202] = 1384
			order[203] = 1418
			order[204] = 1591
			order[205] = 2358
			order[206] = 2357
			order[207] = 2360
			order[208] = 2359
			order[209] = 1342
			order[210] = 2492
			order[211] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end

		class NoLegPosAmt < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1587
				order[1] = 1588
				order[2] = 1589
				order[3] = 2938
				order[4] = 1590
				order[5] = 0
				super(1586, 1587, order)
			end
		end

		class NoLegStipulations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 688
				order[1] = 689
				order[2] = 0
				super(683, 688, order)
			end
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end

		class NoOfLegUnderlyings < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(16)
				order[0] = 1330
				order[1] = 1331
				order[2] = 1332
				order[3] = 1333
				order[4] = 1344
				order[5] = 1337
				order[6] = 1338
				order[7] = 1339
				order[8] = 1345
				order[9] = 1405
				order[10] = 1340
				order[11] = 1391
				order[12] = 1343
				order[13] = 1341
				order[14] = 1392
				order[15] = 0
				super(1342, 1330, order)
			end

			class NoUnderlyingLegSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1335
					order[1] = 1336
					order[2] = 0
					super(1334, 1335, order)
				end
			end
		end
	end

	class NoTrdRegTimestamps < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 769
			order[1] = 770
			order[2] = 771
			order[3] = 2839
			order[4] = 1033
			order[5] = 1034
			order[6] = 1035
			order[7] = 1727
			order[8] = 2831
			order[9] = 2832
			order[10] = 2833
			order[11] = 2834
			order[12] = 0
			super(768, 769, order)
		end
	end

	class NoPosAmt < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 707
			order[1] = 708
			order[2] = 2096
			order[3] = 1055
			order[4] = 2937
			order[5] = 2097
			order[6] = 2098
			order[7] = 1585
			order[8] = 2099
			order[9] = 2100
			order[10] = 2876
			order[11] = 2877
			order[12] = 0
			super(753, 707, order)
		end
	end

	class NoTradeQtys < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1842
			order[1] = 1843
			order[2] = 0
			super(1841, 1842, order)
		end
	end

	class NoSides < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(121)
			order[0] = 54
			order[1] = 1427
			order[2] = 1506
			order[3] = 1507
			order[4] = 1428
			order[5] = 1429
			order[6] = 453
			order[7] = 1
			order[8] = 660
			order[9] = 581
			order[10] = 1630
			order[11] = 81
			order[12] = 575
			order[13] = 576
			order[14] = 2671
			order[15] = 578
			order[16] = 579
			order[17] = 376
			order[18] = 2404
			order[19] = 2351
			order[20] = 2352
			order[21] = 377
			order[22] = 582
			order[23] = 336
			order[24] = 625
			order[25] = 943
			order[26] = 430
			order[27] = 1154
			order[28] = 2901
			order[29] = 1155
			order[30] = 2902
			order[31] = 12
			order[32] = 13
			order[33] = 479
			order[34] = 2922
			order[35] = 1233
			order[36] = 1238
			order[37] = 497
			order[38] = 2639
			order[39] = 157
			order[40] = 230
			order[41] = 158
			order[42] = 159
			order[43] = 738
			order[44] = 920
			order[45] = 921
			order[46] = 922
			order[47] = 238
			order[48] = 237
			order[49] = 118
			order[50] = 119
			order[51] = 155
			order[52] = 156
			order[53] = 77
			order[54] = 752
			order[55] = 518
			order[56] = 232
			order[57] = 136
			order[58] = 825
			order[59] = 1158
			order[60] = 826
			order[61] = 1730
			order[62] = 2771
			order[63] = 2759
			order[64] = 2767
			order[65] = 1853
			order[66] = 1854
			order[67] = 1852
			order[68] = 591
			order[69] = 70
			order[70] = 78
			order[71] = 1072
			order[72] = 1057
			order[73] = 1009
			order[74] = 1005
			order[75] = 1006
			order[76] = 1007
			order[77] = 83
			order[78] = 1008
			order[79] = 1115
			order[80] = 1851
			order[81] = 37
			order[82] = 198
			order[83] = 11
			order[84] = 526
			order[85] = 66
			order[86] = 1080
			order[87] = 1081
			order[88] = 1431
			order[89] = 1091
			order[90] = 40
			order[91] = 44
			order[92] = 99
			order[93] = 18
			order[94] = 39
			order[95] = 151
			order[96] = 14
			order[97] = 59
			order[98] = 126
			order[99] = 2362
			order[100] = 2964
			order[101] = 1629
			order[102] = 1916
			order[103] = 528
			order[104] = 529
			order[105] = 775
			order[106] = 1432
			order[107] = 1724
			order[108] = 2704
			order[109] = 821
			order[110] = 1093
			order[111] = 483
			order[112] = 586
			order[113] = 2766
			order[114] = 1016
			order[115] = 1031
			order[116] = 1032
			order[117] = 1855
			order[118] = 1861
			order[119] = 2344
			order[120] = 0
			super(552, 54, order)
		end

		class NoPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 448
				order[1] = 447
				order[2] = 452
				order[3] = 2376
				order[4] = 802
				order[5] = 0
				super(453, 448, order)
			end

			class NoPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 523
					order[1] = 803
					order[2] = 0
					super(802, 523, order)
				end
			end
		end

		class NoLimitAmts < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 1631
				order[1] = 1632
				order[2] = 1633
				order[3] = 2394
				order[4] = 2395
				order[5] = 1634
				order[6] = 2935
				order[7] = 2396
				order[8] = 0
				super(1630, 1631, order)
			end
		end

		class NoClearingInstructions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 577
				order[1] = 0
				super(576, 577, order)
			end
		end

		class NoCommissions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(17)
				order[0] = 2640
				order[1] = 2641
				order[2] = 2725
				order[3] = 2642
				order[4] = 2643
				order[5] = 2923
				order[6] = 2644
				order[7] = 2645
				order[8] = 2924
				order[9] = 2646
				order[10] = 2647
				order[11] = 2648
				order[12] = 2649
				order[13] = 2650
				order[14] = 2651
				order[15] = 2652
				order[16] = 0
				super(2639, 2640, order)
			end
		end

		class NoContAmts < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 519
				order[1] = 520
				order[2] = 521
				order[3] = 0
				super(518, 519, order)
			end
		end

		class NoStipulations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 233
				order[1] = 234
				order[2] = 0
				super(232, 233, order)
			end
		end

		class NoMiscFees < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 137
				order[1] = 138
				order[2] = 139
				order[3] = 2712
				order[4] = 2633
				order[5] = 891
				order[6] = 2216
				order[7] = 2217
				order[8] = 2713
				order[9] = 0
				super(136, 137, order)
			end

			class NoMiscFeeSubTypes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 2634
					order[1] = 2635
					order[2] = 2636
					order[3] = 2637
					order[4] = 2638
					order[5] = 0
					super(2633, 2634, order)
				end
			end
		end

		class NoSettlDetails < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1164
				order[1] = 169
				order[2] = 170
				order[3] = 171
				order[4] = 781
				order[5] = 0
				super(1158, 1164, order)
			end

			class NoSettlPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 782
					order[1] = 783
					order[2] = 784
					order[3] = 2389
					order[4] = 801
					order[5] = 0
					super(781, 782, order)
				end

				class NoSettlPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 785
						order[1] = 786
						order[2] = 0
						super(801, 785, order)
					end
				end
			end
		end

		class NoAllocs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(34)
				order[0] = 79
				order[1] = 661
				order[2] = 736
				order[3] = 2927
				order[4] = 467
				order[5] = 1593
				order[6] = 2727
				order[7] = 1908
				order[8] = 1729
				order[9] = 756
				order[10] = 209
				order[11] = 80
				order[12] = 2515
				order[13] = 1752
				order[14] = 1753
				order[15] = 1754
				order[16] = 1755
				order[17] = 993
				order[18] = 1002
				order[19] = 989
				order[20] = 1136
				order[21] = 1844
				order[22] = 1840
				order[23] = 1735
				order[24] = 161
				order[25] = 360
				order[26] = 361
				order[27] = 1732
				order[28] = 1733
				order[29] = 1734
				order[30] = 2392
				order[31] = 2393
				order[32] = 2653
				order[33] = 0
				super(78, 79, order)
			end

			class NoAllocRegulatoryTradeIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(7)
					order[0] = 1909
					order[1] = 1910
					order[2] = 1911
					order[3] = 1912
					order[4] = 2406
					order[5] = 2399
					order[6] = 0
					super(1908, 1909, order)
				end
			end

			class NoNested2PartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 757
					order[1] = 758
					order[2] = 759
					order[3] = 2381
					order[4] = 806
					order[5] = 0
					super(756, 757, order)
				end

				class NoNested2PartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 760
						order[1] = 807
						order[2] = 0
						super(806, 760, order)
					end
				end
			end

			class NoTradeAllocAmts < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 1845
					order[1] = 1846
					order[2] = 1847
					order[3] = 2933
					order[4] = 1850
					order[5] = 0
					super(1844, 1845, order)
				end
			end

			class NoAllocCommissions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(17)
					order[0] = 2654
					order[1] = 2655
					order[2] = 2726
					order[3] = 2656
					order[4] = 2657
					order[5] = 2925
					order[6] = 2658
					order[7] = 2659
					order[8] = 2926
					order[9] = 2660
					order[10] = 2661
					order[11] = 2662
					order[12] = 2663
					order[13] = 2664
					order[14] = 2665
					order[15] = 2666
					order[16] = 0
					super(2653, 2654, order)
				end
			end
		end

		class NoOrders < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 2887
				order[1] = 2888
				order[2] = 2836
				order[3] = 2889
				order[4] = 2890
				order[5] = 2835
				order[6] = 0
				super(73, 2887, order)
			end
		end

		class NoMatchInst < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1625
				order[1] = 1673
				order[2] = 1626
				order[3] = 1627
				order[4] = 0
				super(1624, 1625, order)
			end
		end

		class NoOrderAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2594
				order[1] = 2595
				order[2] = 0
				super(2593, 2594, order)
			end
		end

		class NoSideTrdRegTS < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1012
				order[1] = 1013
				order[2] = 1014
				order[3] = 0
				super(1016, 1012, order)
			end
		end

		class NoRelatedTrades < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 1856
				order[1] = 1857
				order[2] = 2103
				order[3] = 1858
				order[4] = 1859
				order[5] = 1860
				order[6] = 0
				super(1855, 1856, order)
			end
		end

		class NoRelatedPositions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1862
				order[1] = 1863
				order[2] = 1864
				order[3] = 0
				super(1861, 1862, order)
			end
		end
	end
end

class AllocationReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AS") )
	end

	class NoOrders < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 11
			order[1] = 37
			order[2] = 198
			order[3] = 526
			order[4] = 66
			order[5] = 756
			order[6] = 38
			order[7] = 799
			order[8] = 800
			order[9] = 40
			order[10] = 0
			super(73, 11, order)
		end

		class NoNested2PartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 757
				order[1] = 758
				order[2] = 759
				order[3] = 2381
				order[4] = 806
				order[5] = 0
				super(756, 757, order)
			end

			class NoNested2PartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 760
					order[1] = 807
					order[2] = 0
					super(806, 760, order)
				end
			end
		end
	end

	class NoExecs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(14)
			order[0] = 32
			order[1] = 17
			order[2] = 527
			order[3] = 31
			order[4] = 669
			order[5] = 29
			order[6] = 1003
			order[7] = 1041
			order[8] = 880
			order[9] = 2749
			order[10] = 2524
			order[11] = 2668
			order[12] = 1838
			order[13] = 0
			super(124, 32, order)
		end

		class NoTrdRegPublications < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2669
				order[1] = 2670
				order[2] = 0
				super(2668, 2669, order)
			end
		end

		class NoTradePriceConditions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 1839
				order[1] = 0
				super(1838, 1839, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoInstrAttrib < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 871
			order[1] = 872
			order[2] = 0
			super(870, 871, order)
		end
	end

	class NoIndexRollMonths < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2733
			order[1] = 0
			super(2734, 2733, order)
		end
	end

	class NoReferenceDataDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2747
			order[1] = 2748
			order[2] = 0
			super(2746, 2747, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoPriceQualifiers < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2710
			order[1] = 0
			super(2709, 2710, order)
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoStipulations < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 233
			order[1] = 234
			order[2] = 0
			super(232, 233, order)
		end
	end

	class NoRegulatoryTradeIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 1903
			order[1] = 1905
			order[2] = 1904
			order[3] = 1906
			order[4] = 2411
			order[5] = 2397
			order[6] = 0
			super(1907, 1903, order)
		end
	end

	class NoPosAmt < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 707
			order[1] = 708
			order[2] = 2096
			order[3] = 1055
			order[4] = 2937
			order[5] = 2097
			order[6] = 2098
			order[7] = 1585
			order[8] = 2099
			order[9] = 2100
			order[10] = 2876
			order[11] = 2877
			order[12] = 0
			super(753, 707, order)
		end
	end

	class NoAllocs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(67)
			order[0] = 79
			order[1] = 661
			order[2] = 573
			order[3] = 366
			order[4] = 80
			order[5] = 2515
			order[6] = 1752
			order[7] = 1753
			order[8] = 1754
			order[9] = 1755
			order[10] = 467
			order[11] = 1729
			order[12] = 1593
			order[13] = 2727
			order[14] = 1908
			order[15] = 81
			order[16] = 989
			order[17] = 1002
			order[18] = 1735
			order[19] = 993
			order[20] = 1047
			order[21] = 992
			order[22] = 539
			order[23] = 208
			order[24] = 209
			order[25] = 161
			order[26] = 360
			order[27] = 361
			order[28] = 1732
			order[29] = 1733
			order[30] = 1734
			order[31] = 12
			order[32] = 13
			order[33] = 479
			order[34] = 2922
			order[35] = 1233
			order[36] = 1238
			order[37] = 497
			order[38] = 2653
			order[39] = 153
			order[40] = 154
			order[41] = 119
			order[42] = 2300
			order[43] = 737
			order[44] = 120
			order[45] = 736
			order[46] = 2927
			order[47] = 155
			order[48] = 156
			order[49] = 742
			order[50] = 741
			order[51] = 136
			order[52] = 576
			order[53] = 635
			order[54] = 780
			order[55] = 172
			order[56] = 169
			order[57] = 170
			order[58] = 171
			order[59] = 2392
			order[60] = 2393
			order[61] = 2483
			order[62] = 2761
			order[63] = 2770
			order[64] = 2769
			order[65] = 1844
			order[66] = 0
			super(78, 79, order)
		end

		class NoAllocRegulatoryTradeIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 1909
				order[1] = 1910
				order[2] = 1911
				order[3] = 1912
				order[4] = 2406
				order[5] = 2399
				order[6] = 0
				super(1908, 1909, order)
			end
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end

		class NoAllocCommissions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(17)
				order[0] = 2654
				order[1] = 2655
				order[2] = 2726
				order[3] = 2656
				order[4] = 2657
				order[5] = 2925
				order[6] = 2658
				order[7] = 2659
				order[8] = 2926
				order[9] = 2660
				order[10] = 2661
				order[11] = 2662
				order[12] = 2663
				order[13] = 2664
				order[14] = 2665
				order[15] = 2666
				order[16] = 0
				super(2653, 2654, order)
			end
		end

		class NoMiscFees < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 137
				order[1] = 138
				order[2] = 139
				order[3] = 2712
				order[4] = 2633
				order[5] = 891
				order[6] = 2216
				order[7] = 2217
				order[8] = 2713
				order[9] = 0
				super(136, 137, order)
			end

			class NoMiscFeeSubTypes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 2634
					order[1] = 2635
					order[2] = 2636
					order[3] = 2637
					order[4] = 2638
					order[5] = 0
					super(2633, 2634, order)
				end
			end
		end

		class NoClearingInstructions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 577
				order[1] = 0
				super(576, 577, order)
			end
		end

		class NoDlvyInst < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 165
				order[1] = 787
				order[2] = 781
				order[3] = 0
				super(85, 165, order)
			end

			class NoSettlPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 782
					order[1] = 783
					order[2] = 784
					order[3] = 2389
					order[4] = 801
					order[5] = 0
					super(781, 782, order)
				end

				class NoSettlPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 785
						order[1] = 786
						order[2] = 0
						super(801, 785, order)
					end
				end
			end
		end

		class NoTradeAllocAmts < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1845
				order[1] = 1846
				order[2] = 1847
				order[3] = 2933
				order[4] = 1850
				order[5] = 0
				super(1844, 1845, order)
			end
		end
	end

	class NoRateSources < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1446
			order[1] = 1447
			order[2] = 1448
			order[3] = 2412
			order[4] = 2796
			order[5] = 0
			super(1445, 1446, order)
		end
	end
end

class AllocationReportAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AT") )
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoRegulatoryTradeIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 1903
			order[1] = 1905
			order[2] = 1904
			order[3] = 1906
			order[4] = 2411
			order[5] = 2397
			order[6] = 0
			super(1907, 1903, order)
		end
	end

	class NoAllocs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(31)
			order[0] = 79
			order[1] = 661
			order[2] = 366
			order[3] = 1047
			order[4] = 467
			order[5] = 1593
			order[6] = 1729
			order[7] = 1832
			order[8] = 2727
			order[9] = 1908
			order[10] = 776
			order[11] = 539
			order[12] = 209
			order[13] = 161
			order[14] = 360
			order[15] = 361
			order[16] = 1732
			order[17] = 1733
			order[18] = 1734
			order[19] = 989
			order[20] = 993
			order[21] = 992
			order[22] = 80
			order[23] = 2515
			order[24] = 1752
			order[25] = 1753
			order[26] = 1754
			order[27] = 1755
			order[28] = 2770
			order[29] = 2769
			order[30] = 0
			super(78, 79, order)
		end

		class NoAllocRegulatoryTradeIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 1909
				order[1] = 1910
				order[2] = 1911
				order[3] = 1912
				order[4] = 2406
				order[5] = 2399
				order[6] = 0
				super(1908, 1909, order)
			end
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end
end

class ConfirmationAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AU") )
	end

	class NoRegulatoryTradeIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 1903
			order[1] = 1905
			order[2] = 1904
			order[3] = 1906
			order[4] = 2411
			order[5] = 2397
			order[6] = 0
			super(1907, 1903, order)
		end
	end

	class NoMatchExceptions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 2773
			order[1] = 2774
			order[2] = 2775
			order[3] = 2776
			order[4] = 2777
			order[5] = 2778
			order[6] = 2779
			order[7] = 2780
			order[8] = 2797
			order[9] = 2798
			order[10] = 0
			super(2772, 2773, order)
		end
	end

	class NoMatchingDataPoints < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 2782
			order[1] = 2783
			order[2] = 2784
			order[3] = 2785
			order[4] = 0
			super(2781, 2782, order)
		end
	end
end

class SettlementInstructionRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AV") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end
end

class AssignmentReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AW") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoPositions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 703
			order[1] = 704
			order[2] = 705
			order[3] = 1654
			order[4] = 706
			order[5] = 976
			order[6] = 1836
			order[7] = 1835
			order[8] = 2936
			order[9] = 539
			order[10] = 0
			super(702, 703, order)
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end

	class NoPosAmt < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 707
			order[1] = 708
			order[2] = 2096
			order[3] = 1055
			order[4] = 2937
			order[5] = 2097
			order[6] = 2098
			order[7] = 1585
			order[8] = 2099
			order[9] = 2100
			order[10] = 2876
			order[11] = 2877
			order[12] = 0
			super(753, 707, order)
		end
	end
end

class CollateralRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AX") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoExecs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 17
			order[1] = 0
			super(124, 17, order)
		end
	end

	class NoTrades < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 571
			order[1] = 818
			order[2] = 0
			super(897, 571, order)
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(189)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 944
			order[188] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoTrdRegTimestamps < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 769
			order[1] = 770
			order[2] = 771
			order[3] = 2839
			order[4] = 1033
			order[5] = 1034
			order[6] = 1035
			order[7] = 1727
			order[8] = 2831
			order[9] = 2832
			order[10] = 2833
			order[11] = 2834
			order[12] = 0
			super(768, 769, order)
		end
	end

	class NoMiscFees < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 137
			order[1] = 138
			order[2] = 139
			order[3] = 2712
			order[4] = 2633
			order[5] = 891
			order[6] = 2216
			order[7] = 2217
			order[8] = 2713
			order[9] = 0
			super(136, 137, order)
		end

		class NoMiscFeeSubTypes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2634
				order[1] = 2635
				order[2] = 2636
				order[3] = 2637
				order[4] = 2638
				order[5] = 0
				super(2633, 2634, order)
			end
		end
	end

	class NoStipulations < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 233
			order[1] = 234
			order[2] = 0
			super(232, 233, order)
		end
	end
end

class CollateralAssignment < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AY") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoExecs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 17
			order[1] = 0
			super(124, 17, order)
		end
	end

	class NoTrades < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 571
			order[1] = 818
			order[2] = 0
			super(897, 571, order)
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(189)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 944
			order[188] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoTrdRegTimestamps < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 769
			order[1] = 770
			order[2] = 771
			order[3] = 2839
			order[4] = 1033
			order[5] = 1034
			order[6] = 1035
			order[7] = 1727
			order[8] = 2831
			order[9] = 2832
			order[10] = 2833
			order[11] = 2834
			order[12] = 0
			super(768, 769, order)
		end
	end

	class NoMiscFees < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 137
			order[1] = 138
			order[2] = 139
			order[3] = 2712
			order[4] = 2633
			order[5] = 891
			order[6] = 2216
			order[7] = 2217
			order[8] = 2713
			order[9] = 0
			super(136, 137, order)
		end

		class NoMiscFeeSubTypes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2634
				order[1] = 2635
				order[2] = 2636
				order[3] = 2637
				order[4] = 2638
				order[5] = 0
				super(2633, 2634, order)
			end
		end
	end

	class NoStipulations < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 233
			order[1] = 234
			order[2] = 0
			super(232, 233, order)
		end
	end

	class NoDlvyInst < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 165
			order[1] = 787
			order[2] = 781
			order[3] = 0
			super(85, 165, order)
		end

		class NoSettlPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 782
				order[1] = 783
				order[2] = 784
				order[3] = 2389
				order[4] = 801
				order[5] = 0
				super(781, 782, order)
			end

			class NoSettlPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 785
					order[1] = 786
					order[2] = 0
					super(801, 785, order)
				end
			end
		end
	end
end

class CollateralResponse < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("AZ") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoExecs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 17
			order[1] = 0
			super(124, 17, order)
		end
	end

	class NoTrades < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 571
			order[1] = 818
			order[2] = 0
			super(897, 571, order)
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(189)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 944
			order[188] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoCollateralAmounts < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(17)
			order[0] = 1704
			order[1] = 1705
			order[2] = 2929
			order[3] = 2632
			order[4] = 2090
			order[5] = 2091
			order[6] = 1706
			order[7] = 2092
			order[8] = 2093
			order[9] = 1902
			order[10] = 2350
			order[11] = 2690
			order[12] = 2689
			order[13] = 2840
			order[14] = 2845
			order[15] = 2841
			order[16] = 0
			super(1703, 1704, order)
		end

		class NoCollateralReinvestments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2844
				order[1] = 2842
				order[2] = 2843
				order[3] = 2931
				order[4] = 0
				super(2845, 2844, order)
			end
		end
	end

	class NoTrdRegTimestamps < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 769
			order[1] = 770
			order[2] = 771
			order[3] = 2839
			order[4] = 1033
			order[5] = 1034
			order[6] = 1035
			order[7] = 1727
			order[8] = 2831
			order[9] = 2832
			order[10] = 2833
			order[11] = 2834
			order[12] = 0
			super(768, 769, order)
		end
	end

	class NoMiscFees < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 137
			order[1] = 138
			order[2] = 139
			order[3] = 2712
			order[4] = 2633
			order[5] = 891
			order[6] = 2216
			order[7] = 2217
			order[8] = 2713
			order[9] = 0
			super(136, 137, order)
		end

		class NoMiscFeeSubTypes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2634
				order[1] = 2635
				order[2] = 2636
				order[3] = 2637
				order[4] = 2638
				order[5] = 0
				super(2633, 2634, order)
			end
		end
	end

	class NoStipulations < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 233
			order[1] = 234
			order[2] = 0
			super(232, 233, order)
		end
	end
end

class CollateralReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BA") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoExecs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 17
			order[1] = 0
			super(124, 17, order)
		end
	end

	class NoTrades < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 571
			order[1] = 818
			order[2] = 0
			super(897, 571, order)
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoCollateralAmounts < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(17)
			order[0] = 1704
			order[1] = 1705
			order[2] = 2929
			order[3] = 2632
			order[4] = 2090
			order[5] = 2091
			order[6] = 1706
			order[7] = 2092
			order[8] = 2093
			order[9] = 1902
			order[10] = 2350
			order[11] = 2690
			order[12] = 2689
			order[13] = 2840
			order[14] = 2845
			order[15] = 2841
			order[16] = 0
			super(1703, 1704, order)
		end

		class NoCollateralReinvestments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2844
				order[1] = 2842
				order[2] = 2843
				order[3] = 2931
				order[4] = 0
				super(2845, 2844, order)
			end
		end
	end

	class NoRegulatoryTradeIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 1903
			order[1] = 1905
			order[2] = 1904
			order[3] = 1906
			order[4] = 2411
			order[5] = 2397
			order[6] = 0
			super(1907, 1903, order)
		end
	end

	class NoTrdRegTimestamps < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 769
			order[1] = 770
			order[2] = 771
			order[3] = 2839
			order[4] = 1033
			order[5] = 1034
			order[6] = 1035
			order[7] = 1727
			order[8] = 2831
			order[9] = 2832
			order[10] = 2833
			order[11] = 2834
			order[12] = 0
			super(768, 769, order)
		end
	end

	class NoMiscFees < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 137
			order[1] = 138
			order[2] = 139
			order[3] = 2712
			order[4] = 2633
			order[5] = 891
			order[6] = 2216
			order[7] = 2217
			order[8] = 2713
			order[9] = 0
			super(136, 137, order)
		end

		class NoMiscFeeSubTypes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2634
				order[1] = 2635
				order[2] = 2636
				order[3] = 2637
				order[4] = 2638
				order[5] = 0
				super(2633, 2634, order)
			end
		end
	end

	class NoStipulations < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 233
			order[1] = 234
			order[2] = 0
			super(232, 233, order)
		end
	end

	class NoDlvyInst < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 165
			order[1] = 787
			order[2] = 781
			order[3] = 0
			super(85, 165, order)
		end

		class NoSettlPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 782
				order[1] = 783
				order[2] = 784
				order[3] = 2389
				order[4] = 801
				order[5] = 0
				super(781, 782, order)
			end

			class NoSettlPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 785
					order[1] = 786
					order[2] = 0
					super(801, 785, order)
				end
			end
		end
	end

	class NoFundingSources < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 2846
			order[1] = 2848
			order[2] = 2847
			order[3] = 2954
			order[4] = 0
			super(2849, 2846, order)
		end
	end

	class NoTransactionAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2872
			order[1] = 2873
			order[2] = 0
			super(2871, 2872, order)
		end
	end
end

class CollateralInquiry < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BB") )
	end

	class NoCollInquiryQualifier < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 896
			order[1] = 0
			super(938, 896, order)
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoExecs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 17
			order[1] = 0
			super(124, 17, order)
		end
	end

	class NoTrades < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 571
			order[1] = 818
			order[2] = 0
			super(897, 571, order)
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoTrdRegTimestamps < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 769
			order[1] = 770
			order[2] = 771
			order[3] = 2839
			order[4] = 1033
			order[5] = 1034
			order[6] = 1035
			order[7] = 1727
			order[8] = 2831
			order[9] = 2832
			order[10] = 2833
			order[11] = 2834
			order[12] = 0
			super(768, 769, order)
		end
	end

	class NoStipulations < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 233
			order[1] = 234
			order[2] = 0
			super(232, 233, order)
		end
	end

	class NoDlvyInst < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 165
			order[1] = 787
			order[2] = 781
			order[3] = 0
			super(85, 165, order)
		end

		class NoSettlPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 782
				order[1] = 783
				order[2] = 784
				order[3] = 2389
				order[4] = 801
				order[5] = 0
				super(781, 782, order)
			end

			class NoSettlPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 785
					order[1] = 786
					order[2] = 0
					super(801, 785, order)
				end
			end
		end
	end
end

class NetworkCounterpartySystemStatusRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BC") )
	end

	class NoCompIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 930
			order[1] = 931
			order[2] = 283
			order[3] = 284
			order[4] = 0
			super(936, 930, order)
		end
	end
end

class NetworkCounterpartySystemStatusResponse < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BD") )
	end

	class NoCompIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 930
			order[1] = 931
			order[2] = 283
			order[3] = 284
			order[4] = 928
			order[5] = 929
			order[6] = 0
			super(936, 930, order)
		end
	end
end

class UserRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BE") )
	end
end

class UserResponse < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BF") )
	end

	class NoThrottles < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 1611
			order[1] = 1612
			order[2] = 1613
			order[3] = 1614
			order[4] = 1615
			order[5] = 1618
			order[6] = 0
			super(1610, 1611, order)
		end

		class NoThrottleMsgType < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 1619
				order[1] = 0
				super(1618, 1619, order)
			end
		end
	end
end

class CollateralInquiryAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BG") )
	end

	class NoCollInquiryQualifier < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 896
			order[1] = 0
			super(938, 896, order)
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoExecs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 17
			order[1] = 0
			super(124, 17, order)
		end
	end

	class NoTrades < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 571
			order[1] = 818
			order[2] = 0
			super(897, 571, order)
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end
end

class ConfirmationRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BH") )
	end

	class NoOrders < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 11
			order[1] = 37
			order[2] = 198
			order[3] = 526
			order[4] = 66
			order[5] = 756
			order[6] = 38
			order[7] = 799
			order[8] = 800
			order[9] = 40
			order[10] = 0
			super(73, 11, order)
		end

		class NoNested2PartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 757
				order[1] = 758
				order[2] = 759
				order[3] = 2381
				order[4] = 806
				order[5] = 0
				super(756, 757, order)
			end

			class NoNested2PartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 760
					order[1] = 807
					order[2] = 0
					super(806, 760, order)
				end
			end
		end
	end
end

class ContraryIntentionReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BO") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoExpiration < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 982
			order[1] = 983
			order[2] = 0
			super(981, 982, order)
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end
end

class SecurityDefinitionUpdateReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BP") )
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoInstrAttrib < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 871
			order[1] = 872
			order[2] = 0
			super(870, 871, order)
		end
	end

	class NoIndexRollMonths < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2733
			order[1] = 0
			super(2734, 2733, order)
		end
	end

	class NoReferenceDataDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2747
			order[1] = 2748
			order[2] = 0
			super(2746, 2747, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoRelatedInstruments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 1648
			order[1] = 1649
			order[2] = 1650
			order[3] = 1651
			order[4] = 1652
			order[5] = 1653
			order[6] = 2413
			order[7] = 2414
			order[8] = 2415
			order[9] = 2417
			order[10] = 0
			super(1647, 1648, order)
		end
	end

	class NoStipulations < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 233
			order[1] = 234
			order[2] = 0
			super(232, 233, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoMarketSegments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 1301
			order[1] = 1300
			order[2] = 1201
			order[3] = 0
			super(1310, 1301, order)
		end

		class NoTickRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(8)
				order[0] = 1206
				order[1] = 1207
				order[2] = 1208
				order[3] = 1209
				order[4] = 2571
				order[5] = 1830
				order[6] = 1831
				order[7] = 0
				super(1205, 1206, order)
			end
		end

		class NoLotTypeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1093
				order[1] = 1231
				order[2] = 0
				super(1234, 1093, order)
			end
		end

		class NoPriceRangeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 2551
				order[1] = 2552
				order[2] = 2553
				order[3] = 2554
				order[4] = 2556
				order[5] = 2555
				order[6] = 0
				super(2550, 2551, order)
			end
		end

		class NoQuoteSizeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 647
				order[1] = 648
				order[2] = 2447
				order[3] = 0
				super(2558, 647, order)
			end
		end

		class NoTradingSessionRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 336
				order[1] = 625
				order[2] = 0
				super(1309, 336, order)
			end

			class NoOrdTypeRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40
					order[1] = 0
					super(1237, 40, order)
				end
			end

			class NoTimeInForceRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 59
					order[1] = 0
					super(1239, 59, order)
				end
			end

			class NoExecInstRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 1308
					order[1] = 0
					super(1232, 1308, order)
				end
			end

			class NoAuctionTypeRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1803
					order[1] = 2549
					order[2] = 0
					super(2548, 1803, order)
				end
			end

			class NoMatchRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 1142
					order[1] = 574
					order[2] = 2569
					order[3] = 2570
					order[4] = 0
					super(1235, 1142, order)
				end
			end

			class NoMDFeedTypes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 1022
					order[1] = 1683
					order[2] = 264
					order[3] = 2563
					order[4] = 2564
					order[5] = 2565
					order[6] = 2566
					order[7] = 1021
					order[8] = 1173
					order[9] = 2567
					order[10] = 2568
					order[11] = 0
					super(1141, 1022, order)
				end
			end
		end

		class NoNestedInstrAttrib < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1210
				order[1] = 1211
				order[2] = 0
				super(1312, 1210, order)
			end
		end

		class NoStrikeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 1223
				order[1] = 1202
				order[2] = 1203
				order[3] = 1204
				order[4] = 1304
				order[5] = 1236
				order[6] = 0
				super(1201, 1223, order)
			end

			class NoMaturityRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(7)
					order[0] = 1222
					order[1] = 1303
					order[2] = 1302
					order[3] = 1241
					order[4] = 1226
					order[5] = 1229
					order[6] = 0
					super(1236, 1222, order)
				end
			end
		end
	end
end

class SecurityListUpdateReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BK") )
	end

	class NoRelatedSym < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(209)
			order[0] = 1324
			order[1] = 55
			order[2] = 65
			order[3] = 48
			order[4] = 22
			order[5] = 460
			order[6] = 1227
			order[7] = 1151
			order[8] = 461
			order[9] = 2891
			order[10] = 167
			order[11] = 762
			order[12] = 200
			order[13] = 541
			order[14] = 1079
			order[15] = 966
			order[16] = 1049
			order[17] = 965
			order[18] = 224
			order[19] = 1449
			order[20] = 1450
			order[21] = 1451
			order[22] = 1452
			order[23] = 1457
			order[24] = 1458
			order[25] = 1739
			order[26] = 2210
			order[27] = 1938
			order[28] = 1939
			order[29] = 1940
			order[30] = 2735
			order[31] = 1941
			order[32] = 1575
			order[33] = 1942
			order[34] = 1943
			order[35] = 1944
			order[36] = 1945
			order[37] = 1946
			order[38] = 1947
			order[39] = 1948
			order[40] = 1949
			order[41] = 1950
			order[42] = 2879
			order[43] = 1951
			order[44] = 1952
			order[45] = 1953
			order[46] = 1954
			order[47] = 1955
			order[48] = 1956
			order[49] = 1957
			order[50] = 1958
			order[51] = 1959
			order[52] = 1960
			order[53] = 1577
			order[54] = 1580
			order[55] = 1581
			order[56] = 1678
			order[57] = 1697
			order[58] = 225
			order[59] = 239
			order[60] = 226
			order[61] = 227
			order[62] = 228
			order[63] = 255
			order[64] = 543
			order[65] = 470
			order[66] = 471
			order[67] = 472
			order[68] = 240
			order[69] = 202
			order[70] = 2578
			order[71] = 2577
			order[72] = 947
			order[73] = 2904
			order[74] = 967
			order[75] = 968
			order[76] = 1698
			order[77] = 1866
			order[78] = 2600
			order[79] = 2001
			order[80] = 2601
			order[81] = 1478
			order[82] = 1479
			order[83] = 1480
			order[84] = 1481
			order[85] = 206
			order[86] = 231
			order[87] = 1435
			order[88] = 2353
			order[89] = 1439
			order[90] = 969
			order[91] = 1146
			order[92] = 996
			order[93] = 1147
			order[94] = 1716
			order[95] = 2905
			order[96] = 1191
			order[97] = 1192
			order[98] = 1717
			order[99] = 2906
			order[100] = 1193
			order[101] = 2579
			order[102] = 1194
			order[103] = 1482
			order[104] = 1195
			order[105] = 2753
			order[106] = 1196
			order[107] = 1197
			order[108] = 2002
			order[109] = 2140
			order[110] = 1524
			order[111] = 2907
			order[112] = 1198
			order[113] = 1199
			order[114] = 1200
			order[115] = 201
			order[116] = 2681
			order[117] = 2685
			order[118] = 1244
			order[119] = 1242
			order[120] = 2575
			order[121] = 2574
			order[122] = 997
			order[123] = 223
			order[124] = 207
			order[125] = 970
			order[126] = 971
			order[127] = 106
			order[128] = 348
			order[129] = 349
			order[130] = 2737
			order[131] = 2714
			order[132] = 2715
			order[133] = 2716
			order[134] = 107
			order[135] = 350
			order[136] = 351
			order[137] = 691
			order[138] = 667
			order[139] = 875
			order[140] = 876
			order[141] = 873
			order[142] = 874
			order[143] = 1687
			order[144] = 1787
			order[145] = 2141
			order[146] = 2142
			order[147] = 2143
			order[148] = 2752
			order[149] = 2144
			order[150] = 2145
			order[151] = 2576
			order[152] = 2962
			order[153] = 2602
			order[154] = 2603
			order[155] = 668
			order[156] = 869
			order[157] = 2736
			order[158] = 2738
			order[159] = 913
			order[160] = 914
			order[161] = 1961
			order[162] = 915
			order[163] = 918
			order[164] = 2952
			order[165] = 1962
			order[166] = 1963
			order[167] = 1964
			order[168] = 1965
			order[169] = 1966
			order[170] = 1967
			order[171] = 1968
			order[172] = 1969
			order[173] = 1970
			order[174] = 1513
			order[175] = 1525
			order[176] = 1527
			order[177] = 788
			order[178] = 916
			order[179] = 917
			order[180] = 919
			order[181] = 898
			order[182] = 1201
			order[183] = 711
			order[184] = 15
			order[185] = 2897
			order[186] = 232
			order[187] = 555
			order[188] = 1647
			order[189] = 218
			order[190] = 220
			order[191] = 2950
			order[192] = 221
			order[193] = 222
			order[194] = 662
			order[195] = 663
			order[196] = 699
			order[197] = 761
			order[198] = 235
			order[199] = 236
			order[200] = 701
			order[201] = 696
			order[202] = 697
			order[203] = 698
			order[204] = 1504
			order[205] = 58
			order[206] = 354
			order[207] = 355
			order[208] = 0
			super(146, 1324, order)
		end

		class NoSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 455
				order[1] = 456
				order[2] = 2957
				order[3] = 0
				super(454, 455, order)
			end
		end

		class NoSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1977
				order[1] = 1978
				order[2] = 1979
				order[3] = 2741
				order[4] = 0
				super(1976, 1977, order)
			end
		end

		class NoAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2305
				order[1] = 2306
				order[2] = 2307
				order[3] = 0
				super(2304, 2305, order)
			end
		end

		class NoEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 865
				order[1] = 866
				order[2] = 1145
				order[3] = 1827
				order[4] = 1826
				order[5] = 2340
				order[6] = 867
				order[7] = 868
				order[8] = 1578
				order[9] = 1579
				order[10] = 0
				super(864, 865, order)
			end
		end

		class NoInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1019
				order[1] = 1050
				order[2] = 1051
				order[3] = 2378
				order[4] = 1052
				order[5] = 0
				super(1018, 1019, order)
			end

			class NoInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1053
					order[1] = 1054
					order[2] = 0
					super(1052, 1053, order)
				end
			end
		end

		class NoComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 1484
				order[1] = 2117
				order[2] = 2118
				order[3] = 2119
				order[4] = 1485
				order[5] = 2120
				order[6] = 2121
				order[7] = 2122
				order[8] = 2941
				order[9] = 1486
				order[10] = 2123
				order[11] = 1487
				order[12] = 1488
				order[13] = 1489
				order[14] = 1490
				order[15] = 1491
				order[16] = 2124
				order[17] = 2942
				order[18] = 2125
				order[19] = 2943
				order[20] = 2126
				order[21] = 2127
				order[22] = 2407
				order[23] = 2408
				order[24] = 2128
				order[25] = 2129
				order[26] = 2130
				order[27] = 2131
				order[28] = 2132
				order[29] = 41013
				order[30] = 41020
				order[31] = 41021
				order[32] = 41022
				order[33] = 41023
				order[34] = 41024
				order[35] = 41025
				order[36] = 41026
				order[37] = 41027
				order[38] = 41028
				order[39] = 41010
				order[40] = 2133
				order[41] = 2134
				order[42] = 2135
				order[43] = 2136
				order[44] = 2137
				order[45] = 41029
				order[46] = 40997
				order[47] = 2597
				order[48] = 2598
				order[49] = 2599
				order[50] = 2138
				order[51] = 2139
				order[52] = 0
				super(1483, 1484, order)
			end

			class NoComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1492
					order[1] = 1493
					order[2] = 1494
					order[3] = 0
					super(1491, 1492, order)
				end

				class NoComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1495
						order[1] = 1496
						order[2] = 0
						super(1494, 1495, order)
					end
				end
			end

			class NoComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41014
					order[1] = 41015
					order[2] = 41016
					order[3] = 41017
					order[4] = 0
					super(41013, 41014, order)
				end
			end

			class NoComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41019
					order[1] = 0
					super(41018, 41019, order)
				end
			end

			class NoComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41011
					order[1] = 41012
					order[2] = 41031
					order[3] = 41007
					order[4] = 40994
					order[5] = 0
					super(41010, 41011, order)
				end

				class NoComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41032
						order[1] = 41033
						order[2] = 41034
						order[3] = 41035
						order[4] = 41036
						order[5] = 0
						super(41031, 41032, order)
					end
				end

				class NoComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41008
						order[1] = 41009
						order[2] = 0
						super(41007, 41008, order)
					end
				end

				class NoComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40995
						order[1] = 40996
						order[2] = 0
						super(40994, 40995, order)
					end
				end
			end

			class NoComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41030
					order[1] = 0
					super(41029, 41030, order)
				end
			end

			class NoComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40998
					order[1] = 40999
					order[2] = 41000
					order[3] = 41001
					order[4] = 41002
					order[5] = 41003
					order[6] = 41004
					order[7] = 41005
					order[8] = 0
					super(40997, 40998, order)
				end

				class NoComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41006
						order[1] = 0
						super(41005, 41006, order)
					end
				end
			end
		end

		class NoBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40471
				order[1] = 0
				super(40278, 40471, order)
			end
		end

		class NoPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41231
				order[1] = 0
				super(41230, 41231, order)
			end
		end

		class NoMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41093
				order[1] = 40991
				order[2] = 0
				super(41092, 41093, order)
			end
		end

		class NoMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41095
				order[1] = 40992
				order[2] = 0
				super(41094, 41095, order)
			end
		end

		class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41097
				order[1] = 41098
				order[2] = 41099
				order[3] = 41100
				order[4] = 41101
				order[5] = 41102
				order[6] = 41103
				order[7] = 41104
				order[8] = 41105
				order[9] = 0
				super(41096, 41097, order)
			end
		end

		class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42776
				order[1] = 0
				super(42775, 42776, order)
			end
		end

		class NoOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41117
				order[1] = 0
				super(41116, 41117, order)
			end
		end

		class NoOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41138
				order[1] = 41139
				order[2] = 0
				super(41137, 41138, order)
			end
		end

		class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41141
				order[1] = 0
				super(41140, 41141, order)
			end
		end

		class NoOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41153
				order[1] = 41154
				order[2] = 0
				super(41152, 41153, order)
			end
		end

		class NoStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40050
				order[1] = 41303
				order[2] = 40051
				order[3] = 42784
				order[4] = 42785
				order[5] = 40052
				order[6] = 40053
				order[7] = 41305
				order[8] = 40054
				order[9] = 40055
				order[10] = 42786
				order[11] = 42787
				order[12] = 41306
				order[13] = 41307
				order[14] = 41308
				order[15] = 41309
				order[16] = 41310
				order[17] = 41311
				order[18] = 41251
				order[19] = 41252
				order[20] = 41253
				order[21] = 41254
				order[22] = 41255
				order[23] = 41256
				order[24] = 41257
				order[25] = 42587
				order[26] = 41258
				order[27] = 41259
				order[28] = 41260
				order[29] = 41261
				order[30] = 41262
				order[31] = 41263
				order[32] = 41264
				order[33] = 41265
				order[34] = 41266
				order[35] = 41267
				order[36] = 41268
				order[37] = 41269
				order[38] = 41270
				order[39] = 41271
				order[40] = 41272
				order[41] = 41273
				order[42] = 41274
				order[43] = 41275
				order[44] = 41276
				order[45] = 40907
				order[46] = 40908
				order[47] = 40910
				order[48] = 40911
				order[49] = 40912
				order[50] = 40913
				order[51] = 40914
				order[52] = 40065
				order[53] = 40066
				order[54] = 40068
				order[55] = 40069
				order[56] = 40070
				order[57] = 40071
				order[58] = 40072
				order[59] = 41244
				order[60] = 41245
				order[61] = 40073
				order[62] = 40075
				order[63] = 40076
				order[64] = 40078
				order[65] = 40079
				order[66] = 40080
				order[67] = 40081
				order[68] = 40082
				order[69] = 40083
				order[70] = 40084
				order[71] = 41246
				order[72] = 41247
				order[73] = 41248
				order[74] = 40738
				order[75] = 40739
				order[76] = 40740
				order[77] = 42600
				order[78] = 40741
				order[79] = 40742
				order[80] = 43106
				order[81] = 40743
				order[82] = 40744
				order[83] = 40745
				order[84] = 40746
				order[85] = 40747
				order[86] = 42601
				order[87] = 42602
				order[88] = 42603
				order[89] = 42604
				order[90] = 40748
				order[91] = 40749
				order[92] = 40750
				order[93] = 41180
				order[94] = 41181
				order[95] = 41182
				order[96] = 41183
				order[97] = 41184
				order[98] = 41185
				order[99] = 41186
				order[100] = 42605
				order[101] = 40828
				order[102] = 40872
				order[103] = 41058
				order[104] = 41059
				order[105] = 41060
				order[106] = 41061
				order[107] = 41062
				order[108] = 42192
				order[109] = 42193
				order[110] = 41063
				order[111] = 41064
				order[112] = 41065
				order[113] = 41066
				order[114] = 41067
				order[115] = 41218
				order[116] = 41068
				order[117] = 41069
				order[118] = 41070
				order[119] = 41071
				order[120] = 41072
				order[121] = 41073
				order[122] = 41074
				order[123] = 41075
				order[124] = 41076
				order[125] = 41077
				order[126] = 41078
				order[127] = 41079
				order[128] = 41080
				order[129] = 43094
				order[130] = 41037
				order[131] = 40056
				order[132] = 40982
				order[133] = 40983
				order[134] = 0
				super(40049, 40050, order)
			end

			class NoStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41278
					order[1] = 41279
					order[2] = 0
					super(41277, 41278, order)
				end
			end

			class NoStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41238
					order[1] = 41239
					order[2] = 41240
					order[3] = 0
					super(41237, 41238, order)
				end
			end

			class NoStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41281
					order[1] = 41282
					order[2] = 0
					super(41280, 41281, order)
				end
			end

			class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41250
					order[1] = 0
					super(41249, 41250, order)
				end
			end

			class NoStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41290
					order[1] = 41291
					order[2] = 41292
					order[3] = 41293
					order[4] = 41294
					order[5] = 41295
					order[6] = 41296
					order[7] = 41297
					order[8] = 41298
					order[9] = 41299
					order[10] = 41300
					order[11] = 41283
					order[12] = 41301
					order[13] = 41302
					order[14] = 0
					super(41289, 41290, order)
				end

				class NoStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41284
						order[1] = 41285
						order[2] = 41286
						order[3] = 0
						super(41283, 41284, order)
					end

					class NoStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41287
							order[1] = 41288
							order[2] = 41588
							order[3] = 0
							super(41286, 41287, order)
						end
					end
				end
			end

			class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40909
					order[1] = 0
					super(40960, 40909, order)
				end
			end

			class NoStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40067
					order[1] = 0
					super(40961, 40067, order)
				end
			end

			class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40074
					order[1] = 0
					super(40958, 40074, order)
				end
			end

			class NoStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41242
					order[1] = 41243
					order[2] = 0
					super(41241, 41242, order)
				end
			end

			class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40077
					order[1] = 0
					super(40959, 40077, order)
				end
			end

			class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40752
					order[1] = 0
					super(40947, 40752, order)
				end
			end

			class NoPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41221
					order[1] = 41222
					order[2] = 0
					super(41220, 41221, order)
				end
			end

			class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40763
					order[1] = 0
					super(40948, 40763, order)
				end
			end

			class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40769
					order[1] = 0
					super(40949, 40769, order)
				end
			end

			class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40776
					order[1] = 0
					super(40950, 40776, order)
				end
			end

			class NoPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42661
					order[1] = 42662
					order[2] = 0
					super(42660, 42661, order)
				end
			end

			class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41193
					order[1] = 0
					super(41192, 41193, order)
				end
			end

			class NoPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41228
					order[1] = 41229
					order[2] = 0
					super(41227, 41228, order)
				end
			end

			class NoPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41225
					order[1] = 41226
					order[2] = 0
					super(41224, 41225, order)
				end
			end

			class NoPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43109
					order[1] = 42684
					order[2] = 42685
					order[3] = 0
					super(42683, 43109, order)
				end
			end

			class NoDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42275
					order[1] = 42276
					order[2] = 42277
					order[3] = 42278
					order[4] = 42279
					order[5] = 42280
					order[6] = 42294
					order[7] = 42281
					order[8] = 42282
					order[9] = 42283
					order[10] = 42284
					order[11] = 42285
					order[12] = 42286
					order[13] = 42287
					order[14] = 42288
					order[15] = 42289
					order[16] = 42290
					order[17] = 42291
					order[18] = 42292
					order[19] = 42293
					order[20] = 0
					super(42274, 42275, order)
				end

				class NoDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42295
						order[1] = 0
						super(42294, 42295, order)
					end
				end
			end

			class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42273
					order[1] = 0
					super(42272, 42273, order)
				end
			end

			class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42237
					order[1] = 0
					super(42236, 42237, order)
				end
			end

			class NoReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42736
					order[1] = 42737
					order[2] = 42738
					order[3] = 42739
					order[4] = 42740
					order[5] = 42741
					order[6] = 42765
					order[7] = 42731
					order[8] = 42742
					order[9] = 42743
					order[10] = 42744
					order[11] = 42745
					order[12] = 42746
					order[13] = 42747
					order[14] = 42748
					order[15] = 42749
					order[16] = 42750
					order[17] = 42751
					order[18] = 42752
					order[19] = 42753
					order[20] = 42761
					order[21] = 42754
					order[22] = 42755
					order[23] = 42709
					order[24] = 42756
					order[25] = 42757
					order[26] = 42758
					order[27] = 42759
					order[28] = 42760
					order[29] = 0
					super(42735, 42736, order)
				end

				class NoReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42766
						order[1] = 42767
						order[2] = 42768
						order[3] = 42769
						order[4] = 0
						super(42765, 42766, order)
					end
				end

				class NoReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42732
						order[1] = 42733
						order[2] = 42734
						order[3] = 0
						super(42731, 42732, order)
					end
				end

				class NoReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42762
						order[1] = 42763
						order[2] = 42764
						order[3] = 0
						super(42761, 42762, order)
					end
				end

				class NoReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42710
						order[1] = 42772
						order[2] = 42711
						order[3] = 42712
						order[4] = 42713
						order[5] = 42714
						order[6] = 42715
						order[7] = 42716
						order[8] = 42717
						order[9] = 42718
						order[10] = 42719
						order[11] = 42720
						order[12] = 42721
						order[13] = 42722
						order[14] = 42723
						order[15] = 42724
						order[16] = 42725
						order[17] = 42726
						order[18] = 42727
						order[19] = 42728
						order[20] = 42729
						order[21] = 42730
						order[22] = 42770
						order[23] = 0
						super(42709, 42710, order)
					end

					class NoReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42773
							order[1] = 42774
							order[2] = 0
							super(42772, 42773, order)
						end
					end

					class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42771
							order[1] = 0
							super(42770, 42771, order)
						end
					end
				end
			end

			class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42621
					order[1] = 0
					super(42620, 42621, order)
				end
			end

			class NoPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42607
					order[1] = 42608
					order[2] = 0
					super(42606, 42607, order)
				end
			end

			class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40819
					order[1] = 0
					super(40946, 40819, order)
				end
			end

			class NoNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40826
					order[1] = 40827
					order[2] = 0
					super(40825, 40826, order)
				end
			end

			class NoSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40086
					order[1] = 40373
					order[2] = 40655
					order[3] = 40088
					order[4] = 40089
					order[5] = 0
					super(40085, 40086, order)
				end
			end

			class NoPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40829
					order[1] = 41164
					order[2] = 41165
					order[3] = 40830
					order[4] = 40831
					order[5] = 40832
					order[6] = 40833
					order[7] = 40834
					order[8] = 40835
					order[9] = 40836
					order[10] = 40837
					order[11] = 40838
					order[12] = 40839
					order[13] = 41166
					order[14] = 41167
					order[15] = 41168
					order[16] = 41169
					order[17] = 40840
					order[18] = 40841
					order[19] = 40842
					order[20] = 40843
					order[21] = 41170
					order[22] = 41171
					order[23] = 41172
					order[24] = 41173
					order[25] = 40844
					order[26] = 40845
					order[27] = 40846
					order[28] = 40847
					order[29] = 40848
					order[30] = 40849
					order[31] = 40868
					order[32] = 40850
					order[33] = 40851
					order[34] = 40852
					order[35] = 40853
					order[36] = 40977
					order[37] = 40855
					order[38] = 40856
					order[39] = 40857
					order[40] = 41174
					order[41] = 41175
					order[42] = 40858
					order[43] = 41161
					order[44] = 41176
					order[45] = 41177
					order[46] = 41178
					order[47] = 41179
					order[48] = 40859
					order[49] = 40860
					order[50] = 40861
					order[51] = 40862
					order[52] = 40945
					order[53] = 40864
					order[54] = 40865
					order[55] = 40866
					order[56] = 40867
					order[57] = 0
					super(40828, 40829, order)
				end

				class NoPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40869
						order[1] = 40870
						order[2] = 40871
						order[3] = 0
						super(40868, 40869, order)
					end
				end

				class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40854
						order[1] = 0
						super(40977, 40854, order)
					end
				end

				class NoPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41162
						order[1] = 41163
						order[2] = 0
						super(41161, 41162, order)
					end
				end

				class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40863
						order[1] = 0
						super(40945, 40863, order)
					end
				end
			end

			class NoPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40873
					order[1] = 40874
					order[2] = 42698
					order[3] = 42699
					order[4] = 42700
					order[5] = 42701
					order[6] = 42702
					order[7] = 42703
					order[8] = 42704
					order[9] = 42689
					order[10] = 42690
					order[11] = 42691
					order[12] = 42692
					order[13] = 42693
					order[14] = 42694
					order[15] = 42695
					order[16] = 40875
					order[17] = 40876
					order[18] = 40877
					order[19] = 40878
					order[20] = 40879
					order[21] = 40880
					order[22] = 40881
					order[23] = 40882
					order[24] = 40883
					order[25] = 40884
					order[26] = 40885
					order[27] = 40886
					order[28] = 40887
					order[29] = 40888
					order[30] = 40889
					order[31] = 40890
					order[32] = 40891
					order[33] = 40892
					order[34] = 40893
					order[35] = 40894
					order[36] = 40895
					order[37] = 40896
					order[38] = 40897
					order[39] = 40898
					order[40] = 40899
					order[41] = 40900
					order[42] = 40901
					order[43] = 0
					super(40872, 40873, order)
				end

				class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42706
						order[1] = 0
						super(42705, 42706, order)
					end
				end

				class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42697
						order[1] = 0
						super(42696, 42697, order)
					end
				end
			end

			class NoDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41086
					order[1] = 0
					super(41085, 41086, order)
				end
			end

			class NoDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41082
					order[1] = 41083
					order[2] = 41084
					order[3] = 0
					super(41081, 41082, order)
				end
			end

			class NoDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41038
					order[1] = 41039
					order[2] = 41040
					order[3] = 41041
					order[4] = 41042
					order[5] = 41043
					order[6] = 41044
					order[7] = 41045
					order[8] = 41046
					order[9] = 41047
					order[10] = 41048
					order[11] = 41049
					order[12] = 41050
					order[13] = 41051
					order[14] = 0
					super(41037, 41038, order)
				end

				class NoDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41052
						order[1] = 41053
						order[2] = 41054
						order[3] = 0
						super(41051, 41052, order)
					end

					class NoDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41055
							order[1] = 41056
							order[2] = 41057
							order[3] = 0
							super(41054, 41055, order)
						end
					end
				end
			end
		end

		class NoProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40091
				order[1] = 40092
				order[2] = 40093
				order[3] = 40957
				order[4] = 40095
				order[5] = 40096
				order[6] = 40097
				order[7] = 42707
				order[8] = 42708
				order[9] = 40098
				order[10] = 40099
				order[11] = 40100
				order[12] = 40114
				order[13] = 40115
				order[14] = 40116
				order[15] = 40118
				order[16] = 40119
				order[17] = 40120
				order[18] = 40121
				order[19] = 40122
				order[20] = 40123
				order[21] = 40125
				order[22] = 40126
				order[23] = 40127
				order[24] = 40128
				order[25] = 40129
				order[26] = 40130
				order[27] = 40131
				order[28] = 40132
				order[29] = 40133
				order[30] = 40134
				order[31] = 40135
				order[32] = 40136
				order[33] = 40137
				order[34] = 40138
				order[35] = 40139
				order[36] = 40140
				order[37] = 40141
				order[38] = 40145
				order[39] = 40146
				order[40] = 40148
				order[41] = 40149
				order[42] = 40150
				order[43] = 40151
				order[44] = 40152
				order[45] = 40153
				order[46] = 40154
				order[47] = 40155
				order[48] = 40156
				order[49] = 40158
				order[50] = 40159
				order[51] = 40160
				order[52] = 40161
				order[53] = 40162
				order[54] = 40101
				order[55] = 40102
				order[56] = 40103
				order[57] = 40104
				order[58] = 40105
				order[59] = 40106
				order[60] = 40107
				order[61] = 40163
				order[62] = 40165
				order[63] = 40166
				order[64] = 40167
				order[65] = 40168
				order[66] = 40169
				order[67] = 40170
				order[68] = 40108
				order[69] = 40109
				order[70] = 40110
				order[71] = 40111
				order[72] = 40112
				order[73] = 41406
				order[74] = 40113
				order[75] = 40986
				order[76] = 40987
				order[77] = 40174
				order[78] = 0
				super(40090, 40091, order)
			end

			class NoProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40094
					order[1] = 0
					super(40957, 40094, order)
				end
			end

			class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40117
					order[1] = 0
					super(40953, 40117, order)
				end
			end

			class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40124
					order[1] = 0
					super(40954, 40124, order)
				end
			end

			class NoProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40143
					order[1] = 40144
					order[2] = 0
					super(40142, 40143, order)
				end
			end

			class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40147
					order[1] = 0
					super(40955, 40147, order)
				end
			end

			class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40157
					order[1] = 0
					super(40956, 40157, order)
				end
			end

			class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40164
					order[1] = 0
					super(40952, 40164, order)
				end
			end

			class NoProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40172
					order[1] = 40173
					order[2] = 0
					super(40171, 40172, order)
				end
			end

			class NoProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40175
					order[1] = 40176
					order[2] = 40177
					order[3] = 2385
					order[4] = 40178
					order[5] = 0
					super(40174, 40175, order)
				end

				class NoProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40179
						order[1] = 40180
						order[2] = 0
						super(40178, 40179, order)
					end
				end
			end
		end

		class NoAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40020
				order[1] = 40021
				order[2] = 40000
				order[3] = 0
				super(40019, 40020, order)
			end

			class NoAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 40001
					order[1] = 40002
					order[2] = 40003
					order[3] = 40004
					order[4] = 40005
					order[5] = 40006
					order[6] = 40007
					order[7] = 40008
					order[8] = 40009
					order[9] = 40010
					order[10] = 40011
					order[11] = 40012
					order[12] = 40013
					order[13] = 40014
					order[14] = 40015
					order[15] = 40016
					order[16] = 40017
					order[17] = 40018
					order[18] = 0
					super(40000, 40001, order)
				end
			end
		end

		class NoProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 40182
				order[1] = 40183
				order[2] = 40184
				order[3] = 40185
				order[4] = 40186
				order[5] = 40187
				order[6] = 40188
				order[7] = 40951
				order[8] = 40191
				order[9] = 40201
				order[10] = 40190
				order[11] = 0
				super(40181, 40182, order)
			end

			class NoProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40189
					order[1] = 0
					super(40951, 40189, order)
				end
			end

			class NoProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40192
					order[1] = 40193
					order[2] = 40194
					order[3] = 40195
					order[4] = 40196
					order[5] = 40197
					order[6] = 40198
					order[7] = 40199
					order[8] = 0
					super(40191, 40192, order)
				end

				class NoProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40200
						order[1] = 0
						super(40199, 40200, order)
					end
				end
			end

			class NoProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40202
					order[1] = 40203
					order[2] = 0
					super(40201, 40202, order)
				end
			end
		end

		class NoCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 40023
				order[1] = 40024
				order[2] = 40916
				order[3] = 40917
				order[4] = 40025
				order[5] = 40026
				order[6] = 40027
				order[7] = 40028
				order[8] = 40029
				order[9] = 40030
				order[10] = 40031
				order[11] = 40277
				order[12] = 42216
				order[13] = 42217
				order[14] = 40033
				order[15] = 40034
				order[16] = 42207
				order[17] = 42208
				order[18] = 42209
				order[19] = 42210
				order[20] = 42211
				order[21] = 42212
				order[22] = 42213
				order[23] = 40035
				order[24] = 40036
				order[25] = 40037
				order[26] = 40038
				order[27] = 40039
				order[28] = 0
				super(40022, 40023, order)
			end

			class NoCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40032
					order[1] = 0
					super(40277, 40032, order)
				end
			end

			class NoCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42215
					order[1] = 0
					super(42214, 42215, order)
				end
			end
		end

		class NoPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40209
				order[1] = 40205
				order[2] = 40206
				order[3] = 40207
				order[4] = 40208
				order[5] = 0
				super(40204, 40209, order)
			end

			class NoPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40210
					order[1] = 40211
					order[2] = 0
					super(40209, 40210, order)
				end
			end
		end

		class NoExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42297
				order[1] = 42298
				order[2] = 0
				super(42296, 42297, order)
			end
		end

		class NoInstrAttrib < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 871
				order[1] = 872
				order[2] = 0
				super(870, 871, order)
			end
		end

		class NoIndexRollMonths < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 2733
				order[1] = 0
				super(2734, 2733, order)
			end
		end

		class NoReferenceDataDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2747
				order[1] = 2748
				order[2] = 0
				super(2746, 2747, order)
			end
		end

		class NoContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40041
				order[1] = 0
				super(40040, 40041, order)
			end
		end

		class NoFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40047
				order[1] = 40048
				order[2] = 0
				super(40046, 40047, order)
			end
		end

		class NoContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40043
				order[1] = 40044
				order[2] = 40045
				order[3] = 0
				super(40042, 40043, order)
			end
		end

		class NoTickRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(8)
				order[0] = 1206
				order[1] = 1207
				order[2] = 1208
				order[3] = 1209
				order[4] = 2571
				order[5] = 1830
				order[6] = 1831
				order[7] = 0
				super(1205, 1206, order)
			end
		end

		class NoLotTypeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1093
				order[1] = 1231
				order[2] = 0
				super(1234, 1093, order)
			end
		end

		class NoPriceRangeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 2551
				order[1] = 2552
				order[2] = 2553
				order[3] = 2554
				order[4] = 2556
				order[5] = 2555
				order[6] = 0
				super(2550, 2551, order)
			end
		end

		class NoQuoteSizeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 647
				order[1] = 648
				order[2] = 2447
				order[3] = 0
				super(2558, 647, order)
			end
		end

		class NoTradingSessionRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 336
				order[1] = 625
				order[2] = 0
				super(1309, 336, order)
			end

			class NoOrdTypeRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40
					order[1] = 0
					super(1237, 40, order)
				end
			end

			class NoTimeInForceRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 59
					order[1] = 0
					super(1239, 59, order)
				end
			end

			class NoExecInstRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 1308
					order[1] = 0
					super(1232, 1308, order)
				end
			end

			class NoAuctionTypeRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1803
					order[1] = 2549
					order[2] = 0
					super(2548, 1803, order)
				end
			end

			class NoMatchRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 1142
					order[1] = 574
					order[2] = 2569
					order[3] = 2570
					order[4] = 0
					super(1235, 1142, order)
				end
			end

			class NoMDFeedTypes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 1022
					order[1] = 1683
					order[2] = 264
					order[3] = 2563
					order[4] = 2564
					order[5] = 2565
					order[6] = 2566
					order[7] = 1021
					order[8] = 1173
					order[9] = 2567
					order[10] = 2568
					order[11] = 0
					super(1141, 1022, order)
				end
			end
		end

		class NoNestedInstrAttrib < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1210
				order[1] = 1211
				order[2] = 0
				super(1312, 1210, order)
			end
		end

		class NoStrikeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 1223
				order[1] = 1202
				order[2] = 1203
				order[3] = 1204
				order[4] = 1304
				order[5] = 1236
				order[6] = 0
				super(1201, 1223, order)
			end

			class NoMaturityRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(7)
					order[0] = 1222
					order[1] = 1303
					order[2] = 1302
					order[3] = 1241
					order[4] = 1226
					order[5] = 1229
					order[6] = 0
					super(1236, 1222, order)
				end
			end
		end

		class NoUnderlyings < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(188)
				order[0] = 311
				order[1] = 312
				order[2] = 309
				order[3] = 305
				order[4] = 2874
				order[5] = 462
				order[6] = 463
				order[7] = 2894
				order[8] = 310
				order[9] = 763
				order[10] = 313
				order[11] = 542
				order[12] = 1213
				order[13] = 1837
				order[14] = 241
				order[15] = 1453
				order[16] = 1454
				order[17] = 2614
				order[18] = 2615
				order[19] = 2921
				order[20] = 2616
				order[21] = 2617
				order[22] = 2619
				order[23] = 1455
				order[24] = 1456
				order[25] = 1459
				order[26] = 1460
				order[27] = 242
				order[28] = 243
				order[29] = 244
				order[30] = 245
				order[31] = 246
				order[32] = 256
				order[33] = 595
				order[34] = 592
				order[35] = 593
				order[36] = 594
				order[37] = 247
				order[38] = 316
				order[39] = 941
				order[40] = 2917
				order[41] = 317
				order[42] = 436
				order[43] = 1437
				order[44] = 2363
				order[45] = 1441
				order[46] = 998
				order[47] = 1423
				order[48] = 1718
				order[49] = 2918
				order[50] = 1424
				order[51] = 1425
				order[52] = 1719
				order[53] = 2919
				order[54] = 1000
				order[55] = 1419
				order[56] = 1526
				order[57] = 2920
				order[58] = 435
				order[59] = 308
				order[60] = 306
				order[61] = 362
				order[62] = 363
				order[63] = 2742
				order[64] = 2720
				order[65] = 2721
				order[66] = 2722
				order[67] = 2723
				order[68] = 2724
				order[69] = 307
				order[70] = 364
				order[71] = 365
				order[72] = 877
				order[73] = 878
				order[74] = 972
				order[75] = 318
				order[76] = 2916
				order[77] = 879
				order[78] = 975
				order[79] = 973
				order[80] = 974
				order[81] = 810
				order[82] = 882
				order[83] = 883
				order[84] = 884
				order[85] = 885
				order[86] = 886
				order[87] = 2885
				order[88] = 2886
				order[89] = 1044
				order[90] = 1045
				order[91] = 1046
				order[92] = 1038
				order[93] = 1039
				order[94] = 315
				order[95] = 2683
				order[96] = 2687
				order[97] = 1988
				order[98] = 1989
				order[99] = 1990
				order[100] = 1991
				order[101] = 1992
				order[102] = 1993
				order[103] = 2881
				order[104] = 1994
				order[105] = 1995
				order[106] = 1996
				order[107] = 1997
				order[108] = 2620
				order[109] = 2621
				order[110] = 1998
				order[111] = 1999
				order[112] = 2000
				order[113] = 2003
				order[114] = 2004
				order[115] = 2005
				order[116] = 2006
				order[117] = 2284
				order[118] = 2285
				order[119] = 2286
				order[120] = 2287
				order[121] = 2288
				order[122] = 2007
				order[123] = 2008
				order[124] = 2009
				order[125] = 2010
				order[126] = 2011
				order[127] = 2012
				order[128] = 2491
				order[129] = 2013
				order[130] = 2014
				order[131] = 2015
				order[132] = 2744
				order[133] = 2016
				order[134] = 2289
				order[135] = 2017
				order[136] = 2018
				order[137] = 2019
				order[138] = 2020
				order[139] = 2021
				order[140] = 2022
				order[141] = 2290
				order[142] = 2622
				order[143] = 2291
				order[144] = 2623
				order[145] = 2292
				order[146] = 2023
				order[147] = 2024
				order[148] = 2025
				order[149] = 2026
				order[150] = 2027
				order[151] = 2028
				order[152] = 2029
				order[153] = 2757
				order[154] = 2030
				order[155] = 2031
				order[156] = 2293
				order[157] = 2294
				order[158] = 2032
				order[159] = 2033
				order[160] = 2034
				order[161] = 2035
				order[162] = 2036
				order[163] = 2037
				order[164] = 2038
				order[165] = 2039
				order[166] = 2040
				order[167] = 2041
				order[168] = 2042
				order[169] = 2043
				order[170] = 2044
				order[171] = 41314
				order[172] = 41315
				order[173] = 2295
				order[174] = 2296
				order[175] = 2297
				order[176] = 2756
				order[177] = 2298
				order[178] = 2299
				order[179] = 2624
				order[180] = 2625
				order[181] = 2626
				order[182] = 2627
				order[183] = 2628
				order[184] = 2629
				order[185] = 2630
				order[186] = 2631
				order[187] = 0
				super(711, 311, order)
			end

			class NoUnderlyingSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 458
					order[1] = 459
					order[2] = 2959
					order[3] = 0
					super(457, 458, order)
				end
			end

			class NoUnderlyingStips < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 888
					order[1] = 889
					order[2] = 0
					super(887, 888, order)
				end
			end

			class NoUndlyInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 1059
					order[1] = 1060
					order[2] = 1061
					order[3] = 2391
					order[4] = 1062
					order[5] = 0
					super(1058, 1059, order)
				end

				class NoUndlyInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1063
						order[1] = 1064
						order[2] = 0
						super(1062, 1063, order)
					end
				end
			end

			class NoUnderlyingEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 1982
					order[1] = 1983
					order[2] = 1984
					order[3] = 1985
					order[4] = 1986
					order[5] = 2342
					order[6] = 1987
					order[7] = 2071
					order[8] = 2072
					order[9] = 2073
					order[10] = 0
					super(1981, 1982, order)
				end
			end

			class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2081
					order[1] = 2082
					order[2] = 2083
					order[3] = 2745
					order[4] = 0
					super(2080, 2081, order)
				end
			end

			class NoUnderlyingAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2313
					order[1] = 2314
					order[2] = 2315
					order[3] = 0
					super(2312, 2313, order)
				end
			end

			class NoUnderlyingComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2046
					order[1] = 2261
					order[2] = 2262
					order[3] = 2263
					order[4] = 2047
					order[5] = 2264
					order[6] = 2265
					order[7] = 2266
					order[8] = 2947
					order[9] = 2048
					order[10] = 2267
					order[11] = 2049
					order[12] = 2050
					order[13] = 2051
					order[14] = 2052
					order[15] = 2053
					order[16] = 2268
					order[17] = 2948
					order[18] = 2269
					order[19] = 2949
					order[20] = 2270
					order[21] = 2271
					order[22] = 2419
					order[23] = 2420
					order[24] = 2272
					order[25] = 2273
					order[26] = 2274
					order[27] = 2275
					order[28] = 2276
					order[29] = 41732
					order[30] = 41739
					order[31] = 41740
					order[32] = 41741
					order[33] = 41742
					order[34] = 41743
					order[35] = 41744
					order[36] = 41745
					order[37] = 41746
					order[38] = 41747
					order[39] = 41729
					order[40] = 2277
					order[41] = 2278
					order[42] = 2279
					order[43] = 2280
					order[44] = 2281
					order[45] = 41748
					order[46] = 41716
					order[47] = 2611
					order[48] = 2612
					order[49] = 2613
					order[50] = 2282
					order[51] = 2283
					order[52] = 0
					super(2045, 2046, order)
				end

				class NoUnderlyingComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2054
						order[1] = 2055
						order[2] = 2056
						order[3] = 0
						super(2053, 2054, order)
					end

					class NoUnderlyingComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2057
							order[1] = 2058
							order[2] = 0
							super(2056, 2057, order)
						end
					end
				end

				class NoUnderlyingComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41733
						order[1] = 41734
						order[2] = 41735
						order[3] = 41736
						order[4] = 0
						super(41732, 41733, order)
					end
				end

				class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41738
						order[1] = 0
						super(41737, 41738, order)
					end
				end

				class NoUnderlyingComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41730
						order[1] = 41731
						order[2] = 41750
						order[3] = 41726
						order[4] = 41713
						order[5] = 0
						super(41729, 41730, order)
					end

					class NoUnderlyingComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41751
							order[1] = 41752
							order[2] = 41753
							order[3] = 41754
							order[4] = 41755
							order[5] = 0
							super(41750, 41751, order)
						end
					end

					class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41727
							order[1] = 41728
							order[2] = 0
							super(41726, 41727, order)
						end
					end

					class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41714
							order[1] = 41715
							order[2] = 0
							super(41713, 41714, order)
						end
					end
				end

				class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41749
						order[1] = 0
						super(41748, 41749, order)
					end
				end

				class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41717
						order[1] = 41718
						order[2] = 41719
						order[3] = 41720
						order[4] = 41721
						order[5] = 41722
						order[6] = 41723
						order[7] = 41724
						order[8] = 0
						super(41716, 41717, order)
					end

					class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41725
							order[1] = 0
							super(41724, 41725, order)
						end
					end
				end
			end

			class NoUnderlyingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40963
					order[1] = 0
					super(40962, 40963, order)
				end
			end

			class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41948
					order[1] = 0
					super(41947, 41948, order)
				end
			end

			class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41865
					order[1] = 41338
					order[2] = 0
					super(41864, 41865, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41867
					order[1] = 41339
					order[2] = 0
					super(41866, 41867, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41869
					order[1] = 41870
					order[2] = 41871
					order[3] = 41872
					order[4] = 41873
					order[5] = 41874
					order[6] = 41875
					order[7] = 41876
					order[8] = 41877
					order[9] = 0
					super(41868, 41869, order)
				end
			end

			class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 43075
					order[1] = 0
					super(43074, 43075, order)
				end
			end

			class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41821
					order[1] = 0
					super(41820, 41821, order)
				end
			end

			class NoUnderlyingOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41842
					order[1] = 41843
					order[2] = 0
					super(41841, 41842, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41845
					order[1] = 0
					super(41844, 41845, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41857
					order[1] = 41858
					order[2] = 0
					super(41856, 41857, order)
				end
			end

			class NoUnderlyingStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40541
					order[1] = 42016
					order[2] = 40542
					order[3] = 43083
					order[4] = 43084
					order[5] = 40543
					order[6] = 40544
					order[7] = 42018
					order[8] = 40545
					order[9] = 40546
					order[10] = 43085
					order[11] = 43086
					order[12] = 42019
					order[13] = 42020
					order[14] = 42021
					order[15] = 42022
					order[16] = 42023
					order[17] = 42024
					order[18] = 41964
					order[19] = 41965
					order[20] = 41966
					order[21] = 41967
					order[22] = 41968
					order[23] = 41969
					order[24] = 41970
					order[25] = 42589
					order[26] = 41971
					order[27] = 41972
					order[28] = 41973
					order[29] = 41974
					order[30] = 41975
					order[31] = 41976
					order[32] = 41977
					order[33] = 41978
					order[34] = 41979
					order[35] = 41980
					order[36] = 41981
					order[37] = 41982
					order[38] = 41983
					order[39] = 41984
					order[40] = 41985
					order[41] = 41986
					order[42] = 41987
					order[43] = 41988
					order[44] = 41989
					order[45] = 40057
					order[46] = 40058
					order[47] = 40060
					order[48] = 40061
					order[49] = 40062
					order[50] = 40063
					order[51] = 40064
					order[52] = 40548
					order[53] = 40549
					order[54] = 40551
					order[55] = 40552
					order[56] = 40553
					order[57] = 40554
					order[58] = 40555
					order[59] = 41957
					order[60] = 41958
					order[61] = 40556
					order[62] = 40558
					order[63] = 40559
					order[64] = 40561
					order[65] = 40562
					order[66] = 40563
					order[67] = 40564
					order[68] = 40565
					order[69] = 40566
					order[70] = 40567
					order[71] = 41959
					order[72] = 41960
					order[73] = 41961
					order[74] = 40568
					order[75] = 40569
					order[76] = 40570
					order[77] = 42895
					order[78] = 40571
					order[79] = 40572
					order[80] = 43107
					order[81] = 40573
					order[82] = 40574
					order[83] = 40575
					order[84] = 40576
					order[85] = 40577
					order[86] = 42896
					order[87] = 42897
					order[88] = 42898
					order[89] = 42899
					order[90] = 40578
					order[91] = 40579
					order[92] = 40580
					order[93] = 41897
					order[94] = 41898
					order[95] = 41899
					order[96] = 41900
					order[97] = 41901
					order[98] = 41902
					order[99] = 41903
					order[100] = 42900
					order[101] = 40664
					order[102] = 40708
					order[103] = 41777
					order[104] = 41778
					order[105] = 41779
					order[106] = 41780
					order[107] = 41781
					order[108] = 42196
					order[109] = 42197
					order[110] = 41782
					order[111] = 41783
					order[112] = 41784
					order[113] = 41785
					order[114] = 41786
					order[115] = 41587
					order[116] = 41787
					order[117] = 41788
					order[118] = 41789
					order[119] = 41790
					order[120] = 41791
					order[121] = 41792
					order[122] = 41793
					order[123] = 41794
					order[124] = 41795
					order[125] = 41796
					order[126] = 41797
					order[127] = 41798
					order[128] = 41799
					order[129] = 43096
					order[130] = 41756
					order[131] = 40547
					order[132] = 40988
					order[133] = 40989
					order[134] = 0
					super(40540, 40541, order)
				end

				class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41991
						order[1] = 41992
						order[2] = 0
						super(41990, 41991, order)
					end
				end

				class NoUnderlyingStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41801
						order[1] = 41802
						order[2] = 41803
						order[3] = 0
						super(41800, 41801, order)
					end
				end

				class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41994
						order[1] = 41995
						order[2] = 0
						super(41993, 41994, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41963
						order[1] = 0
						super(41962, 41963, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 42003
						order[1] = 42004
						order[2] = 42005
						order[3] = 42006
						order[4] = 42007
						order[5] = 42008
						order[6] = 42009
						order[7] = 42010
						order[8] = 42011
						order[9] = 42012
						order[10] = 42013
						order[11] = 41996
						order[12] = 42014
						order[13] = 42015
						order[14] = 0
						super(42002, 42003, order)
					end

					class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41997
							order[1] = 41998
							order[2] = 41999
							order[3] = 0
							super(41996, 41997, order)
						end

						class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 42000
								order[1] = 42001
								order[2] = 41936
								order[3] = 0
								super(41999, 42000, order)
							end
						end
					end
				end

				class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40059
						order[1] = 0
						super(40975, 40059, order)
					end
				end

				class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40550
						order[1] = 0
						super(40976, 40550, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40557
						order[1] = 0
						super(40973, 40557, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41955
						order[1] = 41956
						order[2] = 0
						super(41954, 41955, order)
					end
				end

				class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40560
						order[1] = 0
						super(40974, 40560, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40582
						order[1] = 0
						super(40969, 40582, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41938
						order[1] = 41939
						order[2] = 0
						super(41937, 41938, order)
					end
				end

				class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40594
						order[1] = 0
						super(40970, 40594, order)
					end
				end

				class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40600
						order[1] = 0
						super(40971, 40600, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40607
						order[1] = 0
						super(40972, 40607, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42956
						order[1] = 42957
						order[2] = 0
						super(42955, 42956, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41910
						order[1] = 0
						super(41909, 41910, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41945
						order[1] = 41946
						order[2] = 0
						super(41944, 41945, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41942
						order[1] = 41943
						order[2] = 0
						super(41941, 41942, order)
					end
				end

				class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43111
						order[1] = 42982
						order[2] = 42983
						order[3] = 0
						super(42981, 43111, order)
					end
				end

				class NoUnderlyingDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42863
						order[1] = 42864
						order[2] = 42865
						order[3] = 42866
						order[4] = 42867
						order[5] = 42868
						order[6] = 42882
						order[7] = 42869
						order[8] = 42870
						order[9] = 42871
						order[10] = 42872
						order[11] = 42873
						order[12] = 42874
						order[13] = 42875
						order[14] = 42876
						order[15] = 42877
						order[16] = 42878
						order[17] = 42879
						order[18] = 42880
						order[19] = 42881
						order[20] = 0
						super(42862, 42863, order)
					end

					class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42883
							order[1] = 0
							super(42882, 42883, order)
						end
					end
				end

				class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42854
						order[1] = 0
						super(42853, 42854, order)
					end
				end

				class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42800
						order[1] = 0
						super(42799, 42800, order)
					end
				end

				class NoUnderlyingReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 43035
						order[1] = 43036
						order[2] = 43037
						order[3] = 43038
						order[4] = 43039
						order[5] = 43040
						order[6] = 43064
						order[7] = 43030
						order[8] = 43041
						order[9] = 43042
						order[10] = 43043
						order[11] = 43044
						order[12] = 43045
						order[13] = 43046
						order[14] = 43047
						order[15] = 43048
						order[16] = 43049
						order[17] = 43050
						order[18] = 43051
						order[19] = 43052
						order[20] = 43060
						order[21] = 43053
						order[22] = 43054
						order[23] = 43008
						order[24] = 43055
						order[25] = 43056
						order[26] = 43057
						order[27] = 43058
						order[28] = 43059
						order[29] = 0
						super(43034, 43035, order)
					end

					class NoUnderlyingReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 43065
							order[1] = 43066
							order[2] = 43067
							order[3] = 43068
							order[4] = 0
							super(43064, 43065, order)
						end
					end

					class NoUnderlyingReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43031
							order[1] = 43032
							order[2] = 43033
							order[3] = 0
							super(43030, 43031, order)
						end
					end

					class NoUnderlyingReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43061
							order[1] = 43062
							order[2] = 43063
							order[3] = 0
							super(43060, 43061, order)
						end
					end

					class NoUnderlyingReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 43009
							order[1] = 43071
							order[2] = 43010
							order[3] = 43011
							order[4] = 43012
							order[5] = 43013
							order[6] = 43014
							order[7] = 43015
							order[8] = 43016
							order[9] = 43017
							order[10] = 43018
							order[11] = 43019
							order[12] = 43020
							order[13] = 43021
							order[14] = 43022
							order[15] = 43023
							order[16] = 43024
							order[17] = 43025
							order[18] = 43026
							order[19] = 43027
							order[20] = 43028
							order[21] = 43029
							order[22] = 43069
							order[23] = 0
							super(43008, 43009, order)
						end

						class NoUnderlyingReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 43072
								order[1] = 43073
								order[2] = 0
								super(43071, 43072, order)
							end
						end

						class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 43070
								order[1] = 0
								super(43069, 43070, order)
							end
						end
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42916
						order[1] = 0
						super(42915, 42916, order)
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42902
						order[1] = 42903
						order[2] = 0
						super(42901, 42902, order)
					end
				end

				class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40650
						order[1] = 0
						super(40968, 40650, order)
					end
				end

				class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40657
						order[1] = 40658
						order[2] = 0
						super(40656, 40657, order)
					end
				end

				class NoUnderlyingSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40660
						order[1] = 40904
						order[2] = 40915
						order[3] = 40662
						order[4] = 40663
						order[5] = 0
						super(40659, 40660, order)
					end
				end

				class NoUnderlyingPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40665
						order[1] = 41881
						order[2] = 41882
						order[3] = 40666
						order[4] = 40667
						order[5] = 40668
						order[6] = 40669
						order[7] = 40670
						order[8] = 40671
						order[9] = 40672
						order[10] = 40673
						order[11] = 40674
						order[12] = 40675
						order[13] = 41883
						order[14] = 41884
						order[15] = 41885
						order[16] = 41886
						order[17] = 40676
						order[18] = 40677
						order[19] = 40678
						order[20] = 40679
						order[21] = 41887
						order[22] = 41888
						order[23] = 41889
						order[24] = 41890
						order[25] = 40680
						order[26] = 40681
						order[27] = 40682
						order[28] = 40683
						order[29] = 40684
						order[30] = 40685
						order[31] = 40704
						order[32] = 40686
						order[33] = 40687
						order[34] = 40688
						order[35] = 40689
						order[36] = 40966
						order[37] = 40691
						order[38] = 40692
						order[39] = 40693
						order[40] = 41891
						order[41] = 41892
						order[42] = 40694
						order[43] = 41878
						order[44] = 41893
						order[45] = 41894
						order[46] = 41895
						order[47] = 41896
						order[48] = 40695
						order[49] = 40696
						order[50] = 40697
						order[51] = 40698
						order[52] = 40967
						order[53] = 40700
						order[54] = 40701
						order[55] = 40702
						order[56] = 40703
						order[57] = 0
						super(40664, 40665, order)
					end

					class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40705
							order[1] = 40706
							order[2] = 40707
							order[3] = 0
							super(40704, 40705, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40690
							order[1] = 0
							super(40966, 40690, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41879
							order[1] = 41880
							order[2] = 0
							super(41878, 41879, order)
						end
					end

					class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40699
							order[1] = 0
							super(40967, 40699, order)
						end
					end
				end

				class NoUnderlyingPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40709
						order[1] = 40710
						order[2] = 42993
						order[3] = 42994
						order[4] = 42995
						order[5] = 42996
						order[6] = 42997
						order[7] = 42998
						order[8] = 42999
						order[9] = 42984
						order[10] = 42985
						order[11] = 42986
						order[12] = 42987
						order[13] = 42988
						order[14] = 42989
						order[15] = 42990
						order[16] = 40711
						order[17] = 40712
						order[18] = 40713
						order[19] = 40714
						order[20] = 40715
						order[21] = 40716
						order[22] = 40717
						order[23] = 40718
						order[24] = 40719
						order[25] = 40720
						order[26] = 40721
						order[27] = 40722
						order[28] = 40723
						order[29] = 40724
						order[30] = 40725
						order[31] = 40726
						order[32] = 40727
						order[33] = 40728
						order[34] = 40729
						order[35] = 40730
						order[36] = 40731
						order[37] = 40732
						order[38] = 40733
						order[39] = 40734
						order[40] = 40735
						order[41] = 40736
						order[42] = 40737
						order[43] = 0
						super(40708, 40709, order)
					end

					class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43001
							order[1] = 0
							super(43000, 43001, order)
						end
					end

					class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42992
							order[1] = 0
							super(42991, 42992, order)
						end
					end
				end

				class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41809
						order[1] = 0
						super(41808, 41809, order)
					end
				end

				class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41805
						order[1] = 41806
						order[2] = 41807
						order[3] = 0
						super(41804, 41805, order)
					end
				end

				class NoUnderlyingDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41757
						order[1] = 41758
						order[2] = 41759
						order[3] = 41760
						order[4] = 41761
						order[5] = 41762
						order[6] = 41763
						order[7] = 41764
						order[8] = 41765
						order[9] = 41766
						order[10] = 41767
						order[11] = 41768
						order[12] = 41769
						order[13] = 41770
						order[14] = 0
						super(41756, 41757, order)
					end

					class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41771
							order[1] = 41772
							order[2] = 41773
							order[3] = 0
							super(41770, 41771, order)
						end

						class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41774
								order[1] = 41775
								order[2] = 41776
								order[3] = 0
								super(41773, 41774, order)
							end
						end
					end
				end
			end

			class NoUnderlyingProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 42150
					order[1] = 42151
					order[2] = 42152
					order[3] = 42190
					order[4] = 42153
					order[5] = 42154
					order[6] = 42155
					order[7] = 43002
					order[8] = 43003
					order[9] = 42156
					order[10] = 42157
					order[11] = 42158
					order[12] = 42104
					order[13] = 42105
					order[14] = 42106
					order[15] = 42107
					order[16] = 42108
					order[17] = 42109
					order[18] = 42110
					order[19] = 42111
					order[20] = 42115
					order[21] = 42116
					order[22] = 42117
					order[23] = 42118
					order[24] = 42119
					order[25] = 42120
					order[26] = 42121
					order[27] = 42122
					order[28] = 42123
					order[29] = 42124
					order[30] = 42125
					order[31] = 42126
					order[32] = 42127
					order[33] = 42128
					order[34] = 42129
					order[35] = 42130
					order[36] = 42131
					order[37] = 42132
					order[38] = 42133
					order[39] = 42134
					order[40] = 42135
					order[41] = 42136
					order[42] = 42137
					order[43] = 42138
					order[44] = 42139
					order[45] = 42140
					order[46] = 42141
					order[47] = 42142
					order[48] = 42143
					order[49] = 42144
					order[50] = 42145
					order[51] = 42146
					order[52] = 42147
					order[53] = 42148
					order[54] = 42159
					order[55] = 42160
					order[56] = 42161
					order[57] = 42162
					order[58] = 42163
					order[59] = 42164
					order[60] = 42165
					order[61] = 42092
					order[62] = 42093
					order[63] = 42094
					order[64] = 42095
					order[65] = 42096
					order[66] = 42097
					order[67] = 42098
					order[68] = 42166
					order[69] = 42167
					order[70] = 42168
					order[71] = 42169
					order[72] = 42102
					order[73] = 42103
					order[74] = 42170
					order[75] = 42171
					order[76] = 42172
					order[77] = 42173
					order[78] = 0
					super(42149, 42150, order)
				end

				class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42191
						order[1] = 0
						super(42190, 42191, order)
					end
				end

				class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42183
						order[1] = 0
						super(42182, 42183, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42185
						order[1] = 0
						super(42184, 42185, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42113
						order[1] = 42114
						order[2] = 0
						super(42112, 42113, order)
					end
				end

				class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42187
						order[1] = 0
						super(42186, 42187, order)
					end
				end

				class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42189
						order[1] = 0
						super(42188, 42189, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42181
						order[1] = 0
						super(42180, 42181, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42100
						order[1] = 42101
						order[2] = 0
						super(42099, 42100, order)
					end
				end

				class NoUnderlyingProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 42174
						order[1] = 42175
						order[2] = 42176
						order[3] = 40918
						order[4] = 42177
						order[5] = 0
						super(42173, 42174, order)
					end

					class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42178
							order[1] = 42179
							order[2] = 0
							super(42177, 42178, order)
						end
					end
				end
			end

			class NoUnderlyingAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42037
					order[1] = 42038
					order[2] = 41340
					order[3] = 0
					super(42036, 42037, order)
				end

				class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41341
						order[1] = 41701
						order[2] = 41709
						order[3] = 41710
						order[4] = 41711
						order[5] = 41712
						order[6] = 42017
						order[7] = 42025
						order[8] = 42026
						order[9] = 42027
						order[10] = 42028
						order[11] = 42029
						order[12] = 42030
						order[13] = 42031
						order[14] = 42032
						order[15] = 42033
						order[16] = 42034
						order[17] = 42035
						order[18] = 0
						super(41340, 41341, order)
					end
				end
			end

			class NoUnderlyingProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 42069
					order[1] = 42070
					order[2] = 42071
					order[3] = 42072
					order[4] = 42073
					order[5] = 42074
					order[6] = 42075
					order[7] = 42090
					order[8] = 42077
					order[9] = 42087
					order[10] = 42076
					order[11] = 0
					super(42068, 42069, order)
				end

				class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42091
						order[1] = 0
						super(42090, 42091, order)
					end
				end

				class NoUnderlyingProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 42078
						order[1] = 42079
						order[2] = 42080
						order[3] = 42081
						order[4] = 42082
						order[5] = 42083
						order[6] = 42084
						order[7] = 42085
						order[8] = 0
						super(42077, 42078, order)
					end

					class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42086
							order[1] = 0
							super(42085, 42086, order)
						end
					end
				end

				class NoUnderlyingProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42088
						order[1] = 42089
						order[2] = 0
						super(42087, 42088, order)
					end
				end
			end

			class NoUnderlyingCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 42042
					order[1] = 42043
					order[2] = 42044
					order[3] = 42045
					order[4] = 42046
					order[5] = 42047
					order[6] = 42048
					order[7] = 42049
					order[8] = 42050
					order[9] = 42051
					order[10] = 42052
					order[11] = 42039
					order[12] = 42797
					order[13] = 42798
					order[14] = 42053
					order[15] = 42054
					order[16] = 42790
					order[17] = 42791
					order[18] = 42792
					order[19] = 42793
					order[20] = 42794
					order[21] = 42795
					order[22] = 42796
					order[23] = 42055
					order[24] = 42056
					order[25] = 42057
					order[26] = 42058
					order[27] = 42059
					order[28] = 0
					super(42041, 42042, order)
				end

				class NoUnderlyingCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42040
						order[1] = 0
						super(42039, 42040, order)
					end
				end

				class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42789
						order[1] = 0
						super(42788, 42789, order)
					end
				end
			end

			class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42065
					order[1] = 42061
					order[2] = 42062
					order[3] = 42063
					order[4] = 42064
					order[5] = 0
					super(42060, 42065, order)
				end

				class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42066
						order[1] = 42067
						order[2] = 0
						super(42065, 42066, order)
					end
				end
			end

			class NoUnderlyingRateSpreadSteps < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 43006
					order[1] = 43007
					order[2] = 0
					super(43005, 43006, order)
				end
			end

			class NoUnderlyingDividendPayments < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42856
					order[1] = 42857
					order[2] = 42858
					order[3] = 42859
					order[4] = 0
					super(42855, 42856, order)
				end
			end

			class NoUnderlyingExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42885
					order[1] = 42886
					order[2] = 0
					super(42884, 42885, order)
				end
			end
		end

		class NoStipulations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 233
				order[1] = 234
				order[2] = 0
				super(232, 233, order)
			end
		end

		class NoLegs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(162)
				order[0] = 600
				order[1] = 601
				order[2] = 602
				order[3] = 603
				order[4] = 1788
				order[5] = 607
				order[6] = 1594
				order[7] = 608
				order[8] = 2893
				order[9] = 609
				order[10] = 764
				order[11] = 610
				order[12] = 611
				order[13] = 1212
				order[14] = 2146
				order[15] = 2147
				order[16] = 2148
				order[17] = 248
				order[18] = 2149
				order[19] = 2150
				order[20] = 2151
				order[21] = 2152
				order[22] = 2153
				order[23] = 2154
				order[24] = 2155
				order[25] = 2348
				order[26] = 2067
				order[27] = 2068
				order[28] = 2069
				order[29] = 2739
				order[30] = 2070
				order[31] = 2156
				order[32] = 2157
				order[33] = 2158
				order[34] = 2159
				order[35] = 2160
				order[36] = 2161
				order[37] = 2162
				order[38] = 2163
				order[39] = 2164
				order[40] = 2165
				order[41] = 2880
				order[42] = 2166
				order[43] = 2167
				order[44] = 2168
				order[45] = 2169
				order[46] = 2170
				order[47] = 2171
				order[48] = 2172
				order[49] = 2173
				order[50] = 2174
				order[51] = 2175
				order[52] = 2176
				order[53] = 2177
				order[54] = 2178
				order[55] = 2179
				order[56] = 2180
				order[57] = 249
				order[58] = 250
				order[59] = 251
				order[60] = 252
				order[61] = 253
				order[62] = 257
				order[63] = 599
				order[64] = 596
				order[65] = 597
				order[66] = 598
				order[67] = 254
				order[68] = 612
				order[69] = 942
				order[70] = 2908
				order[71] = 2181
				order[72] = 2182
				order[73] = 2183
				order[74] = 2184
				order[75] = 2604
				order[76] = 2185
				order[77] = 2605
				order[78] = 2186
				order[79] = 2187
				order[80] = 2188
				order[81] = 2189
				order[82] = 613
				order[83] = 614
				order[84] = 1436
				order[85] = 2354
				order[86] = 1440
				order[87] = 2190
				order[88] = 2191
				order[89] = 999
				order[90] = 1224
				order[91] = 1720
				order[92] = 2909
				order[93] = 1421
				order[94] = 1422
				order[95] = 1721
				order[96] = 2910
				order[97] = 2192
				order[98] = 1001
				order[99] = 1420
				order[100] = 2193
				order[101] = 2194
				order[102] = 2755
				order[103] = 2195
				order[104] = 2196
				order[105] = 2197
				order[106] = 2198
				order[107] = 1528
				order[108] = 2911
				order[109] = 2199
				order[110] = 2200
				order[111] = 2201
				order[112] = 2202
				order[113] = 2203
				order[114] = 615
				order[115] = 616
				order[116] = 2205
				order[117] = 2206
				order[118] = 617
				order[119] = 618
				order[120] = 619
				order[121] = 2740
				order[122] = 2717
				order[123] = 2718
				order[124] = 2719
				order[125] = 620
				order[126] = 621
				order[127] = 622
				order[128] = 2207
				order[129] = 2208
				order[130] = 623
				order[131] = 624
				order[132] = 556
				order[133] = 2898
				order[134] = 740
				order[135] = 739
				order[136] = 955
				order[137] = 956
				order[138] = 1358
				order[139] = 2682
				order[140] = 2686
				order[141] = 1017
				order[142] = 566
				order[143] = 2209
				order[144] = 2211
				order[145] = 2212
				order[146] = 2213
				order[147] = 2754
				order[148] = 2214
				order[149] = 2215
				order[150] = 2606
				order[151] = 2607
				order[152] = 690
				order[153] = 587
				order[154] = 683
				order[155] = 676
				order[156] = 2951
				order[157] = 677
				order[158] = 678
				order[159] = 679
				order[160] = 680
				order[161] = 0
				super(555, 600, order)
			end

			class NoLegSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 605
					order[1] = 606
					order[2] = 2958
					order[3] = 0
					super(604, 605, order)
				end
			end

			class NoLegSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2077
					order[1] = 2078
					order[2] = 2079
					order[3] = 2743
					order[4] = 0
					super(2076, 2077, order)
				end
			end

			class NoLegAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2309
					order[1] = 2310
					order[2] = 2311
					order[3] = 0
					super(2308, 2309, order)
				end
			end

			class NoLegEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 2060
					order[1] = 2061
					order[2] = 2062
					order[3] = 2063
					order[4] = 2064
					order[5] = 2341
					order[6] = 2065
					order[7] = 2066
					order[8] = 2074
					order[9] = 2075
					order[10] = 0
					super(2059, 2060, order)
				end
			end

			class NoLegInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 2255
					order[1] = 2256
					order[2] = 2257
					order[3] = 2379
					order[4] = 2258
					order[5] = 0
					super(2254, 2255, order)
				end

				class NoLegInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2259
						order[1] = 2260
						order[2] = 0
						super(2258, 2259, order)
					end
				end
			end

			class NoLegComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2219
					order[1] = 2220
					order[2] = 2221
					order[3] = 2222
					order[4] = 2223
					order[5] = 2224
					order[6] = 2225
					order[7] = 2226
					order[8] = 2944
					order[9] = 2227
					order[10] = 2228
					order[11] = 2229
					order[12] = 2230
					order[13] = 2231
					order[14] = 2232
					order[15] = 2250
					order[16] = 2233
					order[17] = 2945
					order[18] = 2234
					order[19] = 2946
					order[20] = 2235
					order[21] = 2236
					order[22] = 2409
					order[23] = 2410
					order[24] = 2237
					order[25] = 2238
					order[26] = 2239
					order[27] = 2240
					order[28] = 2241
					order[29] = 41382
					order[30] = 41389
					order[31] = 41390
					order[32] = 41391
					order[33] = 41392
					order[34] = 41393
					order[35] = 41394
					order[36] = 41395
					order[37] = 41396
					order[38] = 41397
					order[39] = 41379
					order[40] = 2242
					order[41] = 2243
					order[42] = 2244
					order[43] = 2245
					order[44] = 2246
					order[45] = 41398
					order[46] = 41366
					order[47] = 2608
					order[48] = 2609
					order[49] = 2610
					order[50] = 2248
					order[51] = 2249
					order[52] = 0
					super(2218, 2219, order)
				end

				class NoLegComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2251
						order[1] = 2252
						order[2] = 2253
						order[3] = 0
						super(2250, 2251, order)
					end

					class NoLegComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2204
							order[1] = 2247
							order[2] = 0
							super(2253, 2204, order)
						end
					end
				end

				class NoLegComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41383
						order[1] = 41384
						order[2] = 41385
						order[3] = 41386
						order[4] = 0
						super(41382, 41383, order)
					end
				end

				class NoLegComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41388
						order[1] = 0
						super(41387, 41388, order)
					end
				end

				class NoLegComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41380
						order[1] = 41381
						order[2] = 41400
						order[3] = 41376
						order[4] = 41363
						order[5] = 0
						super(41379, 41380, order)
					end

					class NoLegComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41401
							order[1] = 41402
							order[2] = 41403
							order[3] = 41404
							order[4] = 41405
							order[5] = 0
							super(41400, 41401, order)
						end
					end

					class NoLegComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41377
							order[1] = 41378
							order[2] = 0
							super(41376, 41377, order)
						end
					end

					class NoLegComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41364
							order[1] = 41365
							order[2] = 0
							super(41363, 41364, order)
						end
					end
				end

				class NoLegComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41399
						order[1] = 0
						super(41398, 41399, order)
					end
				end

				class NoLegComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41367
						order[1] = 41368
						order[2] = 41369
						order[3] = 41370
						order[4] = 41371
						order[5] = 41372
						order[6] = 41373
						order[7] = 41374
						order[8] = 0
						super(41366, 41367, order)
					end

					class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41375
							order[1] = 0
							super(41374, 41375, order)
						end
					end
				end
			end

			class NoLegBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40924
					order[1] = 0
					super(40923, 40924, order)
				end
			end

			class NoLegPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41608
					order[1] = 0
					super(41607, 41608, order)
				end
			end

			class NoLegMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41468
					order[1] = 40223
					order[2] = 0
					super(41467, 41468, order)
				end
			end

			class NoLegMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41470
					order[1] = 40990
					order[2] = 0
					super(41469, 41470, order)
				end
			end

			class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41472
					order[1] = 41473
					order[2] = 41474
					order[3] = 41475
					order[4] = 41476
					order[5] = 41477
					order[6] = 41478
					order[7] = 41479
					order[8] = 41480
					order[9] = 0
					super(41471, 41472, order)
				end
			end

			class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42582
					order[1] = 0
					super(42581, 42582, order)
				end
			end

			class NoLegOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41492
					order[1] = 0
					super(41491, 41492, order)
				end
			end

			class NoLegOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41513
					order[1] = 41514
					order[2] = 0
					super(41512, 41513, order)
				end
			end

			class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41516
					order[1] = 0
					super(41515, 41516, order)
				end
			end

			class NoLegOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41528
					order[1] = 41529
					order[2] = 0
					super(41527, 41528, order)
				end
			end

			class NoLegStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40242
					order[1] = 41700
					order[2] = 40243
					order[3] = 42583
					order[4] = 42584
					order[5] = 40244
					order[6] = 40245
					order[7] = 41702
					order[8] = 40246
					order[9] = 40247
					order[10] = 42585
					order[11] = 42586
					order[12] = 41703
					order[13] = 41704
					order[14] = 41705
					order[15] = 41706
					order[16] = 41707
					order[17] = 41708
					order[18] = 41648
					order[19] = 41649
					order[20] = 41650
					order[21] = 41651
					order[22] = 41652
					order[23] = 41653
					order[24] = 41654
					order[25] = 42588
					order[26] = 41655
					order[27] = 41656
					order[28] = 41657
					order[29] = 41658
					order[30] = 41659
					order[31] = 41660
					order[32] = 41661
					order[33] = 41662
					order[34] = 41663
					order[35] = 41664
					order[36] = 41665
					order[37] = 41666
					order[38] = 41667
					order[39] = 41668
					order[40] = 41669
					order[41] = 41670
					order[42] = 41671
					order[43] = 41672
					order[44] = 41673
					order[45] = 40249
					order[46] = 40250
					order[47] = 40252
					order[48] = 40253
					order[49] = 40254
					order[50] = 40255
					order[51] = 40256
					order[52] = 40257
					order[53] = 40258
					order[54] = 40260
					order[55] = 40261
					order[56] = 40262
					order[57] = 40263
					order[58] = 40264
					order[59] = 41641
					order[60] = 41642
					order[61] = 40265
					order[62] = 40267
					order[63] = 40268
					order[64] = 40270
					order[65] = 40271
					order[66] = 40272
					order[67] = 40273
					order[68] = 40274
					order[69] = 40275
					order[70] = 40276
					order[71] = 41643
					order[72] = 41644
					order[73] = 41645
					order[74] = 40279
					order[75] = 40280
					order[76] = 40281
					order[77] = 42399
					order[78] = 40282
					order[79] = 40283
					order[80] = 43108
					order[81] = 40284
					order[82] = 40285
					order[83] = 40286
					order[84] = 40287
					order[85] = 40288
					order[86] = 42400
					order[87] = 42401
					order[88] = 42402
					order[89] = 42403
					order[90] = 40289
					order[91] = 40290
					order[92] = 40291
					order[93] = 41549
					order[94] = 41550
					order[95] = 41551
					order[96] = 41552
					order[97] = 41553
					order[98] = 41554
					order[99] = 41555
					order[100] = 42404
					order[101] = 40374
					order[102] = 40418
					order[103] = 41429
					order[104] = 41430
					order[105] = 41431
					order[106] = 41432
					order[107] = 41433
					order[108] = 42194
					order[109] = 42195
					order[110] = 41434
					order[111] = 41435
					order[112] = 41436
					order[113] = 41437
					order[114] = 41438
					order[115] = 41219
					order[116] = 41439
					order[117] = 41440
					order[118] = 41441
					order[119] = 41442
					order[120] = 41443
					order[121] = 41444
					order[122] = 41445
					order[123] = 41446
					order[124] = 41447
					order[125] = 41448
					order[126] = 41449
					order[127] = 41450
					order[128] = 41451
					order[129] = 43095
					order[130] = 41408
					order[131] = 40248
					order[132] = 40978
					order[133] = 40979
					order[134] = 0
					super(40241, 40242, order)
				end

				class NoLegStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41675
						order[1] = 41676
						order[2] = 0
						super(41674, 41675, order)
					end
				end

				class NoLegStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41453
						order[1] = 41454
						order[2] = 41455
						order[3] = 0
						super(41452, 41453, order)
					end
				end

				class NoLegStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41678
						order[1] = 41679
						order[2] = 0
						super(41677, 41678, order)
					end
				end

				class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41647
						order[1] = 0
						super(41646, 41647, order)
					end
				end

				class NoLegStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41687
						order[1] = 41688
						order[2] = 41689
						order[3] = 41690
						order[4] = 41691
						order[5] = 41692
						order[6] = 41693
						order[7] = 41694
						order[8] = 41695
						order[9] = 41696
						order[10] = 41697
						order[11] = 41680
						order[12] = 41698
						order[13] = 41699
						order[14] = 0
						super(41686, 41687, order)
					end

					class NoLegStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41681
							order[1] = 41682
							order[2] = 41683
							order[3] = 0
							super(41680, 41681, order)
						end

						class NoLegStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41684
								order[1] = 41685
								order[2] = 41935
								order[3] = 0
								super(41683, 41684, order)
							end
						end
					end
				end

				class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40251
						order[1] = 0
						super(40942, 40251, order)
					end
				end

				class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40259
						order[1] = 0
						super(40943, 40259, order)
					end
				end

				class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40266
						order[1] = 0
						super(40940, 40266, order)
					end
				end

				class NoLegStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41639
						order[1] = 41640
						order[2] = 0
						super(41638, 41639, order)
					end
				end

				class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40269
						order[1] = 0
						super(40941, 40269, order)
					end
				end

				class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40293
						order[1] = 0
						super(40930, 40293, order)
					end
				end

				class NoLegPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41590
						order[1] = 41591
						order[2] = 0
						super(41589, 41590, order)
					end
				end

				class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40305
						order[1] = 0
						super(40931, 40305, order)
					end
				end

				class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40311
						order[1] = 0
						super(40932, 40311, order)
					end
				end

				class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40318
						order[1] = 0
						super(40933, 40318, order)
					end
				end

				class NoLegPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42460
						order[1] = 42461
						order[2] = 0
						super(42459, 42460, order)
					end
				end

				class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41562
						order[1] = 0
						super(41561, 41562, order)
					end
				end

				class NoLegPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41597
						order[1] = 41598
						order[2] = 0
						super(41596, 41597, order)
					end
				end

				class NoLegPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41594
						order[1] = 41595
						order[2] = 0
						super(41593, 41594, order)
					end
				end

				class NoLegPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43110
						order[1] = 42486
						order[2] = 42487
						order[3] = 0
						super(42485, 43110, order)
					end
				end

				class NoLegDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42367
						order[1] = 42368
						order[2] = 42369
						order[3] = 42370
						order[4] = 42371
						order[5] = 42372
						order[6] = 42386
						order[7] = 42373
						order[8] = 42374
						order[9] = 42375
						order[10] = 42376
						order[11] = 42377
						order[12] = 42378
						order[13] = 42379
						order[14] = 42380
						order[15] = 42381
						order[16] = 42382
						order[17] = 42383
						order[18] = 42384
						order[19] = 42385
						order[20] = 0
						super(42366, 42367, order)
					end

					class NoLegDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42387
							order[1] = 0
							super(42386, 42387, order)
						end
					end
				end

				class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42365
						order[1] = 0
						super(42364, 42365, order)
					end
				end

				class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42311
						order[1] = 0
						super(42310, 42311, order)
					end
				end

				class NoLegReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 42535
						order[1] = 42536
						order[2] = 42537
						order[3] = 42538
						order[4] = 42539
						order[5] = 42540
						order[6] = 42564
						order[7] = 42530
						order[8] = 42541
						order[9] = 42542
						order[10] = 42543
						order[11] = 42544
						order[12] = 42545
						order[13] = 42546
						order[14] = 42547
						order[15] = 42548
						order[16] = 42549
						order[17] = 42550
						order[18] = 42551
						order[19] = 42552
						order[20] = 42560
						order[21] = 42553
						order[22] = 42554
						order[23] = 42508
						order[24] = 42555
						order[25] = 42556
						order[26] = 42557
						order[27] = 42558
						order[28] = 42559
						order[29] = 0
						super(42534, 42535, order)
					end

					class NoLegReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 42565
							order[1] = 42566
							order[2] = 42567
							order[3] = 42568
							order[4] = 0
							super(42564, 42565, order)
						end
					end

					class NoLegReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42531
							order[1] = 42532
							order[2] = 42533
							order[3] = 0
							super(42530, 42531, order)
						end
					end

					class NoLegReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42561
							order[1] = 42562
							order[2] = 42563
							order[3] = 0
							super(42560, 42561, order)
						end
					end

					class NoLegReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 42509
							order[1] = 42571
							order[2] = 42510
							order[3] = 42511
							order[4] = 42512
							order[5] = 42513
							order[6] = 42514
							order[7] = 42515
							order[8] = 42516
							order[9] = 42517
							order[10] = 42518
							order[11] = 42519
							order[12] = 42520
							order[13] = 42521
							order[14] = 42522
							order[15] = 42523
							order[16] = 42524
							order[17] = 42525
							order[18] = 42526
							order[19] = 42527
							order[20] = 42528
							order[21] = 42529
							order[22] = 42569
							order[23] = 0
							super(42508, 42509, order)
						end

						class NoLegReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 42572
								order[1] = 42573
								order[2] = 0
								super(42571, 42572, order)
							end
						end

						class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 42570
								order[1] = 0
								super(42569, 42570, order)
							end
						end
					end
				end

				class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42420
						order[1] = 0
						super(42419, 42420, order)
					end
				end

				class NoLegPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42406
						order[1] = 42407
						order[2] = 0
						super(42405, 42406, order)
					end
				end

				class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40361
						order[1] = 0
						super(40929, 40361, order)
					end
				end

				class NoLegNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40368
						order[1] = 40369
						order[2] = 0
						super(40367, 40368, order)
					end
				end

				class NoLegSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40903
						order[1] = 40366
						order[2] = 40370
						order[3] = 40905
						order[4] = 40906
						order[5] = 0
						super(40902, 40903, order)
					end
				end

				class NoLegPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40375
						order[1] = 41533
						order[2] = 41534
						order[3] = 40376
						order[4] = 40377
						order[5] = 40378
						order[6] = 40379
						order[7] = 40380
						order[8] = 40381
						order[9] = 40382
						order[10] = 40383
						order[11] = 40384
						order[12] = 40385
						order[13] = 41535
						order[14] = 41536
						order[15] = 41537
						order[16] = 41538
						order[17] = 40386
						order[18] = 40387
						order[19] = 40388
						order[20] = 40389
						order[21] = 41539
						order[22] = 41540
						order[23] = 41541
						order[24] = 41542
						order[25] = 40390
						order[26] = 40391
						order[27] = 40392
						order[28] = 40393
						order[29] = 40394
						order[30] = 40395
						order[31] = 40414
						order[32] = 40396
						order[33] = 40397
						order[34] = 40398
						order[35] = 40399
						order[36] = 40927
						order[37] = 40401
						order[38] = 40402
						order[39] = 40403
						order[40] = 41543
						order[41] = 41544
						order[42] = 40404
						order[43] = 41530
						order[44] = 41545
						order[45] = 41546
						order[46] = 41547
						order[47] = 41548
						order[48] = 40405
						order[49] = 40406
						order[50] = 40407
						order[51] = 40408
						order[52] = 40928
						order[53] = 40410
						order[54] = 40411
						order[55] = 40412
						order[56] = 40413
						order[57] = 0
						super(40374, 40375, order)
					end

					class NoLegPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40415
							order[1] = 40416
							order[2] = 40417
							order[3] = 0
							super(40414, 40415, order)
						end
					end

					class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40400
							order[1] = 0
							super(40927, 40400, order)
						end
					end

					class NoLegPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41531
							order[1] = 41532
							order[2] = 0
							super(41530, 41531, order)
						end
					end

					class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40409
							order[1] = 0
							super(40928, 40409, order)
						end
					end
				end

				class NoLegPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40419
						order[1] = 40420
						order[2] = 42497
						order[3] = 42498
						order[4] = 42499
						order[5] = 42500
						order[6] = 42501
						order[7] = 42502
						order[8] = 42503
						order[9] = 42488
						order[10] = 42489
						order[11] = 42490
						order[12] = 42491
						order[13] = 42492
						order[14] = 42493
						order[15] = 42494
						order[16] = 40421
						order[17] = 40422
						order[18] = 40423
						order[19] = 40424
						order[20] = 40425
						order[21] = 40426
						order[22] = 40427
						order[23] = 40428
						order[24] = 40429
						order[25] = 40430
						order[26] = 40431
						order[27] = 40432
						order[28] = 40433
						order[29] = 40434
						order[30] = 40435
						order[31] = 40436
						order[32] = 40437
						order[33] = 40438
						order[34] = 40439
						order[35] = 40440
						order[36] = 40441
						order[37] = 40442
						order[38] = 40443
						order[39] = 40444
						order[40] = 40445
						order[41] = 40446
						order[42] = 40447
						order[43] = 0
						super(40418, 40419, order)
					end

					class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42505
							order[1] = 0
							super(42504, 42505, order)
						end
					end

					class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42496
							order[1] = 0
							super(42495, 42496, order)
						end
					end
				end

				class NoLegDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41461
						order[1] = 0
						super(41460, 41461, order)
					end
				end

				class NoLegDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41457
						order[1] = 41458
						order[2] = 41459
						order[3] = 0
						super(41456, 41457, order)
					end
				end

				class NoLegDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41409
						order[1] = 41410
						order[2] = 41411
						order[3] = 41412
						order[4] = 41413
						order[5] = 41414
						order[6] = 41415
						order[7] = 41416
						order[8] = 41417
						order[9] = 41418
						order[10] = 41419
						order[11] = 41420
						order[12] = 41421
						order[13] = 41422
						order[14] = 0
						super(41408, 41409, order)
					end

					class NoLegDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41423
							order[1] = 41424
							order[2] = 41425
							order[3] = 0
							super(41422, 41423, order)
						end

						class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41426
								order[1] = 41427
								order[2] = 41428
								order[3] = 0
								super(41425, 41426, order)
							end
						end
					end
				end
			end

			class NoLegProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 40449
					order[1] = 40450
					order[2] = 40451
					order[3] = 40939
					order[4] = 40453
					order[5] = 40454
					order[6] = 40455
					order[7] = 42506
					order[8] = 42507
					order[9] = 40456
					order[10] = 40457
					order[11] = 40458
					order[12] = 40524
					order[13] = 40525
					order[14] = 40526
					order[15] = 40528
					order[16] = 40529
					order[17] = 40530
					order[18] = 40531
					order[19] = 40532
					order[20] = 40476
					order[21] = 40478
					order[22] = 40479
					order[23] = 40480
					order[24] = 40481
					order[25] = 40482
					order[26] = 40483
					order[27] = 40484
					order[28] = 40485
					order[29] = 40486
					order[30] = 40487
					order[31] = 40488
					order[32] = 40489
					order[33] = 40490
					order[34] = 40491
					order[35] = 40492
					order[36] = 40493
					order[37] = 40494
					order[38] = 40498
					order[39] = 40499
					order[40] = 40501
					order[41] = 40502
					order[42] = 40503
					order[43] = 40504
					order[44] = 40505
					order[45] = 40506
					order[46] = 40507
					order[47] = 40508
					order[48] = 40509
					order[49] = 40511
					order[50] = 40512
					order[51] = 40513
					order[52] = 40514
					order[53] = 40515
					order[54] = 40459
					order[55] = 40460
					order[56] = 40461
					order[57] = 40462
					order[58] = 40463
					order[59] = 40464
					order[60] = 40465
					order[61] = 40516
					order[62] = 40518
					order[63] = 40519
					order[64] = 40520
					order[65] = 40521
					order[66] = 40522
					order[67] = 40523
					order[68] = 40466
					order[69] = 40467
					order[70] = 40468
					order[71] = 40469
					order[72] = 40470
					order[73] = 41407
					order[74] = 40472
					order[75] = 40980
					order[76] = 40981
					order[77] = 40533
					order[78] = 0
					super(40448, 40449, order)
				end

				class NoLegProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40452
						order[1] = 0
						super(40939, 40452, order)
					end
				end

				class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40527
						order[1] = 0
						super(40935, 40527, order)
					end
				end

				class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40477
						order[1] = 0
						super(40936, 40477, order)
					end
				end

				class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40496
						order[1] = 40497
						order[2] = 0
						super(40495, 40496, order)
					end
				end

				class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40500
						order[1] = 0
						super(40937, 40500, order)
					end
				end

				class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40510
						order[1] = 0
						super(40938, 40510, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40517
						order[1] = 0
						super(40934, 40517, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40474
						order[1] = 40475
						order[2] = 0
						super(40473, 40474, order)
					end
				end

				class NoLegProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40534
						order[1] = 40535
						order[2] = 40536
						order[3] = 2380
						order[4] = 40537
						order[5] = 0
						super(40533, 40534, order)
					end

					class NoLegProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40538
							order[1] = 40539
							order[2] = 0
							super(40537, 40538, order)
						end
					end
				end
			end

			class NoLegAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41336
					order[1] = 41337
					order[2] = 41316
					order[3] = 0
					super(41335, 41336, order)
				end

				class NoLegAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41317
						order[1] = 41318
						order[2] = 41319
						order[3] = 41320
						order[4] = 41321
						order[5] = 41322
						order[6] = 41323
						order[7] = 41324
						order[8] = 41325
						order[9] = 41326
						order[10] = 41327
						order[11] = 41328
						order[12] = 41329
						order[13] = 41330
						order[14] = 41331
						order[15] = 41332
						order[16] = 41333
						order[17] = 41334
						order[18] = 0
						super(41316, 41317, order)
					end
				end
			end

			class NoLegProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 41618
					order[1] = 41619
					order[2] = 41620
					order[3] = 41621
					order[4] = 41622
					order[5] = 41623
					order[6] = 41624
					order[7] = 41614
					order[8] = 41625
					order[9] = 41635
					order[10] = 41617
					order[11] = 0
					super(41616, 41618, order)
				end

				class NoLegProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41615
						order[1] = 0
						super(41614, 41615, order)
					end
				end

				class NoLegProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41626
						order[1] = 41627
						order[2] = 41628
						order[3] = 41629
						order[4] = 41630
						order[5] = 41631
						order[6] = 41632
						order[7] = 41633
						order[8] = 0
						super(41625, 41626, order)
					end

					class NoLegProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41634
							order[1] = 0
							super(41633, 41634, order)
						end
					end
				end

				class NoLegProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41636
						order[1] = 41637
						order[2] = 0
						super(41635, 41636, order)
					end
				end
			end

			class NoLegCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 41345
					order[1] = 41346
					order[2] = 41347
					order[3] = 41348
					order[4] = 41349
					order[5] = 41350
					order[6] = 41351
					order[7] = 41352
					order[8] = 41353
					order[9] = 41354
					order[10] = 41355
					order[11] = 41342
					order[12] = 42308
					order[13] = 42309
					order[14] = 41356
					order[15] = 41357
					order[16] = 42299
					order[17] = 42300
					order[18] = 42301
					order[19] = 42302
					order[20] = 42303
					order[21] = 42304
					order[22] = 42305
					order[23] = 41358
					order[24] = 41359
					order[25] = 41360
					order[26] = 41361
					order[27] = 41362
					order[28] = 0
					super(41344, 41345, order)
				end

				class NoLegCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41343
						order[1] = 0
						super(41342, 41343, order)
					end
				end

				class NoLegCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42307
						order[1] = 0
						super(42306, 42307, order)
					end
				end
			end

			class NoLegPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41604
					order[1] = 41601
					order[2] = 41602
					order[3] = 41603
					order[4] = 41600
					order[5] = 0
					super(41599, 41604, order)
				end

				class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41605
						order[1] = 41606
						order[2] = 0
						super(41604, 41605, order)
					end
				end
			end

			class NoLegExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42389
					order[1] = 42390
					order[2] = 0
					super(42388, 42389, order)
				end
			end

			class NoLegStipulations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 688
					order[1] = 689
					order[2] = 0
					super(683, 688, order)
				end
			end
		end

		class NoRelatedInstruments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1648
				order[1] = 1649
				order[2] = 1650
				order[3] = 1651
				order[4] = 1652
				order[5] = 1653
				order[6] = 2413
				order[7] = 2414
				order[8] = 2415
				order[9] = 2417
				order[10] = 0
				super(1647, 1648, order)
			end
		end
	end
end

class AdjustedPositionReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BL") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoPositions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 703
			order[1] = 704
			order[2] = 705
			order[3] = 1654
			order[4] = 706
			order[5] = 976
			order[6] = 1836
			order[7] = 1835
			order[8] = 2936
			order[9] = 539
			order[10] = 0
			super(702, 703, order)
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end

	class NoRelatedSym < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(183)
			order[0] = 55
			order[1] = 65
			order[2] = 48
			order[3] = 22
			order[4] = 460
			order[5] = 1227
			order[6] = 1151
			order[7] = 461
			order[8] = 2891
			order[9] = 167
			order[10] = 762
			order[11] = 200
			order[12] = 541
			order[13] = 1079
			order[14] = 966
			order[15] = 1049
			order[16] = 965
			order[17] = 224
			order[18] = 1449
			order[19] = 1450
			order[20] = 1451
			order[21] = 1452
			order[22] = 1457
			order[23] = 1458
			order[24] = 1739
			order[25] = 2210
			order[26] = 1938
			order[27] = 1939
			order[28] = 1940
			order[29] = 2735
			order[30] = 1941
			order[31] = 1575
			order[32] = 1942
			order[33] = 1943
			order[34] = 1944
			order[35] = 1945
			order[36] = 1946
			order[37] = 1947
			order[38] = 1948
			order[39] = 1949
			order[40] = 1950
			order[41] = 2879
			order[42] = 1951
			order[43] = 1952
			order[44] = 1953
			order[45] = 1954
			order[46] = 1955
			order[47] = 1956
			order[48] = 1957
			order[49] = 1958
			order[50] = 1959
			order[51] = 1960
			order[52] = 1577
			order[53] = 1580
			order[54] = 1581
			order[55] = 1678
			order[56] = 1697
			order[57] = 225
			order[58] = 239
			order[59] = 226
			order[60] = 227
			order[61] = 228
			order[62] = 255
			order[63] = 543
			order[64] = 470
			order[65] = 471
			order[66] = 472
			order[67] = 240
			order[68] = 202
			order[69] = 2578
			order[70] = 2577
			order[71] = 947
			order[72] = 2904
			order[73] = 967
			order[74] = 968
			order[75] = 1698
			order[76] = 1866
			order[77] = 2600
			order[78] = 2001
			order[79] = 2601
			order[80] = 1478
			order[81] = 1479
			order[82] = 1480
			order[83] = 1481
			order[84] = 206
			order[85] = 231
			order[86] = 1435
			order[87] = 2353
			order[88] = 1439
			order[89] = 969
			order[90] = 1146
			order[91] = 996
			order[92] = 1147
			order[93] = 1716
			order[94] = 2905
			order[95] = 1191
			order[96] = 1192
			order[97] = 1717
			order[98] = 2906
			order[99] = 1193
			order[100] = 2579
			order[101] = 1194
			order[102] = 1482
			order[103] = 1195
			order[104] = 2753
			order[105] = 1196
			order[106] = 1197
			order[107] = 2002
			order[108] = 2140
			order[109] = 1524
			order[110] = 2907
			order[111] = 1198
			order[112] = 1199
			order[113] = 1200
			order[114] = 201
			order[115] = 2681
			order[116] = 2685
			order[117] = 1244
			order[118] = 1242
			order[119] = 2575
			order[120] = 2574
			order[121] = 997
			order[122] = 223
			order[123] = 207
			order[124] = 970
			order[125] = 971
			order[126] = 106
			order[127] = 348
			order[128] = 349
			order[129] = 2737
			order[130] = 2714
			order[131] = 2715
			order[132] = 2716
			order[133] = 107
			order[134] = 350
			order[135] = 351
			order[136] = 691
			order[137] = 667
			order[138] = 875
			order[139] = 876
			order[140] = 873
			order[141] = 874
			order[142] = 1687
			order[143] = 1787
			order[144] = 2141
			order[145] = 2142
			order[146] = 2143
			order[147] = 2752
			order[148] = 2144
			order[149] = 2145
			order[150] = 2576
			order[151] = 2962
			order[152] = 2602
			order[153] = 2603
			order[154] = 668
			order[155] = 869
			order[156] = 2736
			order[157] = 2738
			order[158] = 913
			order[159] = 914
			order[160] = 1961
			order[161] = 915
			order[162] = 918
			order[163] = 2952
			order[164] = 1962
			order[165] = 1963
			order[166] = 1964
			order[167] = 1965
			order[168] = 1966
			order[169] = 1967
			order[170] = 1968
			order[171] = 1969
			order[172] = 1970
			order[173] = 1513
			order[174] = 1525
			order[175] = 1527
			order[176] = 788
			order[177] = 916
			order[178] = 917
			order[179] = 919
			order[180] = 898
			order[181] = 1647
			order[182] = 0
			super(146, 55, order)
		end

		class NoSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 455
				order[1] = 456
				order[2] = 2957
				order[3] = 0
				super(454, 455, order)
			end
		end

		class NoSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1977
				order[1] = 1978
				order[2] = 1979
				order[3] = 2741
				order[4] = 0
				super(1976, 1977, order)
			end
		end

		class NoAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2305
				order[1] = 2306
				order[2] = 2307
				order[3] = 0
				super(2304, 2305, order)
			end
		end

		class NoEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 865
				order[1] = 866
				order[2] = 1145
				order[3] = 1827
				order[4] = 1826
				order[5] = 2340
				order[6] = 867
				order[7] = 868
				order[8] = 1578
				order[9] = 1579
				order[10] = 0
				super(864, 865, order)
			end
		end

		class NoInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1019
				order[1] = 1050
				order[2] = 1051
				order[3] = 2378
				order[4] = 1052
				order[5] = 0
				super(1018, 1019, order)
			end

			class NoInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1053
					order[1] = 1054
					order[2] = 0
					super(1052, 1053, order)
				end
			end
		end

		class NoComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 1484
				order[1] = 2117
				order[2] = 2118
				order[3] = 2119
				order[4] = 1485
				order[5] = 2120
				order[6] = 2121
				order[7] = 2122
				order[8] = 2941
				order[9] = 1486
				order[10] = 2123
				order[11] = 1487
				order[12] = 1488
				order[13] = 1489
				order[14] = 1490
				order[15] = 1491
				order[16] = 2124
				order[17] = 2942
				order[18] = 2125
				order[19] = 2943
				order[20] = 2126
				order[21] = 2127
				order[22] = 2407
				order[23] = 2408
				order[24] = 2128
				order[25] = 2129
				order[26] = 2130
				order[27] = 2131
				order[28] = 2132
				order[29] = 41013
				order[30] = 41020
				order[31] = 41021
				order[32] = 41022
				order[33] = 41023
				order[34] = 41024
				order[35] = 41025
				order[36] = 41026
				order[37] = 41027
				order[38] = 41028
				order[39] = 41010
				order[40] = 2133
				order[41] = 2134
				order[42] = 2135
				order[43] = 2136
				order[44] = 2137
				order[45] = 41029
				order[46] = 40997
				order[47] = 2597
				order[48] = 2598
				order[49] = 2599
				order[50] = 2138
				order[51] = 2139
				order[52] = 0
				super(1483, 1484, order)
			end

			class NoComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1492
					order[1] = 1493
					order[2] = 1494
					order[3] = 0
					super(1491, 1492, order)
				end

				class NoComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1495
						order[1] = 1496
						order[2] = 0
						super(1494, 1495, order)
					end
				end
			end

			class NoComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41014
					order[1] = 41015
					order[2] = 41016
					order[3] = 41017
					order[4] = 0
					super(41013, 41014, order)
				end
			end

			class NoComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41019
					order[1] = 0
					super(41018, 41019, order)
				end
			end

			class NoComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41011
					order[1] = 41012
					order[2] = 41031
					order[3] = 41007
					order[4] = 40994
					order[5] = 0
					super(41010, 41011, order)
				end

				class NoComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41032
						order[1] = 41033
						order[2] = 41034
						order[3] = 41035
						order[4] = 41036
						order[5] = 0
						super(41031, 41032, order)
					end
				end

				class NoComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41008
						order[1] = 41009
						order[2] = 0
						super(41007, 41008, order)
					end
				end

				class NoComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40995
						order[1] = 40996
						order[2] = 0
						super(40994, 40995, order)
					end
				end
			end

			class NoComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41030
					order[1] = 0
					super(41029, 41030, order)
				end
			end

			class NoComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40998
					order[1] = 40999
					order[2] = 41000
					order[3] = 41001
					order[4] = 41002
					order[5] = 41003
					order[6] = 41004
					order[7] = 41005
					order[8] = 0
					super(40997, 40998, order)
				end

				class NoComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41006
						order[1] = 0
						super(41005, 41006, order)
					end
				end
			end
		end

		class NoBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40471
				order[1] = 0
				super(40278, 40471, order)
			end
		end

		class NoPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41231
				order[1] = 0
				super(41230, 41231, order)
			end
		end

		class NoMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41093
				order[1] = 40991
				order[2] = 0
				super(41092, 41093, order)
			end
		end

		class NoMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41095
				order[1] = 40992
				order[2] = 0
				super(41094, 41095, order)
			end
		end

		class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41097
				order[1] = 41098
				order[2] = 41099
				order[3] = 41100
				order[4] = 41101
				order[5] = 41102
				order[6] = 41103
				order[7] = 41104
				order[8] = 41105
				order[9] = 0
				super(41096, 41097, order)
			end
		end

		class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42776
				order[1] = 0
				super(42775, 42776, order)
			end
		end

		class NoOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41117
				order[1] = 0
				super(41116, 41117, order)
			end
		end

		class NoOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41138
				order[1] = 41139
				order[2] = 0
				super(41137, 41138, order)
			end
		end

		class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41141
				order[1] = 0
				super(41140, 41141, order)
			end
		end

		class NoOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41153
				order[1] = 41154
				order[2] = 0
				super(41152, 41153, order)
			end
		end

		class NoStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40050
				order[1] = 41303
				order[2] = 40051
				order[3] = 42784
				order[4] = 42785
				order[5] = 40052
				order[6] = 40053
				order[7] = 41305
				order[8] = 40054
				order[9] = 40055
				order[10] = 42786
				order[11] = 42787
				order[12] = 41306
				order[13] = 41307
				order[14] = 41308
				order[15] = 41309
				order[16] = 41310
				order[17] = 41311
				order[18] = 41251
				order[19] = 41252
				order[20] = 41253
				order[21] = 41254
				order[22] = 41255
				order[23] = 41256
				order[24] = 41257
				order[25] = 42587
				order[26] = 41258
				order[27] = 41259
				order[28] = 41260
				order[29] = 41261
				order[30] = 41262
				order[31] = 41263
				order[32] = 41264
				order[33] = 41265
				order[34] = 41266
				order[35] = 41267
				order[36] = 41268
				order[37] = 41269
				order[38] = 41270
				order[39] = 41271
				order[40] = 41272
				order[41] = 41273
				order[42] = 41274
				order[43] = 41275
				order[44] = 41276
				order[45] = 40907
				order[46] = 40908
				order[47] = 40910
				order[48] = 40911
				order[49] = 40912
				order[50] = 40913
				order[51] = 40914
				order[52] = 40065
				order[53] = 40066
				order[54] = 40068
				order[55] = 40069
				order[56] = 40070
				order[57] = 40071
				order[58] = 40072
				order[59] = 41244
				order[60] = 41245
				order[61] = 40073
				order[62] = 40075
				order[63] = 40076
				order[64] = 40078
				order[65] = 40079
				order[66] = 40080
				order[67] = 40081
				order[68] = 40082
				order[69] = 40083
				order[70] = 40084
				order[71] = 41246
				order[72] = 41247
				order[73] = 41248
				order[74] = 40738
				order[75] = 40739
				order[76] = 40740
				order[77] = 42600
				order[78] = 40741
				order[79] = 40742
				order[80] = 43106
				order[81] = 40743
				order[82] = 40744
				order[83] = 40745
				order[84] = 40746
				order[85] = 40747
				order[86] = 42601
				order[87] = 42602
				order[88] = 42603
				order[89] = 42604
				order[90] = 40748
				order[91] = 40749
				order[92] = 40750
				order[93] = 41180
				order[94] = 41181
				order[95] = 41182
				order[96] = 41183
				order[97] = 41184
				order[98] = 41185
				order[99] = 41186
				order[100] = 42605
				order[101] = 40828
				order[102] = 40872
				order[103] = 41058
				order[104] = 41059
				order[105] = 41060
				order[106] = 41061
				order[107] = 41062
				order[108] = 42192
				order[109] = 42193
				order[110] = 41063
				order[111] = 41064
				order[112] = 41065
				order[113] = 41066
				order[114] = 41067
				order[115] = 41218
				order[116] = 41068
				order[117] = 41069
				order[118] = 41070
				order[119] = 41071
				order[120] = 41072
				order[121] = 41073
				order[122] = 41074
				order[123] = 41075
				order[124] = 41076
				order[125] = 41077
				order[126] = 41078
				order[127] = 41079
				order[128] = 41080
				order[129] = 43094
				order[130] = 41037
				order[131] = 40056
				order[132] = 40982
				order[133] = 40983
				order[134] = 0
				super(40049, 40050, order)
			end

			class NoStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41278
					order[1] = 41279
					order[2] = 0
					super(41277, 41278, order)
				end
			end

			class NoStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41238
					order[1] = 41239
					order[2] = 41240
					order[3] = 0
					super(41237, 41238, order)
				end
			end

			class NoStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41281
					order[1] = 41282
					order[2] = 0
					super(41280, 41281, order)
				end
			end

			class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41250
					order[1] = 0
					super(41249, 41250, order)
				end
			end

			class NoStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41290
					order[1] = 41291
					order[2] = 41292
					order[3] = 41293
					order[4] = 41294
					order[5] = 41295
					order[6] = 41296
					order[7] = 41297
					order[8] = 41298
					order[9] = 41299
					order[10] = 41300
					order[11] = 41283
					order[12] = 41301
					order[13] = 41302
					order[14] = 0
					super(41289, 41290, order)
				end

				class NoStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41284
						order[1] = 41285
						order[2] = 41286
						order[3] = 0
						super(41283, 41284, order)
					end

					class NoStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41287
							order[1] = 41288
							order[2] = 41588
							order[3] = 0
							super(41286, 41287, order)
						end
					end
				end
			end

			class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40909
					order[1] = 0
					super(40960, 40909, order)
				end
			end

			class NoStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40067
					order[1] = 0
					super(40961, 40067, order)
				end
			end

			class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40074
					order[1] = 0
					super(40958, 40074, order)
				end
			end

			class NoStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41242
					order[1] = 41243
					order[2] = 0
					super(41241, 41242, order)
				end
			end

			class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40077
					order[1] = 0
					super(40959, 40077, order)
				end
			end

			class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40752
					order[1] = 0
					super(40947, 40752, order)
				end
			end

			class NoPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41221
					order[1] = 41222
					order[2] = 0
					super(41220, 41221, order)
				end
			end

			class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40763
					order[1] = 0
					super(40948, 40763, order)
				end
			end

			class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40769
					order[1] = 0
					super(40949, 40769, order)
				end
			end

			class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40776
					order[1] = 0
					super(40950, 40776, order)
				end
			end

			class NoPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42661
					order[1] = 42662
					order[2] = 0
					super(42660, 42661, order)
				end
			end

			class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41193
					order[1] = 0
					super(41192, 41193, order)
				end
			end

			class NoPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41228
					order[1] = 41229
					order[2] = 0
					super(41227, 41228, order)
				end
			end

			class NoPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41225
					order[1] = 41226
					order[2] = 0
					super(41224, 41225, order)
				end
			end

			class NoPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43109
					order[1] = 42684
					order[2] = 42685
					order[3] = 0
					super(42683, 43109, order)
				end
			end

			class NoDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42275
					order[1] = 42276
					order[2] = 42277
					order[3] = 42278
					order[4] = 42279
					order[5] = 42280
					order[6] = 42294
					order[7] = 42281
					order[8] = 42282
					order[9] = 42283
					order[10] = 42284
					order[11] = 42285
					order[12] = 42286
					order[13] = 42287
					order[14] = 42288
					order[15] = 42289
					order[16] = 42290
					order[17] = 42291
					order[18] = 42292
					order[19] = 42293
					order[20] = 0
					super(42274, 42275, order)
				end

				class NoDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42295
						order[1] = 0
						super(42294, 42295, order)
					end
				end
			end

			class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42273
					order[1] = 0
					super(42272, 42273, order)
				end
			end

			class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42237
					order[1] = 0
					super(42236, 42237, order)
				end
			end

			class NoReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42736
					order[1] = 42737
					order[2] = 42738
					order[3] = 42739
					order[4] = 42740
					order[5] = 42741
					order[6] = 42765
					order[7] = 42731
					order[8] = 42742
					order[9] = 42743
					order[10] = 42744
					order[11] = 42745
					order[12] = 42746
					order[13] = 42747
					order[14] = 42748
					order[15] = 42749
					order[16] = 42750
					order[17] = 42751
					order[18] = 42752
					order[19] = 42753
					order[20] = 42761
					order[21] = 42754
					order[22] = 42755
					order[23] = 42709
					order[24] = 42756
					order[25] = 42757
					order[26] = 42758
					order[27] = 42759
					order[28] = 42760
					order[29] = 0
					super(42735, 42736, order)
				end

				class NoReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42766
						order[1] = 42767
						order[2] = 42768
						order[3] = 42769
						order[4] = 0
						super(42765, 42766, order)
					end
				end

				class NoReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42732
						order[1] = 42733
						order[2] = 42734
						order[3] = 0
						super(42731, 42732, order)
					end
				end

				class NoReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42762
						order[1] = 42763
						order[2] = 42764
						order[3] = 0
						super(42761, 42762, order)
					end
				end

				class NoReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42710
						order[1] = 42772
						order[2] = 42711
						order[3] = 42712
						order[4] = 42713
						order[5] = 42714
						order[6] = 42715
						order[7] = 42716
						order[8] = 42717
						order[9] = 42718
						order[10] = 42719
						order[11] = 42720
						order[12] = 42721
						order[13] = 42722
						order[14] = 42723
						order[15] = 42724
						order[16] = 42725
						order[17] = 42726
						order[18] = 42727
						order[19] = 42728
						order[20] = 42729
						order[21] = 42730
						order[22] = 42770
						order[23] = 0
						super(42709, 42710, order)
					end

					class NoReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42773
							order[1] = 42774
							order[2] = 0
							super(42772, 42773, order)
						end
					end

					class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42771
							order[1] = 0
							super(42770, 42771, order)
						end
					end
				end
			end

			class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42621
					order[1] = 0
					super(42620, 42621, order)
				end
			end

			class NoPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42607
					order[1] = 42608
					order[2] = 0
					super(42606, 42607, order)
				end
			end

			class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40819
					order[1] = 0
					super(40946, 40819, order)
				end
			end

			class NoNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40826
					order[1] = 40827
					order[2] = 0
					super(40825, 40826, order)
				end
			end

			class NoSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40086
					order[1] = 40373
					order[2] = 40655
					order[3] = 40088
					order[4] = 40089
					order[5] = 0
					super(40085, 40086, order)
				end
			end

			class NoPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40829
					order[1] = 41164
					order[2] = 41165
					order[3] = 40830
					order[4] = 40831
					order[5] = 40832
					order[6] = 40833
					order[7] = 40834
					order[8] = 40835
					order[9] = 40836
					order[10] = 40837
					order[11] = 40838
					order[12] = 40839
					order[13] = 41166
					order[14] = 41167
					order[15] = 41168
					order[16] = 41169
					order[17] = 40840
					order[18] = 40841
					order[19] = 40842
					order[20] = 40843
					order[21] = 41170
					order[22] = 41171
					order[23] = 41172
					order[24] = 41173
					order[25] = 40844
					order[26] = 40845
					order[27] = 40846
					order[28] = 40847
					order[29] = 40848
					order[30] = 40849
					order[31] = 40868
					order[32] = 40850
					order[33] = 40851
					order[34] = 40852
					order[35] = 40853
					order[36] = 40977
					order[37] = 40855
					order[38] = 40856
					order[39] = 40857
					order[40] = 41174
					order[41] = 41175
					order[42] = 40858
					order[43] = 41161
					order[44] = 41176
					order[45] = 41177
					order[46] = 41178
					order[47] = 41179
					order[48] = 40859
					order[49] = 40860
					order[50] = 40861
					order[51] = 40862
					order[52] = 40945
					order[53] = 40864
					order[54] = 40865
					order[55] = 40866
					order[56] = 40867
					order[57] = 0
					super(40828, 40829, order)
				end

				class NoPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40869
						order[1] = 40870
						order[2] = 40871
						order[3] = 0
						super(40868, 40869, order)
					end
				end

				class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40854
						order[1] = 0
						super(40977, 40854, order)
					end
				end

				class NoPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41162
						order[1] = 41163
						order[2] = 0
						super(41161, 41162, order)
					end
				end

				class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40863
						order[1] = 0
						super(40945, 40863, order)
					end
				end
			end

			class NoPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40873
					order[1] = 40874
					order[2] = 42698
					order[3] = 42699
					order[4] = 42700
					order[5] = 42701
					order[6] = 42702
					order[7] = 42703
					order[8] = 42704
					order[9] = 42689
					order[10] = 42690
					order[11] = 42691
					order[12] = 42692
					order[13] = 42693
					order[14] = 42694
					order[15] = 42695
					order[16] = 40875
					order[17] = 40876
					order[18] = 40877
					order[19] = 40878
					order[20] = 40879
					order[21] = 40880
					order[22] = 40881
					order[23] = 40882
					order[24] = 40883
					order[25] = 40884
					order[26] = 40885
					order[27] = 40886
					order[28] = 40887
					order[29] = 40888
					order[30] = 40889
					order[31] = 40890
					order[32] = 40891
					order[33] = 40892
					order[34] = 40893
					order[35] = 40894
					order[36] = 40895
					order[37] = 40896
					order[38] = 40897
					order[39] = 40898
					order[40] = 40899
					order[41] = 40900
					order[42] = 40901
					order[43] = 0
					super(40872, 40873, order)
				end

				class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42706
						order[1] = 0
						super(42705, 42706, order)
					end
				end

				class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42697
						order[1] = 0
						super(42696, 42697, order)
					end
				end
			end

			class NoDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41086
					order[1] = 0
					super(41085, 41086, order)
				end
			end

			class NoDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41082
					order[1] = 41083
					order[2] = 41084
					order[3] = 0
					super(41081, 41082, order)
				end
			end

			class NoDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41038
					order[1] = 41039
					order[2] = 41040
					order[3] = 41041
					order[4] = 41042
					order[5] = 41043
					order[6] = 41044
					order[7] = 41045
					order[8] = 41046
					order[9] = 41047
					order[10] = 41048
					order[11] = 41049
					order[12] = 41050
					order[13] = 41051
					order[14] = 0
					super(41037, 41038, order)
				end

				class NoDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41052
						order[1] = 41053
						order[2] = 41054
						order[3] = 0
						super(41051, 41052, order)
					end

					class NoDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41055
							order[1] = 41056
							order[2] = 41057
							order[3] = 0
							super(41054, 41055, order)
						end
					end
				end
			end
		end

		class NoProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40091
				order[1] = 40092
				order[2] = 40093
				order[3] = 40957
				order[4] = 40095
				order[5] = 40096
				order[6] = 40097
				order[7] = 42707
				order[8] = 42708
				order[9] = 40098
				order[10] = 40099
				order[11] = 40100
				order[12] = 40114
				order[13] = 40115
				order[14] = 40116
				order[15] = 40118
				order[16] = 40119
				order[17] = 40120
				order[18] = 40121
				order[19] = 40122
				order[20] = 40123
				order[21] = 40125
				order[22] = 40126
				order[23] = 40127
				order[24] = 40128
				order[25] = 40129
				order[26] = 40130
				order[27] = 40131
				order[28] = 40132
				order[29] = 40133
				order[30] = 40134
				order[31] = 40135
				order[32] = 40136
				order[33] = 40137
				order[34] = 40138
				order[35] = 40139
				order[36] = 40140
				order[37] = 40141
				order[38] = 40145
				order[39] = 40146
				order[40] = 40148
				order[41] = 40149
				order[42] = 40150
				order[43] = 40151
				order[44] = 40152
				order[45] = 40153
				order[46] = 40154
				order[47] = 40155
				order[48] = 40156
				order[49] = 40158
				order[50] = 40159
				order[51] = 40160
				order[52] = 40161
				order[53] = 40162
				order[54] = 40101
				order[55] = 40102
				order[56] = 40103
				order[57] = 40104
				order[58] = 40105
				order[59] = 40106
				order[60] = 40107
				order[61] = 40163
				order[62] = 40165
				order[63] = 40166
				order[64] = 40167
				order[65] = 40168
				order[66] = 40169
				order[67] = 40170
				order[68] = 40108
				order[69] = 40109
				order[70] = 40110
				order[71] = 40111
				order[72] = 40112
				order[73] = 41406
				order[74] = 40113
				order[75] = 40986
				order[76] = 40987
				order[77] = 40174
				order[78] = 0
				super(40090, 40091, order)
			end

			class NoProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40094
					order[1] = 0
					super(40957, 40094, order)
				end
			end

			class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40117
					order[1] = 0
					super(40953, 40117, order)
				end
			end

			class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40124
					order[1] = 0
					super(40954, 40124, order)
				end
			end

			class NoProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40143
					order[1] = 40144
					order[2] = 0
					super(40142, 40143, order)
				end
			end

			class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40147
					order[1] = 0
					super(40955, 40147, order)
				end
			end

			class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40157
					order[1] = 0
					super(40956, 40157, order)
				end
			end

			class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40164
					order[1] = 0
					super(40952, 40164, order)
				end
			end

			class NoProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40172
					order[1] = 40173
					order[2] = 0
					super(40171, 40172, order)
				end
			end

			class NoProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40175
					order[1] = 40176
					order[2] = 40177
					order[3] = 2385
					order[4] = 40178
					order[5] = 0
					super(40174, 40175, order)
				end

				class NoProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40179
						order[1] = 40180
						order[2] = 0
						super(40178, 40179, order)
					end
				end
			end
		end

		class NoAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40020
				order[1] = 40021
				order[2] = 40000
				order[3] = 0
				super(40019, 40020, order)
			end

			class NoAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 40001
					order[1] = 40002
					order[2] = 40003
					order[3] = 40004
					order[4] = 40005
					order[5] = 40006
					order[6] = 40007
					order[7] = 40008
					order[8] = 40009
					order[9] = 40010
					order[10] = 40011
					order[11] = 40012
					order[12] = 40013
					order[13] = 40014
					order[14] = 40015
					order[15] = 40016
					order[16] = 40017
					order[17] = 40018
					order[18] = 0
					super(40000, 40001, order)
				end
			end
		end

		class NoProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 40182
				order[1] = 40183
				order[2] = 40184
				order[3] = 40185
				order[4] = 40186
				order[5] = 40187
				order[6] = 40188
				order[7] = 40951
				order[8] = 40191
				order[9] = 40201
				order[10] = 40190
				order[11] = 0
				super(40181, 40182, order)
			end

			class NoProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40189
					order[1] = 0
					super(40951, 40189, order)
				end
			end

			class NoProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40192
					order[1] = 40193
					order[2] = 40194
					order[3] = 40195
					order[4] = 40196
					order[5] = 40197
					order[6] = 40198
					order[7] = 40199
					order[8] = 0
					super(40191, 40192, order)
				end

				class NoProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40200
						order[1] = 0
						super(40199, 40200, order)
					end
				end
			end

			class NoProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40202
					order[1] = 40203
					order[2] = 0
					super(40201, 40202, order)
				end
			end
		end

		class NoCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 40023
				order[1] = 40024
				order[2] = 40916
				order[3] = 40917
				order[4] = 40025
				order[5] = 40026
				order[6] = 40027
				order[7] = 40028
				order[8] = 40029
				order[9] = 40030
				order[10] = 40031
				order[11] = 40277
				order[12] = 42216
				order[13] = 42217
				order[14] = 40033
				order[15] = 40034
				order[16] = 42207
				order[17] = 42208
				order[18] = 42209
				order[19] = 42210
				order[20] = 42211
				order[21] = 42212
				order[22] = 42213
				order[23] = 40035
				order[24] = 40036
				order[25] = 40037
				order[26] = 40038
				order[27] = 40039
				order[28] = 0
				super(40022, 40023, order)
			end

			class NoCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40032
					order[1] = 0
					super(40277, 40032, order)
				end
			end

			class NoCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42215
					order[1] = 0
					super(42214, 42215, order)
				end
			end
		end

		class NoPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40209
				order[1] = 40205
				order[2] = 40206
				order[3] = 40207
				order[4] = 40208
				order[5] = 0
				super(40204, 40209, order)
			end

			class NoPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40210
					order[1] = 40211
					order[2] = 0
					super(40209, 40210, order)
				end
			end
		end

		class NoExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42297
				order[1] = 42298
				order[2] = 0
				super(42296, 42297, order)
			end
		end

		class NoInstrAttrib < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 871
				order[1] = 872
				order[2] = 0
				super(870, 871, order)
			end
		end

		class NoIndexRollMonths < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 2733
				order[1] = 0
				super(2734, 2733, order)
			end
		end

		class NoReferenceDataDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2747
				order[1] = 2748
				order[2] = 0
				super(2746, 2747, order)
			end
		end

		class NoContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40041
				order[1] = 0
				super(40040, 40041, order)
			end
		end

		class NoFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40047
				order[1] = 40048
				order[2] = 0
				super(40046, 40047, order)
			end
		end

		class NoContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40043
				order[1] = 40044
				order[2] = 40045
				order[3] = 0
				super(40042, 40043, order)
			end
		end

		class NoRelatedInstruments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1648
				order[1] = 1649
				order[2] = 1650
				order[3] = 1651
				order[4] = 1652
				order[5] = 1653
				order[6] = 2413
				order[7] = 2414
				order[8] = 2415
				order[9] = 2417
				order[10] = 0
				super(1647, 1648, order)
			end
		end
	end
end

class AllocationInstructionAlert < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BM") )
	end

	class NoOrders < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 11
			order[1] = 37
			order[2] = 198
			order[3] = 526
			order[4] = 66
			order[5] = 756
			order[6] = 38
			order[7] = 799
			order[8] = 800
			order[9] = 40
			order[10] = 0
			super(73, 11, order)
		end

		class NoNested2PartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 757
				order[1] = 758
				order[2] = 759
				order[3] = 2381
				order[4] = 806
				order[5] = 0
				super(756, 757, order)
			end

			class NoNested2PartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 760
					order[1] = 807
					order[2] = 0
					super(806, 760, order)
				end
			end
		end
	end

	class NoExecs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(14)
			order[0] = 32
			order[1] = 17
			order[2] = 527
			order[3] = 31
			order[4] = 669
			order[5] = 29
			order[6] = 1003
			order[7] = 1041
			order[8] = 880
			order[9] = 2749
			order[10] = 2524
			order[11] = 2668
			order[12] = 1838
			order[13] = 0
			super(124, 32, order)
		end

		class NoTrdRegPublications < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2669
				order[1] = 2670
				order[2] = 0
				super(2668, 2669, order)
			end
		end

		class NoTradePriceConditions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 1839
				order[1] = 0
				super(1838, 1839, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoInstrAttrib < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 871
			order[1] = 872
			order[2] = 0
			super(870, 871, order)
		end
	end

	class NoIndexRollMonths < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2733
			order[1] = 0
			super(2734, 2733, order)
		end
	end

	class NoReferenceDataDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2747
			order[1] = 2748
			order[2] = 0
			super(2746, 2747, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoPriceQualifiers < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2710
			order[1] = 0
			super(2709, 2710, order)
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoStipulations < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 233
			order[1] = 234
			order[2] = 0
			super(232, 233, order)
		end
	end

	class NoPosAmt < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 707
			order[1] = 708
			order[2] = 2096
			order[3] = 1055
			order[4] = 2937
			order[5] = 2097
			order[6] = 2098
			order[7] = 1585
			order[8] = 2099
			order[9] = 2100
			order[10] = 2876
			order[11] = 2877
			order[12] = 0
			super(753, 707, order)
		end
	end

	class NoAllocs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(67)
			order[0] = 79
			order[1] = 661
			order[2] = 573
			order[3] = 366
			order[4] = 80
			order[5] = 2515
			order[6] = 1752
			order[7] = 1753
			order[8] = 1754
			order[9] = 1755
			order[10] = 467
			order[11] = 1729
			order[12] = 1593
			order[13] = 2727
			order[14] = 1908
			order[15] = 81
			order[16] = 989
			order[17] = 1002
			order[18] = 1735
			order[19] = 993
			order[20] = 1047
			order[21] = 992
			order[22] = 539
			order[23] = 208
			order[24] = 209
			order[25] = 161
			order[26] = 360
			order[27] = 361
			order[28] = 1732
			order[29] = 1733
			order[30] = 1734
			order[31] = 12
			order[32] = 13
			order[33] = 479
			order[34] = 2922
			order[35] = 1233
			order[36] = 1238
			order[37] = 497
			order[38] = 2653
			order[39] = 153
			order[40] = 154
			order[41] = 119
			order[42] = 2300
			order[43] = 737
			order[44] = 120
			order[45] = 736
			order[46] = 2927
			order[47] = 155
			order[48] = 156
			order[49] = 742
			order[50] = 741
			order[51] = 136
			order[52] = 576
			order[53] = 635
			order[54] = 780
			order[55] = 172
			order[56] = 169
			order[57] = 170
			order[58] = 171
			order[59] = 2392
			order[60] = 2393
			order[61] = 2483
			order[62] = 2761
			order[63] = 2770
			order[64] = 2769
			order[65] = 1844
			order[66] = 0
			super(78, 79, order)
		end

		class NoAllocRegulatoryTradeIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 1909
				order[1] = 1910
				order[2] = 1911
				order[3] = 1912
				order[4] = 2406
				order[5] = 2399
				order[6] = 0
				super(1908, 1909, order)
			end
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end

		class NoAllocCommissions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(17)
				order[0] = 2654
				order[1] = 2655
				order[2] = 2726
				order[3] = 2656
				order[4] = 2657
				order[5] = 2925
				order[6] = 2658
				order[7] = 2659
				order[8] = 2926
				order[9] = 2660
				order[10] = 2661
				order[11] = 2662
				order[12] = 2663
				order[13] = 2664
				order[14] = 2665
				order[15] = 2666
				order[16] = 0
				super(2653, 2654, order)
			end
		end

		class NoMiscFees < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 137
				order[1] = 138
				order[2] = 139
				order[3] = 2712
				order[4] = 2633
				order[5] = 891
				order[6] = 2216
				order[7] = 2217
				order[8] = 2713
				order[9] = 0
				super(136, 137, order)
			end

			class NoMiscFeeSubTypes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 2634
					order[1] = 2635
					order[2] = 2636
					order[3] = 2637
					order[4] = 2638
					order[5] = 0
					super(2633, 2634, order)
				end
			end
		end

		class NoClearingInstructions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 577
				order[1] = 0
				super(576, 577, order)
			end
		end

		class NoDlvyInst < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 165
				order[1] = 787
				order[2] = 781
				order[3] = 0
				super(85, 165, order)
			end

			class NoSettlPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 782
					order[1] = 783
					order[2] = 784
					order[3] = 2389
					order[4] = 801
					order[5] = 0
					super(781, 782, order)
				end

				class NoSettlPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 785
						order[1] = 786
						order[2] = 0
						super(801, 785, order)
					end
				end
			end
		end

		class NoTradeAllocAmts < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1845
				order[1] = 1846
				order[2] = 1847
				order[3] = 2933
				order[4] = 1850
				order[5] = 0
				super(1844, 1845, order)
			end
		end
	end
end

class ExecutionAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BN") )
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoPriceQualifiers < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2710
			order[1] = 0
			super(2709, 2710, order)
		end
	end

	class NoRegulatoryTradeIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 1903
			order[1] = 1905
			order[2] = 1904
			order[3] = 1906
			order[4] = 2411
			order[5] = 2397
			order[6] = 0
			super(1907, 1903, order)
		end
	end
end

class TradingSessionList < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BJ") )
	end

	class NoTradingSessions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(23)
			order[0] = 336
			order[1] = 625
			order[2] = 1327
			order[3] = 207
			order[4] = 1301
			order[5] = 1300
			order[6] = 1326
			order[7] = 338
			order[8] = 339
			order[9] = 325
			order[10] = 340
			order[11] = 567
			order[12] = 341
			order[13] = 342
			order[14] = 343
			order[15] = 344
			order[16] = 345
			order[17] = 387
			order[18] = 60
			order[19] = 58
			order[20] = 354
			order[21] = 355
			order[22] = 0
			super(386, 336, order)
		end

		class NoOrdTypeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40
				order[1] = 0
				super(1237, 40, order)
			end
		end

		class NoTimeInForceRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 59
				order[1] = 0
				super(1239, 59, order)
			end
		end

		class NoExecInstRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 1308
				order[1] = 0
				super(1232, 1308, order)
			end
		end

		class NoAuctionTypeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1803
				order[1] = 2549
				order[2] = 0
				super(2548, 1803, order)
			end
		end

		class NoMatchRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1142
				order[1] = 574
				order[2] = 2569
				order[3] = 2570
				order[4] = 0
				super(1235, 1142, order)
			end
		end

		class NoMDFeedTypes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 1022
				order[1] = 1683
				order[2] = 264
				order[3] = 2563
				order[4] = 2564
				order[5] = 2565
				order[6] = 2566
				order[7] = 1021
				order[8] = 1173
				order[9] = 2567
				order[10] = 2568
				order[11] = 0
				super(1141, 1022, order)
			end
		end
	end
end

class TradingSessionListRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BI") )
	end
end

class SettlementObligationReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BQ") )
	end

	class NoSettlOblig < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(172)
			order[0] = 430
			order[1] = 1161
			order[2] = 1162
			order[3] = 1163
			order[4] = 1157
			order[5] = 119
			order[6] = 15
			order[7] = 2897
			order[8] = 120
			order[9] = 2899
			order[10] = 155
			order[11] = 64
			order[12] = 55
			order[13] = 65
			order[14] = 48
			order[15] = 22
			order[16] = 460
			order[17] = 1227
			order[18] = 1151
			order[19] = 461
			order[20] = 2891
			order[21] = 167
			order[22] = 762
			order[23] = 200
			order[24] = 541
			order[25] = 1079
			order[26] = 966
			order[27] = 1049
			order[28] = 965
			order[29] = 224
			order[30] = 1449
			order[31] = 1450
			order[32] = 1451
			order[33] = 1452
			order[34] = 1457
			order[35] = 1458
			order[36] = 1739
			order[37] = 2210
			order[38] = 1938
			order[39] = 1939
			order[40] = 1940
			order[41] = 2735
			order[42] = 1941
			order[43] = 1575
			order[44] = 1942
			order[45] = 1943
			order[46] = 1944
			order[47] = 1945
			order[48] = 1946
			order[49] = 1947
			order[50] = 1948
			order[51] = 1949
			order[52] = 1950
			order[53] = 2879
			order[54] = 1951
			order[55] = 1952
			order[56] = 1953
			order[57] = 1954
			order[58] = 1955
			order[59] = 1956
			order[60] = 1957
			order[61] = 1958
			order[62] = 1959
			order[63] = 1960
			order[64] = 1577
			order[65] = 1580
			order[66] = 1581
			order[67] = 1678
			order[68] = 1697
			order[69] = 225
			order[70] = 239
			order[71] = 226
			order[72] = 227
			order[73] = 228
			order[74] = 255
			order[75] = 543
			order[76] = 470
			order[77] = 471
			order[78] = 472
			order[79] = 240
			order[80] = 202
			order[81] = 2578
			order[82] = 2577
			order[83] = 947
			order[84] = 2904
			order[85] = 967
			order[86] = 968
			order[87] = 1698
			order[88] = 1866
			order[89] = 2600
			order[90] = 2001
			order[91] = 2601
			order[92] = 1478
			order[93] = 1479
			order[94] = 1480
			order[95] = 1481
			order[96] = 206
			order[97] = 231
			order[98] = 1435
			order[99] = 2353
			order[100] = 1439
			order[101] = 969
			order[102] = 1146
			order[103] = 996
			order[104] = 1147
			order[105] = 1716
			order[106] = 2905
			order[107] = 1191
			order[108] = 1192
			order[109] = 1717
			order[110] = 2906
			order[111] = 1193
			order[112] = 2579
			order[113] = 1194
			order[114] = 1482
			order[115] = 1195
			order[116] = 2753
			order[117] = 1196
			order[118] = 1197
			order[119] = 2002
			order[120] = 2140
			order[121] = 1524
			order[122] = 2907
			order[123] = 1198
			order[124] = 1199
			order[125] = 1200
			order[126] = 201
			order[127] = 2681
			order[128] = 2685
			order[129] = 1244
			order[130] = 1242
			order[131] = 2575
			order[132] = 2574
			order[133] = 997
			order[134] = 223
			order[135] = 207
			order[136] = 970
			order[137] = 971
			order[138] = 106
			order[139] = 348
			order[140] = 349
			order[141] = 2737
			order[142] = 2714
			order[143] = 2715
			order[144] = 2716
			order[145] = 107
			order[146] = 350
			order[147] = 351
			order[148] = 691
			order[149] = 667
			order[150] = 875
			order[151] = 876
			order[152] = 873
			order[153] = 874
			order[154] = 1687
			order[155] = 1787
			order[156] = 2141
			order[157] = 2142
			order[158] = 2143
			order[159] = 2752
			order[160] = 2144
			order[161] = 2145
			order[162] = 2576
			order[163] = 2962
			order[164] = 2602
			order[165] = 2603
			order[166] = 453
			order[167] = 168
			order[168] = 126
			order[169] = 779
			order[170] = 1158
			order[171] = 0
			super(1165, 430, order)
		end

		class NoSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 455
				order[1] = 456
				order[2] = 2957
				order[3] = 0
				super(454, 455, order)
			end
		end

		class NoSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1977
				order[1] = 1978
				order[2] = 1979
				order[3] = 2741
				order[4] = 0
				super(1976, 1977, order)
			end
		end

		class NoAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2305
				order[1] = 2306
				order[2] = 2307
				order[3] = 0
				super(2304, 2305, order)
			end
		end

		class NoEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 865
				order[1] = 866
				order[2] = 1145
				order[3] = 1827
				order[4] = 1826
				order[5] = 2340
				order[6] = 867
				order[7] = 868
				order[8] = 1578
				order[9] = 1579
				order[10] = 0
				super(864, 865, order)
			end
		end

		class NoInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1019
				order[1] = 1050
				order[2] = 1051
				order[3] = 2378
				order[4] = 1052
				order[5] = 0
				super(1018, 1019, order)
			end

			class NoInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1053
					order[1] = 1054
					order[2] = 0
					super(1052, 1053, order)
				end
			end
		end

		class NoComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 1484
				order[1] = 2117
				order[2] = 2118
				order[3] = 2119
				order[4] = 1485
				order[5] = 2120
				order[6] = 2121
				order[7] = 2122
				order[8] = 2941
				order[9] = 1486
				order[10] = 2123
				order[11] = 1487
				order[12] = 1488
				order[13] = 1489
				order[14] = 1490
				order[15] = 1491
				order[16] = 2124
				order[17] = 2942
				order[18] = 2125
				order[19] = 2943
				order[20] = 2126
				order[21] = 2127
				order[22] = 2407
				order[23] = 2408
				order[24] = 2128
				order[25] = 2129
				order[26] = 2130
				order[27] = 2131
				order[28] = 2132
				order[29] = 41013
				order[30] = 41020
				order[31] = 41021
				order[32] = 41022
				order[33] = 41023
				order[34] = 41024
				order[35] = 41025
				order[36] = 41026
				order[37] = 41027
				order[38] = 41028
				order[39] = 41010
				order[40] = 2133
				order[41] = 2134
				order[42] = 2135
				order[43] = 2136
				order[44] = 2137
				order[45] = 41029
				order[46] = 40997
				order[47] = 2597
				order[48] = 2598
				order[49] = 2599
				order[50] = 2138
				order[51] = 2139
				order[52] = 0
				super(1483, 1484, order)
			end

			class NoComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1492
					order[1] = 1493
					order[2] = 1494
					order[3] = 0
					super(1491, 1492, order)
				end

				class NoComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1495
						order[1] = 1496
						order[2] = 0
						super(1494, 1495, order)
					end
				end
			end

			class NoComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41014
					order[1] = 41015
					order[2] = 41016
					order[3] = 41017
					order[4] = 0
					super(41013, 41014, order)
				end
			end

			class NoComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41019
					order[1] = 0
					super(41018, 41019, order)
				end
			end

			class NoComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41011
					order[1] = 41012
					order[2] = 41031
					order[3] = 41007
					order[4] = 40994
					order[5] = 0
					super(41010, 41011, order)
				end

				class NoComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41032
						order[1] = 41033
						order[2] = 41034
						order[3] = 41035
						order[4] = 41036
						order[5] = 0
						super(41031, 41032, order)
					end
				end

				class NoComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41008
						order[1] = 41009
						order[2] = 0
						super(41007, 41008, order)
					end
				end

				class NoComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40995
						order[1] = 40996
						order[2] = 0
						super(40994, 40995, order)
					end
				end
			end

			class NoComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41030
					order[1] = 0
					super(41029, 41030, order)
				end
			end

			class NoComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40998
					order[1] = 40999
					order[2] = 41000
					order[3] = 41001
					order[4] = 41002
					order[5] = 41003
					order[6] = 41004
					order[7] = 41005
					order[8] = 0
					super(40997, 40998, order)
				end

				class NoComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41006
						order[1] = 0
						super(41005, 41006, order)
					end
				end
			end
		end

		class NoBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40471
				order[1] = 0
				super(40278, 40471, order)
			end
		end

		class NoPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41231
				order[1] = 0
				super(41230, 41231, order)
			end
		end

		class NoMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41093
				order[1] = 40991
				order[2] = 0
				super(41092, 41093, order)
			end
		end

		class NoMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41095
				order[1] = 40992
				order[2] = 0
				super(41094, 41095, order)
			end
		end

		class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41097
				order[1] = 41098
				order[2] = 41099
				order[3] = 41100
				order[4] = 41101
				order[5] = 41102
				order[6] = 41103
				order[7] = 41104
				order[8] = 41105
				order[9] = 0
				super(41096, 41097, order)
			end
		end

		class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42776
				order[1] = 0
				super(42775, 42776, order)
			end
		end

		class NoOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41117
				order[1] = 0
				super(41116, 41117, order)
			end
		end

		class NoOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41138
				order[1] = 41139
				order[2] = 0
				super(41137, 41138, order)
			end
		end

		class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41141
				order[1] = 0
				super(41140, 41141, order)
			end
		end

		class NoOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41153
				order[1] = 41154
				order[2] = 0
				super(41152, 41153, order)
			end
		end

		class NoStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40050
				order[1] = 41303
				order[2] = 40051
				order[3] = 42784
				order[4] = 42785
				order[5] = 40052
				order[6] = 40053
				order[7] = 41305
				order[8] = 40054
				order[9] = 40055
				order[10] = 42786
				order[11] = 42787
				order[12] = 41306
				order[13] = 41307
				order[14] = 41308
				order[15] = 41309
				order[16] = 41310
				order[17] = 41311
				order[18] = 41251
				order[19] = 41252
				order[20] = 41253
				order[21] = 41254
				order[22] = 41255
				order[23] = 41256
				order[24] = 41257
				order[25] = 42587
				order[26] = 41258
				order[27] = 41259
				order[28] = 41260
				order[29] = 41261
				order[30] = 41262
				order[31] = 41263
				order[32] = 41264
				order[33] = 41265
				order[34] = 41266
				order[35] = 41267
				order[36] = 41268
				order[37] = 41269
				order[38] = 41270
				order[39] = 41271
				order[40] = 41272
				order[41] = 41273
				order[42] = 41274
				order[43] = 41275
				order[44] = 41276
				order[45] = 40907
				order[46] = 40908
				order[47] = 40910
				order[48] = 40911
				order[49] = 40912
				order[50] = 40913
				order[51] = 40914
				order[52] = 40065
				order[53] = 40066
				order[54] = 40068
				order[55] = 40069
				order[56] = 40070
				order[57] = 40071
				order[58] = 40072
				order[59] = 41244
				order[60] = 41245
				order[61] = 40073
				order[62] = 40075
				order[63] = 40076
				order[64] = 40078
				order[65] = 40079
				order[66] = 40080
				order[67] = 40081
				order[68] = 40082
				order[69] = 40083
				order[70] = 40084
				order[71] = 41246
				order[72] = 41247
				order[73] = 41248
				order[74] = 40738
				order[75] = 40739
				order[76] = 40740
				order[77] = 42600
				order[78] = 40741
				order[79] = 40742
				order[80] = 43106
				order[81] = 40743
				order[82] = 40744
				order[83] = 40745
				order[84] = 40746
				order[85] = 40747
				order[86] = 42601
				order[87] = 42602
				order[88] = 42603
				order[89] = 42604
				order[90] = 40748
				order[91] = 40749
				order[92] = 40750
				order[93] = 41180
				order[94] = 41181
				order[95] = 41182
				order[96] = 41183
				order[97] = 41184
				order[98] = 41185
				order[99] = 41186
				order[100] = 42605
				order[101] = 40828
				order[102] = 40872
				order[103] = 41058
				order[104] = 41059
				order[105] = 41060
				order[106] = 41061
				order[107] = 41062
				order[108] = 42192
				order[109] = 42193
				order[110] = 41063
				order[111] = 41064
				order[112] = 41065
				order[113] = 41066
				order[114] = 41067
				order[115] = 41218
				order[116] = 41068
				order[117] = 41069
				order[118] = 41070
				order[119] = 41071
				order[120] = 41072
				order[121] = 41073
				order[122] = 41074
				order[123] = 41075
				order[124] = 41076
				order[125] = 41077
				order[126] = 41078
				order[127] = 41079
				order[128] = 41080
				order[129] = 43094
				order[130] = 41037
				order[131] = 40056
				order[132] = 40982
				order[133] = 40983
				order[134] = 0
				super(40049, 40050, order)
			end

			class NoStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41278
					order[1] = 41279
					order[2] = 0
					super(41277, 41278, order)
				end
			end

			class NoStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41238
					order[1] = 41239
					order[2] = 41240
					order[3] = 0
					super(41237, 41238, order)
				end
			end

			class NoStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41281
					order[1] = 41282
					order[2] = 0
					super(41280, 41281, order)
				end
			end

			class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41250
					order[1] = 0
					super(41249, 41250, order)
				end
			end

			class NoStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41290
					order[1] = 41291
					order[2] = 41292
					order[3] = 41293
					order[4] = 41294
					order[5] = 41295
					order[6] = 41296
					order[7] = 41297
					order[8] = 41298
					order[9] = 41299
					order[10] = 41300
					order[11] = 41283
					order[12] = 41301
					order[13] = 41302
					order[14] = 0
					super(41289, 41290, order)
				end

				class NoStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41284
						order[1] = 41285
						order[2] = 41286
						order[3] = 0
						super(41283, 41284, order)
					end

					class NoStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41287
							order[1] = 41288
							order[2] = 41588
							order[3] = 0
							super(41286, 41287, order)
						end
					end
				end
			end

			class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40909
					order[1] = 0
					super(40960, 40909, order)
				end
			end

			class NoStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40067
					order[1] = 0
					super(40961, 40067, order)
				end
			end

			class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40074
					order[1] = 0
					super(40958, 40074, order)
				end
			end

			class NoStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41242
					order[1] = 41243
					order[2] = 0
					super(41241, 41242, order)
				end
			end

			class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40077
					order[1] = 0
					super(40959, 40077, order)
				end
			end

			class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40752
					order[1] = 0
					super(40947, 40752, order)
				end
			end

			class NoPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41221
					order[1] = 41222
					order[2] = 0
					super(41220, 41221, order)
				end
			end

			class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40763
					order[1] = 0
					super(40948, 40763, order)
				end
			end

			class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40769
					order[1] = 0
					super(40949, 40769, order)
				end
			end

			class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40776
					order[1] = 0
					super(40950, 40776, order)
				end
			end

			class NoPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42661
					order[1] = 42662
					order[2] = 0
					super(42660, 42661, order)
				end
			end

			class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41193
					order[1] = 0
					super(41192, 41193, order)
				end
			end

			class NoPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41228
					order[1] = 41229
					order[2] = 0
					super(41227, 41228, order)
				end
			end

			class NoPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41225
					order[1] = 41226
					order[2] = 0
					super(41224, 41225, order)
				end
			end

			class NoPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43109
					order[1] = 42684
					order[2] = 42685
					order[3] = 0
					super(42683, 43109, order)
				end
			end

			class NoDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42275
					order[1] = 42276
					order[2] = 42277
					order[3] = 42278
					order[4] = 42279
					order[5] = 42280
					order[6] = 42294
					order[7] = 42281
					order[8] = 42282
					order[9] = 42283
					order[10] = 42284
					order[11] = 42285
					order[12] = 42286
					order[13] = 42287
					order[14] = 42288
					order[15] = 42289
					order[16] = 42290
					order[17] = 42291
					order[18] = 42292
					order[19] = 42293
					order[20] = 0
					super(42274, 42275, order)
				end

				class NoDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42295
						order[1] = 0
						super(42294, 42295, order)
					end
				end
			end

			class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42273
					order[1] = 0
					super(42272, 42273, order)
				end
			end

			class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42237
					order[1] = 0
					super(42236, 42237, order)
				end
			end

			class NoReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42736
					order[1] = 42737
					order[2] = 42738
					order[3] = 42739
					order[4] = 42740
					order[5] = 42741
					order[6] = 42765
					order[7] = 42731
					order[8] = 42742
					order[9] = 42743
					order[10] = 42744
					order[11] = 42745
					order[12] = 42746
					order[13] = 42747
					order[14] = 42748
					order[15] = 42749
					order[16] = 42750
					order[17] = 42751
					order[18] = 42752
					order[19] = 42753
					order[20] = 42761
					order[21] = 42754
					order[22] = 42755
					order[23] = 42709
					order[24] = 42756
					order[25] = 42757
					order[26] = 42758
					order[27] = 42759
					order[28] = 42760
					order[29] = 0
					super(42735, 42736, order)
				end

				class NoReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42766
						order[1] = 42767
						order[2] = 42768
						order[3] = 42769
						order[4] = 0
						super(42765, 42766, order)
					end
				end

				class NoReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42732
						order[1] = 42733
						order[2] = 42734
						order[3] = 0
						super(42731, 42732, order)
					end
				end

				class NoReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42762
						order[1] = 42763
						order[2] = 42764
						order[3] = 0
						super(42761, 42762, order)
					end
				end

				class NoReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42710
						order[1] = 42772
						order[2] = 42711
						order[3] = 42712
						order[4] = 42713
						order[5] = 42714
						order[6] = 42715
						order[7] = 42716
						order[8] = 42717
						order[9] = 42718
						order[10] = 42719
						order[11] = 42720
						order[12] = 42721
						order[13] = 42722
						order[14] = 42723
						order[15] = 42724
						order[16] = 42725
						order[17] = 42726
						order[18] = 42727
						order[19] = 42728
						order[20] = 42729
						order[21] = 42730
						order[22] = 42770
						order[23] = 0
						super(42709, 42710, order)
					end

					class NoReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42773
							order[1] = 42774
							order[2] = 0
							super(42772, 42773, order)
						end
					end

					class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42771
							order[1] = 0
							super(42770, 42771, order)
						end
					end
				end
			end

			class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42621
					order[1] = 0
					super(42620, 42621, order)
				end
			end

			class NoPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42607
					order[1] = 42608
					order[2] = 0
					super(42606, 42607, order)
				end
			end

			class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40819
					order[1] = 0
					super(40946, 40819, order)
				end
			end

			class NoNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40826
					order[1] = 40827
					order[2] = 0
					super(40825, 40826, order)
				end
			end

			class NoSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40086
					order[1] = 40373
					order[2] = 40655
					order[3] = 40088
					order[4] = 40089
					order[5] = 0
					super(40085, 40086, order)
				end
			end

			class NoPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40829
					order[1] = 41164
					order[2] = 41165
					order[3] = 40830
					order[4] = 40831
					order[5] = 40832
					order[6] = 40833
					order[7] = 40834
					order[8] = 40835
					order[9] = 40836
					order[10] = 40837
					order[11] = 40838
					order[12] = 40839
					order[13] = 41166
					order[14] = 41167
					order[15] = 41168
					order[16] = 41169
					order[17] = 40840
					order[18] = 40841
					order[19] = 40842
					order[20] = 40843
					order[21] = 41170
					order[22] = 41171
					order[23] = 41172
					order[24] = 41173
					order[25] = 40844
					order[26] = 40845
					order[27] = 40846
					order[28] = 40847
					order[29] = 40848
					order[30] = 40849
					order[31] = 40868
					order[32] = 40850
					order[33] = 40851
					order[34] = 40852
					order[35] = 40853
					order[36] = 40977
					order[37] = 40855
					order[38] = 40856
					order[39] = 40857
					order[40] = 41174
					order[41] = 41175
					order[42] = 40858
					order[43] = 41161
					order[44] = 41176
					order[45] = 41177
					order[46] = 41178
					order[47] = 41179
					order[48] = 40859
					order[49] = 40860
					order[50] = 40861
					order[51] = 40862
					order[52] = 40945
					order[53] = 40864
					order[54] = 40865
					order[55] = 40866
					order[56] = 40867
					order[57] = 0
					super(40828, 40829, order)
				end

				class NoPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40869
						order[1] = 40870
						order[2] = 40871
						order[3] = 0
						super(40868, 40869, order)
					end
				end

				class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40854
						order[1] = 0
						super(40977, 40854, order)
					end
				end

				class NoPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41162
						order[1] = 41163
						order[2] = 0
						super(41161, 41162, order)
					end
				end

				class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40863
						order[1] = 0
						super(40945, 40863, order)
					end
				end
			end

			class NoPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40873
					order[1] = 40874
					order[2] = 42698
					order[3] = 42699
					order[4] = 42700
					order[5] = 42701
					order[6] = 42702
					order[7] = 42703
					order[8] = 42704
					order[9] = 42689
					order[10] = 42690
					order[11] = 42691
					order[12] = 42692
					order[13] = 42693
					order[14] = 42694
					order[15] = 42695
					order[16] = 40875
					order[17] = 40876
					order[18] = 40877
					order[19] = 40878
					order[20] = 40879
					order[21] = 40880
					order[22] = 40881
					order[23] = 40882
					order[24] = 40883
					order[25] = 40884
					order[26] = 40885
					order[27] = 40886
					order[28] = 40887
					order[29] = 40888
					order[30] = 40889
					order[31] = 40890
					order[32] = 40891
					order[33] = 40892
					order[34] = 40893
					order[35] = 40894
					order[36] = 40895
					order[37] = 40896
					order[38] = 40897
					order[39] = 40898
					order[40] = 40899
					order[41] = 40900
					order[42] = 40901
					order[43] = 0
					super(40872, 40873, order)
				end

				class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42706
						order[1] = 0
						super(42705, 42706, order)
					end
				end

				class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42697
						order[1] = 0
						super(42696, 42697, order)
					end
				end
			end

			class NoDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41086
					order[1] = 0
					super(41085, 41086, order)
				end
			end

			class NoDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41082
					order[1] = 41083
					order[2] = 41084
					order[3] = 0
					super(41081, 41082, order)
				end
			end

			class NoDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41038
					order[1] = 41039
					order[2] = 41040
					order[3] = 41041
					order[4] = 41042
					order[5] = 41043
					order[6] = 41044
					order[7] = 41045
					order[8] = 41046
					order[9] = 41047
					order[10] = 41048
					order[11] = 41049
					order[12] = 41050
					order[13] = 41051
					order[14] = 0
					super(41037, 41038, order)
				end

				class NoDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41052
						order[1] = 41053
						order[2] = 41054
						order[3] = 0
						super(41051, 41052, order)
					end

					class NoDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41055
							order[1] = 41056
							order[2] = 41057
							order[3] = 0
							super(41054, 41055, order)
						end
					end
				end
			end
		end

		class NoProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40091
				order[1] = 40092
				order[2] = 40093
				order[3] = 40957
				order[4] = 40095
				order[5] = 40096
				order[6] = 40097
				order[7] = 42707
				order[8] = 42708
				order[9] = 40098
				order[10] = 40099
				order[11] = 40100
				order[12] = 40114
				order[13] = 40115
				order[14] = 40116
				order[15] = 40118
				order[16] = 40119
				order[17] = 40120
				order[18] = 40121
				order[19] = 40122
				order[20] = 40123
				order[21] = 40125
				order[22] = 40126
				order[23] = 40127
				order[24] = 40128
				order[25] = 40129
				order[26] = 40130
				order[27] = 40131
				order[28] = 40132
				order[29] = 40133
				order[30] = 40134
				order[31] = 40135
				order[32] = 40136
				order[33] = 40137
				order[34] = 40138
				order[35] = 40139
				order[36] = 40140
				order[37] = 40141
				order[38] = 40145
				order[39] = 40146
				order[40] = 40148
				order[41] = 40149
				order[42] = 40150
				order[43] = 40151
				order[44] = 40152
				order[45] = 40153
				order[46] = 40154
				order[47] = 40155
				order[48] = 40156
				order[49] = 40158
				order[50] = 40159
				order[51] = 40160
				order[52] = 40161
				order[53] = 40162
				order[54] = 40101
				order[55] = 40102
				order[56] = 40103
				order[57] = 40104
				order[58] = 40105
				order[59] = 40106
				order[60] = 40107
				order[61] = 40163
				order[62] = 40165
				order[63] = 40166
				order[64] = 40167
				order[65] = 40168
				order[66] = 40169
				order[67] = 40170
				order[68] = 40108
				order[69] = 40109
				order[70] = 40110
				order[71] = 40111
				order[72] = 40112
				order[73] = 41406
				order[74] = 40113
				order[75] = 40986
				order[76] = 40987
				order[77] = 40174
				order[78] = 0
				super(40090, 40091, order)
			end

			class NoProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40094
					order[1] = 0
					super(40957, 40094, order)
				end
			end

			class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40117
					order[1] = 0
					super(40953, 40117, order)
				end
			end

			class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40124
					order[1] = 0
					super(40954, 40124, order)
				end
			end

			class NoProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40143
					order[1] = 40144
					order[2] = 0
					super(40142, 40143, order)
				end
			end

			class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40147
					order[1] = 0
					super(40955, 40147, order)
				end
			end

			class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40157
					order[1] = 0
					super(40956, 40157, order)
				end
			end

			class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40164
					order[1] = 0
					super(40952, 40164, order)
				end
			end

			class NoProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40172
					order[1] = 40173
					order[2] = 0
					super(40171, 40172, order)
				end
			end

			class NoProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40175
					order[1] = 40176
					order[2] = 40177
					order[3] = 2385
					order[4] = 40178
					order[5] = 0
					super(40174, 40175, order)
				end

				class NoProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40179
						order[1] = 40180
						order[2] = 0
						super(40178, 40179, order)
					end
				end
			end
		end

		class NoAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40020
				order[1] = 40021
				order[2] = 40000
				order[3] = 0
				super(40019, 40020, order)
			end

			class NoAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 40001
					order[1] = 40002
					order[2] = 40003
					order[3] = 40004
					order[4] = 40005
					order[5] = 40006
					order[6] = 40007
					order[7] = 40008
					order[8] = 40009
					order[9] = 40010
					order[10] = 40011
					order[11] = 40012
					order[12] = 40013
					order[13] = 40014
					order[14] = 40015
					order[15] = 40016
					order[16] = 40017
					order[17] = 40018
					order[18] = 0
					super(40000, 40001, order)
				end
			end
		end

		class NoProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 40182
				order[1] = 40183
				order[2] = 40184
				order[3] = 40185
				order[4] = 40186
				order[5] = 40187
				order[6] = 40188
				order[7] = 40951
				order[8] = 40191
				order[9] = 40201
				order[10] = 40190
				order[11] = 0
				super(40181, 40182, order)
			end

			class NoProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40189
					order[1] = 0
					super(40951, 40189, order)
				end
			end

			class NoProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40192
					order[1] = 40193
					order[2] = 40194
					order[3] = 40195
					order[4] = 40196
					order[5] = 40197
					order[6] = 40198
					order[7] = 40199
					order[8] = 0
					super(40191, 40192, order)
				end

				class NoProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40200
						order[1] = 0
						super(40199, 40200, order)
					end
				end
			end

			class NoProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40202
					order[1] = 40203
					order[2] = 0
					super(40201, 40202, order)
				end
			end
		end

		class NoCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 40023
				order[1] = 40024
				order[2] = 40916
				order[3] = 40917
				order[4] = 40025
				order[5] = 40026
				order[6] = 40027
				order[7] = 40028
				order[8] = 40029
				order[9] = 40030
				order[10] = 40031
				order[11] = 40277
				order[12] = 42216
				order[13] = 42217
				order[14] = 40033
				order[15] = 40034
				order[16] = 42207
				order[17] = 42208
				order[18] = 42209
				order[19] = 42210
				order[20] = 42211
				order[21] = 42212
				order[22] = 42213
				order[23] = 40035
				order[24] = 40036
				order[25] = 40037
				order[26] = 40038
				order[27] = 40039
				order[28] = 0
				super(40022, 40023, order)
			end

			class NoCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40032
					order[1] = 0
					super(40277, 40032, order)
				end
			end

			class NoCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42215
					order[1] = 0
					super(42214, 42215, order)
				end
			end
		end

		class NoPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40209
				order[1] = 40205
				order[2] = 40206
				order[3] = 40207
				order[4] = 40208
				order[5] = 0
				super(40204, 40209, order)
			end

			class NoPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40210
					order[1] = 40211
					order[2] = 0
					super(40209, 40210, order)
				end
			end
		end

		class NoExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42297
				order[1] = 42298
				order[2] = 0
				super(42296, 42297, order)
			end
		end

		class NoPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 448
				order[1] = 447
				order[2] = 452
				order[3] = 2376
				order[4] = 802
				order[5] = 0
				super(453, 448, order)
			end

			class NoPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 523
					order[1] = 803
					order[2] = 0
					super(802, 523, order)
				end
			end
		end

		class NoSettlDetails < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1164
				order[1] = 169
				order[2] = 170
				order[3] = 171
				order[4] = 781
				order[5] = 0
				super(1158, 1164, order)
			end

			class NoSettlPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 782
					order[1] = 783
					order[2] = 784
					order[3] = 2389
					order[4] = 801
					order[5] = 0
					super(781, 782, order)
				end

				class NoSettlPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 785
						order[1] = 786
						order[2] = 0
						super(801, 785, order)
					end
				end
			end
		end
	end
end

class DerivativeSecurityListUpdateReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BR") )
	end

	class NoUnderlyingSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 458
			order[1] = 459
			order[2] = 2959
			order[3] = 0
			super(457, 458, order)
		end
	end

	class NoUnderlyingStips < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 888
			order[1] = 889
			order[2] = 0
			super(887, 888, order)
		end
	end

	class NoUndlyInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1059
			order[1] = 1060
			order[2] = 1061
			order[3] = 2391
			order[4] = 1062
			order[5] = 0
			super(1058, 1059, order)
		end

		class NoUndlyInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1063
				order[1] = 1064
				order[2] = 0
				super(1062, 1063, order)
			end
		end
	end

	class NoUnderlyingEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 1982
			order[1] = 1983
			order[2] = 1984
			order[3] = 1985
			order[4] = 1986
			order[5] = 2342
			order[6] = 1987
			order[7] = 2071
			order[8] = 2072
			order[9] = 2073
			order[10] = 0
			super(1981, 1982, order)
		end
	end

	class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 2081
			order[1] = 2082
			order[2] = 2083
			order[3] = 2745
			order[4] = 0
			super(2080, 2081, order)
		end
	end

	class NoUnderlyingAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2313
			order[1] = 2314
			order[2] = 2315
			order[3] = 0
			super(2312, 2313, order)
		end
	end

	class NoUnderlyingComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 2046
			order[1] = 2261
			order[2] = 2262
			order[3] = 2263
			order[4] = 2047
			order[5] = 2264
			order[6] = 2265
			order[7] = 2266
			order[8] = 2947
			order[9] = 2048
			order[10] = 2267
			order[11] = 2049
			order[12] = 2050
			order[13] = 2051
			order[14] = 2052
			order[15] = 2053
			order[16] = 2268
			order[17] = 2948
			order[18] = 2269
			order[19] = 2949
			order[20] = 2270
			order[21] = 2271
			order[22] = 2419
			order[23] = 2420
			order[24] = 2272
			order[25] = 2273
			order[26] = 2274
			order[27] = 2275
			order[28] = 2276
			order[29] = 41732
			order[30] = 41739
			order[31] = 41740
			order[32] = 41741
			order[33] = 41742
			order[34] = 41743
			order[35] = 41744
			order[36] = 41745
			order[37] = 41746
			order[38] = 41747
			order[39] = 41729
			order[40] = 2277
			order[41] = 2278
			order[42] = 2279
			order[43] = 2280
			order[44] = 2281
			order[45] = 41748
			order[46] = 41716
			order[47] = 2611
			order[48] = 2612
			order[49] = 2613
			order[50] = 2282
			order[51] = 2283
			order[52] = 0
			super(2045, 2046, order)
		end

		class NoUnderlyingComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2054
				order[1] = 2055
				order[2] = 2056
				order[3] = 0
				super(2053, 2054, order)
			end

			class NoUnderlyingComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2057
					order[1] = 2058
					order[2] = 0
					super(2056, 2057, order)
				end
			end
		end

		class NoUnderlyingComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41733
				order[1] = 41734
				order[2] = 41735
				order[3] = 41736
				order[4] = 0
				super(41732, 41733, order)
			end
		end

		class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41738
				order[1] = 0
				super(41737, 41738, order)
			end
		end

		class NoUnderlyingComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41730
				order[1] = 41731
				order[2] = 41750
				order[3] = 41726
				order[4] = 41713
				order[5] = 0
				super(41729, 41730, order)
			end

			class NoUnderlyingComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41751
					order[1] = 41752
					order[2] = 41753
					order[3] = 41754
					order[4] = 41755
					order[5] = 0
					super(41750, 41751, order)
				end
			end

			class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41727
					order[1] = 41728
					order[2] = 0
					super(41726, 41727, order)
				end
			end

			class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41714
					order[1] = 41715
					order[2] = 0
					super(41713, 41714, order)
				end
			end
		end

		class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41749
				order[1] = 0
				super(41748, 41749, order)
			end
		end

		class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 41717
				order[1] = 41718
				order[2] = 41719
				order[3] = 41720
				order[4] = 41721
				order[5] = 41722
				order[6] = 41723
				order[7] = 41724
				order[8] = 0
				super(41716, 41717, order)
			end

			class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41725
					order[1] = 0
					super(41724, 41725, order)
				end
			end
		end
	end

	class NoUnderlyingBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40963
			order[1] = 0
			super(40962, 40963, order)
		end
	end

	class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41948
			order[1] = 0
			super(41947, 41948, order)
		end
	end

	class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41865
			order[1] = 41338
			order[2] = 0
			super(41864, 41865, order)
		end
	end

	class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41867
			order[1] = 41339
			order[2] = 0
			super(41866, 41867, order)
		end
	end

	class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41869
			order[1] = 41870
			order[2] = 41871
			order[3] = 41872
			order[4] = 41873
			order[5] = 41874
			order[6] = 41875
			order[7] = 41876
			order[8] = 41877
			order[9] = 0
			super(41868, 41869, order)
		end
	end

	class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 43075
			order[1] = 0
			super(43074, 43075, order)
		end
	end

	class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41821
			order[1] = 0
			super(41820, 41821, order)
		end
	end

	class NoUnderlyingOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41842
			order[1] = 41843
			order[2] = 0
			super(41841, 41842, order)
		end
	end

	class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41845
			order[1] = 0
			super(41844, 41845, order)
		end
	end

	class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41857
			order[1] = 41858
			order[2] = 0
			super(41856, 41857, order)
		end
	end

	class NoUnderlyingStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40541
			order[1] = 42016
			order[2] = 40542
			order[3] = 43083
			order[4] = 43084
			order[5] = 40543
			order[6] = 40544
			order[7] = 42018
			order[8] = 40545
			order[9] = 40546
			order[10] = 43085
			order[11] = 43086
			order[12] = 42019
			order[13] = 42020
			order[14] = 42021
			order[15] = 42022
			order[16] = 42023
			order[17] = 42024
			order[18] = 41964
			order[19] = 41965
			order[20] = 41966
			order[21] = 41967
			order[22] = 41968
			order[23] = 41969
			order[24] = 41970
			order[25] = 42589
			order[26] = 41971
			order[27] = 41972
			order[28] = 41973
			order[29] = 41974
			order[30] = 41975
			order[31] = 41976
			order[32] = 41977
			order[33] = 41978
			order[34] = 41979
			order[35] = 41980
			order[36] = 41981
			order[37] = 41982
			order[38] = 41983
			order[39] = 41984
			order[40] = 41985
			order[41] = 41986
			order[42] = 41987
			order[43] = 41988
			order[44] = 41989
			order[45] = 40057
			order[46] = 40058
			order[47] = 40060
			order[48] = 40061
			order[49] = 40062
			order[50] = 40063
			order[51] = 40064
			order[52] = 40548
			order[53] = 40549
			order[54] = 40551
			order[55] = 40552
			order[56] = 40553
			order[57] = 40554
			order[58] = 40555
			order[59] = 41957
			order[60] = 41958
			order[61] = 40556
			order[62] = 40558
			order[63] = 40559
			order[64] = 40561
			order[65] = 40562
			order[66] = 40563
			order[67] = 40564
			order[68] = 40565
			order[69] = 40566
			order[70] = 40567
			order[71] = 41959
			order[72] = 41960
			order[73] = 41961
			order[74] = 40568
			order[75] = 40569
			order[76] = 40570
			order[77] = 42895
			order[78] = 40571
			order[79] = 40572
			order[80] = 43107
			order[81] = 40573
			order[82] = 40574
			order[83] = 40575
			order[84] = 40576
			order[85] = 40577
			order[86] = 42896
			order[87] = 42897
			order[88] = 42898
			order[89] = 42899
			order[90] = 40578
			order[91] = 40579
			order[92] = 40580
			order[93] = 41897
			order[94] = 41898
			order[95] = 41899
			order[96] = 41900
			order[97] = 41901
			order[98] = 41902
			order[99] = 41903
			order[100] = 42900
			order[101] = 40664
			order[102] = 40708
			order[103] = 41777
			order[104] = 41778
			order[105] = 41779
			order[106] = 41780
			order[107] = 41781
			order[108] = 42196
			order[109] = 42197
			order[110] = 41782
			order[111] = 41783
			order[112] = 41784
			order[113] = 41785
			order[114] = 41786
			order[115] = 41587
			order[116] = 41787
			order[117] = 41788
			order[118] = 41789
			order[119] = 41790
			order[120] = 41791
			order[121] = 41792
			order[122] = 41793
			order[123] = 41794
			order[124] = 41795
			order[125] = 41796
			order[126] = 41797
			order[127] = 41798
			order[128] = 41799
			order[129] = 43096
			order[130] = 41756
			order[131] = 40547
			order[132] = 40988
			order[133] = 40989
			order[134] = 0
			super(40540, 40541, order)
		end

		class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41991
				order[1] = 41992
				order[2] = 0
				super(41990, 41991, order)
			end
		end

		class NoUnderlyingStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41801
				order[1] = 41802
				order[2] = 41803
				order[3] = 0
				super(41800, 41801, order)
			end
		end

		class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41994
				order[1] = 41995
				order[2] = 0
				super(41993, 41994, order)
			end
		end

		class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41963
				order[1] = 0
				super(41962, 41963, order)
			end
		end

		class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 42003
				order[1] = 42004
				order[2] = 42005
				order[3] = 42006
				order[4] = 42007
				order[5] = 42008
				order[6] = 42009
				order[7] = 42010
				order[8] = 42011
				order[9] = 42012
				order[10] = 42013
				order[11] = 41996
				order[12] = 42014
				order[13] = 42015
				order[14] = 0
				super(42002, 42003, order)
			end

			class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41997
					order[1] = 41998
					order[2] = 41999
					order[3] = 0
					super(41996, 41997, order)
				end

				class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42000
						order[1] = 42001
						order[2] = 41936
						order[3] = 0
						super(41999, 42000, order)
					end
				end
			end
		end

		class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40059
				order[1] = 0
				super(40975, 40059, order)
			end
		end

		class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40550
				order[1] = 0
				super(40976, 40550, order)
			end
		end

		class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40557
				order[1] = 0
				super(40973, 40557, order)
			end
		end

		class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41955
				order[1] = 41956
				order[2] = 0
				super(41954, 41955, order)
			end
		end

		class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40560
				order[1] = 0
				super(40974, 40560, order)
			end
		end

		class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40582
				order[1] = 0
				super(40969, 40582, order)
			end
		end

		class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41938
				order[1] = 41939
				order[2] = 0
				super(41937, 41938, order)
			end
		end

		class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40594
				order[1] = 0
				super(40970, 40594, order)
			end
		end

		class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40600
				order[1] = 0
				super(40971, 40600, order)
			end
		end

		class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40607
				order[1] = 0
				super(40972, 40607, order)
			end
		end

		class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42956
				order[1] = 42957
				order[2] = 0
				super(42955, 42956, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41910
				order[1] = 0
				super(41909, 41910, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41945
				order[1] = 41946
				order[2] = 0
				super(41944, 41945, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41942
				order[1] = 41943
				order[2] = 0
				super(41941, 41942, order)
			end
		end

		class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43111
				order[1] = 42982
				order[2] = 42983
				order[3] = 0
				super(42981, 43111, order)
			end
		end

		class NoUnderlyingDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42863
				order[1] = 42864
				order[2] = 42865
				order[3] = 42866
				order[4] = 42867
				order[5] = 42868
				order[6] = 42882
				order[7] = 42869
				order[8] = 42870
				order[9] = 42871
				order[10] = 42872
				order[11] = 42873
				order[12] = 42874
				order[13] = 42875
				order[14] = 42876
				order[15] = 42877
				order[16] = 42878
				order[17] = 42879
				order[18] = 42880
				order[19] = 42881
				order[20] = 0
				super(42862, 42863, order)
			end

			class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42883
					order[1] = 0
					super(42882, 42883, order)
				end
			end
		end

		class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42854
				order[1] = 0
				super(42853, 42854, order)
			end
		end

		class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42800
				order[1] = 0
				super(42799, 42800, order)
			end
		end

		class NoUnderlyingReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 43035
				order[1] = 43036
				order[2] = 43037
				order[3] = 43038
				order[4] = 43039
				order[5] = 43040
				order[6] = 43064
				order[7] = 43030
				order[8] = 43041
				order[9] = 43042
				order[10] = 43043
				order[11] = 43044
				order[12] = 43045
				order[13] = 43046
				order[14] = 43047
				order[15] = 43048
				order[16] = 43049
				order[17] = 43050
				order[18] = 43051
				order[19] = 43052
				order[20] = 43060
				order[21] = 43053
				order[22] = 43054
				order[23] = 43008
				order[24] = 43055
				order[25] = 43056
				order[26] = 43057
				order[27] = 43058
				order[28] = 43059
				order[29] = 0
				super(43034, 43035, order)
			end

			class NoUnderlyingReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 43065
					order[1] = 43066
					order[2] = 43067
					order[3] = 43068
					order[4] = 0
					super(43064, 43065, order)
				end
			end

			class NoUnderlyingReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43031
					order[1] = 43032
					order[2] = 43033
					order[3] = 0
					super(43030, 43031, order)
				end
			end

			class NoUnderlyingReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43061
					order[1] = 43062
					order[2] = 43063
					order[3] = 0
					super(43060, 43061, order)
				end
			end

			class NoUnderlyingReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 43009
					order[1] = 43071
					order[2] = 43010
					order[3] = 43011
					order[4] = 43012
					order[5] = 43013
					order[6] = 43014
					order[7] = 43015
					order[8] = 43016
					order[9] = 43017
					order[10] = 43018
					order[11] = 43019
					order[12] = 43020
					order[13] = 43021
					order[14] = 43022
					order[15] = 43023
					order[16] = 43024
					order[17] = 43025
					order[18] = 43026
					order[19] = 43027
					order[20] = 43028
					order[21] = 43029
					order[22] = 43069
					order[23] = 0
					super(43008, 43009, order)
				end

				class NoUnderlyingReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 43072
						order[1] = 43073
						order[2] = 0
						super(43071, 43072, order)
					end
				end

				class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43070
						order[1] = 0
						super(43069, 43070, order)
					end
				end
			end
		end

		class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42916
				order[1] = 0
				super(42915, 42916, order)
			end
		end

		class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42902
				order[1] = 42903
				order[2] = 0
				super(42901, 42902, order)
			end
		end

		class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40650
				order[1] = 0
				super(40968, 40650, order)
			end
		end

		class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40657
				order[1] = 40658
				order[2] = 0
				super(40656, 40657, order)
			end
		end

		class NoUnderlyingSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40660
				order[1] = 40904
				order[2] = 40915
				order[3] = 40662
				order[4] = 40663
				order[5] = 0
				super(40659, 40660, order)
			end
		end

		class NoUnderlyingPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40665
				order[1] = 41881
				order[2] = 41882
				order[3] = 40666
				order[4] = 40667
				order[5] = 40668
				order[6] = 40669
				order[7] = 40670
				order[8] = 40671
				order[9] = 40672
				order[10] = 40673
				order[11] = 40674
				order[12] = 40675
				order[13] = 41883
				order[14] = 41884
				order[15] = 41885
				order[16] = 41886
				order[17] = 40676
				order[18] = 40677
				order[19] = 40678
				order[20] = 40679
				order[21] = 41887
				order[22] = 41888
				order[23] = 41889
				order[24] = 41890
				order[25] = 40680
				order[26] = 40681
				order[27] = 40682
				order[28] = 40683
				order[29] = 40684
				order[30] = 40685
				order[31] = 40704
				order[32] = 40686
				order[33] = 40687
				order[34] = 40688
				order[35] = 40689
				order[36] = 40966
				order[37] = 40691
				order[38] = 40692
				order[39] = 40693
				order[40] = 41891
				order[41] = 41892
				order[42] = 40694
				order[43] = 41878
				order[44] = 41893
				order[45] = 41894
				order[46] = 41895
				order[47] = 41896
				order[48] = 40695
				order[49] = 40696
				order[50] = 40697
				order[51] = 40698
				order[52] = 40967
				order[53] = 40700
				order[54] = 40701
				order[55] = 40702
				order[56] = 40703
				order[57] = 0
				super(40664, 40665, order)
			end

			class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40705
					order[1] = 40706
					order[2] = 40707
					order[3] = 0
					super(40704, 40705, order)
				end
			end

			class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40690
					order[1] = 0
					super(40966, 40690, order)
				end
			end

			class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41879
					order[1] = 41880
					order[2] = 0
					super(41878, 41879, order)
				end
			end

			class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40699
					order[1] = 0
					super(40967, 40699, order)
				end
			end
		end

		class NoUnderlyingPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40709
				order[1] = 40710
				order[2] = 42993
				order[3] = 42994
				order[4] = 42995
				order[5] = 42996
				order[6] = 42997
				order[7] = 42998
				order[8] = 42999
				order[9] = 42984
				order[10] = 42985
				order[11] = 42986
				order[12] = 42987
				order[13] = 42988
				order[14] = 42989
				order[15] = 42990
				order[16] = 40711
				order[17] = 40712
				order[18] = 40713
				order[19] = 40714
				order[20] = 40715
				order[21] = 40716
				order[22] = 40717
				order[23] = 40718
				order[24] = 40719
				order[25] = 40720
				order[26] = 40721
				order[27] = 40722
				order[28] = 40723
				order[29] = 40724
				order[30] = 40725
				order[31] = 40726
				order[32] = 40727
				order[33] = 40728
				order[34] = 40729
				order[35] = 40730
				order[36] = 40731
				order[37] = 40732
				order[38] = 40733
				order[39] = 40734
				order[40] = 40735
				order[41] = 40736
				order[42] = 40737
				order[43] = 0
				super(40708, 40709, order)
			end

			class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 43001
					order[1] = 0
					super(43000, 43001, order)
				end
			end

			class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42992
					order[1] = 0
					super(42991, 42992, order)
				end
			end
		end

		class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41809
				order[1] = 0
				super(41808, 41809, order)
			end
		end

		class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41805
				order[1] = 41806
				order[2] = 41807
				order[3] = 0
				super(41804, 41805, order)
			end
		end

		class NoUnderlyingDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41757
				order[1] = 41758
				order[2] = 41759
				order[3] = 41760
				order[4] = 41761
				order[5] = 41762
				order[6] = 41763
				order[7] = 41764
				order[8] = 41765
				order[9] = 41766
				order[10] = 41767
				order[11] = 41768
				order[12] = 41769
				order[13] = 41770
				order[14] = 0
				super(41756, 41757, order)
			end

			class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41771
					order[1] = 41772
					order[2] = 41773
					order[3] = 0
					super(41770, 41771, order)
				end

				class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41774
						order[1] = 41775
						order[2] = 41776
						order[3] = 0
						super(41773, 41774, order)
					end
				end
			end
		end
	end

	class NoUnderlyingProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 42150
			order[1] = 42151
			order[2] = 42152
			order[3] = 42190
			order[4] = 42153
			order[5] = 42154
			order[6] = 42155
			order[7] = 43002
			order[8] = 43003
			order[9] = 42156
			order[10] = 42157
			order[11] = 42158
			order[12] = 42104
			order[13] = 42105
			order[14] = 42106
			order[15] = 42107
			order[16] = 42108
			order[17] = 42109
			order[18] = 42110
			order[19] = 42111
			order[20] = 42115
			order[21] = 42116
			order[22] = 42117
			order[23] = 42118
			order[24] = 42119
			order[25] = 42120
			order[26] = 42121
			order[27] = 42122
			order[28] = 42123
			order[29] = 42124
			order[30] = 42125
			order[31] = 42126
			order[32] = 42127
			order[33] = 42128
			order[34] = 42129
			order[35] = 42130
			order[36] = 42131
			order[37] = 42132
			order[38] = 42133
			order[39] = 42134
			order[40] = 42135
			order[41] = 42136
			order[42] = 42137
			order[43] = 42138
			order[44] = 42139
			order[45] = 42140
			order[46] = 42141
			order[47] = 42142
			order[48] = 42143
			order[49] = 42144
			order[50] = 42145
			order[51] = 42146
			order[52] = 42147
			order[53] = 42148
			order[54] = 42159
			order[55] = 42160
			order[56] = 42161
			order[57] = 42162
			order[58] = 42163
			order[59] = 42164
			order[60] = 42165
			order[61] = 42092
			order[62] = 42093
			order[63] = 42094
			order[64] = 42095
			order[65] = 42096
			order[66] = 42097
			order[67] = 42098
			order[68] = 42166
			order[69] = 42167
			order[70] = 42168
			order[71] = 42169
			order[72] = 42102
			order[73] = 42103
			order[74] = 42170
			order[75] = 42171
			order[76] = 42172
			order[77] = 42173
			order[78] = 0
			super(42149, 42150, order)
		end

		class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42191
				order[1] = 0
				super(42190, 42191, order)
			end
		end

		class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42183
				order[1] = 0
				super(42182, 42183, order)
			end
		end

		class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42185
				order[1] = 0
				super(42184, 42185, order)
			end
		end

		class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42113
				order[1] = 42114
				order[2] = 0
				super(42112, 42113, order)
			end
		end

		class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42187
				order[1] = 0
				super(42186, 42187, order)
			end
		end

		class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42189
				order[1] = 0
				super(42188, 42189, order)
			end
		end

		class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42181
				order[1] = 0
				super(42180, 42181, order)
			end
		end

		class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42100
				order[1] = 42101
				order[2] = 0
				super(42099, 42100, order)
			end
		end

		class NoUnderlyingProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42174
				order[1] = 42175
				order[2] = 42176
				order[3] = 40918
				order[4] = 42177
				order[5] = 0
				super(42173, 42174, order)
			end

			class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42178
					order[1] = 42179
					order[2] = 0
					super(42177, 42178, order)
				end
			end
		end
	end

	class NoUnderlyingAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 42037
			order[1] = 42038
			order[2] = 41340
			order[3] = 0
			super(42036, 42037, order)
		end

		class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 41341
				order[1] = 41701
				order[2] = 41709
				order[3] = 41710
				order[4] = 41711
				order[5] = 41712
				order[6] = 42017
				order[7] = 42025
				order[8] = 42026
				order[9] = 42027
				order[10] = 42028
				order[11] = 42029
				order[12] = 42030
				order[13] = 42031
				order[14] = 42032
				order[15] = 42033
				order[16] = 42034
				order[17] = 42035
				order[18] = 0
				super(41340, 41341, order)
			end
		end
	end

	class NoUnderlyingProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 42069
			order[1] = 42070
			order[2] = 42071
			order[3] = 42072
			order[4] = 42073
			order[5] = 42074
			order[6] = 42075
			order[7] = 42090
			order[8] = 42077
			order[9] = 42087
			order[10] = 42076
			order[11] = 0
			super(42068, 42069, order)
		end

		class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42091
				order[1] = 0
				super(42090, 42091, order)
			end
		end

		class NoUnderlyingProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 42078
				order[1] = 42079
				order[2] = 42080
				order[3] = 42081
				order[4] = 42082
				order[5] = 42083
				order[6] = 42084
				order[7] = 42085
				order[8] = 0
				super(42077, 42078, order)
			end

			class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42086
					order[1] = 0
					super(42085, 42086, order)
				end
			end
		end

		class NoUnderlyingProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42088
				order[1] = 42089
				order[2] = 0
				super(42087, 42088, order)
			end
		end
	end

	class NoUnderlyingCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 42042
			order[1] = 42043
			order[2] = 42044
			order[3] = 42045
			order[4] = 42046
			order[5] = 42047
			order[6] = 42048
			order[7] = 42049
			order[8] = 42050
			order[9] = 42051
			order[10] = 42052
			order[11] = 42039
			order[12] = 42797
			order[13] = 42798
			order[14] = 42053
			order[15] = 42054
			order[16] = 42790
			order[17] = 42791
			order[18] = 42792
			order[19] = 42793
			order[20] = 42794
			order[21] = 42795
			order[22] = 42796
			order[23] = 42055
			order[24] = 42056
			order[25] = 42057
			order[26] = 42058
			order[27] = 42059
			order[28] = 0
			super(42041, 42042, order)
		end

		class NoUnderlyingCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42040
				order[1] = 0
				super(42039, 42040, order)
			end
		end

		class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42789
				order[1] = 0
				super(42788, 42789, order)
			end
		end
	end

	class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 42065
			order[1] = 42061
			order[2] = 42062
			order[3] = 42063
			order[4] = 42064
			order[5] = 0
			super(42060, 42065, order)
		end

		class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42066
				order[1] = 42067
				order[2] = 0
				super(42065, 42066, order)
			end
		end
	end

	class NoUnderlyingRateSpreadSteps < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 43006
			order[1] = 43007
			order[2] = 0
			super(43005, 43006, order)
		end
	end

	class NoUnderlyingDividendPayments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 42856
			order[1] = 42857
			order[2] = 42858
			order[3] = 42859
			order[4] = 0
			super(42855, 42856, order)
		end
	end

	class NoUnderlyingExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42885
			order[1] = 42886
			order[2] = 0
			super(42884, 42885, order)
		end
	end

	class NoDerivativeSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1219
			order[1] = 1220
			order[2] = 0
			super(1218, 1219, order)
		end
	end

	class NoDerivativeEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1287
			order[1] = 1288
			order[2] = 1289
			order[3] = 1290
			order[4] = 1291
			order[5] = 0
			super(1286, 1287, order)
		end
	end

	class NoDerivativeInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1293
			order[1] = 1294
			order[2] = 1295
			order[3] = 2377
			order[4] = 1296
			order[5] = 0
			super(1292, 1293, order)
		end

		class NoDerivativeInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1297
				order[1] = 1298
				order[2] = 0
				super(1296, 1297, order)
			end
		end
	end

	class NoDerivativeInstrAttrib < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1313
			order[1] = 1314
			order[2] = 0
			super(1311, 1313, order)
		end
	end

	class NoMarketSegments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 1301
			order[1] = 1300
			order[2] = 1201
			order[3] = 0
			super(1310, 1301, order)
		end

		class NoTickRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(8)
				order[0] = 1206
				order[1] = 1207
				order[2] = 1208
				order[3] = 1209
				order[4] = 2571
				order[5] = 1830
				order[6] = 1831
				order[7] = 0
				super(1205, 1206, order)
			end
		end

		class NoLotTypeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1093
				order[1] = 1231
				order[2] = 0
				super(1234, 1093, order)
			end
		end

		class NoPriceRangeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 2551
				order[1] = 2552
				order[2] = 2553
				order[3] = 2554
				order[4] = 2556
				order[5] = 2555
				order[6] = 0
				super(2550, 2551, order)
			end
		end

		class NoQuoteSizeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 647
				order[1] = 648
				order[2] = 2447
				order[3] = 0
				super(2558, 647, order)
			end
		end

		class NoTradingSessionRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 336
				order[1] = 625
				order[2] = 0
				super(1309, 336, order)
			end

			class NoOrdTypeRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40
					order[1] = 0
					super(1237, 40, order)
				end
			end

			class NoTimeInForceRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 59
					order[1] = 0
					super(1239, 59, order)
				end
			end

			class NoExecInstRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 1308
					order[1] = 0
					super(1232, 1308, order)
				end
			end

			class NoAuctionTypeRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1803
					order[1] = 2549
					order[2] = 0
					super(2548, 1803, order)
				end
			end

			class NoMatchRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 1142
					order[1] = 574
					order[2] = 2569
					order[3] = 2570
					order[4] = 0
					super(1235, 1142, order)
				end
			end

			class NoMDFeedTypes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 1022
					order[1] = 1683
					order[2] = 264
					order[3] = 2563
					order[4] = 2564
					order[5] = 2565
					order[6] = 2566
					order[7] = 1021
					order[8] = 1173
					order[9] = 2567
					order[10] = 2568
					order[11] = 0
					super(1141, 1022, order)
				end
			end
		end

		class NoNestedInstrAttrib < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1210
				order[1] = 1211
				order[2] = 0
				super(1312, 1210, order)
			end
		end

		class NoStrikeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(7)
				order[0] = 1223
				order[1] = 1202
				order[2] = 1203
				order[3] = 1204
				order[4] = 1304
				order[5] = 1236
				order[6] = 0
				super(1201, 1223, order)
			end

			class NoMaturityRules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(7)
					order[0] = 1222
					order[1] = 1303
					order[2] = 1302
					order[3] = 1241
					order[4] = 1226
					order[5] = 1229
					order[6] = 0
					super(1236, 1222, order)
				end
			end
		end
	end

	class NoSecurityClassifications < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1583
			order[1] = 1584
			order[2] = 0
			super(1582, 1583, order)
		end
	end

	class NoRelatedSym < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(172)
			order[0] = 1324
			order[1] = 292
			order[2] = 55
			order[3] = 65
			order[4] = 48
			order[5] = 22
			order[6] = 460
			order[7] = 1227
			order[8] = 1151
			order[9] = 461
			order[10] = 2891
			order[11] = 167
			order[12] = 762
			order[13] = 200
			order[14] = 541
			order[15] = 1079
			order[16] = 966
			order[17] = 1049
			order[18] = 965
			order[19] = 224
			order[20] = 1449
			order[21] = 1450
			order[22] = 1451
			order[23] = 1452
			order[24] = 1457
			order[25] = 1458
			order[26] = 1739
			order[27] = 2210
			order[28] = 1938
			order[29] = 1939
			order[30] = 1940
			order[31] = 2735
			order[32] = 1941
			order[33] = 1575
			order[34] = 1942
			order[35] = 1943
			order[36] = 1944
			order[37] = 1945
			order[38] = 1946
			order[39] = 1947
			order[40] = 1948
			order[41] = 1949
			order[42] = 1950
			order[43] = 2879
			order[44] = 1951
			order[45] = 1952
			order[46] = 1953
			order[47] = 1954
			order[48] = 1955
			order[49] = 1956
			order[50] = 1957
			order[51] = 1958
			order[52] = 1959
			order[53] = 1960
			order[54] = 1577
			order[55] = 1580
			order[56] = 1581
			order[57] = 1678
			order[58] = 1697
			order[59] = 225
			order[60] = 239
			order[61] = 226
			order[62] = 227
			order[63] = 228
			order[64] = 255
			order[65] = 543
			order[66] = 470
			order[67] = 471
			order[68] = 472
			order[69] = 240
			order[70] = 202
			order[71] = 2578
			order[72] = 2577
			order[73] = 947
			order[74] = 2904
			order[75] = 967
			order[76] = 968
			order[77] = 1698
			order[78] = 1866
			order[79] = 2600
			order[80] = 2001
			order[81] = 2601
			order[82] = 1478
			order[83] = 1479
			order[84] = 1480
			order[85] = 1481
			order[86] = 206
			order[87] = 231
			order[88] = 1435
			order[89] = 2353
			order[90] = 1439
			order[91] = 969
			order[92] = 1146
			order[93] = 996
			order[94] = 1147
			order[95] = 1716
			order[96] = 2905
			order[97] = 1191
			order[98] = 1192
			order[99] = 1717
			order[100] = 2906
			order[101] = 1193
			order[102] = 2579
			order[103] = 1194
			order[104] = 1482
			order[105] = 1195
			order[106] = 2753
			order[107] = 1196
			order[108] = 1197
			order[109] = 2002
			order[110] = 2140
			order[111] = 1524
			order[112] = 2907
			order[113] = 1198
			order[114] = 1199
			order[115] = 1200
			order[116] = 201
			order[117] = 2681
			order[118] = 2685
			order[119] = 1244
			order[120] = 1242
			order[121] = 2575
			order[122] = 2574
			order[123] = 997
			order[124] = 223
			order[125] = 207
			order[126] = 970
			order[127] = 971
			order[128] = 106
			order[129] = 348
			order[130] = 349
			order[131] = 2737
			order[132] = 2714
			order[133] = 2715
			order[134] = 2716
			order[135] = 107
			order[136] = 350
			order[137] = 351
			order[138] = 691
			order[139] = 667
			order[140] = 875
			order[141] = 876
			order[142] = 873
			order[143] = 874
			order[144] = 1687
			order[145] = 1787
			order[146] = 2141
			order[147] = 2142
			order[148] = 2143
			order[149] = 2752
			order[150] = 2144
			order[151] = 2145
			order[152] = 2576
			order[153] = 2962
			order[154] = 2602
			order[155] = 2603
			order[156] = 668
			order[157] = 869
			order[158] = 2736
			order[159] = 2738
			order[160] = 1305
			order[161] = 1221
			order[162] = 1230
			order[163] = 1240
			order[164] = 15
			order[165] = 2897
			order[166] = 555
			order[167] = 1504
			order[168] = 58
			order[169] = 354
			order[170] = 355
			order[171] = 0
			super(146, 1324, order)
		end

		class NoSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 455
				order[1] = 456
				order[2] = 2957
				order[3] = 0
				super(454, 455, order)
			end
		end

		class NoSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1977
				order[1] = 1978
				order[2] = 1979
				order[3] = 2741
				order[4] = 0
				super(1976, 1977, order)
			end
		end

		class NoAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2305
				order[1] = 2306
				order[2] = 2307
				order[3] = 0
				super(2304, 2305, order)
			end
		end

		class NoEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 865
				order[1] = 866
				order[2] = 1145
				order[3] = 1827
				order[4] = 1826
				order[5] = 2340
				order[6] = 867
				order[7] = 868
				order[8] = 1578
				order[9] = 1579
				order[10] = 0
				super(864, 865, order)
			end
		end

		class NoInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1019
				order[1] = 1050
				order[2] = 1051
				order[3] = 2378
				order[4] = 1052
				order[5] = 0
				super(1018, 1019, order)
			end

			class NoInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1053
					order[1] = 1054
					order[2] = 0
					super(1052, 1053, order)
				end
			end
		end

		class NoComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 1484
				order[1] = 2117
				order[2] = 2118
				order[3] = 2119
				order[4] = 1485
				order[5] = 2120
				order[6] = 2121
				order[7] = 2122
				order[8] = 2941
				order[9] = 1486
				order[10] = 2123
				order[11] = 1487
				order[12] = 1488
				order[13] = 1489
				order[14] = 1490
				order[15] = 1491
				order[16] = 2124
				order[17] = 2942
				order[18] = 2125
				order[19] = 2943
				order[20] = 2126
				order[21] = 2127
				order[22] = 2407
				order[23] = 2408
				order[24] = 2128
				order[25] = 2129
				order[26] = 2130
				order[27] = 2131
				order[28] = 2132
				order[29] = 41013
				order[30] = 41020
				order[31] = 41021
				order[32] = 41022
				order[33] = 41023
				order[34] = 41024
				order[35] = 41025
				order[36] = 41026
				order[37] = 41027
				order[38] = 41028
				order[39] = 41010
				order[40] = 2133
				order[41] = 2134
				order[42] = 2135
				order[43] = 2136
				order[44] = 2137
				order[45] = 41029
				order[46] = 40997
				order[47] = 2597
				order[48] = 2598
				order[49] = 2599
				order[50] = 2138
				order[51] = 2139
				order[52] = 0
				super(1483, 1484, order)
			end

			class NoComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1492
					order[1] = 1493
					order[2] = 1494
					order[3] = 0
					super(1491, 1492, order)
				end

				class NoComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1495
						order[1] = 1496
						order[2] = 0
						super(1494, 1495, order)
					end
				end
			end

			class NoComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41014
					order[1] = 41015
					order[2] = 41016
					order[3] = 41017
					order[4] = 0
					super(41013, 41014, order)
				end
			end

			class NoComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41019
					order[1] = 0
					super(41018, 41019, order)
				end
			end

			class NoComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41011
					order[1] = 41012
					order[2] = 41031
					order[3] = 41007
					order[4] = 40994
					order[5] = 0
					super(41010, 41011, order)
				end

				class NoComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41032
						order[1] = 41033
						order[2] = 41034
						order[3] = 41035
						order[4] = 41036
						order[5] = 0
						super(41031, 41032, order)
					end
				end

				class NoComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41008
						order[1] = 41009
						order[2] = 0
						super(41007, 41008, order)
					end
				end

				class NoComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40995
						order[1] = 40996
						order[2] = 0
						super(40994, 40995, order)
					end
				end
			end

			class NoComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41030
					order[1] = 0
					super(41029, 41030, order)
				end
			end

			class NoComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40998
					order[1] = 40999
					order[2] = 41000
					order[3] = 41001
					order[4] = 41002
					order[5] = 41003
					order[6] = 41004
					order[7] = 41005
					order[8] = 0
					super(40997, 40998, order)
				end

				class NoComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41006
						order[1] = 0
						super(41005, 41006, order)
					end
				end
			end
		end

		class NoBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40471
				order[1] = 0
				super(40278, 40471, order)
			end
		end

		class NoPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41231
				order[1] = 0
				super(41230, 41231, order)
			end
		end

		class NoMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41093
				order[1] = 40991
				order[2] = 0
				super(41092, 41093, order)
			end
		end

		class NoMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41095
				order[1] = 40992
				order[2] = 0
				super(41094, 41095, order)
			end
		end

		class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41097
				order[1] = 41098
				order[2] = 41099
				order[3] = 41100
				order[4] = 41101
				order[5] = 41102
				order[6] = 41103
				order[7] = 41104
				order[8] = 41105
				order[9] = 0
				super(41096, 41097, order)
			end
		end

		class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42776
				order[1] = 0
				super(42775, 42776, order)
			end
		end

		class NoOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41117
				order[1] = 0
				super(41116, 41117, order)
			end
		end

		class NoOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41138
				order[1] = 41139
				order[2] = 0
				super(41137, 41138, order)
			end
		end

		class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41141
				order[1] = 0
				super(41140, 41141, order)
			end
		end

		class NoOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41153
				order[1] = 41154
				order[2] = 0
				super(41152, 41153, order)
			end
		end

		class NoStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40050
				order[1] = 41303
				order[2] = 40051
				order[3] = 42784
				order[4] = 42785
				order[5] = 40052
				order[6] = 40053
				order[7] = 41305
				order[8] = 40054
				order[9] = 40055
				order[10] = 42786
				order[11] = 42787
				order[12] = 41306
				order[13] = 41307
				order[14] = 41308
				order[15] = 41309
				order[16] = 41310
				order[17] = 41311
				order[18] = 41251
				order[19] = 41252
				order[20] = 41253
				order[21] = 41254
				order[22] = 41255
				order[23] = 41256
				order[24] = 41257
				order[25] = 42587
				order[26] = 41258
				order[27] = 41259
				order[28] = 41260
				order[29] = 41261
				order[30] = 41262
				order[31] = 41263
				order[32] = 41264
				order[33] = 41265
				order[34] = 41266
				order[35] = 41267
				order[36] = 41268
				order[37] = 41269
				order[38] = 41270
				order[39] = 41271
				order[40] = 41272
				order[41] = 41273
				order[42] = 41274
				order[43] = 41275
				order[44] = 41276
				order[45] = 40907
				order[46] = 40908
				order[47] = 40910
				order[48] = 40911
				order[49] = 40912
				order[50] = 40913
				order[51] = 40914
				order[52] = 40065
				order[53] = 40066
				order[54] = 40068
				order[55] = 40069
				order[56] = 40070
				order[57] = 40071
				order[58] = 40072
				order[59] = 41244
				order[60] = 41245
				order[61] = 40073
				order[62] = 40075
				order[63] = 40076
				order[64] = 40078
				order[65] = 40079
				order[66] = 40080
				order[67] = 40081
				order[68] = 40082
				order[69] = 40083
				order[70] = 40084
				order[71] = 41246
				order[72] = 41247
				order[73] = 41248
				order[74] = 40738
				order[75] = 40739
				order[76] = 40740
				order[77] = 42600
				order[78] = 40741
				order[79] = 40742
				order[80] = 43106
				order[81] = 40743
				order[82] = 40744
				order[83] = 40745
				order[84] = 40746
				order[85] = 40747
				order[86] = 42601
				order[87] = 42602
				order[88] = 42603
				order[89] = 42604
				order[90] = 40748
				order[91] = 40749
				order[92] = 40750
				order[93] = 41180
				order[94] = 41181
				order[95] = 41182
				order[96] = 41183
				order[97] = 41184
				order[98] = 41185
				order[99] = 41186
				order[100] = 42605
				order[101] = 40828
				order[102] = 40872
				order[103] = 41058
				order[104] = 41059
				order[105] = 41060
				order[106] = 41061
				order[107] = 41062
				order[108] = 42192
				order[109] = 42193
				order[110] = 41063
				order[111] = 41064
				order[112] = 41065
				order[113] = 41066
				order[114] = 41067
				order[115] = 41218
				order[116] = 41068
				order[117] = 41069
				order[118] = 41070
				order[119] = 41071
				order[120] = 41072
				order[121] = 41073
				order[122] = 41074
				order[123] = 41075
				order[124] = 41076
				order[125] = 41077
				order[126] = 41078
				order[127] = 41079
				order[128] = 41080
				order[129] = 43094
				order[130] = 41037
				order[131] = 40056
				order[132] = 40982
				order[133] = 40983
				order[134] = 0
				super(40049, 40050, order)
			end

			class NoStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41278
					order[1] = 41279
					order[2] = 0
					super(41277, 41278, order)
				end
			end

			class NoStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41238
					order[1] = 41239
					order[2] = 41240
					order[3] = 0
					super(41237, 41238, order)
				end
			end

			class NoStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41281
					order[1] = 41282
					order[2] = 0
					super(41280, 41281, order)
				end
			end

			class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41250
					order[1] = 0
					super(41249, 41250, order)
				end
			end

			class NoStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41290
					order[1] = 41291
					order[2] = 41292
					order[3] = 41293
					order[4] = 41294
					order[5] = 41295
					order[6] = 41296
					order[7] = 41297
					order[8] = 41298
					order[9] = 41299
					order[10] = 41300
					order[11] = 41283
					order[12] = 41301
					order[13] = 41302
					order[14] = 0
					super(41289, 41290, order)
				end

				class NoStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41284
						order[1] = 41285
						order[2] = 41286
						order[3] = 0
						super(41283, 41284, order)
					end

					class NoStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41287
							order[1] = 41288
							order[2] = 41588
							order[3] = 0
							super(41286, 41287, order)
						end
					end
				end
			end

			class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40909
					order[1] = 0
					super(40960, 40909, order)
				end
			end

			class NoStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40067
					order[1] = 0
					super(40961, 40067, order)
				end
			end

			class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40074
					order[1] = 0
					super(40958, 40074, order)
				end
			end

			class NoStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41242
					order[1] = 41243
					order[2] = 0
					super(41241, 41242, order)
				end
			end

			class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40077
					order[1] = 0
					super(40959, 40077, order)
				end
			end

			class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40752
					order[1] = 0
					super(40947, 40752, order)
				end
			end

			class NoPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41221
					order[1] = 41222
					order[2] = 0
					super(41220, 41221, order)
				end
			end

			class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40763
					order[1] = 0
					super(40948, 40763, order)
				end
			end

			class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40769
					order[1] = 0
					super(40949, 40769, order)
				end
			end

			class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40776
					order[1] = 0
					super(40950, 40776, order)
				end
			end

			class NoPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42661
					order[1] = 42662
					order[2] = 0
					super(42660, 42661, order)
				end
			end

			class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41193
					order[1] = 0
					super(41192, 41193, order)
				end
			end

			class NoPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41228
					order[1] = 41229
					order[2] = 0
					super(41227, 41228, order)
				end
			end

			class NoPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41225
					order[1] = 41226
					order[2] = 0
					super(41224, 41225, order)
				end
			end

			class NoPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43109
					order[1] = 42684
					order[2] = 42685
					order[3] = 0
					super(42683, 43109, order)
				end
			end

			class NoDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42275
					order[1] = 42276
					order[2] = 42277
					order[3] = 42278
					order[4] = 42279
					order[5] = 42280
					order[6] = 42294
					order[7] = 42281
					order[8] = 42282
					order[9] = 42283
					order[10] = 42284
					order[11] = 42285
					order[12] = 42286
					order[13] = 42287
					order[14] = 42288
					order[15] = 42289
					order[16] = 42290
					order[17] = 42291
					order[18] = 42292
					order[19] = 42293
					order[20] = 0
					super(42274, 42275, order)
				end

				class NoDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42295
						order[1] = 0
						super(42294, 42295, order)
					end
				end
			end

			class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42273
					order[1] = 0
					super(42272, 42273, order)
				end
			end

			class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42237
					order[1] = 0
					super(42236, 42237, order)
				end
			end

			class NoReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42736
					order[1] = 42737
					order[2] = 42738
					order[3] = 42739
					order[4] = 42740
					order[5] = 42741
					order[6] = 42765
					order[7] = 42731
					order[8] = 42742
					order[9] = 42743
					order[10] = 42744
					order[11] = 42745
					order[12] = 42746
					order[13] = 42747
					order[14] = 42748
					order[15] = 42749
					order[16] = 42750
					order[17] = 42751
					order[18] = 42752
					order[19] = 42753
					order[20] = 42761
					order[21] = 42754
					order[22] = 42755
					order[23] = 42709
					order[24] = 42756
					order[25] = 42757
					order[26] = 42758
					order[27] = 42759
					order[28] = 42760
					order[29] = 0
					super(42735, 42736, order)
				end

				class NoReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42766
						order[1] = 42767
						order[2] = 42768
						order[3] = 42769
						order[4] = 0
						super(42765, 42766, order)
					end
				end

				class NoReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42732
						order[1] = 42733
						order[2] = 42734
						order[3] = 0
						super(42731, 42732, order)
					end
				end

				class NoReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42762
						order[1] = 42763
						order[2] = 42764
						order[3] = 0
						super(42761, 42762, order)
					end
				end

				class NoReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42710
						order[1] = 42772
						order[2] = 42711
						order[3] = 42712
						order[4] = 42713
						order[5] = 42714
						order[6] = 42715
						order[7] = 42716
						order[8] = 42717
						order[9] = 42718
						order[10] = 42719
						order[11] = 42720
						order[12] = 42721
						order[13] = 42722
						order[14] = 42723
						order[15] = 42724
						order[16] = 42725
						order[17] = 42726
						order[18] = 42727
						order[19] = 42728
						order[20] = 42729
						order[21] = 42730
						order[22] = 42770
						order[23] = 0
						super(42709, 42710, order)
					end

					class NoReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42773
							order[1] = 42774
							order[2] = 0
							super(42772, 42773, order)
						end
					end

					class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42771
							order[1] = 0
							super(42770, 42771, order)
						end
					end
				end
			end

			class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42621
					order[1] = 0
					super(42620, 42621, order)
				end
			end

			class NoPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42607
					order[1] = 42608
					order[2] = 0
					super(42606, 42607, order)
				end
			end

			class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40819
					order[1] = 0
					super(40946, 40819, order)
				end
			end

			class NoNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40826
					order[1] = 40827
					order[2] = 0
					super(40825, 40826, order)
				end
			end

			class NoSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40086
					order[1] = 40373
					order[2] = 40655
					order[3] = 40088
					order[4] = 40089
					order[5] = 0
					super(40085, 40086, order)
				end
			end

			class NoPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40829
					order[1] = 41164
					order[2] = 41165
					order[3] = 40830
					order[4] = 40831
					order[5] = 40832
					order[6] = 40833
					order[7] = 40834
					order[8] = 40835
					order[9] = 40836
					order[10] = 40837
					order[11] = 40838
					order[12] = 40839
					order[13] = 41166
					order[14] = 41167
					order[15] = 41168
					order[16] = 41169
					order[17] = 40840
					order[18] = 40841
					order[19] = 40842
					order[20] = 40843
					order[21] = 41170
					order[22] = 41171
					order[23] = 41172
					order[24] = 41173
					order[25] = 40844
					order[26] = 40845
					order[27] = 40846
					order[28] = 40847
					order[29] = 40848
					order[30] = 40849
					order[31] = 40868
					order[32] = 40850
					order[33] = 40851
					order[34] = 40852
					order[35] = 40853
					order[36] = 40977
					order[37] = 40855
					order[38] = 40856
					order[39] = 40857
					order[40] = 41174
					order[41] = 41175
					order[42] = 40858
					order[43] = 41161
					order[44] = 41176
					order[45] = 41177
					order[46] = 41178
					order[47] = 41179
					order[48] = 40859
					order[49] = 40860
					order[50] = 40861
					order[51] = 40862
					order[52] = 40945
					order[53] = 40864
					order[54] = 40865
					order[55] = 40866
					order[56] = 40867
					order[57] = 0
					super(40828, 40829, order)
				end

				class NoPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40869
						order[1] = 40870
						order[2] = 40871
						order[3] = 0
						super(40868, 40869, order)
					end
				end

				class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40854
						order[1] = 0
						super(40977, 40854, order)
					end
				end

				class NoPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41162
						order[1] = 41163
						order[2] = 0
						super(41161, 41162, order)
					end
				end

				class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40863
						order[1] = 0
						super(40945, 40863, order)
					end
				end
			end

			class NoPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40873
					order[1] = 40874
					order[2] = 42698
					order[3] = 42699
					order[4] = 42700
					order[5] = 42701
					order[6] = 42702
					order[7] = 42703
					order[8] = 42704
					order[9] = 42689
					order[10] = 42690
					order[11] = 42691
					order[12] = 42692
					order[13] = 42693
					order[14] = 42694
					order[15] = 42695
					order[16] = 40875
					order[17] = 40876
					order[18] = 40877
					order[19] = 40878
					order[20] = 40879
					order[21] = 40880
					order[22] = 40881
					order[23] = 40882
					order[24] = 40883
					order[25] = 40884
					order[26] = 40885
					order[27] = 40886
					order[28] = 40887
					order[29] = 40888
					order[30] = 40889
					order[31] = 40890
					order[32] = 40891
					order[33] = 40892
					order[34] = 40893
					order[35] = 40894
					order[36] = 40895
					order[37] = 40896
					order[38] = 40897
					order[39] = 40898
					order[40] = 40899
					order[41] = 40900
					order[42] = 40901
					order[43] = 0
					super(40872, 40873, order)
				end

				class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42706
						order[1] = 0
						super(42705, 42706, order)
					end
				end

				class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42697
						order[1] = 0
						super(42696, 42697, order)
					end
				end
			end

			class NoDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41086
					order[1] = 0
					super(41085, 41086, order)
				end
			end

			class NoDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41082
					order[1] = 41083
					order[2] = 41084
					order[3] = 0
					super(41081, 41082, order)
				end
			end

			class NoDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41038
					order[1] = 41039
					order[2] = 41040
					order[3] = 41041
					order[4] = 41042
					order[5] = 41043
					order[6] = 41044
					order[7] = 41045
					order[8] = 41046
					order[9] = 41047
					order[10] = 41048
					order[11] = 41049
					order[12] = 41050
					order[13] = 41051
					order[14] = 0
					super(41037, 41038, order)
				end

				class NoDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41052
						order[1] = 41053
						order[2] = 41054
						order[3] = 0
						super(41051, 41052, order)
					end

					class NoDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41055
							order[1] = 41056
							order[2] = 41057
							order[3] = 0
							super(41054, 41055, order)
						end
					end
				end
			end
		end

		class NoProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40091
				order[1] = 40092
				order[2] = 40093
				order[3] = 40957
				order[4] = 40095
				order[5] = 40096
				order[6] = 40097
				order[7] = 42707
				order[8] = 42708
				order[9] = 40098
				order[10] = 40099
				order[11] = 40100
				order[12] = 40114
				order[13] = 40115
				order[14] = 40116
				order[15] = 40118
				order[16] = 40119
				order[17] = 40120
				order[18] = 40121
				order[19] = 40122
				order[20] = 40123
				order[21] = 40125
				order[22] = 40126
				order[23] = 40127
				order[24] = 40128
				order[25] = 40129
				order[26] = 40130
				order[27] = 40131
				order[28] = 40132
				order[29] = 40133
				order[30] = 40134
				order[31] = 40135
				order[32] = 40136
				order[33] = 40137
				order[34] = 40138
				order[35] = 40139
				order[36] = 40140
				order[37] = 40141
				order[38] = 40145
				order[39] = 40146
				order[40] = 40148
				order[41] = 40149
				order[42] = 40150
				order[43] = 40151
				order[44] = 40152
				order[45] = 40153
				order[46] = 40154
				order[47] = 40155
				order[48] = 40156
				order[49] = 40158
				order[50] = 40159
				order[51] = 40160
				order[52] = 40161
				order[53] = 40162
				order[54] = 40101
				order[55] = 40102
				order[56] = 40103
				order[57] = 40104
				order[58] = 40105
				order[59] = 40106
				order[60] = 40107
				order[61] = 40163
				order[62] = 40165
				order[63] = 40166
				order[64] = 40167
				order[65] = 40168
				order[66] = 40169
				order[67] = 40170
				order[68] = 40108
				order[69] = 40109
				order[70] = 40110
				order[71] = 40111
				order[72] = 40112
				order[73] = 41406
				order[74] = 40113
				order[75] = 40986
				order[76] = 40987
				order[77] = 40174
				order[78] = 0
				super(40090, 40091, order)
			end

			class NoProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40094
					order[1] = 0
					super(40957, 40094, order)
				end
			end

			class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40117
					order[1] = 0
					super(40953, 40117, order)
				end
			end

			class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40124
					order[1] = 0
					super(40954, 40124, order)
				end
			end

			class NoProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40143
					order[1] = 40144
					order[2] = 0
					super(40142, 40143, order)
				end
			end

			class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40147
					order[1] = 0
					super(40955, 40147, order)
				end
			end

			class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40157
					order[1] = 0
					super(40956, 40157, order)
				end
			end

			class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40164
					order[1] = 0
					super(40952, 40164, order)
				end
			end

			class NoProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40172
					order[1] = 40173
					order[2] = 0
					super(40171, 40172, order)
				end
			end

			class NoProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40175
					order[1] = 40176
					order[2] = 40177
					order[3] = 2385
					order[4] = 40178
					order[5] = 0
					super(40174, 40175, order)
				end

				class NoProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40179
						order[1] = 40180
						order[2] = 0
						super(40178, 40179, order)
					end
				end
			end
		end

		class NoAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40020
				order[1] = 40021
				order[2] = 40000
				order[3] = 0
				super(40019, 40020, order)
			end

			class NoAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 40001
					order[1] = 40002
					order[2] = 40003
					order[3] = 40004
					order[4] = 40005
					order[5] = 40006
					order[6] = 40007
					order[7] = 40008
					order[8] = 40009
					order[9] = 40010
					order[10] = 40011
					order[11] = 40012
					order[12] = 40013
					order[13] = 40014
					order[14] = 40015
					order[15] = 40016
					order[16] = 40017
					order[17] = 40018
					order[18] = 0
					super(40000, 40001, order)
				end
			end
		end

		class NoProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 40182
				order[1] = 40183
				order[2] = 40184
				order[3] = 40185
				order[4] = 40186
				order[5] = 40187
				order[6] = 40188
				order[7] = 40951
				order[8] = 40191
				order[9] = 40201
				order[10] = 40190
				order[11] = 0
				super(40181, 40182, order)
			end

			class NoProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40189
					order[1] = 0
					super(40951, 40189, order)
				end
			end

			class NoProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40192
					order[1] = 40193
					order[2] = 40194
					order[3] = 40195
					order[4] = 40196
					order[5] = 40197
					order[6] = 40198
					order[7] = 40199
					order[8] = 0
					super(40191, 40192, order)
				end

				class NoProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40200
						order[1] = 0
						super(40199, 40200, order)
					end
				end
			end

			class NoProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40202
					order[1] = 40203
					order[2] = 0
					super(40201, 40202, order)
				end
			end
		end

		class NoCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 40023
				order[1] = 40024
				order[2] = 40916
				order[3] = 40917
				order[4] = 40025
				order[5] = 40026
				order[6] = 40027
				order[7] = 40028
				order[8] = 40029
				order[9] = 40030
				order[10] = 40031
				order[11] = 40277
				order[12] = 42216
				order[13] = 42217
				order[14] = 40033
				order[15] = 40034
				order[16] = 42207
				order[17] = 42208
				order[18] = 42209
				order[19] = 42210
				order[20] = 42211
				order[21] = 42212
				order[22] = 42213
				order[23] = 40035
				order[24] = 40036
				order[25] = 40037
				order[26] = 40038
				order[27] = 40039
				order[28] = 0
				super(40022, 40023, order)
			end

			class NoCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40032
					order[1] = 0
					super(40277, 40032, order)
				end
			end

			class NoCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42215
					order[1] = 0
					super(42214, 42215, order)
				end
			end
		end

		class NoPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40209
				order[1] = 40205
				order[2] = 40206
				order[3] = 40207
				order[4] = 40208
				order[5] = 0
				super(40204, 40209, order)
			end

			class NoPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40210
					order[1] = 40211
					order[2] = 0
					super(40209, 40210, order)
				end
			end
		end

		class NoExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42297
				order[1] = 42298
				order[2] = 0
				super(42296, 42297, order)
			end
		end

		class NoInstrAttrib < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 871
				order[1] = 872
				order[2] = 0
				super(870, 871, order)
			end
		end

		class NoIndexRollMonths < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 2733
				order[1] = 0
				super(2734, 2733, order)
			end
		end

		class NoReferenceDataDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2747
				order[1] = 2748
				order[2] = 0
				super(2746, 2747, order)
			end
		end

		class NoLegs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(176)
				order[0] = 600
				order[1] = 601
				order[2] = 602
				order[3] = 603
				order[4] = 1788
				order[5] = 607
				order[6] = 1594
				order[7] = 608
				order[8] = 2893
				order[9] = 609
				order[10] = 764
				order[11] = 610
				order[12] = 611
				order[13] = 1212
				order[14] = 2146
				order[15] = 2147
				order[16] = 2148
				order[17] = 248
				order[18] = 2149
				order[19] = 2150
				order[20] = 2151
				order[21] = 2152
				order[22] = 2153
				order[23] = 2154
				order[24] = 2155
				order[25] = 2348
				order[26] = 2067
				order[27] = 2068
				order[28] = 2069
				order[29] = 2739
				order[30] = 2070
				order[31] = 2156
				order[32] = 2157
				order[33] = 2158
				order[34] = 2159
				order[35] = 2160
				order[36] = 2161
				order[37] = 2162
				order[38] = 2163
				order[39] = 2164
				order[40] = 2165
				order[41] = 2880
				order[42] = 2166
				order[43] = 2167
				order[44] = 2168
				order[45] = 2169
				order[46] = 2170
				order[47] = 2171
				order[48] = 2172
				order[49] = 2173
				order[50] = 2174
				order[51] = 2175
				order[52] = 2176
				order[53] = 2177
				order[54] = 2178
				order[55] = 2179
				order[56] = 2180
				order[57] = 249
				order[58] = 250
				order[59] = 251
				order[60] = 252
				order[61] = 253
				order[62] = 257
				order[63] = 599
				order[64] = 596
				order[65] = 597
				order[66] = 598
				order[67] = 254
				order[68] = 612
				order[69] = 942
				order[70] = 2908
				order[71] = 2181
				order[72] = 2182
				order[73] = 2183
				order[74] = 2184
				order[75] = 2604
				order[76] = 2185
				order[77] = 2605
				order[78] = 2186
				order[79] = 2187
				order[80] = 2188
				order[81] = 2189
				order[82] = 613
				order[83] = 614
				order[84] = 1436
				order[85] = 2354
				order[86] = 1440
				order[87] = 2190
				order[88] = 2191
				order[89] = 999
				order[90] = 1224
				order[91] = 1720
				order[92] = 2909
				order[93] = 1421
				order[94] = 1422
				order[95] = 1721
				order[96] = 2910
				order[97] = 2192
				order[98] = 1001
				order[99] = 1420
				order[100] = 2193
				order[101] = 2194
				order[102] = 2755
				order[103] = 2195
				order[104] = 2196
				order[105] = 2197
				order[106] = 2198
				order[107] = 1528
				order[108] = 2911
				order[109] = 2199
				order[110] = 2200
				order[111] = 2201
				order[112] = 2202
				order[113] = 2203
				order[114] = 615
				order[115] = 616
				order[116] = 2205
				order[117] = 2206
				order[118] = 617
				order[119] = 618
				order[120] = 619
				order[121] = 2740
				order[122] = 2717
				order[123] = 2718
				order[124] = 2719
				order[125] = 620
				order[126] = 621
				order[127] = 622
				order[128] = 2207
				order[129] = 2208
				order[130] = 623
				order[131] = 624
				order[132] = 556
				order[133] = 2898
				order[134] = 740
				order[135] = 739
				order[136] = 955
				order[137] = 956
				order[138] = 1358
				order[139] = 2682
				order[140] = 2686
				order[141] = 1017
				order[142] = 566
				order[143] = 2209
				order[144] = 2211
				order[145] = 2212
				order[146] = 2213
				order[147] = 2754
				order[148] = 2214
				order[149] = 2215
				order[150] = 2606
				order[151] = 2607
				order[152] = 2497
				order[153] = 2498
				order[154] = 2499
				order[155] = 2496
				order[156] = 2495
				order[157] = 2953
				order[158] = 2511
				order[159] = 2510
				order[160] = 2512
				order[161] = 2509
				order[162] = 2500
				order[163] = 2502
				order[164] = 2501
				order[165] = 2503
				order[166] = 2507
				order[167] = 2505
				order[168] = 2494
				order[169] = 2493
				order[170] = 2514
				order[171] = 2513
				order[172] = 2506
				order[173] = 2504
				order[174] = 2508
				order[175] = 0
				super(555, 600, order)
			end

			class NoLegSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 605
					order[1] = 606
					order[2] = 2958
					order[3] = 0
					super(604, 605, order)
				end
			end

			class NoLegSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2077
					order[1] = 2078
					order[2] = 2079
					order[3] = 2743
					order[4] = 0
					super(2076, 2077, order)
				end
			end

			class NoLegAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2309
					order[1] = 2310
					order[2] = 2311
					order[3] = 0
					super(2308, 2309, order)
				end
			end

			class NoLegEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 2060
					order[1] = 2061
					order[2] = 2062
					order[3] = 2063
					order[4] = 2064
					order[5] = 2341
					order[6] = 2065
					order[7] = 2066
					order[8] = 2074
					order[9] = 2075
					order[10] = 0
					super(2059, 2060, order)
				end
			end

			class NoLegInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 2255
					order[1] = 2256
					order[2] = 2257
					order[3] = 2379
					order[4] = 2258
					order[5] = 0
					super(2254, 2255, order)
				end

				class NoLegInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2259
						order[1] = 2260
						order[2] = 0
						super(2258, 2259, order)
					end
				end
			end

			class NoLegComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2219
					order[1] = 2220
					order[2] = 2221
					order[3] = 2222
					order[4] = 2223
					order[5] = 2224
					order[6] = 2225
					order[7] = 2226
					order[8] = 2944
					order[9] = 2227
					order[10] = 2228
					order[11] = 2229
					order[12] = 2230
					order[13] = 2231
					order[14] = 2232
					order[15] = 2250
					order[16] = 2233
					order[17] = 2945
					order[18] = 2234
					order[19] = 2946
					order[20] = 2235
					order[21] = 2236
					order[22] = 2409
					order[23] = 2410
					order[24] = 2237
					order[25] = 2238
					order[26] = 2239
					order[27] = 2240
					order[28] = 2241
					order[29] = 41382
					order[30] = 41389
					order[31] = 41390
					order[32] = 41391
					order[33] = 41392
					order[34] = 41393
					order[35] = 41394
					order[36] = 41395
					order[37] = 41396
					order[38] = 41397
					order[39] = 41379
					order[40] = 2242
					order[41] = 2243
					order[42] = 2244
					order[43] = 2245
					order[44] = 2246
					order[45] = 41398
					order[46] = 41366
					order[47] = 2608
					order[48] = 2609
					order[49] = 2610
					order[50] = 2248
					order[51] = 2249
					order[52] = 0
					super(2218, 2219, order)
				end

				class NoLegComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2251
						order[1] = 2252
						order[2] = 2253
						order[3] = 0
						super(2250, 2251, order)
					end

					class NoLegComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2204
							order[1] = 2247
							order[2] = 0
							super(2253, 2204, order)
						end
					end
				end

				class NoLegComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41383
						order[1] = 41384
						order[2] = 41385
						order[3] = 41386
						order[4] = 0
						super(41382, 41383, order)
					end
				end

				class NoLegComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41388
						order[1] = 0
						super(41387, 41388, order)
					end
				end

				class NoLegComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41380
						order[1] = 41381
						order[2] = 41400
						order[3] = 41376
						order[4] = 41363
						order[5] = 0
						super(41379, 41380, order)
					end

					class NoLegComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41401
							order[1] = 41402
							order[2] = 41403
							order[3] = 41404
							order[4] = 41405
							order[5] = 0
							super(41400, 41401, order)
						end
					end

					class NoLegComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41377
							order[1] = 41378
							order[2] = 0
							super(41376, 41377, order)
						end
					end

					class NoLegComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41364
							order[1] = 41365
							order[2] = 0
							super(41363, 41364, order)
						end
					end
				end

				class NoLegComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41399
						order[1] = 0
						super(41398, 41399, order)
					end
				end

				class NoLegComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41367
						order[1] = 41368
						order[2] = 41369
						order[3] = 41370
						order[4] = 41371
						order[5] = 41372
						order[6] = 41373
						order[7] = 41374
						order[8] = 0
						super(41366, 41367, order)
					end

					class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41375
							order[1] = 0
							super(41374, 41375, order)
						end
					end
				end
			end

			class NoLegBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40924
					order[1] = 0
					super(40923, 40924, order)
				end
			end

			class NoLegPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41608
					order[1] = 0
					super(41607, 41608, order)
				end
			end

			class NoLegMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41468
					order[1] = 40223
					order[2] = 0
					super(41467, 41468, order)
				end
			end

			class NoLegMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41470
					order[1] = 40990
					order[2] = 0
					super(41469, 41470, order)
				end
			end

			class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41472
					order[1] = 41473
					order[2] = 41474
					order[3] = 41475
					order[4] = 41476
					order[5] = 41477
					order[6] = 41478
					order[7] = 41479
					order[8] = 41480
					order[9] = 0
					super(41471, 41472, order)
				end
			end

			class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42582
					order[1] = 0
					super(42581, 42582, order)
				end
			end

			class NoLegOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41492
					order[1] = 0
					super(41491, 41492, order)
				end
			end

			class NoLegOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41513
					order[1] = 41514
					order[2] = 0
					super(41512, 41513, order)
				end
			end

			class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41516
					order[1] = 0
					super(41515, 41516, order)
				end
			end

			class NoLegOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41528
					order[1] = 41529
					order[2] = 0
					super(41527, 41528, order)
				end
			end

			class NoLegStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40242
					order[1] = 41700
					order[2] = 40243
					order[3] = 42583
					order[4] = 42584
					order[5] = 40244
					order[6] = 40245
					order[7] = 41702
					order[8] = 40246
					order[9] = 40247
					order[10] = 42585
					order[11] = 42586
					order[12] = 41703
					order[13] = 41704
					order[14] = 41705
					order[15] = 41706
					order[16] = 41707
					order[17] = 41708
					order[18] = 41648
					order[19] = 41649
					order[20] = 41650
					order[21] = 41651
					order[22] = 41652
					order[23] = 41653
					order[24] = 41654
					order[25] = 42588
					order[26] = 41655
					order[27] = 41656
					order[28] = 41657
					order[29] = 41658
					order[30] = 41659
					order[31] = 41660
					order[32] = 41661
					order[33] = 41662
					order[34] = 41663
					order[35] = 41664
					order[36] = 41665
					order[37] = 41666
					order[38] = 41667
					order[39] = 41668
					order[40] = 41669
					order[41] = 41670
					order[42] = 41671
					order[43] = 41672
					order[44] = 41673
					order[45] = 40249
					order[46] = 40250
					order[47] = 40252
					order[48] = 40253
					order[49] = 40254
					order[50] = 40255
					order[51] = 40256
					order[52] = 40257
					order[53] = 40258
					order[54] = 40260
					order[55] = 40261
					order[56] = 40262
					order[57] = 40263
					order[58] = 40264
					order[59] = 41641
					order[60] = 41642
					order[61] = 40265
					order[62] = 40267
					order[63] = 40268
					order[64] = 40270
					order[65] = 40271
					order[66] = 40272
					order[67] = 40273
					order[68] = 40274
					order[69] = 40275
					order[70] = 40276
					order[71] = 41643
					order[72] = 41644
					order[73] = 41645
					order[74] = 40279
					order[75] = 40280
					order[76] = 40281
					order[77] = 42399
					order[78] = 40282
					order[79] = 40283
					order[80] = 43108
					order[81] = 40284
					order[82] = 40285
					order[83] = 40286
					order[84] = 40287
					order[85] = 40288
					order[86] = 42400
					order[87] = 42401
					order[88] = 42402
					order[89] = 42403
					order[90] = 40289
					order[91] = 40290
					order[92] = 40291
					order[93] = 41549
					order[94] = 41550
					order[95] = 41551
					order[96] = 41552
					order[97] = 41553
					order[98] = 41554
					order[99] = 41555
					order[100] = 42404
					order[101] = 40374
					order[102] = 40418
					order[103] = 41429
					order[104] = 41430
					order[105] = 41431
					order[106] = 41432
					order[107] = 41433
					order[108] = 42194
					order[109] = 42195
					order[110] = 41434
					order[111] = 41435
					order[112] = 41436
					order[113] = 41437
					order[114] = 41438
					order[115] = 41219
					order[116] = 41439
					order[117] = 41440
					order[118] = 41441
					order[119] = 41442
					order[120] = 41443
					order[121] = 41444
					order[122] = 41445
					order[123] = 41446
					order[124] = 41447
					order[125] = 41448
					order[126] = 41449
					order[127] = 41450
					order[128] = 41451
					order[129] = 43095
					order[130] = 41408
					order[131] = 40248
					order[132] = 40978
					order[133] = 40979
					order[134] = 0
					super(40241, 40242, order)
				end

				class NoLegStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41675
						order[1] = 41676
						order[2] = 0
						super(41674, 41675, order)
					end
				end

				class NoLegStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41453
						order[1] = 41454
						order[2] = 41455
						order[3] = 0
						super(41452, 41453, order)
					end
				end

				class NoLegStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41678
						order[1] = 41679
						order[2] = 0
						super(41677, 41678, order)
					end
				end

				class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41647
						order[1] = 0
						super(41646, 41647, order)
					end
				end

				class NoLegStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41687
						order[1] = 41688
						order[2] = 41689
						order[3] = 41690
						order[4] = 41691
						order[5] = 41692
						order[6] = 41693
						order[7] = 41694
						order[8] = 41695
						order[9] = 41696
						order[10] = 41697
						order[11] = 41680
						order[12] = 41698
						order[13] = 41699
						order[14] = 0
						super(41686, 41687, order)
					end

					class NoLegStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41681
							order[1] = 41682
							order[2] = 41683
							order[3] = 0
							super(41680, 41681, order)
						end

						class NoLegStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41684
								order[1] = 41685
								order[2] = 41935
								order[3] = 0
								super(41683, 41684, order)
							end
						end
					end
				end

				class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40251
						order[1] = 0
						super(40942, 40251, order)
					end
				end

				class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40259
						order[1] = 0
						super(40943, 40259, order)
					end
				end

				class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40266
						order[1] = 0
						super(40940, 40266, order)
					end
				end

				class NoLegStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41639
						order[1] = 41640
						order[2] = 0
						super(41638, 41639, order)
					end
				end

				class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40269
						order[1] = 0
						super(40941, 40269, order)
					end
				end

				class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40293
						order[1] = 0
						super(40930, 40293, order)
					end
				end

				class NoLegPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41590
						order[1] = 41591
						order[2] = 0
						super(41589, 41590, order)
					end
				end

				class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40305
						order[1] = 0
						super(40931, 40305, order)
					end
				end

				class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40311
						order[1] = 0
						super(40932, 40311, order)
					end
				end

				class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40318
						order[1] = 0
						super(40933, 40318, order)
					end
				end

				class NoLegPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42460
						order[1] = 42461
						order[2] = 0
						super(42459, 42460, order)
					end
				end

				class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41562
						order[1] = 0
						super(41561, 41562, order)
					end
				end

				class NoLegPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41597
						order[1] = 41598
						order[2] = 0
						super(41596, 41597, order)
					end
				end

				class NoLegPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41594
						order[1] = 41595
						order[2] = 0
						super(41593, 41594, order)
					end
				end

				class NoLegPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43110
						order[1] = 42486
						order[2] = 42487
						order[3] = 0
						super(42485, 43110, order)
					end
				end

				class NoLegDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42367
						order[1] = 42368
						order[2] = 42369
						order[3] = 42370
						order[4] = 42371
						order[5] = 42372
						order[6] = 42386
						order[7] = 42373
						order[8] = 42374
						order[9] = 42375
						order[10] = 42376
						order[11] = 42377
						order[12] = 42378
						order[13] = 42379
						order[14] = 42380
						order[15] = 42381
						order[16] = 42382
						order[17] = 42383
						order[18] = 42384
						order[19] = 42385
						order[20] = 0
						super(42366, 42367, order)
					end

					class NoLegDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42387
							order[1] = 0
							super(42386, 42387, order)
						end
					end
				end

				class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42365
						order[1] = 0
						super(42364, 42365, order)
					end
				end

				class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42311
						order[1] = 0
						super(42310, 42311, order)
					end
				end

				class NoLegReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 42535
						order[1] = 42536
						order[2] = 42537
						order[3] = 42538
						order[4] = 42539
						order[5] = 42540
						order[6] = 42564
						order[7] = 42530
						order[8] = 42541
						order[9] = 42542
						order[10] = 42543
						order[11] = 42544
						order[12] = 42545
						order[13] = 42546
						order[14] = 42547
						order[15] = 42548
						order[16] = 42549
						order[17] = 42550
						order[18] = 42551
						order[19] = 42552
						order[20] = 42560
						order[21] = 42553
						order[22] = 42554
						order[23] = 42508
						order[24] = 42555
						order[25] = 42556
						order[26] = 42557
						order[27] = 42558
						order[28] = 42559
						order[29] = 0
						super(42534, 42535, order)
					end

					class NoLegReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 42565
							order[1] = 42566
							order[2] = 42567
							order[3] = 42568
							order[4] = 0
							super(42564, 42565, order)
						end
					end

					class NoLegReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42531
							order[1] = 42532
							order[2] = 42533
							order[3] = 0
							super(42530, 42531, order)
						end
					end

					class NoLegReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42561
							order[1] = 42562
							order[2] = 42563
							order[3] = 0
							super(42560, 42561, order)
						end
					end

					class NoLegReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 42509
							order[1] = 42571
							order[2] = 42510
							order[3] = 42511
							order[4] = 42512
							order[5] = 42513
							order[6] = 42514
							order[7] = 42515
							order[8] = 42516
							order[9] = 42517
							order[10] = 42518
							order[11] = 42519
							order[12] = 42520
							order[13] = 42521
							order[14] = 42522
							order[15] = 42523
							order[16] = 42524
							order[17] = 42525
							order[18] = 42526
							order[19] = 42527
							order[20] = 42528
							order[21] = 42529
							order[22] = 42569
							order[23] = 0
							super(42508, 42509, order)
						end

						class NoLegReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 42572
								order[1] = 42573
								order[2] = 0
								super(42571, 42572, order)
							end
						end

						class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 42570
								order[1] = 0
								super(42569, 42570, order)
							end
						end
					end
				end

				class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42420
						order[1] = 0
						super(42419, 42420, order)
					end
				end

				class NoLegPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42406
						order[1] = 42407
						order[2] = 0
						super(42405, 42406, order)
					end
				end

				class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40361
						order[1] = 0
						super(40929, 40361, order)
					end
				end

				class NoLegNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40368
						order[1] = 40369
						order[2] = 0
						super(40367, 40368, order)
					end
				end

				class NoLegSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40903
						order[1] = 40366
						order[2] = 40370
						order[3] = 40905
						order[4] = 40906
						order[5] = 0
						super(40902, 40903, order)
					end
				end

				class NoLegPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40375
						order[1] = 41533
						order[2] = 41534
						order[3] = 40376
						order[4] = 40377
						order[5] = 40378
						order[6] = 40379
						order[7] = 40380
						order[8] = 40381
						order[9] = 40382
						order[10] = 40383
						order[11] = 40384
						order[12] = 40385
						order[13] = 41535
						order[14] = 41536
						order[15] = 41537
						order[16] = 41538
						order[17] = 40386
						order[18] = 40387
						order[19] = 40388
						order[20] = 40389
						order[21] = 41539
						order[22] = 41540
						order[23] = 41541
						order[24] = 41542
						order[25] = 40390
						order[26] = 40391
						order[27] = 40392
						order[28] = 40393
						order[29] = 40394
						order[30] = 40395
						order[31] = 40414
						order[32] = 40396
						order[33] = 40397
						order[34] = 40398
						order[35] = 40399
						order[36] = 40927
						order[37] = 40401
						order[38] = 40402
						order[39] = 40403
						order[40] = 41543
						order[41] = 41544
						order[42] = 40404
						order[43] = 41530
						order[44] = 41545
						order[45] = 41546
						order[46] = 41547
						order[47] = 41548
						order[48] = 40405
						order[49] = 40406
						order[50] = 40407
						order[51] = 40408
						order[52] = 40928
						order[53] = 40410
						order[54] = 40411
						order[55] = 40412
						order[56] = 40413
						order[57] = 0
						super(40374, 40375, order)
					end

					class NoLegPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40415
							order[1] = 40416
							order[2] = 40417
							order[3] = 0
							super(40414, 40415, order)
						end
					end

					class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40400
							order[1] = 0
							super(40927, 40400, order)
						end
					end

					class NoLegPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41531
							order[1] = 41532
							order[2] = 0
							super(41530, 41531, order)
						end
					end

					class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40409
							order[1] = 0
							super(40928, 40409, order)
						end
					end
				end

				class NoLegPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40419
						order[1] = 40420
						order[2] = 42497
						order[3] = 42498
						order[4] = 42499
						order[5] = 42500
						order[6] = 42501
						order[7] = 42502
						order[8] = 42503
						order[9] = 42488
						order[10] = 42489
						order[11] = 42490
						order[12] = 42491
						order[13] = 42492
						order[14] = 42493
						order[15] = 42494
						order[16] = 40421
						order[17] = 40422
						order[18] = 40423
						order[19] = 40424
						order[20] = 40425
						order[21] = 40426
						order[22] = 40427
						order[23] = 40428
						order[24] = 40429
						order[25] = 40430
						order[26] = 40431
						order[27] = 40432
						order[28] = 40433
						order[29] = 40434
						order[30] = 40435
						order[31] = 40436
						order[32] = 40437
						order[33] = 40438
						order[34] = 40439
						order[35] = 40440
						order[36] = 40441
						order[37] = 40442
						order[38] = 40443
						order[39] = 40444
						order[40] = 40445
						order[41] = 40446
						order[42] = 40447
						order[43] = 0
						super(40418, 40419, order)
					end

					class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42505
							order[1] = 0
							super(42504, 42505, order)
						end
					end

					class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42496
							order[1] = 0
							super(42495, 42496, order)
						end
					end
				end

				class NoLegDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41461
						order[1] = 0
						super(41460, 41461, order)
					end
				end

				class NoLegDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41457
						order[1] = 41458
						order[2] = 41459
						order[3] = 0
						super(41456, 41457, order)
					end
				end

				class NoLegDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41409
						order[1] = 41410
						order[2] = 41411
						order[3] = 41412
						order[4] = 41413
						order[5] = 41414
						order[6] = 41415
						order[7] = 41416
						order[8] = 41417
						order[9] = 41418
						order[10] = 41419
						order[11] = 41420
						order[12] = 41421
						order[13] = 41422
						order[14] = 0
						super(41408, 41409, order)
					end

					class NoLegDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41423
							order[1] = 41424
							order[2] = 41425
							order[3] = 0
							super(41422, 41423, order)
						end

						class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41426
								order[1] = 41427
								order[2] = 41428
								order[3] = 0
								super(41425, 41426, order)
							end
						end
					end
				end
			end

			class NoLegProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 40449
					order[1] = 40450
					order[2] = 40451
					order[3] = 40939
					order[4] = 40453
					order[5] = 40454
					order[6] = 40455
					order[7] = 42506
					order[8] = 42507
					order[9] = 40456
					order[10] = 40457
					order[11] = 40458
					order[12] = 40524
					order[13] = 40525
					order[14] = 40526
					order[15] = 40528
					order[16] = 40529
					order[17] = 40530
					order[18] = 40531
					order[19] = 40532
					order[20] = 40476
					order[21] = 40478
					order[22] = 40479
					order[23] = 40480
					order[24] = 40481
					order[25] = 40482
					order[26] = 40483
					order[27] = 40484
					order[28] = 40485
					order[29] = 40486
					order[30] = 40487
					order[31] = 40488
					order[32] = 40489
					order[33] = 40490
					order[34] = 40491
					order[35] = 40492
					order[36] = 40493
					order[37] = 40494
					order[38] = 40498
					order[39] = 40499
					order[40] = 40501
					order[41] = 40502
					order[42] = 40503
					order[43] = 40504
					order[44] = 40505
					order[45] = 40506
					order[46] = 40507
					order[47] = 40508
					order[48] = 40509
					order[49] = 40511
					order[50] = 40512
					order[51] = 40513
					order[52] = 40514
					order[53] = 40515
					order[54] = 40459
					order[55] = 40460
					order[56] = 40461
					order[57] = 40462
					order[58] = 40463
					order[59] = 40464
					order[60] = 40465
					order[61] = 40516
					order[62] = 40518
					order[63] = 40519
					order[64] = 40520
					order[65] = 40521
					order[66] = 40522
					order[67] = 40523
					order[68] = 40466
					order[69] = 40467
					order[70] = 40468
					order[71] = 40469
					order[72] = 40470
					order[73] = 41407
					order[74] = 40472
					order[75] = 40980
					order[76] = 40981
					order[77] = 40533
					order[78] = 0
					super(40448, 40449, order)
				end

				class NoLegProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40452
						order[1] = 0
						super(40939, 40452, order)
					end
				end

				class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40527
						order[1] = 0
						super(40935, 40527, order)
					end
				end

				class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40477
						order[1] = 0
						super(40936, 40477, order)
					end
				end

				class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40496
						order[1] = 40497
						order[2] = 0
						super(40495, 40496, order)
					end
				end

				class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40500
						order[1] = 0
						super(40937, 40500, order)
					end
				end

				class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40510
						order[1] = 0
						super(40938, 40510, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40517
						order[1] = 0
						super(40934, 40517, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40474
						order[1] = 40475
						order[2] = 0
						super(40473, 40474, order)
					end
				end

				class NoLegProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40534
						order[1] = 40535
						order[2] = 40536
						order[3] = 2380
						order[4] = 40537
						order[5] = 0
						super(40533, 40534, order)
					end

					class NoLegProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40538
							order[1] = 40539
							order[2] = 0
							super(40537, 40538, order)
						end
					end
				end
			end

			class NoLegAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41336
					order[1] = 41337
					order[2] = 41316
					order[3] = 0
					super(41335, 41336, order)
				end

				class NoLegAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41317
						order[1] = 41318
						order[2] = 41319
						order[3] = 41320
						order[4] = 41321
						order[5] = 41322
						order[6] = 41323
						order[7] = 41324
						order[8] = 41325
						order[9] = 41326
						order[10] = 41327
						order[11] = 41328
						order[12] = 41329
						order[13] = 41330
						order[14] = 41331
						order[15] = 41332
						order[16] = 41333
						order[17] = 41334
						order[18] = 0
						super(41316, 41317, order)
					end
				end
			end

			class NoLegProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 41618
					order[1] = 41619
					order[2] = 41620
					order[3] = 41621
					order[4] = 41622
					order[5] = 41623
					order[6] = 41624
					order[7] = 41614
					order[8] = 41625
					order[9] = 41635
					order[10] = 41617
					order[11] = 0
					super(41616, 41618, order)
				end

				class NoLegProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41615
						order[1] = 0
						super(41614, 41615, order)
					end
				end

				class NoLegProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41626
						order[1] = 41627
						order[2] = 41628
						order[3] = 41629
						order[4] = 41630
						order[5] = 41631
						order[6] = 41632
						order[7] = 41633
						order[8] = 0
						super(41625, 41626, order)
					end

					class NoLegProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41634
							order[1] = 0
							super(41633, 41634, order)
						end
					end
				end

				class NoLegProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41636
						order[1] = 41637
						order[2] = 0
						super(41635, 41636, order)
					end
				end
			end

			class NoLegCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 41345
					order[1] = 41346
					order[2] = 41347
					order[3] = 41348
					order[4] = 41349
					order[5] = 41350
					order[6] = 41351
					order[7] = 41352
					order[8] = 41353
					order[9] = 41354
					order[10] = 41355
					order[11] = 41342
					order[12] = 42308
					order[13] = 42309
					order[14] = 41356
					order[15] = 41357
					order[16] = 42299
					order[17] = 42300
					order[18] = 42301
					order[19] = 42302
					order[20] = 42303
					order[21] = 42304
					order[22] = 42305
					order[23] = 41358
					order[24] = 41359
					order[25] = 41360
					order[26] = 41361
					order[27] = 41362
					order[28] = 0
					super(41344, 41345, order)
				end

				class NoLegCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41343
						order[1] = 0
						super(41342, 41343, order)
					end
				end

				class NoLegCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42307
						order[1] = 0
						super(42306, 42307, order)
					end
				end
			end

			class NoLegPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41604
					order[1] = 41601
					order[2] = 41602
					order[3] = 41603
					order[4] = 41600
					order[5] = 0
					super(41599, 41604, order)
				end

				class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41605
						order[1] = 41606
						order[2] = 0
						super(41604, 41605, order)
					end
				end
			end

			class NoLegExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42389
					order[1] = 42390
					order[2] = 0
					super(42388, 42389, order)
				end
			end

			class NoLegContractualDefinitions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42199
					order[1] = 0
					super(42198, 42199, order)
				end
			end

			class NoLegFinancingTermSupplements < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42201
					order[1] = 42202
					order[2] = 0
					super(42200, 42201, order)
				end
			end

			class NoLegContractualMatrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42204
					order[1] = 42205
					order[2] = 42206
					order[3] = 0
					super(42203, 42204, order)
				end
			end
		end
	end
end

class TradingSessionListUpdateReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BS") )
	end

	class NoTradingSessions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(23)
			order[0] = 336
			order[1] = 625
			order[2] = 1327
			order[3] = 207
			order[4] = 1301
			order[5] = 1300
			order[6] = 1326
			order[7] = 338
			order[8] = 339
			order[9] = 325
			order[10] = 340
			order[11] = 567
			order[12] = 341
			order[13] = 342
			order[14] = 343
			order[15] = 344
			order[16] = 345
			order[17] = 387
			order[18] = 60
			order[19] = 58
			order[20] = 354
			order[21] = 355
			order[22] = 0
			super(386, 336, order)
		end

		class NoOrdTypeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40
				order[1] = 0
				super(1237, 40, order)
			end
		end

		class NoTimeInForceRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 59
				order[1] = 0
				super(1239, 59, order)
			end
		end

		class NoExecInstRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 1308
				order[1] = 0
				super(1232, 1308, order)
			end
		end

		class NoAuctionTypeRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1803
				order[1] = 2549
				order[2] = 0
				super(2548, 1803, order)
			end
		end

		class NoMatchRules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1142
				order[1] = 574
				order[2] = 2569
				order[3] = 2570
				order[4] = 0
				super(1235, 1142, order)
			end
		end

		class NoMDFeedTypes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 1022
				order[1] = 1683
				order[2] = 264
				order[3] = 2563
				order[4] = 2564
				order[5] = 2565
				order[6] = 2566
				order[7] = 1021
				order[8] = 1173
				order[9] = 2567
				order[10] = 2568
				order[11] = 0
				super(1141, 1022, order)
			end
		end
	end
end

class MarketDefinitionRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BT") )
	end
end

class MarketDefinition < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BU") )
	end

	class NoInstrumentScopes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(25)
			order[0] = 1535
			order[1] = 1536
			order[2] = 1537
			order[3] = 1538
			order[4] = 1539
			order[5] = 1543
			order[6] = 1544
			order[7] = 1545
			order[8] = 1546
			order[9] = 2895
			order[10] = 1547
			order[11] = 1548
			order[12] = 1549
			order[13] = 1550
			order[14] = 1551
			order[15] = 1552
			order[16] = 1553
			order[17] = 1554
			order[18] = 1555
			order[19] = 1616
			order[20] = 1556
			order[21] = 1620
			order[22] = 1621
			order[23] = 1557
			order[24] = 0
			super(1656, 1535, order)
		end

		class NoInstrumentScopeSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1541
				order[1] = 1542
				order[2] = 0
				super(1540, 1541, order)
			end
		end
	end

	class NoRelatedMarketSegments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2546
			order[1] = 2547
			order[2] = 0
			super(2545, 2546, order)
		end
	end

	class NoTickRules < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(8)
			order[0] = 1206
			order[1] = 1207
			order[2] = 1208
			order[3] = 1209
			order[4] = 2571
			order[5] = 1830
			order[6] = 1831
			order[7] = 0
			super(1205, 1206, order)
		end
	end

	class NoLotTypeRules < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1093
			order[1] = 1231
			order[2] = 0
			super(1234, 1093, order)
		end
	end

	class NoPriceRangeRules < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 2551
			order[1] = 2552
			order[2] = 2553
			order[3] = 2554
			order[4] = 2556
			order[5] = 2555
			order[6] = 0
			super(2550, 2551, order)
		end
	end

	class NoQuoteSizeRules < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 647
			order[1] = 648
			order[2] = 2447
			order[3] = 0
			super(2558, 647, order)
		end
	end

	class NoOrdTypeRules < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40
			order[1] = 0
			super(1237, 40, order)
		end
	end

	class NoTimeInForceRules < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 59
			order[1] = 0
			super(1239, 59, order)
		end
	end

	class NoExecInstRules < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 1308
			order[1] = 0
			super(1232, 1308, order)
		end
	end

	class NoAuctionTypeRules < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1803
			order[1] = 2549
			order[2] = 0
			super(2548, 1803, order)
		end
	end

	class NoMDFeedTypes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 1022
			order[1] = 1683
			order[2] = 264
			order[3] = 2563
			order[4] = 2564
			order[5] = 2565
			order[6] = 2566
			order[7] = 1021
			order[8] = 1173
			order[9] = 2567
			order[10] = 2568
			order[11] = 0
			super(1141, 1022, order)
		end
	end

	class NoMatchRules < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1142
			order[1] = 574
			order[2] = 2569
			order[3] = 2570
			order[4] = 0
			super(1235, 1142, order)
		end
	end

	class NoFlexProductEligibilities < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1242
			order[1] = 2561
			order[2] = 0
			super(2560, 1242, order)
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoMiscFees < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 137
			order[1] = 138
			order[2] = 139
			order[3] = 2712
			order[4] = 2633
			order[5] = 891
			order[6] = 2216
			order[7] = 2217
			order[8] = 2713
			order[9] = 0
			super(136, 137, order)
		end

		class NoMiscFeeSubTypes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2634
				order[1] = 2635
				order[2] = 2636
				order[3] = 2637
				order[4] = 2638
				order[5] = 0
				super(2633, 2634, order)
			end
		end
	end
end

class MarketDefinitionUpdateReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BV") )
	end

	class NoInstrumentScopes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(25)
			order[0] = 1535
			order[1] = 1536
			order[2] = 1537
			order[3] = 1538
			order[4] = 1539
			order[5] = 1543
			order[6] = 1544
			order[7] = 1545
			order[8] = 1546
			order[9] = 2895
			order[10] = 1547
			order[11] = 1548
			order[12] = 1549
			order[13] = 1550
			order[14] = 1551
			order[15] = 1552
			order[16] = 1553
			order[17] = 1554
			order[18] = 1555
			order[19] = 1616
			order[20] = 1556
			order[21] = 1620
			order[22] = 1621
			order[23] = 1557
			order[24] = 0
			super(1656, 1535, order)
		end

		class NoInstrumentScopeSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1541
				order[1] = 1542
				order[2] = 0
				super(1540, 1541, order)
			end
		end
	end

	class NoRelatedMarketSegments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2546
			order[1] = 2547
			order[2] = 0
			super(2545, 2546, order)
		end
	end

	class NoTickRules < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(8)
			order[0] = 1206
			order[1] = 1207
			order[2] = 1208
			order[3] = 1209
			order[4] = 2571
			order[5] = 1830
			order[6] = 1831
			order[7] = 0
			super(1205, 1206, order)
		end
	end

	class NoLotTypeRules < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1093
			order[1] = 1231
			order[2] = 0
			super(1234, 1093, order)
		end
	end

	class NoPriceRangeRules < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 2551
			order[1] = 2552
			order[2] = 2553
			order[3] = 2554
			order[4] = 2556
			order[5] = 2555
			order[6] = 0
			super(2550, 2551, order)
		end
	end

	class NoQuoteSizeRules < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 647
			order[1] = 648
			order[2] = 2447
			order[3] = 0
			super(2558, 647, order)
		end
	end

	class NoOrdTypeRules < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40
			order[1] = 0
			super(1237, 40, order)
		end
	end

	class NoTimeInForceRules < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 59
			order[1] = 0
			super(1239, 59, order)
		end
	end

	class NoExecInstRules < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 1308
			order[1] = 0
			super(1232, 1308, order)
		end
	end

	class NoAuctionTypeRules < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1803
			order[1] = 2549
			order[2] = 0
			super(2548, 1803, order)
		end
	end

	class NoMDFeedTypes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 1022
			order[1] = 1683
			order[2] = 264
			order[3] = 2563
			order[4] = 2564
			order[5] = 2565
			order[6] = 2566
			order[7] = 1021
			order[8] = 1173
			order[9] = 2567
			order[10] = 2568
			order[11] = 0
			super(1141, 1022, order)
		end
	end

	class NoMatchRules < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1142
			order[1] = 574
			order[2] = 2569
			order[3] = 2570
			order[4] = 0
			super(1235, 1142, order)
		end
	end

	class NoFlexProductEligibilities < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1242
			order[1] = 2561
			order[2] = 0
			super(2560, 1242, order)
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end
end

class UserNotification < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CB") )
	end

	class NoUsernames < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 553
			order[1] = 0
			super(809, 553, order)
		end
	end

	class NoThrottles < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 1611
			order[1] = 1612
			order[2] = 1613
			order[3] = 1614
			order[4] = 1615
			order[5] = 1618
			order[6] = 0
			super(1610, 1611, order)
		end

		class NoThrottleMsgType < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 1619
				order[1] = 0
				super(1618, 1619, order)
			end
		end
	end
end

class OrderMassActionReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BZ") )
	end

	class NoAffectedOrders < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 1824
			order[1] = 535
			order[2] = 536
			order[3] = 0
			super(534, 1824, order)
		end
	end

	class NoNotAffectedOrders < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1372
			order[1] = 1371
			order[2] = 1825
			order[3] = 2677
			order[4] = 0
			super(1370, 1372, order)
		end
	end

	class NoAffectedMarketSegments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 1792
			order[1] = 0
			super(1791, 1792, order)
		end
	end

	class NoNotAffectedMarketSegments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 1794
			order[1] = 0
			super(1793, 1794, order)
		end
	end

	class NoTargetMarketSegments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 1790
			order[1] = 0
			super(1789, 1790, order)
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoTargetPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1462
			order[1] = 1463
			order[2] = 1464
			order[3] = 1818
			order[4] = 2433
			order[5] = 0
			super(1461, 1462, order)
		end

		class NoTargetPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2434
				order[1] = 2435
				order[2] = 0
				super(2433, 2434, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoUnderlyingSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 458
			order[1] = 459
			order[2] = 2959
			order[3] = 0
			super(457, 458, order)
		end
	end

	class NoUnderlyingStips < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 888
			order[1] = 889
			order[2] = 0
			super(887, 888, order)
		end
	end

	class NoUndlyInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1059
			order[1] = 1060
			order[2] = 1061
			order[3] = 2391
			order[4] = 1062
			order[5] = 0
			super(1058, 1059, order)
		end

		class NoUndlyInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1063
				order[1] = 1064
				order[2] = 0
				super(1062, 1063, order)
			end
		end
	end

	class NoUnderlyingEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 1982
			order[1] = 1983
			order[2] = 1984
			order[3] = 1985
			order[4] = 1986
			order[5] = 2342
			order[6] = 1987
			order[7] = 2071
			order[8] = 2072
			order[9] = 2073
			order[10] = 0
			super(1981, 1982, order)
		end
	end

	class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 2081
			order[1] = 2082
			order[2] = 2083
			order[3] = 2745
			order[4] = 0
			super(2080, 2081, order)
		end
	end

	class NoUnderlyingAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2313
			order[1] = 2314
			order[2] = 2315
			order[3] = 0
			super(2312, 2313, order)
		end
	end

	class NoUnderlyingComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 2046
			order[1] = 2261
			order[2] = 2262
			order[3] = 2263
			order[4] = 2047
			order[5] = 2264
			order[6] = 2265
			order[7] = 2266
			order[8] = 2947
			order[9] = 2048
			order[10] = 2267
			order[11] = 2049
			order[12] = 2050
			order[13] = 2051
			order[14] = 2052
			order[15] = 2053
			order[16] = 2268
			order[17] = 2948
			order[18] = 2269
			order[19] = 2949
			order[20] = 2270
			order[21] = 2271
			order[22] = 2419
			order[23] = 2420
			order[24] = 2272
			order[25] = 2273
			order[26] = 2274
			order[27] = 2275
			order[28] = 2276
			order[29] = 41732
			order[30] = 41739
			order[31] = 41740
			order[32] = 41741
			order[33] = 41742
			order[34] = 41743
			order[35] = 41744
			order[36] = 41745
			order[37] = 41746
			order[38] = 41747
			order[39] = 41729
			order[40] = 2277
			order[41] = 2278
			order[42] = 2279
			order[43] = 2280
			order[44] = 2281
			order[45] = 41748
			order[46] = 41716
			order[47] = 2611
			order[48] = 2612
			order[49] = 2613
			order[50] = 2282
			order[51] = 2283
			order[52] = 0
			super(2045, 2046, order)
		end

		class NoUnderlyingComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2054
				order[1] = 2055
				order[2] = 2056
				order[3] = 0
				super(2053, 2054, order)
			end

			class NoUnderlyingComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2057
					order[1] = 2058
					order[2] = 0
					super(2056, 2057, order)
				end
			end
		end

		class NoUnderlyingComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41733
				order[1] = 41734
				order[2] = 41735
				order[3] = 41736
				order[4] = 0
				super(41732, 41733, order)
			end
		end

		class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41738
				order[1] = 0
				super(41737, 41738, order)
			end
		end

		class NoUnderlyingComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41730
				order[1] = 41731
				order[2] = 41750
				order[3] = 41726
				order[4] = 41713
				order[5] = 0
				super(41729, 41730, order)
			end

			class NoUnderlyingComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41751
					order[1] = 41752
					order[2] = 41753
					order[3] = 41754
					order[4] = 41755
					order[5] = 0
					super(41750, 41751, order)
				end
			end

			class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41727
					order[1] = 41728
					order[2] = 0
					super(41726, 41727, order)
				end
			end

			class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41714
					order[1] = 41715
					order[2] = 0
					super(41713, 41714, order)
				end
			end
		end

		class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41749
				order[1] = 0
				super(41748, 41749, order)
			end
		end

		class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 41717
				order[1] = 41718
				order[2] = 41719
				order[3] = 41720
				order[4] = 41721
				order[5] = 41722
				order[6] = 41723
				order[7] = 41724
				order[8] = 0
				super(41716, 41717, order)
			end

			class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41725
					order[1] = 0
					super(41724, 41725, order)
				end
			end
		end
	end

	class NoUnderlyingBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40963
			order[1] = 0
			super(40962, 40963, order)
		end
	end

	class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41948
			order[1] = 0
			super(41947, 41948, order)
		end
	end

	class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41865
			order[1] = 41338
			order[2] = 0
			super(41864, 41865, order)
		end
	end

	class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41867
			order[1] = 41339
			order[2] = 0
			super(41866, 41867, order)
		end
	end

	class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41869
			order[1] = 41870
			order[2] = 41871
			order[3] = 41872
			order[4] = 41873
			order[5] = 41874
			order[6] = 41875
			order[7] = 41876
			order[8] = 41877
			order[9] = 0
			super(41868, 41869, order)
		end
	end

	class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 43075
			order[1] = 0
			super(43074, 43075, order)
		end
	end

	class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41821
			order[1] = 0
			super(41820, 41821, order)
		end
	end

	class NoUnderlyingOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41842
			order[1] = 41843
			order[2] = 0
			super(41841, 41842, order)
		end
	end

	class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41845
			order[1] = 0
			super(41844, 41845, order)
		end
	end

	class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41857
			order[1] = 41858
			order[2] = 0
			super(41856, 41857, order)
		end
	end

	class NoUnderlyingStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40541
			order[1] = 42016
			order[2] = 40542
			order[3] = 43083
			order[4] = 43084
			order[5] = 40543
			order[6] = 40544
			order[7] = 42018
			order[8] = 40545
			order[9] = 40546
			order[10] = 43085
			order[11] = 43086
			order[12] = 42019
			order[13] = 42020
			order[14] = 42021
			order[15] = 42022
			order[16] = 42023
			order[17] = 42024
			order[18] = 41964
			order[19] = 41965
			order[20] = 41966
			order[21] = 41967
			order[22] = 41968
			order[23] = 41969
			order[24] = 41970
			order[25] = 42589
			order[26] = 41971
			order[27] = 41972
			order[28] = 41973
			order[29] = 41974
			order[30] = 41975
			order[31] = 41976
			order[32] = 41977
			order[33] = 41978
			order[34] = 41979
			order[35] = 41980
			order[36] = 41981
			order[37] = 41982
			order[38] = 41983
			order[39] = 41984
			order[40] = 41985
			order[41] = 41986
			order[42] = 41987
			order[43] = 41988
			order[44] = 41989
			order[45] = 40057
			order[46] = 40058
			order[47] = 40060
			order[48] = 40061
			order[49] = 40062
			order[50] = 40063
			order[51] = 40064
			order[52] = 40548
			order[53] = 40549
			order[54] = 40551
			order[55] = 40552
			order[56] = 40553
			order[57] = 40554
			order[58] = 40555
			order[59] = 41957
			order[60] = 41958
			order[61] = 40556
			order[62] = 40558
			order[63] = 40559
			order[64] = 40561
			order[65] = 40562
			order[66] = 40563
			order[67] = 40564
			order[68] = 40565
			order[69] = 40566
			order[70] = 40567
			order[71] = 41959
			order[72] = 41960
			order[73] = 41961
			order[74] = 40568
			order[75] = 40569
			order[76] = 40570
			order[77] = 42895
			order[78] = 40571
			order[79] = 40572
			order[80] = 43107
			order[81] = 40573
			order[82] = 40574
			order[83] = 40575
			order[84] = 40576
			order[85] = 40577
			order[86] = 42896
			order[87] = 42897
			order[88] = 42898
			order[89] = 42899
			order[90] = 40578
			order[91] = 40579
			order[92] = 40580
			order[93] = 41897
			order[94] = 41898
			order[95] = 41899
			order[96] = 41900
			order[97] = 41901
			order[98] = 41902
			order[99] = 41903
			order[100] = 42900
			order[101] = 40664
			order[102] = 40708
			order[103] = 41777
			order[104] = 41778
			order[105] = 41779
			order[106] = 41780
			order[107] = 41781
			order[108] = 42196
			order[109] = 42197
			order[110] = 41782
			order[111] = 41783
			order[112] = 41784
			order[113] = 41785
			order[114] = 41786
			order[115] = 41587
			order[116] = 41787
			order[117] = 41788
			order[118] = 41789
			order[119] = 41790
			order[120] = 41791
			order[121] = 41792
			order[122] = 41793
			order[123] = 41794
			order[124] = 41795
			order[125] = 41796
			order[126] = 41797
			order[127] = 41798
			order[128] = 41799
			order[129] = 43096
			order[130] = 41756
			order[131] = 40547
			order[132] = 40988
			order[133] = 40989
			order[134] = 0
			super(40540, 40541, order)
		end

		class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41991
				order[1] = 41992
				order[2] = 0
				super(41990, 41991, order)
			end
		end

		class NoUnderlyingStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41801
				order[1] = 41802
				order[2] = 41803
				order[3] = 0
				super(41800, 41801, order)
			end
		end

		class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41994
				order[1] = 41995
				order[2] = 0
				super(41993, 41994, order)
			end
		end

		class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41963
				order[1] = 0
				super(41962, 41963, order)
			end
		end

		class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 42003
				order[1] = 42004
				order[2] = 42005
				order[3] = 42006
				order[4] = 42007
				order[5] = 42008
				order[6] = 42009
				order[7] = 42010
				order[8] = 42011
				order[9] = 42012
				order[10] = 42013
				order[11] = 41996
				order[12] = 42014
				order[13] = 42015
				order[14] = 0
				super(42002, 42003, order)
			end

			class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41997
					order[1] = 41998
					order[2] = 41999
					order[3] = 0
					super(41996, 41997, order)
				end

				class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42000
						order[1] = 42001
						order[2] = 41936
						order[3] = 0
						super(41999, 42000, order)
					end
				end
			end
		end

		class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40059
				order[1] = 0
				super(40975, 40059, order)
			end
		end

		class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40550
				order[1] = 0
				super(40976, 40550, order)
			end
		end

		class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40557
				order[1] = 0
				super(40973, 40557, order)
			end
		end

		class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41955
				order[1] = 41956
				order[2] = 0
				super(41954, 41955, order)
			end
		end

		class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40560
				order[1] = 0
				super(40974, 40560, order)
			end
		end

		class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40582
				order[1] = 0
				super(40969, 40582, order)
			end
		end

		class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41938
				order[1] = 41939
				order[2] = 0
				super(41937, 41938, order)
			end
		end

		class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40594
				order[1] = 0
				super(40970, 40594, order)
			end
		end

		class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40600
				order[1] = 0
				super(40971, 40600, order)
			end
		end

		class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40607
				order[1] = 0
				super(40972, 40607, order)
			end
		end

		class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42956
				order[1] = 42957
				order[2] = 0
				super(42955, 42956, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41910
				order[1] = 0
				super(41909, 41910, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41945
				order[1] = 41946
				order[2] = 0
				super(41944, 41945, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41942
				order[1] = 41943
				order[2] = 0
				super(41941, 41942, order)
			end
		end

		class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43111
				order[1] = 42982
				order[2] = 42983
				order[3] = 0
				super(42981, 43111, order)
			end
		end

		class NoUnderlyingDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42863
				order[1] = 42864
				order[2] = 42865
				order[3] = 42866
				order[4] = 42867
				order[5] = 42868
				order[6] = 42882
				order[7] = 42869
				order[8] = 42870
				order[9] = 42871
				order[10] = 42872
				order[11] = 42873
				order[12] = 42874
				order[13] = 42875
				order[14] = 42876
				order[15] = 42877
				order[16] = 42878
				order[17] = 42879
				order[18] = 42880
				order[19] = 42881
				order[20] = 0
				super(42862, 42863, order)
			end

			class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42883
					order[1] = 0
					super(42882, 42883, order)
				end
			end
		end

		class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42854
				order[1] = 0
				super(42853, 42854, order)
			end
		end

		class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42800
				order[1] = 0
				super(42799, 42800, order)
			end
		end

		class NoUnderlyingReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 43035
				order[1] = 43036
				order[2] = 43037
				order[3] = 43038
				order[4] = 43039
				order[5] = 43040
				order[6] = 43064
				order[7] = 43030
				order[8] = 43041
				order[9] = 43042
				order[10] = 43043
				order[11] = 43044
				order[12] = 43045
				order[13] = 43046
				order[14] = 43047
				order[15] = 43048
				order[16] = 43049
				order[17] = 43050
				order[18] = 43051
				order[19] = 43052
				order[20] = 43060
				order[21] = 43053
				order[22] = 43054
				order[23] = 43008
				order[24] = 43055
				order[25] = 43056
				order[26] = 43057
				order[27] = 43058
				order[28] = 43059
				order[29] = 0
				super(43034, 43035, order)
			end

			class NoUnderlyingReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 43065
					order[1] = 43066
					order[2] = 43067
					order[3] = 43068
					order[4] = 0
					super(43064, 43065, order)
				end
			end

			class NoUnderlyingReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43031
					order[1] = 43032
					order[2] = 43033
					order[3] = 0
					super(43030, 43031, order)
				end
			end

			class NoUnderlyingReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43061
					order[1] = 43062
					order[2] = 43063
					order[3] = 0
					super(43060, 43061, order)
				end
			end

			class NoUnderlyingReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 43009
					order[1] = 43071
					order[2] = 43010
					order[3] = 43011
					order[4] = 43012
					order[5] = 43013
					order[6] = 43014
					order[7] = 43015
					order[8] = 43016
					order[9] = 43017
					order[10] = 43018
					order[11] = 43019
					order[12] = 43020
					order[13] = 43021
					order[14] = 43022
					order[15] = 43023
					order[16] = 43024
					order[17] = 43025
					order[18] = 43026
					order[19] = 43027
					order[20] = 43028
					order[21] = 43029
					order[22] = 43069
					order[23] = 0
					super(43008, 43009, order)
				end

				class NoUnderlyingReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 43072
						order[1] = 43073
						order[2] = 0
						super(43071, 43072, order)
					end
				end

				class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43070
						order[1] = 0
						super(43069, 43070, order)
					end
				end
			end
		end

		class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42916
				order[1] = 0
				super(42915, 42916, order)
			end
		end

		class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42902
				order[1] = 42903
				order[2] = 0
				super(42901, 42902, order)
			end
		end

		class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40650
				order[1] = 0
				super(40968, 40650, order)
			end
		end

		class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40657
				order[1] = 40658
				order[2] = 0
				super(40656, 40657, order)
			end
		end

		class NoUnderlyingSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40660
				order[1] = 40904
				order[2] = 40915
				order[3] = 40662
				order[4] = 40663
				order[5] = 0
				super(40659, 40660, order)
			end
		end

		class NoUnderlyingPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40665
				order[1] = 41881
				order[2] = 41882
				order[3] = 40666
				order[4] = 40667
				order[5] = 40668
				order[6] = 40669
				order[7] = 40670
				order[8] = 40671
				order[9] = 40672
				order[10] = 40673
				order[11] = 40674
				order[12] = 40675
				order[13] = 41883
				order[14] = 41884
				order[15] = 41885
				order[16] = 41886
				order[17] = 40676
				order[18] = 40677
				order[19] = 40678
				order[20] = 40679
				order[21] = 41887
				order[22] = 41888
				order[23] = 41889
				order[24] = 41890
				order[25] = 40680
				order[26] = 40681
				order[27] = 40682
				order[28] = 40683
				order[29] = 40684
				order[30] = 40685
				order[31] = 40704
				order[32] = 40686
				order[33] = 40687
				order[34] = 40688
				order[35] = 40689
				order[36] = 40966
				order[37] = 40691
				order[38] = 40692
				order[39] = 40693
				order[40] = 41891
				order[41] = 41892
				order[42] = 40694
				order[43] = 41878
				order[44] = 41893
				order[45] = 41894
				order[46] = 41895
				order[47] = 41896
				order[48] = 40695
				order[49] = 40696
				order[50] = 40697
				order[51] = 40698
				order[52] = 40967
				order[53] = 40700
				order[54] = 40701
				order[55] = 40702
				order[56] = 40703
				order[57] = 0
				super(40664, 40665, order)
			end

			class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40705
					order[1] = 40706
					order[2] = 40707
					order[3] = 0
					super(40704, 40705, order)
				end
			end

			class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40690
					order[1] = 0
					super(40966, 40690, order)
				end
			end

			class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41879
					order[1] = 41880
					order[2] = 0
					super(41878, 41879, order)
				end
			end

			class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40699
					order[1] = 0
					super(40967, 40699, order)
				end
			end
		end

		class NoUnderlyingPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40709
				order[1] = 40710
				order[2] = 42993
				order[3] = 42994
				order[4] = 42995
				order[5] = 42996
				order[6] = 42997
				order[7] = 42998
				order[8] = 42999
				order[9] = 42984
				order[10] = 42985
				order[11] = 42986
				order[12] = 42987
				order[13] = 42988
				order[14] = 42989
				order[15] = 42990
				order[16] = 40711
				order[17] = 40712
				order[18] = 40713
				order[19] = 40714
				order[20] = 40715
				order[21] = 40716
				order[22] = 40717
				order[23] = 40718
				order[24] = 40719
				order[25] = 40720
				order[26] = 40721
				order[27] = 40722
				order[28] = 40723
				order[29] = 40724
				order[30] = 40725
				order[31] = 40726
				order[32] = 40727
				order[33] = 40728
				order[34] = 40729
				order[35] = 40730
				order[36] = 40731
				order[37] = 40732
				order[38] = 40733
				order[39] = 40734
				order[40] = 40735
				order[41] = 40736
				order[42] = 40737
				order[43] = 0
				super(40708, 40709, order)
			end

			class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 43001
					order[1] = 0
					super(43000, 43001, order)
				end
			end

			class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42992
					order[1] = 0
					super(42991, 42992, order)
				end
			end
		end

		class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41809
				order[1] = 0
				super(41808, 41809, order)
			end
		end

		class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41805
				order[1] = 41806
				order[2] = 41807
				order[3] = 0
				super(41804, 41805, order)
			end
		end

		class NoUnderlyingDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41757
				order[1] = 41758
				order[2] = 41759
				order[3] = 41760
				order[4] = 41761
				order[5] = 41762
				order[6] = 41763
				order[7] = 41764
				order[8] = 41765
				order[9] = 41766
				order[10] = 41767
				order[11] = 41768
				order[12] = 41769
				order[13] = 41770
				order[14] = 0
				super(41756, 41757, order)
			end

			class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41771
					order[1] = 41772
					order[2] = 41773
					order[3] = 0
					super(41770, 41771, order)
				end

				class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41774
						order[1] = 41775
						order[2] = 41776
						order[3] = 0
						super(41773, 41774, order)
					end
				end
			end
		end
	end

	class NoUnderlyingProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 42150
			order[1] = 42151
			order[2] = 42152
			order[3] = 42190
			order[4] = 42153
			order[5] = 42154
			order[6] = 42155
			order[7] = 43002
			order[8] = 43003
			order[9] = 42156
			order[10] = 42157
			order[11] = 42158
			order[12] = 42104
			order[13] = 42105
			order[14] = 42106
			order[15] = 42107
			order[16] = 42108
			order[17] = 42109
			order[18] = 42110
			order[19] = 42111
			order[20] = 42115
			order[21] = 42116
			order[22] = 42117
			order[23] = 42118
			order[24] = 42119
			order[25] = 42120
			order[26] = 42121
			order[27] = 42122
			order[28] = 42123
			order[29] = 42124
			order[30] = 42125
			order[31] = 42126
			order[32] = 42127
			order[33] = 42128
			order[34] = 42129
			order[35] = 42130
			order[36] = 42131
			order[37] = 42132
			order[38] = 42133
			order[39] = 42134
			order[40] = 42135
			order[41] = 42136
			order[42] = 42137
			order[43] = 42138
			order[44] = 42139
			order[45] = 42140
			order[46] = 42141
			order[47] = 42142
			order[48] = 42143
			order[49] = 42144
			order[50] = 42145
			order[51] = 42146
			order[52] = 42147
			order[53] = 42148
			order[54] = 42159
			order[55] = 42160
			order[56] = 42161
			order[57] = 42162
			order[58] = 42163
			order[59] = 42164
			order[60] = 42165
			order[61] = 42092
			order[62] = 42093
			order[63] = 42094
			order[64] = 42095
			order[65] = 42096
			order[66] = 42097
			order[67] = 42098
			order[68] = 42166
			order[69] = 42167
			order[70] = 42168
			order[71] = 42169
			order[72] = 42102
			order[73] = 42103
			order[74] = 42170
			order[75] = 42171
			order[76] = 42172
			order[77] = 42173
			order[78] = 0
			super(42149, 42150, order)
		end

		class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42191
				order[1] = 0
				super(42190, 42191, order)
			end
		end

		class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42183
				order[1] = 0
				super(42182, 42183, order)
			end
		end

		class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42185
				order[1] = 0
				super(42184, 42185, order)
			end
		end

		class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42113
				order[1] = 42114
				order[2] = 0
				super(42112, 42113, order)
			end
		end

		class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42187
				order[1] = 0
				super(42186, 42187, order)
			end
		end

		class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42189
				order[1] = 0
				super(42188, 42189, order)
			end
		end

		class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42181
				order[1] = 0
				super(42180, 42181, order)
			end
		end

		class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42100
				order[1] = 42101
				order[2] = 0
				super(42099, 42100, order)
			end
		end

		class NoUnderlyingProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42174
				order[1] = 42175
				order[2] = 42176
				order[3] = 40918
				order[4] = 42177
				order[5] = 0
				super(42173, 42174, order)
			end

			class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42178
					order[1] = 42179
					order[2] = 0
					super(42177, 42178, order)
				end
			end
		end
	end

	class NoUnderlyingAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 42037
			order[1] = 42038
			order[2] = 41340
			order[3] = 0
			super(42036, 42037, order)
		end

		class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 41341
				order[1] = 41701
				order[2] = 41709
				order[3] = 41710
				order[4] = 41711
				order[5] = 41712
				order[6] = 42017
				order[7] = 42025
				order[8] = 42026
				order[9] = 42027
				order[10] = 42028
				order[11] = 42029
				order[12] = 42030
				order[13] = 42031
				order[14] = 42032
				order[15] = 42033
				order[16] = 42034
				order[17] = 42035
				order[18] = 0
				super(41340, 41341, order)
			end
		end
	end

	class NoUnderlyingProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 42069
			order[1] = 42070
			order[2] = 42071
			order[3] = 42072
			order[4] = 42073
			order[5] = 42074
			order[6] = 42075
			order[7] = 42090
			order[8] = 42077
			order[9] = 42087
			order[10] = 42076
			order[11] = 0
			super(42068, 42069, order)
		end

		class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42091
				order[1] = 0
				super(42090, 42091, order)
			end
		end

		class NoUnderlyingProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 42078
				order[1] = 42079
				order[2] = 42080
				order[3] = 42081
				order[4] = 42082
				order[5] = 42083
				order[6] = 42084
				order[7] = 42085
				order[8] = 0
				super(42077, 42078, order)
			end

			class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42086
					order[1] = 0
					super(42085, 42086, order)
				end
			end
		end

		class NoUnderlyingProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42088
				order[1] = 42089
				order[2] = 0
				super(42087, 42088, order)
			end
		end
	end

	class NoUnderlyingCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 42042
			order[1] = 42043
			order[2] = 42044
			order[3] = 42045
			order[4] = 42046
			order[5] = 42047
			order[6] = 42048
			order[7] = 42049
			order[8] = 42050
			order[9] = 42051
			order[10] = 42052
			order[11] = 42039
			order[12] = 42797
			order[13] = 42798
			order[14] = 42053
			order[15] = 42054
			order[16] = 42790
			order[17] = 42791
			order[18] = 42792
			order[19] = 42793
			order[20] = 42794
			order[21] = 42795
			order[22] = 42796
			order[23] = 42055
			order[24] = 42056
			order[25] = 42057
			order[26] = 42058
			order[27] = 42059
			order[28] = 0
			super(42041, 42042, order)
		end

		class NoUnderlyingCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42040
				order[1] = 0
				super(42039, 42040, order)
			end
		end

		class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42789
				order[1] = 0
				super(42788, 42789, order)
			end
		end
	end

	class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 42065
			order[1] = 42061
			order[2] = 42062
			order[3] = 42063
			order[4] = 42064
			order[5] = 0
			super(42060, 42065, order)
		end

		class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42066
				order[1] = 42067
				order[2] = 0
				super(42065, 42066, order)
			end
		end
	end

	class NoUnderlyingRateSpreadSteps < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 43006
			order[1] = 43007
			order[2] = 0
			super(43005, 43006, order)
		end
	end

	class NoUnderlyingDividendPayments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 42856
			order[1] = 42857
			order[2] = 42858
			order[3] = 42859
			order[4] = 0
			super(42855, 42856, order)
		end
	end

	class NoUnderlyingExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42885
			order[1] = 42886
			order[2] = 0
			super(42884, 42885, order)
		end
	end
end

class OrderMassActionRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CA") )
	end

	class NoTargetMarketSegments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 1790
			order[1] = 0
			super(1789, 1790, order)
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoTargetPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1462
			order[1] = 1463
			order[2] = 1464
			order[3] = 1818
			order[4] = 2433
			order[5] = 0
			super(1461, 1462, order)
		end

		class NoTargetPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2434
				order[1] = 2435
				order[2] = 0
				super(2433, 2434, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoUnderlyingSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 458
			order[1] = 459
			order[2] = 2959
			order[3] = 0
			super(457, 458, order)
		end
	end

	class NoUnderlyingStips < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 888
			order[1] = 889
			order[2] = 0
			super(887, 888, order)
		end
	end

	class NoUndlyInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1059
			order[1] = 1060
			order[2] = 1061
			order[3] = 2391
			order[4] = 1062
			order[5] = 0
			super(1058, 1059, order)
		end

		class NoUndlyInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1063
				order[1] = 1064
				order[2] = 0
				super(1062, 1063, order)
			end
		end
	end

	class NoUnderlyingEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 1982
			order[1] = 1983
			order[2] = 1984
			order[3] = 1985
			order[4] = 1986
			order[5] = 2342
			order[6] = 1987
			order[7] = 2071
			order[8] = 2072
			order[9] = 2073
			order[10] = 0
			super(1981, 1982, order)
		end
	end

	class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 2081
			order[1] = 2082
			order[2] = 2083
			order[3] = 2745
			order[4] = 0
			super(2080, 2081, order)
		end
	end

	class NoUnderlyingAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2313
			order[1] = 2314
			order[2] = 2315
			order[3] = 0
			super(2312, 2313, order)
		end
	end

	class NoUnderlyingComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 2046
			order[1] = 2261
			order[2] = 2262
			order[3] = 2263
			order[4] = 2047
			order[5] = 2264
			order[6] = 2265
			order[7] = 2266
			order[8] = 2947
			order[9] = 2048
			order[10] = 2267
			order[11] = 2049
			order[12] = 2050
			order[13] = 2051
			order[14] = 2052
			order[15] = 2053
			order[16] = 2268
			order[17] = 2948
			order[18] = 2269
			order[19] = 2949
			order[20] = 2270
			order[21] = 2271
			order[22] = 2419
			order[23] = 2420
			order[24] = 2272
			order[25] = 2273
			order[26] = 2274
			order[27] = 2275
			order[28] = 2276
			order[29] = 41732
			order[30] = 41739
			order[31] = 41740
			order[32] = 41741
			order[33] = 41742
			order[34] = 41743
			order[35] = 41744
			order[36] = 41745
			order[37] = 41746
			order[38] = 41747
			order[39] = 41729
			order[40] = 2277
			order[41] = 2278
			order[42] = 2279
			order[43] = 2280
			order[44] = 2281
			order[45] = 41748
			order[46] = 41716
			order[47] = 2611
			order[48] = 2612
			order[49] = 2613
			order[50] = 2282
			order[51] = 2283
			order[52] = 0
			super(2045, 2046, order)
		end

		class NoUnderlyingComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2054
				order[1] = 2055
				order[2] = 2056
				order[3] = 0
				super(2053, 2054, order)
			end

			class NoUnderlyingComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2057
					order[1] = 2058
					order[2] = 0
					super(2056, 2057, order)
				end
			end
		end

		class NoUnderlyingComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41733
				order[1] = 41734
				order[2] = 41735
				order[3] = 41736
				order[4] = 0
				super(41732, 41733, order)
			end
		end

		class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41738
				order[1] = 0
				super(41737, 41738, order)
			end
		end

		class NoUnderlyingComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41730
				order[1] = 41731
				order[2] = 41750
				order[3] = 41726
				order[4] = 41713
				order[5] = 0
				super(41729, 41730, order)
			end

			class NoUnderlyingComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41751
					order[1] = 41752
					order[2] = 41753
					order[3] = 41754
					order[4] = 41755
					order[5] = 0
					super(41750, 41751, order)
				end
			end

			class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41727
					order[1] = 41728
					order[2] = 0
					super(41726, 41727, order)
				end
			end

			class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41714
					order[1] = 41715
					order[2] = 0
					super(41713, 41714, order)
				end
			end
		end

		class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41749
				order[1] = 0
				super(41748, 41749, order)
			end
		end

		class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 41717
				order[1] = 41718
				order[2] = 41719
				order[3] = 41720
				order[4] = 41721
				order[5] = 41722
				order[6] = 41723
				order[7] = 41724
				order[8] = 0
				super(41716, 41717, order)
			end

			class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41725
					order[1] = 0
					super(41724, 41725, order)
				end
			end
		end
	end

	class NoUnderlyingBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40963
			order[1] = 0
			super(40962, 40963, order)
		end
	end

	class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41948
			order[1] = 0
			super(41947, 41948, order)
		end
	end

	class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41865
			order[1] = 41338
			order[2] = 0
			super(41864, 41865, order)
		end
	end

	class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41867
			order[1] = 41339
			order[2] = 0
			super(41866, 41867, order)
		end
	end

	class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41869
			order[1] = 41870
			order[2] = 41871
			order[3] = 41872
			order[4] = 41873
			order[5] = 41874
			order[6] = 41875
			order[7] = 41876
			order[8] = 41877
			order[9] = 0
			super(41868, 41869, order)
		end
	end

	class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 43075
			order[1] = 0
			super(43074, 43075, order)
		end
	end

	class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41821
			order[1] = 0
			super(41820, 41821, order)
		end
	end

	class NoUnderlyingOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41842
			order[1] = 41843
			order[2] = 0
			super(41841, 41842, order)
		end
	end

	class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41845
			order[1] = 0
			super(41844, 41845, order)
		end
	end

	class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41857
			order[1] = 41858
			order[2] = 0
			super(41856, 41857, order)
		end
	end

	class NoUnderlyingStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40541
			order[1] = 42016
			order[2] = 40542
			order[3] = 43083
			order[4] = 43084
			order[5] = 40543
			order[6] = 40544
			order[7] = 42018
			order[8] = 40545
			order[9] = 40546
			order[10] = 43085
			order[11] = 43086
			order[12] = 42019
			order[13] = 42020
			order[14] = 42021
			order[15] = 42022
			order[16] = 42023
			order[17] = 42024
			order[18] = 41964
			order[19] = 41965
			order[20] = 41966
			order[21] = 41967
			order[22] = 41968
			order[23] = 41969
			order[24] = 41970
			order[25] = 42589
			order[26] = 41971
			order[27] = 41972
			order[28] = 41973
			order[29] = 41974
			order[30] = 41975
			order[31] = 41976
			order[32] = 41977
			order[33] = 41978
			order[34] = 41979
			order[35] = 41980
			order[36] = 41981
			order[37] = 41982
			order[38] = 41983
			order[39] = 41984
			order[40] = 41985
			order[41] = 41986
			order[42] = 41987
			order[43] = 41988
			order[44] = 41989
			order[45] = 40057
			order[46] = 40058
			order[47] = 40060
			order[48] = 40061
			order[49] = 40062
			order[50] = 40063
			order[51] = 40064
			order[52] = 40548
			order[53] = 40549
			order[54] = 40551
			order[55] = 40552
			order[56] = 40553
			order[57] = 40554
			order[58] = 40555
			order[59] = 41957
			order[60] = 41958
			order[61] = 40556
			order[62] = 40558
			order[63] = 40559
			order[64] = 40561
			order[65] = 40562
			order[66] = 40563
			order[67] = 40564
			order[68] = 40565
			order[69] = 40566
			order[70] = 40567
			order[71] = 41959
			order[72] = 41960
			order[73] = 41961
			order[74] = 40568
			order[75] = 40569
			order[76] = 40570
			order[77] = 42895
			order[78] = 40571
			order[79] = 40572
			order[80] = 43107
			order[81] = 40573
			order[82] = 40574
			order[83] = 40575
			order[84] = 40576
			order[85] = 40577
			order[86] = 42896
			order[87] = 42897
			order[88] = 42898
			order[89] = 42899
			order[90] = 40578
			order[91] = 40579
			order[92] = 40580
			order[93] = 41897
			order[94] = 41898
			order[95] = 41899
			order[96] = 41900
			order[97] = 41901
			order[98] = 41902
			order[99] = 41903
			order[100] = 42900
			order[101] = 40664
			order[102] = 40708
			order[103] = 41777
			order[104] = 41778
			order[105] = 41779
			order[106] = 41780
			order[107] = 41781
			order[108] = 42196
			order[109] = 42197
			order[110] = 41782
			order[111] = 41783
			order[112] = 41784
			order[113] = 41785
			order[114] = 41786
			order[115] = 41587
			order[116] = 41787
			order[117] = 41788
			order[118] = 41789
			order[119] = 41790
			order[120] = 41791
			order[121] = 41792
			order[122] = 41793
			order[123] = 41794
			order[124] = 41795
			order[125] = 41796
			order[126] = 41797
			order[127] = 41798
			order[128] = 41799
			order[129] = 43096
			order[130] = 41756
			order[131] = 40547
			order[132] = 40988
			order[133] = 40989
			order[134] = 0
			super(40540, 40541, order)
		end

		class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41991
				order[1] = 41992
				order[2] = 0
				super(41990, 41991, order)
			end
		end

		class NoUnderlyingStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41801
				order[1] = 41802
				order[2] = 41803
				order[3] = 0
				super(41800, 41801, order)
			end
		end

		class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41994
				order[1] = 41995
				order[2] = 0
				super(41993, 41994, order)
			end
		end

		class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41963
				order[1] = 0
				super(41962, 41963, order)
			end
		end

		class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 42003
				order[1] = 42004
				order[2] = 42005
				order[3] = 42006
				order[4] = 42007
				order[5] = 42008
				order[6] = 42009
				order[7] = 42010
				order[8] = 42011
				order[9] = 42012
				order[10] = 42013
				order[11] = 41996
				order[12] = 42014
				order[13] = 42015
				order[14] = 0
				super(42002, 42003, order)
			end

			class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41997
					order[1] = 41998
					order[2] = 41999
					order[3] = 0
					super(41996, 41997, order)
				end

				class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42000
						order[1] = 42001
						order[2] = 41936
						order[3] = 0
						super(41999, 42000, order)
					end
				end
			end
		end

		class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40059
				order[1] = 0
				super(40975, 40059, order)
			end
		end

		class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40550
				order[1] = 0
				super(40976, 40550, order)
			end
		end

		class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40557
				order[1] = 0
				super(40973, 40557, order)
			end
		end

		class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41955
				order[1] = 41956
				order[2] = 0
				super(41954, 41955, order)
			end
		end

		class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40560
				order[1] = 0
				super(40974, 40560, order)
			end
		end

		class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40582
				order[1] = 0
				super(40969, 40582, order)
			end
		end

		class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41938
				order[1] = 41939
				order[2] = 0
				super(41937, 41938, order)
			end
		end

		class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40594
				order[1] = 0
				super(40970, 40594, order)
			end
		end

		class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40600
				order[1] = 0
				super(40971, 40600, order)
			end
		end

		class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40607
				order[1] = 0
				super(40972, 40607, order)
			end
		end

		class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42956
				order[1] = 42957
				order[2] = 0
				super(42955, 42956, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41910
				order[1] = 0
				super(41909, 41910, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41945
				order[1] = 41946
				order[2] = 0
				super(41944, 41945, order)
			end
		end

		class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41942
				order[1] = 41943
				order[2] = 0
				super(41941, 41942, order)
			end
		end

		class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43111
				order[1] = 42982
				order[2] = 42983
				order[3] = 0
				super(42981, 43111, order)
			end
		end

		class NoUnderlyingDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42863
				order[1] = 42864
				order[2] = 42865
				order[3] = 42866
				order[4] = 42867
				order[5] = 42868
				order[6] = 42882
				order[7] = 42869
				order[8] = 42870
				order[9] = 42871
				order[10] = 42872
				order[11] = 42873
				order[12] = 42874
				order[13] = 42875
				order[14] = 42876
				order[15] = 42877
				order[16] = 42878
				order[17] = 42879
				order[18] = 42880
				order[19] = 42881
				order[20] = 0
				super(42862, 42863, order)
			end

			class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42883
					order[1] = 0
					super(42882, 42883, order)
				end
			end
		end

		class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42854
				order[1] = 0
				super(42853, 42854, order)
			end
		end

		class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42800
				order[1] = 0
				super(42799, 42800, order)
			end
		end

		class NoUnderlyingReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 43035
				order[1] = 43036
				order[2] = 43037
				order[3] = 43038
				order[4] = 43039
				order[5] = 43040
				order[6] = 43064
				order[7] = 43030
				order[8] = 43041
				order[9] = 43042
				order[10] = 43043
				order[11] = 43044
				order[12] = 43045
				order[13] = 43046
				order[14] = 43047
				order[15] = 43048
				order[16] = 43049
				order[17] = 43050
				order[18] = 43051
				order[19] = 43052
				order[20] = 43060
				order[21] = 43053
				order[22] = 43054
				order[23] = 43008
				order[24] = 43055
				order[25] = 43056
				order[26] = 43057
				order[27] = 43058
				order[28] = 43059
				order[29] = 0
				super(43034, 43035, order)
			end

			class NoUnderlyingReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 43065
					order[1] = 43066
					order[2] = 43067
					order[3] = 43068
					order[4] = 0
					super(43064, 43065, order)
				end
			end

			class NoUnderlyingReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43031
					order[1] = 43032
					order[2] = 43033
					order[3] = 0
					super(43030, 43031, order)
				end
			end

			class NoUnderlyingReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43061
					order[1] = 43062
					order[2] = 43063
					order[3] = 0
					super(43060, 43061, order)
				end
			end

			class NoUnderlyingReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 43009
					order[1] = 43071
					order[2] = 43010
					order[3] = 43011
					order[4] = 43012
					order[5] = 43013
					order[6] = 43014
					order[7] = 43015
					order[8] = 43016
					order[9] = 43017
					order[10] = 43018
					order[11] = 43019
					order[12] = 43020
					order[13] = 43021
					order[14] = 43022
					order[15] = 43023
					order[16] = 43024
					order[17] = 43025
					order[18] = 43026
					order[19] = 43027
					order[20] = 43028
					order[21] = 43029
					order[22] = 43069
					order[23] = 0
					super(43008, 43009, order)
				end

				class NoUnderlyingReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 43072
						order[1] = 43073
						order[2] = 0
						super(43071, 43072, order)
					end
				end

				class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43070
						order[1] = 0
						super(43069, 43070, order)
					end
				end
			end
		end

		class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42916
				order[1] = 0
				super(42915, 42916, order)
			end
		end

		class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42902
				order[1] = 42903
				order[2] = 0
				super(42901, 42902, order)
			end
		end

		class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40650
				order[1] = 0
				super(40968, 40650, order)
			end
		end

		class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40657
				order[1] = 40658
				order[2] = 0
				super(40656, 40657, order)
			end
		end

		class NoUnderlyingSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40660
				order[1] = 40904
				order[2] = 40915
				order[3] = 40662
				order[4] = 40663
				order[5] = 0
				super(40659, 40660, order)
			end
		end

		class NoUnderlyingPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40665
				order[1] = 41881
				order[2] = 41882
				order[3] = 40666
				order[4] = 40667
				order[5] = 40668
				order[6] = 40669
				order[7] = 40670
				order[8] = 40671
				order[9] = 40672
				order[10] = 40673
				order[11] = 40674
				order[12] = 40675
				order[13] = 41883
				order[14] = 41884
				order[15] = 41885
				order[16] = 41886
				order[17] = 40676
				order[18] = 40677
				order[19] = 40678
				order[20] = 40679
				order[21] = 41887
				order[22] = 41888
				order[23] = 41889
				order[24] = 41890
				order[25] = 40680
				order[26] = 40681
				order[27] = 40682
				order[28] = 40683
				order[29] = 40684
				order[30] = 40685
				order[31] = 40704
				order[32] = 40686
				order[33] = 40687
				order[34] = 40688
				order[35] = 40689
				order[36] = 40966
				order[37] = 40691
				order[38] = 40692
				order[39] = 40693
				order[40] = 41891
				order[41] = 41892
				order[42] = 40694
				order[43] = 41878
				order[44] = 41893
				order[45] = 41894
				order[46] = 41895
				order[47] = 41896
				order[48] = 40695
				order[49] = 40696
				order[50] = 40697
				order[51] = 40698
				order[52] = 40967
				order[53] = 40700
				order[54] = 40701
				order[55] = 40702
				order[56] = 40703
				order[57] = 0
				super(40664, 40665, order)
			end

			class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40705
					order[1] = 40706
					order[2] = 40707
					order[3] = 0
					super(40704, 40705, order)
				end
			end

			class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40690
					order[1] = 0
					super(40966, 40690, order)
				end
			end

			class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41879
					order[1] = 41880
					order[2] = 0
					super(41878, 41879, order)
				end
			end

			class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40699
					order[1] = 0
					super(40967, 40699, order)
				end
			end
		end

		class NoUnderlyingPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40709
				order[1] = 40710
				order[2] = 42993
				order[3] = 42994
				order[4] = 42995
				order[5] = 42996
				order[6] = 42997
				order[7] = 42998
				order[8] = 42999
				order[9] = 42984
				order[10] = 42985
				order[11] = 42986
				order[12] = 42987
				order[13] = 42988
				order[14] = 42989
				order[15] = 42990
				order[16] = 40711
				order[17] = 40712
				order[18] = 40713
				order[19] = 40714
				order[20] = 40715
				order[21] = 40716
				order[22] = 40717
				order[23] = 40718
				order[24] = 40719
				order[25] = 40720
				order[26] = 40721
				order[27] = 40722
				order[28] = 40723
				order[29] = 40724
				order[30] = 40725
				order[31] = 40726
				order[32] = 40727
				order[33] = 40728
				order[34] = 40729
				order[35] = 40730
				order[36] = 40731
				order[37] = 40732
				order[38] = 40733
				order[39] = 40734
				order[40] = 40735
				order[41] = 40736
				order[42] = 40737
				order[43] = 0
				super(40708, 40709, order)
			end

			class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 43001
					order[1] = 0
					super(43000, 43001, order)
				end
			end

			class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42992
					order[1] = 0
					super(42991, 42992, order)
				end
			end
		end

		class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41809
				order[1] = 0
				super(41808, 41809, order)
			end
		end

		class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41805
				order[1] = 41806
				order[2] = 41807
				order[3] = 0
				super(41804, 41805, order)
			end
		end

		class NoUnderlyingDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41757
				order[1] = 41758
				order[2] = 41759
				order[3] = 41760
				order[4] = 41761
				order[5] = 41762
				order[6] = 41763
				order[7] = 41764
				order[8] = 41765
				order[9] = 41766
				order[10] = 41767
				order[11] = 41768
				order[12] = 41769
				order[13] = 41770
				order[14] = 0
				super(41756, 41757, order)
			end

			class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41771
					order[1] = 41772
					order[2] = 41773
					order[3] = 0
					super(41770, 41771, order)
				end

				class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41774
						order[1] = 41775
						order[2] = 41776
						order[3] = 0
						super(41773, 41774, order)
					end
				end
			end
		end
	end

	class NoUnderlyingProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 42150
			order[1] = 42151
			order[2] = 42152
			order[3] = 42190
			order[4] = 42153
			order[5] = 42154
			order[6] = 42155
			order[7] = 43002
			order[8] = 43003
			order[9] = 42156
			order[10] = 42157
			order[11] = 42158
			order[12] = 42104
			order[13] = 42105
			order[14] = 42106
			order[15] = 42107
			order[16] = 42108
			order[17] = 42109
			order[18] = 42110
			order[19] = 42111
			order[20] = 42115
			order[21] = 42116
			order[22] = 42117
			order[23] = 42118
			order[24] = 42119
			order[25] = 42120
			order[26] = 42121
			order[27] = 42122
			order[28] = 42123
			order[29] = 42124
			order[30] = 42125
			order[31] = 42126
			order[32] = 42127
			order[33] = 42128
			order[34] = 42129
			order[35] = 42130
			order[36] = 42131
			order[37] = 42132
			order[38] = 42133
			order[39] = 42134
			order[40] = 42135
			order[41] = 42136
			order[42] = 42137
			order[43] = 42138
			order[44] = 42139
			order[45] = 42140
			order[46] = 42141
			order[47] = 42142
			order[48] = 42143
			order[49] = 42144
			order[50] = 42145
			order[51] = 42146
			order[52] = 42147
			order[53] = 42148
			order[54] = 42159
			order[55] = 42160
			order[56] = 42161
			order[57] = 42162
			order[58] = 42163
			order[59] = 42164
			order[60] = 42165
			order[61] = 42092
			order[62] = 42093
			order[63] = 42094
			order[64] = 42095
			order[65] = 42096
			order[66] = 42097
			order[67] = 42098
			order[68] = 42166
			order[69] = 42167
			order[70] = 42168
			order[71] = 42169
			order[72] = 42102
			order[73] = 42103
			order[74] = 42170
			order[75] = 42171
			order[76] = 42172
			order[77] = 42173
			order[78] = 0
			super(42149, 42150, order)
		end

		class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42191
				order[1] = 0
				super(42190, 42191, order)
			end
		end

		class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42183
				order[1] = 0
				super(42182, 42183, order)
			end
		end

		class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42185
				order[1] = 0
				super(42184, 42185, order)
			end
		end

		class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42113
				order[1] = 42114
				order[2] = 0
				super(42112, 42113, order)
			end
		end

		class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42187
				order[1] = 0
				super(42186, 42187, order)
			end
		end

		class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42189
				order[1] = 0
				super(42188, 42189, order)
			end
		end

		class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42181
				order[1] = 0
				super(42180, 42181, order)
			end
		end

		class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42100
				order[1] = 42101
				order[2] = 0
				super(42099, 42100, order)
			end
		end

		class NoUnderlyingProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42174
				order[1] = 42175
				order[2] = 42176
				order[3] = 40918
				order[4] = 42177
				order[5] = 0
				super(42173, 42174, order)
			end

			class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42178
					order[1] = 42179
					order[2] = 0
					super(42177, 42178, order)
				end
			end
		end
	end

	class NoUnderlyingAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 42037
			order[1] = 42038
			order[2] = 41340
			order[3] = 0
			super(42036, 42037, order)
		end

		class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 41341
				order[1] = 41701
				order[2] = 41709
				order[3] = 41710
				order[4] = 41711
				order[5] = 41712
				order[6] = 42017
				order[7] = 42025
				order[8] = 42026
				order[9] = 42027
				order[10] = 42028
				order[11] = 42029
				order[12] = 42030
				order[13] = 42031
				order[14] = 42032
				order[15] = 42033
				order[16] = 42034
				order[17] = 42035
				order[18] = 0
				super(41340, 41341, order)
			end
		end
	end

	class NoUnderlyingProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 42069
			order[1] = 42070
			order[2] = 42071
			order[3] = 42072
			order[4] = 42073
			order[5] = 42074
			order[6] = 42075
			order[7] = 42090
			order[8] = 42077
			order[9] = 42087
			order[10] = 42076
			order[11] = 0
			super(42068, 42069, order)
		end

		class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42091
				order[1] = 0
				super(42090, 42091, order)
			end
		end

		class NoUnderlyingProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 42078
				order[1] = 42079
				order[2] = 42080
				order[3] = 42081
				order[4] = 42082
				order[5] = 42083
				order[6] = 42084
				order[7] = 42085
				order[8] = 0
				super(42077, 42078, order)
			end

			class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42086
					order[1] = 0
					super(42085, 42086, order)
				end
			end
		end

		class NoUnderlyingProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42088
				order[1] = 42089
				order[2] = 0
				super(42087, 42088, order)
			end
		end
	end

	class NoUnderlyingCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 42042
			order[1] = 42043
			order[2] = 42044
			order[3] = 42045
			order[4] = 42046
			order[5] = 42047
			order[6] = 42048
			order[7] = 42049
			order[8] = 42050
			order[9] = 42051
			order[10] = 42052
			order[11] = 42039
			order[12] = 42797
			order[13] = 42798
			order[14] = 42053
			order[15] = 42054
			order[16] = 42790
			order[17] = 42791
			order[18] = 42792
			order[19] = 42793
			order[20] = 42794
			order[21] = 42795
			order[22] = 42796
			order[23] = 42055
			order[24] = 42056
			order[25] = 42057
			order[26] = 42058
			order[27] = 42059
			order[28] = 0
			super(42041, 42042, order)
		end

		class NoUnderlyingCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42040
				order[1] = 0
				super(42039, 42040, order)
			end
		end

		class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42789
				order[1] = 0
				super(42788, 42789, order)
			end
		end
	end

	class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 42065
			order[1] = 42061
			order[2] = 42062
			order[3] = 42063
			order[4] = 42064
			order[5] = 0
			super(42060, 42065, order)
		end

		class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42066
				order[1] = 42067
				order[2] = 0
				super(42065, 42066, order)
			end
		end
	end

	class NoUnderlyingRateSpreadSteps < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 43006
			order[1] = 43007
			order[2] = 0
			super(43005, 43006, order)
		end
	end

	class NoUnderlyingDividendPayments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 42856
			order[1] = 42857
			order[2] = 42858
			order[3] = 42859
			order[4] = 0
			super(42855, 42856, order)
		end
	end

	class NoUnderlyingExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42885
			order[1] = 42886
			order[2] = 0
			super(42884, 42885, order)
		end
	end
end

class ApplicationMessageRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BW") )
	end

	class NoApplIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1355
			order[1] = 1433
			order[2] = 1182
			order[3] = 1183
			order[4] = 539
			order[5] = 0
			super(1351, 1355, order)
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end
end

class ApplicationMessageRequestAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BX") )
	end

	class NoApplIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(8)
			order[0] = 1355
			order[1] = 1433
			order[2] = 1182
			order[3] = 1183
			order[4] = 1357
			order[5] = 1354
			order[6] = 539
			order[7] = 0
			super(1351, 1355, order)
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end
end

class ApplicationMessageReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("BY") )
	end

	class NoApplIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 1355
			order[1] = 1399
			order[2] = 1357
			order[3] = 0
			super(1351, 1355, order)
		end
	end
end

class StreamAssignmentRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CC") )
	end

	class NoAsgnReqs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 453
			order[1] = 146
			order[2] = 0
			super(1499, 453, order)
		end

		class NoPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 448
				order[1] = 447
				order[2] = 452
				order[3] = 2376
				order[4] = 802
				order[5] = 0
				super(453, 448, order)
			end

			class NoPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 523
					order[1] = 803
					order[2] = 0
					super(802, 523, order)
				end
			end
		end

		class NoRelatedSym < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(158)
				order[0] = 55
				order[1] = 65
				order[2] = 48
				order[3] = 22
				order[4] = 460
				order[5] = 1227
				order[6] = 1151
				order[7] = 461
				order[8] = 2891
				order[9] = 167
				order[10] = 762
				order[11] = 200
				order[12] = 541
				order[13] = 1079
				order[14] = 966
				order[15] = 1049
				order[16] = 965
				order[17] = 224
				order[18] = 1449
				order[19] = 1450
				order[20] = 1451
				order[21] = 1452
				order[22] = 1457
				order[23] = 1458
				order[24] = 1739
				order[25] = 2210
				order[26] = 1938
				order[27] = 1939
				order[28] = 1940
				order[29] = 2735
				order[30] = 1941
				order[31] = 1575
				order[32] = 1942
				order[33] = 1943
				order[34] = 1944
				order[35] = 1945
				order[36] = 1946
				order[37] = 1947
				order[38] = 1948
				order[39] = 1949
				order[40] = 1950
				order[41] = 2879
				order[42] = 1951
				order[43] = 1952
				order[44] = 1953
				order[45] = 1954
				order[46] = 1955
				order[47] = 1956
				order[48] = 1957
				order[49] = 1958
				order[50] = 1959
				order[51] = 1960
				order[52] = 1577
				order[53] = 1580
				order[54] = 1581
				order[55] = 1678
				order[56] = 1697
				order[57] = 225
				order[58] = 239
				order[59] = 226
				order[60] = 227
				order[61] = 228
				order[62] = 255
				order[63] = 543
				order[64] = 470
				order[65] = 471
				order[66] = 472
				order[67] = 240
				order[68] = 202
				order[69] = 2578
				order[70] = 2577
				order[71] = 947
				order[72] = 2904
				order[73] = 967
				order[74] = 968
				order[75] = 1698
				order[76] = 1866
				order[77] = 2600
				order[78] = 2001
				order[79] = 2601
				order[80] = 1478
				order[81] = 1479
				order[82] = 1480
				order[83] = 1481
				order[84] = 206
				order[85] = 231
				order[86] = 1435
				order[87] = 2353
				order[88] = 1439
				order[89] = 969
				order[90] = 1146
				order[91] = 996
				order[92] = 1147
				order[93] = 1716
				order[94] = 2905
				order[95] = 1191
				order[96] = 1192
				order[97] = 1717
				order[98] = 2906
				order[99] = 1193
				order[100] = 2579
				order[101] = 1194
				order[102] = 1482
				order[103] = 1195
				order[104] = 2753
				order[105] = 1196
				order[106] = 1197
				order[107] = 2002
				order[108] = 2140
				order[109] = 1524
				order[110] = 2907
				order[111] = 1198
				order[112] = 1199
				order[113] = 1200
				order[114] = 201
				order[115] = 2681
				order[116] = 2685
				order[117] = 1244
				order[118] = 1242
				order[119] = 2575
				order[120] = 2574
				order[121] = 997
				order[122] = 223
				order[123] = 207
				order[124] = 970
				order[125] = 971
				order[126] = 106
				order[127] = 348
				order[128] = 349
				order[129] = 2737
				order[130] = 2714
				order[131] = 2715
				order[132] = 2716
				order[133] = 107
				order[134] = 350
				order[135] = 351
				order[136] = 691
				order[137] = 667
				order[138] = 875
				order[139] = 876
				order[140] = 873
				order[141] = 874
				order[142] = 1687
				order[143] = 1787
				order[144] = 2141
				order[145] = 2142
				order[146] = 2143
				order[147] = 2752
				order[148] = 2144
				order[149] = 2145
				order[150] = 2576
				order[151] = 2962
				order[152] = 2602
				order[153] = 2603
				order[154] = 63
				order[155] = 271
				order[156] = 1500
				order[157] = 0
				super(146, 55, order)
			end

			class NoSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 455
					order[1] = 456
					order[2] = 2957
					order[3] = 0
					super(454, 455, order)
				end
			end

			class NoSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 1977
					order[1] = 1978
					order[2] = 1979
					order[3] = 2741
					order[4] = 0
					super(1976, 1977, order)
				end
			end

			class NoAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2305
					order[1] = 2306
					order[2] = 2307
					order[3] = 0
					super(2304, 2305, order)
				end
			end

			class NoEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 865
					order[1] = 866
					order[2] = 1145
					order[3] = 1827
					order[4] = 1826
					order[5] = 2340
					order[6] = 867
					order[7] = 868
					order[8] = 1578
					order[9] = 1579
					order[10] = 0
					super(864, 865, order)
				end
			end

			class NoInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 1019
					order[1] = 1050
					order[2] = 1051
					order[3] = 2378
					order[4] = 1052
					order[5] = 0
					super(1018, 1019, order)
				end

				class NoInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1053
						order[1] = 1054
						order[2] = 0
						super(1052, 1053, order)
					end
				end
			end

			class NoComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 1484
					order[1] = 2117
					order[2] = 2118
					order[3] = 2119
					order[4] = 1485
					order[5] = 2120
					order[6] = 2121
					order[7] = 2122
					order[8] = 2941
					order[9] = 1486
					order[10] = 2123
					order[11] = 1487
					order[12] = 1488
					order[13] = 1489
					order[14] = 1490
					order[15] = 1491
					order[16] = 2124
					order[17] = 2942
					order[18] = 2125
					order[19] = 2943
					order[20] = 2126
					order[21] = 2127
					order[22] = 2407
					order[23] = 2408
					order[24] = 2128
					order[25] = 2129
					order[26] = 2130
					order[27] = 2131
					order[28] = 2132
					order[29] = 41013
					order[30] = 41020
					order[31] = 41021
					order[32] = 41022
					order[33] = 41023
					order[34] = 41024
					order[35] = 41025
					order[36] = 41026
					order[37] = 41027
					order[38] = 41028
					order[39] = 41010
					order[40] = 2133
					order[41] = 2134
					order[42] = 2135
					order[43] = 2136
					order[44] = 2137
					order[45] = 41029
					order[46] = 40997
					order[47] = 2597
					order[48] = 2598
					order[49] = 2599
					order[50] = 2138
					order[51] = 2139
					order[52] = 0
					super(1483, 1484, order)
				end

				class NoComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 1492
						order[1] = 1493
						order[2] = 1494
						order[3] = 0
						super(1491, 1492, order)
					end

					class NoComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 1495
							order[1] = 1496
							order[2] = 0
							super(1494, 1495, order)
						end
					end
				end

				class NoComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41014
						order[1] = 41015
						order[2] = 41016
						order[3] = 41017
						order[4] = 0
						super(41013, 41014, order)
					end
				end

				class NoComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41019
						order[1] = 0
						super(41018, 41019, order)
					end
				end

				class NoComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41011
						order[1] = 41012
						order[2] = 41031
						order[3] = 41007
						order[4] = 40994
						order[5] = 0
						super(41010, 41011, order)
					end

					class NoComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41032
							order[1] = 41033
							order[2] = 41034
							order[3] = 41035
							order[4] = 41036
							order[5] = 0
							super(41031, 41032, order)
						end
					end

					class NoComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41008
							order[1] = 41009
							order[2] = 0
							super(41007, 41008, order)
						end
					end

					class NoComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40995
							order[1] = 40996
							order[2] = 0
							super(40994, 40995, order)
						end
					end
				end

				class NoComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41030
						order[1] = 0
						super(41029, 41030, order)
					end
				end

				class NoComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 40998
						order[1] = 40999
						order[2] = 41000
						order[3] = 41001
						order[4] = 41002
						order[5] = 41003
						order[6] = 41004
						order[7] = 41005
						order[8] = 0
						super(40997, 40998, order)
					end

					class NoComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41006
							order[1] = 0
							super(41005, 41006, order)
						end
					end
				end
			end

			class NoBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40471
					order[1] = 0
					super(40278, 40471, order)
				end
			end

			class NoPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41231
					order[1] = 0
					super(41230, 41231, order)
				end
			end

			class NoMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41093
					order[1] = 40991
					order[2] = 0
					super(41092, 41093, order)
				end
			end

			class NoMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41095
					order[1] = 40992
					order[2] = 0
					super(41094, 41095, order)
				end
			end

			class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41097
					order[1] = 41098
					order[2] = 41099
					order[3] = 41100
					order[4] = 41101
					order[5] = 41102
					order[6] = 41103
					order[7] = 41104
					order[8] = 41105
					order[9] = 0
					super(41096, 41097, order)
				end
			end

			class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42776
					order[1] = 0
					super(42775, 42776, order)
				end
			end

			class NoOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41117
					order[1] = 0
					super(41116, 41117, order)
				end
			end

			class NoOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41138
					order[1] = 41139
					order[2] = 0
					super(41137, 41138, order)
				end
			end

			class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41141
					order[1] = 0
					super(41140, 41141, order)
				end
			end

			class NoOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41153
					order[1] = 41154
					order[2] = 0
					super(41152, 41153, order)
				end
			end

			class NoStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40050
					order[1] = 41303
					order[2] = 40051
					order[3] = 42784
					order[4] = 42785
					order[5] = 40052
					order[6] = 40053
					order[7] = 41305
					order[8] = 40054
					order[9] = 40055
					order[10] = 42786
					order[11] = 42787
					order[12] = 41306
					order[13] = 41307
					order[14] = 41308
					order[15] = 41309
					order[16] = 41310
					order[17] = 41311
					order[18] = 41251
					order[19] = 41252
					order[20] = 41253
					order[21] = 41254
					order[22] = 41255
					order[23] = 41256
					order[24] = 41257
					order[25] = 42587
					order[26] = 41258
					order[27] = 41259
					order[28] = 41260
					order[29] = 41261
					order[30] = 41262
					order[31] = 41263
					order[32] = 41264
					order[33] = 41265
					order[34] = 41266
					order[35] = 41267
					order[36] = 41268
					order[37] = 41269
					order[38] = 41270
					order[39] = 41271
					order[40] = 41272
					order[41] = 41273
					order[42] = 41274
					order[43] = 41275
					order[44] = 41276
					order[45] = 40907
					order[46] = 40908
					order[47] = 40910
					order[48] = 40911
					order[49] = 40912
					order[50] = 40913
					order[51] = 40914
					order[52] = 40065
					order[53] = 40066
					order[54] = 40068
					order[55] = 40069
					order[56] = 40070
					order[57] = 40071
					order[58] = 40072
					order[59] = 41244
					order[60] = 41245
					order[61] = 40073
					order[62] = 40075
					order[63] = 40076
					order[64] = 40078
					order[65] = 40079
					order[66] = 40080
					order[67] = 40081
					order[68] = 40082
					order[69] = 40083
					order[70] = 40084
					order[71] = 41246
					order[72] = 41247
					order[73] = 41248
					order[74] = 40738
					order[75] = 40739
					order[76] = 40740
					order[77] = 42600
					order[78] = 40741
					order[79] = 40742
					order[80] = 43106
					order[81] = 40743
					order[82] = 40744
					order[83] = 40745
					order[84] = 40746
					order[85] = 40747
					order[86] = 42601
					order[87] = 42602
					order[88] = 42603
					order[89] = 42604
					order[90] = 40748
					order[91] = 40749
					order[92] = 40750
					order[93] = 41180
					order[94] = 41181
					order[95] = 41182
					order[96] = 41183
					order[97] = 41184
					order[98] = 41185
					order[99] = 41186
					order[100] = 42605
					order[101] = 40828
					order[102] = 40872
					order[103] = 41058
					order[104] = 41059
					order[105] = 41060
					order[106] = 41061
					order[107] = 41062
					order[108] = 42192
					order[109] = 42193
					order[110] = 41063
					order[111] = 41064
					order[112] = 41065
					order[113] = 41066
					order[114] = 41067
					order[115] = 41218
					order[116] = 41068
					order[117] = 41069
					order[118] = 41070
					order[119] = 41071
					order[120] = 41072
					order[121] = 41073
					order[122] = 41074
					order[123] = 41075
					order[124] = 41076
					order[125] = 41077
					order[126] = 41078
					order[127] = 41079
					order[128] = 41080
					order[129] = 43094
					order[130] = 41037
					order[131] = 40056
					order[132] = 40982
					order[133] = 40983
					order[134] = 0
					super(40049, 40050, order)
				end

				class NoStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41278
						order[1] = 41279
						order[2] = 0
						super(41277, 41278, order)
					end
				end

				class NoStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41238
						order[1] = 41239
						order[2] = 41240
						order[3] = 0
						super(41237, 41238, order)
					end
				end

				class NoStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41281
						order[1] = 41282
						order[2] = 0
						super(41280, 41281, order)
					end
				end

				class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41250
						order[1] = 0
						super(41249, 41250, order)
					end
				end

				class NoStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41290
						order[1] = 41291
						order[2] = 41292
						order[3] = 41293
						order[4] = 41294
						order[5] = 41295
						order[6] = 41296
						order[7] = 41297
						order[8] = 41298
						order[9] = 41299
						order[10] = 41300
						order[11] = 41283
						order[12] = 41301
						order[13] = 41302
						order[14] = 0
						super(41289, 41290, order)
					end

					class NoStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41284
							order[1] = 41285
							order[2] = 41286
							order[3] = 0
							super(41283, 41284, order)
						end

						class NoStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41287
								order[1] = 41288
								order[2] = 41588
								order[3] = 0
								super(41286, 41287, order)
							end
						end
					end
				end

				class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40909
						order[1] = 0
						super(40960, 40909, order)
					end
				end

				class NoStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40067
						order[1] = 0
						super(40961, 40067, order)
					end
				end

				class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40074
						order[1] = 0
						super(40958, 40074, order)
					end
				end

				class NoStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41242
						order[1] = 41243
						order[2] = 0
						super(41241, 41242, order)
					end
				end

				class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40077
						order[1] = 0
						super(40959, 40077, order)
					end
				end

				class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40752
						order[1] = 0
						super(40947, 40752, order)
					end
				end

				class NoPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41221
						order[1] = 41222
						order[2] = 0
						super(41220, 41221, order)
					end
				end

				class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40763
						order[1] = 0
						super(40948, 40763, order)
					end
				end

				class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40769
						order[1] = 0
						super(40949, 40769, order)
					end
				end

				class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40776
						order[1] = 0
						super(40950, 40776, order)
					end
				end

				class NoPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42661
						order[1] = 42662
						order[2] = 0
						super(42660, 42661, order)
					end
				end

				class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41193
						order[1] = 0
						super(41192, 41193, order)
					end
				end

				class NoPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41228
						order[1] = 41229
						order[2] = 0
						super(41227, 41228, order)
					end
				end

				class NoPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41225
						order[1] = 41226
						order[2] = 0
						super(41224, 41225, order)
					end
				end

				class NoPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43109
						order[1] = 42684
						order[2] = 42685
						order[3] = 0
						super(42683, 43109, order)
					end
				end

				class NoDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42275
						order[1] = 42276
						order[2] = 42277
						order[3] = 42278
						order[4] = 42279
						order[5] = 42280
						order[6] = 42294
						order[7] = 42281
						order[8] = 42282
						order[9] = 42283
						order[10] = 42284
						order[11] = 42285
						order[12] = 42286
						order[13] = 42287
						order[14] = 42288
						order[15] = 42289
						order[16] = 42290
						order[17] = 42291
						order[18] = 42292
						order[19] = 42293
						order[20] = 0
						super(42274, 42275, order)
					end

					class NoDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42295
							order[1] = 0
							super(42294, 42295, order)
						end
					end
				end

				class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42273
						order[1] = 0
						super(42272, 42273, order)
					end
				end

				class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42237
						order[1] = 0
						super(42236, 42237, order)
					end
				end

				class NoReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 42736
						order[1] = 42737
						order[2] = 42738
						order[3] = 42739
						order[4] = 42740
						order[5] = 42741
						order[6] = 42765
						order[7] = 42731
						order[8] = 42742
						order[9] = 42743
						order[10] = 42744
						order[11] = 42745
						order[12] = 42746
						order[13] = 42747
						order[14] = 42748
						order[15] = 42749
						order[16] = 42750
						order[17] = 42751
						order[18] = 42752
						order[19] = 42753
						order[20] = 42761
						order[21] = 42754
						order[22] = 42755
						order[23] = 42709
						order[24] = 42756
						order[25] = 42757
						order[26] = 42758
						order[27] = 42759
						order[28] = 42760
						order[29] = 0
						super(42735, 42736, order)
					end

					class NoReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 42766
							order[1] = 42767
							order[2] = 42768
							order[3] = 42769
							order[4] = 0
							super(42765, 42766, order)
						end
					end

					class NoReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42732
							order[1] = 42733
							order[2] = 42734
							order[3] = 0
							super(42731, 42732, order)
						end
					end

					class NoReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42762
							order[1] = 42763
							order[2] = 42764
							order[3] = 0
							super(42761, 42762, order)
						end
					end

					class NoReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 42710
							order[1] = 42772
							order[2] = 42711
							order[3] = 42712
							order[4] = 42713
							order[5] = 42714
							order[6] = 42715
							order[7] = 42716
							order[8] = 42717
							order[9] = 42718
							order[10] = 42719
							order[11] = 42720
							order[12] = 42721
							order[13] = 42722
							order[14] = 42723
							order[15] = 42724
							order[16] = 42725
							order[17] = 42726
							order[18] = 42727
							order[19] = 42728
							order[20] = 42729
							order[21] = 42730
							order[22] = 42770
							order[23] = 0
							super(42709, 42710, order)
						end

						class NoReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 42773
								order[1] = 42774
								order[2] = 0
								super(42772, 42773, order)
							end
						end

						class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 42771
								order[1] = 0
								super(42770, 42771, order)
							end
						end
					end
				end

				class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42621
						order[1] = 0
						super(42620, 42621, order)
					end
				end

				class NoPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42607
						order[1] = 42608
						order[2] = 0
						super(42606, 42607, order)
					end
				end

				class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40819
						order[1] = 0
						super(40946, 40819, order)
					end
				end

				class NoNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40826
						order[1] = 40827
						order[2] = 0
						super(40825, 40826, order)
					end
				end

				class NoSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40086
						order[1] = 40373
						order[2] = 40655
						order[3] = 40088
						order[4] = 40089
						order[5] = 0
						super(40085, 40086, order)
					end
				end

				class NoPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40829
						order[1] = 41164
						order[2] = 41165
						order[3] = 40830
						order[4] = 40831
						order[5] = 40832
						order[6] = 40833
						order[7] = 40834
						order[8] = 40835
						order[9] = 40836
						order[10] = 40837
						order[11] = 40838
						order[12] = 40839
						order[13] = 41166
						order[14] = 41167
						order[15] = 41168
						order[16] = 41169
						order[17] = 40840
						order[18] = 40841
						order[19] = 40842
						order[20] = 40843
						order[21] = 41170
						order[22] = 41171
						order[23] = 41172
						order[24] = 41173
						order[25] = 40844
						order[26] = 40845
						order[27] = 40846
						order[28] = 40847
						order[29] = 40848
						order[30] = 40849
						order[31] = 40868
						order[32] = 40850
						order[33] = 40851
						order[34] = 40852
						order[35] = 40853
						order[36] = 40977
						order[37] = 40855
						order[38] = 40856
						order[39] = 40857
						order[40] = 41174
						order[41] = 41175
						order[42] = 40858
						order[43] = 41161
						order[44] = 41176
						order[45] = 41177
						order[46] = 41178
						order[47] = 41179
						order[48] = 40859
						order[49] = 40860
						order[50] = 40861
						order[51] = 40862
						order[52] = 40945
						order[53] = 40864
						order[54] = 40865
						order[55] = 40866
						order[56] = 40867
						order[57] = 0
						super(40828, 40829, order)
					end

					class NoPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40869
							order[1] = 40870
							order[2] = 40871
							order[3] = 0
							super(40868, 40869, order)
						end
					end

					class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40854
							order[1] = 0
							super(40977, 40854, order)
						end
					end

					class NoPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41162
							order[1] = 41163
							order[2] = 0
							super(41161, 41162, order)
						end
					end

					class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40863
							order[1] = 0
							super(40945, 40863, order)
						end
					end
				end

				class NoPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40873
						order[1] = 40874
						order[2] = 42698
						order[3] = 42699
						order[4] = 42700
						order[5] = 42701
						order[6] = 42702
						order[7] = 42703
						order[8] = 42704
						order[9] = 42689
						order[10] = 42690
						order[11] = 42691
						order[12] = 42692
						order[13] = 42693
						order[14] = 42694
						order[15] = 42695
						order[16] = 40875
						order[17] = 40876
						order[18] = 40877
						order[19] = 40878
						order[20] = 40879
						order[21] = 40880
						order[22] = 40881
						order[23] = 40882
						order[24] = 40883
						order[25] = 40884
						order[26] = 40885
						order[27] = 40886
						order[28] = 40887
						order[29] = 40888
						order[30] = 40889
						order[31] = 40890
						order[32] = 40891
						order[33] = 40892
						order[34] = 40893
						order[35] = 40894
						order[36] = 40895
						order[37] = 40896
						order[38] = 40897
						order[39] = 40898
						order[40] = 40899
						order[41] = 40900
						order[42] = 40901
						order[43] = 0
						super(40872, 40873, order)
					end

					class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42706
							order[1] = 0
							super(42705, 42706, order)
						end
					end

					class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42697
							order[1] = 0
							super(42696, 42697, order)
						end
					end
				end

				class NoDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41086
						order[1] = 0
						super(41085, 41086, order)
					end
				end

				class NoDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41082
						order[1] = 41083
						order[2] = 41084
						order[3] = 0
						super(41081, 41082, order)
					end
				end

				class NoDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41038
						order[1] = 41039
						order[2] = 41040
						order[3] = 41041
						order[4] = 41042
						order[5] = 41043
						order[6] = 41044
						order[7] = 41045
						order[8] = 41046
						order[9] = 41047
						order[10] = 41048
						order[11] = 41049
						order[12] = 41050
						order[13] = 41051
						order[14] = 0
						super(41037, 41038, order)
					end

					class NoDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41052
							order[1] = 41053
							order[2] = 41054
							order[3] = 0
							super(41051, 41052, order)
						end

						class NoDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41055
								order[1] = 41056
								order[2] = 41057
								order[3] = 0
								super(41054, 41055, order)
							end
						end
					end
				end
			end

			class NoProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 40091
					order[1] = 40092
					order[2] = 40093
					order[3] = 40957
					order[4] = 40095
					order[5] = 40096
					order[6] = 40097
					order[7] = 42707
					order[8] = 42708
					order[9] = 40098
					order[10] = 40099
					order[11] = 40100
					order[12] = 40114
					order[13] = 40115
					order[14] = 40116
					order[15] = 40118
					order[16] = 40119
					order[17] = 40120
					order[18] = 40121
					order[19] = 40122
					order[20] = 40123
					order[21] = 40125
					order[22] = 40126
					order[23] = 40127
					order[24] = 40128
					order[25] = 40129
					order[26] = 40130
					order[27] = 40131
					order[28] = 40132
					order[29] = 40133
					order[30] = 40134
					order[31] = 40135
					order[32] = 40136
					order[33] = 40137
					order[34] = 40138
					order[35] = 40139
					order[36] = 40140
					order[37] = 40141
					order[38] = 40145
					order[39] = 40146
					order[40] = 40148
					order[41] = 40149
					order[42] = 40150
					order[43] = 40151
					order[44] = 40152
					order[45] = 40153
					order[46] = 40154
					order[47] = 40155
					order[48] = 40156
					order[49] = 40158
					order[50] = 40159
					order[51] = 40160
					order[52] = 40161
					order[53] = 40162
					order[54] = 40101
					order[55] = 40102
					order[56] = 40103
					order[57] = 40104
					order[58] = 40105
					order[59] = 40106
					order[60] = 40107
					order[61] = 40163
					order[62] = 40165
					order[63] = 40166
					order[64] = 40167
					order[65] = 40168
					order[66] = 40169
					order[67] = 40170
					order[68] = 40108
					order[69] = 40109
					order[70] = 40110
					order[71] = 40111
					order[72] = 40112
					order[73] = 41406
					order[74] = 40113
					order[75] = 40986
					order[76] = 40987
					order[77] = 40174
					order[78] = 0
					super(40090, 40091, order)
				end

				class NoProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40094
						order[1] = 0
						super(40957, 40094, order)
					end
				end

				class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40117
						order[1] = 0
						super(40953, 40117, order)
					end
				end

				class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40124
						order[1] = 0
						super(40954, 40124, order)
					end
				end

				class NoProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40143
						order[1] = 40144
						order[2] = 0
						super(40142, 40143, order)
					end
				end

				class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40147
						order[1] = 0
						super(40955, 40147, order)
					end
				end

				class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40157
						order[1] = 0
						super(40956, 40157, order)
					end
				end

				class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40164
						order[1] = 0
						super(40952, 40164, order)
					end
				end

				class NoProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40172
						order[1] = 40173
						order[2] = 0
						super(40171, 40172, order)
					end
				end

				class NoProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40175
						order[1] = 40176
						order[2] = 40177
						order[3] = 2385
						order[4] = 40178
						order[5] = 0
						super(40174, 40175, order)
					end

					class NoProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40179
							order[1] = 40180
							order[2] = 0
							super(40178, 40179, order)
						end
					end
				end
			end

			class NoAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40020
					order[1] = 40021
					order[2] = 40000
					order[3] = 0
					super(40019, 40020, order)
				end

				class NoAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 40001
						order[1] = 40002
						order[2] = 40003
						order[3] = 40004
						order[4] = 40005
						order[5] = 40006
						order[6] = 40007
						order[7] = 40008
						order[8] = 40009
						order[9] = 40010
						order[10] = 40011
						order[11] = 40012
						order[12] = 40013
						order[13] = 40014
						order[14] = 40015
						order[15] = 40016
						order[16] = 40017
						order[17] = 40018
						order[18] = 0
						super(40000, 40001, order)
					end
				end
			end

			class NoProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 40182
					order[1] = 40183
					order[2] = 40184
					order[3] = 40185
					order[4] = 40186
					order[5] = 40187
					order[6] = 40188
					order[7] = 40951
					order[8] = 40191
					order[9] = 40201
					order[10] = 40190
					order[11] = 0
					super(40181, 40182, order)
				end

				class NoProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40189
						order[1] = 0
						super(40951, 40189, order)
					end
				end

				class NoProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 40192
						order[1] = 40193
						order[2] = 40194
						order[3] = 40195
						order[4] = 40196
						order[5] = 40197
						order[6] = 40198
						order[7] = 40199
						order[8] = 0
						super(40191, 40192, order)
					end

					class NoProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40200
							order[1] = 0
							super(40199, 40200, order)
						end
					end
				end

				class NoProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40202
						order[1] = 40203
						order[2] = 0
						super(40201, 40202, order)
					end
				end
			end

			class NoCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 40023
					order[1] = 40024
					order[2] = 40916
					order[3] = 40917
					order[4] = 40025
					order[5] = 40026
					order[6] = 40027
					order[7] = 40028
					order[8] = 40029
					order[9] = 40030
					order[10] = 40031
					order[11] = 40277
					order[12] = 42216
					order[13] = 42217
					order[14] = 40033
					order[15] = 40034
					order[16] = 42207
					order[17] = 42208
					order[18] = 42209
					order[19] = 42210
					order[20] = 42211
					order[21] = 42212
					order[22] = 42213
					order[23] = 40035
					order[24] = 40036
					order[25] = 40037
					order[26] = 40038
					order[27] = 40039
					order[28] = 0
					super(40022, 40023, order)
				end

				class NoCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40032
						order[1] = 0
						super(40277, 40032, order)
					end
				end

				class NoCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42215
						order[1] = 0
						super(42214, 42215, order)
					end
				end
			end

			class NoPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40209
					order[1] = 40205
					order[2] = 40206
					order[3] = 40207
					order[4] = 40208
					order[5] = 0
					super(40204, 40209, order)
				end

				class NoPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40210
						order[1] = 40211
						order[2] = 0
						super(40209, 40210, order)
					end
				end
			end

			class NoExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42297
					order[1] = 42298
					order[2] = 0
					super(42296, 42297, order)
				end
			end
		end
	end
end

class StreamAssignmentReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CD") )
	end

	class NoAsgnReqs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 453
			order[1] = 146
			order[2] = 0
			super(1499, 453, order)
		end

		class NoPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 448
				order[1] = 447
				order[2] = 452
				order[3] = 2376
				order[4] = 802
				order[5] = 0
				super(453, 448, order)
			end

			class NoPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 523
					order[1] = 803
					order[2] = 0
					super(802, 523, order)
				end
			end
		end

		class NoRelatedSym < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(162)
				order[0] = 55
				order[1] = 65
				order[2] = 48
				order[3] = 22
				order[4] = 460
				order[5] = 1227
				order[6] = 1151
				order[7] = 461
				order[8] = 2891
				order[9] = 167
				order[10] = 762
				order[11] = 200
				order[12] = 541
				order[13] = 1079
				order[14] = 966
				order[15] = 1049
				order[16] = 965
				order[17] = 224
				order[18] = 1449
				order[19] = 1450
				order[20] = 1451
				order[21] = 1452
				order[22] = 1457
				order[23] = 1458
				order[24] = 1739
				order[25] = 2210
				order[26] = 1938
				order[27] = 1939
				order[28] = 1940
				order[29] = 2735
				order[30] = 1941
				order[31] = 1575
				order[32] = 1942
				order[33] = 1943
				order[34] = 1944
				order[35] = 1945
				order[36] = 1946
				order[37] = 1947
				order[38] = 1948
				order[39] = 1949
				order[40] = 1950
				order[41] = 2879
				order[42] = 1951
				order[43] = 1952
				order[44] = 1953
				order[45] = 1954
				order[46] = 1955
				order[47] = 1956
				order[48] = 1957
				order[49] = 1958
				order[50] = 1959
				order[51] = 1960
				order[52] = 1577
				order[53] = 1580
				order[54] = 1581
				order[55] = 1678
				order[56] = 1697
				order[57] = 225
				order[58] = 239
				order[59] = 226
				order[60] = 227
				order[61] = 228
				order[62] = 255
				order[63] = 543
				order[64] = 470
				order[65] = 471
				order[66] = 472
				order[67] = 240
				order[68] = 202
				order[69] = 2578
				order[70] = 2577
				order[71] = 947
				order[72] = 2904
				order[73] = 967
				order[74] = 968
				order[75] = 1698
				order[76] = 1866
				order[77] = 2600
				order[78] = 2001
				order[79] = 2601
				order[80] = 1478
				order[81] = 1479
				order[82] = 1480
				order[83] = 1481
				order[84] = 206
				order[85] = 231
				order[86] = 1435
				order[87] = 2353
				order[88] = 1439
				order[89] = 969
				order[90] = 1146
				order[91] = 996
				order[92] = 1147
				order[93] = 1716
				order[94] = 2905
				order[95] = 1191
				order[96] = 1192
				order[97] = 1717
				order[98] = 2906
				order[99] = 1193
				order[100] = 2579
				order[101] = 1194
				order[102] = 1482
				order[103] = 1195
				order[104] = 2753
				order[105] = 1196
				order[106] = 1197
				order[107] = 2002
				order[108] = 2140
				order[109] = 1524
				order[110] = 2907
				order[111] = 1198
				order[112] = 1199
				order[113] = 1200
				order[114] = 201
				order[115] = 2681
				order[116] = 2685
				order[117] = 1244
				order[118] = 1242
				order[119] = 2575
				order[120] = 2574
				order[121] = 997
				order[122] = 223
				order[123] = 207
				order[124] = 970
				order[125] = 971
				order[126] = 106
				order[127] = 348
				order[128] = 349
				order[129] = 2737
				order[130] = 2714
				order[131] = 2715
				order[132] = 2716
				order[133] = 107
				order[134] = 350
				order[135] = 351
				order[136] = 691
				order[137] = 667
				order[138] = 875
				order[139] = 876
				order[140] = 873
				order[141] = 874
				order[142] = 1687
				order[143] = 1787
				order[144] = 2141
				order[145] = 2142
				order[146] = 2143
				order[147] = 2752
				order[148] = 2144
				order[149] = 2145
				order[150] = 2576
				order[151] = 2962
				order[152] = 2602
				order[153] = 2603
				order[154] = 63
				order[155] = 1617
				order[156] = 1500
				order[157] = 1502
				order[158] = 58
				order[159] = 354
				order[160] = 355
				order[161] = 0
				super(146, 55, order)
			end

			class NoSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 455
					order[1] = 456
					order[2] = 2957
					order[3] = 0
					super(454, 455, order)
				end
			end

			class NoSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 1977
					order[1] = 1978
					order[2] = 1979
					order[3] = 2741
					order[4] = 0
					super(1976, 1977, order)
				end
			end

			class NoAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2305
					order[1] = 2306
					order[2] = 2307
					order[3] = 0
					super(2304, 2305, order)
				end
			end

			class NoEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 865
					order[1] = 866
					order[2] = 1145
					order[3] = 1827
					order[4] = 1826
					order[5] = 2340
					order[6] = 867
					order[7] = 868
					order[8] = 1578
					order[9] = 1579
					order[10] = 0
					super(864, 865, order)
				end
			end

			class NoInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 1019
					order[1] = 1050
					order[2] = 1051
					order[3] = 2378
					order[4] = 1052
					order[5] = 0
					super(1018, 1019, order)
				end

				class NoInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1053
						order[1] = 1054
						order[2] = 0
						super(1052, 1053, order)
					end
				end
			end

			class NoComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 1484
					order[1] = 2117
					order[2] = 2118
					order[3] = 2119
					order[4] = 1485
					order[5] = 2120
					order[6] = 2121
					order[7] = 2122
					order[8] = 2941
					order[9] = 1486
					order[10] = 2123
					order[11] = 1487
					order[12] = 1488
					order[13] = 1489
					order[14] = 1490
					order[15] = 1491
					order[16] = 2124
					order[17] = 2942
					order[18] = 2125
					order[19] = 2943
					order[20] = 2126
					order[21] = 2127
					order[22] = 2407
					order[23] = 2408
					order[24] = 2128
					order[25] = 2129
					order[26] = 2130
					order[27] = 2131
					order[28] = 2132
					order[29] = 41013
					order[30] = 41020
					order[31] = 41021
					order[32] = 41022
					order[33] = 41023
					order[34] = 41024
					order[35] = 41025
					order[36] = 41026
					order[37] = 41027
					order[38] = 41028
					order[39] = 41010
					order[40] = 2133
					order[41] = 2134
					order[42] = 2135
					order[43] = 2136
					order[44] = 2137
					order[45] = 41029
					order[46] = 40997
					order[47] = 2597
					order[48] = 2598
					order[49] = 2599
					order[50] = 2138
					order[51] = 2139
					order[52] = 0
					super(1483, 1484, order)
				end

				class NoComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 1492
						order[1] = 1493
						order[2] = 1494
						order[3] = 0
						super(1491, 1492, order)
					end

					class NoComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 1495
							order[1] = 1496
							order[2] = 0
							super(1494, 1495, order)
						end
					end
				end

				class NoComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41014
						order[1] = 41015
						order[2] = 41016
						order[3] = 41017
						order[4] = 0
						super(41013, 41014, order)
					end
				end

				class NoComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41019
						order[1] = 0
						super(41018, 41019, order)
					end
				end

				class NoComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41011
						order[1] = 41012
						order[2] = 41031
						order[3] = 41007
						order[4] = 40994
						order[5] = 0
						super(41010, 41011, order)
					end

					class NoComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41032
							order[1] = 41033
							order[2] = 41034
							order[3] = 41035
							order[4] = 41036
							order[5] = 0
							super(41031, 41032, order)
						end
					end

					class NoComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41008
							order[1] = 41009
							order[2] = 0
							super(41007, 41008, order)
						end
					end

					class NoComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40995
							order[1] = 40996
							order[2] = 0
							super(40994, 40995, order)
						end
					end
				end

				class NoComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41030
						order[1] = 0
						super(41029, 41030, order)
					end
				end

				class NoComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 40998
						order[1] = 40999
						order[2] = 41000
						order[3] = 41001
						order[4] = 41002
						order[5] = 41003
						order[6] = 41004
						order[7] = 41005
						order[8] = 0
						super(40997, 40998, order)
					end

					class NoComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41006
							order[1] = 0
							super(41005, 41006, order)
						end
					end
				end
			end

			class NoBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40471
					order[1] = 0
					super(40278, 40471, order)
				end
			end

			class NoPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41231
					order[1] = 0
					super(41230, 41231, order)
				end
			end

			class NoMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41093
					order[1] = 40991
					order[2] = 0
					super(41092, 41093, order)
				end
			end

			class NoMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41095
					order[1] = 40992
					order[2] = 0
					super(41094, 41095, order)
				end
			end

			class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41097
					order[1] = 41098
					order[2] = 41099
					order[3] = 41100
					order[4] = 41101
					order[5] = 41102
					order[6] = 41103
					order[7] = 41104
					order[8] = 41105
					order[9] = 0
					super(41096, 41097, order)
				end
			end

			class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42776
					order[1] = 0
					super(42775, 42776, order)
				end
			end

			class NoOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41117
					order[1] = 0
					super(41116, 41117, order)
				end
			end

			class NoOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41138
					order[1] = 41139
					order[2] = 0
					super(41137, 41138, order)
				end
			end

			class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41141
					order[1] = 0
					super(41140, 41141, order)
				end
			end

			class NoOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41153
					order[1] = 41154
					order[2] = 0
					super(41152, 41153, order)
				end
			end

			class NoStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40050
					order[1] = 41303
					order[2] = 40051
					order[3] = 42784
					order[4] = 42785
					order[5] = 40052
					order[6] = 40053
					order[7] = 41305
					order[8] = 40054
					order[9] = 40055
					order[10] = 42786
					order[11] = 42787
					order[12] = 41306
					order[13] = 41307
					order[14] = 41308
					order[15] = 41309
					order[16] = 41310
					order[17] = 41311
					order[18] = 41251
					order[19] = 41252
					order[20] = 41253
					order[21] = 41254
					order[22] = 41255
					order[23] = 41256
					order[24] = 41257
					order[25] = 42587
					order[26] = 41258
					order[27] = 41259
					order[28] = 41260
					order[29] = 41261
					order[30] = 41262
					order[31] = 41263
					order[32] = 41264
					order[33] = 41265
					order[34] = 41266
					order[35] = 41267
					order[36] = 41268
					order[37] = 41269
					order[38] = 41270
					order[39] = 41271
					order[40] = 41272
					order[41] = 41273
					order[42] = 41274
					order[43] = 41275
					order[44] = 41276
					order[45] = 40907
					order[46] = 40908
					order[47] = 40910
					order[48] = 40911
					order[49] = 40912
					order[50] = 40913
					order[51] = 40914
					order[52] = 40065
					order[53] = 40066
					order[54] = 40068
					order[55] = 40069
					order[56] = 40070
					order[57] = 40071
					order[58] = 40072
					order[59] = 41244
					order[60] = 41245
					order[61] = 40073
					order[62] = 40075
					order[63] = 40076
					order[64] = 40078
					order[65] = 40079
					order[66] = 40080
					order[67] = 40081
					order[68] = 40082
					order[69] = 40083
					order[70] = 40084
					order[71] = 41246
					order[72] = 41247
					order[73] = 41248
					order[74] = 40738
					order[75] = 40739
					order[76] = 40740
					order[77] = 42600
					order[78] = 40741
					order[79] = 40742
					order[80] = 43106
					order[81] = 40743
					order[82] = 40744
					order[83] = 40745
					order[84] = 40746
					order[85] = 40747
					order[86] = 42601
					order[87] = 42602
					order[88] = 42603
					order[89] = 42604
					order[90] = 40748
					order[91] = 40749
					order[92] = 40750
					order[93] = 41180
					order[94] = 41181
					order[95] = 41182
					order[96] = 41183
					order[97] = 41184
					order[98] = 41185
					order[99] = 41186
					order[100] = 42605
					order[101] = 40828
					order[102] = 40872
					order[103] = 41058
					order[104] = 41059
					order[105] = 41060
					order[106] = 41061
					order[107] = 41062
					order[108] = 42192
					order[109] = 42193
					order[110] = 41063
					order[111] = 41064
					order[112] = 41065
					order[113] = 41066
					order[114] = 41067
					order[115] = 41218
					order[116] = 41068
					order[117] = 41069
					order[118] = 41070
					order[119] = 41071
					order[120] = 41072
					order[121] = 41073
					order[122] = 41074
					order[123] = 41075
					order[124] = 41076
					order[125] = 41077
					order[126] = 41078
					order[127] = 41079
					order[128] = 41080
					order[129] = 43094
					order[130] = 41037
					order[131] = 40056
					order[132] = 40982
					order[133] = 40983
					order[134] = 0
					super(40049, 40050, order)
				end

				class NoStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41278
						order[1] = 41279
						order[2] = 0
						super(41277, 41278, order)
					end
				end

				class NoStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41238
						order[1] = 41239
						order[2] = 41240
						order[3] = 0
						super(41237, 41238, order)
					end
				end

				class NoStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41281
						order[1] = 41282
						order[2] = 0
						super(41280, 41281, order)
					end
				end

				class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41250
						order[1] = 0
						super(41249, 41250, order)
					end
				end

				class NoStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41290
						order[1] = 41291
						order[2] = 41292
						order[3] = 41293
						order[4] = 41294
						order[5] = 41295
						order[6] = 41296
						order[7] = 41297
						order[8] = 41298
						order[9] = 41299
						order[10] = 41300
						order[11] = 41283
						order[12] = 41301
						order[13] = 41302
						order[14] = 0
						super(41289, 41290, order)
					end

					class NoStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41284
							order[1] = 41285
							order[2] = 41286
							order[3] = 0
							super(41283, 41284, order)
						end

						class NoStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41287
								order[1] = 41288
								order[2] = 41588
								order[3] = 0
								super(41286, 41287, order)
							end
						end
					end
				end

				class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40909
						order[1] = 0
						super(40960, 40909, order)
					end
				end

				class NoStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40067
						order[1] = 0
						super(40961, 40067, order)
					end
				end

				class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40074
						order[1] = 0
						super(40958, 40074, order)
					end
				end

				class NoStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41242
						order[1] = 41243
						order[2] = 0
						super(41241, 41242, order)
					end
				end

				class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40077
						order[1] = 0
						super(40959, 40077, order)
					end
				end

				class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40752
						order[1] = 0
						super(40947, 40752, order)
					end
				end

				class NoPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41221
						order[1] = 41222
						order[2] = 0
						super(41220, 41221, order)
					end
				end

				class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40763
						order[1] = 0
						super(40948, 40763, order)
					end
				end

				class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40769
						order[1] = 0
						super(40949, 40769, order)
					end
				end

				class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40776
						order[1] = 0
						super(40950, 40776, order)
					end
				end

				class NoPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42661
						order[1] = 42662
						order[2] = 0
						super(42660, 42661, order)
					end
				end

				class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41193
						order[1] = 0
						super(41192, 41193, order)
					end
				end

				class NoPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41228
						order[1] = 41229
						order[2] = 0
						super(41227, 41228, order)
					end
				end

				class NoPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41225
						order[1] = 41226
						order[2] = 0
						super(41224, 41225, order)
					end
				end

				class NoPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43109
						order[1] = 42684
						order[2] = 42685
						order[3] = 0
						super(42683, 43109, order)
					end
				end

				class NoDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42275
						order[1] = 42276
						order[2] = 42277
						order[3] = 42278
						order[4] = 42279
						order[5] = 42280
						order[6] = 42294
						order[7] = 42281
						order[8] = 42282
						order[9] = 42283
						order[10] = 42284
						order[11] = 42285
						order[12] = 42286
						order[13] = 42287
						order[14] = 42288
						order[15] = 42289
						order[16] = 42290
						order[17] = 42291
						order[18] = 42292
						order[19] = 42293
						order[20] = 0
						super(42274, 42275, order)
					end

					class NoDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42295
							order[1] = 0
							super(42294, 42295, order)
						end
					end
				end

				class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42273
						order[1] = 0
						super(42272, 42273, order)
					end
				end

				class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42237
						order[1] = 0
						super(42236, 42237, order)
					end
				end

				class NoReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 42736
						order[1] = 42737
						order[2] = 42738
						order[3] = 42739
						order[4] = 42740
						order[5] = 42741
						order[6] = 42765
						order[7] = 42731
						order[8] = 42742
						order[9] = 42743
						order[10] = 42744
						order[11] = 42745
						order[12] = 42746
						order[13] = 42747
						order[14] = 42748
						order[15] = 42749
						order[16] = 42750
						order[17] = 42751
						order[18] = 42752
						order[19] = 42753
						order[20] = 42761
						order[21] = 42754
						order[22] = 42755
						order[23] = 42709
						order[24] = 42756
						order[25] = 42757
						order[26] = 42758
						order[27] = 42759
						order[28] = 42760
						order[29] = 0
						super(42735, 42736, order)
					end

					class NoReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 42766
							order[1] = 42767
							order[2] = 42768
							order[3] = 42769
							order[4] = 0
							super(42765, 42766, order)
						end
					end

					class NoReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42732
							order[1] = 42733
							order[2] = 42734
							order[3] = 0
							super(42731, 42732, order)
						end
					end

					class NoReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42762
							order[1] = 42763
							order[2] = 42764
							order[3] = 0
							super(42761, 42762, order)
						end
					end

					class NoReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 42710
							order[1] = 42772
							order[2] = 42711
							order[3] = 42712
							order[4] = 42713
							order[5] = 42714
							order[6] = 42715
							order[7] = 42716
							order[8] = 42717
							order[9] = 42718
							order[10] = 42719
							order[11] = 42720
							order[12] = 42721
							order[13] = 42722
							order[14] = 42723
							order[15] = 42724
							order[16] = 42725
							order[17] = 42726
							order[18] = 42727
							order[19] = 42728
							order[20] = 42729
							order[21] = 42730
							order[22] = 42770
							order[23] = 0
							super(42709, 42710, order)
						end

						class NoReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 42773
								order[1] = 42774
								order[2] = 0
								super(42772, 42773, order)
							end
						end

						class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 42771
								order[1] = 0
								super(42770, 42771, order)
							end
						end
					end
				end

				class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42621
						order[1] = 0
						super(42620, 42621, order)
					end
				end

				class NoPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42607
						order[1] = 42608
						order[2] = 0
						super(42606, 42607, order)
					end
				end

				class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40819
						order[1] = 0
						super(40946, 40819, order)
					end
				end

				class NoNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40826
						order[1] = 40827
						order[2] = 0
						super(40825, 40826, order)
					end
				end

				class NoSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40086
						order[1] = 40373
						order[2] = 40655
						order[3] = 40088
						order[4] = 40089
						order[5] = 0
						super(40085, 40086, order)
					end
				end

				class NoPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40829
						order[1] = 41164
						order[2] = 41165
						order[3] = 40830
						order[4] = 40831
						order[5] = 40832
						order[6] = 40833
						order[7] = 40834
						order[8] = 40835
						order[9] = 40836
						order[10] = 40837
						order[11] = 40838
						order[12] = 40839
						order[13] = 41166
						order[14] = 41167
						order[15] = 41168
						order[16] = 41169
						order[17] = 40840
						order[18] = 40841
						order[19] = 40842
						order[20] = 40843
						order[21] = 41170
						order[22] = 41171
						order[23] = 41172
						order[24] = 41173
						order[25] = 40844
						order[26] = 40845
						order[27] = 40846
						order[28] = 40847
						order[29] = 40848
						order[30] = 40849
						order[31] = 40868
						order[32] = 40850
						order[33] = 40851
						order[34] = 40852
						order[35] = 40853
						order[36] = 40977
						order[37] = 40855
						order[38] = 40856
						order[39] = 40857
						order[40] = 41174
						order[41] = 41175
						order[42] = 40858
						order[43] = 41161
						order[44] = 41176
						order[45] = 41177
						order[46] = 41178
						order[47] = 41179
						order[48] = 40859
						order[49] = 40860
						order[50] = 40861
						order[51] = 40862
						order[52] = 40945
						order[53] = 40864
						order[54] = 40865
						order[55] = 40866
						order[56] = 40867
						order[57] = 0
						super(40828, 40829, order)
					end

					class NoPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40869
							order[1] = 40870
							order[2] = 40871
							order[3] = 0
							super(40868, 40869, order)
						end
					end

					class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40854
							order[1] = 0
							super(40977, 40854, order)
						end
					end

					class NoPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41162
							order[1] = 41163
							order[2] = 0
							super(41161, 41162, order)
						end
					end

					class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40863
							order[1] = 0
							super(40945, 40863, order)
						end
					end
				end

				class NoPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40873
						order[1] = 40874
						order[2] = 42698
						order[3] = 42699
						order[4] = 42700
						order[5] = 42701
						order[6] = 42702
						order[7] = 42703
						order[8] = 42704
						order[9] = 42689
						order[10] = 42690
						order[11] = 42691
						order[12] = 42692
						order[13] = 42693
						order[14] = 42694
						order[15] = 42695
						order[16] = 40875
						order[17] = 40876
						order[18] = 40877
						order[19] = 40878
						order[20] = 40879
						order[21] = 40880
						order[22] = 40881
						order[23] = 40882
						order[24] = 40883
						order[25] = 40884
						order[26] = 40885
						order[27] = 40886
						order[28] = 40887
						order[29] = 40888
						order[30] = 40889
						order[31] = 40890
						order[32] = 40891
						order[33] = 40892
						order[34] = 40893
						order[35] = 40894
						order[36] = 40895
						order[37] = 40896
						order[38] = 40897
						order[39] = 40898
						order[40] = 40899
						order[41] = 40900
						order[42] = 40901
						order[43] = 0
						super(40872, 40873, order)
					end

					class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42706
							order[1] = 0
							super(42705, 42706, order)
						end
					end

					class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42697
							order[1] = 0
							super(42696, 42697, order)
						end
					end
				end

				class NoDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41086
						order[1] = 0
						super(41085, 41086, order)
					end
				end

				class NoDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41082
						order[1] = 41083
						order[2] = 41084
						order[3] = 0
						super(41081, 41082, order)
					end
				end

				class NoDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41038
						order[1] = 41039
						order[2] = 41040
						order[3] = 41041
						order[4] = 41042
						order[5] = 41043
						order[6] = 41044
						order[7] = 41045
						order[8] = 41046
						order[9] = 41047
						order[10] = 41048
						order[11] = 41049
						order[12] = 41050
						order[13] = 41051
						order[14] = 0
						super(41037, 41038, order)
					end

					class NoDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41052
							order[1] = 41053
							order[2] = 41054
							order[3] = 0
							super(41051, 41052, order)
						end

						class NoDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41055
								order[1] = 41056
								order[2] = 41057
								order[3] = 0
								super(41054, 41055, order)
							end
						end
					end
				end
			end

			class NoProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 40091
					order[1] = 40092
					order[2] = 40093
					order[3] = 40957
					order[4] = 40095
					order[5] = 40096
					order[6] = 40097
					order[7] = 42707
					order[8] = 42708
					order[9] = 40098
					order[10] = 40099
					order[11] = 40100
					order[12] = 40114
					order[13] = 40115
					order[14] = 40116
					order[15] = 40118
					order[16] = 40119
					order[17] = 40120
					order[18] = 40121
					order[19] = 40122
					order[20] = 40123
					order[21] = 40125
					order[22] = 40126
					order[23] = 40127
					order[24] = 40128
					order[25] = 40129
					order[26] = 40130
					order[27] = 40131
					order[28] = 40132
					order[29] = 40133
					order[30] = 40134
					order[31] = 40135
					order[32] = 40136
					order[33] = 40137
					order[34] = 40138
					order[35] = 40139
					order[36] = 40140
					order[37] = 40141
					order[38] = 40145
					order[39] = 40146
					order[40] = 40148
					order[41] = 40149
					order[42] = 40150
					order[43] = 40151
					order[44] = 40152
					order[45] = 40153
					order[46] = 40154
					order[47] = 40155
					order[48] = 40156
					order[49] = 40158
					order[50] = 40159
					order[51] = 40160
					order[52] = 40161
					order[53] = 40162
					order[54] = 40101
					order[55] = 40102
					order[56] = 40103
					order[57] = 40104
					order[58] = 40105
					order[59] = 40106
					order[60] = 40107
					order[61] = 40163
					order[62] = 40165
					order[63] = 40166
					order[64] = 40167
					order[65] = 40168
					order[66] = 40169
					order[67] = 40170
					order[68] = 40108
					order[69] = 40109
					order[70] = 40110
					order[71] = 40111
					order[72] = 40112
					order[73] = 41406
					order[74] = 40113
					order[75] = 40986
					order[76] = 40987
					order[77] = 40174
					order[78] = 0
					super(40090, 40091, order)
				end

				class NoProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40094
						order[1] = 0
						super(40957, 40094, order)
					end
				end

				class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40117
						order[1] = 0
						super(40953, 40117, order)
					end
				end

				class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40124
						order[1] = 0
						super(40954, 40124, order)
					end
				end

				class NoProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40143
						order[1] = 40144
						order[2] = 0
						super(40142, 40143, order)
					end
				end

				class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40147
						order[1] = 0
						super(40955, 40147, order)
					end
				end

				class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40157
						order[1] = 0
						super(40956, 40157, order)
					end
				end

				class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40164
						order[1] = 0
						super(40952, 40164, order)
					end
				end

				class NoProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40172
						order[1] = 40173
						order[2] = 0
						super(40171, 40172, order)
					end
				end

				class NoProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40175
						order[1] = 40176
						order[2] = 40177
						order[3] = 2385
						order[4] = 40178
						order[5] = 0
						super(40174, 40175, order)
					end

					class NoProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40179
							order[1] = 40180
							order[2] = 0
							super(40178, 40179, order)
						end
					end
				end
			end

			class NoAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40020
					order[1] = 40021
					order[2] = 40000
					order[3] = 0
					super(40019, 40020, order)
				end

				class NoAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 40001
						order[1] = 40002
						order[2] = 40003
						order[3] = 40004
						order[4] = 40005
						order[5] = 40006
						order[6] = 40007
						order[7] = 40008
						order[8] = 40009
						order[9] = 40010
						order[10] = 40011
						order[11] = 40012
						order[12] = 40013
						order[13] = 40014
						order[14] = 40015
						order[15] = 40016
						order[16] = 40017
						order[17] = 40018
						order[18] = 0
						super(40000, 40001, order)
					end
				end
			end

			class NoProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 40182
					order[1] = 40183
					order[2] = 40184
					order[3] = 40185
					order[4] = 40186
					order[5] = 40187
					order[6] = 40188
					order[7] = 40951
					order[8] = 40191
					order[9] = 40201
					order[10] = 40190
					order[11] = 0
					super(40181, 40182, order)
				end

				class NoProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40189
						order[1] = 0
						super(40951, 40189, order)
					end
				end

				class NoProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 40192
						order[1] = 40193
						order[2] = 40194
						order[3] = 40195
						order[4] = 40196
						order[5] = 40197
						order[6] = 40198
						order[7] = 40199
						order[8] = 0
						super(40191, 40192, order)
					end

					class NoProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40200
							order[1] = 0
							super(40199, 40200, order)
						end
					end
				end

				class NoProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40202
						order[1] = 40203
						order[2] = 0
						super(40201, 40202, order)
					end
				end
			end

			class NoCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 40023
					order[1] = 40024
					order[2] = 40916
					order[3] = 40917
					order[4] = 40025
					order[5] = 40026
					order[6] = 40027
					order[7] = 40028
					order[8] = 40029
					order[9] = 40030
					order[10] = 40031
					order[11] = 40277
					order[12] = 42216
					order[13] = 42217
					order[14] = 40033
					order[15] = 40034
					order[16] = 42207
					order[17] = 42208
					order[18] = 42209
					order[19] = 42210
					order[20] = 42211
					order[21] = 42212
					order[22] = 42213
					order[23] = 40035
					order[24] = 40036
					order[25] = 40037
					order[26] = 40038
					order[27] = 40039
					order[28] = 0
					super(40022, 40023, order)
				end

				class NoCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40032
						order[1] = 0
						super(40277, 40032, order)
					end
				end

				class NoCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42215
						order[1] = 0
						super(42214, 42215, order)
					end
				end
			end

			class NoPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40209
					order[1] = 40205
					order[2] = 40206
					order[3] = 40207
					order[4] = 40208
					order[5] = 0
					super(40204, 40209, order)
				end

				class NoPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40210
						order[1] = 40211
						order[2] = 0
						super(40209, 40210, order)
					end
				end
			end

			class NoExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42297
					order[1] = 42298
					order[2] = 0
					super(42296, 42297, order)
				end
			end
		end
	end
end

class StreamAssignmentReportACK < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CE") )
	end
end

class MarginRequirementInquiry < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CH") )
	end

	class NoMarginReqmtInqQualifier < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 1637
			order[1] = 0
			super(1636, 1637, order)
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end
end

class MarginRequirementInquiryAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CI") )
	end

	class NoMarginReqmtInqQualifier < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 1637
			order[1] = 0
			super(1636, 1637, order)
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end
end

class MarginRequirementReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CJ") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoTrdRegTimestamps < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 769
			order[1] = 770
			order[2] = 771
			order[3] = 2839
			order[4] = 1033
			order[5] = 1034
			order[6] = 1035
			order[7] = 1727
			order[8] = 2831
			order[9] = 2832
			order[10] = 2833
			order[11] = 2834
			order[12] = 0
			super(768, 769, order)
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoMarginAmt < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(9)
			order[0] = 1645
			order[1] = 1644
			order[2] = 1646
			order[3] = 2088
			order[4] = 2089
			order[5] = 1714
			order[6] = 1715
			order[7] = 2851
			order[8] = 0
			super(1643, 1645, order)
		end
	end
end

class PartyDetailsListRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CF") )
	end

	class NoRequestingPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1658
			order[1] = 1659
			order[2] = 1660
			order[3] = 2338
			order[4] = 1661
			order[5] = 0
			super(1657, 1658, order)
		end

		class NoRequestingPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1662
				order[1] = 1663
				order[2] = 0
				super(1661, 1662, order)
			end
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoRequestedPartyRoles < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1509
			order[1] = 2386
			order[2] = 0
			super(1508, 1509, order)
		end
	end

	class NoPartyRelationships < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 1515
			order[1] = 0
			super(1514, 1515, order)
		end
	end
end

class PartyDetailsListReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CG") )
	end

	class NoPartyDetails < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(9)
			order[0] = 1691
			order[1] = 1692
			order[2] = 1693
			order[3] = 1674
			order[4] = 1694
			order[5] = 1516
			order[6] = 1562
			order[7] = 1672
			order[8] = 0
			super(1671, 1691, order)
		end

		class NoPartyDetailSubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1695
				order[1] = 1696
				order[2] = 0
				super(1694, 1695, order)
			end
		end

		class NoPartyDetailAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1517
				order[1] = 1518
				order[2] = 1519
				order[3] = 0
				super(1516, 1517, order)
			end

			class NoPartyDetailAltSubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1520
					order[1] = 1521
					order[2] = 0
					super(1519, 1520, order)
				end
			end
		end

		class NoRelatedPartyDetailID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(8)
				order[0] = 1563
				order[1] = 1564
				order[2] = 1565
				order[3] = 1675
				order[4] = 1566
				order[5] = 1569
				order[6] = 1514
				order[7] = 0
				super(1562, 1563, order)
			end

			class NoRelatedPartyDetailSubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1567
					order[1] = 1568
					order[2] = 0
					super(1566, 1567, order)
				end
			end

			class NoRelatedPartyDetailAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1570
					order[1] = 1571
					order[2] = 1572
					order[3] = 0
					super(1569, 1570, order)
				end

				class NoRelatedPartyDetailAltSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1573
						order[1] = 1574
						order[2] = 0
						super(1572, 1573, order)
					end
				end
			end

			class NoPartyRelationships < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 1515
					order[1] = 0
					super(1514, 1515, order)
				end
			end
		end
	end
end

class PartyDetailsListUpdateReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CK") )
	end

	class NoRequestingPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1658
			order[1] = 1659
			order[2] = 1660
			order[3] = 2338
			order[4] = 1661
			order[5] = 0
			super(1657, 1658, order)
		end

		class NoRequestingPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1662
				order[1] = 1663
				order[2] = 0
				super(1661, 1662, order)
			end
		end
	end

	class NoPartyUpdates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1324
			order[1] = 1671
			order[2] = 0
			super(1676, 1324, order)
		end

		class NoPartyDetails < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 1691
				order[1] = 1692
				order[2] = 1693
				order[3] = 1674
				order[4] = 1694
				order[5] = 1516
				order[6] = 1562
				order[7] = 1672
				order[8] = 0
				super(1671, 1691, order)
			end

			class NoPartyDetailSubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1695
					order[1] = 1696
					order[2] = 0
					super(1694, 1695, order)
				end
			end

			class NoPartyDetailAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1517
					order[1] = 1518
					order[2] = 1519
					order[3] = 0
					super(1516, 1517, order)
				end

				class NoPartyDetailAltSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1520
						order[1] = 1521
						order[2] = 0
						super(1519, 1520, order)
					end
				end
			end

			class NoRelatedPartyDetailID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(8)
					order[0] = 1563
					order[1] = 1564
					order[2] = 1565
					order[3] = 1675
					order[4] = 1566
					order[5] = 1569
					order[6] = 1514
					order[7] = 0
					super(1562, 1563, order)
				end

				class NoRelatedPartyDetailSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1567
						order[1] = 1568
						order[2] = 0
						super(1566, 1567, order)
					end
				end

				class NoRelatedPartyDetailAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 1570
						order[1] = 1571
						order[2] = 1572
						order[3] = 0
						super(1569, 1570, order)
					end

					class NoRelatedPartyDetailAltSubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 1573
							order[1] = 1574
							order[2] = 0
							super(1572, 1573, order)
						end
					end
				end

				class NoPartyRelationships < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 1515
						order[1] = 0
						super(1514, 1515, order)
					end
				end
			end
		end
	end
end

class PartyRiskLimitsRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CL") )
	end

	class NoRequestingPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1658
			order[1] = 1659
			order[2] = 1660
			order[3] = 2338
			order[4] = 1661
			order[5] = 0
			super(1657, 1658, order)
		end

		class NoRequestingPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1662
				order[1] = 1663
				order[2] = 0
				super(1661, 1662, order)
			end
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoRequestedPartyRoles < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1509
			order[1] = 2386
			order[2] = 0
			super(1508, 1509, order)
		end
	end

	class NoRequestedRiskLimitType < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 1530
			order[1] = 0
			super(1668, 1530, order)
		end
	end

	class NoRiskInstrumentScopes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(26)
			order[0] = 1535
			order[1] = 1536
			order[2] = 1537
			order[3] = 1538
			order[4] = 1539
			order[5] = 1543
			order[6] = 1544
			order[7] = 1545
			order[8] = 1546
			order[9] = 2895
			order[10] = 1547
			order[11] = 1548
			order[12] = 1549
			order[13] = 1550
			order[14] = 1551
			order[15] = 1552
			order[16] = 1553
			order[17] = 1554
			order[18] = 1555
			order[19] = 1616
			order[20] = 1556
			order[21] = 1620
			order[22] = 1621
			order[23] = 1557
			order[24] = 1558
			order[25] = 0
			super(1534, 1535, order)
		end

		class NoInstrumentScopeSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1541
				order[1] = 1542
				order[2] = 0
				super(1540, 1541, order)
			end
		end
	end
end

class PartyRiskLimitsReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CM") )
	end

	class NoPartyRiskLimits < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1671
			order[1] = 1669
			order[2] = 1670
			order[3] = 2339
			order[4] = 2355
			order[5] = 0
			super(1677, 1671, order)
		end

		class NoPartyDetails < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 1691
				order[1] = 1692
				order[2] = 1693
				order[3] = 1674
				order[4] = 1694
				order[5] = 1516
				order[6] = 1562
				order[7] = 1672
				order[8] = 0
				super(1671, 1691, order)
			end

			class NoPartyDetailSubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1695
					order[1] = 1696
					order[2] = 0
					super(1694, 1695, order)
				end
			end

			class NoPartyDetailAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1517
					order[1] = 1518
					order[2] = 1519
					order[3] = 0
					super(1516, 1517, order)
				end

				class NoPartyDetailAltSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1520
						order[1] = 1521
						order[2] = 0
						super(1519, 1520, order)
					end
				end
			end

			class NoRelatedPartyDetailID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(8)
					order[0] = 1563
					order[1] = 1564
					order[2] = 1565
					order[3] = 1675
					order[4] = 1566
					order[5] = 1569
					order[6] = 1514
					order[7] = 0
					super(1562, 1563, order)
				end

				class NoRelatedPartyDetailSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1567
						order[1] = 1568
						order[2] = 0
						super(1566, 1567, order)
					end
				end

				class NoRelatedPartyDetailAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 1570
						order[1] = 1571
						order[2] = 1572
						order[3] = 0
						super(1569, 1570, order)
					end

					class NoRelatedPartyDetailAltSubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 1573
							order[1] = 1574
							order[2] = 0
							super(1572, 1573, order)
						end
					end
				end

				class NoPartyRelationships < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 1515
						order[1] = 0
						super(1514, 1515, order)
					end
				end
			end
		end

		class NoRiskLimits < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1529
				order[1] = 1534
				order[2] = 0
				super(1669, 1529, order)
			end

			class NoRiskLimitTypes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 1530
					order[1] = 1531
					order[2] = 1767
					order[3] = 1766
					order[4] = 1765
					order[5] = 1532
					order[6] = 2939
					order[7] = 1533
					order[8] = 2336
					order[9] = 2337
					order[10] = 1559
					order[11] = 0
					super(1529, 1530, order)
				end

				class NoRiskWarningLevels < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 1769
						order[1] = 1560
						order[2] = 1768
						order[3] = 1561
						order[4] = 0
						super(1559, 1769, order)
					end
				end
			end

			class NoRiskInstrumentScopes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(26)
					order[0] = 1535
					order[1] = 1536
					order[2] = 1537
					order[3] = 1538
					order[4] = 1539
					order[5] = 1543
					order[6] = 1544
					order[7] = 1545
					order[8] = 1546
					order[9] = 2895
					order[10] = 1547
					order[11] = 1548
					order[12] = 1549
					order[13] = 1550
					order[14] = 1551
					order[15] = 1552
					order[16] = 1553
					order[17] = 1554
					order[18] = 1555
					order[19] = 1616
					order[20] = 1556
					order[21] = 1620
					order[22] = 1621
					order[23] = 1557
					order[24] = 1558
					order[25] = 0
					super(1534, 1535, order)
				end

				class NoInstrumentScopeSecurityAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1541
						order[1] = 1542
						order[2] = 0
						super(1540, 1541, order)
					end
				end
			end
		end
	end
end

class SecurityMassStatusRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CN") )
	end

	class NoInstrumentScopeSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1541
			order[1] = 1542
			order[2] = 0
			super(1540, 1541, order)
		end
	end
end

class SecurityMassStatus < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CO") )
	end

	class NoInstrumentScopeSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1541
			order[1] = 1542
			order[2] = 0
			super(1540, 1541, order)
		end
	end

	class NoRelatedSym < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(193)
			order[0] = 55
			order[1] = 65
			order[2] = 48
			order[3] = 22
			order[4] = 460
			order[5] = 1227
			order[6] = 1151
			order[7] = 461
			order[8] = 2891
			order[9] = 167
			order[10] = 762
			order[11] = 200
			order[12] = 541
			order[13] = 1079
			order[14] = 966
			order[15] = 1049
			order[16] = 965
			order[17] = 224
			order[18] = 1449
			order[19] = 1450
			order[20] = 1451
			order[21] = 1452
			order[22] = 1457
			order[23] = 1458
			order[24] = 1739
			order[25] = 2210
			order[26] = 1938
			order[27] = 1939
			order[28] = 1940
			order[29] = 2735
			order[30] = 1941
			order[31] = 1575
			order[32] = 1942
			order[33] = 1943
			order[34] = 1944
			order[35] = 1945
			order[36] = 1946
			order[37] = 1947
			order[38] = 1948
			order[39] = 1949
			order[40] = 1950
			order[41] = 2879
			order[42] = 1951
			order[43] = 1952
			order[44] = 1953
			order[45] = 1954
			order[46] = 1955
			order[47] = 1956
			order[48] = 1957
			order[49] = 1958
			order[50] = 1959
			order[51] = 1960
			order[52] = 1577
			order[53] = 1580
			order[54] = 1581
			order[55] = 1678
			order[56] = 1697
			order[57] = 225
			order[58] = 239
			order[59] = 226
			order[60] = 227
			order[61] = 228
			order[62] = 255
			order[63] = 543
			order[64] = 470
			order[65] = 471
			order[66] = 472
			order[67] = 240
			order[68] = 202
			order[69] = 2578
			order[70] = 2577
			order[71] = 947
			order[72] = 2904
			order[73] = 967
			order[74] = 968
			order[75] = 1698
			order[76] = 1866
			order[77] = 2600
			order[78] = 2001
			order[79] = 2601
			order[80] = 1478
			order[81] = 1479
			order[82] = 1480
			order[83] = 1481
			order[84] = 206
			order[85] = 231
			order[86] = 1435
			order[87] = 2353
			order[88] = 1439
			order[89] = 969
			order[90] = 1146
			order[91] = 996
			order[92] = 1147
			order[93] = 1716
			order[94] = 2905
			order[95] = 1191
			order[96] = 1192
			order[97] = 1717
			order[98] = 2906
			order[99] = 1193
			order[100] = 2579
			order[101] = 1194
			order[102] = 1482
			order[103] = 1195
			order[104] = 2753
			order[105] = 1196
			order[106] = 1197
			order[107] = 2002
			order[108] = 2140
			order[109] = 1524
			order[110] = 2907
			order[111] = 1198
			order[112] = 1199
			order[113] = 1200
			order[114] = 201
			order[115] = 2681
			order[116] = 2685
			order[117] = 1244
			order[118] = 1242
			order[119] = 2575
			order[120] = 2574
			order[121] = 997
			order[122] = 223
			order[123] = 207
			order[124] = 970
			order[125] = 971
			order[126] = 106
			order[127] = 348
			order[128] = 349
			order[129] = 2737
			order[130] = 2714
			order[131] = 2715
			order[132] = 2716
			order[133] = 107
			order[134] = 350
			order[135] = 351
			order[136] = 691
			order[137] = 667
			order[138] = 875
			order[139] = 876
			order[140] = 873
			order[141] = 874
			order[142] = 1687
			order[143] = 1787
			order[144] = 2141
			order[145] = 2142
			order[146] = 2143
			order[147] = 2752
			order[148] = 2144
			order[149] = 2145
			order[150] = 2576
			order[151] = 2962
			order[152] = 2602
			order[153] = 2603
			order[154] = 668
			order[155] = 869
			order[156] = 2736
			order[157] = 2738
			order[158] = 913
			order[159] = 914
			order[160] = 1961
			order[161] = 915
			order[162] = 918
			order[163] = 2952
			order[164] = 1962
			order[165] = 1963
			order[166] = 1964
			order[167] = 1965
			order[168] = 1966
			order[169] = 1967
			order[170] = 1968
			order[171] = 1969
			order[172] = 1970
			order[173] = 1513
			order[174] = 1525
			order[175] = 1527
			order[176] = 788
			order[177] = 916
			order[178] = 917
			order[179] = 919
			order[180] = 898
			order[181] = 711
			order[182] = 555
			order[183] = 1647
			order[184] = 326
			order[185] = 1174
			order[186] = 327
			order[187] = 291
			order[188] = 292
			order[189] = 58
			order[190] = 354
			order[191] = 355
			order[192] = 0
			super(146, 55, order)
		end

		class NoSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 455
				order[1] = 456
				order[2] = 2957
				order[3] = 0
				super(454, 455, order)
			end
		end

		class NoSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1977
				order[1] = 1978
				order[2] = 1979
				order[3] = 2741
				order[4] = 0
				super(1976, 1977, order)
			end
		end

		class NoAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2305
				order[1] = 2306
				order[2] = 2307
				order[3] = 0
				super(2304, 2305, order)
			end
		end

		class NoEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 865
				order[1] = 866
				order[2] = 1145
				order[3] = 1827
				order[4] = 1826
				order[5] = 2340
				order[6] = 867
				order[7] = 868
				order[8] = 1578
				order[9] = 1579
				order[10] = 0
				super(864, 865, order)
			end
		end

		class NoInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1019
				order[1] = 1050
				order[2] = 1051
				order[3] = 2378
				order[4] = 1052
				order[5] = 0
				super(1018, 1019, order)
			end

			class NoInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1053
					order[1] = 1054
					order[2] = 0
					super(1052, 1053, order)
				end
			end
		end

		class NoComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 1484
				order[1] = 2117
				order[2] = 2118
				order[3] = 2119
				order[4] = 1485
				order[5] = 2120
				order[6] = 2121
				order[7] = 2122
				order[8] = 2941
				order[9] = 1486
				order[10] = 2123
				order[11] = 1487
				order[12] = 1488
				order[13] = 1489
				order[14] = 1490
				order[15] = 1491
				order[16] = 2124
				order[17] = 2942
				order[18] = 2125
				order[19] = 2943
				order[20] = 2126
				order[21] = 2127
				order[22] = 2407
				order[23] = 2408
				order[24] = 2128
				order[25] = 2129
				order[26] = 2130
				order[27] = 2131
				order[28] = 2132
				order[29] = 41013
				order[30] = 41020
				order[31] = 41021
				order[32] = 41022
				order[33] = 41023
				order[34] = 41024
				order[35] = 41025
				order[36] = 41026
				order[37] = 41027
				order[38] = 41028
				order[39] = 41010
				order[40] = 2133
				order[41] = 2134
				order[42] = 2135
				order[43] = 2136
				order[44] = 2137
				order[45] = 41029
				order[46] = 40997
				order[47] = 2597
				order[48] = 2598
				order[49] = 2599
				order[50] = 2138
				order[51] = 2139
				order[52] = 0
				super(1483, 1484, order)
			end

			class NoComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1492
					order[1] = 1493
					order[2] = 1494
					order[3] = 0
					super(1491, 1492, order)
				end

				class NoComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1495
						order[1] = 1496
						order[2] = 0
						super(1494, 1495, order)
					end
				end
			end

			class NoComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41014
					order[1] = 41015
					order[2] = 41016
					order[3] = 41017
					order[4] = 0
					super(41013, 41014, order)
				end
			end

			class NoComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41019
					order[1] = 0
					super(41018, 41019, order)
				end
			end

			class NoComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41011
					order[1] = 41012
					order[2] = 41031
					order[3] = 41007
					order[4] = 40994
					order[5] = 0
					super(41010, 41011, order)
				end

				class NoComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41032
						order[1] = 41033
						order[2] = 41034
						order[3] = 41035
						order[4] = 41036
						order[5] = 0
						super(41031, 41032, order)
					end
				end

				class NoComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41008
						order[1] = 41009
						order[2] = 0
						super(41007, 41008, order)
					end
				end

				class NoComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40995
						order[1] = 40996
						order[2] = 0
						super(40994, 40995, order)
					end
				end
			end

			class NoComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41030
					order[1] = 0
					super(41029, 41030, order)
				end
			end

			class NoComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40998
					order[1] = 40999
					order[2] = 41000
					order[3] = 41001
					order[4] = 41002
					order[5] = 41003
					order[6] = 41004
					order[7] = 41005
					order[8] = 0
					super(40997, 40998, order)
				end

				class NoComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41006
						order[1] = 0
						super(41005, 41006, order)
					end
				end
			end
		end

		class NoBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40471
				order[1] = 0
				super(40278, 40471, order)
			end
		end

		class NoPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41231
				order[1] = 0
				super(41230, 41231, order)
			end
		end

		class NoMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41093
				order[1] = 40991
				order[2] = 0
				super(41092, 41093, order)
			end
		end

		class NoMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41095
				order[1] = 40992
				order[2] = 0
				super(41094, 41095, order)
			end
		end

		class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41097
				order[1] = 41098
				order[2] = 41099
				order[3] = 41100
				order[4] = 41101
				order[5] = 41102
				order[6] = 41103
				order[7] = 41104
				order[8] = 41105
				order[9] = 0
				super(41096, 41097, order)
			end
		end

		class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42776
				order[1] = 0
				super(42775, 42776, order)
			end
		end

		class NoOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41117
				order[1] = 0
				super(41116, 41117, order)
			end
		end

		class NoOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41138
				order[1] = 41139
				order[2] = 0
				super(41137, 41138, order)
			end
		end

		class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41141
				order[1] = 0
				super(41140, 41141, order)
			end
		end

		class NoOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41153
				order[1] = 41154
				order[2] = 0
				super(41152, 41153, order)
			end
		end

		class NoStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40050
				order[1] = 41303
				order[2] = 40051
				order[3] = 42784
				order[4] = 42785
				order[5] = 40052
				order[6] = 40053
				order[7] = 41305
				order[8] = 40054
				order[9] = 40055
				order[10] = 42786
				order[11] = 42787
				order[12] = 41306
				order[13] = 41307
				order[14] = 41308
				order[15] = 41309
				order[16] = 41310
				order[17] = 41311
				order[18] = 41251
				order[19] = 41252
				order[20] = 41253
				order[21] = 41254
				order[22] = 41255
				order[23] = 41256
				order[24] = 41257
				order[25] = 42587
				order[26] = 41258
				order[27] = 41259
				order[28] = 41260
				order[29] = 41261
				order[30] = 41262
				order[31] = 41263
				order[32] = 41264
				order[33] = 41265
				order[34] = 41266
				order[35] = 41267
				order[36] = 41268
				order[37] = 41269
				order[38] = 41270
				order[39] = 41271
				order[40] = 41272
				order[41] = 41273
				order[42] = 41274
				order[43] = 41275
				order[44] = 41276
				order[45] = 40907
				order[46] = 40908
				order[47] = 40910
				order[48] = 40911
				order[49] = 40912
				order[50] = 40913
				order[51] = 40914
				order[52] = 40065
				order[53] = 40066
				order[54] = 40068
				order[55] = 40069
				order[56] = 40070
				order[57] = 40071
				order[58] = 40072
				order[59] = 41244
				order[60] = 41245
				order[61] = 40073
				order[62] = 40075
				order[63] = 40076
				order[64] = 40078
				order[65] = 40079
				order[66] = 40080
				order[67] = 40081
				order[68] = 40082
				order[69] = 40083
				order[70] = 40084
				order[71] = 41246
				order[72] = 41247
				order[73] = 41248
				order[74] = 40738
				order[75] = 40739
				order[76] = 40740
				order[77] = 42600
				order[78] = 40741
				order[79] = 40742
				order[80] = 43106
				order[81] = 40743
				order[82] = 40744
				order[83] = 40745
				order[84] = 40746
				order[85] = 40747
				order[86] = 42601
				order[87] = 42602
				order[88] = 42603
				order[89] = 42604
				order[90] = 40748
				order[91] = 40749
				order[92] = 40750
				order[93] = 41180
				order[94] = 41181
				order[95] = 41182
				order[96] = 41183
				order[97] = 41184
				order[98] = 41185
				order[99] = 41186
				order[100] = 42605
				order[101] = 40828
				order[102] = 40872
				order[103] = 41058
				order[104] = 41059
				order[105] = 41060
				order[106] = 41061
				order[107] = 41062
				order[108] = 42192
				order[109] = 42193
				order[110] = 41063
				order[111] = 41064
				order[112] = 41065
				order[113] = 41066
				order[114] = 41067
				order[115] = 41218
				order[116] = 41068
				order[117] = 41069
				order[118] = 41070
				order[119] = 41071
				order[120] = 41072
				order[121] = 41073
				order[122] = 41074
				order[123] = 41075
				order[124] = 41076
				order[125] = 41077
				order[126] = 41078
				order[127] = 41079
				order[128] = 41080
				order[129] = 43094
				order[130] = 41037
				order[131] = 40056
				order[132] = 40982
				order[133] = 40983
				order[134] = 0
				super(40049, 40050, order)
			end

			class NoStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41278
					order[1] = 41279
					order[2] = 0
					super(41277, 41278, order)
				end
			end

			class NoStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41238
					order[1] = 41239
					order[2] = 41240
					order[3] = 0
					super(41237, 41238, order)
				end
			end

			class NoStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41281
					order[1] = 41282
					order[2] = 0
					super(41280, 41281, order)
				end
			end

			class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41250
					order[1] = 0
					super(41249, 41250, order)
				end
			end

			class NoStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41290
					order[1] = 41291
					order[2] = 41292
					order[3] = 41293
					order[4] = 41294
					order[5] = 41295
					order[6] = 41296
					order[7] = 41297
					order[8] = 41298
					order[9] = 41299
					order[10] = 41300
					order[11] = 41283
					order[12] = 41301
					order[13] = 41302
					order[14] = 0
					super(41289, 41290, order)
				end

				class NoStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41284
						order[1] = 41285
						order[2] = 41286
						order[3] = 0
						super(41283, 41284, order)
					end

					class NoStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41287
							order[1] = 41288
							order[2] = 41588
							order[3] = 0
							super(41286, 41287, order)
						end
					end
				end
			end

			class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40909
					order[1] = 0
					super(40960, 40909, order)
				end
			end

			class NoStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40067
					order[1] = 0
					super(40961, 40067, order)
				end
			end

			class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40074
					order[1] = 0
					super(40958, 40074, order)
				end
			end

			class NoStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41242
					order[1] = 41243
					order[2] = 0
					super(41241, 41242, order)
				end
			end

			class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40077
					order[1] = 0
					super(40959, 40077, order)
				end
			end

			class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40752
					order[1] = 0
					super(40947, 40752, order)
				end
			end

			class NoPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41221
					order[1] = 41222
					order[2] = 0
					super(41220, 41221, order)
				end
			end

			class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40763
					order[1] = 0
					super(40948, 40763, order)
				end
			end

			class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40769
					order[1] = 0
					super(40949, 40769, order)
				end
			end

			class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40776
					order[1] = 0
					super(40950, 40776, order)
				end
			end

			class NoPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42661
					order[1] = 42662
					order[2] = 0
					super(42660, 42661, order)
				end
			end

			class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41193
					order[1] = 0
					super(41192, 41193, order)
				end
			end

			class NoPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41228
					order[1] = 41229
					order[2] = 0
					super(41227, 41228, order)
				end
			end

			class NoPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41225
					order[1] = 41226
					order[2] = 0
					super(41224, 41225, order)
				end
			end

			class NoPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43109
					order[1] = 42684
					order[2] = 42685
					order[3] = 0
					super(42683, 43109, order)
				end
			end

			class NoDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42275
					order[1] = 42276
					order[2] = 42277
					order[3] = 42278
					order[4] = 42279
					order[5] = 42280
					order[6] = 42294
					order[7] = 42281
					order[8] = 42282
					order[9] = 42283
					order[10] = 42284
					order[11] = 42285
					order[12] = 42286
					order[13] = 42287
					order[14] = 42288
					order[15] = 42289
					order[16] = 42290
					order[17] = 42291
					order[18] = 42292
					order[19] = 42293
					order[20] = 0
					super(42274, 42275, order)
				end

				class NoDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42295
						order[1] = 0
						super(42294, 42295, order)
					end
				end
			end

			class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42273
					order[1] = 0
					super(42272, 42273, order)
				end
			end

			class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42237
					order[1] = 0
					super(42236, 42237, order)
				end
			end

			class NoReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42736
					order[1] = 42737
					order[2] = 42738
					order[3] = 42739
					order[4] = 42740
					order[5] = 42741
					order[6] = 42765
					order[7] = 42731
					order[8] = 42742
					order[9] = 42743
					order[10] = 42744
					order[11] = 42745
					order[12] = 42746
					order[13] = 42747
					order[14] = 42748
					order[15] = 42749
					order[16] = 42750
					order[17] = 42751
					order[18] = 42752
					order[19] = 42753
					order[20] = 42761
					order[21] = 42754
					order[22] = 42755
					order[23] = 42709
					order[24] = 42756
					order[25] = 42757
					order[26] = 42758
					order[27] = 42759
					order[28] = 42760
					order[29] = 0
					super(42735, 42736, order)
				end

				class NoReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42766
						order[1] = 42767
						order[2] = 42768
						order[3] = 42769
						order[4] = 0
						super(42765, 42766, order)
					end
				end

				class NoReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42732
						order[1] = 42733
						order[2] = 42734
						order[3] = 0
						super(42731, 42732, order)
					end
				end

				class NoReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42762
						order[1] = 42763
						order[2] = 42764
						order[3] = 0
						super(42761, 42762, order)
					end
				end

				class NoReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42710
						order[1] = 42772
						order[2] = 42711
						order[3] = 42712
						order[4] = 42713
						order[5] = 42714
						order[6] = 42715
						order[7] = 42716
						order[8] = 42717
						order[9] = 42718
						order[10] = 42719
						order[11] = 42720
						order[12] = 42721
						order[13] = 42722
						order[14] = 42723
						order[15] = 42724
						order[16] = 42725
						order[17] = 42726
						order[18] = 42727
						order[19] = 42728
						order[20] = 42729
						order[21] = 42730
						order[22] = 42770
						order[23] = 0
						super(42709, 42710, order)
					end

					class NoReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42773
							order[1] = 42774
							order[2] = 0
							super(42772, 42773, order)
						end
					end

					class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42771
							order[1] = 0
							super(42770, 42771, order)
						end
					end
				end
			end

			class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42621
					order[1] = 0
					super(42620, 42621, order)
				end
			end

			class NoPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42607
					order[1] = 42608
					order[2] = 0
					super(42606, 42607, order)
				end
			end

			class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40819
					order[1] = 0
					super(40946, 40819, order)
				end
			end

			class NoNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40826
					order[1] = 40827
					order[2] = 0
					super(40825, 40826, order)
				end
			end

			class NoSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40086
					order[1] = 40373
					order[2] = 40655
					order[3] = 40088
					order[4] = 40089
					order[5] = 0
					super(40085, 40086, order)
				end
			end

			class NoPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40829
					order[1] = 41164
					order[2] = 41165
					order[3] = 40830
					order[4] = 40831
					order[5] = 40832
					order[6] = 40833
					order[7] = 40834
					order[8] = 40835
					order[9] = 40836
					order[10] = 40837
					order[11] = 40838
					order[12] = 40839
					order[13] = 41166
					order[14] = 41167
					order[15] = 41168
					order[16] = 41169
					order[17] = 40840
					order[18] = 40841
					order[19] = 40842
					order[20] = 40843
					order[21] = 41170
					order[22] = 41171
					order[23] = 41172
					order[24] = 41173
					order[25] = 40844
					order[26] = 40845
					order[27] = 40846
					order[28] = 40847
					order[29] = 40848
					order[30] = 40849
					order[31] = 40868
					order[32] = 40850
					order[33] = 40851
					order[34] = 40852
					order[35] = 40853
					order[36] = 40977
					order[37] = 40855
					order[38] = 40856
					order[39] = 40857
					order[40] = 41174
					order[41] = 41175
					order[42] = 40858
					order[43] = 41161
					order[44] = 41176
					order[45] = 41177
					order[46] = 41178
					order[47] = 41179
					order[48] = 40859
					order[49] = 40860
					order[50] = 40861
					order[51] = 40862
					order[52] = 40945
					order[53] = 40864
					order[54] = 40865
					order[55] = 40866
					order[56] = 40867
					order[57] = 0
					super(40828, 40829, order)
				end

				class NoPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40869
						order[1] = 40870
						order[2] = 40871
						order[3] = 0
						super(40868, 40869, order)
					end
				end

				class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40854
						order[1] = 0
						super(40977, 40854, order)
					end
				end

				class NoPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41162
						order[1] = 41163
						order[2] = 0
						super(41161, 41162, order)
					end
				end

				class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40863
						order[1] = 0
						super(40945, 40863, order)
					end
				end
			end

			class NoPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40873
					order[1] = 40874
					order[2] = 42698
					order[3] = 42699
					order[4] = 42700
					order[5] = 42701
					order[6] = 42702
					order[7] = 42703
					order[8] = 42704
					order[9] = 42689
					order[10] = 42690
					order[11] = 42691
					order[12] = 42692
					order[13] = 42693
					order[14] = 42694
					order[15] = 42695
					order[16] = 40875
					order[17] = 40876
					order[18] = 40877
					order[19] = 40878
					order[20] = 40879
					order[21] = 40880
					order[22] = 40881
					order[23] = 40882
					order[24] = 40883
					order[25] = 40884
					order[26] = 40885
					order[27] = 40886
					order[28] = 40887
					order[29] = 40888
					order[30] = 40889
					order[31] = 40890
					order[32] = 40891
					order[33] = 40892
					order[34] = 40893
					order[35] = 40894
					order[36] = 40895
					order[37] = 40896
					order[38] = 40897
					order[39] = 40898
					order[40] = 40899
					order[41] = 40900
					order[42] = 40901
					order[43] = 0
					super(40872, 40873, order)
				end

				class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42706
						order[1] = 0
						super(42705, 42706, order)
					end
				end

				class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42697
						order[1] = 0
						super(42696, 42697, order)
					end
				end
			end

			class NoDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41086
					order[1] = 0
					super(41085, 41086, order)
				end
			end

			class NoDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41082
					order[1] = 41083
					order[2] = 41084
					order[3] = 0
					super(41081, 41082, order)
				end
			end

			class NoDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41038
					order[1] = 41039
					order[2] = 41040
					order[3] = 41041
					order[4] = 41042
					order[5] = 41043
					order[6] = 41044
					order[7] = 41045
					order[8] = 41046
					order[9] = 41047
					order[10] = 41048
					order[11] = 41049
					order[12] = 41050
					order[13] = 41051
					order[14] = 0
					super(41037, 41038, order)
				end

				class NoDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41052
						order[1] = 41053
						order[2] = 41054
						order[3] = 0
						super(41051, 41052, order)
					end

					class NoDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41055
							order[1] = 41056
							order[2] = 41057
							order[3] = 0
							super(41054, 41055, order)
						end
					end
				end
			end
		end

		class NoProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40091
				order[1] = 40092
				order[2] = 40093
				order[3] = 40957
				order[4] = 40095
				order[5] = 40096
				order[6] = 40097
				order[7] = 42707
				order[8] = 42708
				order[9] = 40098
				order[10] = 40099
				order[11] = 40100
				order[12] = 40114
				order[13] = 40115
				order[14] = 40116
				order[15] = 40118
				order[16] = 40119
				order[17] = 40120
				order[18] = 40121
				order[19] = 40122
				order[20] = 40123
				order[21] = 40125
				order[22] = 40126
				order[23] = 40127
				order[24] = 40128
				order[25] = 40129
				order[26] = 40130
				order[27] = 40131
				order[28] = 40132
				order[29] = 40133
				order[30] = 40134
				order[31] = 40135
				order[32] = 40136
				order[33] = 40137
				order[34] = 40138
				order[35] = 40139
				order[36] = 40140
				order[37] = 40141
				order[38] = 40145
				order[39] = 40146
				order[40] = 40148
				order[41] = 40149
				order[42] = 40150
				order[43] = 40151
				order[44] = 40152
				order[45] = 40153
				order[46] = 40154
				order[47] = 40155
				order[48] = 40156
				order[49] = 40158
				order[50] = 40159
				order[51] = 40160
				order[52] = 40161
				order[53] = 40162
				order[54] = 40101
				order[55] = 40102
				order[56] = 40103
				order[57] = 40104
				order[58] = 40105
				order[59] = 40106
				order[60] = 40107
				order[61] = 40163
				order[62] = 40165
				order[63] = 40166
				order[64] = 40167
				order[65] = 40168
				order[66] = 40169
				order[67] = 40170
				order[68] = 40108
				order[69] = 40109
				order[70] = 40110
				order[71] = 40111
				order[72] = 40112
				order[73] = 41406
				order[74] = 40113
				order[75] = 40986
				order[76] = 40987
				order[77] = 40174
				order[78] = 0
				super(40090, 40091, order)
			end

			class NoProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40094
					order[1] = 0
					super(40957, 40094, order)
				end
			end

			class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40117
					order[1] = 0
					super(40953, 40117, order)
				end
			end

			class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40124
					order[1] = 0
					super(40954, 40124, order)
				end
			end

			class NoProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40143
					order[1] = 40144
					order[2] = 0
					super(40142, 40143, order)
				end
			end

			class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40147
					order[1] = 0
					super(40955, 40147, order)
				end
			end

			class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40157
					order[1] = 0
					super(40956, 40157, order)
				end
			end

			class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40164
					order[1] = 0
					super(40952, 40164, order)
				end
			end

			class NoProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40172
					order[1] = 40173
					order[2] = 0
					super(40171, 40172, order)
				end
			end

			class NoProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40175
					order[1] = 40176
					order[2] = 40177
					order[3] = 2385
					order[4] = 40178
					order[5] = 0
					super(40174, 40175, order)
				end

				class NoProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40179
						order[1] = 40180
						order[2] = 0
						super(40178, 40179, order)
					end
				end
			end
		end

		class NoAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40020
				order[1] = 40021
				order[2] = 40000
				order[3] = 0
				super(40019, 40020, order)
			end

			class NoAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 40001
					order[1] = 40002
					order[2] = 40003
					order[3] = 40004
					order[4] = 40005
					order[5] = 40006
					order[6] = 40007
					order[7] = 40008
					order[8] = 40009
					order[9] = 40010
					order[10] = 40011
					order[11] = 40012
					order[12] = 40013
					order[13] = 40014
					order[14] = 40015
					order[15] = 40016
					order[16] = 40017
					order[17] = 40018
					order[18] = 0
					super(40000, 40001, order)
				end
			end
		end

		class NoProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 40182
				order[1] = 40183
				order[2] = 40184
				order[3] = 40185
				order[4] = 40186
				order[5] = 40187
				order[6] = 40188
				order[7] = 40951
				order[8] = 40191
				order[9] = 40201
				order[10] = 40190
				order[11] = 0
				super(40181, 40182, order)
			end

			class NoProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40189
					order[1] = 0
					super(40951, 40189, order)
				end
			end

			class NoProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40192
					order[1] = 40193
					order[2] = 40194
					order[3] = 40195
					order[4] = 40196
					order[5] = 40197
					order[6] = 40198
					order[7] = 40199
					order[8] = 0
					super(40191, 40192, order)
				end

				class NoProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40200
						order[1] = 0
						super(40199, 40200, order)
					end
				end
			end

			class NoProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40202
					order[1] = 40203
					order[2] = 0
					super(40201, 40202, order)
				end
			end
		end

		class NoCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 40023
				order[1] = 40024
				order[2] = 40916
				order[3] = 40917
				order[4] = 40025
				order[5] = 40026
				order[6] = 40027
				order[7] = 40028
				order[8] = 40029
				order[9] = 40030
				order[10] = 40031
				order[11] = 40277
				order[12] = 42216
				order[13] = 42217
				order[14] = 40033
				order[15] = 40034
				order[16] = 42207
				order[17] = 42208
				order[18] = 42209
				order[19] = 42210
				order[20] = 42211
				order[21] = 42212
				order[22] = 42213
				order[23] = 40035
				order[24] = 40036
				order[25] = 40037
				order[26] = 40038
				order[27] = 40039
				order[28] = 0
				super(40022, 40023, order)
			end

			class NoCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40032
					order[1] = 0
					super(40277, 40032, order)
				end
			end

			class NoCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42215
					order[1] = 0
					super(42214, 42215, order)
				end
			end
		end

		class NoPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40209
				order[1] = 40205
				order[2] = 40206
				order[3] = 40207
				order[4] = 40208
				order[5] = 0
				super(40204, 40209, order)
			end

			class NoPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40210
					order[1] = 40211
					order[2] = 0
					super(40209, 40210, order)
				end
			end
		end

		class NoExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42297
				order[1] = 42298
				order[2] = 0
				super(42296, 42297, order)
			end
		end

		class NoInstrAttrib < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 871
				order[1] = 872
				order[2] = 0
				super(870, 871, order)
			end
		end

		class NoIndexRollMonths < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 2733
				order[1] = 0
				super(2734, 2733, order)
			end
		end

		class NoReferenceDataDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2747
				order[1] = 2748
				order[2] = 0
				super(2746, 2747, order)
			end
		end

		class NoContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40041
				order[1] = 0
				super(40040, 40041, order)
			end
		end

		class NoFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40047
				order[1] = 40048
				order[2] = 0
				super(40046, 40047, order)
			end
		end

		class NoContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40043
				order[1] = 40044
				order[2] = 40045
				order[3] = 0
				super(40042, 40043, order)
			end
		end

		class NoUnderlyings < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(188)
				order[0] = 311
				order[1] = 312
				order[2] = 309
				order[3] = 305
				order[4] = 2874
				order[5] = 462
				order[6] = 463
				order[7] = 2894
				order[8] = 310
				order[9] = 763
				order[10] = 313
				order[11] = 542
				order[12] = 1213
				order[13] = 1837
				order[14] = 241
				order[15] = 1453
				order[16] = 1454
				order[17] = 2614
				order[18] = 2615
				order[19] = 2921
				order[20] = 2616
				order[21] = 2617
				order[22] = 2619
				order[23] = 1455
				order[24] = 1456
				order[25] = 1459
				order[26] = 1460
				order[27] = 242
				order[28] = 243
				order[29] = 244
				order[30] = 245
				order[31] = 246
				order[32] = 256
				order[33] = 595
				order[34] = 592
				order[35] = 593
				order[36] = 594
				order[37] = 247
				order[38] = 316
				order[39] = 941
				order[40] = 2917
				order[41] = 317
				order[42] = 436
				order[43] = 1437
				order[44] = 2363
				order[45] = 1441
				order[46] = 998
				order[47] = 1423
				order[48] = 1718
				order[49] = 2918
				order[50] = 1424
				order[51] = 1425
				order[52] = 1719
				order[53] = 2919
				order[54] = 1000
				order[55] = 1419
				order[56] = 1526
				order[57] = 2920
				order[58] = 435
				order[59] = 308
				order[60] = 306
				order[61] = 362
				order[62] = 363
				order[63] = 2742
				order[64] = 2720
				order[65] = 2721
				order[66] = 2722
				order[67] = 2723
				order[68] = 2724
				order[69] = 307
				order[70] = 364
				order[71] = 365
				order[72] = 877
				order[73] = 878
				order[74] = 972
				order[75] = 318
				order[76] = 2916
				order[77] = 879
				order[78] = 975
				order[79] = 973
				order[80] = 974
				order[81] = 810
				order[82] = 882
				order[83] = 883
				order[84] = 884
				order[85] = 885
				order[86] = 886
				order[87] = 2885
				order[88] = 2886
				order[89] = 1044
				order[90] = 1045
				order[91] = 1046
				order[92] = 1038
				order[93] = 1039
				order[94] = 315
				order[95] = 2683
				order[96] = 2687
				order[97] = 1988
				order[98] = 1989
				order[99] = 1990
				order[100] = 1991
				order[101] = 1992
				order[102] = 1993
				order[103] = 2881
				order[104] = 1994
				order[105] = 1995
				order[106] = 1996
				order[107] = 1997
				order[108] = 2620
				order[109] = 2621
				order[110] = 1998
				order[111] = 1999
				order[112] = 2000
				order[113] = 2003
				order[114] = 2004
				order[115] = 2005
				order[116] = 2006
				order[117] = 2284
				order[118] = 2285
				order[119] = 2286
				order[120] = 2287
				order[121] = 2288
				order[122] = 2007
				order[123] = 2008
				order[124] = 2009
				order[125] = 2010
				order[126] = 2011
				order[127] = 2012
				order[128] = 2491
				order[129] = 2013
				order[130] = 2014
				order[131] = 2015
				order[132] = 2744
				order[133] = 2016
				order[134] = 2289
				order[135] = 2017
				order[136] = 2018
				order[137] = 2019
				order[138] = 2020
				order[139] = 2021
				order[140] = 2022
				order[141] = 2290
				order[142] = 2622
				order[143] = 2291
				order[144] = 2623
				order[145] = 2292
				order[146] = 2023
				order[147] = 2024
				order[148] = 2025
				order[149] = 2026
				order[150] = 2027
				order[151] = 2028
				order[152] = 2029
				order[153] = 2757
				order[154] = 2030
				order[155] = 2031
				order[156] = 2293
				order[157] = 2294
				order[158] = 2032
				order[159] = 2033
				order[160] = 2034
				order[161] = 2035
				order[162] = 2036
				order[163] = 2037
				order[164] = 2038
				order[165] = 2039
				order[166] = 2040
				order[167] = 2041
				order[168] = 2042
				order[169] = 2043
				order[170] = 2044
				order[171] = 41314
				order[172] = 41315
				order[173] = 2295
				order[174] = 2296
				order[175] = 2297
				order[176] = 2756
				order[177] = 2298
				order[178] = 2299
				order[179] = 2624
				order[180] = 2625
				order[181] = 2626
				order[182] = 2627
				order[183] = 2628
				order[184] = 2629
				order[185] = 2630
				order[186] = 2631
				order[187] = 0
				super(711, 311, order)
			end

			class NoUnderlyingSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 458
					order[1] = 459
					order[2] = 2959
					order[3] = 0
					super(457, 458, order)
				end
			end

			class NoUnderlyingStips < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 888
					order[1] = 889
					order[2] = 0
					super(887, 888, order)
				end
			end

			class NoUndlyInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 1059
					order[1] = 1060
					order[2] = 1061
					order[3] = 2391
					order[4] = 1062
					order[5] = 0
					super(1058, 1059, order)
				end

				class NoUndlyInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1063
						order[1] = 1064
						order[2] = 0
						super(1062, 1063, order)
					end
				end
			end

			class NoUnderlyingEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 1982
					order[1] = 1983
					order[2] = 1984
					order[3] = 1985
					order[4] = 1986
					order[5] = 2342
					order[6] = 1987
					order[7] = 2071
					order[8] = 2072
					order[9] = 2073
					order[10] = 0
					super(1981, 1982, order)
				end
			end

			class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2081
					order[1] = 2082
					order[2] = 2083
					order[3] = 2745
					order[4] = 0
					super(2080, 2081, order)
				end
			end

			class NoUnderlyingAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2313
					order[1] = 2314
					order[2] = 2315
					order[3] = 0
					super(2312, 2313, order)
				end
			end

			class NoUnderlyingComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2046
					order[1] = 2261
					order[2] = 2262
					order[3] = 2263
					order[4] = 2047
					order[5] = 2264
					order[6] = 2265
					order[7] = 2266
					order[8] = 2947
					order[9] = 2048
					order[10] = 2267
					order[11] = 2049
					order[12] = 2050
					order[13] = 2051
					order[14] = 2052
					order[15] = 2053
					order[16] = 2268
					order[17] = 2948
					order[18] = 2269
					order[19] = 2949
					order[20] = 2270
					order[21] = 2271
					order[22] = 2419
					order[23] = 2420
					order[24] = 2272
					order[25] = 2273
					order[26] = 2274
					order[27] = 2275
					order[28] = 2276
					order[29] = 41732
					order[30] = 41739
					order[31] = 41740
					order[32] = 41741
					order[33] = 41742
					order[34] = 41743
					order[35] = 41744
					order[36] = 41745
					order[37] = 41746
					order[38] = 41747
					order[39] = 41729
					order[40] = 2277
					order[41] = 2278
					order[42] = 2279
					order[43] = 2280
					order[44] = 2281
					order[45] = 41748
					order[46] = 41716
					order[47] = 2611
					order[48] = 2612
					order[49] = 2613
					order[50] = 2282
					order[51] = 2283
					order[52] = 0
					super(2045, 2046, order)
				end

				class NoUnderlyingComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2054
						order[1] = 2055
						order[2] = 2056
						order[3] = 0
						super(2053, 2054, order)
					end

					class NoUnderlyingComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2057
							order[1] = 2058
							order[2] = 0
							super(2056, 2057, order)
						end
					end
				end

				class NoUnderlyingComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41733
						order[1] = 41734
						order[2] = 41735
						order[3] = 41736
						order[4] = 0
						super(41732, 41733, order)
					end
				end

				class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41738
						order[1] = 0
						super(41737, 41738, order)
					end
				end

				class NoUnderlyingComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41730
						order[1] = 41731
						order[2] = 41750
						order[3] = 41726
						order[4] = 41713
						order[5] = 0
						super(41729, 41730, order)
					end

					class NoUnderlyingComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41751
							order[1] = 41752
							order[2] = 41753
							order[3] = 41754
							order[4] = 41755
							order[5] = 0
							super(41750, 41751, order)
						end
					end

					class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41727
							order[1] = 41728
							order[2] = 0
							super(41726, 41727, order)
						end
					end

					class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41714
							order[1] = 41715
							order[2] = 0
							super(41713, 41714, order)
						end
					end
				end

				class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41749
						order[1] = 0
						super(41748, 41749, order)
					end
				end

				class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41717
						order[1] = 41718
						order[2] = 41719
						order[3] = 41720
						order[4] = 41721
						order[5] = 41722
						order[6] = 41723
						order[7] = 41724
						order[8] = 0
						super(41716, 41717, order)
					end

					class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41725
							order[1] = 0
							super(41724, 41725, order)
						end
					end
				end
			end

			class NoUnderlyingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40963
					order[1] = 0
					super(40962, 40963, order)
				end
			end

			class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41948
					order[1] = 0
					super(41947, 41948, order)
				end
			end

			class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41865
					order[1] = 41338
					order[2] = 0
					super(41864, 41865, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41867
					order[1] = 41339
					order[2] = 0
					super(41866, 41867, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41869
					order[1] = 41870
					order[2] = 41871
					order[3] = 41872
					order[4] = 41873
					order[5] = 41874
					order[6] = 41875
					order[7] = 41876
					order[8] = 41877
					order[9] = 0
					super(41868, 41869, order)
				end
			end

			class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 43075
					order[1] = 0
					super(43074, 43075, order)
				end
			end

			class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41821
					order[1] = 0
					super(41820, 41821, order)
				end
			end

			class NoUnderlyingOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41842
					order[1] = 41843
					order[2] = 0
					super(41841, 41842, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41845
					order[1] = 0
					super(41844, 41845, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41857
					order[1] = 41858
					order[2] = 0
					super(41856, 41857, order)
				end
			end

			class NoUnderlyingStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40541
					order[1] = 42016
					order[2] = 40542
					order[3] = 43083
					order[4] = 43084
					order[5] = 40543
					order[6] = 40544
					order[7] = 42018
					order[8] = 40545
					order[9] = 40546
					order[10] = 43085
					order[11] = 43086
					order[12] = 42019
					order[13] = 42020
					order[14] = 42021
					order[15] = 42022
					order[16] = 42023
					order[17] = 42024
					order[18] = 41964
					order[19] = 41965
					order[20] = 41966
					order[21] = 41967
					order[22] = 41968
					order[23] = 41969
					order[24] = 41970
					order[25] = 42589
					order[26] = 41971
					order[27] = 41972
					order[28] = 41973
					order[29] = 41974
					order[30] = 41975
					order[31] = 41976
					order[32] = 41977
					order[33] = 41978
					order[34] = 41979
					order[35] = 41980
					order[36] = 41981
					order[37] = 41982
					order[38] = 41983
					order[39] = 41984
					order[40] = 41985
					order[41] = 41986
					order[42] = 41987
					order[43] = 41988
					order[44] = 41989
					order[45] = 40057
					order[46] = 40058
					order[47] = 40060
					order[48] = 40061
					order[49] = 40062
					order[50] = 40063
					order[51] = 40064
					order[52] = 40548
					order[53] = 40549
					order[54] = 40551
					order[55] = 40552
					order[56] = 40553
					order[57] = 40554
					order[58] = 40555
					order[59] = 41957
					order[60] = 41958
					order[61] = 40556
					order[62] = 40558
					order[63] = 40559
					order[64] = 40561
					order[65] = 40562
					order[66] = 40563
					order[67] = 40564
					order[68] = 40565
					order[69] = 40566
					order[70] = 40567
					order[71] = 41959
					order[72] = 41960
					order[73] = 41961
					order[74] = 40568
					order[75] = 40569
					order[76] = 40570
					order[77] = 42895
					order[78] = 40571
					order[79] = 40572
					order[80] = 43107
					order[81] = 40573
					order[82] = 40574
					order[83] = 40575
					order[84] = 40576
					order[85] = 40577
					order[86] = 42896
					order[87] = 42897
					order[88] = 42898
					order[89] = 42899
					order[90] = 40578
					order[91] = 40579
					order[92] = 40580
					order[93] = 41897
					order[94] = 41898
					order[95] = 41899
					order[96] = 41900
					order[97] = 41901
					order[98] = 41902
					order[99] = 41903
					order[100] = 42900
					order[101] = 40664
					order[102] = 40708
					order[103] = 41777
					order[104] = 41778
					order[105] = 41779
					order[106] = 41780
					order[107] = 41781
					order[108] = 42196
					order[109] = 42197
					order[110] = 41782
					order[111] = 41783
					order[112] = 41784
					order[113] = 41785
					order[114] = 41786
					order[115] = 41587
					order[116] = 41787
					order[117] = 41788
					order[118] = 41789
					order[119] = 41790
					order[120] = 41791
					order[121] = 41792
					order[122] = 41793
					order[123] = 41794
					order[124] = 41795
					order[125] = 41796
					order[126] = 41797
					order[127] = 41798
					order[128] = 41799
					order[129] = 43096
					order[130] = 41756
					order[131] = 40547
					order[132] = 40988
					order[133] = 40989
					order[134] = 0
					super(40540, 40541, order)
				end

				class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41991
						order[1] = 41992
						order[2] = 0
						super(41990, 41991, order)
					end
				end

				class NoUnderlyingStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41801
						order[1] = 41802
						order[2] = 41803
						order[3] = 0
						super(41800, 41801, order)
					end
				end

				class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41994
						order[1] = 41995
						order[2] = 0
						super(41993, 41994, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41963
						order[1] = 0
						super(41962, 41963, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 42003
						order[1] = 42004
						order[2] = 42005
						order[3] = 42006
						order[4] = 42007
						order[5] = 42008
						order[6] = 42009
						order[7] = 42010
						order[8] = 42011
						order[9] = 42012
						order[10] = 42013
						order[11] = 41996
						order[12] = 42014
						order[13] = 42015
						order[14] = 0
						super(42002, 42003, order)
					end

					class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41997
							order[1] = 41998
							order[2] = 41999
							order[3] = 0
							super(41996, 41997, order)
						end

						class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 42000
								order[1] = 42001
								order[2] = 41936
								order[3] = 0
								super(41999, 42000, order)
							end
						end
					end
				end

				class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40059
						order[1] = 0
						super(40975, 40059, order)
					end
				end

				class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40550
						order[1] = 0
						super(40976, 40550, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40557
						order[1] = 0
						super(40973, 40557, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41955
						order[1] = 41956
						order[2] = 0
						super(41954, 41955, order)
					end
				end

				class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40560
						order[1] = 0
						super(40974, 40560, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40582
						order[1] = 0
						super(40969, 40582, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41938
						order[1] = 41939
						order[2] = 0
						super(41937, 41938, order)
					end
				end

				class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40594
						order[1] = 0
						super(40970, 40594, order)
					end
				end

				class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40600
						order[1] = 0
						super(40971, 40600, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40607
						order[1] = 0
						super(40972, 40607, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42956
						order[1] = 42957
						order[2] = 0
						super(42955, 42956, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41910
						order[1] = 0
						super(41909, 41910, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41945
						order[1] = 41946
						order[2] = 0
						super(41944, 41945, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41942
						order[1] = 41943
						order[2] = 0
						super(41941, 41942, order)
					end
				end

				class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43111
						order[1] = 42982
						order[2] = 42983
						order[3] = 0
						super(42981, 43111, order)
					end
				end

				class NoUnderlyingDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42863
						order[1] = 42864
						order[2] = 42865
						order[3] = 42866
						order[4] = 42867
						order[5] = 42868
						order[6] = 42882
						order[7] = 42869
						order[8] = 42870
						order[9] = 42871
						order[10] = 42872
						order[11] = 42873
						order[12] = 42874
						order[13] = 42875
						order[14] = 42876
						order[15] = 42877
						order[16] = 42878
						order[17] = 42879
						order[18] = 42880
						order[19] = 42881
						order[20] = 0
						super(42862, 42863, order)
					end

					class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42883
							order[1] = 0
							super(42882, 42883, order)
						end
					end
				end

				class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42854
						order[1] = 0
						super(42853, 42854, order)
					end
				end

				class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42800
						order[1] = 0
						super(42799, 42800, order)
					end
				end

				class NoUnderlyingReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 43035
						order[1] = 43036
						order[2] = 43037
						order[3] = 43038
						order[4] = 43039
						order[5] = 43040
						order[6] = 43064
						order[7] = 43030
						order[8] = 43041
						order[9] = 43042
						order[10] = 43043
						order[11] = 43044
						order[12] = 43045
						order[13] = 43046
						order[14] = 43047
						order[15] = 43048
						order[16] = 43049
						order[17] = 43050
						order[18] = 43051
						order[19] = 43052
						order[20] = 43060
						order[21] = 43053
						order[22] = 43054
						order[23] = 43008
						order[24] = 43055
						order[25] = 43056
						order[26] = 43057
						order[27] = 43058
						order[28] = 43059
						order[29] = 0
						super(43034, 43035, order)
					end

					class NoUnderlyingReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 43065
							order[1] = 43066
							order[2] = 43067
							order[3] = 43068
							order[4] = 0
							super(43064, 43065, order)
						end
					end

					class NoUnderlyingReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43031
							order[1] = 43032
							order[2] = 43033
							order[3] = 0
							super(43030, 43031, order)
						end
					end

					class NoUnderlyingReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43061
							order[1] = 43062
							order[2] = 43063
							order[3] = 0
							super(43060, 43061, order)
						end
					end

					class NoUnderlyingReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 43009
							order[1] = 43071
							order[2] = 43010
							order[3] = 43011
							order[4] = 43012
							order[5] = 43013
							order[6] = 43014
							order[7] = 43015
							order[8] = 43016
							order[9] = 43017
							order[10] = 43018
							order[11] = 43019
							order[12] = 43020
							order[13] = 43021
							order[14] = 43022
							order[15] = 43023
							order[16] = 43024
							order[17] = 43025
							order[18] = 43026
							order[19] = 43027
							order[20] = 43028
							order[21] = 43029
							order[22] = 43069
							order[23] = 0
							super(43008, 43009, order)
						end

						class NoUnderlyingReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 43072
								order[1] = 43073
								order[2] = 0
								super(43071, 43072, order)
							end
						end

						class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 43070
								order[1] = 0
								super(43069, 43070, order)
							end
						end
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42916
						order[1] = 0
						super(42915, 42916, order)
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42902
						order[1] = 42903
						order[2] = 0
						super(42901, 42902, order)
					end
				end

				class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40650
						order[1] = 0
						super(40968, 40650, order)
					end
				end

				class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40657
						order[1] = 40658
						order[2] = 0
						super(40656, 40657, order)
					end
				end

				class NoUnderlyingSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40660
						order[1] = 40904
						order[2] = 40915
						order[3] = 40662
						order[4] = 40663
						order[5] = 0
						super(40659, 40660, order)
					end
				end

				class NoUnderlyingPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40665
						order[1] = 41881
						order[2] = 41882
						order[3] = 40666
						order[4] = 40667
						order[5] = 40668
						order[6] = 40669
						order[7] = 40670
						order[8] = 40671
						order[9] = 40672
						order[10] = 40673
						order[11] = 40674
						order[12] = 40675
						order[13] = 41883
						order[14] = 41884
						order[15] = 41885
						order[16] = 41886
						order[17] = 40676
						order[18] = 40677
						order[19] = 40678
						order[20] = 40679
						order[21] = 41887
						order[22] = 41888
						order[23] = 41889
						order[24] = 41890
						order[25] = 40680
						order[26] = 40681
						order[27] = 40682
						order[28] = 40683
						order[29] = 40684
						order[30] = 40685
						order[31] = 40704
						order[32] = 40686
						order[33] = 40687
						order[34] = 40688
						order[35] = 40689
						order[36] = 40966
						order[37] = 40691
						order[38] = 40692
						order[39] = 40693
						order[40] = 41891
						order[41] = 41892
						order[42] = 40694
						order[43] = 41878
						order[44] = 41893
						order[45] = 41894
						order[46] = 41895
						order[47] = 41896
						order[48] = 40695
						order[49] = 40696
						order[50] = 40697
						order[51] = 40698
						order[52] = 40967
						order[53] = 40700
						order[54] = 40701
						order[55] = 40702
						order[56] = 40703
						order[57] = 0
						super(40664, 40665, order)
					end

					class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40705
							order[1] = 40706
							order[2] = 40707
							order[3] = 0
							super(40704, 40705, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40690
							order[1] = 0
							super(40966, 40690, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41879
							order[1] = 41880
							order[2] = 0
							super(41878, 41879, order)
						end
					end

					class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40699
							order[1] = 0
							super(40967, 40699, order)
						end
					end
				end

				class NoUnderlyingPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40709
						order[1] = 40710
						order[2] = 42993
						order[3] = 42994
						order[4] = 42995
						order[5] = 42996
						order[6] = 42997
						order[7] = 42998
						order[8] = 42999
						order[9] = 42984
						order[10] = 42985
						order[11] = 42986
						order[12] = 42987
						order[13] = 42988
						order[14] = 42989
						order[15] = 42990
						order[16] = 40711
						order[17] = 40712
						order[18] = 40713
						order[19] = 40714
						order[20] = 40715
						order[21] = 40716
						order[22] = 40717
						order[23] = 40718
						order[24] = 40719
						order[25] = 40720
						order[26] = 40721
						order[27] = 40722
						order[28] = 40723
						order[29] = 40724
						order[30] = 40725
						order[31] = 40726
						order[32] = 40727
						order[33] = 40728
						order[34] = 40729
						order[35] = 40730
						order[36] = 40731
						order[37] = 40732
						order[38] = 40733
						order[39] = 40734
						order[40] = 40735
						order[41] = 40736
						order[42] = 40737
						order[43] = 0
						super(40708, 40709, order)
					end

					class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43001
							order[1] = 0
							super(43000, 43001, order)
						end
					end

					class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42992
							order[1] = 0
							super(42991, 42992, order)
						end
					end
				end

				class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41809
						order[1] = 0
						super(41808, 41809, order)
					end
				end

				class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41805
						order[1] = 41806
						order[2] = 41807
						order[3] = 0
						super(41804, 41805, order)
					end
				end

				class NoUnderlyingDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41757
						order[1] = 41758
						order[2] = 41759
						order[3] = 41760
						order[4] = 41761
						order[5] = 41762
						order[6] = 41763
						order[7] = 41764
						order[8] = 41765
						order[9] = 41766
						order[10] = 41767
						order[11] = 41768
						order[12] = 41769
						order[13] = 41770
						order[14] = 0
						super(41756, 41757, order)
					end

					class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41771
							order[1] = 41772
							order[2] = 41773
							order[3] = 0
							super(41770, 41771, order)
						end

						class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41774
								order[1] = 41775
								order[2] = 41776
								order[3] = 0
								super(41773, 41774, order)
							end
						end
					end
				end
			end

			class NoUnderlyingProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 42150
					order[1] = 42151
					order[2] = 42152
					order[3] = 42190
					order[4] = 42153
					order[5] = 42154
					order[6] = 42155
					order[7] = 43002
					order[8] = 43003
					order[9] = 42156
					order[10] = 42157
					order[11] = 42158
					order[12] = 42104
					order[13] = 42105
					order[14] = 42106
					order[15] = 42107
					order[16] = 42108
					order[17] = 42109
					order[18] = 42110
					order[19] = 42111
					order[20] = 42115
					order[21] = 42116
					order[22] = 42117
					order[23] = 42118
					order[24] = 42119
					order[25] = 42120
					order[26] = 42121
					order[27] = 42122
					order[28] = 42123
					order[29] = 42124
					order[30] = 42125
					order[31] = 42126
					order[32] = 42127
					order[33] = 42128
					order[34] = 42129
					order[35] = 42130
					order[36] = 42131
					order[37] = 42132
					order[38] = 42133
					order[39] = 42134
					order[40] = 42135
					order[41] = 42136
					order[42] = 42137
					order[43] = 42138
					order[44] = 42139
					order[45] = 42140
					order[46] = 42141
					order[47] = 42142
					order[48] = 42143
					order[49] = 42144
					order[50] = 42145
					order[51] = 42146
					order[52] = 42147
					order[53] = 42148
					order[54] = 42159
					order[55] = 42160
					order[56] = 42161
					order[57] = 42162
					order[58] = 42163
					order[59] = 42164
					order[60] = 42165
					order[61] = 42092
					order[62] = 42093
					order[63] = 42094
					order[64] = 42095
					order[65] = 42096
					order[66] = 42097
					order[67] = 42098
					order[68] = 42166
					order[69] = 42167
					order[70] = 42168
					order[71] = 42169
					order[72] = 42102
					order[73] = 42103
					order[74] = 42170
					order[75] = 42171
					order[76] = 42172
					order[77] = 42173
					order[78] = 0
					super(42149, 42150, order)
				end

				class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42191
						order[1] = 0
						super(42190, 42191, order)
					end
				end

				class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42183
						order[1] = 0
						super(42182, 42183, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42185
						order[1] = 0
						super(42184, 42185, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42113
						order[1] = 42114
						order[2] = 0
						super(42112, 42113, order)
					end
				end

				class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42187
						order[1] = 0
						super(42186, 42187, order)
					end
				end

				class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42189
						order[1] = 0
						super(42188, 42189, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42181
						order[1] = 0
						super(42180, 42181, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42100
						order[1] = 42101
						order[2] = 0
						super(42099, 42100, order)
					end
				end

				class NoUnderlyingProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 42174
						order[1] = 42175
						order[2] = 42176
						order[3] = 40918
						order[4] = 42177
						order[5] = 0
						super(42173, 42174, order)
					end

					class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42178
							order[1] = 42179
							order[2] = 0
							super(42177, 42178, order)
						end
					end
				end
			end

			class NoUnderlyingAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42037
					order[1] = 42038
					order[2] = 41340
					order[3] = 0
					super(42036, 42037, order)
				end

				class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41341
						order[1] = 41701
						order[2] = 41709
						order[3] = 41710
						order[4] = 41711
						order[5] = 41712
						order[6] = 42017
						order[7] = 42025
						order[8] = 42026
						order[9] = 42027
						order[10] = 42028
						order[11] = 42029
						order[12] = 42030
						order[13] = 42031
						order[14] = 42032
						order[15] = 42033
						order[16] = 42034
						order[17] = 42035
						order[18] = 0
						super(41340, 41341, order)
					end
				end
			end

			class NoUnderlyingProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 42069
					order[1] = 42070
					order[2] = 42071
					order[3] = 42072
					order[4] = 42073
					order[5] = 42074
					order[6] = 42075
					order[7] = 42090
					order[8] = 42077
					order[9] = 42087
					order[10] = 42076
					order[11] = 0
					super(42068, 42069, order)
				end

				class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42091
						order[1] = 0
						super(42090, 42091, order)
					end
				end

				class NoUnderlyingProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 42078
						order[1] = 42079
						order[2] = 42080
						order[3] = 42081
						order[4] = 42082
						order[5] = 42083
						order[6] = 42084
						order[7] = 42085
						order[8] = 0
						super(42077, 42078, order)
					end

					class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42086
							order[1] = 0
							super(42085, 42086, order)
						end
					end
				end

				class NoUnderlyingProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42088
						order[1] = 42089
						order[2] = 0
						super(42087, 42088, order)
					end
				end
			end

			class NoUnderlyingCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 42042
					order[1] = 42043
					order[2] = 42044
					order[3] = 42045
					order[4] = 42046
					order[5] = 42047
					order[6] = 42048
					order[7] = 42049
					order[8] = 42050
					order[9] = 42051
					order[10] = 42052
					order[11] = 42039
					order[12] = 42797
					order[13] = 42798
					order[14] = 42053
					order[15] = 42054
					order[16] = 42790
					order[17] = 42791
					order[18] = 42792
					order[19] = 42793
					order[20] = 42794
					order[21] = 42795
					order[22] = 42796
					order[23] = 42055
					order[24] = 42056
					order[25] = 42057
					order[26] = 42058
					order[27] = 42059
					order[28] = 0
					super(42041, 42042, order)
				end

				class NoUnderlyingCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42040
						order[1] = 0
						super(42039, 42040, order)
					end
				end

				class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42789
						order[1] = 0
						super(42788, 42789, order)
					end
				end
			end

			class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42065
					order[1] = 42061
					order[2] = 42062
					order[3] = 42063
					order[4] = 42064
					order[5] = 0
					super(42060, 42065, order)
				end

				class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42066
						order[1] = 42067
						order[2] = 0
						super(42065, 42066, order)
					end
				end
			end

			class NoUnderlyingRateSpreadSteps < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 43006
					order[1] = 43007
					order[2] = 0
					super(43005, 43006, order)
				end
			end

			class NoUnderlyingDividendPayments < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42856
					order[1] = 42857
					order[2] = 42858
					order[3] = 42859
					order[4] = 0
					super(42855, 42856, order)
				end
			end

			class NoUnderlyingExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42885
					order[1] = 42886
					order[2] = 0
					super(42884, 42885, order)
				end
			end
		end

		class NoLegs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(176)
				order[0] = 600
				order[1] = 601
				order[2] = 602
				order[3] = 603
				order[4] = 1788
				order[5] = 607
				order[6] = 1594
				order[7] = 608
				order[8] = 2893
				order[9] = 609
				order[10] = 764
				order[11] = 610
				order[12] = 611
				order[13] = 1212
				order[14] = 2146
				order[15] = 2147
				order[16] = 2148
				order[17] = 248
				order[18] = 2149
				order[19] = 2150
				order[20] = 2151
				order[21] = 2152
				order[22] = 2153
				order[23] = 2154
				order[24] = 2155
				order[25] = 2348
				order[26] = 2067
				order[27] = 2068
				order[28] = 2069
				order[29] = 2739
				order[30] = 2070
				order[31] = 2156
				order[32] = 2157
				order[33] = 2158
				order[34] = 2159
				order[35] = 2160
				order[36] = 2161
				order[37] = 2162
				order[38] = 2163
				order[39] = 2164
				order[40] = 2165
				order[41] = 2880
				order[42] = 2166
				order[43] = 2167
				order[44] = 2168
				order[45] = 2169
				order[46] = 2170
				order[47] = 2171
				order[48] = 2172
				order[49] = 2173
				order[50] = 2174
				order[51] = 2175
				order[52] = 2176
				order[53] = 2177
				order[54] = 2178
				order[55] = 2179
				order[56] = 2180
				order[57] = 249
				order[58] = 250
				order[59] = 251
				order[60] = 252
				order[61] = 253
				order[62] = 257
				order[63] = 599
				order[64] = 596
				order[65] = 597
				order[66] = 598
				order[67] = 254
				order[68] = 612
				order[69] = 942
				order[70] = 2908
				order[71] = 2181
				order[72] = 2182
				order[73] = 2183
				order[74] = 2184
				order[75] = 2604
				order[76] = 2185
				order[77] = 2605
				order[78] = 2186
				order[79] = 2187
				order[80] = 2188
				order[81] = 2189
				order[82] = 613
				order[83] = 614
				order[84] = 1436
				order[85] = 2354
				order[86] = 1440
				order[87] = 2190
				order[88] = 2191
				order[89] = 999
				order[90] = 1224
				order[91] = 1720
				order[92] = 2909
				order[93] = 1421
				order[94] = 1422
				order[95] = 1721
				order[96] = 2910
				order[97] = 2192
				order[98] = 1001
				order[99] = 1420
				order[100] = 2193
				order[101] = 2194
				order[102] = 2755
				order[103] = 2195
				order[104] = 2196
				order[105] = 2197
				order[106] = 2198
				order[107] = 1528
				order[108] = 2911
				order[109] = 2199
				order[110] = 2200
				order[111] = 2201
				order[112] = 2202
				order[113] = 2203
				order[114] = 615
				order[115] = 616
				order[116] = 2205
				order[117] = 2206
				order[118] = 617
				order[119] = 618
				order[120] = 619
				order[121] = 2740
				order[122] = 2717
				order[123] = 2718
				order[124] = 2719
				order[125] = 620
				order[126] = 621
				order[127] = 622
				order[128] = 2207
				order[129] = 2208
				order[130] = 623
				order[131] = 624
				order[132] = 556
				order[133] = 2898
				order[134] = 740
				order[135] = 739
				order[136] = 955
				order[137] = 956
				order[138] = 1358
				order[139] = 2682
				order[140] = 2686
				order[141] = 1017
				order[142] = 566
				order[143] = 2209
				order[144] = 2211
				order[145] = 2212
				order[146] = 2213
				order[147] = 2754
				order[148] = 2214
				order[149] = 2215
				order[150] = 2606
				order[151] = 2607
				order[152] = 2497
				order[153] = 2498
				order[154] = 2499
				order[155] = 2496
				order[156] = 2495
				order[157] = 2953
				order[158] = 2511
				order[159] = 2510
				order[160] = 2512
				order[161] = 2509
				order[162] = 2500
				order[163] = 2502
				order[164] = 2501
				order[165] = 2503
				order[166] = 2507
				order[167] = 2505
				order[168] = 2494
				order[169] = 2493
				order[170] = 2514
				order[171] = 2513
				order[172] = 2506
				order[173] = 2504
				order[174] = 2508
				order[175] = 0
				super(555, 600, order)
			end

			class NoLegSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 605
					order[1] = 606
					order[2] = 2958
					order[3] = 0
					super(604, 605, order)
				end
			end

			class NoLegSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2077
					order[1] = 2078
					order[2] = 2079
					order[3] = 2743
					order[4] = 0
					super(2076, 2077, order)
				end
			end

			class NoLegAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2309
					order[1] = 2310
					order[2] = 2311
					order[3] = 0
					super(2308, 2309, order)
				end
			end

			class NoLegEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 2060
					order[1] = 2061
					order[2] = 2062
					order[3] = 2063
					order[4] = 2064
					order[5] = 2341
					order[6] = 2065
					order[7] = 2066
					order[8] = 2074
					order[9] = 2075
					order[10] = 0
					super(2059, 2060, order)
				end
			end

			class NoLegInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 2255
					order[1] = 2256
					order[2] = 2257
					order[3] = 2379
					order[4] = 2258
					order[5] = 0
					super(2254, 2255, order)
				end

				class NoLegInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2259
						order[1] = 2260
						order[2] = 0
						super(2258, 2259, order)
					end
				end
			end

			class NoLegComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2219
					order[1] = 2220
					order[2] = 2221
					order[3] = 2222
					order[4] = 2223
					order[5] = 2224
					order[6] = 2225
					order[7] = 2226
					order[8] = 2944
					order[9] = 2227
					order[10] = 2228
					order[11] = 2229
					order[12] = 2230
					order[13] = 2231
					order[14] = 2232
					order[15] = 2250
					order[16] = 2233
					order[17] = 2945
					order[18] = 2234
					order[19] = 2946
					order[20] = 2235
					order[21] = 2236
					order[22] = 2409
					order[23] = 2410
					order[24] = 2237
					order[25] = 2238
					order[26] = 2239
					order[27] = 2240
					order[28] = 2241
					order[29] = 41382
					order[30] = 41389
					order[31] = 41390
					order[32] = 41391
					order[33] = 41392
					order[34] = 41393
					order[35] = 41394
					order[36] = 41395
					order[37] = 41396
					order[38] = 41397
					order[39] = 41379
					order[40] = 2242
					order[41] = 2243
					order[42] = 2244
					order[43] = 2245
					order[44] = 2246
					order[45] = 41398
					order[46] = 41366
					order[47] = 2608
					order[48] = 2609
					order[49] = 2610
					order[50] = 2248
					order[51] = 2249
					order[52] = 0
					super(2218, 2219, order)
				end

				class NoLegComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2251
						order[1] = 2252
						order[2] = 2253
						order[3] = 0
						super(2250, 2251, order)
					end

					class NoLegComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2204
							order[1] = 2247
							order[2] = 0
							super(2253, 2204, order)
						end
					end
				end

				class NoLegComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41383
						order[1] = 41384
						order[2] = 41385
						order[3] = 41386
						order[4] = 0
						super(41382, 41383, order)
					end
				end

				class NoLegComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41388
						order[1] = 0
						super(41387, 41388, order)
					end
				end

				class NoLegComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41380
						order[1] = 41381
						order[2] = 41400
						order[3] = 41376
						order[4] = 41363
						order[5] = 0
						super(41379, 41380, order)
					end

					class NoLegComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41401
							order[1] = 41402
							order[2] = 41403
							order[3] = 41404
							order[4] = 41405
							order[5] = 0
							super(41400, 41401, order)
						end
					end

					class NoLegComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41377
							order[1] = 41378
							order[2] = 0
							super(41376, 41377, order)
						end
					end

					class NoLegComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41364
							order[1] = 41365
							order[2] = 0
							super(41363, 41364, order)
						end
					end
				end

				class NoLegComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41399
						order[1] = 0
						super(41398, 41399, order)
					end
				end

				class NoLegComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41367
						order[1] = 41368
						order[2] = 41369
						order[3] = 41370
						order[4] = 41371
						order[5] = 41372
						order[6] = 41373
						order[7] = 41374
						order[8] = 0
						super(41366, 41367, order)
					end

					class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41375
							order[1] = 0
							super(41374, 41375, order)
						end
					end
				end
			end

			class NoLegBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40924
					order[1] = 0
					super(40923, 40924, order)
				end
			end

			class NoLegPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41608
					order[1] = 0
					super(41607, 41608, order)
				end
			end

			class NoLegMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41468
					order[1] = 40223
					order[2] = 0
					super(41467, 41468, order)
				end
			end

			class NoLegMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41470
					order[1] = 40990
					order[2] = 0
					super(41469, 41470, order)
				end
			end

			class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41472
					order[1] = 41473
					order[2] = 41474
					order[3] = 41475
					order[4] = 41476
					order[5] = 41477
					order[6] = 41478
					order[7] = 41479
					order[8] = 41480
					order[9] = 0
					super(41471, 41472, order)
				end
			end

			class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42582
					order[1] = 0
					super(42581, 42582, order)
				end
			end

			class NoLegOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41492
					order[1] = 0
					super(41491, 41492, order)
				end
			end

			class NoLegOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41513
					order[1] = 41514
					order[2] = 0
					super(41512, 41513, order)
				end
			end

			class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41516
					order[1] = 0
					super(41515, 41516, order)
				end
			end

			class NoLegOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41528
					order[1] = 41529
					order[2] = 0
					super(41527, 41528, order)
				end
			end

			class NoLegStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40242
					order[1] = 41700
					order[2] = 40243
					order[3] = 42583
					order[4] = 42584
					order[5] = 40244
					order[6] = 40245
					order[7] = 41702
					order[8] = 40246
					order[9] = 40247
					order[10] = 42585
					order[11] = 42586
					order[12] = 41703
					order[13] = 41704
					order[14] = 41705
					order[15] = 41706
					order[16] = 41707
					order[17] = 41708
					order[18] = 41648
					order[19] = 41649
					order[20] = 41650
					order[21] = 41651
					order[22] = 41652
					order[23] = 41653
					order[24] = 41654
					order[25] = 42588
					order[26] = 41655
					order[27] = 41656
					order[28] = 41657
					order[29] = 41658
					order[30] = 41659
					order[31] = 41660
					order[32] = 41661
					order[33] = 41662
					order[34] = 41663
					order[35] = 41664
					order[36] = 41665
					order[37] = 41666
					order[38] = 41667
					order[39] = 41668
					order[40] = 41669
					order[41] = 41670
					order[42] = 41671
					order[43] = 41672
					order[44] = 41673
					order[45] = 40249
					order[46] = 40250
					order[47] = 40252
					order[48] = 40253
					order[49] = 40254
					order[50] = 40255
					order[51] = 40256
					order[52] = 40257
					order[53] = 40258
					order[54] = 40260
					order[55] = 40261
					order[56] = 40262
					order[57] = 40263
					order[58] = 40264
					order[59] = 41641
					order[60] = 41642
					order[61] = 40265
					order[62] = 40267
					order[63] = 40268
					order[64] = 40270
					order[65] = 40271
					order[66] = 40272
					order[67] = 40273
					order[68] = 40274
					order[69] = 40275
					order[70] = 40276
					order[71] = 41643
					order[72] = 41644
					order[73] = 41645
					order[74] = 40279
					order[75] = 40280
					order[76] = 40281
					order[77] = 42399
					order[78] = 40282
					order[79] = 40283
					order[80] = 43108
					order[81] = 40284
					order[82] = 40285
					order[83] = 40286
					order[84] = 40287
					order[85] = 40288
					order[86] = 42400
					order[87] = 42401
					order[88] = 42402
					order[89] = 42403
					order[90] = 40289
					order[91] = 40290
					order[92] = 40291
					order[93] = 41549
					order[94] = 41550
					order[95] = 41551
					order[96] = 41552
					order[97] = 41553
					order[98] = 41554
					order[99] = 41555
					order[100] = 42404
					order[101] = 40374
					order[102] = 40418
					order[103] = 41429
					order[104] = 41430
					order[105] = 41431
					order[106] = 41432
					order[107] = 41433
					order[108] = 42194
					order[109] = 42195
					order[110] = 41434
					order[111] = 41435
					order[112] = 41436
					order[113] = 41437
					order[114] = 41438
					order[115] = 41219
					order[116] = 41439
					order[117] = 41440
					order[118] = 41441
					order[119] = 41442
					order[120] = 41443
					order[121] = 41444
					order[122] = 41445
					order[123] = 41446
					order[124] = 41447
					order[125] = 41448
					order[126] = 41449
					order[127] = 41450
					order[128] = 41451
					order[129] = 43095
					order[130] = 41408
					order[131] = 40248
					order[132] = 40978
					order[133] = 40979
					order[134] = 0
					super(40241, 40242, order)
				end

				class NoLegStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41675
						order[1] = 41676
						order[2] = 0
						super(41674, 41675, order)
					end
				end

				class NoLegStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41453
						order[1] = 41454
						order[2] = 41455
						order[3] = 0
						super(41452, 41453, order)
					end
				end

				class NoLegStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41678
						order[1] = 41679
						order[2] = 0
						super(41677, 41678, order)
					end
				end

				class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41647
						order[1] = 0
						super(41646, 41647, order)
					end
				end

				class NoLegStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41687
						order[1] = 41688
						order[2] = 41689
						order[3] = 41690
						order[4] = 41691
						order[5] = 41692
						order[6] = 41693
						order[7] = 41694
						order[8] = 41695
						order[9] = 41696
						order[10] = 41697
						order[11] = 41680
						order[12] = 41698
						order[13] = 41699
						order[14] = 0
						super(41686, 41687, order)
					end

					class NoLegStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41681
							order[1] = 41682
							order[2] = 41683
							order[3] = 0
							super(41680, 41681, order)
						end

						class NoLegStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41684
								order[1] = 41685
								order[2] = 41935
								order[3] = 0
								super(41683, 41684, order)
							end
						end
					end
				end

				class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40251
						order[1] = 0
						super(40942, 40251, order)
					end
				end

				class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40259
						order[1] = 0
						super(40943, 40259, order)
					end
				end

				class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40266
						order[1] = 0
						super(40940, 40266, order)
					end
				end

				class NoLegStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41639
						order[1] = 41640
						order[2] = 0
						super(41638, 41639, order)
					end
				end

				class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40269
						order[1] = 0
						super(40941, 40269, order)
					end
				end

				class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40293
						order[1] = 0
						super(40930, 40293, order)
					end
				end

				class NoLegPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41590
						order[1] = 41591
						order[2] = 0
						super(41589, 41590, order)
					end
				end

				class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40305
						order[1] = 0
						super(40931, 40305, order)
					end
				end

				class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40311
						order[1] = 0
						super(40932, 40311, order)
					end
				end

				class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40318
						order[1] = 0
						super(40933, 40318, order)
					end
				end

				class NoLegPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42460
						order[1] = 42461
						order[2] = 0
						super(42459, 42460, order)
					end
				end

				class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41562
						order[1] = 0
						super(41561, 41562, order)
					end
				end

				class NoLegPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41597
						order[1] = 41598
						order[2] = 0
						super(41596, 41597, order)
					end
				end

				class NoLegPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41594
						order[1] = 41595
						order[2] = 0
						super(41593, 41594, order)
					end
				end

				class NoLegPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43110
						order[1] = 42486
						order[2] = 42487
						order[3] = 0
						super(42485, 43110, order)
					end
				end

				class NoLegDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42367
						order[1] = 42368
						order[2] = 42369
						order[3] = 42370
						order[4] = 42371
						order[5] = 42372
						order[6] = 42386
						order[7] = 42373
						order[8] = 42374
						order[9] = 42375
						order[10] = 42376
						order[11] = 42377
						order[12] = 42378
						order[13] = 42379
						order[14] = 42380
						order[15] = 42381
						order[16] = 42382
						order[17] = 42383
						order[18] = 42384
						order[19] = 42385
						order[20] = 0
						super(42366, 42367, order)
					end

					class NoLegDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42387
							order[1] = 0
							super(42386, 42387, order)
						end
					end
				end

				class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42365
						order[1] = 0
						super(42364, 42365, order)
					end
				end

				class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42311
						order[1] = 0
						super(42310, 42311, order)
					end
				end

				class NoLegReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 42535
						order[1] = 42536
						order[2] = 42537
						order[3] = 42538
						order[4] = 42539
						order[5] = 42540
						order[6] = 42564
						order[7] = 42530
						order[8] = 42541
						order[9] = 42542
						order[10] = 42543
						order[11] = 42544
						order[12] = 42545
						order[13] = 42546
						order[14] = 42547
						order[15] = 42548
						order[16] = 42549
						order[17] = 42550
						order[18] = 42551
						order[19] = 42552
						order[20] = 42560
						order[21] = 42553
						order[22] = 42554
						order[23] = 42508
						order[24] = 42555
						order[25] = 42556
						order[26] = 42557
						order[27] = 42558
						order[28] = 42559
						order[29] = 0
						super(42534, 42535, order)
					end

					class NoLegReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 42565
							order[1] = 42566
							order[2] = 42567
							order[3] = 42568
							order[4] = 0
							super(42564, 42565, order)
						end
					end

					class NoLegReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42531
							order[1] = 42532
							order[2] = 42533
							order[3] = 0
							super(42530, 42531, order)
						end
					end

					class NoLegReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42561
							order[1] = 42562
							order[2] = 42563
							order[3] = 0
							super(42560, 42561, order)
						end
					end

					class NoLegReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 42509
							order[1] = 42571
							order[2] = 42510
							order[3] = 42511
							order[4] = 42512
							order[5] = 42513
							order[6] = 42514
							order[7] = 42515
							order[8] = 42516
							order[9] = 42517
							order[10] = 42518
							order[11] = 42519
							order[12] = 42520
							order[13] = 42521
							order[14] = 42522
							order[15] = 42523
							order[16] = 42524
							order[17] = 42525
							order[18] = 42526
							order[19] = 42527
							order[20] = 42528
							order[21] = 42529
							order[22] = 42569
							order[23] = 0
							super(42508, 42509, order)
						end

						class NoLegReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 42572
								order[1] = 42573
								order[2] = 0
								super(42571, 42572, order)
							end
						end

						class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 42570
								order[1] = 0
								super(42569, 42570, order)
							end
						end
					end
				end

				class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42420
						order[1] = 0
						super(42419, 42420, order)
					end
				end

				class NoLegPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42406
						order[1] = 42407
						order[2] = 0
						super(42405, 42406, order)
					end
				end

				class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40361
						order[1] = 0
						super(40929, 40361, order)
					end
				end

				class NoLegNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40368
						order[1] = 40369
						order[2] = 0
						super(40367, 40368, order)
					end
				end

				class NoLegSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40903
						order[1] = 40366
						order[2] = 40370
						order[3] = 40905
						order[4] = 40906
						order[5] = 0
						super(40902, 40903, order)
					end
				end

				class NoLegPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40375
						order[1] = 41533
						order[2] = 41534
						order[3] = 40376
						order[4] = 40377
						order[5] = 40378
						order[6] = 40379
						order[7] = 40380
						order[8] = 40381
						order[9] = 40382
						order[10] = 40383
						order[11] = 40384
						order[12] = 40385
						order[13] = 41535
						order[14] = 41536
						order[15] = 41537
						order[16] = 41538
						order[17] = 40386
						order[18] = 40387
						order[19] = 40388
						order[20] = 40389
						order[21] = 41539
						order[22] = 41540
						order[23] = 41541
						order[24] = 41542
						order[25] = 40390
						order[26] = 40391
						order[27] = 40392
						order[28] = 40393
						order[29] = 40394
						order[30] = 40395
						order[31] = 40414
						order[32] = 40396
						order[33] = 40397
						order[34] = 40398
						order[35] = 40399
						order[36] = 40927
						order[37] = 40401
						order[38] = 40402
						order[39] = 40403
						order[40] = 41543
						order[41] = 41544
						order[42] = 40404
						order[43] = 41530
						order[44] = 41545
						order[45] = 41546
						order[46] = 41547
						order[47] = 41548
						order[48] = 40405
						order[49] = 40406
						order[50] = 40407
						order[51] = 40408
						order[52] = 40928
						order[53] = 40410
						order[54] = 40411
						order[55] = 40412
						order[56] = 40413
						order[57] = 0
						super(40374, 40375, order)
					end

					class NoLegPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40415
							order[1] = 40416
							order[2] = 40417
							order[3] = 0
							super(40414, 40415, order)
						end
					end

					class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40400
							order[1] = 0
							super(40927, 40400, order)
						end
					end

					class NoLegPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41531
							order[1] = 41532
							order[2] = 0
							super(41530, 41531, order)
						end
					end

					class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40409
							order[1] = 0
							super(40928, 40409, order)
						end
					end
				end

				class NoLegPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40419
						order[1] = 40420
						order[2] = 42497
						order[3] = 42498
						order[4] = 42499
						order[5] = 42500
						order[6] = 42501
						order[7] = 42502
						order[8] = 42503
						order[9] = 42488
						order[10] = 42489
						order[11] = 42490
						order[12] = 42491
						order[13] = 42492
						order[14] = 42493
						order[15] = 42494
						order[16] = 40421
						order[17] = 40422
						order[18] = 40423
						order[19] = 40424
						order[20] = 40425
						order[21] = 40426
						order[22] = 40427
						order[23] = 40428
						order[24] = 40429
						order[25] = 40430
						order[26] = 40431
						order[27] = 40432
						order[28] = 40433
						order[29] = 40434
						order[30] = 40435
						order[31] = 40436
						order[32] = 40437
						order[33] = 40438
						order[34] = 40439
						order[35] = 40440
						order[36] = 40441
						order[37] = 40442
						order[38] = 40443
						order[39] = 40444
						order[40] = 40445
						order[41] = 40446
						order[42] = 40447
						order[43] = 0
						super(40418, 40419, order)
					end

					class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42505
							order[1] = 0
							super(42504, 42505, order)
						end
					end

					class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42496
							order[1] = 0
							super(42495, 42496, order)
						end
					end
				end

				class NoLegDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41461
						order[1] = 0
						super(41460, 41461, order)
					end
				end

				class NoLegDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41457
						order[1] = 41458
						order[2] = 41459
						order[3] = 0
						super(41456, 41457, order)
					end
				end

				class NoLegDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41409
						order[1] = 41410
						order[2] = 41411
						order[3] = 41412
						order[4] = 41413
						order[5] = 41414
						order[6] = 41415
						order[7] = 41416
						order[8] = 41417
						order[9] = 41418
						order[10] = 41419
						order[11] = 41420
						order[12] = 41421
						order[13] = 41422
						order[14] = 0
						super(41408, 41409, order)
					end

					class NoLegDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41423
							order[1] = 41424
							order[2] = 41425
							order[3] = 0
							super(41422, 41423, order)
						end

						class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41426
								order[1] = 41427
								order[2] = 41428
								order[3] = 0
								super(41425, 41426, order)
							end
						end
					end
				end
			end

			class NoLegProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 40449
					order[1] = 40450
					order[2] = 40451
					order[3] = 40939
					order[4] = 40453
					order[5] = 40454
					order[6] = 40455
					order[7] = 42506
					order[8] = 42507
					order[9] = 40456
					order[10] = 40457
					order[11] = 40458
					order[12] = 40524
					order[13] = 40525
					order[14] = 40526
					order[15] = 40528
					order[16] = 40529
					order[17] = 40530
					order[18] = 40531
					order[19] = 40532
					order[20] = 40476
					order[21] = 40478
					order[22] = 40479
					order[23] = 40480
					order[24] = 40481
					order[25] = 40482
					order[26] = 40483
					order[27] = 40484
					order[28] = 40485
					order[29] = 40486
					order[30] = 40487
					order[31] = 40488
					order[32] = 40489
					order[33] = 40490
					order[34] = 40491
					order[35] = 40492
					order[36] = 40493
					order[37] = 40494
					order[38] = 40498
					order[39] = 40499
					order[40] = 40501
					order[41] = 40502
					order[42] = 40503
					order[43] = 40504
					order[44] = 40505
					order[45] = 40506
					order[46] = 40507
					order[47] = 40508
					order[48] = 40509
					order[49] = 40511
					order[50] = 40512
					order[51] = 40513
					order[52] = 40514
					order[53] = 40515
					order[54] = 40459
					order[55] = 40460
					order[56] = 40461
					order[57] = 40462
					order[58] = 40463
					order[59] = 40464
					order[60] = 40465
					order[61] = 40516
					order[62] = 40518
					order[63] = 40519
					order[64] = 40520
					order[65] = 40521
					order[66] = 40522
					order[67] = 40523
					order[68] = 40466
					order[69] = 40467
					order[70] = 40468
					order[71] = 40469
					order[72] = 40470
					order[73] = 41407
					order[74] = 40472
					order[75] = 40980
					order[76] = 40981
					order[77] = 40533
					order[78] = 0
					super(40448, 40449, order)
				end

				class NoLegProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40452
						order[1] = 0
						super(40939, 40452, order)
					end
				end

				class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40527
						order[1] = 0
						super(40935, 40527, order)
					end
				end

				class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40477
						order[1] = 0
						super(40936, 40477, order)
					end
				end

				class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40496
						order[1] = 40497
						order[2] = 0
						super(40495, 40496, order)
					end
				end

				class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40500
						order[1] = 0
						super(40937, 40500, order)
					end
				end

				class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40510
						order[1] = 0
						super(40938, 40510, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40517
						order[1] = 0
						super(40934, 40517, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40474
						order[1] = 40475
						order[2] = 0
						super(40473, 40474, order)
					end
				end

				class NoLegProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40534
						order[1] = 40535
						order[2] = 40536
						order[3] = 2380
						order[4] = 40537
						order[5] = 0
						super(40533, 40534, order)
					end

					class NoLegProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40538
							order[1] = 40539
							order[2] = 0
							super(40537, 40538, order)
						end
					end
				end
			end

			class NoLegAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41336
					order[1] = 41337
					order[2] = 41316
					order[3] = 0
					super(41335, 41336, order)
				end

				class NoLegAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41317
						order[1] = 41318
						order[2] = 41319
						order[3] = 41320
						order[4] = 41321
						order[5] = 41322
						order[6] = 41323
						order[7] = 41324
						order[8] = 41325
						order[9] = 41326
						order[10] = 41327
						order[11] = 41328
						order[12] = 41329
						order[13] = 41330
						order[14] = 41331
						order[15] = 41332
						order[16] = 41333
						order[17] = 41334
						order[18] = 0
						super(41316, 41317, order)
					end
				end
			end

			class NoLegProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 41618
					order[1] = 41619
					order[2] = 41620
					order[3] = 41621
					order[4] = 41622
					order[5] = 41623
					order[6] = 41624
					order[7] = 41614
					order[8] = 41625
					order[9] = 41635
					order[10] = 41617
					order[11] = 0
					super(41616, 41618, order)
				end

				class NoLegProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41615
						order[1] = 0
						super(41614, 41615, order)
					end
				end

				class NoLegProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41626
						order[1] = 41627
						order[2] = 41628
						order[3] = 41629
						order[4] = 41630
						order[5] = 41631
						order[6] = 41632
						order[7] = 41633
						order[8] = 0
						super(41625, 41626, order)
					end

					class NoLegProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41634
							order[1] = 0
							super(41633, 41634, order)
						end
					end
				end

				class NoLegProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41636
						order[1] = 41637
						order[2] = 0
						super(41635, 41636, order)
					end
				end
			end

			class NoLegCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 41345
					order[1] = 41346
					order[2] = 41347
					order[3] = 41348
					order[4] = 41349
					order[5] = 41350
					order[6] = 41351
					order[7] = 41352
					order[8] = 41353
					order[9] = 41354
					order[10] = 41355
					order[11] = 41342
					order[12] = 42308
					order[13] = 42309
					order[14] = 41356
					order[15] = 41357
					order[16] = 42299
					order[17] = 42300
					order[18] = 42301
					order[19] = 42302
					order[20] = 42303
					order[21] = 42304
					order[22] = 42305
					order[23] = 41358
					order[24] = 41359
					order[25] = 41360
					order[26] = 41361
					order[27] = 41362
					order[28] = 0
					super(41344, 41345, order)
				end

				class NoLegCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41343
						order[1] = 0
						super(41342, 41343, order)
					end
				end

				class NoLegCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42307
						order[1] = 0
						super(42306, 42307, order)
					end
				end
			end

			class NoLegPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41604
					order[1] = 41601
					order[2] = 41602
					order[3] = 41603
					order[4] = 41600
					order[5] = 0
					super(41599, 41604, order)
				end

				class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41605
						order[1] = 41606
						order[2] = 0
						super(41604, 41605, order)
					end
				end
			end

			class NoLegExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42389
					order[1] = 42390
					order[2] = 0
					super(42388, 42389, order)
				end
			end

			class NoLegContractualDefinitions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42199
					order[1] = 0
					super(42198, 42199, order)
				end
			end

			class NoLegFinancingTermSupplements < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42201
					order[1] = 42202
					order[2] = 0
					super(42200, 42201, order)
				end
			end

			class NoLegContractualMatrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42204
					order[1] = 42205
					order[2] = 42206
					order[3] = 0
					super(42203, 42204, order)
				end
			end
		end

		class NoRelatedInstruments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1648
				order[1] = 1649
				order[2] = 1650
				order[3] = 1651
				order[4] = 1652
				order[5] = 1653
				order[6] = 2413
				order[7] = 2414
				order[8] = 2415
				order[9] = 2417
				order[10] = 0
				super(1647, 1648, order)
			end
		end
	end
end

class AccountSummaryReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CQ") )
	end

	class NoSettlementAmounts < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 1701
			order[1] = 1702
			order[2] = 2903
			order[3] = 0
			super(1700, 1701, order)
		end
	end

	class NoMarginAmt < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(9)
			order[0] = 1645
			order[1] = 1644
			order[2] = 1646
			order[3] = 2088
			order[4] = 2089
			order[5] = 1714
			order[6] = 1715
			order[7] = 2851
			order[8] = 0
			super(1643, 1645, order)
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoCollateralAmounts < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(17)
			order[0] = 1704
			order[1] = 1705
			order[2] = 2929
			order[3] = 2632
			order[4] = 2090
			order[5] = 2091
			order[6] = 1706
			order[7] = 2092
			order[8] = 2093
			order[9] = 1902
			order[10] = 2350
			order[11] = 2690
			order[12] = 2689
			order[13] = 2840
			order[14] = 2845
			order[15] = 2841
			order[16] = 0
			super(1703, 1704, order)
		end

		class NoCollateralReinvestments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2844
				order[1] = 2842
				order[2] = 2843
				order[3] = 2931
				order[4] = 0
				super(2845, 2844, order)
			end
		end
	end

	class NoPayCollects < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 1708
			order[1] = 1709
			order[2] = 2955
			order[3] = 2094
			order[4] = 2095
			order[5] = 1710
			order[6] = 1711
			order[7] = 1712
			order[8] = 1713
			order[9] = 0
			super(1707, 1708, order)
		end
	end

	class NoPosAmt < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 707
			order[1] = 708
			order[2] = 2096
			order[3] = 1055
			order[4] = 2937
			order[5] = 2097
			order[6] = 2098
			order[7] = 1585
			order[8] = 2099
			order[9] = 2100
			order[10] = 2876
			order[11] = 2877
			order[12] = 0
			super(753, 707, order)
		end
	end
end

class PartyRiskLimitsUpdateReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CR") )
	end

	class NoRequestingPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1658
			order[1] = 1659
			order[2] = 1660
			order[3] = 2338
			order[4] = 1661
			order[5] = 0
			super(1657, 1658, order)
		end

		class NoRequestingPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1662
				order[1] = 1663
				order[2] = 0
				super(1661, 1662, order)
			end
		end
	end

	class NoPartyRiskLimits < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 1324
			order[1] = 1671
			order[2] = 1669
			order[3] = 1670
			order[4] = 2339
			order[5] = 2355
			order[6] = 0
			super(1677, 1324, order)
		end

		class NoPartyDetails < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 1691
				order[1] = 1692
				order[2] = 1693
				order[3] = 1674
				order[4] = 1694
				order[5] = 1516
				order[6] = 1562
				order[7] = 1672
				order[8] = 0
				super(1671, 1691, order)
			end

			class NoPartyDetailSubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1695
					order[1] = 1696
					order[2] = 0
					super(1694, 1695, order)
				end
			end

			class NoPartyDetailAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1517
					order[1] = 1518
					order[2] = 1519
					order[3] = 0
					super(1516, 1517, order)
				end

				class NoPartyDetailAltSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1520
						order[1] = 1521
						order[2] = 0
						super(1519, 1520, order)
					end
				end
			end

			class NoRelatedPartyDetailID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(8)
					order[0] = 1563
					order[1] = 1564
					order[2] = 1565
					order[3] = 1675
					order[4] = 1566
					order[5] = 1569
					order[6] = 1514
					order[7] = 0
					super(1562, 1563, order)
				end

				class NoRelatedPartyDetailSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1567
						order[1] = 1568
						order[2] = 0
						super(1566, 1567, order)
					end
				end

				class NoRelatedPartyDetailAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 1570
						order[1] = 1571
						order[2] = 1572
						order[3] = 0
						super(1569, 1570, order)
					end

					class NoRelatedPartyDetailAltSubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 1573
							order[1] = 1574
							order[2] = 0
							super(1572, 1573, order)
						end
					end
				end

				class NoPartyRelationships < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 1515
						order[1] = 0
						super(1514, 1515, order)
					end
				end
			end
		end

		class NoRiskLimits < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1529
				order[1] = 1534
				order[2] = 0
				super(1669, 1529, order)
			end

			class NoRiskLimitTypes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 1530
					order[1] = 1531
					order[2] = 1767
					order[3] = 1766
					order[4] = 1765
					order[5] = 1532
					order[6] = 2939
					order[7] = 1533
					order[8] = 2336
					order[9] = 2337
					order[10] = 1559
					order[11] = 0
					super(1529, 1530, order)
				end

				class NoRiskWarningLevels < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 1769
						order[1] = 1560
						order[2] = 1768
						order[3] = 1561
						order[4] = 0
						super(1559, 1769, order)
					end
				end
			end

			class NoRiskInstrumentScopes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(26)
					order[0] = 1535
					order[1] = 1536
					order[2] = 1537
					order[3] = 1538
					order[4] = 1539
					order[5] = 1543
					order[6] = 1544
					order[7] = 1545
					order[8] = 1546
					order[9] = 2895
					order[10] = 1547
					order[11] = 1548
					order[12] = 1549
					order[13] = 1550
					order[14] = 1551
					order[15] = 1552
					order[16] = 1553
					order[17] = 1554
					order[18] = 1555
					order[19] = 1616
					order[20] = 1556
					order[21] = 1620
					order[22] = 1621
					order[23] = 1557
					order[24] = 1558
					order[25] = 0
					super(1534, 1535, order)
				end

				class NoInstrumentScopeSecurityAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1541
						order[1] = 1542
						order[2] = 0
						super(1540, 1541, order)
					end
				end
			end
		end
	end
end

class PartyRiskLimitsDefinitionRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CS") )
	end

	class NoRequestingPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1658
			order[1] = 1659
			order[2] = 1660
			order[3] = 2338
			order[4] = 1661
			order[5] = 0
			super(1657, 1658, order)
		end

		class NoRequestingPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1662
				order[1] = 1663
				order[2] = 0
				super(1661, 1662, order)
			end
		end
	end

	class NoPartyRiskLimits < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 1324
			order[1] = 1671
			order[2] = 1669
			order[3] = 1670
			order[4] = 2339
			order[5] = 2355
			order[6] = 0
			super(1677, 1324, order)
		end

		class NoPartyDetails < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 1691
				order[1] = 1692
				order[2] = 1693
				order[3] = 1674
				order[4] = 1694
				order[5] = 1516
				order[6] = 1562
				order[7] = 1672
				order[8] = 0
				super(1671, 1691, order)
			end

			class NoPartyDetailSubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1695
					order[1] = 1696
					order[2] = 0
					super(1694, 1695, order)
				end
			end

			class NoPartyDetailAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1517
					order[1] = 1518
					order[2] = 1519
					order[3] = 0
					super(1516, 1517, order)
				end

				class NoPartyDetailAltSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1520
						order[1] = 1521
						order[2] = 0
						super(1519, 1520, order)
					end
				end
			end

			class NoRelatedPartyDetailID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(8)
					order[0] = 1563
					order[1] = 1564
					order[2] = 1565
					order[3] = 1675
					order[4] = 1566
					order[5] = 1569
					order[6] = 1514
					order[7] = 0
					super(1562, 1563, order)
				end

				class NoRelatedPartyDetailSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1567
						order[1] = 1568
						order[2] = 0
						super(1566, 1567, order)
					end
				end

				class NoRelatedPartyDetailAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 1570
						order[1] = 1571
						order[2] = 1572
						order[3] = 0
						super(1569, 1570, order)
					end

					class NoRelatedPartyDetailAltSubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 1573
							order[1] = 1574
							order[2] = 0
							super(1572, 1573, order)
						end
					end
				end

				class NoPartyRelationships < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 1515
						order[1] = 0
						super(1514, 1515, order)
					end
				end
			end
		end

		class NoRiskLimits < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1529
				order[1] = 1534
				order[2] = 0
				super(1669, 1529, order)
			end

			class NoRiskLimitTypes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 1530
					order[1] = 1531
					order[2] = 1767
					order[3] = 1766
					order[4] = 1765
					order[5] = 1532
					order[6] = 2939
					order[7] = 1533
					order[8] = 2336
					order[9] = 2337
					order[10] = 1559
					order[11] = 0
					super(1529, 1530, order)
				end

				class NoRiskWarningLevels < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 1769
						order[1] = 1560
						order[2] = 1768
						order[3] = 1561
						order[4] = 0
						super(1559, 1769, order)
					end
				end
			end

			class NoRiskInstrumentScopes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(26)
					order[0] = 1535
					order[1] = 1536
					order[2] = 1537
					order[3] = 1538
					order[4] = 1539
					order[5] = 1543
					order[6] = 1544
					order[7] = 1545
					order[8] = 1546
					order[9] = 2895
					order[10] = 1547
					order[11] = 1548
					order[12] = 1549
					order[13] = 1550
					order[14] = 1551
					order[15] = 1552
					order[16] = 1553
					order[17] = 1554
					order[18] = 1555
					order[19] = 1616
					order[20] = 1556
					order[21] = 1620
					order[22] = 1621
					order[23] = 1557
					order[24] = 1558
					order[25] = 0
					super(1534, 1535, order)
				end

				class NoInstrumentScopeSecurityAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1541
						order[1] = 1542
						order[2] = 0
						super(1540, 1541, order)
					end
				end
			end
		end
	end
end

class PartyRiskLimitsDefinitionRequestAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CT") )
	end

	class NoRequestingPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1658
			order[1] = 1659
			order[2] = 1660
			order[3] = 2338
			order[4] = 1661
			order[5] = 0
			super(1657, 1658, order)
		end

		class NoRequestingPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1662
				order[1] = 1663
				order[2] = 0
				super(1661, 1662, order)
			end
		end
	end

	class NoPartyRiskLimits < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 1324
			order[1] = 1763
			order[2] = 1764
			order[3] = 1671
			order[4] = 1669
			order[5] = 1670
			order[6] = 2339
			order[7] = 1328
			order[8] = 1664
			order[9] = 1665
			order[10] = 2355
			order[11] = 0
			super(1677, 1324, order)
		end

		class NoPartyDetails < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 1691
				order[1] = 1692
				order[2] = 1693
				order[3] = 1674
				order[4] = 1694
				order[5] = 1516
				order[6] = 1562
				order[7] = 1672
				order[8] = 0
				super(1671, 1691, order)
			end

			class NoPartyDetailSubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1695
					order[1] = 1696
					order[2] = 0
					super(1694, 1695, order)
				end
			end

			class NoPartyDetailAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1517
					order[1] = 1518
					order[2] = 1519
					order[3] = 0
					super(1516, 1517, order)
				end

				class NoPartyDetailAltSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1520
						order[1] = 1521
						order[2] = 0
						super(1519, 1520, order)
					end
				end
			end

			class NoRelatedPartyDetailID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(8)
					order[0] = 1563
					order[1] = 1564
					order[2] = 1565
					order[3] = 1675
					order[4] = 1566
					order[5] = 1569
					order[6] = 1514
					order[7] = 0
					super(1562, 1563, order)
				end

				class NoRelatedPartyDetailSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1567
						order[1] = 1568
						order[2] = 0
						super(1566, 1567, order)
					end
				end

				class NoRelatedPartyDetailAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 1570
						order[1] = 1571
						order[2] = 1572
						order[3] = 0
						super(1569, 1570, order)
					end

					class NoRelatedPartyDetailAltSubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 1573
							order[1] = 1574
							order[2] = 0
							super(1572, 1573, order)
						end
					end
				end

				class NoPartyRelationships < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 1515
						order[1] = 0
						super(1514, 1515, order)
					end
				end
			end
		end

		class NoRiskLimits < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1529
				order[1] = 1534
				order[2] = 0
				super(1669, 1529, order)
			end

			class NoRiskLimitTypes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 1530
					order[1] = 1531
					order[2] = 1767
					order[3] = 1766
					order[4] = 1765
					order[5] = 1532
					order[6] = 2939
					order[7] = 1533
					order[8] = 2336
					order[9] = 2337
					order[10] = 1559
					order[11] = 0
					super(1529, 1530, order)
				end

				class NoRiskWarningLevels < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 1769
						order[1] = 1560
						order[2] = 1768
						order[3] = 1561
						order[4] = 0
						super(1559, 1769, order)
					end
				end
			end

			class NoRiskInstrumentScopes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(26)
					order[0] = 1535
					order[1] = 1536
					order[2] = 1537
					order[3] = 1538
					order[4] = 1539
					order[5] = 1543
					order[6] = 1544
					order[7] = 1545
					order[8] = 1546
					order[9] = 2895
					order[10] = 1547
					order[11] = 1548
					order[12] = 1549
					order[13] = 1550
					order[14] = 1551
					order[15] = 1552
					order[16] = 1553
					order[17] = 1554
					order[18] = 1555
					order[19] = 1616
					order[20] = 1556
					order[21] = 1620
					order[22] = 1621
					order[23] = 1557
					order[24] = 1558
					order[25] = 0
					super(1534, 1535, order)
				end

				class NoInstrumentScopeSecurityAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1541
						order[1] = 1542
						order[2] = 0
						super(1540, 1541, order)
					end
				end
			end
		end
	end
end

class PartyEntitlementsRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CU") )
	end

	class NoRequestingPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1658
			order[1] = 1659
			order[2] = 1660
			order[3] = 2338
			order[4] = 1661
			order[5] = 0
			super(1657, 1658, order)
		end

		class NoRequestingPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1662
				order[1] = 1663
				order[2] = 0
				super(1661, 1662, order)
			end
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoRequestedPartyRoles < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1509
			order[1] = 2386
			order[2] = 0
			super(1508, 1509, order)
		end
	end

	class NoEntitlementTypes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1775
			order[1] = 2402
			order[2] = 0
			super(2345, 1775, order)
		end
	end

	class NoInstrumentScopes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(25)
			order[0] = 1535
			order[1] = 1536
			order[2] = 1537
			order[3] = 1538
			order[4] = 1539
			order[5] = 1543
			order[6] = 1544
			order[7] = 1545
			order[8] = 1546
			order[9] = 2895
			order[10] = 1547
			order[11] = 1548
			order[12] = 1549
			order[13] = 1550
			order[14] = 1551
			order[15] = 1552
			order[16] = 1553
			order[17] = 1554
			order[18] = 1555
			order[19] = 1616
			order[20] = 1556
			order[21] = 1620
			order[22] = 1621
			order[23] = 1557
			order[24] = 0
			super(1656, 1535, order)
		end

		class NoInstrumentScopeSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1541
				order[1] = 1542
				order[2] = 0
				super(1540, 1541, order)
			end
		end
	end

	class NoMarketSegments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1301
			order[1] = 1300
			order[2] = 0
			super(1310, 1301, order)
		end
	end
end

class PartyEntitlementsReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CV") )
	end

	class NoPartyEntitlements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 1671
			order[1] = 1883
			order[2] = 1773
			order[3] = 0
			super(1772, 1671, order)
		end

		class NoPartyDetails < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 1691
				order[1] = 1692
				order[2] = 1693
				order[3] = 1674
				order[4] = 1694
				order[5] = 1516
				order[6] = 1562
				order[7] = 1672
				order[8] = 0
				super(1671, 1691, order)
			end

			class NoPartyDetailSubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1695
					order[1] = 1696
					order[2] = 0
					super(1694, 1695, order)
				end
			end

			class NoPartyDetailAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1517
					order[1] = 1518
					order[2] = 1519
					order[3] = 0
					super(1516, 1517, order)
				end

				class NoPartyDetailAltSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1520
						order[1] = 1521
						order[2] = 0
						super(1519, 1520, order)
					end
				end
			end

			class NoRelatedPartyDetailID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(8)
					order[0] = 1563
					order[1] = 1564
					order[2] = 1565
					order[3] = 1675
					order[4] = 1566
					order[5] = 1569
					order[6] = 1514
					order[7] = 0
					super(1562, 1563, order)
				end

				class NoRelatedPartyDetailSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1567
						order[1] = 1568
						order[2] = 0
						super(1566, 1567, order)
					end
				end

				class NoRelatedPartyDetailAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 1570
						order[1] = 1571
						order[2] = 1572
						order[3] = 0
						super(1569, 1570, order)
					end

					class NoRelatedPartyDetailAltSubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 1573
							order[1] = 1574
							order[2] = 0
							super(1572, 1573, order)
						end
					end
				end

				class NoPartyRelationships < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 1515
						order[1] = 0
						super(1514, 1515, order)
					end
				end
			end
		end

		class NoEntitlements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1774
				order[1] = 1775
				order[2] = 2402
				order[3] = 1777
				order[4] = 1776
				order[5] = 1784
				order[6] = 1656
				order[7] = 1310
				order[8] = 1782
				order[9] = 1783
				order[10] = 0
				super(1773, 1774, order)
			end

			class NoEntitlementAttrib < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 1778
					order[1] = 1779
					order[2] = 1780
					order[3] = 1781
					order[4] = 2940
					order[5] = 0
					super(1777, 1778, order)
				end
			end

			class NoInstrumentScopes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(25)
					order[0] = 1535
					order[1] = 1536
					order[2] = 1537
					order[3] = 1538
					order[4] = 1539
					order[5] = 1543
					order[6] = 1544
					order[7] = 1545
					order[8] = 1546
					order[9] = 2895
					order[10] = 1547
					order[11] = 1548
					order[12] = 1549
					order[13] = 1550
					order[14] = 1551
					order[15] = 1552
					order[16] = 1553
					order[17] = 1554
					order[18] = 1555
					order[19] = 1616
					order[20] = 1556
					order[21] = 1620
					order[22] = 1621
					order[23] = 1557
					order[24] = 0
					super(1656, 1535, order)
				end

				class NoInstrumentScopeSecurityAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1541
						order[1] = 1542
						order[2] = 0
						super(1540, 1541, order)
					end
				end
			end

			class NoMarketSegments < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1301
					order[1] = 1300
					order[2] = 0
					super(1310, 1301, order)
				end
			end
		end
	end
end

class QuoteAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CW") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoQuoteAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2707
			order[1] = 2708
			order[2] = 0
			super(2706, 2707, order)
		end
	end
end

class PartyDetailsDefinitionRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CX") )
	end

	class NoRequestingPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1658
			order[1] = 1659
			order[2] = 1660
			order[3] = 2338
			order[4] = 1661
			order[5] = 0
			super(1657, 1658, order)
		end

		class NoRequestingPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1662
				order[1] = 1663
				order[2] = 0
				super(1661, 1662, order)
			end
		end
	end

	class NoPartyUpdates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1324
			order[1] = 1671
			order[2] = 0
			super(1676, 1324, order)
		end

		class NoPartyDetails < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 1691
				order[1] = 1692
				order[2] = 1693
				order[3] = 1674
				order[4] = 1694
				order[5] = 1516
				order[6] = 1562
				order[7] = 1672
				order[8] = 0
				super(1671, 1691, order)
			end

			class NoPartyDetailSubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1695
					order[1] = 1696
					order[2] = 0
					super(1694, 1695, order)
				end
			end

			class NoPartyDetailAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1517
					order[1] = 1518
					order[2] = 1519
					order[3] = 0
					super(1516, 1517, order)
				end

				class NoPartyDetailAltSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1520
						order[1] = 1521
						order[2] = 0
						super(1519, 1520, order)
					end
				end
			end

			class NoRelatedPartyDetailID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(8)
					order[0] = 1563
					order[1] = 1564
					order[2] = 1565
					order[3] = 1675
					order[4] = 1566
					order[5] = 1569
					order[6] = 1514
					order[7] = 0
					super(1562, 1563, order)
				end

				class NoRelatedPartyDetailSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1567
						order[1] = 1568
						order[2] = 0
						super(1566, 1567, order)
					end
				end

				class NoRelatedPartyDetailAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 1570
						order[1] = 1571
						order[2] = 1572
						order[3] = 0
						super(1569, 1570, order)
					end

					class NoRelatedPartyDetailAltSubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 1573
							order[1] = 1574
							order[2] = 0
							super(1572, 1573, order)
						end
					end
				end

				class NoPartyRelationships < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 1515
						order[1] = 0
						super(1514, 1515, order)
					end
				end
			end
		end
	end
end

class PartyDetailsDefinitionRequestAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CY") )
	end

	class NoRequestingPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1658
			order[1] = 1659
			order[2] = 1660
			order[3] = 2338
			order[4] = 1661
			order[5] = 0
			super(1657, 1658, order)
		end

		class NoRequestingPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1662
				order[1] = 1663
				order[2] = 0
				super(1661, 1662, order)
			end
		end
	end

	class NoPartyUpdates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(8)
			order[0] = 1324
			order[1] = 1879
			order[2] = 1880
			order[3] = 1328
			order[4] = 1664
			order[5] = 1665
			order[6] = 1671
			order[7] = 0
			super(1676, 1324, order)
		end

		class NoPartyDetails < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 1691
				order[1] = 1692
				order[2] = 1693
				order[3] = 1674
				order[4] = 1694
				order[5] = 1516
				order[6] = 1562
				order[7] = 1672
				order[8] = 0
				super(1671, 1691, order)
			end

			class NoPartyDetailSubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1695
					order[1] = 1696
					order[2] = 0
					super(1694, 1695, order)
				end
			end

			class NoPartyDetailAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1517
					order[1] = 1518
					order[2] = 1519
					order[3] = 0
					super(1516, 1517, order)
				end

				class NoPartyDetailAltSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1520
						order[1] = 1521
						order[2] = 0
						super(1519, 1520, order)
					end
				end
			end

			class NoRelatedPartyDetailID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(8)
					order[0] = 1563
					order[1] = 1564
					order[2] = 1565
					order[3] = 1675
					order[4] = 1566
					order[5] = 1569
					order[6] = 1514
					order[7] = 0
					super(1562, 1563, order)
				end

				class NoRelatedPartyDetailSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1567
						order[1] = 1568
						order[2] = 0
						super(1566, 1567, order)
					end
				end

				class NoRelatedPartyDetailAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 1570
						order[1] = 1571
						order[2] = 1572
						order[3] = 0
						super(1569, 1570, order)
					end

					class NoRelatedPartyDetailAltSubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 1573
							order[1] = 1574
							order[2] = 0
							super(1572, 1573, order)
						end
					end
				end

				class NoPartyRelationships < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 1515
						order[1] = 0
						super(1514, 1515, order)
					end
				end
			end
		end
	end
end

class PartyEntitlementsUpdateReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("CZ") )
	end

	class NoRequestingPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1658
			order[1] = 1659
			order[2] = 1660
			order[3] = 2338
			order[4] = 1661
			order[5] = 0
			super(1657, 1658, order)
		end

		class NoRequestingPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1662
				order[1] = 1663
				order[2] = 0
				super(1661, 1662, order)
			end
		end
	end

	class NoPartyEntitlements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1324
			order[1] = 1671
			order[2] = 1883
			order[3] = 1773
			order[4] = 1885
			order[5] = 0
			super(1772, 1324, order)
		end

		class NoPartyDetails < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 1691
				order[1] = 1692
				order[2] = 1693
				order[3] = 1674
				order[4] = 1694
				order[5] = 1516
				order[6] = 1562
				order[7] = 1672
				order[8] = 0
				super(1671, 1691, order)
			end

			class NoPartyDetailSubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1695
					order[1] = 1696
					order[2] = 0
					super(1694, 1695, order)
				end
			end

			class NoPartyDetailAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1517
					order[1] = 1518
					order[2] = 1519
					order[3] = 0
					super(1516, 1517, order)
				end

				class NoPartyDetailAltSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1520
						order[1] = 1521
						order[2] = 0
						super(1519, 1520, order)
					end
				end
			end

			class NoRelatedPartyDetailID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(8)
					order[0] = 1563
					order[1] = 1564
					order[2] = 1565
					order[3] = 1675
					order[4] = 1566
					order[5] = 1569
					order[6] = 1514
					order[7] = 0
					super(1562, 1563, order)
				end

				class NoRelatedPartyDetailSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1567
						order[1] = 1568
						order[2] = 0
						super(1566, 1567, order)
					end
				end

				class NoRelatedPartyDetailAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 1570
						order[1] = 1571
						order[2] = 1572
						order[3] = 0
						super(1569, 1570, order)
					end

					class NoRelatedPartyDetailAltSubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 1573
							order[1] = 1574
							order[2] = 0
							super(1572, 1573, order)
						end
					end
				end

				class NoPartyRelationships < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 1515
						order[1] = 0
						super(1514, 1515, order)
					end
				end
			end
		end

		class NoEntitlements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1774
				order[1] = 1775
				order[2] = 2402
				order[3] = 1777
				order[4] = 1776
				order[5] = 1784
				order[6] = 1656
				order[7] = 1310
				order[8] = 1782
				order[9] = 1783
				order[10] = 0
				super(1773, 1774, order)
			end

			class NoEntitlementAttrib < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 1778
					order[1] = 1779
					order[2] = 1780
					order[3] = 1781
					order[4] = 2940
					order[5] = 0
					super(1777, 1778, order)
				end
			end

			class NoInstrumentScopes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(25)
					order[0] = 1535
					order[1] = 1536
					order[2] = 1537
					order[3] = 1538
					order[4] = 1539
					order[5] = 1543
					order[6] = 1544
					order[7] = 1545
					order[8] = 1546
					order[9] = 2895
					order[10] = 1547
					order[11] = 1548
					order[12] = 1549
					order[13] = 1550
					order[14] = 1551
					order[15] = 1552
					order[16] = 1553
					order[17] = 1554
					order[18] = 1555
					order[19] = 1616
					order[20] = 1556
					order[21] = 1620
					order[22] = 1621
					order[23] = 1557
					order[24] = 0
					super(1656, 1535, order)
				end

				class NoInstrumentScopeSecurityAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1541
						order[1] = 1542
						order[2] = 0
						super(1540, 1541, order)
					end
				end
			end

			class NoMarketSegments < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1301
					order[1] = 1300
					order[2] = 0
					super(1310, 1301, order)
				end
			end
		end
	end
end

class PartyEntitlementsDefinitionRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DA") )
	end

	class NoRequestingPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1658
			order[1] = 1659
			order[2] = 1660
			order[3] = 2338
			order[4] = 1661
			order[5] = 0
			super(1657, 1658, order)
		end

		class NoRequestingPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1662
				order[1] = 1663
				order[2] = 0
				super(1661, 1662, order)
			end
		end
	end

	class NoPartyEntitlements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1324
			order[1] = 1671
			order[2] = 1883
			order[3] = 1773
			order[4] = 1885
			order[5] = 0
			super(1772, 1324, order)
		end

		class NoPartyDetails < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 1691
				order[1] = 1692
				order[2] = 1693
				order[3] = 1674
				order[4] = 1694
				order[5] = 1516
				order[6] = 1562
				order[7] = 1672
				order[8] = 0
				super(1671, 1691, order)
			end

			class NoPartyDetailSubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1695
					order[1] = 1696
					order[2] = 0
					super(1694, 1695, order)
				end
			end

			class NoPartyDetailAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1517
					order[1] = 1518
					order[2] = 1519
					order[3] = 0
					super(1516, 1517, order)
				end

				class NoPartyDetailAltSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1520
						order[1] = 1521
						order[2] = 0
						super(1519, 1520, order)
					end
				end
			end

			class NoRelatedPartyDetailID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(8)
					order[0] = 1563
					order[1] = 1564
					order[2] = 1565
					order[3] = 1675
					order[4] = 1566
					order[5] = 1569
					order[6] = 1514
					order[7] = 0
					super(1562, 1563, order)
				end

				class NoRelatedPartyDetailSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1567
						order[1] = 1568
						order[2] = 0
						super(1566, 1567, order)
					end
				end

				class NoRelatedPartyDetailAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 1570
						order[1] = 1571
						order[2] = 1572
						order[3] = 0
						super(1569, 1570, order)
					end

					class NoRelatedPartyDetailAltSubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 1573
							order[1] = 1574
							order[2] = 0
							super(1572, 1573, order)
						end
					end
				end

				class NoPartyRelationships < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 1515
						order[1] = 0
						super(1514, 1515, order)
					end
				end
			end
		end

		class NoEntitlements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1774
				order[1] = 1775
				order[2] = 2402
				order[3] = 1777
				order[4] = 1776
				order[5] = 1784
				order[6] = 1656
				order[7] = 1310
				order[8] = 1782
				order[9] = 1783
				order[10] = 0
				super(1773, 1774, order)
			end

			class NoEntitlementAttrib < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 1778
					order[1] = 1779
					order[2] = 1780
					order[3] = 1781
					order[4] = 2940
					order[5] = 0
					super(1777, 1778, order)
				end
			end

			class NoInstrumentScopes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(25)
					order[0] = 1535
					order[1] = 1536
					order[2] = 1537
					order[3] = 1538
					order[4] = 1539
					order[5] = 1543
					order[6] = 1544
					order[7] = 1545
					order[8] = 1546
					order[9] = 2895
					order[10] = 1547
					order[11] = 1548
					order[12] = 1549
					order[13] = 1550
					order[14] = 1551
					order[15] = 1552
					order[16] = 1553
					order[17] = 1554
					order[18] = 1555
					order[19] = 1616
					order[20] = 1556
					order[21] = 1620
					order[22] = 1621
					order[23] = 1557
					order[24] = 0
					super(1656, 1535, order)
				end

				class NoInstrumentScopeSecurityAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1541
						order[1] = 1542
						order[2] = 0
						super(1540, 1541, order)
					end
				end
			end

			class NoMarketSegments < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1301
					order[1] = 1300
					order[2] = 0
					super(1310, 1301, order)
				end
			end
		end
	end
end

class PartyEntitlementsDefinitionRequestAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DB") )
	end

	class NoRequestingPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1658
			order[1] = 1659
			order[2] = 1660
			order[3] = 2338
			order[4] = 1661
			order[5] = 0
			super(1657, 1658, order)
		end

		class NoRequestingPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1662
				order[1] = 1663
				order[2] = 0
				super(1661, 1662, order)
			end
		end
	end

	class NoPartyEntitlements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 1324
			order[1] = 1883
			order[2] = 1884
			order[3] = 1328
			order[4] = 1664
			order[5] = 1665
			order[6] = 1671
			order[7] = 1773
			order[8] = 1885
			order[9] = 0
			super(1772, 1324, order)
		end

		class NoPartyDetails < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 1691
				order[1] = 1692
				order[2] = 1693
				order[3] = 1674
				order[4] = 1694
				order[5] = 1516
				order[6] = 1562
				order[7] = 1672
				order[8] = 0
				super(1671, 1691, order)
			end

			class NoPartyDetailSubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1695
					order[1] = 1696
					order[2] = 0
					super(1694, 1695, order)
				end
			end

			class NoPartyDetailAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1517
					order[1] = 1518
					order[2] = 1519
					order[3] = 0
					super(1516, 1517, order)
				end

				class NoPartyDetailAltSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1520
						order[1] = 1521
						order[2] = 0
						super(1519, 1520, order)
					end
				end
			end

			class NoRelatedPartyDetailID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(8)
					order[0] = 1563
					order[1] = 1564
					order[2] = 1565
					order[3] = 1675
					order[4] = 1566
					order[5] = 1569
					order[6] = 1514
					order[7] = 0
					super(1562, 1563, order)
				end

				class NoRelatedPartyDetailSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1567
						order[1] = 1568
						order[2] = 0
						super(1566, 1567, order)
					end
				end

				class NoRelatedPartyDetailAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 1570
						order[1] = 1571
						order[2] = 1572
						order[3] = 0
						super(1569, 1570, order)
					end

					class NoRelatedPartyDetailAltSubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 1573
							order[1] = 1574
							order[2] = 0
							super(1572, 1573, order)
						end
					end
				end

				class NoPartyRelationships < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 1515
						order[1] = 0
						super(1514, 1515, order)
					end
				end
			end
		end

		class NoEntitlements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1774
				order[1] = 1775
				order[2] = 2402
				order[3] = 1777
				order[4] = 1776
				order[5] = 1784
				order[6] = 1656
				order[7] = 1310
				order[8] = 1782
				order[9] = 1783
				order[10] = 0
				super(1773, 1774, order)
			end

			class NoEntitlementAttrib < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 1778
					order[1] = 1779
					order[2] = 1780
					order[3] = 1781
					order[4] = 2940
					order[5] = 0
					super(1777, 1778, order)
				end
			end

			class NoInstrumentScopes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(25)
					order[0] = 1535
					order[1] = 1536
					order[2] = 1537
					order[3] = 1538
					order[4] = 1539
					order[5] = 1543
					order[6] = 1544
					order[7] = 1545
					order[8] = 1546
					order[9] = 2895
					order[10] = 1547
					order[11] = 1548
					order[12] = 1549
					order[13] = 1550
					order[14] = 1551
					order[15] = 1552
					order[16] = 1553
					order[17] = 1554
					order[18] = 1555
					order[19] = 1616
					order[20] = 1556
					order[21] = 1620
					order[22] = 1621
					order[23] = 1557
					order[24] = 0
					super(1656, 1535, order)
				end

				class NoInstrumentScopeSecurityAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1541
						order[1] = 1542
						order[2] = 0
						super(1540, 1541, order)
					end
				end
			end

			class NoMarketSegments < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1301
					order[1] = 1300
					order[2] = 0
					super(1310, 1301, order)
				end
			end
		end
	end
end

class TradeMatchReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DC") )
	end

	class NoInstrmtMatchSides < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(169)
			order[0] = 55
			order[1] = 65
			order[2] = 48
			order[3] = 22
			order[4] = 460
			order[5] = 1227
			order[6] = 1151
			order[7] = 461
			order[8] = 2891
			order[9] = 167
			order[10] = 762
			order[11] = 200
			order[12] = 541
			order[13] = 1079
			order[14] = 966
			order[15] = 1049
			order[16] = 965
			order[17] = 224
			order[18] = 1449
			order[19] = 1450
			order[20] = 1451
			order[21] = 1452
			order[22] = 1457
			order[23] = 1458
			order[24] = 1739
			order[25] = 2210
			order[26] = 1938
			order[27] = 1939
			order[28] = 1940
			order[29] = 2735
			order[30] = 1941
			order[31] = 1575
			order[32] = 1942
			order[33] = 1943
			order[34] = 1944
			order[35] = 1945
			order[36] = 1946
			order[37] = 1947
			order[38] = 1948
			order[39] = 1949
			order[40] = 1950
			order[41] = 2879
			order[42] = 1951
			order[43] = 1952
			order[44] = 1953
			order[45] = 1954
			order[46] = 1955
			order[47] = 1956
			order[48] = 1957
			order[49] = 1958
			order[50] = 1959
			order[51] = 1960
			order[52] = 1577
			order[53] = 1580
			order[54] = 1581
			order[55] = 1678
			order[56] = 1697
			order[57] = 225
			order[58] = 239
			order[59] = 226
			order[60] = 227
			order[61] = 228
			order[62] = 255
			order[63] = 543
			order[64] = 470
			order[65] = 471
			order[66] = 472
			order[67] = 240
			order[68] = 202
			order[69] = 2578
			order[70] = 2577
			order[71] = 947
			order[72] = 2904
			order[73] = 967
			order[74] = 968
			order[75] = 1698
			order[76] = 1866
			order[77] = 2600
			order[78] = 2001
			order[79] = 2601
			order[80] = 1478
			order[81] = 1479
			order[82] = 1480
			order[83] = 1481
			order[84] = 206
			order[85] = 231
			order[86] = 1435
			order[87] = 2353
			order[88] = 1439
			order[89] = 969
			order[90] = 1146
			order[91] = 996
			order[92] = 1147
			order[93] = 1716
			order[94] = 2905
			order[95] = 1191
			order[96] = 1192
			order[97] = 1717
			order[98] = 2906
			order[99] = 1193
			order[100] = 2579
			order[101] = 1194
			order[102] = 1482
			order[103] = 1195
			order[104] = 2753
			order[105] = 1196
			order[106] = 1197
			order[107] = 2002
			order[108] = 2140
			order[109] = 1524
			order[110] = 2907
			order[111] = 1198
			order[112] = 1199
			order[113] = 1200
			order[114] = 201
			order[115] = 2681
			order[116] = 2685
			order[117] = 1244
			order[118] = 1242
			order[119] = 2575
			order[120] = 2574
			order[121] = 997
			order[122] = 223
			order[123] = 207
			order[124] = 970
			order[125] = 971
			order[126] = 106
			order[127] = 348
			order[128] = 349
			order[129] = 2737
			order[130] = 2714
			order[131] = 2715
			order[132] = 2716
			order[133] = 107
			order[134] = 350
			order[135] = 351
			order[136] = 691
			order[137] = 667
			order[138] = 875
			order[139] = 876
			order[140] = 873
			order[141] = 874
			order[142] = 1687
			order[143] = 1787
			order[144] = 2141
			order[145] = 2142
			order[146] = 2143
			order[147] = 2752
			order[148] = 2144
			order[149] = 2145
			order[150] = 2576
			order[151] = 2962
			order[152] = 2602
			order[153] = 2603
			order[154] = 555
			order[155] = 711
			order[156] = 1891
			order[157] = 53
			order[158] = 15
			order[159] = 2897
			order[160] = 120
			order[161] = 2899
			order[162] = 854
			order[163] = 32
			order[164] = 423
			order[165] = 31
			order[166] = 30
			order[167] = 1890
			order[168] = 0
			super(1889, 55, order)
		end

		class NoSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 455
				order[1] = 456
				order[2] = 2957
				order[3] = 0
				super(454, 455, order)
			end
		end

		class NoSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1977
				order[1] = 1978
				order[2] = 1979
				order[3] = 2741
				order[4] = 0
				super(1976, 1977, order)
			end
		end

		class NoAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2305
				order[1] = 2306
				order[2] = 2307
				order[3] = 0
				super(2304, 2305, order)
			end
		end

		class NoEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 865
				order[1] = 866
				order[2] = 1145
				order[3] = 1827
				order[4] = 1826
				order[5] = 2340
				order[6] = 867
				order[7] = 868
				order[8] = 1578
				order[9] = 1579
				order[10] = 0
				super(864, 865, order)
			end
		end

		class NoInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1019
				order[1] = 1050
				order[2] = 1051
				order[3] = 2378
				order[4] = 1052
				order[5] = 0
				super(1018, 1019, order)
			end

			class NoInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1053
					order[1] = 1054
					order[2] = 0
					super(1052, 1053, order)
				end
			end
		end

		class NoComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 1484
				order[1] = 2117
				order[2] = 2118
				order[3] = 2119
				order[4] = 1485
				order[5] = 2120
				order[6] = 2121
				order[7] = 2122
				order[8] = 2941
				order[9] = 1486
				order[10] = 2123
				order[11] = 1487
				order[12] = 1488
				order[13] = 1489
				order[14] = 1490
				order[15] = 1491
				order[16] = 2124
				order[17] = 2942
				order[18] = 2125
				order[19] = 2943
				order[20] = 2126
				order[21] = 2127
				order[22] = 2407
				order[23] = 2408
				order[24] = 2128
				order[25] = 2129
				order[26] = 2130
				order[27] = 2131
				order[28] = 2132
				order[29] = 41013
				order[30] = 41020
				order[31] = 41021
				order[32] = 41022
				order[33] = 41023
				order[34] = 41024
				order[35] = 41025
				order[36] = 41026
				order[37] = 41027
				order[38] = 41028
				order[39] = 41010
				order[40] = 2133
				order[41] = 2134
				order[42] = 2135
				order[43] = 2136
				order[44] = 2137
				order[45] = 41029
				order[46] = 40997
				order[47] = 2597
				order[48] = 2598
				order[49] = 2599
				order[50] = 2138
				order[51] = 2139
				order[52] = 0
				super(1483, 1484, order)
			end

			class NoComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1492
					order[1] = 1493
					order[2] = 1494
					order[3] = 0
					super(1491, 1492, order)
				end

				class NoComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1495
						order[1] = 1496
						order[2] = 0
						super(1494, 1495, order)
					end
				end
			end

			class NoComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41014
					order[1] = 41015
					order[2] = 41016
					order[3] = 41017
					order[4] = 0
					super(41013, 41014, order)
				end
			end

			class NoComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41019
					order[1] = 0
					super(41018, 41019, order)
				end
			end

			class NoComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41011
					order[1] = 41012
					order[2] = 41031
					order[3] = 41007
					order[4] = 40994
					order[5] = 0
					super(41010, 41011, order)
				end

				class NoComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41032
						order[1] = 41033
						order[2] = 41034
						order[3] = 41035
						order[4] = 41036
						order[5] = 0
						super(41031, 41032, order)
					end
				end

				class NoComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41008
						order[1] = 41009
						order[2] = 0
						super(41007, 41008, order)
					end
				end

				class NoComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40995
						order[1] = 40996
						order[2] = 0
						super(40994, 40995, order)
					end
				end
			end

			class NoComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41030
					order[1] = 0
					super(41029, 41030, order)
				end
			end

			class NoComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40998
					order[1] = 40999
					order[2] = 41000
					order[3] = 41001
					order[4] = 41002
					order[5] = 41003
					order[6] = 41004
					order[7] = 41005
					order[8] = 0
					super(40997, 40998, order)
				end

				class NoComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41006
						order[1] = 0
						super(41005, 41006, order)
					end
				end
			end
		end

		class NoBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40471
				order[1] = 0
				super(40278, 40471, order)
			end
		end

		class NoPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41231
				order[1] = 0
				super(41230, 41231, order)
			end
		end

		class NoMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41093
				order[1] = 40991
				order[2] = 0
				super(41092, 41093, order)
			end
		end

		class NoMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41095
				order[1] = 40992
				order[2] = 0
				super(41094, 41095, order)
			end
		end

		class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41097
				order[1] = 41098
				order[2] = 41099
				order[3] = 41100
				order[4] = 41101
				order[5] = 41102
				order[6] = 41103
				order[7] = 41104
				order[8] = 41105
				order[9] = 0
				super(41096, 41097, order)
			end
		end

		class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42776
				order[1] = 0
				super(42775, 42776, order)
			end
		end

		class NoOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41117
				order[1] = 0
				super(41116, 41117, order)
			end
		end

		class NoOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41138
				order[1] = 41139
				order[2] = 0
				super(41137, 41138, order)
			end
		end

		class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41141
				order[1] = 0
				super(41140, 41141, order)
			end
		end

		class NoOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41153
				order[1] = 41154
				order[2] = 0
				super(41152, 41153, order)
			end
		end

		class NoStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40050
				order[1] = 41303
				order[2] = 40051
				order[3] = 42784
				order[4] = 42785
				order[5] = 40052
				order[6] = 40053
				order[7] = 41305
				order[8] = 40054
				order[9] = 40055
				order[10] = 42786
				order[11] = 42787
				order[12] = 41306
				order[13] = 41307
				order[14] = 41308
				order[15] = 41309
				order[16] = 41310
				order[17] = 41311
				order[18] = 41251
				order[19] = 41252
				order[20] = 41253
				order[21] = 41254
				order[22] = 41255
				order[23] = 41256
				order[24] = 41257
				order[25] = 42587
				order[26] = 41258
				order[27] = 41259
				order[28] = 41260
				order[29] = 41261
				order[30] = 41262
				order[31] = 41263
				order[32] = 41264
				order[33] = 41265
				order[34] = 41266
				order[35] = 41267
				order[36] = 41268
				order[37] = 41269
				order[38] = 41270
				order[39] = 41271
				order[40] = 41272
				order[41] = 41273
				order[42] = 41274
				order[43] = 41275
				order[44] = 41276
				order[45] = 40907
				order[46] = 40908
				order[47] = 40910
				order[48] = 40911
				order[49] = 40912
				order[50] = 40913
				order[51] = 40914
				order[52] = 40065
				order[53] = 40066
				order[54] = 40068
				order[55] = 40069
				order[56] = 40070
				order[57] = 40071
				order[58] = 40072
				order[59] = 41244
				order[60] = 41245
				order[61] = 40073
				order[62] = 40075
				order[63] = 40076
				order[64] = 40078
				order[65] = 40079
				order[66] = 40080
				order[67] = 40081
				order[68] = 40082
				order[69] = 40083
				order[70] = 40084
				order[71] = 41246
				order[72] = 41247
				order[73] = 41248
				order[74] = 40738
				order[75] = 40739
				order[76] = 40740
				order[77] = 42600
				order[78] = 40741
				order[79] = 40742
				order[80] = 43106
				order[81] = 40743
				order[82] = 40744
				order[83] = 40745
				order[84] = 40746
				order[85] = 40747
				order[86] = 42601
				order[87] = 42602
				order[88] = 42603
				order[89] = 42604
				order[90] = 40748
				order[91] = 40749
				order[92] = 40750
				order[93] = 41180
				order[94] = 41181
				order[95] = 41182
				order[96] = 41183
				order[97] = 41184
				order[98] = 41185
				order[99] = 41186
				order[100] = 42605
				order[101] = 40828
				order[102] = 40872
				order[103] = 41058
				order[104] = 41059
				order[105] = 41060
				order[106] = 41061
				order[107] = 41062
				order[108] = 42192
				order[109] = 42193
				order[110] = 41063
				order[111] = 41064
				order[112] = 41065
				order[113] = 41066
				order[114] = 41067
				order[115] = 41218
				order[116] = 41068
				order[117] = 41069
				order[118] = 41070
				order[119] = 41071
				order[120] = 41072
				order[121] = 41073
				order[122] = 41074
				order[123] = 41075
				order[124] = 41076
				order[125] = 41077
				order[126] = 41078
				order[127] = 41079
				order[128] = 41080
				order[129] = 43094
				order[130] = 41037
				order[131] = 40056
				order[132] = 40982
				order[133] = 40983
				order[134] = 0
				super(40049, 40050, order)
			end

			class NoStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41278
					order[1] = 41279
					order[2] = 0
					super(41277, 41278, order)
				end
			end

			class NoStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41238
					order[1] = 41239
					order[2] = 41240
					order[3] = 0
					super(41237, 41238, order)
				end
			end

			class NoStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41281
					order[1] = 41282
					order[2] = 0
					super(41280, 41281, order)
				end
			end

			class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41250
					order[1] = 0
					super(41249, 41250, order)
				end
			end

			class NoStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41290
					order[1] = 41291
					order[2] = 41292
					order[3] = 41293
					order[4] = 41294
					order[5] = 41295
					order[6] = 41296
					order[7] = 41297
					order[8] = 41298
					order[9] = 41299
					order[10] = 41300
					order[11] = 41283
					order[12] = 41301
					order[13] = 41302
					order[14] = 0
					super(41289, 41290, order)
				end

				class NoStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41284
						order[1] = 41285
						order[2] = 41286
						order[3] = 0
						super(41283, 41284, order)
					end

					class NoStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41287
							order[1] = 41288
							order[2] = 41588
							order[3] = 0
							super(41286, 41287, order)
						end
					end
				end
			end

			class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40909
					order[1] = 0
					super(40960, 40909, order)
				end
			end

			class NoStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40067
					order[1] = 0
					super(40961, 40067, order)
				end
			end

			class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40074
					order[1] = 0
					super(40958, 40074, order)
				end
			end

			class NoStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41242
					order[1] = 41243
					order[2] = 0
					super(41241, 41242, order)
				end
			end

			class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40077
					order[1] = 0
					super(40959, 40077, order)
				end
			end

			class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40752
					order[1] = 0
					super(40947, 40752, order)
				end
			end

			class NoPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41221
					order[1] = 41222
					order[2] = 0
					super(41220, 41221, order)
				end
			end

			class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40763
					order[1] = 0
					super(40948, 40763, order)
				end
			end

			class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40769
					order[1] = 0
					super(40949, 40769, order)
				end
			end

			class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40776
					order[1] = 0
					super(40950, 40776, order)
				end
			end

			class NoPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42661
					order[1] = 42662
					order[2] = 0
					super(42660, 42661, order)
				end
			end

			class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41193
					order[1] = 0
					super(41192, 41193, order)
				end
			end

			class NoPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41228
					order[1] = 41229
					order[2] = 0
					super(41227, 41228, order)
				end
			end

			class NoPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41225
					order[1] = 41226
					order[2] = 0
					super(41224, 41225, order)
				end
			end

			class NoPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43109
					order[1] = 42684
					order[2] = 42685
					order[3] = 0
					super(42683, 43109, order)
				end
			end

			class NoDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42275
					order[1] = 42276
					order[2] = 42277
					order[3] = 42278
					order[4] = 42279
					order[5] = 42280
					order[6] = 42294
					order[7] = 42281
					order[8] = 42282
					order[9] = 42283
					order[10] = 42284
					order[11] = 42285
					order[12] = 42286
					order[13] = 42287
					order[14] = 42288
					order[15] = 42289
					order[16] = 42290
					order[17] = 42291
					order[18] = 42292
					order[19] = 42293
					order[20] = 0
					super(42274, 42275, order)
				end

				class NoDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42295
						order[1] = 0
						super(42294, 42295, order)
					end
				end
			end

			class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42273
					order[1] = 0
					super(42272, 42273, order)
				end
			end

			class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42237
					order[1] = 0
					super(42236, 42237, order)
				end
			end

			class NoReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42736
					order[1] = 42737
					order[2] = 42738
					order[3] = 42739
					order[4] = 42740
					order[5] = 42741
					order[6] = 42765
					order[7] = 42731
					order[8] = 42742
					order[9] = 42743
					order[10] = 42744
					order[11] = 42745
					order[12] = 42746
					order[13] = 42747
					order[14] = 42748
					order[15] = 42749
					order[16] = 42750
					order[17] = 42751
					order[18] = 42752
					order[19] = 42753
					order[20] = 42761
					order[21] = 42754
					order[22] = 42755
					order[23] = 42709
					order[24] = 42756
					order[25] = 42757
					order[26] = 42758
					order[27] = 42759
					order[28] = 42760
					order[29] = 0
					super(42735, 42736, order)
				end

				class NoReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42766
						order[1] = 42767
						order[2] = 42768
						order[3] = 42769
						order[4] = 0
						super(42765, 42766, order)
					end
				end

				class NoReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42732
						order[1] = 42733
						order[2] = 42734
						order[3] = 0
						super(42731, 42732, order)
					end
				end

				class NoReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42762
						order[1] = 42763
						order[2] = 42764
						order[3] = 0
						super(42761, 42762, order)
					end
				end

				class NoReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42710
						order[1] = 42772
						order[2] = 42711
						order[3] = 42712
						order[4] = 42713
						order[5] = 42714
						order[6] = 42715
						order[7] = 42716
						order[8] = 42717
						order[9] = 42718
						order[10] = 42719
						order[11] = 42720
						order[12] = 42721
						order[13] = 42722
						order[14] = 42723
						order[15] = 42724
						order[16] = 42725
						order[17] = 42726
						order[18] = 42727
						order[19] = 42728
						order[20] = 42729
						order[21] = 42730
						order[22] = 42770
						order[23] = 0
						super(42709, 42710, order)
					end

					class NoReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42773
							order[1] = 42774
							order[2] = 0
							super(42772, 42773, order)
						end
					end

					class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42771
							order[1] = 0
							super(42770, 42771, order)
						end
					end
				end
			end

			class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42621
					order[1] = 0
					super(42620, 42621, order)
				end
			end

			class NoPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42607
					order[1] = 42608
					order[2] = 0
					super(42606, 42607, order)
				end
			end

			class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40819
					order[1] = 0
					super(40946, 40819, order)
				end
			end

			class NoNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40826
					order[1] = 40827
					order[2] = 0
					super(40825, 40826, order)
				end
			end

			class NoSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40086
					order[1] = 40373
					order[2] = 40655
					order[3] = 40088
					order[4] = 40089
					order[5] = 0
					super(40085, 40086, order)
				end
			end

			class NoPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40829
					order[1] = 41164
					order[2] = 41165
					order[3] = 40830
					order[4] = 40831
					order[5] = 40832
					order[6] = 40833
					order[7] = 40834
					order[8] = 40835
					order[9] = 40836
					order[10] = 40837
					order[11] = 40838
					order[12] = 40839
					order[13] = 41166
					order[14] = 41167
					order[15] = 41168
					order[16] = 41169
					order[17] = 40840
					order[18] = 40841
					order[19] = 40842
					order[20] = 40843
					order[21] = 41170
					order[22] = 41171
					order[23] = 41172
					order[24] = 41173
					order[25] = 40844
					order[26] = 40845
					order[27] = 40846
					order[28] = 40847
					order[29] = 40848
					order[30] = 40849
					order[31] = 40868
					order[32] = 40850
					order[33] = 40851
					order[34] = 40852
					order[35] = 40853
					order[36] = 40977
					order[37] = 40855
					order[38] = 40856
					order[39] = 40857
					order[40] = 41174
					order[41] = 41175
					order[42] = 40858
					order[43] = 41161
					order[44] = 41176
					order[45] = 41177
					order[46] = 41178
					order[47] = 41179
					order[48] = 40859
					order[49] = 40860
					order[50] = 40861
					order[51] = 40862
					order[52] = 40945
					order[53] = 40864
					order[54] = 40865
					order[55] = 40866
					order[56] = 40867
					order[57] = 0
					super(40828, 40829, order)
				end

				class NoPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40869
						order[1] = 40870
						order[2] = 40871
						order[3] = 0
						super(40868, 40869, order)
					end
				end

				class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40854
						order[1] = 0
						super(40977, 40854, order)
					end
				end

				class NoPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41162
						order[1] = 41163
						order[2] = 0
						super(41161, 41162, order)
					end
				end

				class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40863
						order[1] = 0
						super(40945, 40863, order)
					end
				end
			end

			class NoPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40873
					order[1] = 40874
					order[2] = 42698
					order[3] = 42699
					order[4] = 42700
					order[5] = 42701
					order[6] = 42702
					order[7] = 42703
					order[8] = 42704
					order[9] = 42689
					order[10] = 42690
					order[11] = 42691
					order[12] = 42692
					order[13] = 42693
					order[14] = 42694
					order[15] = 42695
					order[16] = 40875
					order[17] = 40876
					order[18] = 40877
					order[19] = 40878
					order[20] = 40879
					order[21] = 40880
					order[22] = 40881
					order[23] = 40882
					order[24] = 40883
					order[25] = 40884
					order[26] = 40885
					order[27] = 40886
					order[28] = 40887
					order[29] = 40888
					order[30] = 40889
					order[31] = 40890
					order[32] = 40891
					order[33] = 40892
					order[34] = 40893
					order[35] = 40894
					order[36] = 40895
					order[37] = 40896
					order[38] = 40897
					order[39] = 40898
					order[40] = 40899
					order[41] = 40900
					order[42] = 40901
					order[43] = 0
					super(40872, 40873, order)
				end

				class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42706
						order[1] = 0
						super(42705, 42706, order)
					end
				end

				class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42697
						order[1] = 0
						super(42696, 42697, order)
					end
				end
			end

			class NoDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41086
					order[1] = 0
					super(41085, 41086, order)
				end
			end

			class NoDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41082
					order[1] = 41083
					order[2] = 41084
					order[3] = 0
					super(41081, 41082, order)
				end
			end

			class NoDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41038
					order[1] = 41039
					order[2] = 41040
					order[3] = 41041
					order[4] = 41042
					order[5] = 41043
					order[6] = 41044
					order[7] = 41045
					order[8] = 41046
					order[9] = 41047
					order[10] = 41048
					order[11] = 41049
					order[12] = 41050
					order[13] = 41051
					order[14] = 0
					super(41037, 41038, order)
				end

				class NoDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41052
						order[1] = 41053
						order[2] = 41054
						order[3] = 0
						super(41051, 41052, order)
					end

					class NoDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41055
							order[1] = 41056
							order[2] = 41057
							order[3] = 0
							super(41054, 41055, order)
						end
					end
				end
			end
		end

		class NoProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40091
				order[1] = 40092
				order[2] = 40093
				order[3] = 40957
				order[4] = 40095
				order[5] = 40096
				order[6] = 40097
				order[7] = 42707
				order[8] = 42708
				order[9] = 40098
				order[10] = 40099
				order[11] = 40100
				order[12] = 40114
				order[13] = 40115
				order[14] = 40116
				order[15] = 40118
				order[16] = 40119
				order[17] = 40120
				order[18] = 40121
				order[19] = 40122
				order[20] = 40123
				order[21] = 40125
				order[22] = 40126
				order[23] = 40127
				order[24] = 40128
				order[25] = 40129
				order[26] = 40130
				order[27] = 40131
				order[28] = 40132
				order[29] = 40133
				order[30] = 40134
				order[31] = 40135
				order[32] = 40136
				order[33] = 40137
				order[34] = 40138
				order[35] = 40139
				order[36] = 40140
				order[37] = 40141
				order[38] = 40145
				order[39] = 40146
				order[40] = 40148
				order[41] = 40149
				order[42] = 40150
				order[43] = 40151
				order[44] = 40152
				order[45] = 40153
				order[46] = 40154
				order[47] = 40155
				order[48] = 40156
				order[49] = 40158
				order[50] = 40159
				order[51] = 40160
				order[52] = 40161
				order[53] = 40162
				order[54] = 40101
				order[55] = 40102
				order[56] = 40103
				order[57] = 40104
				order[58] = 40105
				order[59] = 40106
				order[60] = 40107
				order[61] = 40163
				order[62] = 40165
				order[63] = 40166
				order[64] = 40167
				order[65] = 40168
				order[66] = 40169
				order[67] = 40170
				order[68] = 40108
				order[69] = 40109
				order[70] = 40110
				order[71] = 40111
				order[72] = 40112
				order[73] = 41406
				order[74] = 40113
				order[75] = 40986
				order[76] = 40987
				order[77] = 40174
				order[78] = 0
				super(40090, 40091, order)
			end

			class NoProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40094
					order[1] = 0
					super(40957, 40094, order)
				end
			end

			class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40117
					order[1] = 0
					super(40953, 40117, order)
				end
			end

			class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40124
					order[1] = 0
					super(40954, 40124, order)
				end
			end

			class NoProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40143
					order[1] = 40144
					order[2] = 0
					super(40142, 40143, order)
				end
			end

			class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40147
					order[1] = 0
					super(40955, 40147, order)
				end
			end

			class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40157
					order[1] = 0
					super(40956, 40157, order)
				end
			end

			class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40164
					order[1] = 0
					super(40952, 40164, order)
				end
			end

			class NoProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40172
					order[1] = 40173
					order[2] = 0
					super(40171, 40172, order)
				end
			end

			class NoProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40175
					order[1] = 40176
					order[2] = 40177
					order[3] = 2385
					order[4] = 40178
					order[5] = 0
					super(40174, 40175, order)
				end

				class NoProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40179
						order[1] = 40180
						order[2] = 0
						super(40178, 40179, order)
					end
				end
			end
		end

		class NoAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40020
				order[1] = 40021
				order[2] = 40000
				order[3] = 0
				super(40019, 40020, order)
			end

			class NoAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 40001
					order[1] = 40002
					order[2] = 40003
					order[3] = 40004
					order[4] = 40005
					order[5] = 40006
					order[6] = 40007
					order[7] = 40008
					order[8] = 40009
					order[9] = 40010
					order[10] = 40011
					order[11] = 40012
					order[12] = 40013
					order[13] = 40014
					order[14] = 40015
					order[15] = 40016
					order[16] = 40017
					order[17] = 40018
					order[18] = 0
					super(40000, 40001, order)
				end
			end
		end

		class NoProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 40182
				order[1] = 40183
				order[2] = 40184
				order[3] = 40185
				order[4] = 40186
				order[5] = 40187
				order[6] = 40188
				order[7] = 40951
				order[8] = 40191
				order[9] = 40201
				order[10] = 40190
				order[11] = 0
				super(40181, 40182, order)
			end

			class NoProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40189
					order[1] = 0
					super(40951, 40189, order)
				end
			end

			class NoProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40192
					order[1] = 40193
					order[2] = 40194
					order[3] = 40195
					order[4] = 40196
					order[5] = 40197
					order[6] = 40198
					order[7] = 40199
					order[8] = 0
					super(40191, 40192, order)
				end

				class NoProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40200
						order[1] = 0
						super(40199, 40200, order)
					end
				end
			end

			class NoProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40202
					order[1] = 40203
					order[2] = 0
					super(40201, 40202, order)
				end
			end
		end

		class NoCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 40023
				order[1] = 40024
				order[2] = 40916
				order[3] = 40917
				order[4] = 40025
				order[5] = 40026
				order[6] = 40027
				order[7] = 40028
				order[8] = 40029
				order[9] = 40030
				order[10] = 40031
				order[11] = 40277
				order[12] = 42216
				order[13] = 42217
				order[14] = 40033
				order[15] = 40034
				order[16] = 42207
				order[17] = 42208
				order[18] = 42209
				order[19] = 42210
				order[20] = 42211
				order[21] = 42212
				order[22] = 42213
				order[23] = 40035
				order[24] = 40036
				order[25] = 40037
				order[26] = 40038
				order[27] = 40039
				order[28] = 0
				super(40022, 40023, order)
			end

			class NoCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40032
					order[1] = 0
					super(40277, 40032, order)
				end
			end

			class NoCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42215
					order[1] = 0
					super(42214, 42215, order)
				end
			end
		end

		class NoPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40209
				order[1] = 40205
				order[2] = 40206
				order[3] = 40207
				order[4] = 40208
				order[5] = 0
				super(40204, 40209, order)
			end

			class NoPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40210
					order[1] = 40211
					order[2] = 0
					super(40209, 40210, order)
				end
			end
		end

		class NoExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42297
				order[1] = 42298
				order[2] = 0
				super(42296, 42297, order)
			end
		end

		class NoLegs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(176)
				order[0] = 600
				order[1] = 601
				order[2] = 602
				order[3] = 603
				order[4] = 1788
				order[5] = 607
				order[6] = 1594
				order[7] = 608
				order[8] = 2893
				order[9] = 609
				order[10] = 764
				order[11] = 610
				order[12] = 611
				order[13] = 1212
				order[14] = 2146
				order[15] = 2147
				order[16] = 2148
				order[17] = 248
				order[18] = 2149
				order[19] = 2150
				order[20] = 2151
				order[21] = 2152
				order[22] = 2153
				order[23] = 2154
				order[24] = 2155
				order[25] = 2348
				order[26] = 2067
				order[27] = 2068
				order[28] = 2069
				order[29] = 2739
				order[30] = 2070
				order[31] = 2156
				order[32] = 2157
				order[33] = 2158
				order[34] = 2159
				order[35] = 2160
				order[36] = 2161
				order[37] = 2162
				order[38] = 2163
				order[39] = 2164
				order[40] = 2165
				order[41] = 2880
				order[42] = 2166
				order[43] = 2167
				order[44] = 2168
				order[45] = 2169
				order[46] = 2170
				order[47] = 2171
				order[48] = 2172
				order[49] = 2173
				order[50] = 2174
				order[51] = 2175
				order[52] = 2176
				order[53] = 2177
				order[54] = 2178
				order[55] = 2179
				order[56] = 2180
				order[57] = 249
				order[58] = 250
				order[59] = 251
				order[60] = 252
				order[61] = 253
				order[62] = 257
				order[63] = 599
				order[64] = 596
				order[65] = 597
				order[66] = 598
				order[67] = 254
				order[68] = 612
				order[69] = 942
				order[70] = 2908
				order[71] = 2181
				order[72] = 2182
				order[73] = 2183
				order[74] = 2184
				order[75] = 2604
				order[76] = 2185
				order[77] = 2605
				order[78] = 2186
				order[79] = 2187
				order[80] = 2188
				order[81] = 2189
				order[82] = 613
				order[83] = 614
				order[84] = 1436
				order[85] = 2354
				order[86] = 1440
				order[87] = 2190
				order[88] = 2191
				order[89] = 999
				order[90] = 1224
				order[91] = 1720
				order[92] = 2909
				order[93] = 1421
				order[94] = 1422
				order[95] = 1721
				order[96] = 2910
				order[97] = 2192
				order[98] = 1001
				order[99] = 1420
				order[100] = 2193
				order[101] = 2194
				order[102] = 2755
				order[103] = 2195
				order[104] = 2196
				order[105] = 2197
				order[106] = 2198
				order[107] = 1528
				order[108] = 2911
				order[109] = 2199
				order[110] = 2200
				order[111] = 2201
				order[112] = 2202
				order[113] = 2203
				order[114] = 615
				order[115] = 616
				order[116] = 2205
				order[117] = 2206
				order[118] = 617
				order[119] = 618
				order[120] = 619
				order[121] = 2740
				order[122] = 2717
				order[123] = 2718
				order[124] = 2719
				order[125] = 620
				order[126] = 621
				order[127] = 622
				order[128] = 2207
				order[129] = 2208
				order[130] = 623
				order[131] = 624
				order[132] = 556
				order[133] = 2898
				order[134] = 740
				order[135] = 739
				order[136] = 955
				order[137] = 956
				order[138] = 1358
				order[139] = 2682
				order[140] = 2686
				order[141] = 1017
				order[142] = 566
				order[143] = 2209
				order[144] = 2211
				order[145] = 2212
				order[146] = 2213
				order[147] = 2754
				order[148] = 2214
				order[149] = 2215
				order[150] = 2606
				order[151] = 2607
				order[152] = 2497
				order[153] = 2498
				order[154] = 2499
				order[155] = 2496
				order[156] = 2495
				order[157] = 2953
				order[158] = 2511
				order[159] = 2510
				order[160] = 2512
				order[161] = 2509
				order[162] = 2500
				order[163] = 2502
				order[164] = 2501
				order[165] = 2503
				order[166] = 2507
				order[167] = 2505
				order[168] = 2494
				order[169] = 2493
				order[170] = 2514
				order[171] = 2513
				order[172] = 2506
				order[173] = 2504
				order[174] = 2508
				order[175] = 0
				super(555, 600, order)
			end

			class NoLegSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 605
					order[1] = 606
					order[2] = 2958
					order[3] = 0
					super(604, 605, order)
				end
			end

			class NoLegSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2077
					order[1] = 2078
					order[2] = 2079
					order[3] = 2743
					order[4] = 0
					super(2076, 2077, order)
				end
			end

			class NoLegAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2309
					order[1] = 2310
					order[2] = 2311
					order[3] = 0
					super(2308, 2309, order)
				end
			end

			class NoLegEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 2060
					order[1] = 2061
					order[2] = 2062
					order[3] = 2063
					order[4] = 2064
					order[5] = 2341
					order[6] = 2065
					order[7] = 2066
					order[8] = 2074
					order[9] = 2075
					order[10] = 0
					super(2059, 2060, order)
				end
			end

			class NoLegInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 2255
					order[1] = 2256
					order[2] = 2257
					order[3] = 2379
					order[4] = 2258
					order[5] = 0
					super(2254, 2255, order)
				end

				class NoLegInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2259
						order[1] = 2260
						order[2] = 0
						super(2258, 2259, order)
					end
				end
			end

			class NoLegComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2219
					order[1] = 2220
					order[2] = 2221
					order[3] = 2222
					order[4] = 2223
					order[5] = 2224
					order[6] = 2225
					order[7] = 2226
					order[8] = 2944
					order[9] = 2227
					order[10] = 2228
					order[11] = 2229
					order[12] = 2230
					order[13] = 2231
					order[14] = 2232
					order[15] = 2250
					order[16] = 2233
					order[17] = 2945
					order[18] = 2234
					order[19] = 2946
					order[20] = 2235
					order[21] = 2236
					order[22] = 2409
					order[23] = 2410
					order[24] = 2237
					order[25] = 2238
					order[26] = 2239
					order[27] = 2240
					order[28] = 2241
					order[29] = 41382
					order[30] = 41389
					order[31] = 41390
					order[32] = 41391
					order[33] = 41392
					order[34] = 41393
					order[35] = 41394
					order[36] = 41395
					order[37] = 41396
					order[38] = 41397
					order[39] = 41379
					order[40] = 2242
					order[41] = 2243
					order[42] = 2244
					order[43] = 2245
					order[44] = 2246
					order[45] = 41398
					order[46] = 41366
					order[47] = 2608
					order[48] = 2609
					order[49] = 2610
					order[50] = 2248
					order[51] = 2249
					order[52] = 0
					super(2218, 2219, order)
				end

				class NoLegComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2251
						order[1] = 2252
						order[2] = 2253
						order[3] = 0
						super(2250, 2251, order)
					end

					class NoLegComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2204
							order[1] = 2247
							order[2] = 0
							super(2253, 2204, order)
						end
					end
				end

				class NoLegComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41383
						order[1] = 41384
						order[2] = 41385
						order[3] = 41386
						order[4] = 0
						super(41382, 41383, order)
					end
				end

				class NoLegComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41388
						order[1] = 0
						super(41387, 41388, order)
					end
				end

				class NoLegComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41380
						order[1] = 41381
						order[2] = 41400
						order[3] = 41376
						order[4] = 41363
						order[5] = 0
						super(41379, 41380, order)
					end

					class NoLegComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41401
							order[1] = 41402
							order[2] = 41403
							order[3] = 41404
							order[4] = 41405
							order[5] = 0
							super(41400, 41401, order)
						end
					end

					class NoLegComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41377
							order[1] = 41378
							order[2] = 0
							super(41376, 41377, order)
						end
					end

					class NoLegComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41364
							order[1] = 41365
							order[2] = 0
							super(41363, 41364, order)
						end
					end
				end

				class NoLegComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41399
						order[1] = 0
						super(41398, 41399, order)
					end
				end

				class NoLegComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41367
						order[1] = 41368
						order[2] = 41369
						order[3] = 41370
						order[4] = 41371
						order[5] = 41372
						order[6] = 41373
						order[7] = 41374
						order[8] = 0
						super(41366, 41367, order)
					end

					class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41375
							order[1] = 0
							super(41374, 41375, order)
						end
					end
				end
			end

			class NoLegBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40924
					order[1] = 0
					super(40923, 40924, order)
				end
			end

			class NoLegPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41608
					order[1] = 0
					super(41607, 41608, order)
				end
			end

			class NoLegMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41468
					order[1] = 40223
					order[2] = 0
					super(41467, 41468, order)
				end
			end

			class NoLegMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41470
					order[1] = 40990
					order[2] = 0
					super(41469, 41470, order)
				end
			end

			class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41472
					order[1] = 41473
					order[2] = 41474
					order[3] = 41475
					order[4] = 41476
					order[5] = 41477
					order[6] = 41478
					order[7] = 41479
					order[8] = 41480
					order[9] = 0
					super(41471, 41472, order)
				end
			end

			class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42582
					order[1] = 0
					super(42581, 42582, order)
				end
			end

			class NoLegOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41492
					order[1] = 0
					super(41491, 41492, order)
				end
			end

			class NoLegOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41513
					order[1] = 41514
					order[2] = 0
					super(41512, 41513, order)
				end
			end

			class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41516
					order[1] = 0
					super(41515, 41516, order)
				end
			end

			class NoLegOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41528
					order[1] = 41529
					order[2] = 0
					super(41527, 41528, order)
				end
			end

			class NoLegStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40242
					order[1] = 41700
					order[2] = 40243
					order[3] = 42583
					order[4] = 42584
					order[5] = 40244
					order[6] = 40245
					order[7] = 41702
					order[8] = 40246
					order[9] = 40247
					order[10] = 42585
					order[11] = 42586
					order[12] = 41703
					order[13] = 41704
					order[14] = 41705
					order[15] = 41706
					order[16] = 41707
					order[17] = 41708
					order[18] = 41648
					order[19] = 41649
					order[20] = 41650
					order[21] = 41651
					order[22] = 41652
					order[23] = 41653
					order[24] = 41654
					order[25] = 42588
					order[26] = 41655
					order[27] = 41656
					order[28] = 41657
					order[29] = 41658
					order[30] = 41659
					order[31] = 41660
					order[32] = 41661
					order[33] = 41662
					order[34] = 41663
					order[35] = 41664
					order[36] = 41665
					order[37] = 41666
					order[38] = 41667
					order[39] = 41668
					order[40] = 41669
					order[41] = 41670
					order[42] = 41671
					order[43] = 41672
					order[44] = 41673
					order[45] = 40249
					order[46] = 40250
					order[47] = 40252
					order[48] = 40253
					order[49] = 40254
					order[50] = 40255
					order[51] = 40256
					order[52] = 40257
					order[53] = 40258
					order[54] = 40260
					order[55] = 40261
					order[56] = 40262
					order[57] = 40263
					order[58] = 40264
					order[59] = 41641
					order[60] = 41642
					order[61] = 40265
					order[62] = 40267
					order[63] = 40268
					order[64] = 40270
					order[65] = 40271
					order[66] = 40272
					order[67] = 40273
					order[68] = 40274
					order[69] = 40275
					order[70] = 40276
					order[71] = 41643
					order[72] = 41644
					order[73] = 41645
					order[74] = 40279
					order[75] = 40280
					order[76] = 40281
					order[77] = 42399
					order[78] = 40282
					order[79] = 40283
					order[80] = 43108
					order[81] = 40284
					order[82] = 40285
					order[83] = 40286
					order[84] = 40287
					order[85] = 40288
					order[86] = 42400
					order[87] = 42401
					order[88] = 42402
					order[89] = 42403
					order[90] = 40289
					order[91] = 40290
					order[92] = 40291
					order[93] = 41549
					order[94] = 41550
					order[95] = 41551
					order[96] = 41552
					order[97] = 41553
					order[98] = 41554
					order[99] = 41555
					order[100] = 42404
					order[101] = 40374
					order[102] = 40418
					order[103] = 41429
					order[104] = 41430
					order[105] = 41431
					order[106] = 41432
					order[107] = 41433
					order[108] = 42194
					order[109] = 42195
					order[110] = 41434
					order[111] = 41435
					order[112] = 41436
					order[113] = 41437
					order[114] = 41438
					order[115] = 41219
					order[116] = 41439
					order[117] = 41440
					order[118] = 41441
					order[119] = 41442
					order[120] = 41443
					order[121] = 41444
					order[122] = 41445
					order[123] = 41446
					order[124] = 41447
					order[125] = 41448
					order[126] = 41449
					order[127] = 41450
					order[128] = 41451
					order[129] = 43095
					order[130] = 41408
					order[131] = 40248
					order[132] = 40978
					order[133] = 40979
					order[134] = 0
					super(40241, 40242, order)
				end

				class NoLegStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41675
						order[1] = 41676
						order[2] = 0
						super(41674, 41675, order)
					end
				end

				class NoLegStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41453
						order[1] = 41454
						order[2] = 41455
						order[3] = 0
						super(41452, 41453, order)
					end
				end

				class NoLegStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41678
						order[1] = 41679
						order[2] = 0
						super(41677, 41678, order)
					end
				end

				class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41647
						order[1] = 0
						super(41646, 41647, order)
					end
				end

				class NoLegStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41687
						order[1] = 41688
						order[2] = 41689
						order[3] = 41690
						order[4] = 41691
						order[5] = 41692
						order[6] = 41693
						order[7] = 41694
						order[8] = 41695
						order[9] = 41696
						order[10] = 41697
						order[11] = 41680
						order[12] = 41698
						order[13] = 41699
						order[14] = 0
						super(41686, 41687, order)
					end

					class NoLegStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41681
							order[1] = 41682
							order[2] = 41683
							order[3] = 0
							super(41680, 41681, order)
						end

						class NoLegStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41684
								order[1] = 41685
								order[2] = 41935
								order[3] = 0
								super(41683, 41684, order)
							end
						end
					end
				end

				class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40251
						order[1] = 0
						super(40942, 40251, order)
					end
				end

				class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40259
						order[1] = 0
						super(40943, 40259, order)
					end
				end

				class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40266
						order[1] = 0
						super(40940, 40266, order)
					end
				end

				class NoLegStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41639
						order[1] = 41640
						order[2] = 0
						super(41638, 41639, order)
					end
				end

				class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40269
						order[1] = 0
						super(40941, 40269, order)
					end
				end

				class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40293
						order[1] = 0
						super(40930, 40293, order)
					end
				end

				class NoLegPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41590
						order[1] = 41591
						order[2] = 0
						super(41589, 41590, order)
					end
				end

				class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40305
						order[1] = 0
						super(40931, 40305, order)
					end
				end

				class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40311
						order[1] = 0
						super(40932, 40311, order)
					end
				end

				class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40318
						order[1] = 0
						super(40933, 40318, order)
					end
				end

				class NoLegPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42460
						order[1] = 42461
						order[2] = 0
						super(42459, 42460, order)
					end
				end

				class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41562
						order[1] = 0
						super(41561, 41562, order)
					end
				end

				class NoLegPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41597
						order[1] = 41598
						order[2] = 0
						super(41596, 41597, order)
					end
				end

				class NoLegPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41594
						order[1] = 41595
						order[2] = 0
						super(41593, 41594, order)
					end
				end

				class NoLegPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43110
						order[1] = 42486
						order[2] = 42487
						order[3] = 0
						super(42485, 43110, order)
					end
				end

				class NoLegDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42367
						order[1] = 42368
						order[2] = 42369
						order[3] = 42370
						order[4] = 42371
						order[5] = 42372
						order[6] = 42386
						order[7] = 42373
						order[8] = 42374
						order[9] = 42375
						order[10] = 42376
						order[11] = 42377
						order[12] = 42378
						order[13] = 42379
						order[14] = 42380
						order[15] = 42381
						order[16] = 42382
						order[17] = 42383
						order[18] = 42384
						order[19] = 42385
						order[20] = 0
						super(42366, 42367, order)
					end

					class NoLegDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42387
							order[1] = 0
							super(42386, 42387, order)
						end
					end
				end

				class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42365
						order[1] = 0
						super(42364, 42365, order)
					end
				end

				class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42311
						order[1] = 0
						super(42310, 42311, order)
					end
				end

				class NoLegReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 42535
						order[1] = 42536
						order[2] = 42537
						order[3] = 42538
						order[4] = 42539
						order[5] = 42540
						order[6] = 42564
						order[7] = 42530
						order[8] = 42541
						order[9] = 42542
						order[10] = 42543
						order[11] = 42544
						order[12] = 42545
						order[13] = 42546
						order[14] = 42547
						order[15] = 42548
						order[16] = 42549
						order[17] = 42550
						order[18] = 42551
						order[19] = 42552
						order[20] = 42560
						order[21] = 42553
						order[22] = 42554
						order[23] = 42508
						order[24] = 42555
						order[25] = 42556
						order[26] = 42557
						order[27] = 42558
						order[28] = 42559
						order[29] = 0
						super(42534, 42535, order)
					end

					class NoLegReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 42565
							order[1] = 42566
							order[2] = 42567
							order[3] = 42568
							order[4] = 0
							super(42564, 42565, order)
						end
					end

					class NoLegReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42531
							order[1] = 42532
							order[2] = 42533
							order[3] = 0
							super(42530, 42531, order)
						end
					end

					class NoLegReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42561
							order[1] = 42562
							order[2] = 42563
							order[3] = 0
							super(42560, 42561, order)
						end
					end

					class NoLegReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 42509
							order[1] = 42571
							order[2] = 42510
							order[3] = 42511
							order[4] = 42512
							order[5] = 42513
							order[6] = 42514
							order[7] = 42515
							order[8] = 42516
							order[9] = 42517
							order[10] = 42518
							order[11] = 42519
							order[12] = 42520
							order[13] = 42521
							order[14] = 42522
							order[15] = 42523
							order[16] = 42524
							order[17] = 42525
							order[18] = 42526
							order[19] = 42527
							order[20] = 42528
							order[21] = 42529
							order[22] = 42569
							order[23] = 0
							super(42508, 42509, order)
						end

						class NoLegReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 42572
								order[1] = 42573
								order[2] = 0
								super(42571, 42572, order)
							end
						end

						class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 42570
								order[1] = 0
								super(42569, 42570, order)
							end
						end
					end
				end

				class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42420
						order[1] = 0
						super(42419, 42420, order)
					end
				end

				class NoLegPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42406
						order[1] = 42407
						order[2] = 0
						super(42405, 42406, order)
					end
				end

				class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40361
						order[1] = 0
						super(40929, 40361, order)
					end
				end

				class NoLegNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40368
						order[1] = 40369
						order[2] = 0
						super(40367, 40368, order)
					end
				end

				class NoLegSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40903
						order[1] = 40366
						order[2] = 40370
						order[3] = 40905
						order[4] = 40906
						order[5] = 0
						super(40902, 40903, order)
					end
				end

				class NoLegPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40375
						order[1] = 41533
						order[2] = 41534
						order[3] = 40376
						order[4] = 40377
						order[5] = 40378
						order[6] = 40379
						order[7] = 40380
						order[8] = 40381
						order[9] = 40382
						order[10] = 40383
						order[11] = 40384
						order[12] = 40385
						order[13] = 41535
						order[14] = 41536
						order[15] = 41537
						order[16] = 41538
						order[17] = 40386
						order[18] = 40387
						order[19] = 40388
						order[20] = 40389
						order[21] = 41539
						order[22] = 41540
						order[23] = 41541
						order[24] = 41542
						order[25] = 40390
						order[26] = 40391
						order[27] = 40392
						order[28] = 40393
						order[29] = 40394
						order[30] = 40395
						order[31] = 40414
						order[32] = 40396
						order[33] = 40397
						order[34] = 40398
						order[35] = 40399
						order[36] = 40927
						order[37] = 40401
						order[38] = 40402
						order[39] = 40403
						order[40] = 41543
						order[41] = 41544
						order[42] = 40404
						order[43] = 41530
						order[44] = 41545
						order[45] = 41546
						order[46] = 41547
						order[47] = 41548
						order[48] = 40405
						order[49] = 40406
						order[50] = 40407
						order[51] = 40408
						order[52] = 40928
						order[53] = 40410
						order[54] = 40411
						order[55] = 40412
						order[56] = 40413
						order[57] = 0
						super(40374, 40375, order)
					end

					class NoLegPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40415
							order[1] = 40416
							order[2] = 40417
							order[3] = 0
							super(40414, 40415, order)
						end
					end

					class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40400
							order[1] = 0
							super(40927, 40400, order)
						end
					end

					class NoLegPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41531
							order[1] = 41532
							order[2] = 0
							super(41530, 41531, order)
						end
					end

					class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40409
							order[1] = 0
							super(40928, 40409, order)
						end
					end
				end

				class NoLegPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40419
						order[1] = 40420
						order[2] = 42497
						order[3] = 42498
						order[4] = 42499
						order[5] = 42500
						order[6] = 42501
						order[7] = 42502
						order[8] = 42503
						order[9] = 42488
						order[10] = 42489
						order[11] = 42490
						order[12] = 42491
						order[13] = 42492
						order[14] = 42493
						order[15] = 42494
						order[16] = 40421
						order[17] = 40422
						order[18] = 40423
						order[19] = 40424
						order[20] = 40425
						order[21] = 40426
						order[22] = 40427
						order[23] = 40428
						order[24] = 40429
						order[25] = 40430
						order[26] = 40431
						order[27] = 40432
						order[28] = 40433
						order[29] = 40434
						order[30] = 40435
						order[31] = 40436
						order[32] = 40437
						order[33] = 40438
						order[34] = 40439
						order[35] = 40440
						order[36] = 40441
						order[37] = 40442
						order[38] = 40443
						order[39] = 40444
						order[40] = 40445
						order[41] = 40446
						order[42] = 40447
						order[43] = 0
						super(40418, 40419, order)
					end

					class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42505
							order[1] = 0
							super(42504, 42505, order)
						end
					end

					class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42496
							order[1] = 0
							super(42495, 42496, order)
						end
					end
				end

				class NoLegDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41461
						order[1] = 0
						super(41460, 41461, order)
					end
				end

				class NoLegDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41457
						order[1] = 41458
						order[2] = 41459
						order[3] = 0
						super(41456, 41457, order)
					end
				end

				class NoLegDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41409
						order[1] = 41410
						order[2] = 41411
						order[3] = 41412
						order[4] = 41413
						order[5] = 41414
						order[6] = 41415
						order[7] = 41416
						order[8] = 41417
						order[9] = 41418
						order[10] = 41419
						order[11] = 41420
						order[12] = 41421
						order[13] = 41422
						order[14] = 0
						super(41408, 41409, order)
					end

					class NoLegDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41423
							order[1] = 41424
							order[2] = 41425
							order[3] = 0
							super(41422, 41423, order)
						end

						class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41426
								order[1] = 41427
								order[2] = 41428
								order[3] = 0
								super(41425, 41426, order)
							end
						end
					end
				end
			end

			class NoLegProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 40449
					order[1] = 40450
					order[2] = 40451
					order[3] = 40939
					order[4] = 40453
					order[5] = 40454
					order[6] = 40455
					order[7] = 42506
					order[8] = 42507
					order[9] = 40456
					order[10] = 40457
					order[11] = 40458
					order[12] = 40524
					order[13] = 40525
					order[14] = 40526
					order[15] = 40528
					order[16] = 40529
					order[17] = 40530
					order[18] = 40531
					order[19] = 40532
					order[20] = 40476
					order[21] = 40478
					order[22] = 40479
					order[23] = 40480
					order[24] = 40481
					order[25] = 40482
					order[26] = 40483
					order[27] = 40484
					order[28] = 40485
					order[29] = 40486
					order[30] = 40487
					order[31] = 40488
					order[32] = 40489
					order[33] = 40490
					order[34] = 40491
					order[35] = 40492
					order[36] = 40493
					order[37] = 40494
					order[38] = 40498
					order[39] = 40499
					order[40] = 40501
					order[41] = 40502
					order[42] = 40503
					order[43] = 40504
					order[44] = 40505
					order[45] = 40506
					order[46] = 40507
					order[47] = 40508
					order[48] = 40509
					order[49] = 40511
					order[50] = 40512
					order[51] = 40513
					order[52] = 40514
					order[53] = 40515
					order[54] = 40459
					order[55] = 40460
					order[56] = 40461
					order[57] = 40462
					order[58] = 40463
					order[59] = 40464
					order[60] = 40465
					order[61] = 40516
					order[62] = 40518
					order[63] = 40519
					order[64] = 40520
					order[65] = 40521
					order[66] = 40522
					order[67] = 40523
					order[68] = 40466
					order[69] = 40467
					order[70] = 40468
					order[71] = 40469
					order[72] = 40470
					order[73] = 41407
					order[74] = 40472
					order[75] = 40980
					order[76] = 40981
					order[77] = 40533
					order[78] = 0
					super(40448, 40449, order)
				end

				class NoLegProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40452
						order[1] = 0
						super(40939, 40452, order)
					end
				end

				class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40527
						order[1] = 0
						super(40935, 40527, order)
					end
				end

				class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40477
						order[1] = 0
						super(40936, 40477, order)
					end
				end

				class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40496
						order[1] = 40497
						order[2] = 0
						super(40495, 40496, order)
					end
				end

				class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40500
						order[1] = 0
						super(40937, 40500, order)
					end
				end

				class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40510
						order[1] = 0
						super(40938, 40510, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40517
						order[1] = 0
						super(40934, 40517, order)
					end
				end

				class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40474
						order[1] = 40475
						order[2] = 0
						super(40473, 40474, order)
					end
				end

				class NoLegProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40534
						order[1] = 40535
						order[2] = 40536
						order[3] = 2380
						order[4] = 40537
						order[5] = 0
						super(40533, 40534, order)
					end

					class NoLegProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 40538
							order[1] = 40539
							order[2] = 0
							super(40537, 40538, order)
						end
					end
				end
			end

			class NoLegAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41336
					order[1] = 41337
					order[2] = 41316
					order[3] = 0
					super(41335, 41336, order)
				end

				class NoLegAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41317
						order[1] = 41318
						order[2] = 41319
						order[3] = 41320
						order[4] = 41321
						order[5] = 41322
						order[6] = 41323
						order[7] = 41324
						order[8] = 41325
						order[9] = 41326
						order[10] = 41327
						order[11] = 41328
						order[12] = 41329
						order[13] = 41330
						order[14] = 41331
						order[15] = 41332
						order[16] = 41333
						order[17] = 41334
						order[18] = 0
						super(41316, 41317, order)
					end
				end
			end

			class NoLegProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 41618
					order[1] = 41619
					order[2] = 41620
					order[3] = 41621
					order[4] = 41622
					order[5] = 41623
					order[6] = 41624
					order[7] = 41614
					order[8] = 41625
					order[9] = 41635
					order[10] = 41617
					order[11] = 0
					super(41616, 41618, order)
				end

				class NoLegProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41615
						order[1] = 0
						super(41614, 41615, order)
					end
				end

				class NoLegProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41626
						order[1] = 41627
						order[2] = 41628
						order[3] = 41629
						order[4] = 41630
						order[5] = 41631
						order[6] = 41632
						order[7] = 41633
						order[8] = 0
						super(41625, 41626, order)
					end

					class NoLegProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41634
							order[1] = 0
							super(41633, 41634, order)
						end
					end
				end

				class NoLegProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41636
						order[1] = 41637
						order[2] = 0
						super(41635, 41636, order)
					end
				end
			end

			class NoLegCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 41345
					order[1] = 41346
					order[2] = 41347
					order[3] = 41348
					order[4] = 41349
					order[5] = 41350
					order[6] = 41351
					order[7] = 41352
					order[8] = 41353
					order[9] = 41354
					order[10] = 41355
					order[11] = 41342
					order[12] = 42308
					order[13] = 42309
					order[14] = 41356
					order[15] = 41357
					order[16] = 42299
					order[17] = 42300
					order[18] = 42301
					order[19] = 42302
					order[20] = 42303
					order[21] = 42304
					order[22] = 42305
					order[23] = 41358
					order[24] = 41359
					order[25] = 41360
					order[26] = 41361
					order[27] = 41362
					order[28] = 0
					super(41344, 41345, order)
				end

				class NoLegCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41343
						order[1] = 0
						super(41342, 41343, order)
					end
				end

				class NoLegCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42307
						order[1] = 0
						super(42306, 42307, order)
					end
				end
			end

			class NoLegPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41604
					order[1] = 41601
					order[2] = 41602
					order[3] = 41603
					order[4] = 41600
					order[5] = 0
					super(41599, 41604, order)
				end

				class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41605
						order[1] = 41606
						order[2] = 0
						super(41604, 41605, order)
					end
				end
			end

			class NoLegExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42389
					order[1] = 42390
					order[2] = 0
					super(42388, 42389, order)
				end
			end

			class NoLegContractualDefinitions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42199
					order[1] = 0
					super(42198, 42199, order)
				end
			end

			class NoLegFinancingTermSupplements < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42201
					order[1] = 42202
					order[2] = 0
					super(42200, 42201, order)
				end
			end

			class NoLegContractualMatrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42204
					order[1] = 42205
					order[2] = 42206
					order[3] = 0
					super(42203, 42204, order)
				end
			end
		end

		class NoUnderlyings < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(188)
				order[0] = 311
				order[1] = 312
				order[2] = 309
				order[3] = 305
				order[4] = 2874
				order[5] = 462
				order[6] = 463
				order[7] = 2894
				order[8] = 310
				order[9] = 763
				order[10] = 313
				order[11] = 542
				order[12] = 1213
				order[13] = 1837
				order[14] = 241
				order[15] = 1453
				order[16] = 1454
				order[17] = 2614
				order[18] = 2615
				order[19] = 2921
				order[20] = 2616
				order[21] = 2617
				order[22] = 2619
				order[23] = 1455
				order[24] = 1456
				order[25] = 1459
				order[26] = 1460
				order[27] = 242
				order[28] = 243
				order[29] = 244
				order[30] = 245
				order[31] = 246
				order[32] = 256
				order[33] = 595
				order[34] = 592
				order[35] = 593
				order[36] = 594
				order[37] = 247
				order[38] = 316
				order[39] = 941
				order[40] = 2917
				order[41] = 317
				order[42] = 436
				order[43] = 1437
				order[44] = 2363
				order[45] = 1441
				order[46] = 998
				order[47] = 1423
				order[48] = 1718
				order[49] = 2918
				order[50] = 1424
				order[51] = 1425
				order[52] = 1719
				order[53] = 2919
				order[54] = 1000
				order[55] = 1419
				order[56] = 1526
				order[57] = 2920
				order[58] = 435
				order[59] = 308
				order[60] = 306
				order[61] = 362
				order[62] = 363
				order[63] = 2742
				order[64] = 2720
				order[65] = 2721
				order[66] = 2722
				order[67] = 2723
				order[68] = 2724
				order[69] = 307
				order[70] = 364
				order[71] = 365
				order[72] = 877
				order[73] = 878
				order[74] = 972
				order[75] = 318
				order[76] = 2916
				order[77] = 879
				order[78] = 975
				order[79] = 973
				order[80] = 974
				order[81] = 810
				order[82] = 882
				order[83] = 883
				order[84] = 884
				order[85] = 885
				order[86] = 886
				order[87] = 2885
				order[88] = 2886
				order[89] = 1044
				order[90] = 1045
				order[91] = 1046
				order[92] = 1038
				order[93] = 1039
				order[94] = 315
				order[95] = 2683
				order[96] = 2687
				order[97] = 1988
				order[98] = 1989
				order[99] = 1990
				order[100] = 1991
				order[101] = 1992
				order[102] = 1993
				order[103] = 2881
				order[104] = 1994
				order[105] = 1995
				order[106] = 1996
				order[107] = 1997
				order[108] = 2620
				order[109] = 2621
				order[110] = 1998
				order[111] = 1999
				order[112] = 2000
				order[113] = 2003
				order[114] = 2004
				order[115] = 2005
				order[116] = 2006
				order[117] = 2284
				order[118] = 2285
				order[119] = 2286
				order[120] = 2287
				order[121] = 2288
				order[122] = 2007
				order[123] = 2008
				order[124] = 2009
				order[125] = 2010
				order[126] = 2011
				order[127] = 2012
				order[128] = 2491
				order[129] = 2013
				order[130] = 2014
				order[131] = 2015
				order[132] = 2744
				order[133] = 2016
				order[134] = 2289
				order[135] = 2017
				order[136] = 2018
				order[137] = 2019
				order[138] = 2020
				order[139] = 2021
				order[140] = 2022
				order[141] = 2290
				order[142] = 2622
				order[143] = 2291
				order[144] = 2623
				order[145] = 2292
				order[146] = 2023
				order[147] = 2024
				order[148] = 2025
				order[149] = 2026
				order[150] = 2027
				order[151] = 2028
				order[152] = 2029
				order[153] = 2757
				order[154] = 2030
				order[155] = 2031
				order[156] = 2293
				order[157] = 2294
				order[158] = 2032
				order[159] = 2033
				order[160] = 2034
				order[161] = 2035
				order[162] = 2036
				order[163] = 2037
				order[164] = 2038
				order[165] = 2039
				order[166] = 2040
				order[167] = 2041
				order[168] = 2042
				order[169] = 2043
				order[170] = 2044
				order[171] = 41314
				order[172] = 41315
				order[173] = 2295
				order[174] = 2296
				order[175] = 2297
				order[176] = 2756
				order[177] = 2298
				order[178] = 2299
				order[179] = 2624
				order[180] = 2625
				order[181] = 2626
				order[182] = 2627
				order[183] = 2628
				order[184] = 2629
				order[185] = 2630
				order[186] = 2631
				order[187] = 0
				super(711, 311, order)
			end

			class NoUnderlyingSecurityAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 458
					order[1] = 459
					order[2] = 2959
					order[3] = 0
					super(457, 458, order)
				end
			end

			class NoUnderlyingStips < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 888
					order[1] = 889
					order[2] = 0
					super(887, 888, order)
				end
			end

			class NoUndlyInstrumentParties < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 1059
					order[1] = 1060
					order[2] = 1061
					order[3] = 2391
					order[4] = 1062
					order[5] = 0
					super(1058, 1059, order)
				end

				class NoUndlyInstrumentPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1063
						order[1] = 1064
						order[2] = 0
						super(1062, 1063, order)
					end
				end
			end

			class NoUnderlyingEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(11)
					order[0] = 1982
					order[1] = 1983
					order[2] = 1984
					order[3] = 1985
					order[4] = 1986
					order[5] = 2342
					order[6] = 1987
					order[7] = 2071
					order[8] = 2072
					order[9] = 2073
					order[10] = 0
					super(1981, 1982, order)
				end
			end

			class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 2081
					order[1] = 2082
					order[2] = 2083
					order[3] = 2745
					order[4] = 0
					super(2080, 2081, order)
				end
			end

			class NoUnderlyingAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2313
					order[1] = 2314
					order[2] = 2315
					order[3] = 0
					super(2312, 2313, order)
				end
			end

			class NoUnderlyingComplexEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(53)
					order[0] = 2046
					order[1] = 2261
					order[2] = 2262
					order[3] = 2263
					order[4] = 2047
					order[5] = 2264
					order[6] = 2265
					order[7] = 2266
					order[8] = 2947
					order[9] = 2048
					order[10] = 2267
					order[11] = 2049
					order[12] = 2050
					order[13] = 2051
					order[14] = 2052
					order[15] = 2053
					order[16] = 2268
					order[17] = 2948
					order[18] = 2269
					order[19] = 2949
					order[20] = 2270
					order[21] = 2271
					order[22] = 2419
					order[23] = 2420
					order[24] = 2272
					order[25] = 2273
					order[26] = 2274
					order[27] = 2275
					order[28] = 2276
					order[29] = 41732
					order[30] = 41739
					order[31] = 41740
					order[32] = 41741
					order[33] = 41742
					order[34] = 41743
					order[35] = 41744
					order[36] = 41745
					order[37] = 41746
					order[38] = 41747
					order[39] = 41729
					order[40] = 2277
					order[41] = 2278
					order[42] = 2279
					order[43] = 2280
					order[44] = 2281
					order[45] = 41748
					order[46] = 41716
					order[47] = 2611
					order[48] = 2612
					order[49] = 2613
					order[50] = 2282
					order[51] = 2283
					order[52] = 0
					super(2045, 2046, order)
				end

				class NoUnderlyingComplexEventDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 2054
						order[1] = 2055
						order[2] = 2056
						order[3] = 0
						super(2053, 2054, order)
					end

					class NoUnderlyingComplexEventTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 2057
							order[1] = 2058
							order[2] = 0
							super(2056, 2057, order)
						end
					end
				end

				class NoUnderlyingComplexEventRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 41733
						order[1] = 41734
						order[2] = 41735
						order[3] = 41736
						order[4] = 0
						super(41732, 41733, order)
					end
				end

				class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41738
						order[1] = 0
						super(41737, 41738, order)
					end
				end

				class NoUnderlyingComplexEventPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41730
						order[1] = 41731
						order[2] = 41750
						order[3] = 41726
						order[4] = 41713
						order[5] = 0
						super(41729, 41730, order)
					end

					class NoUnderlyingComplexEventSchedules < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(6)
							order[0] = 41751
							order[1] = 41752
							order[2] = 41753
							order[3] = 41754
							order[4] = 41755
							order[5] = 0
							super(41750, 41751, order)
						end
					end

					class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41727
							order[1] = 41728
							order[2] = 0
							super(41726, 41727, order)
						end
					end

					class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41714
							order[1] = 41715
							order[2] = 0
							super(41713, 41714, order)
						end
					end
				end

				class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41749
						order[1] = 0
						super(41748, 41749, order)
					end
				end

				class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 41717
						order[1] = 41718
						order[2] = 41719
						order[3] = 41720
						order[4] = 41721
						order[5] = 41722
						order[6] = 41723
						order[7] = 41724
						order[8] = 0
						super(41716, 41717, order)
					end

					class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 41725
							order[1] = 0
							super(41724, 41725, order)
						end
					end
				end
			end

			class NoUnderlyingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40963
					order[1] = 0
					super(40962, 40963, order)
				end
			end

			class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41948
					order[1] = 0
					super(41947, 41948, order)
				end
			end

			class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41865
					order[1] = 41338
					order[2] = 0
					super(41864, 41865, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41867
					order[1] = 41339
					order[2] = 0
					super(41866, 41867, order)
				end
			end

			class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(10)
					order[0] = 41869
					order[1] = 41870
					order[2] = 41871
					order[3] = 41872
					order[4] = 41873
					order[5] = 41874
					order[6] = 41875
					order[7] = 41876
					order[8] = 41877
					order[9] = 0
					super(41868, 41869, order)
				end
			end

			class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 43075
					order[1] = 0
					super(43074, 43075, order)
				end
			end

			class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41821
					order[1] = 0
					super(41820, 41821, order)
				end
			end

			class NoUnderlyingOptionExerciseDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41842
					order[1] = 41843
					order[2] = 0
					super(41841, 41842, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41845
					order[1] = 0
					super(41844, 41845, order)
				end
			end

			class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41857
					order[1] = 41858
					order[2] = 0
					super(41856, 41857, order)
				end
			end

			class NoUnderlyingStreams < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(135)
					order[0] = 40541
					order[1] = 42016
					order[2] = 40542
					order[3] = 43083
					order[4] = 43084
					order[5] = 40543
					order[6] = 40544
					order[7] = 42018
					order[8] = 40545
					order[9] = 40546
					order[10] = 43085
					order[11] = 43086
					order[12] = 42019
					order[13] = 42020
					order[14] = 42021
					order[15] = 42022
					order[16] = 42023
					order[17] = 42024
					order[18] = 41964
					order[19] = 41965
					order[20] = 41966
					order[21] = 41967
					order[22] = 41968
					order[23] = 41969
					order[24] = 41970
					order[25] = 42589
					order[26] = 41971
					order[27] = 41972
					order[28] = 41973
					order[29] = 41974
					order[30] = 41975
					order[31] = 41976
					order[32] = 41977
					order[33] = 41978
					order[34] = 41979
					order[35] = 41980
					order[36] = 41981
					order[37] = 41982
					order[38] = 41983
					order[39] = 41984
					order[40] = 41985
					order[41] = 41986
					order[42] = 41987
					order[43] = 41988
					order[44] = 41989
					order[45] = 40057
					order[46] = 40058
					order[47] = 40060
					order[48] = 40061
					order[49] = 40062
					order[50] = 40063
					order[51] = 40064
					order[52] = 40548
					order[53] = 40549
					order[54] = 40551
					order[55] = 40552
					order[56] = 40553
					order[57] = 40554
					order[58] = 40555
					order[59] = 41957
					order[60] = 41958
					order[61] = 40556
					order[62] = 40558
					order[63] = 40559
					order[64] = 40561
					order[65] = 40562
					order[66] = 40563
					order[67] = 40564
					order[68] = 40565
					order[69] = 40566
					order[70] = 40567
					order[71] = 41959
					order[72] = 41960
					order[73] = 41961
					order[74] = 40568
					order[75] = 40569
					order[76] = 40570
					order[77] = 42895
					order[78] = 40571
					order[79] = 40572
					order[80] = 43107
					order[81] = 40573
					order[82] = 40574
					order[83] = 40575
					order[84] = 40576
					order[85] = 40577
					order[86] = 42896
					order[87] = 42897
					order[88] = 42898
					order[89] = 42899
					order[90] = 40578
					order[91] = 40579
					order[92] = 40580
					order[93] = 41897
					order[94] = 41898
					order[95] = 41899
					order[96] = 41900
					order[97] = 41901
					order[98] = 41902
					order[99] = 41903
					order[100] = 42900
					order[101] = 40664
					order[102] = 40708
					order[103] = 41777
					order[104] = 41778
					order[105] = 41779
					order[106] = 41780
					order[107] = 41781
					order[108] = 42196
					order[109] = 42197
					order[110] = 41782
					order[111] = 41783
					order[112] = 41784
					order[113] = 41785
					order[114] = 41786
					order[115] = 41587
					order[116] = 41787
					order[117] = 41788
					order[118] = 41789
					order[119] = 41790
					order[120] = 41791
					order[121] = 41792
					order[122] = 41793
					order[123] = 41794
					order[124] = 41795
					order[125] = 41796
					order[126] = 41797
					order[127] = 41798
					order[128] = 41799
					order[129] = 43096
					order[130] = 41756
					order[131] = 40547
					order[132] = 40988
					order[133] = 40989
					order[134] = 0
					super(40540, 40541, order)
				end

				class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41991
						order[1] = 41992
						order[2] = 0
						super(41990, 41991, order)
					end
				end

				class NoUnderlyingStreamAssetAttributes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41801
						order[1] = 41802
						order[2] = 41803
						order[3] = 0
						super(41800, 41801, order)
					end
				end

				class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41994
						order[1] = 41995
						order[2] = 0
						super(41993, 41994, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41963
						order[1] = 0
						super(41962, 41963, order)
					end
				end

				class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 42003
						order[1] = 42004
						order[2] = 42005
						order[3] = 42006
						order[4] = 42007
						order[5] = 42008
						order[6] = 42009
						order[7] = 42010
						order[8] = 42011
						order[9] = 42012
						order[10] = 42013
						order[11] = 41996
						order[12] = 42014
						order[13] = 42015
						order[14] = 0
						super(42002, 42003, order)
					end

					class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41997
							order[1] = 41998
							order[2] = 41999
							order[3] = 0
							super(41996, 41997, order)
						end

						class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 42000
								order[1] = 42001
								order[2] = 41936
								order[3] = 0
								super(41999, 42000, order)
							end
						end
					end
				end

				class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40059
						order[1] = 0
						super(40975, 40059, order)
					end
				end

				class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40550
						order[1] = 0
						super(40976, 40550, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40557
						order[1] = 0
						super(40973, 40557, order)
					end
				end

				class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41955
						order[1] = 41956
						order[2] = 0
						super(41954, 41955, order)
					end
				end

				class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40560
						order[1] = 0
						super(40974, 40560, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40582
						order[1] = 0
						super(40969, 40582, order)
					end
				end

				class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41938
						order[1] = 41939
						order[2] = 0
						super(41937, 41938, order)
					end
				end

				class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40594
						order[1] = 0
						super(40970, 40594, order)
					end
				end

				class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40600
						order[1] = 0
						super(40971, 40600, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40607
						order[1] = 0
						super(40972, 40607, order)
					end
				end

				class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42956
						order[1] = 42957
						order[2] = 0
						super(42955, 42956, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41910
						order[1] = 0
						super(41909, 41910, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41945
						order[1] = 41946
						order[2] = 0
						super(41944, 41945, order)
					end
				end

				class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41942
						order[1] = 41943
						order[2] = 0
						super(41941, 41942, order)
					end
				end

				class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43111
						order[1] = 42982
						order[2] = 42983
						order[3] = 0
						super(42981, 43111, order)
					end
				end

				class NoUnderlyingDividendPeriods < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(21)
						order[0] = 42863
						order[1] = 42864
						order[2] = 42865
						order[3] = 42866
						order[4] = 42867
						order[5] = 42868
						order[6] = 42882
						order[7] = 42869
						order[8] = 42870
						order[9] = 42871
						order[10] = 42872
						order[11] = 42873
						order[12] = 42874
						order[13] = 42875
						order[14] = 42876
						order[15] = 42877
						order[16] = 42878
						order[17] = 42879
						order[18] = 42880
						order[19] = 42881
						order[20] = 0
						super(42862, 42863, order)
					end

					class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42883
							order[1] = 0
							super(42882, 42883, order)
						end
					end
				end

				class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42854
						order[1] = 0
						super(42853, 42854, order)
					end
				end

				class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42800
						order[1] = 0
						super(42799, 42800, order)
					end
				end

				class NoUnderlyingReturnRates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(30)
						order[0] = 43035
						order[1] = 43036
						order[2] = 43037
						order[3] = 43038
						order[4] = 43039
						order[5] = 43040
						order[6] = 43064
						order[7] = 43030
						order[8] = 43041
						order[9] = 43042
						order[10] = 43043
						order[11] = 43044
						order[12] = 43045
						order[13] = 43046
						order[14] = 43047
						order[15] = 43048
						order[16] = 43049
						order[17] = 43050
						order[18] = 43051
						order[19] = 43052
						order[20] = 43060
						order[21] = 43053
						order[22] = 43054
						order[23] = 43008
						order[24] = 43055
						order[25] = 43056
						order[26] = 43057
						order[27] = 43058
						order[28] = 43059
						order[29] = 0
						super(43034, 43035, order)
					end

					class NoUnderlyingReturnRatePrices < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(5)
							order[0] = 43065
							order[1] = 43066
							order[2] = 43067
							order[3] = 43068
							order[4] = 0
							super(43064, 43065, order)
						end
					end

					class NoUnderlyingReturnRateFXConversions < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43031
							order[1] = 43032
							order[2] = 43033
							order[3] = 0
							super(43030, 43031, order)
						end
					end

					class NoUnderlyingReturnRateInformationSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 43061
							order[1] = 43062
							order[2] = 43063
							order[3] = 0
							super(43060, 43061, order)
						end
					end

					class NoUnderlyingReturnRateDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(24)
							order[0] = 43009
							order[1] = 43071
							order[2] = 43010
							order[3] = 43011
							order[4] = 43012
							order[5] = 43013
							order[6] = 43014
							order[7] = 43015
							order[8] = 43016
							order[9] = 43017
							order[10] = 43018
							order[11] = 43019
							order[12] = 43020
							order[13] = 43021
							order[14] = 43022
							order[15] = 43023
							order[16] = 43024
							order[17] = 43025
							order[18] = 43026
							order[19] = 43027
							order[20] = 43028
							order[21] = 43029
							order[22] = 43069
							order[23] = 0
							super(43008, 43009, order)
						end

						class NoUnderlyingReturnRateValuationDates < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(3)
								order[0] = 43072
								order[1] = 43073
								order[2] = 0
								super(43071, 43072, order)
							end
						end

						class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(2)
								order[0] = 43070
								order[1] = 0
								super(43069, 43070, order)
							end
						end
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42916
						order[1] = 0
						super(42915, 42916, order)
					end
				end

				class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42902
						order[1] = 42903
						order[2] = 0
						super(42901, 42902, order)
					end
				end

				class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40650
						order[1] = 0
						super(40968, 40650, order)
					end
				end

				class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40657
						order[1] = 40658
						order[2] = 0
						super(40656, 40657, order)
					end
				end

				class NoUnderlyingSettlRateFallbacks < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 40660
						order[1] = 40904
						order[2] = 40915
						order[3] = 40662
						order[4] = 40663
						order[5] = 0
						super(40659, 40660, order)
					end
				end

				class NoUnderlyingPaymentSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(58)
						order[0] = 40665
						order[1] = 41881
						order[2] = 41882
						order[3] = 40666
						order[4] = 40667
						order[5] = 40668
						order[6] = 40669
						order[7] = 40670
						order[8] = 40671
						order[9] = 40672
						order[10] = 40673
						order[11] = 40674
						order[12] = 40675
						order[13] = 41883
						order[14] = 41884
						order[15] = 41885
						order[16] = 41886
						order[17] = 40676
						order[18] = 40677
						order[19] = 40678
						order[20] = 40679
						order[21] = 41887
						order[22] = 41888
						order[23] = 41889
						order[24] = 41890
						order[25] = 40680
						order[26] = 40681
						order[27] = 40682
						order[28] = 40683
						order[29] = 40684
						order[30] = 40685
						order[31] = 40704
						order[32] = 40686
						order[33] = 40687
						order[34] = 40688
						order[35] = 40689
						order[36] = 40966
						order[37] = 40691
						order[38] = 40692
						order[39] = 40693
						order[40] = 41891
						order[41] = 41892
						order[42] = 40694
						order[43] = 41878
						order[44] = 41893
						order[45] = 41894
						order[46] = 41895
						order[47] = 41896
						order[48] = 40695
						order[49] = 40696
						order[50] = 40697
						order[51] = 40698
						order[52] = 40967
						order[53] = 40700
						order[54] = 40701
						order[55] = 40702
						order[56] = 40703
						order[57] = 0
						super(40664, 40665, order)
					end

					class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 40705
							order[1] = 40706
							order[2] = 40707
							order[3] = 0
							super(40704, 40705, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40690
							order[1] = 0
							super(40966, 40690, order)
						end
					end

					class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 41879
							order[1] = 41880
							order[2] = 0
							super(41878, 41879, order)
						end
					end

					class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 40699
							order[1] = 0
							super(40967, 40699, order)
						end
					end
				end

				class NoUnderlyingPaymentStubs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(44)
						order[0] = 40709
						order[1] = 40710
						order[2] = 42993
						order[3] = 42994
						order[4] = 42995
						order[5] = 42996
						order[6] = 42997
						order[7] = 42998
						order[8] = 42999
						order[9] = 42984
						order[10] = 42985
						order[11] = 42986
						order[12] = 42987
						order[13] = 42988
						order[14] = 42989
						order[15] = 42990
						order[16] = 40711
						order[17] = 40712
						order[18] = 40713
						order[19] = 40714
						order[20] = 40715
						order[21] = 40716
						order[22] = 40717
						order[23] = 40718
						order[24] = 40719
						order[25] = 40720
						order[26] = 40721
						order[27] = 40722
						order[28] = 40723
						order[29] = 40724
						order[30] = 40725
						order[31] = 40726
						order[32] = 40727
						order[33] = 40728
						order[34] = 40729
						order[35] = 40730
						order[36] = 40731
						order[37] = 40732
						order[38] = 40733
						order[39] = 40734
						order[40] = 40735
						order[41] = 40736
						order[42] = 40737
						order[43] = 0
						super(40708, 40709, order)
					end

					class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43001
							order[1] = 0
							super(43000, 43001, order)
						end
					end

					class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42992
							order[1] = 0
							super(42991, 42992, order)
						end
					end
				end

				class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41809
						order[1] = 0
						super(41808, 41809, order)
					end
				end

				class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41805
						order[1] = 41806
						order[2] = 41807
						order[3] = 0
						super(41804, 41805, order)
					end
				end

				class NoUnderlyingDeliverySchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(15)
						order[0] = 41757
						order[1] = 41758
						order[2] = 41759
						order[3] = 41760
						order[4] = 41761
						order[5] = 41762
						order[6] = 41763
						order[7] = 41764
						order[8] = 41765
						order[9] = 41766
						order[10] = 41767
						order[11] = 41768
						order[12] = 41769
						order[13] = 41770
						order[14] = 0
						super(41756, 41757, order)
					end

					class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41771
							order[1] = 41772
							order[2] = 41773
							order[3] = 0
							super(41770, 41771, order)
						end

						class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
							def initialize
								order = Quickfix::IntArray.new(4)
								order[0] = 41774
								order[1] = 41775
								order[2] = 41776
								order[3] = 0
								super(41773, 41774, order)
							end
						end
					end
				end
			end

			class NoUnderlyingProvisions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(79)
					order[0] = 42150
					order[1] = 42151
					order[2] = 42152
					order[3] = 42190
					order[4] = 42153
					order[5] = 42154
					order[6] = 42155
					order[7] = 43002
					order[8] = 43003
					order[9] = 42156
					order[10] = 42157
					order[11] = 42158
					order[12] = 42104
					order[13] = 42105
					order[14] = 42106
					order[15] = 42107
					order[16] = 42108
					order[17] = 42109
					order[18] = 42110
					order[19] = 42111
					order[20] = 42115
					order[21] = 42116
					order[22] = 42117
					order[23] = 42118
					order[24] = 42119
					order[25] = 42120
					order[26] = 42121
					order[27] = 42122
					order[28] = 42123
					order[29] = 42124
					order[30] = 42125
					order[31] = 42126
					order[32] = 42127
					order[33] = 42128
					order[34] = 42129
					order[35] = 42130
					order[36] = 42131
					order[37] = 42132
					order[38] = 42133
					order[39] = 42134
					order[40] = 42135
					order[41] = 42136
					order[42] = 42137
					order[43] = 42138
					order[44] = 42139
					order[45] = 42140
					order[46] = 42141
					order[47] = 42142
					order[48] = 42143
					order[49] = 42144
					order[50] = 42145
					order[51] = 42146
					order[52] = 42147
					order[53] = 42148
					order[54] = 42159
					order[55] = 42160
					order[56] = 42161
					order[57] = 42162
					order[58] = 42163
					order[59] = 42164
					order[60] = 42165
					order[61] = 42092
					order[62] = 42093
					order[63] = 42094
					order[64] = 42095
					order[65] = 42096
					order[66] = 42097
					order[67] = 42098
					order[68] = 42166
					order[69] = 42167
					order[70] = 42168
					order[71] = 42169
					order[72] = 42102
					order[73] = 42103
					order[74] = 42170
					order[75] = 42171
					order[76] = 42172
					order[77] = 42173
					order[78] = 0
					super(42149, 42150, order)
				end

				class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42191
						order[1] = 0
						super(42190, 42191, order)
					end
				end

				class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42183
						order[1] = 0
						super(42182, 42183, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42185
						order[1] = 0
						super(42184, 42185, order)
					end
				end

				class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42113
						order[1] = 42114
						order[2] = 0
						super(42112, 42113, order)
					end
				end

				class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42187
						order[1] = 0
						super(42186, 42187, order)
					end
				end

				class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42189
						order[1] = 0
						super(42188, 42189, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42181
						order[1] = 0
						super(42180, 42181, order)
					end
				end

				class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42100
						order[1] = 42101
						order[2] = 0
						super(42099, 42100, order)
					end
				end

				class NoUnderlyingProvisionPartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 42174
						order[1] = 42175
						order[2] = 42176
						order[3] = 40918
						order[4] = 42177
						order[5] = 0
						super(42173, 42174, order)
					end

					class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42178
							order[1] = 42179
							order[2] = 0
							super(42177, 42178, order)
						end
					end
				end
			end

			class NoUnderlyingAdditionalTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42037
					order[1] = 42038
					order[2] = 41340
					order[3] = 0
					super(42036, 42037, order)
				end

				class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(19)
						order[0] = 41341
						order[1] = 41701
						order[2] = 41709
						order[3] = 41710
						order[4] = 41711
						order[5] = 41712
						order[6] = 42017
						order[7] = 42025
						order[8] = 42026
						order[9] = 42027
						order[10] = 42028
						order[11] = 42029
						order[12] = 42030
						order[13] = 42031
						order[14] = 42032
						order[15] = 42033
						order[16] = 42034
						order[17] = 42035
						order[18] = 0
						super(41340, 41341, order)
					end
				end
			end

			class NoUnderlyingProtectionTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 42069
					order[1] = 42070
					order[2] = 42071
					order[3] = 42072
					order[4] = 42073
					order[5] = 42074
					order[6] = 42075
					order[7] = 42090
					order[8] = 42077
					order[9] = 42087
					order[10] = 42076
					order[11] = 0
					super(42068, 42069, order)
				end

				class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42091
						order[1] = 0
						super(42090, 42091, order)
					end
				end

				class NoUnderlyingProtectionTermEvents < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(9)
						order[0] = 42078
						order[1] = 42079
						order[2] = 42080
						order[3] = 42081
						order[4] = 42082
						order[5] = 42083
						order[6] = 42084
						order[7] = 42085
						order[8] = 0
						super(42077, 42078, order)
					end

					class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42086
							order[1] = 0
							super(42085, 42086, order)
						end
					end
				end

				class NoUnderlyingProtectionTermObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42088
						order[1] = 42089
						order[2] = 0
						super(42087, 42088, order)
					end
				end
			end

			class NoUnderlyingCashSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(29)
					order[0] = 42042
					order[1] = 42043
					order[2] = 42044
					order[3] = 42045
					order[4] = 42046
					order[5] = 42047
					order[6] = 42048
					order[7] = 42049
					order[8] = 42050
					order[9] = 42051
					order[10] = 42052
					order[11] = 42039
					order[12] = 42797
					order[13] = 42798
					order[14] = 42053
					order[15] = 42054
					order[16] = 42790
					order[17] = 42791
					order[18] = 42792
					order[19] = 42793
					order[20] = 42794
					order[21] = 42795
					order[22] = 42796
					order[23] = 42055
					order[24] = 42056
					order[25] = 42057
					order[26] = 42058
					order[27] = 42059
					order[28] = 0
					super(42041, 42042, order)
				end

				class NoUnderlyingCashSettlDealers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42040
						order[1] = 0
						super(42039, 42040, order)
					end
				end

				class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42789
						order[1] = 0
						super(42788, 42789, order)
					end
				end
			end

			class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42065
					order[1] = 42061
					order[2] = 42062
					order[3] = 42063
					order[4] = 42064
					order[5] = 0
					super(42060, 42065, order)
				end

				class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42066
						order[1] = 42067
						order[2] = 0
						super(42065, 42066, order)
					end
				end
			end

			class NoUnderlyingRateSpreadSteps < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 43006
					order[1] = 43007
					order[2] = 0
					super(43005, 43006, order)
				end
			end

			class NoUnderlyingDividendPayments < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42856
					order[1] = 42857
					order[2] = 42858
					order[3] = 42859
					order[4] = 0
					super(42855, 42856, order)
				end
			end

			class NoUnderlyingExtraordinaryEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42885
					order[1] = 42886
					order[2] = 0
					super(42884, 42885, order)
				end
			end
		end

		class NoTrdMatchSides < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(85)
				order[0] = 54
				order[1] = 1427
				order[2] = 1900
				order[3] = 1506
				order[4] = 1005
				order[5] = 1428
				order[6] = 1429
				order[7] = 1009
				order[8] = 1597
				order[9] = 1599
				order[10] = 1598
				order[11] = 1006
				order[12] = 1007
				order[13] = 1008
				order[14] = 430
				order[15] = 1154
				order[16] = 2901
				order[17] = 1155
				order[18] = 2902
				order[19] = 453
				order[20] = 578
				order[21] = 579
				order[22] = 376
				order[23] = 2404
				order[24] = 2351
				order[25] = 2352
				order[26] = 377
				order[27] = 582
				order[28] = 943
				order[29] = 77
				order[30] = 825
				order[31] = 826
				order[32] = 591
				order[33] = 70
				order[34] = 78
				order[35] = 1072
				order[36] = 1057
				order[37] = 1139
				order[38] = 1690
				order[39] = 1115
				order[40] = 819
				order[41] = 1731
				order[42] = 1898
				order[43] = 1899
				order[44] = 635
				order[45] = 37
				order[46] = 198
				order[47] = 11
				order[48] = 526
				order[49] = 66
				order[50] = 1080
				order[51] = 1081
				order[52] = 1431
				order[53] = 1091
				order[54] = 40
				order[55] = 44
				order[56] = 99
				order[57] = 18
				order[58] = 39
				order[59] = 151
				order[60] = 14
				order[61] = 59
				order[62] = 126
				order[63] = 2362
				order[64] = 2964
				order[65] = 1629
				order[66] = 1916
				order[67] = 528
				order[68] = 529
				order[69] = 775
				order[70] = 1432
				order[71] = 1724
				order[72] = 2704
				order[73] = 821
				order[74] = 1093
				order[75] = 483
				order[76] = 586
				order[77] = 2766
				order[78] = 1892
				order[79] = 1031
				order[80] = 1032
				order[81] = 58
				order[82] = 354
				order[83] = 355
				order[84] = 0
				super(1890, 54, order)
			end

			class NoPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 448
					order[1] = 447
					order[2] = 452
					order[3] = 2376
					order[4] = 802
					order[5] = 0
					super(453, 448, order)
				end

				class NoPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 523
						order[1] = 803
						order[2] = 0
						super(802, 523, order)
					end
				end
			end

			class NoAllocs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(34)
					order[0] = 79
					order[1] = 661
					order[2] = 736
					order[3] = 2927
					order[4] = 467
					order[5] = 1593
					order[6] = 2727
					order[7] = 1908
					order[8] = 1729
					order[9] = 756
					order[10] = 209
					order[11] = 80
					order[12] = 2515
					order[13] = 1752
					order[14] = 1753
					order[15] = 1754
					order[16] = 1755
					order[17] = 993
					order[18] = 1002
					order[19] = 989
					order[20] = 1136
					order[21] = 1844
					order[22] = 1840
					order[23] = 1735
					order[24] = 161
					order[25] = 360
					order[26] = 361
					order[27] = 1732
					order[28] = 1733
					order[29] = 1734
					order[30] = 2392
					order[31] = 2393
					order[32] = 2653
					order[33] = 0
					super(78, 79, order)
				end

				class NoAllocRegulatoryTradeIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(7)
						order[0] = 1909
						order[1] = 1910
						order[2] = 1911
						order[3] = 1912
						order[4] = 2406
						order[5] = 2399
						order[6] = 0
						super(1908, 1909, order)
					end
				end

				class NoNested2PartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 757
						order[1] = 758
						order[2] = 759
						order[3] = 2381
						order[4] = 806
						order[5] = 0
						super(756, 757, order)
					end

					class NoNested2PartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 760
							order[1] = 807
							order[2] = 0
							super(806, 760, order)
						end
					end
				end

				class NoTradeAllocAmts < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 1845
						order[1] = 1846
						order[2] = 1847
						order[3] = 2933
						order[4] = 1850
						order[5] = 0
						super(1844, 1845, order)
					end
				end

				class NoAllocCommissions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(17)
						order[0] = 2654
						order[1] = 2655
						order[2] = 2726
						order[3] = 2656
						order[4] = 2657
						order[5] = 2925
						order[6] = 2658
						order[7] = 2659
						order[8] = 2926
						order[9] = 2660
						order[10] = 2661
						order[11] = 2662
						order[12] = 2663
						order[13] = 2664
						order[14] = 2665
						order[15] = 2666
						order[16] = 0
						super(2653, 2654, order)
					end
				end
			end

			class NoOrders < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(7)
					order[0] = 2887
					order[1] = 2888
					order[2] = 2836
					order[3] = 2889
					order[4] = 2890
					order[5] = 2835
					order[6] = 0
					super(73, 2887, order)
				end
			end

			class NoMatchInst < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 1625
					order[1] = 1673
					order[2] = 1626
					order[3] = 1627
					order[4] = 0
					super(1624, 1625, order)
				end
			end

			class NoOrderAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2594
					order[1] = 2595
					order[2] = 0
					super(2593, 2594, order)
				end
			end

			class NoLegExecs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(17)
					order[0] = 654
					order[1] = 1893
					order[2] = 1901
					order[3] = 1894
					order[4] = 1895
					order[5] = 685
					order[6] = 564
					order[7] = 565
					order[8] = 948
					order[9] = 637
					order[10] = 686
					order[11] = 675
					order[12] = 2900
					order[13] = 1689
					order[14] = 1418
					order[15] = 1591
					order[16] = 0
					super(1892, 654, order)
				end

				class NoNested3PartyIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 949
						order[1] = 950
						order[2] = 951
						order[3] = 2382
						order[4] = 952
						order[5] = 0
						super(948, 949, order)
					end

					class NoNested3PartySubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 953
							order[1] = 954
							order[2] = 0
							super(952, 953, order)
						end
					end
				end
			end
		end
	end
end

class TradeMatchReportAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DD") )
	end
end

class PartyRiskLimitsReportAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DE") )
	end

	class NoPartyRiskLimits < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 1324
			order[1] = 1671
			order[2] = 1669
			order[3] = 1670
			order[4] = 2339
			order[5] = 2355
			order[6] = 0
			super(1677, 1324, order)
		end

		class NoPartyDetails < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 1691
				order[1] = 1692
				order[2] = 1693
				order[3] = 1674
				order[4] = 1694
				order[5] = 1516
				order[6] = 1562
				order[7] = 1672
				order[8] = 0
				super(1671, 1691, order)
			end

			class NoPartyDetailSubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1695
					order[1] = 1696
					order[2] = 0
					super(1694, 1695, order)
				end
			end

			class NoPartyDetailAltID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1517
					order[1] = 1518
					order[2] = 1519
					order[3] = 0
					super(1516, 1517, order)
				end

				class NoPartyDetailAltSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1520
						order[1] = 1521
						order[2] = 0
						super(1519, 1520, order)
					end
				end
			end

			class NoRelatedPartyDetailID < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(8)
					order[0] = 1563
					order[1] = 1564
					order[2] = 1565
					order[3] = 1675
					order[4] = 1566
					order[5] = 1569
					order[6] = 1514
					order[7] = 0
					super(1562, 1563, order)
				end

				class NoRelatedPartyDetailSubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1567
						order[1] = 1568
						order[2] = 0
						super(1566, 1567, order)
					end
				end

				class NoRelatedPartyDetailAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 1570
						order[1] = 1571
						order[2] = 1572
						order[3] = 0
						super(1569, 1570, order)
					end

					class NoRelatedPartyDetailAltSubIDs < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 1573
							order[1] = 1574
							order[2] = 0
							super(1572, 1573, order)
						end
					end
				end

				class NoPartyRelationships < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 1515
						order[1] = 0
						super(1514, 1515, order)
					end
				end
			end
		end

		class NoRiskLimits < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1529
				order[1] = 1534
				order[2] = 0
				super(1669, 1529, order)
			end

			class NoRiskLimitTypes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(12)
					order[0] = 1530
					order[1] = 1531
					order[2] = 1767
					order[3] = 1766
					order[4] = 1765
					order[5] = 1532
					order[6] = 2939
					order[7] = 1533
					order[8] = 2336
					order[9] = 2337
					order[10] = 1559
					order[11] = 0
					super(1529, 1530, order)
				end

				class NoRiskWarningLevels < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 1769
						order[1] = 1560
						order[2] = 1768
						order[3] = 1561
						order[4] = 0
						super(1559, 1769, order)
					end
				end
			end

			class NoRiskInstrumentScopes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(26)
					order[0] = 1535
					order[1] = 1536
					order[2] = 1537
					order[3] = 1538
					order[4] = 1539
					order[5] = 1543
					order[6] = 1544
					order[7] = 1545
					order[8] = 1546
					order[9] = 2895
					order[10] = 1547
					order[11] = 1548
					order[12] = 1549
					order[13] = 1550
					order[14] = 1551
					order[15] = 1552
					order[16] = 1553
					order[17] = 1554
					order[18] = 1555
					order[19] = 1616
					order[20] = 1556
					order[21] = 1620
					order[22] = 1621
					order[23] = 1557
					order[24] = 1558
					order[25] = 0
					super(1534, 1535, order)
				end

				class NoInstrumentScopeSecurityAltID < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1541
						order[1] = 1542
						order[2] = 0
						super(1540, 1541, order)
					end
				end
			end
		end
	end
end

class PartyRiskLimitCheckRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DF") )
	end

	class NoRequestingPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1658
			order[1] = 1659
			order[2] = 1660
			order[3] = 2338
			order[4] = 1661
			order[5] = 0
			super(1657, 1658, order)
		end

		class NoRequestingPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1662
				order[1] = 1663
				order[2] = 0
				super(1661, 1662, order)
			end
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoRelatedPartyDetailID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(8)
			order[0] = 1563
			order[1] = 1564
			order[2] = 1565
			order[3] = 1675
			order[4] = 1566
			order[5] = 1569
			order[6] = 1514
			order[7] = 0
			super(1562, 1563, order)
		end

		class NoRelatedPartyDetailSubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1567
				order[1] = 1568
				order[2] = 0
				super(1566, 1567, order)
			end
		end

		class NoRelatedPartyDetailAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1570
				order[1] = 1571
				order[2] = 1572
				order[3] = 0
				super(1569, 1570, order)
			end

			class NoRelatedPartyDetailAltSubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1573
					order[1] = 1574
					order[2] = 0
					super(1572, 1573, order)
				end
			end
		end

		class NoPartyRelationships < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 1515
				order[1] = 0
				super(1514, 1515, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(174)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 685
			order[153] = 687
			order[154] = 690
			order[155] = 683
			order[156] = 1366
			order[157] = 670
			order[158] = 2680
			order[159] = 1817
			order[160] = 564
			order[161] = 565
			order[162] = 539
			order[163] = 654
			order[164] = 587
			order[165] = 588
			order[166] = 675
			order[167] = 2900
			order[168] = 1379
			order[169] = 1381
			order[170] = 1383
			order[171] = 1384
			order[172] = 1689
			order[173] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegStipulations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 688
				order[1] = 689
				order[2] = 0
				super(683, 688, order)
			end
		end

		class NoLegAllocs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 671
				order[1] = 672
				order[2] = 756
				order[3] = 673
				order[4] = 674
				order[5] = 1367
				order[6] = 2928
				order[7] = 1756
				order[8] = 1757
				order[9] = 1758
				order[10] = 1759
				order[11] = 0
				super(670, 671, order)
			end

			class NoNested2PartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 757
					order[1] = 758
					order[2] = 759
					order[3] = 2381
					order[4] = 806
					order[5] = 0
					super(756, 757, order)
				end

				class NoNested2PartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 760
						order[1] = 807
						order[2] = 0
						super(806, 760, order)
					end
				end
			end
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end
end

class PartyRiskLimitCheckRequestAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DG") )
	end

	class NoRequestingPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1658
			order[1] = 1659
			order[2] = 1660
			order[3] = 2338
			order[4] = 1661
			order[5] = 0
			super(1657, 1658, order)
		end

		class NoRequestingPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1662
				order[1] = 1663
				order[2] = 0
				super(1661, 1662, order)
			end
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoRelatedPartyDetailID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(8)
			order[0] = 1563
			order[1] = 1564
			order[2] = 1565
			order[3] = 1675
			order[4] = 1566
			order[5] = 1569
			order[6] = 1514
			order[7] = 0
			super(1562, 1563, order)
		end

		class NoRelatedPartyDetailSubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1567
				order[1] = 1568
				order[2] = 0
				super(1566, 1567, order)
			end
		end

		class NoRelatedPartyDetailAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1570
				order[1] = 1571
				order[2] = 1572
				order[3] = 0
				super(1569, 1570, order)
			end

			class NoRelatedPartyDetailAltSubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1573
					order[1] = 1574
					order[2] = 0
					super(1572, 1573, order)
				end
			end
		end

		class NoPartyRelationships < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 1515
				order[1] = 0
				super(1514, 1515, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(174)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 685
			order[153] = 687
			order[154] = 690
			order[155] = 683
			order[156] = 1366
			order[157] = 670
			order[158] = 2680
			order[159] = 1817
			order[160] = 564
			order[161] = 565
			order[162] = 539
			order[163] = 654
			order[164] = 587
			order[165] = 588
			order[166] = 675
			order[167] = 2900
			order[168] = 1379
			order[169] = 1381
			order[170] = 1383
			order[171] = 1384
			order[172] = 1689
			order[173] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegStipulations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 688
				order[1] = 689
				order[2] = 0
				super(683, 688, order)
			end
		end

		class NoLegAllocs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 671
				order[1] = 672
				order[2] = 756
				order[3] = 673
				order[4] = 674
				order[5] = 1367
				order[6] = 2928
				order[7] = 1756
				order[8] = 1757
				order[9] = 1758
				order[10] = 1759
				order[11] = 0
				super(670, 671, order)
			end

			class NoNested2PartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 757
					order[1] = 758
					order[2] = 759
					order[3] = 2381
					order[4] = 806
					order[5] = 0
					super(756, 757, order)
				end

				class NoNested2PartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 760
						order[1] = 807
						order[2] = 0
						super(806, 760, order)
					end
				end
			end
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end
end

class PartyActionRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DH") )
	end

	class NoInstrumentScopeSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1541
			order[1] = 1542
			order[2] = 0
			super(1540, 1541, order)
		end
	end

	class NoRequestingPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1658
			order[1] = 1659
			order[2] = 1660
			order[3] = 2338
			order[4] = 1661
			order[5] = 0
			super(1657, 1658, order)
		end

		class NoRequestingPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1662
				order[1] = 1663
				order[2] = 0
				super(1661, 1662, order)
			end
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoRelatedPartyDetailID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(8)
			order[0] = 1563
			order[1] = 1564
			order[2] = 1565
			order[3] = 1675
			order[4] = 1566
			order[5] = 1569
			order[6] = 1514
			order[7] = 0
			super(1562, 1563, order)
		end

		class NoRelatedPartyDetailSubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1567
				order[1] = 1568
				order[2] = 0
				super(1566, 1567, order)
			end
		end

		class NoRelatedPartyDetailAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1570
				order[1] = 1571
				order[2] = 1572
				order[3] = 0
				super(1569, 1570, order)
			end

			class NoRelatedPartyDetailAltSubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1573
					order[1] = 1574
					order[2] = 0
					super(1572, 1573, order)
				end
			end
		end

		class NoPartyRelationships < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 1515
				order[1] = 0
				super(1514, 1515, order)
			end
		end
	end
end

class PartyActionReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DI") )
	end

	class NoInstrumentScopeSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 1541
			order[1] = 1542
			order[2] = 0
			super(1540, 1541, order)
		end
	end

	class NoRequestingPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1658
			order[1] = 1659
			order[2] = 1660
			order[3] = 2338
			order[4] = 1661
			order[5] = 0
			super(1657, 1658, order)
		end

		class NoRequestingPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1662
				order[1] = 1663
				order[2] = 0
				super(1661, 1662, order)
			end
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoRelatedPartyDetailID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(8)
			order[0] = 1563
			order[1] = 1564
			order[2] = 1565
			order[3] = 1675
			order[4] = 1566
			order[5] = 1569
			order[6] = 1514
			order[7] = 0
			super(1562, 1563, order)
		end

		class NoRelatedPartyDetailSubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1567
				order[1] = 1568
				order[2] = 0
				super(1566, 1567, order)
			end
		end

		class NoRelatedPartyDetailAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1570
				order[1] = 1571
				order[2] = 1572
				order[3] = 0
				super(1569, 1570, order)
			end

			class NoRelatedPartyDetailAltSubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1573
					order[1] = 1574
					order[2] = 0
					super(1572, 1573, order)
				end
			end
		end

		class NoPartyRelationships < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 1515
				order[1] = 0
				super(1514, 1515, order)
			end
		end
	end
end

class MassOrder < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DJ") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoOrderEntries < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(169)
			order[0] = 2429
			order[1] = 2430
			order[2] = 11
			order[3] = 41
			order[4] = 37
			order[5] = 40
			order[6] = 44
			order[7] = 54
			order[8] = 59
			order[9] = 38
			order[10] = 152
			order[11] = 516
			order[12] = 468
			order[13] = 469
			order[14] = 55
			order[15] = 65
			order[16] = 48
			order[17] = 22
			order[18] = 460
			order[19] = 1227
			order[20] = 1151
			order[21] = 461
			order[22] = 2891
			order[23] = 167
			order[24] = 762
			order[25] = 200
			order[26] = 541
			order[27] = 1079
			order[28] = 966
			order[29] = 1049
			order[30] = 965
			order[31] = 224
			order[32] = 1449
			order[33] = 1450
			order[34] = 1451
			order[35] = 1452
			order[36] = 1457
			order[37] = 1458
			order[38] = 1739
			order[39] = 2210
			order[40] = 1938
			order[41] = 1939
			order[42] = 1940
			order[43] = 2735
			order[44] = 1941
			order[45] = 1575
			order[46] = 1942
			order[47] = 1943
			order[48] = 1944
			order[49] = 1945
			order[50] = 1946
			order[51] = 1947
			order[52] = 1948
			order[53] = 1949
			order[54] = 1950
			order[55] = 2879
			order[56] = 1951
			order[57] = 1952
			order[58] = 1953
			order[59] = 1954
			order[60] = 1955
			order[61] = 1956
			order[62] = 1957
			order[63] = 1958
			order[64] = 1959
			order[65] = 1960
			order[66] = 1577
			order[67] = 1580
			order[68] = 1581
			order[69] = 1678
			order[70] = 1697
			order[71] = 225
			order[72] = 239
			order[73] = 226
			order[74] = 227
			order[75] = 228
			order[76] = 255
			order[77] = 543
			order[78] = 470
			order[79] = 471
			order[80] = 472
			order[81] = 240
			order[82] = 202
			order[83] = 2578
			order[84] = 2577
			order[85] = 947
			order[86] = 2904
			order[87] = 967
			order[88] = 968
			order[89] = 1698
			order[90] = 1866
			order[91] = 2600
			order[92] = 2001
			order[93] = 2601
			order[94] = 1478
			order[95] = 1479
			order[96] = 1480
			order[97] = 1481
			order[98] = 206
			order[99] = 231
			order[100] = 1435
			order[101] = 2353
			order[102] = 1439
			order[103] = 969
			order[104] = 1146
			order[105] = 996
			order[106] = 1147
			order[107] = 1716
			order[108] = 2905
			order[109] = 1191
			order[110] = 1192
			order[111] = 1717
			order[112] = 2906
			order[113] = 1193
			order[114] = 2579
			order[115] = 1194
			order[116] = 1482
			order[117] = 1195
			order[118] = 2753
			order[119] = 1196
			order[120] = 1197
			order[121] = 2002
			order[122] = 2140
			order[123] = 1524
			order[124] = 2907
			order[125] = 1198
			order[126] = 1199
			order[127] = 1200
			order[128] = 201
			order[129] = 2681
			order[130] = 2685
			order[131] = 1244
			order[132] = 1242
			order[133] = 2575
			order[134] = 2574
			order[135] = 997
			order[136] = 223
			order[137] = 207
			order[138] = 970
			order[139] = 971
			order[140] = 106
			order[141] = 348
			order[142] = 349
			order[143] = 2737
			order[144] = 2714
			order[145] = 2715
			order[146] = 2716
			order[147] = 107
			order[148] = 350
			order[149] = 351
			order[150] = 691
			order[151] = 667
			order[152] = 875
			order[153] = 876
			order[154] = 873
			order[155] = 874
			order[156] = 1687
			order[157] = 1787
			order[158] = 2141
			order[159] = 2142
			order[160] = 2143
			order[161] = 2752
			order[162] = 2144
			order[163] = 2145
			order[164] = 2576
			order[165] = 2962
			order[166] = 2602
			order[167] = 2603
			order[168] = 0
			super(2428, 2429, order)
		end

		class NoSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 455
				order[1] = 456
				order[2] = 2957
				order[3] = 0
				super(454, 455, order)
			end
		end

		class NoSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1977
				order[1] = 1978
				order[2] = 1979
				order[3] = 2741
				order[4] = 0
				super(1976, 1977, order)
			end
		end

		class NoAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2305
				order[1] = 2306
				order[2] = 2307
				order[3] = 0
				super(2304, 2305, order)
			end
		end

		class NoEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 865
				order[1] = 866
				order[2] = 1145
				order[3] = 1827
				order[4] = 1826
				order[5] = 2340
				order[6] = 867
				order[7] = 868
				order[8] = 1578
				order[9] = 1579
				order[10] = 0
				super(864, 865, order)
			end
		end

		class NoInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1019
				order[1] = 1050
				order[2] = 1051
				order[3] = 2378
				order[4] = 1052
				order[5] = 0
				super(1018, 1019, order)
			end

			class NoInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1053
					order[1] = 1054
					order[2] = 0
					super(1052, 1053, order)
				end
			end
		end

		class NoComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 1484
				order[1] = 2117
				order[2] = 2118
				order[3] = 2119
				order[4] = 1485
				order[5] = 2120
				order[6] = 2121
				order[7] = 2122
				order[8] = 2941
				order[9] = 1486
				order[10] = 2123
				order[11] = 1487
				order[12] = 1488
				order[13] = 1489
				order[14] = 1490
				order[15] = 1491
				order[16] = 2124
				order[17] = 2942
				order[18] = 2125
				order[19] = 2943
				order[20] = 2126
				order[21] = 2127
				order[22] = 2407
				order[23] = 2408
				order[24] = 2128
				order[25] = 2129
				order[26] = 2130
				order[27] = 2131
				order[28] = 2132
				order[29] = 41013
				order[30] = 41020
				order[31] = 41021
				order[32] = 41022
				order[33] = 41023
				order[34] = 41024
				order[35] = 41025
				order[36] = 41026
				order[37] = 41027
				order[38] = 41028
				order[39] = 41010
				order[40] = 2133
				order[41] = 2134
				order[42] = 2135
				order[43] = 2136
				order[44] = 2137
				order[45] = 41029
				order[46] = 40997
				order[47] = 2597
				order[48] = 2598
				order[49] = 2599
				order[50] = 2138
				order[51] = 2139
				order[52] = 0
				super(1483, 1484, order)
			end

			class NoComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1492
					order[1] = 1493
					order[2] = 1494
					order[3] = 0
					super(1491, 1492, order)
				end

				class NoComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1495
						order[1] = 1496
						order[2] = 0
						super(1494, 1495, order)
					end
				end
			end

			class NoComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41014
					order[1] = 41015
					order[2] = 41016
					order[3] = 41017
					order[4] = 0
					super(41013, 41014, order)
				end
			end

			class NoComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41019
					order[1] = 0
					super(41018, 41019, order)
				end
			end

			class NoComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41011
					order[1] = 41012
					order[2] = 41031
					order[3] = 41007
					order[4] = 40994
					order[5] = 0
					super(41010, 41011, order)
				end

				class NoComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41032
						order[1] = 41033
						order[2] = 41034
						order[3] = 41035
						order[4] = 41036
						order[5] = 0
						super(41031, 41032, order)
					end
				end

				class NoComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41008
						order[1] = 41009
						order[2] = 0
						super(41007, 41008, order)
					end
				end

				class NoComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40995
						order[1] = 40996
						order[2] = 0
						super(40994, 40995, order)
					end
				end
			end

			class NoComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41030
					order[1] = 0
					super(41029, 41030, order)
				end
			end

			class NoComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40998
					order[1] = 40999
					order[2] = 41000
					order[3] = 41001
					order[4] = 41002
					order[5] = 41003
					order[6] = 41004
					order[7] = 41005
					order[8] = 0
					super(40997, 40998, order)
				end

				class NoComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41006
						order[1] = 0
						super(41005, 41006, order)
					end
				end
			end
		end

		class NoBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40471
				order[1] = 0
				super(40278, 40471, order)
			end
		end

		class NoPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41231
				order[1] = 0
				super(41230, 41231, order)
			end
		end

		class NoMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41093
				order[1] = 40991
				order[2] = 0
				super(41092, 41093, order)
			end
		end

		class NoMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41095
				order[1] = 40992
				order[2] = 0
				super(41094, 41095, order)
			end
		end

		class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41097
				order[1] = 41098
				order[2] = 41099
				order[3] = 41100
				order[4] = 41101
				order[5] = 41102
				order[6] = 41103
				order[7] = 41104
				order[8] = 41105
				order[9] = 0
				super(41096, 41097, order)
			end
		end

		class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42776
				order[1] = 0
				super(42775, 42776, order)
			end
		end

		class NoOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41117
				order[1] = 0
				super(41116, 41117, order)
			end
		end

		class NoOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41138
				order[1] = 41139
				order[2] = 0
				super(41137, 41138, order)
			end
		end

		class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41141
				order[1] = 0
				super(41140, 41141, order)
			end
		end

		class NoOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41153
				order[1] = 41154
				order[2] = 0
				super(41152, 41153, order)
			end
		end

		class NoStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40050
				order[1] = 41303
				order[2] = 40051
				order[3] = 42784
				order[4] = 42785
				order[5] = 40052
				order[6] = 40053
				order[7] = 41305
				order[8] = 40054
				order[9] = 40055
				order[10] = 42786
				order[11] = 42787
				order[12] = 41306
				order[13] = 41307
				order[14] = 41308
				order[15] = 41309
				order[16] = 41310
				order[17] = 41311
				order[18] = 41251
				order[19] = 41252
				order[20] = 41253
				order[21] = 41254
				order[22] = 41255
				order[23] = 41256
				order[24] = 41257
				order[25] = 42587
				order[26] = 41258
				order[27] = 41259
				order[28] = 41260
				order[29] = 41261
				order[30] = 41262
				order[31] = 41263
				order[32] = 41264
				order[33] = 41265
				order[34] = 41266
				order[35] = 41267
				order[36] = 41268
				order[37] = 41269
				order[38] = 41270
				order[39] = 41271
				order[40] = 41272
				order[41] = 41273
				order[42] = 41274
				order[43] = 41275
				order[44] = 41276
				order[45] = 40907
				order[46] = 40908
				order[47] = 40910
				order[48] = 40911
				order[49] = 40912
				order[50] = 40913
				order[51] = 40914
				order[52] = 40065
				order[53] = 40066
				order[54] = 40068
				order[55] = 40069
				order[56] = 40070
				order[57] = 40071
				order[58] = 40072
				order[59] = 41244
				order[60] = 41245
				order[61] = 40073
				order[62] = 40075
				order[63] = 40076
				order[64] = 40078
				order[65] = 40079
				order[66] = 40080
				order[67] = 40081
				order[68] = 40082
				order[69] = 40083
				order[70] = 40084
				order[71] = 41246
				order[72] = 41247
				order[73] = 41248
				order[74] = 40738
				order[75] = 40739
				order[76] = 40740
				order[77] = 42600
				order[78] = 40741
				order[79] = 40742
				order[80] = 43106
				order[81] = 40743
				order[82] = 40744
				order[83] = 40745
				order[84] = 40746
				order[85] = 40747
				order[86] = 42601
				order[87] = 42602
				order[88] = 42603
				order[89] = 42604
				order[90] = 40748
				order[91] = 40749
				order[92] = 40750
				order[93] = 41180
				order[94] = 41181
				order[95] = 41182
				order[96] = 41183
				order[97] = 41184
				order[98] = 41185
				order[99] = 41186
				order[100] = 42605
				order[101] = 40828
				order[102] = 40872
				order[103] = 41058
				order[104] = 41059
				order[105] = 41060
				order[106] = 41061
				order[107] = 41062
				order[108] = 42192
				order[109] = 42193
				order[110] = 41063
				order[111] = 41064
				order[112] = 41065
				order[113] = 41066
				order[114] = 41067
				order[115] = 41218
				order[116] = 41068
				order[117] = 41069
				order[118] = 41070
				order[119] = 41071
				order[120] = 41072
				order[121] = 41073
				order[122] = 41074
				order[123] = 41075
				order[124] = 41076
				order[125] = 41077
				order[126] = 41078
				order[127] = 41079
				order[128] = 41080
				order[129] = 43094
				order[130] = 41037
				order[131] = 40056
				order[132] = 40982
				order[133] = 40983
				order[134] = 0
				super(40049, 40050, order)
			end

			class NoStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41278
					order[1] = 41279
					order[2] = 0
					super(41277, 41278, order)
				end
			end

			class NoStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41238
					order[1] = 41239
					order[2] = 41240
					order[3] = 0
					super(41237, 41238, order)
				end
			end

			class NoStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41281
					order[1] = 41282
					order[2] = 0
					super(41280, 41281, order)
				end
			end

			class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41250
					order[1] = 0
					super(41249, 41250, order)
				end
			end

			class NoStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41290
					order[1] = 41291
					order[2] = 41292
					order[3] = 41293
					order[4] = 41294
					order[5] = 41295
					order[6] = 41296
					order[7] = 41297
					order[8] = 41298
					order[9] = 41299
					order[10] = 41300
					order[11] = 41283
					order[12] = 41301
					order[13] = 41302
					order[14] = 0
					super(41289, 41290, order)
				end

				class NoStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41284
						order[1] = 41285
						order[2] = 41286
						order[3] = 0
						super(41283, 41284, order)
					end

					class NoStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41287
							order[1] = 41288
							order[2] = 41588
							order[3] = 0
							super(41286, 41287, order)
						end
					end
				end
			end

			class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40909
					order[1] = 0
					super(40960, 40909, order)
				end
			end

			class NoStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40067
					order[1] = 0
					super(40961, 40067, order)
				end
			end

			class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40074
					order[1] = 0
					super(40958, 40074, order)
				end
			end

			class NoStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41242
					order[1] = 41243
					order[2] = 0
					super(41241, 41242, order)
				end
			end

			class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40077
					order[1] = 0
					super(40959, 40077, order)
				end
			end

			class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40752
					order[1] = 0
					super(40947, 40752, order)
				end
			end

			class NoPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41221
					order[1] = 41222
					order[2] = 0
					super(41220, 41221, order)
				end
			end

			class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40763
					order[1] = 0
					super(40948, 40763, order)
				end
			end

			class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40769
					order[1] = 0
					super(40949, 40769, order)
				end
			end

			class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40776
					order[1] = 0
					super(40950, 40776, order)
				end
			end

			class NoPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42661
					order[1] = 42662
					order[2] = 0
					super(42660, 42661, order)
				end
			end

			class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41193
					order[1] = 0
					super(41192, 41193, order)
				end
			end

			class NoPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41228
					order[1] = 41229
					order[2] = 0
					super(41227, 41228, order)
				end
			end

			class NoPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41225
					order[1] = 41226
					order[2] = 0
					super(41224, 41225, order)
				end
			end

			class NoPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43109
					order[1] = 42684
					order[2] = 42685
					order[3] = 0
					super(42683, 43109, order)
				end
			end

			class NoDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42275
					order[1] = 42276
					order[2] = 42277
					order[3] = 42278
					order[4] = 42279
					order[5] = 42280
					order[6] = 42294
					order[7] = 42281
					order[8] = 42282
					order[9] = 42283
					order[10] = 42284
					order[11] = 42285
					order[12] = 42286
					order[13] = 42287
					order[14] = 42288
					order[15] = 42289
					order[16] = 42290
					order[17] = 42291
					order[18] = 42292
					order[19] = 42293
					order[20] = 0
					super(42274, 42275, order)
				end

				class NoDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42295
						order[1] = 0
						super(42294, 42295, order)
					end
				end
			end

			class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42273
					order[1] = 0
					super(42272, 42273, order)
				end
			end

			class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42237
					order[1] = 0
					super(42236, 42237, order)
				end
			end

			class NoReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42736
					order[1] = 42737
					order[2] = 42738
					order[3] = 42739
					order[4] = 42740
					order[5] = 42741
					order[6] = 42765
					order[7] = 42731
					order[8] = 42742
					order[9] = 42743
					order[10] = 42744
					order[11] = 42745
					order[12] = 42746
					order[13] = 42747
					order[14] = 42748
					order[15] = 42749
					order[16] = 42750
					order[17] = 42751
					order[18] = 42752
					order[19] = 42753
					order[20] = 42761
					order[21] = 42754
					order[22] = 42755
					order[23] = 42709
					order[24] = 42756
					order[25] = 42757
					order[26] = 42758
					order[27] = 42759
					order[28] = 42760
					order[29] = 0
					super(42735, 42736, order)
				end

				class NoReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42766
						order[1] = 42767
						order[2] = 42768
						order[3] = 42769
						order[4] = 0
						super(42765, 42766, order)
					end
				end

				class NoReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42732
						order[1] = 42733
						order[2] = 42734
						order[3] = 0
						super(42731, 42732, order)
					end
				end

				class NoReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42762
						order[1] = 42763
						order[2] = 42764
						order[3] = 0
						super(42761, 42762, order)
					end
				end

				class NoReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42710
						order[1] = 42772
						order[2] = 42711
						order[3] = 42712
						order[4] = 42713
						order[5] = 42714
						order[6] = 42715
						order[7] = 42716
						order[8] = 42717
						order[9] = 42718
						order[10] = 42719
						order[11] = 42720
						order[12] = 42721
						order[13] = 42722
						order[14] = 42723
						order[15] = 42724
						order[16] = 42725
						order[17] = 42726
						order[18] = 42727
						order[19] = 42728
						order[20] = 42729
						order[21] = 42730
						order[22] = 42770
						order[23] = 0
						super(42709, 42710, order)
					end

					class NoReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42773
							order[1] = 42774
							order[2] = 0
							super(42772, 42773, order)
						end
					end

					class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42771
							order[1] = 0
							super(42770, 42771, order)
						end
					end
				end
			end

			class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42621
					order[1] = 0
					super(42620, 42621, order)
				end
			end

			class NoPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42607
					order[1] = 42608
					order[2] = 0
					super(42606, 42607, order)
				end
			end

			class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40819
					order[1] = 0
					super(40946, 40819, order)
				end
			end

			class NoNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40826
					order[1] = 40827
					order[2] = 0
					super(40825, 40826, order)
				end
			end

			class NoSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40086
					order[1] = 40373
					order[2] = 40655
					order[3] = 40088
					order[4] = 40089
					order[5] = 0
					super(40085, 40086, order)
				end
			end

			class NoPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40829
					order[1] = 41164
					order[2] = 41165
					order[3] = 40830
					order[4] = 40831
					order[5] = 40832
					order[6] = 40833
					order[7] = 40834
					order[8] = 40835
					order[9] = 40836
					order[10] = 40837
					order[11] = 40838
					order[12] = 40839
					order[13] = 41166
					order[14] = 41167
					order[15] = 41168
					order[16] = 41169
					order[17] = 40840
					order[18] = 40841
					order[19] = 40842
					order[20] = 40843
					order[21] = 41170
					order[22] = 41171
					order[23] = 41172
					order[24] = 41173
					order[25] = 40844
					order[26] = 40845
					order[27] = 40846
					order[28] = 40847
					order[29] = 40848
					order[30] = 40849
					order[31] = 40868
					order[32] = 40850
					order[33] = 40851
					order[34] = 40852
					order[35] = 40853
					order[36] = 40977
					order[37] = 40855
					order[38] = 40856
					order[39] = 40857
					order[40] = 41174
					order[41] = 41175
					order[42] = 40858
					order[43] = 41161
					order[44] = 41176
					order[45] = 41177
					order[46] = 41178
					order[47] = 41179
					order[48] = 40859
					order[49] = 40860
					order[50] = 40861
					order[51] = 40862
					order[52] = 40945
					order[53] = 40864
					order[54] = 40865
					order[55] = 40866
					order[56] = 40867
					order[57] = 0
					super(40828, 40829, order)
				end

				class NoPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40869
						order[1] = 40870
						order[2] = 40871
						order[3] = 0
						super(40868, 40869, order)
					end
				end

				class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40854
						order[1] = 0
						super(40977, 40854, order)
					end
				end

				class NoPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41162
						order[1] = 41163
						order[2] = 0
						super(41161, 41162, order)
					end
				end

				class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40863
						order[1] = 0
						super(40945, 40863, order)
					end
				end
			end

			class NoPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40873
					order[1] = 40874
					order[2] = 42698
					order[3] = 42699
					order[4] = 42700
					order[5] = 42701
					order[6] = 42702
					order[7] = 42703
					order[8] = 42704
					order[9] = 42689
					order[10] = 42690
					order[11] = 42691
					order[12] = 42692
					order[13] = 42693
					order[14] = 42694
					order[15] = 42695
					order[16] = 40875
					order[17] = 40876
					order[18] = 40877
					order[19] = 40878
					order[20] = 40879
					order[21] = 40880
					order[22] = 40881
					order[23] = 40882
					order[24] = 40883
					order[25] = 40884
					order[26] = 40885
					order[27] = 40886
					order[28] = 40887
					order[29] = 40888
					order[30] = 40889
					order[31] = 40890
					order[32] = 40891
					order[33] = 40892
					order[34] = 40893
					order[35] = 40894
					order[36] = 40895
					order[37] = 40896
					order[38] = 40897
					order[39] = 40898
					order[40] = 40899
					order[41] = 40900
					order[42] = 40901
					order[43] = 0
					super(40872, 40873, order)
				end

				class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42706
						order[1] = 0
						super(42705, 42706, order)
					end
				end

				class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42697
						order[1] = 0
						super(42696, 42697, order)
					end
				end
			end

			class NoDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41086
					order[1] = 0
					super(41085, 41086, order)
				end
			end

			class NoDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41082
					order[1] = 41083
					order[2] = 41084
					order[3] = 0
					super(41081, 41082, order)
				end
			end

			class NoDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41038
					order[1] = 41039
					order[2] = 41040
					order[3] = 41041
					order[4] = 41042
					order[5] = 41043
					order[6] = 41044
					order[7] = 41045
					order[8] = 41046
					order[9] = 41047
					order[10] = 41048
					order[11] = 41049
					order[12] = 41050
					order[13] = 41051
					order[14] = 0
					super(41037, 41038, order)
				end

				class NoDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41052
						order[1] = 41053
						order[2] = 41054
						order[3] = 0
						super(41051, 41052, order)
					end

					class NoDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41055
							order[1] = 41056
							order[2] = 41057
							order[3] = 0
							super(41054, 41055, order)
						end
					end
				end
			end
		end

		class NoProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40091
				order[1] = 40092
				order[2] = 40093
				order[3] = 40957
				order[4] = 40095
				order[5] = 40096
				order[6] = 40097
				order[7] = 42707
				order[8] = 42708
				order[9] = 40098
				order[10] = 40099
				order[11] = 40100
				order[12] = 40114
				order[13] = 40115
				order[14] = 40116
				order[15] = 40118
				order[16] = 40119
				order[17] = 40120
				order[18] = 40121
				order[19] = 40122
				order[20] = 40123
				order[21] = 40125
				order[22] = 40126
				order[23] = 40127
				order[24] = 40128
				order[25] = 40129
				order[26] = 40130
				order[27] = 40131
				order[28] = 40132
				order[29] = 40133
				order[30] = 40134
				order[31] = 40135
				order[32] = 40136
				order[33] = 40137
				order[34] = 40138
				order[35] = 40139
				order[36] = 40140
				order[37] = 40141
				order[38] = 40145
				order[39] = 40146
				order[40] = 40148
				order[41] = 40149
				order[42] = 40150
				order[43] = 40151
				order[44] = 40152
				order[45] = 40153
				order[46] = 40154
				order[47] = 40155
				order[48] = 40156
				order[49] = 40158
				order[50] = 40159
				order[51] = 40160
				order[52] = 40161
				order[53] = 40162
				order[54] = 40101
				order[55] = 40102
				order[56] = 40103
				order[57] = 40104
				order[58] = 40105
				order[59] = 40106
				order[60] = 40107
				order[61] = 40163
				order[62] = 40165
				order[63] = 40166
				order[64] = 40167
				order[65] = 40168
				order[66] = 40169
				order[67] = 40170
				order[68] = 40108
				order[69] = 40109
				order[70] = 40110
				order[71] = 40111
				order[72] = 40112
				order[73] = 41406
				order[74] = 40113
				order[75] = 40986
				order[76] = 40987
				order[77] = 40174
				order[78] = 0
				super(40090, 40091, order)
			end

			class NoProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40094
					order[1] = 0
					super(40957, 40094, order)
				end
			end

			class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40117
					order[1] = 0
					super(40953, 40117, order)
				end
			end

			class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40124
					order[1] = 0
					super(40954, 40124, order)
				end
			end

			class NoProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40143
					order[1] = 40144
					order[2] = 0
					super(40142, 40143, order)
				end
			end

			class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40147
					order[1] = 0
					super(40955, 40147, order)
				end
			end

			class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40157
					order[1] = 0
					super(40956, 40157, order)
				end
			end

			class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40164
					order[1] = 0
					super(40952, 40164, order)
				end
			end

			class NoProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40172
					order[1] = 40173
					order[2] = 0
					super(40171, 40172, order)
				end
			end

			class NoProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40175
					order[1] = 40176
					order[2] = 40177
					order[3] = 2385
					order[4] = 40178
					order[5] = 0
					super(40174, 40175, order)
				end

				class NoProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40179
						order[1] = 40180
						order[2] = 0
						super(40178, 40179, order)
					end
				end
			end
		end

		class NoAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40020
				order[1] = 40021
				order[2] = 40000
				order[3] = 0
				super(40019, 40020, order)
			end

			class NoAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 40001
					order[1] = 40002
					order[2] = 40003
					order[3] = 40004
					order[4] = 40005
					order[5] = 40006
					order[6] = 40007
					order[7] = 40008
					order[8] = 40009
					order[9] = 40010
					order[10] = 40011
					order[11] = 40012
					order[12] = 40013
					order[13] = 40014
					order[14] = 40015
					order[15] = 40016
					order[16] = 40017
					order[17] = 40018
					order[18] = 0
					super(40000, 40001, order)
				end
			end
		end

		class NoProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 40182
				order[1] = 40183
				order[2] = 40184
				order[3] = 40185
				order[4] = 40186
				order[5] = 40187
				order[6] = 40188
				order[7] = 40951
				order[8] = 40191
				order[9] = 40201
				order[10] = 40190
				order[11] = 0
				super(40181, 40182, order)
			end

			class NoProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40189
					order[1] = 0
					super(40951, 40189, order)
				end
			end

			class NoProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40192
					order[1] = 40193
					order[2] = 40194
					order[3] = 40195
					order[4] = 40196
					order[5] = 40197
					order[6] = 40198
					order[7] = 40199
					order[8] = 0
					super(40191, 40192, order)
				end

				class NoProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40200
						order[1] = 0
						super(40199, 40200, order)
					end
				end
			end

			class NoProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40202
					order[1] = 40203
					order[2] = 0
					super(40201, 40202, order)
				end
			end
		end

		class NoCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 40023
				order[1] = 40024
				order[2] = 40916
				order[3] = 40917
				order[4] = 40025
				order[5] = 40026
				order[6] = 40027
				order[7] = 40028
				order[8] = 40029
				order[9] = 40030
				order[10] = 40031
				order[11] = 40277
				order[12] = 42216
				order[13] = 42217
				order[14] = 40033
				order[15] = 40034
				order[16] = 42207
				order[17] = 42208
				order[18] = 42209
				order[19] = 42210
				order[20] = 42211
				order[21] = 42212
				order[22] = 42213
				order[23] = 40035
				order[24] = 40036
				order[25] = 40037
				order[26] = 40038
				order[27] = 40039
				order[28] = 0
				super(40022, 40023, order)
			end

			class NoCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40032
					order[1] = 0
					super(40277, 40032, order)
				end
			end

			class NoCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42215
					order[1] = 0
					super(42214, 42215, order)
				end
			end
		end

		class NoPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40209
				order[1] = 40205
				order[2] = 40206
				order[3] = 40207
				order[4] = 40208
				order[5] = 0
				super(40204, 40209, order)
			end

			class NoPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40210
					order[1] = 40211
					order[2] = 0
					super(40209, 40210, order)
				end
			end
		end

		class NoExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42297
				order[1] = 42298
				order[2] = 0
				super(42296, 42297, order)
			end
		end
	end
end

class MassOrderAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DK") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoOrderEntries < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 39
			order[1] = 150
			order[2] = 2431
			order[3] = 2429
			order[4] = 2430
			order[5] = 11
			order[6] = 41
			order[7] = 37
			order[8] = 103
			order[9] = 14
			order[10] = 151
			order[11] = 84
			order[12] = 40
			order[13] = 44
			order[14] = 54
			order[15] = 59
			order[16] = 38
			order[17] = 152
			order[18] = 516
			order[19] = 468
			order[20] = 469
			order[21] = 55
			order[22] = 65
			order[23] = 48
			order[24] = 22
			order[25] = 460
			order[26] = 1227
			order[27] = 1151
			order[28] = 461
			order[29] = 2891
			order[30] = 167
			order[31] = 762
			order[32] = 200
			order[33] = 541
			order[34] = 1079
			order[35] = 966
			order[36] = 1049
			order[37] = 965
			order[38] = 224
			order[39] = 1449
			order[40] = 1450
			order[41] = 1451
			order[42] = 1452
			order[43] = 1457
			order[44] = 1458
			order[45] = 1739
			order[46] = 2210
			order[47] = 1938
			order[48] = 1939
			order[49] = 1940
			order[50] = 2735
			order[51] = 1941
			order[52] = 1575
			order[53] = 1942
			order[54] = 1943
			order[55] = 1944
			order[56] = 1945
			order[57] = 1946
			order[58] = 1947
			order[59] = 1948
			order[60] = 1949
			order[61] = 1950
			order[62] = 2879
			order[63] = 1951
			order[64] = 1952
			order[65] = 1953
			order[66] = 1954
			order[67] = 1955
			order[68] = 1956
			order[69] = 1957
			order[70] = 1958
			order[71] = 1959
			order[72] = 1960
			order[73] = 1577
			order[74] = 1580
			order[75] = 1581
			order[76] = 1678
			order[77] = 1697
			order[78] = 225
			order[79] = 239
			order[80] = 226
			order[81] = 227
			order[82] = 228
			order[83] = 255
			order[84] = 543
			order[85] = 470
			order[86] = 471
			order[87] = 472
			order[88] = 240
			order[89] = 202
			order[90] = 2578
			order[91] = 2577
			order[92] = 947
			order[93] = 2904
			order[94] = 967
			order[95] = 968
			order[96] = 1698
			order[97] = 1866
			order[98] = 2600
			order[99] = 2001
			order[100] = 2601
			order[101] = 1478
			order[102] = 1479
			order[103] = 1480
			order[104] = 1481
			order[105] = 206
			order[106] = 231
			order[107] = 1435
			order[108] = 2353
			order[109] = 1439
			order[110] = 969
			order[111] = 1146
			order[112] = 996
			order[113] = 1147
			order[114] = 1716
			order[115] = 2905
			order[116] = 1191
			order[117] = 1192
			order[118] = 1717
			order[119] = 2906
			order[120] = 1193
			order[121] = 2579
			order[122] = 1194
			order[123] = 1482
			order[124] = 1195
			order[125] = 2753
			order[126] = 1196
			order[127] = 1197
			order[128] = 2002
			order[129] = 2140
			order[130] = 1524
			order[131] = 2907
			order[132] = 1198
			order[133] = 1199
			order[134] = 1200
			order[135] = 201
			order[136] = 2681
			order[137] = 2685
			order[138] = 1244
			order[139] = 1242
			order[140] = 2575
			order[141] = 2574
			order[142] = 997
			order[143] = 223
			order[144] = 207
			order[145] = 970
			order[146] = 971
			order[147] = 106
			order[148] = 348
			order[149] = 349
			order[150] = 2737
			order[151] = 2714
			order[152] = 2715
			order[153] = 2716
			order[154] = 107
			order[155] = 350
			order[156] = 351
			order[157] = 691
			order[158] = 667
			order[159] = 875
			order[160] = 876
			order[161] = 873
			order[162] = 874
			order[163] = 1687
			order[164] = 1787
			order[165] = 2141
			order[166] = 2142
			order[167] = 2143
			order[168] = 2752
			order[169] = 2144
			order[170] = 2145
			order[171] = 2576
			order[172] = 2962
			order[173] = 2602
			order[174] = 2603
			order[175] = 0
			super(2428, 39, order)
		end

		class NoSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 455
				order[1] = 456
				order[2] = 2957
				order[3] = 0
				super(454, 455, order)
			end
		end

		class NoSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 1977
				order[1] = 1978
				order[2] = 1979
				order[3] = 2741
				order[4] = 0
				super(1976, 1977, order)
			end
		end

		class NoAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2305
				order[1] = 2306
				order[2] = 2307
				order[3] = 0
				super(2304, 2305, order)
			end
		end

		class NoEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 865
				order[1] = 866
				order[2] = 1145
				order[3] = 1827
				order[4] = 1826
				order[5] = 2340
				order[6] = 867
				order[7] = 868
				order[8] = 1578
				order[9] = 1579
				order[10] = 0
				super(864, 865, order)
			end
		end

		class NoInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1019
				order[1] = 1050
				order[2] = 1051
				order[3] = 2378
				order[4] = 1052
				order[5] = 0
				super(1018, 1019, order)
			end

			class NoInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1053
					order[1] = 1054
					order[2] = 0
					super(1052, 1053, order)
				end
			end
		end

		class NoComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 1484
				order[1] = 2117
				order[2] = 2118
				order[3] = 2119
				order[4] = 1485
				order[5] = 2120
				order[6] = 2121
				order[7] = 2122
				order[8] = 2941
				order[9] = 1486
				order[10] = 2123
				order[11] = 1487
				order[12] = 1488
				order[13] = 1489
				order[14] = 1490
				order[15] = 1491
				order[16] = 2124
				order[17] = 2942
				order[18] = 2125
				order[19] = 2943
				order[20] = 2126
				order[21] = 2127
				order[22] = 2407
				order[23] = 2408
				order[24] = 2128
				order[25] = 2129
				order[26] = 2130
				order[27] = 2131
				order[28] = 2132
				order[29] = 41013
				order[30] = 41020
				order[31] = 41021
				order[32] = 41022
				order[33] = 41023
				order[34] = 41024
				order[35] = 41025
				order[36] = 41026
				order[37] = 41027
				order[38] = 41028
				order[39] = 41010
				order[40] = 2133
				order[41] = 2134
				order[42] = 2135
				order[43] = 2136
				order[44] = 2137
				order[45] = 41029
				order[46] = 40997
				order[47] = 2597
				order[48] = 2598
				order[49] = 2599
				order[50] = 2138
				order[51] = 2139
				order[52] = 0
				super(1483, 1484, order)
			end

			class NoComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 1492
					order[1] = 1493
					order[2] = 1494
					order[3] = 0
					super(1491, 1492, order)
				end

				class NoComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 1495
						order[1] = 1496
						order[2] = 0
						super(1494, 1495, order)
					end
				end
			end

			class NoComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41014
					order[1] = 41015
					order[2] = 41016
					order[3] = 41017
					order[4] = 0
					super(41013, 41014, order)
				end
			end

			class NoComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41019
					order[1] = 0
					super(41018, 41019, order)
				end
			end

			class NoComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41011
					order[1] = 41012
					order[2] = 41031
					order[3] = 41007
					order[4] = 40994
					order[5] = 0
					super(41010, 41011, order)
				end

				class NoComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41032
						order[1] = 41033
						order[2] = 41034
						order[3] = 41035
						order[4] = 41036
						order[5] = 0
						super(41031, 41032, order)
					end
				end

				class NoComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41008
						order[1] = 41009
						order[2] = 0
						super(41007, 41008, order)
					end
				end

				class NoComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40995
						order[1] = 40996
						order[2] = 0
						super(40994, 40995, order)
					end
				end
			end

			class NoComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41030
					order[1] = 0
					super(41029, 41030, order)
				end
			end

			class NoComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40998
					order[1] = 40999
					order[2] = 41000
					order[3] = 41001
					order[4] = 41002
					order[5] = 41003
					order[6] = 41004
					order[7] = 41005
					order[8] = 0
					super(40997, 40998, order)
				end

				class NoComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41006
						order[1] = 0
						super(41005, 41006, order)
					end
				end
			end
		end

		class NoBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40471
				order[1] = 0
				super(40278, 40471, order)
			end
		end

		class NoPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41231
				order[1] = 0
				super(41230, 41231, order)
			end
		end

		class NoMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41093
				order[1] = 40991
				order[2] = 0
				super(41092, 41093, order)
			end
		end

		class NoMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41095
				order[1] = 40992
				order[2] = 0
				super(41094, 41095, order)
			end
		end

		class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41097
				order[1] = 41098
				order[2] = 41099
				order[3] = 41100
				order[4] = 41101
				order[5] = 41102
				order[6] = 41103
				order[7] = 41104
				order[8] = 41105
				order[9] = 0
				super(41096, 41097, order)
			end
		end

		class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42776
				order[1] = 0
				super(42775, 42776, order)
			end
		end

		class NoOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41117
				order[1] = 0
				super(41116, 41117, order)
			end
		end

		class NoOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41138
				order[1] = 41139
				order[2] = 0
				super(41137, 41138, order)
			end
		end

		class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41141
				order[1] = 0
				super(41140, 41141, order)
			end
		end

		class NoOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41153
				order[1] = 41154
				order[2] = 0
				super(41152, 41153, order)
			end
		end

		class NoStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40050
				order[1] = 41303
				order[2] = 40051
				order[3] = 42784
				order[4] = 42785
				order[5] = 40052
				order[6] = 40053
				order[7] = 41305
				order[8] = 40054
				order[9] = 40055
				order[10] = 42786
				order[11] = 42787
				order[12] = 41306
				order[13] = 41307
				order[14] = 41308
				order[15] = 41309
				order[16] = 41310
				order[17] = 41311
				order[18] = 41251
				order[19] = 41252
				order[20] = 41253
				order[21] = 41254
				order[22] = 41255
				order[23] = 41256
				order[24] = 41257
				order[25] = 42587
				order[26] = 41258
				order[27] = 41259
				order[28] = 41260
				order[29] = 41261
				order[30] = 41262
				order[31] = 41263
				order[32] = 41264
				order[33] = 41265
				order[34] = 41266
				order[35] = 41267
				order[36] = 41268
				order[37] = 41269
				order[38] = 41270
				order[39] = 41271
				order[40] = 41272
				order[41] = 41273
				order[42] = 41274
				order[43] = 41275
				order[44] = 41276
				order[45] = 40907
				order[46] = 40908
				order[47] = 40910
				order[48] = 40911
				order[49] = 40912
				order[50] = 40913
				order[51] = 40914
				order[52] = 40065
				order[53] = 40066
				order[54] = 40068
				order[55] = 40069
				order[56] = 40070
				order[57] = 40071
				order[58] = 40072
				order[59] = 41244
				order[60] = 41245
				order[61] = 40073
				order[62] = 40075
				order[63] = 40076
				order[64] = 40078
				order[65] = 40079
				order[66] = 40080
				order[67] = 40081
				order[68] = 40082
				order[69] = 40083
				order[70] = 40084
				order[71] = 41246
				order[72] = 41247
				order[73] = 41248
				order[74] = 40738
				order[75] = 40739
				order[76] = 40740
				order[77] = 42600
				order[78] = 40741
				order[79] = 40742
				order[80] = 43106
				order[81] = 40743
				order[82] = 40744
				order[83] = 40745
				order[84] = 40746
				order[85] = 40747
				order[86] = 42601
				order[87] = 42602
				order[88] = 42603
				order[89] = 42604
				order[90] = 40748
				order[91] = 40749
				order[92] = 40750
				order[93] = 41180
				order[94] = 41181
				order[95] = 41182
				order[96] = 41183
				order[97] = 41184
				order[98] = 41185
				order[99] = 41186
				order[100] = 42605
				order[101] = 40828
				order[102] = 40872
				order[103] = 41058
				order[104] = 41059
				order[105] = 41060
				order[106] = 41061
				order[107] = 41062
				order[108] = 42192
				order[109] = 42193
				order[110] = 41063
				order[111] = 41064
				order[112] = 41065
				order[113] = 41066
				order[114] = 41067
				order[115] = 41218
				order[116] = 41068
				order[117] = 41069
				order[118] = 41070
				order[119] = 41071
				order[120] = 41072
				order[121] = 41073
				order[122] = 41074
				order[123] = 41075
				order[124] = 41076
				order[125] = 41077
				order[126] = 41078
				order[127] = 41079
				order[128] = 41080
				order[129] = 43094
				order[130] = 41037
				order[131] = 40056
				order[132] = 40982
				order[133] = 40983
				order[134] = 0
				super(40049, 40050, order)
			end

			class NoStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41278
					order[1] = 41279
					order[2] = 0
					super(41277, 41278, order)
				end
			end

			class NoStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41238
					order[1] = 41239
					order[2] = 41240
					order[3] = 0
					super(41237, 41238, order)
				end
			end

			class NoStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41281
					order[1] = 41282
					order[2] = 0
					super(41280, 41281, order)
				end
			end

			class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41250
					order[1] = 0
					super(41249, 41250, order)
				end
			end

			class NoStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41290
					order[1] = 41291
					order[2] = 41292
					order[3] = 41293
					order[4] = 41294
					order[5] = 41295
					order[6] = 41296
					order[7] = 41297
					order[8] = 41298
					order[9] = 41299
					order[10] = 41300
					order[11] = 41283
					order[12] = 41301
					order[13] = 41302
					order[14] = 0
					super(41289, 41290, order)
				end

				class NoStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41284
						order[1] = 41285
						order[2] = 41286
						order[3] = 0
						super(41283, 41284, order)
					end

					class NoStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41287
							order[1] = 41288
							order[2] = 41588
							order[3] = 0
							super(41286, 41287, order)
						end
					end
				end
			end

			class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40909
					order[1] = 0
					super(40960, 40909, order)
				end
			end

			class NoStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40067
					order[1] = 0
					super(40961, 40067, order)
				end
			end

			class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40074
					order[1] = 0
					super(40958, 40074, order)
				end
			end

			class NoStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41242
					order[1] = 41243
					order[2] = 0
					super(41241, 41242, order)
				end
			end

			class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40077
					order[1] = 0
					super(40959, 40077, order)
				end
			end

			class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40752
					order[1] = 0
					super(40947, 40752, order)
				end
			end

			class NoPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41221
					order[1] = 41222
					order[2] = 0
					super(41220, 41221, order)
				end
			end

			class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40763
					order[1] = 0
					super(40948, 40763, order)
				end
			end

			class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40769
					order[1] = 0
					super(40949, 40769, order)
				end
			end

			class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40776
					order[1] = 0
					super(40950, 40776, order)
				end
			end

			class NoPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42661
					order[1] = 42662
					order[2] = 0
					super(42660, 42661, order)
				end
			end

			class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41193
					order[1] = 0
					super(41192, 41193, order)
				end
			end

			class NoPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41228
					order[1] = 41229
					order[2] = 0
					super(41227, 41228, order)
				end
			end

			class NoPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41225
					order[1] = 41226
					order[2] = 0
					super(41224, 41225, order)
				end
			end

			class NoPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43109
					order[1] = 42684
					order[2] = 42685
					order[3] = 0
					super(42683, 43109, order)
				end
			end

			class NoDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42275
					order[1] = 42276
					order[2] = 42277
					order[3] = 42278
					order[4] = 42279
					order[5] = 42280
					order[6] = 42294
					order[7] = 42281
					order[8] = 42282
					order[9] = 42283
					order[10] = 42284
					order[11] = 42285
					order[12] = 42286
					order[13] = 42287
					order[14] = 42288
					order[15] = 42289
					order[16] = 42290
					order[17] = 42291
					order[18] = 42292
					order[19] = 42293
					order[20] = 0
					super(42274, 42275, order)
				end

				class NoDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42295
						order[1] = 0
						super(42294, 42295, order)
					end
				end
			end

			class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42273
					order[1] = 0
					super(42272, 42273, order)
				end
			end

			class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42237
					order[1] = 0
					super(42236, 42237, order)
				end
			end

			class NoReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42736
					order[1] = 42737
					order[2] = 42738
					order[3] = 42739
					order[4] = 42740
					order[5] = 42741
					order[6] = 42765
					order[7] = 42731
					order[8] = 42742
					order[9] = 42743
					order[10] = 42744
					order[11] = 42745
					order[12] = 42746
					order[13] = 42747
					order[14] = 42748
					order[15] = 42749
					order[16] = 42750
					order[17] = 42751
					order[18] = 42752
					order[19] = 42753
					order[20] = 42761
					order[21] = 42754
					order[22] = 42755
					order[23] = 42709
					order[24] = 42756
					order[25] = 42757
					order[26] = 42758
					order[27] = 42759
					order[28] = 42760
					order[29] = 0
					super(42735, 42736, order)
				end

				class NoReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42766
						order[1] = 42767
						order[2] = 42768
						order[3] = 42769
						order[4] = 0
						super(42765, 42766, order)
					end
				end

				class NoReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42732
						order[1] = 42733
						order[2] = 42734
						order[3] = 0
						super(42731, 42732, order)
					end
				end

				class NoReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42762
						order[1] = 42763
						order[2] = 42764
						order[3] = 0
						super(42761, 42762, order)
					end
				end

				class NoReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42710
						order[1] = 42772
						order[2] = 42711
						order[3] = 42712
						order[4] = 42713
						order[5] = 42714
						order[6] = 42715
						order[7] = 42716
						order[8] = 42717
						order[9] = 42718
						order[10] = 42719
						order[11] = 42720
						order[12] = 42721
						order[13] = 42722
						order[14] = 42723
						order[15] = 42724
						order[16] = 42725
						order[17] = 42726
						order[18] = 42727
						order[19] = 42728
						order[20] = 42729
						order[21] = 42730
						order[22] = 42770
						order[23] = 0
						super(42709, 42710, order)
					end

					class NoReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42773
							order[1] = 42774
							order[2] = 0
							super(42772, 42773, order)
						end
					end

					class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42771
							order[1] = 0
							super(42770, 42771, order)
						end
					end
				end
			end

			class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42621
					order[1] = 0
					super(42620, 42621, order)
				end
			end

			class NoPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42607
					order[1] = 42608
					order[2] = 0
					super(42606, 42607, order)
				end
			end

			class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40819
					order[1] = 0
					super(40946, 40819, order)
				end
			end

			class NoNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40826
					order[1] = 40827
					order[2] = 0
					super(40825, 40826, order)
				end
			end

			class NoSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40086
					order[1] = 40373
					order[2] = 40655
					order[3] = 40088
					order[4] = 40089
					order[5] = 0
					super(40085, 40086, order)
				end
			end

			class NoPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40829
					order[1] = 41164
					order[2] = 41165
					order[3] = 40830
					order[4] = 40831
					order[5] = 40832
					order[6] = 40833
					order[7] = 40834
					order[8] = 40835
					order[9] = 40836
					order[10] = 40837
					order[11] = 40838
					order[12] = 40839
					order[13] = 41166
					order[14] = 41167
					order[15] = 41168
					order[16] = 41169
					order[17] = 40840
					order[18] = 40841
					order[19] = 40842
					order[20] = 40843
					order[21] = 41170
					order[22] = 41171
					order[23] = 41172
					order[24] = 41173
					order[25] = 40844
					order[26] = 40845
					order[27] = 40846
					order[28] = 40847
					order[29] = 40848
					order[30] = 40849
					order[31] = 40868
					order[32] = 40850
					order[33] = 40851
					order[34] = 40852
					order[35] = 40853
					order[36] = 40977
					order[37] = 40855
					order[38] = 40856
					order[39] = 40857
					order[40] = 41174
					order[41] = 41175
					order[42] = 40858
					order[43] = 41161
					order[44] = 41176
					order[45] = 41177
					order[46] = 41178
					order[47] = 41179
					order[48] = 40859
					order[49] = 40860
					order[50] = 40861
					order[51] = 40862
					order[52] = 40945
					order[53] = 40864
					order[54] = 40865
					order[55] = 40866
					order[56] = 40867
					order[57] = 0
					super(40828, 40829, order)
				end

				class NoPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40869
						order[1] = 40870
						order[2] = 40871
						order[3] = 0
						super(40868, 40869, order)
					end
				end

				class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40854
						order[1] = 0
						super(40977, 40854, order)
					end
				end

				class NoPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41162
						order[1] = 41163
						order[2] = 0
						super(41161, 41162, order)
					end
				end

				class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40863
						order[1] = 0
						super(40945, 40863, order)
					end
				end
			end

			class NoPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40873
					order[1] = 40874
					order[2] = 42698
					order[3] = 42699
					order[4] = 42700
					order[5] = 42701
					order[6] = 42702
					order[7] = 42703
					order[8] = 42704
					order[9] = 42689
					order[10] = 42690
					order[11] = 42691
					order[12] = 42692
					order[13] = 42693
					order[14] = 42694
					order[15] = 42695
					order[16] = 40875
					order[17] = 40876
					order[18] = 40877
					order[19] = 40878
					order[20] = 40879
					order[21] = 40880
					order[22] = 40881
					order[23] = 40882
					order[24] = 40883
					order[25] = 40884
					order[26] = 40885
					order[27] = 40886
					order[28] = 40887
					order[29] = 40888
					order[30] = 40889
					order[31] = 40890
					order[32] = 40891
					order[33] = 40892
					order[34] = 40893
					order[35] = 40894
					order[36] = 40895
					order[37] = 40896
					order[38] = 40897
					order[39] = 40898
					order[40] = 40899
					order[41] = 40900
					order[42] = 40901
					order[43] = 0
					super(40872, 40873, order)
				end

				class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42706
						order[1] = 0
						super(42705, 42706, order)
					end
				end

				class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42697
						order[1] = 0
						super(42696, 42697, order)
					end
				end
			end

			class NoDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41086
					order[1] = 0
					super(41085, 41086, order)
				end
			end

			class NoDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41082
					order[1] = 41083
					order[2] = 41084
					order[3] = 0
					super(41081, 41082, order)
				end
			end

			class NoDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41038
					order[1] = 41039
					order[2] = 41040
					order[3] = 41041
					order[4] = 41042
					order[5] = 41043
					order[6] = 41044
					order[7] = 41045
					order[8] = 41046
					order[9] = 41047
					order[10] = 41048
					order[11] = 41049
					order[12] = 41050
					order[13] = 41051
					order[14] = 0
					super(41037, 41038, order)
				end

				class NoDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41052
						order[1] = 41053
						order[2] = 41054
						order[3] = 0
						super(41051, 41052, order)
					end

					class NoDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41055
							order[1] = 41056
							order[2] = 41057
							order[3] = 0
							super(41054, 41055, order)
						end
					end
				end
			end
		end

		class NoProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40091
				order[1] = 40092
				order[2] = 40093
				order[3] = 40957
				order[4] = 40095
				order[5] = 40096
				order[6] = 40097
				order[7] = 42707
				order[8] = 42708
				order[9] = 40098
				order[10] = 40099
				order[11] = 40100
				order[12] = 40114
				order[13] = 40115
				order[14] = 40116
				order[15] = 40118
				order[16] = 40119
				order[17] = 40120
				order[18] = 40121
				order[19] = 40122
				order[20] = 40123
				order[21] = 40125
				order[22] = 40126
				order[23] = 40127
				order[24] = 40128
				order[25] = 40129
				order[26] = 40130
				order[27] = 40131
				order[28] = 40132
				order[29] = 40133
				order[30] = 40134
				order[31] = 40135
				order[32] = 40136
				order[33] = 40137
				order[34] = 40138
				order[35] = 40139
				order[36] = 40140
				order[37] = 40141
				order[38] = 40145
				order[39] = 40146
				order[40] = 40148
				order[41] = 40149
				order[42] = 40150
				order[43] = 40151
				order[44] = 40152
				order[45] = 40153
				order[46] = 40154
				order[47] = 40155
				order[48] = 40156
				order[49] = 40158
				order[50] = 40159
				order[51] = 40160
				order[52] = 40161
				order[53] = 40162
				order[54] = 40101
				order[55] = 40102
				order[56] = 40103
				order[57] = 40104
				order[58] = 40105
				order[59] = 40106
				order[60] = 40107
				order[61] = 40163
				order[62] = 40165
				order[63] = 40166
				order[64] = 40167
				order[65] = 40168
				order[66] = 40169
				order[67] = 40170
				order[68] = 40108
				order[69] = 40109
				order[70] = 40110
				order[71] = 40111
				order[72] = 40112
				order[73] = 41406
				order[74] = 40113
				order[75] = 40986
				order[76] = 40987
				order[77] = 40174
				order[78] = 0
				super(40090, 40091, order)
			end

			class NoProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40094
					order[1] = 0
					super(40957, 40094, order)
				end
			end

			class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40117
					order[1] = 0
					super(40953, 40117, order)
				end
			end

			class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40124
					order[1] = 0
					super(40954, 40124, order)
				end
			end

			class NoProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40143
					order[1] = 40144
					order[2] = 0
					super(40142, 40143, order)
				end
			end

			class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40147
					order[1] = 0
					super(40955, 40147, order)
				end
			end

			class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40157
					order[1] = 0
					super(40956, 40157, order)
				end
			end

			class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40164
					order[1] = 0
					super(40952, 40164, order)
				end
			end

			class NoProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40172
					order[1] = 40173
					order[2] = 0
					super(40171, 40172, order)
				end
			end

			class NoProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40175
					order[1] = 40176
					order[2] = 40177
					order[3] = 2385
					order[4] = 40178
					order[5] = 0
					super(40174, 40175, order)
				end

				class NoProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40179
						order[1] = 40180
						order[2] = 0
						super(40178, 40179, order)
					end
				end
			end
		end

		class NoAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 40020
				order[1] = 40021
				order[2] = 40000
				order[3] = 0
				super(40019, 40020, order)
			end

			class NoAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 40001
					order[1] = 40002
					order[2] = 40003
					order[3] = 40004
					order[4] = 40005
					order[5] = 40006
					order[6] = 40007
					order[7] = 40008
					order[8] = 40009
					order[9] = 40010
					order[10] = 40011
					order[11] = 40012
					order[12] = 40013
					order[13] = 40014
					order[14] = 40015
					order[15] = 40016
					order[16] = 40017
					order[17] = 40018
					order[18] = 0
					super(40000, 40001, order)
				end
			end
		end

		class NoProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 40182
				order[1] = 40183
				order[2] = 40184
				order[3] = 40185
				order[4] = 40186
				order[5] = 40187
				order[6] = 40188
				order[7] = 40951
				order[8] = 40191
				order[9] = 40201
				order[10] = 40190
				order[11] = 0
				super(40181, 40182, order)
			end

			class NoProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40189
					order[1] = 0
					super(40951, 40189, order)
				end
			end

			class NoProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 40192
					order[1] = 40193
					order[2] = 40194
					order[3] = 40195
					order[4] = 40196
					order[5] = 40197
					order[6] = 40198
					order[7] = 40199
					order[8] = 0
					super(40191, 40192, order)
				end

				class NoProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40200
						order[1] = 0
						super(40199, 40200, order)
					end
				end
			end

			class NoProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40202
					order[1] = 40203
					order[2] = 0
					super(40201, 40202, order)
				end
			end
		end

		class NoCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 40023
				order[1] = 40024
				order[2] = 40916
				order[3] = 40917
				order[4] = 40025
				order[5] = 40026
				order[6] = 40027
				order[7] = 40028
				order[8] = 40029
				order[9] = 40030
				order[10] = 40031
				order[11] = 40277
				order[12] = 42216
				order[13] = 42217
				order[14] = 40033
				order[15] = 40034
				order[16] = 42207
				order[17] = 42208
				order[18] = 42209
				order[19] = 42210
				order[20] = 42211
				order[21] = 42212
				order[22] = 42213
				order[23] = 40035
				order[24] = 40036
				order[25] = 40037
				order[26] = 40038
				order[27] = 40039
				order[28] = 0
				super(40022, 40023, order)
			end

			class NoCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40032
					order[1] = 0
					super(40277, 40032, order)
				end
			end

			class NoCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42215
					order[1] = 0
					super(42214, 42215, order)
				end
			end
		end

		class NoPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40209
				order[1] = 40205
				order[2] = 40206
				order[3] = 40207
				order[4] = 40208
				order[5] = 0
				super(40204, 40209, order)
			end

			class NoPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40210
					order[1] = 40211
					order[2] = 0
					super(40209, 40210, order)
				end
			end
		end

		class NoExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42297
				order[1] = 42298
				order[2] = 0
				super(42296, 42297, order)
			end
		end
	end
end

class PositionTransferInstruction < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DL") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoTargetPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1462
			order[1] = 1463
			order[2] = 1464
			order[3] = 1818
			order[4] = 2433
			order[5] = 0
			super(1461, 1462, order)
		end

		class NoTargetPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2434
				order[1] = 2435
				order[2] = 0
				super(2433, 2434, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoPositions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 703
			order[1] = 704
			order[2] = 705
			order[3] = 1654
			order[4] = 706
			order[5] = 976
			order[6] = 1836
			order[7] = 1835
			order[8] = 2936
			order[9] = 539
			order[10] = 0
			super(702, 703, order)
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end

	class NoPosAmt < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 707
			order[1] = 708
			order[2] = 2096
			order[3] = 1055
			order[4] = 2937
			order[5] = 2097
			order[6] = 2098
			order[7] = 1585
			order[8] = 2099
			order[9] = 2100
			order[10] = 2876
			order[11] = 2877
			order[12] = 0
			super(753, 707, order)
		end
	end
end

class PositionTransferInstructionAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DM") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoTargetPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1462
			order[1] = 1463
			order[2] = 1464
			order[3] = 1818
			order[4] = 2433
			order[5] = 0
			super(1461, 1462, order)
		end

		class NoTargetPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2434
				order[1] = 2435
				order[2] = 0
				super(2433, 2434, order)
			end
		end
	end
end

class PositionTransferReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DN") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoTargetPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1462
			order[1] = 1463
			order[2] = 1464
			order[3] = 1818
			order[4] = 2433
			order[5] = 0
			super(1461, 1462, order)
		end

		class NoTargetPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 2434
				order[1] = 2435
				order[2] = 0
				super(2433, 2434, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoPositions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 703
			order[1] = 704
			order[2] = 705
			order[3] = 1654
			order[4] = 706
			order[5] = 976
			order[6] = 1836
			order[7] = 1835
			order[8] = 2936
			order[9] = 539
			order[10] = 0
			super(702, 703, order)
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end

	class NoPosAmt < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(13)
			order[0] = 707
			order[1] = 708
			order[2] = 2096
			order[3] = 1055
			order[4] = 2937
			order[5] = 2097
			order[6] = 2098
			order[7] = 1585
			order[8] = 2099
			order[9] = 2100
			order[10] = 2876
			order[11] = 2877
			order[12] = 0
			super(753, 707, order)
		end
	end
end

class MarketDataStatisticsRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DO") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoInstrAttrib < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 871
			order[1] = 872
			order[2] = 0
			super(870, 871, order)
		end
	end

	class NoIndexRollMonths < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2733
			order[1] = 0
			super(2734, 2733, order)
		end
	end

	class NoReferenceDataDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2747
			order[1] = 2748
			order[2] = 0
			super(2746, 2747, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoRelatedInstruments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 1648
			order[1] = 1649
			order[2] = 1650
			order[3] = 1651
			order[4] = 1652
			order[5] = 1653
			order[6] = 2413
			order[7] = 2414
			order[8] = 2415
			order[9] = 2417
			order[10] = 0
			super(1647, 1648, order)
		end
	end

	class NoMDStatistics < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(41)
			order[0] = 2475
			order[1] = 2456
			order[2] = 2457
			order[3] = 2458
			order[4] = 2459
			order[5] = 2454
			order[6] = 2455
			order[7] = 2481
			order[8] = 2482
			order[9] = 264
			order[10] = 2460
			order[11] = 2461
			order[12] = 2462
			order[13] = 2463
			order[14] = 2464
			order[15] = 2465
			order[16] = 2466
			order[17] = 2467
			order[18] = 2468
			order[19] = 2469
			order[20] = 2470
			order[21] = 2471
			order[22] = 2472
			order[23] = 2584
			order[24] = 1815
			order[25] = 40
			order[26] = 59
			order[27] = 276
			order[28] = 277
			order[29] = 54
			order[30] = 578
			order[31] = 336
			order[32] = 625
			order[33] = 1024
			order[34] = 2711
			order[35] = 338
			order[36] = 1022
			order[37] = 1629
			order[38] = 1916
			order[39] = 1057
			order[40] = 0
			super(2474, 2475, order)
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end
end

class MarketDataStatisticsReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DP") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoInstrAttrib < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 871
			order[1] = 872
			order[2] = 0
			super(870, 871, order)
		end
	end

	class NoIndexRollMonths < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 2733
			order[1] = 0
			super(2734, 2733, order)
		end
	end

	class NoReferenceDataDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 2747
			order[1] = 2748
			order[2] = 0
			super(2746, 2747, order)
		end
	end

	class NoContractualDefinitions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40041
			order[1] = 0
			super(40040, 40041, order)
		end
	end

	class NoFinancingTermSupplements < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 40047
			order[1] = 40048
			order[2] = 0
			super(40046, 40047, order)
		end
	end

	class NoContractualMatrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40043
			order[1] = 40044
			order[2] = 40045
			order[3] = 0
			super(40042, 40043, order)
		end
	end

	class NoUnderlyings < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(188)
			order[0] = 311
			order[1] = 312
			order[2] = 309
			order[3] = 305
			order[4] = 2874
			order[5] = 462
			order[6] = 463
			order[7] = 2894
			order[8] = 310
			order[9] = 763
			order[10] = 313
			order[11] = 542
			order[12] = 1213
			order[13] = 1837
			order[14] = 241
			order[15] = 1453
			order[16] = 1454
			order[17] = 2614
			order[18] = 2615
			order[19] = 2921
			order[20] = 2616
			order[21] = 2617
			order[22] = 2619
			order[23] = 1455
			order[24] = 1456
			order[25] = 1459
			order[26] = 1460
			order[27] = 242
			order[28] = 243
			order[29] = 244
			order[30] = 245
			order[31] = 246
			order[32] = 256
			order[33] = 595
			order[34] = 592
			order[35] = 593
			order[36] = 594
			order[37] = 247
			order[38] = 316
			order[39] = 941
			order[40] = 2917
			order[41] = 317
			order[42] = 436
			order[43] = 1437
			order[44] = 2363
			order[45] = 1441
			order[46] = 998
			order[47] = 1423
			order[48] = 1718
			order[49] = 2918
			order[50] = 1424
			order[51] = 1425
			order[52] = 1719
			order[53] = 2919
			order[54] = 1000
			order[55] = 1419
			order[56] = 1526
			order[57] = 2920
			order[58] = 435
			order[59] = 308
			order[60] = 306
			order[61] = 362
			order[62] = 363
			order[63] = 2742
			order[64] = 2720
			order[65] = 2721
			order[66] = 2722
			order[67] = 2723
			order[68] = 2724
			order[69] = 307
			order[70] = 364
			order[71] = 365
			order[72] = 877
			order[73] = 878
			order[74] = 972
			order[75] = 318
			order[76] = 2916
			order[77] = 879
			order[78] = 975
			order[79] = 973
			order[80] = 974
			order[81] = 810
			order[82] = 882
			order[83] = 883
			order[84] = 884
			order[85] = 885
			order[86] = 886
			order[87] = 2885
			order[88] = 2886
			order[89] = 1044
			order[90] = 1045
			order[91] = 1046
			order[92] = 1038
			order[93] = 1039
			order[94] = 315
			order[95] = 2683
			order[96] = 2687
			order[97] = 1988
			order[98] = 1989
			order[99] = 1990
			order[100] = 1991
			order[101] = 1992
			order[102] = 1993
			order[103] = 2881
			order[104] = 1994
			order[105] = 1995
			order[106] = 1996
			order[107] = 1997
			order[108] = 2620
			order[109] = 2621
			order[110] = 1998
			order[111] = 1999
			order[112] = 2000
			order[113] = 2003
			order[114] = 2004
			order[115] = 2005
			order[116] = 2006
			order[117] = 2284
			order[118] = 2285
			order[119] = 2286
			order[120] = 2287
			order[121] = 2288
			order[122] = 2007
			order[123] = 2008
			order[124] = 2009
			order[125] = 2010
			order[126] = 2011
			order[127] = 2012
			order[128] = 2491
			order[129] = 2013
			order[130] = 2014
			order[131] = 2015
			order[132] = 2744
			order[133] = 2016
			order[134] = 2289
			order[135] = 2017
			order[136] = 2018
			order[137] = 2019
			order[138] = 2020
			order[139] = 2021
			order[140] = 2022
			order[141] = 2290
			order[142] = 2622
			order[143] = 2291
			order[144] = 2623
			order[145] = 2292
			order[146] = 2023
			order[147] = 2024
			order[148] = 2025
			order[149] = 2026
			order[150] = 2027
			order[151] = 2028
			order[152] = 2029
			order[153] = 2757
			order[154] = 2030
			order[155] = 2031
			order[156] = 2293
			order[157] = 2294
			order[158] = 2032
			order[159] = 2033
			order[160] = 2034
			order[161] = 2035
			order[162] = 2036
			order[163] = 2037
			order[164] = 2038
			order[165] = 2039
			order[166] = 2040
			order[167] = 2041
			order[168] = 2042
			order[169] = 2043
			order[170] = 2044
			order[171] = 41314
			order[172] = 41315
			order[173] = 2295
			order[174] = 2296
			order[175] = 2297
			order[176] = 2756
			order[177] = 2298
			order[178] = 2299
			order[179] = 2624
			order[180] = 2625
			order[181] = 2626
			order[182] = 2627
			order[183] = 2628
			order[184] = 2629
			order[185] = 2630
			order[186] = 2631
			order[187] = 0
			super(711, 311, order)
		end

		class NoUnderlyingSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 458
				order[1] = 459
				order[2] = 2959
				order[3] = 0
				super(457, 458, order)
			end
		end

		class NoUnderlyingStips < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 888
				order[1] = 889
				order[2] = 0
				super(887, 888, order)
			end
		end

		class NoUndlyInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 1059
				order[1] = 1060
				order[2] = 1061
				order[3] = 2391
				order[4] = 1062
				order[5] = 0
				super(1058, 1059, order)
			end

			class NoUndlyInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1063
					order[1] = 1064
					order[2] = 0
					super(1062, 1063, order)
				end
			end
		end

		class NoUnderlyingEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 1982
				order[1] = 1983
				order[2] = 1984
				order[3] = 1985
				order[4] = 1986
				order[5] = 2342
				order[6] = 1987
				order[7] = 2071
				order[8] = 2072
				order[9] = 2073
				order[10] = 0
				super(1981, 1982, order)
			end
		end

		class NoUnderlyingSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2081
				order[1] = 2082
				order[2] = 2083
				order[3] = 2745
				order[4] = 0
				super(2080, 2081, order)
			end
		end

		class NoUnderlyingAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2313
				order[1] = 2314
				order[2] = 2315
				order[3] = 0
				super(2312, 2313, order)
			end
		end

		class NoUnderlyingComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2046
				order[1] = 2261
				order[2] = 2262
				order[3] = 2263
				order[4] = 2047
				order[5] = 2264
				order[6] = 2265
				order[7] = 2266
				order[8] = 2947
				order[9] = 2048
				order[10] = 2267
				order[11] = 2049
				order[12] = 2050
				order[13] = 2051
				order[14] = 2052
				order[15] = 2053
				order[16] = 2268
				order[17] = 2948
				order[18] = 2269
				order[19] = 2949
				order[20] = 2270
				order[21] = 2271
				order[22] = 2419
				order[23] = 2420
				order[24] = 2272
				order[25] = 2273
				order[26] = 2274
				order[27] = 2275
				order[28] = 2276
				order[29] = 41732
				order[30] = 41739
				order[31] = 41740
				order[32] = 41741
				order[33] = 41742
				order[34] = 41743
				order[35] = 41744
				order[36] = 41745
				order[37] = 41746
				order[38] = 41747
				order[39] = 41729
				order[40] = 2277
				order[41] = 2278
				order[42] = 2279
				order[43] = 2280
				order[44] = 2281
				order[45] = 41748
				order[46] = 41716
				order[47] = 2611
				order[48] = 2612
				order[49] = 2613
				order[50] = 2282
				order[51] = 2283
				order[52] = 0
				super(2045, 2046, order)
			end

			class NoUnderlyingComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2054
					order[1] = 2055
					order[2] = 2056
					order[3] = 0
					super(2053, 2054, order)
				end

				class NoUnderlyingComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2057
						order[1] = 2058
						order[2] = 0
						super(2056, 2057, order)
					end
				end
			end

			class NoUnderlyingComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41733
					order[1] = 41734
					order[2] = 41735
					order[3] = 41736
					order[4] = 0
					super(41732, 41733, order)
				end
			end

			class NoUnderlyingComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41738
					order[1] = 0
					super(41737, 41738, order)
				end
			end

			class NoUnderlyingComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41730
					order[1] = 41731
					order[2] = 41750
					order[3] = 41726
					order[4] = 41713
					order[5] = 0
					super(41729, 41730, order)
				end

				class NoUnderlyingComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41751
						order[1] = 41752
						order[2] = 41753
						order[3] = 41754
						order[4] = 41755
						order[5] = 0
						super(41750, 41751, order)
					end
				end

				class NoUnderlyingComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41727
						order[1] = 41728
						order[2] = 0
						super(41726, 41727, order)
					end
				end

				class NoUnderlyingComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41714
						order[1] = 41715
						order[2] = 0
						super(41713, 41714, order)
					end
				end
			end

			class NoUnderlyingComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41749
					order[1] = 0
					super(41748, 41749, order)
				end
			end

			class NoUnderlyingComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41717
					order[1] = 41718
					order[2] = 41719
					order[3] = 41720
					order[4] = 41721
					order[5] = 41722
					order[6] = 41723
					order[7] = 41724
					order[8] = 0
					super(41716, 41717, order)
				end

				class NoUnderlyingComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41725
						order[1] = 0
						super(41724, 41725, order)
					end
				end
			end
		end

		class NoUnderlyingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40963
				order[1] = 0
				super(40962, 40963, order)
			end
		end

		class NoUnderlyingPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41948
				order[1] = 0
				super(41947, 41948, order)
			end
		end

		class NoUnderlyingMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41865
				order[1] = 41338
				order[2] = 0
				super(41864, 41865, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41867
				order[1] = 41339
				order[2] = 0
				super(41866, 41867, order)
			end
		end

		class NoUnderlyingMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41869
				order[1] = 41870
				order[2] = 41871
				order[3] = 41872
				order[4] = 41873
				order[5] = 41874
				order[6] = 41875
				order[7] = 41876
				order[8] = 41877
				order[9] = 0
				super(41868, 41869, order)
			end
		end

		class NoUnderlyingSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 43075
				order[1] = 0
				super(43074, 43075, order)
			end
		end

		class NoUnderlyingOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41821
				order[1] = 0
				super(41820, 41821, order)
			end
		end

		class NoUnderlyingOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41842
				order[1] = 41843
				order[2] = 0
				super(41841, 41842, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41845
				order[1] = 0
				super(41844, 41845, order)
			end
		end

		class NoUnderlyingOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41857
				order[1] = 41858
				order[2] = 0
				super(41856, 41857, order)
			end
		end

		class NoUnderlyingStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40541
				order[1] = 42016
				order[2] = 40542
				order[3] = 43083
				order[4] = 43084
				order[5] = 40543
				order[6] = 40544
				order[7] = 42018
				order[8] = 40545
				order[9] = 40546
				order[10] = 43085
				order[11] = 43086
				order[12] = 42019
				order[13] = 42020
				order[14] = 42021
				order[15] = 42022
				order[16] = 42023
				order[17] = 42024
				order[18] = 41964
				order[19] = 41965
				order[20] = 41966
				order[21] = 41967
				order[22] = 41968
				order[23] = 41969
				order[24] = 41970
				order[25] = 42589
				order[26] = 41971
				order[27] = 41972
				order[28] = 41973
				order[29] = 41974
				order[30] = 41975
				order[31] = 41976
				order[32] = 41977
				order[33] = 41978
				order[34] = 41979
				order[35] = 41980
				order[36] = 41981
				order[37] = 41982
				order[38] = 41983
				order[39] = 41984
				order[40] = 41985
				order[41] = 41986
				order[42] = 41987
				order[43] = 41988
				order[44] = 41989
				order[45] = 40057
				order[46] = 40058
				order[47] = 40060
				order[48] = 40061
				order[49] = 40062
				order[50] = 40063
				order[51] = 40064
				order[52] = 40548
				order[53] = 40549
				order[54] = 40551
				order[55] = 40552
				order[56] = 40553
				order[57] = 40554
				order[58] = 40555
				order[59] = 41957
				order[60] = 41958
				order[61] = 40556
				order[62] = 40558
				order[63] = 40559
				order[64] = 40561
				order[65] = 40562
				order[66] = 40563
				order[67] = 40564
				order[68] = 40565
				order[69] = 40566
				order[70] = 40567
				order[71] = 41959
				order[72] = 41960
				order[73] = 41961
				order[74] = 40568
				order[75] = 40569
				order[76] = 40570
				order[77] = 42895
				order[78] = 40571
				order[79] = 40572
				order[80] = 43107
				order[81] = 40573
				order[82] = 40574
				order[83] = 40575
				order[84] = 40576
				order[85] = 40577
				order[86] = 42896
				order[87] = 42897
				order[88] = 42898
				order[89] = 42899
				order[90] = 40578
				order[91] = 40579
				order[92] = 40580
				order[93] = 41897
				order[94] = 41898
				order[95] = 41899
				order[96] = 41900
				order[97] = 41901
				order[98] = 41902
				order[99] = 41903
				order[100] = 42900
				order[101] = 40664
				order[102] = 40708
				order[103] = 41777
				order[104] = 41778
				order[105] = 41779
				order[106] = 41780
				order[107] = 41781
				order[108] = 42196
				order[109] = 42197
				order[110] = 41782
				order[111] = 41783
				order[112] = 41784
				order[113] = 41785
				order[114] = 41786
				order[115] = 41587
				order[116] = 41787
				order[117] = 41788
				order[118] = 41789
				order[119] = 41790
				order[120] = 41791
				order[121] = 41792
				order[122] = 41793
				order[123] = 41794
				order[124] = 41795
				order[125] = 41796
				order[126] = 41797
				order[127] = 41798
				order[128] = 41799
				order[129] = 43096
				order[130] = 41756
				order[131] = 40547
				order[132] = 40988
				order[133] = 40989
				order[134] = 0
				super(40540, 40541, order)
			end

			class NoUnderlyingStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41991
					order[1] = 41992
					order[2] = 0
					super(41990, 41991, order)
				end
			end

			class NoUnderlyingStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41801
					order[1] = 41802
					order[2] = 41803
					order[3] = 0
					super(41800, 41801, order)
				end
			end

			class NoUnderlyingStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41994
					order[1] = 41995
					order[2] = 0
					super(41993, 41994, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41963
					order[1] = 0
					super(41962, 41963, order)
				end
			end

			class NoUnderlyingStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 42003
					order[1] = 42004
					order[2] = 42005
					order[3] = 42006
					order[4] = 42007
					order[5] = 42008
					order[6] = 42009
					order[7] = 42010
					order[8] = 42011
					order[9] = 42012
					order[10] = 42013
					order[11] = 41996
					order[12] = 42014
					order[13] = 42015
					order[14] = 0
					super(42002, 42003, order)
				end

				class NoUnderlyingStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41997
						order[1] = 41998
						order[2] = 41999
						order[3] = 0
						super(41996, 41997, order)
					end

					class NoUnderlyingStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 42000
							order[1] = 42001
							order[2] = 41936
							order[3] = 0
							super(41999, 42000, order)
						end
					end
				end
			end

			class NoUnderlyingStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40059
					order[1] = 0
					super(40975, 40059, order)
				end
			end

			class NoUnderlyingStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40550
					order[1] = 0
					super(40976, 40550, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40557
					order[1] = 0
					super(40973, 40557, order)
				end
			end

			class NoUnderlyingStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41955
					order[1] = 41956
					order[2] = 0
					super(41954, 41955, order)
				end
			end

			class NoUnderlyingStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40560
					order[1] = 0
					super(40974, 40560, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40582
					order[1] = 0
					super(40969, 40582, order)
				end
			end

			class NoUnderlyingPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41938
					order[1] = 41939
					order[2] = 0
					super(41937, 41938, order)
				end
			end

			class NoUnderlyingPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40594
					order[1] = 0
					super(40970, 40594, order)
				end
			end

			class NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40600
					order[1] = 0
					super(40971, 40600, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40607
					order[1] = 0
					super(40972, 40607, order)
				end
			end

			class NoUnderlyingPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42956
					order[1] = 42957
					order[2] = 0
					super(42955, 42956, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41910
					order[1] = 0
					super(41909, 41910, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41945
					order[1] = 41946
					order[2] = 0
					super(41944, 41945, order)
				end
			end

			class NoUnderlyingPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41942
					order[1] = 41943
					order[2] = 0
					super(41941, 41942, order)
				end
			end

			class NoUnderlyingPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43111
					order[1] = 42982
					order[2] = 42983
					order[3] = 0
					super(42981, 43111, order)
				end
			end

			class NoUnderlyingDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42863
					order[1] = 42864
					order[2] = 42865
					order[3] = 42866
					order[4] = 42867
					order[5] = 42868
					order[6] = 42882
					order[7] = 42869
					order[8] = 42870
					order[9] = 42871
					order[10] = 42872
					order[11] = 42873
					order[12] = 42874
					order[13] = 42875
					order[14] = 42876
					order[15] = 42877
					order[16] = 42878
					order[17] = 42879
					order[18] = 42880
					order[19] = 42881
					order[20] = 0
					super(42862, 42863, order)
				end

				class NoUnderlyingDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42883
						order[1] = 0
						super(42882, 42883, order)
					end
				end
			end

			class NoUnderlyingDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42854
					order[1] = 0
					super(42853, 42854, order)
				end
			end

			class NoUnderlyingDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42800
					order[1] = 0
					super(42799, 42800, order)
				end
			end

			class NoUnderlyingReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 43035
					order[1] = 43036
					order[2] = 43037
					order[3] = 43038
					order[4] = 43039
					order[5] = 43040
					order[6] = 43064
					order[7] = 43030
					order[8] = 43041
					order[9] = 43042
					order[10] = 43043
					order[11] = 43044
					order[12] = 43045
					order[13] = 43046
					order[14] = 43047
					order[15] = 43048
					order[16] = 43049
					order[17] = 43050
					order[18] = 43051
					order[19] = 43052
					order[20] = 43060
					order[21] = 43053
					order[22] = 43054
					order[23] = 43008
					order[24] = 43055
					order[25] = 43056
					order[26] = 43057
					order[27] = 43058
					order[28] = 43059
					order[29] = 0
					super(43034, 43035, order)
				end

				class NoUnderlyingReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 43065
						order[1] = 43066
						order[2] = 43067
						order[3] = 43068
						order[4] = 0
						super(43064, 43065, order)
					end
				end

				class NoUnderlyingReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43031
						order[1] = 43032
						order[2] = 43033
						order[3] = 0
						super(43030, 43031, order)
					end
				end

				class NoUnderlyingReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 43061
						order[1] = 43062
						order[2] = 43063
						order[3] = 0
						super(43060, 43061, order)
					end
				end

				class NoUnderlyingReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 43009
						order[1] = 43071
						order[2] = 43010
						order[3] = 43011
						order[4] = 43012
						order[5] = 43013
						order[6] = 43014
						order[7] = 43015
						order[8] = 43016
						order[9] = 43017
						order[10] = 43018
						order[11] = 43019
						order[12] = 43020
						order[13] = 43021
						order[14] = 43022
						order[15] = 43023
						order[16] = 43024
						order[17] = 43025
						order[18] = 43026
						order[19] = 43027
						order[20] = 43028
						order[21] = 43029
						order[22] = 43069
						order[23] = 0
						super(43008, 43009, order)
					end

					class NoUnderlyingReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 43072
							order[1] = 43073
							order[2] = 0
							super(43071, 43072, order)
						end
					end

					class NoUnderlyingReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 43070
							order[1] = 0
							super(43069, 43070, order)
						end
					end
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42916
					order[1] = 0
					super(42915, 42916, order)
				end
			end

			class NoUnderlyingPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42902
					order[1] = 42903
					order[2] = 0
					super(42901, 42902, order)
				end
			end

			class NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40650
					order[1] = 0
					super(40968, 40650, order)
				end
			end

			class NoUnderlyingNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40657
					order[1] = 40658
					order[2] = 0
					super(40656, 40657, order)
				end
			end

			class NoUnderlyingSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40660
					order[1] = 40904
					order[2] = 40915
					order[3] = 40662
					order[4] = 40663
					order[5] = 0
					super(40659, 40660, order)
				end
			end

			class NoUnderlyingPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40665
					order[1] = 41881
					order[2] = 41882
					order[3] = 40666
					order[4] = 40667
					order[5] = 40668
					order[6] = 40669
					order[7] = 40670
					order[8] = 40671
					order[9] = 40672
					order[10] = 40673
					order[11] = 40674
					order[12] = 40675
					order[13] = 41883
					order[14] = 41884
					order[15] = 41885
					order[16] = 41886
					order[17] = 40676
					order[18] = 40677
					order[19] = 40678
					order[20] = 40679
					order[21] = 41887
					order[22] = 41888
					order[23] = 41889
					order[24] = 41890
					order[25] = 40680
					order[26] = 40681
					order[27] = 40682
					order[28] = 40683
					order[29] = 40684
					order[30] = 40685
					order[31] = 40704
					order[32] = 40686
					order[33] = 40687
					order[34] = 40688
					order[35] = 40689
					order[36] = 40966
					order[37] = 40691
					order[38] = 40692
					order[39] = 40693
					order[40] = 41891
					order[41] = 41892
					order[42] = 40694
					order[43] = 41878
					order[44] = 41893
					order[45] = 41894
					order[46] = 41895
					order[47] = 41896
					order[48] = 40695
					order[49] = 40696
					order[50] = 40697
					order[51] = 40698
					order[52] = 40967
					order[53] = 40700
					order[54] = 40701
					order[55] = 40702
					order[56] = 40703
					order[57] = 0
					super(40664, 40665, order)
				end

				class NoUnderlyingPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40705
						order[1] = 40706
						order[2] = 40707
						order[3] = 0
						super(40704, 40705, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40690
						order[1] = 0
						super(40966, 40690, order)
					end
				end

				class NoUnderlyingPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41879
						order[1] = 41880
						order[2] = 0
						super(41878, 41879, order)
					end
				end

				class NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40699
						order[1] = 0
						super(40967, 40699, order)
					end
				end
			end

			class NoUnderlyingPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40709
					order[1] = 40710
					order[2] = 42993
					order[3] = 42994
					order[4] = 42995
					order[5] = 42996
					order[6] = 42997
					order[7] = 42998
					order[8] = 42999
					order[9] = 42984
					order[10] = 42985
					order[11] = 42986
					order[12] = 42987
					order[13] = 42988
					order[14] = 42989
					order[15] = 42990
					order[16] = 40711
					order[17] = 40712
					order[18] = 40713
					order[19] = 40714
					order[20] = 40715
					order[21] = 40716
					order[22] = 40717
					order[23] = 40718
					order[24] = 40719
					order[25] = 40720
					order[26] = 40721
					order[27] = 40722
					order[28] = 40723
					order[29] = 40724
					order[30] = 40725
					order[31] = 40726
					order[32] = 40727
					order[33] = 40728
					order[34] = 40729
					order[35] = 40730
					order[36] = 40731
					order[37] = 40732
					order[38] = 40733
					order[39] = 40734
					order[40] = 40735
					order[41] = 40736
					order[42] = 40737
					order[43] = 0
					super(40708, 40709, order)
				end

				class NoUnderlyingPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 43001
						order[1] = 0
						super(43000, 43001, order)
					end
				end

				class NoUnderlyingPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42992
						order[1] = 0
						super(42991, 42992, order)
					end
				end
			end

			class NoUnderlyingDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41809
					order[1] = 0
					super(41808, 41809, order)
				end
			end

			class NoUnderlyingDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41805
					order[1] = 41806
					order[2] = 41807
					order[3] = 0
					super(41804, 41805, order)
				end
			end

			class NoUnderlyingDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41757
					order[1] = 41758
					order[2] = 41759
					order[3] = 41760
					order[4] = 41761
					order[5] = 41762
					order[6] = 41763
					order[7] = 41764
					order[8] = 41765
					order[9] = 41766
					order[10] = 41767
					order[11] = 41768
					order[12] = 41769
					order[13] = 41770
					order[14] = 0
					super(41756, 41757, order)
				end

				class NoUnderlyingDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41771
						order[1] = 41772
						order[2] = 41773
						order[3] = 0
						super(41770, 41771, order)
					end

					class NoUnderlyingDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41774
							order[1] = 41775
							order[2] = 41776
							order[3] = 0
							super(41773, 41774, order)
						end
					end
				end
			end
		end

		class NoUnderlyingProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 42150
				order[1] = 42151
				order[2] = 42152
				order[3] = 42190
				order[4] = 42153
				order[5] = 42154
				order[6] = 42155
				order[7] = 43002
				order[8] = 43003
				order[9] = 42156
				order[10] = 42157
				order[11] = 42158
				order[12] = 42104
				order[13] = 42105
				order[14] = 42106
				order[15] = 42107
				order[16] = 42108
				order[17] = 42109
				order[18] = 42110
				order[19] = 42111
				order[20] = 42115
				order[21] = 42116
				order[22] = 42117
				order[23] = 42118
				order[24] = 42119
				order[25] = 42120
				order[26] = 42121
				order[27] = 42122
				order[28] = 42123
				order[29] = 42124
				order[30] = 42125
				order[31] = 42126
				order[32] = 42127
				order[33] = 42128
				order[34] = 42129
				order[35] = 42130
				order[36] = 42131
				order[37] = 42132
				order[38] = 42133
				order[39] = 42134
				order[40] = 42135
				order[41] = 42136
				order[42] = 42137
				order[43] = 42138
				order[44] = 42139
				order[45] = 42140
				order[46] = 42141
				order[47] = 42142
				order[48] = 42143
				order[49] = 42144
				order[50] = 42145
				order[51] = 42146
				order[52] = 42147
				order[53] = 42148
				order[54] = 42159
				order[55] = 42160
				order[56] = 42161
				order[57] = 42162
				order[58] = 42163
				order[59] = 42164
				order[60] = 42165
				order[61] = 42092
				order[62] = 42093
				order[63] = 42094
				order[64] = 42095
				order[65] = 42096
				order[66] = 42097
				order[67] = 42098
				order[68] = 42166
				order[69] = 42167
				order[70] = 42168
				order[71] = 42169
				order[72] = 42102
				order[73] = 42103
				order[74] = 42170
				order[75] = 42171
				order[76] = 42172
				order[77] = 42173
				order[78] = 0
				super(42149, 42150, order)
			end

			class NoUnderlyingProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42191
					order[1] = 0
					super(42190, 42191, order)
				end
			end

			class NoUnderlyingProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42183
					order[1] = 0
					super(42182, 42183, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42185
					order[1] = 0
					super(42184, 42185, order)
				end
			end

			class NoUnderlyingProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42113
					order[1] = 42114
					order[2] = 0
					super(42112, 42113, order)
				end
			end

			class NoUnderlyingProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42187
					order[1] = 0
					super(42186, 42187, order)
				end
			end

			class NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42189
					order[1] = 0
					super(42188, 42189, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42181
					order[1] = 0
					super(42180, 42181, order)
				end
			end

			class NoUnderlyingProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42100
					order[1] = 42101
					order[2] = 0
					super(42099, 42100, order)
				end
			end

			class NoUnderlyingProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 42174
					order[1] = 42175
					order[2] = 42176
					order[3] = 40918
					order[4] = 42177
					order[5] = 0
					super(42173, 42174, order)
				end

				class NoUnderlyingProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42178
						order[1] = 42179
						order[2] = 0
						super(42177, 42178, order)
					end
				end
			end
		end

		class NoUnderlyingAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42037
				order[1] = 42038
				order[2] = 41340
				order[3] = 0
				super(42036, 42037, order)
			end

			class NoUnderlyingAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41341
					order[1] = 41701
					order[2] = 41709
					order[3] = 41710
					order[4] = 41711
					order[5] = 41712
					order[6] = 42017
					order[7] = 42025
					order[8] = 42026
					order[9] = 42027
					order[10] = 42028
					order[11] = 42029
					order[12] = 42030
					order[13] = 42031
					order[14] = 42032
					order[15] = 42033
					order[16] = 42034
					order[17] = 42035
					order[18] = 0
					super(41340, 41341, order)
				end
			end
		end

		class NoUnderlyingProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 42069
				order[1] = 42070
				order[2] = 42071
				order[3] = 42072
				order[4] = 42073
				order[5] = 42074
				order[6] = 42075
				order[7] = 42090
				order[8] = 42077
				order[9] = 42087
				order[10] = 42076
				order[11] = 0
				super(42068, 42069, order)
			end

			class NoUnderlyingProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42091
					order[1] = 0
					super(42090, 42091, order)
				end
			end

			class NoUnderlyingProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 42078
					order[1] = 42079
					order[2] = 42080
					order[3] = 42081
					order[4] = 42082
					order[5] = 42083
					order[6] = 42084
					order[7] = 42085
					order[8] = 0
					super(42077, 42078, order)
				end

				class NoUnderlyingProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42086
						order[1] = 0
						super(42085, 42086, order)
					end
				end
			end

			class NoUnderlyingProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42088
					order[1] = 42089
					order[2] = 0
					super(42087, 42088, order)
				end
			end
		end

		class NoUnderlyingCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 42042
				order[1] = 42043
				order[2] = 42044
				order[3] = 42045
				order[4] = 42046
				order[5] = 42047
				order[6] = 42048
				order[7] = 42049
				order[8] = 42050
				order[9] = 42051
				order[10] = 42052
				order[11] = 42039
				order[12] = 42797
				order[13] = 42798
				order[14] = 42053
				order[15] = 42054
				order[16] = 42790
				order[17] = 42791
				order[18] = 42792
				order[19] = 42793
				order[20] = 42794
				order[21] = 42795
				order[22] = 42796
				order[23] = 42055
				order[24] = 42056
				order[25] = 42057
				order[26] = 42058
				order[27] = 42059
				order[28] = 0
				super(42041, 42042, order)
			end

			class NoUnderlyingCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42040
					order[1] = 0
					super(42039, 42040, order)
				end
			end

			class NoUnderlyingCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42789
					order[1] = 0
					super(42788, 42789, order)
				end
			end
		end

		class NoUnderlyingPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 42065
				order[1] = 42061
				order[2] = 42062
				order[3] = 42063
				order[4] = 42064
				order[5] = 0
				super(42060, 42065, order)
			end

			class NoUnderlyingPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42066
					order[1] = 42067
					order[2] = 0
					super(42065, 42066, order)
				end
			end
		end

		class NoUnderlyingRateSpreadSteps < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 43006
				order[1] = 43007
				order[2] = 0
				super(43005, 43006, order)
			end
		end

		class NoUnderlyingDividendPayments < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 42856
				order[1] = 42857
				order[2] = 42858
				order[3] = 42859
				order[4] = 0
				super(42855, 42856, order)
			end
		end

		class NoUnderlyingExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42885
				order[1] = 42886
				order[2] = 0
				super(42884, 42885, order)
			end
		end
	end

	class NoLegs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(176)
			order[0] = 600
			order[1] = 601
			order[2] = 602
			order[3] = 603
			order[4] = 1788
			order[5] = 607
			order[6] = 1594
			order[7] = 608
			order[8] = 2893
			order[9] = 609
			order[10] = 764
			order[11] = 610
			order[12] = 611
			order[13] = 1212
			order[14] = 2146
			order[15] = 2147
			order[16] = 2148
			order[17] = 248
			order[18] = 2149
			order[19] = 2150
			order[20] = 2151
			order[21] = 2152
			order[22] = 2153
			order[23] = 2154
			order[24] = 2155
			order[25] = 2348
			order[26] = 2067
			order[27] = 2068
			order[28] = 2069
			order[29] = 2739
			order[30] = 2070
			order[31] = 2156
			order[32] = 2157
			order[33] = 2158
			order[34] = 2159
			order[35] = 2160
			order[36] = 2161
			order[37] = 2162
			order[38] = 2163
			order[39] = 2164
			order[40] = 2165
			order[41] = 2880
			order[42] = 2166
			order[43] = 2167
			order[44] = 2168
			order[45] = 2169
			order[46] = 2170
			order[47] = 2171
			order[48] = 2172
			order[49] = 2173
			order[50] = 2174
			order[51] = 2175
			order[52] = 2176
			order[53] = 2177
			order[54] = 2178
			order[55] = 2179
			order[56] = 2180
			order[57] = 249
			order[58] = 250
			order[59] = 251
			order[60] = 252
			order[61] = 253
			order[62] = 257
			order[63] = 599
			order[64] = 596
			order[65] = 597
			order[66] = 598
			order[67] = 254
			order[68] = 612
			order[69] = 942
			order[70] = 2908
			order[71] = 2181
			order[72] = 2182
			order[73] = 2183
			order[74] = 2184
			order[75] = 2604
			order[76] = 2185
			order[77] = 2605
			order[78] = 2186
			order[79] = 2187
			order[80] = 2188
			order[81] = 2189
			order[82] = 613
			order[83] = 614
			order[84] = 1436
			order[85] = 2354
			order[86] = 1440
			order[87] = 2190
			order[88] = 2191
			order[89] = 999
			order[90] = 1224
			order[91] = 1720
			order[92] = 2909
			order[93] = 1421
			order[94] = 1422
			order[95] = 1721
			order[96] = 2910
			order[97] = 2192
			order[98] = 1001
			order[99] = 1420
			order[100] = 2193
			order[101] = 2194
			order[102] = 2755
			order[103] = 2195
			order[104] = 2196
			order[105] = 2197
			order[106] = 2198
			order[107] = 1528
			order[108] = 2911
			order[109] = 2199
			order[110] = 2200
			order[111] = 2201
			order[112] = 2202
			order[113] = 2203
			order[114] = 615
			order[115] = 616
			order[116] = 2205
			order[117] = 2206
			order[118] = 617
			order[119] = 618
			order[120] = 619
			order[121] = 2740
			order[122] = 2717
			order[123] = 2718
			order[124] = 2719
			order[125] = 620
			order[126] = 621
			order[127] = 622
			order[128] = 2207
			order[129] = 2208
			order[130] = 623
			order[131] = 624
			order[132] = 556
			order[133] = 2898
			order[134] = 740
			order[135] = 739
			order[136] = 955
			order[137] = 956
			order[138] = 1358
			order[139] = 2682
			order[140] = 2686
			order[141] = 1017
			order[142] = 566
			order[143] = 2209
			order[144] = 2211
			order[145] = 2212
			order[146] = 2213
			order[147] = 2754
			order[148] = 2214
			order[149] = 2215
			order[150] = 2606
			order[151] = 2607
			order[152] = 2497
			order[153] = 2498
			order[154] = 2499
			order[155] = 2496
			order[156] = 2495
			order[157] = 2953
			order[158] = 2511
			order[159] = 2510
			order[160] = 2512
			order[161] = 2509
			order[162] = 2500
			order[163] = 2502
			order[164] = 2501
			order[165] = 2503
			order[166] = 2507
			order[167] = 2505
			order[168] = 2494
			order[169] = 2493
			order[170] = 2514
			order[171] = 2513
			order[172] = 2506
			order[173] = 2504
			order[174] = 2508
			order[175] = 0
			super(555, 600, order)
		end

		class NoLegSecurityAltID < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 605
				order[1] = 606
				order[2] = 2958
				order[3] = 0
				super(604, 605, order)
			end
		end

		class NoLegSecondaryAssetClasses < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 2077
				order[1] = 2078
				order[2] = 2079
				order[3] = 2743
				order[4] = 0
				super(2076, 2077, order)
			end
		end

		class NoLegAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 2309
				order[1] = 2310
				order[2] = 2311
				order[3] = 0
				super(2308, 2309, order)
			end
		end

		class NoLegEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(11)
				order[0] = 2060
				order[1] = 2061
				order[2] = 2062
				order[3] = 2063
				order[4] = 2064
				order[5] = 2341
				order[6] = 2065
				order[7] = 2066
				order[8] = 2074
				order[9] = 2075
				order[10] = 0
				super(2059, 2060, order)
			end
		end

		class NoLegInstrumentParties < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 2255
				order[1] = 2256
				order[2] = 2257
				order[3] = 2379
				order[4] = 2258
				order[5] = 0
				super(2254, 2255, order)
			end

			class NoLegInstrumentPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 2259
					order[1] = 2260
					order[2] = 0
					super(2258, 2259, order)
				end
			end
		end

		class NoLegComplexEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(53)
				order[0] = 2219
				order[1] = 2220
				order[2] = 2221
				order[3] = 2222
				order[4] = 2223
				order[5] = 2224
				order[6] = 2225
				order[7] = 2226
				order[8] = 2944
				order[9] = 2227
				order[10] = 2228
				order[11] = 2229
				order[12] = 2230
				order[13] = 2231
				order[14] = 2232
				order[15] = 2250
				order[16] = 2233
				order[17] = 2945
				order[18] = 2234
				order[19] = 2946
				order[20] = 2235
				order[21] = 2236
				order[22] = 2409
				order[23] = 2410
				order[24] = 2237
				order[25] = 2238
				order[26] = 2239
				order[27] = 2240
				order[28] = 2241
				order[29] = 41382
				order[30] = 41389
				order[31] = 41390
				order[32] = 41391
				order[33] = 41392
				order[34] = 41393
				order[35] = 41394
				order[36] = 41395
				order[37] = 41396
				order[38] = 41397
				order[39] = 41379
				order[40] = 2242
				order[41] = 2243
				order[42] = 2244
				order[43] = 2245
				order[44] = 2246
				order[45] = 41398
				order[46] = 41366
				order[47] = 2608
				order[48] = 2609
				order[49] = 2610
				order[50] = 2248
				order[51] = 2249
				order[52] = 0
				super(2218, 2219, order)
			end

			class NoLegComplexEventDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 2251
					order[1] = 2252
					order[2] = 2253
					order[3] = 0
					super(2250, 2251, order)
				end

				class NoLegComplexEventTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 2204
						order[1] = 2247
						order[2] = 0
						super(2253, 2204, order)
					end
				end
			end

			class NoLegComplexEventRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 41383
					order[1] = 41384
					order[2] = 41385
					order[3] = 41386
					order[4] = 0
					super(41382, 41383, order)
				end
			end

			class NoLegComplexEventDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41388
					order[1] = 0
					super(41387, 41388, order)
				end
			end

			class NoLegComplexEventPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41380
					order[1] = 41381
					order[2] = 41400
					order[3] = 41376
					order[4] = 41363
					order[5] = 0
					super(41379, 41380, order)
				end

				class NoLegComplexEventSchedules < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(6)
						order[0] = 41401
						order[1] = 41402
						order[2] = 41403
						order[3] = 41404
						order[4] = 41405
						order[5] = 0
						super(41400, 41401, order)
					end
				end

				class NoLegComplexEventPeriodDateTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41377
						order[1] = 41378
						order[2] = 0
						super(41376, 41377, order)
					end
				end

				class NoLegComplexEventAveragingObservations < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41364
						order[1] = 41365
						order[2] = 0
						super(41363, 41364, order)
					end
				end
			end

			class NoLegComplexEventCreditEventSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41399
					order[1] = 0
					super(41398, 41399, order)
				end
			end

			class NoLegComplexEventCreditEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41367
					order[1] = 41368
					order[2] = 41369
					order[3] = 41370
					order[4] = 41371
					order[5] = 41372
					order[6] = 41373
					order[7] = 41374
					order[8] = 0
					super(41366, 41367, order)
				end

				class NoLegComplexEventCreditEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41375
						order[1] = 0
						super(41374, 41375, order)
					end
				end
			end
		end

		class NoLegBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40924
				order[1] = 0
				super(40923, 40924, order)
			end
		end

		class NoLegPricingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41608
				order[1] = 0
				super(41607, 41608, order)
			end
		end

		class NoLegMarketDisruptionEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41468
				order[1] = 40223
				order[2] = 0
				super(41467, 41468, order)
			end
		end

		class NoLegMarketDisruptionFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41470
				order[1] = 40990
				order[2] = 0
				super(41469, 41470, order)
			end
		end

		class NoLegMarketDisruptionFallbackReferencePrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(10)
				order[0] = 41472
				order[1] = 41473
				order[2] = 41474
				order[3] = 41475
				order[4] = 41476
				order[5] = 41477
				order[6] = 41478
				order[7] = 41479
				order[8] = 41480
				order[9] = 0
				super(41471, 41472, order)
			end
		end

		class NoLegSettlMethodElectionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42582
				order[1] = 0
				super(42581, 42582, order)
			end
		end

		class NoLegOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41492
				order[1] = 0
				super(41491, 41492, order)
			end
		end

		class NoLegOptionExerciseDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41513
				order[1] = 41514
				order[2] = 0
				super(41512, 41513, order)
			end
		end

		class NoLegOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41516
				order[1] = 0
				super(41515, 41516, order)
			end
		end

		class NoLegOptionExerciseExpirationDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41528
				order[1] = 41529
				order[2] = 0
				super(41527, 41528, order)
			end
		end

		class NoLegStreams < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(135)
				order[0] = 40242
				order[1] = 41700
				order[2] = 40243
				order[3] = 42583
				order[4] = 42584
				order[5] = 40244
				order[6] = 40245
				order[7] = 41702
				order[8] = 40246
				order[9] = 40247
				order[10] = 42585
				order[11] = 42586
				order[12] = 41703
				order[13] = 41704
				order[14] = 41705
				order[15] = 41706
				order[16] = 41707
				order[17] = 41708
				order[18] = 41648
				order[19] = 41649
				order[20] = 41650
				order[21] = 41651
				order[22] = 41652
				order[23] = 41653
				order[24] = 41654
				order[25] = 42588
				order[26] = 41655
				order[27] = 41656
				order[28] = 41657
				order[29] = 41658
				order[30] = 41659
				order[31] = 41660
				order[32] = 41661
				order[33] = 41662
				order[34] = 41663
				order[35] = 41664
				order[36] = 41665
				order[37] = 41666
				order[38] = 41667
				order[39] = 41668
				order[40] = 41669
				order[41] = 41670
				order[42] = 41671
				order[43] = 41672
				order[44] = 41673
				order[45] = 40249
				order[46] = 40250
				order[47] = 40252
				order[48] = 40253
				order[49] = 40254
				order[50] = 40255
				order[51] = 40256
				order[52] = 40257
				order[53] = 40258
				order[54] = 40260
				order[55] = 40261
				order[56] = 40262
				order[57] = 40263
				order[58] = 40264
				order[59] = 41641
				order[60] = 41642
				order[61] = 40265
				order[62] = 40267
				order[63] = 40268
				order[64] = 40270
				order[65] = 40271
				order[66] = 40272
				order[67] = 40273
				order[68] = 40274
				order[69] = 40275
				order[70] = 40276
				order[71] = 41643
				order[72] = 41644
				order[73] = 41645
				order[74] = 40279
				order[75] = 40280
				order[76] = 40281
				order[77] = 42399
				order[78] = 40282
				order[79] = 40283
				order[80] = 43108
				order[81] = 40284
				order[82] = 40285
				order[83] = 40286
				order[84] = 40287
				order[85] = 40288
				order[86] = 42400
				order[87] = 42401
				order[88] = 42402
				order[89] = 42403
				order[90] = 40289
				order[91] = 40290
				order[92] = 40291
				order[93] = 41549
				order[94] = 41550
				order[95] = 41551
				order[96] = 41552
				order[97] = 41553
				order[98] = 41554
				order[99] = 41555
				order[100] = 42404
				order[101] = 40374
				order[102] = 40418
				order[103] = 41429
				order[104] = 41430
				order[105] = 41431
				order[106] = 41432
				order[107] = 41433
				order[108] = 42194
				order[109] = 42195
				order[110] = 41434
				order[111] = 41435
				order[112] = 41436
				order[113] = 41437
				order[114] = 41438
				order[115] = 41219
				order[116] = 41439
				order[117] = 41440
				order[118] = 41441
				order[119] = 41442
				order[120] = 41443
				order[121] = 41444
				order[122] = 41445
				order[123] = 41446
				order[124] = 41447
				order[125] = 41448
				order[126] = 41449
				order[127] = 41450
				order[128] = 41451
				order[129] = 43095
				order[130] = 41408
				order[131] = 40248
				order[132] = 40978
				order[133] = 40979
				order[134] = 0
				super(40241, 40242, order)
			end

			class NoLegStreamCommodityAltIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41675
					order[1] = 41676
					order[2] = 0
					super(41674, 41675, order)
				end
			end

			class NoLegStreamAssetAttributes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41453
					order[1] = 41454
					order[2] = 41455
					order[3] = 0
					super(41452, 41453, order)
				end
			end

			class NoLegStreamCommodityDataSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41678
					order[1] = 41679
					order[2] = 0
					super(41677, 41678, order)
				end
			end

			class NoLegStreamCommoditySettlBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41647
					order[1] = 0
					super(41646, 41647, order)
				end
			end

			class NoLegStreamCommoditySettlPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41687
					order[1] = 41688
					order[2] = 41689
					order[3] = 41690
					order[4] = 41691
					order[5] = 41692
					order[6] = 41693
					order[7] = 41694
					order[8] = 41695
					order[9] = 41696
					order[10] = 41697
					order[11] = 41680
					order[12] = 41698
					order[13] = 41699
					order[14] = 0
					super(41686, 41687, order)
				end

				class NoLegStreamCommoditySettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41681
						order[1] = 41682
						order[2] = 41683
						order[3] = 0
						super(41680, 41681, order)
					end

					class NoLegStreamCommoditySettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41684
							order[1] = 41685
							order[2] = 41935
							order[3] = 0
							super(41683, 41684, order)
						end
					end
				end
			end

			class NoLegStreamEffectiveDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40251
					order[1] = 0
					super(40942, 40251, order)
				end
			end

			class NoLegStreamTerminationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40259
					order[1] = 0
					super(40943, 40259, order)
				end
			end

			class NoLegStreamCalculationPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40266
					order[1] = 0
					super(40940, 40266, order)
				end
			end

			class NoLegStreamCalculationPeriodDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41639
					order[1] = 41640
					order[2] = 0
					super(41638, 41639, order)
				end
			end

			class NoLegStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40269
					order[1] = 0
					super(40941, 40269, order)
				end
			end

			class NoLegPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40293
					order[1] = 0
					super(40930, 40293, order)
				end
			end

			class NoLegPaymentStreamPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41590
					order[1] = 41591
					order[2] = 0
					super(41589, 41590, order)
				end
			end

			class NoLegPaymentStreamResetDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40305
					order[1] = 0
					super(40931, 40305, order)
				end
			end

			class NoLegPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40311
					order[1] = 0
					super(40932, 40311, order)
				end
			end

			class NoLegPaymentStreamFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40318
					order[1] = 0
					super(40933, 40318, order)
				end
			end

			class NoLegPaymentStreamFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42460
					order[1] = 42461
					order[2] = 0
					super(42459, 42460, order)
				end
			end

			class NoLegPaymentStreamPricingBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41562
					order[1] = 0
					super(41561, 41562, order)
				end
			end

			class NoLegPaymentStreamPricingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41597
					order[1] = 41598
					order[2] = 0
					super(41596, 41597, order)
				end
			end

			class NoLegPaymentStreamPricingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41594
					order[1] = 41595
					order[2] = 0
					super(41593, 41594, order)
				end
			end

			class NoLegPaymentStreamFormulas < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 43110
					order[1] = 42486
					order[2] = 42487
					order[3] = 0
					super(42485, 43110, order)
				end
			end

			class NoLegDividendPeriods < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(21)
					order[0] = 42367
					order[1] = 42368
					order[2] = 42369
					order[3] = 42370
					order[4] = 42371
					order[5] = 42372
					order[6] = 42386
					order[7] = 42373
					order[8] = 42374
					order[9] = 42375
					order[10] = 42376
					order[11] = 42377
					order[12] = 42378
					order[13] = 42379
					order[14] = 42380
					order[15] = 42381
					order[16] = 42382
					order[17] = 42383
					order[18] = 42384
					order[19] = 42385
					order[20] = 0
					super(42366, 42367, order)
				end

				class NoLegDividendPeriodBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42387
						order[1] = 0
						super(42386, 42387, order)
					end
				end
			end

			class NoLegDividendFXTriggerDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42365
					order[1] = 0
					super(42364, 42365, order)
				end
			end

			class NoLegDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42311
					order[1] = 0
					super(42310, 42311, order)
				end
			end

			class NoLegReturnRates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(30)
					order[0] = 42535
					order[1] = 42536
					order[2] = 42537
					order[3] = 42538
					order[4] = 42539
					order[5] = 42540
					order[6] = 42564
					order[7] = 42530
					order[8] = 42541
					order[9] = 42542
					order[10] = 42543
					order[11] = 42544
					order[12] = 42545
					order[13] = 42546
					order[14] = 42547
					order[15] = 42548
					order[16] = 42549
					order[17] = 42550
					order[18] = 42551
					order[19] = 42552
					order[20] = 42560
					order[21] = 42553
					order[22] = 42554
					order[23] = 42508
					order[24] = 42555
					order[25] = 42556
					order[26] = 42557
					order[27] = 42558
					order[28] = 42559
					order[29] = 0
					super(42534, 42535, order)
				end

				class NoLegReturnRatePrices < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(5)
						order[0] = 42565
						order[1] = 42566
						order[2] = 42567
						order[3] = 42568
						order[4] = 0
						super(42564, 42565, order)
					end
				end

				class NoLegReturnRateFXConversions < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42531
						order[1] = 42532
						order[2] = 42533
						order[3] = 0
						super(42530, 42531, order)
					end
				end

				class NoLegReturnRateInformationSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 42561
						order[1] = 42562
						order[2] = 42563
						order[3] = 0
						super(42560, 42561, order)
					end
				end

				class NoLegReturnRateDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(24)
						order[0] = 42509
						order[1] = 42571
						order[2] = 42510
						order[3] = 42511
						order[4] = 42512
						order[5] = 42513
						order[6] = 42514
						order[7] = 42515
						order[8] = 42516
						order[9] = 42517
						order[10] = 42518
						order[11] = 42519
						order[12] = 42520
						order[13] = 42521
						order[14] = 42522
						order[15] = 42523
						order[16] = 42524
						order[17] = 42525
						order[18] = 42526
						order[19] = 42527
						order[20] = 42528
						order[21] = 42529
						order[22] = 42569
						order[23] = 0
						super(42508, 42509, order)
					end

					class NoLegReturnRateValuationDates < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(3)
							order[0] = 42572
							order[1] = 42573
							order[2] = 0
							super(42571, 42572, order)
						end
					end

					class NoLegReturnRateValuationDateBusinessCenters < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(2)
							order[0] = 42570
							order[1] = 0
							super(42569, 42570, order)
						end
					end
				end
			end

			class NoLegPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42420
					order[1] = 0
					super(42419, 42420, order)
				end
			end

			class NoLegPaymentStreamCompoundingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 42406
					order[1] = 42407
					order[2] = 0
					super(42405, 42406, order)
				end
			end

			class NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40361
					order[1] = 0
					super(40929, 40361, order)
				end
			end

			class NoLegNonDeliverableFixingDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40368
					order[1] = 40369
					order[2] = 0
					super(40367, 40368, order)
				end
			end

			class NoLegSettlRateFallbacks < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40903
					order[1] = 40366
					order[2] = 40370
					order[3] = 40905
					order[4] = 40906
					order[5] = 0
					super(40902, 40903, order)
				end
			end

			class NoLegPaymentSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(58)
					order[0] = 40375
					order[1] = 41533
					order[2] = 41534
					order[3] = 40376
					order[4] = 40377
					order[5] = 40378
					order[6] = 40379
					order[7] = 40380
					order[8] = 40381
					order[9] = 40382
					order[10] = 40383
					order[11] = 40384
					order[12] = 40385
					order[13] = 41535
					order[14] = 41536
					order[15] = 41537
					order[16] = 41538
					order[17] = 40386
					order[18] = 40387
					order[19] = 40388
					order[20] = 40389
					order[21] = 41539
					order[22] = 41540
					order[23] = 41541
					order[24] = 41542
					order[25] = 40390
					order[26] = 40391
					order[27] = 40392
					order[28] = 40393
					order[29] = 40394
					order[30] = 40395
					order[31] = 40414
					order[32] = 40396
					order[33] = 40397
					order[34] = 40398
					order[35] = 40399
					order[36] = 40927
					order[37] = 40401
					order[38] = 40402
					order[39] = 40403
					order[40] = 41543
					order[41] = 41544
					order[42] = 40404
					order[43] = 41530
					order[44] = 41545
					order[45] = 41546
					order[46] = 41547
					order[47] = 41548
					order[48] = 40405
					order[49] = 40406
					order[50] = 40407
					order[51] = 40408
					order[52] = 40928
					order[53] = 40410
					order[54] = 40411
					order[55] = 40412
					order[56] = 40413
					order[57] = 0
					super(40374, 40375, order)
				end

				class NoLegPaymentScheduleRateSources < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 40415
						order[1] = 40416
						order[2] = 40417
						order[3] = 0
						super(40414, 40415, order)
					end
				end

				class NoLegPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40400
						order[1] = 0
						super(40927, 40400, order)
					end
				end

				class NoLegPaymentScheduleFixingDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 41531
						order[1] = 41532
						order[2] = 0
						super(41530, 41531, order)
					end
				end

				class NoLegPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 40409
						order[1] = 0
						super(40928, 40409, order)
					end
				end
			end

			class NoLegPaymentStubs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(44)
					order[0] = 40419
					order[1] = 40420
					order[2] = 42497
					order[3] = 42498
					order[4] = 42499
					order[5] = 42500
					order[6] = 42501
					order[7] = 42502
					order[8] = 42503
					order[9] = 42488
					order[10] = 42489
					order[11] = 42490
					order[12] = 42491
					order[13] = 42492
					order[14] = 42493
					order[15] = 42494
					order[16] = 40421
					order[17] = 40422
					order[18] = 40423
					order[19] = 40424
					order[20] = 40425
					order[21] = 40426
					order[22] = 40427
					order[23] = 40428
					order[24] = 40429
					order[25] = 40430
					order[26] = 40431
					order[27] = 40432
					order[28] = 40433
					order[29] = 40434
					order[30] = 40435
					order[31] = 40436
					order[32] = 40437
					order[33] = 40438
					order[34] = 40439
					order[35] = 40440
					order[36] = 40441
					order[37] = 40442
					order[38] = 40443
					order[39] = 40444
					order[40] = 40445
					order[41] = 40446
					order[42] = 40447
					order[43] = 0
					super(40418, 40419, order)
				end

				class NoLegPaymentStubStartDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42505
						order[1] = 0
						super(42504, 42505, order)
					end
				end

				class NoLegPaymentStubEndDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42496
						order[1] = 0
						super(42495, 42496, order)
					end
				end
			end

			class NoLegDeliveryStreamCommoditySources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41461
					order[1] = 0
					super(41460, 41461, order)
				end
			end

			class NoLegDeliveryStreamCycles < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41457
					order[1] = 41458
					order[2] = 41459
					order[3] = 0
					super(41456, 41457, order)
				end
			end

			class NoLegDeliverySchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(15)
					order[0] = 41409
					order[1] = 41410
					order[2] = 41411
					order[3] = 41412
					order[4] = 41413
					order[5] = 41414
					order[6] = 41415
					order[7] = 41416
					order[8] = 41417
					order[9] = 41418
					order[10] = 41419
					order[11] = 41420
					order[12] = 41421
					order[13] = 41422
					order[14] = 0
					super(41408, 41409, order)
				end

				class NoLegDeliveryScheduleSettlDays < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41423
						order[1] = 41424
						order[2] = 41425
						order[3] = 0
						super(41422, 41423, order)
					end

					class NoLegDeliveryScheduleSettlTimes < Quickfix::Group
						def initialize
							order = Quickfix::IntArray.new(4)
							order[0] = 41426
							order[1] = 41427
							order[2] = 41428
							order[3] = 0
							super(41425, 41426, order)
						end
					end
				end
			end
		end

		class NoLegProvisions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(79)
				order[0] = 40449
				order[1] = 40450
				order[2] = 40451
				order[3] = 40939
				order[4] = 40453
				order[5] = 40454
				order[6] = 40455
				order[7] = 42506
				order[8] = 42507
				order[9] = 40456
				order[10] = 40457
				order[11] = 40458
				order[12] = 40524
				order[13] = 40525
				order[14] = 40526
				order[15] = 40528
				order[16] = 40529
				order[17] = 40530
				order[18] = 40531
				order[19] = 40532
				order[20] = 40476
				order[21] = 40478
				order[22] = 40479
				order[23] = 40480
				order[24] = 40481
				order[25] = 40482
				order[26] = 40483
				order[27] = 40484
				order[28] = 40485
				order[29] = 40486
				order[30] = 40487
				order[31] = 40488
				order[32] = 40489
				order[33] = 40490
				order[34] = 40491
				order[35] = 40492
				order[36] = 40493
				order[37] = 40494
				order[38] = 40498
				order[39] = 40499
				order[40] = 40501
				order[41] = 40502
				order[42] = 40503
				order[43] = 40504
				order[44] = 40505
				order[45] = 40506
				order[46] = 40507
				order[47] = 40508
				order[48] = 40509
				order[49] = 40511
				order[50] = 40512
				order[51] = 40513
				order[52] = 40514
				order[53] = 40515
				order[54] = 40459
				order[55] = 40460
				order[56] = 40461
				order[57] = 40462
				order[58] = 40463
				order[59] = 40464
				order[60] = 40465
				order[61] = 40516
				order[62] = 40518
				order[63] = 40519
				order[64] = 40520
				order[65] = 40521
				order[66] = 40522
				order[67] = 40523
				order[68] = 40466
				order[69] = 40467
				order[70] = 40468
				order[71] = 40469
				order[72] = 40470
				order[73] = 41407
				order[74] = 40472
				order[75] = 40980
				order[76] = 40981
				order[77] = 40533
				order[78] = 0
				super(40448, 40449, order)
			end

			class NoLegProvisionDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40452
					order[1] = 0
					super(40939, 40452, order)
				end
			end

			class NoLegProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40527
					order[1] = 0
					super(40935, 40527, order)
				end
			end

			class NoLegProvisionOptionExerciseBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40477
					order[1] = 0
					super(40936, 40477, order)
				end
			end

			class NoLegProvisionOptionExerciseFixedDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40496
					order[1] = 40497
					order[2] = 0
					super(40495, 40496, order)
				end
			end

			class NoLegProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40500
					order[1] = 0
					super(40937, 40500, order)
				end
			end

			class NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40510
					order[1] = 0
					super(40938, 40510, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40517
					order[1] = 0
					super(40934, 40517, order)
				end
			end

			class NoLegProvisionCashSettlPaymentDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40474
					order[1] = 40475
					order[2] = 0
					super(40473, 40474, order)
				end
			end

			class NoLegProvisionPartyIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 40534
					order[1] = 40535
					order[2] = 40536
					order[3] = 2380
					order[4] = 40537
					order[5] = 0
					super(40533, 40534, order)
				end

				class NoLegProvisionPartySubIDs < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 40538
						order[1] = 40539
						order[2] = 0
						super(40537, 40538, order)
					end
				end
			end
		end

		class NoLegAdditionalTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41336
				order[1] = 41337
				order[2] = 41316
				order[3] = 0
				super(41335, 41336, order)
			end

			class NoLegAdditionalTermBondRefs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(19)
					order[0] = 41317
					order[1] = 41318
					order[2] = 41319
					order[3] = 41320
					order[4] = 41321
					order[5] = 41322
					order[6] = 41323
					order[7] = 41324
					order[8] = 41325
					order[9] = 41326
					order[10] = 41327
					order[11] = 41328
					order[12] = 41329
					order[13] = 41330
					order[14] = 41331
					order[15] = 41332
					order[16] = 41333
					order[17] = 41334
					order[18] = 0
					super(41316, 41317, order)
				end
			end
		end

		class NoLegProtectionTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(12)
				order[0] = 41618
				order[1] = 41619
				order[2] = 41620
				order[3] = 41621
				order[4] = 41622
				order[5] = 41623
				order[6] = 41624
				order[7] = 41614
				order[8] = 41625
				order[9] = 41635
				order[10] = 41617
				order[11] = 0
				super(41616, 41618, order)
			end

			class NoLegProtectionTermEventNewsSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41615
					order[1] = 0
					super(41614, 41615, order)
				end
			end

			class NoLegProtectionTermEvents < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(9)
					order[0] = 41626
					order[1] = 41627
					order[2] = 41628
					order[3] = 41629
					order[4] = 41630
					order[5] = 41631
					order[6] = 41632
					order[7] = 41633
					order[8] = 0
					super(41625, 41626, order)
				end

				class NoLegProtectionTermEventQualifiers < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 41634
						order[1] = 0
						super(41633, 41634, order)
					end
				end
			end

			class NoLegProtectionTermObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41636
					order[1] = 41637
					order[2] = 0
					super(41635, 41636, order)
				end
			end
		end

		class NoLegCashSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(29)
				order[0] = 41345
				order[1] = 41346
				order[2] = 41347
				order[3] = 41348
				order[4] = 41349
				order[5] = 41350
				order[6] = 41351
				order[7] = 41352
				order[8] = 41353
				order[9] = 41354
				order[10] = 41355
				order[11] = 41342
				order[12] = 42308
				order[13] = 42309
				order[14] = 41356
				order[15] = 41357
				order[16] = 42299
				order[17] = 42300
				order[18] = 42301
				order[19] = 42302
				order[20] = 42303
				order[21] = 42304
				order[22] = 42305
				order[23] = 41358
				order[24] = 41359
				order[25] = 41360
				order[26] = 41361
				order[27] = 41362
				order[28] = 0
				super(41344, 41345, order)
			end

			class NoLegCashSettlDealers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41343
					order[1] = 0
					super(41342, 41343, order)
				end
			end

			class NoLegCashSettlDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42307
					order[1] = 0
					super(42306, 42307, order)
				end
			end
		end

		class NoLegPhysicalSettlTerms < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41604
				order[1] = 41601
				order[2] = 41602
				order[3] = 41603
				order[4] = 41600
				order[5] = 0
				super(41599, 41604, order)
			end

			class NoLegPhysicalSettlDeliverableObligations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41605
					order[1] = 41606
					order[2] = 0
					super(41604, 41605, order)
				end
			end
		end

		class NoLegExtraordinaryEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42389
				order[1] = 42390
				order[2] = 0
				super(42388, 42389, order)
			end
		end

		class NoLegContractualDefinitions < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42199
				order[1] = 0
				super(42198, 42199, order)
			end
		end

		class NoLegFinancingTermSupplements < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42201
				order[1] = 42202
				order[2] = 0
				super(42200, 42201, order)
			end
		end

		class NoLegContractualMatrices < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 42204
				order[1] = 42205
				order[2] = 42206
				order[3] = 0
				super(42203, 42204, order)
			end
		end
	end

	class NoRelatedInstruments < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 1648
			order[1] = 1649
			order[2] = 1650
			order[3] = 1651
			order[4] = 1652
			order[5] = 1653
			order[6] = 2413
			order[7] = 2414
			order[8] = 2415
			order[9] = 2417
			order[10] = 0
			super(1647, 1648, order)
		end
	end

	class NoMDStatistics < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(46)
			order[0] = 2456
			order[1] = 2457
			order[2] = 2458
			order[3] = 2459
			order[4] = 2454
			order[5] = 2455
			order[6] = 2481
			order[7] = 2482
			order[8] = 264
			order[9] = 2460
			order[10] = 2461
			order[11] = 2462
			order[12] = 2463
			order[13] = 2464
			order[14] = 2465
			order[15] = 2466
			order[16] = 2467
			order[17] = 2468
			order[18] = 2469
			order[19] = 2470
			order[20] = 2471
			order[21] = 2472
			order[22] = 2584
			order[23] = 1815
			order[24] = 40
			order[25] = 59
			order[26] = 276
			order[27] = 277
			order[28] = 54
			order[29] = 578
			order[30] = 336
			order[31] = 625
			order[32] = 1024
			order[33] = 2711
			order[34] = 338
			order[35] = 1022
			order[36] = 1629
			order[37] = 1916
			order[38] = 1057
			order[39] = 2475
			order[40] = 2476
			order[41] = 2477
			order[42] = 2478
			order[43] = 2479
			order[44] = 2480
			order[45] = 0
			super(2474, 2456, order)
		end

		class NoNestedPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 524
				order[1] = 525
				order[2] = 538
				order[3] = 2384
				order[4] = 804
				order[5] = 0
				super(539, 524, order)
			end

			class NoNestedPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 545
					order[1] = 805
					order[2] = 0
					super(804, 545, order)
				end
			end
		end
	end
end

class CollateralReportAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DQ") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end
end

class MarketDataReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DR") )
	end
end

class CrossRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DS") )
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end
end

class CrossRequestAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DT") )
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end
end

class AllocationInstructionAlertRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DU") )
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end
end

class AllocationInstructionAlertRequestAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DV") )
	end
end

class TradeAggregationRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DW") )
	end

	class NoOrders < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 11
			order[1] = 37
			order[2] = 38
			order[3] = 799
			order[4] = 0
			super(73, 11, order)
		end
	end

	class NoExecs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 32
			order[1] = 17
			order[2] = 1003
			order[3] = 31
			order[4] = 0
			super(124, 32, order)
		end
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end
end

class TradeAggregationReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DX") )
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end
end

class PayManagementReport < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("EA") )
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoRelatedTrades < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 1856
			order[1] = 1857
			order[2] = 2103
			order[3] = 1858
			order[4] = 1859
			order[5] = 1860
			order[6] = 0
			super(1855, 1856, order)
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoSettlDetails < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1164
			order[1] = 169
			order[2] = 170
			order[3] = 171
			order[4] = 781
			order[5] = 0
			super(1158, 1164, order)
		end

		class NoSettlPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 782
				order[1] = 783
				order[2] = 784
				order[3] = 2389
				order[4] = 801
				order[5] = 0
				super(781, 782, order)
			end

			class NoSettlPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 785
					order[1] = 786
					order[2] = 0
					super(801, 785, order)
				end
			end
		end
	end
end

class PayManagementReportAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("EB") )
	end
end

class PayManagementRequest < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DY") )
	end

	class NoSecurityAltID < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 455
			order[1] = 456
			order[2] = 2957
			order[3] = 0
			super(454, 455, order)
		end
	end

	class NoSecondaryAssetClasses < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(5)
			order[0] = 1977
			order[1] = 1978
			order[2] = 1979
			order[3] = 2741
			order[4] = 0
			super(1976, 1977, order)
		end
	end

	class NoAssetAttributes < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 2305
			order[1] = 2306
			order[2] = 2307
			order[3] = 0
			super(2304, 2305, order)
		end
	end

	class NoEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(11)
			order[0] = 865
			order[1] = 866
			order[2] = 1145
			order[3] = 1827
			order[4] = 1826
			order[5] = 2340
			order[6] = 867
			order[7] = 868
			order[8] = 1578
			order[9] = 1579
			order[10] = 0
			super(864, 865, order)
		end
	end

	class NoInstrumentParties < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1019
			order[1] = 1050
			order[2] = 1051
			order[3] = 2378
			order[4] = 1052
			order[5] = 0
			super(1018, 1019, order)
		end

		class NoInstrumentPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 1053
				order[1] = 1054
				order[2] = 0
				super(1052, 1053, order)
			end
		end
	end

	class NoComplexEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(53)
			order[0] = 1484
			order[1] = 2117
			order[2] = 2118
			order[3] = 2119
			order[4] = 1485
			order[5] = 2120
			order[6] = 2121
			order[7] = 2122
			order[8] = 2941
			order[9] = 1486
			order[10] = 2123
			order[11] = 1487
			order[12] = 1488
			order[13] = 1489
			order[14] = 1490
			order[15] = 1491
			order[16] = 2124
			order[17] = 2942
			order[18] = 2125
			order[19] = 2943
			order[20] = 2126
			order[21] = 2127
			order[22] = 2407
			order[23] = 2408
			order[24] = 2128
			order[25] = 2129
			order[26] = 2130
			order[27] = 2131
			order[28] = 2132
			order[29] = 41013
			order[30] = 41020
			order[31] = 41021
			order[32] = 41022
			order[33] = 41023
			order[34] = 41024
			order[35] = 41025
			order[36] = 41026
			order[37] = 41027
			order[38] = 41028
			order[39] = 41010
			order[40] = 2133
			order[41] = 2134
			order[42] = 2135
			order[43] = 2136
			order[44] = 2137
			order[45] = 41029
			order[46] = 40997
			order[47] = 2597
			order[48] = 2598
			order[49] = 2599
			order[50] = 2138
			order[51] = 2139
			order[52] = 0
			super(1483, 1484, order)
		end

		class NoComplexEventDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 1492
				order[1] = 1493
				order[2] = 1494
				order[3] = 0
				super(1491, 1492, order)
			end

			class NoComplexEventTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 1495
					order[1] = 1496
					order[2] = 0
					super(1494, 1495, order)
				end
			end
		end

		class NoComplexEventRateSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(5)
				order[0] = 41014
				order[1] = 41015
				order[2] = 41016
				order[3] = 41017
				order[4] = 0
				super(41013, 41014, order)
			end
		end

		class NoComplexEventDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41019
				order[1] = 0
				super(41018, 41019, order)
			end
		end

		class NoComplexEventPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 41011
				order[1] = 41012
				order[2] = 41031
				order[3] = 41007
				order[4] = 40994
				order[5] = 0
				super(41010, 41011, order)
			end

			class NoComplexEventSchedules < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(6)
					order[0] = 41032
					order[1] = 41033
					order[2] = 41034
					order[3] = 41035
					order[4] = 41036
					order[5] = 0
					super(41031, 41032, order)
				end
			end

			class NoComplexEventPeriodDateTimes < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41008
					order[1] = 41009
					order[2] = 0
					super(41007, 41008, order)
				end
			end

			class NoComplexEventAveragingObservations < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40995
					order[1] = 40996
					order[2] = 0
					super(40994, 40995, order)
				end
			end
		end

		class NoComplexEventCreditEventSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41030
				order[1] = 0
				super(41029, 41030, order)
			end
		end

		class NoComplexEventCreditEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40998
				order[1] = 40999
				order[2] = 41000
				order[3] = 41001
				order[4] = 41002
				order[5] = 41003
				order[6] = 41004
				order[7] = 41005
				order[8] = 0
				super(40997, 40998, order)
			end

			class NoComplexEventCreditEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 41006
					order[1] = 0
					super(41005, 41006, order)
				end
			end
		end
	end

	class NoBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 40471
			order[1] = 0
			super(40278, 40471, order)
		end
	end

	class NoPricingDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41231
			order[1] = 0
			super(41230, 41231, order)
		end
	end

	class NoMarketDisruptionEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41093
			order[1] = 40991
			order[2] = 0
			super(41092, 41093, order)
		end
	end

	class NoMarketDisruptionFallbacks < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41095
			order[1] = 40992
			order[2] = 0
			super(41094, 41095, order)
		end
	end

	class NoMarketDisruptionFallbackReferencePrices < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(10)
			order[0] = 41097
			order[1] = 41098
			order[2] = 41099
			order[3] = 41100
			order[4] = 41101
			order[5] = 41102
			order[6] = 41103
			order[7] = 41104
			order[8] = 41105
			order[9] = 0
			super(41096, 41097, order)
		end
	end

	class NoSettlMethodElectionDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 42776
			order[1] = 0
			super(42775, 42776, order)
		end
	end

	class NoOptionExerciseBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41117
			order[1] = 0
			super(41116, 41117, order)
		end
	end

	class NoOptionExerciseDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41138
			order[1] = 41139
			order[2] = 0
			super(41137, 41138, order)
		end
	end

	class NoOptionExerciseExpirationDateBusinessCenters < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(2)
			order[0] = 41141
			order[1] = 0
			super(41140, 41141, order)
		end
	end

	class NoOptionExerciseExpirationDates < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 41153
			order[1] = 41154
			order[2] = 0
			super(41152, 41153, order)
		end
	end

	class NoStreams < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(135)
			order[0] = 40050
			order[1] = 41303
			order[2] = 40051
			order[3] = 42784
			order[4] = 42785
			order[5] = 40052
			order[6] = 40053
			order[7] = 41305
			order[8] = 40054
			order[9] = 40055
			order[10] = 42786
			order[11] = 42787
			order[12] = 41306
			order[13] = 41307
			order[14] = 41308
			order[15] = 41309
			order[16] = 41310
			order[17] = 41311
			order[18] = 41251
			order[19] = 41252
			order[20] = 41253
			order[21] = 41254
			order[22] = 41255
			order[23] = 41256
			order[24] = 41257
			order[25] = 42587
			order[26] = 41258
			order[27] = 41259
			order[28] = 41260
			order[29] = 41261
			order[30] = 41262
			order[31] = 41263
			order[32] = 41264
			order[33] = 41265
			order[34] = 41266
			order[35] = 41267
			order[36] = 41268
			order[37] = 41269
			order[38] = 41270
			order[39] = 41271
			order[40] = 41272
			order[41] = 41273
			order[42] = 41274
			order[43] = 41275
			order[44] = 41276
			order[45] = 40907
			order[46] = 40908
			order[47] = 40910
			order[48] = 40911
			order[49] = 40912
			order[50] = 40913
			order[51] = 40914
			order[52] = 40065
			order[53] = 40066
			order[54] = 40068
			order[55] = 40069
			order[56] = 40070
			order[57] = 40071
			order[58] = 40072
			order[59] = 41244
			order[60] = 41245
			order[61] = 40073
			order[62] = 40075
			order[63] = 40076
			order[64] = 40078
			order[65] = 40079
			order[66] = 40080
			order[67] = 40081
			order[68] = 40082
			order[69] = 40083
			order[70] = 40084
			order[71] = 41246
			order[72] = 41247
			order[73] = 41248
			order[74] = 40738
			order[75] = 40739
			order[76] = 40740
			order[77] = 42600
			order[78] = 40741
			order[79] = 40742
			order[80] = 43106
			order[81] = 40743
			order[82] = 40744
			order[83] = 40745
			order[84] = 40746
			order[85] = 40747
			order[86] = 42601
			order[87] = 42602
			order[88] = 42603
			order[89] = 42604
			order[90] = 40748
			order[91] = 40749
			order[92] = 40750
			order[93] = 41180
			order[94] = 41181
			order[95] = 41182
			order[96] = 41183
			order[97] = 41184
			order[98] = 41185
			order[99] = 41186
			order[100] = 42605
			order[101] = 40828
			order[102] = 40872
			order[103] = 41058
			order[104] = 41059
			order[105] = 41060
			order[106] = 41061
			order[107] = 41062
			order[108] = 42192
			order[109] = 42193
			order[110] = 41063
			order[111] = 41064
			order[112] = 41065
			order[113] = 41066
			order[114] = 41067
			order[115] = 41218
			order[116] = 41068
			order[117] = 41069
			order[118] = 41070
			order[119] = 41071
			order[120] = 41072
			order[121] = 41073
			order[122] = 41074
			order[123] = 41075
			order[124] = 41076
			order[125] = 41077
			order[126] = 41078
			order[127] = 41079
			order[128] = 41080
			order[129] = 43094
			order[130] = 41037
			order[131] = 40056
			order[132] = 40982
			order[133] = 40983
			order[134] = 0
			super(40049, 40050, order)
		end

		class NoStreamCommodityAltIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41278
				order[1] = 41279
				order[2] = 0
				super(41277, 41278, order)
			end
		end

		class NoStreamAssetAttributes < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41238
				order[1] = 41239
				order[2] = 41240
				order[3] = 0
				super(41237, 41238, order)
			end
		end

		class NoStreamCommodityDataSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41281
				order[1] = 41282
				order[2] = 0
				super(41280, 41281, order)
			end
		end

		class NoStreamCommoditySettlBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41250
				order[1] = 0
				super(41249, 41250, order)
			end
		end

		class NoStreamCommoditySettlPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41290
				order[1] = 41291
				order[2] = 41292
				order[3] = 41293
				order[4] = 41294
				order[5] = 41295
				order[6] = 41296
				order[7] = 41297
				order[8] = 41298
				order[9] = 41299
				order[10] = 41300
				order[11] = 41283
				order[12] = 41301
				order[13] = 41302
				order[14] = 0
				super(41289, 41290, order)
			end

			class NoStreamCommoditySettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41284
					order[1] = 41285
					order[2] = 41286
					order[3] = 0
					super(41283, 41284, order)
				end

				class NoStreamCommoditySettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41287
						order[1] = 41288
						order[2] = 41588
						order[3] = 0
						super(41286, 41287, order)
					end
				end
			end
		end

		class NoStreamEffectiveDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40909
				order[1] = 0
				super(40960, 40909, order)
			end
		end

		class NoStreamTerminationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40067
				order[1] = 0
				super(40961, 40067, order)
			end
		end

		class NoStreamCalculationPeriodBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40074
				order[1] = 0
				super(40958, 40074, order)
			end
		end

		class NoStreamCalculationPeriodDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41242
				order[1] = 41243
				order[2] = 0
				super(41241, 41242, order)
			end
		end

		class NoStreamFirstPeriodStartDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40077
				order[1] = 0
				super(40959, 40077, order)
			end
		end

		class NoPaymentStreamPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40752
				order[1] = 0
				super(40947, 40752, order)
			end
		end

		class NoPaymentStreamPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41221
				order[1] = 41222
				order[2] = 0
				super(41220, 41221, order)
			end
		end

		class NoPaymentStreamResetDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40763
				order[1] = 0
				super(40948, 40763, order)
			end
		end

		class NoPaymentStreamInitialFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40769
				order[1] = 0
				super(40949, 40769, order)
			end
		end

		class NoPaymentStreamFixingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40776
				order[1] = 0
				super(40950, 40776, order)
			end
		end

		class NoPaymentStreamFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42661
				order[1] = 42662
				order[2] = 0
				super(42660, 42661, order)
			end
		end

		class NoPaymentStreamPricingBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41193
				order[1] = 0
				super(41192, 41193, order)
			end
		end

		class NoPaymentStreamPricingDays < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41228
				order[1] = 41229
				order[2] = 0
				super(41227, 41228, order)
			end
		end

		class NoPaymentStreamPricingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 41225
				order[1] = 41226
				order[2] = 0
				super(41224, 41225, order)
			end
		end

		class NoPaymentStreamFormulas < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 43109
				order[1] = 42684
				order[2] = 42685
				order[3] = 0
				super(42683, 43109, order)
			end
		end

		class NoDividendPeriods < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(21)
				order[0] = 42275
				order[1] = 42276
				order[2] = 42277
				order[3] = 42278
				order[4] = 42279
				order[5] = 42280
				order[6] = 42294
				order[7] = 42281
				order[8] = 42282
				order[9] = 42283
				order[10] = 42284
				order[11] = 42285
				order[12] = 42286
				order[13] = 42287
				order[14] = 42288
				order[15] = 42289
				order[16] = 42290
				order[17] = 42291
				order[18] = 42292
				order[19] = 42293
				order[20] = 0
				super(42274, 42275, order)
			end

			class NoDividendPeriodBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42295
					order[1] = 0
					super(42294, 42295, order)
				end
			end
		end

		class NoDividendFXTriggerDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42273
				order[1] = 0
				super(42272, 42273, order)
			end
		end

		class NoDividendAccrualPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42237
				order[1] = 0
				super(42236, 42237, order)
			end
		end

		class NoReturnRates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(30)
				order[0] = 42736
				order[1] = 42737
				order[2] = 42738
				order[3] = 42739
				order[4] = 42740
				order[5] = 42741
				order[6] = 42765
				order[7] = 42731
				order[8] = 42742
				order[9] = 42743
				order[10] = 42744
				order[11] = 42745
				order[12] = 42746
				order[13] = 42747
				order[14] = 42748
				order[15] = 42749
				order[16] = 42750
				order[17] = 42751
				order[18] = 42752
				order[19] = 42753
				order[20] = 42761
				order[21] = 42754
				order[22] = 42755
				order[23] = 42709
				order[24] = 42756
				order[25] = 42757
				order[26] = 42758
				order[27] = 42759
				order[28] = 42760
				order[29] = 0
				super(42735, 42736, order)
			end

			class NoReturnRatePrices < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(5)
					order[0] = 42766
					order[1] = 42767
					order[2] = 42768
					order[3] = 42769
					order[4] = 0
					super(42765, 42766, order)
				end
			end

			class NoReturnRateFXConversions < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42732
					order[1] = 42733
					order[2] = 42734
					order[3] = 0
					super(42731, 42732, order)
				end
			end

			class NoReturnRateInformationSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 42762
					order[1] = 42763
					order[2] = 42764
					order[3] = 0
					super(42761, 42762, order)
				end
			end

			class NoReturnRateDates < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(24)
					order[0] = 42710
					order[1] = 42772
					order[2] = 42711
					order[3] = 42712
					order[4] = 42713
					order[5] = 42714
					order[6] = 42715
					order[7] = 42716
					order[8] = 42717
					order[9] = 42718
					order[10] = 42719
					order[11] = 42720
					order[12] = 42721
					order[13] = 42722
					order[14] = 42723
					order[15] = 42724
					order[16] = 42725
					order[17] = 42726
					order[18] = 42727
					order[19] = 42728
					order[20] = 42729
					order[21] = 42730
					order[22] = 42770
					order[23] = 0
					super(42709, 42710, order)
				end

				class NoReturnRateValuationDates < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(3)
						order[0] = 42773
						order[1] = 42774
						order[2] = 0
						super(42772, 42773, order)
					end
				end

				class NoReturnRateValuationDateBusinessCenters < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(2)
						order[0] = 42771
						order[1] = 0
						super(42770, 42771, order)
					end
				end
			end
		end

		class NoPaymentStreamCompoundingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42621
				order[1] = 0
				super(42620, 42621, order)
			end
		end

		class NoPaymentStreamCompoundingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 42607
				order[1] = 42608
				order[2] = 0
				super(42606, 42607, order)
			end
		end

		class NoPaymentStreamNonDeliverableFixingDatesBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40819
				order[1] = 0
				super(40946, 40819, order)
			end
		end

		class NoNonDeliverableFixingDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40826
				order[1] = 40827
				order[2] = 0
				super(40825, 40826, order)
			end
		end

		class NoSettlRateFallbacks < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40086
				order[1] = 40373
				order[2] = 40655
				order[3] = 40088
				order[4] = 40089
				order[5] = 0
				super(40085, 40086, order)
			end
		end

		class NoPaymentSchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(58)
				order[0] = 40829
				order[1] = 41164
				order[2] = 41165
				order[3] = 40830
				order[4] = 40831
				order[5] = 40832
				order[6] = 40833
				order[7] = 40834
				order[8] = 40835
				order[9] = 40836
				order[10] = 40837
				order[11] = 40838
				order[12] = 40839
				order[13] = 41166
				order[14] = 41167
				order[15] = 41168
				order[16] = 41169
				order[17] = 40840
				order[18] = 40841
				order[19] = 40842
				order[20] = 40843
				order[21] = 41170
				order[22] = 41171
				order[23] = 41172
				order[24] = 41173
				order[25] = 40844
				order[26] = 40845
				order[27] = 40846
				order[28] = 40847
				order[29] = 40848
				order[30] = 40849
				order[31] = 40868
				order[32] = 40850
				order[33] = 40851
				order[34] = 40852
				order[35] = 40853
				order[36] = 40977
				order[37] = 40855
				order[38] = 40856
				order[39] = 40857
				order[40] = 41174
				order[41] = 41175
				order[42] = 40858
				order[43] = 41161
				order[44] = 41176
				order[45] = 41177
				order[46] = 41178
				order[47] = 41179
				order[48] = 40859
				order[49] = 40860
				order[50] = 40861
				order[51] = 40862
				order[52] = 40945
				order[53] = 40864
				order[54] = 40865
				order[55] = 40866
				order[56] = 40867
				order[57] = 0
				super(40828, 40829, order)
			end

			class NoPaymentScheduleRateSources < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 40869
					order[1] = 40870
					order[2] = 40871
					order[3] = 0
					super(40868, 40869, order)
				end
			end

			class NoPaymentScheduleFixingDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40854
					order[1] = 0
					super(40977, 40854, order)
				end
			end

			class NoPaymentScheduleFixingDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 41162
					order[1] = 41163
					order[2] = 0
					super(41161, 41162, order)
				end
			end

			class NoPaymentScheduleInterimExchangeDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40863
					order[1] = 0
					super(40945, 40863, order)
				end
			end
		end

		class NoPaymentStubs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(44)
				order[0] = 40873
				order[1] = 40874
				order[2] = 42698
				order[3] = 42699
				order[4] = 42700
				order[5] = 42701
				order[6] = 42702
				order[7] = 42703
				order[8] = 42704
				order[9] = 42689
				order[10] = 42690
				order[11] = 42691
				order[12] = 42692
				order[13] = 42693
				order[14] = 42694
				order[15] = 42695
				order[16] = 40875
				order[17] = 40876
				order[18] = 40877
				order[19] = 40878
				order[20] = 40879
				order[21] = 40880
				order[22] = 40881
				order[23] = 40882
				order[24] = 40883
				order[25] = 40884
				order[26] = 40885
				order[27] = 40886
				order[28] = 40887
				order[29] = 40888
				order[30] = 40889
				order[31] = 40890
				order[32] = 40891
				order[33] = 40892
				order[34] = 40893
				order[35] = 40894
				order[36] = 40895
				order[37] = 40896
				order[38] = 40897
				order[39] = 40898
				order[40] = 40899
				order[41] = 40900
				order[42] = 40901
				order[43] = 0
				super(40872, 40873, order)
			end

			class NoPaymentStubStartDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42706
					order[1] = 0
					super(42705, 42706, order)
				end
			end

			class NoPaymentStubEndDateBusinessCenters < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 42697
					order[1] = 0
					super(42696, 42697, order)
				end
			end
		end

		class NoDeliveryStreamCommoditySources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 41086
				order[1] = 0
				super(41085, 41086, order)
			end
		end

		class NoDeliveryStreamCycles < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(4)
				order[0] = 41082
				order[1] = 41083
				order[2] = 41084
				order[3] = 0
				super(41081, 41082, order)
			end
		end

		class NoDeliverySchedules < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(15)
				order[0] = 41038
				order[1] = 41039
				order[2] = 41040
				order[3] = 41041
				order[4] = 41042
				order[5] = 41043
				order[6] = 41044
				order[7] = 41045
				order[8] = 41046
				order[9] = 41047
				order[10] = 41048
				order[11] = 41049
				order[12] = 41050
				order[13] = 41051
				order[14] = 0
				super(41037, 41038, order)
			end

			class NoDeliveryScheduleSettlDays < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(4)
					order[0] = 41052
					order[1] = 41053
					order[2] = 41054
					order[3] = 0
					super(41051, 41052, order)
				end

				class NoDeliveryScheduleSettlTimes < Quickfix::Group
					def initialize
						order = Quickfix::IntArray.new(4)
						order[0] = 41055
						order[1] = 41056
						order[2] = 41057
						order[3] = 0
						super(41054, 41055, order)
					end
				end
			end
		end
	end

	class NoProvisions < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(79)
			order[0] = 40091
			order[1] = 40092
			order[2] = 40093
			order[3] = 40957
			order[4] = 40095
			order[5] = 40096
			order[6] = 40097
			order[7] = 42707
			order[8] = 42708
			order[9] = 40098
			order[10] = 40099
			order[11] = 40100
			order[12] = 40114
			order[13] = 40115
			order[14] = 40116
			order[15] = 40118
			order[16] = 40119
			order[17] = 40120
			order[18] = 40121
			order[19] = 40122
			order[20] = 40123
			order[21] = 40125
			order[22] = 40126
			order[23] = 40127
			order[24] = 40128
			order[25] = 40129
			order[26] = 40130
			order[27] = 40131
			order[28] = 40132
			order[29] = 40133
			order[30] = 40134
			order[31] = 40135
			order[32] = 40136
			order[33] = 40137
			order[34] = 40138
			order[35] = 40139
			order[36] = 40140
			order[37] = 40141
			order[38] = 40145
			order[39] = 40146
			order[40] = 40148
			order[41] = 40149
			order[42] = 40150
			order[43] = 40151
			order[44] = 40152
			order[45] = 40153
			order[46] = 40154
			order[47] = 40155
			order[48] = 40156
			order[49] = 40158
			order[50] = 40159
			order[51] = 40160
			order[52] = 40161
			order[53] = 40162
			order[54] = 40101
			order[55] = 40102
			order[56] = 40103
			order[57] = 40104
			order[58] = 40105
			order[59] = 40106
			order[60] = 40107
			order[61] = 40163
			order[62] = 40165
			order[63] = 40166
			order[64] = 40167
			order[65] = 40168
			order[66] = 40169
			order[67] = 40170
			order[68] = 40108
			order[69] = 40109
			order[70] = 40110
			order[71] = 40111
			order[72] = 40112
			order[73] = 41406
			order[74] = 40113
			order[75] = 40986
			order[76] = 40987
			order[77] = 40174
			order[78] = 0
			super(40090, 40091, order)
		end

		class NoProvisionDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40094
				order[1] = 0
				super(40957, 40094, order)
			end
		end

		class NoProvisionCashSettlValueDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40117
				order[1] = 0
				super(40953, 40117, order)
			end
		end

		class NoProvisionOptionExerciseBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40124
				order[1] = 0
				super(40954, 40124, order)
			end
		end

		class NoProvisionOptionExerciseFixedDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40143
				order[1] = 40144
				order[2] = 0
				super(40142, 40143, order)
			end
		end

		class NoProvisionOptionExpirationDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40147
				order[1] = 0
				super(40955, 40147, order)
			end
		end

		class NoProvisionOptionRelevantUnderlyingDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40157
				order[1] = 0
				super(40956, 40157, order)
			end
		end

		class NoProvisionCashSettlPaymentDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40164
				order[1] = 0
				super(40952, 40164, order)
			end
		end

		class NoProvisionCashSettlPaymentDates < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40172
				order[1] = 40173
				order[2] = 0
				super(40171, 40172, order)
			end
		end

		class NoProvisionPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 40175
				order[1] = 40176
				order[2] = 40177
				order[3] = 2385
				order[4] = 40178
				order[5] = 0
				super(40174, 40175, order)
			end

			class NoProvisionPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 40179
					order[1] = 40180
					order[2] = 0
					super(40178, 40179, order)
				end
			end
		end
	end

	class NoAdditionalTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(4)
			order[0] = 40020
			order[1] = 40021
			order[2] = 40000
			order[3] = 0
			super(40019, 40020, order)
		end

		class NoAdditionalTermBondRefs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(19)
				order[0] = 40001
				order[1] = 40002
				order[2] = 40003
				order[3] = 40004
				order[4] = 40005
				order[5] = 40006
				order[6] = 40007
				order[7] = 40008
				order[8] = 40009
				order[9] = 40010
				order[10] = 40011
				order[11] = 40012
				order[12] = 40013
				order[13] = 40014
				order[14] = 40015
				order[15] = 40016
				order[16] = 40017
				order[17] = 40018
				order[18] = 0
				super(40000, 40001, order)
			end
		end
	end

	class NoProtectionTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(12)
			order[0] = 40182
			order[1] = 40183
			order[2] = 40184
			order[3] = 40185
			order[4] = 40186
			order[5] = 40187
			order[6] = 40188
			order[7] = 40951
			order[8] = 40191
			order[9] = 40201
			order[10] = 40190
			order[11] = 0
			super(40181, 40182, order)
		end

		class NoProtectionTermEventNewsSources < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40189
				order[1] = 0
				super(40951, 40189, order)
			end
		end

		class NoProtectionTermEvents < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(9)
				order[0] = 40192
				order[1] = 40193
				order[2] = 40194
				order[3] = 40195
				order[4] = 40196
				order[5] = 40197
				order[6] = 40198
				order[7] = 40199
				order[8] = 0
				super(40191, 40192, order)
			end

			class NoProtectionTermEventQualifiers < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(2)
					order[0] = 40200
					order[1] = 0
					super(40199, 40200, order)
				end
			end
		end

		class NoProtectionTermObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40202
				order[1] = 40203
				order[2] = 0
				super(40201, 40202, order)
			end
		end
	end

	class NoCashSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(29)
			order[0] = 40023
			order[1] = 40024
			order[2] = 40916
			order[3] = 40917
			order[4] = 40025
			order[5] = 40026
			order[6] = 40027
			order[7] = 40028
			order[8] = 40029
			order[9] = 40030
			order[10] = 40031
			order[11] = 40277
			order[12] = 42216
			order[13] = 42217
			order[14] = 40033
			order[15] = 40034
			order[16] = 42207
			order[17] = 42208
			order[18] = 42209
			order[19] = 42210
			order[20] = 42211
			order[21] = 42212
			order[22] = 42213
			order[23] = 40035
			order[24] = 40036
			order[25] = 40037
			order[26] = 40038
			order[27] = 40039
			order[28] = 0
			super(40022, 40023, order)
		end

		class NoCashSettlDealers < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 40032
				order[1] = 0
				super(40277, 40032, order)
			end
		end

		class NoCashSettlDateBusinessCenters < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(2)
				order[0] = 42215
				order[1] = 0
				super(42214, 42215, order)
			end
		end
	end

	class NoPhysicalSettlTerms < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 40209
			order[1] = 40205
			order[2] = 40206
			order[3] = 40207
			order[4] = 40208
			order[5] = 0
			super(40204, 40209, order)
		end

		class NoPhysicalSettlDeliverableObligations < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 40210
				order[1] = 40211
				order[2] = 0
				super(40209, 40210, order)
			end
		end
	end

	class NoExtraordinaryEvents < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(3)
			order[0] = 42297
			order[1] = 42298
			order[2] = 0
			super(42296, 42297, order)
		end
	end

	class NoRelatedTrades < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(7)
			order[0] = 1856
			order[1] = 1857
			order[2] = 2103
			order[3] = 1858
			order[4] = 1859
			order[5] = 1860
			order[6] = 0
			super(1855, 1856, order)
		end
	end

	class NoPartyIDs < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 448
			order[1] = 447
			order[2] = 452
			order[3] = 2376
			order[4] = 802
			order[5] = 0
			super(453, 448, order)
		end

		class NoPartySubIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(3)
				order[0] = 523
				order[1] = 803
				order[2] = 0
				super(802, 523, order)
			end
		end
	end

	class NoSettlDetails < Quickfix::Group
		def initialize
			order = Quickfix::IntArray.new(6)
			order[0] = 1164
			order[1] = 169
			order[2] = 170
			order[3] = 171
			order[4] = 781
			order[5] = 0
			super(1158, 1164, order)
		end

		class NoSettlPartyIDs < Quickfix::Group
			def initialize
				order = Quickfix::IntArray.new(6)
				order[0] = 782
				order[1] = 783
				order[2] = 784
				order[3] = 2389
				order[4] = 801
				order[5] = 0
				super(781, 782, order)
			end

			class NoSettlPartySubIDs < Quickfix::Group
				def initialize
					order = Quickfix::IntArray.new(3)
					order[0] = 785
					order[1] = 786
					order[2] = 0
					super(801, 785, order)
				end
			end
		end
	end
end

class PayManagementRequestAck < Message
	def initialize
		super
		getHeader().setField( Quickfix::MsgType.new("DZ") )
	end
end
end
